#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 5013
#define LARGE_STATE_COUNT 1100
#define SYMBOL_COUNT 395
#define ALIAS_COUNT 7
#define TOKEN_COUNT 167
#define EXTERNAL_TOKEN_COUNT 5
#define FIELD_COUNT 51
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 330

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_type = 6,
  anon_sym_EQ = 7,
  anon_sym_as = 8,
  anon_sym_namespace = 9,
  anon_sym_LBRACE = 10,
  anon_sym_COMMA = 11,
  anon_sym_RBRACE = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_BANG = 19,
  anon_sym_else = 20,
  anon_sym_if = 21,
  anon_sym_switch = 22,
  anon_sym_for = 23,
  anon_sym_LPAREN = 24,
  anon_sym_RPAREN = 25,
  anon_sym_await = 26,
  anon_sym_in = 27,
  anon_sym_of = 28,
  anon_sym_while = 29,
  anon_sym_do = 30,
  anon_sym_try = 31,
  anon_sym_with = 32,
  anon_sym_break = 33,
  anon_sym_continue = 34,
  anon_sym_debugger = 35,
  anon_sym_return = 36,
  anon_sym_throw = 37,
  anon_sym_SEMI = 38,
  anon_sym_COLON = 39,
  anon_sym_case = 40,
  anon_sym_catch = 41,
  anon_sym_finally = 42,
  anon_sym_yield = 43,
  anon_sym_LBRACK = 44,
  anon_sym_RBRACK = 45,
  sym__glimmer_template_content = 46,
  anon_sym_LTtemplate_GT = 47,
  anon_sym_LT_SLASHtemplate_GT = 48,
  anon_sym_LT = 49,
  anon_sym_GT = 50,
  anon_sym_SLASH = 51,
  anon_sym_DOT = 52,
  anon_sym_class = 53,
  anon_sym_async = 54,
  anon_sym_function = 55,
  anon_sym_EQ_GT = 56,
  anon_sym_QMARK_DOT = 57,
  anon_sym_new = 58,
  anon_sym_PLUS_EQ = 59,
  anon_sym_DASH_EQ = 60,
  anon_sym_STAR_EQ = 61,
  anon_sym_SLASH_EQ = 62,
  anon_sym_PERCENT_EQ = 63,
  anon_sym_CARET_EQ = 64,
  anon_sym_AMP_EQ = 65,
  anon_sym_PIPE_EQ = 66,
  anon_sym_GT_GT_EQ = 67,
  anon_sym_GT_GT_GT_EQ = 68,
  anon_sym_LT_LT_EQ = 69,
  anon_sym_STAR_STAR_EQ = 70,
  anon_sym_AMP_AMP_EQ = 71,
  anon_sym_PIPE_PIPE_EQ = 72,
  anon_sym_QMARK_QMARK_EQ = 73,
  anon_sym_DOT_DOT_DOT = 74,
  anon_sym_AMP_AMP = 75,
  anon_sym_PIPE_PIPE = 76,
  anon_sym_GT_GT = 77,
  anon_sym_GT_GT_GT = 78,
  anon_sym_LT_LT = 79,
  anon_sym_AMP = 80,
  anon_sym_CARET = 81,
  anon_sym_PIPE = 82,
  anon_sym_PLUS = 83,
  anon_sym_DASH = 84,
  anon_sym_PERCENT = 85,
  anon_sym_STAR_STAR = 86,
  anon_sym_LT_EQ = 87,
  anon_sym_EQ_EQ = 88,
  anon_sym_EQ_EQ_EQ = 89,
  anon_sym_BANG_EQ = 90,
  anon_sym_BANG_EQ_EQ = 91,
  anon_sym_GT_EQ = 92,
  anon_sym_QMARK_QMARK = 93,
  anon_sym_instanceof = 94,
  anon_sym_TILDE = 95,
  anon_sym_void = 96,
  anon_sym_delete = 97,
  anon_sym_PLUS_PLUS = 98,
  anon_sym_DASH_DASH = 99,
  anon_sym_DQUOTE = 100,
  anon_sym_SQUOTE = 101,
  sym_unescaped_double_string_fragment = 102,
  sym_unescaped_single_string_fragment = 103,
  sym_escape_sequence = 104,
  sym_comment = 105,
  anon_sym_BQUOTE = 106,
  anon_sym_DOLLAR_LBRACE = 107,
  anon_sym_SLASH2 = 108,
  sym_regex_pattern = 109,
  sym_regex_flags = 110,
  sym_number = 111,
  sym_private_property_identifier = 112,
  anon_sym_target = 113,
  sym_this = 114,
  sym_super = 115,
  sym_true = 116,
  sym_false = 117,
  sym_null = 118,
  sym_undefined = 119,
  anon_sym_AT = 120,
  anon_sym_static = 121,
  anon_sym_readonly = 122,
  anon_sym_get = 123,
  anon_sym_set = 124,
  anon_sym_QMARK = 125,
  anon_sym_declare = 126,
  anon_sym_public = 127,
  anon_sym_private = 128,
  anon_sym_protected = 129,
  anon_sym_override = 130,
  anon_sym_module = 131,
  anon_sym_any = 132,
  anon_sym_number = 133,
  anon_sym_boolean = 134,
  anon_sym_string = 135,
  anon_sym_symbol = 136,
  anon_sym_property = 137,
  anon_sym_signal = 138,
  anon_sym_on = 139,
  anon_sym_required = 140,
  anon_sym_component = 141,
  anon_sym_abstract = 142,
  anon_sym_require = 143,
  anon_sym_extends = 144,
  anon_sym_implements = 145,
  anon_sym_global = 146,
  anon_sym_interface = 147,
  anon_sym_enum = 148,
  anon_sym_DASH_QMARK_COLON = 149,
  anon_sym_QMARK_COLON = 150,
  anon_sym_asserts = 151,
  anon_sym_infer = 152,
  anon_sym_is = 153,
  anon_sym_keyof = 154,
  anon_sym_unknown = 155,
  anon_sym_never = 156,
  anon_sym_object = 157,
  anon_sym_LBRACE_PIPE = 158,
  anon_sym_PIPE_RBRACE = 159,
  anon_sym_pragma = 160,
  aux_sym_ui_version_specifier_token1 = 161,
  anon_sym_list = 162,
  sym__automatic_semicolon = 163,
  sym__template_chars = 164,
  sym__ternary_qmark = 165,
  sym__function_signature_automatic_semicolon = 166,
  sym_program = 167,
  sym_export_statement = 168,
  sym_export_clause = 169,
  sym__import_export_specifier = 170,
  sym_declaration = 171,
  sym_import = 172,
  sym_import_statement = 173,
  sym_import_clause = 174,
  sym__from_clause = 175,
  sym_namespace_import_export = 176,
  sym_named_imports = 177,
  sym_expression_statement = 178,
  sym_variable_declaration = 179,
  sym_lexical_declaration = 180,
  sym_variable_declarator = 181,
  sym_statement_block = 182,
  sym_else_clause = 183,
  sym_if_statement = 184,
  sym_switch_statement = 185,
  sym_for_statement = 186,
  sym_for_in_statement = 187,
  sym__for_header = 188,
  sym_while_statement = 189,
  sym_do_statement = 190,
  sym_try_statement = 191,
  sym_with_statement = 192,
  sym_break_statement = 193,
  sym_continue_statement = 194,
  sym_debugger_statement = 195,
  sym_return_statement = 196,
  sym_throw_statement = 197,
  sym_empty_statement = 198,
  sym_labeled_statement = 199,
  sym_switch_body = 200,
  sym_switch_case = 201,
  sym_switch_default = 202,
  sym_catch_clause = 203,
  sym_finally_clause = 204,
  sym_parenthesized_expression = 205,
  sym_expression = 206,
  sym_primary_expression = 207,
  sym_yield_expression = 208,
  sym_object = 209,
  sym_object_pattern = 210,
  sym_assignment_pattern = 211,
  sym_object_assignment_pattern = 212,
  sym_array = 213,
  sym_array_pattern = 214,
  sym_glimmer_template = 215,
  sym_glimmer_opening_tag = 216,
  sym_glimmer_closing_tag = 217,
  sym_nested_identifier = 218,
  sym_class = 219,
  sym_class_declaration = 220,
  sym_class_heritage = 221,
  sym_function = 222,
  sym_function_declaration = 223,
  sym_generator_function = 224,
  sym_generator_function_declaration = 225,
  sym_arrow_function = 226,
  sym__call_signature = 227,
  sym__formal_parameter = 228,
  sym_optional_chain = 229,
  sym_call_expression = 230,
  sym_new_expression = 231,
  sym_await_expression = 232,
  sym_member_expression = 233,
  sym_subscript_expression = 234,
  sym_assignment_expression = 235,
  sym__augmented_assignment_lhs = 236,
  sym_augmented_assignment_expression = 237,
  sym__initializer = 238,
  sym__destructuring_pattern = 239,
  sym_spread_element = 240,
  sym_ternary_expression = 241,
  sym_binary_expression = 242,
  sym_unary_expression = 243,
  sym_update_expression = 244,
  sym_sequence_expression = 245,
  sym_string = 246,
  sym_template_string = 247,
  sym_template_substitution = 248,
  sym_regex = 249,
  sym_meta_property = 250,
  sym_arguments = 251,
  sym_decorator = 252,
  sym_decorator_member_expression = 253,
  sym_decorator_call_expression = 254,
  sym_class_body = 255,
  sym_formal_parameters = 256,
  sym_pattern = 257,
  sym_rest_pattern = 258,
  sym_method_definition = 259,
  sym_pair = 260,
  sym_pair_pattern = 261,
  sym__property_name = 262,
  sym_computed_property_name = 263,
  sym_public_field_definition = 264,
  sym_non_null_expression = 265,
  sym_method_signature = 266,
  sym_abstract_method_signature = 267,
  sym_function_signature = 268,
  sym_type_assertion = 269,
  sym_as_expression = 270,
  sym_import_require_clause = 271,
  sym_extends_clause = 272,
  sym_implements_clause = 273,
  sym_ambient_declaration = 274,
  sym_abstract_class_declaration = 275,
  sym_module = 276,
  sym_internal_module = 277,
  sym__module = 278,
  sym_import_alias = 279,
  sym_nested_type_identifier = 280,
  sym_interface_declaration = 281,
  sym_extends_type_clause = 282,
  sym_enum_declaration = 283,
  sym_enum_body = 284,
  sym_enum_assignment = 285,
  sym_type_alias_declaration = 286,
  sym_accessibility_modifier = 287,
  sym_override_modifier = 288,
  sym_required_parameter = 289,
  sym_optional_parameter = 290,
  sym__parameter_name = 291,
  sym_omitting_type_annotation = 292,
  sym_opting_type_annotation = 293,
  sym_type_annotation = 294,
  sym_asserts = 295,
  sym__type = 296,
  sym_tuple_parameter = 297,
  sym_optional_tuple_parameter = 298,
  sym_optional_type = 299,
  sym_rest_type = 300,
  sym__tuple_type_member = 301,
  sym_constructor_type = 302,
  sym__primary_type = 303,
  sym_template_type = 304,
  sym_template_literal_type = 305,
  sym_infer_type = 306,
  sym_conditional_type = 307,
  sym_generic_type = 308,
  sym_type_predicate = 309,
  sym_type_predicate_annotation = 310,
  sym__type_query_member_expression = 311,
  sym__type_query_subscript_expression = 312,
  sym__type_query_call_expression = 313,
  sym_type_query = 314,
  sym_index_type_query = 315,
  sym_lookup_type = 316,
  sym_mapped_type_clause = 317,
  sym_literal_type = 318,
  sym__number = 319,
  sym_existential_type = 320,
  sym_flow_maybe_type = 321,
  sym_parenthesized_type = 322,
  sym_predefined_type = 323,
  sym_type_arguments = 324,
  sym_object_type = 325,
  sym_call_signature = 326,
  sym_property_signature = 327,
  sym_type_parameters = 328,
  sym_type_parameter = 329,
  sym_default_type = 330,
  sym_constraint = 331,
  sym_construct_signature = 332,
  sym_index_signature = 333,
  sym_array_type = 334,
  sym_tuple_type = 335,
  sym_readonly_type = 336,
  sym_union_type = 337,
  sym_intersection_type = 338,
  sym_function_type = 339,
  sym_ui_pragma = 340,
  sym_ui_import = 341,
  sym_ui_version_specifier = 342,
  sym_ui_object_definition = 343,
  sym_ui_annotated_object = 344,
  sym_ui_annotation = 345,
  sym_ui_object_initializer = 346,
  sym_ui_annotated_object_member = 347,
  sym_ui_object_definition_binding = 348,
  sym_ui_binding = 349,
  sym_ui_property = 350,
  sym_ui_list_property_type = 351,
  sym_ui_property_modifier = 352,
  sym_ui_object_array = 353,
  sym_ui_required = 354,
  sym_ui_signal = 355,
  sym_ui_signal_parameters = 356,
  sym_ui_signal_parameter = 357,
  sym_ui_inline_component = 358,
  sym__qml_enum_declaration = 359,
  sym__qml_enum_body = 360,
  sym__qml_enum_assignment = 361,
  sym__qml_enum_negative_number = 362,
  sym_ui_nested_identifier = 363,
  aux_sym_program_repeat1 = 364,
  aux_sym_export_statement_repeat1 = 365,
  aux_sym_export_clause_repeat1 = 366,
  aux_sym_named_imports_repeat1 = 367,
  aux_sym_variable_declaration_repeat1 = 368,
  aux_sym_statement_block_repeat1 = 369,
  aux_sym_switch_body_repeat1 = 370,
  aux_sym_object_repeat1 = 371,
  aux_sym_object_pattern_repeat1 = 372,
  aux_sym_array_repeat1 = 373,
  aux_sym_array_pattern_repeat1 = 374,
  aux_sym_glimmer_template_repeat1 = 375,
  aux_sym_string_repeat1 = 376,
  aux_sym_string_repeat2 = 377,
  aux_sym_template_string_repeat1 = 378,
  aux_sym_class_body_repeat1 = 379,
  aux_sym_formal_parameters_repeat1 = 380,
  aux_sym_extends_clause_repeat1 = 381,
  aux_sym_implements_clause_repeat1 = 382,
  aux_sym_extends_type_clause_repeat1 = 383,
  aux_sym_enum_body_repeat1 = 384,
  aux_sym_template_literal_type_repeat1 = 385,
  aux_sym_object_type_repeat1 = 386,
  aux_sym_type_parameters_repeat1 = 387,
  aux_sym_tuple_type_repeat1 = 388,
  aux_sym_ui_annotated_object_repeat1 = 389,
  aux_sym_ui_object_initializer_repeat1 = 390,
  aux_sym_ui_property_repeat1 = 391,
  aux_sym_ui_object_array_repeat1 = 392,
  aux_sym_ui_signal_parameters_repeat1 = 393,
  aux_sym__qml_enum_body_repeat1 = 394,
  alias_sym_import_specifier = 395,
  alias_sym_namespace_export = 396,
  alias_sym_property_identifier = 397,
  alias_sym_shorthand_property_identifier = 398,
  alias_sym_shorthand_property_identifier_pattern = 399,
  alias_sym_statement_identifier = 400,
  alias_sym_this_type = 401,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_BANG] = "!",
  [anon_sym_else] = "else",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym__glimmer_template_content] = "_glimmer_template_content",
  [anon_sym_LTtemplate_GT] = "<template>",
  [anon_sym_LT_SLASHtemplate_GT] = "</template>",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_QMARK_DOT] = "\?.",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [sym_unescaped_double_string_fragment] = "string_fragment",
  [sym_unescaped_single_string_fragment] = "string_fragment",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [sym_private_property_identifier] = "private_property_identifier",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_readonly] = "readonly",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_QMARK] = "\?",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_override] = "override",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_property] = "property",
  [anon_sym_signal] = "signal",
  [anon_sym_on] = "on",
  [anon_sym_required] = "required",
  [anon_sym_component] = "component",
  [anon_sym_abstract] = "abstract",
  [anon_sym_require] = "require",
  [anon_sym_extends] = "extends",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_enum] = "enum",
  [anon_sym_DASH_QMARK_COLON] = "-\?:",
  [anon_sym_QMARK_COLON] = "\?:",
  [anon_sym_asserts] = "asserts",
  [anon_sym_infer] = "infer",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_unknown] = "unknown",
  [anon_sym_never] = "never",
  [anon_sym_object] = "object",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [anon_sym_pragma] = "pragma",
  [aux_sym_ui_version_specifier_token1] = "number",
  [anon_sym_list] = "type_identifier",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym__ternary_qmark] = "\?",
  [sym__function_signature_automatic_semicolon] = "_function_signature_automatic_semicolon",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "export_specifier",
  [sym_declaration] = "declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import_export] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_else_clause] = "else_clause",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_object_pattern] = "object_pattern",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_object_assignment_pattern] = "object_assignment_pattern",
  [sym_array] = "array",
  [sym_array_pattern] = "array_pattern",
  [sym_glimmer_template] = "glimmer_template",
  [sym_glimmer_opening_tag] = "glimmer_opening_tag",
  [sym_glimmer_closing_tag] = "glimmer_closing_tag",
  [sym_nested_identifier] = "nested_identifier",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym__call_signature] = "_call_signature",
  [sym__formal_parameter] = "_formal_parameter",
  [sym_optional_chain] = "optional_chain",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym__augmented_assignment_lhs] = "_augmented_assignment_lhs",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym__destructuring_pattern] = "_destructuring_pattern",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_formal_parameters] = "formal_parameters",
  [sym_pattern] = "pattern",
  [sym_rest_pattern] = "rest_pattern",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym_pair_pattern] = "pair_pattern",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_public_field_definition] = "public_field_definition",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_extends_clause] = "extends_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class_declaration] = "abstract_class_declaration",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_type_clause] = "extends_type_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_override_modifier] = "override_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym__parameter_name] = "_parameter_name",
  [sym_omitting_type_annotation] = "omitting_type_annotation",
  [sym_opting_type_annotation] = "opting_type_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym_asserts] = "asserts",
  [sym__type] = "_type",
  [sym_tuple_parameter] = "required_parameter",
  [sym_optional_tuple_parameter] = "optional_parameter",
  [sym_optional_type] = "optional_type",
  [sym_rest_type] = "rest_type",
  [sym__tuple_type_member] = "_tuple_type_member",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_template_type] = "template_type",
  [sym_template_literal_type] = "template_literal_type",
  [sym_infer_type] = "infer_type",
  [sym_conditional_type] = "conditional_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_predicate_annotation] = "type_predicate_annotation",
  [sym__type_query_member_expression] = "member_expression",
  [sym__type_query_subscript_expression] = "subscript_expression",
  [sym__type_query_call_expression] = "call_expression",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type_clause] = "mapped_type_clause",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_call_signature] = "call_signature",
  [sym_property_signature] = "property_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_readonly_type] = "readonly_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [sym_ui_pragma] = "ui_pragma",
  [sym_ui_import] = "ui_import",
  [sym_ui_version_specifier] = "ui_version_specifier",
  [sym_ui_object_definition] = "ui_object_definition",
  [sym_ui_annotated_object] = "ui_annotated_object",
  [sym_ui_annotation] = "ui_annotation",
  [sym_ui_object_initializer] = "ui_object_initializer",
  [sym_ui_annotated_object_member] = "ui_annotated_object_member",
  [sym_ui_object_definition_binding] = "ui_object_definition_binding",
  [sym_ui_binding] = "ui_binding",
  [sym_ui_property] = "ui_property",
  [sym_ui_list_property_type] = "ui_list_property_type",
  [sym_ui_property_modifier] = "ui_property_modifier",
  [sym_ui_object_array] = "ui_object_array",
  [sym_ui_required] = "ui_required",
  [sym_ui_signal] = "ui_signal",
  [sym_ui_signal_parameters] = "ui_signal_parameters",
  [sym_ui_signal_parameter] = "ui_signal_parameter",
  [sym_ui_inline_component] = "ui_inline_component",
  [sym__qml_enum_declaration] = "enum_declaration",
  [sym__qml_enum_body] = "enum_body",
  [sym__qml_enum_assignment] = "enum_assignment",
  [sym__qml_enum_negative_number] = "unary_expression",
  [sym_ui_nested_identifier] = "nested_identifier",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_statement_block_repeat1] = "statement_block_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_object_pattern_repeat1] = "object_pattern_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_array_pattern_repeat1] = "array_pattern_repeat1",
  [aux_sym_glimmer_template_repeat1] = "glimmer_template_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_type_clause_repeat1] = "extends_type_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_template_literal_type_repeat1] = "template_literal_type_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_ui_annotated_object_repeat1] = "ui_annotated_object_repeat1",
  [aux_sym_ui_object_initializer_repeat1] = "ui_object_initializer_repeat1",
  [aux_sym_ui_property_repeat1] = "ui_property_repeat1",
  [aux_sym_ui_object_array_repeat1] = "ui_object_array_repeat1",
  [aux_sym_ui_signal_parameters_repeat1] = "ui_signal_parameters_repeat1",
  [aux_sym__qml_enum_body_repeat1] = "_qml_enum_body_repeat1",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_namespace_export] = "namespace_export",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_shorthand_property_identifier_pattern] = "shorthand_property_identifier_pattern",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_this_type] = "this_type",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [sym__glimmer_template_content] = sym__glimmer_template_content,
  [anon_sym_LTtemplate_GT] = anon_sym_LTtemplate_GT,
  [anon_sym_LT_SLASHtemplate_GT] = anon_sym_LT_SLASHtemplate_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_QMARK_DOT] = anon_sym_QMARK_DOT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym_unescaped_double_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_unescaped_single_string_fragment] = sym_unescaped_double_string_fragment,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [sym_private_property_identifier] = sym_private_property_identifier,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_symbol] = anon_sym_symbol,
  [anon_sym_property] = anon_sym_property,
  [anon_sym_signal] = anon_sym_signal,
  [anon_sym_on] = anon_sym_on,
  [anon_sym_required] = anon_sym_required,
  [anon_sym_component] = anon_sym_component,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_require] = anon_sym_require,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_DASH_QMARK_COLON] = anon_sym_DASH_QMARK_COLON,
  [anon_sym_QMARK_COLON] = anon_sym_QMARK_COLON,
  [anon_sym_asserts] = anon_sym_asserts,
  [anon_sym_infer] = anon_sym_infer,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_keyof] = anon_sym_keyof,
  [anon_sym_unknown] = anon_sym_unknown,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_object] = anon_sym_object,
  [anon_sym_LBRACE_PIPE] = anon_sym_LBRACE_PIPE,
  [anon_sym_PIPE_RBRACE] = anon_sym_PIPE_RBRACE,
  [anon_sym_pragma] = anon_sym_pragma,
  [aux_sym_ui_version_specifier_token1] = sym_number,
  [anon_sym_list] = anon_sym_list,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym__ternary_qmark] = anon_sym_QMARK,
  [sym__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym_declaration] = sym_declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import_export] = sym_namespace_import_export,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_else_clause] = sym_else_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_object_pattern] = sym_object_pattern,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_object_assignment_pattern] = sym_object_assignment_pattern,
  [sym_array] = sym_array,
  [sym_array_pattern] = sym_array_pattern,
  [sym_glimmer_template] = sym_glimmer_template,
  [sym_glimmer_opening_tag] = sym_glimmer_opening_tag,
  [sym_glimmer_closing_tag] = sym_glimmer_closing_tag,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym__call_signature] = sym__call_signature,
  [sym__formal_parameter] = sym__formal_parameter,
  [sym_optional_chain] = sym_optional_chain,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym__augmented_assignment_lhs] = sym__augmented_assignment_lhs,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym__destructuring_pattern] = sym__destructuring_pattern,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_pattern] = sym_pattern,
  [sym_rest_pattern] = sym_rest_pattern,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym_pair_pattern] = sym_pair_pattern,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_non_null_expression] = sym_non_null_expression,
  [sym_method_signature] = sym_method_signature,
  [sym_abstract_method_signature] = sym_abstract_method_signature,
  [sym_function_signature] = sym_function_signature,
  [sym_type_assertion] = sym_type_assertion,
  [sym_as_expression] = sym_as_expression,
  [sym_import_require_clause] = sym_import_require_clause,
  [sym_extends_clause] = sym_extends_clause,
  [sym_implements_clause] = sym_implements_clause,
  [sym_ambient_declaration] = sym_ambient_declaration,
  [sym_abstract_class_declaration] = sym_abstract_class_declaration,
  [sym_module] = sym_module,
  [sym_internal_module] = sym_internal_module,
  [sym__module] = sym__module,
  [sym_import_alias] = sym_import_alias,
  [sym_nested_type_identifier] = sym_nested_type_identifier,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_type_clause] = sym_extends_type_clause,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_assignment] = sym_enum_assignment,
  [sym_type_alias_declaration] = sym_type_alias_declaration,
  [sym_accessibility_modifier] = sym_accessibility_modifier,
  [sym_override_modifier] = sym_override_modifier,
  [sym_required_parameter] = sym_required_parameter,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym__parameter_name] = sym__parameter_name,
  [sym_omitting_type_annotation] = sym_omitting_type_annotation,
  [sym_opting_type_annotation] = sym_opting_type_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym_asserts] = sym_asserts,
  [sym__type] = sym__type,
  [sym_tuple_parameter] = sym_required_parameter,
  [sym_optional_tuple_parameter] = sym_optional_parameter,
  [sym_optional_type] = sym_optional_type,
  [sym_rest_type] = sym_rest_type,
  [sym__tuple_type_member] = sym__tuple_type_member,
  [sym_constructor_type] = sym_constructor_type,
  [sym__primary_type] = sym__primary_type,
  [sym_template_type] = sym_template_type,
  [sym_template_literal_type] = sym_template_literal_type,
  [sym_infer_type] = sym_infer_type,
  [sym_conditional_type] = sym_conditional_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_predicate] = sym_type_predicate,
  [sym_type_predicate_annotation] = sym_type_predicate_annotation,
  [sym__type_query_member_expression] = sym_member_expression,
  [sym__type_query_subscript_expression] = sym_subscript_expression,
  [sym__type_query_call_expression] = sym_call_expression,
  [sym_type_query] = sym_type_query,
  [sym_index_type_query] = sym_index_type_query,
  [sym_lookup_type] = sym_lookup_type,
  [sym_mapped_type_clause] = sym_mapped_type_clause,
  [sym_literal_type] = sym_literal_type,
  [sym__number] = sym_unary_expression,
  [sym_existential_type] = sym_existential_type,
  [sym_flow_maybe_type] = sym_flow_maybe_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_predefined_type] = sym_predefined_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_object_type] = sym_object_type,
  [sym_call_signature] = sym_call_signature,
  [sym_property_signature] = sym_property_signature,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_default_type] = sym_default_type,
  [sym_constraint] = sym_constraint,
  [sym_construct_signature] = sym_construct_signature,
  [sym_index_signature] = sym_index_signature,
  [sym_array_type] = sym_array_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_readonly_type] = sym_readonly_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_function_type] = sym_function_type,
  [sym_ui_pragma] = sym_ui_pragma,
  [sym_ui_import] = sym_ui_import,
  [sym_ui_version_specifier] = sym_ui_version_specifier,
  [sym_ui_object_definition] = sym_ui_object_definition,
  [sym_ui_annotated_object] = sym_ui_annotated_object,
  [sym_ui_annotation] = sym_ui_annotation,
  [sym_ui_object_initializer] = sym_ui_object_initializer,
  [sym_ui_annotated_object_member] = sym_ui_annotated_object_member,
  [sym_ui_object_definition_binding] = sym_ui_object_definition_binding,
  [sym_ui_binding] = sym_ui_binding,
  [sym_ui_property] = sym_ui_property,
  [sym_ui_list_property_type] = sym_ui_list_property_type,
  [sym_ui_property_modifier] = sym_ui_property_modifier,
  [sym_ui_object_array] = sym_ui_object_array,
  [sym_ui_required] = sym_ui_required,
  [sym_ui_signal] = sym_ui_signal,
  [sym_ui_signal_parameters] = sym_ui_signal_parameters,
  [sym_ui_signal_parameter] = sym_ui_signal_parameter,
  [sym_ui_inline_component] = sym_ui_inline_component,
  [sym__qml_enum_declaration] = sym_enum_declaration,
  [sym__qml_enum_body] = sym_enum_body,
  [sym__qml_enum_assignment] = sym_enum_assignment,
  [sym__qml_enum_negative_number] = sym_unary_expression,
  [sym_ui_nested_identifier] = sym_nested_identifier,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_statement_block_repeat1] = aux_sym_statement_block_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_object_pattern_repeat1] = aux_sym_object_pattern_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_array_pattern_repeat1] = aux_sym_array_pattern_repeat1,
  [aux_sym_glimmer_template_repeat1] = aux_sym_glimmer_template_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [aux_sym_extends_clause_repeat1] = aux_sym_extends_clause_repeat1,
  [aux_sym_implements_clause_repeat1] = aux_sym_implements_clause_repeat1,
  [aux_sym_extends_type_clause_repeat1] = aux_sym_extends_type_clause_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_template_literal_type_repeat1] = aux_sym_template_literal_type_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_ui_annotated_object_repeat1] = aux_sym_ui_annotated_object_repeat1,
  [aux_sym_ui_object_initializer_repeat1] = aux_sym_ui_object_initializer_repeat1,
  [aux_sym_ui_property_repeat1] = aux_sym_ui_property_repeat1,
  [aux_sym_ui_object_array_repeat1] = aux_sym_ui_object_array_repeat1,
  [aux_sym_ui_signal_parameters_repeat1] = aux_sym_ui_signal_parameters_repeat1,
  [aux_sym__qml_enum_body_repeat1] = aux_sym__qml_enum_body_repeat1,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_namespace_export] = alias_sym_namespace_export,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_shorthand_property_identifier_pattern] = alias_sym_shorthand_property_identifier_pattern,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_this_type] = alias_sym_this_type,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym__glimmer_template_content] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LTtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_SLASHtemplate_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_unescaped_double_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_unescaped_single_string_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_private_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_property] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_on] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_required] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_component] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asserts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unknown] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_object] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pragma] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_ui_version_specifier_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym__ternary_qmark] = {
    .visible = true,
    .named = false,
  },
  [sym__function_signature_automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import_export] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_object_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_template] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_opening_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_glimmer_closing_tag] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym__call_signature] = {
    .visible = false,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_optional_chain] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__augmented_assignment_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym__destructuring_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_rest_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_pair_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_override_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_name] = {
    .visible = false,
    .named = true,
  },
  [sym_omitting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_opting_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_asserts] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_tuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_type] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_type_member] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_infer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__type_query_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_readonly_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_pragma] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_import] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_version_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_object_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_annotated_object] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_object_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_annotated_object_member] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_object_definition_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_property] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_list_property_type] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_property_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_object_array] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_required] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_signal] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_signal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_signal_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_inline_component] = {
    .visible = true,
    .named = true,
  },
  [sym__qml_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__qml_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym__qml_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__qml_enum_negative_number] = {
    .visible = true,
    .named = true,
  },
  [sym_ui_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_statement_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_glimmer_template_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_type_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_literal_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ui_annotated_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ui_object_initializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ui_property_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ui_object_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ui_signal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__qml_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_export] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_this_type] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_annotation = 3,
  field_argument = 4,
  field_arguments = 5,
  field_body = 6,
  field_close_tag = 7,
  field_component = 8,
  field_condition = 9,
  field_consequence = 10,
  field_constraint = 11,
  field_constructor = 12,
  field_content = 13,
  field_declaration = 14,
  field_decorator = 15,
  field_definition = 16,
  field_finalizer = 17,
  field_flags = 18,
  field_function = 19,
  field_handler = 20,
  field_increment = 21,
  field_index = 22,
  field_index_type = 23,
  field_initializer = 24,
  field_key = 25,
  field_kind = 26,
  field_label = 27,
  field_left = 28,
  field_major = 29,
  field_minor = 30,
  field_module = 31,
  field_name = 32,
  field_object = 33,
  field_open_tag = 34,
  field_operator = 35,
  field_optional_chain = 36,
  field_parameter = 37,
  field_parameters = 38,
  field_pattern = 39,
  field_property = 40,
  field_return_type = 41,
  field_right = 42,
  field_root = 43,
  field_sign = 44,
  field_source = 45,
  field_type = 46,
  field_type_arguments = 47,
  field_type_name = 48,
  field_type_parameters = 49,
  field_value = 50,
  field_version = 51,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_annotation] = "annotation",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_component] = "component",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_constructor] = "constructor",
  [field_content] = "content",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_definition] = "definition",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_index_type] = "index_type",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_kind] = "kind",
  [field_label] = "label",
  [field_left] = "left",
  [field_major] = "major",
  [field_minor] = "minor",
  [field_module] = "module",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_optional_chain] = "optional_chain",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_root] = "root",
  [field_sign] = "sign",
  [field_source] = "source",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_name] = "type_name",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
  [field_version] = "version",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 2},
  [5] = {.index = 3, .length = 2},
  [6] = {.index = 5, .length = 2},
  [7] = {.index = 7, .length = 2},
  [8] = {.index = 9, .length = 1},
  [9] = {.index = 10, .length = 2},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 13, .length = 1},
  [13] = {.index = 14, .length = 2},
  [14] = {.index = 16, .length = 1},
  [15] = {.index = 17, .length = 1},
  [16] = {.index = 18, .length = 4},
  [17] = {.index = 22, .length = 2},
  [18] = {.index = 24, .length = 2},
  [19] = {.index = 26, .length = 1},
  [20] = {.index = 27, .length = 1},
  [22] = {.index = 28, .length = 2},
  [23] = {.index = 30, .length = 2},
  [24] = {.index = 24, .length = 2},
  [25] = {.index = 16, .length = 1},
  [26] = {.index = 32, .length = 3},
  [27] = {.index = 35, .length = 2},
  [28] = {.index = 37, .length = 2},
  [29] = {.index = 39, .length = 2},
  [30] = {.index = 41, .length = 2},
  [31] = {.index = 43, .length = 2},
  [32] = {.index = 45, .length = 1},
  [33] = {.index = 46, .length = 2},
  [34] = {.index = 48, .length = 1},
  [36] = {.index = 17, .length = 1},
  [38] = {.index = 49, .length = 2},
  [39] = {.index = 51, .length = 1},
  [40] = {.index = 52, .length = 2},
  [41] = {.index = 54, .length = 2},
  [42] = {.index = 56, .length = 2},
  [43] = {.index = 58, .length = 2},
  [44] = {.index = 60, .length = 2},
  [45] = {.index = 62, .length = 2},
  [46] = {.index = 64, .length = 3},
  [47] = {.index = 64, .length = 3},
  [50] = {.index = 67, .length = 1},
  [51] = {.index = 68, .length = 2},
  [52] = {.index = 70, .length = 3},
  [53] = {.index = 73, .length = 5},
  [54] = {.index = 64, .length = 3},
  [55] = {.index = 64, .length = 3},
  [56] = {.index = 78, .length = 2},
  [57] = {.index = 80, .length = 2},
  [58] = {.index = 78, .length = 2},
  [59] = {.index = 78, .length = 2},
  [60] = {.index = 78, .length = 2},
  [61] = {.index = 82, .length = 2},
  [62] = {.index = 84, .length = 2},
  [63] = {.index = 86, .length = 3},
  [64] = {.index = 89, .length = 2},
  [65] = {.index = 91, .length = 2},
  [66] = {.index = 93, .length = 2},
  [68] = {.index = 95, .length = 1},
  [69] = {.index = 96, .length = 2},
  [70] = {.index = 98, .length = 2},
  [71] = {.index = 100, .length = 1},
  [72] = {.index = 101, .length = 3},
  [73] = {.index = 104, .length = 3},
  [74] = {.index = 107, .length = 2},
  [75] = {.index = 109, .length = 2},
  [76] = {.index = 111, .length = 2},
  [77] = {.index = 113, .length = 2},
  [78] = {.index = 115, .length = 3},
  [79] = {.index = 118, .length = 2},
  [80] = {.index = 120, .length = 2},
  [81] = {.index = 122, .length = 2},
  [82] = {.index = 124, .length = 2},
  [83] = {.index = 126, .length = 2},
  [84] = {.index = 128, .length = 2},
  [86] = {.index = 124, .length = 2},
  [87] = {.index = 130, .length = 2},
  [88] = {.index = 132, .length = 1},
  [89] = {.index = 133, .length = 2},
  [90] = {.index = 135, .length = 4},
  [91] = {.index = 139, .length = 2},
  [92] = {.index = 141, .length = 2},
  [93] = {.index = 89, .length = 2},
  [94] = {.index = 91, .length = 2},
  [95] = {.index = 143, .length = 3},
  [96] = {.index = 146, .length = 2},
  [97] = {.index = 146, .length = 2},
  [98] = {.index = 148, .length = 3},
  [99] = {.index = 148, .length = 3},
  [100] = {.index = 151, .length = 3},
  [101] = {.index = 154, .length = 2},
  [102] = {.index = 156, .length = 3},
  [103] = {.index = 159, .length = 4},
  [104] = {.index = 163, .length = 3},
  [105] = {.index = 166, .length = 2},
  [106] = {.index = 89, .length = 2},
  [107] = {.index = 168, .length = 2},
  [108] = {.index = 170, .length = 5},
  [109] = {.index = 175, .length = 3},
  [110] = {.index = 175, .length = 3},
  [112] = {.index = 175, .length = 3},
  [113] = {.index = 175, .length = 3},
  [114] = {.index = 178, .length = 2},
  [115] = {.index = 178, .length = 2},
  [116] = {.index = 180, .length = 2},
  [117] = {.index = 182, .length = 2},
  [118] = {.index = 182, .length = 2},
  [119] = {.index = 182, .length = 2},
  [120] = {.index = 182, .length = 2},
  [121] = {.index = 184, .length = 1},
  [122] = {.index = 185, .length = 2},
  [123] = {.index = 187, .length = 1},
  [124] = {.index = 188, .length = 6},
  [125] = {.index = 194, .length = 2},
  [126] = {.index = 196, .length = 1},
  [127] = {.index = 130, .length = 2},
  [128] = {.index = 197, .length = 5},
  [129] = {.index = 202, .length = 2},
  [130] = {.index = 204, .length = 3},
  [131] = {.index = 207, .length = 1},
  [132] = {.index = 208, .length = 1},
  [133] = {.index = 209, .length = 3},
  [134] = {.index = 212, .length = 3},
  [135] = {.index = 215, .length = 4},
  [136] = {.index = 219, .length = 2},
  [137] = {.index = 221, .length = 3},
  [138] = {.index = 224, .length = 1},
  [139] = {.index = 225, .length = 4},
  [140] = {.index = 229, .length = 4},
  [141] = {.index = 233, .length = 4},
  [142] = {.index = 237, .length = 3},
  [143] = {.index = 240, .length = 2},
  [144] = {.index = 242, .length = 2},
  [145] = {.index = 244, .length = 2},
  [146] = {.index = 246, .length = 3},
  [147] = {.index = 249, .length = 2},
  [148] = {.index = 251, .length = 3},
  [149] = {.index = 254, .length = 2},
  [150] = {.index = 256, .length = 2},
  [151] = {.index = 258, .length = 4},
  [152] = {.index = 256, .length = 2},
  [153] = {.index = 262, .length = 4},
  [154] = {.index = 266, .length = 3},
  [155] = {.index = 269, .length = 2},
  [156] = {.index = 271, .length = 3},
  [157] = {.index = 274, .length = 3},
  [158] = {.index = 277, .length = 2},
  [159] = {.index = 279, .length = 3},
  [160] = {.index = 282, .length = 5},
  [161] = {.index = 287, .length = 4},
  [162] = {.index = 287, .length = 4},
  [163] = {.index = 287, .length = 4},
  [164] = {.index = 287, .length = 4},
  [165] = {.index = 68, .length = 2},
  [166] = {.index = 291, .length = 4},
  [167] = {.index = 295, .length = 2},
  [168] = {.index = 297, .length = 2},
  [169] = {.index = 299, .length = 3},
  [170] = {.index = 302, .length = 3},
  [171] = {.index = 302, .length = 3},
  [172] = {.index = 302, .length = 3},
  [173] = {.index = 302, .length = 3},
  [174] = {.index = 305, .length = 1},
  [175] = {.index = 306, .length = 1},
  [176] = {.index = 307, .length = 2},
  [177] = {.index = 305, .length = 1},
  [178] = {.index = 309, .length = 1},
  [179] = {.index = 307, .length = 2},
  [180] = {.index = 310, .length = 2},
  [181] = {.index = 312, .length = 6},
  [182] = {.index = 318, .length = 4},
  [183] = {.index = 310, .length = 2},
  [184] = {.index = 322, .length = 1},
  [185] = {.index = 322, .length = 1},
  [186] = {.index = 323, .length = 5},
  [187] = {.index = 328, .length = 2},
  [188] = {.index = 330, .length = 1},
  [189] = {.index = 331, .length = 4},
  [190] = {.index = 335, .length = 2},
  [191] = {.index = 337, .length = 2},
  [192] = {.index = 339, .length = 2},
  [193] = {.index = 341, .length = 1},
  [194] = {.index = 342, .length = 2},
  [195] = {.index = 344, .length = 1},
  [196] = {.index = 345, .length = 4},
  [197] = {.index = 349, .length = 4},
  [198] = {.index = 349, .length = 4},
  [199] = {.index = 353, .length = 4},
  [200] = {.index = 353, .length = 4},
  [201] = {.index = 357, .length = 4},
  [202] = {.index = 357, .length = 4},
  [203] = {.index = 361, .length = 2},
  [204] = {.index = 363, .length = 3},
  [205] = {.index = 366, .length = 2},
  [206] = {.index = 368, .length = 2},
  [207] = {.index = 370, .length = 3},
  [208] = {.index = 373, .length = 4},
  [209] = {.index = 377, .length = 4},
  [210] = {.index = 381, .length = 4},
  [211] = {.index = 385, .length = 3},
  [212] = {.index = 388, .length = 3},
  [213] = {.index = 68, .length = 2},
  [214] = {.index = 391, .length = 3},
  [215] = {.index = 394, .length = 4},
  [216] = {.index = 398, .length = 3},
  [217] = {.index = 401, .length = 4},
  [218] = {.index = 401, .length = 4},
  [219] = {.index = 401, .length = 4},
  [220] = {.index = 401, .length = 4},
  [221] = {.index = 405, .length = 1},
  [222] = {.index = 406, .length = 2},
  [223] = {.index = 408, .length = 5},
  [224] = {.index = 39, .length = 2},
  [225] = {.index = 413, .length = 2},
  [226] = {.index = 415, .length = 4},
  [227] = {.index = 419, .length = 2},
  [228] = {.index = 421, .length = 3},
  [229] = {.index = 424, .length = 2},
  [230] = {.index = 424, .length = 2},
  [231] = {.index = 426, .length = 2},
  [232] = {.index = 428, .length = 3},
  [233] = {.index = 431, .length = 2},
  [234] = {.index = 433, .length = 4},
  [235] = {.index = 68, .length = 2},
  [236] = {.index = 437, .length = 1},
  [237] = {.index = 438, .length = 3},
  [238] = {.index = 441, .length = 2},
  [239] = {.index = 443, .length = 2},
  [240] = {.index = 445, .length = 1},
  [241] = {.index = 446, .length = 2},
  [242] = {.index = 448, .length = 2},
  [243] = {.index = 450, .length = 4},
  [244] = {.index = 454, .length = 4},
  [245] = {.index = 458, .length = 4},
  [246] = {.index = 462, .length = 3},
  [247] = {.index = 465, .length = 2},
  [248] = {.index = 467, .length = 2},
  [249] = {.index = 469, .length = 2},
  [250] = {.index = 471, .length = 3},
  [251] = {.index = 474, .length = 3},
  [252] = {.index = 477, .length = 4},
  [253] = {.index = 481, .length = 2},
  [254] = {.index = 483, .length = 3},
  [255] = {.index = 486, .length = 3},
  [256] = {.index = 486, .length = 3},
  [257] = {.index = 489, .length = 3},
  [258] = {.index = 492, .length = 5},
  [259] = {.index = 497, .length = 3},
  [260] = {.index = 500, .length = 2},
  [261] = {.index = 502, .length = 1},
  [262] = {.index = 503, .length = 3},
  [263] = {.index = 506, .length = 4},
  [264] = {.index = 510, .length = 2},
  [265] = {.index = 512, .length = 2},
  [266] = {.index = 514, .length = 4},
  [267] = {.index = 518, .length = 4},
  [268] = {.index = 522, .length = 2},
  [269] = {.index = 524, .length = 2},
  [270] = {.index = 526, .length = 1},
  [271] = {.index = 527, .length = 3},
  [272] = {.index = 530, .length = 1},
  [273] = {.index = 531, .length = 2},
  [274] = {.index = 533, .length = 4},
  [275] = {.index = 537, .length = 4},
  [276] = {.index = 541, .length = 4},
  [277] = {.index = 545, .length = 3},
  [278] = {.index = 548, .length = 2},
  [279] = {.index = 550, .length = 3},
  [280] = {.index = 553, .length = 3},
  [281] = {.index = 556, .length = 2},
  [282] = {.index = 558, .length = 1},
  [283] = {.index = 559, .length = 4},
  [284] = {.index = 563, .length = 4},
  [285] = {.index = 567, .length = 5},
  [286] = {.index = 572, .length = 5},
  [288] = {.index = 577, .length = 4},
  [289] = {.index = 581, .length = 3},
  [290] = {.index = 584, .length = 3},
  [291] = {.index = 587, .length = 3},
  [292] = {.index = 584, .length = 3},
  [293] = {.index = 590, .length = 2},
  [294] = {.index = 592, .length = 4},
  [295] = {.index = 596, .length = 4},
  [296] = {.index = 600, .length = 2},
  [297] = {.index = 602, .length = 2},
  [298] = {.index = 604, .length = 4},
  [299] = {.index = 608, .length = 3},
  [300] = {.index = 611, .length = 2},
  [301] = {.index = 613, .length = 3},
  [302] = {.index = 616, .length = 2},
  [303] = {.index = 618, .length = 1},
  [304] = {.index = 619, .length = 5},
  [305] = {.index = 624, .length = 5},
  [306] = {.index = 629, .length = 5},
  [307] = {.index = 634, .length = 4},
  [308] = {.index = 638, .length = 4},
  [309] = {.index = 642, .length = 3},
  [310] = {.index = 642, .length = 3},
  [311] = {.index = 645, .length = 2},
  [312] = {.index = 647, .length = 3},
  [313] = {.index = 650, .length = 2},
  [314] = {.index = 652, .length = 3},
  [315] = {.index = 655, .length = 2},
  [316] = {.index = 657, .length = 2},
  [317] = {.index = 659, .length = 5},
  [318] = {.index = 664, .length = 5},
  [319] = {.index = 669, .length = 4},
  [320] = {.index = 669, .length = 4},
  [321] = {.index = 673, .length = 4},
  [322] = {.index = 677, .length = 4},
  [323] = {.index = 681, .length = 3},
  [324] = {.index = 684, .length = 2},
  [325] = {.index = 686, .length = 2},
  [326] = {.index = 688, .length = 3},
  [327] = {.index = 691, .length = 5},
  [328] = {.index = 696, .length = 4},
  [329] = {.index = 700, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_root, 0},
  [1] =
    {field_annotation, 0},
  [2] =
    {field_root, 1},
  [3] =
    {field_initializer, 1},
    {field_type_name, 0},
  [5] =
    {field_annotation, 0, .inherited = true},
    {field_definition, 1},
  [7] =
    {field_annotation, 0, .inherited = true},
    {field_annotation, 1, .inherited = true},
  [9] =
    {field_root, 2},
  [10] =
    {field_body, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [12] =
    {field_source, 1},
  [13] =
    {field_major, 0},
  [14] =
    {field_initializer, 2},
    {field_type_name, 1},
  [16] =
    {field_name, 1},
  [17] =
    {field_name, 0},
  [18] =
    {field_annotation, 0, .inherited = true},
    {field_body, 1, .inherited = true},
    {field_definition, 1},
    {field_name, 1, .inherited = true},
  [22] =
    {field_source, 1},
    {field_version, 2},
  [24] =
    {field_name, 0},
    {field_value, 2},
  [26] =
    {field_decorator, 0},
  [27] =
    {field_parameters, 0},
  [28] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [30] =
    {field_name, 0},
    {field_type, 1},
  [32] =
    {field_body, 2},
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [35] =
    {field_alias, 3},
    {field_source, 1},
  [37] =
    {field_major, 0},
    {field_minor, 2},
  [39] =
    {field_name, 1},
    {field_value, 3},
  [41] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [43] =
    {field_argument, 1},
    {field_operator, 0},
  [45] =
    {field_pattern, 0},
  [46] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
  [48] =
    {field_body, 1},
  [49] =
    {field_argument, 0, .inherited = true},
    {field_operator, 0, .inherited = true},
  [51] =
    {field_constructor, 1},
  [52] =
    {field_argument, 0},
    {field_operator, 1},
  [54] =
    {field_arguments, 1},
    {field_function, 0},
  [56] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [58] =
    {field_parameters, 0},
    {field_return_type, 1},
  [60] =
    {field_parameters, 1},
    {field_type_parameters, 0},
  [62] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [64] =
    {field_initializer, 3},
    {field_name, 2},
    {field_type_name, 0},
  [67] =
    {field_value, 1},
  [68] =
    {field_name, 0},
    {field_type, 2},
  [70] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [73] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [78] =
    {field_name, 2},
    {field_type, 1},
  [80] =
    {field_module, 0},
    {field_name, 2},
  [82] =
    {field_name, 1},
    {field_parameters, 2},
  [84] =
    {field_component, 3},
    {field_name, 1},
  [86] =
    {field_alias, 4},
    {field_source, 1},
    {field_version, 2},
  [89] =
    {field_left, 0},
    {field_right, 2},
  [91] =
    {field_body, 2},
    {field_parameter, 0},
  [93] =
    {field_body, 1},
    {field_name, 0},
  [95] =
    {field_declaration, 1},
  [96] =
    {field_condition, 1},
    {field_consequence, 2},
  [98] =
    {field_body, 2},
    {field_value, 1},
  [100] =
    {field_pattern, 1},
  [101] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [104] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
  [107] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 1},
  [109] =
    {field_body, 1},
    {field_handler, 2},
  [111] =
    {field_body, 1},
    {field_finalizer, 2},
  [113] =
    {field_body, 2},
    {field_object, 1},
  [115] =
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [118] =
    {field_object, 1, .inherited = true},
    {field_property, 1, .inherited = true},
  [120] =
    {field_index, 1, .inherited = true},
    {field_object, 1, .inherited = true},
  [122] =
    {field_arguments, 1, .inherited = true},
    {field_function, 1, .inherited = true},
  [124] =
    {field_name, 0},
    {field_type_arguments, 1},
  [126] =
    {field_name, 0},
    {field_value, 1},
  [128] =
    {field_constraint, 1},
    {field_name, 0},
  [130] =
    {field_body, 2},
    {field_name, 1},
  [132] =
    {field_body, 2},
  [133] =
    {field_body, 2},
    {field_type_parameters, 1},
  [135] =
    {field_body, 2},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [139] =
    {field_arguments, 2},
    {field_constructor, 1},
  [141] =
    {field_constructor, 1},
    {field_type_arguments, 2},
  [143] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [146] =
    {field_object, 0},
    {field_property, 2},
  [148] =
    {field_object, 0},
    {field_optional_chain, 1},
    {field_property, 2},
  [151] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [154] =
    {field_arguments, 2},
    {field_function, 0},
  [156] =
    {field_close_tag, 2},
    {field_content, 1},
    {field_open_tag, 0},
  [159] =
    {field_body, 2},
    {field_parameters, 0, .inherited = true},
    {field_return_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [163] =
    {field_parameters, 1},
    {field_return_type, 2},
    {field_type_parameters, 0},
  [166] =
    {field_body, 2},
    {field_decorator, 0, .inherited = true},
  [168] =
    {field_key, 0},
    {field_value, 2},
  [170] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [175] =
    {field_name, 2},
    {field_type, 1},
    {field_value, 4},
  [178] =
    {field_name, 1},
    {field_type, 0},
  [180] =
    {field_name, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [182] =
    {field_name, 3},
    {field_type, 2},
  [184] =
    {field_declaration, 2},
  [185] =
    {field_body, 2},
    {field_label, 0},
  [187] =
    {field_kind, 0},
  [188] =
    {field_body, 2},
    {field_kind, 1, .inherited = true},
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [194] =
    {field_body, 2},
    {field_condition, 1},
  [196] =
    {field_label, 1},
  [197] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [202] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [204] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [207] =
    {field_type, 2},
  [208] =
    {field_pattern, 2},
  [209] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [212] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
  [215] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 1},
    {field_value, 2, .inherited = true},
  [219] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 2},
  [221] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [224] =
    {field_parameters, 1},
  [225] =
    {field_name, 0},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [229] =
    {field_arguments, 1},
    {field_function, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [233] =
    {field_arguments, 1},
    {field_function, 0},
    {field_index, 0, .inherited = true},
    {field_object, 0, .inherited = true},
  [237] =
    {field_constraint, 1},
    {field_name, 0},
    {field_value, 2},
  [240] =
    {field_parameters, 0},
    {field_return_type, 2},
  [242] =
    {field_flags, 3},
    {field_pattern, 1},
  [244] =
    {field_body, 3},
    {field_name, 1},
  [246] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [249] =
    {field_type_arguments, 2},
    {field_value, 1},
  [251] =
    {field_type_arguments, 2, .inherited = true},
    {field_value, 1},
    {field_value, 2, .inherited = true},
  [254] =
    {field_body, 3},
    {field_type_parameters, 1},
  [256] =
    {field_body, 3},
    {field_parameter, 1},
  [258] =
    {field_body, 3},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [262] =
    {field_body, 3},
    {field_parameters, 1, .inherited = true},
    {field_return_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [266] =
    {field_arguments, 3},
    {field_constructor, 1},
    {field_type_arguments, 2},
  [269] =
    {field_index, 2},
    {field_object, 0},
  [271] =
    {field_arguments, 3},
    {field_function, 0},
    {field_type_arguments, 2},
  [274] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [277] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [279] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [282] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [287] =
    {field_name, 2},
    {field_type, 1},
    {field_value, 4},
    {field_value, 5},
  [291] =
    {field_argument, 2, .inherited = true},
    {field_name, 0},
    {field_operator, 2, .inherited = true},
    {field_value, 2},
  [295] =
    {field_name, 1},
    {field_name, 2, .inherited = true},
  [297] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [299] =
    {field_name, 1, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_value, 1, .inherited = true},
  [302] =
    {field_name, 3},
    {field_type, 2},
    {field_value, 5},
  [305] =
    {field_source, 2, .inherited = true},
  [306] =
    {field_value, 2},
  [307] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [309] =
    {field_source, 2},
  [310] =
    {field_body, 3},
    {field_name, 2},
  [312] =
    {field_body, 3},
    {field_kind, 2, .inherited = true},
    {field_left, 2, .inherited = true},
    {field_operator, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [318] =
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [322] =
    {field_type, 1},
  [323] =
    {field_body, 3},
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [328] =
    {field_declaration, 3},
    {field_decorator, 0, .inherited = true},
  [330] =
    {field_pattern, 3},
  [331] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 0, .inherited = true},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [335] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 3},
  [337] =
    {field_parameters, 1},
    {field_type, 2},
  [339] =
    {field_parameters, 2},
    {field_type_parameters, 1},
  [341] =
    {field_name, 2},
  [342] =
    {field_name, 1},
    {field_type, 2},
  [344] =
    {field_parameters, 2},
  [345] =
    {field_name, 0},
    {field_parameters, 2, .inherited = true},
    {field_return_type, 2, .inherited = true},
    {field_type_parameters, 2, .inherited = true},
  [349] =
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_property, 2},
  [353] =
    {field_index, 0, .inherited = true},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 2},
  [357] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_object, 0},
    {field_property, 2},
  [361] =
    {field_parameters, 1},
    {field_type, 3},
  [363] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_type_parameters, 0},
  [366] =
    {field_name, 1},
    {field_value, 2, .inherited = true},
  [368] =
    {field_name, 0},
    {field_value, 2, .inherited = true},
  [370] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [373] =
    {field_type_arguments, 2},
    {field_type_arguments, 3, .inherited = true},
    {field_value, 1},
    {field_value, 3, .inherited = true},
  [377] =
    {field_type_arguments, 0, .inherited = true},
    {field_type_arguments, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [381] =
    {field_body, 4},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [385] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [388] =
    {field_index, 3},
    {field_object, 0},
    {field_optional_chain, 1},
  [391] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [394] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [398] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_type_parameters, 2},
  [401] =
    {field_name, 3},
    {field_type, 2},
    {field_value, 5},
    {field_value, 6},
  [405] =
    {field_source, 3, .inherited = true},
  [406] =
    {field_alias, 2},
    {field_name, 0},
  [408] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [413] =
    {field_body, 1},
    {field_condition, 3},
  [415] =
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [419] =
    {field_body, 4},
    {field_name, 2},
  [421] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [424] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [426] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [428] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [431] =
    {field_decorator, 0, .inherited = true},
    {field_pattern, 4},
  [433] =
    {field_name, 1},
    {field_parameters, 3, .inherited = true},
    {field_return_type, 3, .inherited = true},
    {field_type_parameters, 3, .inherited = true},
  [437] =
    {field_type, 3},
  [438] =
    {field_parameters, 2},
    {field_type, 3},
    {field_type_parameters, 1},
  [441] =
    {field_name, 2},
    {field_type, 3},
  [443] =
    {field_name, 1},
    {field_type, 3},
  [445] =
    {field_name, 3},
  [446] =
    {field_parameters, 2},
    {field_type, 3},
  [448] =
    {field_parameters, 3},
    {field_type_parameters, 2},
  [450] =
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [454] =
    {field_index, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [458] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 2},
    {field_object, 0},
  [462] =
    {field_parameters, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [465] =
    {field_parameters, 2},
    {field_type, 4},
  [467] =
    {field_name, 2},
    {field_value, 3, .inherited = true},
  [469] =
    {field_name, 1},
    {field_value, 3, .inherited = true},
  [471] =
    {field_name, 1},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [474] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 3, .inherited = true},
  [477] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
    {field_type_parameters, 3},
  [481] =
    {field_alias, 3},
    {field_name, 1},
  [483] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [486] =
    {field_left, 1},
    {field_operator, 2},
    {field_right, 3},
  [489] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [492] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [497] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [500] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [502] =
    {field_name, 2, .inherited = true},
  [503] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
  [506] =
    {field_body, 5},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [510] =
    {field_body, 3},
    {field_value, 1},
  [512] =
    {field_body, 4},
    {field_parameter, 2},
  [514] =
    {field_name, 2},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [518] =
    {field_name, 3},
    {field_parameters, 4, .inherited = true},
    {field_return_type, 4, .inherited = true},
    {field_type_parameters, 4, .inherited = true},
  [522] =
    {field_name, 2},
    {field_type, 4},
  [524] =
    {field_name, 3},
    {field_type, 4},
  [526] =
    {field_type, 4},
  [527] =
    {field_parameters, 3},
    {field_type, 4},
    {field_type_parameters, 2},
  [530] =
    {field_name, 4},
  [531] =
    {field_index, 3},
    {field_object, 0},
  [533] =
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
    {field_property, 0, .inherited = true},
  [537] =
    {field_index, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
    {field_object, 0, .inherited = true},
  [541] =
    {field_arguments, 0, .inherited = true},
    {field_function, 0, .inherited = true},
    {field_index, 3},
    {field_object, 0},
  [545] =
    {field_parameters, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [548] =
    {field_name, 2},
    {field_value, 4, .inherited = true},
  [550] =
    {field_name, 2},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [553] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 4, .inherited = true},
  [556] =
    {field_name, 3},
    {field_value, 4, .inherited = true},
  [558] =
    {field_source, 4},
  [559] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 3},
    {field_right, 4},
  [563] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [567] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [572] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [577] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 3},
    {field_type_parameters, 4},
  [581] =
    {field_body, 5},
    {field_parameter, 2},
    {field_type, 3},
  [584] =
    {field_index_type, 3},
    {field_name, 1},
    {field_type, 5},
  [587] =
    {field_alias, 4},
    {field_name, 0},
    {field_type, 2},
  [590] =
    {field_sign, 0},
    {field_type, 5},
  [592] =
    {field_name, 3},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [596] =
    {field_name, 4},
    {field_parameters, 5, .inherited = true},
    {field_return_type, 5, .inherited = true},
    {field_type_parameters, 5, .inherited = true},
  [600] =
    {field_name, 3},
    {field_type, 5},
  [602] =
    {field_name, 4},
    {field_type, 5},
  [604] =
    {field_alternative, 6},
    {field_consequence, 4},
    {field_left, 0},
    {field_right, 2},
  [608] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [611] =
    {field_name, 3},
    {field_value, 5, .inherited = true},
  [613] =
    {field_name, 3},
    {field_type, 4},
    {field_value, 5, .inherited = true},
  [616] =
    {field_name, 4},
    {field_value, 5, .inherited = true},
  [618] =
    {field_name, 5},
  [619] =
    {field_kind, 1},
    {field_left, 2},
    {field_operator, 4},
    {field_right, 5},
    {field_value, 3, .inherited = true},
  [624] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [629] =
    {field_body, 7},
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [634] =
    {field_name, 4},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [638] =
    {field_name, 5},
    {field_parameters, 6, .inherited = true},
    {field_return_type, 6, .inherited = true},
    {field_type_parameters, 6, .inherited = true},
  [642] =
    {field_index_type, 4},
    {field_name, 2},
    {field_type, 6},
  [645] =
    {field_name, 4},
    {field_type, 6},
  [647] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [650] =
    {field_name, 4},
    {field_value, 6, .inherited = true},
  [652] =
    {field_name, 4},
    {field_type, 5},
    {field_value, 6, .inherited = true},
  [655] =
    {field_name, 5},
    {field_value, 6, .inherited = true},
  [657] =
    {field_name, 5},
    {field_type, 6},
  [659] =
    {field_body, 8},
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [664] =
    {field_body, 8},
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [669] =
    {field_index_type, 5},
    {field_name, 3},
    {field_sign, 0},
    {field_type, 7},
  [673] =
    {field_name, 5},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [677] =
    {field_name, 6},
    {field_parameters, 7, .inherited = true},
    {field_return_type, 7, .inherited = true},
    {field_type_parameters, 7, .inherited = true},
  [681] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [684] =
    {field_name, 5},
    {field_value, 7, .inherited = true},
  [686] =
    {field_name, 5},
    {field_type, 7},
  [688] =
    {field_name, 5},
    {field_type, 6},
    {field_value, 7, .inherited = true},
  [691] =
    {field_body, 9},
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [696] =
    {field_name, 6},
    {field_parameters, 8, .inherited = true},
    {field_return_type, 8, .inherited = true},
    {field_type_parameters, 8, .inherited = true},
  [700] =
    {field_name, 5},
    {field_type, 7},
    {field_value, 8, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [4] = {
    [0] = sym_identifier,
  },
  [10] = {
    [0] = sym_identifier,
  },
  [18] = {
    [0] = sym_identifier,
  },
  [21] = {
    [0] = alias_sym_property_identifier,
  },
  [25] = {
    [1] = sym_identifier,
  },
  [35] = {
    [0] = anon_sym_list,
  },
  [36] = {
    [0] = anon_sym_list,
  },
  [37] = {
    [0] = alias_sym_this_type,
  },
  [46] = {
    [0] = sym_identifier,
    [2] = sym_identifier,
  },
  [47] = {
    [0] = sym_identifier,
  },
  [48] = {
    [1] = alias_sym_shorthand_property_identifier_pattern,
  },
  [49] = {
    [1] = sym_identifier,
  },
  [54] = {
    [2] = sym_identifier,
  },
  [56] = {
    [1] = anon_sym_list,
    [2] = sym_identifier,
  },
  [57] = {
    [2] = anon_sym_list,
  },
  [58] = {
    [1] = anon_sym_list,
  },
  [59] = {
    [2] = sym_identifier,
  },
  [64] = {
    [0] = sym_identifier,
  },
  [65] = {
    [0] = sym_identifier,
  },
  [67] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [82] = {
    [0] = anon_sym_list,
  },
  [83] = {
    [0] = anon_sym_list,
  },
  [84] = {
    [0] = anon_sym_list,
  },
  [85] = {
    [1] = anon_sym_list,
  },
  [87] = {
    [1] = anon_sym_list,
  },
  [96] = {
    [2] = alias_sym_property_identifier,
  },
  [98] = {
    [2] = alias_sym_property_identifier,
  },
  [106] = {
    [0] = alias_sym_shorthand_property_identifier_pattern,
  },
  [109] = {
    [1] = anon_sym_list,
    [2] = sym_identifier,
  },
  [110] = {
    [1] = anon_sym_list,
  },
  [111] = {
    [2] = anon_sym_list,
  },
  [112] = {
    [2] = sym_identifier,
  },
  [114] = {
    [0] = anon_sym_list,
  },
  [117] = {
    [2] = anon_sym_list,
    [3] = sym_identifier,
  },
  [118] = {
    [2] = anon_sym_list,
  },
  [119] = {
    [3] = sym_identifier,
  },
  [122] = {
    [0] = alias_sym_statement_identifier,
  },
  [126] = {
    [1] = alias_sym_statement_identifier,
  },
  [142] = {
    [0] = anon_sym_list,
  },
  [145] = {
    [1] = anon_sym_list,
  },
  [146] = {
    [1] = anon_sym_list,
  },
  [150] = {
    [1] = sym_identifier,
  },
  [157] = {
    [2] = anon_sym_list,
  },
  [161] = {
    [1] = anon_sym_list,
    [2] = sym_identifier,
  },
  [162] = {
    [1] = anon_sym_list,
  },
  [163] = {
    [2] = sym_identifier,
  },
  [165] = {
    [2] = anon_sym_list,
  },
  [170] = {
    [2] = anon_sym_list,
    [3] = sym_identifier,
  },
  [171] = {
    [2] = anon_sym_list,
  },
  [172] = {
    [3] = sym_identifier,
  },
  [177] = {
    [1] = alias_sym_namespace_export,
  },
  [179] = {
    [1] = alias_sym_import_specifier,
  },
  [183] = {
    [2] = anon_sym_list,
  },
  [184] = {
    [1] = anon_sym_list,
  },
  [197] = {
    [2] = alias_sym_property_identifier,
  },
  [199] = {
    [2] = alias_sym_property_identifier,
  },
  [201] = {
    [2] = alias_sym_property_identifier,
  },
  [207] = {
    [1] = anon_sym_list,
  },
  [213] = {
    [0] = sym_identifier,
  },
  [214] = {
    [2] = anon_sym_list,
  },
  [215] = {
    [2] = anon_sym_list,
  },
  [217] = {
    [2] = anon_sym_list,
    [3] = sym_identifier,
  },
  [218] = {
    [2] = anon_sym_list,
  },
  [219] = {
    [3] = sym_identifier,
  },
  [224] = {
    [1] = anon_sym_list,
  },
  [227] = {
    [2] = anon_sym_list,
  },
  [228] = {
    [2] = anon_sym_list,
  },
  [229] = {
    [1] = anon_sym_list,
  },
  [232] = {
    [3] = anon_sym_list,
  },
  [235] = {
    [0] = anon_sym_list,
  },
  [252] = {
    [2] = anon_sym_list,
  },
  [254] = {
    [1] = anon_sym_list,
  },
  [255] = {
    [1] = sym_identifier,
  },
  [259] = {
    [2] = anon_sym_list,
  },
  [262] = {
    [3] = anon_sym_list,
  },
  [263] = {
    [3] = anon_sym_list,
  },
  [287] = {
    [3] = alias_sym_property_identifier,
  },
  [288] = {
    [3] = anon_sym_list,
  },
  [290] = {
    [1] = sym_identifier,
  },
  [291] = {
    [0] = anon_sym_list,
  },
  [309] = {
    [2] = sym_identifier,
  },
  [319] = {
    [3] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__import_export_specifier, 2,
    sym__import_export_specifier,
    alias_sym_import_specifier,
  sym_namespace_import_export, 2,
    sym_namespace_import_export,
    alias_sym_namespace_export,
  sym_predefined_type, 2,
    sym_predefined_type,
    sym_identifier,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 4,
  [6] = 4,
  [7] = 4,
  [8] = 4,
  [9] = 4,
  [10] = 4,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 16,
  [18] = 18,
  [19] = 16,
  [20] = 18,
  [21] = 18,
  [22] = 16,
  [23] = 16,
  [24] = 18,
  [25] = 16,
  [26] = 18,
  [27] = 16,
  [28] = 16,
  [29] = 18,
  [30] = 18,
  [31] = 18,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 33,
  [37] = 35,
  [38] = 38,
  [39] = 39,
  [40] = 35,
  [41] = 33,
  [42] = 42,
  [43] = 38,
  [44] = 44,
  [45] = 39,
  [46] = 34,
  [47] = 47,
  [48] = 44,
  [49] = 38,
  [50] = 50,
  [51] = 34,
  [52] = 44,
  [53] = 47,
  [54] = 50,
  [55] = 42,
  [56] = 32,
  [57] = 47,
  [58] = 39,
  [59] = 50,
  [60] = 42,
  [61] = 61,
  [62] = 61,
  [63] = 61,
  [64] = 61,
  [65] = 61,
  [66] = 61,
  [67] = 61,
  [68] = 61,
  [69] = 61,
  [70] = 61,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 75,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 79,
  [81] = 79,
  [82] = 82,
  [83] = 82,
  [84] = 82,
  [85] = 82,
  [86] = 82,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 90,
  [92] = 90,
  [93] = 90,
  [94] = 90,
  [95] = 90,
  [96] = 90,
  [97] = 90,
  [98] = 98,
  [99] = 90,
  [100] = 100,
  [101] = 100,
  [102] = 100,
  [103] = 100,
  [104] = 100,
  [105] = 100,
  [106] = 100,
  [107] = 100,
  [108] = 100,
  [109] = 109,
  [110] = 109,
  [111] = 109,
  [112] = 112,
  [113] = 112,
  [114] = 109,
  [115] = 112,
  [116] = 112,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 127,
  [129] = 129,
  [130] = 130,
  [131] = 129,
  [132] = 132,
  [133] = 133,
  [134] = 133,
  [135] = 132,
  [136] = 136,
  [137] = 130,
  [138] = 133,
  [139] = 132,
  [140] = 130,
  [141] = 136,
  [142] = 136,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 145,
  [147] = 147,
  [148] = 145,
  [149] = 149,
  [150] = 145,
  [151] = 151,
  [152] = 145,
  [153] = 153,
  [154] = 145,
  [155] = 155,
  [156] = 155,
  [157] = 145,
  [158] = 155,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 153,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 153,
  [181] = 181,
  [182] = 182,
  [183] = 143,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 130,
  [189] = 189,
  [190] = 130,
  [191] = 191,
  [192] = 191,
  [193] = 143,
  [194] = 130,
  [195] = 130,
  [196] = 130,
  [197] = 197,
  [198] = 197,
  [199] = 199,
  [200] = 200,
  [201] = 144,
  [202] = 130,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 143,
  [207] = 143,
  [208] = 143,
  [209] = 204,
  [210] = 143,
  [211] = 143,
  [212] = 204,
  [213] = 143,
  [214] = 204,
  [215] = 215,
  [216] = 204,
  [217] = 204,
  [218] = 218,
  [219] = 204,
  [220] = 205,
  [221] = 215,
  [222] = 222,
  [223] = 143,
  [224] = 224,
  [225] = 224,
  [226] = 226,
  [227] = 224,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 231,
  [235] = 235,
  [236] = 231,
  [237] = 231,
  [238] = 231,
  [239] = 231,
  [240] = 231,
  [241] = 235,
  [242] = 231,
  [243] = 231,
  [244] = 244,
  [245] = 231,
  [246] = 231,
  [247] = 231,
  [248] = 231,
  [249] = 231,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 253,
  [255] = 252,
  [256] = 252,
  [257] = 257,
  [258] = 258,
  [259] = 258,
  [260] = 258,
  [261] = 261,
  [262] = 262,
  [263] = 262,
  [264] = 257,
  [265] = 262,
  [266] = 258,
  [267] = 262,
  [268] = 268,
  [269] = 269,
  [270] = 258,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 262,
  [275] = 257,
  [276] = 258,
  [277] = 277,
  [278] = 278,
  [279] = 269,
  [280] = 280,
  [281] = 280,
  [282] = 269,
  [283] = 278,
  [284] = 257,
  [285] = 277,
  [286] = 257,
  [287] = 287,
  [288] = 269,
  [289] = 278,
  [290] = 269,
  [291] = 280,
  [292] = 287,
  [293] = 280,
  [294] = 258,
  [295] = 278,
  [296] = 296,
  [297] = 296,
  [298] = 257,
  [299] = 278,
  [300] = 280,
  [301] = 301,
  [302] = 257,
  [303] = 277,
  [304] = 269,
  [305] = 262,
  [306] = 287,
  [307] = 262,
  [308] = 308,
  [309] = 287,
  [310] = 310,
  [311] = 280,
  [312] = 278,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 287,
  [317] = 262,
  [318] = 269,
  [319] = 262,
  [320] = 258,
  [321] = 258,
  [322] = 277,
  [323] = 271,
  [324] = 287,
  [325] = 257,
  [326] = 278,
  [327] = 277,
  [328] = 277,
  [329] = 269,
  [330] = 280,
  [331] = 257,
  [332] = 287,
  [333] = 333,
  [334] = 268,
  [335] = 258,
  [336] = 287,
  [337] = 287,
  [338] = 277,
  [339] = 273,
  [340] = 340,
  [341] = 269,
  [342] = 262,
  [343] = 340,
  [344] = 280,
  [345] = 280,
  [346] = 278,
  [347] = 277,
  [348] = 348,
  [349] = 278,
  [350] = 350,
  [351] = 277,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 354,
  [357] = 357,
  [358] = 358,
  [359] = 353,
  [360] = 360,
  [361] = 353,
  [362] = 362,
  [363] = 363,
  [364] = 362,
  [365] = 354,
  [366] = 366,
  [367] = 363,
  [368] = 368,
  [369] = 369,
  [370] = 366,
  [371] = 369,
  [372] = 355,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 355,
  [383] = 373,
  [384] = 374,
  [385] = 385,
  [386] = 386,
  [387] = 375,
  [388] = 388,
  [389] = 380,
  [390] = 390,
  [391] = 353,
  [392] = 375,
  [393] = 376,
  [394] = 394,
  [395] = 377,
  [396] = 378,
  [397] = 362,
  [398] = 379,
  [399] = 354,
  [400] = 363,
  [401] = 385,
  [402] = 385,
  [403] = 378,
  [404] = 366,
  [405] = 369,
  [406] = 355,
  [407] = 373,
  [408] = 379,
  [409] = 409,
  [410] = 353,
  [411] = 374,
  [412] = 379,
  [413] = 413,
  [414] = 369,
  [415] = 366,
  [416] = 366,
  [417] = 362,
  [418] = 418,
  [419] = 419,
  [420] = 363,
  [421] = 375,
  [422] = 380,
  [423] = 378,
  [424] = 424,
  [425] = 368,
  [426] = 426,
  [427] = 376,
  [428] = 358,
  [429] = 357,
  [430] = 377,
  [431] = 378,
  [432] = 379,
  [433] = 385,
  [434] = 358,
  [435] = 380,
  [436] = 436,
  [437] = 377,
  [438] = 385,
  [439] = 436,
  [440] = 376,
  [441] = 436,
  [442] = 442,
  [443] = 375,
  [444] = 374,
  [445] = 368,
  [446] = 374,
  [447] = 363,
  [448] = 419,
  [449] = 436,
  [450] = 354,
  [451] = 357,
  [452] = 373,
  [453] = 373,
  [454] = 355,
  [455] = 369,
  [456] = 419,
  [457] = 386,
  [458] = 388,
  [459] = 436,
  [460] = 381,
  [461] = 380,
  [462] = 366,
  [463] = 358,
  [464] = 353,
  [465] = 380,
  [466] = 358,
  [467] = 388,
  [468] = 381,
  [469] = 385,
  [470] = 362,
  [471] = 357,
  [472] = 472,
  [473] = 379,
  [474] = 436,
  [475] = 386,
  [476] = 476,
  [477] = 378,
  [478] = 377,
  [479] = 419,
  [480] = 368,
  [481] = 380,
  [482] = 363,
  [483] = 354,
  [484] = 353,
  [485] = 368,
  [486] = 366,
  [487] = 380,
  [488] = 380,
  [489] = 419,
  [490] = 373,
  [491] = 491,
  [492] = 376,
  [493] = 493,
  [494] = 375,
  [495] = 374,
  [496] = 373,
  [497] = 355,
  [498] = 369,
  [499] = 366,
  [500] = 363,
  [501] = 354,
  [502] = 376,
  [503] = 374,
  [504] = 375,
  [505] = 368,
  [506] = 357,
  [507] = 358,
  [508] = 380,
  [509] = 381,
  [510] = 386,
  [511] = 381,
  [512] = 436,
  [513] = 357,
  [514] = 388,
  [515] = 368,
  [516] = 358,
  [517] = 381,
  [518] = 518,
  [519] = 436,
  [520] = 491,
  [521] = 386,
  [522] = 385,
  [523] = 379,
  [524] = 378,
  [525] = 381,
  [526] = 381,
  [527] = 386,
  [528] = 358,
  [529] = 419,
  [530] = 380,
  [531] = 362,
  [532] = 362,
  [533] = 357,
  [534] = 377,
  [535] = 386,
  [536] = 381,
  [537] = 358,
  [538] = 368,
  [539] = 353,
  [540] = 376,
  [541] = 386,
  [542] = 375,
  [543] = 374,
  [544] = 354,
  [545] = 380,
  [546] = 373,
  [547] = 547,
  [548] = 357,
  [549] = 426,
  [550] = 368,
  [551] = 363,
  [552] = 377,
  [553] = 362,
  [554] = 419,
  [555] = 369,
  [556] = 380,
  [557] = 419,
  [558] = 362,
  [559] = 355,
  [560] = 366,
  [561] = 561,
  [562] = 369,
  [563] = 436,
  [564] = 386,
  [565] = 380,
  [566] = 419,
  [567] = 353,
  [568] = 355,
  [569] = 385,
  [570] = 355,
  [571] = 379,
  [572] = 378,
  [573] = 357,
  [574] = 385,
  [575] = 354,
  [576] = 379,
  [577] = 378,
  [578] = 377,
  [579] = 376,
  [580] = 377,
  [581] = 375,
  [582] = 363,
  [583] = 374,
  [584] = 373,
  [585] = 376,
  [586] = 369,
  [587] = 587,
  [588] = 587,
  [589] = 587,
  [590] = 587,
  [591] = 591,
  [592] = 591,
  [593] = 591,
  [594] = 591,
  [595] = 595,
  [596] = 595,
  [597] = 595,
  [598] = 595,
  [599] = 599,
  [600] = 600,
  [601] = 599,
  [602] = 600,
  [603] = 599,
  [604] = 600,
  [605] = 599,
  [606] = 600,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 607,
  [612] = 612,
  [613] = 613,
  [614] = 607,
  [615] = 607,
  [616] = 616,
  [617] = 616,
  [618] = 616,
  [619] = 619,
  [620] = 620,
  [621] = 620,
  [622] = 619,
  [623] = 620,
  [624] = 620,
  [625] = 619,
  [626] = 619,
  [627] = 627,
  [628] = 627,
  [629] = 627,
  [630] = 630,
  [631] = 631,
  [632] = 631,
  [633] = 633,
  [634] = 634,
  [635] = 633,
  [636] = 634,
  [637] = 637,
  [638] = 638,
  [639] = 633,
  [640] = 640,
  [641] = 637,
  [642] = 637,
  [643] = 638,
  [644] = 638,
  [645] = 630,
  [646] = 633,
  [647] = 638,
  [648] = 633,
  [649] = 633,
  [650] = 650,
  [651] = 651,
  [652] = 633,
  [653] = 633,
  [654] = 654,
  [655] = 655,
  [656] = 633,
  [657] = 657,
  [658] = 657,
  [659] = 173,
  [660] = 170,
  [661] = 631,
  [662] = 657,
  [663] = 663,
  [664] = 187,
  [665] = 186,
  [666] = 633,
  [667] = 657,
  [668] = 633,
  [669] = 633,
  [670] = 633,
  [671] = 161,
  [672] = 163,
  [673] = 633,
  [674] = 151,
  [675] = 675,
  [676] = 676,
  [677] = 163,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 149,
  [682] = 682,
  [683] = 683,
  [684] = 186,
  [685] = 161,
  [686] = 686,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 187,
  [692] = 692,
  [693] = 633,
  [694] = 633,
  [695] = 175,
  [696] = 696,
  [697] = 650,
  [698] = 633,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 170,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 173,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 776,
  [777] = 777,
  [778] = 778,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 782,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 176,
  [792] = 792,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 801,
  [802] = 177,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 185,
  [811] = 811,
  [812] = 812,
  [813] = 813,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 178,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 823,
  [824] = 824,
  [825] = 825,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 829,
  [830] = 830,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 836,
  [837] = 837,
  [838] = 838,
  [839] = 839,
  [840] = 840,
  [841] = 841,
  [842] = 842,
  [843] = 843,
  [844] = 844,
  [845] = 845,
  [846] = 846,
  [847] = 847,
  [848] = 848,
  [849] = 849,
  [850] = 850,
  [851] = 851,
  [852] = 852,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 864,
  [865] = 151,
  [866] = 149,
  [867] = 867,
  [868] = 867,
  [869] = 176,
  [870] = 867,
  [871] = 867,
  [872] = 867,
  [873] = 147,
  [874] = 175,
  [875] = 177,
  [876] = 168,
  [877] = 166,
  [878] = 186,
  [879] = 174,
  [880] = 182,
  [881] = 171,
  [882] = 162,
  [883] = 883,
  [884] = 884,
  [885] = 884,
  [886] = 884,
  [887] = 887,
  [888] = 884,
  [889] = 889,
  [890] = 887,
  [891] = 169,
  [892] = 884,
  [893] = 884,
  [894] = 889,
  [895] = 884,
  [896] = 185,
  [897] = 884,
  [898] = 167,
  [899] = 899,
  [900] = 164,
  [901] = 884,
  [902] = 184,
  [903] = 884,
  [904] = 178,
  [905] = 181,
  [906] = 884,
  [907] = 907,
  [908] = 187,
  [909] = 170,
  [910] = 189,
  [911] = 172,
  [912] = 887,
  [913] = 887,
  [914] = 889,
  [915] = 884,
  [916] = 161,
  [917] = 173,
  [918] = 889,
  [919] = 889,
  [920] = 884,
  [921] = 163,
  [922] = 887,
  [923] = 923,
  [924] = 924,
  [925] = 924,
  [926] = 926,
  [927] = 927,
  [928] = 928,
  [929] = 926,
  [930] = 928,
  [931] = 926,
  [932] = 928,
  [933] = 928,
  [934] = 927,
  [935] = 927,
  [936] = 926,
  [937] = 937,
  [938] = 938,
  [939] = 939,
  [940] = 940,
  [941] = 937,
  [942] = 937,
  [943] = 943,
  [944] = 943,
  [945] = 937,
  [946] = 943,
  [947] = 939,
  [948] = 948,
  [949] = 937,
  [950] = 943,
  [951] = 943,
  [952] = 940,
  [953] = 940,
  [954] = 940,
  [955] = 948,
  [956] = 939,
  [957] = 940,
  [958] = 940,
  [959] = 937,
  [960] = 943,
  [961] = 948,
  [962] = 948,
  [963] = 939,
  [964] = 939,
  [965] = 939,
  [966] = 948,
  [967] = 967,
  [968] = 968,
  [969] = 969,
  [970] = 967,
  [971] = 971,
  [972] = 972,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 968,
  [977] = 975,
  [978] = 978,
  [979] = 979,
  [980] = 980,
  [981] = 981,
  [982] = 982,
  [983] = 974,
  [984] = 968,
  [985] = 985,
  [986] = 986,
  [987] = 969,
  [988] = 967,
  [989] = 971,
  [990] = 972,
  [991] = 973,
  [992] = 992,
  [993] = 974,
  [994] = 994,
  [995] = 974,
  [996] = 994,
  [997] = 994,
  [998] = 994,
  [999] = 968,
  [1000] = 975,
  [1001] = 985,
  [1002] = 1002,
  [1003] = 973,
  [1004] = 1004,
  [1005] = 1004,
  [1006] = 1006,
  [1007] = 972,
  [1008] = 971,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1006,
  [1015] = 986,
  [1016] = 1006,
  [1017] = 1017,
  [1018] = 978,
  [1019] = 1019,
  [1020] = 979,
  [1021] = 994,
  [1022] = 967,
  [1023] = 980,
  [1024] = 974,
  [1025] = 981,
  [1026] = 982,
  [1027] = 969,
  [1028] = 971,
  [1029] = 986,
  [1030] = 972,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 973,
  [1034] = 975,
  [1035] = 985,
  [1036] = 972,
  [1037] = 985,
  [1038] = 974,
  [1039] = 1006,
  [1040] = 1040,
  [1041] = 986,
  [1042] = 1042,
  [1043] = 1004,
  [1044] = 969,
  [1045] = 1006,
  [1046] = 967,
  [1047] = 1047,
  [1048] = 978,
  [1049] = 979,
  [1050] = 992,
  [1051] = 1040,
  [1052] = 1031,
  [1053] = 980,
  [1054] = 1054,
  [1055] = 978,
  [1056] = 981,
  [1057] = 982,
  [1058] = 1032,
  [1059] = 1006,
  [1060] = 992,
  [1061] = 969,
  [1062] = 967,
  [1063] = 981,
  [1064] = 980,
  [1065] = 979,
  [1066] = 978,
  [1067] = 1067,
  [1068] = 971,
  [1069] = 972,
  [1070] = 982,
  [1071] = 981,
  [1072] = 1042,
  [1073] = 1073,
  [1074] = 980,
  [1075] = 985,
  [1076] = 1076,
  [1077] = 973,
  [1078] = 979,
  [1079] = 978,
  [1080] = 973,
  [1081] = 1081,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 982,
  [1085] = 979,
  [1086] = 980,
  [1087] = 981,
  [1088] = 982,
  [1089] = 1031,
  [1090] = 994,
  [1091] = 975,
  [1092] = 968,
  [1093] = 985,
  [1094] = 986,
  [1095] = 968,
  [1096] = 975,
  [1097] = 969,
  [1098] = 986,
  [1099] = 971,
  [1100] = 1100,
  [1101] = 1101,
  [1102] = 1101,
  [1103] = 1100,
  [1104] = 1104,
  [1105] = 1100,
  [1106] = 1106,
  [1107] = 1107,
  [1108] = 1100,
  [1109] = 1104,
  [1110] = 1110,
  [1111] = 1100,
  [1112] = 1112,
  [1113] = 1106,
  [1114] = 1106,
  [1115] = 1002,
  [1116] = 1116,
  [1117] = 1104,
  [1118] = 1100,
  [1119] = 1119,
  [1120] = 1120,
  [1121] = 1121,
  [1122] = 1122,
  [1123] = 1121,
  [1124] = 1124,
  [1125] = 1121,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 1129,
  [1130] = 1121,
  [1131] = 1100,
  [1132] = 1100,
  [1133] = 1133,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 1100,
  [1142] = 1134,
  [1143] = 1139,
  [1144] = 1139,
  [1145] = 1145,
  [1146] = 1146,
  [1147] = 1134,
  [1148] = 1100,
  [1149] = 1149,
  [1150] = 1139,
  [1151] = 1138,
  [1152] = 1152,
  [1153] = 1138,
  [1154] = 1134,
  [1155] = 1138,
  [1156] = 1100,
  [1157] = 1032,
  [1158] = 1100,
  [1159] = 1159,
  [1160] = 1100,
  [1161] = 1100,
  [1162] = 855,
  [1163] = 1163,
  [1164] = 1163,
  [1165] = 1163,
  [1166] = 1166,
  [1167] = 1167,
  [1168] = 1167,
  [1169] = 1169,
  [1170] = 1163,
  [1171] = 1163,
  [1172] = 1163,
  [1173] = 1173,
  [1174] = 860,
  [1175] = 1175,
  [1176] = 1100,
  [1177] = 1112,
  [1178] = 1100,
  [1179] = 1100,
  [1180] = 1100,
  [1181] = 1163,
  [1182] = 1167,
  [1183] = 1173,
  [1184] = 1169,
  [1185] = 1185,
  [1186] = 1173,
  [1187] = 1187,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1185,
  [1191] = 1169,
  [1192] = 1167,
  [1193] = 1193,
  [1194] = 1167,
  [1195] = 1195,
  [1196] = 1187,
  [1197] = 1100,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1195,
  [1202] = 1202,
  [1203] = 1167,
  [1204] = 1204,
  [1205] = 1200,
  [1206] = 1199,
  [1207] = 1207,
  [1208] = 1202,
  [1209] = 1209,
  [1210] = 1199,
  [1211] = 1198,
  [1212] = 1204,
  [1213] = 1200,
  [1214] = 1167,
  [1215] = 1215,
  [1216] = 1167,
  [1217] = 1199,
  [1218] = 1202,
  [1219] = 1199,
  [1220] = 1188,
  [1221] = 1198,
  [1222] = 1200,
  [1223] = 1198,
  [1224] = 1224,
  [1225] = 1200,
  [1226] = 1198,
  [1227] = 1199,
  [1228] = 1198,
  [1229] = 1188,
  [1230] = 1200,
  [1231] = 1200,
  [1232] = 1224,
  [1233] = 1209,
  [1234] = 1234,
  [1235] = 1169,
  [1236] = 1199,
  [1237] = 1234,
  [1238] = 1215,
  [1239] = 1169,
  [1240] = 1240,
  [1241] = 1195,
  [1242] = 1240,
  [1243] = 1198,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1169,
  [1247] = 1136,
  [1248] = 1167,
  [1249] = 1249,
  [1250] = 1234,
  [1251] = 1149,
  [1252] = 855,
  [1253] = 1245,
  [1254] = 1254,
  [1255] = 1169,
  [1256] = 1189,
  [1257] = 1188,
  [1258] = 1146,
  [1259] = 1140,
  [1260] = 1167,
  [1261] = 1234,
  [1262] = 860,
  [1263] = 1175,
  [1264] = 1167,
  [1265] = 1169,
  [1266] = 1215,
  [1267] = 1234,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1254,
  [1271] = 1152,
  [1272] = 1169,
  [1273] = 1215,
  [1274] = 1245,
  [1275] = 1135,
  [1276] = 1167,
  [1277] = 1215,
  [1278] = 1254,
  [1279] = 1145,
  [1280] = 1268,
  [1281] = 1281,
  [1282] = 1195,
  [1283] = 1215,
  [1284] = 1234,
  [1285] = 1175,
  [1286] = 1188,
  [1287] = 1234,
  [1288] = 1234,
  [1289] = 1289,
  [1290] = 1290,
  [1291] = 1291,
  [1292] = 1291,
  [1293] = 1167,
  [1294] = 1215,
  [1295] = 1295,
  [1296] = 1188,
  [1297] = 1291,
  [1298] = 1291,
  [1299] = 1291,
  [1300] = 1289,
  [1301] = 1188,
  [1302] = 1167,
  [1303] = 1215,
  [1304] = 1175,
  [1305] = 1188,
  [1306] = 1306,
  [1307] = 1291,
  [1308] = 1169,
  [1309] = 1291,
  [1310] = 1289,
  [1311] = 1175,
  [1312] = 1312,
  [1313] = 1188,
  [1314] = 1207,
  [1315] = 1193,
  [1316] = 1234,
  [1317] = 1185,
  [1318] = 1318,
  [1319] = 1234,
  [1320] = 1187,
  [1321] = 1215,
  [1322] = 1175,
  [1323] = 1323,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1188,
  [1327] = 1215,
  [1328] = 1328,
  [1329] = 1328,
  [1330] = 1215,
  [1331] = 1215,
  [1332] = 1215,
  [1333] = 1215,
  [1334] = 1281,
  [1335] = 1234,
  [1336] = 1234,
  [1337] = 1328,
  [1338] = 1215,
  [1339] = 1328,
  [1340] = 1328,
  [1341] = 1234,
  [1342] = 1249,
  [1343] = 1328,
  [1344] = 1215,
  [1345] = 1175,
  [1346] = 1234,
  [1347] = 1234,
  [1348] = 1240,
  [1349] = 1328,
  [1350] = 1234,
  [1351] = 1175,
  [1352] = 1215,
  [1353] = 1234,
  [1354] = 1175,
  [1355] = 1306,
  [1356] = 1175,
  [1357] = 1357,
  [1358] = 1357,
  [1359] = 1359,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1361,
  [1363] = 1363,
  [1364] = 1363,
  [1365] = 176,
  [1366] = 177,
  [1367] = 1363,
  [1368] = 1363,
  [1369] = 1363,
  [1370] = 1363,
  [1371] = 1371,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1372,
  [1376] = 1372,
  [1377] = 1373,
  [1378] = 1372,
  [1379] = 1372,
  [1380] = 1371,
  [1381] = 1373,
  [1382] = 1371,
  [1383] = 1371,
  [1384] = 1372,
  [1385] = 1373,
  [1386] = 1371,
  [1387] = 1373,
  [1388] = 1371,
  [1389] = 1373,
  [1390] = 1373,
  [1391] = 1391,
  [1392] = 1373,
  [1393] = 1372,
  [1394] = 1391,
  [1395] = 1372,
  [1396] = 1396,
  [1397] = 1397,
  [1398] = 1396,
  [1399] = 1396,
  [1400] = 1396,
  [1401] = 1396,
  [1402] = 1397,
  [1403] = 1397,
  [1404] = 1397,
  [1405] = 1397,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 1397,
  [1410] = 1396,
  [1411] = 1411,
  [1412] = 177,
  [1413] = 176,
  [1414] = 163,
  [1415] = 1411,
  [1416] = 1416,
  [1417] = 1411,
  [1418] = 187,
  [1419] = 1411,
  [1420] = 1411,
  [1421] = 161,
  [1422] = 1411,
  [1423] = 186,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 1426,
  [1430] = 1430,
  [1431] = 1428,
  [1432] = 1426,
  [1433] = 1433,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1426,
  [1437] = 1437,
  [1438] = 1438,
  [1439] = 1439,
  [1440] = 1426,
  [1441] = 1426,
  [1442] = 1442,
  [1443] = 1426,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 151,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 1450,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 149,
  [1460] = 1460,
  [1461] = 176,
  [1462] = 1462,
  [1463] = 1451,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 177,
  [1469] = 1469,
  [1470] = 1454,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1448,
  [1475] = 1453,
  [1476] = 1445,
  [1477] = 1477,
  [1478] = 1478,
  [1479] = 1478,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 1480,
  [1483] = 1478,
  [1484] = 1484,
  [1485] = 147,
  [1486] = 1486,
  [1487] = 1453,
  [1488] = 1457,
  [1489] = 1453,
  [1490] = 1457,
  [1491] = 1453,
  [1492] = 1480,
  [1493] = 1478,
  [1494] = 1457,
  [1495] = 1457,
  [1496] = 1496,
  [1497] = 1453,
  [1498] = 1498,
  [1499] = 1478,
  [1500] = 1480,
  [1501] = 1501,
  [1502] = 1457,
  [1503] = 1453,
  [1504] = 1504,
  [1505] = 1478,
  [1506] = 1480,
  [1507] = 1480,
  [1508] = 1508,
  [1509] = 1509,
  [1510] = 1457,
  [1511] = 1511,
  [1512] = 1512,
  [1513] = 1513,
  [1514] = 1514,
  [1515] = 610,
  [1516] = 1516,
  [1517] = 1517,
  [1518] = 1518,
  [1519] = 1519,
  [1520] = 1520,
  [1521] = 1521,
  [1522] = 1522,
  [1523] = 1523,
  [1524] = 1524,
  [1525] = 1525,
  [1526] = 1526,
  [1527] = 1527,
  [1528] = 1528,
  [1529] = 1529,
  [1530] = 1530,
  [1531] = 1531,
  [1532] = 1532,
  [1533] = 1533,
  [1534] = 1534,
  [1535] = 1535,
  [1536] = 1536,
  [1537] = 1537,
  [1538] = 1538,
  [1539] = 1539,
  [1540] = 1540,
  [1541] = 1541,
  [1542] = 1542,
  [1543] = 1543,
  [1544] = 1544,
  [1545] = 1545,
  [1546] = 1546,
  [1547] = 1547,
  [1548] = 1548,
  [1549] = 1549,
  [1550] = 1550,
  [1551] = 186,
  [1552] = 187,
  [1553] = 1553,
  [1554] = 1554,
  [1555] = 1555,
  [1556] = 1556,
  [1557] = 1557,
  [1558] = 1120,
  [1559] = 149,
  [1560] = 151,
  [1561] = 1561,
  [1562] = 1562,
  [1563] = 1563,
  [1564] = 1564,
  [1565] = 1542,
  [1566] = 1126,
  [1567] = 1567,
  [1568] = 1554,
  [1569] = 1569,
  [1570] = 1554,
  [1571] = 1546,
  [1572] = 1572,
  [1573] = 1124,
  [1574] = 1574,
  [1575] = 1548,
  [1576] = 1549,
  [1577] = 175,
  [1578] = 1554,
  [1579] = 1554,
  [1580] = 1580,
  [1581] = 1581,
  [1582] = 1554,
  [1583] = 1583,
  [1584] = 1554,
  [1585] = 1585,
  [1586] = 1586,
  [1587] = 1587,
  [1588] = 1588,
  [1589] = 1589,
  [1590] = 1590,
  [1591] = 1591,
  [1592] = 1592,
  [1593] = 1593,
  [1594] = 1594,
  [1595] = 1595,
  [1596] = 1596,
  [1597] = 1597,
  [1598] = 1598,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1601,
  [1602] = 1602,
  [1603] = 609,
  [1604] = 1604,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1608,
  [1609] = 1609,
  [1610] = 1610,
  [1611] = 883,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 608,
  [1615] = 1615,
  [1616] = 1616,
  [1617] = 1617,
  [1618] = 1618,
  [1619] = 1619,
  [1620] = 1620,
  [1621] = 1621,
  [1622] = 1622,
  [1623] = 907,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1626,
  [1627] = 1627,
  [1628] = 1628,
  [1629] = 1629,
  [1630] = 1630,
  [1631] = 1631,
  [1632] = 1632,
  [1633] = 1633,
  [1634] = 1634,
  [1635] = 1635,
  [1636] = 1636,
  [1637] = 1637,
  [1638] = 1638,
  [1639] = 1639,
  [1640] = 1640,
  [1641] = 1641,
  [1642] = 1642,
  [1643] = 1643,
  [1644] = 613,
  [1645] = 1645,
  [1646] = 1646,
  [1647] = 612,
  [1648] = 1648,
  [1649] = 1649,
  [1650] = 1650,
  [1651] = 1651,
  [1652] = 1652,
  [1653] = 1653,
  [1654] = 1654,
  [1655] = 1655,
  [1656] = 1656,
  [1657] = 1657,
  [1658] = 1658,
  [1659] = 1659,
  [1660] = 1660,
  [1661] = 1661,
  [1662] = 1662,
  [1663] = 899,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 1667,
  [1668] = 1668,
  [1669] = 173,
  [1670] = 1580,
  [1671] = 163,
  [1672] = 1672,
  [1673] = 1545,
  [1674] = 1544,
  [1675] = 1543,
  [1676] = 1676,
  [1677] = 175,
  [1678] = 1678,
  [1679] = 1679,
  [1680] = 1680,
  [1681] = 1523,
  [1682] = 1682,
  [1683] = 185,
  [1684] = 1524,
  [1685] = 1685,
  [1686] = 1525,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 1689,
  [1690] = 1690,
  [1691] = 1528,
  [1692] = 170,
  [1693] = 1435,
  [1694] = 1541,
  [1695] = 1540,
  [1696] = 1539,
  [1697] = 1697,
  [1698] = 1698,
  [1699] = 1538,
  [1700] = 1537,
  [1701] = 1536,
  [1702] = 1535,
  [1703] = 1534,
  [1704] = 1533,
  [1705] = 1532,
  [1706] = 1531,
  [1707] = 1531,
  [1708] = 1530,
  [1709] = 1532,
  [1710] = 1710,
  [1711] = 170,
  [1712] = 1528,
  [1713] = 178,
  [1714] = 1714,
  [1715] = 1525,
  [1716] = 1716,
  [1717] = 1524,
  [1718] = 1718,
  [1719] = 1719,
  [1720] = 1720,
  [1721] = 1523,
  [1722] = 1628,
  [1723] = 1723,
  [1724] = 1533,
  [1725] = 1725,
  [1726] = 1726,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 1729,
  [1730] = 1730,
  [1731] = 1731,
  [1732] = 1534,
  [1733] = 1728,
  [1734] = 1535,
  [1735] = 1536,
  [1736] = 1537,
  [1737] = 1629,
  [1738] = 1530,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1742,
  [1743] = 178,
  [1744] = 1539,
  [1745] = 1633,
  [1746] = 1746,
  [1747] = 1540,
  [1748] = 1541,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 1751,
  [1752] = 1752,
  [1753] = 1753,
  [1754] = 1754,
  [1755] = 1516,
  [1756] = 1516,
  [1757] = 187,
  [1758] = 1758,
  [1759] = 186,
  [1760] = 1538,
  [1761] = 1761,
  [1762] = 173,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1434,
  [1770] = 1634,
  [1771] = 1771,
  [1772] = 1513,
  [1773] = 1580,
  [1774] = 1774,
  [1775] = 1775,
  [1776] = 1776,
  [1777] = 1777,
  [1778] = 1778,
  [1779] = 1779,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 1547,
  [1783] = 1529,
  [1784] = 1784,
  [1785] = 1785,
  [1786] = 161,
  [1787] = 1529,
  [1788] = 1788,
  [1789] = 1634,
  [1790] = 1728,
  [1791] = 1633,
  [1792] = 1629,
  [1793] = 1728,
  [1794] = 1628,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1797,
  [1798] = 1798,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1801,
  [1802] = 1730,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1805,
  [1806] = 1547,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1545,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1797,
  [1815] = 1815,
  [1816] = 1517,
  [1817] = 1817,
  [1818] = 161,
  [1819] = 1682,
  [1820] = 1544,
  [1821] = 1543,
  [1822] = 163,
  [1823] = 1513,
  [1824] = 185,
  [1825] = 1825,
  [1826] = 1524,
  [1827] = 1730,
  [1828] = 1828,
  [1829] = 1829,
  [1830] = 1634,
  [1831] = 1831,
  [1832] = 1633,
  [1833] = 1629,
  [1834] = 1628,
  [1835] = 1478,
  [1836] = 1480,
  [1837] = 1529,
  [1838] = 1547,
  [1839] = 1545,
  [1840] = 1778,
  [1841] = 1544,
  [1842] = 1543,
  [1843] = 1541,
  [1844] = 1540,
  [1845] = 1845,
  [1846] = 1450,
  [1847] = 1847,
  [1848] = 1539,
  [1849] = 1538,
  [1850] = 1537,
  [1851] = 1536,
  [1852] = 1852,
  [1853] = 1509,
  [1854] = 1557,
  [1855] = 1456,
  [1856] = 1856,
  [1857] = 1829,
  [1858] = 1508,
  [1859] = 1535,
  [1860] = 1534,
  [1861] = 1861,
  [1862] = 1825,
  [1863] = 1580,
  [1864] = 1533,
  [1865] = 1480,
  [1866] = 1631,
  [1867] = 1478,
  [1868] = 1778,
  [1869] = 1829,
  [1870] = 1480,
  [1871] = 1478,
  [1872] = 1478,
  [1873] = 1532,
  [1874] = 1480,
  [1875] = 1875,
  [1876] = 1632,
  [1877] = 1531,
  [1878] = 1513,
  [1879] = 1530,
  [1880] = 1829,
  [1881] = 1829,
  [1882] = 1882,
  [1883] = 1883,
  [1884] = 1828,
  [1885] = 1885,
  [1886] = 1478,
  [1887] = 1480,
  [1888] = 1888,
  [1889] = 1889,
  [1890] = 1496,
  [1891] = 1480,
  [1892] = 1892,
  [1893] = 1478,
  [1894] = 1888,
  [1895] = 1528,
  [1896] = 1896,
  [1897] = 1525,
  [1898] = 1473,
  [1899] = 1472,
  [1900] = 1631,
  [1901] = 1831,
  [1902] = 1516,
  [1903] = 1829,
  [1904] = 1889,
  [1905] = 1892,
  [1906] = 1682,
  [1907] = 1480,
  [1908] = 1478,
  [1909] = 1632,
  [1910] = 1523,
  [1911] = 1911,
  [1912] = 1912,
  [1913] = 1797,
  [1914] = 1465,
  [1915] = 1829,
  [1916] = 1538,
  [1917] = 1654,
  [1918] = 1662,
  [1919] = 1661,
  [1920] = 1616,
  [1921] = 1660,
  [1922] = 1580,
  [1923] = 1513,
  [1924] = 1657,
  [1925] = 1656,
  [1926] = 1517,
  [1927] = 1628,
  [1928] = 1629,
  [1929] = 1651,
  [1930] = 1633,
  [1931] = 1512,
  [1932] = 1615,
  [1933] = 1634,
  [1934] = 899,
  [1935] = 1516,
  [1936] = 1936,
  [1937] = 1718,
  [1938] = 1645,
  [1939] = 1939,
  [1940] = 1596,
  [1941] = 1523,
  [1942] = 1524,
  [1943] = 1525,
  [1944] = 1528,
  [1945] = 1945,
  [1946] = 1668,
  [1947] = 1666,
  [1948] = 1665,
  [1949] = 1530,
  [1950] = 1531,
  [1951] = 1532,
  [1952] = 1533,
  [1953] = 1534,
  [1954] = 1535,
  [1955] = 610,
  [1956] = 1627,
  [1957] = 1536,
  [1958] = 1537,
  [1959] = 1527,
  [1960] = 1539,
  [1961] = 1632,
  [1962] = 1529,
  [1963] = 1963,
  [1964] = 613,
  [1965] = 1635,
  [1966] = 1540,
  [1967] = 1967,
  [1968] = 1541,
  [1969] = 1562,
  [1970] = 1655,
  [1971] = 1971,
  [1972] = 1972,
  [1973] = 1646,
  [1974] = 1124,
  [1975] = 1667,
  [1976] = 1971,
  [1977] = 1971,
  [1978] = 883,
  [1979] = 1730,
  [1980] = 608,
  [1981] = 1613,
  [1982] = 1659,
  [1983] = 1658,
  [1984] = 1588,
  [1985] = 1589,
  [1986] = 1590,
  [1987] = 1591,
  [1988] = 1592,
  [1989] = 1593,
  [1990] = 1594,
  [1991] = 1991,
  [1992] = 1882,
  [1993] = 1595,
  [1994] = 1543,
  [1995] = 1626,
  [1996] = 1544,
  [1997] = 1514,
  [1998] = 1563,
  [1999] = 1610,
  [2000] = 1618,
  [2001] = 1598,
  [2002] = 1600,
  [2003] = 1624,
  [2004] = 1609,
  [2005] = 1617,
  [2006] = 1601,
  [2007] = 1518,
  [2008] = 1653,
  [2009] = 1652,
  [2010] = 1650,
  [2011] = 1545,
  [2012] = 2012,
  [2013] = 1649,
  [2014] = 1648,
  [2015] = 1563,
  [2016] = 612,
  [2017] = 2017,
  [2018] = 1645,
  [2019] = 2019,
  [2020] = 1622,
  [2021] = 2021,
  [2022] = 1519,
  [2023] = 1619,
  [2024] = 1967,
  [2025] = 907,
  [2026] = 1861,
  [2027] = 1710,
  [2028] = 1547,
  [2029] = 2029,
  [2030] = 1963,
  [2031] = 1710,
  [2032] = 1945,
  [2033] = 1718,
  [2034] = 1608,
  [2035] = 1520,
  [2036] = 1620,
  [2037] = 1120,
  [2038] = 1607,
  [2039] = 1750,
  [2040] = 1632,
  [2041] = 609,
  [2042] = 1606,
  [2043] = 1631,
  [2044] = 1861,
  [2045] = 1605,
  [2046] = 2046,
  [2047] = 1882,
  [2048] = 1604,
  [2049] = 1991,
  [2050] = 2012,
  [2051] = 1521,
  [2052] = 1621,
  [2053] = 1602,
  [2054] = 1586,
  [2055] = 1967,
  [2056] = 1556,
  [2057] = 1750,
  [2058] = 1526,
  [2059] = 1585,
  [2060] = 1797,
  [2061] = 2061,
  [2062] = 1632,
  [2063] = 1126,
  [2064] = 1682,
  [2065] = 1555,
  [2066] = 1963,
  [2067] = 1631,
  [2068] = 2068,
  [2069] = 1631,
  [2070] = 1612,
  [2071] = 1630,
  [2072] = 1631,
  [2073] = 1632,
  [2074] = 1583,
  [2075] = 1636,
  [2076] = 1581,
  [2077] = 1637,
  [2078] = 2078,
  [2079] = 1638,
  [2080] = 1553,
  [2081] = 1639,
  [2082] = 1640,
  [2083] = 1641,
  [2084] = 147,
  [2085] = 1625,
  [2086] = 2086,
  [2087] = 147,
  [2088] = 2088,
  [2089] = 2089,
  [2090] = 1642,
  [2091] = 1643,
  [2092] = 2092,
  [2093] = 2093,
  [2094] = 1739,
  [2095] = 2095,
  [2096] = 1537,
  [2097] = 1536,
  [2098] = 1689,
  [2099] = 1780,
  [2100] = 1861,
  [2101] = 1716,
  [2102] = 1720,
  [2103] = 166,
  [2104] = 1538,
  [2105] = 1539,
  [2106] = 172,
  [2107] = 1778,
  [2108] = 1540,
  [2109] = 1723,
  [2110] = 1725,
  [2111] = 1726,
  [2112] = 1727,
  [2113] = 1682,
  [2114] = 1729,
  [2115] = 1797,
  [2116] = 1534,
  [2117] = 1533,
  [2118] = 2118,
  [2119] = 1731,
  [2120] = 1532,
  [2121] = 2121,
  [2122] = 1730,
  [2123] = 2123,
  [2124] = 2124,
  [2125] = 1631,
  [2126] = 1632,
  [2127] = 1531,
  [2128] = 2128,
  [2129] = 1530,
  [2130] = 1528,
  [2131] = 167,
  [2132] = 164,
  [2133] = 2133,
  [2134] = 1541,
  [2135] = 1543,
  [2136] = 1544,
  [2137] = 1545,
  [2138] = 184,
  [2139] = 189,
  [2140] = 2140,
  [2141] = 1547,
  [2142] = 1718,
  [2143] = 181,
  [2144] = 168,
  [2145] = 1861,
  [2146] = 2146,
  [2147] = 2021,
  [2148] = 1563,
  [2149] = 1777,
  [2150] = 2121,
  [2151] = 1776,
  [2152] = 1808,
  [2153] = 1809,
  [2154] = 1775,
  [2155] = 1807,
  [2156] = 1753,
  [2157] = 1774,
  [2158] = 1685,
  [2159] = 1631,
  [2160] = 1525,
  [2161] = 1524,
  [2162] = 1523,
  [2163] = 1632,
  [2164] = 1516,
  [2165] = 1805,
  [2166] = 1804,
  [2167] = 1781,
  [2168] = 1803,
  [2169] = 1513,
  [2170] = 1580,
  [2171] = 1710,
  [2172] = 1529,
  [2173] = 1679,
  [2174] = 2174,
  [2175] = 1678,
  [2176] = 1750,
  [2177] = 2121,
  [2178] = 1768,
  [2179] = 1767,
  [2180] = 1749,
  [2181] = 1750,
  [2182] = 1784,
  [2183] = 2121,
  [2184] = 1766,
  [2185] = 1765,
  [2186] = 1764,
  [2187] = 1107,
  [2188] = 1763,
  [2189] = 1535,
  [2190] = 2190,
  [2191] = 168,
  [2192] = 2192,
  [2193] = 2193,
  [2194] = 2193,
  [2195] = 1785,
  [2196] = 174,
  [2197] = 2121,
  [2198] = 1740,
  [2199] = 1741,
  [2200] = 1687,
  [2201] = 1742,
  [2202] = 1688,
  [2203] = 1714,
  [2204] = 182,
  [2205] = 1801,
  [2206] = 2121,
  [2207] = 1690,
  [2208] = 2021,
  [2209] = 1758,
  [2210] = 1751,
  [2211] = 171,
  [2212] = 162,
  [2213] = 1719,
  [2214] = 169,
  [2215] = 166,
  [2216] = 1645,
  [2217] = 172,
  [2218] = 1634,
  [2219] = 1761,
  [2220] = 1750,
  [2221] = 1882,
  [2222] = 1633,
  [2223] = 1629,
  [2224] = 1628,
  [2225] = 2174,
  [2226] = 1634,
  [2227] = 1633,
  [2228] = 1629,
  [2229] = 1628,
  [2230] = 2230,
  [2231] = 1718,
  [2232] = 1754,
  [2233] = 2233,
  [2234] = 2121,
  [2235] = 167,
  [2236] = 1752,
  [2237] = 1563,
  [2238] = 2238,
  [2239] = 162,
  [2240] = 171,
  [2241] = 182,
  [2242] = 174,
  [2243] = 2121,
  [2244] = 2244,
  [2245] = 1529,
  [2246] = 1634,
  [2247] = 1812,
  [2248] = 169,
  [2249] = 1633,
  [2250] = 1629,
  [2251] = 1628,
  [2252] = 164,
  [2253] = 1811,
  [2254] = 184,
  [2255] = 189,
  [2256] = 181,
  [2257] = 1547,
  [2258] = 1545,
  [2259] = 1544,
  [2260] = 1543,
  [2261] = 1580,
  [2262] = 1541,
  [2263] = 1513,
  [2264] = 1540,
  [2265] = 1680,
  [2266] = 1539,
  [2267] = 1538,
  [2268] = 1516,
  [2269] = 1523,
  [2270] = 1676,
  [2271] = 2271,
  [2272] = 1718,
  [2273] = 2273,
  [2274] = 2121,
  [2275] = 1524,
  [2276] = 1537,
  [2277] = 1536,
  [2278] = 1746,
  [2279] = 1529,
  [2280] = 1547,
  [2281] = 1580,
  [2282] = 1513,
  [2283] = 1516,
  [2284] = 1535,
  [2285] = 1523,
  [2286] = 1524,
  [2287] = 2244,
  [2288] = 1545,
  [2289] = 1534,
  [2290] = 1525,
  [2291] = 1528,
  [2292] = 1544,
  [2293] = 1543,
  [2294] = 1533,
  [2295] = 1532,
  [2296] = 1531,
  [2297] = 1530,
  [2298] = 1528,
  [2299] = 1541,
  [2300] = 1540,
  [2301] = 1525,
  [2302] = 1530,
  [2303] = 1531,
  [2304] = 1532,
  [2305] = 1533,
  [2306] = 1534,
  [2307] = 1539,
  [2308] = 1535,
  [2309] = 1536,
  [2310] = 1538,
  [2311] = 1537,
  [2312] = 1533,
  [2313] = 1531,
  [2314] = 1544,
  [2315] = 1543,
  [2316] = 1861,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 1861,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 1718,
  [2323] = 186,
  [2324] = 2324,
  [2325] = 187,
  [2326] = 2326,
  [2327] = 1645,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2330,
  [2331] = 1750,
  [2332] = 2332,
  [2333] = 1634,
  [2334] = 1682,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 1563,
  [2338] = 2338,
  [2339] = 2339,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 1797,
  [2344] = 1861,
  [2345] = 2345,
  [2346] = 2346,
  [2347] = 2347,
  [2348] = 2021,
  [2349] = 1524,
  [2350] = 2350,
  [2351] = 1525,
  [2352] = 1516,
  [2353] = 1633,
  [2354] = 1629,
  [2355] = 1528,
  [2356] = 1547,
  [2357] = 1513,
  [2358] = 651,
  [2359] = 1545,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 1710,
  [2363] = 1580,
  [2364] = 2364,
  [2365] = 1628,
  [2366] = 1530,
  [2367] = 2367,
  [2368] = 2368,
  [2369] = 1861,
  [2370] = 1883,
  [2371] = 1529,
  [2372] = 1532,
  [2373] = 1710,
  [2374] = 2338,
  [2375] = 1682,
  [2376] = 1133,
  [2377] = 1534,
  [2378] = 1523,
  [2379] = 1730,
  [2380] = 2380,
  [2381] = 1631,
  [2382] = 1632,
  [2383] = 2383,
  [2384] = 1541,
  [2385] = 2385,
  [2386] = 1540,
  [2387] = 2387,
  [2388] = 2388,
  [2389] = 2389,
  [2390] = 1535,
  [2391] = 2391,
  [2392] = 1536,
  [2393] = 1537,
  [2394] = 1538,
  [2395] = 2395,
  [2396] = 1539,
  [2397] = 2397,
  [2398] = 2398,
  [2399] = 1596,
  [2400] = 1549,
  [2401] = 2401,
  [2402] = 1542,
  [2403] = 1718,
  [2404] = 2404,
  [2405] = 1750,
  [2406] = 2406,
  [2407] = 1563,
  [2408] = 2408,
  [2409] = 1511,
  [2410] = 2410,
  [2411] = 1542,
  [2412] = 163,
  [2413] = 1574,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2416,
  [2417] = 1861,
  [2418] = 2418,
  [2419] = 1569,
  [2420] = 161,
  [2421] = 2421,
  [2422] = 1546,
  [2423] = 1548,
  [2424] = 1549,
  [2425] = 2406,
  [2426] = 2426,
  [2427] = 1546,
  [2428] = 1710,
  [2429] = 1828,
  [2430] = 2397,
  [2431] = 2431,
  [2432] = 1548,
  [2433] = 2433,
  [2434] = 1564,
  [2435] = 2397,
  [2436] = 2436,
  [2437] = 2437,
  [2438] = 2438,
  [2439] = 2439,
  [2440] = 2440,
  [2441] = 1710,
  [2442] = 2442,
  [2443] = 2443,
  [2444] = 1129,
  [2445] = 1730,
  [2446] = 151,
  [2447] = 2021,
  [2448] = 1122,
  [2449] = 1797,
  [2450] = 2450,
  [2451] = 675,
  [2452] = 2450,
  [2453] = 2442,
  [2454] = 2450,
  [2455] = 2455,
  [2456] = 2456,
  [2457] = 2457,
  [2458] = 2457,
  [2459] = 2455,
  [2460] = 175,
  [2461] = 1563,
  [2462] = 1563,
  [2463] = 2463,
  [2464] = 1682,
  [2465] = 2465,
  [2466] = 2466,
  [2467] = 1563,
  [2468] = 2457,
  [2469] = 2456,
  [2470] = 1124,
  [2471] = 1126,
  [2472] = 2455,
  [2473] = 2456,
  [2474] = 2442,
  [2475] = 1120,
  [2476] = 2476,
  [2477] = 2128,
  [2478] = 2478,
  [2479] = 696,
  [2480] = 2480,
  [2481] = 678,
  [2482] = 2482,
  [2483] = 2483,
  [2484] = 2484,
  [2485] = 2485,
  [2486] = 149,
  [2487] = 2487,
  [2488] = 2488,
  [2489] = 680,
  [2490] = 2490,
  [2491] = 2491,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 692,
  [2495] = 2495,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 686,
  [2499] = 1522,
  [2500] = 2500,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 700,
  [2504] = 688,
  [2505] = 2505,
  [2506] = 687,
  [2507] = 731,
  [2508] = 818,
  [2509] = 2509,
  [2510] = 682,
  [2511] = 2511,
  [2512] = 2512,
  [2513] = 744,
  [2514] = 2514,
  [2515] = 2515,
  [2516] = 809,
  [2517] = 2517,
  [2518] = 2518,
  [2519] = 689,
  [2520] = 2520,
  [2521] = 2521,
  [2522] = 2522,
  [2523] = 2512,
  [2524] = 2524,
  [2525] = 2518,
  [2526] = 2526,
  [2527] = 690,
  [2528] = 2528,
  [2529] = 812,
  [2530] = 813,
  [2531] = 2531,
  [2532] = 720,
  [2533] = 721,
  [2534] = 2528,
  [2535] = 2535,
  [2536] = 2536,
  [2537] = 703,
  [2538] = 683,
  [2539] = 2539,
  [2540] = 170,
  [2541] = 679,
  [2542] = 2542,
  [2543] = 173,
  [2544] = 2544,
  [2545] = 2545,
  [2546] = 2546,
  [2547] = 2522,
  [2548] = 2548,
  [2549] = 701,
  [2550] = 676,
  [2551] = 737,
  [2552] = 702,
  [2553] = 736,
  [2554] = 738,
  [2555] = 727,
  [2556] = 699,
  [2557] = 2557,
  [2558] = 716,
  [2559] = 715,
  [2560] = 2560,
  [2561] = 2521,
  [2562] = 2531,
  [2563] = 714,
  [2564] = 2564,
  [2565] = 2565,
  [2566] = 820,
  [2567] = 821,
  [2568] = 803,
  [2569] = 807,
  [2570] = 704,
  [2571] = 825,
  [2572] = 839,
  [2573] = 835,
  [2574] = 822,
  [2575] = 811,
  [2576] = 795,
  [2577] = 792,
  [2578] = 793,
  [2579] = 776,
  [2580] = 726,
  [2581] = 173,
  [2582] = 851,
  [2583] = 708,
  [2584] = 712,
  [2585] = 706,
  [2586] = 774,
  [2587] = 739,
  [2588] = 845,
  [2589] = 746,
  [2590] = 789,
  [2591] = 2591,
  [2592] = 826,
  [2593] = 844,
  [2594] = 843,
  [2595] = 837,
  [2596] = 816,
  [2597] = 815,
  [2598] = 814,
  [2599] = 788,
  [2600] = 786,
  [2601] = 785,
  [2602] = 608,
  [2603] = 705,
  [2604] = 784,
  [2605] = 796,
  [2606] = 794,
  [2607] = 782,
  [2608] = 781,
  [2609] = 780,
  [2610] = 779,
  [2611] = 790,
  [2612] = 722,
  [2613] = 732,
  [2614] = 778,
  [2615] = 777,
  [2616] = 170,
  [2617] = 775,
  [2618] = 772,
  [2619] = 178,
  [2620] = 770,
  [2621] = 768,
  [2622] = 767,
  [2623] = 766,
  [2624] = 765,
  [2625] = 733,
  [2626] = 846,
  [2627] = 760,
  [2628] = 745,
  [2629] = 800,
  [2630] = 185,
  [2631] = 805,
  [2632] = 840,
  [2633] = 808,
  [2634] = 817,
  [2635] = 801,
  [2636] = 764,
  [2637] = 823,
  [2638] = 824,
  [2639] = 783,
  [2640] = 743,
  [2641] = 830,
  [2642] = 742,
  [2643] = 741,
  [2644] = 740,
  [2645] = 761,
  [2646] = 758,
  [2647] = 723,
  [2648] = 834,
  [2649] = 757,
  [2650] = 748,
  [2651] = 773,
  [2652] = 836,
  [2653] = 842,
  [2654] = 849,
  [2655] = 850,
  [2656] = 848,
  [2657] = 729,
  [2658] = 734,
  [2659] = 755,
  [2660] = 747,
  [2661] = 847,
  [2662] = 763,
  [2663] = 711,
  [2664] = 841,
  [2665] = 735,
  [2666] = 838,
  [2667] = 833,
  [2668] = 724,
  [2669] = 832,
  [2670] = 831,
  [2671] = 610,
  [2672] = 829,
  [2673] = 828,
  [2674] = 749,
  [2675] = 751,
  [2676] = 756,
  [2677] = 827,
  [2678] = 709,
  [2679] = 806,
  [2680] = 804,
  [2681] = 797,
  [2682] = 719,
  [2683] = 717,
  [2684] = 609,
  [2685] = 730,
  [2686] = 787,
  [2687] = 759,
  [2688] = 728,
  [2689] = 725,
  [2690] = 798,
  [2691] = 707,
  [2692] = 713,
  [2693] = 612,
  [2694] = 799,
  [2695] = 613,
  [2696] = 762,
  [2697] = 771,
  [2698] = 769,
  [2699] = 754,
  [2700] = 753,
  [2701] = 752,
  [2702] = 750,
  [2703] = 2703,
  [2704] = 2704,
  [2705] = 2705,
  [2706] = 2706,
  [2707] = 2707,
  [2708] = 2705,
  [2709] = 2709,
  [2710] = 2710,
  [2711] = 2711,
  [2712] = 2712,
  [2713] = 2713,
  [2714] = 2714,
  [2715] = 2715,
  [2716] = 2705,
  [2717] = 2717,
  [2718] = 2706,
  [2719] = 2719,
  [2720] = 2720,
  [2721] = 2721,
  [2722] = 2722,
  [2723] = 2723,
  [2724] = 2724,
  [2725] = 2725,
  [2726] = 2726,
  [2727] = 2727,
  [2728] = 2728,
  [2729] = 2729,
  [2730] = 2730,
  [2731] = 2731,
  [2732] = 2732,
  [2733] = 2733,
  [2734] = 2705,
  [2735] = 2735,
  [2736] = 2736,
  [2737] = 2737,
  [2738] = 2706,
  [2739] = 2706,
  [2740] = 2740,
  [2741] = 2741,
  [2742] = 2742,
  [2743] = 2743,
  [2744] = 2744,
  [2745] = 2745,
  [2746] = 2746,
  [2747] = 2747,
  [2748] = 2748,
  [2749] = 2749,
  [2750] = 2750,
  [2751] = 2751,
  [2752] = 2752,
  [2753] = 2753,
  [2754] = 2754,
  [2755] = 2755,
  [2756] = 2756,
  [2757] = 2757,
  [2758] = 2758,
  [2759] = 2759,
  [2760] = 2760,
  [2761] = 2761,
  [2762] = 2762,
  [2763] = 2763,
  [2764] = 2764,
  [2765] = 2765,
  [2766] = 2766,
  [2767] = 2767,
  [2768] = 2768,
  [2769] = 2769,
  [2770] = 2770,
  [2771] = 2771,
  [2772] = 2772,
  [2773] = 2773,
  [2774] = 2774,
  [2775] = 2775,
  [2776] = 2776,
  [2777] = 2777,
  [2778] = 2778,
  [2779] = 2779,
  [2780] = 2780,
  [2781] = 2781,
  [2782] = 2782,
  [2783] = 2783,
  [2784] = 2784,
  [2785] = 2785,
  [2786] = 2786,
  [2787] = 2787,
  [2788] = 1496,
  [2789] = 1473,
  [2790] = 1472,
  [2791] = 1659,
  [2792] = 1605,
  [2793] = 1650,
  [2794] = 1586,
  [2795] = 176,
  [2796] = 1619,
  [2797] = 1607,
  [2798] = 1608,
  [2799] = 1649,
  [2800] = 1620,
  [2801] = 1618,
  [2802] = 1609,
  [2803] = 1610,
  [2804] = 1613,
  [2805] = 1624,
  [2806] = 1622,
  [2807] = 1655,
  [2808] = 1667,
  [2809] = 1665,
  [2810] = 1666,
  [2811] = 1585,
  [2812] = 1646,
  [2813] = 1652,
  [2814] = 1602,
  [2815] = 1653,
  [2816] = 1654,
  [2817] = 1621,
  [2818] = 1668,
  [2819] = 1648,
  [2820] = 1625,
  [2821] = 1435,
  [2822] = 1604,
  [2823] = 1658,
  [2824] = 177,
  [2825] = 1635,
  [2826] = 1627,
  [2827] = 1626,
  [2828] = 1630,
  [2829] = 1612,
  [2830] = 1606,
  [2831] = 1465,
  [2832] = 1514,
  [2833] = 1124,
  [2834] = 1120,
  [2835] = 1126,
  [2836] = 1450,
  [2837] = 1456,
  [2838] = 1616,
  [2839] = 1520,
  [2840] = 1519,
  [2841] = 1588,
  [2842] = 2842,
  [2843] = 1589,
  [2844] = 1583,
  [2845] = 1591,
  [2846] = 1592,
  [2847] = 1593,
  [2848] = 1640,
  [2849] = 1595,
  [2850] = 1641,
  [2851] = 1660,
  [2852] = 1656,
  [2853] = 1643,
  [2854] = 1651,
  [2855] = 1598,
  [2856] = 2842,
  [2857] = 1600,
  [2858] = 2842,
  [2859] = 1435,
  [2860] = 1601,
  [2861] = 2842,
  [2862] = 1509,
  [2863] = 2842,
  [2864] = 1527,
  [2865] = 2842,
  [2866] = 2842,
  [2867] = 1638,
  [2868] = 1615,
  [2869] = 1526,
  [2870] = 1496,
  [2871] = 1473,
  [2872] = 1472,
  [2873] = 1637,
  [2874] = 1521,
  [2875] = 1617,
  [2876] = 2842,
  [2877] = 1508,
  [2878] = 2842,
  [2879] = 1512,
  [2880] = 1518,
  [2881] = 1636,
  [2882] = 1648,
  [2883] = 1590,
  [2884] = 1668,
  [2885] = 1665,
  [2886] = 1646,
  [2887] = 1618,
  [2888] = 1667,
  [2889] = 1659,
  [2890] = 1658,
  [2891] = 1666,
  [2892] = 1654,
  [2893] = 1653,
  [2894] = 1652,
  [2895] = 1635,
  [2896] = 1627,
  [2897] = 2897,
  [2898] = 1626,
  [2899] = 2899,
  [2900] = 2900,
  [2901] = 1465,
  [2902] = 1650,
  [2903] = 2903,
  [2904] = 1662,
  [2905] = 1661,
  [2906] = 1649,
  [2907] = 1625,
  [2908] = 2908,
  [2909] = 1624,
  [2910] = 1642,
  [2911] = 1655,
  [2912] = 2912,
  [2913] = 1639,
  [2914] = 1657,
  [2915] = 2900,
  [2916] = 2897,
  [2917] = 2899,
  [2918] = 2918,
  [2919] = 1594,
  [2920] = 1581,
  [2921] = 1610,
  [2922] = 2922,
  [2923] = 2923,
  [2924] = 2924,
  [2925] = 1619,
  [2926] = 2918,
  [2927] = 2899,
  [2928] = 2897,
  [2929] = 2900,
  [2930] = 1622,
  [2931] = 1613,
  [2932] = 2918,
  [2933] = 2918,
  [2934] = 2899,
  [2935] = 2897,
  [2936] = 2900,
  [2937] = 2937,
  [2938] = 1585,
  [2939] = 1621,
  [2940] = 1620,
  [2941] = 1586,
  [2942] = 2900,
  [2943] = 2897,
  [2944] = 2899,
  [2945] = 2918,
  [2946] = 1609,
  [2947] = 1602,
  [2948] = 1608,
  [2949] = 1607,
  [2950] = 1604,
  [2951] = 1605,
  [2952] = 2952,
  [2953] = 1435,
  [2954] = 1517,
  [2955] = 2955,
  [2956] = 2956,
  [2957] = 2957,
  [2958] = 2958,
  [2959] = 1514,
  [2960] = 1496,
  [2961] = 1473,
  [2962] = 1472,
  [2963] = 2963,
  [2964] = 2964,
  [2965] = 1120,
  [2966] = 2966,
  [2967] = 2963,
  [2968] = 2968,
  [2969] = 1126,
  [2970] = 2970,
  [2971] = 1606,
  [2972] = 2972,
  [2973] = 1630,
  [2974] = 1456,
  [2975] = 1124,
  [2976] = 2976,
  [2977] = 2963,
  [2978] = 1612,
  [2979] = 1465,
  [2980] = 1620,
  [2981] = 2981,
  [2982] = 2982,
  [2983] = 2983,
  [2984] = 2984,
  [2985] = 2985,
  [2986] = 2986,
  [2987] = 2987,
  [2988] = 2988,
  [2989] = 2989,
  [2990] = 2990,
  [2991] = 2991,
  [2992] = 2992,
  [2993] = 2993,
  [2994] = 1648,
  [2995] = 1649,
  [2996] = 1650,
  [2997] = 1508,
  [2998] = 1652,
  [2999] = 1653,
  [3000] = 1654,
  [3001] = 1658,
  [3002] = 2981,
  [3003] = 1509,
  [3004] = 1659,
  [3005] = 1667,
  [3006] = 1646,
  [3007] = 1655,
  [3008] = 1665,
  [3009] = 3009,
  [3010] = 2981,
  [3011] = 1450,
  [3012] = 3012,
  [3013] = 1666,
  [3014] = 1668,
  [3015] = 1635,
  [3016] = 3016,
  [3017] = 1627,
  [3018] = 1626,
  [3019] = 3019,
  [3020] = 1585,
  [3021] = 1586,
  [3022] = 1602,
  [3023] = 1604,
  [3024] = 1605,
  [3025] = 1625,
  [3026] = 1624,
  [3027] = 1607,
  [3028] = 1608,
  [3029] = 1609,
  [3030] = 2981,
  [3031] = 1610,
  [3032] = 1613,
  [3033] = 1618,
  [3034] = 2981,
  [3035] = 1619,
  [3036] = 1622,
  [3037] = 3037,
  [3038] = 2981,
  [3039] = 3039,
  [3040] = 1621,
  [3041] = 899,
  [3042] = 1637,
  [3043] = 1583,
  [3044] = 3044,
  [3045] = 1598,
  [3046] = 1657,
  [3047] = 1662,
  [3048] = 1595,
  [3049] = 1124,
  [3050] = 1601,
  [3051] = 1594,
  [3052] = 1593,
  [3053] = 1527,
  [3054] = 1592,
  [3055] = 1643,
  [3056] = 1456,
  [3057] = 1591,
  [3058] = 1590,
  [3059] = 1660,
  [3060] = 613,
  [3061] = 1636,
  [3062] = 1517,
  [3063] = 1642,
  [3064] = 1641,
  [3065] = 883,
  [3066] = 1526,
  [3067] = 1640,
  [3068] = 1521,
  [3069] = 612,
  [3070] = 1600,
  [3071] = 609,
  [3072] = 1514,
  [3073] = 1639,
  [3074] = 1512,
  [3075] = 1517,
  [3076] = 1589,
  [3077] = 1126,
  [3078] = 1656,
  [3079] = 1661,
  [3080] = 1638,
  [3081] = 1606,
  [3082] = 1612,
  [3083] = 1630,
  [3084] = 1520,
  [3085] = 1651,
  [3086] = 1519,
  [3087] = 1615,
  [3088] = 1581,
  [3089] = 1518,
  [3090] = 610,
  [3091] = 1120,
  [3092] = 1616,
  [3093] = 1617,
  [3094] = 1588,
  [3095] = 608,
  [3096] = 907,
  [3097] = 3097,
  [3098] = 3098,
  [3099] = 3099,
  [3100] = 3100,
  [3101] = 3101,
  [3102] = 1435,
  [3103] = 3103,
  [3104] = 3104,
  [3105] = 3105,
  [3106] = 1508,
  [3107] = 1509,
  [3108] = 3108,
  [3109] = 3109,
  [3110] = 3110,
  [3111] = 3104,
  [3112] = 3105,
  [3113] = 3108,
  [3114] = 3105,
  [3115] = 3104,
  [3116] = 3116,
  [3117] = 3116,
  [3118] = 3099,
  [3119] = 3119,
  [3120] = 3104,
  [3121] = 3105,
  [3122] = 3122,
  [3123] = 1450,
  [3124] = 3124,
  [3125] = 3125,
  [3126] = 3125,
  [3127] = 1592,
  [3128] = 3128,
  [3129] = 3129,
  [3130] = 612,
  [3131] = 1591,
  [3132] = 1590,
  [3133] = 1589,
  [3134] = 1588,
  [3135] = 610,
  [3136] = 3136,
  [3137] = 3125,
  [3138] = 1518,
  [3139] = 1519,
  [3140] = 1520,
  [3141] = 3141,
  [3142] = 1521,
  [3143] = 1512,
  [3144] = 1651,
  [3145] = 1526,
  [3146] = 883,
  [3147] = 1656,
  [3148] = 1657,
  [3149] = 1660,
  [3150] = 1661,
  [3151] = 1662,
  [3152] = 613,
  [3153] = 3153,
  [3154] = 1527,
  [3155] = 3155,
  [3156] = 3124,
  [3157] = 3155,
  [3158] = 3158,
  [3159] = 3155,
  [3160] = 3125,
  [3161] = 1617,
  [3162] = 1616,
  [3163] = 1615,
  [3164] = 2981,
  [3165] = 608,
  [3166] = 3166,
  [3167] = 3158,
  [3168] = 3098,
  [3169] = 3169,
  [3170] = 1593,
  [3171] = 3169,
  [3172] = 1594,
  [3173] = 3173,
  [3174] = 3153,
  [3175] = 3175,
  [3176] = 1583,
  [3177] = 3128,
  [3178] = 1581,
  [3179] = 3169,
  [3180] = 3158,
  [3181] = 1643,
  [3182] = 1595,
  [3183] = 1642,
  [3184] = 2981,
  [3185] = 1641,
  [3186] = 3186,
  [3187] = 3128,
  [3188] = 2981,
  [3189] = 3128,
  [3190] = 899,
  [3191] = 2981,
  [3192] = 1598,
  [3193] = 3193,
  [3194] = 3194,
  [3195] = 1640,
  [3196] = 2981,
  [3197] = 907,
  [3198] = 2981,
  [3199] = 3153,
  [3200] = 3200,
  [3201] = 3201,
  [3202] = 3202,
  [3203] = 1600,
  [3204] = 1639,
  [3205] = 3101,
  [3206] = 2981,
  [3207] = 1638,
  [3208] = 1601,
  [3209] = 899,
  [3210] = 3210,
  [3211] = 175,
  [3212] = 1637,
  [3213] = 883,
  [3214] = 3200,
  [3215] = 1465,
  [3216] = 3216,
  [3217] = 176,
  [3218] = 177,
  [3219] = 1636,
  [3220] = 3220,
  [3221] = 3122,
  [3222] = 609,
  [3223] = 907,
  [3224] = 151,
  [3225] = 3225,
  [3226] = 3225,
  [3227] = 3225,
  [3228] = 3228,
  [3229] = 3229,
  [3230] = 3225,
  [3231] = 3229,
  [3232] = 3225,
  [3233] = 3233,
  [3234] = 3225,
  [3235] = 3101,
  [3236] = 1456,
  [3237] = 3237,
  [3238] = 3229,
  [3239] = 3239,
  [3240] = 3225,
  [3241] = 3225,
  [3242] = 3242,
  [3243] = 3243,
  [3244] = 3244,
  [3245] = 3245,
  [3246] = 3246,
  [3247] = 3247,
  [3248] = 149,
  [3249] = 3202,
  [3250] = 3250,
  [3251] = 3251,
  [3252] = 3245,
  [3253] = 3253,
  [3254] = 3254,
  [3255] = 3255,
  [3256] = 3246,
  [3257] = 3257,
  [3258] = 3258,
  [3259] = 3251,
  [3260] = 3260,
  [3261] = 3261,
  [3262] = 3262,
  [3263] = 3263,
  [3264] = 3264,
  [3265] = 3265,
  [3266] = 3266,
  [3267] = 3243,
  [3268] = 3247,
  [3269] = 3269,
  [3270] = 3270,
  [3271] = 3243,
  [3272] = 3272,
  [3273] = 3273,
  [3274] = 3274,
  [3275] = 3245,
  [3276] = 3246,
  [3277] = 3277,
  [3278] = 3278,
  [3279] = 3279,
  [3280] = 3280,
  [3281] = 3281,
  [3282] = 3282,
  [3283] = 3280,
  [3284] = 3201,
  [3285] = 3285,
  [3286] = 3286,
  [3287] = 3264,
  [3288] = 3288,
  [3289] = 3289,
  [3290] = 3260,
  [3291] = 3291,
  [3292] = 3292,
  [3293] = 3141,
  [3294] = 3294,
  [3295] = 3295,
  [3296] = 3296,
  [3297] = 3297,
  [3298] = 3298,
  [3299] = 3263,
  [3300] = 3110,
  [3301] = 3301,
  [3302] = 3302,
  [3303] = 3097,
  [3304] = 3304,
  [3305] = 3305,
  [3306] = 3186,
  [3307] = 3307,
  [3308] = 3250,
  [3309] = 3242,
  [3310] = 3262,
  [3311] = 3136,
  [3312] = 3312,
  [3313] = 3313,
  [3314] = 3314,
  [3315] = 3315,
  [3316] = 3263,
  [3317] = 3317,
  [3318] = 3318,
  [3319] = 3319,
  [3320] = 3242,
  [3321] = 3246,
  [3322] = 3322,
  [3323] = 3315,
  [3324] = 3324,
  [3325] = 3325,
  [3326] = 1509,
  [3327] = 3245,
  [3328] = 1508,
  [3329] = 3329,
  [3330] = 3330,
  [3331] = 3315,
  [3332] = 3258,
  [3333] = 3333,
  [3334] = 3315,
  [3335] = 3322,
  [3336] = 3336,
  [3337] = 3337,
  [3338] = 3322,
  [3339] = 3339,
  [3340] = 3340,
  [3341] = 3341,
  [3342] = 3342,
  [3343] = 3343,
  [3344] = 3344,
  [3345] = 3345,
  [3346] = 3346,
  [3347] = 3250,
  [3348] = 3250,
  [3349] = 3349,
  [3350] = 3350,
  [3351] = 3346,
  [3352] = 3352,
  [3353] = 3353,
  [3354] = 1107,
  [3355] = 3352,
  [3356] = 3251,
  [3357] = 3353,
  [3358] = 3262,
  [3359] = 3263,
  [3360] = 3278,
  [3361] = 3247,
  [3362] = 3260,
  [3363] = 3296,
  [3364] = 3364,
  [3365] = 3365,
  [3366] = 3337,
  [3367] = 3340,
  [3368] = 3368,
  [3369] = 3369,
  [3370] = 3370,
  [3371] = 1642,
  [3372] = 3372,
  [3373] = 3373,
  [3374] = 3365,
  [3375] = 3375,
  [3376] = 3376,
  [3377] = 3377,
  [3378] = 3378,
  [3379] = 3330,
  [3380] = 3380,
  [3381] = 3380,
  [3382] = 3382,
  [3383] = 3333,
  [3384] = 3341,
  [3385] = 3370,
  [3386] = 3368,
  [3387] = 3378,
  [3388] = 3388,
  [3389] = 3369,
  [3390] = 3390,
  [3391] = 3391,
  [3392] = 3329,
  [3393] = 3393,
  [3394] = 3281,
  [3395] = 1590,
  [3396] = 1594,
  [3397] = 3286,
  [3398] = 3382,
  [3399] = 3399,
  [3400] = 3400,
  [3401] = 3377,
  [3402] = 1133,
  [3403] = 3098,
  [3404] = 3314,
  [3405] = 3405,
  [3406] = 3406,
  [3407] = 3407,
  [3408] = 3408,
  [3409] = 3409,
  [3410] = 3409,
  [3411] = 3407,
  [3412] = 3412,
  [3413] = 3413,
  [3414] = 3414,
  [3415] = 3415,
  [3416] = 3382,
  [3417] = 3417,
  [3418] = 3369,
  [3419] = 3419,
  [3420] = 3420,
  [3421] = 3421,
  [3422] = 3422,
  [3423] = 3376,
  [3424] = 3292,
  [3425] = 3425,
  [3426] = 3426,
  [3427] = 3365,
  [3428] = 3428,
  [3429] = 3376,
  [3430] = 3376,
  [3431] = 3370,
  [3432] = 3369,
  [3433] = 3272,
  [3434] = 1110,
  [3435] = 3343,
  [3436] = 3407,
  [3437] = 3336,
  [3438] = 3375,
  [3439] = 3291,
  [3440] = 3312,
  [3441] = 3441,
  [3442] = 3409,
  [3443] = 3443,
  [3444] = 3444,
  [3445] = 3253,
  [3446] = 3377,
  [3447] = 3377,
  [3448] = 3273,
  [3449] = 3254,
  [3450] = 3377,
  [3451] = 3451,
  [3452] = 3452,
  [3453] = 3453,
  [3454] = 3454,
  [3455] = 3382,
  [3456] = 3378,
  [3457] = 3307,
  [3458] = 3458,
  [3459] = 3370,
  [3460] = 3460,
  [3461] = 3342,
  [3462] = 3044,
  [3463] = 3463,
  [3464] = 3304,
  [3465] = 3465,
  [3466] = 3294,
  [3467] = 3467,
  [3468] = 3468,
  [3469] = 3469,
  [3470] = 3255,
  [3471] = 3257,
  [3472] = 3370,
  [3473] = 3473,
  [3474] = 3406,
  [3475] = 3475,
  [3476] = 3476,
  [3477] = 3477,
  [3478] = 3478,
  [3479] = 3122,
  [3480] = 3480,
  [3481] = 3481,
  [3482] = 3468,
  [3483] = 3409,
  [3484] = 3289,
  [3485] = 3485,
  [3486] = 3486,
  [3487] = 3487,
  [3488] = 3393,
  [3489] = 3489,
  [3490] = 3490,
  [3491] = 3463,
  [3492] = 3407,
  [3493] = 1581,
  [3494] = 3452,
  [3495] = 3376,
  [3496] = 3369,
  [3497] = 3382,
  [3498] = 3465,
  [3499] = 3417,
  [3500] = 3415,
  [3501] = 3378,
  [3502] = 3480,
  [3503] = 3377,
  [3504] = 3274,
  [3505] = 3382,
  [3506] = 1662,
  [3507] = 3378,
  [3508] = 3508,
  [3509] = 3509,
  [3510] = 1661,
  [3511] = 3370,
  [3512] = 3512,
  [3513] = 3425,
  [3514] = 1657,
  [3515] = 3515,
  [3516] = 3516,
  [3517] = 3370,
  [3518] = 3518,
  [3519] = 3369,
  [3520] = 177,
  [3521] = 176,
  [3522] = 3378,
  [3523] = 608,
  [3524] = 613,
  [3525] = 3525,
  [3526] = 612,
  [3527] = 3527,
  [3528] = 609,
  [3529] = 610,
  [3530] = 3377,
  [3531] = 3391,
  [3532] = 3417,
  [3533] = 3533,
  [3534] = 1639,
  [3535] = 3415,
  [3536] = 3288,
  [3537] = 3537,
  [3538] = 3372,
  [3539] = 3415,
  [3540] = 3382,
  [3541] = 3417,
  [3542] = 3378,
  [3543] = 3543,
  [3544] = 3285,
  [3545] = 3545,
  [3546] = 3546,
  [3547] = 3547,
  [3548] = 3548,
  [3549] = 3549,
  [3550] = 3550,
  [3551] = 3551,
  [3552] = 3552,
  [3553] = 3553,
  [3554] = 3554,
  [3555] = 3555,
  [3556] = 3556,
  [3557] = 3557,
  [3558] = 3558,
  [3559] = 3559,
  [3560] = 3560,
  [3561] = 3561,
  [3562] = 3562,
  [3563] = 3527,
  [3564] = 3564,
  [3565] = 3565,
  [3566] = 3566,
  [3567] = 3567,
  [3568] = 3525,
  [3569] = 3569,
  [3570] = 3570,
  [3571] = 3571,
  [3572] = 3572,
  [3573] = 3552,
  [3574] = 3570,
  [3575] = 724,
  [3576] = 3576,
  [3577] = 3577,
  [3578] = 3578,
  [3579] = 3579,
  [3580] = 3580,
  [3581] = 3581,
  [3582] = 3582,
  [3583] = 3583,
  [3584] = 751,
  [3585] = 3585,
  [3586] = 709,
  [3587] = 713,
  [3588] = 744,
  [3589] = 680,
  [3590] = 3590,
  [3591] = 844,
  [3592] = 837,
  [3593] = 3593,
  [3594] = 3572,
  [3595] = 3595,
  [3596] = 3583,
  [3597] = 814,
  [3598] = 3598,
  [3599] = 3599,
  [3600] = 3600,
  [3601] = 3601,
  [3602] = 3602,
  [3603] = 3603,
  [3604] = 3604,
  [3605] = 3605,
  [3606] = 734,
  [3607] = 3607,
  [3608] = 729,
  [3609] = 3609,
  [3610] = 717,
  [3611] = 3611,
  [3612] = 3612,
  [3613] = 728,
  [3614] = 3614,
  [3615] = 3615,
  [3616] = 690,
  [3617] = 748,
  [3618] = 3618,
  [3619] = 757,
  [3620] = 758,
  [3621] = 3621,
  [3622] = 3580,
  [3623] = 723,
  [3624] = 764,
  [3625] = 3625,
  [3626] = 707,
  [3627] = 3627,
  [3628] = 730,
  [3629] = 3629,
  [3630] = 3630,
  [3631] = 3599,
  [3632] = 688,
  [3633] = 3593,
  [3634] = 700,
  [3635] = 3635,
  [3636] = 3636,
  [3637] = 3569,
  [3638] = 3638,
  [3639] = 3569,
  [3640] = 3640,
  [3641] = 3641,
  [3642] = 3593,
  [3643] = 3643,
  [3644] = 3644,
  [3645] = 3645,
  [3646] = 3646,
  [3647] = 3647,
  [3648] = 3648,
  [3649] = 3649,
  [3650] = 3650,
  [3651] = 3651,
  [3652] = 689,
  [3653] = 3653,
  [3654] = 746,
  [3655] = 3655,
  [3656] = 773,
  [3657] = 3657,
  [3658] = 3658,
  [3659] = 3400,
  [3660] = 3660,
  [3661] = 3661,
  [3662] = 3662,
  [3663] = 3590,
  [3664] = 3598,
  [3665] = 3665,
  [3666] = 3279,
  [3667] = 3607,
  [3668] = 3668,
  [3669] = 3669,
  [3670] = 3670,
  [3671] = 3580,
  [3672] = 3672,
  [3673] = 3673,
  [3674] = 3674,
  [3675] = 3675,
  [3676] = 185,
  [3677] = 3677,
  [3678] = 790,
  [3679] = 796,
  [3680] = 3680,
  [3681] = 3681,
  [3682] = 3635,
  [3683] = 3683,
  [3684] = 3577,
  [3685] = 3685,
  [3686] = 3686,
  [3687] = 3687,
  [3688] = 3688,
  [3689] = 3689,
  [3690] = 3680,
  [3691] = 3598,
  [3692] = 3692,
  [3693] = 801,
  [3694] = 803,
  [3695] = 3590,
  [3696] = 754,
  [3697] = 178,
  [3698] = 3556,
  [3699] = 807,
  [3700] = 3700,
  [3701] = 3602,
  [3702] = 704,
  [3703] = 3703,
  [3704] = 825,
  [3705] = 839,
  [3706] = 835,
  [3707] = 3557,
  [3708] = 3545,
  [3709] = 3709,
  [3710] = 3604,
  [3711] = 3583,
  [3712] = 822,
  [3713] = 3713,
  [3714] = 3549,
  [3715] = 774,
  [3716] = 820,
  [3717] = 3572,
  [3718] = 3718,
  [3719] = 3719,
  [3720] = 3720,
  [3721] = 3564,
  [3722] = 3579,
  [3723] = 3602,
  [3724] = 3601,
  [3725] = 851,
  [3726] = 3579,
  [3727] = 3570,
  [3728] = 3728,
  [3729] = 3557,
  [3730] = 3556,
  [3731] = 3552,
  [3732] = 3553,
  [3733] = 3546,
  [3734] = 3669,
  [3735] = 3601,
  [3736] = 3736,
  [3737] = 3670,
  [3738] = 3569,
  [3739] = 3607,
  [3740] = 3740,
  [3741] = 706,
  [3742] = 3742,
  [3743] = 3670,
  [3744] = 721,
  [3745] = 3745,
  [3746] = 720,
  [3747] = 701,
  [3748] = 3677,
  [3749] = 3282,
  [3750] = 3305,
  [3751] = 3551,
  [3752] = 3443,
  [3753] = 3753,
  [3754] = 676,
  [3755] = 740,
  [3756] = 702,
  [3757] = 3602,
  [3758] = 3625,
  [3759] = 3759,
  [3760] = 3760,
  [3761] = 3572,
  [3762] = 776,
  [3763] = 3763,
  [3764] = 739,
  [3765] = 3765,
  [3766] = 3766,
  [3767] = 840,
  [3768] = 845,
  [3769] = 3769,
  [3770] = 3770,
  [3771] = 683,
  [3772] = 741,
  [3773] = 3773,
  [3774] = 3774,
  [3775] = 3775,
  [3776] = 3776,
  [3777] = 3777,
  [3778] = 687,
  [3779] = 742,
  [3780] = 743,
  [3781] = 3781,
  [3782] = 3551,
  [3783] = 736,
  [3784] = 3549,
  [3785] = 3785,
  [3786] = 3786,
  [3787] = 3753,
  [3788] = 3549,
  [3789] = 699,
  [3790] = 789,
  [3791] = 809,
  [3792] = 826,
  [3793] = 3793,
  [3794] = 3794,
  [3795] = 3552,
  [3796] = 3796,
  [3797] = 3797,
  [3798] = 3553,
  [3799] = 3799,
  [3800] = 714,
  [3801] = 3801,
  [3802] = 3802,
  [3803] = 3803,
  [3804] = 3668,
  [3805] = 753,
  [3806] = 805,
  [3807] = 722,
  [3808] = 3553,
  [3809] = 732,
  [3810] = 3810,
  [3811] = 733,
  [3812] = 3552,
  [3813] = 745,
  [3814] = 3814,
  [3815] = 760,
  [3816] = 800,
  [3817] = 3817,
  [3818] = 3818,
  [3819] = 3579,
  [3820] = 3570,
  [3821] = 3557,
  [3822] = 3556,
  [3823] = 3823,
  [3824] = 3824,
  [3825] = 3546,
  [3826] = 750,
  [3827] = 3601,
  [3828] = 3828,
  [3829] = 3829,
  [3830] = 3830,
  [3831] = 3567,
  [3832] = 3553,
  [3833] = 3669,
  [3834] = 808,
  [3835] = 3565,
  [3836] = 3670,
  [3837] = 3837,
  [3838] = 3838,
  [3839] = 3786,
  [3840] = 692,
  [3841] = 806,
  [3842] = 752,
  [3843] = 3843,
  [3844] = 3844,
  [3845] = 151,
  [3846] = 3740,
  [3847] = 3546,
  [3848] = 804,
  [3849] = 3849,
  [3850] = 3849,
  [3851] = 3851,
  [3852] = 3852,
  [3853] = 3853,
  [3854] = 3854,
  [3855] = 3855,
  [3856] = 3856,
  [3857] = 3857,
  [3858] = 3855,
  [3859] = 3855,
  [3860] = 3854,
  [3861] = 3861,
  [3862] = 3862,
  [3863] = 3863,
  [3864] = 3864,
  [3865] = 3854,
  [3866] = 3866,
  [3867] = 3867,
  [3868] = 3868,
  [3869] = 3869,
  [3870] = 3862,
  [3871] = 3871,
  [3872] = 3872,
  [3873] = 3873,
  [3874] = 3874,
  [3875] = 3875,
  [3876] = 3863,
  [3877] = 3877,
  [3878] = 3878,
  [3879] = 3879,
  [3880] = 3856,
  [3881] = 3851,
  [3882] = 3878,
  [3883] = 3852,
  [3884] = 3884,
  [3885] = 3863,
  [3886] = 3849,
  [3887] = 3866,
  [3888] = 3869,
  [3889] = 3874,
  [3890] = 3868,
  [3891] = 3891,
  [3892] = 3892,
  [3893] = 3893,
  [3894] = 3852,
  [3895] = 3895,
  [3896] = 3869,
  [3897] = 3868,
  [3898] = 149,
  [3899] = 3899,
  [3900] = 3891,
  [3901] = 3901,
  [3902] = 3902,
  [3903] = 3903,
  [3904] = 3904,
  [3905] = 3875,
  [3906] = 3862,
  [3907] = 3899,
  [3908] = 3908,
  [3909] = 3854,
  [3910] = 3856,
  [3911] = 3911,
  [3912] = 3852,
  [3913] = 3849,
  [3914] = 3869,
  [3915] = 3868,
  [3916] = 3862,
  [3917] = 3857,
  [3918] = 3918,
  [3919] = 3856,
  [3920] = 3920,
  [3921] = 3921,
  [3922] = 3871,
  [3923] = 3857,
  [3924] = 3879,
  [3925] = 3925,
  [3926] = 3852,
  [3927] = 3871,
  [3928] = 3849,
  [3929] = 3929,
  [3930] = 3930,
  [3931] = 3869,
  [3932] = 3932,
  [3933] = 3862,
  [3934] = 3856,
  [3935] = 3868,
  [3936] = 3936,
  [3937] = 3862,
  [3938] = 3884,
  [3939] = 3939,
  [3940] = 3893,
  [3941] = 3941,
  [3942] = 3942,
  [3943] = 3943,
  [3944] = 3944,
  [3945] = 3945,
  [3946] = 3946,
  [3947] = 3852,
  [3948] = 3849,
  [3949] = 3949,
  [3950] = 3950,
  [3951] = 3951,
  [3952] = 3868,
  [3953] = 3856,
  [3954] = 3954,
  [3955] = 3955,
  [3956] = 3956,
  [3957] = 3957,
  [3958] = 3899,
  [3959] = 3959,
  [3960] = 3960,
  [3961] = 3875,
  [3962] = 3962,
  [3963] = 3869,
  [3964] = 3871,
  [3965] = 3849,
  [3966] = 3966,
  [3967] = 3852,
  [3968] = 3968,
  [3969] = 3849,
  [3970] = 3852,
  [3971] = 3971,
  [3972] = 3871,
  [3973] = 3849,
  [3974] = 3884,
  [3975] = 3869,
  [3976] = 3976,
  [3977] = 3869,
  [3978] = 3978,
  [3979] = 3868,
  [3980] = 3868,
  [3981] = 3899,
  [3982] = 3868,
  [3983] = 3869,
  [3984] = 3884,
  [3985] = 3884,
  [3986] = 3871,
  [3987] = 3987,
  [3988] = 3893,
  [3989] = 3884,
  [3990] = 3879,
  [3991] = 3854,
  [3992] = 3992,
  [3993] = 3993,
  [3994] = 3852,
  [3995] = 3899,
  [3996] = 3996,
  [3997] = 3997,
  [3998] = 3998,
  [3999] = 3999,
  [4000] = 4000,
  [4001] = 4001,
  [4002] = 4002,
  [4003] = 4003,
  [4004] = 4004,
  [4005] = 4005,
  [4006] = 3281,
  [4007] = 4007,
  [4008] = 4008,
  [4009] = 4009,
  [4010] = 4010,
  [4011] = 4011,
  [4012] = 4012,
  [4013] = 4013,
  [4014] = 4014,
  [4015] = 4014,
  [4016] = 4013,
  [4017] = 4017,
  [4018] = 4018,
  [4019] = 4019,
  [4020] = 4020,
  [4021] = 4008,
  [4022] = 3341,
  [4023] = 4023,
  [4024] = 4024,
  [4025] = 3997,
  [4026] = 4026,
  [4027] = 4027,
  [4028] = 4028,
  [4029] = 4029,
  [4030] = 4030,
  [4031] = 4031,
  [4032] = 4032,
  [4033] = 4033,
  [4034] = 4034,
  [4035] = 4035,
  [4036] = 4036,
  [4037] = 4031,
  [4038] = 4038,
  [4039] = 4039,
  [4040] = 4040,
  [4041] = 4041,
  [4042] = 4042,
  [4043] = 4043,
  [4044] = 4044,
  [4045] = 4045,
  [4046] = 4046,
  [4047] = 4047,
  [4048] = 4048,
  [4049] = 4049,
  [4050] = 4050,
  [4051] = 4051,
  [4052] = 4034,
  [4053] = 4053,
  [4054] = 4054,
  [4055] = 4055,
  [4056] = 4056,
  [4057] = 4057,
  [4058] = 4058,
  [4059] = 4059,
  [4060] = 4060,
  [4061] = 4061,
  [4062] = 4062,
  [4063] = 4063,
  [4064] = 4064,
  [4065] = 4040,
  [4066] = 4066,
  [4067] = 4067,
  [4068] = 4068,
  [4069] = 4069,
  [4070] = 4070,
  [4071] = 4071,
  [4072] = 4033,
  [4073] = 4073,
  [4074] = 4074,
  [4075] = 4075,
  [4076] = 4076,
  [4077] = 4077,
  [4078] = 4078,
  [4079] = 4079,
  [4080] = 4080,
  [4081] = 4081,
  [4082] = 4035,
  [4083] = 4083,
  [4084] = 4084,
  [4085] = 4085,
  [4086] = 4086,
  [4087] = 4038,
  [4088] = 3272,
  [4089] = 4089,
  [4090] = 4090,
  [4091] = 4091,
  [4092] = 4092,
  [4093] = 4093,
  [4094] = 4094,
  [4095] = 4039,
  [4096] = 4096,
  [4097] = 4097,
  [4098] = 4032,
  [4099] = 4099,
  [4100] = 3296,
  [4101] = 4101,
  [4102] = 4102,
  [4103] = 4103,
  [4104] = 4104,
  [4105] = 4005,
  [4106] = 4051,
  [4107] = 4107,
  [4108] = 4049,
  [4109] = 4109,
  [4110] = 3638,
  [4111] = 4111,
  [4112] = 4101,
  [4113] = 4113,
  [4114] = 4114,
  [4115] = 4101,
  [4116] = 4032,
  [4117] = 4051,
  [4118] = 4094,
  [4119] = 3997,
  [4120] = 4120,
  [4121] = 4121,
  [4122] = 4075,
  [4123] = 4123,
  [4124] = 4084,
  [4125] = 4081,
  [4126] = 4036,
  [4127] = 4127,
  [4128] = 4032,
  [4129] = 4129,
  [4130] = 4039,
  [4131] = 4114,
  [4132] = 682,
  [4133] = 4133,
  [4134] = 4044,
  [4135] = 4135,
  [4136] = 4094,
  [4137] = 4137,
  [4138] = 3998,
  [4139] = 4139,
  [4140] = 4140,
  [4141] = 4141,
  [4142] = 4123,
  [4143] = 4143,
  [4144] = 4144,
  [4145] = 4040,
  [4146] = 3996,
  [4147] = 4081,
  [4148] = 4129,
  [4149] = 4149,
  [4150] = 3996,
  [4151] = 4005,
  [4152] = 4120,
  [4153] = 3342,
  [4154] = 4081,
  [4155] = 4084,
  [4156] = 4002,
  [4157] = 4157,
  [4158] = 4158,
  [4159] = 3999,
  [4160] = 4073,
  [4161] = 4161,
  [4162] = 4019,
  [4163] = 4163,
  [4164] = 3996,
  [4165] = 4079,
  [4166] = 4166,
  [4167] = 4167,
  [4168] = 1593,
  [4169] = 1601,
  [4170] = 4085,
  [4171] = 4047,
  [4172] = 4172,
  [4173] = 4050,
  [4174] = 4101,
  [4175] = 4032,
  [4176] = 4094,
  [4177] = 4177,
  [4178] = 4143,
  [4179] = 4179,
  [4180] = 3996,
  [4181] = 4149,
  [4182] = 4182,
  [4183] = 4183,
  [4184] = 4184,
  [4185] = 4185,
  [4186] = 4109,
  [4187] = 4187,
  [4188] = 4081,
  [4189] = 3566,
  [4190] = 4084,
  [4191] = 4191,
  [4192] = 4192,
  [4193] = 4094,
  [4194] = 4057,
  [4195] = 4195,
  [4196] = 4120,
  [4197] = 4197,
  [4198] = 4198,
  [4199] = 4084,
  [4200] = 4081,
  [4201] = 4084,
  [4202] = 4103,
  [4203] = 4203,
  [4204] = 4204,
  [4205] = 4157,
  [4206] = 4206,
  [4207] = 4090,
  [4208] = 4208,
  [4209] = 4209,
  [4210] = 4027,
  [4211] = 4030,
  [4212] = 4212,
  [4213] = 4213,
  [4214] = 4214,
  [4215] = 3336,
  [4216] = 4027,
  [4217] = 4030,
  [4218] = 4218,
  [4219] = 4047,
  [4220] = 4050,
  [4221] = 4221,
  [4222] = 4222,
  [4223] = 4223,
  [4224] = 4224,
  [4225] = 4209,
  [4226] = 4226,
  [4227] = 4227,
  [4228] = 3774,
  [4229] = 4229,
  [4230] = 4230,
  [4231] = 4057,
  [4232] = 4232,
  [4233] = 4233,
  [4234] = 4157,
  [4235] = 3996,
  [4236] = 4236,
  [4237] = 4046,
  [4238] = 4238,
  [4239] = 4239,
  [4240] = 4040,
  [4241] = 4049,
  [4242] = 4242,
  [4243] = 4243,
  [4244] = 4244,
  [4245] = 4004,
  [4246] = 4246,
  [4247] = 4247,
  [4248] = 4236,
  [4249] = 4249,
  [4250] = 4250,
  [4251] = 4251,
  [4252] = 4212,
  [4253] = 4208,
  [4254] = 4101,
  [4255] = 4238,
  [4256] = 4256,
  [4257] = 4032,
  [4258] = 4258,
  [4259] = 4094,
  [4260] = 4260,
  [4261] = 4229,
  [4262] = 4084,
  [4263] = 4081,
  [4264] = 4264,
  [4265] = 4238,
  [4266] = 4208,
  [4267] = 4212,
  [4268] = 4236,
  [4269] = 4269,
  [4270] = 4270,
  [4271] = 4040,
  [4272] = 4272,
  [4273] = 4073,
  [4274] = 3996,
  [4275] = 4275,
  [4276] = 4276,
  [4277] = 4277,
  [4278] = 2347,
  [4279] = 4279,
  [4280] = 4279,
  [4281] = 4281,
  [4282] = 4282,
  [4283] = 4283,
  [4284] = 2350,
  [4285] = 4285,
  [4286] = 4286,
  [4287] = 4287,
  [4288] = 4288,
  [4289] = 4281,
  [4290] = 4290,
  [4291] = 4291,
  [4292] = 4292,
  [4293] = 4283,
  [4294] = 4285,
  [4295] = 4295,
  [4296] = 4296,
  [4297] = 4297,
  [4298] = 4298,
  [4299] = 4299,
  [4300] = 4300,
  [4301] = 4301,
  [4302] = 4302,
  [4303] = 4303,
  [4304] = 4304,
  [4305] = 4279,
  [4306] = 4306,
  [4307] = 4307,
  [4308] = 4308,
  [4309] = 4309,
  [4310] = 4300,
  [4311] = 4311,
  [4312] = 4312,
  [4313] = 4313,
  [4314] = 4314,
  [4315] = 4315,
  [4316] = 4275,
  [4317] = 4304,
  [4318] = 4299,
  [4319] = 2342,
  [4320] = 4320,
  [4321] = 4321,
  [4322] = 4322,
  [4323] = 4309,
  [4324] = 4324,
  [4325] = 4325,
  [4326] = 4326,
  [4327] = 4327,
  [4328] = 4328,
  [4329] = 4329,
  [4330] = 4328,
  [4331] = 4331,
  [4332] = 4332,
  [4333] = 4285,
  [4334] = 4334,
  [4335] = 4335,
  [4336] = 4336,
  [4337] = 4337,
  [4338] = 4338,
  [4339] = 4339,
  [4340] = 2328,
  [4341] = 4341,
  [4342] = 4312,
  [4343] = 4343,
  [4344] = 4344,
  [4345] = 4345,
  [4346] = 4346,
  [4347] = 2368,
  [4348] = 2324,
  [4349] = 4349,
  [4350] = 4350,
  [4351] = 4304,
  [4352] = 4352,
  [4353] = 4353,
  [4354] = 4277,
  [4355] = 4355,
  [4356] = 4313,
  [4357] = 4357,
  [4358] = 4321,
  [4359] = 4359,
  [4360] = 4360,
  [4361] = 4361,
  [4362] = 4352,
  [4363] = 4363,
  [4364] = 4364,
  [4365] = 4365,
  [4366] = 4366,
  [4367] = 4367,
  [4368] = 4345,
  [4369] = 4297,
  [4370] = 860,
  [4371] = 4306,
  [4372] = 4325,
  [4373] = 4373,
  [4374] = 4374,
  [4375] = 4341,
  [4376] = 4376,
  [4377] = 4346,
  [4378] = 3443,
  [4379] = 4360,
  [4380] = 4341,
  [4381] = 4295,
  [4382] = 4382,
  [4383] = 2385,
  [4384] = 4315,
  [4385] = 4385,
  [4386] = 2387,
  [4387] = 4283,
  [4388] = 4388,
  [4389] = 4360,
  [4390] = 4363,
  [4391] = 2360,
  [4392] = 2364,
  [4393] = 4393,
  [4394] = 4394,
  [4395] = 4395,
  [4396] = 4396,
  [4397] = 4300,
  [4398] = 4398,
  [4399] = 2318,
  [4400] = 2326,
  [4401] = 4401,
  [4402] = 4331,
  [4403] = 4403,
  [4404] = 4327,
  [4405] = 4326,
  [4406] = 4281,
  [4407] = 4304,
  [4408] = 4308,
  [4409] = 4409,
  [4410] = 4285,
  [4411] = 4283,
  [4412] = 4281,
  [4413] = 4279,
  [4414] = 4414,
  [4415] = 4415,
  [4416] = 4303,
  [4417] = 4277,
  [4418] = 4418,
  [4419] = 4419,
  [4420] = 2335,
  [4421] = 4421,
  [4422] = 4329,
  [4423] = 4423,
  [4424] = 4332,
  [4425] = 4425,
  [4426] = 4426,
  [4427] = 4427,
  [4428] = 4275,
  [4429] = 4429,
  [4430] = 4430,
  [4431] = 4431,
  [4432] = 4432,
  [4433] = 4433,
  [4434] = 4335,
  [4435] = 4435,
  [4436] = 2746,
  [4437] = 4355,
  [4438] = 4298,
  [4439] = 3527,
  [4440] = 3978,
  [4441] = 4441,
  [4442] = 2340,
  [4443] = 4300,
  [4444] = 4444,
  [4445] = 4445,
  [4446] = 4446,
  [4447] = 4447,
  [4448] = 4301,
  [4449] = 2764,
  [4450] = 4450,
  [4451] = 4451,
  [4452] = 4452,
  [4453] = 4447,
  [4454] = 4450,
  [4455] = 4451,
  [4456] = 4396,
  [4457] = 4457,
  [4458] = 3525,
  [4459] = 4459,
  [4460] = 4460,
  [4461] = 4403,
  [4462] = 4462,
  [4463] = 4452,
  [4464] = 4409,
  [4465] = 4326,
  [4466] = 4466,
  [4467] = 4467,
  [4468] = 4468,
  [4469] = 4409,
  [4470] = 4470,
  [4471] = 4471,
  [4472] = 4472,
  [4473] = 4327,
  [4474] = 4474,
  [4475] = 4475,
  [4476] = 4367,
  [4477] = 4477,
  [4478] = 4409,
  [4479] = 4479,
  [4480] = 4396,
  [4481] = 4320,
  [4482] = 4324,
  [4483] = 4483,
  [4484] = 4403,
  [4485] = 2380,
  [4486] = 4335,
  [4487] = 4487,
  [4488] = 4488,
  [4489] = 4409,
  [4490] = 2391,
  [4491] = 4444,
  [4492] = 4350,
  [4493] = 4331,
  [4494] = 4337,
  [4495] = 4435,
  [4496] = 4298,
  [4497] = 4497,
  [4498] = 4364,
  [4499] = 4355,
  [4500] = 4425,
  [4501] = 4393,
  [4502] = 4502,
  [4503] = 4503,
  [4504] = 4504,
  [4505] = 4505,
  [4506] = 4353,
  [4507] = 4507,
  [4508] = 4508,
  [4509] = 4403,
  [4510] = 4510,
  [4511] = 4511,
  [4512] = 4401,
  [4513] = 4513,
  [4514] = 4376,
  [4515] = 4515,
  [4516] = 4302,
  [4517] = 4517,
  [4518] = 855,
  [4519] = 4519,
  [4520] = 2317,
  [4521] = 4521,
  [4522] = 2321,
  [4523] = 4401,
  [4524] = 4396,
  [4525] = 4366,
  [4526] = 4366,
  [4527] = 4527,
  [4528] = 4528,
  [4529] = 4529,
  [4530] = 4530,
  [4531] = 4531,
  [4532] = 4359,
  [4533] = 4511,
  [4534] = 4429,
  [4535] = 4357,
  [4536] = 4536,
  [4537] = 4537,
  [4538] = 4444,
  [4539] = 2329,
  [4540] = 4540,
  [4541] = 4403,
  [4542] = 4475,
  [4543] = 4540,
  [4544] = 4396,
  [4545] = 4497,
  [4546] = 4503,
  [4547] = 2395,
  [4548] = 4529,
  [4549] = 2484,
  [4550] = 4296,
  [4551] = 2483,
  [4552] = 2501,
  [4553] = 4497,
  [4554] = 2478,
  [4555] = 4423,
  [4556] = 4460,
  [4557] = 4459,
  [4558] = 4558,
  [4559] = 4559,
  [4560] = 4560,
  [4561] = 4561,
  [4562] = 4562,
  [4563] = 4296,
  [4564] = 4396,
  [4565] = 4565,
  [4566] = 4537,
  [4567] = 4507,
  [4568] = 4568,
  [4569] = 4432,
  [4570] = 4431,
  [4571] = 4537,
  [4572] = 4572,
  [4573] = 4363,
  [4574] = 4360,
  [4575] = 4575,
  [4576] = 4513,
  [4577] = 4403,
  [4578] = 4578,
  [4579] = 4346,
  [4580] = 4341,
  [4581] = 4581,
  [4582] = 4582,
  [4583] = 2332,
  [4584] = 4584,
  [4585] = 4585,
  [4586] = 4444,
  [4587] = 4306,
  [4588] = 4364,
  [4589] = 4511,
  [4590] = 4337,
  [4591] = 4409,
  [4592] = 2339,
  [4593] = 4297,
  [4594] = 4298,
  [4595] = 4466,
  [4596] = 3400,
  [4597] = 4314,
  [4598] = 4529,
  [4599] = 4298,
  [4600] = 4600,
  [4601] = 4601,
  [4602] = 4602,
  [4603] = 4603,
  [4604] = 4350,
  [4605] = 4605,
  [4606] = 4606,
  [4607] = 4607,
  [4608] = 4332,
  [4609] = 4329,
  [4610] = 4325,
  [4611] = 4611,
  [4612] = 4277,
  [4613] = 4427,
  [4614] = 4614,
  [4615] = 4615,
  [4616] = 4616,
  [4617] = 4299,
  [4618] = 4474,
  [4619] = 4331,
  [4620] = 4279,
  [4621] = 4328,
  [4622] = 4281,
  [4623] = 4327,
  [4624] = 4326,
  [4625] = 4283,
  [4626] = 4285,
  [4627] = 4446,
  [4628] = 4628,
  [4629] = 4315,
  [4630] = 4288,
  [4631] = 4479,
  [4632] = 4445,
  [4633] = 4423,
  [4634] = 4634,
  [4635] = 4635,
  [4636] = 4636,
  [4637] = 4637,
  [4638] = 4638,
  [4639] = 4639,
  [4640] = 4640,
  [4641] = 4635,
  [4642] = 4642,
  [4643] = 4643,
  [4644] = 4644,
  [4645] = 4645,
  [4646] = 4646,
  [4647] = 4647,
  [4648] = 4648,
  [4649] = 4636,
  [4650] = 4650,
  [4651] = 4651,
  [4652] = 4650,
  [4653] = 4653,
  [4654] = 4654,
  [4655] = 4655,
  [4656] = 4656,
  [4657] = 4657,
  [4658] = 4658,
  [4659] = 4659,
  [4660] = 4660,
  [4661] = 4642,
  [4662] = 4662,
  [4663] = 4663,
  [4664] = 4664,
  [4665] = 4634,
  [4666] = 4666,
  [4667] = 4667,
  [4668] = 4668,
  [4669] = 4669,
  [4670] = 4670,
  [4671] = 4671,
  [4672] = 4672,
  [4673] = 4673,
  [4674] = 4654,
  [4675] = 4675,
  [4676] = 4676,
  [4677] = 4671,
  [4678] = 4678,
  [4679] = 4672,
  [4680] = 4680,
  [4681] = 4681,
  [4682] = 4682,
  [4683] = 4683,
  [4684] = 4684,
  [4685] = 4685,
  [4686] = 4655,
  [4687] = 4656,
  [4688] = 4688,
  [4689] = 4689,
  [4690] = 4690,
  [4691] = 4691,
  [4692] = 4692,
  [4693] = 4693,
  [4694] = 4669,
  [4695] = 4695,
  [4696] = 4696,
  [4697] = 4697,
  [4698] = 4698,
  [4699] = 4699,
  [4700] = 4700,
  [4701] = 4701,
  [4702] = 4638,
  [4703] = 4647,
  [4704] = 4636,
  [4705] = 4675,
  [4706] = 4706,
  [4707] = 4646,
  [4708] = 4683,
  [4709] = 4688,
  [4710] = 4710,
  [4711] = 4711,
  [4712] = 4712,
  [4713] = 4668,
  [4714] = 4701,
  [4715] = 4715,
  [4716] = 4642,
  [4717] = 4675,
  [4718] = 4718,
  [4719] = 4697,
  [4720] = 4710,
  [4721] = 4721,
  [4722] = 4722,
  [4723] = 4692,
  [4724] = 4678,
  [4725] = 4690,
  [4726] = 4678,
  [4727] = 4648,
  [4728] = 4635,
  [4729] = 4729,
  [4730] = 4701,
  [4731] = 4664,
  [4732] = 4637,
  [4733] = 4664,
  [4734] = 4640,
  [4735] = 4735,
  [4736] = 4637,
  [4737] = 4640,
  [4738] = 4738,
  [4739] = 4712,
  [4740] = 4668,
  [4741] = 4738,
  [4742] = 4711,
  [4743] = 4743,
  [4744] = 4684,
  [4745] = 4684,
  [4746] = 4640,
  [4747] = 4700,
  [4748] = 4637,
  [4749] = 4636,
  [4750] = 4647,
  [4751] = 4638,
  [4752] = 4666,
  [4753] = 4706,
  [4754] = 4682,
  [4755] = 4699,
  [4756] = 4640,
  [4757] = 4680,
  [4758] = 4634,
  [4759] = 4666,
  [4760] = 4637,
  [4761] = 4761,
  [4762] = 4648,
  [4763] = 4690,
  [4764] = 4764,
  [4765] = 4765,
  [4766] = 4688,
  [4767] = 4698,
  [4768] = 4683,
  [4769] = 4769,
  [4770] = 4770,
  [4771] = 4669,
  [4772] = 4668,
  [4773] = 4658,
  [4774] = 4701,
  [4775] = 4659,
  [4776] = 4776,
  [4777] = 4706,
  [4778] = 4710,
  [4779] = 4664,
  [4780] = 4688,
  [4781] = 4683,
  [4782] = 4695,
  [4783] = 4783,
  [4784] = 4693,
  [4785] = 4691,
  [4786] = 4689,
  [4787] = 4683,
  [4788] = 4706,
  [4789] = 4634,
  [4790] = 4666,
  [4791] = 4791,
  [4792] = 4792,
  [4793] = 4636,
  [4794] = 4647,
  [4795] = 4638,
  [4796] = 4796,
  [4797] = 4638,
  [4798] = 4647,
  [4799] = 4799,
  [4800] = 4672,
  [4801] = 4671,
  [4802] = 4660,
  [4803] = 4638,
  [4804] = 4804,
  [4805] = 4805,
  [4806] = 4806,
  [4807] = 4807,
  [4808] = 4678,
  [4809] = 4663,
  [4810] = 4645,
  [4811] = 4634,
  [4812] = 4663,
  [4813] = 4813,
  [4814] = 4814,
  [4815] = 4815,
  [4816] = 4697,
  [4817] = 4817,
  [4818] = 4666,
  [4819] = 4682,
  [4820] = 4820,
  [4821] = 4821,
  [4822] = 4636,
  [4823] = 4647,
  [4824] = 4712,
  [4825] = 4648,
  [4826] = 4669,
  [4827] = 4668,
  [4828] = 4640,
  [4829] = 4738,
  [4830] = 4637,
  [4831] = 4662,
  [4832] = 4664,
  [4833] = 4833,
  [4834] = 4676,
  [4835] = 4692,
  [4836] = 4836,
  [4837] = 4764,
  [4838] = 4642,
  [4839] = 4636,
  [4840] = 4647,
  [4841] = 4638,
  [4842] = 4842,
  [4843] = 4843,
  [4844] = 4710,
  [4845] = 4711,
  [4846] = 4646,
  [4847] = 4700,
  [4848] = 4848,
  [4849] = 4799,
  [4850] = 4635,
  [4851] = 4699,
  [4852] = 4761,
  [4853] = 4729,
  [4854] = 1754,
  [4855] = 4698,
  [4856] = 4695,
  [4857] = 4693,
  [4858] = 4650,
  [4859] = 4806,
  [4860] = 4654,
  [4861] = 4861,
  [4862] = 4691,
  [4863] = 4863,
  [4864] = 4655,
  [4865] = 4689,
  [4866] = 4776,
  [4867] = 4656,
  [4868] = 4657,
  [4869] = 4869,
  [4870] = 4634,
  [4871] = 4871,
  [4872] = 4658,
  [4873] = 4696,
  [4874] = 4659,
  [4875] = 4820,
  [4876] = 4660,
  [4877] = 4670,
  [4878] = 4673,
  [4879] = 4675,
  [4880] = 4738,
  [4881] = 4881,
  [4882] = 4689,
  [4883] = 4691,
  [4884] = 4685,
  [4885] = 4695,
  [4886] = 4698,
  [4887] = 4738,
  [4888] = 4888,
  [4889] = 4699,
  [4890] = 4700,
  [4891] = 4646,
  [4892] = 4711,
  [4893] = 4712,
  [4894] = 4693,
  [4895] = 4640,
  [4896] = 4896,
  [4897] = 4861,
  [4898] = 4738,
  [4899] = 4899,
  [4900] = 4900,
  [4901] = 4675,
  [4902] = 4640,
  [4903] = 4817,
  [4904] = 4904,
  [4905] = 4673,
  [4906] = 4670,
  [4907] = 4660,
  [4908] = 4659,
  [4909] = 4658,
  [4910] = 4657,
  [4911] = 4670,
  [4912] = 4637,
  [4913] = 4656,
  [4914] = 4655,
  [4915] = 4680,
  [4916] = 4654,
  [4917] = 4639,
  [4918] = 4918,
  [4919] = 4648,
  [4920] = 4648,
  [4921] = 4921,
  [4922] = 4673,
  [4923] = 4650,
  [4924] = 4685,
  [4925] = 4925,
  [4926] = 4926,
  [4927] = 4927,
  [4928] = 4738,
  [4929] = 4929,
  [4930] = 4843,
  [4931] = 4710,
  [4932] = 4640,
  [4933] = 4688,
  [4934] = 4637,
  [4935] = 4636,
  [4936] = 4647,
  [4937] = 4638,
  [4938] = 4683,
  [4939] = 4706,
  [4940] = 4940,
  [4941] = 4941,
  [4942] = 4636,
  [4943] = 4943,
  [4944] = 4647,
  [4945] = 4945,
  [4946] = 4638,
  [4947] = 4712,
  [4948] = 4711,
  [4949] = 4949,
  [4950] = 4646,
  [4951] = 4700,
  [4952] = 4699,
  [4953] = 4698,
  [4954] = 4676,
  [4955] = 4764,
  [4956] = 4843,
  [4957] = 4695,
  [4958] = 4693,
  [4959] = 4691,
  [4960] = 4960,
  [4961] = 4689,
  [4962] = 4637,
  [4963] = 4761,
  [4964] = 4729,
  [4965] = 4675,
  [4966] = 4966,
  [4967] = 4806,
  [4968] = 4673,
  [4969] = 4861,
  [4970] = 4639,
  [4971] = 4896,
  [4972] = 4776,
  [4973] = 4670,
  [4974] = 4660,
  [4975] = 4659,
  [4976] = 4976,
  [4977] = 4658,
  [4978] = 4978,
  [4979] = 4657,
  [4980] = 4764,
  [4981] = 4656,
  [4982] = 4655,
  [4983] = 4654,
  [4984] = 4650,
  [4985] = 4668,
  [4986] = 4635,
  [4987] = 4642,
  [4988] = 4764,
  [4989] = 4989,
  [4990] = 4820,
  [4991] = 4662,
  [4992] = 4992,
  [4993] = 4764,
  [4994] = 4994,
  [4995] = 4918,
  [4996] = 4899,
  [4997] = 4997,
  [4998] = 4635,
  [4999] = 4869,
  [5000] = 4642,
  [5001] = 5001,
  [5002] = 4669,
  [5003] = 5003,
  [5004] = 4918,
  [5005] = 4899,
  [5006] = 4657,
  [5007] = 4664,
  [5008] = 4869,
  [5009] = 4899,
  [5010] = 5010,
  [5011] = 5011,
  [5012] = 5012,
};

static inline bool anon_sym_BANG_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? (c >= '\t' && c <= '\n')
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym__glimmer_template_content_character_set_1(int32_t c) {
  return (c < 8192
    ? (c < ' '
      ? (c < '\r'
        ? c == '\t'
        : c <= '\r')
      : (c <= ' ' || (c < 5760
        ? c == 160
        : c <= 5760)))
    : (c <= 8203 || (c < 12288
      ? (c < 8287
        ? c == 8239
        : c <= 8288)
      : (c <= 12288 || c == 65279))));
}

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '{' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 160
    ? (c < ':'
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '/')))
      : (c <= '@' || (c < '`'
        ? (c >= '[' && c <= '^')
        : (c <= '`' || (c >= '|' && c <= '~')))))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static inline bool sym_private_property_identifier_character_set_1(int32_t c) {
  return (c < 160
    ? (c < '['
      ? (c < 0
        ? c == 0
        : (c <= '#' || (c >= '%' && c <= '@')))
      : (c <= '^' || (c < '{'
        ? c == '`'
        : c <= '~')))
    : (c <= 160 || (c < 8287
      ? (c < 8192
        ? c == 5760
        : (c <= 8203 || c == 8239))
      : (c <= 8288 || (c < 65279
        ? c == 12288
        : c <= 65279)))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(94);
      if (lookahead == '!') ADVANCE(107);
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == '$') ADVANCE(231);
      if (lookahead == '%') ADVANCE(181);
      if (lookahead == '&') ADVANCE(163);
      if (lookahead == '\'') ADVANCE(196);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(175);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(179);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '/') ADVANCE(217);
      if (lookahead == '0') ADVANCE(222);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(237);
      if (lookahead == '@') ADVANCE(234);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(53);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '^') ADVANCE(166);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '|') ADVANCE(169);
      if (lookahead == '}') ADVANCE(105);
      if (lookahead == '~') ADVANCE(192);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(223);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(92)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(232);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(1)
      if (lookahead == '/') ADVANCE(115);
      if (lookahead == '<') ADVANCE(117);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(116);
      if (lookahead != 0) ADVANCE(114);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(29)
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '[') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(91);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(218);
      if (lookahead != 0) ADVANCE(219);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(107);
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '#') ADVANCE(36);
      if (lookahead == '%') ADVANCE(181);
      if (lookahead == '&') ADVANCE(163);
      if (lookahead == '\'') ADVANCE(196);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(175);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(178);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(130);
      if (lookahead == '0') ADVANCE(222);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '<') ADVANCE(121);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(237);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '^') ADVANCE(166);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '|') ADVANCE(168);
      if (lookahead == '}') ADVANCE(105);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(223);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(3)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '@' &&
          lookahead != '~') ADVANCE(232);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(107);
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '%') ADVANCE(181);
      if (lookahead == '&') ADVANCE(163);
      if (lookahead == '\'') ADVANCE(196);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(175);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(178);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '/') ADVANCE(130);
      if (lookahead == '0') ADVANCE(222);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(237);
      if (lookahead == '@') ADVANCE(234);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == '^') ADVANCE(166);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(168);
      if (lookahead == '~') ADVANCE(192);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(223);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(4)
      if (lookahead != 0 &&
          lookahead > '#' &&
          lookahead != ';' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(232);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(107);
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '%') ADVANCE(181);
      if (lookahead == '&') ADVANCE(163);
      if (lookahead == '\'') ADVANCE(196);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(175);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(178);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(130);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '<') ADVANCE(121);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(237);
      if (lookahead == '@') ADVANCE(234);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '^') ADVANCE(166);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(169);
      if (lookahead == '}') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(243);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(5)
      if (lookahead != 0 &&
          lookahead > '#' &&
          lookahead != '~') ADVANCE(232);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(107);
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '%') ADVANCE(180);
      if (lookahead == '&') ADVANCE(164);
      if (lookahead == '\'') ADVANCE(196);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == '*') ADVANCE(98);
      if (lookahead == '+') ADVANCE(174);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(177);
      if (lookahead == '.') ADVANCE(133);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '0') ADVANCE(222);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '<') ADVANCE(124);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '?') ADVANCE(27);
      if (lookahead == '@') ADVANCE(234);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '^') ADVANCE(165);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(170);
      if (lookahead == '}') ADVANCE(105);
      if (lookahead == '~') ADVANCE(192);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(223);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(6)
      if (lookahead != 0 &&
          lookahead > '#') ADVANCE(232);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(107);
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '%') ADVANCE(180);
      if (lookahead == '&') ADVANCE(164);
      if (lookahead == '\'') ADVANCE(196);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == '*') ADVANCE(98);
      if (lookahead == '+') ADVANCE(174);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(177);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '?') ADVANCE(238);
      if (lookahead == '@') ADVANCE(234);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '^') ADVANCE(165);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(171);
      if (lookahead == '}') ADVANCE(105);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(7)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '0' || '9' < lookahead) &&
          lookahead != '~') ADVANCE(232);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(107);
      if (lookahead == '%') ADVANCE(180);
      if (lookahead == '&') ADVANCE(164);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == '*') ADVANCE(98);
      if (lookahead == '+') ADVANCE(174);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(177);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(32);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '?') ADVANCE(27);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '^') ADVANCE(165);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(170);
      if (lookahead == '}') ADVANCE(105);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(9)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(220);
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(232);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(107);
      if (lookahead == '%') ADVANCE(180);
      if (lookahead == '&') ADVANCE(164);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == '*') ADVANCE(98);
      if (lookahead == '+') ADVANCE(174);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(177);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(32);
      if (lookahead == '>') ADVANCE(128);
      if (lookahead == '?') ADVANCE(27);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '^') ADVANCE(165);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(170);
      if (lookahead == '}') ADVANCE(105);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(9)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(232);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(95);
      if (lookahead == '\\') ADVANCE(54);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(233);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '#') ADVANCE(36);
      if (lookahead == '&') ADVANCE(162);
      if (lookahead == '\'') ADVANCE(196);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == '*') ADVANCE(96);
      if (lookahead == '+') ADVANCE(174);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(177);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '0') ADVANCE(222);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(235);
      if (lookahead == '@') ADVANCE(234);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(172);
      if (lookahead == '}') ADVANCE(105);
      if (lookahead == '~') ADVANCE(192);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(223);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(11)
      if (lookahead != 0 &&
          lookahead > 31 &&
          lookahead != '%' &&
          lookahead != '^') ADVANCE(232);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '#') ADVANCE(36);
      if (lookahead == '&') ADVANCE(162);
      if (lookahead == '\'') ADVANCE(196);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == '*') ADVANCE(96);
      if (lookahead == '+') ADVANCE(173);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(176);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '/') ADVANCE(217);
      if (lookahead == '0') ADVANCE(222);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '<') ADVANCE(120);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(235);
      if (lookahead == '@') ADVANCE(234);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '|') ADVANCE(172);
      if (lookahead == '}') ADVANCE(105);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(223);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(13)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || ')' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(232);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '#') ADVANCE(36);
      if (lookahead == '&') ADVANCE(162);
      if (lookahead == '\'') ADVANCE(196);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == '*') ADVANCE(96);
      if (lookahead == '+') ADVANCE(173);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(176);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '0') ADVANCE(222);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '<') ADVANCE(120);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(235);
      if (lookahead == '@') ADVANCE(234);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '|') ADVANCE(172);
      if (lookahead == '}') ADVANCE(105);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(223);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(13)
      if (lookahead != 0 &&
          lookahead > 31 &&
          (lookahead < '%' || ')' < lookahead) &&
          lookahead != '^' &&
          lookahead != '~') ADVANCE(232);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '&') ADVANCE(162);
      if (lookahead == '\'') ADVANCE(196);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == '*') ADVANCE(96);
      if (lookahead == '+') ADVANCE(174);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(177);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '0') ADVANCE(222);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '?') ADVANCE(235);
      if (lookahead == '@') ADVANCE(234);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '|') ADVANCE(167);
      if (lookahead == '~') ADVANCE(192);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(223);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(14)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          lookahead != '^' &&
          lookahead != '}') ADVANCE(232);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '&') ADVANCE(162);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '<') ADVANCE(120);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(235);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(172);
      if (lookahead == '}') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(243);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(15)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(232);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '#') ADVANCE(36);
      if (lookahead == '&') ADVANCE(162);
      if (lookahead == '\'') ADVANCE(196);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == '*') ADVANCE(96);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(176);
      if (lookahead == '.') ADVANCE(26);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '0') ADVANCE(222);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '<') ADVANCE(120);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(235);
      if (lookahead == '@') ADVANCE(234);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(172);
      if (lookahead == '}') ADVANCE(105);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(223);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(16)
      if (lookahead != 0 &&
          lookahead > '!' &&
          (lookahead < '%' || '+' < lookahead) &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(232);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '/') ADVANCE(198);
      if (lookahead == '\\') ADVANCE(56);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(201);
      if (lookahead != 0) ADVANCE(202);
      END_STATE();
    case 18:
      if (lookahead == '$') ADVANCE(57);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == '`') ADVANCE(215);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(19)
      END_STATE();
    case 19:
      if (lookahead == '$') ADVANCE(57);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '`') ADVANCE(215);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(19)
      END_STATE();
    case 20:
      if (lookahead == '&') ADVANCE(162);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(126);
      if (lookahead == '?') ADVANCE(236);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '{') ADVANCE(102);
      if (lookahead == '|') ADVANCE(172);
      if (lookahead == '}') ADVANCE(105);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(20)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '~') ADVANCE(232);
      END_STATE();
    case 21:
      if (lookahead == '&') ADVANCE(162);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(35);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == '<') ADVANCE(120);
      if (lookahead == '?') ADVANCE(31);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '|') ADVANCE(167);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(21)
      if (lookahead != 0 &&
          lookahead > '#' &&
          (lookahead < '%' || '@' < lookahead) &&
          lookahead != '^' &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~') ADVANCE(232);
      END_STATE();
    case 22:
      if (lookahead == '\'') ADVANCE(196);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '\\') ADVANCE(56);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(207);
      if (lookahead != 0) ADVANCE(208);
      END_STATE();
    case 23:
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(214);
      END_STATE();
    case 24:
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '/') ADVANCE(213);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 25:
      if (lookahead == '*') ADVANCE(24);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 26:
      if (lookahead == '.') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(229);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(135);
      if (lookahead == '?') ADVANCE(190);
      END_STATE();
    case 28:
      if (lookahead == '.') ADVANCE(151);
      END_STATE();
    case 29:
      if (lookahead == '/') ADVANCE(23);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(29)
      END_STATE();
    case 30:
      if (lookahead == ':') ADVANCE(239);
      END_STATE();
    case 31:
      if (lookahead == ':') ADVANCE(240);
      END_STATE();
    case 32:
      if (lookahead == '=') ADVANCE(185);
      END_STATE();
    case 33:
      if (lookahead == '>') ADVANCE(118);
      END_STATE();
    case 34:
      if (lookahead == '>') ADVANCE(119);
      END_STATE();
    case 35:
      if (lookahead == '?') ADVANCE(30);
      END_STATE();
    case 36:
      if (lookahead == '\\') ADVANCE(54);
      if (!sym_private_property_identifier_character_set_1(lookahead)) ADVANCE(233);
      END_STATE();
    case 37:
      if (lookahead == '\\') ADVANCE(90);
      if (lookahead == ']') ADVANCE(219);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(37);
      END_STATE();
    case 38:
      if (lookahead == 'a') ADVANCE(50);
      END_STATE();
    case 39:
      if (lookahead == 'a') ADVANCE(51);
      END_STATE();
    case 40:
      if (lookahead == 'e') ADVANCE(46);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(33);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(34);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 44:
      if (lookahead == 'l') ADVANCE(38);
      END_STATE();
    case 45:
      if (lookahead == 'l') ADVANCE(39);
      END_STATE();
    case 46:
      if (lookahead == 'm') ADVANCE(48);
      END_STATE();
    case 47:
      if (lookahead == 'm') ADVANCE(49);
      END_STATE();
    case 48:
      if (lookahead == 'p') ADVANCE(44);
      END_STATE();
    case 49:
      if (lookahead == 'p') ADVANCE(45);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(41);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(42);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 53:
      if (lookahead == 'u') ADVANCE(58);
      if (lookahead == 'x') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(212);
      if (lookahead != 0) ADVANCE(209);
      END_STATE();
    case 54:
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 55:
      if (lookahead == 'u') ADVANCE(60);
      END_STATE();
    case 56:
      if (lookahead == 'u') ADVANCE(61);
      if (lookahead == 'x') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(212);
      if (lookahead != 0) ADVANCE(209);
      END_STATE();
    case 57:
      if (lookahead == '{') ADVANCE(216);
      END_STATE();
    case 58:
      if (lookahead == '{') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      END_STATE();
    case 59:
      if (lookahead == '{') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(88);
      END_STATE();
    case 60:
      if (lookahead == '{') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(89);
      END_STATE();
    case 61:
      if (lookahead == '{') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(79);
      END_STATE();
    case 62:
      if (lookahead == '}') ADVANCE(232);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 63:
      if (lookahead == '}') ADVANCE(233);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 64:
      if (lookahead == '}') ADVANCE(209);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 65:
      if (lookahead == '}') ADVANCE(210);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 66:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(228);
      END_STATE();
    case 67:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(224);
      END_STATE();
    case 68:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(225);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(223);
      END_STATE();
    case 70:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(229);
      END_STATE();
    case 71:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(227);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(228);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(232);
      END_STATE();
    case 74:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(233);
      END_STATE();
    case 75:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(209);
      END_STATE();
    case 76:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(226);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 78:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(210);
      END_STATE();
    case 79:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(82);
      END_STATE();
    case 80:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(63);
      END_STATE();
    case 81:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 82:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(75);
      END_STATE();
    case 83:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(64);
      END_STATE();
    case 84:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 85:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      END_STATE();
    case 86:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      END_STATE();
    case 87:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(84);
      END_STATE();
    case 88:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(85);
      END_STATE();
    case 89:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(86);
      END_STATE();
    case 90:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(37);
      END_STATE();
    case 91:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(219);
      END_STATE();
    case 92:
      if (eof) ADVANCE(94);
      if (lookahead == '!') ADVANCE(107);
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == '$') ADVANCE(231);
      if (lookahead == '%') ADVANCE(181);
      if (lookahead == '&') ADVANCE(163);
      if (lookahead == '\'') ADVANCE(196);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(175);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(179);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '/') ADVANCE(129);
      if (lookahead == '0') ADVANCE(222);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(237);
      if (lookahead == '@') ADVANCE(234);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '^') ADVANCE(166);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '|') ADVANCE(169);
      if (lookahead == '}') ADVANCE(105);
      if (lookahead == '~') ADVANCE(192);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(223);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(92)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(232);
      END_STATE();
    case 93:
      if (eof) ADVANCE(94);
      if (lookahead == '!') ADVANCE(107);
      if (lookahead == '"') ADVANCE(195);
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == '%') ADVANCE(181);
      if (lookahead == '&') ADVANCE(163);
      if (lookahead == '\'') ADVANCE(196);
      if (lookahead == '(') ADVANCE(108);
      if (lookahead == ')') ADVANCE(109);
      if (lookahead == '*') ADVANCE(97);
      if (lookahead == '+') ADVANCE(175);
      if (lookahead == ',') ADVANCE(104);
      if (lookahead == '-') ADVANCE(178);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '/') ADVANCE(130);
      if (lookahead == '0') ADVANCE(222);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(110);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(100);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '?') ADVANCE(237);
      if (lookahead == '@') ADVANCE(234);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == '^') ADVANCE(166);
      if (lookahead == '`') ADVANCE(215);
      if (lookahead == '{') ADVANCE(103);
      if (lookahead == '|') ADVANCE(168);
      if (lookahead == '}') ADVANCE(105);
      if (lookahead == '~') ADVANCE(192);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(223);
      if (anon_sym_BANG_character_set_1(lookahead)) SKIP(93)
      if (lookahead != 0 &&
          lookahead > 31) ADVANCE(232);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(95);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(183);
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(182);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(185);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(185);
      if (lookahead == '>') ADVANCE(134);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(134);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|') ADVANCE(241);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(187);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(214);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '/') ADVANCE(115);
      if (lookahead == '<') ADVANCE(117);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(116);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(114);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym__glimmer_template_content);
      if (lookahead == '/') ADVANCE(52);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_LTtemplate_GT);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LT_SLASHtemplate_GT);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(161);
      if (lookahead == '=') ADVANCE(184);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(161);
      if (lookahead == '=') ADVANCE(184);
      if (lookahead == 't') ADVANCE(40);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(160);
      if (lookahead == '=') ADVANCE(184);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(160);
      if (lookahead == '=') ADVANCE(184);
      if (lookahead == 't') ADVANCE(40);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == 't') ADVANCE(40);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == '>') ADVANCE(156);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(189);
      if (lookahead == '>') ADVANCE(157);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(214);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(214);
      if (lookahead == '=') ADVANCE(139);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(229);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(229);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_QMARK_DOT);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(148);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(149);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(144);
      if (lookahead == '>') ADVANCE(159);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(158);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(145);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(146);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(153);
      if (lookahead == '=') ADVANCE(142);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(152);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(143);
      if (lookahead == '|') ADVANCE(155);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(143);
      if (lookahead == '|') ADVANCE(155);
      if (lookahead == '}') ADVANCE(242);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(154);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(154);
      if (lookahead == '}') ADVANCE(242);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}') ADVANCE(242);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(193);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(193);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(194);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(194);
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(194);
      if (lookahead == '=') ADVANCE(137);
      if (lookahead == '?') ADVANCE(30);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(140);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(186);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(188);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '\n') ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(197);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(200);
      if (lookahead == '/') ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(202);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(199);
      if (lookahead == '/') ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(200);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '*') ADVANCE(199);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(200);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead == '/') ADVANCE(198);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(201);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(202);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_unescaped_double_string_fragment);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(202);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '\n') ADVANCE(208);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(203);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(206);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(208);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(205);
      if (lookahead == '/') ADVANCE(208);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(206);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '*') ADVANCE(205);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(206);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead == '/') ADVANCE(204);
      if (anon_sym_BANG_character_set_1(lookahead)) ADVANCE(207);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(208);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_unescaped_single_string_fragment);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(208);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(55);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(232);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(209);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(211);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(214);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(25);
      if (lookahead == '/') ADVANCE(214);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '\n') SKIP(29)
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '[') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(91);
      if (sym__glimmer_template_content_character_set_1(lookahead)) ADVANCE(218);
      if (lookahead != 0) ADVANCE(219);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(37);
      if (lookahead == '\\') ADVANCE(91);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(219);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(55);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(220);
      if (!sym_identifier_character_set_2(lookahead)) ADVANCE(232);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(230);
      if (lookahead == '0') ADVANCE(227);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(67);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(68);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(76);
      if (lookahead == '_') ADVANCE(71);
      if (lookahead == 'n') ADVANCE(221);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(223);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(230);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (lookahead == '_') ADVANCE(69);
      if (lookahead == 'n') ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(223);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(67);
      if (lookahead == 'n') ADVANCE(221);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(224);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(68);
      if (lookahead == 'n') ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(225);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(76);
      if (lookahead == 'n') ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(226);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(71);
      if (lookahead == 'n') ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(227);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(228);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (lookahead == '_') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(229);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(229);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(55);
      if (lookahead == '{') ADVANCE(216);
      if (!sym_identifier_character_set_3(lookahead)) ADVANCE(232);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(55);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(232);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_private_property_identifier);
      if (lookahead == '\\') ADVANCE(54);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(233);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(135);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(135);
      if (lookahead == '?') ADVANCE(191);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '.') ADVANCE(135);
      if (lookahead == '?') ADVANCE(190);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_DASH_QMARK_COLON);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_QMARK_COLON);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(aux_sym_ui_version_specifier_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(243);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'k') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'r') ADVANCE(15);
      if (lookahead == 's') ADVANCE(16);
      if (lookahead == 't') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(18);
      if (lookahead == 'v') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8203) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 8288 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 's') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(37);
      if (lookahead == 'o') ADVANCE(38);
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(48);
      if (lookahead == 'i') ADVANCE(49);
      END_STATE();
    case 11:
      if (lookahead == 'o') ADVANCE(50);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(51);
      if (lookahead == 'e') ADVANCE(52);
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 13:
      if (lookahead == 'b') ADVANCE(54);
      if (lookahead == 'f') ADVANCE(55);
      if (lookahead == 'n') ADVANCE(56);
      if (lookahead == 'v') ADVANCE(57);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(58);
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(60);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(61);
      if (lookahead == 'i') ADVANCE(62);
      if (lookahead == 't') ADVANCE(63);
      if (lookahead == 'u') ADVANCE(64);
      if (lookahead == 'w') ADVANCE(65);
      if (lookahead == 'y') ADVANCE(66);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'h') ADVANCE(68);
      if (lookahead == 'r') ADVANCE(69);
      if (lookahead == 'y') ADVANCE(70);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(71);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(72);
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(74);
      if (lookahead == 'i') ADVANCE(75);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(76);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(77);
      END_STATE();
    case 23:
      if (lookahead == 'y') ADVANCE(78);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(79);
      if (lookahead == 'y') ADVANCE(80);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(81);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(82);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(84);
      if (lookahead == 't') ADVANCE(85);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(86);
      END_STATE();
    case 30:
      if (lookahead == 'm') ADVANCE(87);
      if (lookahead == 'n') ADVANCE(88);
      END_STATE();
    case 31:
      if (lookahead == 'b') ADVANCE(89);
      if (lookahead == 'c') ADVANCE(90);
      if (lookahead == 'f') ADVANCE(91);
      if (lookahead == 'l') ADVANCE(92);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(93);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(94);
      END_STATE();
    case 35:
      if (lookahead == 'p') ADVANCE(95);
      if (lookahead == 't') ADVANCE(96);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(97);
      END_STATE();
    case 37:
      if (lookahead == 'n') ADVANCE(98);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(99);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(100);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(101);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(103);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(104);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(105);
      if (lookahead == 's') ADVANCE(106);
      if (lookahead == 't') ADVANCE(107);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y') ADVANCE(108);
      END_STATE();
    case 48:
      if (lookahead == 't') ADVANCE(109);
      END_STATE();
    case 49:
      if (lookahead == 's') ADVANCE(110);
      END_STATE();
    case 50:
      if (lookahead == 'd') ADVANCE(111);
      END_STATE();
    case 51:
      if (lookahead == 'm') ADVANCE(112);
      END_STATE();
    case 52:
      if (lookahead == 'v') ADVANCE(113);
      if (lookahead == 'w') ADVANCE(114);
      END_STATE();
    case 53:
      if (lookahead == 'l') ADVANCE(115);
      if (lookahead == 'm') ADVANCE(116);
      END_STATE();
    case 54:
      if (lookahead == 'j') ADVANCE(117);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_on);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(118);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(119);
      if (lookahead == 'i') ADVANCE(120);
      if (lookahead == 'o') ADVANCE(121);
      END_STATE();
    case 59:
      if (lookahead == 'b') ADVANCE(122);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(123);
      if (lookahead == 'q') ADVANCE(124);
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 61:
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 62:
      if (lookahead == 'g') ADVANCE(127);
      END_STATE();
    case 63:
      if (lookahead == 'a') ADVANCE(128);
      if (lookahead == 'r') ADVANCE(129);
      END_STATE();
    case 64:
      if (lookahead == 'p') ADVANCE(130);
      END_STATE();
    case 65:
      if (lookahead == 'i') ADVANCE(131);
      END_STATE();
    case 66:
      if (lookahead == 'm') ADVANCE(132);
      END_STATE();
    case 67:
      if (lookahead == 'r') ADVANCE(133);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(134);
      if (lookahead == 'r') ADVANCE(135);
      END_STATE();
    case 69:
      if (lookahead == 'u') ADVANCE(136);
      if (lookahead == 'y') ADVANCE(137);
      END_STATE();
    case 70:
      if (lookahead == 'p') ADVANCE(138);
      END_STATE();
    case 71:
      if (lookahead == 'd') ADVANCE(139);
      if (lookahead == 'k') ADVANCE(140);
      END_STATE();
    case 72:
      if (lookahead == 'r') ADVANCE(141);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(142);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(143);
      END_STATE();
    case 75:
      if (lookahead == 't') ADVANCE(144);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(146);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(147);
      END_STATE();
    case 80:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 81:
      if (lookahead == 'i') ADVANCE(149);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(150);
      END_STATE();
    case 83:
      if (lookahead == 'a') ADVANCE(151);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 85:
      if (lookahead == 'c') ADVANCE(153);
      END_STATE();
    case 86:
      if (lookahead == 's') ADVANCE(154);
      END_STATE();
    case 87:
      if (lookahead == 'p') ADVANCE(155);
      END_STATE();
    case 88:
      if (lookahead == 's') ADVANCE(156);
      if (lookahead == 't') ADVANCE(157);
      END_STATE();
    case 89:
      if (lookahead == 'u') ADVANCE(158);
      END_STATE();
    case 90:
      if (lookahead == 'l') ADVANCE(159);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(160);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(161);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 94:
      if (lookahead == 'm') ADVANCE(163);
      END_STATE();
    case 95:
      if (lookahead == 'o') ADVANCE(164);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(165);
      END_STATE();
    case 97:
      if (lookahead == 's') ADVANCE(166);
      END_STATE();
    case 98:
      if (lookahead == 'a') ADVANCE(167);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 100:
      if (lookahead == 'm') ADVANCE(168);
      END_STATE();
    case 101:
      if (lookahead == 'c') ADVANCE(169);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 103:
      if (lookahead == 'b') ADVANCE(170);
      END_STATE();
    case 104:
      if (lookahead == 'l') ADVANCE(171);
      if (lookahead == 'o') ADVANCE(172);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(173);
      END_STATE();
    case 106:
      if (lookahead == 't') ADVANCE(174);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 108:
      if (lookahead == 'o') ADVANCE(176);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 110:
      if (lookahead == 't') ADVANCE(177);
      END_STATE();
    case 111:
      if (lookahead == 'u') ADVANCE(178);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 115:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 116:
      if (lookahead == 'b') ADVANCE(182);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(183);
      END_STATE();
    case 118:
      if (lookahead == 'r') ADVANCE(184);
      END_STATE();
    case 119:
      if (lookahead == 'g') ADVANCE(185);
      END_STATE();
    case 120:
      if (lookahead == 'v') ADVANCE(186);
      END_STATE();
    case 121:
      if (lookahead == 'p') ADVANCE(187);
      if (lookahead == 't') ADVANCE(188);
      END_STATE();
    case 122:
      if (lookahead == 'l') ADVANCE(189);
      END_STATE();
    case 123:
      if (lookahead == 'd') ADVANCE(190);
      END_STATE();
    case 124:
      if (lookahead == 'u') ADVANCE(191);
      END_STATE();
    case 125:
      if (lookahead == 'u') ADVANCE(192);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 127:
      if (lookahead == 'n') ADVANCE(193);
      END_STATE();
    case 128:
      if (lookahead == 't') ADVANCE(194);
      END_STATE();
    case 129:
      if (lookahead == 'i') ADVANCE(195);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(196);
      END_STATE();
    case 131:
      if (lookahead == 't') ADVANCE(197);
      END_STATE();
    case 132:
      if (lookahead == 'b') ADVANCE(198);
      END_STATE();
    case 133:
      if (lookahead == 'g') ADVANCE(199);
      END_STATE();
    case 134:
      if (lookahead == 's') ADVANCE(200);
      END_STATE();
    case 135:
      if (lookahead == 'o') ADVANCE(201);
      END_STATE();
    case 136:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 138:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 140:
      if (lookahead == 'n') ADVANCE(205);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 142:
      if (lookahead == 'd') ADVANCE(206);
      END_STATE();
    case 143:
      if (lookahead == 'l') ADVANCE(207);
      END_STATE();
    case 144:
      if (lookahead == 'h') ADVANCE(208);
      END_STATE();
    case 145:
      if (lookahead == 'l') ADVANCE(209);
      END_STATE();
    case 146:
      if (lookahead == 'r') ADVANCE(210);
      END_STATE();
    case 147:
      if (lookahead == 'r') ADVANCE(211);
      END_STATE();
    case 148:
      if (lookahead == 'c') ADVANCE(212);
      END_STATE();
    case 149:
      if (lookahead == 't') ADVANCE(213);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(214);
      END_STATE();
    case 151:
      if (lookahead == 'k') ADVANCE(215);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 153:
      if (lookahead == 'h') ADVANCE(216);
      END_STATE();
    case 154:
      if (lookahead == 's') ADVANCE(217);
      END_STATE();
    case 155:
      if (lookahead == 'o') ADVANCE(218);
      END_STATE();
    case 156:
      if (lookahead == 't') ADVANCE(219);
      END_STATE();
    case 157:
      if (lookahead == 'i') ADVANCE(220);
      END_STATE();
    case 158:
      if (lookahead == 'g') ADVANCE(221);
      END_STATE();
    case 159:
      if (lookahead == 'a') ADVANCE(222);
      END_STATE();
    case 160:
      if (lookahead == 'u') ADVANCE(223);
      END_STATE();
    case 161:
      if (lookahead == 't') ADVANCE(224);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 164:
      if (lookahead == 'r') ADVANCE(225);
      END_STATE();
    case 165:
      if (lookahead == 'n') ADVANCE(226);
      END_STATE();
    case 166:
      if (lookahead == 'e') ADVANCE(227);
      END_STATE();
    case 167:
      if (lookahead == 'l') ADVANCE(228);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 169:
      if (lookahead == 't') ADVANCE(229);
      END_STATE();
    case 170:
      if (lookahead == 'a') ADVANCE(230);
      END_STATE();
    case 171:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 172:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 173:
      if (lookahead == 'r') ADVANCE(233);
      END_STATE();
    case 174:
      if (lookahead == 'a') ADVANCE(234);
      END_STATE();
    case 175:
      if (lookahead == 'r') ADVANCE(235);
      END_STATE();
    case 176:
      if (lookahead == 'f') ADVANCE(236);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_list);
      END_STATE();
    case 178:
      if (lookahead == 'l') ADVANCE(237);
      END_STATE();
    case 179:
      if (lookahead == 's') ADVANCE(238);
      END_STATE();
    case 180:
      if (lookahead == 'r') ADVANCE(239);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(240);
      END_STATE();
    case 183:
      if (lookahead == 'c') ADVANCE(241);
      END_STATE();
    case 184:
      if (lookahead == 'r') ADVANCE(242);
      END_STATE();
    case 185:
      if (lookahead == 'm') ADVANCE(243);
      END_STATE();
    case 186:
      if (lookahead == 'a') ADVANCE(244);
      END_STATE();
    case 187:
      if (lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 188:
      if (lookahead == 'e') ADVANCE(246);
      END_STATE();
    case 189:
      if (lookahead == 'i') ADVANCE(247);
      END_STATE();
    case 190:
      if (lookahead == 'o') ADVANCE(248);
      END_STATE();
    case 191:
      if (lookahead == 'i') ADVANCE(249);
      END_STATE();
    case 192:
      if (lookahead == 'r') ADVANCE(250);
      END_STATE();
    case 193:
      if (lookahead == 'a') ADVANCE(251);
      END_STATE();
    case 194:
      if (lookahead == 'i') ADVANCE(252);
      END_STATE();
    case 195:
      if (lookahead == 'n') ADVANCE(253);
      END_STATE();
    case 196:
      if (lookahead == 'r') ADVANCE(254);
      END_STATE();
    case 197:
      if (lookahead == 'c') ADVANCE(255);
      END_STATE();
    case 198:
      if (lookahead == 'o') ADVANCE(256);
      END_STATE();
    case 199:
      if (lookahead == 'e') ADVANCE(257);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 201:
      if (lookahead == 'w') ADVANCE(258);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(259);
      END_STATE();
    case 204:
      if (lookahead == 'f') ADVANCE(260);
      END_STATE();
    case 205:
      if (lookahead == 'o') ADVANCE(261);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 207:
      if (lookahead == 'e') ADVANCE(262);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 209:
      if (lookahead == 'd') ADVANCE(263);
      END_STATE();
    case 210:
      if (lookahead == 'a') ADVANCE(264);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(265);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 214:
      if (lookahead == 'a') ADVANCE(266);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 218:
      if (lookahead == 'n') ADVANCE(267);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 220:
      if (lookahead == 'n') ADVANCE(268);
      END_STATE();
    case 221:
      if (lookahead == 'g') ADVANCE(269);
      END_STATE();
    case 222:
      if (lookahead == 'r') ADVANCE(270);
      END_STATE();
    case 223:
      if (lookahead == 'l') ADVANCE(271);
      END_STATE();
    case 224:
      if (lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 225:
      if (lookahead == 't') ADVANCE(273);
      END_STATE();
    case 226:
      if (lookahead == 'd') ADVANCE(274);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 228:
      if (lookahead == 'l') ADVANCE(275);
      END_STATE();
    case 229:
      if (lookahead == 'i') ADVANCE(276);
      END_STATE();
    case 230:
      if (lookahead == 'l') ADVANCE(277);
      END_STATE();
    case 231:
      if (lookahead == 'm') ADVANCE(278);
      END_STATE();
    case 232:
      if (lookahead == 't') ADVANCE(279);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_infer);
      END_STATE();
    case 234:
      if (lookahead == 'n') ADVANCE(280);
      END_STATE();
    case 235:
      if (lookahead == 'f') ADVANCE(281);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 237:
      if (lookahead == 'e') ADVANCE(282);
      END_STATE();
    case 238:
      if (lookahead == 'p') ADVANCE(283);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 240:
      if (lookahead == 'r') ADVANCE(284);
      END_STATE();
    case 241:
      if (lookahead == 't') ADVANCE(285);
      END_STATE();
    case 242:
      if (lookahead == 'i') ADVANCE(286);
      END_STATE();
    case 243:
      if (lookahead == 'a') ADVANCE(287);
      END_STATE();
    case 244:
      if (lookahead == 't') ADVANCE(288);
      END_STATE();
    case 245:
      if (lookahead == 'r') ADVANCE(289);
      END_STATE();
    case 246:
      if (lookahead == 'c') ADVANCE(290);
      END_STATE();
    case 247:
      if (lookahead == 'c') ADVANCE(291);
      END_STATE();
    case 248:
      if (lookahead == 'n') ADVANCE(292);
      END_STATE();
    case 249:
      if (lookahead == 'r') ADVANCE(293);
      END_STATE();
    case 250:
      if (lookahead == 'n') ADVANCE(294);
      END_STATE();
    case 251:
      if (lookahead == 'l') ADVANCE(295);
      END_STATE();
    case 252:
      if (lookahead == 'c') ADVANCE(296);
      END_STATE();
    case 253:
      if (lookahead == 'g') ADVANCE(297);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 255:
      if (lookahead == 'h') ADVANCE(298);
      END_STATE();
    case 256:
      if (lookahead == 'l') ADVANCE(299);
      END_STATE();
    case 257:
      if (lookahead == 't') ADVANCE(300);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 259:
      if (lookahead == 'f') ADVANCE(301);
      END_STATE();
    case 260:
      if (lookahead == 'i') ADVANCE(302);
      END_STATE();
    case 261:
      if (lookahead == 'w') ADVANCE(303);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 264:
      if (lookahead == 'c') ADVANCE(304);
      END_STATE();
    case 265:
      if (lookahead == 's') ADVANCE(305);
      END_STATE();
    case 266:
      if (lookahead == 'n') ADVANCE(306);
      END_STATE();
    case 267:
      if (lookahead == 'e') ADVANCE(307);
      END_STATE();
    case 268:
      if (lookahead == 'u') ADVANCE(308);
      END_STATE();
    case 269:
      if (lookahead == 'e') ADVANCE(309);
      END_STATE();
    case 270:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 271:
      if (lookahead == 't') ADVANCE(311);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 274:
      if (lookahead == 's') ADVANCE(312);
      END_STATE();
    case 275:
      if (lookahead == 'y') ADVANCE(313);
      END_STATE();
    case 276:
      if (lookahead == 'o') ADVANCE(314);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 278:
      if (lookahead == 'e') ADVANCE(315);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 280:
      if (lookahead == 'c') ADVANCE(316);
      END_STATE();
    case 281:
      if (lookahead == 'a') ADVANCE(317);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 283:
      if (lookahead == 'a') ADVANCE(318);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_object);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(319);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_pragma);
      END_STATE();
    case 288:
      if (lookahead == 'e') ADVANCE(320);
      END_STATE();
    case 289:
      if (lookahead == 't') ADVANCE(321);
      END_STATE();
    case 290:
      if (lookahead == 't') ADVANCE(322);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 292:
      if (lookahead == 'l') ADVANCE(323);
      END_STATE();
    case 293:
      if (lookahead == 'e') ADVANCE(324);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_signal);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 302:
      if (lookahead == 'n') ADVANCE(325);
      END_STATE();
    case 303:
      if (lookahead == 'n') ADVANCE(326);
      END_STATE();
    case 304:
      if (lookahead == 't') ADVANCE(327);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_asserts);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 307:
      if (lookahead == 'n') ADVANCE(328);
      END_STATE();
    case 308:
      if (lookahead == 'e') ADVANCE(329);
      END_STATE();
    case 309:
      if (lookahead == 'r') ADVANCE(330);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 314:
      if (lookahead == 'n') ADVANCE(331);
      END_STATE();
    case 315:
      if (lookahead == 'n') ADVANCE(332);
      END_STATE();
    case 316:
      if (lookahead == 'e') ADVANCE(333);
      END_STATE();
    case 317:
      if (lookahead == 'c') ADVANCE(334);
      END_STATE();
    case 318:
      if (lookahead == 'c') ADVANCE(335);
      END_STATE();
    case 319:
      if (lookahead == 'e') ADVANCE(336);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 321:
      if (lookahead == 'y') ADVANCE(337);
      END_STATE();
    case 322:
      if (lookahead == 'e') ADVANCE(338);
      END_STATE();
    case 323:
      if (lookahead == 'y') ADVANCE(339);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_require);
      if (lookahead == 'd') ADVANCE(340);
      END_STATE();
    case 325:
      if (lookahead == 'e') ADVANCE(341);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_unknown);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 328:
      if (lookahead == 't') ADVANCE(342);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 332:
      if (lookahead == 't') ADVANCE(343);
      END_STATE();
    case 333:
      if (lookahead == 'o') ADVANCE(344);
      END_STATE();
    case 334:
      if (lookahead == 'e') ADVANCE(345);
      END_STATE();
    case 335:
      if (lookahead == 'e') ADVANCE(346);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(anon_sym_property);
      END_STATE();
    case 338:
      if (lookahead == 'd') ADVANCE(347);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_required);
      END_STATE();
    case 341:
      if (lookahead == 'd') ADVANCE(348);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_component);
      END_STATE();
    case 343:
      if (lookahead == 's') ADVANCE(349);
      END_STATE();
    case 344:
      if (lookahead == 'f') ADVANCE(350);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 93},
  [2] = {.lex_state = 93, .external_lex_state = 2},
  [3] = {.lex_state = 93, .external_lex_state = 2},
  [4] = {.lex_state = 11},
  [5] = {.lex_state = 11},
  [6] = {.lex_state = 11},
  [7] = {.lex_state = 11},
  [8] = {.lex_state = 11},
  [9] = {.lex_state = 11},
  [10] = {.lex_state = 11},
  [11] = {.lex_state = 11},
  [12] = {.lex_state = 11},
  [13] = {.lex_state = 11},
  [14] = {.lex_state = 11},
  [15] = {.lex_state = 11},
  [16] = {.lex_state = 11},
  [17] = {.lex_state = 11},
  [18] = {.lex_state = 11},
  [19] = {.lex_state = 11},
  [20] = {.lex_state = 11},
  [21] = {.lex_state = 11},
  [22] = {.lex_state = 11},
  [23] = {.lex_state = 11},
  [24] = {.lex_state = 11},
  [25] = {.lex_state = 11},
  [26] = {.lex_state = 11},
  [27] = {.lex_state = 11},
  [28] = {.lex_state = 11},
  [29] = {.lex_state = 11},
  [30] = {.lex_state = 11},
  [31] = {.lex_state = 11},
  [32] = {.lex_state = 11},
  [33] = {.lex_state = 11},
  [34] = {.lex_state = 11},
  [35] = {.lex_state = 11},
  [36] = {.lex_state = 11},
  [37] = {.lex_state = 11},
  [38] = {.lex_state = 11},
  [39] = {.lex_state = 11},
  [40] = {.lex_state = 11},
  [41] = {.lex_state = 11},
  [42] = {.lex_state = 11},
  [43] = {.lex_state = 11},
  [44] = {.lex_state = 11},
  [45] = {.lex_state = 11},
  [46] = {.lex_state = 11},
  [47] = {.lex_state = 11},
  [48] = {.lex_state = 11},
  [49] = {.lex_state = 11},
  [50] = {.lex_state = 11},
  [51] = {.lex_state = 11},
  [52] = {.lex_state = 11},
  [53] = {.lex_state = 11},
  [54] = {.lex_state = 11},
  [55] = {.lex_state = 11},
  [56] = {.lex_state = 11},
  [57] = {.lex_state = 11},
  [58] = {.lex_state = 11},
  [59] = {.lex_state = 11},
  [60] = {.lex_state = 11},
  [61] = {.lex_state = 14},
  [62] = {.lex_state = 14},
  [63] = {.lex_state = 14},
  [64] = {.lex_state = 14},
  [65] = {.lex_state = 14},
  [66] = {.lex_state = 14},
  [67] = {.lex_state = 14},
  [68] = {.lex_state = 14},
  [69] = {.lex_state = 14},
  [70] = {.lex_state = 14},
  [71] = {.lex_state = 4, .external_lex_state = 2},
  [72] = {.lex_state = 4, .external_lex_state = 2},
  [73] = {.lex_state = 4, .external_lex_state = 2},
  [74] = {.lex_state = 4, .external_lex_state = 2},
  [75] = {.lex_state = 4, .external_lex_state = 2},
  [76] = {.lex_state = 4, .external_lex_state = 2},
  [77] = {.lex_state = 4, .external_lex_state = 2},
  [78] = {.lex_state = 4, .external_lex_state = 2},
  [79] = {.lex_state = 14},
  [80] = {.lex_state = 14},
  [81] = {.lex_state = 14},
  [82] = {.lex_state = 14},
  [83] = {.lex_state = 14},
  [84] = {.lex_state = 14},
  [85] = {.lex_state = 14},
  [86] = {.lex_state = 14},
  [87] = {.lex_state = 14},
  [88] = {.lex_state = 14},
  [89] = {.lex_state = 14},
  [90] = {.lex_state = 14},
  [91] = {.lex_state = 14},
  [92] = {.lex_state = 14},
  [93] = {.lex_state = 14},
  [94] = {.lex_state = 14},
  [95] = {.lex_state = 14},
  [96] = {.lex_state = 14},
  [97] = {.lex_state = 14},
  [98] = {.lex_state = 14},
  [99] = {.lex_state = 14},
  [100] = {.lex_state = 6, .external_lex_state = 2},
  [101] = {.lex_state = 6, .external_lex_state = 3},
  [102] = {.lex_state = 6, .external_lex_state = 3},
  [103] = {.lex_state = 6, .external_lex_state = 2},
  [104] = {.lex_state = 6, .external_lex_state = 3},
  [105] = {.lex_state = 6, .external_lex_state = 2},
  [106] = {.lex_state = 6, .external_lex_state = 2},
  [107] = {.lex_state = 6, .external_lex_state = 2},
  [108] = {.lex_state = 6, .external_lex_state = 2},
  [109] = {.lex_state = 11},
  [110] = {.lex_state = 11},
  [111] = {.lex_state = 11},
  [112] = {.lex_state = 11},
  [113] = {.lex_state = 11},
  [114] = {.lex_state = 11},
  [115] = {.lex_state = 11},
  [116] = {.lex_state = 11},
  [117] = {.lex_state = 11},
  [118] = {.lex_state = 11},
  [119] = {.lex_state = 11},
  [120] = {.lex_state = 11},
  [121] = {.lex_state = 11},
  [122] = {.lex_state = 11},
  [123] = {.lex_state = 11},
  [124] = {.lex_state = 11},
  [125] = {.lex_state = 11},
  [126] = {.lex_state = 11},
  [127] = {.lex_state = 11},
  [128] = {.lex_state = 11},
  [129] = {.lex_state = 11},
  [130] = {.lex_state = 3, .external_lex_state = 2},
  [131] = {.lex_state = 11},
  [132] = {.lex_state = 11},
  [133] = {.lex_state = 11},
  [134] = {.lex_state = 11},
  [135] = {.lex_state = 11},
  [136] = {.lex_state = 11},
  [137] = {.lex_state = 3, .external_lex_state = 3},
  [138] = {.lex_state = 11},
  [139] = {.lex_state = 11},
  [140] = {.lex_state = 3, .external_lex_state = 3},
  [141] = {.lex_state = 11},
  [142] = {.lex_state = 11},
  [143] = {.lex_state = 11},
  [144] = {.lex_state = 3, .external_lex_state = 2},
  [145] = {.lex_state = 11},
  [146] = {.lex_state = 11},
  [147] = {.lex_state = 6, .external_lex_state = 3},
  [148] = {.lex_state = 11},
  [149] = {.lex_state = 6, .external_lex_state = 3},
  [150] = {.lex_state = 11},
  [151] = {.lex_state = 6, .external_lex_state = 3},
  [152] = {.lex_state = 11},
  [153] = {.lex_state = 3, .external_lex_state = 2},
  [154] = {.lex_state = 11},
  [155] = {.lex_state = 11},
  [156] = {.lex_state = 11},
  [157] = {.lex_state = 11},
  [158] = {.lex_state = 11},
  [159] = {.lex_state = 11},
  [160] = {.lex_state = 11},
  [161] = {.lex_state = 6, .external_lex_state = 3},
  [162] = {.lex_state = 6, .external_lex_state = 3},
  [163] = {.lex_state = 6, .external_lex_state = 3},
  [164] = {.lex_state = 6, .external_lex_state = 3},
  [165] = {.lex_state = 3, .external_lex_state = 2},
  [166] = {.lex_state = 6, .external_lex_state = 3},
  [167] = {.lex_state = 6, .external_lex_state = 3},
  [168] = {.lex_state = 6, .external_lex_state = 3},
  [169] = {.lex_state = 6, .external_lex_state = 3},
  [170] = {.lex_state = 6, .external_lex_state = 3},
  [171] = {.lex_state = 6, .external_lex_state = 3},
  [172] = {.lex_state = 6, .external_lex_state = 3},
  [173] = {.lex_state = 6, .external_lex_state = 3},
  [174] = {.lex_state = 6, .external_lex_state = 3},
  [175] = {.lex_state = 6, .external_lex_state = 3},
  [176] = {.lex_state = 6, .external_lex_state = 3},
  [177] = {.lex_state = 6, .external_lex_state = 3},
  [178] = {.lex_state = 6, .external_lex_state = 3},
  [179] = {.lex_state = 11},
  [180] = {.lex_state = 3, .external_lex_state = 2},
  [181] = {.lex_state = 6, .external_lex_state = 3},
  [182] = {.lex_state = 6, .external_lex_state = 3},
  [183] = {.lex_state = 11, .external_lex_state = 4},
  [184] = {.lex_state = 6, .external_lex_state = 3},
  [185] = {.lex_state = 6, .external_lex_state = 3},
  [186] = {.lex_state = 6, .external_lex_state = 3},
  [187] = {.lex_state = 6, .external_lex_state = 3},
  [188] = {.lex_state = 3, .external_lex_state = 3},
  [189] = {.lex_state = 6, .external_lex_state = 3},
  [190] = {.lex_state = 3, .external_lex_state = 2},
  [191] = {.lex_state = 11},
  [192] = {.lex_state = 11},
  [193] = {.lex_state = 11},
  [194] = {.lex_state = 3, .external_lex_state = 2},
  [195] = {.lex_state = 3, .external_lex_state = 2},
  [196] = {.lex_state = 3, .external_lex_state = 2},
  [197] = {.lex_state = 11},
  [198] = {.lex_state = 11},
  [199] = {.lex_state = 11},
  [200] = {.lex_state = 11},
  [201] = {.lex_state = 3, .external_lex_state = 2},
  [202] = {.lex_state = 3, .external_lex_state = 2},
  [203] = {.lex_state = 11},
  [204] = {.lex_state = 11},
  [205] = {.lex_state = 4, .external_lex_state = 2},
  [206] = {.lex_state = 11},
  [207] = {.lex_state = 11},
  [208] = {.lex_state = 11},
  [209] = {.lex_state = 11},
  [210] = {.lex_state = 11},
  [211] = {.lex_state = 11},
  [212] = {.lex_state = 11},
  [213] = {.lex_state = 11},
  [214] = {.lex_state = 11},
  [215] = {.lex_state = 4, .external_lex_state = 2},
  [216] = {.lex_state = 11},
  [217] = {.lex_state = 11},
  [218] = {.lex_state = 11},
  [219] = {.lex_state = 11},
  [220] = {.lex_state = 4, .external_lex_state = 2},
  [221] = {.lex_state = 4, .external_lex_state = 2},
  [222] = {.lex_state = 11},
  [223] = {.lex_state = 11},
  [224] = {.lex_state = 11},
  [225] = {.lex_state = 11},
  [226] = {.lex_state = 11},
  [227] = {.lex_state = 11},
  [228] = {.lex_state = 11},
  [229] = {.lex_state = 11},
  [230] = {.lex_state = 11},
  [231] = {.lex_state = 11},
  [232] = {.lex_state = 11},
  [233] = {.lex_state = 11},
  [234] = {.lex_state = 11},
  [235] = {.lex_state = 11, .external_lex_state = 4},
  [236] = {.lex_state = 11},
  [237] = {.lex_state = 11},
  [238] = {.lex_state = 11},
  [239] = {.lex_state = 11},
  [240] = {.lex_state = 11},
  [241] = {.lex_state = 11, .external_lex_state = 4},
  [242] = {.lex_state = 11},
  [243] = {.lex_state = 11},
  [244] = {.lex_state = 11},
  [245] = {.lex_state = 11},
  [246] = {.lex_state = 11},
  [247] = {.lex_state = 11},
  [248] = {.lex_state = 11},
  [249] = {.lex_state = 11},
  [250] = {.lex_state = 11},
  [251] = {.lex_state = 11},
  [252] = {.lex_state = 11},
  [253] = {.lex_state = 11},
  [254] = {.lex_state = 11},
  [255] = {.lex_state = 11},
  [256] = {.lex_state = 11},
  [257] = {.lex_state = 11},
  [258] = {.lex_state = 11},
  [259] = {.lex_state = 11},
  [260] = {.lex_state = 11},
  [261] = {.lex_state = 11},
  [262] = {.lex_state = 11},
  [263] = {.lex_state = 11},
  [264] = {.lex_state = 11},
  [265] = {.lex_state = 11},
  [266] = {.lex_state = 11},
  [267] = {.lex_state = 11},
  [268] = {.lex_state = 11},
  [269] = {.lex_state = 11},
  [270] = {.lex_state = 11},
  [271] = {.lex_state = 11},
  [272] = {.lex_state = 11},
  [273] = {.lex_state = 11},
  [274] = {.lex_state = 11},
  [275] = {.lex_state = 11},
  [276] = {.lex_state = 11},
  [277] = {.lex_state = 11},
  [278] = {.lex_state = 11},
  [279] = {.lex_state = 11},
  [280] = {.lex_state = 11},
  [281] = {.lex_state = 11},
  [282] = {.lex_state = 11},
  [283] = {.lex_state = 11},
  [284] = {.lex_state = 11},
  [285] = {.lex_state = 11},
  [286] = {.lex_state = 11},
  [287] = {.lex_state = 11},
  [288] = {.lex_state = 11},
  [289] = {.lex_state = 11},
  [290] = {.lex_state = 11},
  [291] = {.lex_state = 11},
  [292] = {.lex_state = 11},
  [293] = {.lex_state = 11},
  [294] = {.lex_state = 11},
  [295] = {.lex_state = 11},
  [296] = {.lex_state = 11},
  [297] = {.lex_state = 11},
  [298] = {.lex_state = 11},
  [299] = {.lex_state = 11},
  [300] = {.lex_state = 11},
  [301] = {.lex_state = 11},
  [302] = {.lex_state = 11},
  [303] = {.lex_state = 11},
  [304] = {.lex_state = 11},
  [305] = {.lex_state = 11},
  [306] = {.lex_state = 11},
  [307] = {.lex_state = 11},
  [308] = {.lex_state = 11},
  [309] = {.lex_state = 11},
  [310] = {.lex_state = 11},
  [311] = {.lex_state = 11},
  [312] = {.lex_state = 11},
  [313] = {.lex_state = 11},
  [314] = {.lex_state = 11},
  [315] = {.lex_state = 11},
  [316] = {.lex_state = 11},
  [317] = {.lex_state = 11},
  [318] = {.lex_state = 11},
  [319] = {.lex_state = 11},
  [320] = {.lex_state = 11},
  [321] = {.lex_state = 11},
  [322] = {.lex_state = 11},
  [323] = {.lex_state = 11},
  [324] = {.lex_state = 11},
  [325] = {.lex_state = 11},
  [326] = {.lex_state = 11},
  [327] = {.lex_state = 11},
  [328] = {.lex_state = 11},
  [329] = {.lex_state = 11},
  [330] = {.lex_state = 11},
  [331] = {.lex_state = 11},
  [332] = {.lex_state = 11},
  [333] = {.lex_state = 11},
  [334] = {.lex_state = 11},
  [335] = {.lex_state = 11},
  [336] = {.lex_state = 11},
  [337] = {.lex_state = 11},
  [338] = {.lex_state = 11},
  [339] = {.lex_state = 11},
  [340] = {.lex_state = 11},
  [341] = {.lex_state = 11},
  [342] = {.lex_state = 11},
  [343] = {.lex_state = 11},
  [344] = {.lex_state = 11},
  [345] = {.lex_state = 11},
  [346] = {.lex_state = 11},
  [347] = {.lex_state = 11},
  [348] = {.lex_state = 11},
  [349] = {.lex_state = 11},
  [350] = {.lex_state = 11},
  [351] = {.lex_state = 11},
  [352] = {.lex_state = 11},
  [353] = {.lex_state = 11},
  [354] = {.lex_state = 11},
  [355] = {.lex_state = 11},
  [356] = {.lex_state = 11},
  [357] = {.lex_state = 11},
  [358] = {.lex_state = 11},
  [359] = {.lex_state = 11},
  [360] = {.lex_state = 11},
  [361] = {.lex_state = 11},
  [362] = {.lex_state = 11},
  [363] = {.lex_state = 11},
  [364] = {.lex_state = 11},
  [365] = {.lex_state = 11},
  [366] = {.lex_state = 11},
  [367] = {.lex_state = 11},
  [368] = {.lex_state = 11},
  [369] = {.lex_state = 11},
  [370] = {.lex_state = 11},
  [371] = {.lex_state = 11},
  [372] = {.lex_state = 11},
  [373] = {.lex_state = 11},
  [374] = {.lex_state = 11},
  [375] = {.lex_state = 11},
  [376] = {.lex_state = 11},
  [377] = {.lex_state = 11},
  [378] = {.lex_state = 11},
  [379] = {.lex_state = 11},
  [380] = {.lex_state = 11},
  [381] = {.lex_state = 11},
  [382] = {.lex_state = 11},
  [383] = {.lex_state = 11},
  [384] = {.lex_state = 11},
  [385] = {.lex_state = 11},
  [386] = {.lex_state = 11},
  [387] = {.lex_state = 11},
  [388] = {.lex_state = 11},
  [389] = {.lex_state = 11},
  [390] = {.lex_state = 11},
  [391] = {.lex_state = 11},
  [392] = {.lex_state = 11},
  [393] = {.lex_state = 11},
  [394] = {.lex_state = 11},
  [395] = {.lex_state = 11},
  [396] = {.lex_state = 11},
  [397] = {.lex_state = 11},
  [398] = {.lex_state = 11},
  [399] = {.lex_state = 11},
  [400] = {.lex_state = 11},
  [401] = {.lex_state = 11},
  [402] = {.lex_state = 11},
  [403] = {.lex_state = 11},
  [404] = {.lex_state = 11},
  [405] = {.lex_state = 11},
  [406] = {.lex_state = 11},
  [407] = {.lex_state = 11},
  [408] = {.lex_state = 11},
  [409] = {.lex_state = 11},
  [410] = {.lex_state = 11},
  [411] = {.lex_state = 11},
  [412] = {.lex_state = 11},
  [413] = {.lex_state = 11},
  [414] = {.lex_state = 11},
  [415] = {.lex_state = 11},
  [416] = {.lex_state = 11},
  [417] = {.lex_state = 11},
  [418] = {.lex_state = 11},
  [419] = {.lex_state = 11},
  [420] = {.lex_state = 11},
  [421] = {.lex_state = 11},
  [422] = {.lex_state = 11},
  [423] = {.lex_state = 11},
  [424] = {.lex_state = 11},
  [425] = {.lex_state = 11},
  [426] = {.lex_state = 11},
  [427] = {.lex_state = 11},
  [428] = {.lex_state = 11},
  [429] = {.lex_state = 11},
  [430] = {.lex_state = 11},
  [431] = {.lex_state = 11},
  [432] = {.lex_state = 11},
  [433] = {.lex_state = 11},
  [434] = {.lex_state = 11},
  [435] = {.lex_state = 11},
  [436] = {.lex_state = 11},
  [437] = {.lex_state = 11},
  [438] = {.lex_state = 11},
  [439] = {.lex_state = 11},
  [440] = {.lex_state = 11},
  [441] = {.lex_state = 11},
  [442] = {.lex_state = 11},
  [443] = {.lex_state = 11},
  [444] = {.lex_state = 11},
  [445] = {.lex_state = 11},
  [446] = {.lex_state = 11},
  [447] = {.lex_state = 11},
  [448] = {.lex_state = 11},
  [449] = {.lex_state = 11},
  [450] = {.lex_state = 11},
  [451] = {.lex_state = 11},
  [452] = {.lex_state = 11},
  [453] = {.lex_state = 11},
  [454] = {.lex_state = 11},
  [455] = {.lex_state = 11},
  [456] = {.lex_state = 11},
  [457] = {.lex_state = 11},
  [458] = {.lex_state = 11},
  [459] = {.lex_state = 11},
  [460] = {.lex_state = 11},
  [461] = {.lex_state = 11},
  [462] = {.lex_state = 11},
  [463] = {.lex_state = 11},
  [464] = {.lex_state = 11},
  [465] = {.lex_state = 11},
  [466] = {.lex_state = 11},
  [467] = {.lex_state = 11},
  [468] = {.lex_state = 11},
  [469] = {.lex_state = 11},
  [470] = {.lex_state = 11},
  [471] = {.lex_state = 11},
  [472] = {.lex_state = 11},
  [473] = {.lex_state = 11},
  [474] = {.lex_state = 11},
  [475] = {.lex_state = 11},
  [476] = {.lex_state = 11},
  [477] = {.lex_state = 11},
  [478] = {.lex_state = 11},
  [479] = {.lex_state = 11},
  [480] = {.lex_state = 11},
  [481] = {.lex_state = 11},
  [482] = {.lex_state = 11},
  [483] = {.lex_state = 11},
  [484] = {.lex_state = 11},
  [485] = {.lex_state = 11},
  [486] = {.lex_state = 11},
  [487] = {.lex_state = 11},
  [488] = {.lex_state = 11},
  [489] = {.lex_state = 11},
  [490] = {.lex_state = 11},
  [491] = {.lex_state = 11},
  [492] = {.lex_state = 11},
  [493] = {.lex_state = 11},
  [494] = {.lex_state = 11},
  [495] = {.lex_state = 11},
  [496] = {.lex_state = 11},
  [497] = {.lex_state = 11},
  [498] = {.lex_state = 11},
  [499] = {.lex_state = 11},
  [500] = {.lex_state = 11},
  [501] = {.lex_state = 11},
  [502] = {.lex_state = 11},
  [503] = {.lex_state = 11},
  [504] = {.lex_state = 11},
  [505] = {.lex_state = 11},
  [506] = {.lex_state = 11},
  [507] = {.lex_state = 11},
  [508] = {.lex_state = 11},
  [509] = {.lex_state = 11},
  [510] = {.lex_state = 11},
  [511] = {.lex_state = 11},
  [512] = {.lex_state = 11},
  [513] = {.lex_state = 11},
  [514] = {.lex_state = 11},
  [515] = {.lex_state = 11},
  [516] = {.lex_state = 11},
  [517] = {.lex_state = 11},
  [518] = {.lex_state = 11},
  [519] = {.lex_state = 11},
  [520] = {.lex_state = 11},
  [521] = {.lex_state = 11},
  [522] = {.lex_state = 11},
  [523] = {.lex_state = 11},
  [524] = {.lex_state = 11},
  [525] = {.lex_state = 11},
  [526] = {.lex_state = 11},
  [527] = {.lex_state = 11},
  [528] = {.lex_state = 11},
  [529] = {.lex_state = 11},
  [530] = {.lex_state = 11},
  [531] = {.lex_state = 11},
  [532] = {.lex_state = 11},
  [533] = {.lex_state = 11},
  [534] = {.lex_state = 11},
  [535] = {.lex_state = 11},
  [536] = {.lex_state = 11},
  [537] = {.lex_state = 11},
  [538] = {.lex_state = 11},
  [539] = {.lex_state = 11},
  [540] = {.lex_state = 11},
  [541] = {.lex_state = 11},
  [542] = {.lex_state = 11},
  [543] = {.lex_state = 11},
  [544] = {.lex_state = 11},
  [545] = {.lex_state = 11},
  [546] = {.lex_state = 11},
  [547] = {.lex_state = 11},
  [548] = {.lex_state = 11},
  [549] = {.lex_state = 11},
  [550] = {.lex_state = 11},
  [551] = {.lex_state = 11},
  [552] = {.lex_state = 11},
  [553] = {.lex_state = 11},
  [554] = {.lex_state = 11},
  [555] = {.lex_state = 11},
  [556] = {.lex_state = 11},
  [557] = {.lex_state = 11},
  [558] = {.lex_state = 11},
  [559] = {.lex_state = 11},
  [560] = {.lex_state = 11},
  [561] = {.lex_state = 11},
  [562] = {.lex_state = 11},
  [563] = {.lex_state = 11},
  [564] = {.lex_state = 11},
  [565] = {.lex_state = 11},
  [566] = {.lex_state = 11},
  [567] = {.lex_state = 11},
  [568] = {.lex_state = 11},
  [569] = {.lex_state = 11},
  [570] = {.lex_state = 11},
  [571] = {.lex_state = 11},
  [572] = {.lex_state = 11},
  [573] = {.lex_state = 11},
  [574] = {.lex_state = 11},
  [575] = {.lex_state = 11},
  [576] = {.lex_state = 11},
  [577] = {.lex_state = 11},
  [578] = {.lex_state = 11},
  [579] = {.lex_state = 11},
  [580] = {.lex_state = 11},
  [581] = {.lex_state = 11},
  [582] = {.lex_state = 11},
  [583] = {.lex_state = 11},
  [584] = {.lex_state = 11},
  [585] = {.lex_state = 11},
  [586] = {.lex_state = 11},
  [587] = {.lex_state = 3, .external_lex_state = 3},
  [588] = {.lex_state = 3, .external_lex_state = 3},
  [589] = {.lex_state = 3, .external_lex_state = 3},
  [590] = {.lex_state = 3, .external_lex_state = 3},
  [591] = {.lex_state = 5, .external_lex_state = 3},
  [592] = {.lex_state = 5, .external_lex_state = 3},
  [593] = {.lex_state = 5, .external_lex_state = 3},
  [594] = {.lex_state = 5, .external_lex_state = 3},
  [595] = {.lex_state = 3, .external_lex_state = 3},
  [596] = {.lex_state = 3, .external_lex_state = 3},
  [597] = {.lex_state = 3, .external_lex_state = 3},
  [598] = {.lex_state = 3, .external_lex_state = 3},
  [599] = {.lex_state = 3, .external_lex_state = 3},
  [600] = {.lex_state = 3, .external_lex_state = 3},
  [601] = {.lex_state = 3, .external_lex_state = 3},
  [602] = {.lex_state = 3, .external_lex_state = 3},
  [603] = {.lex_state = 3, .external_lex_state = 3},
  [604] = {.lex_state = 3, .external_lex_state = 3},
  [605] = {.lex_state = 3, .external_lex_state = 3},
  [606] = {.lex_state = 3, .external_lex_state = 3},
  [607] = {.lex_state = 5, .external_lex_state = 3},
  [608] = {.lex_state = 11},
  [609] = {.lex_state = 11},
  [610] = {.lex_state = 11},
  [611] = {.lex_state = 5, .external_lex_state = 3},
  [612] = {.lex_state = 11},
  [613] = {.lex_state = 11},
  [614] = {.lex_state = 5, .external_lex_state = 3},
  [615] = {.lex_state = 5, .external_lex_state = 3},
  [616] = {.lex_state = 5, .external_lex_state = 3},
  [617] = {.lex_state = 5, .external_lex_state = 3},
  [618] = {.lex_state = 5, .external_lex_state = 3},
  [619] = {.lex_state = 3, .external_lex_state = 3},
  [620] = {.lex_state = 3, .external_lex_state = 3},
  [621] = {.lex_state = 3, .external_lex_state = 3},
  [622] = {.lex_state = 3, .external_lex_state = 3},
  [623] = {.lex_state = 3, .external_lex_state = 3},
  [624] = {.lex_state = 3, .external_lex_state = 3},
  [625] = {.lex_state = 3, .external_lex_state = 3},
  [626] = {.lex_state = 3, .external_lex_state = 3},
  [627] = {.lex_state = 5, .external_lex_state = 3},
  [628] = {.lex_state = 5, .external_lex_state = 3},
  [629] = {.lex_state = 5, .external_lex_state = 3},
  [630] = {.lex_state = 5, .external_lex_state = 2},
  [631] = {.lex_state = 5, .external_lex_state = 2},
  [632] = {.lex_state = 5, .external_lex_state = 2},
  [633] = {.lex_state = 5, .external_lex_state = 2},
  [634] = {.lex_state = 5, .external_lex_state = 3},
  [635] = {.lex_state = 5, .external_lex_state = 2},
  [636] = {.lex_state = 5, .external_lex_state = 3},
  [637] = {.lex_state = 5, .external_lex_state = 3},
  [638] = {.lex_state = 5, .external_lex_state = 3},
  [639] = {.lex_state = 5, .external_lex_state = 3},
  [640] = {.lex_state = 5, .external_lex_state = 2},
  [641] = {.lex_state = 5, .external_lex_state = 3},
  [642] = {.lex_state = 5, .external_lex_state = 3},
  [643] = {.lex_state = 5, .external_lex_state = 3},
  [644] = {.lex_state = 5, .external_lex_state = 3},
  [645] = {.lex_state = 5, .external_lex_state = 2},
  [646] = {.lex_state = 5, .external_lex_state = 3},
  [647] = {.lex_state = 5, .external_lex_state = 3},
  [648] = {.lex_state = 5, .external_lex_state = 3},
  [649] = {.lex_state = 5, .external_lex_state = 2},
  [650] = {.lex_state = 5, .external_lex_state = 3},
  [651] = {.lex_state = 11},
  [652] = {.lex_state = 5, .external_lex_state = 2},
  [653] = {.lex_state = 5, .external_lex_state = 3},
  [654] = {.lex_state = 5, .external_lex_state = 2},
  [655] = {.lex_state = 5, .external_lex_state = 2},
  [656] = {.lex_state = 5, .external_lex_state = 3},
  [657] = {.lex_state = 5, .external_lex_state = 3},
  [658] = {.lex_state = 5, .external_lex_state = 3},
  [659] = {.lex_state = 11, .external_lex_state = 4},
  [660] = {.lex_state = 11, .external_lex_state = 4},
  [661] = {.lex_state = 5, .external_lex_state = 2},
  [662] = {.lex_state = 5, .external_lex_state = 3},
  [663] = {.lex_state = 5, .external_lex_state = 2},
  [664] = {.lex_state = 11, .external_lex_state = 4},
  [665] = {.lex_state = 11, .external_lex_state = 4},
  [666] = {.lex_state = 5, .external_lex_state = 3},
  [667] = {.lex_state = 5, .external_lex_state = 3},
  [668] = {.lex_state = 5, .external_lex_state = 2},
  [669] = {.lex_state = 5, .external_lex_state = 2},
  [670] = {.lex_state = 5, .external_lex_state = 2},
  [671] = {.lex_state = 11},
  [672] = {.lex_state = 11},
  [673] = {.lex_state = 5, .external_lex_state = 2},
  [674] = {.lex_state = 11},
  [675] = {.lex_state = 11},
  [676] = {.lex_state = 11, .external_lex_state = 4},
  [677] = {.lex_state = 11, .external_lex_state = 4},
  [678] = {.lex_state = 11},
  [679] = {.lex_state = 11},
  [680] = {.lex_state = 11, .external_lex_state = 4},
  [681] = {.lex_state = 11},
  [682] = {.lex_state = 11},
  [683] = {.lex_state = 11, .external_lex_state = 4},
  [684] = {.lex_state = 11, .external_lex_state = 4},
  [685] = {.lex_state = 11, .external_lex_state = 4},
  [686] = {.lex_state = 11},
  [687] = {.lex_state = 11, .external_lex_state = 4},
  [688] = {.lex_state = 11, .external_lex_state = 4},
  [689] = {.lex_state = 11, .external_lex_state = 4},
  [690] = {.lex_state = 11, .external_lex_state = 4},
  [691] = {.lex_state = 11, .external_lex_state = 4},
  [692] = {.lex_state = 11, .external_lex_state = 4},
  [693] = {.lex_state = 5, .external_lex_state = 2},
  [694] = {.lex_state = 5, .external_lex_state = 2},
  [695] = {.lex_state = 11},
  [696] = {.lex_state = 11},
  [697] = {.lex_state = 5, .external_lex_state = 2},
  [698] = {.lex_state = 5, .external_lex_state = 2},
  [699] = {.lex_state = 11, .external_lex_state = 4},
  [700] = {.lex_state = 11, .external_lex_state = 4},
  [701] = {.lex_state = 11, .external_lex_state = 4},
  [702] = {.lex_state = 11, .external_lex_state = 4},
  [703] = {.lex_state = 11},
  [704] = {.lex_state = 11},
  [705] = {.lex_state = 11},
  [706] = {.lex_state = 11},
  [707] = {.lex_state = 11},
  [708] = {.lex_state = 11},
  [709] = {.lex_state = 11},
  [710] = {.lex_state = 11},
  [711] = {.lex_state = 11},
  [712] = {.lex_state = 11},
  [713] = {.lex_state = 11},
  [714] = {.lex_state = 11},
  [715] = {.lex_state = 11},
  [716] = {.lex_state = 11},
  [717] = {.lex_state = 11},
  [718] = {.lex_state = 11},
  [719] = {.lex_state = 11},
  [720] = {.lex_state = 11},
  [721] = {.lex_state = 11},
  [722] = {.lex_state = 11},
  [723] = {.lex_state = 11},
  [724] = {.lex_state = 11},
  [725] = {.lex_state = 11},
  [726] = {.lex_state = 11},
  [727] = {.lex_state = 11},
  [728] = {.lex_state = 11},
  [729] = {.lex_state = 11},
  [730] = {.lex_state = 11},
  [731] = {.lex_state = 11},
  [732] = {.lex_state = 11},
  [733] = {.lex_state = 11},
  [734] = {.lex_state = 11},
  [735] = {.lex_state = 11},
  [736] = {.lex_state = 11},
  [737] = {.lex_state = 11},
  [738] = {.lex_state = 11},
  [739] = {.lex_state = 11},
  [740] = {.lex_state = 11},
  [741] = {.lex_state = 11},
  [742] = {.lex_state = 11},
  [743] = {.lex_state = 11},
  [744] = {.lex_state = 11},
  [745] = {.lex_state = 11},
  [746] = {.lex_state = 11},
  [747] = {.lex_state = 11},
  [748] = {.lex_state = 11},
  [749] = {.lex_state = 11},
  [750] = {.lex_state = 11},
  [751] = {.lex_state = 11},
  [752] = {.lex_state = 11},
  [753] = {.lex_state = 11},
  [754] = {.lex_state = 11},
  [755] = {.lex_state = 11},
  [756] = {.lex_state = 11},
  [757] = {.lex_state = 11},
  [758] = {.lex_state = 11},
  [759] = {.lex_state = 11},
  [760] = {.lex_state = 11},
  [761] = {.lex_state = 11},
  [762] = {.lex_state = 11},
  [763] = {.lex_state = 11},
  [764] = {.lex_state = 11},
  [765] = {.lex_state = 11},
  [766] = {.lex_state = 11},
  [767] = {.lex_state = 11},
  [768] = {.lex_state = 11},
  [769] = {.lex_state = 11},
  [770] = {.lex_state = 11},
  [771] = {.lex_state = 11},
  [772] = {.lex_state = 11},
  [773] = {.lex_state = 11},
  [774] = {.lex_state = 11},
  [775] = {.lex_state = 11},
  [776] = {.lex_state = 11},
  [777] = {.lex_state = 11},
  [778] = {.lex_state = 11},
  [779] = {.lex_state = 11},
  [780] = {.lex_state = 11},
  [781] = {.lex_state = 11},
  [782] = {.lex_state = 11},
  [783] = {.lex_state = 11},
  [784] = {.lex_state = 11},
  [785] = {.lex_state = 11},
  [786] = {.lex_state = 11},
  [787] = {.lex_state = 11},
  [788] = {.lex_state = 11},
  [789] = {.lex_state = 11},
  [790] = {.lex_state = 11},
  [791] = {.lex_state = 11},
  [792] = {.lex_state = 11},
  [793] = {.lex_state = 11},
  [794] = {.lex_state = 11},
  [795] = {.lex_state = 11},
  [796] = {.lex_state = 11},
  [797] = {.lex_state = 11},
  [798] = {.lex_state = 11},
  [799] = {.lex_state = 11},
  [800] = {.lex_state = 11},
  [801] = {.lex_state = 11},
  [802] = {.lex_state = 11},
  [803] = {.lex_state = 11},
  [804] = {.lex_state = 11},
  [805] = {.lex_state = 11},
  [806] = {.lex_state = 11},
  [807] = {.lex_state = 11},
  [808] = {.lex_state = 11},
  [809] = {.lex_state = 11},
  [810] = {.lex_state = 11},
  [811] = {.lex_state = 11},
  [812] = {.lex_state = 11},
  [813] = {.lex_state = 11},
  [814] = {.lex_state = 11},
  [815] = {.lex_state = 11},
  [816] = {.lex_state = 11},
  [817] = {.lex_state = 11},
  [818] = {.lex_state = 11},
  [819] = {.lex_state = 11},
  [820] = {.lex_state = 11},
  [821] = {.lex_state = 11},
  [822] = {.lex_state = 11},
  [823] = {.lex_state = 11},
  [824] = {.lex_state = 11},
  [825] = {.lex_state = 11},
  [826] = {.lex_state = 11},
  [827] = {.lex_state = 11},
  [828] = {.lex_state = 11},
  [829] = {.lex_state = 11},
  [830] = {.lex_state = 11},
  [831] = {.lex_state = 11},
  [832] = {.lex_state = 11},
  [833] = {.lex_state = 11},
  [834] = {.lex_state = 11},
  [835] = {.lex_state = 11},
  [836] = {.lex_state = 11},
  [837] = {.lex_state = 11},
  [838] = {.lex_state = 11},
  [839] = {.lex_state = 11},
  [840] = {.lex_state = 11},
  [841] = {.lex_state = 11},
  [842] = {.lex_state = 11},
  [843] = {.lex_state = 11},
  [844] = {.lex_state = 11},
  [845] = {.lex_state = 11},
  [846] = {.lex_state = 11},
  [847] = {.lex_state = 11},
  [848] = {.lex_state = 11},
  [849] = {.lex_state = 11},
  [850] = {.lex_state = 11},
  [851] = {.lex_state = 11},
  [852] = {.lex_state = 11},
  [853] = {.lex_state = 11},
  [854] = {.lex_state = 11},
  [855] = {.lex_state = 11},
  [856] = {.lex_state = 11},
  [857] = {.lex_state = 11},
  [858] = {.lex_state = 11},
  [859] = {.lex_state = 11},
  [860] = {.lex_state = 11},
  [861] = {.lex_state = 11},
  [862] = {.lex_state = 11},
  [863] = {.lex_state = 11},
  [864] = {.lex_state = 11},
  [865] = {.lex_state = 7, .external_lex_state = 3},
  [866] = {.lex_state = 7, .external_lex_state = 3},
  [867] = {.lex_state = 12},
  [868] = {.lex_state = 12},
  [869] = {.lex_state = 7, .external_lex_state = 3},
  [870] = {.lex_state = 12},
  [871] = {.lex_state = 12},
  [872] = {.lex_state = 12},
  [873] = {.lex_state = 7, .external_lex_state = 3},
  [874] = {.lex_state = 7, .external_lex_state = 3},
  [875] = {.lex_state = 7, .external_lex_state = 3},
  [876] = {.lex_state = 7, .external_lex_state = 3},
  [877] = {.lex_state = 7, .external_lex_state = 3},
  [878] = {.lex_state = 7, .external_lex_state = 3},
  [879] = {.lex_state = 7, .external_lex_state = 3},
  [880] = {.lex_state = 7, .external_lex_state = 3},
  [881] = {.lex_state = 7, .external_lex_state = 3},
  [882] = {.lex_state = 7, .external_lex_state = 3},
  [883] = {.lex_state = 11},
  [884] = {.lex_state = 16},
  [885] = {.lex_state = 16},
  [886] = {.lex_state = 16},
  [887] = {.lex_state = 12},
  [888] = {.lex_state = 16},
  [889] = {.lex_state = 12},
  [890] = {.lex_state = 12},
  [891] = {.lex_state = 7, .external_lex_state = 3},
  [892] = {.lex_state = 16},
  [893] = {.lex_state = 16},
  [894] = {.lex_state = 12},
  [895] = {.lex_state = 16},
  [896] = {.lex_state = 7, .external_lex_state = 3},
  [897] = {.lex_state = 16},
  [898] = {.lex_state = 7, .external_lex_state = 3},
  [899] = {.lex_state = 11},
  [900] = {.lex_state = 7, .external_lex_state = 3},
  [901] = {.lex_state = 16},
  [902] = {.lex_state = 7, .external_lex_state = 3},
  [903] = {.lex_state = 16},
  [904] = {.lex_state = 7, .external_lex_state = 3},
  [905] = {.lex_state = 7, .external_lex_state = 3},
  [906] = {.lex_state = 16},
  [907] = {.lex_state = 11},
  [908] = {.lex_state = 7, .external_lex_state = 3},
  [909] = {.lex_state = 7, .external_lex_state = 3},
  [910] = {.lex_state = 7, .external_lex_state = 3},
  [911] = {.lex_state = 7, .external_lex_state = 3},
  [912] = {.lex_state = 12},
  [913] = {.lex_state = 12},
  [914] = {.lex_state = 12},
  [915] = {.lex_state = 16},
  [916] = {.lex_state = 7, .external_lex_state = 3},
  [917] = {.lex_state = 7, .external_lex_state = 3},
  [918] = {.lex_state = 12},
  [919] = {.lex_state = 12},
  [920] = {.lex_state = 16},
  [921] = {.lex_state = 7, .external_lex_state = 3},
  [922] = {.lex_state = 12},
  [923] = {.lex_state = 12},
  [924] = {.lex_state = 16},
  [925] = {.lex_state = 16},
  [926] = {.lex_state = 5, .external_lex_state = 3},
  [927] = {.lex_state = 12},
  [928] = {.lex_state = 5, .external_lex_state = 3},
  [929] = {.lex_state = 5, .external_lex_state = 3},
  [930] = {.lex_state = 5, .external_lex_state = 3},
  [931] = {.lex_state = 5, .external_lex_state = 3},
  [932] = {.lex_state = 5, .external_lex_state = 3},
  [933] = {.lex_state = 5, .external_lex_state = 3},
  [934] = {.lex_state = 12},
  [935] = {.lex_state = 12},
  [936] = {.lex_state = 5, .external_lex_state = 3},
  [937] = {.lex_state = 12},
  [938] = {.lex_state = 12},
  [939] = {.lex_state = 12},
  [940] = {.lex_state = 12},
  [941] = {.lex_state = 12},
  [942] = {.lex_state = 12},
  [943] = {.lex_state = 12},
  [944] = {.lex_state = 12},
  [945] = {.lex_state = 12},
  [946] = {.lex_state = 12},
  [947] = {.lex_state = 12},
  [948] = {.lex_state = 12},
  [949] = {.lex_state = 12},
  [950] = {.lex_state = 12},
  [951] = {.lex_state = 12},
  [952] = {.lex_state = 12},
  [953] = {.lex_state = 12},
  [954] = {.lex_state = 12},
  [955] = {.lex_state = 12},
  [956] = {.lex_state = 12},
  [957] = {.lex_state = 12},
  [958] = {.lex_state = 12},
  [959] = {.lex_state = 12},
  [960] = {.lex_state = 12},
  [961] = {.lex_state = 12},
  [962] = {.lex_state = 12},
  [963] = {.lex_state = 12},
  [964] = {.lex_state = 12},
  [965] = {.lex_state = 12},
  [966] = {.lex_state = 12},
  [967] = {.lex_state = 12},
  [968] = {.lex_state = 12},
  [969] = {.lex_state = 12},
  [970] = {.lex_state = 12},
  [971] = {.lex_state = 12},
  [972] = {.lex_state = 12},
  [973] = {.lex_state = 12},
  [974] = {.lex_state = 12},
  [975] = {.lex_state = 12},
  [976] = {.lex_state = 12},
  [977] = {.lex_state = 12},
  [978] = {.lex_state = 12},
  [979] = {.lex_state = 12},
  [980] = {.lex_state = 12},
  [981] = {.lex_state = 12},
  [982] = {.lex_state = 12},
  [983] = {.lex_state = 12},
  [984] = {.lex_state = 12},
  [985] = {.lex_state = 12},
  [986] = {.lex_state = 12},
  [987] = {.lex_state = 12},
  [988] = {.lex_state = 12},
  [989] = {.lex_state = 12},
  [990] = {.lex_state = 12},
  [991] = {.lex_state = 12},
  [992] = {.lex_state = 12},
  [993] = {.lex_state = 12},
  [994] = {.lex_state = 12},
  [995] = {.lex_state = 12},
  [996] = {.lex_state = 12},
  [997] = {.lex_state = 12},
  [998] = {.lex_state = 12},
  [999] = {.lex_state = 12},
  [1000] = {.lex_state = 12},
  [1001] = {.lex_state = 12},
  [1002] = {.lex_state = 5, .external_lex_state = 2},
  [1003] = {.lex_state = 12},
  [1004] = {.lex_state = 12},
  [1005] = {.lex_state = 12},
  [1006] = {.lex_state = 12},
  [1007] = {.lex_state = 12},
  [1008] = {.lex_state = 12},
  [1009] = {.lex_state = 12},
  [1010] = {.lex_state = 12},
  [1011] = {.lex_state = 12},
  [1012] = {.lex_state = 12},
  [1013] = {.lex_state = 12},
  [1014] = {.lex_state = 12},
  [1015] = {.lex_state = 12},
  [1016] = {.lex_state = 12},
  [1017] = {.lex_state = 12},
  [1018] = {.lex_state = 12},
  [1019] = {.lex_state = 12},
  [1020] = {.lex_state = 12},
  [1021] = {.lex_state = 12},
  [1022] = {.lex_state = 12},
  [1023] = {.lex_state = 12},
  [1024] = {.lex_state = 12},
  [1025] = {.lex_state = 12},
  [1026] = {.lex_state = 12},
  [1027] = {.lex_state = 12},
  [1028] = {.lex_state = 12},
  [1029] = {.lex_state = 12},
  [1030] = {.lex_state = 12},
  [1031] = {.lex_state = 12},
  [1032] = {.lex_state = 5, .external_lex_state = 2},
  [1033] = {.lex_state = 12},
  [1034] = {.lex_state = 12},
  [1035] = {.lex_state = 12},
  [1036] = {.lex_state = 12},
  [1037] = {.lex_state = 12},
  [1038] = {.lex_state = 12},
  [1039] = {.lex_state = 12},
  [1040] = {.lex_state = 12},
  [1041] = {.lex_state = 12},
  [1042] = {.lex_state = 12},
  [1043] = {.lex_state = 12},
  [1044] = {.lex_state = 12},
  [1045] = {.lex_state = 12},
  [1046] = {.lex_state = 12},
  [1047] = {.lex_state = 12},
  [1048] = {.lex_state = 12},
  [1049] = {.lex_state = 12},
  [1050] = {.lex_state = 12},
  [1051] = {.lex_state = 12},
  [1052] = {.lex_state = 12},
  [1053] = {.lex_state = 12},
  [1054] = {.lex_state = 12},
  [1055] = {.lex_state = 12},
  [1056] = {.lex_state = 12},
  [1057] = {.lex_state = 12},
  [1058] = {.lex_state = 5, .external_lex_state = 2},
  [1059] = {.lex_state = 12},
  [1060] = {.lex_state = 12},
  [1061] = {.lex_state = 12},
  [1062] = {.lex_state = 12},
  [1063] = {.lex_state = 12},
  [1064] = {.lex_state = 12},
  [1065] = {.lex_state = 12},
  [1066] = {.lex_state = 12},
  [1067] = {.lex_state = 12},
  [1068] = {.lex_state = 12},
  [1069] = {.lex_state = 12},
  [1070] = {.lex_state = 12},
  [1071] = {.lex_state = 12},
  [1072] = {.lex_state = 12},
  [1073] = {.lex_state = 12},
  [1074] = {.lex_state = 12},
  [1075] = {.lex_state = 12},
  [1076] = {.lex_state = 12},
  [1077] = {.lex_state = 12},
  [1078] = {.lex_state = 12},
  [1079] = {.lex_state = 12},
  [1080] = {.lex_state = 12},
  [1081] = {.lex_state = 12},
  [1082] = {.lex_state = 12},
  [1083] = {.lex_state = 12},
  [1084] = {.lex_state = 12},
  [1085] = {.lex_state = 12},
  [1086] = {.lex_state = 12},
  [1087] = {.lex_state = 12},
  [1088] = {.lex_state = 12},
  [1089] = {.lex_state = 12},
  [1090] = {.lex_state = 12},
  [1091] = {.lex_state = 12},
  [1092] = {.lex_state = 12},
  [1093] = {.lex_state = 12},
  [1094] = {.lex_state = 12},
  [1095] = {.lex_state = 12},
  [1096] = {.lex_state = 12},
  [1097] = {.lex_state = 12},
  [1098] = {.lex_state = 12},
  [1099] = {.lex_state = 12},
  [1100] = {.lex_state = 5, .external_lex_state = 2},
  [1101] = {.lex_state = 5, .external_lex_state = 3},
  [1102] = {.lex_state = 5, .external_lex_state = 3},
  [1103] = {.lex_state = 5, .external_lex_state = 2},
  [1104] = {.lex_state = 5, .external_lex_state = 3},
  [1105] = {.lex_state = 5, .external_lex_state = 3},
  [1106] = {.lex_state = 5, .external_lex_state = 3},
  [1107] = {.lex_state = 11},
  [1108] = {.lex_state = 5, .external_lex_state = 3},
  [1109] = {.lex_state = 5, .external_lex_state = 3},
  [1110] = {.lex_state = 11},
  [1111] = {.lex_state = 5, .external_lex_state = 3},
  [1112] = {.lex_state = 5, .external_lex_state = 3},
  [1113] = {.lex_state = 5, .external_lex_state = 3},
  [1114] = {.lex_state = 5, .external_lex_state = 3},
  [1115] = {.lex_state = 5, .external_lex_state = 2},
  [1116] = {.lex_state = 5, .external_lex_state = 2},
  [1117] = {.lex_state = 5, .external_lex_state = 3},
  [1118] = {.lex_state = 5, .external_lex_state = 3},
  [1119] = {.lex_state = 11},
  [1120] = {.lex_state = 11},
  [1121] = {.lex_state = 5, .external_lex_state = 3},
  [1122] = {.lex_state = 11},
  [1123] = {.lex_state = 5, .external_lex_state = 3},
  [1124] = {.lex_state = 11},
  [1125] = {.lex_state = 5, .external_lex_state = 3},
  [1126] = {.lex_state = 11},
  [1127] = {.lex_state = 5, .external_lex_state = 2},
  [1128] = {.lex_state = 11},
  [1129] = {.lex_state = 11},
  [1130] = {.lex_state = 5, .external_lex_state = 3},
  [1131] = {.lex_state = 5, .external_lex_state = 2},
  [1132] = {.lex_state = 5, .external_lex_state = 2},
  [1133] = {.lex_state = 11},
  [1134] = {.lex_state = 5, .external_lex_state = 3},
  [1135] = {.lex_state = 5, .external_lex_state = 2},
  [1136] = {.lex_state = 5, .external_lex_state = 2},
  [1137] = {.lex_state = 5, .external_lex_state = 2},
  [1138] = {.lex_state = 5, .external_lex_state = 3},
  [1139] = {.lex_state = 5, .external_lex_state = 3},
  [1140] = {.lex_state = 5, .external_lex_state = 2},
  [1141] = {.lex_state = 5, .external_lex_state = 3},
  [1142] = {.lex_state = 5, .external_lex_state = 3},
  [1143] = {.lex_state = 5, .external_lex_state = 3},
  [1144] = {.lex_state = 5, .external_lex_state = 3},
  [1145] = {.lex_state = 5, .external_lex_state = 2},
  [1146] = {.lex_state = 5, .external_lex_state = 2},
  [1147] = {.lex_state = 5, .external_lex_state = 3},
  [1148] = {.lex_state = 5, .external_lex_state = 3},
  [1149] = {.lex_state = 5, .external_lex_state = 2},
  [1150] = {.lex_state = 5, .external_lex_state = 3},
  [1151] = {.lex_state = 5, .external_lex_state = 3},
  [1152] = {.lex_state = 5, .external_lex_state = 2},
  [1153] = {.lex_state = 5, .external_lex_state = 3},
  [1154] = {.lex_state = 5, .external_lex_state = 3},
  [1155] = {.lex_state = 5, .external_lex_state = 3},
  [1156] = {.lex_state = 5, .external_lex_state = 3},
  [1157] = {.lex_state = 5, .external_lex_state = 2},
  [1158] = {.lex_state = 5, .external_lex_state = 3},
  [1159] = {.lex_state = 5, .external_lex_state = 2},
  [1160] = {.lex_state = 5, .external_lex_state = 2},
  [1161] = {.lex_state = 5, .external_lex_state = 2},
  [1162] = {.lex_state = 5, .external_lex_state = 2},
  [1163] = {.lex_state = 12},
  [1164] = {.lex_state = 12},
  [1165] = {.lex_state = 12},
  [1166] = {.lex_state = 5, .external_lex_state = 2},
  [1167] = {.lex_state = 5, .external_lex_state = 2},
  [1168] = {.lex_state = 5, .external_lex_state = 3},
  [1169] = {.lex_state = 5, .external_lex_state = 2},
  [1170] = {.lex_state = 12},
  [1171] = {.lex_state = 12},
  [1172] = {.lex_state = 12},
  [1173] = {.lex_state = 5, .external_lex_state = 3},
  [1174] = {.lex_state = 5, .external_lex_state = 2},
  [1175] = {.lex_state = 5, .external_lex_state = 2},
  [1176] = {.lex_state = 5, .external_lex_state = 2},
  [1177] = {.lex_state = 5, .external_lex_state = 2},
  [1178] = {.lex_state = 5, .external_lex_state = 2},
  [1179] = {.lex_state = 5, .external_lex_state = 2},
  [1180] = {.lex_state = 5, .external_lex_state = 2},
  [1181] = {.lex_state = 12},
  [1182] = {.lex_state = 5, .external_lex_state = 3},
  [1183] = {.lex_state = 5, .external_lex_state = 2},
  [1184] = {.lex_state = 5, .external_lex_state = 3},
  [1185] = {.lex_state = 5, .external_lex_state = 2},
  [1186] = {.lex_state = 5, .external_lex_state = 2},
  [1187] = {.lex_state = 5, .external_lex_state = 2},
  [1188] = {.lex_state = 5, .external_lex_state = 2},
  [1189] = {.lex_state = 5, .external_lex_state = 2},
  [1190] = {.lex_state = 5, .external_lex_state = 2},
  [1191] = {.lex_state = 5, .external_lex_state = 3},
  [1192] = {.lex_state = 5, .external_lex_state = 3},
  [1193] = {.lex_state = 5, .external_lex_state = 2},
  [1194] = {.lex_state = 5, .external_lex_state = 2},
  [1195] = {.lex_state = 5, .external_lex_state = 3},
  [1196] = {.lex_state = 5, .external_lex_state = 2},
  [1197] = {.lex_state = 5, .external_lex_state = 2},
  [1198] = {.lex_state = 12},
  [1199] = {.lex_state = 12},
  [1200] = {.lex_state = 12},
  [1201] = {.lex_state = 5, .external_lex_state = 2},
  [1202] = {.lex_state = 5, .external_lex_state = 3},
  [1203] = {.lex_state = 5, .external_lex_state = 2},
  [1204] = {.lex_state = 5, .external_lex_state = 2},
  [1205] = {.lex_state = 12},
  [1206] = {.lex_state = 12},
  [1207] = {.lex_state = 5, .external_lex_state = 2},
  [1208] = {.lex_state = 5, .external_lex_state = 3},
  [1209] = {.lex_state = 5, .external_lex_state = 3},
  [1210] = {.lex_state = 12},
  [1211] = {.lex_state = 12},
  [1212] = {.lex_state = 5, .external_lex_state = 2},
  [1213] = {.lex_state = 12},
  [1214] = {.lex_state = 5, .external_lex_state = 3},
  [1215] = {.lex_state = 5, .external_lex_state = 2},
  [1216] = {.lex_state = 5, .external_lex_state = 2},
  [1217] = {.lex_state = 12},
  [1218] = {.lex_state = 5, .external_lex_state = 3},
  [1219] = {.lex_state = 12},
  [1220] = {.lex_state = 5, .external_lex_state = 3},
  [1221] = {.lex_state = 12},
  [1222] = {.lex_state = 12},
  [1223] = {.lex_state = 12},
  [1224] = {.lex_state = 5, .external_lex_state = 3},
  [1225] = {.lex_state = 12},
  [1226] = {.lex_state = 12},
  [1227] = {.lex_state = 12},
  [1228] = {.lex_state = 12},
  [1229] = {.lex_state = 5, .external_lex_state = 3},
  [1230] = {.lex_state = 12},
  [1231] = {.lex_state = 12},
  [1232] = {.lex_state = 5, .external_lex_state = 3},
  [1233] = {.lex_state = 5, .external_lex_state = 3},
  [1234] = {.lex_state = 5, .external_lex_state = 2},
  [1235] = {.lex_state = 5, .external_lex_state = 2},
  [1236] = {.lex_state = 12},
  [1237] = {.lex_state = 5, .external_lex_state = 2},
  [1238] = {.lex_state = 5, .external_lex_state = 2},
  [1239] = {.lex_state = 5, .external_lex_state = 3},
  [1240] = {.lex_state = 5, .external_lex_state = 2},
  [1241] = {.lex_state = 5, .external_lex_state = 2},
  [1242] = {.lex_state = 5, .external_lex_state = 2},
  [1243] = {.lex_state = 12},
  [1244] = {.lex_state = 5, .external_lex_state = 2},
  [1245] = {.lex_state = 5, .external_lex_state = 3},
  [1246] = {.lex_state = 5, .external_lex_state = 2},
  [1247] = {.lex_state = 5, .external_lex_state = 3},
  [1248] = {.lex_state = 5, .external_lex_state = 2},
  [1249] = {.lex_state = 5, .external_lex_state = 3},
  [1250] = {.lex_state = 5, .external_lex_state = 3},
  [1251] = {.lex_state = 5, .external_lex_state = 3},
  [1252] = {.lex_state = 5, .external_lex_state = 3},
  [1253] = {.lex_state = 5, .external_lex_state = 3},
  [1254] = {.lex_state = 5, .external_lex_state = 3},
  [1255] = {.lex_state = 5, .external_lex_state = 2},
  [1256] = {.lex_state = 5, .external_lex_state = 2},
  [1257] = {.lex_state = 5, .external_lex_state = 2},
  [1258] = {.lex_state = 5, .external_lex_state = 3},
  [1259] = {.lex_state = 5, .external_lex_state = 3},
  [1260] = {.lex_state = 5, .external_lex_state = 2},
  [1261] = {.lex_state = 5, .external_lex_state = 3},
  [1262] = {.lex_state = 5, .external_lex_state = 3},
  [1263] = {.lex_state = 5, .external_lex_state = 3},
  [1264] = {.lex_state = 5, .external_lex_state = 2},
  [1265] = {.lex_state = 5, .external_lex_state = 2},
  [1266] = {.lex_state = 5, .external_lex_state = 3},
  [1267] = {.lex_state = 5, .external_lex_state = 3},
  [1268] = {.lex_state = 5, .external_lex_state = 2},
  [1269] = {.lex_state = 5, .external_lex_state = 2},
  [1270] = {.lex_state = 5, .external_lex_state = 3},
  [1271] = {.lex_state = 5, .external_lex_state = 3},
  [1272] = {.lex_state = 5, .external_lex_state = 2},
  [1273] = {.lex_state = 5, .external_lex_state = 3},
  [1274] = {.lex_state = 5, .external_lex_state = 3},
  [1275] = {.lex_state = 5, .external_lex_state = 3},
  [1276] = {.lex_state = 5, .external_lex_state = 2},
  [1277] = {.lex_state = 5, .external_lex_state = 3},
  [1278] = {.lex_state = 5, .external_lex_state = 3},
  [1279] = {.lex_state = 5, .external_lex_state = 3},
  [1280] = {.lex_state = 5, .external_lex_state = 2},
  [1281] = {.lex_state = 5, .external_lex_state = 3},
  [1282] = {.lex_state = 5, .external_lex_state = 2},
  [1283] = {.lex_state = 5, .external_lex_state = 3},
  [1284] = {.lex_state = 5, .external_lex_state = 3},
  [1285] = {.lex_state = 5, .external_lex_state = 2},
  [1286] = {.lex_state = 5, .external_lex_state = 3},
  [1287] = {.lex_state = 5, .external_lex_state = 2},
  [1288] = {.lex_state = 5, .external_lex_state = 2},
  [1289] = {.lex_state = 5, .external_lex_state = 3},
  [1290] = {.lex_state = 5, .external_lex_state = 2},
  [1291] = {.lex_state = 12},
  [1292] = {.lex_state = 12},
  [1293] = {.lex_state = 5, .external_lex_state = 2},
  [1294] = {.lex_state = 5, .external_lex_state = 2},
  [1295] = {.lex_state = 5, .external_lex_state = 2},
  [1296] = {.lex_state = 5, .external_lex_state = 2},
  [1297] = {.lex_state = 12},
  [1298] = {.lex_state = 12},
  [1299] = {.lex_state = 12},
  [1300] = {.lex_state = 5, .external_lex_state = 3},
  [1301] = {.lex_state = 5, .external_lex_state = 2},
  [1302] = {.lex_state = 5, .external_lex_state = 2},
  [1303] = {.lex_state = 5, .external_lex_state = 2},
  [1304] = {.lex_state = 5, .external_lex_state = 3},
  [1305] = {.lex_state = 5, .external_lex_state = 2},
  [1306] = {.lex_state = 5, .external_lex_state = 3},
  [1307] = {.lex_state = 12},
  [1308] = {.lex_state = 5, .external_lex_state = 2},
  [1309] = {.lex_state = 12},
  [1310] = {.lex_state = 5, .external_lex_state = 3},
  [1311] = {.lex_state = 5, .external_lex_state = 3},
  [1312] = {.lex_state = 12},
  [1313] = {.lex_state = 5, .external_lex_state = 2},
  [1314] = {.lex_state = 5, .external_lex_state = 2},
  [1315] = {.lex_state = 5, .external_lex_state = 2},
  [1316] = {.lex_state = 5, .external_lex_state = 3},
  [1317] = {.lex_state = 5, .external_lex_state = 2},
  [1318] = {.lex_state = 5, .external_lex_state = 2},
  [1319] = {.lex_state = 5, .external_lex_state = 3},
  [1320] = {.lex_state = 5, .external_lex_state = 2},
  [1321] = {.lex_state = 5, .external_lex_state = 3},
  [1322] = {.lex_state = 5, .external_lex_state = 2},
  [1323] = {.lex_state = 5, .external_lex_state = 2},
  [1324] = {.lex_state = 5, .external_lex_state = 2},
  [1325] = {.lex_state = 5, .external_lex_state = 2},
  [1326] = {.lex_state = 5, .external_lex_state = 2},
  [1327] = {.lex_state = 5, .external_lex_state = 3},
  [1328] = {.lex_state = 11},
  [1329] = {.lex_state = 11},
  [1330] = {.lex_state = 5, .external_lex_state = 2},
  [1331] = {.lex_state = 5, .external_lex_state = 2},
  [1332] = {.lex_state = 5, .external_lex_state = 2},
  [1333] = {.lex_state = 5, .external_lex_state = 2},
  [1334] = {.lex_state = 5, .external_lex_state = 2},
  [1335] = {.lex_state = 5, .external_lex_state = 2},
  [1336] = {.lex_state = 5, .external_lex_state = 2},
  [1337] = {.lex_state = 11},
  [1338] = {.lex_state = 5, .external_lex_state = 2},
  [1339] = {.lex_state = 11},
  [1340] = {.lex_state = 11},
  [1341] = {.lex_state = 5, .external_lex_state = 2},
  [1342] = {.lex_state = 5, .external_lex_state = 2},
  [1343] = {.lex_state = 11},
  [1344] = {.lex_state = 5, .external_lex_state = 2},
  [1345] = {.lex_state = 5, .external_lex_state = 3},
  [1346] = {.lex_state = 5, .external_lex_state = 2},
  [1347] = {.lex_state = 5, .external_lex_state = 2},
  [1348] = {.lex_state = 5, .external_lex_state = 2},
  [1349] = {.lex_state = 11},
  [1350] = {.lex_state = 5, .external_lex_state = 2},
  [1351] = {.lex_state = 5, .external_lex_state = 2},
  [1352] = {.lex_state = 5, .external_lex_state = 2},
  [1353] = {.lex_state = 5, .external_lex_state = 2},
  [1354] = {.lex_state = 5, .external_lex_state = 2},
  [1355] = {.lex_state = 5, .external_lex_state = 2},
  [1356] = {.lex_state = 5, .external_lex_state = 2},
  [1357] = {.lex_state = 93},
  [1358] = {.lex_state = 93},
  [1359] = {.lex_state = 11},
  [1360] = {.lex_state = 93},
  [1361] = {.lex_state = 93},
  [1362] = {.lex_state = 93},
  [1363] = {.lex_state = 16, .external_lex_state = 4},
  [1364] = {.lex_state = 16, .external_lex_state = 4},
  [1365] = {.lex_state = 16},
  [1366] = {.lex_state = 16},
  [1367] = {.lex_state = 16, .external_lex_state = 4},
  [1368] = {.lex_state = 16, .external_lex_state = 4},
  [1369] = {.lex_state = 16, .external_lex_state = 4},
  [1370] = {.lex_state = 16, .external_lex_state = 4},
  [1371] = {.lex_state = 12, .external_lex_state = 4},
  [1372] = {.lex_state = 12},
  [1373] = {.lex_state = 12},
  [1374] = {.lex_state = 12},
  [1375] = {.lex_state = 12},
  [1376] = {.lex_state = 12},
  [1377] = {.lex_state = 12},
  [1378] = {.lex_state = 12},
  [1379] = {.lex_state = 12},
  [1380] = {.lex_state = 12, .external_lex_state = 4},
  [1381] = {.lex_state = 12},
  [1382] = {.lex_state = 12, .external_lex_state = 4},
  [1383] = {.lex_state = 12, .external_lex_state = 4},
  [1384] = {.lex_state = 12},
  [1385] = {.lex_state = 12},
  [1386] = {.lex_state = 12, .external_lex_state = 4},
  [1387] = {.lex_state = 12},
  [1388] = {.lex_state = 12, .external_lex_state = 4},
  [1389] = {.lex_state = 12},
  [1390] = {.lex_state = 12},
  [1391] = {.lex_state = 7, .external_lex_state = 3},
  [1392] = {.lex_state = 12},
  [1393] = {.lex_state = 12},
  [1394] = {.lex_state = 7, .external_lex_state = 3},
  [1395] = {.lex_state = 12},
  [1396] = {.lex_state = 12, .external_lex_state = 4},
  [1397] = {.lex_state = 12, .external_lex_state = 4},
  [1398] = {.lex_state = 12, .external_lex_state = 4},
  [1399] = {.lex_state = 12, .external_lex_state = 4},
  [1400] = {.lex_state = 12, .external_lex_state = 4},
  [1401] = {.lex_state = 12, .external_lex_state = 4},
  [1402] = {.lex_state = 12, .external_lex_state = 4},
  [1403] = {.lex_state = 12, .external_lex_state = 4},
  [1404] = {.lex_state = 12, .external_lex_state = 4},
  [1405] = {.lex_state = 12, .external_lex_state = 4},
  [1406] = {.lex_state = 16, .external_lex_state = 4},
  [1407] = {.lex_state = 93},
  [1408] = {.lex_state = 16, .external_lex_state = 4},
  [1409] = {.lex_state = 12, .external_lex_state = 4},
  [1410] = {.lex_state = 12, .external_lex_state = 4},
  [1411] = {.lex_state = 12, .external_lex_state = 4},
  [1412] = {.lex_state = 7, .external_lex_state = 3},
  [1413] = {.lex_state = 7, .external_lex_state = 3},
  [1414] = {.lex_state = 12, .external_lex_state = 4},
  [1415] = {.lex_state = 12, .external_lex_state = 4},
  [1416] = {.lex_state = 12, .external_lex_state = 4},
  [1417] = {.lex_state = 12, .external_lex_state = 4},
  [1418] = {.lex_state = 12, .external_lex_state = 4},
  [1419] = {.lex_state = 12, .external_lex_state = 4},
  [1420] = {.lex_state = 12, .external_lex_state = 4},
  [1421] = {.lex_state = 12, .external_lex_state = 4},
  [1422] = {.lex_state = 12, .external_lex_state = 4},
  [1423] = {.lex_state = 12, .external_lex_state = 4},
  [1424] = {.lex_state = 12, .external_lex_state = 4},
  [1425] = {.lex_state = 12, .external_lex_state = 4},
  [1426] = {.lex_state = 12},
  [1427] = {.lex_state = 12, .external_lex_state = 4},
  [1428] = {.lex_state = 11},
  [1429] = {.lex_state = 12},
  [1430] = {.lex_state = 12, .external_lex_state = 4},
  [1431] = {.lex_state = 11},
  [1432] = {.lex_state = 12},
  [1433] = {.lex_state = 12, .external_lex_state = 4},
  [1434] = {.lex_state = 7, .external_lex_state = 2},
  [1435] = {.lex_state = 7, .external_lex_state = 2},
  [1436] = {.lex_state = 12},
  [1437] = {.lex_state = 12, .external_lex_state = 4},
  [1438] = {.lex_state = 12, .external_lex_state = 4},
  [1439] = {.lex_state = 12, .external_lex_state = 4},
  [1440] = {.lex_state = 12},
  [1441] = {.lex_state = 12},
  [1442] = {.lex_state = 12, .external_lex_state = 4},
  [1443] = {.lex_state = 12},
  [1444] = {.lex_state = 12, .external_lex_state = 4},
  [1445] = {.lex_state = 12, .external_lex_state = 4},
  [1446] = {.lex_state = 7, .external_lex_state = 3},
  [1447] = {.lex_state = 12, .external_lex_state = 4},
  [1448] = {.lex_state = 12, .external_lex_state = 4},
  [1449] = {.lex_state = 12, .external_lex_state = 4},
  [1450] = {.lex_state = 7, .external_lex_state = 2},
  [1451] = {.lex_state = 12, .external_lex_state = 4},
  [1452] = {.lex_state = 12, .external_lex_state = 4},
  [1453] = {.lex_state = 12},
  [1454] = {.lex_state = 12, .external_lex_state = 4},
  [1455] = {.lex_state = 12, .external_lex_state = 4},
  [1456] = {.lex_state = 7, .external_lex_state = 2},
  [1457] = {.lex_state = 12},
  [1458] = {.lex_state = 12, .external_lex_state = 4},
  [1459] = {.lex_state = 7, .external_lex_state = 3},
  [1460] = {.lex_state = 12, .external_lex_state = 4},
  [1461] = {.lex_state = 7, .external_lex_state = 2},
  [1462] = {.lex_state = 12, .external_lex_state = 4},
  [1463] = {.lex_state = 12, .external_lex_state = 4},
  [1464] = {.lex_state = 12, .external_lex_state = 4},
  [1465] = {.lex_state = 7, .external_lex_state = 2},
  [1466] = {.lex_state = 12, .external_lex_state = 4},
  [1467] = {.lex_state = 12, .external_lex_state = 4},
  [1468] = {.lex_state = 7, .external_lex_state = 2},
  [1469] = {.lex_state = 11},
  [1470] = {.lex_state = 12, .external_lex_state = 4},
  [1471] = {.lex_state = 12, .external_lex_state = 4},
  [1472] = {.lex_state = 7, .external_lex_state = 2},
  [1473] = {.lex_state = 7, .external_lex_state = 2},
  [1474] = {.lex_state = 12, .external_lex_state = 4},
  [1475] = {.lex_state = 12},
  [1476] = {.lex_state = 12, .external_lex_state = 4},
  [1477] = {.lex_state = 12, .external_lex_state = 4},
  [1478] = {.lex_state = 12, .external_lex_state = 4},
  [1479] = {.lex_state = 12, .external_lex_state = 4},
  [1480] = {.lex_state = 12, .external_lex_state = 4},
  [1481] = {.lex_state = 12, .external_lex_state = 4},
  [1482] = {.lex_state = 12, .external_lex_state = 4},
  [1483] = {.lex_state = 12, .external_lex_state = 4},
  [1484] = {.lex_state = 12, .external_lex_state = 4},
  [1485] = {.lex_state = 7, .external_lex_state = 3},
  [1486] = {.lex_state = 12, .external_lex_state = 4},
  [1487] = {.lex_state = 12},
  [1488] = {.lex_state = 12},
  [1489] = {.lex_state = 12},
  [1490] = {.lex_state = 12},
  [1491] = {.lex_state = 12},
  [1492] = {.lex_state = 12, .external_lex_state = 4},
  [1493] = {.lex_state = 12, .external_lex_state = 4},
  [1494] = {.lex_state = 12},
  [1495] = {.lex_state = 12},
  [1496] = {.lex_state = 7, .external_lex_state = 2},
  [1497] = {.lex_state = 12},
  [1498] = {.lex_state = 12, .external_lex_state = 4},
  [1499] = {.lex_state = 12, .external_lex_state = 4},
  [1500] = {.lex_state = 12, .external_lex_state = 4},
  [1501] = {.lex_state = 12, .external_lex_state = 4},
  [1502] = {.lex_state = 12},
  [1503] = {.lex_state = 12},
  [1504] = {.lex_state = 12, .external_lex_state = 4},
  [1505] = {.lex_state = 12, .external_lex_state = 4},
  [1506] = {.lex_state = 12, .external_lex_state = 4},
  [1507] = {.lex_state = 12, .external_lex_state = 4},
  [1508] = {.lex_state = 7, .external_lex_state = 2},
  [1509] = {.lex_state = 7, .external_lex_state = 2},
  [1510] = {.lex_state = 12},
  [1511] = {.lex_state = 12, .external_lex_state = 4},
  [1512] = {.lex_state = 7, .external_lex_state = 2},
  [1513] = {.lex_state = 7, .external_lex_state = 2},
  [1514] = {.lex_state = 7, .external_lex_state = 2},
  [1515] = {.lex_state = 7, .external_lex_state = 2},
  [1516] = {.lex_state = 7, .external_lex_state = 2},
  [1517] = {.lex_state = 7, .external_lex_state = 2},
  [1518] = {.lex_state = 7, .external_lex_state = 2},
  [1519] = {.lex_state = 7, .external_lex_state = 2},
  [1520] = {.lex_state = 7, .external_lex_state = 2},
  [1521] = {.lex_state = 7, .external_lex_state = 2},
  [1522] = {.lex_state = 12, .external_lex_state = 4},
  [1523] = {.lex_state = 7, .external_lex_state = 2},
  [1524] = {.lex_state = 7, .external_lex_state = 2},
  [1525] = {.lex_state = 7, .external_lex_state = 2},
  [1526] = {.lex_state = 7, .external_lex_state = 2},
  [1527] = {.lex_state = 7, .external_lex_state = 2},
  [1528] = {.lex_state = 7, .external_lex_state = 2},
  [1529] = {.lex_state = 7, .external_lex_state = 2},
  [1530] = {.lex_state = 7, .external_lex_state = 2},
  [1531] = {.lex_state = 7, .external_lex_state = 2},
  [1532] = {.lex_state = 7, .external_lex_state = 2},
  [1533] = {.lex_state = 7, .external_lex_state = 2},
  [1534] = {.lex_state = 7, .external_lex_state = 2},
  [1535] = {.lex_state = 7, .external_lex_state = 2},
  [1536] = {.lex_state = 7, .external_lex_state = 2},
  [1537] = {.lex_state = 7, .external_lex_state = 2},
  [1538] = {.lex_state = 7, .external_lex_state = 2},
  [1539] = {.lex_state = 7, .external_lex_state = 2},
  [1540] = {.lex_state = 7, .external_lex_state = 2},
  [1541] = {.lex_state = 7, .external_lex_state = 2},
  [1542] = {.lex_state = 12, .external_lex_state = 4},
  [1543] = {.lex_state = 7, .external_lex_state = 2},
  [1544] = {.lex_state = 7, .external_lex_state = 2},
  [1545] = {.lex_state = 7, .external_lex_state = 2},
  [1546] = {.lex_state = 12, .external_lex_state = 4},
  [1547] = {.lex_state = 7, .external_lex_state = 2},
  [1548] = {.lex_state = 12, .external_lex_state = 4},
  [1549] = {.lex_state = 12, .external_lex_state = 4},
  [1550] = {.lex_state = 12, .external_lex_state = 4},
  [1551] = {.lex_state = 7, .external_lex_state = 3},
  [1552] = {.lex_state = 7, .external_lex_state = 3},
  [1553] = {.lex_state = 7, .external_lex_state = 2},
  [1554] = {.lex_state = 12},
  [1555] = {.lex_state = 7, .external_lex_state = 2},
  [1556] = {.lex_state = 7, .external_lex_state = 2},
  [1557] = {.lex_state = 7, .external_lex_state = 2},
  [1558] = {.lex_state = 7, .external_lex_state = 2},
  [1559] = {.lex_state = 7, .external_lex_state = 2},
  [1560] = {.lex_state = 7, .external_lex_state = 2},
  [1561] = {.lex_state = 12, .external_lex_state = 4},
  [1562] = {.lex_state = 7, .external_lex_state = 2},
  [1563] = {.lex_state = 7, .external_lex_state = 2},
  [1564] = {.lex_state = 12, .external_lex_state = 4},
  [1565] = {.lex_state = 12, .external_lex_state = 4},
  [1566] = {.lex_state = 7, .external_lex_state = 2},
  [1567] = {.lex_state = 11},
  [1568] = {.lex_state = 12},
  [1569] = {.lex_state = 12, .external_lex_state = 4},
  [1570] = {.lex_state = 12},
  [1571] = {.lex_state = 12, .external_lex_state = 4},
  [1572] = {.lex_state = 12},
  [1573] = {.lex_state = 7, .external_lex_state = 2},
  [1574] = {.lex_state = 12, .external_lex_state = 4},
  [1575] = {.lex_state = 12, .external_lex_state = 4},
  [1576] = {.lex_state = 12, .external_lex_state = 4},
  [1577] = {.lex_state = 7, .external_lex_state = 3},
  [1578] = {.lex_state = 12},
  [1579] = {.lex_state = 12},
  [1580] = {.lex_state = 7, .external_lex_state = 2},
  [1581] = {.lex_state = 7, .external_lex_state = 2},
  [1582] = {.lex_state = 12},
  [1583] = {.lex_state = 7, .external_lex_state = 2},
  [1584] = {.lex_state = 12},
  [1585] = {.lex_state = 7, .external_lex_state = 2},
  [1586] = {.lex_state = 7, .external_lex_state = 2},
  [1587] = {.lex_state = 12, .external_lex_state = 4},
  [1588] = {.lex_state = 7, .external_lex_state = 2},
  [1589] = {.lex_state = 7, .external_lex_state = 2},
  [1590] = {.lex_state = 7, .external_lex_state = 2},
  [1591] = {.lex_state = 7, .external_lex_state = 2},
  [1592] = {.lex_state = 7, .external_lex_state = 2},
  [1593] = {.lex_state = 7, .external_lex_state = 2},
  [1594] = {.lex_state = 7, .external_lex_state = 2},
  [1595] = {.lex_state = 7, .external_lex_state = 2},
  [1596] = {.lex_state = 7, .external_lex_state = 2},
  [1597] = {.lex_state = 12, .external_lex_state = 4},
  [1598] = {.lex_state = 7, .external_lex_state = 2},
  [1599] = {.lex_state = 12, .external_lex_state = 4},
  [1600] = {.lex_state = 7, .external_lex_state = 2},
  [1601] = {.lex_state = 7, .external_lex_state = 2},
  [1602] = {.lex_state = 7, .external_lex_state = 2},
  [1603] = {.lex_state = 7, .external_lex_state = 2},
  [1604] = {.lex_state = 7, .external_lex_state = 2},
  [1605] = {.lex_state = 7, .external_lex_state = 2},
  [1606] = {.lex_state = 7, .external_lex_state = 2},
  [1607] = {.lex_state = 7, .external_lex_state = 2},
  [1608] = {.lex_state = 7, .external_lex_state = 2},
  [1609] = {.lex_state = 7, .external_lex_state = 2},
  [1610] = {.lex_state = 7, .external_lex_state = 2},
  [1611] = {.lex_state = 7, .external_lex_state = 2},
  [1612] = {.lex_state = 7, .external_lex_state = 2},
  [1613] = {.lex_state = 7, .external_lex_state = 2},
  [1614] = {.lex_state = 7, .external_lex_state = 2},
  [1615] = {.lex_state = 7, .external_lex_state = 2},
  [1616] = {.lex_state = 7, .external_lex_state = 2},
  [1617] = {.lex_state = 7, .external_lex_state = 2},
  [1618] = {.lex_state = 7, .external_lex_state = 2},
  [1619] = {.lex_state = 7, .external_lex_state = 2},
  [1620] = {.lex_state = 7, .external_lex_state = 2},
  [1621] = {.lex_state = 7, .external_lex_state = 2},
  [1622] = {.lex_state = 7, .external_lex_state = 2},
  [1623] = {.lex_state = 7, .external_lex_state = 2},
  [1624] = {.lex_state = 7, .external_lex_state = 2},
  [1625] = {.lex_state = 7, .external_lex_state = 2},
  [1626] = {.lex_state = 7, .external_lex_state = 2},
  [1627] = {.lex_state = 7, .external_lex_state = 2},
  [1628] = {.lex_state = 7, .external_lex_state = 2},
  [1629] = {.lex_state = 7, .external_lex_state = 2},
  [1630] = {.lex_state = 7, .external_lex_state = 2},
  [1631] = {.lex_state = 7, .external_lex_state = 2},
  [1632] = {.lex_state = 7, .external_lex_state = 2},
  [1633] = {.lex_state = 7, .external_lex_state = 2},
  [1634] = {.lex_state = 7, .external_lex_state = 2},
  [1635] = {.lex_state = 7, .external_lex_state = 2},
  [1636] = {.lex_state = 7, .external_lex_state = 2},
  [1637] = {.lex_state = 7, .external_lex_state = 2},
  [1638] = {.lex_state = 7, .external_lex_state = 2},
  [1639] = {.lex_state = 7, .external_lex_state = 2},
  [1640] = {.lex_state = 7, .external_lex_state = 2},
  [1641] = {.lex_state = 7, .external_lex_state = 2},
  [1642] = {.lex_state = 7, .external_lex_state = 2},
  [1643] = {.lex_state = 7, .external_lex_state = 2},
  [1644] = {.lex_state = 7, .external_lex_state = 2},
  [1645] = {.lex_state = 7, .external_lex_state = 2},
  [1646] = {.lex_state = 7, .external_lex_state = 2},
  [1647] = {.lex_state = 7, .external_lex_state = 2},
  [1648] = {.lex_state = 7, .external_lex_state = 2},
  [1649] = {.lex_state = 7, .external_lex_state = 2},
  [1650] = {.lex_state = 7, .external_lex_state = 2},
  [1651] = {.lex_state = 7, .external_lex_state = 2},
  [1652] = {.lex_state = 7, .external_lex_state = 2},
  [1653] = {.lex_state = 7, .external_lex_state = 2},
  [1654] = {.lex_state = 7, .external_lex_state = 2},
  [1655] = {.lex_state = 7, .external_lex_state = 2},
  [1656] = {.lex_state = 7, .external_lex_state = 2},
  [1657] = {.lex_state = 7, .external_lex_state = 2},
  [1658] = {.lex_state = 7, .external_lex_state = 2},
  [1659] = {.lex_state = 7, .external_lex_state = 2},
  [1660] = {.lex_state = 7, .external_lex_state = 2},
  [1661] = {.lex_state = 7, .external_lex_state = 2},
  [1662] = {.lex_state = 7, .external_lex_state = 2},
  [1663] = {.lex_state = 7, .external_lex_state = 2},
  [1664] = {.lex_state = 12, .external_lex_state = 4},
  [1665] = {.lex_state = 7, .external_lex_state = 2},
  [1666] = {.lex_state = 7, .external_lex_state = 2},
  [1667] = {.lex_state = 7, .external_lex_state = 2},
  [1668] = {.lex_state = 7, .external_lex_state = 2},
  [1669] = {.lex_state = 7, .external_lex_state = 3},
  [1670] = {.lex_state = 7, .external_lex_state = 3},
  [1671] = {.lex_state = 7, .external_lex_state = 3},
  [1672] = {.lex_state = 7, .external_lex_state = 2},
  [1673] = {.lex_state = 7, .external_lex_state = 3},
  [1674] = {.lex_state = 7, .external_lex_state = 3},
  [1675] = {.lex_state = 7, .external_lex_state = 3},
  [1676] = {.lex_state = 7, .external_lex_state = 2},
  [1677] = {.lex_state = 7, .external_lex_state = 2},
  [1678] = {.lex_state = 12, .external_lex_state = 4},
  [1679] = {.lex_state = 12, .external_lex_state = 4},
  [1680] = {.lex_state = 7, .external_lex_state = 2},
  [1681] = {.lex_state = 7, .external_lex_state = 3},
  [1682] = {.lex_state = 7, .external_lex_state = 2},
  [1683] = {.lex_state = 7, .external_lex_state = 2},
  [1684] = {.lex_state = 7, .external_lex_state = 3},
  [1685] = {.lex_state = 7, .external_lex_state = 2},
  [1686] = {.lex_state = 7, .external_lex_state = 3},
  [1687] = {.lex_state = 7, .external_lex_state = 2},
  [1688] = {.lex_state = 7, .external_lex_state = 2},
  [1689] = {.lex_state = 7, .external_lex_state = 2},
  [1690] = {.lex_state = 7, .external_lex_state = 2},
  [1691] = {.lex_state = 7, .external_lex_state = 3},
  [1692] = {.lex_state = 7, .external_lex_state = 3},
  [1693] = {.lex_state = 7, .external_lex_state = 3},
  [1694] = {.lex_state = 7, .external_lex_state = 3},
  [1695] = {.lex_state = 7, .external_lex_state = 3},
  [1696] = {.lex_state = 7, .external_lex_state = 3},
  [1697] = {.lex_state = 11, .external_lex_state = 4},
  [1698] = {.lex_state = 11, .external_lex_state = 4},
  [1699] = {.lex_state = 7, .external_lex_state = 3},
  [1700] = {.lex_state = 7, .external_lex_state = 3},
  [1701] = {.lex_state = 7, .external_lex_state = 3},
  [1702] = {.lex_state = 7, .external_lex_state = 3},
  [1703] = {.lex_state = 7, .external_lex_state = 3},
  [1704] = {.lex_state = 7, .external_lex_state = 3},
  [1705] = {.lex_state = 7, .external_lex_state = 3},
  [1706] = {.lex_state = 7, .external_lex_state = 3},
  [1707] = {.lex_state = 7, .external_lex_state = 3},
  [1708] = {.lex_state = 7, .external_lex_state = 3},
  [1709] = {.lex_state = 7, .external_lex_state = 3},
  [1710] = {.lex_state = 7, .external_lex_state = 2},
  [1711] = {.lex_state = 7, .external_lex_state = 2},
  [1712] = {.lex_state = 7, .external_lex_state = 3},
  [1713] = {.lex_state = 7, .external_lex_state = 3},
  [1714] = {.lex_state = 7, .external_lex_state = 2},
  [1715] = {.lex_state = 7, .external_lex_state = 3},
  [1716] = {.lex_state = 7, .external_lex_state = 2},
  [1717] = {.lex_state = 7, .external_lex_state = 3},
  [1718] = {.lex_state = 7, .external_lex_state = 2},
  [1719] = {.lex_state = 7, .external_lex_state = 2},
  [1720] = {.lex_state = 7, .external_lex_state = 2},
  [1721] = {.lex_state = 7, .external_lex_state = 3},
  [1722] = {.lex_state = 7, .external_lex_state = 3},
  [1723] = {.lex_state = 7, .external_lex_state = 2},
  [1724] = {.lex_state = 7, .external_lex_state = 3},
  [1725] = {.lex_state = 7, .external_lex_state = 2},
  [1726] = {.lex_state = 7, .external_lex_state = 2},
  [1727] = {.lex_state = 7, .external_lex_state = 2},
  [1728] = {.lex_state = 7, .external_lex_state = 2},
  [1729] = {.lex_state = 7, .external_lex_state = 2},
  [1730] = {.lex_state = 7, .external_lex_state = 2},
  [1731] = {.lex_state = 7, .external_lex_state = 2},
  [1732] = {.lex_state = 7, .external_lex_state = 3},
  [1733] = {.lex_state = 7, .external_lex_state = 2},
  [1734] = {.lex_state = 7, .external_lex_state = 3},
  [1735] = {.lex_state = 7, .external_lex_state = 3},
  [1736] = {.lex_state = 7, .external_lex_state = 3},
  [1737] = {.lex_state = 7, .external_lex_state = 3},
  [1738] = {.lex_state = 7, .external_lex_state = 3},
  [1739] = {.lex_state = 7, .external_lex_state = 2},
  [1740] = {.lex_state = 7, .external_lex_state = 2},
  [1741] = {.lex_state = 7, .external_lex_state = 2},
  [1742] = {.lex_state = 7, .external_lex_state = 2},
  [1743] = {.lex_state = 7, .external_lex_state = 2},
  [1744] = {.lex_state = 7, .external_lex_state = 3},
  [1745] = {.lex_state = 7, .external_lex_state = 3},
  [1746] = {.lex_state = 7, .external_lex_state = 2},
  [1747] = {.lex_state = 7, .external_lex_state = 3},
  [1748] = {.lex_state = 7, .external_lex_state = 3},
  [1749] = {.lex_state = 7, .external_lex_state = 2},
  [1750] = {.lex_state = 7, .external_lex_state = 2},
  [1751] = {.lex_state = 7, .external_lex_state = 2},
  [1752] = {.lex_state = 7, .external_lex_state = 2},
  [1753] = {.lex_state = 7, .external_lex_state = 2},
  [1754] = {.lex_state = 7, .external_lex_state = 2},
  [1755] = {.lex_state = 7, .external_lex_state = 3},
  [1756] = {.lex_state = 7, .external_lex_state = 3},
  [1757] = {.lex_state = 7, .external_lex_state = 3},
  [1758] = {.lex_state = 7, .external_lex_state = 2},
  [1759] = {.lex_state = 7, .external_lex_state = 3},
  [1760] = {.lex_state = 7, .external_lex_state = 3},
  [1761] = {.lex_state = 7, .external_lex_state = 2},
  [1762] = {.lex_state = 7, .external_lex_state = 2},
  [1763] = {.lex_state = 7, .external_lex_state = 2},
  [1764] = {.lex_state = 7, .external_lex_state = 2},
  [1765] = {.lex_state = 7, .external_lex_state = 2},
  [1766] = {.lex_state = 7, .external_lex_state = 2},
  [1767] = {.lex_state = 7, .external_lex_state = 2},
  [1768] = {.lex_state = 7, .external_lex_state = 2},
  [1769] = {.lex_state = 7, .external_lex_state = 3},
  [1770] = {.lex_state = 7, .external_lex_state = 3},
  [1771] = {.lex_state = 11, .external_lex_state = 4},
  [1772] = {.lex_state = 7, .external_lex_state = 3},
  [1773] = {.lex_state = 7, .external_lex_state = 3},
  [1774] = {.lex_state = 7, .external_lex_state = 2},
  [1775] = {.lex_state = 7, .external_lex_state = 2},
  [1776] = {.lex_state = 7, .external_lex_state = 2},
  [1777] = {.lex_state = 7, .external_lex_state = 2},
  [1778] = {.lex_state = 7, .external_lex_state = 3},
  [1779] = {.lex_state = 11, .external_lex_state = 4},
  [1780] = {.lex_state = 7, .external_lex_state = 2},
  [1781] = {.lex_state = 7, .external_lex_state = 2},
  [1782] = {.lex_state = 7, .external_lex_state = 3},
  [1783] = {.lex_state = 7, .external_lex_state = 3},
  [1784] = {.lex_state = 7, .external_lex_state = 2},
  [1785] = {.lex_state = 7, .external_lex_state = 2},
  [1786] = {.lex_state = 7, .external_lex_state = 3},
  [1787] = {.lex_state = 7, .external_lex_state = 3},
  [1788] = {.lex_state = 7, .external_lex_state = 2},
  [1789] = {.lex_state = 7, .external_lex_state = 3},
  [1790] = {.lex_state = 7, .external_lex_state = 2},
  [1791] = {.lex_state = 7, .external_lex_state = 3},
  [1792] = {.lex_state = 7, .external_lex_state = 3},
  [1793] = {.lex_state = 7, .external_lex_state = 2},
  [1794] = {.lex_state = 7, .external_lex_state = 3},
  [1795] = {.lex_state = 7, .external_lex_state = 3},
  [1796] = {.lex_state = 7, .external_lex_state = 3},
  [1797] = {.lex_state = 7, .external_lex_state = 2},
  [1798] = {.lex_state = 7, .external_lex_state = 3},
  [1799] = {.lex_state = 12},
  [1800] = {.lex_state = 12},
  [1801] = {.lex_state = 7, .external_lex_state = 2},
  [1802] = {.lex_state = 7, .external_lex_state = 2},
  [1803] = {.lex_state = 7, .external_lex_state = 2},
  [1804] = {.lex_state = 7, .external_lex_state = 2},
  [1805] = {.lex_state = 7, .external_lex_state = 2},
  [1806] = {.lex_state = 7, .external_lex_state = 3},
  [1807] = {.lex_state = 7, .external_lex_state = 2},
  [1808] = {.lex_state = 7, .external_lex_state = 2},
  [1809] = {.lex_state = 7, .external_lex_state = 2},
  [1810] = {.lex_state = 7, .external_lex_state = 3},
  [1811] = {.lex_state = 7, .external_lex_state = 2},
  [1812] = {.lex_state = 7, .external_lex_state = 2},
  [1813] = {.lex_state = 7, .external_lex_state = 3},
  [1814] = {.lex_state = 7, .external_lex_state = 2},
  [1815] = {.lex_state = 7, .external_lex_state = 3},
  [1816] = {.lex_state = 15},
  [1817] = {.lex_state = 12},
  [1818] = {.lex_state = 7, .external_lex_state = 2},
  [1819] = {.lex_state = 7, .external_lex_state = 2},
  [1820] = {.lex_state = 7, .external_lex_state = 3},
  [1821] = {.lex_state = 7, .external_lex_state = 3},
  [1822] = {.lex_state = 7, .external_lex_state = 2},
  [1823] = {.lex_state = 7, .external_lex_state = 3},
  [1824] = {.lex_state = 7, .external_lex_state = 3},
  [1825] = {.lex_state = 7, .external_lex_state = 3},
  [1826] = {.lex_state = 7, .external_lex_state = 2},
  [1827] = {.lex_state = 7, .external_lex_state = 2},
  [1828] = {.lex_state = 7, .external_lex_state = 2},
  [1829] = {.lex_state = 7, .external_lex_state = 2},
  [1830] = {.lex_state = 7, .external_lex_state = 2},
  [1831] = {.lex_state = 7, .external_lex_state = 3},
  [1832] = {.lex_state = 7, .external_lex_state = 2},
  [1833] = {.lex_state = 7, .external_lex_state = 2},
  [1834] = {.lex_state = 7, .external_lex_state = 2},
  [1835] = {.lex_state = 12},
  [1836] = {.lex_state = 12},
  [1837] = {.lex_state = 7, .external_lex_state = 2},
  [1838] = {.lex_state = 7, .external_lex_state = 2},
  [1839] = {.lex_state = 7, .external_lex_state = 2},
  [1840] = {.lex_state = 7, .external_lex_state = 2},
  [1841] = {.lex_state = 7, .external_lex_state = 2},
  [1842] = {.lex_state = 7, .external_lex_state = 2},
  [1843] = {.lex_state = 7, .external_lex_state = 2},
  [1844] = {.lex_state = 7, .external_lex_state = 2},
  [1845] = {.lex_state = 12},
  [1846] = {.lex_state = 7, .external_lex_state = 3},
  [1847] = {.lex_state = 12},
  [1848] = {.lex_state = 7, .external_lex_state = 2},
  [1849] = {.lex_state = 7, .external_lex_state = 2},
  [1850] = {.lex_state = 7, .external_lex_state = 2},
  [1851] = {.lex_state = 7, .external_lex_state = 2},
  [1852] = {.lex_state = 11, .external_lex_state = 4},
  [1853] = {.lex_state = 7, .external_lex_state = 3},
  [1854] = {.lex_state = 7, .external_lex_state = 3},
  [1855] = {.lex_state = 7, .external_lex_state = 3},
  [1856] = {.lex_state = 11, .external_lex_state = 4},
  [1857] = {.lex_state = 7, .external_lex_state = 2},
  [1858] = {.lex_state = 7, .external_lex_state = 3},
  [1859] = {.lex_state = 7, .external_lex_state = 2},
  [1860] = {.lex_state = 7, .external_lex_state = 2},
  [1861] = {.lex_state = 7, .external_lex_state = 2},
  [1862] = {.lex_state = 7, .external_lex_state = 3},
  [1863] = {.lex_state = 7, .external_lex_state = 2},
  [1864] = {.lex_state = 7, .external_lex_state = 2},
  [1865] = {.lex_state = 12},
  [1866] = {.lex_state = 7, .external_lex_state = 3},
  [1867] = {.lex_state = 12},
  [1868] = {.lex_state = 7, .external_lex_state = 3},
  [1869] = {.lex_state = 7, .external_lex_state = 2},
  [1870] = {.lex_state = 12},
  [1871] = {.lex_state = 12},
  [1872] = {.lex_state = 12},
  [1873] = {.lex_state = 7, .external_lex_state = 2},
  [1874] = {.lex_state = 12},
  [1875] = {.lex_state = 12},
  [1876] = {.lex_state = 7, .external_lex_state = 3},
  [1877] = {.lex_state = 7, .external_lex_state = 2},
  [1878] = {.lex_state = 7, .external_lex_state = 2},
  [1879] = {.lex_state = 7, .external_lex_state = 2},
  [1880] = {.lex_state = 7, .external_lex_state = 2},
  [1881] = {.lex_state = 7, .external_lex_state = 2},
  [1882] = {.lex_state = 7, .external_lex_state = 3},
  [1883] = {.lex_state = 7, .external_lex_state = 2},
  [1884] = {.lex_state = 7, .external_lex_state = 2},
  [1885] = {.lex_state = 7, .external_lex_state = 2},
  [1886] = {.lex_state = 12},
  [1887] = {.lex_state = 12},
  [1888] = {.lex_state = 7, .external_lex_state = 2},
  [1889] = {.lex_state = 7, .external_lex_state = 3},
  [1890] = {.lex_state = 7, .external_lex_state = 3},
  [1891] = {.lex_state = 12},
  [1892] = {.lex_state = 7, .external_lex_state = 3},
  [1893] = {.lex_state = 12},
  [1894] = {.lex_state = 7, .external_lex_state = 2},
  [1895] = {.lex_state = 7, .external_lex_state = 2},
  [1896] = {.lex_state = 7, .external_lex_state = 2},
  [1897] = {.lex_state = 7, .external_lex_state = 2},
  [1898] = {.lex_state = 7, .external_lex_state = 3},
  [1899] = {.lex_state = 7, .external_lex_state = 3},
  [1900] = {.lex_state = 7, .external_lex_state = 3},
  [1901] = {.lex_state = 7, .external_lex_state = 3},
  [1902] = {.lex_state = 7, .external_lex_state = 2},
  [1903] = {.lex_state = 7, .external_lex_state = 2},
  [1904] = {.lex_state = 7, .external_lex_state = 3},
  [1905] = {.lex_state = 7, .external_lex_state = 3},
  [1906] = {.lex_state = 7, .external_lex_state = 2},
  [1907] = {.lex_state = 12},
  [1908] = {.lex_state = 12},
  [1909] = {.lex_state = 7, .external_lex_state = 3},
  [1910] = {.lex_state = 7, .external_lex_state = 2},
  [1911] = {.lex_state = 7, .external_lex_state = 2},
  [1912] = {.lex_state = 7, .external_lex_state = 2},
  [1913] = {.lex_state = 7, .external_lex_state = 2},
  [1914] = {.lex_state = 7, .external_lex_state = 3},
  [1915] = {.lex_state = 7, .external_lex_state = 2},
  [1916] = {.lex_state = 7, .external_lex_state = 3},
  [1917] = {.lex_state = 7, .external_lex_state = 3},
  [1918] = {.lex_state = 7, .external_lex_state = 3},
  [1919] = {.lex_state = 7, .external_lex_state = 3},
  [1920] = {.lex_state = 7, .external_lex_state = 3},
  [1921] = {.lex_state = 7, .external_lex_state = 3},
  [1922] = {.lex_state = 7, .external_lex_state = 3},
  [1923] = {.lex_state = 7, .external_lex_state = 3},
  [1924] = {.lex_state = 7, .external_lex_state = 3},
  [1925] = {.lex_state = 7, .external_lex_state = 3},
  [1926] = {.lex_state = 7, .external_lex_state = 3},
  [1927] = {.lex_state = 7, .external_lex_state = 3},
  [1928] = {.lex_state = 7, .external_lex_state = 3},
  [1929] = {.lex_state = 7, .external_lex_state = 3},
  [1930] = {.lex_state = 7, .external_lex_state = 3},
  [1931] = {.lex_state = 7, .external_lex_state = 3},
  [1932] = {.lex_state = 7, .external_lex_state = 3},
  [1933] = {.lex_state = 7, .external_lex_state = 3},
  [1934] = {.lex_state = 7, .external_lex_state = 3},
  [1935] = {.lex_state = 7, .external_lex_state = 3},
  [1936] = {.lex_state = 7, .external_lex_state = 2},
  [1937] = {.lex_state = 7, .external_lex_state = 3},
  [1938] = {.lex_state = 7, .external_lex_state = 3},
  [1939] = {.lex_state = 7, .external_lex_state = 2},
  [1940] = {.lex_state = 7, .external_lex_state = 3},
  [1941] = {.lex_state = 7, .external_lex_state = 3},
  [1942] = {.lex_state = 7, .external_lex_state = 3},
  [1943] = {.lex_state = 7, .external_lex_state = 3},
  [1944] = {.lex_state = 7, .external_lex_state = 3},
  [1945] = {.lex_state = 7, .external_lex_state = 2},
  [1946] = {.lex_state = 7, .external_lex_state = 3},
  [1947] = {.lex_state = 7, .external_lex_state = 3},
  [1948] = {.lex_state = 7, .external_lex_state = 3},
  [1949] = {.lex_state = 7, .external_lex_state = 3},
  [1950] = {.lex_state = 7, .external_lex_state = 3},
  [1951] = {.lex_state = 7, .external_lex_state = 3},
  [1952] = {.lex_state = 7, .external_lex_state = 3},
  [1953] = {.lex_state = 7, .external_lex_state = 3},
  [1954] = {.lex_state = 7, .external_lex_state = 3},
  [1955] = {.lex_state = 7, .external_lex_state = 3},
  [1956] = {.lex_state = 7, .external_lex_state = 3},
  [1957] = {.lex_state = 7, .external_lex_state = 3},
  [1958] = {.lex_state = 7, .external_lex_state = 3},
  [1959] = {.lex_state = 7, .external_lex_state = 3},
  [1960] = {.lex_state = 7, .external_lex_state = 3},
  [1961] = {.lex_state = 7, .external_lex_state = 2},
  [1962] = {.lex_state = 7, .external_lex_state = 3},
  [1963] = {.lex_state = 7, .external_lex_state = 2},
  [1964] = {.lex_state = 7, .external_lex_state = 3},
  [1965] = {.lex_state = 7, .external_lex_state = 3},
  [1966] = {.lex_state = 7, .external_lex_state = 3},
  [1967] = {.lex_state = 7, .external_lex_state = 3},
  [1968] = {.lex_state = 7, .external_lex_state = 3},
  [1969] = {.lex_state = 7, .external_lex_state = 3},
  [1970] = {.lex_state = 7, .external_lex_state = 3},
  [1971] = {.lex_state = 7, .external_lex_state = 3},
  [1972] = {.lex_state = 7, .external_lex_state = 2},
  [1973] = {.lex_state = 7, .external_lex_state = 3},
  [1974] = {.lex_state = 7, .external_lex_state = 3},
  [1975] = {.lex_state = 7, .external_lex_state = 3},
  [1976] = {.lex_state = 7, .external_lex_state = 3},
  [1977] = {.lex_state = 7, .external_lex_state = 3},
  [1978] = {.lex_state = 7, .external_lex_state = 3},
  [1979] = {.lex_state = 7, .external_lex_state = 3},
  [1980] = {.lex_state = 7, .external_lex_state = 3},
  [1981] = {.lex_state = 7, .external_lex_state = 3},
  [1982] = {.lex_state = 7, .external_lex_state = 3},
  [1983] = {.lex_state = 7, .external_lex_state = 3},
  [1984] = {.lex_state = 7, .external_lex_state = 3},
  [1985] = {.lex_state = 7, .external_lex_state = 3},
  [1986] = {.lex_state = 7, .external_lex_state = 3},
  [1987] = {.lex_state = 7, .external_lex_state = 3},
  [1988] = {.lex_state = 7, .external_lex_state = 3},
  [1989] = {.lex_state = 7, .external_lex_state = 3},
  [1990] = {.lex_state = 7, .external_lex_state = 3},
  [1991] = {.lex_state = 7, .external_lex_state = 2},
  [1992] = {.lex_state = 7, .external_lex_state = 2},
  [1993] = {.lex_state = 7, .external_lex_state = 3},
  [1994] = {.lex_state = 7, .external_lex_state = 3},
  [1995] = {.lex_state = 7, .external_lex_state = 3},
  [1996] = {.lex_state = 7, .external_lex_state = 3},
  [1997] = {.lex_state = 7, .external_lex_state = 3},
  [1998] = {.lex_state = 7, .external_lex_state = 3},
  [1999] = {.lex_state = 7, .external_lex_state = 3},
  [2000] = {.lex_state = 7, .external_lex_state = 3},
  [2001] = {.lex_state = 7, .external_lex_state = 3},
  [2002] = {.lex_state = 7, .external_lex_state = 3},
  [2003] = {.lex_state = 7, .external_lex_state = 3},
  [2004] = {.lex_state = 7, .external_lex_state = 3},
  [2005] = {.lex_state = 7, .external_lex_state = 3},
  [2006] = {.lex_state = 7, .external_lex_state = 3},
  [2007] = {.lex_state = 7, .external_lex_state = 3},
  [2008] = {.lex_state = 7, .external_lex_state = 3},
  [2009] = {.lex_state = 7, .external_lex_state = 3},
  [2010] = {.lex_state = 7, .external_lex_state = 3},
  [2011] = {.lex_state = 7, .external_lex_state = 3},
  [2012] = {.lex_state = 7, .external_lex_state = 2},
  [2013] = {.lex_state = 7, .external_lex_state = 3},
  [2014] = {.lex_state = 7, .external_lex_state = 3},
  [2015] = {.lex_state = 7, .external_lex_state = 2},
  [2016] = {.lex_state = 7, .external_lex_state = 3},
  [2017] = {.lex_state = 7, .external_lex_state = 3},
  [2018] = {.lex_state = 7, .external_lex_state = 3},
  [2019] = {.lex_state = 7, .external_lex_state = 2},
  [2020] = {.lex_state = 7, .external_lex_state = 3},
  [2021] = {.lex_state = 8, .external_lex_state = 2},
  [2022] = {.lex_state = 7, .external_lex_state = 3},
  [2023] = {.lex_state = 7, .external_lex_state = 3},
  [2024] = {.lex_state = 7, .external_lex_state = 3},
  [2025] = {.lex_state = 7, .external_lex_state = 3},
  [2026] = {.lex_state = 7, .external_lex_state = 3},
  [2027] = {.lex_state = 7, .external_lex_state = 3},
  [2028] = {.lex_state = 7, .external_lex_state = 3},
  [2029] = {.lex_state = 7, .external_lex_state = 2},
  [2030] = {.lex_state = 7, .external_lex_state = 2},
  [2031] = {.lex_state = 7, .external_lex_state = 3},
  [2032] = {.lex_state = 7, .external_lex_state = 2},
  [2033] = {.lex_state = 7, .external_lex_state = 3},
  [2034] = {.lex_state = 7, .external_lex_state = 3},
  [2035] = {.lex_state = 7, .external_lex_state = 3},
  [2036] = {.lex_state = 7, .external_lex_state = 3},
  [2037] = {.lex_state = 7, .external_lex_state = 3},
  [2038] = {.lex_state = 7, .external_lex_state = 3},
  [2039] = {.lex_state = 7, .external_lex_state = 3},
  [2040] = {.lex_state = 7, .external_lex_state = 2},
  [2041] = {.lex_state = 7, .external_lex_state = 3},
  [2042] = {.lex_state = 7, .external_lex_state = 3},
  [2043] = {.lex_state = 7, .external_lex_state = 2},
  [2044] = {.lex_state = 7, .external_lex_state = 3},
  [2045] = {.lex_state = 7, .external_lex_state = 3},
  [2046] = {.lex_state = 7, .external_lex_state = 2},
  [2047] = {.lex_state = 7, .external_lex_state = 2},
  [2048] = {.lex_state = 7, .external_lex_state = 3},
  [2049] = {.lex_state = 7, .external_lex_state = 2},
  [2050] = {.lex_state = 7, .external_lex_state = 2},
  [2051] = {.lex_state = 7, .external_lex_state = 3},
  [2052] = {.lex_state = 7, .external_lex_state = 3},
  [2053] = {.lex_state = 7, .external_lex_state = 3},
  [2054] = {.lex_state = 7, .external_lex_state = 3},
  [2055] = {.lex_state = 7, .external_lex_state = 3},
  [2056] = {.lex_state = 7, .external_lex_state = 3},
  [2057] = {.lex_state = 7, .external_lex_state = 3},
  [2058] = {.lex_state = 7, .external_lex_state = 3},
  [2059] = {.lex_state = 7, .external_lex_state = 3},
  [2060] = {.lex_state = 7, .external_lex_state = 3},
  [2061] = {.lex_state = 12},
  [2062] = {.lex_state = 7, .external_lex_state = 2},
  [2063] = {.lex_state = 7, .external_lex_state = 3},
  [2064] = {.lex_state = 7, .external_lex_state = 3},
  [2065] = {.lex_state = 7, .external_lex_state = 3},
  [2066] = {.lex_state = 7, .external_lex_state = 2},
  [2067] = {.lex_state = 7, .external_lex_state = 2},
  [2068] = {.lex_state = 7, .external_lex_state = 2},
  [2069] = {.lex_state = 7, .external_lex_state = 2},
  [2070] = {.lex_state = 7, .external_lex_state = 3},
  [2071] = {.lex_state = 7, .external_lex_state = 3},
  [2072] = {.lex_state = 7, .external_lex_state = 2},
  [2073] = {.lex_state = 7, .external_lex_state = 2},
  [2074] = {.lex_state = 7, .external_lex_state = 3},
  [2075] = {.lex_state = 7, .external_lex_state = 3},
  [2076] = {.lex_state = 7, .external_lex_state = 3},
  [2077] = {.lex_state = 7, .external_lex_state = 3},
  [2078] = {.lex_state = 7, .external_lex_state = 2},
  [2079] = {.lex_state = 7, .external_lex_state = 3},
  [2080] = {.lex_state = 7, .external_lex_state = 3},
  [2081] = {.lex_state = 7, .external_lex_state = 3},
  [2082] = {.lex_state = 7, .external_lex_state = 3},
  [2083] = {.lex_state = 7, .external_lex_state = 3},
  [2084] = {.lex_state = 7, .external_lex_state = 3},
  [2085] = {.lex_state = 7, .external_lex_state = 3},
  [2086] = {.lex_state = 7, .external_lex_state = 2},
  [2087] = {.lex_state = 7, .external_lex_state = 3},
  [2088] = {.lex_state = 7, .external_lex_state = 2},
  [2089] = {.lex_state = 7, .external_lex_state = 2},
  [2090] = {.lex_state = 7, .external_lex_state = 3},
  [2091] = {.lex_state = 7, .external_lex_state = 3},
  [2092] = {.lex_state = 7, .external_lex_state = 2},
  [2093] = {.lex_state = 7, .external_lex_state = 2},
  [2094] = {.lex_state = 7, .external_lex_state = 3},
  [2095] = {.lex_state = 12},
  [2096] = {.lex_state = 7, .external_lex_state = 2},
  [2097] = {.lex_state = 7, .external_lex_state = 2},
  [2098] = {.lex_state = 7, .external_lex_state = 3},
  [2099] = {.lex_state = 7, .external_lex_state = 3},
  [2100] = {.lex_state = 7, .external_lex_state = 2},
  [2101] = {.lex_state = 7, .external_lex_state = 3},
  [2102] = {.lex_state = 7, .external_lex_state = 3},
  [2103] = {.lex_state = 7, .external_lex_state = 3},
  [2104] = {.lex_state = 7, .external_lex_state = 2},
  [2105] = {.lex_state = 7, .external_lex_state = 2},
  [2106] = {.lex_state = 7, .external_lex_state = 3},
  [2107] = {.lex_state = 7, .external_lex_state = 2},
  [2108] = {.lex_state = 7, .external_lex_state = 2},
  [2109] = {.lex_state = 7, .external_lex_state = 3},
  [2110] = {.lex_state = 7, .external_lex_state = 3},
  [2111] = {.lex_state = 7, .external_lex_state = 3},
  [2112] = {.lex_state = 7, .external_lex_state = 3},
  [2113] = {.lex_state = 7, .external_lex_state = 3},
  [2114] = {.lex_state = 7, .external_lex_state = 3},
  [2115] = {.lex_state = 7, .external_lex_state = 3},
  [2116] = {.lex_state = 7, .external_lex_state = 2},
  [2117] = {.lex_state = 7, .external_lex_state = 2},
  [2118] = {.lex_state = 7, .external_lex_state = 2},
  [2119] = {.lex_state = 7, .external_lex_state = 3},
  [2120] = {.lex_state = 7, .external_lex_state = 2},
  [2121] = {.lex_state = 7, .external_lex_state = 2},
  [2122] = {.lex_state = 7, .external_lex_state = 3},
  [2123] = {.lex_state = 7, .external_lex_state = 3},
  [2124] = {.lex_state = 7, .external_lex_state = 2},
  [2125] = {.lex_state = 7, .external_lex_state = 2},
  [2126] = {.lex_state = 7, .external_lex_state = 2},
  [2127] = {.lex_state = 7, .external_lex_state = 2},
  [2128] = {.lex_state = 7, .external_lex_state = 3},
  [2129] = {.lex_state = 7, .external_lex_state = 2},
  [2130] = {.lex_state = 7, .external_lex_state = 2},
  [2131] = {.lex_state = 7, .external_lex_state = 3},
  [2132] = {.lex_state = 7, .external_lex_state = 3},
  [2133] = {.lex_state = 7, .external_lex_state = 2},
  [2134] = {.lex_state = 7, .external_lex_state = 2},
  [2135] = {.lex_state = 7, .external_lex_state = 2},
  [2136] = {.lex_state = 7, .external_lex_state = 2},
  [2137] = {.lex_state = 7, .external_lex_state = 2},
  [2138] = {.lex_state = 7, .external_lex_state = 3},
  [2139] = {.lex_state = 7, .external_lex_state = 3},
  [2140] = {.lex_state = 7, .external_lex_state = 2},
  [2141] = {.lex_state = 7, .external_lex_state = 2},
  [2142] = {.lex_state = 7, .external_lex_state = 2},
  [2143] = {.lex_state = 7, .external_lex_state = 3},
  [2144] = {.lex_state = 7, .external_lex_state = 3},
  [2145] = {.lex_state = 7, .external_lex_state = 3},
  [2146] = {.lex_state = 7, .external_lex_state = 2},
  [2147] = {.lex_state = 8, .external_lex_state = 3},
  [2148] = {.lex_state = 7, .external_lex_state = 3},
  [2149] = {.lex_state = 7, .external_lex_state = 3},
  [2150] = {.lex_state = 7, .external_lex_state = 2},
  [2151] = {.lex_state = 7, .external_lex_state = 3},
  [2152] = {.lex_state = 7, .external_lex_state = 3},
  [2153] = {.lex_state = 7, .external_lex_state = 3},
  [2154] = {.lex_state = 7, .external_lex_state = 3},
  [2155] = {.lex_state = 7, .external_lex_state = 3},
  [2156] = {.lex_state = 7, .external_lex_state = 3},
  [2157] = {.lex_state = 7, .external_lex_state = 3},
  [2158] = {.lex_state = 7, .external_lex_state = 3},
  [2159] = {.lex_state = 7, .external_lex_state = 3},
  [2160] = {.lex_state = 7, .external_lex_state = 2},
  [2161] = {.lex_state = 7, .external_lex_state = 2},
  [2162] = {.lex_state = 7, .external_lex_state = 2},
  [2163] = {.lex_state = 7, .external_lex_state = 3},
  [2164] = {.lex_state = 7, .external_lex_state = 2},
  [2165] = {.lex_state = 7, .external_lex_state = 3},
  [2166] = {.lex_state = 7, .external_lex_state = 3},
  [2167] = {.lex_state = 7, .external_lex_state = 3},
  [2168] = {.lex_state = 7, .external_lex_state = 3},
  [2169] = {.lex_state = 7, .external_lex_state = 2},
  [2170] = {.lex_state = 7, .external_lex_state = 2},
  [2171] = {.lex_state = 7, .external_lex_state = 2},
  [2172] = {.lex_state = 7, .external_lex_state = 2},
  [2173] = {.lex_state = 12},
  [2174] = {.lex_state = 7, .external_lex_state = 2},
  [2175] = {.lex_state = 12},
  [2176] = {.lex_state = 7, .external_lex_state = 2},
  [2177] = {.lex_state = 7, .external_lex_state = 2},
  [2178] = {.lex_state = 7, .external_lex_state = 3},
  [2179] = {.lex_state = 7, .external_lex_state = 3},
  [2180] = {.lex_state = 7, .external_lex_state = 3},
  [2181] = {.lex_state = 7, .external_lex_state = 2},
  [2182] = {.lex_state = 7, .external_lex_state = 3},
  [2183] = {.lex_state = 7, .external_lex_state = 2},
  [2184] = {.lex_state = 7, .external_lex_state = 3},
  [2185] = {.lex_state = 7, .external_lex_state = 3},
  [2186] = {.lex_state = 7, .external_lex_state = 3},
  [2187] = {.lex_state = 12},
  [2188] = {.lex_state = 7, .external_lex_state = 3},
  [2189] = {.lex_state = 7, .external_lex_state = 2},
  [2190] = {.lex_state = 7, .external_lex_state = 2},
  [2191] = {.lex_state = 7, .external_lex_state = 3},
  [2192] = {.lex_state = 7, .external_lex_state = 2},
  [2193] = {.lex_state = 7, .external_lex_state = 2},
  [2194] = {.lex_state = 7, .external_lex_state = 2},
  [2195] = {.lex_state = 7, .external_lex_state = 3},
  [2196] = {.lex_state = 7, .external_lex_state = 3},
  [2197] = {.lex_state = 7, .external_lex_state = 2},
  [2198] = {.lex_state = 7, .external_lex_state = 3},
  [2199] = {.lex_state = 7, .external_lex_state = 3},
  [2200] = {.lex_state = 7, .external_lex_state = 3},
  [2201] = {.lex_state = 7, .external_lex_state = 3},
  [2202] = {.lex_state = 7, .external_lex_state = 3},
  [2203] = {.lex_state = 7, .external_lex_state = 3},
  [2204] = {.lex_state = 7, .external_lex_state = 3},
  [2205] = {.lex_state = 7, .external_lex_state = 3},
  [2206] = {.lex_state = 7, .external_lex_state = 2},
  [2207] = {.lex_state = 7, .external_lex_state = 3},
  [2208] = {.lex_state = 8, .external_lex_state = 3},
  [2209] = {.lex_state = 7, .external_lex_state = 3},
  [2210] = {.lex_state = 7, .external_lex_state = 3},
  [2211] = {.lex_state = 7, .external_lex_state = 3},
  [2212] = {.lex_state = 7, .external_lex_state = 3},
  [2213] = {.lex_state = 7, .external_lex_state = 3},
  [2214] = {.lex_state = 7, .external_lex_state = 3},
  [2215] = {.lex_state = 7, .external_lex_state = 3},
  [2216] = {.lex_state = 7, .external_lex_state = 2},
  [2217] = {.lex_state = 7, .external_lex_state = 3},
  [2218] = {.lex_state = 7, .external_lex_state = 2},
  [2219] = {.lex_state = 7, .external_lex_state = 3},
  [2220] = {.lex_state = 7, .external_lex_state = 2},
  [2221] = {.lex_state = 7, .external_lex_state = 2},
  [2222] = {.lex_state = 7, .external_lex_state = 2},
  [2223] = {.lex_state = 7, .external_lex_state = 2},
  [2224] = {.lex_state = 7, .external_lex_state = 2},
  [2225] = {.lex_state = 7, .external_lex_state = 2},
  [2226] = {.lex_state = 7, .external_lex_state = 2},
  [2227] = {.lex_state = 7, .external_lex_state = 2},
  [2228] = {.lex_state = 7, .external_lex_state = 2},
  [2229] = {.lex_state = 7, .external_lex_state = 2},
  [2230] = {.lex_state = 7, .external_lex_state = 3},
  [2231] = {.lex_state = 7, .external_lex_state = 2},
  [2232] = {.lex_state = 7, .external_lex_state = 3},
  [2233] = {.lex_state = 7, .external_lex_state = 2},
  [2234] = {.lex_state = 7, .external_lex_state = 2},
  [2235] = {.lex_state = 7, .external_lex_state = 3},
  [2236] = {.lex_state = 7, .external_lex_state = 3},
  [2237] = {.lex_state = 7, .external_lex_state = 3},
  [2238] = {.lex_state = 7, .external_lex_state = 2},
  [2239] = {.lex_state = 7, .external_lex_state = 3},
  [2240] = {.lex_state = 7, .external_lex_state = 3},
  [2241] = {.lex_state = 7, .external_lex_state = 3},
  [2242] = {.lex_state = 7, .external_lex_state = 3},
  [2243] = {.lex_state = 7, .external_lex_state = 2},
  [2244] = {.lex_state = 7, .external_lex_state = 2},
  [2245] = {.lex_state = 7, .external_lex_state = 2},
  [2246] = {.lex_state = 7, .external_lex_state = 2},
  [2247] = {.lex_state = 7, .external_lex_state = 3},
  [2248] = {.lex_state = 7, .external_lex_state = 3},
  [2249] = {.lex_state = 7, .external_lex_state = 2},
  [2250] = {.lex_state = 7, .external_lex_state = 2},
  [2251] = {.lex_state = 7, .external_lex_state = 2},
  [2252] = {.lex_state = 7, .external_lex_state = 3},
  [2253] = {.lex_state = 7, .external_lex_state = 3},
  [2254] = {.lex_state = 7, .external_lex_state = 3},
  [2255] = {.lex_state = 7, .external_lex_state = 3},
  [2256] = {.lex_state = 7, .external_lex_state = 3},
  [2257] = {.lex_state = 7, .external_lex_state = 2},
  [2258] = {.lex_state = 7, .external_lex_state = 2},
  [2259] = {.lex_state = 7, .external_lex_state = 2},
  [2260] = {.lex_state = 7, .external_lex_state = 2},
  [2261] = {.lex_state = 7, .external_lex_state = 2},
  [2262] = {.lex_state = 7, .external_lex_state = 2},
  [2263] = {.lex_state = 7, .external_lex_state = 2},
  [2264] = {.lex_state = 7, .external_lex_state = 2},
  [2265] = {.lex_state = 7, .external_lex_state = 3},
  [2266] = {.lex_state = 7, .external_lex_state = 2},
  [2267] = {.lex_state = 7, .external_lex_state = 2},
  [2268] = {.lex_state = 7, .external_lex_state = 2},
  [2269] = {.lex_state = 7, .external_lex_state = 2},
  [2270] = {.lex_state = 7, .external_lex_state = 3},
  [2271] = {.lex_state = 7, .external_lex_state = 2},
  [2272] = {.lex_state = 7, .external_lex_state = 2},
  [2273] = {.lex_state = 7, .external_lex_state = 2},
  [2274] = {.lex_state = 7, .external_lex_state = 2},
  [2275] = {.lex_state = 7, .external_lex_state = 2},
  [2276] = {.lex_state = 7, .external_lex_state = 2},
  [2277] = {.lex_state = 7, .external_lex_state = 2},
  [2278] = {.lex_state = 7, .external_lex_state = 3},
  [2279] = {.lex_state = 7, .external_lex_state = 2},
  [2280] = {.lex_state = 7, .external_lex_state = 2},
  [2281] = {.lex_state = 7, .external_lex_state = 2},
  [2282] = {.lex_state = 7, .external_lex_state = 2},
  [2283] = {.lex_state = 7, .external_lex_state = 2},
  [2284] = {.lex_state = 7, .external_lex_state = 2},
  [2285] = {.lex_state = 7, .external_lex_state = 2},
  [2286] = {.lex_state = 7, .external_lex_state = 2},
  [2287] = {.lex_state = 7, .external_lex_state = 2},
  [2288] = {.lex_state = 7, .external_lex_state = 2},
  [2289] = {.lex_state = 7, .external_lex_state = 2},
  [2290] = {.lex_state = 7, .external_lex_state = 2},
  [2291] = {.lex_state = 7, .external_lex_state = 2},
  [2292] = {.lex_state = 7, .external_lex_state = 2},
  [2293] = {.lex_state = 7, .external_lex_state = 2},
  [2294] = {.lex_state = 7, .external_lex_state = 2},
  [2295] = {.lex_state = 7, .external_lex_state = 2},
  [2296] = {.lex_state = 7, .external_lex_state = 2},
  [2297] = {.lex_state = 7, .external_lex_state = 2},
  [2298] = {.lex_state = 7, .external_lex_state = 2},
  [2299] = {.lex_state = 7, .external_lex_state = 2},
  [2300] = {.lex_state = 7, .external_lex_state = 2},
  [2301] = {.lex_state = 7, .external_lex_state = 2},
  [2302] = {.lex_state = 7, .external_lex_state = 2},
  [2303] = {.lex_state = 7, .external_lex_state = 2},
  [2304] = {.lex_state = 7, .external_lex_state = 2},
  [2305] = {.lex_state = 7, .external_lex_state = 2},
  [2306] = {.lex_state = 7, .external_lex_state = 2},
  [2307] = {.lex_state = 7, .external_lex_state = 2},
  [2308] = {.lex_state = 7, .external_lex_state = 2},
  [2309] = {.lex_state = 7, .external_lex_state = 2},
  [2310] = {.lex_state = 7, .external_lex_state = 2},
  [2311] = {.lex_state = 7, .external_lex_state = 2},
  [2312] = {.lex_state = 7, .external_lex_state = 2},
  [2313] = {.lex_state = 7, .external_lex_state = 2},
  [2314] = {.lex_state = 7, .external_lex_state = 2},
  [2315] = {.lex_state = 7, .external_lex_state = 2},
  [2316] = {.lex_state = 7, .external_lex_state = 2},
  [2317] = {.lex_state = 12, .external_lex_state = 4},
  [2318] = {.lex_state = 12, .external_lex_state = 4},
  [2319] = {.lex_state = 7, .external_lex_state = 2},
  [2320] = {.lex_state = 12},
  [2321] = {.lex_state = 12, .external_lex_state = 4},
  [2322] = {.lex_state = 7, .external_lex_state = 3},
  [2323] = {.lex_state = 93, .external_lex_state = 4},
  [2324] = {.lex_state = 12, .external_lex_state = 4},
  [2325] = {.lex_state = 93, .external_lex_state = 4},
  [2326] = {.lex_state = 12, .external_lex_state = 4},
  [2327] = {.lex_state = 7, .external_lex_state = 2},
  [2328] = {.lex_state = 12, .external_lex_state = 4},
  [2329] = {.lex_state = 12, .external_lex_state = 4},
  [2330] = {.lex_state = 12},
  [2331] = {.lex_state = 7, .external_lex_state = 3},
  [2332] = {.lex_state = 12, .external_lex_state = 4},
  [2333] = {.lex_state = 7, .external_lex_state = 2},
  [2334] = {.lex_state = 7, .external_lex_state = 2},
  [2335] = {.lex_state = 12, .external_lex_state = 4},
  [2336] = {.lex_state = 12},
  [2337] = {.lex_state = 7, .external_lex_state = 2},
  [2338] = {.lex_state = 7, .external_lex_state = 2},
  [2339] = {.lex_state = 12, .external_lex_state = 4},
  [2340] = {.lex_state = 12, .external_lex_state = 4},
  [2341] = {.lex_state = 12},
  [2342] = {.lex_state = 12, .external_lex_state = 4},
  [2343] = {.lex_state = 7, .external_lex_state = 2},
  [2344] = {.lex_state = 7, .external_lex_state = 2},
  [2345] = {.lex_state = 12},
  [2346] = {.lex_state = 12},
  [2347] = {.lex_state = 12, .external_lex_state = 4},
  [2348] = {.lex_state = 8, .external_lex_state = 2},
  [2349] = {.lex_state = 7, .external_lex_state = 2},
  [2350] = {.lex_state = 12, .external_lex_state = 4},
  [2351] = {.lex_state = 7, .external_lex_state = 2},
  [2352] = {.lex_state = 7, .external_lex_state = 2},
  [2353] = {.lex_state = 7, .external_lex_state = 2},
  [2354] = {.lex_state = 7, .external_lex_state = 2},
  [2355] = {.lex_state = 7, .external_lex_state = 2},
  [2356] = {.lex_state = 7, .external_lex_state = 2},
  [2357] = {.lex_state = 7, .external_lex_state = 2},
  [2358] = {.lex_state = 93},
  [2359] = {.lex_state = 7, .external_lex_state = 2},
  [2360] = {.lex_state = 12, .external_lex_state = 4},
  [2361] = {.lex_state = 12},
  [2362] = {.lex_state = 7, .external_lex_state = 3},
  [2363] = {.lex_state = 7, .external_lex_state = 2},
  [2364] = {.lex_state = 12, .external_lex_state = 4},
  [2365] = {.lex_state = 7, .external_lex_state = 2},
  [2366] = {.lex_state = 7, .external_lex_state = 2},
  [2367] = {.lex_state = 12},
  [2368] = {.lex_state = 12, .external_lex_state = 4},
  [2369] = {.lex_state = 7, .external_lex_state = 2},
  [2370] = {.lex_state = 7, .external_lex_state = 2},
  [2371] = {.lex_state = 7, .external_lex_state = 2},
  [2372] = {.lex_state = 7, .external_lex_state = 2},
  [2373] = {.lex_state = 7, .external_lex_state = 2},
  [2374] = {.lex_state = 7, .external_lex_state = 2},
  [2375] = {.lex_state = 7, .external_lex_state = 2},
  [2376] = {.lex_state = 12},
  [2377] = {.lex_state = 7, .external_lex_state = 2},
  [2378] = {.lex_state = 7, .external_lex_state = 2},
  [2379] = {.lex_state = 7, .external_lex_state = 2},
  [2380] = {.lex_state = 12, .external_lex_state = 4},
  [2381] = {.lex_state = 7, .external_lex_state = 2},
  [2382] = {.lex_state = 7, .external_lex_state = 2},
  [2383] = {.lex_state = 12, .external_lex_state = 4},
  [2384] = {.lex_state = 7, .external_lex_state = 2},
  [2385] = {.lex_state = 12, .external_lex_state = 4},
  [2386] = {.lex_state = 7, .external_lex_state = 2},
  [2387] = {.lex_state = 12, .external_lex_state = 4},
  [2388] = {.lex_state = 12},
  [2389] = {.lex_state = 12},
  [2390] = {.lex_state = 7, .external_lex_state = 2},
  [2391] = {.lex_state = 12, .external_lex_state = 4},
  [2392] = {.lex_state = 7, .external_lex_state = 2},
  [2393] = {.lex_state = 7, .external_lex_state = 2},
  [2394] = {.lex_state = 7, .external_lex_state = 2},
  [2395] = {.lex_state = 12, .external_lex_state = 4},
  [2396] = {.lex_state = 7, .external_lex_state = 2},
  [2397] = {.lex_state = 7, .external_lex_state = 3},
  [2398] = {.lex_state = 7, .external_lex_state = 2},
  [2399] = {.lex_state = 7, .external_lex_state = 2},
  [2400] = {.lex_state = 12},
  [2401] = {.lex_state = 7, .external_lex_state = 2},
  [2402] = {.lex_state = 12},
  [2403] = {.lex_state = 7, .external_lex_state = 2},
  [2404] = {.lex_state = 93},
  [2405] = {.lex_state = 7, .external_lex_state = 2},
  [2406] = {.lex_state = 12},
  [2407] = {.lex_state = 7, .external_lex_state = 3},
  [2408] = {.lex_state = 12},
  [2409] = {.lex_state = 12},
  [2410] = {.lex_state = 12},
  [2411] = {.lex_state = 12},
  [2412] = {.lex_state = 93},
  [2413] = {.lex_state = 12},
  [2414] = {.lex_state = 12},
  [2415] = {.lex_state = 93},
  [2416] = {.lex_state = 7, .external_lex_state = 2},
  [2417] = {.lex_state = 7, .external_lex_state = 2},
  [2418] = {.lex_state = 7, .external_lex_state = 2},
  [2419] = {.lex_state = 12},
  [2420] = {.lex_state = 93},
  [2421] = {.lex_state = 7, .external_lex_state = 2},
  [2422] = {.lex_state = 12},
  [2423] = {.lex_state = 12},
  [2424] = {.lex_state = 12},
  [2425] = {.lex_state = 12},
  [2426] = {.lex_state = 12},
  [2427] = {.lex_state = 12},
  [2428] = {.lex_state = 7, .external_lex_state = 2},
  [2429] = {.lex_state = 7, .external_lex_state = 2},
  [2430] = {.lex_state = 7, .external_lex_state = 3},
  [2431] = {.lex_state = 12},
  [2432] = {.lex_state = 12},
  [2433] = {.lex_state = 93},
  [2434] = {.lex_state = 12},
  [2435] = {.lex_state = 7, .external_lex_state = 3},
  [2436] = {.lex_state = 12},
  [2437] = {.lex_state = 11},
  [2438] = {.lex_state = 7, .external_lex_state = 2},
  [2439] = {.lex_state = 7, .external_lex_state = 2},
  [2440] = {.lex_state = 7, .external_lex_state = 2},
  [2441] = {.lex_state = 7, .external_lex_state = 2},
  [2442] = {.lex_state = 93},
  [2443] = {.lex_state = 11},
  [2444] = {.lex_state = 12},
  [2445] = {.lex_state = 7, .external_lex_state = 2},
  [2446] = {.lex_state = 5},
  [2447] = {.lex_state = 8, .external_lex_state = 2},
  [2448] = {.lex_state = 12},
  [2449] = {.lex_state = 7, .external_lex_state = 2},
  [2450] = {.lex_state = 93},
  [2451] = {.lex_state = 93},
  [2452] = {.lex_state = 93},
  [2453] = {.lex_state = 93},
  [2454] = {.lex_state = 93},
  [2455] = {.lex_state = 93},
  [2456] = {.lex_state = 93},
  [2457] = {.lex_state = 93},
  [2458] = {.lex_state = 93},
  [2459] = {.lex_state = 93},
  [2460] = {.lex_state = 5},
  [2461] = {.lex_state = 7, .external_lex_state = 2},
  [2462] = {.lex_state = 7, .external_lex_state = 2},
  [2463] = {.lex_state = 11},
  [2464] = {.lex_state = 7, .external_lex_state = 2},
  [2465] = {.lex_state = 12},
  [2466] = {.lex_state = 93},
  [2467] = {.lex_state = 7, .external_lex_state = 2},
  [2468] = {.lex_state = 93},
  [2469] = {.lex_state = 93},
  [2470] = {.lex_state = 12},
  [2471] = {.lex_state = 12},
  [2472] = {.lex_state = 93},
  [2473] = {.lex_state = 93},
  [2474] = {.lex_state = 93},
  [2475] = {.lex_state = 12},
  [2476] = {.lex_state = 11},
  [2477] = {.lex_state = 7, .external_lex_state = 2},
  [2478] = {.lex_state = 93},
  [2479] = {.lex_state = 93},
  [2480] = {.lex_state = 11},
  [2481] = {.lex_state = 93},
  [2482] = {.lex_state = 11},
  [2483] = {.lex_state = 93},
  [2484] = {.lex_state = 93},
  [2485] = {.lex_state = 11},
  [2486] = {.lex_state = 11},
  [2487] = {.lex_state = 11},
  [2488] = {.lex_state = 11},
  [2489] = {.lex_state = 93, .external_lex_state = 4},
  [2490] = {.lex_state = 11},
  [2491] = {.lex_state = 11},
  [2492] = {.lex_state = 11},
  [2493] = {.lex_state = 11},
  [2494] = {.lex_state = 93, .external_lex_state = 4},
  [2495] = {.lex_state = 11},
  [2496] = {.lex_state = 11},
  [2497] = {.lex_state = 11},
  [2498] = {.lex_state = 93},
  [2499] = {.lex_state = 12},
  [2500] = {.lex_state = 93},
  [2501] = {.lex_state = 93},
  [2502] = {.lex_state = 11},
  [2503] = {.lex_state = 93, .external_lex_state = 4},
  [2504] = {.lex_state = 93, .external_lex_state = 4},
  [2505] = {.lex_state = 11},
  [2506] = {.lex_state = 93, .external_lex_state = 4},
  [2507] = {.lex_state = 93},
  [2508] = {.lex_state = 93},
  [2509] = {.lex_state = 93},
  [2510] = {.lex_state = 93},
  [2511] = {.lex_state = 93},
  [2512] = {.lex_state = 93},
  [2513] = {.lex_state = 93},
  [2514] = {.lex_state = 93},
  [2515] = {.lex_state = 93},
  [2516] = {.lex_state = 93},
  [2517] = {.lex_state = 93},
  [2518] = {.lex_state = 93},
  [2519] = {.lex_state = 93, .external_lex_state = 4},
  [2520] = {.lex_state = 93},
  [2521] = {.lex_state = 93},
  [2522] = {.lex_state = 93},
  [2523] = {.lex_state = 93},
  [2524] = {.lex_state = 93},
  [2525] = {.lex_state = 93},
  [2526] = {.lex_state = 93},
  [2527] = {.lex_state = 93, .external_lex_state = 4},
  [2528] = {.lex_state = 93},
  [2529] = {.lex_state = 93},
  [2530] = {.lex_state = 93},
  [2531] = {.lex_state = 93},
  [2532] = {.lex_state = 93},
  [2533] = {.lex_state = 93},
  [2534] = {.lex_state = 93},
  [2535] = {.lex_state = 93},
  [2536] = {.lex_state = 93},
  [2537] = {.lex_state = 93},
  [2538] = {.lex_state = 93, .external_lex_state = 4},
  [2539] = {.lex_state = 93},
  [2540] = {.lex_state = 93, .external_lex_state = 4},
  [2541] = {.lex_state = 93},
  [2542] = {.lex_state = 93},
  [2543] = {.lex_state = 93, .external_lex_state = 4},
  [2544] = {.lex_state = 93},
  [2545] = {.lex_state = 93},
  [2546] = {.lex_state = 93},
  [2547] = {.lex_state = 93},
  [2548] = {.lex_state = 93},
  [2549] = {.lex_state = 93, .external_lex_state = 4},
  [2550] = {.lex_state = 93, .external_lex_state = 4},
  [2551] = {.lex_state = 93},
  [2552] = {.lex_state = 93, .external_lex_state = 4},
  [2553] = {.lex_state = 93},
  [2554] = {.lex_state = 93},
  [2555] = {.lex_state = 93},
  [2556] = {.lex_state = 93, .external_lex_state = 4},
  [2557] = {.lex_state = 93},
  [2558] = {.lex_state = 93},
  [2559] = {.lex_state = 93},
  [2560] = {.lex_state = 93},
  [2561] = {.lex_state = 93},
  [2562] = {.lex_state = 93},
  [2563] = {.lex_state = 93},
  [2564] = {.lex_state = 93},
  [2565] = {.lex_state = 93},
  [2566] = {.lex_state = 93},
  [2567] = {.lex_state = 93},
  [2568] = {.lex_state = 93},
  [2569] = {.lex_state = 93},
  [2570] = {.lex_state = 93},
  [2571] = {.lex_state = 93},
  [2572] = {.lex_state = 93},
  [2573] = {.lex_state = 93},
  [2574] = {.lex_state = 93},
  [2575] = {.lex_state = 93},
  [2576] = {.lex_state = 93},
  [2577] = {.lex_state = 93},
  [2578] = {.lex_state = 93},
  [2579] = {.lex_state = 93},
  [2580] = {.lex_state = 93},
  [2581] = {.lex_state = 93},
  [2582] = {.lex_state = 93},
  [2583] = {.lex_state = 93},
  [2584] = {.lex_state = 93},
  [2585] = {.lex_state = 93},
  [2586] = {.lex_state = 93},
  [2587] = {.lex_state = 93},
  [2588] = {.lex_state = 93},
  [2589] = {.lex_state = 93},
  [2590] = {.lex_state = 93},
  [2591] = {.lex_state = 93},
  [2592] = {.lex_state = 93},
  [2593] = {.lex_state = 93},
  [2594] = {.lex_state = 93},
  [2595] = {.lex_state = 93},
  [2596] = {.lex_state = 93},
  [2597] = {.lex_state = 93},
  [2598] = {.lex_state = 93},
  [2599] = {.lex_state = 93},
  [2600] = {.lex_state = 93},
  [2601] = {.lex_state = 93},
  [2602] = {.lex_state = 93},
  [2603] = {.lex_state = 93},
  [2604] = {.lex_state = 93},
  [2605] = {.lex_state = 93},
  [2606] = {.lex_state = 93},
  [2607] = {.lex_state = 93},
  [2608] = {.lex_state = 93},
  [2609] = {.lex_state = 93},
  [2610] = {.lex_state = 93},
  [2611] = {.lex_state = 93},
  [2612] = {.lex_state = 93},
  [2613] = {.lex_state = 93},
  [2614] = {.lex_state = 93},
  [2615] = {.lex_state = 93},
  [2616] = {.lex_state = 93},
  [2617] = {.lex_state = 93},
  [2618] = {.lex_state = 93},
  [2619] = {.lex_state = 93},
  [2620] = {.lex_state = 93},
  [2621] = {.lex_state = 93},
  [2622] = {.lex_state = 93},
  [2623] = {.lex_state = 93},
  [2624] = {.lex_state = 93},
  [2625] = {.lex_state = 93},
  [2626] = {.lex_state = 93},
  [2627] = {.lex_state = 93},
  [2628] = {.lex_state = 93},
  [2629] = {.lex_state = 93},
  [2630] = {.lex_state = 93},
  [2631] = {.lex_state = 93},
  [2632] = {.lex_state = 93},
  [2633] = {.lex_state = 93},
  [2634] = {.lex_state = 93},
  [2635] = {.lex_state = 93},
  [2636] = {.lex_state = 93},
  [2637] = {.lex_state = 93},
  [2638] = {.lex_state = 93},
  [2639] = {.lex_state = 93},
  [2640] = {.lex_state = 93},
  [2641] = {.lex_state = 93},
  [2642] = {.lex_state = 93},
  [2643] = {.lex_state = 93},
  [2644] = {.lex_state = 93},
  [2645] = {.lex_state = 93},
  [2646] = {.lex_state = 93},
  [2647] = {.lex_state = 93},
  [2648] = {.lex_state = 93},
  [2649] = {.lex_state = 93},
  [2650] = {.lex_state = 93},
  [2651] = {.lex_state = 93},
  [2652] = {.lex_state = 93},
  [2653] = {.lex_state = 93},
  [2654] = {.lex_state = 93},
  [2655] = {.lex_state = 93},
  [2656] = {.lex_state = 93},
  [2657] = {.lex_state = 93},
  [2658] = {.lex_state = 93},
  [2659] = {.lex_state = 93},
  [2660] = {.lex_state = 93},
  [2661] = {.lex_state = 93},
  [2662] = {.lex_state = 93},
  [2663] = {.lex_state = 93},
  [2664] = {.lex_state = 93},
  [2665] = {.lex_state = 93},
  [2666] = {.lex_state = 93},
  [2667] = {.lex_state = 93},
  [2668] = {.lex_state = 93},
  [2669] = {.lex_state = 93},
  [2670] = {.lex_state = 93},
  [2671] = {.lex_state = 93},
  [2672] = {.lex_state = 93},
  [2673] = {.lex_state = 93},
  [2674] = {.lex_state = 93},
  [2675] = {.lex_state = 93},
  [2676] = {.lex_state = 93},
  [2677] = {.lex_state = 93},
  [2678] = {.lex_state = 93},
  [2679] = {.lex_state = 93},
  [2680] = {.lex_state = 93},
  [2681] = {.lex_state = 93},
  [2682] = {.lex_state = 93},
  [2683] = {.lex_state = 93},
  [2684] = {.lex_state = 93},
  [2685] = {.lex_state = 93},
  [2686] = {.lex_state = 93},
  [2687] = {.lex_state = 93},
  [2688] = {.lex_state = 93},
  [2689] = {.lex_state = 93},
  [2690] = {.lex_state = 93},
  [2691] = {.lex_state = 93},
  [2692] = {.lex_state = 93},
  [2693] = {.lex_state = 93},
  [2694] = {.lex_state = 93},
  [2695] = {.lex_state = 93},
  [2696] = {.lex_state = 93},
  [2697] = {.lex_state = 93},
  [2698] = {.lex_state = 93},
  [2699] = {.lex_state = 93},
  [2700] = {.lex_state = 93},
  [2701] = {.lex_state = 93},
  [2702] = {.lex_state = 93},
  [2703] = {.lex_state = 93},
  [2704] = {.lex_state = 93},
  [2705] = {.lex_state = 93},
  [2706] = {.lex_state = 93},
  [2707] = {.lex_state = 93},
  [2708] = {.lex_state = 93},
  [2709] = {.lex_state = 93},
  [2710] = {.lex_state = 93},
  [2711] = {.lex_state = 93},
  [2712] = {.lex_state = 93},
  [2713] = {.lex_state = 93},
  [2714] = {.lex_state = 93},
  [2715] = {.lex_state = 93},
  [2716] = {.lex_state = 93},
  [2717] = {.lex_state = 93},
  [2718] = {.lex_state = 93},
  [2719] = {.lex_state = 93},
  [2720] = {.lex_state = 93},
  [2721] = {.lex_state = 93},
  [2722] = {.lex_state = 93},
  [2723] = {.lex_state = 93},
  [2724] = {.lex_state = 93},
  [2725] = {.lex_state = 93},
  [2726] = {.lex_state = 93},
  [2727] = {.lex_state = 93},
  [2728] = {.lex_state = 93},
  [2729] = {.lex_state = 93},
  [2730] = {.lex_state = 93},
  [2731] = {.lex_state = 93},
  [2732] = {.lex_state = 93},
  [2733] = {.lex_state = 93},
  [2734] = {.lex_state = 93},
  [2735] = {.lex_state = 93},
  [2736] = {.lex_state = 93},
  [2737] = {.lex_state = 93},
  [2738] = {.lex_state = 93},
  [2739] = {.lex_state = 93},
  [2740] = {.lex_state = 93},
  [2741] = {.lex_state = 93},
  [2742] = {.lex_state = 93},
  [2743] = {.lex_state = 93},
  [2744] = {.lex_state = 93},
  [2745] = {.lex_state = 93},
  [2746] = {.lex_state = 93},
  [2747] = {.lex_state = 93},
  [2748] = {.lex_state = 93},
  [2749] = {.lex_state = 93},
  [2750] = {.lex_state = 93},
  [2751] = {.lex_state = 93},
  [2752] = {.lex_state = 93},
  [2753] = {.lex_state = 93},
  [2754] = {.lex_state = 93},
  [2755] = {.lex_state = 93},
  [2756] = {.lex_state = 93},
  [2757] = {.lex_state = 93},
  [2758] = {.lex_state = 93},
  [2759] = {.lex_state = 93},
  [2760] = {.lex_state = 93},
  [2761] = {.lex_state = 93},
  [2762] = {.lex_state = 93},
  [2763] = {.lex_state = 93},
  [2764] = {.lex_state = 93},
  [2765] = {.lex_state = 93},
  [2766] = {.lex_state = 93},
  [2767] = {.lex_state = 5},
  [2768] = {.lex_state = 93},
  [2769] = {.lex_state = 93},
  [2770] = {.lex_state = 93},
  [2771] = {.lex_state = 93},
  [2772] = {.lex_state = 93},
  [2773] = {.lex_state = 93},
  [2774] = {.lex_state = 93},
  [2775] = {.lex_state = 93},
  [2776] = {.lex_state = 93, .external_lex_state = 4},
  [2777] = {.lex_state = 93},
  [2778] = {.lex_state = 93},
  [2779] = {.lex_state = 93},
  [2780] = {.lex_state = 5},
  [2781] = {.lex_state = 93},
  [2782] = {.lex_state = 93},
  [2783] = {.lex_state = 5},
  [2784] = {.lex_state = 93},
  [2785] = {.lex_state = 93},
  [2786] = {.lex_state = 93},
  [2787] = {.lex_state = 93},
  [2788] = {.lex_state = 20},
  [2789] = {.lex_state = 20},
  [2790] = {.lex_state = 20},
  [2791] = {.lex_state = 20},
  [2792] = {.lex_state = 20},
  [2793] = {.lex_state = 20},
  [2794] = {.lex_state = 20},
  [2795] = {.lex_state = 15, .external_lex_state = 4},
  [2796] = {.lex_state = 20},
  [2797] = {.lex_state = 20},
  [2798] = {.lex_state = 20},
  [2799] = {.lex_state = 20},
  [2800] = {.lex_state = 20},
  [2801] = {.lex_state = 20},
  [2802] = {.lex_state = 20},
  [2803] = {.lex_state = 20},
  [2804] = {.lex_state = 20},
  [2805] = {.lex_state = 20},
  [2806] = {.lex_state = 20},
  [2807] = {.lex_state = 20},
  [2808] = {.lex_state = 20},
  [2809] = {.lex_state = 20},
  [2810] = {.lex_state = 20},
  [2811] = {.lex_state = 20},
  [2812] = {.lex_state = 20},
  [2813] = {.lex_state = 20},
  [2814] = {.lex_state = 20},
  [2815] = {.lex_state = 20},
  [2816] = {.lex_state = 20},
  [2817] = {.lex_state = 20},
  [2818] = {.lex_state = 20},
  [2819] = {.lex_state = 20},
  [2820] = {.lex_state = 20},
  [2821] = {.lex_state = 15},
  [2822] = {.lex_state = 20},
  [2823] = {.lex_state = 20},
  [2824] = {.lex_state = 15, .external_lex_state = 4},
  [2825] = {.lex_state = 20},
  [2826] = {.lex_state = 20},
  [2827] = {.lex_state = 20},
  [2828] = {.lex_state = 20},
  [2829] = {.lex_state = 20},
  [2830] = {.lex_state = 20},
  [2831] = {.lex_state = 15},
  [2832] = {.lex_state = 20},
  [2833] = {.lex_state = 20},
  [2834] = {.lex_state = 20},
  [2835] = {.lex_state = 20},
  [2836] = {.lex_state = 11},
  [2837] = {.lex_state = 16},
  [2838] = {.lex_state = 11},
  [2839] = {.lex_state = 11},
  [2840] = {.lex_state = 11},
  [2841] = {.lex_state = 11},
  [2842] = {.lex_state = 93},
  [2843] = {.lex_state = 11},
  [2844] = {.lex_state = 11},
  [2845] = {.lex_state = 11},
  [2846] = {.lex_state = 11},
  [2847] = {.lex_state = 11},
  [2848] = {.lex_state = 11},
  [2849] = {.lex_state = 11},
  [2850] = {.lex_state = 11},
  [2851] = {.lex_state = 11},
  [2852] = {.lex_state = 11},
  [2853] = {.lex_state = 11},
  [2854] = {.lex_state = 11},
  [2855] = {.lex_state = 11},
  [2856] = {.lex_state = 93},
  [2857] = {.lex_state = 11},
  [2858] = {.lex_state = 93},
  [2859] = {.lex_state = 15, .external_lex_state = 4},
  [2860] = {.lex_state = 11},
  [2861] = {.lex_state = 93},
  [2862] = {.lex_state = 11},
  [2863] = {.lex_state = 93},
  [2864] = {.lex_state = 11},
  [2865] = {.lex_state = 93},
  [2866] = {.lex_state = 93},
  [2867] = {.lex_state = 11},
  [2868] = {.lex_state = 11},
  [2869] = {.lex_state = 11},
  [2870] = {.lex_state = 20, .external_lex_state = 4},
  [2871] = {.lex_state = 20, .external_lex_state = 4},
  [2872] = {.lex_state = 20, .external_lex_state = 4},
  [2873] = {.lex_state = 11},
  [2874] = {.lex_state = 11},
  [2875] = {.lex_state = 11},
  [2876] = {.lex_state = 93},
  [2877] = {.lex_state = 11},
  [2878] = {.lex_state = 93},
  [2879] = {.lex_state = 11},
  [2880] = {.lex_state = 11},
  [2881] = {.lex_state = 11},
  [2882] = {.lex_state = 20, .external_lex_state = 4},
  [2883] = {.lex_state = 11},
  [2884] = {.lex_state = 20, .external_lex_state = 4},
  [2885] = {.lex_state = 20, .external_lex_state = 4},
  [2886] = {.lex_state = 20, .external_lex_state = 4},
  [2887] = {.lex_state = 20, .external_lex_state = 4},
  [2888] = {.lex_state = 20, .external_lex_state = 4},
  [2889] = {.lex_state = 20, .external_lex_state = 4},
  [2890] = {.lex_state = 20, .external_lex_state = 4},
  [2891] = {.lex_state = 20, .external_lex_state = 4},
  [2892] = {.lex_state = 20, .external_lex_state = 4},
  [2893] = {.lex_state = 20, .external_lex_state = 4},
  [2894] = {.lex_state = 20, .external_lex_state = 4},
  [2895] = {.lex_state = 20, .external_lex_state = 4},
  [2896] = {.lex_state = 20, .external_lex_state = 4},
  [2897] = {.lex_state = 93},
  [2898] = {.lex_state = 20, .external_lex_state = 4},
  [2899] = {.lex_state = 93},
  [2900] = {.lex_state = 93},
  [2901] = {.lex_state = 15, .external_lex_state = 4},
  [2902] = {.lex_state = 20, .external_lex_state = 4},
  [2903] = {.lex_state = 12, .external_lex_state = 4},
  [2904] = {.lex_state = 11},
  [2905] = {.lex_state = 11},
  [2906] = {.lex_state = 20, .external_lex_state = 4},
  [2907] = {.lex_state = 20, .external_lex_state = 4},
  [2908] = {.lex_state = 12, .external_lex_state = 4},
  [2909] = {.lex_state = 20, .external_lex_state = 4},
  [2910] = {.lex_state = 11},
  [2911] = {.lex_state = 20, .external_lex_state = 4},
  [2912] = {.lex_state = 12, .external_lex_state = 4},
  [2913] = {.lex_state = 11},
  [2914] = {.lex_state = 11},
  [2915] = {.lex_state = 93},
  [2916] = {.lex_state = 93},
  [2917] = {.lex_state = 93},
  [2918] = {.lex_state = 93},
  [2919] = {.lex_state = 11},
  [2920] = {.lex_state = 11},
  [2921] = {.lex_state = 20, .external_lex_state = 4},
  [2922] = {.lex_state = 12, .external_lex_state = 4},
  [2923] = {.lex_state = 12, .external_lex_state = 4},
  [2924] = {.lex_state = 12, .external_lex_state = 4},
  [2925] = {.lex_state = 20, .external_lex_state = 4},
  [2926] = {.lex_state = 93},
  [2927] = {.lex_state = 93},
  [2928] = {.lex_state = 93},
  [2929] = {.lex_state = 93},
  [2930] = {.lex_state = 20, .external_lex_state = 4},
  [2931] = {.lex_state = 20, .external_lex_state = 4},
  [2932] = {.lex_state = 93},
  [2933] = {.lex_state = 93},
  [2934] = {.lex_state = 93},
  [2935] = {.lex_state = 93},
  [2936] = {.lex_state = 93},
  [2937] = {.lex_state = 12, .external_lex_state = 4},
  [2938] = {.lex_state = 20, .external_lex_state = 4},
  [2939] = {.lex_state = 20, .external_lex_state = 4},
  [2940] = {.lex_state = 20, .external_lex_state = 4},
  [2941] = {.lex_state = 20, .external_lex_state = 4},
  [2942] = {.lex_state = 93},
  [2943] = {.lex_state = 93},
  [2944] = {.lex_state = 93},
  [2945] = {.lex_state = 93},
  [2946] = {.lex_state = 20, .external_lex_state = 4},
  [2947] = {.lex_state = 20, .external_lex_state = 4},
  [2948] = {.lex_state = 20, .external_lex_state = 4},
  [2949] = {.lex_state = 20, .external_lex_state = 4},
  [2950] = {.lex_state = 20, .external_lex_state = 4},
  [2951] = {.lex_state = 20, .external_lex_state = 4},
  [2952] = {.lex_state = 12, .external_lex_state = 4},
  [2953] = {.lex_state = 15, .external_lex_state = 5},
  [2954] = {.lex_state = 15, .external_lex_state = 4},
  [2955] = {.lex_state = 12, .external_lex_state = 4},
  [2956] = {.lex_state = 12, .external_lex_state = 4},
  [2957] = {.lex_state = 12, .external_lex_state = 4},
  [2958] = {.lex_state = 12, .external_lex_state = 4},
  [2959] = {.lex_state = 20, .external_lex_state = 4},
  [2960] = {.lex_state = 20, .external_lex_state = 5},
  [2961] = {.lex_state = 20, .external_lex_state = 5},
  [2962] = {.lex_state = 20, .external_lex_state = 5},
  [2963] = {.lex_state = 93},
  [2964] = {.lex_state = 12, .external_lex_state = 4},
  [2965] = {.lex_state = 20, .external_lex_state = 4},
  [2966] = {.lex_state = 12, .external_lex_state = 4},
  [2967] = {.lex_state = 93},
  [2968] = {.lex_state = 12, .external_lex_state = 4},
  [2969] = {.lex_state = 20, .external_lex_state = 4},
  [2970] = {.lex_state = 15},
  [2971] = {.lex_state = 20, .external_lex_state = 4},
  [2972] = {.lex_state = 12, .external_lex_state = 4},
  [2973] = {.lex_state = 20, .external_lex_state = 4},
  [2974] = {.lex_state = 16, .external_lex_state = 4},
  [2975] = {.lex_state = 20, .external_lex_state = 4},
  [2976] = {.lex_state = 12, .external_lex_state = 4},
  [2977] = {.lex_state = 93},
  [2978] = {.lex_state = 20, .external_lex_state = 4},
  [2979] = {.lex_state = 15, .external_lex_state = 5},
  [2980] = {.lex_state = 20, .external_lex_state = 5},
  [2981] = {.lex_state = 12, .external_lex_state = 4},
  [2982] = {.lex_state = 12, .external_lex_state = 4},
  [2983] = {.lex_state = 12, .external_lex_state = 4},
  [2984] = {.lex_state = 12, .external_lex_state = 4},
  [2985] = {.lex_state = 12, .external_lex_state = 4},
  [2986] = {.lex_state = 12, .external_lex_state = 4},
  [2987] = {.lex_state = 12, .external_lex_state = 4},
  [2988] = {.lex_state = 12, .external_lex_state = 4},
  [2989] = {.lex_state = 12, .external_lex_state = 4},
  [2990] = {.lex_state = 12, .external_lex_state = 4},
  [2991] = {.lex_state = 12, .external_lex_state = 4},
  [2992] = {.lex_state = 12, .external_lex_state = 4},
  [2993] = {.lex_state = 12, .external_lex_state = 4},
  [2994] = {.lex_state = 20, .external_lex_state = 5},
  [2995] = {.lex_state = 20, .external_lex_state = 5},
  [2996] = {.lex_state = 20, .external_lex_state = 5},
  [2997] = {.lex_state = 11, .external_lex_state = 4},
  [2998] = {.lex_state = 20, .external_lex_state = 5},
  [2999] = {.lex_state = 20, .external_lex_state = 5},
  [3000] = {.lex_state = 20, .external_lex_state = 5},
  [3001] = {.lex_state = 20, .external_lex_state = 5},
  [3002] = {.lex_state = 12, .external_lex_state = 4},
  [3003] = {.lex_state = 11, .external_lex_state = 4},
  [3004] = {.lex_state = 20, .external_lex_state = 5},
  [3005] = {.lex_state = 20, .external_lex_state = 5},
  [3006] = {.lex_state = 20, .external_lex_state = 5},
  [3007] = {.lex_state = 20, .external_lex_state = 5},
  [3008] = {.lex_state = 20, .external_lex_state = 5},
  [3009] = {.lex_state = 15},
  [3010] = {.lex_state = 12, .external_lex_state = 4},
  [3011] = {.lex_state = 11, .external_lex_state = 4},
  [3012] = {.lex_state = 12, .external_lex_state = 4},
  [3013] = {.lex_state = 20, .external_lex_state = 5},
  [3014] = {.lex_state = 20, .external_lex_state = 5},
  [3015] = {.lex_state = 20, .external_lex_state = 5},
  [3016] = {.lex_state = 12, .external_lex_state = 4},
  [3017] = {.lex_state = 20, .external_lex_state = 5},
  [3018] = {.lex_state = 20, .external_lex_state = 5},
  [3019] = {.lex_state = 12, .external_lex_state = 4},
  [3020] = {.lex_state = 20, .external_lex_state = 5},
  [3021] = {.lex_state = 20, .external_lex_state = 5},
  [3022] = {.lex_state = 20, .external_lex_state = 5},
  [3023] = {.lex_state = 20, .external_lex_state = 5},
  [3024] = {.lex_state = 20, .external_lex_state = 5},
  [3025] = {.lex_state = 20, .external_lex_state = 5},
  [3026] = {.lex_state = 20, .external_lex_state = 5},
  [3027] = {.lex_state = 20, .external_lex_state = 5},
  [3028] = {.lex_state = 20, .external_lex_state = 5},
  [3029] = {.lex_state = 20, .external_lex_state = 5},
  [3030] = {.lex_state = 12, .external_lex_state = 4},
  [3031] = {.lex_state = 20, .external_lex_state = 5},
  [3032] = {.lex_state = 20, .external_lex_state = 5},
  [3033] = {.lex_state = 20, .external_lex_state = 5},
  [3034] = {.lex_state = 12, .external_lex_state = 4},
  [3035] = {.lex_state = 20, .external_lex_state = 5},
  [3036] = {.lex_state = 20, .external_lex_state = 5},
  [3037] = {.lex_state = 12, .external_lex_state = 4},
  [3038] = {.lex_state = 12, .external_lex_state = 4},
  [3039] = {.lex_state = 12, .external_lex_state = 4},
  [3040] = {.lex_state = 20, .external_lex_state = 5},
  [3041] = {.lex_state = 11, .external_lex_state = 4},
  [3042] = {.lex_state = 11, .external_lex_state = 4},
  [3043] = {.lex_state = 11, .external_lex_state = 4},
  [3044] = {.lex_state = 12, .external_lex_state = 4},
  [3045] = {.lex_state = 11, .external_lex_state = 4},
  [3046] = {.lex_state = 11, .external_lex_state = 4},
  [3047] = {.lex_state = 11, .external_lex_state = 4},
  [3048] = {.lex_state = 11, .external_lex_state = 4},
  [3049] = {.lex_state = 20, .external_lex_state = 5},
  [3050] = {.lex_state = 11, .external_lex_state = 4},
  [3051] = {.lex_state = 11, .external_lex_state = 4},
  [3052] = {.lex_state = 11, .external_lex_state = 4},
  [3053] = {.lex_state = 11, .external_lex_state = 4},
  [3054] = {.lex_state = 11, .external_lex_state = 4},
  [3055] = {.lex_state = 11, .external_lex_state = 4},
  [3056] = {.lex_state = 16, .external_lex_state = 5},
  [3057] = {.lex_state = 11, .external_lex_state = 4},
  [3058] = {.lex_state = 11, .external_lex_state = 4},
  [3059] = {.lex_state = 11, .external_lex_state = 4},
  [3060] = {.lex_state = 11, .external_lex_state = 4},
  [3061] = {.lex_state = 11, .external_lex_state = 4},
  [3062] = {.lex_state = 15, .external_lex_state = 5},
  [3063] = {.lex_state = 11, .external_lex_state = 4},
  [3064] = {.lex_state = 11, .external_lex_state = 4},
  [3065] = {.lex_state = 11, .external_lex_state = 4},
  [3066] = {.lex_state = 11, .external_lex_state = 4},
  [3067] = {.lex_state = 11, .external_lex_state = 4},
  [3068] = {.lex_state = 11, .external_lex_state = 4},
  [3069] = {.lex_state = 11, .external_lex_state = 4},
  [3070] = {.lex_state = 11, .external_lex_state = 4},
  [3071] = {.lex_state = 11, .external_lex_state = 4},
  [3072] = {.lex_state = 20, .external_lex_state = 5},
  [3073] = {.lex_state = 11, .external_lex_state = 4},
  [3074] = {.lex_state = 11, .external_lex_state = 4},
  [3075] = {.lex_state = 21},
  [3076] = {.lex_state = 11, .external_lex_state = 4},
  [3077] = {.lex_state = 20, .external_lex_state = 5},
  [3078] = {.lex_state = 11, .external_lex_state = 4},
  [3079] = {.lex_state = 11, .external_lex_state = 4},
  [3080] = {.lex_state = 11, .external_lex_state = 4},
  [3081] = {.lex_state = 20, .external_lex_state = 5},
  [3082] = {.lex_state = 20, .external_lex_state = 5},
  [3083] = {.lex_state = 20, .external_lex_state = 5},
  [3084] = {.lex_state = 11, .external_lex_state = 4},
  [3085] = {.lex_state = 11, .external_lex_state = 4},
  [3086] = {.lex_state = 11, .external_lex_state = 4},
  [3087] = {.lex_state = 11, .external_lex_state = 4},
  [3088] = {.lex_state = 11, .external_lex_state = 4},
  [3089] = {.lex_state = 11, .external_lex_state = 4},
  [3090] = {.lex_state = 11, .external_lex_state = 4},
  [3091] = {.lex_state = 20, .external_lex_state = 5},
  [3092] = {.lex_state = 11, .external_lex_state = 4},
  [3093] = {.lex_state = 11, .external_lex_state = 4},
  [3094] = {.lex_state = 11, .external_lex_state = 4},
  [3095] = {.lex_state = 11, .external_lex_state = 4},
  [3096] = {.lex_state = 11, .external_lex_state = 4},
  [3097] = {.lex_state = 12, .external_lex_state = 4},
  [3098] = {.lex_state = 11, .external_lex_state = 4},
  [3099] = {.lex_state = 16},
  [3100] = {.lex_state = 5},
  [3101] = {.lex_state = 11, .external_lex_state = 4},
  [3102] = {.lex_state = 15},
  [3103] = {.lex_state = 11, .external_lex_state = 4},
  [3104] = {.lex_state = 16},
  [3105] = {.lex_state = 16},
  [3106] = {.lex_state = 11, .external_lex_state = 5},
  [3107] = {.lex_state = 11, .external_lex_state = 5},
  [3108] = {.lex_state = 16},
  [3109] = {.lex_state = 11, .external_lex_state = 4},
  [3110] = {.lex_state = 12, .external_lex_state = 4},
  [3111] = {.lex_state = 16},
  [3112] = {.lex_state = 16},
  [3113] = {.lex_state = 16},
  [3114] = {.lex_state = 16},
  [3115] = {.lex_state = 16},
  [3116] = {.lex_state = 11},
  [3117] = {.lex_state = 11},
  [3118] = {.lex_state = 16},
  [3119] = {.lex_state = 16},
  [3120] = {.lex_state = 16},
  [3121] = {.lex_state = 16},
  [3122] = {.lex_state = 11, .external_lex_state = 4},
  [3123] = {.lex_state = 11, .external_lex_state = 5},
  [3124] = {.lex_state = 16},
  [3125] = {.lex_state = 16},
  [3126] = {.lex_state = 16},
  [3127] = {.lex_state = 11, .external_lex_state = 5},
  [3128] = {.lex_state = 16},
  [3129] = {.lex_state = 11, .external_lex_state = 4},
  [3130] = {.lex_state = 11, .external_lex_state = 5},
  [3131] = {.lex_state = 11, .external_lex_state = 5},
  [3132] = {.lex_state = 11, .external_lex_state = 5},
  [3133] = {.lex_state = 11, .external_lex_state = 5},
  [3134] = {.lex_state = 11, .external_lex_state = 5},
  [3135] = {.lex_state = 11, .external_lex_state = 5},
  [3136] = {.lex_state = 11},
  [3137] = {.lex_state = 16},
  [3138] = {.lex_state = 11, .external_lex_state = 5},
  [3139] = {.lex_state = 11, .external_lex_state = 5},
  [3140] = {.lex_state = 11, .external_lex_state = 5},
  [3141] = {.lex_state = 11},
  [3142] = {.lex_state = 11, .external_lex_state = 5},
  [3143] = {.lex_state = 11, .external_lex_state = 5},
  [3144] = {.lex_state = 11, .external_lex_state = 5},
  [3145] = {.lex_state = 11, .external_lex_state = 5},
  [3146] = {.lex_state = 14},
  [3147] = {.lex_state = 11, .external_lex_state = 5},
  [3148] = {.lex_state = 11, .external_lex_state = 5},
  [3149] = {.lex_state = 11, .external_lex_state = 5},
  [3150] = {.lex_state = 11, .external_lex_state = 5},
  [3151] = {.lex_state = 11, .external_lex_state = 5},
  [3152] = {.lex_state = 11, .external_lex_state = 5},
  [3153] = {.lex_state = 16},
  [3154] = {.lex_state = 11, .external_lex_state = 5},
  [3155] = {.lex_state = 16},
  [3156] = {.lex_state = 16},
  [3157] = {.lex_state = 16},
  [3158] = {.lex_state = 16},
  [3159] = {.lex_state = 16},
  [3160] = {.lex_state = 16},
  [3161] = {.lex_state = 11, .external_lex_state = 5},
  [3162] = {.lex_state = 11, .external_lex_state = 5},
  [3163] = {.lex_state = 11, .external_lex_state = 5},
  [3164] = {.lex_state = 12},
  [3165] = {.lex_state = 11, .external_lex_state = 5},
  [3166] = {.lex_state = 11, .external_lex_state = 4},
  [3167] = {.lex_state = 16},
  [3168] = {.lex_state = 11, .external_lex_state = 5},
  [3169] = {.lex_state = 16},
  [3170] = {.lex_state = 11, .external_lex_state = 5},
  [3171] = {.lex_state = 16},
  [3172] = {.lex_state = 11, .external_lex_state = 5},
  [3173] = {.lex_state = 16},
  [3174] = {.lex_state = 16},
  [3175] = {.lex_state = 5},
  [3176] = {.lex_state = 11, .external_lex_state = 5},
  [3177] = {.lex_state = 16},
  [3178] = {.lex_state = 11, .external_lex_state = 5},
  [3179] = {.lex_state = 16},
  [3180] = {.lex_state = 16},
  [3181] = {.lex_state = 11, .external_lex_state = 5},
  [3182] = {.lex_state = 11, .external_lex_state = 5},
  [3183] = {.lex_state = 11, .external_lex_state = 5},
  [3184] = {.lex_state = 12},
  [3185] = {.lex_state = 11, .external_lex_state = 5},
  [3186] = {.lex_state = 11},
  [3187] = {.lex_state = 16},
  [3188] = {.lex_state = 12},
  [3189] = {.lex_state = 16},
  [3190] = {.lex_state = 14},
  [3191] = {.lex_state = 12},
  [3192] = {.lex_state = 11, .external_lex_state = 5},
  [3193] = {.lex_state = 11, .external_lex_state = 4},
  [3194] = {.lex_state = 11, .external_lex_state = 4},
  [3195] = {.lex_state = 11, .external_lex_state = 5},
  [3196] = {.lex_state = 12},
  [3197] = {.lex_state = 11, .external_lex_state = 5},
  [3198] = {.lex_state = 12},
  [3199] = {.lex_state = 16},
  [3200] = {.lex_state = 16},
  [3201] = {.lex_state = 11},
  [3202] = {.lex_state = 11},
  [3203] = {.lex_state = 11, .external_lex_state = 5},
  [3204] = {.lex_state = 11, .external_lex_state = 5},
  [3205] = {.lex_state = 11},
  [3206] = {.lex_state = 12},
  [3207] = {.lex_state = 11, .external_lex_state = 5},
  [3208] = {.lex_state = 11, .external_lex_state = 5},
  [3209] = {.lex_state = 11, .external_lex_state = 5},
  [3210] = {.lex_state = 11, .external_lex_state = 4},
  [3211] = {.lex_state = 5, .external_lex_state = 4},
  [3212] = {.lex_state = 11, .external_lex_state = 5},
  [3213] = {.lex_state = 11, .external_lex_state = 5},
  [3214] = {.lex_state = 16},
  [3215] = {.lex_state = 15},
  [3216] = {.lex_state = 93, .external_lex_state = 4},
  [3217] = {.lex_state = 11, .external_lex_state = 5},
  [3218] = {.lex_state = 11, .external_lex_state = 5},
  [3219] = {.lex_state = 11, .external_lex_state = 5},
  [3220] = {.lex_state = 93, .external_lex_state = 4},
  [3221] = {.lex_state = 11, .external_lex_state = 5},
  [3222] = {.lex_state = 11, .external_lex_state = 5},
  [3223] = {.lex_state = 14},
  [3224] = {.lex_state = 5, .external_lex_state = 4},
  [3225] = {.lex_state = 18, .external_lex_state = 6},
  [3226] = {.lex_state = 18, .external_lex_state = 6},
  [3227] = {.lex_state = 18, .external_lex_state = 6},
  [3228] = {.lex_state = 11, .external_lex_state = 4},
  [3229] = {.lex_state = 11},
  [3230] = {.lex_state = 18, .external_lex_state = 6},
  [3231] = {.lex_state = 11},
  [3232] = {.lex_state = 18, .external_lex_state = 6},
  [3233] = {.lex_state = 11, .external_lex_state = 4},
  [3234] = {.lex_state = 18, .external_lex_state = 6},
  [3235] = {.lex_state = 11, .external_lex_state = 5},
  [3236] = {.lex_state = 12},
  [3237] = {.lex_state = 11, .external_lex_state = 4},
  [3238] = {.lex_state = 11},
  [3239] = {.lex_state = 11},
  [3240] = {.lex_state = 18, .external_lex_state = 6},
  [3241] = {.lex_state = 18, .external_lex_state = 6},
  [3242] = {.lex_state = 11},
  [3243] = {.lex_state = 11},
  [3244] = {.lex_state = 0, .external_lex_state = 4},
  [3245] = {.lex_state = 12},
  [3246] = {.lex_state = 12},
  [3247] = {.lex_state = 11},
  [3248] = {.lex_state = 11, .external_lex_state = 4},
  [3249] = {.lex_state = 93, .external_lex_state = 4},
  [3250] = {.lex_state = 11},
  [3251] = {.lex_state = 11},
  [3252] = {.lex_state = 12},
  [3253] = {.lex_state = 11, .external_lex_state = 4},
  [3254] = {.lex_state = 11, .external_lex_state = 4},
  [3255] = {.lex_state = 11, .external_lex_state = 4},
  [3256] = {.lex_state = 12},
  [3257] = {.lex_state = 11, .external_lex_state = 4},
  [3258] = {.lex_state = 11},
  [3259] = {.lex_state = 11},
  [3260] = {.lex_state = 11},
  [3261] = {.lex_state = 11},
  [3262] = {.lex_state = 11},
  [3263] = {.lex_state = 11},
  [3264] = {.lex_state = 11},
  [3265] = {.lex_state = 11},
  [3266] = {.lex_state = 11},
  [3267] = {.lex_state = 11},
  [3268] = {.lex_state = 11},
  [3269] = {.lex_state = 0, .external_lex_state = 4},
  [3270] = {.lex_state = 0, .external_lex_state = 4},
  [3271] = {.lex_state = 11},
  [3272] = {.lex_state = 11, .external_lex_state = 4},
  [3273] = {.lex_state = 11, .external_lex_state = 4},
  [3274] = {.lex_state = 11, .external_lex_state = 4},
  [3275] = {.lex_state = 12},
  [3276] = {.lex_state = 12},
  [3277] = {.lex_state = 0, .external_lex_state = 4},
  [3278] = {.lex_state = 12},
  [3279] = {.lex_state = 93, .external_lex_state = 4},
  [3280] = {.lex_state = 11},
  [3281] = {.lex_state = 11, .external_lex_state = 4},
  [3282] = {.lex_state = 93, .external_lex_state = 4},
  [3283] = {.lex_state = 11},
  [3284] = {.lex_state = 93, .external_lex_state = 4},
  [3285] = {.lex_state = 11},
  [3286] = {.lex_state = 11, .external_lex_state = 4},
  [3287] = {.lex_state = 11},
  [3288] = {.lex_state = 11, .external_lex_state = 4},
  [3289] = {.lex_state = 11, .external_lex_state = 4},
  [3290] = {.lex_state = 11},
  [3291] = {.lex_state = 11, .external_lex_state = 4},
  [3292] = {.lex_state = 11, .external_lex_state = 4},
  [3293] = {.lex_state = 93, .external_lex_state = 4},
  [3294] = {.lex_state = 11, .external_lex_state = 4},
  [3295] = {.lex_state = 21},
  [3296] = {.lex_state = 11},
  [3297] = {.lex_state = 0, .external_lex_state = 4},
  [3298] = {.lex_state = 11},
  [3299] = {.lex_state = 11},
  [3300] = {.lex_state = 12},
  [3301] = {.lex_state = 11},
  [3302] = {.lex_state = 0, .external_lex_state = 4},
  [3303] = {.lex_state = 12},
  [3304] = {.lex_state = 11, .external_lex_state = 4},
  [3305] = {.lex_state = 93, .external_lex_state = 4},
  [3306] = {.lex_state = 93, .external_lex_state = 4},
  [3307] = {.lex_state = 11, .external_lex_state = 4},
  [3308] = {.lex_state = 11},
  [3309] = {.lex_state = 11},
  [3310] = {.lex_state = 11},
  [3311] = {.lex_state = 93, .external_lex_state = 4},
  [3312] = {.lex_state = 11, .external_lex_state = 4},
  [3313] = {.lex_state = 11},
  [3314] = {.lex_state = 11, .external_lex_state = 4},
  [3315] = {.lex_state = 5},
  [3316] = {.lex_state = 11},
  [3317] = {.lex_state = 11},
  [3318] = {.lex_state = 11},
  [3319] = {.lex_state = 0, .external_lex_state = 4},
  [3320] = {.lex_state = 11},
  [3321] = {.lex_state = 12},
  [3322] = {.lex_state = 12},
  [3323] = {.lex_state = 5},
  [3324] = {.lex_state = 12},
  [3325] = {.lex_state = 11},
  [3326] = {.lex_state = 11},
  [3327] = {.lex_state = 12},
  [3328] = {.lex_state = 11},
  [3329] = {.lex_state = 11, .external_lex_state = 4},
  [3330] = {.lex_state = 11, .external_lex_state = 4},
  [3331] = {.lex_state = 5},
  [3332] = {.lex_state = 11},
  [3333] = {.lex_state = 11, .external_lex_state = 4},
  [3334] = {.lex_state = 5},
  [3335] = {.lex_state = 12},
  [3336] = {.lex_state = 11, .external_lex_state = 4},
  [3337] = {.lex_state = 11, .external_lex_state = 4},
  [3338] = {.lex_state = 12},
  [3339] = {.lex_state = 0, .external_lex_state = 4},
  [3340] = {.lex_state = 11, .external_lex_state = 4},
  [3341] = {.lex_state = 11, .external_lex_state = 4},
  [3342] = {.lex_state = 11, .external_lex_state = 4},
  [3343] = {.lex_state = 11, .external_lex_state = 4},
  [3344] = {.lex_state = 0, .external_lex_state = 4},
  [3345] = {.lex_state = 0, .external_lex_state = 4},
  [3346] = {.lex_state = 12},
  [3347] = {.lex_state = 11},
  [3348] = {.lex_state = 11},
  [3349] = {.lex_state = 0, .external_lex_state = 4},
  [3350] = {.lex_state = 12},
  [3351] = {.lex_state = 12},
  [3352] = {.lex_state = 12},
  [3353] = {.lex_state = 11},
  [3354] = {.lex_state = 5},
  [3355] = {.lex_state = 12},
  [3356] = {.lex_state = 11},
  [3357] = {.lex_state = 11},
  [3358] = {.lex_state = 11},
  [3359] = {.lex_state = 11},
  [3360] = {.lex_state = 12},
  [3361] = {.lex_state = 11},
  [3362] = {.lex_state = 11},
  [3363] = {.lex_state = 11},
  [3364] = {.lex_state = 21},
  [3365] = {.lex_state = 93},
  [3366] = {.lex_state = 11, .external_lex_state = 5},
  [3367] = {.lex_state = 11, .external_lex_state = 5},
  [3368] = {.lex_state = 12},
  [3369] = {.lex_state = 11},
  [3370] = {.lex_state = 0, .external_lex_state = 4},
  [3371] = {.lex_state = 11},
  [3372] = {.lex_state = 93},
  [3373] = {.lex_state = 21},
  [3374] = {.lex_state = 93},
  [3375] = {.lex_state = 93},
  [3376] = {.lex_state = 93},
  [3377] = {.lex_state = 0, .external_lex_state = 4},
  [3378] = {.lex_state = 0, .external_lex_state = 4},
  [3379] = {.lex_state = 11, .external_lex_state = 5},
  [3380] = {.lex_state = 18, .external_lex_state = 6},
  [3381] = {.lex_state = 18, .external_lex_state = 6},
  [3382] = {.lex_state = 0, .external_lex_state = 4},
  [3383] = {.lex_state = 11, .external_lex_state = 5},
  [3384] = {.lex_state = 11, .external_lex_state = 5},
  [3385] = {.lex_state = 0, .external_lex_state = 4},
  [3386] = {.lex_state = 12},
  [3387] = {.lex_state = 0, .external_lex_state = 4},
  [3388] = {.lex_state = 12},
  [3389] = {.lex_state = 11},
  [3390] = {.lex_state = 0, .external_lex_state = 4},
  [3391] = {.lex_state = 12},
  [3392] = {.lex_state = 11, .external_lex_state = 5},
  [3393] = {.lex_state = 12},
  [3394] = {.lex_state = 11, .external_lex_state = 5},
  [3395] = {.lex_state = 11},
  [3396] = {.lex_state = 11},
  [3397] = {.lex_state = 11, .external_lex_state = 5},
  [3398] = {.lex_state = 0, .external_lex_state = 4},
  [3399] = {.lex_state = 21},
  [3400] = {.lex_state = 11, .external_lex_state = 4},
  [3401] = {.lex_state = 0, .external_lex_state = 4},
  [3402] = {.lex_state = 5},
  [3403] = {.lex_state = 11},
  [3404] = {.lex_state = 11, .external_lex_state = 5},
  [3405] = {.lex_state = 12},
  [3406] = {.lex_state = 12},
  [3407] = {.lex_state = 93},
  [3408] = {.lex_state = 21},
  [3409] = {.lex_state = 93},
  [3410] = {.lex_state = 93},
  [3411] = {.lex_state = 93},
  [3412] = {.lex_state = 11},
  [3413] = {.lex_state = 12},
  [3414] = {.lex_state = 21},
  [3415] = {.lex_state = 12},
  [3416] = {.lex_state = 0, .external_lex_state = 4},
  [3417] = {.lex_state = 12},
  [3418] = {.lex_state = 11},
  [3419] = {.lex_state = 11},
  [3420] = {.lex_state = 21},
  [3421] = {.lex_state = 12},
  [3422] = {.lex_state = 11},
  [3423] = {.lex_state = 93},
  [3424] = {.lex_state = 11, .external_lex_state = 5},
  [3425] = {.lex_state = 12},
  [3426] = {.lex_state = 21},
  [3427] = {.lex_state = 93},
  [3428] = {.lex_state = 12},
  [3429] = {.lex_state = 93},
  [3430] = {.lex_state = 93},
  [3431] = {.lex_state = 0, .external_lex_state = 4},
  [3432] = {.lex_state = 11},
  [3433] = {.lex_state = 11, .external_lex_state = 5},
  [3434] = {.lex_state = 93},
  [3435] = {.lex_state = 11, .external_lex_state = 5},
  [3436] = {.lex_state = 93},
  [3437] = {.lex_state = 11, .external_lex_state = 5},
  [3438] = {.lex_state = 93},
  [3439] = {.lex_state = 11, .external_lex_state = 5},
  [3440] = {.lex_state = 11, .external_lex_state = 5},
  [3441] = {.lex_state = 93},
  [3442] = {.lex_state = 93},
  [3443] = {.lex_state = 11, .external_lex_state = 4},
  [3444] = {.lex_state = 12},
  [3445] = {.lex_state = 11, .external_lex_state = 5},
  [3446] = {.lex_state = 0, .external_lex_state = 4},
  [3447] = {.lex_state = 0, .external_lex_state = 4},
  [3448] = {.lex_state = 11, .external_lex_state = 5},
  [3449] = {.lex_state = 11, .external_lex_state = 5},
  [3450] = {.lex_state = 0, .external_lex_state = 4},
  [3451] = {.lex_state = 93},
  [3452] = {.lex_state = 12},
  [3453] = {.lex_state = 0},
  [3454] = {.lex_state = 12},
  [3455] = {.lex_state = 0, .external_lex_state = 4},
  [3456] = {.lex_state = 0, .external_lex_state = 4},
  [3457] = {.lex_state = 11, .external_lex_state = 5},
  [3458] = {.lex_state = 12},
  [3459] = {.lex_state = 0, .external_lex_state = 4},
  [3460] = {.lex_state = 12},
  [3461] = {.lex_state = 11, .external_lex_state = 5},
  [3462] = {.lex_state = 12},
  [3463] = {.lex_state = 12},
  [3464] = {.lex_state = 11, .external_lex_state = 5},
  [3465] = {.lex_state = 12},
  [3466] = {.lex_state = 11, .external_lex_state = 5},
  [3467] = {.lex_state = 12},
  [3468] = {.lex_state = 18, .external_lex_state = 6},
  [3469] = {.lex_state = 11},
  [3470] = {.lex_state = 11, .external_lex_state = 5},
  [3471] = {.lex_state = 11, .external_lex_state = 5},
  [3472] = {.lex_state = 0, .external_lex_state = 4},
  [3473] = {.lex_state = 21},
  [3474] = {.lex_state = 12},
  [3475] = {.lex_state = 11},
  [3476] = {.lex_state = 21},
  [3477] = {.lex_state = 11},
  [3478] = {.lex_state = 12},
  [3479] = {.lex_state = 11},
  [3480] = {.lex_state = 11},
  [3481] = {.lex_state = 18, .external_lex_state = 6},
  [3482] = {.lex_state = 18, .external_lex_state = 6},
  [3483] = {.lex_state = 93},
  [3484] = {.lex_state = 11, .external_lex_state = 5},
  [3485] = {.lex_state = 93},
  [3486] = {.lex_state = 21},
  [3487] = {.lex_state = 93},
  [3488] = {.lex_state = 12},
  [3489] = {.lex_state = 12},
  [3490] = {.lex_state = 12},
  [3491] = {.lex_state = 12},
  [3492] = {.lex_state = 93},
  [3493] = {.lex_state = 11},
  [3494] = {.lex_state = 12},
  [3495] = {.lex_state = 93},
  [3496] = {.lex_state = 11},
  [3497] = {.lex_state = 0, .external_lex_state = 4},
  [3498] = {.lex_state = 12},
  [3499] = {.lex_state = 12},
  [3500] = {.lex_state = 12},
  [3501] = {.lex_state = 0, .external_lex_state = 4},
  [3502] = {.lex_state = 11},
  [3503] = {.lex_state = 0, .external_lex_state = 4},
  [3504] = {.lex_state = 11, .external_lex_state = 5},
  [3505] = {.lex_state = 0, .external_lex_state = 4},
  [3506] = {.lex_state = 11},
  [3507] = {.lex_state = 0, .external_lex_state = 4},
  [3508] = {.lex_state = 93},
  [3509] = {.lex_state = 5},
  [3510] = {.lex_state = 11},
  [3511] = {.lex_state = 0, .external_lex_state = 4},
  [3512] = {.lex_state = 5},
  [3513] = {.lex_state = 12},
  [3514] = {.lex_state = 11},
  [3515] = {.lex_state = 12},
  [3516] = {.lex_state = 12},
  [3517] = {.lex_state = 0, .external_lex_state = 4},
  [3518] = {.lex_state = 5},
  [3519] = {.lex_state = 11},
  [3520] = {.lex_state = 11},
  [3521] = {.lex_state = 11},
  [3522] = {.lex_state = 0, .external_lex_state = 4},
  [3523] = {.lex_state = 11},
  [3524] = {.lex_state = 11},
  [3525] = {.lex_state = 11, .external_lex_state = 4},
  [3526] = {.lex_state = 11},
  [3527] = {.lex_state = 11, .external_lex_state = 4},
  [3528] = {.lex_state = 11},
  [3529] = {.lex_state = 11},
  [3530] = {.lex_state = 0, .external_lex_state = 4},
  [3531] = {.lex_state = 12},
  [3532] = {.lex_state = 12},
  [3533] = {.lex_state = 5, .external_lex_state = 4},
  [3534] = {.lex_state = 11},
  [3535] = {.lex_state = 12},
  [3536] = {.lex_state = 11, .external_lex_state = 5},
  [3537] = {.lex_state = 12},
  [3538] = {.lex_state = 93},
  [3539] = {.lex_state = 12},
  [3540] = {.lex_state = 0, .external_lex_state = 4},
  [3541] = {.lex_state = 12},
  [3542] = {.lex_state = 0, .external_lex_state = 4},
  [3543] = {.lex_state = 0, .external_lex_state = 4},
  [3544] = {.lex_state = 0},
  [3545] = {.lex_state = 12},
  [3546] = {.lex_state = 12},
  [3547] = {.lex_state = 93},
  [3548] = {.lex_state = 93},
  [3549] = {.lex_state = 11, .external_lex_state = 5},
  [3550] = {.lex_state = 0, .external_lex_state = 4},
  [3551] = {.lex_state = 93},
  [3552] = {.lex_state = 18, .external_lex_state = 6},
  [3553] = {.lex_state = 18, .external_lex_state = 6},
  [3554] = {.lex_state = 12},
  [3555] = {.lex_state = 93},
  [3556] = {.lex_state = 12},
  [3557] = {.lex_state = 12},
  [3558] = {.lex_state = 12},
  [3559] = {.lex_state = 0, .external_lex_state = 4},
  [3560] = {.lex_state = 0, .external_lex_state = 4},
  [3561] = {.lex_state = 0, .external_lex_state = 4},
  [3562] = {.lex_state = 12},
  [3563] = {.lex_state = 11, .external_lex_state = 5},
  [3564] = {.lex_state = 0},
  [3565] = {.lex_state = 0},
  [3566] = {.lex_state = 11},
  [3567] = {.lex_state = 12},
  [3568] = {.lex_state = 11, .external_lex_state = 5},
  [3569] = {.lex_state = 11, .external_lex_state = 5},
  [3570] = {.lex_state = 12},
  [3571] = {.lex_state = 0, .external_lex_state = 4},
  [3572] = {.lex_state = 11, .external_lex_state = 5},
  [3573] = {.lex_state = 18, .external_lex_state = 6},
  [3574] = {.lex_state = 12},
  [3575] = {.lex_state = 0, .external_lex_state = 4},
  [3576] = {.lex_state = 0, .external_lex_state = 4},
  [3577] = {.lex_state = 12},
  [3578] = {.lex_state = 11},
  [3579] = {.lex_state = 12},
  [3580] = {.lex_state = 11, .external_lex_state = 4},
  [3581] = {.lex_state = 11},
  [3582] = {.lex_state = 0, .external_lex_state = 4},
  [3583] = {.lex_state = 11, .external_lex_state = 4},
  [3584] = {.lex_state = 0, .external_lex_state = 4},
  [3585] = {.lex_state = 5, .external_lex_state = 4},
  [3586] = {.lex_state = 0, .external_lex_state = 4},
  [3587] = {.lex_state = 0, .external_lex_state = 4},
  [3588] = {.lex_state = 0, .external_lex_state = 4},
  [3589] = {.lex_state = 0, .external_lex_state = 4},
  [3590] = {.lex_state = 93},
  [3591] = {.lex_state = 0, .external_lex_state = 4},
  [3592] = {.lex_state = 0, .external_lex_state = 4},
  [3593] = {.lex_state = 11, .external_lex_state = 4},
  [3594] = {.lex_state = 11, .external_lex_state = 5},
  [3595] = {.lex_state = 93},
  [3596] = {.lex_state = 11, .external_lex_state = 4},
  [3597] = {.lex_state = 0, .external_lex_state = 4},
  [3598] = {.lex_state = 12},
  [3599] = {.lex_state = 12},
  [3600] = {.lex_state = 0, .external_lex_state = 4},
  [3601] = {.lex_state = 93},
  [3602] = {.lex_state = 11, .external_lex_state = 5},
  [3603] = {.lex_state = 5},
  [3604] = {.lex_state = 12},
  [3605] = {.lex_state = 93, .external_lex_state = 4},
  [3606] = {.lex_state = 0, .external_lex_state = 4},
  [3607] = {.lex_state = 0},
  [3608] = {.lex_state = 0, .external_lex_state = 4},
  [3609] = {.lex_state = 93, .external_lex_state = 4},
  [3610] = {.lex_state = 0, .external_lex_state = 4},
  [3611] = {.lex_state = 5},
  [3612] = {.lex_state = 12},
  [3613] = {.lex_state = 0, .external_lex_state = 4},
  [3614] = {.lex_state = 0, .external_lex_state = 4},
  [3615] = {.lex_state = 12},
  [3616] = {.lex_state = 0, .external_lex_state = 4},
  [3617] = {.lex_state = 0, .external_lex_state = 4},
  [3618] = {.lex_state = 12},
  [3619] = {.lex_state = 0, .external_lex_state = 4},
  [3620] = {.lex_state = 0, .external_lex_state = 4},
  [3621] = {.lex_state = 0, .external_lex_state = 4},
  [3622] = {.lex_state = 11, .external_lex_state = 4},
  [3623] = {.lex_state = 0, .external_lex_state = 4},
  [3624] = {.lex_state = 0, .external_lex_state = 4},
  [3625] = {.lex_state = 0},
  [3626] = {.lex_state = 0, .external_lex_state = 4},
  [3627] = {.lex_state = 93},
  [3628] = {.lex_state = 0, .external_lex_state = 4},
  [3629] = {.lex_state = 0, .external_lex_state = 4},
  [3630] = {.lex_state = 12},
  [3631] = {.lex_state = 12},
  [3632] = {.lex_state = 0, .external_lex_state = 4},
  [3633] = {.lex_state = 11, .external_lex_state = 4},
  [3634] = {.lex_state = 0, .external_lex_state = 4},
  [3635] = {.lex_state = 12},
  [3636] = {.lex_state = 18, .external_lex_state = 6},
  [3637] = {.lex_state = 11, .external_lex_state = 5},
  [3638] = {.lex_state = 11},
  [3639] = {.lex_state = 11, .external_lex_state = 5},
  [3640] = {.lex_state = 11},
  [3641] = {.lex_state = 0, .external_lex_state = 4},
  [3642] = {.lex_state = 11, .external_lex_state = 4},
  [3643] = {.lex_state = 0, .external_lex_state = 4},
  [3644] = {.lex_state = 11},
  [3645] = {.lex_state = 0, .external_lex_state = 4},
  [3646] = {.lex_state = 0, .external_lex_state = 4},
  [3647] = {.lex_state = 0, .external_lex_state = 4},
  [3648] = {.lex_state = 0, .external_lex_state = 4},
  [3649] = {.lex_state = 12},
  [3650] = {.lex_state = 0, .external_lex_state = 4},
  [3651] = {.lex_state = 0, .external_lex_state = 4},
  [3652] = {.lex_state = 0, .external_lex_state = 4},
  [3653] = {.lex_state = 12},
  [3654] = {.lex_state = 0, .external_lex_state = 4},
  [3655] = {.lex_state = 11},
  [3656] = {.lex_state = 0, .external_lex_state = 4},
  [3657] = {.lex_state = 0, .external_lex_state = 4},
  [3658] = {.lex_state = 11},
  [3659] = {.lex_state = 11, .external_lex_state = 5},
  [3660] = {.lex_state = 0, .external_lex_state = 4},
  [3661] = {.lex_state = 0, .external_lex_state = 4},
  [3662] = {.lex_state = 0, .external_lex_state = 4},
  [3663] = {.lex_state = 93},
  [3664] = {.lex_state = 12},
  [3665] = {.lex_state = 93},
  [3666] = {.lex_state = 93},
  [3667] = {.lex_state = 0},
  [3668] = {.lex_state = 12},
  [3669] = {.lex_state = 12},
  [3670] = {.lex_state = 12},
  [3671] = {.lex_state = 11, .external_lex_state = 4},
  [3672] = {.lex_state = 0, .external_lex_state = 4},
  [3673] = {.lex_state = 12},
  [3674] = {.lex_state = 0, .external_lex_state = 4},
  [3675] = {.lex_state = 0, .external_lex_state = 4},
  [3676] = {.lex_state = 0, .external_lex_state = 4},
  [3677] = {.lex_state = 12},
  [3678] = {.lex_state = 0, .external_lex_state = 4},
  [3679] = {.lex_state = 0, .external_lex_state = 4},
  [3680] = {.lex_state = 12},
  [3681] = {.lex_state = 0, .external_lex_state = 4},
  [3682] = {.lex_state = 12},
  [3683] = {.lex_state = 0, .external_lex_state = 4},
  [3684] = {.lex_state = 12},
  [3685] = {.lex_state = 0, .external_lex_state = 4},
  [3686] = {.lex_state = 0, .external_lex_state = 4},
  [3687] = {.lex_state = 0, .external_lex_state = 4},
  [3688] = {.lex_state = 0, .external_lex_state = 4},
  [3689] = {.lex_state = 0, .external_lex_state = 4},
  [3690] = {.lex_state = 12},
  [3691] = {.lex_state = 12},
  [3692] = {.lex_state = 93},
  [3693] = {.lex_state = 0, .external_lex_state = 4},
  [3694] = {.lex_state = 0, .external_lex_state = 4},
  [3695] = {.lex_state = 93},
  [3696] = {.lex_state = 0, .external_lex_state = 4},
  [3697] = {.lex_state = 0, .external_lex_state = 4},
  [3698] = {.lex_state = 12},
  [3699] = {.lex_state = 0, .external_lex_state = 4},
  [3700] = {.lex_state = 0, .external_lex_state = 4},
  [3701] = {.lex_state = 11, .external_lex_state = 5},
  [3702] = {.lex_state = 0, .external_lex_state = 4},
  [3703] = {.lex_state = 12},
  [3704] = {.lex_state = 0, .external_lex_state = 4},
  [3705] = {.lex_state = 0, .external_lex_state = 4},
  [3706] = {.lex_state = 0, .external_lex_state = 4},
  [3707] = {.lex_state = 12},
  [3708] = {.lex_state = 12},
  [3709] = {.lex_state = 0, .external_lex_state = 4},
  [3710] = {.lex_state = 12},
  [3711] = {.lex_state = 11, .external_lex_state = 4},
  [3712] = {.lex_state = 0, .external_lex_state = 4},
  [3713] = {.lex_state = 0, .external_lex_state = 4},
  [3714] = {.lex_state = 11, .external_lex_state = 5},
  [3715] = {.lex_state = 0, .external_lex_state = 4},
  [3716] = {.lex_state = 0, .external_lex_state = 4},
  [3717] = {.lex_state = 11, .external_lex_state = 5},
  [3718] = {.lex_state = 0, .external_lex_state = 4},
  [3719] = {.lex_state = 12},
  [3720] = {.lex_state = 0},
  [3721] = {.lex_state = 0},
  [3722] = {.lex_state = 12},
  [3723] = {.lex_state = 11, .external_lex_state = 5},
  [3724] = {.lex_state = 93},
  [3725] = {.lex_state = 0, .external_lex_state = 4},
  [3726] = {.lex_state = 12},
  [3727] = {.lex_state = 12},
  [3728] = {.lex_state = 11},
  [3729] = {.lex_state = 12},
  [3730] = {.lex_state = 12},
  [3731] = {.lex_state = 18, .external_lex_state = 6},
  [3732] = {.lex_state = 18, .external_lex_state = 6},
  [3733] = {.lex_state = 12},
  [3734] = {.lex_state = 12},
  [3735] = {.lex_state = 93},
  [3736] = {.lex_state = 12},
  [3737] = {.lex_state = 12},
  [3738] = {.lex_state = 11, .external_lex_state = 5},
  [3739] = {.lex_state = 0},
  [3740] = {.lex_state = 0},
  [3741] = {.lex_state = 0, .external_lex_state = 4},
  [3742] = {.lex_state = 0, .external_lex_state = 4},
  [3743] = {.lex_state = 12},
  [3744] = {.lex_state = 0, .external_lex_state = 4},
  [3745] = {.lex_state = 0, .external_lex_state = 4},
  [3746] = {.lex_state = 0, .external_lex_state = 4},
  [3747] = {.lex_state = 0, .external_lex_state = 4},
  [3748] = {.lex_state = 12},
  [3749] = {.lex_state = 93},
  [3750] = {.lex_state = 93},
  [3751] = {.lex_state = 93},
  [3752] = {.lex_state = 11, .external_lex_state = 5},
  [3753] = {.lex_state = 0},
  [3754] = {.lex_state = 0, .external_lex_state = 4},
  [3755] = {.lex_state = 0, .external_lex_state = 4},
  [3756] = {.lex_state = 0, .external_lex_state = 4},
  [3757] = {.lex_state = 11, .external_lex_state = 5},
  [3758] = {.lex_state = 0},
  [3759] = {.lex_state = 11},
  [3760] = {.lex_state = 11},
  [3761] = {.lex_state = 11, .external_lex_state = 5},
  [3762] = {.lex_state = 0, .external_lex_state = 4},
  [3763] = {.lex_state = 0, .external_lex_state = 4},
  [3764] = {.lex_state = 0, .external_lex_state = 4},
  [3765] = {.lex_state = 0, .external_lex_state = 4},
  [3766] = {.lex_state = 11},
  [3767] = {.lex_state = 0, .external_lex_state = 4},
  [3768] = {.lex_state = 0, .external_lex_state = 4},
  [3769] = {.lex_state = 0, .external_lex_state = 4},
  [3770] = {.lex_state = 12},
  [3771] = {.lex_state = 0, .external_lex_state = 4},
  [3772] = {.lex_state = 0, .external_lex_state = 4},
  [3773] = {.lex_state = 12},
  [3774] = {.lex_state = 11},
  [3775] = {.lex_state = 11},
  [3776] = {.lex_state = 0, .external_lex_state = 4},
  [3777] = {.lex_state = 12},
  [3778] = {.lex_state = 0, .external_lex_state = 4},
  [3779] = {.lex_state = 0, .external_lex_state = 4},
  [3780] = {.lex_state = 0, .external_lex_state = 4},
  [3781] = {.lex_state = 0, .external_lex_state = 4},
  [3782] = {.lex_state = 93},
  [3783] = {.lex_state = 0, .external_lex_state = 4},
  [3784] = {.lex_state = 11, .external_lex_state = 5},
  [3785] = {.lex_state = 0, .external_lex_state = 4},
  [3786] = {.lex_state = 12},
  [3787] = {.lex_state = 0},
  [3788] = {.lex_state = 11, .external_lex_state = 5},
  [3789] = {.lex_state = 0, .external_lex_state = 4},
  [3790] = {.lex_state = 0, .external_lex_state = 4},
  [3791] = {.lex_state = 0, .external_lex_state = 4},
  [3792] = {.lex_state = 0, .external_lex_state = 4},
  [3793] = {.lex_state = 0, .external_lex_state = 4},
  [3794] = {.lex_state = 0, .external_lex_state = 4},
  [3795] = {.lex_state = 18, .external_lex_state = 6},
  [3796] = {.lex_state = 0, .external_lex_state = 4},
  [3797] = {.lex_state = 12},
  [3798] = {.lex_state = 18, .external_lex_state = 6},
  [3799] = {.lex_state = 0, .external_lex_state = 4},
  [3800] = {.lex_state = 0, .external_lex_state = 4},
  [3801] = {.lex_state = 0, .external_lex_state = 4},
  [3802] = {.lex_state = 0, .external_lex_state = 4},
  [3803] = {.lex_state = 11},
  [3804] = {.lex_state = 12},
  [3805] = {.lex_state = 0, .external_lex_state = 4},
  [3806] = {.lex_state = 0, .external_lex_state = 4},
  [3807] = {.lex_state = 0, .external_lex_state = 4},
  [3808] = {.lex_state = 18, .external_lex_state = 6},
  [3809] = {.lex_state = 0, .external_lex_state = 4},
  [3810] = {.lex_state = 0, .external_lex_state = 4},
  [3811] = {.lex_state = 0, .external_lex_state = 4},
  [3812] = {.lex_state = 18, .external_lex_state = 6},
  [3813] = {.lex_state = 0, .external_lex_state = 4},
  [3814] = {.lex_state = 0, .external_lex_state = 4},
  [3815] = {.lex_state = 0, .external_lex_state = 4},
  [3816] = {.lex_state = 0, .external_lex_state = 4},
  [3817] = {.lex_state = 11},
  [3818] = {.lex_state = 12},
  [3819] = {.lex_state = 12},
  [3820] = {.lex_state = 12},
  [3821] = {.lex_state = 12},
  [3822] = {.lex_state = 12},
  [3823] = {.lex_state = 11},
  [3824] = {.lex_state = 0, .external_lex_state = 4},
  [3825] = {.lex_state = 12},
  [3826] = {.lex_state = 0, .external_lex_state = 4},
  [3827] = {.lex_state = 93},
  [3828] = {.lex_state = 0, .external_lex_state = 4},
  [3829] = {.lex_state = 0, .external_lex_state = 4},
  [3830] = {.lex_state = 0, .external_lex_state = 4},
  [3831] = {.lex_state = 12},
  [3832] = {.lex_state = 18, .external_lex_state = 6},
  [3833] = {.lex_state = 12},
  [3834] = {.lex_state = 0, .external_lex_state = 4},
  [3835] = {.lex_state = 0},
  [3836] = {.lex_state = 12},
  [3837] = {.lex_state = 11},
  [3838] = {.lex_state = 0, .external_lex_state = 4},
  [3839] = {.lex_state = 12},
  [3840] = {.lex_state = 0, .external_lex_state = 4},
  [3841] = {.lex_state = 0, .external_lex_state = 4},
  [3842] = {.lex_state = 0, .external_lex_state = 4},
  [3843] = {.lex_state = 0, .external_lex_state = 4},
  [3844] = {.lex_state = 11},
  [3845] = {.lex_state = 5},
  [3846] = {.lex_state = 0},
  [3847] = {.lex_state = 12},
  [3848] = {.lex_state = 0, .external_lex_state = 4},
  [3849] = {.lex_state = 17},
  [3850] = {.lex_state = 17},
  [3851] = {.lex_state = 0},
  [3852] = {.lex_state = 22},
  [3853] = {.lex_state = 11},
  [3854] = {.lex_state = 11},
  [3855] = {.lex_state = 0, .external_lex_state = 4},
  [3856] = {.lex_state = 12},
  [3857] = {.lex_state = 93, .external_lex_state = 4},
  [3858] = {.lex_state = 0, .external_lex_state = 4},
  [3859] = {.lex_state = 0, .external_lex_state = 4},
  [3860] = {.lex_state = 11},
  [3861] = {.lex_state = 11},
  [3862] = {.lex_state = 12},
  [3863] = {.lex_state = 0, .external_lex_state = 4},
  [3864] = {.lex_state = 11},
  [3865] = {.lex_state = 11},
  [3866] = {.lex_state = 93},
  [3867] = {.lex_state = 11},
  [3868] = {.lex_state = 17},
  [3869] = {.lex_state = 22},
  [3870] = {.lex_state = 12},
  [3871] = {.lex_state = 11},
  [3872] = {.lex_state = 93},
  [3873] = {.lex_state = 0},
  [3874] = {.lex_state = 1},
  [3875] = {.lex_state = 93, .external_lex_state = 4},
  [3876] = {.lex_state = 0, .external_lex_state = 4},
  [3877] = {.lex_state = 11},
  [3878] = {.lex_state = 0},
  [3879] = {.lex_state = 0, .external_lex_state = 4},
  [3880] = {.lex_state = 12},
  [3881] = {.lex_state = 0},
  [3882] = {.lex_state = 0},
  [3883] = {.lex_state = 22},
  [3884] = {.lex_state = 11},
  [3885] = {.lex_state = 0, .external_lex_state = 4},
  [3886] = {.lex_state = 17},
  [3887] = {.lex_state = 93},
  [3888] = {.lex_state = 22},
  [3889] = {.lex_state = 1},
  [3890] = {.lex_state = 17},
  [3891] = {.lex_state = 1},
  [3892] = {.lex_state = 18, .external_lex_state = 6},
  [3893] = {.lex_state = 0, .external_lex_state = 4},
  [3894] = {.lex_state = 22},
  [3895] = {.lex_state = 12},
  [3896] = {.lex_state = 22},
  [3897] = {.lex_state = 17},
  [3898] = {.lex_state = 11},
  [3899] = {.lex_state = 11},
  [3900] = {.lex_state = 1},
  [3901] = {.lex_state = 93},
  [3902] = {.lex_state = 12},
  [3903] = {.lex_state = 12},
  [3904] = {.lex_state = 0, .external_lex_state = 5},
  [3905] = {.lex_state = 93, .external_lex_state = 4},
  [3906] = {.lex_state = 12},
  [3907] = {.lex_state = 11},
  [3908] = {.lex_state = 0},
  [3909] = {.lex_state = 11},
  [3910] = {.lex_state = 12},
  [3911] = {.lex_state = 93},
  [3912] = {.lex_state = 22},
  [3913] = {.lex_state = 17},
  [3914] = {.lex_state = 22},
  [3915] = {.lex_state = 17},
  [3916] = {.lex_state = 12},
  [3917] = {.lex_state = 93, .external_lex_state = 4},
  [3918] = {.lex_state = 0},
  [3919] = {.lex_state = 12},
  [3920] = {.lex_state = 22},
  [3921] = {.lex_state = 17},
  [3922] = {.lex_state = 11},
  [3923] = {.lex_state = 93, .external_lex_state = 4},
  [3924] = {.lex_state = 0, .external_lex_state = 4},
  [3925] = {.lex_state = 11},
  [3926] = {.lex_state = 22},
  [3927] = {.lex_state = 11},
  [3928] = {.lex_state = 17},
  [3929] = {.lex_state = 93},
  [3930] = {.lex_state = 93},
  [3931] = {.lex_state = 22},
  [3932] = {.lex_state = 18, .external_lex_state = 6},
  [3933] = {.lex_state = 12},
  [3934] = {.lex_state = 12},
  [3935] = {.lex_state = 17},
  [3936] = {.lex_state = 11},
  [3937] = {.lex_state = 12},
  [3938] = {.lex_state = 11},
  [3939] = {.lex_state = 0, .external_lex_state = 4},
  [3940] = {.lex_state = 0, .external_lex_state = 4},
  [3941] = {.lex_state = 11},
  [3942] = {.lex_state = 11},
  [3943] = {.lex_state = 5},
  [3944] = {.lex_state = 11},
  [3945] = {.lex_state = 11},
  [3946] = {.lex_state = 5, .external_lex_state = 4},
  [3947] = {.lex_state = 22},
  [3948] = {.lex_state = 17},
  [3949] = {.lex_state = 11},
  [3950] = {.lex_state = 5},
  [3951] = {.lex_state = 11},
  [3952] = {.lex_state = 17},
  [3953] = {.lex_state = 12},
  [3954] = {.lex_state = 0},
  [3955] = {.lex_state = 0},
  [3956] = {.lex_state = 0},
  [3957] = {.lex_state = 93},
  [3958] = {.lex_state = 11},
  [3959] = {.lex_state = 93},
  [3960] = {.lex_state = 0},
  [3961] = {.lex_state = 93, .external_lex_state = 4},
  [3962] = {.lex_state = 0},
  [3963] = {.lex_state = 22},
  [3964] = {.lex_state = 11},
  [3965] = {.lex_state = 17},
  [3966] = {.lex_state = 93},
  [3967] = {.lex_state = 22},
  [3968] = {.lex_state = 0, .external_lex_state = 4},
  [3969] = {.lex_state = 17},
  [3970] = {.lex_state = 22},
  [3971] = {.lex_state = 12},
  [3972] = {.lex_state = 11},
  [3973] = {.lex_state = 17},
  [3974] = {.lex_state = 11},
  [3975] = {.lex_state = 22},
  [3976] = {.lex_state = 0},
  [3977] = {.lex_state = 22},
  [3978] = {.lex_state = 0},
  [3979] = {.lex_state = 17},
  [3980] = {.lex_state = 17},
  [3981] = {.lex_state = 11},
  [3982] = {.lex_state = 17},
  [3983] = {.lex_state = 22},
  [3984] = {.lex_state = 11},
  [3985] = {.lex_state = 11},
  [3986] = {.lex_state = 11},
  [3987] = {.lex_state = 11},
  [3988] = {.lex_state = 0, .external_lex_state = 4},
  [3989] = {.lex_state = 11},
  [3990] = {.lex_state = 0, .external_lex_state = 4},
  [3991] = {.lex_state = 11},
  [3992] = {.lex_state = 0},
  [3993] = {.lex_state = 0},
  [3994] = {.lex_state = 22},
  [3995] = {.lex_state = 11},
  [3996] = {.lex_state = 0},
  [3997] = {.lex_state = 0},
  [3998] = {.lex_state = 0},
  [3999] = {.lex_state = 0},
  [4000] = {.lex_state = 0},
  [4001] = {.lex_state = 18, .external_lex_state = 6},
  [4002] = {.lex_state = 11},
  [4003] = {.lex_state = 12},
  [4004] = {.lex_state = 93},
  [4005] = {.lex_state = 0},
  [4006] = {.lex_state = 11},
  [4007] = {.lex_state = 0, .external_lex_state = 4},
  [4008] = {.lex_state = 0},
  [4009] = {.lex_state = 0, .external_lex_state = 4},
  [4010] = {.lex_state = 0},
  [4011] = {.lex_state = 0},
  [4012] = {.lex_state = 0, .external_lex_state = 4},
  [4013] = {.lex_state = 0},
  [4014] = {.lex_state = 0},
  [4015] = {.lex_state = 0},
  [4016] = {.lex_state = 0},
  [4017] = {.lex_state = 0},
  [4018] = {.lex_state = 0, .external_lex_state = 4},
  [4019] = {.lex_state = 0},
  [4020] = {.lex_state = 0},
  [4021] = {.lex_state = 0},
  [4022] = {.lex_state = 11},
  [4023] = {.lex_state = 0},
  [4024] = {.lex_state = 0, .external_lex_state = 4},
  [4025] = {.lex_state = 0},
  [4026] = {.lex_state = 0, .external_lex_state = 4},
  [4027] = {.lex_state = 0},
  [4028] = {.lex_state = 0, .external_lex_state = 4},
  [4029] = {.lex_state = 0, .external_lex_state = 4},
  [4030] = {.lex_state = 0},
  [4031] = {.lex_state = 0},
  [4032] = {.lex_state = 11},
  [4033] = {.lex_state = 11},
  [4034] = {.lex_state = 0},
  [4035] = {.lex_state = 93, .external_lex_state = 4},
  [4036] = {.lex_state = 0},
  [4037] = {.lex_state = 0},
  [4038] = {.lex_state = 93, .external_lex_state = 4},
  [4039] = {.lex_state = 93},
  [4040] = {.lex_state = 0},
  [4041] = {.lex_state = 0},
  [4042] = {.lex_state = 93, .external_lex_state = 4},
  [4043] = {.lex_state = 0, .external_lex_state = 4},
  [4044] = {.lex_state = 0},
  [4045] = {.lex_state = 0, .external_lex_state = 4},
  [4046] = {.lex_state = 11},
  [4047] = {.lex_state = 0},
  [4048] = {.lex_state = 11},
  [4049] = {.lex_state = 11},
  [4050] = {.lex_state = 0},
  [4051] = {.lex_state = 93},
  [4052] = {.lex_state = 0},
  [4053] = {.lex_state = 0, .external_lex_state = 4},
  [4054] = {.lex_state = 93},
  [4055] = {.lex_state = 0, .external_lex_state = 4},
  [4056] = {.lex_state = 0, .external_lex_state = 4},
  [4057] = {.lex_state = 5, .external_lex_state = 4},
  [4058] = {.lex_state = 5},
  [4059] = {.lex_state = 5},
  [4060] = {.lex_state = 0, .external_lex_state = 4},
  [4061] = {.lex_state = 93, .external_lex_state = 4},
  [4062] = {.lex_state = 0},
  [4063] = {.lex_state = 0, .external_lex_state = 4},
  [4064] = {.lex_state = 0, .external_lex_state = 4},
  [4065] = {.lex_state = 0},
  [4066] = {.lex_state = 0, .external_lex_state = 4},
  [4067] = {.lex_state = 0, .external_lex_state = 4},
  [4068] = {.lex_state = 0, .external_lex_state = 4},
  [4069] = {.lex_state = 0, .external_lex_state = 4},
  [4070] = {.lex_state = 0, .external_lex_state = 4},
  [4071] = {.lex_state = 93},
  [4072] = {.lex_state = 11},
  [4073] = {.lex_state = 0},
  [4074] = {.lex_state = 93, .external_lex_state = 4},
  [4075] = {.lex_state = 93},
  [4076] = {.lex_state = 0, .external_lex_state = 4},
  [4077] = {.lex_state = 0, .external_lex_state = 4},
  [4078] = {.lex_state = 0, .external_lex_state = 4},
  [4079] = {.lex_state = 0},
  [4080] = {.lex_state = 0, .external_lex_state = 4},
  [4081] = {.lex_state = 0},
  [4082] = {.lex_state = 93, .external_lex_state = 4},
  [4083] = {.lex_state = 11},
  [4084] = {.lex_state = 0},
  [4085] = {.lex_state = 0},
  [4086] = {.lex_state = 0},
  [4087] = {.lex_state = 93, .external_lex_state = 4},
  [4088] = {.lex_state = 11},
  [4089] = {.lex_state = 0, .external_lex_state = 4},
  [4090] = {.lex_state = 93},
  [4091] = {.lex_state = 0, .external_lex_state = 4},
  [4092] = {.lex_state = 0, .external_lex_state = 4},
  [4093] = {.lex_state = 0, .external_lex_state = 4},
  [4094] = {.lex_state = 11},
  [4095] = {.lex_state = 93},
  [4096] = {.lex_state = 93},
  [4097] = {.lex_state = 0},
  [4098] = {.lex_state = 11},
  [4099] = {.lex_state = 0, .external_lex_state = 4},
  [4100] = {.lex_state = 0},
  [4101] = {.lex_state = 0},
  [4102] = {.lex_state = 0},
  [4103] = {.lex_state = 0},
  [4104] = {.lex_state = 11},
  [4105] = {.lex_state = 0},
  [4106] = {.lex_state = 93},
  [4107] = {.lex_state = 5},
  [4108] = {.lex_state = 11},
  [4109] = {.lex_state = 0},
  [4110] = {.lex_state = 93},
  [4111] = {.lex_state = 93},
  [4112] = {.lex_state = 0},
  [4113] = {.lex_state = 0, .external_lex_state = 4},
  [4114] = {.lex_state = 0},
  [4115] = {.lex_state = 0},
  [4116] = {.lex_state = 11},
  [4117] = {.lex_state = 93},
  [4118] = {.lex_state = 11},
  [4119] = {.lex_state = 0},
  [4120] = {.lex_state = 93},
  [4121] = {.lex_state = 0, .external_lex_state = 4},
  [4122] = {.lex_state = 93},
  [4123] = {.lex_state = 0},
  [4124] = {.lex_state = 0},
  [4125] = {.lex_state = 0},
  [4126] = {.lex_state = 0},
  [4127] = {.lex_state = 0, .external_lex_state = 4},
  [4128] = {.lex_state = 11},
  [4129] = {.lex_state = 0},
  [4130] = {.lex_state = 93},
  [4131] = {.lex_state = 0},
  [4132] = {.lex_state = 93},
  [4133] = {.lex_state = 5},
  [4134] = {.lex_state = 0},
  [4135] = {.lex_state = 5},
  [4136] = {.lex_state = 11},
  [4137] = {.lex_state = 0, .external_lex_state = 4},
  [4138] = {.lex_state = 0},
  [4139] = {.lex_state = 0, .external_lex_state = 4},
  [4140] = {.lex_state = 0, .external_lex_state = 4},
  [4141] = {.lex_state = 0, .external_lex_state = 4},
  [4142] = {.lex_state = 0},
  [4143] = {.lex_state = 11},
  [4144] = {.lex_state = 0, .external_lex_state = 4},
  [4145] = {.lex_state = 0},
  [4146] = {.lex_state = 0},
  [4147] = {.lex_state = 0},
  [4148] = {.lex_state = 0},
  [4149] = {.lex_state = 11},
  [4150] = {.lex_state = 0},
  [4151] = {.lex_state = 0},
  [4152] = {.lex_state = 93},
  [4153] = {.lex_state = 11},
  [4154] = {.lex_state = 0},
  [4155] = {.lex_state = 0},
  [4156] = {.lex_state = 11},
  [4157] = {.lex_state = 12},
  [4158] = {.lex_state = 0},
  [4159] = {.lex_state = 0},
  [4160] = {.lex_state = 0},
  [4161] = {.lex_state = 0, .external_lex_state = 4},
  [4162] = {.lex_state = 0},
  [4163] = {.lex_state = 0, .external_lex_state = 4},
  [4164] = {.lex_state = 0},
  [4165] = {.lex_state = 0},
  [4166] = {.lex_state = 93, .external_lex_state = 4},
  [4167] = {.lex_state = 0},
  [4168] = {.lex_state = 0},
  [4169] = {.lex_state = 0},
  [4170] = {.lex_state = 0},
  [4171] = {.lex_state = 0},
  [4172] = {.lex_state = 0},
  [4173] = {.lex_state = 0},
  [4174] = {.lex_state = 0},
  [4175] = {.lex_state = 11},
  [4176] = {.lex_state = 11},
  [4177] = {.lex_state = 0, .external_lex_state = 4},
  [4178] = {.lex_state = 11},
  [4179] = {.lex_state = 0, .external_lex_state = 4},
  [4180] = {.lex_state = 0},
  [4181] = {.lex_state = 11},
  [4182] = {.lex_state = 0},
  [4183] = {.lex_state = 0},
  [4184] = {.lex_state = 0},
  [4185] = {.lex_state = 0, .external_lex_state = 4},
  [4186] = {.lex_state = 0},
  [4187] = {.lex_state = 0, .external_lex_state = 4},
  [4188] = {.lex_state = 0},
  [4189] = {.lex_state = 93},
  [4190] = {.lex_state = 0},
  [4191] = {.lex_state = 0},
  [4192] = {.lex_state = 0, .external_lex_state = 4},
  [4193] = {.lex_state = 11},
  [4194] = {.lex_state = 5, .external_lex_state = 4},
  [4195] = {.lex_state = 0},
  [4196] = {.lex_state = 93},
  [4197] = {.lex_state = 0},
  [4198] = {.lex_state = 93},
  [4199] = {.lex_state = 0},
  [4200] = {.lex_state = 0},
  [4201] = {.lex_state = 0},
  [4202] = {.lex_state = 0},
  [4203] = {.lex_state = 0},
  [4204] = {.lex_state = 5},
  [4205] = {.lex_state = 12},
  [4206] = {.lex_state = 0, .external_lex_state = 4},
  [4207] = {.lex_state = 93},
  [4208] = {.lex_state = 93},
  [4209] = {.lex_state = 93},
  [4210] = {.lex_state = 0},
  [4211] = {.lex_state = 0},
  [4212] = {.lex_state = 93},
  [4213] = {.lex_state = 93, .external_lex_state = 4},
  [4214] = {.lex_state = 93},
  [4215] = {.lex_state = 11},
  [4216] = {.lex_state = 0},
  [4217] = {.lex_state = 0},
  [4218] = {.lex_state = 93, .external_lex_state = 4},
  [4219] = {.lex_state = 0},
  [4220] = {.lex_state = 0},
  [4221] = {.lex_state = 0, .external_lex_state = 4},
  [4222] = {.lex_state = 0},
  [4223] = {.lex_state = 0, .external_lex_state = 4},
  [4224] = {.lex_state = 0, .external_lex_state = 4},
  [4225] = {.lex_state = 93},
  [4226] = {.lex_state = 0, .external_lex_state = 4},
  [4227] = {.lex_state = 0},
  [4228] = {.lex_state = 93},
  [4229] = {.lex_state = 5},
  [4230] = {.lex_state = 0, .external_lex_state = 4},
  [4231] = {.lex_state = 5, .external_lex_state = 4},
  [4232] = {.lex_state = 0, .external_lex_state = 4},
  [4233] = {.lex_state = 5},
  [4234] = {.lex_state = 12},
  [4235] = {.lex_state = 0},
  [4236] = {.lex_state = 93},
  [4237] = {.lex_state = 11},
  [4238] = {.lex_state = 93},
  [4239] = {.lex_state = 0},
  [4240] = {.lex_state = 0},
  [4241] = {.lex_state = 11},
  [4242] = {.lex_state = 0, .external_lex_state = 4},
  [4243] = {.lex_state = 0},
  [4244] = {.lex_state = 0, .external_lex_state = 4},
  [4245] = {.lex_state = 93},
  [4246] = {.lex_state = 1},
  [4247] = {.lex_state = 0, .external_lex_state = 4},
  [4248] = {.lex_state = 93},
  [4249] = {.lex_state = 93, .external_lex_state = 4},
  [4250] = {.lex_state = 0, .external_lex_state = 4},
  [4251] = {.lex_state = 0, .external_lex_state = 4},
  [4252] = {.lex_state = 93},
  [4253] = {.lex_state = 93},
  [4254] = {.lex_state = 0},
  [4255] = {.lex_state = 93},
  [4256] = {.lex_state = 0, .external_lex_state = 4},
  [4257] = {.lex_state = 11},
  [4258] = {.lex_state = 0, .external_lex_state = 4},
  [4259] = {.lex_state = 11},
  [4260] = {.lex_state = 0},
  [4261] = {.lex_state = 5},
  [4262] = {.lex_state = 0},
  [4263] = {.lex_state = 0},
  [4264] = {.lex_state = 93, .external_lex_state = 4},
  [4265] = {.lex_state = 93},
  [4266] = {.lex_state = 93},
  [4267] = {.lex_state = 93},
  [4268] = {.lex_state = 93},
  [4269] = {.lex_state = 0},
  [4270] = {.lex_state = 5},
  [4271] = {.lex_state = 0},
  [4272] = {.lex_state = 0, .external_lex_state = 4},
  [4273] = {.lex_state = 0},
  [4274] = {.lex_state = 0},
  [4275] = {.lex_state = 0, .external_lex_state = 4},
  [4276] = {.lex_state = 0, .external_lex_state = 4},
  [4277] = {.lex_state = 11},
  [4278] = {.lex_state = 0},
  [4279] = {.lex_state = 93},
  [4280] = {.lex_state = 93},
  [4281] = {.lex_state = 93},
  [4282] = {.lex_state = 11},
  [4283] = {.lex_state = 93},
  [4284] = {.lex_state = 0},
  [4285] = {.lex_state = 93},
  [4286] = {.lex_state = 11},
  [4287] = {.lex_state = 0, .external_lex_state = 4},
  [4288] = {.lex_state = 0, .external_lex_state = 4},
  [4289] = {.lex_state = 93},
  [4290] = {.lex_state = 0},
  [4291] = {.lex_state = 0, .external_lex_state = 4},
  [4292] = {.lex_state = 93},
  [4293] = {.lex_state = 93},
  [4294] = {.lex_state = 93},
  [4295] = {.lex_state = 0},
  [4296] = {.lex_state = 93},
  [4297] = {.lex_state = 11},
  [4298] = {.lex_state = 0},
  [4299] = {.lex_state = 11},
  [4300] = {.lex_state = 11},
  [4301] = {.lex_state = 11},
  [4302] = {.lex_state = 11},
  [4303] = {.lex_state = 11},
  [4304] = {.lex_state = 11},
  [4305] = {.lex_state = 93},
  [4306] = {.lex_state = 11},
  [4307] = {.lex_state = 11},
  [4308] = {.lex_state = 11},
  [4309] = {.lex_state = 0, .external_lex_state = 4},
  [4310] = {.lex_state = 11},
  [4311] = {.lex_state = 15},
  [4312] = {.lex_state = 11},
  [4313] = {.lex_state = 0, .external_lex_state = 4},
  [4314] = {.lex_state = 11},
  [4315] = {.lex_state = 0, .external_lex_state = 4},
  [4316] = {.lex_state = 0, .external_lex_state = 4},
  [4317] = {.lex_state = 11},
  [4318] = {.lex_state = 11},
  [4319] = {.lex_state = 0},
  [4320] = {.lex_state = 11},
  [4321] = {.lex_state = 0, .external_lex_state = 4},
  [4322] = {.lex_state = 0},
  [4323] = {.lex_state = 0, .external_lex_state = 4},
  [4324] = {.lex_state = 0, .external_lex_state = 4},
  [4325] = {.lex_state = 11},
  [4326] = {.lex_state = 11},
  [4327] = {.lex_state = 11},
  [4328] = {.lex_state = 11},
  [4329] = {.lex_state = 0, .external_lex_state = 4},
  [4330] = {.lex_state = 11},
  [4331] = {.lex_state = 11},
  [4332] = {.lex_state = 0, .external_lex_state = 4},
  [4333] = {.lex_state = 93},
  [4334] = {.lex_state = 11},
  [4335] = {.lex_state = 0},
  [4336] = {.lex_state = 93},
  [4337] = {.lex_state = 11},
  [4338] = {.lex_state = 11},
  [4339] = {.lex_state = 11},
  [4340] = {.lex_state = 0},
  [4341] = {.lex_state = 11},
  [4342] = {.lex_state = 11},
  [4343] = {.lex_state = 0},
  [4344] = {.lex_state = 11},
  [4345] = {.lex_state = 11},
  [4346] = {.lex_state = 11},
  [4347] = {.lex_state = 0},
  [4348] = {.lex_state = 0},
  [4349] = {.lex_state = 0},
  [4350] = {.lex_state = 0, .external_lex_state = 4},
  [4351] = {.lex_state = 11},
  [4352] = {.lex_state = 11},
  [4353] = {.lex_state = 11},
  [4354] = {.lex_state = 11},
  [4355] = {.lex_state = 0},
  [4356] = {.lex_state = 0, .external_lex_state = 4},
  [4357] = {.lex_state = 0},
  [4358] = {.lex_state = 0, .external_lex_state = 4},
  [4359] = {.lex_state = 93},
  [4360] = {.lex_state = 11},
  [4361] = {.lex_state = 0},
  [4362] = {.lex_state = 11},
  [4363] = {.lex_state = 11},
  [4364] = {.lex_state = 93},
  [4365] = {.lex_state = 0},
  [4366] = {.lex_state = 11},
  [4367] = {.lex_state = 11},
  [4368] = {.lex_state = 11},
  [4369] = {.lex_state = 11},
  [4370] = {.lex_state = 0, .external_lex_state = 4},
  [4371] = {.lex_state = 11},
  [4372] = {.lex_state = 11},
  [4373] = {.lex_state = 11},
  [4374] = {.lex_state = 11},
  [4375] = {.lex_state = 11},
  [4376] = {.lex_state = 0, .external_lex_state = 4},
  [4377] = {.lex_state = 11},
  [4378] = {.lex_state = 11},
  [4379] = {.lex_state = 11},
  [4380] = {.lex_state = 11},
  [4381] = {.lex_state = 0},
  [4382] = {.lex_state = 11},
  [4383] = {.lex_state = 0},
  [4384] = {.lex_state = 0, .external_lex_state = 4},
  [4385] = {.lex_state = 0},
  [4386] = {.lex_state = 0},
  [4387] = {.lex_state = 93},
  [4388] = {.lex_state = 11},
  [4389] = {.lex_state = 11},
  [4390] = {.lex_state = 11},
  [4391] = {.lex_state = 0},
  [4392] = {.lex_state = 0},
  [4393] = {.lex_state = 11},
  [4394] = {.lex_state = 0, .external_lex_state = 4},
  [4395] = {.lex_state = 0, .external_lex_state = 4},
  [4396] = {.lex_state = 0},
  [4397] = {.lex_state = 11},
  [4398] = {.lex_state = 0, .external_lex_state = 4},
  [4399] = {.lex_state = 0},
  [4400] = {.lex_state = 0},
  [4401] = {.lex_state = 0},
  [4402] = {.lex_state = 11},
  [4403] = {.lex_state = 0},
  [4404] = {.lex_state = 11},
  [4405] = {.lex_state = 11},
  [4406] = {.lex_state = 93},
  [4407] = {.lex_state = 11},
  [4408] = {.lex_state = 11},
  [4409] = {.lex_state = 0},
  [4410] = {.lex_state = 93},
  [4411] = {.lex_state = 93},
  [4412] = {.lex_state = 93},
  [4413] = {.lex_state = 93},
  [4414] = {.lex_state = 0},
  [4415] = {.lex_state = 11},
  [4416] = {.lex_state = 11},
  [4417] = {.lex_state = 11},
  [4418] = {.lex_state = 11},
  [4419] = {.lex_state = 0, .external_lex_state = 4},
  [4420] = {.lex_state = 0},
  [4421] = {.lex_state = 0},
  [4422] = {.lex_state = 0, .external_lex_state = 4},
  [4423] = {.lex_state = 11},
  [4424] = {.lex_state = 0, .external_lex_state = 4},
  [4425] = {.lex_state = 93},
  [4426] = {.lex_state = 0, .external_lex_state = 4},
  [4427] = {.lex_state = 93},
  [4428] = {.lex_state = 0, .external_lex_state = 4},
  [4429] = {.lex_state = 11},
  [4430] = {.lex_state = 0, .external_lex_state = 4},
  [4431] = {.lex_state = 0, .external_lex_state = 4},
  [4432] = {.lex_state = 0, .external_lex_state = 4},
  [4433] = {.lex_state = 93},
  [4434] = {.lex_state = 0},
  [4435] = {.lex_state = 0},
  [4436] = {.lex_state = 0, .external_lex_state = 4},
  [4437] = {.lex_state = 0},
  [4438] = {.lex_state = 0},
  [4439] = {.lex_state = 11},
  [4440] = {.lex_state = 0, .external_lex_state = 4},
  [4441] = {.lex_state = 0},
  [4442] = {.lex_state = 0},
  [4443] = {.lex_state = 11},
  [4444] = {.lex_state = 11},
  [4445] = {.lex_state = 93},
  [4446] = {.lex_state = 11},
  [4447] = {.lex_state = 11},
  [4448] = {.lex_state = 11},
  [4449] = {.lex_state = 0, .external_lex_state = 4},
  [4450] = {.lex_state = 11},
  [4451] = {.lex_state = 11},
  [4452] = {.lex_state = 11},
  [4453] = {.lex_state = 11},
  [4454] = {.lex_state = 11},
  [4455] = {.lex_state = 11},
  [4456] = {.lex_state = 0},
  [4457] = {.lex_state = 0},
  [4458] = {.lex_state = 11},
  [4459] = {.lex_state = 0, .external_lex_state = 4},
  [4460] = {.lex_state = 0, .external_lex_state = 4},
  [4461] = {.lex_state = 0},
  [4462] = {.lex_state = 0, .external_lex_state = 4},
  [4463] = {.lex_state = 11},
  [4464] = {.lex_state = 0},
  [4465] = {.lex_state = 11},
  [4466] = {.lex_state = 0, .external_lex_state = 4},
  [4467] = {.lex_state = 11},
  [4468] = {.lex_state = 0},
  [4469] = {.lex_state = 0},
  [4470] = {.lex_state = 0, .external_lex_state = 4},
  [4471] = {.lex_state = 0},
  [4472] = {.lex_state = 0},
  [4473] = {.lex_state = 11},
  [4474] = {.lex_state = 11},
  [4475] = {.lex_state = 0, .external_lex_state = 4},
  [4476] = {.lex_state = 11},
  [4477] = {.lex_state = 0},
  [4478] = {.lex_state = 0},
  [4479] = {.lex_state = 0, .external_lex_state = 4},
  [4480] = {.lex_state = 0},
  [4481] = {.lex_state = 11},
  [4482] = {.lex_state = 0, .external_lex_state = 4},
  [4483] = {.lex_state = 0},
  [4484] = {.lex_state = 0},
  [4485] = {.lex_state = 0},
  [4486] = {.lex_state = 0},
  [4487] = {.lex_state = 0},
  [4488] = {.lex_state = 11},
  [4489] = {.lex_state = 0},
  [4490] = {.lex_state = 0},
  [4491] = {.lex_state = 11},
  [4492] = {.lex_state = 0, .external_lex_state = 4},
  [4493] = {.lex_state = 11},
  [4494] = {.lex_state = 11},
  [4495] = {.lex_state = 0},
  [4496] = {.lex_state = 0},
  [4497] = {.lex_state = 11},
  [4498] = {.lex_state = 93},
  [4499] = {.lex_state = 0},
  [4500] = {.lex_state = 93},
  [4501] = {.lex_state = 11},
  [4502] = {.lex_state = 1},
  [4503] = {.lex_state = 11},
  [4504] = {.lex_state = 0},
  [4505] = {.lex_state = 11},
  [4506] = {.lex_state = 11},
  [4507] = {.lex_state = 0},
  [4508] = {.lex_state = 11},
  [4509] = {.lex_state = 0},
  [4510] = {.lex_state = 11},
  [4511] = {.lex_state = 11},
  [4512] = {.lex_state = 0},
  [4513] = {.lex_state = 11},
  [4514] = {.lex_state = 0, .external_lex_state = 4},
  [4515] = {.lex_state = 0},
  [4516] = {.lex_state = 11},
  [4517] = {.lex_state = 0},
  [4518] = {.lex_state = 0, .external_lex_state = 4},
  [4519] = {.lex_state = 11},
  [4520] = {.lex_state = 0},
  [4521] = {.lex_state = 11},
  [4522] = {.lex_state = 0},
  [4523] = {.lex_state = 0},
  [4524] = {.lex_state = 0},
  [4525] = {.lex_state = 11},
  [4526] = {.lex_state = 11},
  [4527] = {.lex_state = 93},
  [4528] = {.lex_state = 0, .external_lex_state = 4},
  [4529] = {.lex_state = 0},
  [4530] = {.lex_state = 11},
  [4531] = {.lex_state = 11},
  [4532] = {.lex_state = 93},
  [4533] = {.lex_state = 11},
  [4534] = {.lex_state = 11},
  [4535] = {.lex_state = 0},
  [4536] = {.lex_state = 0},
  [4537] = {.lex_state = 0},
  [4538] = {.lex_state = 11},
  [4539] = {.lex_state = 0},
  [4540] = {.lex_state = 0},
  [4541] = {.lex_state = 0},
  [4542] = {.lex_state = 0, .external_lex_state = 4},
  [4543] = {.lex_state = 0},
  [4544] = {.lex_state = 0},
  [4545] = {.lex_state = 11},
  [4546] = {.lex_state = 11},
  [4547] = {.lex_state = 0},
  [4548] = {.lex_state = 0},
  [4549] = {.lex_state = 0, .external_lex_state = 4},
  [4550] = {.lex_state = 93},
  [4551] = {.lex_state = 0, .external_lex_state = 4},
  [4552] = {.lex_state = 0, .external_lex_state = 4},
  [4553] = {.lex_state = 11},
  [4554] = {.lex_state = 0, .external_lex_state = 4},
  [4555] = {.lex_state = 11},
  [4556] = {.lex_state = 0, .external_lex_state = 4},
  [4557] = {.lex_state = 0, .external_lex_state = 4},
  [4558] = {.lex_state = 0, .external_lex_state = 4},
  [4559] = {.lex_state = 0},
  [4560] = {.lex_state = 0},
  [4561] = {.lex_state = 93},
  [4562] = {.lex_state = 0},
  [4563] = {.lex_state = 93},
  [4564] = {.lex_state = 0},
  [4565] = {.lex_state = 0, .external_lex_state = 4},
  [4566] = {.lex_state = 0},
  [4567] = {.lex_state = 0},
  [4568] = {.lex_state = 0},
  [4569] = {.lex_state = 0, .external_lex_state = 4},
  [4570] = {.lex_state = 0, .external_lex_state = 4},
  [4571] = {.lex_state = 0},
  [4572] = {.lex_state = 0, .external_lex_state = 4},
  [4573] = {.lex_state = 11},
  [4574] = {.lex_state = 11},
  [4575] = {.lex_state = 11},
  [4576] = {.lex_state = 11},
  [4577] = {.lex_state = 0},
  [4578] = {.lex_state = 0, .external_lex_state = 4},
  [4579] = {.lex_state = 11},
  [4580] = {.lex_state = 11},
  [4581] = {.lex_state = 11},
  [4582] = {.lex_state = 0},
  [4583] = {.lex_state = 0},
  [4584] = {.lex_state = 11},
  [4585] = {.lex_state = 11},
  [4586] = {.lex_state = 11},
  [4587] = {.lex_state = 11},
  [4588] = {.lex_state = 93},
  [4589] = {.lex_state = 11},
  [4590] = {.lex_state = 11},
  [4591] = {.lex_state = 0},
  [4592] = {.lex_state = 0},
  [4593] = {.lex_state = 11},
  [4594] = {.lex_state = 0},
  [4595] = {.lex_state = 0, .external_lex_state = 4},
  [4596] = {.lex_state = 11},
  [4597] = {.lex_state = 11},
  [4598] = {.lex_state = 0},
  [4599] = {.lex_state = 0},
  [4600] = {.lex_state = 0},
  [4601] = {.lex_state = 0},
  [4602] = {.lex_state = 0},
  [4603] = {.lex_state = 93},
  [4604] = {.lex_state = 0, .external_lex_state = 4},
  [4605] = {.lex_state = 0, .external_lex_state = 4},
  [4606] = {.lex_state = 0, .external_lex_state = 4},
  [4607] = {.lex_state = 0},
  [4608] = {.lex_state = 0, .external_lex_state = 4},
  [4609] = {.lex_state = 0, .external_lex_state = 4},
  [4610] = {.lex_state = 11},
  [4611] = {.lex_state = 93},
  [4612] = {.lex_state = 11},
  [4613] = {.lex_state = 93},
  [4614] = {.lex_state = 0},
  [4615] = {.lex_state = 0, .external_lex_state = 4},
  [4616] = {.lex_state = 0},
  [4617] = {.lex_state = 11},
  [4618] = {.lex_state = 11},
  [4619] = {.lex_state = 11},
  [4620] = {.lex_state = 93},
  [4621] = {.lex_state = 11},
  [4622] = {.lex_state = 93},
  [4623] = {.lex_state = 11},
  [4624] = {.lex_state = 11},
  [4625] = {.lex_state = 93},
  [4626] = {.lex_state = 93},
  [4627] = {.lex_state = 11},
  [4628] = {.lex_state = 0},
  [4629] = {.lex_state = 0, .external_lex_state = 4},
  [4630] = {.lex_state = 0, .external_lex_state = 4},
  [4631] = {.lex_state = 0, .external_lex_state = 4},
  [4632] = {.lex_state = 93},
  [4633] = {.lex_state = 11},
  [4634] = {.lex_state = 5},
  [4635] = {.lex_state = 0},
  [4636] = {.lex_state = 0},
  [4637] = {.lex_state = 0},
  [4638] = {.lex_state = 0},
  [4639] = {.lex_state = 93},
  [4640] = {.lex_state = 0},
  [4641] = {.lex_state = 0},
  [4642] = {.lex_state = 0},
  [4643] = {.lex_state = 93},
  [4644] = {.lex_state = 93},
  [4645] = {.lex_state = 93},
  [4646] = {.lex_state = 0},
  [4647] = {.lex_state = 0},
  [4648] = {.lex_state = 93},
  [4649] = {.lex_state = 0},
  [4650] = {.lex_state = 0},
  [4651] = {.lex_state = 0},
  [4652] = {.lex_state = 0},
  [4653] = {.lex_state = 0},
  [4654] = {.lex_state = 0},
  [4655] = {.lex_state = 0},
  [4656] = {.lex_state = 0},
  [4657] = {.lex_state = 0},
  [4658] = {.lex_state = 0},
  [4659] = {.lex_state = 0},
  [4660] = {.lex_state = 0},
  [4661] = {.lex_state = 0},
  [4662] = {.lex_state = 93},
  [4663] = {.lex_state = 93},
  [4664] = {.lex_state = 0},
  [4665] = {.lex_state = 5},
  [4666] = {.lex_state = 2},
  [4667] = {.lex_state = 0},
  [4668] = {.lex_state = 0},
  [4669] = {.lex_state = 0},
  [4670] = {.lex_state = 0},
  [4671] = {.lex_state = 93},
  [4672] = {.lex_state = 93},
  [4673] = {.lex_state = 0},
  [4674] = {.lex_state = 0},
  [4675] = {.lex_state = 0},
  [4676] = {.lex_state = 93},
  [4677] = {.lex_state = 93},
  [4678] = {.lex_state = 0},
  [4679] = {.lex_state = 93},
  [4680] = {.lex_state = 93},
  [4681] = {.lex_state = 0},
  [4682] = {.lex_state = 93},
  [4683] = {.lex_state = 0},
  [4684] = {.lex_state = 93},
  [4685] = {.lex_state = 0},
  [4686] = {.lex_state = 0},
  [4687] = {.lex_state = 0},
  [4688] = {.lex_state = 93},
  [4689] = {.lex_state = 0},
  [4690] = {.lex_state = 93},
  [4691] = {.lex_state = 0},
  [4692] = {.lex_state = 93},
  [4693] = {.lex_state = 0},
  [4694] = {.lex_state = 0},
  [4695] = {.lex_state = 0},
  [4696] = {.lex_state = 0},
  [4697] = {.lex_state = 93},
  [4698] = {.lex_state = 0},
  [4699] = {.lex_state = 0},
  [4700] = {.lex_state = 0},
  [4701] = {.lex_state = 0},
  [4702] = {.lex_state = 0},
  [4703] = {.lex_state = 0},
  [4704] = {.lex_state = 0},
  [4705] = {.lex_state = 0},
  [4706] = {.lex_state = 12},
  [4707] = {.lex_state = 0},
  [4708] = {.lex_state = 0},
  [4709] = {.lex_state = 93},
  [4710] = {.lex_state = 93},
  [4711] = {.lex_state = 0},
  [4712] = {.lex_state = 0},
  [4713] = {.lex_state = 0},
  [4714] = {.lex_state = 0},
  [4715] = {.lex_state = 0},
  [4716] = {.lex_state = 0},
  [4717] = {.lex_state = 0},
  [4718] = {.lex_state = 0},
  [4719] = {.lex_state = 93},
  [4720] = {.lex_state = 93},
  [4721] = {.lex_state = 0},
  [4722] = {.lex_state = 0},
  [4723] = {.lex_state = 93},
  [4724] = {.lex_state = 0},
  [4725] = {.lex_state = 93},
  [4726] = {.lex_state = 0},
  [4727] = {.lex_state = 93},
  [4728] = {.lex_state = 0},
  [4729] = {.lex_state = 93},
  [4730] = {.lex_state = 0},
  [4731] = {.lex_state = 0},
  [4732] = {.lex_state = 0},
  [4733] = {.lex_state = 0},
  [4734] = {.lex_state = 0},
  [4735] = {.lex_state = 93},
  [4736] = {.lex_state = 0},
  [4737] = {.lex_state = 0},
  [4738] = {.lex_state = 93},
  [4739] = {.lex_state = 0},
  [4740] = {.lex_state = 0},
  [4741] = {.lex_state = 93},
  [4742] = {.lex_state = 0},
  [4743] = {.lex_state = 93},
  [4744] = {.lex_state = 93},
  [4745] = {.lex_state = 93},
  [4746] = {.lex_state = 0},
  [4747] = {.lex_state = 0},
  [4748] = {.lex_state = 0},
  [4749] = {.lex_state = 0},
  [4750] = {.lex_state = 0},
  [4751] = {.lex_state = 0},
  [4752] = {.lex_state = 2},
  [4753] = {.lex_state = 12},
  [4754] = {.lex_state = 93},
  [4755] = {.lex_state = 0},
  [4756] = {.lex_state = 0},
  [4757] = {.lex_state = 93},
  [4758] = {.lex_state = 5},
  [4759] = {.lex_state = 2},
  [4760] = {.lex_state = 0},
  [4761] = {.lex_state = 93},
  [4762] = {.lex_state = 93},
  [4763] = {.lex_state = 93},
  [4764] = {.lex_state = 93},
  [4765] = {.lex_state = 93},
  [4766] = {.lex_state = 93},
  [4767] = {.lex_state = 0},
  [4768] = {.lex_state = 0},
  [4769] = {.lex_state = 93},
  [4770] = {.lex_state = 0},
  [4771] = {.lex_state = 0},
  [4772] = {.lex_state = 0},
  [4773] = {.lex_state = 0},
  [4774] = {.lex_state = 0},
  [4775] = {.lex_state = 0},
  [4776] = {.lex_state = 0},
  [4777] = {.lex_state = 12},
  [4778] = {.lex_state = 93},
  [4779] = {.lex_state = 0},
  [4780] = {.lex_state = 93},
  [4781] = {.lex_state = 0},
  [4782] = {.lex_state = 0},
  [4783] = {.lex_state = 93},
  [4784] = {.lex_state = 0},
  [4785] = {.lex_state = 0},
  [4786] = {.lex_state = 0},
  [4787] = {.lex_state = 0},
  [4788] = {.lex_state = 12},
  [4789] = {.lex_state = 5},
  [4790] = {.lex_state = 2},
  [4791] = {.lex_state = 5},
  [4792] = {.lex_state = 11},
  [4793] = {.lex_state = 0},
  [4794] = {.lex_state = 0},
  [4795] = {.lex_state = 0},
  [4796] = {.lex_state = 11},
  [4797] = {.lex_state = 0},
  [4798] = {.lex_state = 0},
  [4799] = {.lex_state = 93},
  [4800] = {.lex_state = 93},
  [4801] = {.lex_state = 93},
  [4802] = {.lex_state = 0},
  [4803] = {.lex_state = 0},
  [4804] = {.lex_state = 0},
  [4805] = {.lex_state = 0},
  [4806] = {.lex_state = 0},
  [4807] = {.lex_state = 0},
  [4808] = {.lex_state = 0},
  [4809] = {.lex_state = 93},
  [4810] = {.lex_state = 93},
  [4811] = {.lex_state = 5},
  [4812] = {.lex_state = 93},
  [4813] = {.lex_state = 93},
  [4814] = {.lex_state = 0},
  [4815] = {.lex_state = 93},
  [4816] = {.lex_state = 93},
  [4817] = {.lex_state = 0},
  [4818] = {.lex_state = 2},
  [4819] = {.lex_state = 93},
  [4820] = {.lex_state = 93},
  [4821] = {.lex_state = 0},
  [4822] = {.lex_state = 0},
  [4823] = {.lex_state = 0},
  [4824] = {.lex_state = 0},
  [4825] = {.lex_state = 93},
  [4826] = {.lex_state = 0},
  [4827] = {.lex_state = 0},
  [4828] = {.lex_state = 0},
  [4829] = {.lex_state = 93},
  [4830] = {.lex_state = 0},
  [4831] = {.lex_state = 93},
  [4832] = {.lex_state = 0},
  [4833] = {.lex_state = 93},
  [4834] = {.lex_state = 93},
  [4835] = {.lex_state = 93},
  [4836] = {.lex_state = 93},
  [4837] = {.lex_state = 93},
  [4838] = {.lex_state = 0},
  [4839] = {.lex_state = 0},
  [4840] = {.lex_state = 0},
  [4841] = {.lex_state = 0},
  [4842] = {.lex_state = 93},
  [4843] = {.lex_state = 93},
  [4844] = {.lex_state = 93},
  [4845] = {.lex_state = 0},
  [4846] = {.lex_state = 0},
  [4847] = {.lex_state = 0},
  [4848] = {.lex_state = 0},
  [4849] = {.lex_state = 93},
  [4850] = {.lex_state = 0},
  [4851] = {.lex_state = 0},
  [4852] = {.lex_state = 93},
  [4853] = {.lex_state = 93},
  [4854] = {.lex_state = 0},
  [4855] = {.lex_state = 0},
  [4856] = {.lex_state = 0},
  [4857] = {.lex_state = 0},
  [4858] = {.lex_state = 0},
  [4859] = {.lex_state = 0},
  [4860] = {.lex_state = 0},
  [4861] = {.lex_state = 0},
  [4862] = {.lex_state = 0},
  [4863] = {.lex_state = 0},
  [4864] = {.lex_state = 0},
  [4865] = {.lex_state = 0},
  [4866] = {.lex_state = 0},
  [4867] = {.lex_state = 0},
  [4868] = {.lex_state = 0},
  [4869] = {.lex_state = 93},
  [4870] = {.lex_state = 5},
  [4871] = {.lex_state = 12},
  [4872] = {.lex_state = 0},
  [4873] = {.lex_state = 0},
  [4874] = {.lex_state = 0},
  [4875] = {.lex_state = 93},
  [4876] = {.lex_state = 0},
  [4877] = {.lex_state = 0},
  [4878] = {.lex_state = 0},
  [4879] = {.lex_state = 0},
  [4880] = {.lex_state = 93},
  [4881] = {.lex_state = 93},
  [4882] = {.lex_state = 0},
  [4883] = {.lex_state = 0},
  [4884] = {.lex_state = 0},
  [4885] = {.lex_state = 0},
  [4886] = {.lex_state = 0},
  [4887] = {.lex_state = 93},
  [4888] = {.lex_state = 93},
  [4889] = {.lex_state = 0},
  [4890] = {.lex_state = 0},
  [4891] = {.lex_state = 0},
  [4892] = {.lex_state = 0},
  [4893] = {.lex_state = 0},
  [4894] = {.lex_state = 0},
  [4895] = {.lex_state = 0},
  [4896] = {.lex_state = 0},
  [4897] = {.lex_state = 0},
  [4898] = {.lex_state = 93},
  [4899] = {.lex_state = 93},
  [4900] = {.lex_state = 93},
  [4901] = {.lex_state = 0},
  [4902] = {.lex_state = 0},
  [4903] = {.lex_state = 0},
  [4904] = {.lex_state = 0},
  [4905] = {.lex_state = 0},
  [4906] = {.lex_state = 0},
  [4907] = {.lex_state = 0},
  [4908] = {.lex_state = 0},
  [4909] = {.lex_state = 0},
  [4910] = {.lex_state = 0},
  [4911] = {.lex_state = 0},
  [4912] = {.lex_state = 0},
  [4913] = {.lex_state = 0},
  [4914] = {.lex_state = 0},
  [4915] = {.lex_state = 93},
  [4916] = {.lex_state = 0},
  [4917] = {.lex_state = 93},
  [4918] = {.lex_state = 93},
  [4919] = {.lex_state = 93},
  [4920] = {.lex_state = 93},
  [4921] = {.lex_state = 93},
  [4922] = {.lex_state = 0},
  [4923] = {.lex_state = 0},
  [4924] = {.lex_state = 0},
  [4925] = {.lex_state = 93},
  [4926] = {.lex_state = 0},
  [4927] = {.lex_state = 93},
  [4928] = {.lex_state = 93},
  [4929] = {.lex_state = 93},
  [4930] = {.lex_state = 93},
  [4931] = {.lex_state = 93},
  [4932] = {.lex_state = 0},
  [4933] = {.lex_state = 93},
  [4934] = {.lex_state = 0},
  [4935] = {.lex_state = 0},
  [4936] = {.lex_state = 0},
  [4937] = {.lex_state = 0},
  [4938] = {.lex_state = 0},
  [4939] = {.lex_state = 12},
  [4940] = {.lex_state = 0},
  [4941] = {.lex_state = 0},
  [4942] = {.lex_state = 0},
  [4943] = {.lex_state = 0},
  [4944] = {.lex_state = 0},
  [4945] = {.lex_state = 93},
  [4946] = {.lex_state = 0},
  [4947] = {.lex_state = 0},
  [4948] = {.lex_state = 0},
  [4949] = {.lex_state = 93},
  [4950] = {.lex_state = 0},
  [4951] = {.lex_state = 0},
  [4952] = {.lex_state = 0},
  [4953] = {.lex_state = 0},
  [4954] = {.lex_state = 93},
  [4955] = {.lex_state = 93},
  [4956] = {.lex_state = 93},
  [4957] = {.lex_state = 0},
  [4958] = {.lex_state = 0},
  [4959] = {.lex_state = 0},
  [4960] = {.lex_state = 93},
  [4961] = {.lex_state = 0},
  [4962] = {.lex_state = 0},
  [4963] = {.lex_state = 93},
  [4964] = {.lex_state = 93},
  [4965] = {.lex_state = 0},
  [4966] = {.lex_state = 93},
  [4967] = {.lex_state = 0},
  [4968] = {.lex_state = 0},
  [4969] = {.lex_state = 0},
  [4970] = {.lex_state = 93},
  [4971] = {.lex_state = 0},
  [4972] = {.lex_state = 0},
  [4973] = {.lex_state = 0},
  [4974] = {.lex_state = 0},
  [4975] = {.lex_state = 0},
  [4976] = {.lex_state = 93},
  [4977] = {.lex_state = 0},
  [4978] = {.lex_state = 0},
  [4979] = {.lex_state = 0},
  [4980] = {.lex_state = 93},
  [4981] = {.lex_state = 0},
  [4982] = {.lex_state = 0},
  [4983] = {.lex_state = 0},
  [4984] = {.lex_state = 0},
  [4985] = {.lex_state = 0},
  [4986] = {.lex_state = 0},
  [4987] = {.lex_state = 0},
  [4988] = {.lex_state = 93},
  [4989] = {.lex_state = 11},
  [4990] = {.lex_state = 93},
  [4991] = {.lex_state = 93},
  [4992] = {.lex_state = 0},
  [4993] = {.lex_state = 93},
  [4994] = {.lex_state = 0},
  [4995] = {.lex_state = 93},
  [4996] = {.lex_state = 93},
  [4997] = {.lex_state = 0},
  [4998] = {.lex_state = 0},
  [4999] = {.lex_state = 93},
  [5000] = {.lex_state = 0},
  [5001] = {.lex_state = 0},
  [5002] = {.lex_state = 0},
  [5003] = {.lex_state = 93},
  [5004] = {.lex_state = 93},
  [5005] = {.lex_state = 93},
  [5006] = {.lex_state = 0},
  [5007] = {.lex_state = 0},
  [5008] = {.lex_state = 93},
  [5009] = {.lex_state = 93},
  [5010] = {.lex_state = 93},
  [5011] = {.lex_state = 0},
  [5012] = {.lex_state = 0},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
  ts_external_token__ternary_qmark = 2,
  ts_external_token_PIPE_PIPE = 3,
  ts_external_token__function_signature_automatic_semicolon = 4,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
  [ts_external_token__ternary_qmark] = sym__ternary_qmark,
  [ts_external_token_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [ts_external_token__function_signature_automatic_semicolon] = sym__function_signature_automatic_semicolon,
};

static const bool ts_external_scanner_states[7][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [2] = {
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [3] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__ternary_qmark] = true,
    [ts_external_token_PIPE_PIPE] = true,
  },
  [4] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [5] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__function_signature_automatic_semicolon] = true,
  },
  [6] = {
    [ts_external_token__template_chars] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LTtemplate_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_QMARK_DOT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_private_property_identifier] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_property] = ACTIONS(1),
    [anon_sym_signal] = ACTIONS(1),
    [anon_sym_on] = ACTIONS(1),
    [anon_sym_required] = ACTIONS(1),
    [anon_sym_component] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_DASH_QMARK_COLON] = ACTIONS(1),
    [anon_sym_asserts] = ACTIONS(1),
    [anon_sym_infer] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_unknown] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_object] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [anon_sym_pragma] = ACTIONS(1),
    [aux_sym_ui_version_specifier_token1] = ACTIONS(1),
    [anon_sym_list] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym__ternary_qmark] = ACTIONS(1),
    [sym__function_signature_automatic_semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(5001),
    [sym_ui_pragma] = STATE(2433),
    [sym_ui_import] = STATE(2433),
    [sym_ui_object_definition] = STATE(4997),
    [sym_ui_annotated_object] = STATE(4997),
    [sym_ui_annotation] = STATE(2769),
    [sym_ui_nested_identifier] = STATE(4261),
    [aux_sym_program_repeat1] = STATE(2433),
    [aux_sym_ui_annotated_object_repeat1] = STATE(2768),
    [sym_identifier] = ACTIONS(5),
    [sym_hash_bang_line] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(9),
    [anon_sym_type] = ACTIONS(9),
    [anon_sym_namespace] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(9),
    [anon_sym_of] = ACTIONS(9),
    [anon_sym_async] = ACTIONS(9),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_static] = ACTIONS(9),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_get] = ACTIONS(9),
    [anon_sym_set] = ACTIONS(9),
    [anon_sym_declare] = ACTIONS(9),
    [anon_sym_public] = ACTIONS(9),
    [anon_sym_private] = ACTIONS(9),
    [anon_sym_protected] = ACTIONS(9),
    [anon_sym_override] = ACTIONS(9),
    [anon_sym_module] = ACTIONS(9),
    [anon_sym_any] = ACTIONS(9),
    [anon_sym_number] = ACTIONS(9),
    [anon_sym_boolean] = ACTIONS(9),
    [anon_sym_string] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(9),
    [anon_sym_property] = ACTIONS(9),
    [anon_sym_signal] = ACTIONS(9),
    [anon_sym_on] = ACTIONS(9),
    [anon_sym_required] = ACTIONS(9),
    [anon_sym_component] = ACTIONS(9),
    [anon_sym_pragma] = ACTIONS(15),
  },
  [2] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3581),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_EQ] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_typeof] = ACTIONS(34),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(38),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_RPAREN] = ACTIONS(32),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(32),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(76),
    [anon_sym_DASH] = ACTIONS(76),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(84),
    [anon_sym_DASH_DASH] = ACTIONS(84),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [3] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3581),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(30),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(34),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(38),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(76),
    [anon_sym_DASH] = ACTIONS(76),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(84),
    [anon_sym_DASH_DASH] = ACTIONS(84),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(105),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [4] = {
    [sym_export_statement] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_for_in_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_debugger_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_throw_statement] = STATE(27),
    [sym_empty_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4681),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4681),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4681),
    [sym_spread_element] = STATE(4034),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2230),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4034),
    [sym_pair] = STATE(4034),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(3324),
    [sym_computed_property_name] = STATE(3324),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_accessibility_modifier] = STATE(2476),
    [sym_override_modifier] = STATE(2491),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(27),
    [aux_sym_object_repeat1] = STATE(4031),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(129),
    [anon_sym_export] = ACTIONS(131),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_RBRACE] = ACTIONS(143),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(149),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(191),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(197),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(213),
    [sym_private_property_identifier] = ACTIONS(215),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(221),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_get] = ACTIONS(225),
    [anon_sym_set] = ACTIONS(225),
    [anon_sym_declare] = ACTIONS(227),
    [anon_sym_public] = ACTIONS(229),
    [anon_sym_private] = ACTIONS(229),
    [anon_sym_protected] = ACTIONS(229),
    [anon_sym_override] = ACTIONS(231),
    [anon_sym_module] = ACTIONS(233),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_property] = ACTIONS(149),
    [anon_sym_signal] = ACTIONS(149),
    [anon_sym_on] = ACTIONS(149),
    [anon_sym_required] = ACTIONS(149),
    [anon_sym_component] = ACTIONS(149),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [5] = {
    [sym_export_statement] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4681),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4681),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4681),
    [sym_spread_element] = STATE(4034),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2230),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4034),
    [sym_pair] = STATE(4034),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(3324),
    [sym_computed_property_name] = STATE(3324),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_accessibility_modifier] = STATE(2476),
    [sym_override_modifier] = STATE(2491),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(22),
    [aux_sym_object_repeat1] = STATE(4031),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(129),
    [anon_sym_export] = ACTIONS(131),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_RBRACE] = ACTIONS(241),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(149),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(191),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(197),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(213),
    [sym_private_property_identifier] = ACTIONS(215),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(221),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_get] = ACTIONS(225),
    [anon_sym_set] = ACTIONS(225),
    [anon_sym_declare] = ACTIONS(227),
    [anon_sym_public] = ACTIONS(229),
    [anon_sym_private] = ACTIONS(229),
    [anon_sym_protected] = ACTIONS(229),
    [anon_sym_override] = ACTIONS(231),
    [anon_sym_module] = ACTIONS(233),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_property] = ACTIONS(149),
    [anon_sym_signal] = ACTIONS(149),
    [anon_sym_on] = ACTIONS(149),
    [anon_sym_required] = ACTIONS(149),
    [anon_sym_component] = ACTIONS(149),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [6] = {
    [sym_export_statement] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4681),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4681),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4681),
    [sym_spread_element] = STATE(4034),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2230),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4034),
    [sym_pair] = STATE(4034),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(3324),
    [sym_computed_property_name] = STATE(3324),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_accessibility_modifier] = STATE(2476),
    [sym_override_modifier] = STATE(2491),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(19),
    [aux_sym_object_repeat1] = STATE(4031),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(129),
    [anon_sym_export] = ACTIONS(131),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_RBRACE] = ACTIONS(243),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(149),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(191),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(197),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(213),
    [sym_private_property_identifier] = ACTIONS(215),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(221),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_get] = ACTIONS(225),
    [anon_sym_set] = ACTIONS(225),
    [anon_sym_declare] = ACTIONS(227),
    [anon_sym_public] = ACTIONS(229),
    [anon_sym_private] = ACTIONS(229),
    [anon_sym_protected] = ACTIONS(229),
    [anon_sym_override] = ACTIONS(231),
    [anon_sym_module] = ACTIONS(233),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_property] = ACTIONS(149),
    [anon_sym_signal] = ACTIONS(149),
    [anon_sym_on] = ACTIONS(149),
    [anon_sym_required] = ACTIONS(149),
    [anon_sym_component] = ACTIONS(149),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [7] = {
    [sym_export_statement] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4681),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4681),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4681),
    [sym_spread_element] = STATE(4034),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2230),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4034),
    [sym_pair] = STATE(4034),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(3324),
    [sym_computed_property_name] = STATE(3324),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_accessibility_modifier] = STATE(2476),
    [sym_override_modifier] = STATE(2491),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(19),
    [aux_sym_object_repeat1] = STATE(4031),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(129),
    [anon_sym_export] = ACTIONS(131),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(135),
    [anon_sym_namespace] = ACTIONS(137),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_RBRACE] = ACTIONS(245),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(149),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(149),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(191),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(197),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(213),
    [sym_private_property_identifier] = ACTIONS(215),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(221),
    [anon_sym_readonly] = ACTIONS(223),
    [anon_sym_get] = ACTIONS(225),
    [anon_sym_set] = ACTIONS(225),
    [anon_sym_declare] = ACTIONS(227),
    [anon_sym_public] = ACTIONS(229),
    [anon_sym_private] = ACTIONS(229),
    [anon_sym_protected] = ACTIONS(229),
    [anon_sym_override] = ACTIONS(231),
    [anon_sym_module] = ACTIONS(233),
    [anon_sym_any] = ACTIONS(149),
    [anon_sym_number] = ACTIONS(149),
    [anon_sym_boolean] = ACTIONS(149),
    [anon_sym_string] = ACTIONS(149),
    [anon_sym_symbol] = ACTIONS(149),
    [anon_sym_property] = ACTIONS(149),
    [anon_sym_signal] = ACTIONS(149),
    [anon_sym_on] = ACTIONS(149),
    [anon_sym_required] = ACTIONS(149),
    [anon_sym_component] = ACTIONS(149),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [8] = {
    [sym_export_statement] = STATE(23),
    [sym_declaration] = STATE(23),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4681),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4681),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4681),
    [sym_spread_element] = STATE(4052),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2230),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4052),
    [sym_pair] = STATE(4052),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(3324),
    [sym_computed_property_name] = STATE(3324),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_accessibility_modifier] = STATE(2476),
    [sym_override_modifier] = STATE(2491),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(23),
    [aux_sym_object_repeat1] = STATE(4037),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(249),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(251),
    [anon_sym_namespace] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(257),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(257),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(191),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(213),
    [sym_private_property_identifier] = ACTIONS(215),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(261),
    [anon_sym_readonly] = ACTIONS(263),
    [anon_sym_get] = ACTIONS(265),
    [anon_sym_set] = ACTIONS(265),
    [anon_sym_declare] = ACTIONS(267),
    [anon_sym_public] = ACTIONS(269),
    [anon_sym_private] = ACTIONS(269),
    [anon_sym_protected] = ACTIONS(269),
    [anon_sym_override] = ACTIONS(271),
    [anon_sym_module] = ACTIONS(273),
    [anon_sym_any] = ACTIONS(257),
    [anon_sym_number] = ACTIONS(257),
    [anon_sym_boolean] = ACTIONS(257),
    [anon_sym_string] = ACTIONS(257),
    [anon_sym_symbol] = ACTIONS(257),
    [anon_sym_property] = ACTIONS(257),
    [anon_sym_signal] = ACTIONS(257),
    [anon_sym_on] = ACTIONS(257),
    [anon_sym_required] = ACTIONS(257),
    [anon_sym_component] = ACTIONS(257),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [9] = {
    [sym_export_statement] = STATE(23),
    [sym_declaration] = STATE(23),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4681),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4681),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4681),
    [sym_spread_element] = STATE(4052),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2230),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4052),
    [sym_pair] = STATE(4052),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(3324),
    [sym_computed_property_name] = STATE(3324),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_accessibility_modifier] = STATE(2476),
    [sym_override_modifier] = STATE(2491),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(23),
    [aux_sym_object_repeat1] = STATE(4037),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_export] = ACTIONS(277),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(279),
    [anon_sym_namespace] = ACTIONS(281),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(283),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(283),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(191),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(213),
    [sym_private_property_identifier] = ACTIONS(215),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(287),
    [anon_sym_readonly] = ACTIONS(289),
    [anon_sym_get] = ACTIONS(291),
    [anon_sym_set] = ACTIONS(291),
    [anon_sym_declare] = ACTIONS(293),
    [anon_sym_public] = ACTIONS(295),
    [anon_sym_private] = ACTIONS(295),
    [anon_sym_protected] = ACTIONS(295),
    [anon_sym_override] = ACTIONS(297),
    [anon_sym_module] = ACTIONS(299),
    [anon_sym_any] = ACTIONS(283),
    [anon_sym_number] = ACTIONS(283),
    [anon_sym_boolean] = ACTIONS(283),
    [anon_sym_string] = ACTIONS(283),
    [anon_sym_symbol] = ACTIONS(283),
    [anon_sym_property] = ACTIONS(283),
    [anon_sym_signal] = ACTIONS(283),
    [anon_sym_on] = ACTIONS(283),
    [anon_sym_required] = ACTIONS(283),
    [anon_sym_component] = ACTIONS(283),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [10] = {
    [sym_export_statement] = STATE(23),
    [sym_declaration] = STATE(23),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4681),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4681),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4681),
    [sym_spread_element] = STATE(4052),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2230),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4052),
    [sym_pair] = STATE(4052),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(3324),
    [sym_computed_property_name] = STATE(3324),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_accessibility_modifier] = STATE(2476),
    [sym_override_modifier] = STATE(2491),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(23),
    [aux_sym_object_repeat1] = STATE(4037),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_export] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_type] = ACTIONS(305),
    [anon_sym_namespace] = ACTIONS(307),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(141),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(309),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(309),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(191),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(311),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(213),
    [sym_private_property_identifier] = ACTIONS(215),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(313),
    [anon_sym_readonly] = ACTIONS(315),
    [anon_sym_get] = ACTIONS(317),
    [anon_sym_set] = ACTIONS(317),
    [anon_sym_declare] = ACTIONS(319),
    [anon_sym_public] = ACTIONS(321),
    [anon_sym_private] = ACTIONS(321),
    [anon_sym_protected] = ACTIONS(321),
    [anon_sym_override] = ACTIONS(323),
    [anon_sym_module] = ACTIONS(325),
    [anon_sym_any] = ACTIONS(309),
    [anon_sym_number] = ACTIONS(309),
    [anon_sym_boolean] = ACTIONS(309),
    [anon_sym_string] = ACTIONS(309),
    [anon_sym_symbol] = ACTIONS(309),
    [anon_sym_property] = ACTIONS(309),
    [anon_sym_signal] = ACTIONS(309),
    [anon_sym_on] = ACTIONS(309),
    [anon_sym_required] = ACTIONS(309),
    [anon_sym_component] = ACTIONS(309),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [11] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(12),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_default] = ACTIONS(331),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(337),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_case] = ACTIONS(331),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [12] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(12),
    [sym_identifier] = ACTIONS(351),
    [anon_sym_export] = ACTIONS(354),
    [anon_sym_default] = ACTIONS(357),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_namespace] = ACTIONS(362),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE] = ACTIONS(368),
    [anon_sym_typeof] = ACTIONS(370),
    [anon_sym_import] = ACTIONS(373),
    [anon_sym_from] = ACTIONS(376),
    [anon_sym_var] = ACTIONS(379),
    [anon_sym_let] = ACTIONS(382),
    [anon_sym_const] = ACTIONS(385),
    [anon_sym_BANG] = ACTIONS(388),
    [anon_sym_if] = ACTIONS(391),
    [anon_sym_switch] = ACTIONS(394),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_LPAREN] = ACTIONS(400),
    [anon_sym_await] = ACTIONS(403),
    [anon_sym_of] = ACTIONS(376),
    [anon_sym_while] = ACTIONS(406),
    [anon_sym_do] = ACTIONS(409),
    [anon_sym_try] = ACTIONS(412),
    [anon_sym_with] = ACTIONS(415),
    [anon_sym_break] = ACTIONS(418),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_debugger] = ACTIONS(424),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_throw] = ACTIONS(430),
    [anon_sym_SEMI] = ACTIONS(433),
    [anon_sym_case] = ACTIONS(357),
    [anon_sym_yield] = ACTIONS(436),
    [anon_sym_LBRACK] = ACTIONS(439),
    [anon_sym_LTtemplate_GT] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(448),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_async] = ACTIONS(454),
    [anon_sym_function] = ACTIONS(457),
    [anon_sym_new] = ACTIONS(460),
    [anon_sym_PLUS] = ACTIONS(370),
    [anon_sym_DASH] = ACTIONS(370),
    [anon_sym_TILDE] = ACTIONS(388),
    [anon_sym_void] = ACTIONS(370),
    [anon_sym_delete] = ACTIONS(370),
    [anon_sym_PLUS_PLUS] = ACTIONS(463),
    [anon_sym_DASH_DASH] = ACTIONS(463),
    [anon_sym_DQUOTE] = ACTIONS(466),
    [anon_sym_SQUOTE] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(472),
    [sym_number] = ACTIONS(475),
    [sym_this] = ACTIONS(478),
    [sym_super] = ACTIONS(478),
    [sym_true] = ACTIONS(478),
    [sym_false] = ACTIONS(478),
    [sym_null] = ACTIONS(478),
    [sym_undefined] = ACTIONS(481),
    [anon_sym_AT] = ACTIONS(484),
    [anon_sym_static] = ACTIONS(376),
    [anon_sym_readonly] = ACTIONS(376),
    [anon_sym_get] = ACTIONS(376),
    [anon_sym_set] = ACTIONS(376),
    [anon_sym_declare] = ACTIONS(487),
    [anon_sym_public] = ACTIONS(376),
    [anon_sym_private] = ACTIONS(376),
    [anon_sym_protected] = ACTIONS(376),
    [anon_sym_override] = ACTIONS(376),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_any] = ACTIONS(376),
    [anon_sym_number] = ACTIONS(376),
    [anon_sym_boolean] = ACTIONS(376),
    [anon_sym_string] = ACTIONS(376),
    [anon_sym_symbol] = ACTIONS(376),
    [anon_sym_property] = ACTIONS(376),
    [anon_sym_signal] = ACTIONS(376),
    [anon_sym_on] = ACTIONS(376),
    [anon_sym_required] = ACTIONS(376),
    [anon_sym_component] = ACTIONS(376),
    [anon_sym_abstract] = ACTIONS(493),
    [anon_sym_interface] = ACTIONS(496),
    [anon_sym_enum] = ACTIONS(499),
  },
  [13] = {
    [sym_export_statement] = STATE(11),
    [sym_declaration] = STATE(11),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(11),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_default] = ACTIONS(502),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(504),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_case] = ACTIONS(502),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [14] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(12),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_default] = ACTIONS(506),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(508),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_case] = ACTIONS(506),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [15] = {
    [sym_export_statement] = STATE(14),
    [sym_declaration] = STATE(14),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(14),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_default] = ACTIONS(510),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(512),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_case] = ACTIONS(510),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [16] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(12),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(514),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [17] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(12),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(516),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [18] = {
    [sym_export_statement] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(22),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(518),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [19] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(12),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(520),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [20] = {
    [sym_export_statement] = STATE(27),
    [sym_declaration] = STATE(27),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(27),
    [sym_expression_statement] = STATE(27),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(27),
    [sym_if_statement] = STATE(27),
    [sym_switch_statement] = STATE(27),
    [sym_for_statement] = STATE(27),
    [sym_for_in_statement] = STATE(27),
    [sym_while_statement] = STATE(27),
    [sym_do_statement] = STATE(27),
    [sym_try_statement] = STATE(27),
    [sym_with_statement] = STATE(27),
    [sym_break_statement] = STATE(27),
    [sym_continue_statement] = STATE(27),
    [sym_debugger_statement] = STATE(27),
    [sym_return_statement] = STATE(27),
    [sym_throw_statement] = STATE(27),
    [sym_empty_statement] = STATE(27),
    [sym_labeled_statement] = STATE(27),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(27),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(522),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [21] = {
    [sym_export_statement] = STATE(23),
    [sym_declaration] = STATE(23),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(23),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(524),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [22] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(12),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(526),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [23] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(12),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(528),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [24] = {
    [sym_export_statement] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(25),
    [sym_expression_statement] = STATE(25),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(25),
    [sym_if_statement] = STATE(25),
    [sym_switch_statement] = STATE(25),
    [sym_for_statement] = STATE(25),
    [sym_for_in_statement] = STATE(25),
    [sym_while_statement] = STATE(25),
    [sym_do_statement] = STATE(25),
    [sym_try_statement] = STATE(25),
    [sym_with_statement] = STATE(25),
    [sym_break_statement] = STATE(25),
    [sym_continue_statement] = STATE(25),
    [sym_debugger_statement] = STATE(25),
    [sym_return_statement] = STATE(25),
    [sym_throw_statement] = STATE(25),
    [sym_empty_statement] = STATE(25),
    [sym_labeled_statement] = STATE(25),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(25),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(530),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [25] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(12),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(532),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [26] = {
    [sym_export_statement] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(17),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [27] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(12),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(536),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [28] = {
    [sym_export_statement] = STATE(12),
    [sym_declaration] = STATE(12),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(12),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(538),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [29] = {
    [sym_export_statement] = STATE(19),
    [sym_declaration] = STATE(19),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(19),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(540),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [30] = {
    [sym_export_statement] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(16),
    [sym_expression_statement] = STATE(16),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(16),
    [sym_if_statement] = STATE(16),
    [sym_switch_statement] = STATE(16),
    [sym_for_statement] = STATE(16),
    [sym_for_in_statement] = STATE(16),
    [sym_while_statement] = STATE(16),
    [sym_do_statement] = STATE(16),
    [sym_try_statement] = STATE(16),
    [sym_with_statement] = STATE(16),
    [sym_break_statement] = STATE(16),
    [sym_continue_statement] = STATE(16),
    [sym_debugger_statement] = STATE(16),
    [sym_return_statement] = STATE(16),
    [sym_throw_statement] = STATE(16),
    [sym_empty_statement] = STATE(16),
    [sym_labeled_statement] = STATE(16),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(16),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(542),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [31] = {
    [sym_export_statement] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(28),
    [sym_expression_statement] = STATE(28),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(28),
    [sym_if_statement] = STATE(28),
    [sym_switch_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_for_in_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_do_statement] = STATE(28),
    [sym_try_statement] = STATE(28),
    [sym_with_statement] = STATE(28),
    [sym_break_statement] = STATE(28),
    [sym_continue_statement] = STATE(28),
    [sym_debugger_statement] = STATE(28),
    [sym_return_statement] = STATE(28),
    [sym_throw_statement] = STATE(28),
    [sym_empty_statement] = STATE(28),
    [sym_labeled_statement] = STATE(28),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [aux_sym_statement_block_repeat1] = STATE(28),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_RBRACE] = ACTIONS(544),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [32] = {
    [sym_export_statement] = STATE(4849),
    [sym_declaration] = STATE(4849),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(4849),
    [sym_expression_statement] = STATE(4849),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(4849),
    [sym_if_statement] = STATE(4849),
    [sym_switch_statement] = STATE(4849),
    [sym_for_statement] = STATE(4849),
    [sym_for_in_statement] = STATE(4849),
    [sym_while_statement] = STATE(4849),
    [sym_do_statement] = STATE(4849),
    [sym_try_statement] = STATE(4849),
    [sym_with_statement] = STATE(4849),
    [sym_break_statement] = STATE(4849),
    [sym_continue_statement] = STATE(4849),
    [sym_debugger_statement] = STATE(4849),
    [sym_return_statement] = STATE(4849),
    [sym_throw_statement] = STATE(4849),
    [sym_empty_statement] = STATE(4849),
    [sym_labeled_statement] = STATE(4849),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(2191),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3374),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_type] = ACTIONS(550),
    [anon_sym_namespace] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(556),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(570),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_readonly] = ACTIONS(556),
    [anon_sym_get] = ACTIONS(556),
    [anon_sym_set] = ACTIONS(556),
    [anon_sym_declare] = ACTIONS(580),
    [anon_sym_public] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_protected] = ACTIONS(556),
    [anon_sym_override] = ACTIONS(556),
    [anon_sym_module] = ACTIONS(582),
    [anon_sym_any] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(556),
    [anon_sym_boolean] = ACTIONS(556),
    [anon_sym_string] = ACTIONS(556),
    [anon_sym_symbol] = ACTIONS(556),
    [anon_sym_property] = ACTIONS(556),
    [anon_sym_signal] = ACTIONS(556),
    [anon_sym_on] = ACTIONS(556),
    [anon_sym_required] = ACTIONS(556),
    [anon_sym_component] = ACTIONS(556),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [33] = {
    [sym_export_statement] = STATE(2696),
    [sym_declaration] = STATE(2696),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(2696),
    [sym_expression_statement] = STATE(2696),
    [sym_variable_declaration] = STATE(2592),
    [sym_lexical_declaration] = STATE(2592),
    [sym_statement_block] = STATE(2696),
    [sym_if_statement] = STATE(2696),
    [sym_switch_statement] = STATE(2696),
    [sym_for_statement] = STATE(2696),
    [sym_for_in_statement] = STATE(2696),
    [sym_while_statement] = STATE(2696),
    [sym_do_statement] = STATE(2696),
    [sym_try_statement] = STATE(2696),
    [sym_with_statement] = STATE(2696),
    [sym_break_statement] = STATE(2696),
    [sym_continue_statement] = STATE(2696),
    [sym_debugger_statement] = STATE(2696),
    [sym_return_statement] = STATE(2696),
    [sym_throw_statement] = STATE(2696),
    [sym_empty_statement] = STATE(2696),
    [sym_labeled_statement] = STATE(2696),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(2592),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(2592),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(2592),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(2592),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(2592),
    [sym_abstract_class_declaration] = STATE(2592),
    [sym_module] = STATE(2592),
    [sym_internal_module] = STATE(876),
    [sym_import_alias] = STATE(2592),
    [sym_interface_declaration] = STATE(2592),
    [sym_enum_declaration] = STATE(2592),
    [sym_type_alias_declaration] = STATE(2592),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3365),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(598),
    [anon_sym_const] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(604),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(606),
    [anon_sym_do] = ACTIONS(608),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_break] = ACTIONS(612),
    [anon_sym_continue] = ACTIONS(614),
    [anon_sym_debugger] = ACTIONS(616),
    [anon_sym_return] = ACTIONS(618),
    [anon_sym_throw] = ACTIONS(620),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(630),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_enum] = ACTIONS(636),
  },
  [34] = {
    [sym_export_statement] = STATE(843),
    [sym_declaration] = STATE(843),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(843),
    [sym_expression_statement] = STATE(843),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(843),
    [sym_if_statement] = STATE(843),
    [sym_switch_statement] = STATE(843),
    [sym_for_statement] = STATE(843),
    [sym_for_in_statement] = STATE(843),
    [sym_while_statement] = STATE(843),
    [sym_do_statement] = STATE(843),
    [sym_try_statement] = STATE(843),
    [sym_with_statement] = STATE(843),
    [sym_break_statement] = STATE(843),
    [sym_continue_statement] = STATE(843),
    [sym_debugger_statement] = STATE(843),
    [sym_return_statement] = STATE(843),
    [sym_throw_statement] = STATE(843),
    [sym_empty_statement] = STATE(843),
    [sym_labeled_statement] = STATE(843),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(2191),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3374),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_type] = ACTIONS(550),
    [anon_sym_namespace] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(556),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(570),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_readonly] = ACTIONS(556),
    [anon_sym_get] = ACTIONS(556),
    [anon_sym_set] = ACTIONS(556),
    [anon_sym_declare] = ACTIONS(580),
    [anon_sym_public] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_protected] = ACTIONS(556),
    [anon_sym_override] = ACTIONS(556),
    [anon_sym_module] = ACTIONS(582),
    [anon_sym_any] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(556),
    [anon_sym_boolean] = ACTIONS(556),
    [anon_sym_string] = ACTIONS(556),
    [anon_sym_symbol] = ACTIONS(556),
    [anon_sym_property] = ACTIONS(556),
    [anon_sym_signal] = ACTIONS(556),
    [anon_sym_on] = ACTIONS(556),
    [anon_sym_required] = ACTIONS(556),
    [anon_sym_component] = ACTIONS(556),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [35] = {
    [sym_export_statement] = STATE(788),
    [sym_declaration] = STATE(786),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(785),
    [sym_expression_statement] = STATE(705),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(784),
    [sym_if_statement] = STATE(783),
    [sym_switch_statement] = STATE(782),
    [sym_for_statement] = STATE(781),
    [sym_for_in_statement] = STATE(780),
    [sym_while_statement] = STATE(779),
    [sym_do_statement] = STATE(778),
    [sym_try_statement] = STATE(777),
    [sym_with_statement] = STATE(775),
    [sym_break_statement] = STATE(772),
    [sym_continue_statement] = STATE(770),
    [sym_debugger_statement] = STATE(768),
    [sym_return_statement] = STATE(767),
    [sym_throw_statement] = STATE(766),
    [sym_empty_statement] = STATE(765),
    [sym_labeled_statement] = STATE(763),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(2191),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3374),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_type] = ACTIONS(550),
    [anon_sym_namespace] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(556),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(570),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_readonly] = ACTIONS(556),
    [anon_sym_get] = ACTIONS(556),
    [anon_sym_set] = ACTIONS(556),
    [anon_sym_declare] = ACTIONS(580),
    [anon_sym_public] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_protected] = ACTIONS(556),
    [anon_sym_override] = ACTIONS(556),
    [anon_sym_module] = ACTIONS(582),
    [anon_sym_any] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(556),
    [anon_sym_boolean] = ACTIONS(556),
    [anon_sym_string] = ACTIONS(556),
    [anon_sym_symbol] = ACTIONS(556),
    [anon_sym_property] = ACTIONS(556),
    [anon_sym_signal] = ACTIONS(556),
    [anon_sym_on] = ACTIONS(556),
    [anon_sym_required] = ACTIONS(556),
    [anon_sym_component] = ACTIONS(556),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [36] = {
    [sym_export_statement] = STATE(762),
    [sym_declaration] = STATE(762),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(762),
    [sym_expression_statement] = STATE(762),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(762),
    [sym_if_statement] = STATE(762),
    [sym_switch_statement] = STATE(762),
    [sym_for_statement] = STATE(762),
    [sym_for_in_statement] = STATE(762),
    [sym_while_statement] = STATE(762),
    [sym_do_statement] = STATE(762),
    [sym_try_statement] = STATE(762),
    [sym_with_statement] = STATE(762),
    [sym_break_statement] = STATE(762),
    [sym_continue_statement] = STATE(762),
    [sym_debugger_statement] = STATE(762),
    [sym_return_statement] = STATE(762),
    [sym_throw_statement] = STATE(762),
    [sym_empty_statement] = STATE(762),
    [sym_labeled_statement] = STATE(762),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(2191),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3374),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_type] = ACTIONS(550),
    [anon_sym_namespace] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(556),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(570),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_readonly] = ACTIONS(556),
    [anon_sym_get] = ACTIONS(556),
    [anon_sym_set] = ACTIONS(556),
    [anon_sym_declare] = ACTIONS(580),
    [anon_sym_public] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_protected] = ACTIONS(556),
    [anon_sym_override] = ACTIONS(556),
    [anon_sym_module] = ACTIONS(582),
    [anon_sym_any] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(556),
    [anon_sym_boolean] = ACTIONS(556),
    [anon_sym_string] = ACTIONS(556),
    [anon_sym_symbol] = ACTIONS(556),
    [anon_sym_property] = ACTIONS(556),
    [anon_sym_signal] = ACTIONS(556),
    [anon_sym_on] = ACTIONS(556),
    [anon_sym_required] = ACTIONS(556),
    [anon_sym_component] = ACTIONS(556),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [37] = {
    [sym_export_statement] = STATE(788),
    [sym_declaration] = STATE(786),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(785),
    [sym_expression_statement] = STATE(705),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(784),
    [sym_if_statement] = STATE(783),
    [sym_switch_statement] = STATE(782),
    [sym_for_statement] = STATE(781),
    [sym_for_in_statement] = STATE(780),
    [sym_while_statement] = STATE(779),
    [sym_do_statement] = STATE(778),
    [sym_try_statement] = STATE(777),
    [sym_with_statement] = STATE(775),
    [sym_break_statement] = STATE(772),
    [sym_continue_statement] = STATE(770),
    [sym_debugger_statement] = STATE(768),
    [sym_return_statement] = STATE(767),
    [sym_throw_statement] = STATE(766),
    [sym_empty_statement] = STATE(765),
    [sym_labeled_statement] = STATE(763),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [38] = {
    [sym_export_statement] = STATE(2663),
    [sym_declaration] = STATE(2663),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(2663),
    [sym_expression_statement] = STATE(2663),
    [sym_variable_declaration] = STATE(2592),
    [sym_lexical_declaration] = STATE(2592),
    [sym_statement_block] = STATE(2663),
    [sym_if_statement] = STATE(2663),
    [sym_switch_statement] = STATE(2663),
    [sym_for_statement] = STATE(2663),
    [sym_for_in_statement] = STATE(2663),
    [sym_while_statement] = STATE(2663),
    [sym_do_statement] = STATE(2663),
    [sym_try_statement] = STATE(2663),
    [sym_with_statement] = STATE(2663),
    [sym_break_statement] = STATE(2663),
    [sym_continue_statement] = STATE(2663),
    [sym_debugger_statement] = STATE(2663),
    [sym_return_statement] = STATE(2663),
    [sym_throw_statement] = STATE(2663),
    [sym_empty_statement] = STATE(2663),
    [sym_labeled_statement] = STATE(2663),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(2592),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(2592),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(2592),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(2592),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(2592),
    [sym_abstract_class_declaration] = STATE(2592),
    [sym_module] = STATE(2592),
    [sym_internal_module] = STATE(876),
    [sym_import_alias] = STATE(2592),
    [sym_interface_declaration] = STATE(2592),
    [sym_enum_declaration] = STATE(2592),
    [sym_type_alias_declaration] = STATE(2592),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3365),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(598),
    [anon_sym_const] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(604),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(606),
    [anon_sym_do] = ACTIONS(608),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_break] = ACTIONS(612),
    [anon_sym_continue] = ACTIONS(614),
    [anon_sym_debugger] = ACTIONS(616),
    [anon_sym_return] = ACTIONS(618),
    [anon_sym_throw] = ACTIONS(620),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(630),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_enum] = ACTIONS(636),
  },
  [39] = {
    [sym_export_statement] = STATE(812),
    [sym_declaration] = STATE(812),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(812),
    [sym_expression_statement] = STATE(812),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(812),
    [sym_if_statement] = STATE(812),
    [sym_switch_statement] = STATE(812),
    [sym_for_statement] = STATE(812),
    [sym_for_in_statement] = STATE(812),
    [sym_while_statement] = STATE(812),
    [sym_do_statement] = STATE(812),
    [sym_try_statement] = STATE(812),
    [sym_with_statement] = STATE(812),
    [sym_break_statement] = STATE(812),
    [sym_continue_statement] = STATE(812),
    [sym_debugger_statement] = STATE(812),
    [sym_return_statement] = STATE(812),
    [sym_throw_statement] = STATE(812),
    [sym_empty_statement] = STATE(812),
    [sym_labeled_statement] = STATE(812),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [40] = {
    [sym_export_statement] = STATE(2599),
    [sym_declaration] = STATE(2600),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(2601),
    [sym_expression_statement] = STATE(2603),
    [sym_variable_declaration] = STATE(2592),
    [sym_lexical_declaration] = STATE(2592),
    [sym_statement_block] = STATE(2604),
    [sym_if_statement] = STATE(2639),
    [sym_switch_statement] = STATE(2607),
    [sym_for_statement] = STATE(2608),
    [sym_for_in_statement] = STATE(2609),
    [sym_while_statement] = STATE(2610),
    [sym_do_statement] = STATE(2614),
    [sym_try_statement] = STATE(2615),
    [sym_with_statement] = STATE(2617),
    [sym_break_statement] = STATE(2618),
    [sym_continue_statement] = STATE(2620),
    [sym_debugger_statement] = STATE(2621),
    [sym_return_statement] = STATE(2622),
    [sym_throw_statement] = STATE(2623),
    [sym_empty_statement] = STATE(2624),
    [sym_labeled_statement] = STATE(2662),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(2592),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(2592),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(2592),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(2592),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(2592),
    [sym_abstract_class_declaration] = STATE(2592),
    [sym_module] = STATE(2592),
    [sym_internal_module] = STATE(876),
    [sym_import_alias] = STATE(2592),
    [sym_interface_declaration] = STATE(2592),
    [sym_enum_declaration] = STATE(2592),
    [sym_type_alias_declaration] = STATE(2592),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3365),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(598),
    [anon_sym_const] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(604),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(606),
    [anon_sym_do] = ACTIONS(608),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_break] = ACTIONS(612),
    [anon_sym_continue] = ACTIONS(614),
    [anon_sym_debugger] = ACTIONS(616),
    [anon_sym_return] = ACTIONS(618),
    [anon_sym_throw] = ACTIONS(620),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(630),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_enum] = ACTIONS(636),
  },
  [41] = {
    [sym_export_statement] = STATE(762),
    [sym_declaration] = STATE(762),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(762),
    [sym_expression_statement] = STATE(762),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(762),
    [sym_if_statement] = STATE(762),
    [sym_switch_statement] = STATE(762),
    [sym_for_statement] = STATE(762),
    [sym_for_in_statement] = STATE(762),
    [sym_while_statement] = STATE(762),
    [sym_do_statement] = STATE(762),
    [sym_try_statement] = STATE(762),
    [sym_with_statement] = STATE(762),
    [sym_break_statement] = STATE(762),
    [sym_continue_statement] = STATE(762),
    [sym_debugger_statement] = STATE(762),
    [sym_return_statement] = STATE(762),
    [sym_throw_statement] = STATE(762),
    [sym_empty_statement] = STATE(762),
    [sym_labeled_statement] = STATE(762),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [42] = {
    [sym_export_statement] = STATE(682),
    [sym_declaration] = STATE(682),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(682),
    [sym_expression_statement] = STATE(682),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(682),
    [sym_if_statement] = STATE(682),
    [sym_switch_statement] = STATE(682),
    [sym_for_statement] = STATE(682),
    [sym_for_in_statement] = STATE(682),
    [sym_while_statement] = STATE(682),
    [sym_do_statement] = STATE(682),
    [sym_try_statement] = STATE(682),
    [sym_with_statement] = STATE(682),
    [sym_break_statement] = STATE(682),
    [sym_continue_statement] = STATE(682),
    [sym_debugger_statement] = STATE(682),
    [sym_return_statement] = STATE(682),
    [sym_throw_statement] = STATE(682),
    [sym_empty_statement] = STATE(682),
    [sym_labeled_statement] = STATE(682),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [43] = {
    [sym_export_statement] = STATE(711),
    [sym_declaration] = STATE(711),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(711),
    [sym_expression_statement] = STATE(711),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(711),
    [sym_if_statement] = STATE(711),
    [sym_switch_statement] = STATE(711),
    [sym_for_statement] = STATE(711),
    [sym_for_in_statement] = STATE(711),
    [sym_while_statement] = STATE(711),
    [sym_do_statement] = STATE(711),
    [sym_try_statement] = STATE(711),
    [sym_with_statement] = STATE(711),
    [sym_break_statement] = STATE(711),
    [sym_continue_statement] = STATE(711),
    [sym_debugger_statement] = STATE(711),
    [sym_return_statement] = STATE(711),
    [sym_throw_statement] = STATE(711),
    [sym_empty_statement] = STATE(711),
    [sym_labeled_statement] = STATE(711),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [44] = {
    [sym_export_statement] = STATE(2558),
    [sym_declaration] = STATE(2558),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(2558),
    [sym_expression_statement] = STATE(2558),
    [sym_variable_declaration] = STATE(2592),
    [sym_lexical_declaration] = STATE(2592),
    [sym_statement_block] = STATE(2558),
    [sym_if_statement] = STATE(2558),
    [sym_switch_statement] = STATE(2558),
    [sym_for_statement] = STATE(2558),
    [sym_for_in_statement] = STATE(2558),
    [sym_while_statement] = STATE(2558),
    [sym_do_statement] = STATE(2558),
    [sym_try_statement] = STATE(2558),
    [sym_with_statement] = STATE(2558),
    [sym_break_statement] = STATE(2558),
    [sym_continue_statement] = STATE(2558),
    [sym_debugger_statement] = STATE(2558),
    [sym_return_statement] = STATE(2558),
    [sym_throw_statement] = STATE(2558),
    [sym_empty_statement] = STATE(2558),
    [sym_labeled_statement] = STATE(2558),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(2592),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(2592),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(2592),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(2592),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(2592),
    [sym_abstract_class_declaration] = STATE(2592),
    [sym_module] = STATE(2592),
    [sym_internal_module] = STATE(876),
    [sym_import_alias] = STATE(2592),
    [sym_interface_declaration] = STATE(2592),
    [sym_enum_declaration] = STATE(2592),
    [sym_type_alias_declaration] = STATE(2592),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3365),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(598),
    [anon_sym_const] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(604),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(606),
    [anon_sym_do] = ACTIONS(608),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_break] = ACTIONS(612),
    [anon_sym_continue] = ACTIONS(614),
    [anon_sym_debugger] = ACTIONS(616),
    [anon_sym_return] = ACTIONS(618),
    [anon_sym_throw] = ACTIONS(620),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(630),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_enum] = ACTIONS(636),
  },
  [45] = {
    [sym_export_statement] = STATE(2529),
    [sym_declaration] = STATE(2529),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(2529),
    [sym_expression_statement] = STATE(2529),
    [sym_variable_declaration] = STATE(2592),
    [sym_lexical_declaration] = STATE(2592),
    [sym_statement_block] = STATE(2529),
    [sym_if_statement] = STATE(2529),
    [sym_switch_statement] = STATE(2529),
    [sym_for_statement] = STATE(2529),
    [sym_for_in_statement] = STATE(2529),
    [sym_while_statement] = STATE(2529),
    [sym_do_statement] = STATE(2529),
    [sym_try_statement] = STATE(2529),
    [sym_with_statement] = STATE(2529),
    [sym_break_statement] = STATE(2529),
    [sym_continue_statement] = STATE(2529),
    [sym_debugger_statement] = STATE(2529),
    [sym_return_statement] = STATE(2529),
    [sym_throw_statement] = STATE(2529),
    [sym_empty_statement] = STATE(2529),
    [sym_labeled_statement] = STATE(2529),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(2592),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(2592),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(2592),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(2592),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(2592),
    [sym_abstract_class_declaration] = STATE(2592),
    [sym_module] = STATE(2592),
    [sym_internal_module] = STATE(876),
    [sym_import_alias] = STATE(2592),
    [sym_interface_declaration] = STATE(2592),
    [sym_enum_declaration] = STATE(2592),
    [sym_type_alias_declaration] = STATE(2592),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3365),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(598),
    [anon_sym_const] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(604),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(606),
    [anon_sym_do] = ACTIONS(608),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_break] = ACTIONS(612),
    [anon_sym_continue] = ACTIONS(614),
    [anon_sym_debugger] = ACTIONS(616),
    [anon_sym_return] = ACTIONS(618),
    [anon_sym_throw] = ACTIONS(620),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(630),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_enum] = ACTIONS(636),
  },
  [46] = {
    [sym_export_statement] = STATE(843),
    [sym_declaration] = STATE(843),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(843),
    [sym_expression_statement] = STATE(843),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(843),
    [sym_if_statement] = STATE(843),
    [sym_switch_statement] = STATE(843),
    [sym_for_statement] = STATE(843),
    [sym_for_in_statement] = STATE(843),
    [sym_while_statement] = STATE(843),
    [sym_do_statement] = STATE(843),
    [sym_try_statement] = STATE(843),
    [sym_with_statement] = STATE(843),
    [sym_break_statement] = STATE(843),
    [sym_continue_statement] = STATE(843),
    [sym_debugger_statement] = STATE(843),
    [sym_return_statement] = STATE(843),
    [sym_throw_statement] = STATE(843),
    [sym_empty_statement] = STATE(843),
    [sym_labeled_statement] = STATE(843),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [47] = {
    [sym_export_statement] = STATE(755),
    [sym_declaration] = STATE(755),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(755),
    [sym_expression_statement] = STATE(755),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(755),
    [sym_if_statement] = STATE(755),
    [sym_switch_statement] = STATE(755),
    [sym_for_statement] = STATE(755),
    [sym_for_in_statement] = STATE(755),
    [sym_while_statement] = STATE(755),
    [sym_do_statement] = STATE(755),
    [sym_try_statement] = STATE(755),
    [sym_with_statement] = STATE(755),
    [sym_break_statement] = STATE(755),
    [sym_continue_statement] = STATE(755),
    [sym_debugger_statement] = STATE(755),
    [sym_return_statement] = STATE(755),
    [sym_throw_statement] = STATE(755),
    [sym_empty_statement] = STATE(755),
    [sym_labeled_statement] = STATE(755),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [48] = {
    [sym_export_statement] = STATE(2558),
    [sym_declaration] = STATE(2558),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(2558),
    [sym_expression_statement] = STATE(2558),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(2558),
    [sym_if_statement] = STATE(2558),
    [sym_switch_statement] = STATE(2558),
    [sym_for_statement] = STATE(2558),
    [sym_for_in_statement] = STATE(2558),
    [sym_while_statement] = STATE(2558),
    [sym_do_statement] = STATE(2558),
    [sym_try_statement] = STATE(2558),
    [sym_with_statement] = STATE(2558),
    [sym_break_statement] = STATE(2558),
    [sym_continue_statement] = STATE(2558),
    [sym_debugger_statement] = STATE(2558),
    [sym_return_statement] = STATE(2558),
    [sym_throw_statement] = STATE(2558),
    [sym_empty_statement] = STATE(2558),
    [sym_labeled_statement] = STATE(2558),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(2191),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3374),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_type] = ACTIONS(550),
    [anon_sym_namespace] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(556),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(570),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_readonly] = ACTIONS(556),
    [anon_sym_get] = ACTIONS(556),
    [anon_sym_set] = ACTIONS(556),
    [anon_sym_declare] = ACTIONS(580),
    [anon_sym_public] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_protected] = ACTIONS(556),
    [anon_sym_override] = ACTIONS(556),
    [anon_sym_module] = ACTIONS(582),
    [anon_sym_any] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(556),
    [anon_sym_boolean] = ACTIONS(556),
    [anon_sym_string] = ACTIONS(556),
    [anon_sym_symbol] = ACTIONS(556),
    [anon_sym_property] = ACTIONS(556),
    [anon_sym_signal] = ACTIONS(556),
    [anon_sym_on] = ACTIONS(556),
    [anon_sym_required] = ACTIONS(556),
    [anon_sym_component] = ACTIONS(556),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [49] = {
    [sym_export_statement] = STATE(711),
    [sym_declaration] = STATE(711),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(711),
    [sym_expression_statement] = STATE(711),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(711),
    [sym_if_statement] = STATE(711),
    [sym_switch_statement] = STATE(711),
    [sym_for_statement] = STATE(711),
    [sym_for_in_statement] = STATE(711),
    [sym_while_statement] = STATE(711),
    [sym_do_statement] = STATE(711),
    [sym_try_statement] = STATE(711),
    [sym_with_statement] = STATE(711),
    [sym_break_statement] = STATE(711),
    [sym_continue_statement] = STATE(711),
    [sym_debugger_statement] = STATE(711),
    [sym_return_statement] = STATE(711),
    [sym_throw_statement] = STATE(711),
    [sym_empty_statement] = STATE(711),
    [sym_labeled_statement] = STATE(711),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(2191),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3374),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_type] = ACTIONS(550),
    [anon_sym_namespace] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(556),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(570),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_readonly] = ACTIONS(556),
    [anon_sym_get] = ACTIONS(556),
    [anon_sym_set] = ACTIONS(556),
    [anon_sym_declare] = ACTIONS(580),
    [anon_sym_public] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_protected] = ACTIONS(556),
    [anon_sym_override] = ACTIONS(556),
    [anon_sym_module] = ACTIONS(582),
    [anon_sym_any] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(556),
    [anon_sym_boolean] = ACTIONS(556),
    [anon_sym_string] = ACTIONS(556),
    [anon_sym_symbol] = ACTIONS(556),
    [anon_sym_property] = ACTIONS(556),
    [anon_sym_signal] = ACTIONS(556),
    [anon_sym_on] = ACTIONS(556),
    [anon_sym_required] = ACTIONS(556),
    [anon_sym_component] = ACTIONS(556),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [50] = {
    [sym_export_statement] = STATE(2677),
    [sym_declaration] = STATE(2673),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(2672),
    [sym_expression_statement] = STATE(2670),
    [sym_variable_declaration] = STATE(2592),
    [sym_lexical_declaration] = STATE(2592),
    [sym_statement_block] = STATE(2669),
    [sym_if_statement] = STATE(2667),
    [sym_switch_statement] = STATE(2666),
    [sym_for_statement] = STATE(2664),
    [sym_for_in_statement] = STATE(2626),
    [sym_while_statement] = STATE(2661),
    [sym_do_statement] = STATE(2656),
    [sym_try_statement] = STATE(2655),
    [sym_with_statement] = STATE(2654),
    [sym_break_statement] = STATE(2653),
    [sym_continue_statement] = STATE(2652),
    [sym_debugger_statement] = STATE(2648),
    [sym_return_statement] = STATE(2641),
    [sym_throw_statement] = STATE(2638),
    [sym_empty_statement] = STATE(2637),
    [sym_labeled_statement] = STATE(2567),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(2592),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(2592),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(2592),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(2592),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(2592),
    [sym_abstract_class_declaration] = STATE(2592),
    [sym_module] = STATE(2592),
    [sym_internal_module] = STATE(876),
    [sym_import_alias] = STATE(2592),
    [sym_interface_declaration] = STATE(2592),
    [sym_enum_declaration] = STATE(2592),
    [sym_type_alias_declaration] = STATE(2592),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3365),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(598),
    [anon_sym_const] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(604),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(606),
    [anon_sym_do] = ACTIONS(608),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_break] = ACTIONS(612),
    [anon_sym_continue] = ACTIONS(614),
    [anon_sym_debugger] = ACTIONS(616),
    [anon_sym_return] = ACTIONS(618),
    [anon_sym_throw] = ACTIONS(620),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(630),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_enum] = ACTIONS(636),
  },
  [51] = {
    [sym_export_statement] = STATE(2594),
    [sym_declaration] = STATE(2594),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(2594),
    [sym_expression_statement] = STATE(2594),
    [sym_variable_declaration] = STATE(2592),
    [sym_lexical_declaration] = STATE(2592),
    [sym_statement_block] = STATE(2594),
    [sym_if_statement] = STATE(2594),
    [sym_switch_statement] = STATE(2594),
    [sym_for_statement] = STATE(2594),
    [sym_for_in_statement] = STATE(2594),
    [sym_while_statement] = STATE(2594),
    [sym_do_statement] = STATE(2594),
    [sym_try_statement] = STATE(2594),
    [sym_with_statement] = STATE(2594),
    [sym_break_statement] = STATE(2594),
    [sym_continue_statement] = STATE(2594),
    [sym_debugger_statement] = STATE(2594),
    [sym_return_statement] = STATE(2594),
    [sym_throw_statement] = STATE(2594),
    [sym_empty_statement] = STATE(2594),
    [sym_labeled_statement] = STATE(2594),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(2592),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(2592),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(2592),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(2592),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(2592),
    [sym_abstract_class_declaration] = STATE(2592),
    [sym_module] = STATE(2592),
    [sym_internal_module] = STATE(876),
    [sym_import_alias] = STATE(2592),
    [sym_interface_declaration] = STATE(2592),
    [sym_enum_declaration] = STATE(2592),
    [sym_type_alias_declaration] = STATE(2592),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3365),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(598),
    [anon_sym_const] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(604),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(606),
    [anon_sym_do] = ACTIONS(608),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_break] = ACTIONS(612),
    [anon_sym_continue] = ACTIONS(614),
    [anon_sym_debugger] = ACTIONS(616),
    [anon_sym_return] = ACTIONS(618),
    [anon_sym_throw] = ACTIONS(620),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(630),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_enum] = ACTIONS(636),
  },
  [52] = {
    [sym_export_statement] = STATE(716),
    [sym_declaration] = STATE(716),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(716),
    [sym_expression_statement] = STATE(716),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(716),
    [sym_if_statement] = STATE(716),
    [sym_switch_statement] = STATE(716),
    [sym_for_statement] = STATE(716),
    [sym_for_in_statement] = STATE(716),
    [sym_while_statement] = STATE(716),
    [sym_do_statement] = STATE(716),
    [sym_try_statement] = STATE(716),
    [sym_with_statement] = STATE(716),
    [sym_break_statement] = STATE(716),
    [sym_continue_statement] = STATE(716),
    [sym_debugger_statement] = STATE(716),
    [sym_return_statement] = STATE(716),
    [sym_throw_statement] = STATE(716),
    [sym_empty_statement] = STATE(716),
    [sym_labeled_statement] = STATE(716),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [53] = {
    [sym_export_statement] = STATE(755),
    [sym_declaration] = STATE(755),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(755),
    [sym_expression_statement] = STATE(755),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(755),
    [sym_if_statement] = STATE(755),
    [sym_switch_statement] = STATE(755),
    [sym_for_statement] = STATE(755),
    [sym_for_in_statement] = STATE(755),
    [sym_while_statement] = STATE(755),
    [sym_do_statement] = STATE(755),
    [sym_try_statement] = STATE(755),
    [sym_with_statement] = STATE(755),
    [sym_break_statement] = STATE(755),
    [sym_continue_statement] = STATE(755),
    [sym_debugger_statement] = STATE(755),
    [sym_return_statement] = STATE(755),
    [sym_throw_statement] = STATE(755),
    [sym_empty_statement] = STATE(755),
    [sym_labeled_statement] = STATE(755),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(2191),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3374),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_type] = ACTIONS(550),
    [anon_sym_namespace] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(556),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(570),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_readonly] = ACTIONS(556),
    [anon_sym_get] = ACTIONS(556),
    [anon_sym_set] = ACTIONS(556),
    [anon_sym_declare] = ACTIONS(580),
    [anon_sym_public] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_protected] = ACTIONS(556),
    [anon_sym_override] = ACTIONS(556),
    [anon_sym_module] = ACTIONS(582),
    [anon_sym_any] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(556),
    [anon_sym_boolean] = ACTIONS(556),
    [anon_sym_string] = ACTIONS(556),
    [anon_sym_symbol] = ACTIONS(556),
    [anon_sym_property] = ACTIONS(556),
    [anon_sym_signal] = ACTIONS(556),
    [anon_sym_on] = ACTIONS(556),
    [anon_sym_required] = ACTIONS(556),
    [anon_sym_component] = ACTIONS(556),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [54] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(828),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(829),
    [sym_expression_statement] = STATE(831),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(832),
    [sym_if_statement] = STATE(833),
    [sym_switch_statement] = STATE(838),
    [sym_for_statement] = STATE(841),
    [sym_for_in_statement] = STATE(846),
    [sym_while_statement] = STATE(847),
    [sym_do_statement] = STATE(848),
    [sym_try_statement] = STATE(850),
    [sym_with_statement] = STATE(849),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(836),
    [sym_debugger_statement] = STATE(834),
    [sym_return_statement] = STATE(830),
    [sym_throw_statement] = STATE(824),
    [sym_empty_statement] = STATE(823),
    [sym_labeled_statement] = STATE(821),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3427),
    [sym_identifier] = ACTIONS(327),
    [anon_sym_export] = ACTIONS(329),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_namespace] = ACTIONS(335),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(159),
    [anon_sym_switch] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(339),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(173),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(343),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(339),
    [anon_sym_readonly] = ACTIONS(339),
    [anon_sym_get] = ACTIONS(339),
    [anon_sym_set] = ACTIONS(339),
    [anon_sym_declare] = ACTIONS(347),
    [anon_sym_public] = ACTIONS(339),
    [anon_sym_private] = ACTIONS(339),
    [anon_sym_protected] = ACTIONS(339),
    [anon_sym_override] = ACTIONS(339),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_any] = ACTIONS(339),
    [anon_sym_number] = ACTIONS(339),
    [anon_sym_boolean] = ACTIONS(339),
    [anon_sym_string] = ACTIONS(339),
    [anon_sym_symbol] = ACTIONS(339),
    [anon_sym_property] = ACTIONS(339),
    [anon_sym_signal] = ACTIONS(339),
    [anon_sym_on] = ACTIONS(339),
    [anon_sym_required] = ACTIONS(339),
    [anon_sym_component] = ACTIONS(339),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [55] = {
    [sym_export_statement] = STATE(4132),
    [sym_declaration] = STATE(4132),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(4132),
    [sym_expression_statement] = STATE(4132),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(4132),
    [sym_if_statement] = STATE(4132),
    [sym_switch_statement] = STATE(4132),
    [sym_for_statement] = STATE(4132),
    [sym_for_in_statement] = STATE(4132),
    [sym_while_statement] = STATE(4132),
    [sym_do_statement] = STATE(4132),
    [sym_try_statement] = STATE(4132),
    [sym_with_statement] = STATE(4132),
    [sym_break_statement] = STATE(4132),
    [sym_continue_statement] = STATE(4132),
    [sym_debugger_statement] = STATE(4132),
    [sym_return_statement] = STATE(4132),
    [sym_throw_statement] = STATE(4132),
    [sym_empty_statement] = STATE(4132),
    [sym_labeled_statement] = STATE(4132),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(2191),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3374),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_type] = ACTIONS(550),
    [anon_sym_namespace] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(556),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(570),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_readonly] = ACTIONS(556),
    [anon_sym_get] = ACTIONS(556),
    [anon_sym_set] = ACTIONS(556),
    [anon_sym_declare] = ACTIONS(580),
    [anon_sym_public] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_protected] = ACTIONS(556),
    [anon_sym_override] = ACTIONS(556),
    [anon_sym_module] = ACTIONS(582),
    [anon_sym_any] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(556),
    [anon_sym_boolean] = ACTIONS(556),
    [anon_sym_string] = ACTIONS(556),
    [anon_sym_symbol] = ACTIONS(556),
    [anon_sym_property] = ACTIONS(556),
    [anon_sym_signal] = ACTIONS(556),
    [anon_sym_on] = ACTIONS(556),
    [anon_sym_required] = ACTIONS(556),
    [anon_sym_component] = ACTIONS(556),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [56] = {
    [sym_export_statement] = STATE(4799),
    [sym_declaration] = STATE(4799),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(4799),
    [sym_expression_statement] = STATE(4799),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(4799),
    [sym_if_statement] = STATE(4799),
    [sym_switch_statement] = STATE(4799),
    [sym_for_statement] = STATE(4799),
    [sym_for_in_statement] = STATE(4799),
    [sym_while_statement] = STATE(4799),
    [sym_do_statement] = STATE(4799),
    [sym_try_statement] = STATE(4799),
    [sym_with_statement] = STATE(4799),
    [sym_break_statement] = STATE(4799),
    [sym_continue_statement] = STATE(4799),
    [sym_debugger_statement] = STATE(4799),
    [sym_return_statement] = STATE(4799),
    [sym_throw_statement] = STATE(4799),
    [sym_empty_statement] = STATE(4799),
    [sym_labeled_statement] = STATE(4799),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(2191),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3374),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_type] = ACTIONS(550),
    [anon_sym_namespace] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(556),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(570),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_readonly] = ACTIONS(556),
    [anon_sym_get] = ACTIONS(556),
    [anon_sym_set] = ACTIONS(556),
    [anon_sym_declare] = ACTIONS(580),
    [anon_sym_public] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_protected] = ACTIONS(556),
    [anon_sym_override] = ACTIONS(556),
    [anon_sym_module] = ACTIONS(582),
    [anon_sym_any] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(556),
    [anon_sym_boolean] = ACTIONS(556),
    [anon_sym_string] = ACTIONS(556),
    [anon_sym_symbol] = ACTIONS(556),
    [anon_sym_property] = ACTIONS(556),
    [anon_sym_signal] = ACTIONS(556),
    [anon_sym_on] = ACTIONS(556),
    [anon_sym_required] = ACTIONS(556),
    [anon_sym_component] = ACTIONS(556),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [57] = {
    [sym_export_statement] = STATE(2659),
    [sym_declaration] = STATE(2659),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(2659),
    [sym_expression_statement] = STATE(2659),
    [sym_variable_declaration] = STATE(2592),
    [sym_lexical_declaration] = STATE(2592),
    [sym_statement_block] = STATE(2659),
    [sym_if_statement] = STATE(2659),
    [sym_switch_statement] = STATE(2659),
    [sym_for_statement] = STATE(2659),
    [sym_for_in_statement] = STATE(2659),
    [sym_while_statement] = STATE(2659),
    [sym_do_statement] = STATE(2659),
    [sym_try_statement] = STATE(2659),
    [sym_with_statement] = STATE(2659),
    [sym_break_statement] = STATE(2659),
    [sym_continue_statement] = STATE(2659),
    [sym_debugger_statement] = STATE(2659),
    [sym_return_statement] = STATE(2659),
    [sym_throw_statement] = STATE(2659),
    [sym_empty_statement] = STATE(2659),
    [sym_labeled_statement] = STATE(2659),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(2592),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(2592),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(2592),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(2592),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(2592),
    [sym_abstract_class_declaration] = STATE(2592),
    [sym_module] = STATE(2592),
    [sym_internal_module] = STATE(876),
    [sym_import_alias] = STATE(2592),
    [sym_interface_declaration] = STATE(2592),
    [sym_enum_declaration] = STATE(2592),
    [sym_type_alias_declaration] = STATE(2592),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3365),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(598),
    [anon_sym_const] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(604),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(606),
    [anon_sym_do] = ACTIONS(608),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_break] = ACTIONS(612),
    [anon_sym_continue] = ACTIONS(614),
    [anon_sym_debugger] = ACTIONS(616),
    [anon_sym_return] = ACTIONS(618),
    [anon_sym_throw] = ACTIONS(620),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(630),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_enum] = ACTIONS(636),
  },
  [58] = {
    [sym_export_statement] = STATE(2529),
    [sym_declaration] = STATE(2529),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(2529),
    [sym_expression_statement] = STATE(2529),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(2529),
    [sym_if_statement] = STATE(2529),
    [sym_switch_statement] = STATE(2529),
    [sym_for_statement] = STATE(2529),
    [sym_for_in_statement] = STATE(2529),
    [sym_while_statement] = STATE(2529),
    [sym_do_statement] = STATE(2529),
    [sym_try_statement] = STATE(2529),
    [sym_with_statement] = STATE(2529),
    [sym_break_statement] = STATE(2529),
    [sym_continue_statement] = STATE(2529),
    [sym_debugger_statement] = STATE(2529),
    [sym_return_statement] = STATE(2529),
    [sym_throw_statement] = STATE(2529),
    [sym_empty_statement] = STATE(2529),
    [sym_labeled_statement] = STATE(2529),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(2191),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3374),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_type] = ACTIONS(550),
    [anon_sym_namespace] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(556),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(570),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_readonly] = ACTIONS(556),
    [anon_sym_get] = ACTIONS(556),
    [anon_sym_set] = ACTIONS(556),
    [anon_sym_declare] = ACTIONS(580),
    [anon_sym_public] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_protected] = ACTIONS(556),
    [anon_sym_override] = ACTIONS(556),
    [anon_sym_module] = ACTIONS(582),
    [anon_sym_any] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(556),
    [anon_sym_boolean] = ACTIONS(556),
    [anon_sym_string] = ACTIONS(556),
    [anon_sym_symbol] = ACTIONS(556),
    [anon_sym_property] = ACTIONS(556),
    [anon_sym_signal] = ACTIONS(556),
    [anon_sym_on] = ACTIONS(556),
    [anon_sym_required] = ACTIONS(556),
    [anon_sym_component] = ACTIONS(556),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [59] = {
    [sym_export_statement] = STATE(827),
    [sym_declaration] = STATE(828),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(829),
    [sym_expression_statement] = STATE(831),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_statement_block] = STATE(832),
    [sym_if_statement] = STATE(833),
    [sym_switch_statement] = STATE(838),
    [sym_for_statement] = STATE(841),
    [sym_for_in_statement] = STATE(846),
    [sym_while_statement] = STATE(847),
    [sym_do_statement] = STATE(848),
    [sym_try_statement] = STATE(850),
    [sym_with_statement] = STATE(849),
    [sym_break_statement] = STATE(842),
    [sym_continue_statement] = STATE(836),
    [sym_debugger_statement] = STATE(834),
    [sym_return_statement] = STATE(830),
    [sym_throw_statement] = STATE(824),
    [sym_empty_statement] = STATE(823),
    [sym_labeled_statement] = STATE(821),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(2191),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3374),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_type] = ACTIONS(550),
    [anon_sym_namespace] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_from] = ACTIONS(556),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(566),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(570),
    [anon_sym_break] = ACTIONS(177),
    [anon_sym_continue] = ACTIONS(179),
    [anon_sym_debugger] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(185),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(556),
    [anon_sym_readonly] = ACTIONS(556),
    [anon_sym_get] = ACTIONS(556),
    [anon_sym_set] = ACTIONS(556),
    [anon_sym_declare] = ACTIONS(580),
    [anon_sym_public] = ACTIONS(556),
    [anon_sym_private] = ACTIONS(556),
    [anon_sym_protected] = ACTIONS(556),
    [anon_sym_override] = ACTIONS(556),
    [anon_sym_module] = ACTIONS(582),
    [anon_sym_any] = ACTIONS(556),
    [anon_sym_number] = ACTIONS(556),
    [anon_sym_boolean] = ACTIONS(556),
    [anon_sym_string] = ACTIONS(556),
    [anon_sym_symbol] = ACTIONS(556),
    [anon_sym_property] = ACTIONS(556),
    [anon_sym_signal] = ACTIONS(556),
    [anon_sym_on] = ACTIONS(556),
    [anon_sym_required] = ACTIONS(556),
    [anon_sym_component] = ACTIONS(556),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [60] = {
    [sym_export_statement] = STATE(2510),
    [sym_declaration] = STATE(2510),
    [sym_import] = STATE(2236),
    [sym_import_statement] = STATE(2510),
    [sym_expression_statement] = STATE(2510),
    [sym_variable_declaration] = STATE(2592),
    [sym_lexical_declaration] = STATE(2592),
    [sym_statement_block] = STATE(2510),
    [sym_if_statement] = STATE(2510),
    [sym_switch_statement] = STATE(2510),
    [sym_for_statement] = STATE(2510),
    [sym_for_in_statement] = STATE(2510),
    [sym_while_statement] = STATE(2510),
    [sym_do_statement] = STATE(2510),
    [sym_try_statement] = STATE(2510),
    [sym_with_statement] = STATE(2510),
    [sym_break_statement] = STATE(2510),
    [sym_continue_statement] = STATE(2510),
    [sym_debugger_statement] = STATE(2510),
    [sym_return_statement] = STATE(2510),
    [sym_throw_statement] = STATE(2510),
    [sym_empty_statement] = STATE(2510),
    [sym_labeled_statement] = STATE(2510),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(2592),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(2592),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(2592),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_function_signature] = STATE(2592),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(2592),
    [sym_abstract_class_declaration] = STATE(2592),
    [sym_module] = STATE(2592),
    [sym_internal_module] = STATE(876),
    [sym_import_alias] = STATE(2592),
    [sym_interface_declaration] = STATE(2592),
    [sym_enum_declaration] = STATE(2592),
    [sym_type_alias_declaration] = STATE(2592),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3365),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_export] = ACTIONS(586),
    [anon_sym_type] = ACTIONS(588),
    [anon_sym_namespace] = ACTIONS(590),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(596),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(598),
    [anon_sym_const] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(604),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(596),
    [anon_sym_while] = ACTIONS(606),
    [anon_sym_do] = ACTIONS(608),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_break] = ACTIONS(612),
    [anon_sym_continue] = ACTIONS(614),
    [anon_sym_debugger] = ACTIONS(616),
    [anon_sym_return] = ACTIONS(618),
    [anon_sym_throw] = ACTIONS(620),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(596),
    [anon_sym_readonly] = ACTIONS(596),
    [anon_sym_get] = ACTIONS(596),
    [anon_sym_set] = ACTIONS(596),
    [anon_sym_declare] = ACTIONS(628),
    [anon_sym_public] = ACTIONS(596),
    [anon_sym_private] = ACTIONS(596),
    [anon_sym_protected] = ACTIONS(596),
    [anon_sym_override] = ACTIONS(596),
    [anon_sym_module] = ACTIONS(630),
    [anon_sym_any] = ACTIONS(596),
    [anon_sym_number] = ACTIONS(596),
    [anon_sym_boolean] = ACTIONS(596),
    [anon_sym_string] = ACTIONS(596),
    [anon_sym_symbol] = ACTIONS(596),
    [anon_sym_property] = ACTIONS(596),
    [anon_sym_signal] = ACTIONS(596),
    [anon_sym_on] = ACTIONS(596),
    [anon_sym_required] = ACTIONS(596),
    [anon_sym_component] = ACTIONS(596),
    [anon_sym_abstract] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_enum] = ACTIONS(636),
  },
  [61] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1888),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4008),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3720),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4115),
    [sym_optional_tuple_parameter] = STATE(4115),
    [sym_optional_type] = STATE(4115),
    [sym_rest_type] = STATE(4115),
    [sym__tuple_type_member] = STATE(4115),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4016),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(638),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(648),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_RBRACK] = ACTIONS(660),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(682),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(686),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(690),
    [anon_sym_number] = ACTIONS(690),
    [anon_sym_boolean] = ACTIONS(690),
    [anon_sym_string] = ACTIONS(690),
    [anon_sym_symbol] = ACTIONS(690),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [62] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4021),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3720),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4115),
    [sym_optional_tuple_parameter] = STATE(4115),
    [sym_optional_type] = STATE(4115),
    [sym_rest_type] = STATE(4115),
    [sym__tuple_type_member] = STATE(4115),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4013),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(638),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(648),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_RBRACK] = ACTIONS(692),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(682),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(686),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(690),
    [anon_sym_number] = ACTIONS(690),
    [anon_sym_boolean] = ACTIONS(690),
    [anon_sym_string] = ACTIONS(690),
    [anon_sym_symbol] = ACTIONS(690),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [63] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4021),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3720),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4174),
    [sym_optional_tuple_parameter] = STATE(4174),
    [sym_optional_type] = STATE(4174),
    [sym_rest_type] = STATE(4174),
    [sym__tuple_type_member] = STATE(4174),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4013),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(638),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(694),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_RBRACK] = ACTIONS(696),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(682),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(686),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(690),
    [anon_sym_number] = ACTIONS(690),
    [anon_sym_boolean] = ACTIONS(690),
    [anon_sym_string] = ACTIONS(690),
    [anon_sym_symbol] = ACTIONS(690),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [64] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4021),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3720),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4115),
    [sym_optional_tuple_parameter] = STATE(4115),
    [sym_optional_type] = STATE(4115),
    [sym_rest_type] = STATE(4115),
    [sym__tuple_type_member] = STATE(4115),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4013),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(638),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(648),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_RBRACK] = ACTIONS(698),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(682),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(686),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(690),
    [anon_sym_number] = ACTIONS(690),
    [anon_sym_boolean] = ACTIONS(690),
    [anon_sym_string] = ACTIONS(690),
    [anon_sym_symbol] = ACTIONS(690),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [65] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1888),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4008),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3720),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4115),
    [sym_optional_tuple_parameter] = STATE(4115),
    [sym_optional_type] = STATE(4115),
    [sym_rest_type] = STATE(4115),
    [sym__tuple_type_member] = STATE(4115),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4016),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(638),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(648),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_RBRACK] = ACTIONS(700),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(682),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(686),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(690),
    [anon_sym_number] = ACTIONS(690),
    [anon_sym_boolean] = ACTIONS(690),
    [anon_sym_string] = ACTIONS(690),
    [anon_sym_symbol] = ACTIONS(690),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [66] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4021),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3720),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4115),
    [sym_optional_tuple_parameter] = STATE(4115),
    [sym_optional_type] = STATE(4115),
    [sym_rest_type] = STATE(4115),
    [sym__tuple_type_member] = STATE(4115),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4013),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(638),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(648),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_RBRACK] = ACTIONS(702),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(682),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(686),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(690),
    [anon_sym_number] = ACTIONS(690),
    [anon_sym_boolean] = ACTIONS(690),
    [anon_sym_string] = ACTIONS(690),
    [anon_sym_symbol] = ACTIONS(690),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [67] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4021),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3720),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4115),
    [sym_optional_tuple_parameter] = STATE(4115),
    [sym_optional_type] = STATE(4115),
    [sym_rest_type] = STATE(4115),
    [sym__tuple_type_member] = STATE(4115),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4013),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(638),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(648),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_RBRACK] = ACTIONS(704),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(682),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(686),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(690),
    [anon_sym_number] = ACTIONS(690),
    [anon_sym_boolean] = ACTIONS(690),
    [anon_sym_string] = ACTIONS(690),
    [anon_sym_symbol] = ACTIONS(690),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [68] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4021),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3720),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4115),
    [sym_optional_tuple_parameter] = STATE(4115),
    [sym_optional_type] = STATE(4115),
    [sym_rest_type] = STATE(4115),
    [sym__tuple_type_member] = STATE(4115),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4013),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(638),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(648),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_RBRACK] = ACTIONS(706),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(682),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(686),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(690),
    [anon_sym_number] = ACTIONS(690),
    [anon_sym_boolean] = ACTIONS(690),
    [anon_sym_string] = ACTIONS(690),
    [anon_sym_symbol] = ACTIONS(690),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [69] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4021),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3720),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4115),
    [sym_optional_tuple_parameter] = STATE(4115),
    [sym_optional_type] = STATE(4115),
    [sym_rest_type] = STATE(4115),
    [sym__tuple_type_member] = STATE(4115),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4013),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(638),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(648),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_RBRACK] = ACTIONS(708),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(682),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(686),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(690),
    [anon_sym_number] = ACTIONS(690),
    [anon_sym_boolean] = ACTIONS(690),
    [anon_sym_string] = ACTIONS(690),
    [anon_sym_symbol] = ACTIONS(690),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [70] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4021),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3720),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4115),
    [sym_optional_tuple_parameter] = STATE(4115),
    [sym_optional_type] = STATE(4115),
    [sym_rest_type] = STATE(4115),
    [sym__tuple_type_member] = STATE(4115),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4013),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(638),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(648),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_RBRACK] = ACTIONS(710),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(682),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(686),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(690),
    [anon_sym_number] = ACTIONS(690),
    [anon_sym_boolean] = ACTIONS(690),
    [anon_sym_string] = ACTIONS(690),
    [anon_sym_symbol] = ACTIONS(690),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [71] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3775),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_EQ] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(38),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_RPAREN] = ACTIONS(32),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(32),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(38),
    [anon_sym_DASH] = ACTIONS(38),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(84),
    [anon_sym_DASH_DASH] = ACTIONS(84),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(732),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [72] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3823),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_EQ] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(38),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_RPAREN] = ACTIONS(32),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(32),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(38),
    [anon_sym_DASH] = ACTIONS(38),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(84),
    [anon_sym_DASH_DASH] = ACTIONS(84),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(738),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [73] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3728),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_EQ] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(38),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_RPAREN] = ACTIONS(32),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(32),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(38),
    [anon_sym_DASH] = ACTIONS(38),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(84),
    [anon_sym_DASH_DASH] = ACTIONS(84),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(740),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [74] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3644),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_EQ] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(38),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_RPAREN] = ACTIONS(32),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(32),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(38),
    [anon_sym_DASH] = ACTIONS(38),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(84),
    [anon_sym_DASH_DASH] = ACTIONS(84),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(742),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [75] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3581),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(38),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(38),
    [anon_sym_DASH] = ACTIONS(38),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(84),
    [anon_sym_DASH_DASH] = ACTIONS(84),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(744),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [76] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3581),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_EQ] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(38),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_RPAREN] = ACTIONS(32),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(32),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(38),
    [anon_sym_DASH] = ACTIONS(38),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(84),
    [anon_sym_DASH_DASH] = ACTIONS(84),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(744),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [77] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3803),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_EQ] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(38),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_RPAREN] = ACTIONS(32),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(32),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(38),
    [anon_sym_DASH] = ACTIONS(38),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(84),
    [anon_sym_DASH_DASH] = ACTIONS(84),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(746),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [78] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3759),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_EQ] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(38),
    [anon_sym_LPAREN] = ACTIONS(716),
    [anon_sym_RPAREN] = ACTIONS(32),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_COLON] = ACTIONS(32),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(722),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(53),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(38),
    [anon_sym_DASH] = ACTIONS(38),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(84),
    [anon_sym_DASH_DASH] = ACTIONS(84),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(727),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(748),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [79] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1793),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym__formal_parameter] = STATE(3997),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4730),
    [sym_string] = STATE(2181),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(3997),
    [sym_optional_parameter] = STATE(3997),
    [sym__parameter_name] = STATE(3325),
    [sym__type] = STATE(3860),
    [sym_constructor_type] = STATE(3860),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3860),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3860),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3860),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(754),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_this] = ACTIONS(766),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(768),
    [sym_false] = ACTIONS(768),
    [sym_null] = ACTIONS(768),
    [sym_undefined] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(774),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(776),
    [anon_sym_private] = ACTIONS(776),
    [anon_sym_protected] = ACTIONS(776),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(780),
    [anon_sym_number] = ACTIONS(780),
    [anon_sym_boolean] = ACTIONS(780),
    [anon_sym_string] = ACTIONS(780),
    [anon_sym_symbol] = ACTIONS(780),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [80] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1733),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym__formal_parameter] = STATE(3997),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4701),
    [sym_string] = STATE(2181),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(3997),
    [sym_optional_parameter] = STATE(3997),
    [sym__parameter_name] = STATE(3325),
    [sym__type] = STATE(3860),
    [sym_constructor_type] = STATE(3860),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3860),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3860),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3860),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(754),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_this] = ACTIONS(766),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(768),
    [sym_false] = ACTIONS(768),
    [sym_null] = ACTIONS(768),
    [sym_undefined] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(774),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(776),
    [anon_sym_private] = ACTIONS(776),
    [anon_sym_protected] = ACTIONS(776),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(780),
    [anon_sym_number] = ACTIONS(780),
    [anon_sym_boolean] = ACTIONS(780),
    [anon_sym_string] = ACTIONS(780),
    [anon_sym_symbol] = ACTIONS(780),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [81] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1793),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym__formal_parameter] = STATE(3997),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4730),
    [sym_string] = STATE(2181),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(3997),
    [sym_optional_parameter] = STATE(3997),
    [sym__parameter_name] = STATE(3325),
    [sym__type] = STATE(3909),
    [sym_constructor_type] = STATE(3909),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3909),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3909),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3909),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(752),
    [anon_sym_typeof] = ACTIONS(754),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(758),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_this] = ACTIONS(766),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(768),
    [sym_false] = ACTIONS(768),
    [sym_null] = ACTIONS(768),
    [sym_undefined] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(774),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(776),
    [anon_sym_private] = ACTIONS(776),
    [anon_sym_protected] = ACTIONS(776),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(780),
    [anon_sym_number] = ACTIONS(780),
    [anon_sym_boolean] = ACTIONS(780),
    [anon_sym_string] = ACTIONS(780),
    [anon_sym_symbol] = ACTIONS(780),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [82] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(3997),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(3997),
    [sym_optional_parameter] = STATE(3997),
    [sym__parameter_name] = STATE(3325),
    [sym__type] = STATE(3854),
    [sym_constructor_type] = STATE(3854),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3854),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3854),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3854),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(30),
    [anon_sym_typeof] = ACTIONS(34),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(76),
    [anon_sym_DASH] = ACTIONS(76),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(784),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(786),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [83] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(3997),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(3997),
    [sym_optional_parameter] = STATE(3997),
    [sym__parameter_name] = STATE(3325),
    [sym__type] = STATE(3909),
    [sym_constructor_type] = STATE(3909),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3909),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3909),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3909),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(30),
    [anon_sym_typeof] = ACTIONS(34),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(76),
    [anon_sym_DASH] = ACTIONS(76),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(784),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(786),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [84] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(3997),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(3997),
    [sym_optional_parameter] = STATE(3997),
    [sym__parameter_name] = STATE(3325),
    [sym__type] = STATE(3991),
    [sym_constructor_type] = STATE(3991),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3991),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3991),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3991),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(30),
    [anon_sym_typeof] = ACTIONS(34),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(76),
    [anon_sym_DASH] = ACTIONS(76),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(784),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(786),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [85] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(3997),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(3997),
    [sym_optional_parameter] = STATE(3997),
    [sym__parameter_name] = STATE(3325),
    [sym__type] = STATE(3865),
    [sym_constructor_type] = STATE(3865),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3865),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3865),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3865),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(30),
    [anon_sym_typeof] = ACTIONS(34),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(76),
    [anon_sym_DASH] = ACTIONS(76),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(784),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(786),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [86] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(3997),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(3997),
    [sym_optional_parameter] = STATE(3997),
    [sym__parameter_name] = STATE(3325),
    [sym__type] = STATE(3860),
    [sym_constructor_type] = STATE(3860),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3860),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3860),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3860),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(30),
    [anon_sym_typeof] = ACTIONS(34),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(76),
    [anon_sym_DASH] = ACTIONS(76),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(784),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(786),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(109),
    [anon_sym_number] = ACTIONS(109),
    [anon_sym_boolean] = ACTIONS(109),
    [anon_sym_string] = ACTIONS(109),
    [anon_sym_symbol] = ACTIONS(109),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [87] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2092),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4483),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4634),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2039),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3740),
    [sym_pattern] = STATE(4167),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3101),
    [sym_constructor_type] = STATE(3101),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3101),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4507),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3101),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3101),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(792),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(796),
    [anon_sym_typeof] = ACTIONS(798),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(800),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(802),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(810),
    [anon_sym_DASH] = ACTIONS(810),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(812),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(814),
    [sym_number] = ACTIONS(816),
    [sym_this] = ACTIONS(818),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(820),
    [sym_false] = ACTIONS(820),
    [sym_null] = ACTIONS(820),
    [sym_undefined] = ACTIONS(822),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(824),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(828),
    [anon_sym_number] = ACTIONS(828),
    [anon_sym_boolean] = ACTIONS(828),
    [anon_sym_string] = ACTIONS(828),
    [anon_sym_symbol] = ACTIONS(828),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [88] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2089),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4807),
    [sym_string] = STATE(2181),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(4128),
    [sym_constructor_type] = STATE(4128),
    [sym__primary_type] = STATE(3640),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3944),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(4128),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(4128),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(840),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(846),
    [anon_sym_typeof] = ACTIONS(754),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(848),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(760),
    [anon_sym_DASH] = ACTIONS(760),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(762),
    [sym_number] = ACTIONS(764),
    [sym_this] = ACTIONS(852),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(768),
    [sym_false] = ACTIONS(768),
    [sym_null] = ACTIONS(768),
    [sym_undefined] = ACTIONS(854),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(856),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(858),
    [anon_sym_number] = ACTIONS(858),
    [anon_sym_boolean] = ACTIONS(858),
    [anon_sym_string] = ACTIONS(858),
    [anon_sym_symbol] = ACTIONS(858),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [89] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3285),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3285),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1207),
    [sym_subscript_expression] = STATE(1207),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3285),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2405),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_non_null_expression] = STATE(1207),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3655),
    [sym_constructor_type] = STATE(3655),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3655),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3655),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3655),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_export] = ACTIONS(862),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(862),
    [anon_sym_namespace] = ACTIONS(864),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_typeof] = ACTIONS(868),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(862),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(862),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(870),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(874),
    [anon_sym_DASH] = ACTIONS(874),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(876),
    [sym_number] = ACTIONS(878),
    [sym_this] = ACTIONS(880),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(882),
    [sym_false] = ACTIONS(882),
    [sym_null] = ACTIONS(882),
    [sym_undefined] = ACTIONS(884),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(862),
    [anon_sym_readonly] = ACTIONS(886),
    [anon_sym_get] = ACTIONS(862),
    [anon_sym_set] = ACTIONS(862),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(862),
    [anon_sym_public] = ACTIONS(862),
    [anon_sym_private] = ACTIONS(862),
    [anon_sym_protected] = ACTIONS(862),
    [anon_sym_override] = ACTIONS(862),
    [anon_sym_module] = ACTIONS(862),
    [anon_sym_any] = ACTIONS(888),
    [anon_sym_number] = ACTIONS(888),
    [anon_sym_boolean] = ACTIONS(888),
    [anon_sym_string] = ACTIONS(888),
    [anon_sym_symbol] = ACTIONS(888),
    [anon_sym_property] = ACTIONS(862),
    [anon_sym_signal] = ACTIONS(862),
    [anon_sym_on] = ACTIONS(862),
    [anon_sym_required] = ACTIONS(862),
    [anon_sym_component] = ACTIONS(862),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [90] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1691),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2057),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3389),
    [sym_constructor_type] = STATE(3389),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3389),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(428),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3389),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3389),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(890),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(896),
    [anon_sym_typeof] = ACTIONS(898),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(912),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(914),
    [anon_sym_DASH] = ACTIONS(914),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(916),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(918),
    [sym_number] = ACTIONS(920),
    [sym_this] = ACTIONS(922),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_null] = ACTIONS(924),
    [sym_undefined] = ACTIONS(926),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(928),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(930),
    [anon_sym_number] = ACTIONS(930),
    [anon_sym_boolean] = ACTIONS(930),
    [anon_sym_string] = ACTIONS(930),
    [anon_sym_symbol] = ACTIONS(930),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [91] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1944),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2331),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3389),
    [sym_constructor_type] = STATE(3389),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3389),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(358),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3389),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3389),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(932),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(938),
    [anon_sym_typeof] = ACTIONS(940),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(948),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(952),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(954),
    [anon_sym_DASH] = ACTIONS(954),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(956),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(962),
    [sym_number] = ACTIONS(964),
    [sym_this] = ACTIONS(966),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(968),
    [sym_false] = ACTIONS(968),
    [sym_null] = ACTIONS(968),
    [sym_undefined] = ACTIONS(970),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(972),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(974),
    [anon_sym_number] = ACTIONS(974),
    [anon_sym_boolean] = ACTIONS(974),
    [anon_sym_string] = ACTIONS(974),
    [anon_sym_symbol] = ACTIONS(974),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [92] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2355),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2220),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3389),
    [sym_constructor_type] = STATE(3389),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3389),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(463),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3389),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3389),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(976),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(982),
    [anon_sym_typeof] = ACTIONS(984),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(986),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(66),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(990),
    [anon_sym_DASH] = ACTIONS(990),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(80),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [sym_number] = ACTIONS(994),
    [sym_this] = ACTIONS(996),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(998),
    [sym_false] = ACTIONS(998),
    [sym_null] = ACTIONS(998),
    [sym_undefined] = ACTIONS(1000),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(1004),
    [anon_sym_number] = ACTIONS(1004),
    [anon_sym_boolean] = ACTIONS(1004),
    [anon_sym_string] = ACTIONS(1004),
    [anon_sym_symbol] = ACTIONS(1004),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [93] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2298),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2220),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3389),
    [sym_constructor_type] = STATE(3389),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3389),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(434),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3389),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3389),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1012),
    [anon_sym_typeof] = ACTIONS(1014),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(986),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1024),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(1026),
    [anon_sym_DASH] = ACTIONS(1026),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1028),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [sym_number] = ACTIONS(994),
    [sym_this] = ACTIONS(996),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(998),
    [sym_false] = ACTIONS(998),
    [sym_null] = ACTIONS(998),
    [sym_undefined] = ACTIONS(1034),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1036),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1038),
    [anon_sym_number] = ACTIONS(1038),
    [anon_sym_boolean] = ACTIONS(1038),
    [anon_sym_string] = ACTIONS(1038),
    [anon_sym_symbol] = ACTIONS(1038),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [94] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1712),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2057),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3389),
    [sym_constructor_type] = STATE(3389),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3389),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(466),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3389),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3389),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1040),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(896),
    [anon_sym_typeof] = ACTIONS(1046),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(902),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(904),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1058),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(1060),
    [anon_sym_DASH] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1062),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(918),
    [sym_number] = ACTIONS(920),
    [sym_this] = ACTIONS(922),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_null] = ACTIONS(924),
    [sym_undefined] = ACTIONS(1068),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1070),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1072),
    [anon_sym_number] = ACTIONS(1072),
    [anon_sym_boolean] = ACTIONS(1072),
    [anon_sym_string] = ACTIONS(1072),
    [anon_sym_symbol] = ACTIONS(1072),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [95] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2130),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2220),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3389),
    [sym_constructor_type] = STATE(3389),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3389),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(528),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3389),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3389),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(982),
    [anon_sym_typeof] = ACTIONS(1080),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(986),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1092),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1096),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [sym_number] = ACTIONS(994),
    [sym_this] = ACTIONS(996),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(998),
    [sym_false] = ACTIONS(998),
    [sym_null] = ACTIONS(998),
    [sym_undefined] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1104),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1106),
    [anon_sym_number] = ACTIONS(1106),
    [anon_sym_boolean] = ACTIONS(1106),
    [anon_sym_string] = ACTIONS(1106),
    [anon_sym_symbol] = ACTIONS(1106),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [96] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2291),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2220),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3389),
    [sym_constructor_type] = STATE(3389),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3389),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(537),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3389),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3389),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1114),
    [anon_sym_typeof] = ACTIONS(1116),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(986),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1126),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(1128),
    [anon_sym_DASH] = ACTIONS(1128),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1130),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [sym_number] = ACTIONS(994),
    [sym_this] = ACTIONS(996),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(998),
    [sym_false] = ACTIONS(998),
    [sym_null] = ACTIONS(998),
    [sym_undefined] = ACTIONS(1136),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1138),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1140),
    [anon_sym_number] = ACTIONS(1140),
    [anon_sym_boolean] = ACTIONS(1140),
    [anon_sym_string] = ACTIONS(1140),
    [anon_sym_symbol] = ACTIONS(1140),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [97] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1528),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1750),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3389),
    [sym_constructor_type] = STATE(3389),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3389),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3389),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3389),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1142),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [anon_sym_typeof] = ACTIONS(1146),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1148),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1152),
    [sym_number] = ACTIONS(1154),
    [sym_this] = ACTIONS(1156),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(1158),
    [sym_false] = ACTIONS(1158),
    [sym_null] = ACTIONS(1158),
    [sym_undefined] = ACTIONS(1160),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(856),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(1162),
    [anon_sym_number] = ACTIONS(1162),
    [anon_sym_boolean] = ACTIONS(1162),
    [anon_sym_string] = ACTIONS(1162),
    [anon_sym_symbol] = ACTIONS(1162),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [98] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1788),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3544),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3544),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1314),
    [sym_subscript_expression] = STATE(1314),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3544),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2176),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_non_null_expression] = STATE(1314),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3655),
    [sym_constructor_type] = STATE(3655),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3655),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(516),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3655),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3655),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_export] = ACTIONS(1166),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(1166),
    [anon_sym_namespace] = ACTIONS(1168),
    [anon_sym_LBRACE] = ACTIONS(1170),
    [anon_sym_typeof] = ACTIONS(650),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1166),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(1166),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1172),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [sym_this] = ACTIONS(682),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(99),
    [sym_false] = ACTIONS(99),
    [sym_null] = ACTIONS(99),
    [sym_undefined] = ACTIONS(1174),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1166),
    [anon_sym_readonly] = ACTIONS(1176),
    [anon_sym_get] = ACTIONS(1166),
    [anon_sym_set] = ACTIONS(1166),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(1166),
    [anon_sym_public] = ACTIONS(1166),
    [anon_sym_private] = ACTIONS(1166),
    [anon_sym_protected] = ACTIONS(1166),
    [anon_sym_override] = ACTIONS(1166),
    [anon_sym_module] = ACTIONS(1166),
    [anon_sym_any] = ACTIONS(1178),
    [anon_sym_number] = ACTIONS(1178),
    [anon_sym_boolean] = ACTIONS(1178),
    [anon_sym_string] = ACTIONS(1178),
    [anon_sym_symbol] = ACTIONS(1178),
    [anon_sym_property] = ACTIONS(1166),
    [anon_sym_signal] = ACTIONS(1166),
    [anon_sym_on] = ACTIONS(1166),
    [anon_sym_required] = ACTIONS(1166),
    [anon_sym_component] = ACTIONS(1166),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [99] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1895),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_nested_identifier] = STATE(4870),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1750),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3846),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3389),
    [sym_constructor_type] = STATE(3389),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3389),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_type_arguments] = STATE(507),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4567),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3389),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3389),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1180),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [anon_sym_typeof] = ACTIONS(1186),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1148),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1198),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(1200),
    [anon_sym_DASH] = ACTIONS(1200),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1202),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1152),
    [sym_number] = ACTIONS(1154),
    [sym_this] = ACTIONS(1156),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(1158),
    [sym_false] = ACTIONS(1158),
    [sym_null] = ACTIONS(1158),
    [sym_undefined] = ACTIONS(1208),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1210),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1212),
    [anon_sym_number] = ACTIONS(1212),
    [anon_sym_boolean] = ACTIONS(1212),
    [anon_sym_string] = ACTIONS(1212),
    [anon_sym_symbol] = ACTIONS(1212),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [100] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1633),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_STAR] = ACTIONS(1216),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_as] = ACTIONS(1218),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1222),
    [anon_sym_RBRACE] = ACTIONS(1222),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(678),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1222),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_in] = ACTIONS(1218),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_COLON] = ACTIONS(1222),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_RBRACK] = ACTIONS(1222),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(1222),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_AMP_AMP] = ACTIONS(1222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1222),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_GT_GT_GT] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_PERCENT] = ACTIONS(1222),
    [anon_sym_STAR_STAR] = ACTIONS(1222),
    [anon_sym_LT_EQ] = ACTIONS(1222),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1222),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1222),
    [anon_sym_GT_EQ] = ACTIONS(1222),
    [anon_sym_QMARK_QMARK] = ACTIONS(1222),
    [anon_sym_instanceof] = ACTIONS(1218),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
    [sym__ternary_qmark] = ACTIONS(1222),
  },
  [101] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1745),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_STAR] = ACTIONS(1236),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_as] = ACTIONS(1218),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_COMMA] = ACTIONS(1222),
    [anon_sym_RBRACE] = ACTIONS(1222),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(145),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_in] = ACTIONS(1218),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(1222),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_QMARK_DOT] = ACTIONS(1222),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_AMP_AMP] = ACTIONS(1222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1222),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_GT_GT_GT] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_PERCENT] = ACTIONS(1222),
    [anon_sym_STAR_STAR] = ACTIONS(1222),
    [anon_sym_LT_EQ] = ACTIONS(1222),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1222),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1222),
    [anon_sym_GT_EQ] = ACTIONS(1222),
    [anon_sym_QMARK_QMARK] = ACTIONS(1222),
    [anon_sym_instanceof] = ACTIONS(1218),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
    [sym__automatic_semicolon] = ACTIONS(1222),
    [sym__ternary_qmark] = ACTIONS(1222),
  },
  [102] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1791),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_as] = ACTIONS(1218),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_COMMA] = ACTIONS(1222),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_in] = ACTIONS(1218),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_SEMI] = ACTIONS(1222),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_QMARK_DOT] = ACTIONS(1222),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_AMP_AMP] = ACTIONS(1222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1222),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_GT_GT_GT] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_PERCENT] = ACTIONS(1222),
    [anon_sym_STAR_STAR] = ACTIONS(1222),
    [anon_sym_LT_EQ] = ACTIONS(1222),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1222),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1222),
    [anon_sym_GT_EQ] = ACTIONS(1222),
    [anon_sym_QMARK_QMARK] = ACTIONS(1222),
    [anon_sym_instanceof] = ACTIONS(1218),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
    [sym__automatic_semicolon] = ACTIONS(1222),
    [sym__ternary_qmark] = ACTIONS(1222),
  },
  [103] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1832),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_as] = ACTIONS(1218),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1222),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1204),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_in] = ACTIONS(1218),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(1222),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_AMP_AMP] = ACTIONS(1222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1222),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_GT_GT_GT] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_PERCENT] = ACTIONS(1222),
    [anon_sym_STAR_STAR] = ACTIONS(1222),
    [anon_sym_LT_EQ] = ACTIONS(1222),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1222),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1222),
    [anon_sym_GT_EQ] = ACTIONS(1222),
    [anon_sym_QMARK_QMARK] = ACTIONS(1222),
    [anon_sym_instanceof] = ACTIONS(1218),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
    [anon_sym_implements] = ACTIONS(1218),
    [sym__ternary_qmark] = ACTIONS(1222),
  },
  [104] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1930),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_as] = ACTIONS(1218),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(958),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_in] = ACTIONS(1218),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_SEMI] = ACTIONS(1222),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_QMARK_DOT] = ACTIONS(1222),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_AMP_AMP] = ACTIONS(1222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1222),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_GT_GT_GT] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_PERCENT] = ACTIONS(1222),
    [anon_sym_STAR_STAR] = ACTIONS(1222),
    [anon_sym_LT_EQ] = ACTIONS(1222),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1222),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1222),
    [anon_sym_GT_EQ] = ACTIONS(1222),
    [anon_sym_QMARK_QMARK] = ACTIONS(1222),
    [anon_sym_instanceof] = ACTIONS(1218),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
    [sym__automatic_semicolon] = ACTIONS(1222),
    [sym__ternary_qmark] = ACTIONS(1222),
  },
  [105] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2227),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_as] = ACTIONS(1218),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1030),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_in] = ACTIONS(1218),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_COLON] = ACTIONS(1222),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(1222),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_AMP_AMP] = ACTIONS(1222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1222),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_GT_GT_GT] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_PERCENT] = ACTIONS(1222),
    [anon_sym_STAR_STAR] = ACTIONS(1222),
    [anon_sym_LT_EQ] = ACTIONS(1222),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1222),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1222),
    [anon_sym_GT_EQ] = ACTIONS(1222),
    [anon_sym_QMARK_QMARK] = ACTIONS(1222),
    [anon_sym_instanceof] = ACTIONS(1218),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
    [sym__ternary_qmark] = ACTIONS(1222),
  },
  [106] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2249),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_STAR] = ACTIONS(1278),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_as] = ACTIONS(1218),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1132),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_in] = ACTIONS(1218),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_RBRACK] = ACTIONS(1222),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(1222),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_AMP_AMP] = ACTIONS(1222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1222),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_GT_GT_GT] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_PERCENT] = ACTIONS(1222),
    [anon_sym_STAR_STAR] = ACTIONS(1222),
    [anon_sym_LT_EQ] = ACTIONS(1222),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1222),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1222),
    [anon_sym_GT_EQ] = ACTIONS(1222),
    [anon_sym_QMARK_QMARK] = ACTIONS(1222),
    [anon_sym_instanceof] = ACTIONS(1218),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
    [sym__ternary_qmark] = ACTIONS(1222),
  },
  [107] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2353),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_STAR] = ACTIONS(1286),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_as] = ACTIONS(1218),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(82),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_in] = ACTIONS(1218),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(1222),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(1222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1222),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_GT_GT_GT] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_PERCENT] = ACTIONS(1222),
    [anon_sym_STAR_STAR] = ACTIONS(1222),
    [anon_sym_LT_EQ] = ACTIONS(1222),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1222),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1222),
    [anon_sym_GT_EQ] = ACTIONS(1222),
    [anon_sym_QMARK_QMARK] = ACTIONS(1222),
    [anon_sym_instanceof] = ACTIONS(1218),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
    [sym__ternary_qmark] = ACTIONS(1222),
  },
  [108] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2222),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1294),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_as] = ACTIONS(1218),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1098),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_in] = ACTIONS(1218),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_QMARK_DOT] = ACTIONS(1222),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_AMP_AMP] = ACTIONS(1222),
    [anon_sym_PIPE_PIPE] = ACTIONS(1222),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_GT_GT_GT] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1222),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_PERCENT] = ACTIONS(1222),
    [anon_sym_STAR_STAR] = ACTIONS(1222),
    [anon_sym_LT_EQ] = ACTIONS(1222),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1222),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1222),
    [anon_sym_GT_EQ] = ACTIONS(1222),
    [anon_sym_QMARK_QMARK] = ACTIONS(1222),
    [anon_sym_instanceof] = ACTIONS(1218),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
    [sym__ternary_qmark] = ACTIONS(1222),
  },
  [109] = {
    [sym_declaration] = STATE(3807),
    [sym_import] = STATE(2236),
    [sym_variable_declaration] = STATE(3792),
    [sym_lexical_declaration] = STATE(3792),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1967),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(3792),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(3792),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(3792),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_function_signature] = STATE(3792),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(3792),
    [sym_abstract_class_declaration] = STATE(3792),
    [sym_module] = STATE(3792),
    [sym_internal_module] = STATE(2144),
    [sym_import_alias] = STATE(3792),
    [sym_interface_declaration] = STATE(3792),
    [sym_enum_declaration] = STATE(3792),
    [sym_type_alias_declaration] = STATE(3792),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3735),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(1300),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(1302),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_var] = ACTIONS(1304),
    [anon_sym_let] = ACTIONS(1306),
    [anon_sym_const] = ACTIONS(1308),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(1310),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_function] = ACTIONS(1314),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(1316),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(1318),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
    [anon_sym_abstract] = ACTIONS(1320),
    [anon_sym_interface] = ACTIONS(1322),
    [anon_sym_enum] = ACTIONS(1324),
  },
  [110] = {
    [sym_declaration] = STATE(722),
    [sym_import] = STATE(2236),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(2055),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(2191),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3601),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(1326),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(1328),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(1330),
    [anon_sym_function] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(1332),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(1334),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [111] = {
    [sym_declaration] = STATE(722),
    [sym_import] = STATE(2236),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(2055),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3724),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(1326),
    [anon_sym_namespace] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(1328),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(1338),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(1340),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(1342),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [112] = {
    [sym_declaration] = STATE(3591),
    [sym_import] = STATE(2236),
    [sym_variable_declaration] = STATE(3792),
    [sym_lexical_declaration] = STATE(3792),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1976),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(3792),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(3792),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(3792),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_function_signature] = STATE(3792),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(3792),
    [sym_abstract_class_declaration] = STATE(3792),
    [sym_module] = STATE(3792),
    [sym_internal_module] = STATE(2144),
    [sym_import_alias] = STATE(3792),
    [sym_interface_declaration] = STATE(3792),
    [sym_enum_declaration] = STATE(3792),
    [sym_type_alias_declaration] = STATE(3792),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3735),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(1300),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(1302),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_var] = ACTIONS(1304),
    [anon_sym_let] = ACTIONS(1306),
    [anon_sym_const] = ACTIONS(1308),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(1310),
    [anon_sym_async] = ACTIONS(1312),
    [anon_sym_function] = ACTIONS(1314),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(1316),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(1318),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
    [anon_sym_abstract] = ACTIONS(1320),
    [anon_sym_interface] = ACTIONS(1322),
    [anon_sym_enum] = ACTIONS(1324),
  },
  [113] = {
    [sym_declaration] = STATE(2593),
    [sym_import] = STATE(2236),
    [sym_variable_declaration] = STATE(2592),
    [sym_lexical_declaration] = STATE(2592),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1971),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(2592),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(2592),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(2592),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_function_signature] = STATE(2592),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(2592),
    [sym_abstract_class_declaration] = STATE(2592),
    [sym_module] = STATE(2592),
    [sym_internal_module] = STATE(876),
    [sym_import_alias] = STATE(2592),
    [sym_interface_declaration] = STATE(2592),
    [sym_enum_declaration] = STATE(2592),
    [sym_type_alias_declaration] = STATE(2592),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3827),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(1344),
    [anon_sym_namespace] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(1348),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(598),
    [anon_sym_const] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(1352),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
    [anon_sym_abstract] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_enum] = ACTIONS(636),
  },
  [114] = {
    [sym_declaration] = STATE(2612),
    [sym_import] = STATE(2236),
    [sym_variable_declaration] = STATE(2592),
    [sym_lexical_declaration] = STATE(2592),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(2024),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(2592),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(2592),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(2592),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_function_signature] = STATE(2592),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(2592),
    [sym_abstract_class_declaration] = STATE(2592),
    [sym_module] = STATE(2592),
    [sym_internal_module] = STATE(876),
    [sym_import_alias] = STATE(2592),
    [sym_interface_declaration] = STATE(2592),
    [sym_enum_declaration] = STATE(2592),
    [sym_type_alias_declaration] = STATE(2592),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3827),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(1344),
    [anon_sym_namespace] = ACTIONS(1346),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(1348),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(598),
    [anon_sym_const] = ACTIONS(600),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(1350),
    [anon_sym_function] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(1352),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(1354),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
    [anon_sym_abstract] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(634),
    [anon_sym_enum] = ACTIONS(636),
  },
  [115] = {
    [sym_declaration] = STATE(844),
    [sym_import] = STATE(2236),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1977),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(2191),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3601),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(1326),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(1328),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(1330),
    [anon_sym_function] = ACTIONS(578),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(1332),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(1334),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [116] = {
    [sym_declaration] = STATE(844),
    [sym_import] = STATE(2236),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1977),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_class_declaration] = STATE(826),
    [sym_function] = STATE(2236),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function] = STATE(2236),
    [sym_generator_function_declaration] = STATE(826),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_function_signature] = STATE(826),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(168),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3724),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(1326),
    [anon_sym_namespace] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(1328),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_var] = ACTIONS(151),
    [anon_sym_let] = ACTIONS(153),
    [anon_sym_const] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(195),
    [anon_sym_async] = ACTIONS(1338),
    [anon_sym_function] = ACTIONS(199),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(1340),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(1342),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
    [anon_sym_abstract] = ACTIONS(235),
    [anon_sym_interface] = ACTIONS(237),
    [anon_sym_enum] = ACTIONS(239),
  },
  [117] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(2704),
    [sym_statement_block] = STATE(2704),
    [sym_if_statement] = STATE(2704),
    [sym_switch_statement] = STATE(2704),
    [sym_try_statement] = STATE(2704),
    [sym_with_statement] = STATE(2704),
    [sym_empty_statement] = STATE(2704),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_definition] = STATE(4565),
    [sym_ui_object_array] = STATE(4565),
    [sym_ui_nested_identifier] = STATE(4229),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_export] = ACTIONS(1358),
    [anon_sym_type] = ACTIONS(1358),
    [anon_sym_namespace] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(1358),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1364),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_readonly] = ACTIONS(1358),
    [anon_sym_get] = ACTIONS(1358),
    [anon_sym_set] = ACTIONS(1358),
    [anon_sym_declare] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1358),
    [anon_sym_private] = ACTIONS(1358),
    [anon_sym_protected] = ACTIONS(1358),
    [anon_sym_override] = ACTIONS(1358),
    [anon_sym_module] = ACTIONS(1358),
    [anon_sym_any] = ACTIONS(1358),
    [anon_sym_number] = ACTIONS(1358),
    [anon_sym_boolean] = ACTIONS(1358),
    [anon_sym_string] = ACTIONS(1358),
    [anon_sym_symbol] = ACTIONS(1358),
    [anon_sym_property] = ACTIONS(1358),
    [anon_sym_signal] = ACTIONS(1358),
    [anon_sym_on] = ACTIONS(1358),
    [anon_sym_required] = ACTIONS(1358),
    [anon_sym_component] = ACTIONS(1358),
  },
  [118] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(2742),
    [sym_statement_block] = STATE(2742),
    [sym_if_statement] = STATE(2742),
    [sym_switch_statement] = STATE(2742),
    [sym_try_statement] = STATE(2742),
    [sym_with_statement] = STATE(2742),
    [sym_empty_statement] = STATE(2742),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_definition] = STATE(4430),
    [sym_ui_object_array] = STATE(4430),
    [sym_ui_nested_identifier] = STATE(4229),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_export] = ACTIONS(1358),
    [anon_sym_type] = ACTIONS(1358),
    [anon_sym_namespace] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(1358),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1364),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_readonly] = ACTIONS(1358),
    [anon_sym_get] = ACTIONS(1358),
    [anon_sym_set] = ACTIONS(1358),
    [anon_sym_declare] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1358),
    [anon_sym_private] = ACTIONS(1358),
    [anon_sym_protected] = ACTIONS(1358),
    [anon_sym_override] = ACTIONS(1358),
    [anon_sym_module] = ACTIONS(1358),
    [anon_sym_any] = ACTIONS(1358),
    [anon_sym_number] = ACTIONS(1358),
    [anon_sym_boolean] = ACTIONS(1358),
    [anon_sym_string] = ACTIONS(1358),
    [anon_sym_symbol] = ACTIONS(1358),
    [anon_sym_property] = ACTIONS(1358),
    [anon_sym_signal] = ACTIONS(1358),
    [anon_sym_on] = ACTIONS(1358),
    [anon_sym_required] = ACTIONS(1358),
    [anon_sym_component] = ACTIONS(1358),
  },
  [119] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(2726),
    [sym_statement_block] = STATE(2726),
    [sym_if_statement] = STATE(2726),
    [sym_switch_statement] = STATE(2726),
    [sym_try_statement] = STATE(2726),
    [sym_with_statement] = STATE(2726),
    [sym_empty_statement] = STATE(2726),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_definition] = STATE(2726),
    [sym_ui_object_array] = STATE(2726),
    [sym_ui_nested_identifier] = STATE(4261),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_export] = ACTIONS(1368),
    [anon_sym_type] = ACTIONS(1368),
    [anon_sym_namespace] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(1368),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(1372),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1374),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1368),
    [anon_sym_readonly] = ACTIONS(1368),
    [anon_sym_get] = ACTIONS(1368),
    [anon_sym_set] = ACTIONS(1368),
    [anon_sym_declare] = ACTIONS(1368),
    [anon_sym_public] = ACTIONS(1368),
    [anon_sym_private] = ACTIONS(1368),
    [anon_sym_protected] = ACTIONS(1368),
    [anon_sym_override] = ACTIONS(1368),
    [anon_sym_module] = ACTIONS(1368),
    [anon_sym_any] = ACTIONS(1368),
    [anon_sym_number] = ACTIONS(1368),
    [anon_sym_boolean] = ACTIONS(1368),
    [anon_sym_string] = ACTIONS(1368),
    [anon_sym_symbol] = ACTIONS(1368),
    [anon_sym_property] = ACTIONS(1368),
    [anon_sym_signal] = ACTIONS(1368),
    [anon_sym_on] = ACTIONS(1368),
    [anon_sym_required] = ACTIONS(1368),
    [anon_sym_component] = ACTIONS(1368),
  },
  [120] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(2723),
    [sym_statement_block] = STATE(2723),
    [sym_if_statement] = STATE(2723),
    [sym_switch_statement] = STATE(2723),
    [sym_try_statement] = STATE(2723),
    [sym_with_statement] = STATE(2723),
    [sym_empty_statement] = STATE(2723),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_definition] = STATE(4606),
    [sym_ui_object_array] = STATE(4606),
    [sym_ui_nested_identifier] = STATE(4229),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_export] = ACTIONS(1358),
    [anon_sym_type] = ACTIONS(1358),
    [anon_sym_namespace] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(1358),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1364),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_readonly] = ACTIONS(1358),
    [anon_sym_get] = ACTIONS(1358),
    [anon_sym_set] = ACTIONS(1358),
    [anon_sym_declare] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1358),
    [anon_sym_private] = ACTIONS(1358),
    [anon_sym_protected] = ACTIONS(1358),
    [anon_sym_override] = ACTIONS(1358),
    [anon_sym_module] = ACTIONS(1358),
    [anon_sym_any] = ACTIONS(1358),
    [anon_sym_number] = ACTIONS(1358),
    [anon_sym_boolean] = ACTIONS(1358),
    [anon_sym_string] = ACTIONS(1358),
    [anon_sym_symbol] = ACTIONS(1358),
    [anon_sym_property] = ACTIONS(1358),
    [anon_sym_signal] = ACTIONS(1358),
    [anon_sym_on] = ACTIONS(1358),
    [anon_sym_required] = ACTIONS(1358),
    [anon_sym_component] = ACTIONS(1358),
  },
  [121] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(2760),
    [sym_statement_block] = STATE(2760),
    [sym_if_statement] = STATE(2760),
    [sym_switch_statement] = STATE(2760),
    [sym_try_statement] = STATE(2760),
    [sym_with_statement] = STATE(2760),
    [sym_empty_statement] = STATE(2760),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_definition] = STATE(2760),
    [sym_ui_object_array] = STATE(2760),
    [sym_ui_nested_identifier] = STATE(4261),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_export] = ACTIONS(1368),
    [anon_sym_type] = ACTIONS(1368),
    [anon_sym_namespace] = ACTIONS(1370),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1368),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(1368),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(1372),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1374),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1368),
    [anon_sym_readonly] = ACTIONS(1368),
    [anon_sym_get] = ACTIONS(1368),
    [anon_sym_set] = ACTIONS(1368),
    [anon_sym_declare] = ACTIONS(1368),
    [anon_sym_public] = ACTIONS(1368),
    [anon_sym_private] = ACTIONS(1368),
    [anon_sym_protected] = ACTIONS(1368),
    [anon_sym_override] = ACTIONS(1368),
    [anon_sym_module] = ACTIONS(1368),
    [anon_sym_any] = ACTIONS(1368),
    [anon_sym_number] = ACTIONS(1368),
    [anon_sym_boolean] = ACTIONS(1368),
    [anon_sym_string] = ACTIONS(1368),
    [anon_sym_symbol] = ACTIONS(1368),
    [anon_sym_property] = ACTIONS(1368),
    [anon_sym_signal] = ACTIONS(1368),
    [anon_sym_on] = ACTIONS(1368),
    [anon_sym_required] = ACTIONS(1368),
    [anon_sym_component] = ACTIONS(1368),
  },
  [122] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(2745),
    [sym_statement_block] = STATE(2745),
    [sym_if_statement] = STATE(2745),
    [sym_switch_statement] = STATE(2745),
    [sym_try_statement] = STATE(2745),
    [sym_with_statement] = STATE(2745),
    [sym_empty_statement] = STATE(2745),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_definition] = STATE(4276),
    [sym_ui_object_array] = STATE(4276),
    [sym_ui_nested_identifier] = STATE(4229),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_export] = ACTIONS(1358),
    [anon_sym_type] = ACTIONS(1358),
    [anon_sym_namespace] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(1358),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1364),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_readonly] = ACTIONS(1358),
    [anon_sym_get] = ACTIONS(1358),
    [anon_sym_set] = ACTIONS(1358),
    [anon_sym_declare] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1358),
    [anon_sym_private] = ACTIONS(1358),
    [anon_sym_protected] = ACTIONS(1358),
    [anon_sym_override] = ACTIONS(1358),
    [anon_sym_module] = ACTIONS(1358),
    [anon_sym_any] = ACTIONS(1358),
    [anon_sym_number] = ACTIONS(1358),
    [anon_sym_boolean] = ACTIONS(1358),
    [anon_sym_string] = ACTIONS(1358),
    [anon_sym_symbol] = ACTIONS(1358),
    [anon_sym_property] = ACTIONS(1358),
    [anon_sym_signal] = ACTIONS(1358),
    [anon_sym_on] = ACTIONS(1358),
    [anon_sym_required] = ACTIONS(1358),
    [anon_sym_component] = ACTIONS(1358),
  },
  [123] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(2737),
    [sym_statement_block] = STATE(2737),
    [sym_if_statement] = STATE(2737),
    [sym_switch_statement] = STATE(2737),
    [sym_try_statement] = STATE(2737),
    [sym_with_statement] = STATE(2737),
    [sym_empty_statement] = STATE(2737),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_definition] = STATE(4558),
    [sym_ui_object_array] = STATE(4558),
    [sym_ui_nested_identifier] = STATE(4229),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_export] = ACTIONS(1358),
    [anon_sym_type] = ACTIONS(1358),
    [anon_sym_namespace] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(1358),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1364),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_readonly] = ACTIONS(1358),
    [anon_sym_get] = ACTIONS(1358),
    [anon_sym_set] = ACTIONS(1358),
    [anon_sym_declare] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1358),
    [anon_sym_private] = ACTIONS(1358),
    [anon_sym_protected] = ACTIONS(1358),
    [anon_sym_override] = ACTIONS(1358),
    [anon_sym_module] = ACTIONS(1358),
    [anon_sym_any] = ACTIONS(1358),
    [anon_sym_number] = ACTIONS(1358),
    [anon_sym_boolean] = ACTIONS(1358),
    [anon_sym_string] = ACTIONS(1358),
    [anon_sym_symbol] = ACTIONS(1358),
    [anon_sym_property] = ACTIONS(1358),
    [anon_sym_signal] = ACTIONS(1358),
    [anon_sym_on] = ACTIONS(1358),
    [anon_sym_required] = ACTIONS(1358),
    [anon_sym_component] = ACTIONS(1358),
  },
  [124] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(2747),
    [sym_statement_block] = STATE(2747),
    [sym_if_statement] = STATE(2747),
    [sym_switch_statement] = STATE(2747),
    [sym_try_statement] = STATE(2747),
    [sym_with_statement] = STATE(2747),
    [sym_empty_statement] = STATE(2747),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_definition] = STATE(4419),
    [sym_ui_object_array] = STATE(4419),
    [sym_ui_nested_identifier] = STATE(4229),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_export] = ACTIONS(1358),
    [anon_sym_type] = ACTIONS(1358),
    [anon_sym_namespace] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(1358),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1364),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_readonly] = ACTIONS(1358),
    [anon_sym_get] = ACTIONS(1358),
    [anon_sym_set] = ACTIONS(1358),
    [anon_sym_declare] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1358),
    [anon_sym_private] = ACTIONS(1358),
    [anon_sym_protected] = ACTIONS(1358),
    [anon_sym_override] = ACTIONS(1358),
    [anon_sym_module] = ACTIONS(1358),
    [anon_sym_any] = ACTIONS(1358),
    [anon_sym_number] = ACTIONS(1358),
    [anon_sym_boolean] = ACTIONS(1358),
    [anon_sym_string] = ACTIONS(1358),
    [anon_sym_symbol] = ACTIONS(1358),
    [anon_sym_property] = ACTIONS(1358),
    [anon_sym_signal] = ACTIONS(1358),
    [anon_sym_on] = ACTIONS(1358),
    [anon_sym_required] = ACTIONS(1358),
    [anon_sym_component] = ACTIONS(1358),
  },
  [125] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(2743),
    [sym_statement_block] = STATE(2743),
    [sym_if_statement] = STATE(2743),
    [sym_switch_statement] = STATE(2743),
    [sym_try_statement] = STATE(2743),
    [sym_with_statement] = STATE(2743),
    [sym_empty_statement] = STATE(2743),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_definition] = STATE(4426),
    [sym_ui_object_array] = STATE(4426),
    [sym_ui_nested_identifier] = STATE(4229),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_export] = ACTIONS(1358),
    [anon_sym_type] = ACTIONS(1358),
    [anon_sym_namespace] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(1358),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1364),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_readonly] = ACTIONS(1358),
    [anon_sym_get] = ACTIONS(1358),
    [anon_sym_set] = ACTIONS(1358),
    [anon_sym_declare] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1358),
    [anon_sym_private] = ACTIONS(1358),
    [anon_sym_protected] = ACTIONS(1358),
    [anon_sym_override] = ACTIONS(1358),
    [anon_sym_module] = ACTIONS(1358),
    [anon_sym_any] = ACTIONS(1358),
    [anon_sym_number] = ACTIONS(1358),
    [anon_sym_boolean] = ACTIONS(1358),
    [anon_sym_string] = ACTIONS(1358),
    [anon_sym_symbol] = ACTIONS(1358),
    [anon_sym_property] = ACTIONS(1358),
    [anon_sym_signal] = ACTIONS(1358),
    [anon_sym_on] = ACTIONS(1358),
    [anon_sym_required] = ACTIONS(1358),
    [anon_sym_component] = ACTIONS(1358),
  },
  [126] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(2765),
    [sym_statement_block] = STATE(2765),
    [sym_if_statement] = STATE(2765),
    [sym_switch_statement] = STATE(2765),
    [sym_try_statement] = STATE(2765),
    [sym_with_statement] = STATE(2765),
    [sym_empty_statement] = STATE(2765),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1862),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4514),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_definition] = STATE(4578),
    [sym_ui_object_array] = STATE(4578),
    [sym_ui_nested_identifier] = STATE(4229),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1356),
    [anon_sym_export] = ACTIONS(1358),
    [anon_sym_type] = ACTIONS(1358),
    [anon_sym_namespace] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(592),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1358),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(1358),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_with] = ACTIONS(610),
    [anon_sym_SEMI] = ACTIONS(572),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1364),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1358),
    [anon_sym_readonly] = ACTIONS(1358),
    [anon_sym_get] = ACTIONS(1358),
    [anon_sym_set] = ACTIONS(1358),
    [anon_sym_declare] = ACTIONS(1358),
    [anon_sym_public] = ACTIONS(1358),
    [anon_sym_private] = ACTIONS(1358),
    [anon_sym_protected] = ACTIONS(1358),
    [anon_sym_override] = ACTIONS(1358),
    [anon_sym_module] = ACTIONS(1358),
    [anon_sym_any] = ACTIONS(1358),
    [anon_sym_number] = ACTIONS(1358),
    [anon_sym_boolean] = ACTIONS(1358),
    [anon_sym_string] = ACTIONS(1358),
    [anon_sym_symbol] = ACTIONS(1358),
    [anon_sym_property] = ACTIONS(1358),
    [anon_sym_signal] = ACTIONS(1358),
    [anon_sym_on] = ACTIONS(1358),
    [anon_sym_required] = ACTIONS(1358),
    [anon_sym_component] = ACTIONS(1358),
  },
  [127] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1793),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym__formal_parameter] = STATE(3997),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4730),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(3997),
    [sym_optional_parameter] = STATE(3997),
    [sym__parameter_name] = STATE(3325),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1382),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(1386),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(776),
    [anon_sym_private] = ACTIONS(776),
    [anon_sym_protected] = ACTIONS(776),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(640),
    [anon_sym_number] = ACTIONS(640),
    [anon_sym_boolean] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_symbol] = ACTIONS(640),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
  },
  [128] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1733),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym__formal_parameter] = STATE(3997),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4701),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(3997),
    [sym_optional_parameter] = STATE(3997),
    [sym__parameter_name] = STATE(3325),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1382),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(1386),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(776),
    [anon_sym_private] = ACTIONS(776),
    [anon_sym_protected] = ACTIONS(776),
    [anon_sym_override] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(640),
    [anon_sym_number] = ACTIONS(640),
    [anon_sym_boolean] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_symbol] = ACTIONS(640),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
  },
  [129] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1888),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4008),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_definition] = STATE(4014),
    [sym_ui_nested_identifier] = STATE(4261),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4016),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1390),
    [anon_sym_type] = ACTIONS(1390),
    [anon_sym_namespace] = ACTIONS(1392),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1390),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(1390),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_RBRACK] = ACTIONS(1396),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1398),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_readonly] = ACTIONS(1390),
    [anon_sym_get] = ACTIONS(1390),
    [anon_sym_set] = ACTIONS(1390),
    [anon_sym_declare] = ACTIONS(1390),
    [anon_sym_public] = ACTIONS(1390),
    [anon_sym_private] = ACTIONS(1390),
    [anon_sym_protected] = ACTIONS(1390),
    [anon_sym_override] = ACTIONS(1390),
    [anon_sym_module] = ACTIONS(1390),
    [anon_sym_any] = ACTIONS(1390),
    [anon_sym_number] = ACTIONS(1390),
    [anon_sym_boolean] = ACTIONS(1390),
    [anon_sym_string] = ACTIONS(1390),
    [anon_sym_symbol] = ACTIONS(1390),
    [anon_sym_property] = ACTIONS(1390),
    [anon_sym_signal] = ACTIONS(1390),
    [anon_sym_on] = ACTIONS(1390),
    [anon_sym_required] = ACTIONS(1390),
    [anon_sym_component] = ACTIONS(1390),
  },
  [130] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_EQ] = ACTIONS(1402),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(64),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_RPAREN] = ACTIONS(64),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_COLON] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [131] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1888),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4008),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_definition] = STATE(4015),
    [sym_ui_nested_identifier] = STATE(4261),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4016),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(1388),
    [anon_sym_export] = ACTIONS(1390),
    [anon_sym_type] = ACTIONS(1390),
    [anon_sym_namespace] = ACTIONS(1392),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1390),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(1390),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_RBRACK] = ACTIONS(1396),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1398),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1390),
    [anon_sym_readonly] = ACTIONS(1390),
    [anon_sym_get] = ACTIONS(1390),
    [anon_sym_set] = ACTIONS(1390),
    [anon_sym_declare] = ACTIONS(1390),
    [anon_sym_public] = ACTIONS(1390),
    [anon_sym_private] = ACTIONS(1390),
    [anon_sym_protected] = ACTIONS(1390),
    [anon_sym_override] = ACTIONS(1390),
    [anon_sym_module] = ACTIONS(1390),
    [anon_sym_any] = ACTIONS(1390),
    [anon_sym_number] = ACTIONS(1390),
    [anon_sym_boolean] = ACTIONS(1390),
    [anon_sym_string] = ACTIONS(1390),
    [anon_sym_symbol] = ACTIONS(1390),
    [anon_sym_property] = ACTIONS(1390),
    [anon_sym_signal] = ACTIONS(1390),
    [anon_sym_on] = ACTIONS(1390),
    [anon_sym_required] = ACTIONS(1390),
    [anon_sym_component] = ACTIONS(1390),
  },
  [132] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(4457),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(4457),
    [sym_optional_parameter] = STATE(4457),
    [sym__parameter_name] = STATE(3325),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1432),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1436),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [133] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(4025),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(4025),
    [sym_optional_parameter] = STATE(4025),
    [sym__parameter_name] = STATE(3325),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1438),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1436),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [134] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(3997),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(3997),
    [sym_optional_parameter] = STATE(3997),
    [sym__parameter_name] = STATE(3325),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1436),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [135] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(4457),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(4457),
    [sym_optional_parameter] = STATE(4457),
    [sym__parameter_name] = STATE(3325),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1440),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1436),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [136] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(4457),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(4457),
    [sym_optional_parameter] = STATE(4457),
    [sym__parameter_name] = STATE(3325),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1442),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1436),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [137] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(64),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [138] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(4119),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(4119),
    [sym_optional_parameter] = STATE(4119),
    [sym__parameter_name] = STATE(3325),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1448),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1436),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [139] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(4457),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(4457),
    [sym_optional_parameter] = STATE(4457),
    [sym__parameter_name] = STATE(3325),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1450),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1436),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [140] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_EQ] = ACTIONS(1452),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_EQ_GT] = ACTIONS(1454),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [141] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(4457),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(4457),
    [sym_optional_parameter] = STATE(4457),
    [sym__parameter_name] = STATE(3325),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1456),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1436),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [142] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(4457),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(4457),
    [sym_optional_parameter] = STATE(4457),
    [sym__parameter_name] = STATE(3325),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1458),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1436),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [143] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1628),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1460),
    [anon_sym_RBRACE] = ACTIONS(1460),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1460),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_RBRACK] = ACTIONS(1460),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1460),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_PIPE] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_QMARK] = ACTIONS(1460),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
    [anon_sym_extends] = ACTIONS(1462),
  },
  [144] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_EQ] = ACTIONS(1402),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(1464),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_COLON] = ACTIONS(1467),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [145] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1888),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4008),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4016),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_RBRACK] = ACTIONS(1469),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(640),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(640),
    [anon_sym_number] = ACTIONS(640),
    [anon_sym_boolean] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_symbol] = ACTIONS(640),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
  },
  [146] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4021),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4013),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_RBRACK] = ACTIONS(1471),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(640),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(640),
    [anon_sym_number] = ACTIONS(640),
    [anon_sym_boolean] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_symbol] = ACTIONS(640),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
  },
  [147] = {
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1475),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_type] = ACTIONS(1473),
    [anon_sym_EQ] = ACTIONS(1477),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1479),
    [anon_sym_COMMA] = ACTIONS(1481),
    [anon_sym_RBRACE] = ACTIONS(1479),
    [anon_sym_typeof] = ACTIONS(1473),
    [anon_sym_import] = ACTIONS(1473),
    [anon_sym_from] = ACTIONS(1473),
    [anon_sym_var] = ACTIONS(1473),
    [anon_sym_let] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(1473),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_await] = ACTIONS(1473),
    [anon_sym_in] = ACTIONS(1475),
    [anon_sym_of] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_try] = ACTIONS(1473),
    [anon_sym_with] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_debugger] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_throw] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1479),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_yield] = ACTIONS(1473),
    [anon_sym_LBRACK] = ACTIONS(1479),
    [anon_sym_LTtemplate_GT] = ACTIONS(1479),
    [anon_sym_LT] = ACTIONS(1473),
    [anon_sym_GT] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(1473),
    [anon_sym_DOT] = ACTIONS(1475),
    [anon_sym_class] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_function] = ACTIONS(1473),
    [anon_sym_QMARK_DOT] = ACTIONS(1481),
    [anon_sym_new] = ACTIONS(1473),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1481),
    [anon_sym_GT_GT] = ACTIONS(1475),
    [anon_sym_GT_GT_GT] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_PERCENT] = ACTIONS(1481),
    [anon_sym_STAR_STAR] = ACTIONS(1481),
    [anon_sym_LT_EQ] = ACTIONS(1481),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1481),
    [anon_sym_GT_EQ] = ACTIONS(1481),
    [anon_sym_QMARK_QMARK] = ACTIONS(1481),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_void] = ACTIONS(1473),
    [anon_sym_delete] = ACTIONS(1473),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_DQUOTE] = ACTIONS(1479),
    [anon_sym_SQUOTE] = ACTIONS(1479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1479),
    [sym_number] = ACTIONS(1479),
    [sym_this] = ACTIONS(1473),
    [sym_super] = ACTIONS(1473),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [sym_null] = ACTIONS(1473),
    [sym_undefined] = ACTIONS(1473),
    [anon_sym_AT] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_get] = ACTIONS(1473),
    [anon_sym_set] = ACTIONS(1473),
    [anon_sym_declare] = ACTIONS(1473),
    [anon_sym_public] = ACTIONS(1473),
    [anon_sym_private] = ACTIONS(1473),
    [anon_sym_protected] = ACTIONS(1473),
    [anon_sym_override] = ACTIONS(1473),
    [anon_sym_module] = ACTIONS(1473),
    [anon_sym_any] = ACTIONS(1473),
    [anon_sym_number] = ACTIONS(1473),
    [anon_sym_boolean] = ACTIONS(1473),
    [anon_sym_string] = ACTIONS(1473),
    [anon_sym_symbol] = ACTIONS(1473),
    [anon_sym_property] = ACTIONS(1473),
    [anon_sym_signal] = ACTIONS(1473),
    [anon_sym_on] = ACTIONS(1473),
    [anon_sym_required] = ACTIONS(1473),
    [anon_sym_component] = ACTIONS(1473),
    [anon_sym_abstract] = ACTIONS(1473),
    [anon_sym_interface] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [sym__automatic_semicolon] = ACTIONS(1483),
    [sym__ternary_qmark] = ACTIONS(1481),
  },
  [148] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4021),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4013),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_RBRACK] = ACTIONS(1485),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(640),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(640),
    [anon_sym_number] = ACTIONS(640),
    [anon_sym_boolean] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_symbol] = ACTIONS(640),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
  },
  [149] = {
    [sym_statement_block] = STATE(185),
    [sym_identifier] = ACTIONS(1487),
    [anon_sym_export] = ACTIONS(1487),
    [anon_sym_STAR] = ACTIONS(1487),
    [anon_sym_default] = ACTIONS(1487),
    [anon_sym_type] = ACTIONS(1487),
    [anon_sym_as] = ACTIONS(1487),
    [anon_sym_namespace] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1489),
    [anon_sym_COMMA] = ACTIONS(1491),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_import] = ACTIONS(1487),
    [anon_sym_from] = ACTIONS(1487),
    [anon_sym_var] = ACTIONS(1487),
    [anon_sym_let] = ACTIONS(1487),
    [anon_sym_const] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(1491),
    [anon_sym_await] = ACTIONS(1487),
    [anon_sym_in] = ACTIONS(1487),
    [anon_sym_of] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(1487),
    [anon_sym_try] = ACTIONS(1487),
    [anon_sym_with] = ACTIONS(1487),
    [anon_sym_break] = ACTIONS(1487),
    [anon_sym_continue] = ACTIONS(1487),
    [anon_sym_debugger] = ACTIONS(1487),
    [anon_sym_return] = ACTIONS(1487),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_case] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1491),
    [anon_sym_LTtemplate_GT] = ACTIONS(1491),
    [anon_sym_LT] = ACTIONS(1487),
    [anon_sym_GT] = ACTIONS(1487),
    [anon_sym_SLASH] = ACTIONS(1487),
    [anon_sym_DOT] = ACTIONS(1487),
    [anon_sym_class] = ACTIONS(1487),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_QMARK_DOT] = ACTIONS(1491),
    [anon_sym_new] = ACTIONS(1487),
    [anon_sym_AMP_AMP] = ACTIONS(1491),
    [anon_sym_PIPE_PIPE] = ACTIONS(1491),
    [anon_sym_GT_GT] = ACTIONS(1487),
    [anon_sym_GT_GT_GT] = ACTIONS(1491),
    [anon_sym_LT_LT] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1487),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1487),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_PERCENT] = ACTIONS(1491),
    [anon_sym_STAR_STAR] = ACTIONS(1491),
    [anon_sym_LT_EQ] = ACTIONS(1491),
    [anon_sym_EQ_EQ] = ACTIONS(1487),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1491),
    [anon_sym_BANG_EQ] = ACTIONS(1487),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1491),
    [anon_sym_GT_EQ] = ACTIONS(1491),
    [anon_sym_QMARK_QMARK] = ACTIONS(1491),
    [anon_sym_instanceof] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(1491),
    [anon_sym_SQUOTE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1491),
    [sym_number] = ACTIONS(1491),
    [sym_this] = ACTIONS(1487),
    [sym_super] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_undefined] = ACTIONS(1487),
    [anon_sym_AT] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1487),
    [anon_sym_readonly] = ACTIONS(1487),
    [anon_sym_get] = ACTIONS(1487),
    [anon_sym_set] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1487),
    [anon_sym_public] = ACTIONS(1487),
    [anon_sym_private] = ACTIONS(1487),
    [anon_sym_protected] = ACTIONS(1487),
    [anon_sym_override] = ACTIONS(1487),
    [anon_sym_module] = ACTIONS(1487),
    [anon_sym_any] = ACTIONS(1487),
    [anon_sym_number] = ACTIONS(1487),
    [anon_sym_boolean] = ACTIONS(1487),
    [anon_sym_string] = ACTIONS(1487),
    [anon_sym_symbol] = ACTIONS(1487),
    [anon_sym_property] = ACTIONS(1487),
    [anon_sym_signal] = ACTIONS(1487),
    [anon_sym_on] = ACTIONS(1487),
    [anon_sym_required] = ACTIONS(1487),
    [anon_sym_component] = ACTIONS(1487),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_interface] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1487),
    [sym__automatic_semicolon] = ACTIONS(1491),
    [sym__ternary_qmark] = ACTIONS(1491),
  },
  [150] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1888),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4008),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4016),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_RBRACK] = ACTIONS(1396),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(640),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(640),
    [anon_sym_number] = ACTIONS(640),
    [anon_sym_boolean] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_symbol] = ACTIONS(640),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
  },
  [151] = {
    [sym_statement_block] = STATE(185),
    [sym_identifier] = ACTIONS(1487),
    [anon_sym_export] = ACTIONS(1487),
    [anon_sym_STAR] = ACTIONS(1487),
    [anon_sym_default] = ACTIONS(1487),
    [anon_sym_type] = ACTIONS(1487),
    [anon_sym_as] = ACTIONS(1487),
    [anon_sym_namespace] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1489),
    [anon_sym_COMMA] = ACTIONS(1491),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_import] = ACTIONS(1487),
    [anon_sym_from] = ACTIONS(1487),
    [anon_sym_var] = ACTIONS(1487),
    [anon_sym_let] = ACTIONS(1487),
    [anon_sym_const] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(1491),
    [anon_sym_await] = ACTIONS(1487),
    [anon_sym_in] = ACTIONS(1487),
    [anon_sym_of] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(1487),
    [anon_sym_try] = ACTIONS(1487),
    [anon_sym_with] = ACTIONS(1487),
    [anon_sym_break] = ACTIONS(1487),
    [anon_sym_continue] = ACTIONS(1487),
    [anon_sym_debugger] = ACTIONS(1487),
    [anon_sym_return] = ACTIONS(1487),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_case] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1491),
    [anon_sym_LTtemplate_GT] = ACTIONS(1491),
    [anon_sym_LT] = ACTIONS(1487),
    [anon_sym_GT] = ACTIONS(1487),
    [anon_sym_SLASH] = ACTIONS(1487),
    [anon_sym_DOT] = ACTIONS(1493),
    [anon_sym_class] = ACTIONS(1487),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_QMARK_DOT] = ACTIONS(1491),
    [anon_sym_new] = ACTIONS(1487),
    [anon_sym_AMP_AMP] = ACTIONS(1491),
    [anon_sym_PIPE_PIPE] = ACTIONS(1491),
    [anon_sym_GT_GT] = ACTIONS(1487),
    [anon_sym_GT_GT_GT] = ACTIONS(1491),
    [anon_sym_LT_LT] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1487),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1487),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_PERCENT] = ACTIONS(1491),
    [anon_sym_STAR_STAR] = ACTIONS(1491),
    [anon_sym_LT_EQ] = ACTIONS(1491),
    [anon_sym_EQ_EQ] = ACTIONS(1487),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1491),
    [anon_sym_BANG_EQ] = ACTIONS(1487),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1491),
    [anon_sym_GT_EQ] = ACTIONS(1491),
    [anon_sym_QMARK_QMARK] = ACTIONS(1491),
    [anon_sym_instanceof] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(1491),
    [anon_sym_SQUOTE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1491),
    [sym_number] = ACTIONS(1491),
    [sym_this] = ACTIONS(1487),
    [sym_super] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_undefined] = ACTIONS(1487),
    [anon_sym_AT] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1487),
    [anon_sym_readonly] = ACTIONS(1487),
    [anon_sym_get] = ACTIONS(1487),
    [anon_sym_set] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1487),
    [anon_sym_public] = ACTIONS(1487),
    [anon_sym_private] = ACTIONS(1487),
    [anon_sym_protected] = ACTIONS(1487),
    [anon_sym_override] = ACTIONS(1487),
    [anon_sym_module] = ACTIONS(1487),
    [anon_sym_any] = ACTIONS(1487),
    [anon_sym_number] = ACTIONS(1487),
    [anon_sym_boolean] = ACTIONS(1487),
    [anon_sym_string] = ACTIONS(1487),
    [anon_sym_symbol] = ACTIONS(1487),
    [anon_sym_property] = ACTIONS(1487),
    [anon_sym_signal] = ACTIONS(1487),
    [anon_sym_on] = ACTIONS(1487),
    [anon_sym_required] = ACTIONS(1487),
    [anon_sym_component] = ACTIONS(1487),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_interface] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1487),
    [sym__automatic_semicolon] = ACTIONS(1491),
    [sym__ternary_qmark] = ACTIONS(1491),
  },
  [152] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4021),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4013),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_RBRACK] = ACTIONS(1495),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(640),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(640),
    [anon_sym_number] = ACTIONS(640),
    [anon_sym_boolean] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_symbol] = ACTIONS(640),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
  },
  [153] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_EQ] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_RPAREN] = ACTIONS(32),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_COLON] = ACTIONS(32),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [154] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4021),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4013),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_RBRACK] = ACTIONS(1497),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(640),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(640),
    [anon_sym_number] = ACTIONS(640),
    [anon_sym_boolean] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_symbol] = ACTIONS(640),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
  },
  [155] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(227),
    [sym_variable_declaration] = STATE(227),
    [sym_lexical_declaration] = STATE(227),
    [sym_empty_statement] = STATE(227),
    [sym_parenthesized_expression] = STATE(1306),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4225),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4225),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1306),
    [sym_subscript_expression] = STATE(1306),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4225),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1306),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1499),
    [anon_sym_export] = ACTIONS(1501),
    [anon_sym_type] = ACTIONS(1501),
    [anon_sym_namespace] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1505),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1501),
    [anon_sym_var] = ACTIONS(1507),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_const] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1515),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1501),
    [anon_sym_readonly] = ACTIONS(1501),
    [anon_sym_get] = ACTIONS(1501),
    [anon_sym_set] = ACTIONS(1501),
    [anon_sym_declare] = ACTIONS(1501),
    [anon_sym_public] = ACTIONS(1501),
    [anon_sym_private] = ACTIONS(1501),
    [anon_sym_protected] = ACTIONS(1501),
    [anon_sym_override] = ACTIONS(1501),
    [anon_sym_module] = ACTIONS(1501),
    [anon_sym_any] = ACTIONS(1501),
    [anon_sym_number] = ACTIONS(1501),
    [anon_sym_boolean] = ACTIONS(1501),
    [anon_sym_string] = ACTIONS(1501),
    [anon_sym_symbol] = ACTIONS(1501),
    [anon_sym_property] = ACTIONS(1501),
    [anon_sym_signal] = ACTIONS(1501),
    [anon_sym_on] = ACTIONS(1501),
    [anon_sym_required] = ACTIONS(1501),
    [anon_sym_component] = ACTIONS(1501),
  },
  [156] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(225),
    [sym_variable_declaration] = STATE(225),
    [sym_lexical_declaration] = STATE(225),
    [sym_empty_statement] = STATE(225),
    [sym_parenthesized_expression] = STATE(1306),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4225),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4225),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1306),
    [sym_subscript_expression] = STATE(1306),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4225),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1306),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1499),
    [anon_sym_export] = ACTIONS(1501),
    [anon_sym_type] = ACTIONS(1501),
    [anon_sym_namespace] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1505),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1501),
    [anon_sym_var] = ACTIONS(1507),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_const] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1515),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1501),
    [anon_sym_readonly] = ACTIONS(1501),
    [anon_sym_get] = ACTIONS(1501),
    [anon_sym_set] = ACTIONS(1501),
    [anon_sym_declare] = ACTIONS(1501),
    [anon_sym_public] = ACTIONS(1501),
    [anon_sym_private] = ACTIONS(1501),
    [anon_sym_protected] = ACTIONS(1501),
    [anon_sym_override] = ACTIONS(1501),
    [anon_sym_module] = ACTIONS(1501),
    [anon_sym_any] = ACTIONS(1501),
    [anon_sym_number] = ACTIONS(1501),
    [anon_sym_boolean] = ACTIONS(1501),
    [anon_sym_string] = ACTIONS(1501),
    [anon_sym_symbol] = ACTIONS(1501),
    [anon_sym_property] = ACTIONS(1501),
    [anon_sym_signal] = ACTIONS(1501),
    [anon_sym_on] = ACTIONS(1501),
    [anon_sym_required] = ACTIONS(1501),
    [anon_sym_component] = ACTIONS(1501),
  },
  [157] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1894),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4021),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4013),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_RBRACK] = ACTIONS(1517),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(640),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(640),
    [anon_sym_number] = ACTIONS(640),
    [anon_sym_boolean] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_symbol] = ACTIONS(640),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
  },
  [158] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(224),
    [sym_variable_declaration] = STATE(224),
    [sym_lexical_declaration] = STATE(224),
    [sym_empty_statement] = STATE(224),
    [sym_parenthesized_expression] = STATE(1306),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4225),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4225),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1306),
    [sym_subscript_expression] = STATE(1306),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4225),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1306),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1499),
    [anon_sym_export] = ACTIONS(1501),
    [anon_sym_type] = ACTIONS(1501),
    [anon_sym_namespace] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1505),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1501),
    [anon_sym_var] = ACTIONS(1507),
    [anon_sym_let] = ACTIONS(1509),
    [anon_sym_const] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(1501),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1515),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1501),
    [anon_sym_readonly] = ACTIONS(1501),
    [anon_sym_get] = ACTIONS(1501),
    [anon_sym_set] = ACTIONS(1501),
    [anon_sym_declare] = ACTIONS(1501),
    [anon_sym_public] = ACTIONS(1501),
    [anon_sym_private] = ACTIONS(1501),
    [anon_sym_protected] = ACTIONS(1501),
    [anon_sym_override] = ACTIONS(1501),
    [anon_sym_module] = ACTIONS(1501),
    [anon_sym_any] = ACTIONS(1501),
    [anon_sym_number] = ACTIONS(1501),
    [anon_sym_boolean] = ACTIONS(1501),
    [anon_sym_string] = ACTIONS(1501),
    [anon_sym_symbol] = ACTIONS(1501),
    [anon_sym_property] = ACTIONS(1501),
    [anon_sym_signal] = ACTIONS(1501),
    [anon_sym_on] = ACTIONS(1501),
    [anon_sym_required] = ACTIONS(1501),
    [anon_sym_component] = ACTIONS(1501),
  },
  [159] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1896),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4008),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4016),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_COMMA] = ACTIONS(1394),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_RBRACK] = ACTIONS(1396),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(640),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(640),
    [anon_sym_number] = ACTIONS(640),
    [anon_sym_boolean] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_symbol] = ACTIONS(640),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
  },
  [160] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym__formal_parameter] = STATE(4457),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3578),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_accessibility_modifier] = STATE(229),
    [sym_override_modifier] = STATE(233),
    [sym_required_parameter] = STATE(4457),
    [sym_optional_parameter] = STATE(4457),
    [sym__parameter_name] = STATE(3325),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(218),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1434),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1436),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [161] = {
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_export] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_default] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(1519),
    [anon_sym_as] = ACTIONS(1519),
    [anon_sym_namespace] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_COMMA] = ACTIONS(1521),
    [anon_sym_RBRACE] = ACTIONS(1521),
    [anon_sym_typeof] = ACTIONS(1519),
    [anon_sym_import] = ACTIONS(1519),
    [anon_sym_from] = ACTIONS(1519),
    [anon_sym_var] = ACTIONS(1519),
    [anon_sym_let] = ACTIONS(1519),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_else] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_switch] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_await] = ACTIONS(1519),
    [anon_sym_in] = ACTIONS(1519),
    [anon_sym_of] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_do] = ACTIONS(1519),
    [anon_sym_try] = ACTIONS(1519),
    [anon_sym_with] = ACTIONS(1519),
    [anon_sym_break] = ACTIONS(1519),
    [anon_sym_continue] = ACTIONS(1519),
    [anon_sym_debugger] = ACTIONS(1519),
    [anon_sym_return] = ACTIONS(1519),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_SEMI] = ACTIONS(1521),
    [anon_sym_case] = ACTIONS(1519),
    [anon_sym_yield] = ACTIONS(1519),
    [anon_sym_LBRACK] = ACTIONS(1521),
    [anon_sym_LTtemplate_GT] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_GT] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1519),
    [anon_sym_DOT] = ACTIONS(1519),
    [anon_sym_class] = ACTIONS(1519),
    [anon_sym_async] = ACTIONS(1519),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_QMARK_DOT] = ACTIONS(1521),
    [anon_sym_new] = ACTIONS(1519),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_GT_GT] = ACTIONS(1519),
    [anon_sym_GT_GT_GT] = ACTIONS(1521),
    [anon_sym_LT_LT] = ACTIONS(1521),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_CARET] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_PERCENT] = ACTIONS(1521),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1519),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1521),
    [anon_sym_GT_EQ] = ACTIONS(1521),
    [anon_sym_QMARK_QMARK] = ACTIONS(1521),
    [anon_sym_instanceof] = ACTIONS(1519),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_void] = ACTIONS(1519),
    [anon_sym_delete] = ACTIONS(1519),
    [anon_sym_PLUS_PLUS] = ACTIONS(1521),
    [anon_sym_DASH_DASH] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1521),
    [sym_number] = ACTIONS(1521),
    [sym_this] = ACTIONS(1519),
    [sym_super] = ACTIONS(1519),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_undefined] = ACTIONS(1519),
    [anon_sym_AT] = ACTIONS(1521),
    [anon_sym_static] = ACTIONS(1519),
    [anon_sym_readonly] = ACTIONS(1519),
    [anon_sym_get] = ACTIONS(1519),
    [anon_sym_set] = ACTIONS(1519),
    [anon_sym_declare] = ACTIONS(1519),
    [anon_sym_public] = ACTIONS(1519),
    [anon_sym_private] = ACTIONS(1519),
    [anon_sym_protected] = ACTIONS(1519),
    [anon_sym_override] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(1519),
    [anon_sym_any] = ACTIONS(1519),
    [anon_sym_number] = ACTIONS(1519),
    [anon_sym_boolean] = ACTIONS(1519),
    [anon_sym_string] = ACTIONS(1519),
    [anon_sym_symbol] = ACTIONS(1519),
    [anon_sym_property] = ACTIONS(1519),
    [anon_sym_signal] = ACTIONS(1519),
    [anon_sym_on] = ACTIONS(1519),
    [anon_sym_required] = ACTIONS(1519),
    [anon_sym_component] = ACTIONS(1519),
    [anon_sym_abstract] = ACTIONS(1519),
    [anon_sym_interface] = ACTIONS(1519),
    [anon_sym_enum] = ACTIONS(1519),
    [sym__automatic_semicolon] = ACTIONS(1521),
    [sym__ternary_qmark] = ACTIONS(1521),
  },
  [162] = {
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(1525),
    [anon_sym_default] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_as] = ACTIONS(1525),
    [anon_sym_namespace] = ACTIONS(1523),
    [anon_sym_LBRACE] = ACTIONS(1527),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1527),
    [anon_sym_typeof] = ACTIONS(1523),
    [anon_sym_import] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(1523),
    [anon_sym_var] = ACTIONS(1523),
    [anon_sym_let] = ACTIONS(1523),
    [anon_sym_const] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_else] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_LPAREN] = ACTIONS(1527),
    [anon_sym_await] = ACTIONS(1523),
    [anon_sym_in] = ACTIONS(1525),
    [anon_sym_of] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_do] = ACTIONS(1523),
    [anon_sym_try] = ACTIONS(1523),
    [anon_sym_with] = ACTIONS(1523),
    [anon_sym_break] = ACTIONS(1523),
    [anon_sym_continue] = ACTIONS(1523),
    [anon_sym_debugger] = ACTIONS(1523),
    [anon_sym_return] = ACTIONS(1523),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_SEMI] = ACTIONS(1527),
    [anon_sym_case] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(1523),
    [anon_sym_LBRACK] = ACTIONS(1527),
    [anon_sym_LTtemplate_GT] = ACTIONS(1527),
    [anon_sym_LT] = ACTIONS(1523),
    [anon_sym_GT] = ACTIONS(1525),
    [anon_sym_SLASH] = ACTIONS(1523),
    [anon_sym_DOT] = ACTIONS(1525),
    [anon_sym_class] = ACTIONS(1523),
    [anon_sym_async] = ACTIONS(1523),
    [anon_sym_function] = ACTIONS(1523),
    [anon_sym_QMARK_DOT] = ACTIONS(1529),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_GT_GT] = ACTIONS(1525),
    [anon_sym_GT_GT_GT] = ACTIONS(1529),
    [anon_sym_LT_LT] = ACTIONS(1529),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_CARET] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1525),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_PERCENT] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1525),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1525),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_QMARK_QMARK] = ACTIONS(1529),
    [anon_sym_instanceof] = ACTIONS(1525),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_void] = ACTIONS(1523),
    [anon_sym_delete] = ACTIONS(1523),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_DQUOTE] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1527),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1523),
    [sym_super] = ACTIONS(1523),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_undefined] = ACTIONS(1523),
    [anon_sym_AT] = ACTIONS(1527),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_override] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
    [anon_sym_property] = ACTIONS(1523),
    [anon_sym_signal] = ACTIONS(1523),
    [anon_sym_on] = ACTIONS(1523),
    [anon_sym_required] = ACTIONS(1523),
    [anon_sym_component] = ACTIONS(1523),
    [anon_sym_abstract] = ACTIONS(1523),
    [anon_sym_interface] = ACTIONS(1523),
    [anon_sym_enum] = ACTIONS(1523),
    [sym__automatic_semicolon] = ACTIONS(1531),
    [sym__ternary_qmark] = ACTIONS(1529),
  },
  [163] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_export] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_default] = ACTIONS(1533),
    [anon_sym_type] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1533),
    [anon_sym_LBRACE] = ACTIONS(1535),
    [anon_sym_COMMA] = ACTIONS(1535),
    [anon_sym_RBRACE] = ACTIONS(1535),
    [anon_sym_typeof] = ACTIONS(1533),
    [anon_sym_import] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(1533),
    [anon_sym_var] = ACTIONS(1533),
    [anon_sym_let] = ACTIONS(1533),
    [anon_sym_const] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_else] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_switch] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_in] = ACTIONS(1533),
    [anon_sym_of] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_do] = ACTIONS(1533),
    [anon_sym_try] = ACTIONS(1533),
    [anon_sym_with] = ACTIONS(1533),
    [anon_sym_break] = ACTIONS(1533),
    [anon_sym_continue] = ACTIONS(1533),
    [anon_sym_debugger] = ACTIONS(1533),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_throw] = ACTIONS(1533),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym_case] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1535),
    [anon_sym_LTtemplate_GT] = ACTIONS(1535),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(1533),
    [anon_sym_async] = ACTIONS(1533),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_QMARK_DOT] = ACTIONS(1535),
    [anon_sym_new] = ACTIONS(1533),
    [anon_sym_AMP_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1535),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_GT_GT_GT] = ACTIONS(1535),
    [anon_sym_LT_LT] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1535),
    [anon_sym_STAR_STAR] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1535),
    [anon_sym_EQ_EQ] = ACTIONS(1533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1533),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1535),
    [anon_sym_GT_EQ] = ACTIONS(1535),
    [anon_sym_QMARK_QMARK] = ACTIONS(1535),
    [anon_sym_instanceof] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1533),
    [anon_sym_delete] = ACTIONS(1533),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1535),
    [sym_number] = ACTIONS(1535),
    [sym_this] = ACTIONS(1533),
    [sym_super] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_undefined] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(1535),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_readonly] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1533),
    [anon_sym_set] = ACTIONS(1533),
    [anon_sym_declare] = ACTIONS(1533),
    [anon_sym_public] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1533),
    [anon_sym_protected] = ACTIONS(1533),
    [anon_sym_override] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1533),
    [anon_sym_any] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1533),
    [anon_sym_property] = ACTIONS(1533),
    [anon_sym_signal] = ACTIONS(1533),
    [anon_sym_on] = ACTIONS(1533),
    [anon_sym_required] = ACTIONS(1533),
    [anon_sym_component] = ACTIONS(1533),
    [anon_sym_abstract] = ACTIONS(1533),
    [anon_sym_interface] = ACTIONS(1533),
    [anon_sym_enum] = ACTIONS(1533),
    [sym__automatic_semicolon] = ACTIONS(1535),
    [sym__ternary_qmark] = ACTIONS(1535),
  },
  [164] = {
    [sym_identifier] = ACTIONS(1537),
    [anon_sym_export] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(1537),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_namespace] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1541),
    [anon_sym_COMMA] = ACTIONS(1543),
    [anon_sym_RBRACE] = ACTIONS(1541),
    [anon_sym_typeof] = ACTIONS(1537),
    [anon_sym_import] = ACTIONS(1537),
    [anon_sym_from] = ACTIONS(1537),
    [anon_sym_var] = ACTIONS(1537),
    [anon_sym_let] = ACTIONS(1537),
    [anon_sym_const] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1537),
    [anon_sym_else] = ACTIONS(1537),
    [anon_sym_if] = ACTIONS(1537),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_LPAREN] = ACTIONS(1541),
    [anon_sym_await] = ACTIONS(1537),
    [anon_sym_in] = ACTIONS(1539),
    [anon_sym_of] = ACTIONS(1537),
    [anon_sym_while] = ACTIONS(1537),
    [anon_sym_do] = ACTIONS(1537),
    [anon_sym_try] = ACTIONS(1537),
    [anon_sym_with] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_continue] = ACTIONS(1537),
    [anon_sym_debugger] = ACTIONS(1537),
    [anon_sym_return] = ACTIONS(1537),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_SEMI] = ACTIONS(1541),
    [anon_sym_case] = ACTIONS(1537),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [anon_sym_LTtemplate_GT] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1537),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1537),
    [anon_sym_DOT] = ACTIONS(1539),
    [anon_sym_class] = ACTIONS(1537),
    [anon_sym_async] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1537),
    [anon_sym_QMARK_DOT] = ACTIONS(1543),
    [anon_sym_new] = ACTIONS(1537),
    [anon_sym_AMP_AMP] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE] = ACTIONS(1543),
    [anon_sym_GT_GT] = ACTIONS(1539),
    [anon_sym_GT_GT_GT] = ACTIONS(1543),
    [anon_sym_LT_LT] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_CARET] = ACTIONS(1543),
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_PERCENT] = ACTIONS(1543),
    [anon_sym_STAR_STAR] = ACTIONS(1543),
    [anon_sym_LT_EQ] = ACTIONS(1543),
    [anon_sym_EQ_EQ] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1543),
    [anon_sym_BANG_EQ] = ACTIONS(1539),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1543),
    [anon_sym_GT_EQ] = ACTIONS(1543),
    [anon_sym_QMARK_QMARK] = ACTIONS(1543),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_TILDE] = ACTIONS(1541),
    [anon_sym_void] = ACTIONS(1537),
    [anon_sym_delete] = ACTIONS(1537),
    [anon_sym_PLUS_PLUS] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1541),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [anon_sym_SQUOTE] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1541),
    [sym_number] = ACTIONS(1541),
    [sym_this] = ACTIONS(1537),
    [sym_super] = ACTIONS(1537),
    [sym_true] = ACTIONS(1537),
    [sym_false] = ACTIONS(1537),
    [sym_null] = ACTIONS(1537),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(1541),
    [anon_sym_static] = ACTIONS(1537),
    [anon_sym_readonly] = ACTIONS(1537),
    [anon_sym_get] = ACTIONS(1537),
    [anon_sym_set] = ACTIONS(1537),
    [anon_sym_declare] = ACTIONS(1537),
    [anon_sym_public] = ACTIONS(1537),
    [anon_sym_private] = ACTIONS(1537),
    [anon_sym_protected] = ACTIONS(1537),
    [anon_sym_override] = ACTIONS(1537),
    [anon_sym_module] = ACTIONS(1537),
    [anon_sym_any] = ACTIONS(1537),
    [anon_sym_number] = ACTIONS(1537),
    [anon_sym_boolean] = ACTIONS(1537),
    [anon_sym_string] = ACTIONS(1537),
    [anon_sym_symbol] = ACTIONS(1537),
    [anon_sym_property] = ACTIONS(1537),
    [anon_sym_signal] = ACTIONS(1537),
    [anon_sym_on] = ACTIONS(1537),
    [anon_sym_required] = ACTIONS(1537),
    [anon_sym_component] = ACTIONS(1537),
    [anon_sym_abstract] = ACTIONS(1537),
    [anon_sym_interface] = ACTIONS(1537),
    [anon_sym_enum] = ACTIONS(1537),
    [sym__automatic_semicolon] = ACTIONS(1545),
    [sym__ternary_qmark] = ACTIONS(1543),
  },
  [165] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [166] = {
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_STAR] = ACTIONS(1549),
    [anon_sym_default] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_as] = ACTIONS(1549),
    [anon_sym_namespace] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1551),
    [anon_sym_COMMA] = ACTIONS(1553),
    [anon_sym_RBRACE] = ACTIONS(1551),
    [anon_sym_typeof] = ACTIONS(1547),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_from] = ACTIONS(1547),
    [anon_sym_var] = ACTIONS(1547),
    [anon_sym_let] = ACTIONS(1547),
    [anon_sym_const] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1547),
    [anon_sym_else] = ACTIONS(1547),
    [anon_sym_if] = ACTIONS(1547),
    [anon_sym_switch] = ACTIONS(1547),
    [anon_sym_for] = ACTIONS(1547),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_await] = ACTIONS(1547),
    [anon_sym_in] = ACTIONS(1549),
    [anon_sym_of] = ACTIONS(1547),
    [anon_sym_while] = ACTIONS(1547),
    [anon_sym_do] = ACTIONS(1547),
    [anon_sym_try] = ACTIONS(1547),
    [anon_sym_with] = ACTIONS(1547),
    [anon_sym_break] = ACTIONS(1547),
    [anon_sym_continue] = ACTIONS(1547),
    [anon_sym_debugger] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1547),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym_case] = ACTIONS(1547),
    [anon_sym_yield] = ACTIONS(1547),
    [anon_sym_LBRACK] = ACTIONS(1551),
    [anon_sym_LTtemplate_GT] = ACTIONS(1551),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_GT] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1547),
    [anon_sym_DOT] = ACTIONS(1549),
    [anon_sym_class] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_QMARK_DOT] = ACTIONS(1553),
    [anon_sym_new] = ACTIONS(1547),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_GT_GT] = ACTIONS(1549),
    [anon_sym_GT_GT_GT] = ACTIONS(1553),
    [anon_sym_LT_LT] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1549),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1549),
    [anon_sym_PLUS] = ACTIONS(1547),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_PERCENT] = ACTIONS(1553),
    [anon_sym_STAR_STAR] = ACTIONS(1553),
    [anon_sym_LT_EQ] = ACTIONS(1553),
    [anon_sym_EQ_EQ] = ACTIONS(1549),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1553),
    [anon_sym_BANG_EQ] = ACTIONS(1549),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1553),
    [anon_sym_GT_EQ] = ACTIONS(1553),
    [anon_sym_QMARK_QMARK] = ACTIONS(1553),
    [anon_sym_instanceof] = ACTIONS(1549),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_void] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(1547),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1551),
    [sym_number] = ACTIONS(1551),
    [sym_this] = ACTIONS(1547),
    [sym_super] = ACTIONS(1547),
    [sym_true] = ACTIONS(1547),
    [sym_false] = ACTIONS(1547),
    [sym_null] = ACTIONS(1547),
    [sym_undefined] = ACTIONS(1547),
    [anon_sym_AT] = ACTIONS(1551),
    [anon_sym_static] = ACTIONS(1547),
    [anon_sym_readonly] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_override] = ACTIONS(1547),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_property] = ACTIONS(1547),
    [anon_sym_signal] = ACTIONS(1547),
    [anon_sym_on] = ACTIONS(1547),
    [anon_sym_required] = ACTIONS(1547),
    [anon_sym_component] = ACTIONS(1547),
    [anon_sym_abstract] = ACTIONS(1547),
    [anon_sym_interface] = ACTIONS(1547),
    [anon_sym_enum] = ACTIONS(1547),
    [sym__automatic_semicolon] = ACTIONS(1555),
    [sym__ternary_qmark] = ACTIONS(1553),
  },
  [167] = {
    [sym_identifier] = ACTIONS(1557),
    [anon_sym_export] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1559),
    [anon_sym_default] = ACTIONS(1557),
    [anon_sym_type] = ACTIONS(1557),
    [anon_sym_as] = ACTIONS(1559),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1561),
    [anon_sym_COMMA] = ACTIONS(1563),
    [anon_sym_RBRACE] = ACTIONS(1561),
    [anon_sym_typeof] = ACTIONS(1557),
    [anon_sym_import] = ACTIONS(1557),
    [anon_sym_from] = ACTIONS(1557),
    [anon_sym_var] = ACTIONS(1557),
    [anon_sym_let] = ACTIONS(1557),
    [anon_sym_const] = ACTIONS(1557),
    [anon_sym_BANG] = ACTIONS(1557),
    [anon_sym_else] = ACTIONS(1557),
    [anon_sym_if] = ACTIONS(1557),
    [anon_sym_switch] = ACTIONS(1557),
    [anon_sym_for] = ACTIONS(1557),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_in] = ACTIONS(1559),
    [anon_sym_of] = ACTIONS(1557),
    [anon_sym_while] = ACTIONS(1557),
    [anon_sym_do] = ACTIONS(1557),
    [anon_sym_try] = ACTIONS(1557),
    [anon_sym_with] = ACTIONS(1557),
    [anon_sym_break] = ACTIONS(1557),
    [anon_sym_continue] = ACTIONS(1557),
    [anon_sym_debugger] = ACTIONS(1557),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_throw] = ACTIONS(1557),
    [anon_sym_SEMI] = ACTIONS(1561),
    [anon_sym_case] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1557),
    [anon_sym_LBRACK] = ACTIONS(1561),
    [anon_sym_LTtemplate_GT] = ACTIONS(1561),
    [anon_sym_LT] = ACTIONS(1557),
    [anon_sym_GT] = ACTIONS(1559),
    [anon_sym_SLASH] = ACTIONS(1557),
    [anon_sym_DOT] = ACTIONS(1559),
    [anon_sym_class] = ACTIONS(1557),
    [anon_sym_async] = ACTIONS(1557),
    [anon_sym_function] = ACTIONS(1557),
    [anon_sym_QMARK_DOT] = ACTIONS(1563),
    [anon_sym_new] = ACTIONS(1557),
    [anon_sym_AMP_AMP] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE] = ACTIONS(1563),
    [anon_sym_GT_GT] = ACTIONS(1559),
    [anon_sym_GT_GT_GT] = ACTIONS(1563),
    [anon_sym_LT_LT] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_PIPE] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_PERCENT] = ACTIONS(1563),
    [anon_sym_STAR_STAR] = ACTIONS(1563),
    [anon_sym_LT_EQ] = ACTIONS(1563),
    [anon_sym_EQ_EQ] = ACTIONS(1559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1563),
    [anon_sym_BANG_EQ] = ACTIONS(1559),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1563),
    [anon_sym_GT_EQ] = ACTIONS(1563),
    [anon_sym_QMARK_QMARK] = ACTIONS(1563),
    [anon_sym_instanceof] = ACTIONS(1559),
    [anon_sym_TILDE] = ACTIONS(1561),
    [anon_sym_void] = ACTIONS(1557),
    [anon_sym_delete] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1561),
    [anon_sym_DASH_DASH] = ACTIONS(1561),
    [anon_sym_DQUOTE] = ACTIONS(1561),
    [anon_sym_SQUOTE] = ACTIONS(1561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1561),
    [sym_number] = ACTIONS(1561),
    [sym_this] = ACTIONS(1557),
    [sym_super] = ACTIONS(1557),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [sym_null] = ACTIONS(1557),
    [sym_undefined] = ACTIONS(1557),
    [anon_sym_AT] = ACTIONS(1561),
    [anon_sym_static] = ACTIONS(1557),
    [anon_sym_readonly] = ACTIONS(1557),
    [anon_sym_get] = ACTIONS(1557),
    [anon_sym_set] = ACTIONS(1557),
    [anon_sym_declare] = ACTIONS(1557),
    [anon_sym_public] = ACTIONS(1557),
    [anon_sym_private] = ACTIONS(1557),
    [anon_sym_protected] = ACTIONS(1557),
    [anon_sym_override] = ACTIONS(1557),
    [anon_sym_module] = ACTIONS(1557),
    [anon_sym_any] = ACTIONS(1557),
    [anon_sym_number] = ACTIONS(1557),
    [anon_sym_boolean] = ACTIONS(1557),
    [anon_sym_string] = ACTIONS(1557),
    [anon_sym_symbol] = ACTIONS(1557),
    [anon_sym_property] = ACTIONS(1557),
    [anon_sym_signal] = ACTIONS(1557),
    [anon_sym_on] = ACTIONS(1557),
    [anon_sym_required] = ACTIONS(1557),
    [anon_sym_component] = ACTIONS(1557),
    [anon_sym_abstract] = ACTIONS(1557),
    [anon_sym_interface] = ACTIONS(1557),
    [anon_sym_enum] = ACTIONS(1557),
    [sym__automatic_semicolon] = ACTIONS(1565),
    [sym__ternary_qmark] = ACTIONS(1563),
  },
  [168] = {
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_export] = ACTIONS(1567),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_default] = ACTIONS(1567),
    [anon_sym_type] = ACTIONS(1567),
    [anon_sym_as] = ACTIONS(1569),
    [anon_sym_namespace] = ACTIONS(1567),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_COMMA] = ACTIONS(1573),
    [anon_sym_RBRACE] = ACTIONS(1571),
    [anon_sym_typeof] = ACTIONS(1567),
    [anon_sym_import] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(1567),
    [anon_sym_var] = ACTIONS(1567),
    [anon_sym_let] = ACTIONS(1567),
    [anon_sym_const] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1567),
    [anon_sym_else] = ACTIONS(1567),
    [anon_sym_if] = ACTIONS(1567),
    [anon_sym_switch] = ACTIONS(1567),
    [anon_sym_for] = ACTIONS(1567),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_in] = ACTIONS(1569),
    [anon_sym_of] = ACTIONS(1567),
    [anon_sym_while] = ACTIONS(1567),
    [anon_sym_do] = ACTIONS(1567),
    [anon_sym_try] = ACTIONS(1567),
    [anon_sym_with] = ACTIONS(1567),
    [anon_sym_break] = ACTIONS(1567),
    [anon_sym_continue] = ACTIONS(1567),
    [anon_sym_debugger] = ACTIONS(1567),
    [anon_sym_return] = ACTIONS(1567),
    [anon_sym_throw] = ACTIONS(1567),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_case] = ACTIONS(1567),
    [anon_sym_yield] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(1571),
    [anon_sym_LTtemplate_GT] = ACTIONS(1571),
    [anon_sym_LT] = ACTIONS(1567),
    [anon_sym_GT] = ACTIONS(1569),
    [anon_sym_SLASH] = ACTIONS(1567),
    [anon_sym_DOT] = ACTIONS(1569),
    [anon_sym_class] = ACTIONS(1567),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_function] = ACTIONS(1567),
    [anon_sym_QMARK_DOT] = ACTIONS(1573),
    [anon_sym_new] = ACTIONS(1567),
    [anon_sym_AMP_AMP] = ACTIONS(1573),
    [anon_sym_PIPE_PIPE] = ACTIONS(1573),
    [anon_sym_GT_GT] = ACTIONS(1569),
    [anon_sym_GT_GT_GT] = ACTIONS(1573),
    [anon_sym_LT_LT] = ACTIONS(1573),
    [anon_sym_AMP] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_PERCENT] = ACTIONS(1573),
    [anon_sym_STAR_STAR] = ACTIONS(1573),
    [anon_sym_LT_EQ] = ACTIONS(1573),
    [anon_sym_EQ_EQ] = ACTIONS(1569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1573),
    [anon_sym_BANG_EQ] = ACTIONS(1569),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1573),
    [anon_sym_GT_EQ] = ACTIONS(1573),
    [anon_sym_QMARK_QMARK] = ACTIONS(1573),
    [anon_sym_instanceof] = ACTIONS(1569),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_void] = ACTIONS(1567),
    [anon_sym_delete] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_DQUOTE] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1571),
    [sym_number] = ACTIONS(1571),
    [sym_this] = ACTIONS(1567),
    [sym_super] = ACTIONS(1567),
    [sym_true] = ACTIONS(1567),
    [sym_false] = ACTIONS(1567),
    [sym_null] = ACTIONS(1567),
    [sym_undefined] = ACTIONS(1567),
    [anon_sym_AT] = ACTIONS(1571),
    [anon_sym_static] = ACTIONS(1567),
    [anon_sym_readonly] = ACTIONS(1567),
    [anon_sym_get] = ACTIONS(1567),
    [anon_sym_set] = ACTIONS(1567),
    [anon_sym_declare] = ACTIONS(1567),
    [anon_sym_public] = ACTIONS(1567),
    [anon_sym_private] = ACTIONS(1567),
    [anon_sym_protected] = ACTIONS(1567),
    [anon_sym_override] = ACTIONS(1567),
    [anon_sym_module] = ACTIONS(1567),
    [anon_sym_any] = ACTIONS(1567),
    [anon_sym_number] = ACTIONS(1567),
    [anon_sym_boolean] = ACTIONS(1567),
    [anon_sym_string] = ACTIONS(1567),
    [anon_sym_symbol] = ACTIONS(1567),
    [anon_sym_property] = ACTIONS(1567),
    [anon_sym_signal] = ACTIONS(1567),
    [anon_sym_on] = ACTIONS(1567),
    [anon_sym_required] = ACTIONS(1567),
    [anon_sym_component] = ACTIONS(1567),
    [anon_sym_abstract] = ACTIONS(1567),
    [anon_sym_interface] = ACTIONS(1567),
    [anon_sym_enum] = ACTIONS(1567),
    [sym__automatic_semicolon] = ACTIONS(1573),
    [sym__ternary_qmark] = ACTIONS(1573),
  },
  [169] = {
    [sym_identifier] = ACTIONS(1575),
    [anon_sym_export] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(1577),
    [anon_sym_default] = ACTIONS(1575),
    [anon_sym_type] = ACTIONS(1575),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1575),
    [anon_sym_LBRACE] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(1581),
    [anon_sym_RBRACE] = ACTIONS(1579),
    [anon_sym_typeof] = ACTIONS(1575),
    [anon_sym_import] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(1575),
    [anon_sym_var] = ACTIONS(1575),
    [anon_sym_let] = ACTIONS(1575),
    [anon_sym_const] = ACTIONS(1575),
    [anon_sym_BANG] = ACTIONS(1575),
    [anon_sym_else] = ACTIONS(1575),
    [anon_sym_if] = ACTIONS(1575),
    [anon_sym_switch] = ACTIONS(1575),
    [anon_sym_for] = ACTIONS(1575),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_in] = ACTIONS(1577),
    [anon_sym_of] = ACTIONS(1575),
    [anon_sym_while] = ACTIONS(1575),
    [anon_sym_do] = ACTIONS(1575),
    [anon_sym_try] = ACTIONS(1575),
    [anon_sym_with] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1575),
    [anon_sym_continue] = ACTIONS(1575),
    [anon_sym_debugger] = ACTIONS(1575),
    [anon_sym_return] = ACTIONS(1575),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1579),
    [anon_sym_case] = ACTIONS(1575),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(1579),
    [anon_sym_LTtemplate_GT] = ACTIONS(1579),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1577),
    [anon_sym_SLASH] = ACTIONS(1575),
    [anon_sym_DOT] = ACTIONS(1577),
    [anon_sym_class] = ACTIONS(1575),
    [anon_sym_async] = ACTIONS(1575),
    [anon_sym_function] = ACTIONS(1575),
    [anon_sym_QMARK_DOT] = ACTIONS(1581),
    [anon_sym_new] = ACTIONS(1575),
    [anon_sym_AMP_AMP] = ACTIONS(1581),
    [anon_sym_PIPE_PIPE] = ACTIONS(1581),
    [anon_sym_GT_GT] = ACTIONS(1577),
    [anon_sym_GT_GT_GT] = ACTIONS(1581),
    [anon_sym_LT_LT] = ACTIONS(1581),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1581),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_DASH] = ACTIONS(1575),
    [anon_sym_PERCENT] = ACTIONS(1581),
    [anon_sym_STAR_STAR] = ACTIONS(1581),
    [anon_sym_LT_EQ] = ACTIONS(1581),
    [anon_sym_EQ_EQ] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1581),
    [anon_sym_BANG_EQ] = ACTIONS(1577),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1581),
    [anon_sym_GT_EQ] = ACTIONS(1581),
    [anon_sym_QMARK_QMARK] = ACTIONS(1581),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_TILDE] = ACTIONS(1579),
    [anon_sym_void] = ACTIONS(1575),
    [anon_sym_delete] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1579),
    [anon_sym_DASH_DASH] = ACTIONS(1579),
    [anon_sym_DQUOTE] = ACTIONS(1579),
    [anon_sym_SQUOTE] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1579),
    [sym_number] = ACTIONS(1579),
    [sym_this] = ACTIONS(1575),
    [sym_super] = ACTIONS(1575),
    [sym_true] = ACTIONS(1575),
    [sym_false] = ACTIONS(1575),
    [sym_null] = ACTIONS(1575),
    [sym_undefined] = ACTIONS(1575),
    [anon_sym_AT] = ACTIONS(1579),
    [anon_sym_static] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_get] = ACTIONS(1575),
    [anon_sym_set] = ACTIONS(1575),
    [anon_sym_declare] = ACTIONS(1575),
    [anon_sym_public] = ACTIONS(1575),
    [anon_sym_private] = ACTIONS(1575),
    [anon_sym_protected] = ACTIONS(1575),
    [anon_sym_override] = ACTIONS(1575),
    [anon_sym_module] = ACTIONS(1575),
    [anon_sym_any] = ACTIONS(1575),
    [anon_sym_number] = ACTIONS(1575),
    [anon_sym_boolean] = ACTIONS(1575),
    [anon_sym_string] = ACTIONS(1575),
    [anon_sym_symbol] = ACTIONS(1575),
    [anon_sym_property] = ACTIONS(1575),
    [anon_sym_signal] = ACTIONS(1575),
    [anon_sym_on] = ACTIONS(1575),
    [anon_sym_required] = ACTIONS(1575),
    [anon_sym_component] = ACTIONS(1575),
    [anon_sym_abstract] = ACTIONS(1575),
    [anon_sym_interface] = ACTIONS(1575),
    [anon_sym_enum] = ACTIONS(1575),
    [sym__automatic_semicolon] = ACTIONS(1583),
    [sym__ternary_qmark] = ACTIONS(1581),
  },
  [170] = {
    [sym_identifier] = ACTIONS(1585),
    [anon_sym_export] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1585),
    [anon_sym_default] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(1585),
    [anon_sym_as] = ACTIONS(1585),
    [anon_sym_namespace] = ACTIONS(1585),
    [anon_sym_LBRACE] = ACTIONS(1587),
    [anon_sym_COMMA] = ACTIONS(1587),
    [anon_sym_RBRACE] = ACTIONS(1587),
    [anon_sym_typeof] = ACTIONS(1585),
    [anon_sym_import] = ACTIONS(1585),
    [anon_sym_from] = ACTIONS(1585),
    [anon_sym_var] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(1585),
    [anon_sym_const] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_else] = ACTIONS(1585),
    [anon_sym_if] = ACTIONS(1585),
    [anon_sym_switch] = ACTIONS(1585),
    [anon_sym_for] = ACTIONS(1585),
    [anon_sym_LPAREN] = ACTIONS(1587),
    [anon_sym_await] = ACTIONS(1585),
    [anon_sym_in] = ACTIONS(1585),
    [anon_sym_of] = ACTIONS(1585),
    [anon_sym_while] = ACTIONS(1585),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_try] = ACTIONS(1585),
    [anon_sym_with] = ACTIONS(1585),
    [anon_sym_break] = ACTIONS(1585),
    [anon_sym_continue] = ACTIONS(1585),
    [anon_sym_debugger] = ACTIONS(1585),
    [anon_sym_return] = ACTIONS(1585),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_SEMI] = ACTIONS(1587),
    [anon_sym_case] = ACTIONS(1585),
    [anon_sym_yield] = ACTIONS(1585),
    [anon_sym_LBRACK] = ACTIONS(1587),
    [anon_sym_LTtemplate_GT] = ACTIONS(1587),
    [anon_sym_LT] = ACTIONS(1585),
    [anon_sym_GT] = ACTIONS(1585),
    [anon_sym_SLASH] = ACTIONS(1585),
    [anon_sym_DOT] = ACTIONS(1585),
    [anon_sym_class] = ACTIONS(1585),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_function] = ACTIONS(1585),
    [anon_sym_QMARK_DOT] = ACTIONS(1587),
    [anon_sym_new] = ACTIONS(1585),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1587),
    [anon_sym_GT_GT] = ACTIONS(1585),
    [anon_sym_GT_GT_GT] = ACTIONS(1587),
    [anon_sym_LT_LT] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_PIPE] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_PERCENT] = ACTIONS(1587),
    [anon_sym_STAR_STAR] = ACTIONS(1587),
    [anon_sym_LT_EQ] = ACTIONS(1587),
    [anon_sym_EQ_EQ] = ACTIONS(1585),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1587),
    [anon_sym_BANG_EQ] = ACTIONS(1585),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1587),
    [anon_sym_QMARK_QMARK] = ACTIONS(1587),
    [anon_sym_instanceof] = ACTIONS(1585),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_void] = ACTIONS(1585),
    [anon_sym_delete] = ACTIONS(1585),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_DQUOTE] = ACTIONS(1587),
    [anon_sym_SQUOTE] = ACTIONS(1587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1587),
    [sym_number] = ACTIONS(1587),
    [sym_this] = ACTIONS(1585),
    [sym_super] = ACTIONS(1585),
    [sym_true] = ACTIONS(1585),
    [sym_false] = ACTIONS(1585),
    [sym_null] = ACTIONS(1585),
    [sym_undefined] = ACTIONS(1585),
    [anon_sym_AT] = ACTIONS(1587),
    [anon_sym_static] = ACTIONS(1585),
    [anon_sym_readonly] = ACTIONS(1585),
    [anon_sym_get] = ACTIONS(1585),
    [anon_sym_set] = ACTIONS(1585),
    [anon_sym_declare] = ACTIONS(1585),
    [anon_sym_public] = ACTIONS(1585),
    [anon_sym_private] = ACTIONS(1585),
    [anon_sym_protected] = ACTIONS(1585),
    [anon_sym_override] = ACTIONS(1585),
    [anon_sym_module] = ACTIONS(1585),
    [anon_sym_any] = ACTIONS(1585),
    [anon_sym_number] = ACTIONS(1585),
    [anon_sym_boolean] = ACTIONS(1585),
    [anon_sym_string] = ACTIONS(1585),
    [anon_sym_symbol] = ACTIONS(1585),
    [anon_sym_property] = ACTIONS(1585),
    [anon_sym_signal] = ACTIONS(1585),
    [anon_sym_on] = ACTIONS(1585),
    [anon_sym_required] = ACTIONS(1585),
    [anon_sym_component] = ACTIONS(1585),
    [anon_sym_abstract] = ACTIONS(1585),
    [anon_sym_interface] = ACTIONS(1585),
    [anon_sym_enum] = ACTIONS(1585),
    [sym__automatic_semicolon] = ACTIONS(1587),
    [sym__ternary_qmark] = ACTIONS(1587),
  },
  [171] = {
    [sym_identifier] = ACTIONS(1589),
    [anon_sym_export] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(1591),
    [anon_sym_default] = ACTIONS(1589),
    [anon_sym_type] = ACTIONS(1589),
    [anon_sym_as] = ACTIONS(1591),
    [anon_sym_namespace] = ACTIONS(1589),
    [anon_sym_LBRACE] = ACTIONS(1593),
    [anon_sym_COMMA] = ACTIONS(1595),
    [anon_sym_RBRACE] = ACTIONS(1593),
    [anon_sym_typeof] = ACTIONS(1589),
    [anon_sym_import] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1589),
    [anon_sym_var] = ACTIONS(1589),
    [anon_sym_let] = ACTIONS(1589),
    [anon_sym_const] = ACTIONS(1589),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_else] = ACTIONS(1589),
    [anon_sym_if] = ACTIONS(1589),
    [anon_sym_switch] = ACTIONS(1589),
    [anon_sym_for] = ACTIONS(1589),
    [anon_sym_LPAREN] = ACTIONS(1593),
    [anon_sym_await] = ACTIONS(1589),
    [anon_sym_in] = ACTIONS(1591),
    [anon_sym_of] = ACTIONS(1589),
    [anon_sym_while] = ACTIONS(1589),
    [anon_sym_do] = ACTIONS(1589),
    [anon_sym_try] = ACTIONS(1589),
    [anon_sym_with] = ACTIONS(1589),
    [anon_sym_break] = ACTIONS(1589),
    [anon_sym_continue] = ACTIONS(1589),
    [anon_sym_debugger] = ACTIONS(1589),
    [anon_sym_return] = ACTIONS(1589),
    [anon_sym_throw] = ACTIONS(1589),
    [anon_sym_SEMI] = ACTIONS(1593),
    [anon_sym_case] = ACTIONS(1589),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(1593),
    [anon_sym_LTtemplate_GT] = ACTIONS(1593),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_GT] = ACTIONS(1591),
    [anon_sym_SLASH] = ACTIONS(1589),
    [anon_sym_DOT] = ACTIONS(1591),
    [anon_sym_class] = ACTIONS(1589),
    [anon_sym_async] = ACTIONS(1589),
    [anon_sym_function] = ACTIONS(1589),
    [anon_sym_QMARK_DOT] = ACTIONS(1595),
    [anon_sym_new] = ACTIONS(1589),
    [anon_sym_AMP_AMP] = ACTIONS(1595),
    [anon_sym_PIPE_PIPE] = ACTIONS(1595),
    [anon_sym_GT_GT] = ACTIONS(1591),
    [anon_sym_GT_GT_GT] = ACTIONS(1595),
    [anon_sym_LT_LT] = ACTIONS(1595),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1595),
    [anon_sym_PIPE] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(1589),
    [anon_sym_DASH] = ACTIONS(1589),
    [anon_sym_PERCENT] = ACTIONS(1595),
    [anon_sym_STAR_STAR] = ACTIONS(1595),
    [anon_sym_LT_EQ] = ACTIONS(1595),
    [anon_sym_EQ_EQ] = ACTIONS(1591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1595),
    [anon_sym_BANG_EQ] = ACTIONS(1591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1595),
    [anon_sym_GT_EQ] = ACTIONS(1595),
    [anon_sym_QMARK_QMARK] = ACTIONS(1595),
    [anon_sym_instanceof] = ACTIONS(1591),
    [anon_sym_TILDE] = ACTIONS(1593),
    [anon_sym_void] = ACTIONS(1589),
    [anon_sym_delete] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1593),
    [anon_sym_DASH_DASH] = ACTIONS(1593),
    [anon_sym_DQUOTE] = ACTIONS(1593),
    [anon_sym_SQUOTE] = ACTIONS(1593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1593),
    [sym_number] = ACTIONS(1593),
    [sym_this] = ACTIONS(1589),
    [sym_super] = ACTIONS(1589),
    [sym_true] = ACTIONS(1589),
    [sym_false] = ACTIONS(1589),
    [sym_null] = ACTIONS(1589),
    [sym_undefined] = ACTIONS(1589),
    [anon_sym_AT] = ACTIONS(1593),
    [anon_sym_static] = ACTIONS(1589),
    [anon_sym_readonly] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(1589),
    [anon_sym_set] = ACTIONS(1589),
    [anon_sym_declare] = ACTIONS(1589),
    [anon_sym_public] = ACTIONS(1589),
    [anon_sym_private] = ACTIONS(1589),
    [anon_sym_protected] = ACTIONS(1589),
    [anon_sym_override] = ACTIONS(1589),
    [anon_sym_module] = ACTIONS(1589),
    [anon_sym_any] = ACTIONS(1589),
    [anon_sym_number] = ACTIONS(1589),
    [anon_sym_boolean] = ACTIONS(1589),
    [anon_sym_string] = ACTIONS(1589),
    [anon_sym_symbol] = ACTIONS(1589),
    [anon_sym_property] = ACTIONS(1589),
    [anon_sym_signal] = ACTIONS(1589),
    [anon_sym_on] = ACTIONS(1589),
    [anon_sym_required] = ACTIONS(1589),
    [anon_sym_component] = ACTIONS(1589),
    [anon_sym_abstract] = ACTIONS(1589),
    [anon_sym_interface] = ACTIONS(1589),
    [anon_sym_enum] = ACTIONS(1589),
    [sym__automatic_semicolon] = ACTIONS(1597),
    [sym__ternary_qmark] = ACTIONS(1595),
  },
  [172] = {
    [sym_identifier] = ACTIONS(1599),
    [anon_sym_export] = ACTIONS(1599),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_default] = ACTIONS(1599),
    [anon_sym_type] = ACTIONS(1599),
    [anon_sym_as] = ACTIONS(1601),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1603),
    [anon_sym_COMMA] = ACTIONS(1605),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_typeof] = ACTIONS(1599),
    [anon_sym_import] = ACTIONS(1599),
    [anon_sym_from] = ACTIONS(1599),
    [anon_sym_var] = ACTIONS(1599),
    [anon_sym_let] = ACTIONS(1599),
    [anon_sym_const] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1599),
    [anon_sym_else] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(1599),
    [anon_sym_switch] = ACTIONS(1599),
    [anon_sym_for] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(1603),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_in] = ACTIONS(1601),
    [anon_sym_of] = ACTIONS(1599),
    [anon_sym_while] = ACTIONS(1599),
    [anon_sym_do] = ACTIONS(1599),
    [anon_sym_try] = ACTIONS(1599),
    [anon_sym_with] = ACTIONS(1599),
    [anon_sym_break] = ACTIONS(1599),
    [anon_sym_continue] = ACTIONS(1599),
    [anon_sym_debugger] = ACTIONS(1599),
    [anon_sym_return] = ACTIONS(1599),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1603),
    [anon_sym_case] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1603),
    [anon_sym_LTtemplate_GT] = ACTIONS(1603),
    [anon_sym_LT] = ACTIONS(1599),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1599),
    [anon_sym_DOT] = ACTIONS(1601),
    [anon_sym_class] = ACTIONS(1599),
    [anon_sym_async] = ACTIONS(1599),
    [anon_sym_function] = ACTIONS(1599),
    [anon_sym_QMARK_DOT] = ACTIONS(1605),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_AMP_AMP] = ACTIONS(1605),
    [anon_sym_PIPE_PIPE] = ACTIONS(1605),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1605),
    [anon_sym_LT_LT] = ACTIONS(1605),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_CARET] = ACTIONS(1605),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1599),
    [anon_sym_PERCENT] = ACTIONS(1605),
    [anon_sym_STAR_STAR] = ACTIONS(1605),
    [anon_sym_LT_EQ] = ACTIONS(1605),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1605),
    [anon_sym_GT_EQ] = ACTIONS(1605),
    [anon_sym_QMARK_QMARK] = ACTIONS(1605),
    [anon_sym_instanceof] = ACTIONS(1601),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_void] = ACTIONS(1599),
    [anon_sym_delete] = ACTIONS(1599),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_DQUOTE] = ACTIONS(1603),
    [anon_sym_SQUOTE] = ACTIONS(1603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1603),
    [sym_number] = ACTIONS(1603),
    [sym_this] = ACTIONS(1599),
    [sym_super] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_null] = ACTIONS(1599),
    [sym_undefined] = ACTIONS(1599),
    [anon_sym_AT] = ACTIONS(1603),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_readonly] = ACTIONS(1599),
    [anon_sym_get] = ACTIONS(1599),
    [anon_sym_set] = ACTIONS(1599),
    [anon_sym_declare] = ACTIONS(1599),
    [anon_sym_public] = ACTIONS(1599),
    [anon_sym_private] = ACTIONS(1599),
    [anon_sym_protected] = ACTIONS(1599),
    [anon_sym_override] = ACTIONS(1599),
    [anon_sym_module] = ACTIONS(1599),
    [anon_sym_any] = ACTIONS(1599),
    [anon_sym_number] = ACTIONS(1599),
    [anon_sym_boolean] = ACTIONS(1599),
    [anon_sym_string] = ACTIONS(1599),
    [anon_sym_symbol] = ACTIONS(1599),
    [anon_sym_property] = ACTIONS(1599),
    [anon_sym_signal] = ACTIONS(1599),
    [anon_sym_on] = ACTIONS(1599),
    [anon_sym_required] = ACTIONS(1599),
    [anon_sym_component] = ACTIONS(1599),
    [anon_sym_abstract] = ACTIONS(1599),
    [anon_sym_interface] = ACTIONS(1599),
    [anon_sym_enum] = ACTIONS(1599),
    [sym__automatic_semicolon] = ACTIONS(1607),
    [sym__ternary_qmark] = ACTIONS(1605),
  },
  [173] = {
    [sym_identifier] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1609),
    [anon_sym_default] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1611),
    [anon_sym_RBRACE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_from] = ACTIONS(1609),
    [anon_sym_var] = ACTIONS(1609),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1609),
    [anon_sym_else] = ACTIONS(1609),
    [anon_sym_if] = ACTIONS(1609),
    [anon_sym_switch] = ACTIONS(1609),
    [anon_sym_for] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1611),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_in] = ACTIONS(1609),
    [anon_sym_of] = ACTIONS(1609),
    [anon_sym_while] = ACTIONS(1609),
    [anon_sym_do] = ACTIONS(1609),
    [anon_sym_try] = ACTIONS(1609),
    [anon_sym_with] = ACTIONS(1609),
    [anon_sym_break] = ACTIONS(1609),
    [anon_sym_continue] = ACTIONS(1609),
    [anon_sym_debugger] = ACTIONS(1609),
    [anon_sym_return] = ACTIONS(1609),
    [anon_sym_throw] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1611),
    [anon_sym_case] = ACTIONS(1609),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1611),
    [anon_sym_LTtemplate_GT] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1609),
    [anon_sym_DOT] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(1609),
    [anon_sym_QMARK_DOT] = ACTIONS(1611),
    [anon_sym_new] = ACTIONS(1609),
    [anon_sym_AMP_AMP] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1611),
    [anon_sym_GT_GT] = ACTIONS(1609),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP] = ACTIONS(1609),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PIPE] = ACTIONS(1609),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1611),
    [anon_sym_EQ_EQ] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1611),
    [anon_sym_BANG_EQ] = ACTIONS(1609),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1611),
    [anon_sym_QMARK_QMARK] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1611),
    [sym_number] = ACTIONS(1611),
    [sym_this] = ACTIONS(1609),
    [sym_super] = ACTIONS(1609),
    [sym_true] = ACTIONS(1609),
    [sym_false] = ACTIONS(1609),
    [sym_null] = ACTIONS(1609),
    [sym_undefined] = ACTIONS(1609),
    [anon_sym_AT] = ACTIONS(1611),
    [anon_sym_static] = ACTIONS(1609),
    [anon_sym_readonly] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_override] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_property] = ACTIONS(1609),
    [anon_sym_signal] = ACTIONS(1609),
    [anon_sym_on] = ACTIONS(1609),
    [anon_sym_required] = ACTIONS(1609),
    [anon_sym_component] = ACTIONS(1609),
    [anon_sym_abstract] = ACTIONS(1609),
    [anon_sym_interface] = ACTIONS(1609),
    [anon_sym_enum] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1611),
    [sym__ternary_qmark] = ACTIONS(1611),
  },
  [174] = {
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_export] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(1615),
    [anon_sym_default] = ACTIONS(1613),
    [anon_sym_type] = ACTIONS(1613),
    [anon_sym_as] = ACTIONS(1615),
    [anon_sym_namespace] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_COMMA] = ACTIONS(1619),
    [anon_sym_RBRACE] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(1613),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_from] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1613),
    [anon_sym_let] = ACTIONS(1613),
    [anon_sym_const] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1613),
    [anon_sym_else] = ACTIONS(1613),
    [anon_sym_if] = ACTIONS(1613),
    [anon_sym_switch] = ACTIONS(1613),
    [anon_sym_for] = ACTIONS(1613),
    [anon_sym_LPAREN] = ACTIONS(1617),
    [anon_sym_await] = ACTIONS(1613),
    [anon_sym_in] = ACTIONS(1615),
    [anon_sym_of] = ACTIONS(1613),
    [anon_sym_while] = ACTIONS(1613),
    [anon_sym_do] = ACTIONS(1613),
    [anon_sym_try] = ACTIONS(1613),
    [anon_sym_with] = ACTIONS(1613),
    [anon_sym_break] = ACTIONS(1613),
    [anon_sym_continue] = ACTIONS(1613),
    [anon_sym_debugger] = ACTIONS(1613),
    [anon_sym_return] = ACTIONS(1613),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(1617),
    [anon_sym_case] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(1613),
    [anon_sym_LBRACK] = ACTIONS(1617),
    [anon_sym_LTtemplate_GT] = ACTIONS(1617),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_GT] = ACTIONS(1615),
    [anon_sym_SLASH] = ACTIONS(1613),
    [anon_sym_DOT] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(1613),
    [anon_sym_QMARK_DOT] = ACTIONS(1619),
    [anon_sym_new] = ACTIONS(1613),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE_PIPE] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(1615),
    [anon_sym_GT_GT_GT] = ACTIONS(1619),
    [anon_sym_LT_LT] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1615),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_PERCENT] = ACTIONS(1619),
    [anon_sym_STAR_STAR] = ACTIONS(1619),
    [anon_sym_LT_EQ] = ACTIONS(1619),
    [anon_sym_EQ_EQ] = ACTIONS(1615),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1615),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(1619),
    [anon_sym_QMARK_QMARK] = ACTIONS(1619),
    [anon_sym_instanceof] = ACTIONS(1615),
    [anon_sym_TILDE] = ACTIONS(1617),
    [anon_sym_void] = ACTIONS(1613),
    [anon_sym_delete] = ACTIONS(1613),
    [anon_sym_PLUS_PLUS] = ACTIONS(1617),
    [anon_sym_DASH_DASH] = ACTIONS(1617),
    [anon_sym_DQUOTE] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1617),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1613),
    [sym_super] = ACTIONS(1613),
    [sym_true] = ACTIONS(1613),
    [sym_false] = ACTIONS(1613),
    [sym_null] = ACTIONS(1613),
    [sym_undefined] = ACTIONS(1613),
    [anon_sym_AT] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1613),
    [anon_sym_readonly] = ACTIONS(1613),
    [anon_sym_get] = ACTIONS(1613),
    [anon_sym_set] = ACTIONS(1613),
    [anon_sym_declare] = ACTIONS(1613),
    [anon_sym_public] = ACTIONS(1613),
    [anon_sym_private] = ACTIONS(1613),
    [anon_sym_protected] = ACTIONS(1613),
    [anon_sym_override] = ACTIONS(1613),
    [anon_sym_module] = ACTIONS(1613),
    [anon_sym_any] = ACTIONS(1613),
    [anon_sym_number] = ACTIONS(1613),
    [anon_sym_boolean] = ACTIONS(1613),
    [anon_sym_string] = ACTIONS(1613),
    [anon_sym_symbol] = ACTIONS(1613),
    [anon_sym_property] = ACTIONS(1613),
    [anon_sym_signal] = ACTIONS(1613),
    [anon_sym_on] = ACTIONS(1613),
    [anon_sym_required] = ACTIONS(1613),
    [anon_sym_component] = ACTIONS(1613),
    [anon_sym_abstract] = ACTIONS(1613),
    [anon_sym_interface] = ACTIONS(1613),
    [anon_sym_enum] = ACTIONS(1613),
    [sym__automatic_semicolon] = ACTIONS(1621),
    [sym__ternary_qmark] = ACTIONS(1619),
  },
  [175] = {
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(1623),
    [anon_sym_default] = ACTIONS(1623),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_as] = ACTIONS(1623),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_typeof] = ACTIONS(1623),
    [anon_sym_import] = ACTIONS(1623),
    [anon_sym_from] = ACTIONS(1623),
    [anon_sym_var] = ACTIONS(1623),
    [anon_sym_let] = ACTIONS(1623),
    [anon_sym_const] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_else] = ACTIONS(1623),
    [anon_sym_if] = ACTIONS(1623),
    [anon_sym_switch] = ACTIONS(1623),
    [anon_sym_for] = ACTIONS(1623),
    [anon_sym_LPAREN] = ACTIONS(1625),
    [anon_sym_await] = ACTIONS(1623),
    [anon_sym_in] = ACTIONS(1623),
    [anon_sym_of] = ACTIONS(1623),
    [anon_sym_while] = ACTIONS(1623),
    [anon_sym_do] = ACTIONS(1623),
    [anon_sym_try] = ACTIONS(1623),
    [anon_sym_with] = ACTIONS(1623),
    [anon_sym_break] = ACTIONS(1623),
    [anon_sym_continue] = ACTIONS(1623),
    [anon_sym_debugger] = ACTIONS(1623),
    [anon_sym_return] = ACTIONS(1623),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_case] = ACTIONS(1623),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_LTtemplate_GT] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1623),
    [anon_sym_GT] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1623),
    [anon_sym_DOT] = ACTIONS(1623),
    [anon_sym_class] = ACTIONS(1623),
    [anon_sym_async] = ACTIONS(1623),
    [anon_sym_function] = ACTIONS(1623),
    [anon_sym_QMARK_DOT] = ACTIONS(1625),
    [anon_sym_new] = ACTIONS(1623),
    [anon_sym_AMP_AMP] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(1625),
    [anon_sym_GT_GT] = ACTIONS(1623),
    [anon_sym_GT_GT_GT] = ACTIONS(1625),
    [anon_sym_LT_LT] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1623),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1623),
    [anon_sym_DASH] = ACTIONS(1623),
    [anon_sym_PERCENT] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(1625),
    [anon_sym_LT_EQ] = ACTIONS(1625),
    [anon_sym_EQ_EQ] = ACTIONS(1623),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1623),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1625),
    [anon_sym_GT_EQ] = ACTIONS(1625),
    [anon_sym_QMARK_QMARK] = ACTIONS(1625),
    [anon_sym_instanceof] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_void] = ACTIONS(1623),
    [anon_sym_delete] = ACTIONS(1623),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [anon_sym_SQUOTE] = ACTIONS(1625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [sym_number] = ACTIONS(1625),
    [sym_this] = ACTIONS(1623),
    [sym_super] = ACTIONS(1623),
    [sym_true] = ACTIONS(1623),
    [sym_false] = ACTIONS(1623),
    [sym_null] = ACTIONS(1623),
    [sym_undefined] = ACTIONS(1623),
    [anon_sym_AT] = ACTIONS(1625),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_readonly] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1623),
    [anon_sym_set] = ACTIONS(1623),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_override] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [anon_sym_property] = ACTIONS(1623),
    [anon_sym_signal] = ACTIONS(1623),
    [anon_sym_on] = ACTIONS(1623),
    [anon_sym_required] = ACTIONS(1623),
    [anon_sym_component] = ACTIONS(1623),
    [anon_sym_abstract] = ACTIONS(1623),
    [anon_sym_interface] = ACTIONS(1623),
    [anon_sym_enum] = ACTIONS(1623),
    [sym__automatic_semicolon] = ACTIONS(1625),
    [sym__ternary_qmark] = ACTIONS(1625),
  },
  [176] = {
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1627),
    [anon_sym_default] = ACTIONS(1627),
    [anon_sym_type] = ACTIONS(1627),
    [anon_sym_as] = ACTIONS(1627),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(1629),
    [anon_sym_COMMA] = ACTIONS(1629),
    [anon_sym_RBRACE] = ACTIONS(1629),
    [anon_sym_typeof] = ACTIONS(1627),
    [anon_sym_import] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(1627),
    [anon_sym_var] = ACTIONS(1627),
    [anon_sym_let] = ACTIONS(1627),
    [anon_sym_const] = ACTIONS(1627),
    [anon_sym_BANG] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_switch] = ACTIONS(1627),
    [anon_sym_for] = ACTIONS(1627),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_await] = ACTIONS(1627),
    [anon_sym_in] = ACTIONS(1627),
    [anon_sym_of] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_try] = ACTIONS(1627),
    [anon_sym_with] = ACTIONS(1627),
    [anon_sym_break] = ACTIONS(1627),
    [anon_sym_continue] = ACTIONS(1627),
    [anon_sym_debugger] = ACTIONS(1627),
    [anon_sym_return] = ACTIONS(1627),
    [anon_sym_throw] = ACTIONS(1627),
    [anon_sym_SEMI] = ACTIONS(1629),
    [anon_sym_case] = ACTIONS(1627),
    [anon_sym_yield] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1629),
    [anon_sym_LTtemplate_GT] = ACTIONS(1629),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1627),
    [anon_sym_class] = ACTIONS(1627),
    [anon_sym_async] = ACTIONS(1627),
    [anon_sym_function] = ACTIONS(1627),
    [anon_sym_QMARK_DOT] = ACTIONS(1629),
    [anon_sym_new] = ACTIONS(1627),
    [anon_sym_AMP_AMP] = ACTIONS(1629),
    [anon_sym_PIPE_PIPE] = ACTIONS(1629),
    [anon_sym_GT_GT] = ACTIONS(1627),
    [anon_sym_GT_GT_GT] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1627),
    [anon_sym_CARET] = ACTIONS(1629),
    [anon_sym_PIPE] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_EQ_EQ] = ACTIONS(1627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1629),
    [anon_sym_BANG_EQ] = ACTIONS(1627),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_QMARK_QMARK] = ACTIONS(1629),
    [anon_sym_instanceof] = ACTIONS(1627),
    [anon_sym_TILDE] = ACTIONS(1629),
    [anon_sym_void] = ACTIONS(1627),
    [anon_sym_delete] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1629),
    [anon_sym_DASH_DASH] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(1629),
    [anon_sym_SQUOTE] = ACTIONS(1629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1629),
    [sym_number] = ACTIONS(1629),
    [sym_this] = ACTIONS(1627),
    [sym_super] = ACTIONS(1627),
    [sym_true] = ACTIONS(1627),
    [sym_false] = ACTIONS(1627),
    [sym_null] = ACTIONS(1627),
    [sym_undefined] = ACTIONS(1627),
    [anon_sym_AT] = ACTIONS(1629),
    [anon_sym_static] = ACTIONS(1627),
    [anon_sym_readonly] = ACTIONS(1627),
    [anon_sym_get] = ACTIONS(1627),
    [anon_sym_set] = ACTIONS(1627),
    [anon_sym_declare] = ACTIONS(1627),
    [anon_sym_public] = ACTIONS(1627),
    [anon_sym_private] = ACTIONS(1627),
    [anon_sym_protected] = ACTIONS(1627),
    [anon_sym_override] = ACTIONS(1627),
    [anon_sym_module] = ACTIONS(1627),
    [anon_sym_any] = ACTIONS(1627),
    [anon_sym_number] = ACTIONS(1627),
    [anon_sym_boolean] = ACTIONS(1627),
    [anon_sym_string] = ACTIONS(1627),
    [anon_sym_symbol] = ACTIONS(1627),
    [anon_sym_property] = ACTIONS(1627),
    [anon_sym_signal] = ACTIONS(1627),
    [anon_sym_on] = ACTIONS(1627),
    [anon_sym_required] = ACTIONS(1627),
    [anon_sym_component] = ACTIONS(1627),
    [anon_sym_abstract] = ACTIONS(1627),
    [anon_sym_interface] = ACTIONS(1627),
    [anon_sym_enum] = ACTIONS(1627),
    [sym__automatic_semicolon] = ACTIONS(1629),
    [sym__ternary_qmark] = ACTIONS(1629),
  },
  [177] = {
    [sym_identifier] = ACTIONS(1631),
    [anon_sym_export] = ACTIONS(1631),
    [anon_sym_STAR] = ACTIONS(1631),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1631),
    [anon_sym_as] = ACTIONS(1631),
    [anon_sym_namespace] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1633),
    [anon_sym_RBRACE] = ACTIONS(1633),
    [anon_sym_typeof] = ACTIONS(1631),
    [anon_sym_import] = ACTIONS(1631),
    [anon_sym_from] = ACTIONS(1631),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1631),
    [anon_sym_const] = ACTIONS(1631),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_else] = ACTIONS(1631),
    [anon_sym_if] = ACTIONS(1631),
    [anon_sym_switch] = ACTIONS(1631),
    [anon_sym_for] = ACTIONS(1631),
    [anon_sym_LPAREN] = ACTIONS(1633),
    [anon_sym_await] = ACTIONS(1631),
    [anon_sym_in] = ACTIONS(1631),
    [anon_sym_of] = ACTIONS(1631),
    [anon_sym_while] = ACTIONS(1631),
    [anon_sym_do] = ACTIONS(1631),
    [anon_sym_try] = ACTIONS(1631),
    [anon_sym_with] = ACTIONS(1631),
    [anon_sym_break] = ACTIONS(1631),
    [anon_sym_continue] = ACTIONS(1631),
    [anon_sym_debugger] = ACTIONS(1631),
    [anon_sym_return] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_case] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(1631),
    [anon_sym_LBRACK] = ACTIONS(1633),
    [anon_sym_LTtemplate_GT] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1631),
    [anon_sym_GT] = ACTIONS(1631),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_DOT] = ACTIONS(1631),
    [anon_sym_class] = ACTIONS(1631),
    [anon_sym_async] = ACTIONS(1631),
    [anon_sym_function] = ACTIONS(1631),
    [anon_sym_QMARK_DOT] = ACTIONS(1633),
    [anon_sym_new] = ACTIONS(1631),
    [anon_sym_AMP_AMP] = ACTIONS(1633),
    [anon_sym_PIPE_PIPE] = ACTIONS(1633),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_GT_GT_GT] = ACTIONS(1633),
    [anon_sym_LT_LT] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_CARET] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1631),
    [anon_sym_DASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_STAR_STAR] = ACTIONS(1633),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [anon_sym_EQ_EQ] = ACTIONS(1631),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1633),
    [anon_sym_BANG_EQ] = ACTIONS(1631),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1633),
    [anon_sym_GT_EQ] = ACTIONS(1633),
    [anon_sym_QMARK_QMARK] = ACTIONS(1633),
    [anon_sym_instanceof] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1633),
    [anon_sym_void] = ACTIONS(1631),
    [anon_sym_delete] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1633),
    [anon_sym_DASH_DASH] = ACTIONS(1633),
    [anon_sym_DQUOTE] = ACTIONS(1633),
    [anon_sym_SQUOTE] = ACTIONS(1633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1633),
    [sym_number] = ACTIONS(1633),
    [sym_this] = ACTIONS(1631),
    [sym_super] = ACTIONS(1631),
    [sym_true] = ACTIONS(1631),
    [sym_false] = ACTIONS(1631),
    [sym_null] = ACTIONS(1631),
    [sym_undefined] = ACTIONS(1631),
    [anon_sym_AT] = ACTIONS(1633),
    [anon_sym_static] = ACTIONS(1631),
    [anon_sym_readonly] = ACTIONS(1631),
    [anon_sym_get] = ACTIONS(1631),
    [anon_sym_set] = ACTIONS(1631),
    [anon_sym_declare] = ACTIONS(1631),
    [anon_sym_public] = ACTIONS(1631),
    [anon_sym_private] = ACTIONS(1631),
    [anon_sym_protected] = ACTIONS(1631),
    [anon_sym_override] = ACTIONS(1631),
    [anon_sym_module] = ACTIONS(1631),
    [anon_sym_any] = ACTIONS(1631),
    [anon_sym_number] = ACTIONS(1631),
    [anon_sym_boolean] = ACTIONS(1631),
    [anon_sym_string] = ACTIONS(1631),
    [anon_sym_symbol] = ACTIONS(1631),
    [anon_sym_property] = ACTIONS(1631),
    [anon_sym_signal] = ACTIONS(1631),
    [anon_sym_on] = ACTIONS(1631),
    [anon_sym_required] = ACTIONS(1631),
    [anon_sym_component] = ACTIONS(1631),
    [anon_sym_abstract] = ACTIONS(1631),
    [anon_sym_interface] = ACTIONS(1631),
    [anon_sym_enum] = ACTIONS(1631),
    [sym__automatic_semicolon] = ACTIONS(1633),
    [sym__ternary_qmark] = ACTIONS(1633),
  },
  [178] = {
    [sym_identifier] = ACTIONS(1635),
    [anon_sym_export] = ACTIONS(1635),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_default] = ACTIONS(1635),
    [anon_sym_type] = ACTIONS(1635),
    [anon_sym_as] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1635),
    [anon_sym_LBRACE] = ACTIONS(1637),
    [anon_sym_COMMA] = ACTIONS(1637),
    [anon_sym_RBRACE] = ACTIONS(1637),
    [anon_sym_typeof] = ACTIONS(1635),
    [anon_sym_import] = ACTIONS(1635),
    [anon_sym_from] = ACTIONS(1635),
    [anon_sym_var] = ACTIONS(1635),
    [anon_sym_let] = ACTIONS(1635),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_else] = ACTIONS(1635),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_switch] = ACTIONS(1635),
    [anon_sym_for] = ACTIONS(1635),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_of] = ACTIONS(1635),
    [anon_sym_while] = ACTIONS(1635),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_try] = ACTIONS(1635),
    [anon_sym_with] = ACTIONS(1635),
    [anon_sym_break] = ACTIONS(1635),
    [anon_sym_continue] = ACTIONS(1635),
    [anon_sym_debugger] = ACTIONS(1635),
    [anon_sym_return] = ACTIONS(1635),
    [anon_sym_throw] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1635),
    [anon_sym_yield] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LTtemplate_GT] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1635),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1635),
    [anon_sym_class] = ACTIONS(1635),
    [anon_sym_async] = ACTIONS(1635),
    [anon_sym_function] = ACTIONS(1635),
    [anon_sym_QMARK_DOT] = ACTIONS(1637),
    [anon_sym_new] = ACTIONS(1635),
    [anon_sym_AMP_AMP] = ACTIONS(1637),
    [anon_sym_PIPE_PIPE] = ACTIONS(1637),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_GT_GT_GT] = ACTIONS(1637),
    [anon_sym_LT_LT] = ACTIONS(1637),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1637),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_PERCENT] = ACTIONS(1637),
    [anon_sym_STAR_STAR] = ACTIONS(1637),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_EQ_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1637),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1637),
    [anon_sym_QMARK_QMARK] = ACTIONS(1637),
    [anon_sym_instanceof] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1637),
    [anon_sym_void] = ACTIONS(1635),
    [anon_sym_delete] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1637),
    [anon_sym_DQUOTE] = ACTIONS(1637),
    [anon_sym_SQUOTE] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1637),
    [sym_number] = ACTIONS(1637),
    [sym_this] = ACTIONS(1635),
    [sym_super] = ACTIONS(1635),
    [sym_true] = ACTIONS(1635),
    [sym_false] = ACTIONS(1635),
    [sym_null] = ACTIONS(1635),
    [sym_undefined] = ACTIONS(1635),
    [anon_sym_AT] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1635),
    [anon_sym_readonly] = ACTIONS(1635),
    [anon_sym_get] = ACTIONS(1635),
    [anon_sym_set] = ACTIONS(1635),
    [anon_sym_declare] = ACTIONS(1635),
    [anon_sym_public] = ACTIONS(1635),
    [anon_sym_private] = ACTIONS(1635),
    [anon_sym_protected] = ACTIONS(1635),
    [anon_sym_override] = ACTIONS(1635),
    [anon_sym_module] = ACTIONS(1635),
    [anon_sym_any] = ACTIONS(1635),
    [anon_sym_number] = ACTIONS(1635),
    [anon_sym_boolean] = ACTIONS(1635),
    [anon_sym_string] = ACTIONS(1635),
    [anon_sym_symbol] = ACTIONS(1635),
    [anon_sym_property] = ACTIONS(1635),
    [anon_sym_signal] = ACTIONS(1635),
    [anon_sym_on] = ACTIONS(1635),
    [anon_sym_required] = ACTIONS(1635),
    [anon_sym_component] = ACTIONS(1635),
    [anon_sym_abstract] = ACTIONS(1635),
    [anon_sym_interface] = ACTIONS(1635),
    [anon_sym_enum] = ACTIONS(1635),
    [sym__automatic_semicolon] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1637),
  },
  [179] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2193),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4100),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4100),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4100),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_mapped_type_clause] = STATE(4863),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_type] = ACTIONS(1641),
    [anon_sym_namespace] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_COMMA] = ACTIONS(1645),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1641),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_RBRACK] = ACTIONS(1647),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1649),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1651),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1641),
    [anon_sym_readonly] = ACTIONS(1641),
    [anon_sym_get] = ACTIONS(1641),
    [anon_sym_set] = ACTIONS(1641),
    [anon_sym_declare] = ACTIONS(1641),
    [anon_sym_public] = ACTIONS(1641),
    [anon_sym_private] = ACTIONS(1641),
    [anon_sym_protected] = ACTIONS(1641),
    [anon_sym_override] = ACTIONS(1641),
    [anon_sym_module] = ACTIONS(1641),
    [anon_sym_any] = ACTIONS(1641),
    [anon_sym_number] = ACTIONS(1641),
    [anon_sym_boolean] = ACTIONS(1641),
    [anon_sym_string] = ACTIONS(1641),
    [anon_sym_symbol] = ACTIONS(1641),
    [anon_sym_property] = ACTIONS(1641),
    [anon_sym_signal] = ACTIONS(1641),
    [anon_sym_on] = ACTIONS(1641),
    [anon_sym_required] = ACTIONS(1641),
    [anon_sym_component] = ACTIONS(1641),
  },
  [180] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3051),
    [sym_constructor_type] = STATE(3051),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3051),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3051),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3051),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(1655),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_RBRACE] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(1667),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(1669),
    [anon_sym_PLUS] = ACTIONS(1671),
    [anon_sym_DASH] = ACTIONS(1671),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1687),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [181] = {
    [sym_identifier] = ACTIONS(1689),
    [anon_sym_export] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1691),
    [anon_sym_default] = ACTIONS(1689),
    [anon_sym_type] = ACTIONS(1689),
    [anon_sym_as] = ACTIONS(1691),
    [anon_sym_namespace] = ACTIONS(1689),
    [anon_sym_LBRACE] = ACTIONS(1693),
    [anon_sym_COMMA] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(1693),
    [anon_sym_typeof] = ACTIONS(1689),
    [anon_sym_import] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(1689),
    [anon_sym_var] = ACTIONS(1689),
    [anon_sym_let] = ACTIONS(1689),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(1689),
    [anon_sym_else] = ACTIONS(1689),
    [anon_sym_if] = ACTIONS(1689),
    [anon_sym_switch] = ACTIONS(1689),
    [anon_sym_for] = ACTIONS(1689),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_in] = ACTIONS(1691),
    [anon_sym_of] = ACTIONS(1689),
    [anon_sym_while] = ACTIONS(1689),
    [anon_sym_do] = ACTIONS(1689),
    [anon_sym_try] = ACTIONS(1689),
    [anon_sym_with] = ACTIONS(1689),
    [anon_sym_break] = ACTIONS(1689),
    [anon_sym_continue] = ACTIONS(1689),
    [anon_sym_debugger] = ACTIONS(1689),
    [anon_sym_return] = ACTIONS(1689),
    [anon_sym_throw] = ACTIONS(1689),
    [anon_sym_SEMI] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(1689),
    [anon_sym_yield] = ACTIONS(1689),
    [anon_sym_LBRACK] = ACTIONS(1693),
    [anon_sym_LTtemplate_GT] = ACTIONS(1693),
    [anon_sym_LT] = ACTIONS(1689),
    [anon_sym_GT] = ACTIONS(1691),
    [anon_sym_SLASH] = ACTIONS(1689),
    [anon_sym_DOT] = ACTIONS(1691),
    [anon_sym_class] = ACTIONS(1689),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(1689),
    [anon_sym_QMARK_DOT] = ACTIONS(1695),
    [anon_sym_new] = ACTIONS(1689),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_GT_GT] = ACTIONS(1691),
    [anon_sym_GT_GT_GT] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_CARET] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(1691),
    [anon_sym_PLUS] = ACTIONS(1689),
    [anon_sym_DASH] = ACTIONS(1689),
    [anon_sym_PERCENT] = ACTIONS(1695),
    [anon_sym_STAR_STAR] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BANG_EQ] = ACTIONS(1691),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_QMARK_QMARK] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1693),
    [anon_sym_void] = ACTIONS(1689),
    [anon_sym_delete] = ACTIONS(1689),
    [anon_sym_PLUS_PLUS] = ACTIONS(1693),
    [anon_sym_DASH_DASH] = ACTIONS(1693),
    [anon_sym_DQUOTE] = ACTIONS(1693),
    [anon_sym_SQUOTE] = ACTIONS(1693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1693),
    [sym_number] = ACTIONS(1693),
    [sym_this] = ACTIONS(1689),
    [sym_super] = ACTIONS(1689),
    [sym_true] = ACTIONS(1689),
    [sym_false] = ACTIONS(1689),
    [sym_null] = ACTIONS(1689),
    [sym_undefined] = ACTIONS(1689),
    [anon_sym_AT] = ACTIONS(1693),
    [anon_sym_static] = ACTIONS(1689),
    [anon_sym_readonly] = ACTIONS(1689),
    [anon_sym_get] = ACTIONS(1689),
    [anon_sym_set] = ACTIONS(1689),
    [anon_sym_declare] = ACTIONS(1689),
    [anon_sym_public] = ACTIONS(1689),
    [anon_sym_private] = ACTIONS(1689),
    [anon_sym_protected] = ACTIONS(1689),
    [anon_sym_override] = ACTIONS(1689),
    [anon_sym_module] = ACTIONS(1689),
    [anon_sym_any] = ACTIONS(1689),
    [anon_sym_number] = ACTIONS(1689),
    [anon_sym_boolean] = ACTIONS(1689),
    [anon_sym_string] = ACTIONS(1689),
    [anon_sym_symbol] = ACTIONS(1689),
    [anon_sym_property] = ACTIONS(1689),
    [anon_sym_signal] = ACTIONS(1689),
    [anon_sym_on] = ACTIONS(1689),
    [anon_sym_required] = ACTIONS(1689),
    [anon_sym_component] = ACTIONS(1689),
    [anon_sym_abstract] = ACTIONS(1689),
    [anon_sym_interface] = ACTIONS(1689),
    [anon_sym_enum] = ACTIONS(1689),
    [sym__automatic_semicolon] = ACTIONS(1697),
    [sym__ternary_qmark] = ACTIONS(1695),
  },
  [182] = {
    [sym_identifier] = ACTIONS(1699),
    [anon_sym_export] = ACTIONS(1699),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_default] = ACTIONS(1699),
    [anon_sym_type] = ACTIONS(1699),
    [anon_sym_as] = ACTIONS(1701),
    [anon_sym_namespace] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1705),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_typeof] = ACTIONS(1699),
    [anon_sym_import] = ACTIONS(1699),
    [anon_sym_from] = ACTIONS(1699),
    [anon_sym_var] = ACTIONS(1699),
    [anon_sym_let] = ACTIONS(1699),
    [anon_sym_const] = ACTIONS(1699),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_switch] = ACTIONS(1699),
    [anon_sym_for] = ACTIONS(1699),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_in] = ACTIONS(1701),
    [anon_sym_of] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_try] = ACTIONS(1699),
    [anon_sym_with] = ACTIONS(1699),
    [anon_sym_break] = ACTIONS(1699),
    [anon_sym_continue] = ACTIONS(1699),
    [anon_sym_debugger] = ACTIONS(1699),
    [anon_sym_return] = ACTIONS(1699),
    [anon_sym_throw] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_case] = ACTIONS(1699),
    [anon_sym_yield] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_LTtemplate_GT] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_class] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1699),
    [anon_sym_function] = ACTIONS(1699),
    [anon_sym_QMARK_DOT] = ACTIONS(1705),
    [anon_sym_new] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_GT_GT_GT] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1705),
    [anon_sym_STAR_STAR] = ACTIONS(1705),
    [anon_sym_LT_EQ] = ACTIONS(1705),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1705),
    [anon_sym_BANG_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1705),
    [anon_sym_GT_EQ] = ACTIONS(1705),
    [anon_sym_QMARK_QMARK] = ACTIONS(1705),
    [anon_sym_instanceof] = ACTIONS(1701),
    [anon_sym_TILDE] = ACTIONS(1703),
    [anon_sym_void] = ACTIONS(1699),
    [anon_sym_delete] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1703),
    [anon_sym_DASH_DASH] = ACTIONS(1703),
    [anon_sym_DQUOTE] = ACTIONS(1703),
    [anon_sym_SQUOTE] = ACTIONS(1703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1703),
    [sym_number] = ACTIONS(1703),
    [sym_this] = ACTIONS(1699),
    [sym_super] = ACTIONS(1699),
    [sym_true] = ACTIONS(1699),
    [sym_false] = ACTIONS(1699),
    [sym_null] = ACTIONS(1699),
    [sym_undefined] = ACTIONS(1699),
    [anon_sym_AT] = ACTIONS(1703),
    [anon_sym_static] = ACTIONS(1699),
    [anon_sym_readonly] = ACTIONS(1699),
    [anon_sym_get] = ACTIONS(1699),
    [anon_sym_set] = ACTIONS(1699),
    [anon_sym_declare] = ACTIONS(1699),
    [anon_sym_public] = ACTIONS(1699),
    [anon_sym_private] = ACTIONS(1699),
    [anon_sym_protected] = ACTIONS(1699),
    [anon_sym_override] = ACTIONS(1699),
    [anon_sym_module] = ACTIONS(1699),
    [anon_sym_any] = ACTIONS(1699),
    [anon_sym_number] = ACTIONS(1699),
    [anon_sym_boolean] = ACTIONS(1699),
    [anon_sym_string] = ACTIONS(1699),
    [anon_sym_symbol] = ACTIONS(1699),
    [anon_sym_property] = ACTIONS(1699),
    [anon_sym_signal] = ACTIONS(1699),
    [anon_sym_on] = ACTIONS(1699),
    [anon_sym_required] = ACTIONS(1699),
    [anon_sym_component] = ACTIONS(1699),
    [anon_sym_abstract] = ACTIONS(1699),
    [anon_sym_interface] = ACTIONS(1699),
    [anon_sym_enum] = ACTIONS(1699),
    [sym__automatic_semicolon] = ACTIONS(1707),
    [sym__ternary_qmark] = ACTIONS(1705),
  },
  [183] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1628),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1460),
    [anon_sym_RBRACE] = ACTIONS(1460),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_SEMI] = ACTIONS(1460),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_PIPE] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
    [anon_sym_extends] = ACTIONS(1462),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1460),
    [sym__automatic_semicolon] = ACTIONS(1460),
  },
  [184] = {
    [sym_identifier] = ACTIONS(1709),
    [anon_sym_export] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_default] = ACTIONS(1709),
    [anon_sym_type] = ACTIONS(1709),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_namespace] = ACTIONS(1709),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_COMMA] = ACTIONS(1715),
    [anon_sym_RBRACE] = ACTIONS(1713),
    [anon_sym_typeof] = ACTIONS(1709),
    [anon_sym_import] = ACTIONS(1709),
    [anon_sym_from] = ACTIONS(1709),
    [anon_sym_var] = ACTIONS(1709),
    [anon_sym_let] = ACTIONS(1709),
    [anon_sym_const] = ACTIONS(1709),
    [anon_sym_BANG] = ACTIONS(1709),
    [anon_sym_else] = ACTIONS(1709),
    [anon_sym_if] = ACTIONS(1709),
    [anon_sym_switch] = ACTIONS(1709),
    [anon_sym_for] = ACTIONS(1709),
    [anon_sym_LPAREN] = ACTIONS(1713),
    [anon_sym_await] = ACTIONS(1709),
    [anon_sym_in] = ACTIONS(1711),
    [anon_sym_of] = ACTIONS(1709),
    [anon_sym_while] = ACTIONS(1709),
    [anon_sym_do] = ACTIONS(1709),
    [anon_sym_try] = ACTIONS(1709),
    [anon_sym_with] = ACTIONS(1709),
    [anon_sym_break] = ACTIONS(1709),
    [anon_sym_continue] = ACTIONS(1709),
    [anon_sym_debugger] = ACTIONS(1709),
    [anon_sym_return] = ACTIONS(1709),
    [anon_sym_throw] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1713),
    [anon_sym_case] = ACTIONS(1709),
    [anon_sym_yield] = ACTIONS(1709),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LTtemplate_GT] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1709),
    [anon_sym_GT] = ACTIONS(1711),
    [anon_sym_SLASH] = ACTIONS(1709),
    [anon_sym_DOT] = ACTIONS(1711),
    [anon_sym_class] = ACTIONS(1709),
    [anon_sym_async] = ACTIONS(1709),
    [anon_sym_function] = ACTIONS(1709),
    [anon_sym_QMARK_DOT] = ACTIONS(1715),
    [anon_sym_new] = ACTIONS(1709),
    [anon_sym_AMP_AMP] = ACTIONS(1715),
    [anon_sym_PIPE_PIPE] = ACTIONS(1715),
    [anon_sym_GT_GT] = ACTIONS(1711),
    [anon_sym_GT_GT_GT] = ACTIONS(1715),
    [anon_sym_LT_LT] = ACTIONS(1715),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1715),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_PERCENT] = ACTIONS(1715),
    [anon_sym_STAR_STAR] = ACTIONS(1715),
    [anon_sym_LT_EQ] = ACTIONS(1715),
    [anon_sym_EQ_EQ] = ACTIONS(1711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1715),
    [anon_sym_BANG_EQ] = ACTIONS(1711),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1715),
    [anon_sym_GT_EQ] = ACTIONS(1715),
    [anon_sym_QMARK_QMARK] = ACTIONS(1715),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1713),
    [anon_sym_void] = ACTIONS(1709),
    [anon_sym_delete] = ACTIONS(1709),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_DQUOTE] = ACTIONS(1713),
    [anon_sym_SQUOTE] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1713),
    [sym_number] = ACTIONS(1713),
    [sym_this] = ACTIONS(1709),
    [sym_super] = ACTIONS(1709),
    [sym_true] = ACTIONS(1709),
    [sym_false] = ACTIONS(1709),
    [sym_null] = ACTIONS(1709),
    [sym_undefined] = ACTIONS(1709),
    [anon_sym_AT] = ACTIONS(1713),
    [anon_sym_static] = ACTIONS(1709),
    [anon_sym_readonly] = ACTIONS(1709),
    [anon_sym_get] = ACTIONS(1709),
    [anon_sym_set] = ACTIONS(1709),
    [anon_sym_declare] = ACTIONS(1709),
    [anon_sym_public] = ACTIONS(1709),
    [anon_sym_private] = ACTIONS(1709),
    [anon_sym_protected] = ACTIONS(1709),
    [anon_sym_override] = ACTIONS(1709),
    [anon_sym_module] = ACTIONS(1709),
    [anon_sym_any] = ACTIONS(1709),
    [anon_sym_number] = ACTIONS(1709),
    [anon_sym_boolean] = ACTIONS(1709),
    [anon_sym_string] = ACTIONS(1709),
    [anon_sym_symbol] = ACTIONS(1709),
    [anon_sym_property] = ACTIONS(1709),
    [anon_sym_signal] = ACTIONS(1709),
    [anon_sym_on] = ACTIONS(1709),
    [anon_sym_required] = ACTIONS(1709),
    [anon_sym_component] = ACTIONS(1709),
    [anon_sym_abstract] = ACTIONS(1709),
    [anon_sym_interface] = ACTIONS(1709),
    [anon_sym_enum] = ACTIONS(1709),
    [sym__automatic_semicolon] = ACTIONS(1717),
    [sym__ternary_qmark] = ACTIONS(1715),
  },
  [185] = {
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1719),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_type] = ACTIONS(1719),
    [anon_sym_as] = ACTIONS(1719),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1721),
    [anon_sym_COMMA] = ACTIONS(1721),
    [anon_sym_RBRACE] = ACTIONS(1721),
    [anon_sym_typeof] = ACTIONS(1719),
    [anon_sym_import] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(1719),
    [anon_sym_var] = ACTIONS(1719),
    [anon_sym_let] = ACTIONS(1719),
    [anon_sym_const] = ACTIONS(1719),
    [anon_sym_BANG] = ACTIONS(1719),
    [anon_sym_else] = ACTIONS(1719),
    [anon_sym_if] = ACTIONS(1719),
    [anon_sym_switch] = ACTIONS(1719),
    [anon_sym_for] = ACTIONS(1719),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_await] = ACTIONS(1719),
    [anon_sym_in] = ACTIONS(1719),
    [anon_sym_of] = ACTIONS(1719),
    [anon_sym_while] = ACTIONS(1719),
    [anon_sym_do] = ACTIONS(1719),
    [anon_sym_try] = ACTIONS(1719),
    [anon_sym_with] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1719),
    [anon_sym_continue] = ACTIONS(1719),
    [anon_sym_debugger] = ACTIONS(1719),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1719),
    [anon_sym_SEMI] = ACTIONS(1721),
    [anon_sym_case] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1721),
    [anon_sym_LTtemplate_GT] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1719),
    [anon_sym_GT] = ACTIONS(1719),
    [anon_sym_SLASH] = ACTIONS(1719),
    [anon_sym_DOT] = ACTIONS(1719),
    [anon_sym_class] = ACTIONS(1719),
    [anon_sym_async] = ACTIONS(1719),
    [anon_sym_function] = ACTIONS(1719),
    [anon_sym_QMARK_DOT] = ACTIONS(1721),
    [anon_sym_new] = ACTIONS(1719),
    [anon_sym_AMP_AMP] = ACTIONS(1721),
    [anon_sym_PIPE_PIPE] = ACTIONS(1721),
    [anon_sym_GT_GT] = ACTIONS(1719),
    [anon_sym_GT_GT_GT] = ACTIONS(1721),
    [anon_sym_LT_LT] = ACTIONS(1721),
    [anon_sym_AMP] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1721),
    [anon_sym_PIPE] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(1719),
    [anon_sym_DASH] = ACTIONS(1719),
    [anon_sym_PERCENT] = ACTIONS(1721),
    [anon_sym_STAR_STAR] = ACTIONS(1721),
    [anon_sym_LT_EQ] = ACTIONS(1721),
    [anon_sym_EQ_EQ] = ACTIONS(1719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1721),
    [anon_sym_BANG_EQ] = ACTIONS(1719),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1721),
    [anon_sym_GT_EQ] = ACTIONS(1721),
    [anon_sym_QMARK_QMARK] = ACTIONS(1721),
    [anon_sym_instanceof] = ACTIONS(1719),
    [anon_sym_TILDE] = ACTIONS(1721),
    [anon_sym_void] = ACTIONS(1719),
    [anon_sym_delete] = ACTIONS(1719),
    [anon_sym_PLUS_PLUS] = ACTIONS(1721),
    [anon_sym_DASH_DASH] = ACTIONS(1721),
    [anon_sym_DQUOTE] = ACTIONS(1721),
    [anon_sym_SQUOTE] = ACTIONS(1721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1721),
    [sym_number] = ACTIONS(1721),
    [sym_this] = ACTIONS(1719),
    [sym_super] = ACTIONS(1719),
    [sym_true] = ACTIONS(1719),
    [sym_false] = ACTIONS(1719),
    [sym_null] = ACTIONS(1719),
    [sym_undefined] = ACTIONS(1719),
    [anon_sym_AT] = ACTIONS(1721),
    [anon_sym_static] = ACTIONS(1719),
    [anon_sym_readonly] = ACTIONS(1719),
    [anon_sym_get] = ACTIONS(1719),
    [anon_sym_set] = ACTIONS(1719),
    [anon_sym_declare] = ACTIONS(1719),
    [anon_sym_public] = ACTIONS(1719),
    [anon_sym_private] = ACTIONS(1719),
    [anon_sym_protected] = ACTIONS(1719),
    [anon_sym_override] = ACTIONS(1719),
    [anon_sym_module] = ACTIONS(1719),
    [anon_sym_any] = ACTIONS(1719),
    [anon_sym_number] = ACTIONS(1719),
    [anon_sym_boolean] = ACTIONS(1719),
    [anon_sym_string] = ACTIONS(1719),
    [anon_sym_symbol] = ACTIONS(1719),
    [anon_sym_property] = ACTIONS(1719),
    [anon_sym_signal] = ACTIONS(1719),
    [anon_sym_on] = ACTIONS(1719),
    [anon_sym_required] = ACTIONS(1719),
    [anon_sym_component] = ACTIONS(1719),
    [anon_sym_abstract] = ACTIONS(1719),
    [anon_sym_interface] = ACTIONS(1719),
    [anon_sym_enum] = ACTIONS(1719),
    [sym__automatic_semicolon] = ACTIONS(1721),
    [sym__ternary_qmark] = ACTIONS(1721),
  },
  [186] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_export] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_default] = ACTIONS(1533),
    [anon_sym_type] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1533),
    [anon_sym_LBRACE] = ACTIONS(1535),
    [anon_sym_COMMA] = ACTIONS(1535),
    [anon_sym_RBRACE] = ACTIONS(1535),
    [anon_sym_typeof] = ACTIONS(1533),
    [anon_sym_import] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(1533),
    [anon_sym_var] = ACTIONS(1533),
    [anon_sym_let] = ACTIONS(1533),
    [anon_sym_const] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_else] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_switch] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_in] = ACTIONS(1533),
    [anon_sym_of] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_do] = ACTIONS(1533),
    [anon_sym_try] = ACTIONS(1533),
    [anon_sym_with] = ACTIONS(1533),
    [anon_sym_break] = ACTIONS(1533),
    [anon_sym_continue] = ACTIONS(1533),
    [anon_sym_debugger] = ACTIONS(1533),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_throw] = ACTIONS(1533),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym_case] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1535),
    [anon_sym_LTtemplate_GT] = ACTIONS(1535),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(1533),
    [anon_sym_async] = ACTIONS(1533),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_QMARK_DOT] = ACTIONS(1535),
    [anon_sym_new] = ACTIONS(1533),
    [anon_sym_AMP_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1535),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_GT_GT_GT] = ACTIONS(1535),
    [anon_sym_LT_LT] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1535),
    [anon_sym_STAR_STAR] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1535),
    [anon_sym_EQ_EQ] = ACTIONS(1533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1533),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1535),
    [anon_sym_GT_EQ] = ACTIONS(1535),
    [anon_sym_QMARK_QMARK] = ACTIONS(1535),
    [anon_sym_instanceof] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1533),
    [anon_sym_delete] = ACTIONS(1533),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1535),
    [sym_number] = ACTIONS(1535),
    [sym_this] = ACTIONS(1533),
    [sym_super] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_undefined] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(1535),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_readonly] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1533),
    [anon_sym_set] = ACTIONS(1533),
    [anon_sym_declare] = ACTIONS(1533),
    [anon_sym_public] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1533),
    [anon_sym_protected] = ACTIONS(1533),
    [anon_sym_override] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1533),
    [anon_sym_any] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1533),
    [anon_sym_property] = ACTIONS(1533),
    [anon_sym_signal] = ACTIONS(1533),
    [anon_sym_on] = ACTIONS(1533),
    [anon_sym_required] = ACTIONS(1533),
    [anon_sym_component] = ACTIONS(1533),
    [anon_sym_abstract] = ACTIONS(1533),
    [anon_sym_interface] = ACTIONS(1533),
    [anon_sym_enum] = ACTIONS(1533),
    [sym__automatic_semicolon] = ACTIONS(1723),
    [sym__ternary_qmark] = ACTIONS(1535),
  },
  [187] = {
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_type] = ACTIONS(1473),
    [anon_sym_as] = ACTIONS(1473),
    [anon_sym_namespace] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1479),
    [anon_sym_COMMA] = ACTIONS(1479),
    [anon_sym_RBRACE] = ACTIONS(1479),
    [anon_sym_typeof] = ACTIONS(1473),
    [anon_sym_import] = ACTIONS(1473),
    [anon_sym_from] = ACTIONS(1473),
    [anon_sym_var] = ACTIONS(1473),
    [anon_sym_let] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(1473),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_await] = ACTIONS(1473),
    [anon_sym_in] = ACTIONS(1473),
    [anon_sym_of] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_try] = ACTIONS(1473),
    [anon_sym_with] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_debugger] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_throw] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1479),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_yield] = ACTIONS(1473),
    [anon_sym_LBRACK] = ACTIONS(1479),
    [anon_sym_LTtemplate_GT] = ACTIONS(1479),
    [anon_sym_LT] = ACTIONS(1473),
    [anon_sym_GT] = ACTIONS(1473),
    [anon_sym_SLASH] = ACTIONS(1473),
    [anon_sym_DOT] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_function] = ACTIONS(1473),
    [anon_sym_QMARK_DOT] = ACTIONS(1479),
    [anon_sym_new] = ACTIONS(1473),
    [anon_sym_AMP_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_GT_GT_GT] = ACTIONS(1479),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_PIPE] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_STAR_STAR] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1479),
    [anon_sym_BANG_EQ] = ACTIONS(1473),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1479),
    [anon_sym_GT_EQ] = ACTIONS(1479),
    [anon_sym_QMARK_QMARK] = ACTIONS(1479),
    [anon_sym_instanceof] = ACTIONS(1473),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_void] = ACTIONS(1473),
    [anon_sym_delete] = ACTIONS(1473),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_DQUOTE] = ACTIONS(1479),
    [anon_sym_SQUOTE] = ACTIONS(1479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1479),
    [sym_number] = ACTIONS(1479),
    [sym_this] = ACTIONS(1473),
    [sym_super] = ACTIONS(1473),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [sym_null] = ACTIONS(1473),
    [sym_undefined] = ACTIONS(1473),
    [anon_sym_AT] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_get] = ACTIONS(1473),
    [anon_sym_set] = ACTIONS(1473),
    [anon_sym_declare] = ACTIONS(1473),
    [anon_sym_public] = ACTIONS(1473),
    [anon_sym_private] = ACTIONS(1473),
    [anon_sym_protected] = ACTIONS(1473),
    [anon_sym_override] = ACTIONS(1473),
    [anon_sym_module] = ACTIONS(1473),
    [anon_sym_any] = ACTIONS(1473),
    [anon_sym_number] = ACTIONS(1473),
    [anon_sym_boolean] = ACTIONS(1473),
    [anon_sym_string] = ACTIONS(1473),
    [anon_sym_symbol] = ACTIONS(1473),
    [anon_sym_property] = ACTIONS(1473),
    [anon_sym_signal] = ACTIONS(1473),
    [anon_sym_on] = ACTIONS(1473),
    [anon_sym_required] = ACTIONS(1473),
    [anon_sym_component] = ACTIONS(1473),
    [anon_sym_abstract] = ACTIONS(1473),
    [anon_sym_interface] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [sym__automatic_semicolon] = ACTIONS(1725),
    [sym__ternary_qmark] = ACTIONS(1479),
  },
  [188] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_EQ] = ACTIONS(1727),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_EQ_GT] = ACTIONS(1729),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [189] = {
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1733),
    [anon_sym_default] = ACTIONS(1731),
    [anon_sym_type] = ACTIONS(1731),
    [anon_sym_as] = ACTIONS(1733),
    [anon_sym_namespace] = ACTIONS(1731),
    [anon_sym_LBRACE] = ACTIONS(1735),
    [anon_sym_COMMA] = ACTIONS(1737),
    [anon_sym_RBRACE] = ACTIONS(1735),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym_import] = ACTIONS(1731),
    [anon_sym_from] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1731),
    [anon_sym_let] = ACTIONS(1731),
    [anon_sym_const] = ACTIONS(1731),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_else] = ACTIONS(1731),
    [anon_sym_if] = ACTIONS(1731),
    [anon_sym_switch] = ACTIONS(1731),
    [anon_sym_for] = ACTIONS(1731),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_in] = ACTIONS(1733),
    [anon_sym_of] = ACTIONS(1731),
    [anon_sym_while] = ACTIONS(1731),
    [anon_sym_do] = ACTIONS(1731),
    [anon_sym_try] = ACTIONS(1731),
    [anon_sym_with] = ACTIONS(1731),
    [anon_sym_break] = ACTIONS(1731),
    [anon_sym_continue] = ACTIONS(1731),
    [anon_sym_debugger] = ACTIONS(1731),
    [anon_sym_return] = ACTIONS(1731),
    [anon_sym_throw] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_case] = ACTIONS(1731),
    [anon_sym_yield] = ACTIONS(1731),
    [anon_sym_LBRACK] = ACTIONS(1735),
    [anon_sym_LTtemplate_GT] = ACTIONS(1735),
    [anon_sym_LT] = ACTIONS(1731),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_SLASH] = ACTIONS(1731),
    [anon_sym_DOT] = ACTIONS(1733),
    [anon_sym_class] = ACTIONS(1731),
    [anon_sym_async] = ACTIONS(1731),
    [anon_sym_function] = ACTIONS(1731),
    [anon_sym_QMARK_DOT] = ACTIONS(1737),
    [anon_sym_new] = ACTIONS(1731),
    [anon_sym_AMP_AMP] = ACTIONS(1737),
    [anon_sym_PIPE_PIPE] = ACTIONS(1737),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_GT_GT_GT] = ACTIONS(1737),
    [anon_sym_LT_LT] = ACTIONS(1737),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_CARET] = ACTIONS(1737),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_PERCENT] = ACTIONS(1737),
    [anon_sym_STAR_STAR] = ACTIONS(1737),
    [anon_sym_LT_EQ] = ACTIONS(1737),
    [anon_sym_EQ_EQ] = ACTIONS(1733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1737),
    [anon_sym_BANG_EQ] = ACTIONS(1733),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1737),
    [anon_sym_GT_EQ] = ACTIONS(1737),
    [anon_sym_QMARK_QMARK] = ACTIONS(1737),
    [anon_sym_instanceof] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1735),
    [anon_sym_void] = ACTIONS(1731),
    [anon_sym_delete] = ACTIONS(1731),
    [anon_sym_PLUS_PLUS] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1735),
    [anon_sym_DQUOTE] = ACTIONS(1735),
    [anon_sym_SQUOTE] = ACTIONS(1735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1735),
    [sym_number] = ACTIONS(1735),
    [sym_this] = ACTIONS(1731),
    [sym_super] = ACTIONS(1731),
    [sym_true] = ACTIONS(1731),
    [sym_false] = ACTIONS(1731),
    [sym_null] = ACTIONS(1731),
    [sym_undefined] = ACTIONS(1731),
    [anon_sym_AT] = ACTIONS(1735),
    [anon_sym_static] = ACTIONS(1731),
    [anon_sym_readonly] = ACTIONS(1731),
    [anon_sym_get] = ACTIONS(1731),
    [anon_sym_set] = ACTIONS(1731),
    [anon_sym_declare] = ACTIONS(1731),
    [anon_sym_public] = ACTIONS(1731),
    [anon_sym_private] = ACTIONS(1731),
    [anon_sym_protected] = ACTIONS(1731),
    [anon_sym_override] = ACTIONS(1731),
    [anon_sym_module] = ACTIONS(1731),
    [anon_sym_any] = ACTIONS(1731),
    [anon_sym_number] = ACTIONS(1731),
    [anon_sym_boolean] = ACTIONS(1731),
    [anon_sym_string] = ACTIONS(1731),
    [anon_sym_symbol] = ACTIONS(1731),
    [anon_sym_property] = ACTIONS(1731),
    [anon_sym_signal] = ACTIONS(1731),
    [anon_sym_on] = ACTIONS(1731),
    [anon_sym_required] = ACTIONS(1731),
    [anon_sym_component] = ACTIONS(1731),
    [anon_sym_abstract] = ACTIONS(1731),
    [anon_sym_interface] = ACTIONS(1731),
    [anon_sym_enum] = ACTIONS(1731),
    [sym__automatic_semicolon] = ACTIONS(1739),
    [sym__ternary_qmark] = ACTIONS(1737),
  },
  [190] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_EQ_GT] = ACTIONS(1743),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_implements] = ACTIONS(26),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [191] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1912),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4361),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4000),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(4197),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_COMMA] = ACTIONS(1745),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_RBRACK] = ACTIONS(1748),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(640),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(640),
    [anon_sym_number] = ACTIONS(640),
    [anon_sym_boolean] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_symbol] = ACTIONS(640),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
  },
  [192] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1912),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4361),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4000),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(4197),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_COMMA] = ACTIONS(1745),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_RBRACK] = ACTIONS(1752),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(640),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(640),
    [anon_sym_number] = ACTIONS(640),
    [anon_sym_boolean] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_symbol] = ACTIONS(640),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
  },
  [193] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2365),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(1460),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1460),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_RBRACK] = ACTIONS(1460),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1460),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_PIPE] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
    [anon_sym_extends] = ACTIONS(1462),
  },
  [194] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_EQ] = ACTIONS(1756),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_EQ_GT] = ACTIONS(1758),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [195] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_EQ] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_EQ_GT] = ACTIONS(1762),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [196] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_EQ] = ACTIONS(1764),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_COLON] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_EQ_GT] = ACTIONS(1766),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [197] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(1645),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_RBRACK] = ACTIONS(1647),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [198] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_assignment_pattern] = STATE(4044),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3851),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_pattern_repeat1] = STATE(4114),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(1645),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_RBRACK] = ACTIONS(1768),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [199] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1912),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4361),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_spread_element] = STATE(4000),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(4197),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_COMMA] = ACTIONS(1745),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_RBRACK] = ACTIONS(1745),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(640),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(640),
    [anon_sym_number] = ACTIONS(640),
    [anon_sym_boolean] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_symbol] = ACTIONS(640),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
  },
  [200] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2194),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4100),
    [sym_assignment_pattern] = STATE(4134),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4100),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1348),
    [sym_subscript_expression] = STATE(1348),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4100),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3881),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1348),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_pattern_repeat1] = STATE(4131),
    [sym_identifier] = ACTIONS(1770),
    [anon_sym_export] = ACTIONS(1772),
    [anon_sym_type] = ACTIONS(1772),
    [anon_sym_namespace] = ACTIONS(1774),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_COMMA] = ACTIONS(1645),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1772),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1772),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_RBRACK] = ACTIONS(1647),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1776),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1651),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1772),
    [anon_sym_readonly] = ACTIONS(1772),
    [anon_sym_get] = ACTIONS(1772),
    [anon_sym_set] = ACTIONS(1772),
    [anon_sym_declare] = ACTIONS(1772),
    [anon_sym_public] = ACTIONS(1772),
    [anon_sym_private] = ACTIONS(1772),
    [anon_sym_protected] = ACTIONS(1772),
    [anon_sym_override] = ACTIONS(1772),
    [anon_sym_module] = ACTIONS(1772),
    [anon_sym_any] = ACTIONS(1772),
    [anon_sym_number] = ACTIONS(1772),
    [anon_sym_boolean] = ACTIONS(1772),
    [anon_sym_string] = ACTIONS(1772),
    [anon_sym_symbol] = ACTIONS(1772),
    [anon_sym_property] = ACTIONS(1772),
    [anon_sym_signal] = ACTIONS(1772),
    [anon_sym_on] = ACTIONS(1772),
    [anon_sym_required] = ACTIONS(1772),
    [anon_sym_component] = ACTIONS(1772),
  },
  [201] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_COLON] = ACTIONS(1467),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [202] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(21),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(1412),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(72),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(74),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(107),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [203] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_assignment_pattern] = STATE(4361),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(4197),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(1780),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_RBRACK] = ACTIONS(1780),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [204] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1829),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_spread_element] = STATE(4262),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4263),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1784),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1786),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [205] = {
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_export] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(1788),
    [anon_sym_LBRACE] = ACTIONS(1790),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_typeof] = ACTIONS(1788),
    [anon_sym_import] = ACTIONS(1788),
    [anon_sym_from] = ACTIONS(1788),
    [anon_sym_BANG] = ACTIONS(1788),
    [anon_sym_LPAREN] = ACTIONS(1790),
    [anon_sym_RPAREN] = ACTIONS(32),
    [anon_sym_await] = ACTIONS(1788),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(1788),
    [anon_sym_COLON] = ACTIONS(32),
    [anon_sym_yield] = ACTIONS(1788),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_LTtemplate_GT] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(1788),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(1788),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_class] = ACTIONS(1788),
    [anon_sym_async] = ACTIONS(1788),
    [anon_sym_function] = ACTIONS(1788),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1788),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_TILDE] = ACTIONS(1790),
    [anon_sym_void] = ACTIONS(1788),
    [anon_sym_delete] = ACTIONS(1788),
    [anon_sym_PLUS_PLUS] = ACTIONS(1790),
    [anon_sym_DASH_DASH] = ACTIONS(1790),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_SQUOTE] = ACTIONS(1790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1790),
    [sym_number] = ACTIONS(1790),
    [sym_this] = ACTIONS(1788),
    [sym_super] = ACTIONS(1788),
    [sym_true] = ACTIONS(1788),
    [sym_false] = ACTIONS(1788),
    [sym_null] = ACTIONS(1788),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(1790),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_readonly] = ACTIONS(1788),
    [anon_sym_get] = ACTIONS(1788),
    [anon_sym_set] = ACTIONS(1788),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(1788),
    [anon_sym_public] = ACTIONS(1788),
    [anon_sym_private] = ACTIONS(1788),
    [anon_sym_protected] = ACTIONS(1788),
    [anon_sym_override] = ACTIONS(1788),
    [anon_sym_module] = ACTIONS(1788),
    [anon_sym_any] = ACTIONS(1788),
    [anon_sym_number] = ACTIONS(1788),
    [anon_sym_boolean] = ACTIONS(1788),
    [anon_sym_string] = ACTIONS(1788),
    [anon_sym_symbol] = ACTIONS(1788),
    [anon_sym_property] = ACTIONS(1788),
    [anon_sym_signal] = ACTIONS(1788),
    [anon_sym_on] = ACTIONS(1788),
    [anon_sym_required] = ACTIONS(1788),
    [anon_sym_component] = ACTIONS(1788),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [206] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1834),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1460),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1460),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_PIPE] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
    [anon_sym_extends] = ACTIONS(1462),
  },
  [207] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1927),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_COMMA] = ACTIONS(1460),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1460),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_PIPE] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
    [anon_sym_extends] = ACTIONS(1462),
  },
  [208] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1722),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_COMMA] = ACTIONS(1460),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1460),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_PIPE] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
    [anon_sym_extends] = ACTIONS(1462),
  },
  [209] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1915),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_spread_element] = STATE(4199),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4200),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1792),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1786),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [210] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2251),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1460),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1460),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_PIPE] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
    [anon_sym_extends] = ACTIONS(1462),
  },
  [211] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2229),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_COMMA] = ACTIONS(1460),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1460),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_PIPE] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
    [anon_sym_extends] = ACTIONS(1462),
  },
  [212] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1857),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_spread_element] = STATE(4201),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4147),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1794),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1786),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [213] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2224),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_COMMA] = ACTIONS(1460),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1460),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_PIPE] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
    [anon_sym_extends] = ACTIONS(1462),
  },
  [214] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1880),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_spread_element] = STATE(4124),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4125),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1796),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1786),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [215] = {
    [sym_identifier] = ACTIONS(1798),
    [anon_sym_export] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(1798),
    [anon_sym_LBRACE] = ACTIONS(1800),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_typeof] = ACTIONS(1798),
    [anon_sym_import] = ACTIONS(1798),
    [anon_sym_from] = ACTIONS(1798),
    [anon_sym_BANG] = ACTIONS(1798),
    [anon_sym_LPAREN] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(32),
    [anon_sym_await] = ACTIONS(1798),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(1798),
    [anon_sym_COLON] = ACTIONS(32),
    [anon_sym_yield] = ACTIONS(1798),
    [anon_sym_LBRACK] = ACTIONS(1800),
    [anon_sym_LTtemplate_GT] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(1798),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(1798),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_class] = ACTIONS(1798),
    [anon_sym_async] = ACTIONS(1798),
    [anon_sym_function] = ACTIONS(1798),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1798),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_TILDE] = ACTIONS(1800),
    [anon_sym_void] = ACTIONS(1798),
    [anon_sym_delete] = ACTIONS(1798),
    [anon_sym_PLUS_PLUS] = ACTIONS(1800),
    [anon_sym_DASH_DASH] = ACTIONS(1800),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(1800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1800),
    [sym_number] = ACTIONS(1800),
    [sym_this] = ACTIONS(1798),
    [sym_super] = ACTIONS(1798),
    [sym_true] = ACTIONS(1798),
    [sym_false] = ACTIONS(1798),
    [sym_null] = ACTIONS(1798),
    [sym_undefined] = ACTIONS(1798),
    [anon_sym_AT] = ACTIONS(1800),
    [anon_sym_static] = ACTIONS(1798),
    [anon_sym_readonly] = ACTIONS(1798),
    [anon_sym_get] = ACTIONS(1798),
    [anon_sym_set] = ACTIONS(1798),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(1798),
    [anon_sym_public] = ACTIONS(1798),
    [anon_sym_private] = ACTIONS(1798),
    [anon_sym_protected] = ACTIONS(1798),
    [anon_sym_override] = ACTIONS(1798),
    [anon_sym_module] = ACTIONS(1798),
    [anon_sym_any] = ACTIONS(1798),
    [anon_sym_number] = ACTIONS(1798),
    [anon_sym_boolean] = ACTIONS(1798),
    [anon_sym_string] = ACTIONS(1798),
    [anon_sym_symbol] = ACTIONS(1798),
    [anon_sym_property] = ACTIONS(1798),
    [anon_sym_signal] = ACTIONS(1798),
    [anon_sym_on] = ACTIONS(1798),
    [anon_sym_required] = ACTIONS(1798),
    [anon_sym_component] = ACTIONS(1798),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [216] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1903),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_spread_element] = STATE(4155),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4154),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1802),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1786),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [217] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1881),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_spread_element] = STATE(4084),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4081),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1804),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1786),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [218] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3844),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_accessibility_modifier] = STATE(226),
    [sym_override_modifier] = STATE(251),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(1119),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(1806),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1808),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(772),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1810),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(788),
    [anon_sym_private] = ACTIONS(788),
    [anon_sym_protected] = ACTIONS(788),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [219] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1869),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_spread_element] = STATE(4190),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [aux_sym_array_repeat1] = STATE(4188),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1782),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1812),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1786),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [220] = {
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_export] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(1788),
    [anon_sym_LBRACE] = ACTIONS(1790),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(1788),
    [anon_sym_import] = ACTIONS(1788),
    [anon_sym_from] = ACTIONS(1788),
    [anon_sym_BANG] = ACTIONS(1788),
    [anon_sym_LPAREN] = ACTIONS(1790),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(1788),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(1788),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(1788),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_LTtemplate_GT] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(1788),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(1788),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_class] = ACTIONS(1788),
    [anon_sym_async] = ACTIONS(1788),
    [anon_sym_function] = ACTIONS(1788),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1788),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1790),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(1788),
    [anon_sym_DASH] = ACTIONS(1788),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_TILDE] = ACTIONS(1790),
    [anon_sym_void] = ACTIONS(1788),
    [anon_sym_delete] = ACTIONS(1788),
    [anon_sym_PLUS_PLUS] = ACTIONS(1790),
    [anon_sym_DASH_DASH] = ACTIONS(1790),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_SQUOTE] = ACTIONS(1790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1790),
    [sym_number] = ACTIONS(1790),
    [sym_this] = ACTIONS(1788),
    [sym_super] = ACTIONS(1788),
    [sym_true] = ACTIONS(1788),
    [sym_false] = ACTIONS(1788),
    [sym_null] = ACTIONS(1788),
    [sym_undefined] = ACTIONS(1788),
    [anon_sym_AT] = ACTIONS(1790),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_readonly] = ACTIONS(1788),
    [anon_sym_get] = ACTIONS(1788),
    [anon_sym_set] = ACTIONS(1788),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(1788),
    [anon_sym_public] = ACTIONS(1788),
    [anon_sym_private] = ACTIONS(1788),
    [anon_sym_protected] = ACTIONS(1788),
    [anon_sym_override] = ACTIONS(1788),
    [anon_sym_module] = ACTIONS(1788),
    [anon_sym_any] = ACTIONS(1788),
    [anon_sym_number] = ACTIONS(1788),
    [anon_sym_boolean] = ACTIONS(1788),
    [anon_sym_string] = ACTIONS(1788),
    [anon_sym_symbol] = ACTIONS(1788),
    [anon_sym_property] = ACTIONS(1788),
    [anon_sym_signal] = ACTIONS(1788),
    [anon_sym_on] = ACTIONS(1788),
    [anon_sym_required] = ACTIONS(1788),
    [anon_sym_component] = ACTIONS(1788),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [221] = {
    [sym_identifier] = ACTIONS(1798),
    [anon_sym_export] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(1798),
    [anon_sym_LBRACE] = ACTIONS(1800),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_typeof] = ACTIONS(1798),
    [anon_sym_import] = ACTIONS(1798),
    [anon_sym_from] = ACTIONS(1798),
    [anon_sym_BANG] = ACTIONS(1798),
    [anon_sym_LPAREN] = ACTIONS(1800),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_await] = ACTIONS(1798),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(1798),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_yield] = ACTIONS(1798),
    [anon_sym_LBRACK] = ACTIONS(1800),
    [anon_sym_LTtemplate_GT] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(1798),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(1798),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_class] = ACTIONS(1798),
    [anon_sym_async] = ACTIONS(1798),
    [anon_sym_function] = ACTIONS(1798),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_new] = ACTIONS(1798),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1800),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(1798),
    [anon_sym_DASH] = ACTIONS(1798),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_TILDE] = ACTIONS(1800),
    [anon_sym_void] = ACTIONS(1798),
    [anon_sym_delete] = ACTIONS(1798),
    [anon_sym_PLUS_PLUS] = ACTIONS(1800),
    [anon_sym_DASH_DASH] = ACTIONS(1800),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(1800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1800),
    [sym_number] = ACTIONS(1800),
    [sym_this] = ACTIONS(1798),
    [sym_super] = ACTIONS(1798),
    [sym_true] = ACTIONS(1798),
    [sym_false] = ACTIONS(1798),
    [sym_null] = ACTIONS(1798),
    [sym_undefined] = ACTIONS(1798),
    [anon_sym_AT] = ACTIONS(1800),
    [anon_sym_static] = ACTIONS(1798),
    [anon_sym_readonly] = ACTIONS(1798),
    [anon_sym_get] = ACTIONS(1798),
    [anon_sym_set] = ACTIONS(1798),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(1798),
    [anon_sym_public] = ACTIONS(1798),
    [anon_sym_private] = ACTIONS(1798),
    [anon_sym_protected] = ACTIONS(1798),
    [anon_sym_override] = ACTIONS(1798),
    [anon_sym_module] = ACTIONS(1798),
    [anon_sym_any] = ACTIONS(1798),
    [anon_sym_number] = ACTIONS(1798),
    [anon_sym_boolean] = ACTIONS(1798),
    [anon_sym_string] = ACTIONS(1798),
    [anon_sym_symbol] = ACTIONS(1798),
    [anon_sym_property] = ACTIONS(1798),
    [anon_sym_signal] = ACTIONS(1798),
    [anon_sym_on] = ACTIONS(1798),
    [anon_sym_required] = ACTIONS(1798),
    [anon_sym_component] = ACTIONS(1798),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [222] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1912),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_spread_element] = STATE(4000),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_COMMA] = ACTIONS(1814),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1814),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_RBRACK] = ACTIONS(1814),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1786),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [223] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1794),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_COMMA] = ACTIONS(1460),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(1460),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(1460),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_AMP] = ACTIONS(1460),
    [anon_sym_PIPE] = ACTIONS(1460),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
    [anon_sym_extends] = ACTIONS(1462),
  },
  [224] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(256),
    [sym_empty_statement] = STATE(256),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [225] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(255),
    [sym_empty_statement] = STATE(255),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [226] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3817),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_override_modifier] = STATE(250),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1816),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1818),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [227] = {
    [sym_import] = STATE(2236),
    [sym_expression_statement] = STATE(252),
    [sym_empty_statement] = STATE(252),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1825),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4376),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(187),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [228] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2092),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3363),
    [sym_assignment_pattern] = STATE(4483),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3363),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1242),
    [sym_subscript_expression] = STATE(1242),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3363),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(4167),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1242),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1376),
    [anon_sym_export] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_namespace] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(640),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1384),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(640),
    [anon_sym_readonly] = ACTIONS(640),
    [anon_sym_get] = ACTIONS(640),
    [anon_sym_set] = ACTIONS(640),
    [anon_sym_declare] = ACTIONS(640),
    [anon_sym_public] = ACTIONS(640),
    [anon_sym_private] = ACTIONS(640),
    [anon_sym_protected] = ACTIONS(640),
    [anon_sym_override] = ACTIONS(640),
    [anon_sym_module] = ACTIONS(640),
    [anon_sym_any] = ACTIONS(640),
    [anon_sym_number] = ACTIONS(640),
    [anon_sym_boolean] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_symbol] = ACTIONS(640),
    [anon_sym_property] = ACTIONS(640),
    [anon_sym_signal] = ACTIONS(640),
    [anon_sym_on] = ACTIONS(640),
    [anon_sym_required] = ACTIONS(640),
    [anon_sym_component] = ACTIONS(640),
  },
  [229] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3581),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_override_modifier] = STATE(244),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(744),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1820),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(790),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [230] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_assignment_pattern] = STATE(4483),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(4167),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(19),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [231] = {
    [sym_import] = STATE(1596),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2365),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym__type_query_member_expression] = STATE(2789),
    [sym__type_query_subscript_expression] = STATE(2788),
    [sym__type_query_call_expression] = STATE(2832),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1822),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [232] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1355),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4209),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4209),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1355),
    [sym_subscript_expression] = STATE(1355),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4209),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1355),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1824),
    [anon_sym_export] = ACTIONS(1826),
    [anon_sym_type] = ACTIONS(1826),
    [anon_sym_namespace] = ACTIONS(1828),
    [anon_sym_LBRACE] = ACTIONS(1830),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1826),
    [anon_sym_var] = ACTIONS(1832),
    [anon_sym_let] = ACTIONS(1834),
    [anon_sym_const] = ACTIONS(1834),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1826),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1836),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1838),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1840),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1826),
    [anon_sym_readonly] = ACTIONS(1826),
    [anon_sym_get] = ACTIONS(1826),
    [anon_sym_set] = ACTIONS(1826),
    [anon_sym_declare] = ACTIONS(1826),
    [anon_sym_public] = ACTIONS(1826),
    [anon_sym_private] = ACTIONS(1826),
    [anon_sym_protected] = ACTIONS(1826),
    [anon_sym_override] = ACTIONS(1826),
    [anon_sym_module] = ACTIONS(1826),
    [anon_sym_any] = ACTIONS(1826),
    [anon_sym_number] = ACTIONS(1826),
    [anon_sym_boolean] = ACTIONS(1826),
    [anon_sym_string] = ACTIONS(1826),
    [anon_sym_symbol] = ACTIONS(1826),
    [anon_sym_property] = ACTIONS(1826),
    [anon_sym_signal] = ACTIONS(1826),
    [anon_sym_on] = ACTIONS(1826),
    [anon_sym_required] = ACTIONS(1826),
    [anon_sym_component] = ACTIONS(1826),
  },
  [233] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3581),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(744),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1820),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [234] = {
    [sym_import] = STATE(1596),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1628),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym__type_query_member_expression] = STATE(2789),
    [sym__type_query_subscript_expression] = STATE(2788),
    [sym__type_query_call_expression] = STATE(2832),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1842),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [235] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1889),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4475),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(1844),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
    [sym__automatic_semicolon] = ACTIONS(1844),
  },
  [236] = {
    [sym_import] = STATE(2399),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1628),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym__type_query_member_expression] = STATE(2871),
    [sym__type_query_subscript_expression] = STATE(2870),
    [sym__type_query_call_expression] = STATE(2959),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1846),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [237] = {
    [sym_import] = STATE(1596),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2224),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym__type_query_member_expression] = STATE(2789),
    [sym__type_query_subscript_expression] = STATE(2788),
    [sym__type_query_call_expression] = STATE(2832),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1848),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [238] = {
    [sym_import] = STATE(1596),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2365),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym__type_query_member_expression] = STATE(2789),
    [sym__type_query_subscript_expression] = STATE(2788),
    [sym__type_query_call_expression] = STATE(2832),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1850),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [239] = {
    [sym_import] = STATE(1596),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2229),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym__type_query_member_expression] = STATE(2789),
    [sym__type_query_subscript_expression] = STATE(2788),
    [sym__type_query_call_expression] = STATE(2832),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1852),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [240] = {
    [sym_import] = STATE(1596),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1628),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym__type_query_member_expression] = STATE(2789),
    [sym__type_query_subscript_expression] = STATE(2788),
    [sym__type_query_call_expression] = STATE(2832),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1854),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [241] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1904),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4542),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_SEMI] = ACTIONS(1856),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
    [sym__automatic_semicolon] = ACTIONS(1856),
  },
  [242] = {
    [sym_import] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1722),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym__type_query_member_expression] = STATE(2789),
    [sym__type_query_subscript_expression] = STATE(2788),
    [sym__type_query_call_expression] = STATE(2832),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1858),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [243] = {
    [sym_import] = STATE(1596),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2251),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym__type_query_member_expression] = STATE(2789),
    [sym__type_query_subscript_expression] = STATE(2788),
    [sym__type_query_call_expression] = STATE(2832),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1860),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [244] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3803),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(746),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1862),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [245] = {
    [sym_import] = STATE(1596),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1628),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym__type_query_member_expression] = STATE(2789),
    [sym__type_query_subscript_expression] = STATE(2788),
    [sym__type_query_call_expression] = STATE(2832),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1864),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [246] = {
    [sym_import] = STATE(1596),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2365),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym__type_query_member_expression] = STATE(2789),
    [sym__type_query_subscript_expression] = STATE(2788),
    [sym__type_query_call_expression] = STATE(2832),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1866),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [247] = {
    [sym_import] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1794),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym__type_query_member_expression] = STATE(2789),
    [sym__type_query_subscript_expression] = STATE(2788),
    [sym__type_query_call_expression] = STATE(2832),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1868),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [248] = {
    [sym_import] = STATE(1596),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1834),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym__type_query_member_expression] = STATE(2789),
    [sym__type_query_subscript_expression] = STATE(2788),
    [sym__type_query_call_expression] = STATE(2832),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1870),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [249] = {
    [sym_import] = STATE(1940),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1927),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym__type_query_member_expression] = STATE(2789),
    [sym__type_query_subscript_expression] = STATE(2788),
    [sym__type_query_call_expression] = STATE(2832),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1872),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [250] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3766),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1874),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1876),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [251] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3296),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3296),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1240),
    [sym_subscript_expression] = STATE(1240),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3296),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_pattern] = STATE(3760),
    [sym_rest_pattern] = STATE(3298),
    [sym_non_null_expression] = STATE(1240),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(712),
    [anon_sym_export] = ACTIONS(19),
    [anon_sym_type] = ACTIONS(19),
    [anon_sym_namespace] = ACTIONS(28),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(19),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(58),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(70),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(1878),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(734),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(19),
    [anon_sym_readonly] = ACTIONS(1880),
    [anon_sym_get] = ACTIONS(19),
    [anon_sym_set] = ACTIONS(19),
    [anon_sym_declare] = ACTIONS(19),
    [anon_sym_public] = ACTIONS(19),
    [anon_sym_private] = ACTIONS(19),
    [anon_sym_protected] = ACTIONS(19),
    [anon_sym_override] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(19),
    [anon_sym_any] = ACTIONS(19),
    [anon_sym_number] = ACTIONS(19),
    [anon_sym_boolean] = ACTIONS(19),
    [anon_sym_string] = ACTIONS(19),
    [anon_sym_symbol] = ACTIONS(19),
    [anon_sym_property] = ACTIONS(19),
    [anon_sym_signal] = ACTIONS(19),
    [anon_sym_on] = ACTIONS(19),
    [anon_sym_required] = ACTIONS(19),
    [anon_sym_component] = ACTIONS(19),
  },
  [252] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2030),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4884),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1882),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [253] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2078),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4940),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(1884),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [254] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2078),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4940),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_EQ_GT] = ACTIONS(1886),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [255] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2066),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4924),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1888),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [256] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1963),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4685),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_RPAREN] = ACTIONS(1890),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [257] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1774),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2288),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [258] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1434),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3721),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4543),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1894),
    [anon_sym_export] = ACTIONS(1896),
    [anon_sym_type] = ACTIONS(1896),
    [anon_sym_namespace] = ACTIONS(1898),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1896),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1896),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1902),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1896),
    [anon_sym_readonly] = ACTIONS(1896),
    [anon_sym_get] = ACTIONS(1896),
    [anon_sym_set] = ACTIONS(1896),
    [anon_sym_declare] = ACTIONS(1896),
    [anon_sym_public] = ACTIONS(1896),
    [anon_sym_private] = ACTIONS(1896),
    [anon_sym_protected] = ACTIONS(1896),
    [anon_sym_override] = ACTIONS(1896),
    [anon_sym_module] = ACTIONS(1896),
    [anon_sym_any] = ACTIONS(1896),
    [anon_sym_number] = ACTIONS(1896),
    [anon_sym_boolean] = ACTIONS(1896),
    [anon_sym_string] = ACTIONS(1896),
    [anon_sym_symbol] = ACTIONS(1896),
    [anon_sym_property] = ACTIONS(1896),
    [anon_sym_signal] = ACTIONS(1896),
    [anon_sym_on] = ACTIONS(1896),
    [anon_sym_required] = ACTIONS(1896),
    [anon_sym_component] = ACTIONS(1896),
  },
  [259] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1434),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3721),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4543),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1904),
    [anon_sym_export] = ACTIONS(1906),
    [anon_sym_type] = ACTIONS(1906),
    [anon_sym_namespace] = ACTIONS(1908),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1906),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1906),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1910),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1906),
    [anon_sym_get] = ACTIONS(1906),
    [anon_sym_set] = ACTIONS(1906),
    [anon_sym_declare] = ACTIONS(1906),
    [anon_sym_public] = ACTIONS(1906),
    [anon_sym_private] = ACTIONS(1906),
    [anon_sym_protected] = ACTIONS(1906),
    [anon_sym_override] = ACTIONS(1906),
    [anon_sym_module] = ACTIONS(1906),
    [anon_sym_any] = ACTIONS(1906),
    [anon_sym_number] = ACTIONS(1906),
    [anon_sym_boolean] = ACTIONS(1906),
    [anon_sym_string] = ACTIONS(1906),
    [anon_sym_symbol] = ACTIONS(1906),
    [anon_sym_property] = ACTIONS(1906),
    [anon_sym_signal] = ACTIONS(1906),
    [anon_sym_on] = ACTIONS(1906),
    [anon_sym_required] = ACTIONS(1906),
    [anon_sym_component] = ACTIONS(1906),
  },
  [260] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1263),
    [sym_expression] = STATE(2374),
    [sym_primary_expression] = STATE(1769),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1263),
    [sym_subscript_expression] = STATE(1263),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3721),
    [sym_non_null_expression] = STATE(1263),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4543),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_export] = ACTIONS(1914),
    [anon_sym_type] = ACTIONS(1914),
    [anon_sym_namespace] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1914),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_DOT] = ACTIONS(1918),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1920),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1924),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1914),
    [anon_sym_readonly] = ACTIONS(1914),
    [anon_sym_get] = ACTIONS(1914),
    [anon_sym_set] = ACTIONS(1914),
    [anon_sym_declare] = ACTIONS(1914),
    [anon_sym_public] = ACTIONS(1914),
    [anon_sym_private] = ACTIONS(1914),
    [anon_sym_protected] = ACTIONS(1914),
    [anon_sym_override] = ACTIONS(1914),
    [anon_sym_module] = ACTIONS(1914),
    [anon_sym_any] = ACTIONS(1914),
    [anon_sym_number] = ACTIONS(1914),
    [anon_sym_boolean] = ACTIONS(1914),
    [anon_sym_string] = ACTIONS(1914),
    [anon_sym_symbol] = ACTIONS(1914),
    [anon_sym_property] = ACTIONS(1914),
    [anon_sym_signal] = ACTIONS(1914),
    [anon_sym_on] = ACTIONS(1914),
    [anon_sym_required] = ACTIONS(1914),
    [anon_sym_component] = ACTIONS(1914),
  },
  [261] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2068),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4926),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [262] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1434),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1894),
    [anon_sym_export] = ACTIONS(1896),
    [anon_sym_type] = ACTIONS(1896),
    [anon_sym_namespace] = ACTIONS(1898),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1896),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1896),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1902),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1896),
    [anon_sym_readonly] = ACTIONS(1896),
    [anon_sym_get] = ACTIONS(1896),
    [anon_sym_set] = ACTIONS(1896),
    [anon_sym_declare] = ACTIONS(1896),
    [anon_sym_public] = ACTIONS(1896),
    [anon_sym_private] = ACTIONS(1896),
    [anon_sym_protected] = ACTIONS(1896),
    [anon_sym_override] = ACTIONS(1896),
    [anon_sym_module] = ACTIONS(1896),
    [anon_sym_any] = ACTIONS(1896),
    [anon_sym_number] = ACTIONS(1896),
    [anon_sym_boolean] = ACTIONS(1896),
    [anon_sym_string] = ACTIONS(1896),
    [anon_sym_symbol] = ACTIONS(1896),
    [anon_sym_property] = ACTIONS(1896),
    [anon_sym_signal] = ACTIONS(1896),
    [anon_sym_on] = ACTIONS(1896),
    [anon_sym_required] = ACTIONS(1896),
    [anon_sym_component] = ACTIONS(1896),
  },
  [263] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1434),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1904),
    [anon_sym_export] = ACTIONS(1906),
    [anon_sym_type] = ACTIONS(1906),
    [anon_sym_namespace] = ACTIONS(1908),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1906),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1906),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1910),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1906),
    [anon_sym_readonly] = ACTIONS(1906),
    [anon_sym_get] = ACTIONS(1906),
    [anon_sym_set] = ACTIONS(1906),
    [anon_sym_declare] = ACTIONS(1906),
    [anon_sym_public] = ACTIONS(1906),
    [anon_sym_private] = ACTIONS(1906),
    [anon_sym_protected] = ACTIONS(1906),
    [anon_sym_override] = ACTIONS(1906),
    [anon_sym_module] = ACTIONS(1906),
    [anon_sym_any] = ACTIONS(1906),
    [anon_sym_number] = ACTIONS(1906),
    [anon_sym_boolean] = ACTIONS(1906),
    [anon_sym_string] = ACTIONS(1906),
    [anon_sym_symbol] = ACTIONS(1906),
    [anon_sym_property] = ACTIONS(1906),
    [anon_sym_signal] = ACTIONS(1906),
    [anon_sym_on] = ACTIONS(1906),
    [anon_sym_required] = ACTIONS(1906),
    [anon_sym_component] = ACTIONS(1906),
  },
  [264] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1774),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2258),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1926),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [265] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1263),
    [sym_expression] = STATE(2374),
    [sym_primary_expression] = STATE(1769),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1263),
    [sym_subscript_expression] = STATE(1263),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1263),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1912),
    [anon_sym_export] = ACTIONS(1914),
    [anon_sym_type] = ACTIONS(1914),
    [anon_sym_namespace] = ACTIONS(1916),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1914),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1914),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_DOT] = ACTIONS(1918),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1920),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1924),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1914),
    [anon_sym_readonly] = ACTIONS(1914),
    [anon_sym_get] = ACTIONS(1914),
    [anon_sym_set] = ACTIONS(1914),
    [anon_sym_declare] = ACTIONS(1914),
    [anon_sym_public] = ACTIONS(1914),
    [anon_sym_private] = ACTIONS(1914),
    [anon_sym_protected] = ACTIONS(1914),
    [anon_sym_override] = ACTIONS(1914),
    [anon_sym_module] = ACTIONS(1914),
    [anon_sym_any] = ACTIONS(1914),
    [anon_sym_number] = ACTIONS(1914),
    [anon_sym_boolean] = ACTIONS(1914),
    [anon_sym_string] = ACTIONS(1914),
    [anon_sym_symbol] = ACTIONS(1914),
    [anon_sym_property] = ACTIONS(1914),
    [anon_sym_signal] = ACTIONS(1914),
    [anon_sym_on] = ACTIONS(1914),
    [anon_sym_required] = ACTIONS(1914),
    [anon_sym_component] = ACTIONS(1914),
  },
  [266] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1434),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3721),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4543),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1928),
    [anon_sym_export] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(1930),
    [anon_sym_namespace] = ACTIONS(1932),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1930),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1930),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1934),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1930),
    [anon_sym_get] = ACTIONS(1930),
    [anon_sym_set] = ACTIONS(1930),
    [anon_sym_declare] = ACTIONS(1930),
    [anon_sym_public] = ACTIONS(1930),
    [anon_sym_private] = ACTIONS(1930),
    [anon_sym_protected] = ACTIONS(1930),
    [anon_sym_override] = ACTIONS(1930),
    [anon_sym_module] = ACTIONS(1930),
    [anon_sym_any] = ACTIONS(1930),
    [anon_sym_number] = ACTIONS(1930),
    [anon_sym_boolean] = ACTIONS(1930),
    [anon_sym_string] = ACTIONS(1930),
    [anon_sym_symbol] = ACTIONS(1930),
    [anon_sym_property] = ACTIONS(1930),
    [anon_sym_signal] = ACTIONS(1930),
    [anon_sym_on] = ACTIONS(1930),
    [anon_sym_required] = ACTIONS(1930),
    [anon_sym_component] = ACTIONS(1930),
  },
  [267] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1434),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [268] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1728),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4714),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [269] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1878),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [270] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1434),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3721),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4543),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(1938),
    [anon_sym_type] = ACTIONS(1938),
    [anon_sym_namespace] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1938),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1938),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1942),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_readonly] = ACTIONS(1938),
    [anon_sym_get] = ACTIONS(1938),
    [anon_sym_set] = ACTIONS(1938),
    [anon_sym_declare] = ACTIONS(1938),
    [anon_sym_public] = ACTIONS(1938),
    [anon_sym_private] = ACTIONS(1938),
    [anon_sym_protected] = ACTIONS(1938),
    [anon_sym_override] = ACTIONS(1938),
    [anon_sym_module] = ACTIONS(1938),
    [anon_sym_any] = ACTIONS(1938),
    [anon_sym_number] = ACTIONS(1938),
    [anon_sym_boolean] = ACTIONS(1938),
    [anon_sym_string] = ACTIONS(1938),
    [anon_sym_symbol] = ACTIONS(1938),
    [anon_sym_property] = ACTIONS(1938),
    [anon_sym_signal] = ACTIONS(1938),
    [anon_sym_on] = ACTIONS(1938),
    [anon_sym_required] = ACTIONS(1938),
    [anon_sym_component] = ACTIONS(1938),
  },
  [271] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2032),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4903),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [272] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2078),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4940),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [273] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1892),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4479),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [274] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1434),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1936),
    [anon_sym_export] = ACTIONS(1938),
    [anon_sym_type] = ACTIONS(1938),
    [anon_sym_namespace] = ACTIONS(1940),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1938),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1938),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1942),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1938),
    [anon_sym_readonly] = ACTIONS(1938),
    [anon_sym_get] = ACTIONS(1938),
    [anon_sym_set] = ACTIONS(1938),
    [anon_sym_declare] = ACTIONS(1938),
    [anon_sym_public] = ACTIONS(1938),
    [anon_sym_private] = ACTIONS(1938),
    [anon_sym_protected] = ACTIONS(1938),
    [anon_sym_override] = ACTIONS(1938),
    [anon_sym_module] = ACTIONS(1938),
    [anon_sym_any] = ACTIONS(1938),
    [anon_sym_number] = ACTIONS(1938),
    [anon_sym_boolean] = ACTIONS(1938),
    [anon_sym_string] = ACTIONS(1938),
    [anon_sym_symbol] = ACTIONS(1938),
    [anon_sym_property] = ACTIONS(1938),
    [anon_sym_signal] = ACTIONS(1938),
    [anon_sym_on] = ACTIONS(1938),
    [anon_sym_required] = ACTIONS(1938),
    [anon_sym_component] = ACTIONS(1938),
  },
  [275] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2157),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1673),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [276] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1263),
    [sym_expression] = STATE(2374),
    [sym_primary_expression] = STATE(1769),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1263),
    [sym_subscript_expression] = STATE(1263),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3721),
    [sym_non_null_expression] = STATE(1263),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4543),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1946),
    [anon_sym_export] = ACTIONS(1948),
    [anon_sym_type] = ACTIONS(1948),
    [anon_sym_namespace] = ACTIONS(1950),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1948),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_DOT] = ACTIONS(1918),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1924),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_readonly] = ACTIONS(1948),
    [anon_sym_get] = ACTIONS(1948),
    [anon_sym_set] = ACTIONS(1948),
    [anon_sym_declare] = ACTIONS(1948),
    [anon_sym_public] = ACTIONS(1948),
    [anon_sym_private] = ACTIONS(1948),
    [anon_sym_protected] = ACTIONS(1948),
    [anon_sym_override] = ACTIONS(1948),
    [anon_sym_module] = ACTIONS(1948),
    [anon_sym_any] = ACTIONS(1948),
    [anon_sym_number] = ACTIONS(1948),
    [anon_sym_boolean] = ACTIONS(1948),
    [anon_sym_string] = ACTIONS(1948),
    [anon_sym_symbol] = ACTIONS(1948),
    [anon_sym_property] = ACTIONS(1948),
    [anon_sym_signal] = ACTIONS(1948),
    [anon_sym_on] = ACTIONS(1948),
    [anon_sym_required] = ACTIONS(1948),
    [anon_sym_component] = ACTIONS(1948),
  },
  [277] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1731),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1826),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [278] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2178),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1674),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [279] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2282),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [280] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2184),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1675),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [281] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1766),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2315),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [282] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2357),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [283] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1768),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2314),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [284] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1774),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2359),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [285] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1731),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2286),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [286] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1774),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2137),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [287] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1742),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1844),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [288] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2158),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1772),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [289] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1768),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2136),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [290] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2158),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1823),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [291] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1766),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2135),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [292] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1742),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2108),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [293] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1766),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1842),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [294] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1263),
    [sym_expression] = STATE(2374),
    [sym_primary_expression] = STATE(1769),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1263),
    [sym_subscript_expression] = STATE(1263),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3721),
    [sym_non_null_expression] = STATE(1263),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4543),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1956),
    [anon_sym_export] = ACTIONS(1958),
    [anon_sym_type] = ACTIONS(1958),
    [anon_sym_namespace] = ACTIONS(1960),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1958),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1958),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_DOT] = ACTIONS(1918),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1962),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1924),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_readonly] = ACTIONS(1958),
    [anon_sym_get] = ACTIONS(1958),
    [anon_sym_set] = ACTIONS(1958),
    [anon_sym_declare] = ACTIONS(1958),
    [anon_sym_public] = ACTIONS(1958),
    [anon_sym_private] = ACTIONS(1958),
    [anon_sym_protected] = ACTIONS(1958),
    [anon_sym_override] = ACTIONS(1958),
    [anon_sym_module] = ACTIONS(1958),
    [anon_sym_any] = ACTIONS(1958),
    [anon_sym_number] = ACTIONS(1958),
    [anon_sym_boolean] = ACTIONS(1958),
    [anon_sym_string] = ACTIONS(1958),
    [anon_sym_symbol] = ACTIONS(1958),
    [anon_sym_property] = ACTIONS(1958),
    [anon_sym_signal] = ACTIONS(1958),
    [anon_sym_on] = ACTIONS(1958),
    [anon_sym_required] = ACTIONS(1958),
    [anon_sym_component] = ACTIONS(1958),
  },
  [295] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1768),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1841),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [296] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2012),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4971),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [297] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2050),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4896),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [298] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2157),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(2011),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [299] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2178),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1996),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [300] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2184),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1994),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [301] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1972),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(5012),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [302] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1774),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1839),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [303] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1731),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2161),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [304] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2169),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [305] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1434),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(1918),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [306] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1742),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2300),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [307] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1263),
    [sym_expression] = STATE(2374),
    [sym_primary_expression] = STATE(1769),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1263),
    [sym_subscript_expression] = STATE(1263),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1263),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1956),
    [anon_sym_export] = ACTIONS(1958),
    [anon_sym_type] = ACTIONS(1958),
    [anon_sym_namespace] = ACTIONS(1960),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1958),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1958),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_DOT] = ACTIONS(1918),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1962),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1924),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1958),
    [anon_sym_readonly] = ACTIONS(1958),
    [anon_sym_get] = ACTIONS(1958),
    [anon_sym_set] = ACTIONS(1958),
    [anon_sym_declare] = ACTIONS(1958),
    [anon_sym_public] = ACTIONS(1958),
    [anon_sym_private] = ACTIONS(1958),
    [anon_sym_protected] = ACTIONS(1958),
    [anon_sym_override] = ACTIONS(1958),
    [anon_sym_module] = ACTIONS(1958),
    [anon_sym_any] = ACTIONS(1958),
    [anon_sym_number] = ACTIONS(1958),
    [anon_sym_boolean] = ACTIONS(1958),
    [anon_sym_string] = ACTIONS(1958),
    [anon_sym_symbol] = ACTIONS(1958),
    [anon_sym_property] = ACTIONS(1958),
    [anon_sym_signal] = ACTIONS(1958),
    [anon_sym_on] = ACTIONS(1958),
    [anon_sym_required] = ACTIONS(1958),
    [anon_sym_component] = ACTIONS(1958),
  },
  [308] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2093),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4992),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [309] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2201),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1966),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [310] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2193),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_mapped_type_clause] = STATE(4667),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1964),
    [anon_sym_export] = ACTIONS(1966),
    [anon_sym_type] = ACTIONS(1966),
    [anon_sym_namespace] = ACTIONS(1968),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1966),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1966),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1970),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1966),
    [anon_sym_readonly] = ACTIONS(1966),
    [anon_sym_get] = ACTIONS(1966),
    [anon_sym_set] = ACTIONS(1966),
    [anon_sym_declare] = ACTIONS(1966),
    [anon_sym_public] = ACTIONS(1966),
    [anon_sym_private] = ACTIONS(1966),
    [anon_sym_protected] = ACTIONS(1966),
    [anon_sym_override] = ACTIONS(1966),
    [anon_sym_module] = ACTIONS(1966),
    [anon_sym_any] = ACTIONS(1966),
    [anon_sym_number] = ACTIONS(1966),
    [anon_sym_boolean] = ACTIONS(1966),
    [anon_sym_string] = ACTIONS(1966),
    [anon_sym_symbol] = ACTIONS(1966),
    [anon_sym_property] = ACTIONS(1966),
    [anon_sym_signal] = ACTIONS(1966),
    [anon_sym_on] = ACTIONS(1966),
    [anon_sym_required] = ACTIONS(1966),
    [anon_sym_component] = ACTIONS(1966),
  },
  [311] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1766),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2293),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [312] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1768),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2292),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [313] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2193),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_mapped_type_clause] = STATE(4863),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1972),
    [anon_sym_export] = ACTIONS(1974),
    [anon_sym_type] = ACTIONS(1974),
    [anon_sym_namespace] = ACTIONS(1976),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1974),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1974),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1978),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1974),
    [anon_sym_readonly] = ACTIONS(1974),
    [anon_sym_get] = ACTIONS(1974),
    [anon_sym_set] = ACTIONS(1974),
    [anon_sym_declare] = ACTIONS(1974),
    [anon_sym_public] = ACTIONS(1974),
    [anon_sym_private] = ACTIONS(1974),
    [anon_sym_protected] = ACTIONS(1974),
    [anon_sym_override] = ACTIONS(1974),
    [anon_sym_module] = ACTIONS(1974),
    [anon_sym_any] = ACTIONS(1974),
    [anon_sym_number] = ACTIONS(1974),
    [anon_sym_boolean] = ACTIONS(1974),
    [anon_sym_string] = ACTIONS(1974),
    [anon_sym_symbol] = ACTIONS(1974),
    [anon_sym_property] = ACTIONS(1974),
    [anon_sym_signal] = ACTIONS(1974),
    [anon_sym_on] = ACTIONS(1974),
    [anon_sym_required] = ACTIONS(1974),
    [anon_sym_component] = ACTIONS(1974),
  },
  [314] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2088),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4994),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [315] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2086),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(5011),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [316] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2201),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1695),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [317] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1434),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1928),
    [anon_sym_export] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(1930),
    [anon_sym_namespace] = ACTIONS(1932),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1930),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1930),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1934),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1930),
    [anon_sym_get] = ACTIONS(1930),
    [anon_sym_set] = ACTIONS(1930),
    [anon_sym_declare] = ACTIONS(1930),
    [anon_sym_public] = ACTIONS(1930),
    [anon_sym_private] = ACTIONS(1930),
    [anon_sym_protected] = ACTIONS(1930),
    [anon_sym_override] = ACTIONS(1930),
    [anon_sym_module] = ACTIONS(1930),
    [anon_sym_any] = ACTIONS(1930),
    [anon_sym_number] = ACTIONS(1930),
    [anon_sym_boolean] = ACTIONS(1930),
    [anon_sym_string] = ACTIONS(1930),
    [anon_sym_symbol] = ACTIONS(1930),
    [anon_sym_property] = ACTIONS(1930),
    [anon_sym_signal] = ACTIONS(1930),
    [anon_sym_on] = ACTIONS(1930),
    [anon_sym_required] = ACTIONS(1930),
    [anon_sym_component] = ACTIONS(1930),
  },
  [318] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1513),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [319] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1263),
    [sym_expression] = STATE(2374),
    [sym_primary_expression] = STATE(1769),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1263),
    [sym_subscript_expression] = STATE(1263),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1263),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1946),
    [anon_sym_export] = ACTIONS(1948),
    [anon_sym_type] = ACTIONS(1948),
    [anon_sym_namespace] = ACTIONS(1950),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1948),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1948),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_DOT] = ACTIONS(1918),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1952),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1922),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1924),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1948),
    [anon_sym_readonly] = ACTIONS(1948),
    [anon_sym_get] = ACTIONS(1948),
    [anon_sym_set] = ACTIONS(1948),
    [anon_sym_declare] = ACTIONS(1948),
    [anon_sym_public] = ACTIONS(1948),
    [anon_sym_private] = ACTIONS(1948),
    [anon_sym_protected] = ACTIONS(1948),
    [anon_sym_override] = ACTIONS(1948),
    [anon_sym_module] = ACTIONS(1948),
    [anon_sym_any] = ACTIONS(1948),
    [anon_sym_number] = ACTIONS(1948),
    [anon_sym_boolean] = ACTIONS(1948),
    [anon_sym_string] = ACTIONS(1948),
    [anon_sym_symbol] = ACTIONS(1948),
    [anon_sym_property] = ACTIONS(1948),
    [anon_sym_signal] = ACTIONS(1948),
    [anon_sym_on] = ACTIONS(1948),
    [anon_sym_required] = ACTIONS(1948),
    [anon_sym_component] = ACTIONS(1948),
  },
  [320] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1434),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3721),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4543),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [321] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1434),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3564),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4540),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1928),
    [anon_sym_export] = ACTIONS(1930),
    [anon_sym_type] = ACTIONS(1930),
    [anon_sym_namespace] = ACTIONS(1932),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1930),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1930),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1934),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1930),
    [anon_sym_readonly] = ACTIONS(1930),
    [anon_sym_get] = ACTIONS(1930),
    [anon_sym_set] = ACTIONS(1930),
    [anon_sym_declare] = ACTIONS(1930),
    [anon_sym_public] = ACTIONS(1930),
    [anon_sym_private] = ACTIONS(1930),
    [anon_sym_protected] = ACTIONS(1930),
    [anon_sym_override] = ACTIONS(1930),
    [anon_sym_module] = ACTIONS(1930),
    [anon_sym_any] = ACTIONS(1930),
    [anon_sym_number] = ACTIONS(1930),
    [anon_sym_boolean] = ACTIONS(1930),
    [anon_sym_string] = ACTIONS(1930),
    [anon_sym_symbol] = ACTIONS(1930),
    [anon_sym_property] = ACTIONS(1930),
    [anon_sym_signal] = ACTIONS(1930),
    [anon_sym_on] = ACTIONS(1930),
    [anon_sym_required] = ACTIONS(1930),
    [anon_sym_component] = ACTIONS(1930),
  },
  [322] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1731),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1524),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [323] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1945),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4817),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [324] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1742),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2386),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [325] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1774),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1545),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [326] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1768),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1544),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [327] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2119),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1942),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [328] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1731),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2349),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(1954),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [329] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1685),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2263),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1926),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [330] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1766),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1543),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [331] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2157),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [332] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1742),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1540),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1892),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [333] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2046),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4718),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [334] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1790),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4774),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [335] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1434),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3721),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4543),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1980),
    [anon_sym_export] = ACTIONS(1982),
    [anon_sym_type] = ACTIONS(1982),
    [anon_sym_namespace] = ACTIONS(1984),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1982),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1982),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1986),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1982),
    [anon_sym_readonly] = ACTIONS(1982),
    [anon_sym_get] = ACTIONS(1982),
    [anon_sym_set] = ACTIONS(1982),
    [anon_sym_declare] = ACTIONS(1982),
    [anon_sym_public] = ACTIONS(1982),
    [anon_sym_private] = ACTIONS(1982),
    [anon_sym_protected] = ACTIONS(1982),
    [anon_sym_override] = ACTIONS(1982),
    [anon_sym_module] = ACTIONS(1982),
    [anon_sym_any] = ACTIONS(1982),
    [anon_sym_number] = ACTIONS(1982),
    [anon_sym_boolean] = ACTIONS(1982),
    [anon_sym_string] = ACTIONS(1982),
    [anon_sym_symbol] = ACTIONS(1982),
    [anon_sym_property] = ACTIONS(1982),
    [anon_sym_signal] = ACTIONS(1982),
    [anon_sym_on] = ACTIONS(1982),
    [anon_sym_required] = ACTIONS(1982),
    [anon_sym_component] = ACTIONS(1982),
  },
  [336] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2201),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1747),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [337] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1742),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2264),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1926),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [338] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1731),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2275),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1926),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [339] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1905),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4631),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [340] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1557),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(3978),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [341] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2158),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1923),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [342] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1434),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1980),
    [anon_sym_export] = ACTIONS(1982),
    [anon_sym_type] = ACTIONS(1982),
    [anon_sym_namespace] = ACTIONS(1984),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1982),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(1982),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1986),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1982),
    [anon_sym_readonly] = ACTIONS(1982),
    [anon_sym_get] = ACTIONS(1982),
    [anon_sym_set] = ACTIONS(1982),
    [anon_sym_declare] = ACTIONS(1982),
    [anon_sym_public] = ACTIONS(1982),
    [anon_sym_private] = ACTIONS(1982),
    [anon_sym_protected] = ACTIONS(1982),
    [anon_sym_override] = ACTIONS(1982),
    [anon_sym_module] = ACTIONS(1982),
    [anon_sym_any] = ACTIONS(1982),
    [anon_sym_number] = ACTIONS(1982),
    [anon_sym_boolean] = ACTIONS(1982),
    [anon_sym_string] = ACTIONS(1982),
    [anon_sym_symbol] = ACTIONS(1982),
    [anon_sym_property] = ACTIONS(1982),
    [anon_sym_signal] = ACTIONS(1982),
    [anon_sym_on] = ACTIONS(1982),
    [anon_sym_required] = ACTIONS(1982),
    [anon_sym_component] = ACTIONS(1982),
  },
  [343] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1854),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_sequence_expression] = STATE(4440),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [344] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2184),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1821),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [345] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1766),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2260),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1926),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [346] = {
    [sym_import] = STATE(1752),
    [sym_statement_block] = STATE(1768),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2259),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1926),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [347] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2119),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1717),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [348] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2089),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4807),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [349] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2178),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1820),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [350] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2029),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_sequence_expression] = STATE(4653),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [351] = {
    [sym_import] = STATE(2236),
    [sym_statement_block] = STATE(2119),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1684),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1944),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [352] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1788),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3544),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3544),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1314),
    [sym_subscript_expression] = STATE(1314),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3544),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1314),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1988),
    [anon_sym_export] = ACTIONS(1166),
    [anon_sym_type] = ACTIONS(1166),
    [anon_sym_namespace] = ACTIONS(1168),
    [anon_sym_LBRACE] = ACTIONS(1378),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1166),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(1166),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1172),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1990),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1166),
    [anon_sym_readonly] = ACTIONS(1166),
    [anon_sym_get] = ACTIONS(1166),
    [anon_sym_set] = ACTIONS(1166),
    [anon_sym_declare] = ACTIONS(1166),
    [anon_sym_public] = ACTIONS(1166),
    [anon_sym_private] = ACTIONS(1166),
    [anon_sym_protected] = ACTIONS(1166),
    [anon_sym_override] = ACTIONS(1166),
    [anon_sym_module] = ACTIONS(1166),
    [anon_sym_any] = ACTIONS(1166),
    [anon_sym_number] = ACTIONS(1166),
    [anon_sym_boolean] = ACTIONS(1166),
    [anon_sym_string] = ACTIONS(1166),
    [anon_sym_symbol] = ACTIONS(1166),
    [anon_sym_property] = ACTIONS(1166),
    [anon_sym_signal] = ACTIONS(1166),
    [anon_sym_on] = ACTIONS(1166),
    [anon_sym_required] = ACTIONS(1166),
    [anon_sym_component] = ACTIONS(1166),
  },
  [353] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1910),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [354] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1715),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [355] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2295),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [356] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2351),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [357] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1922),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [358] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1962),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [359] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1721),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [360] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1885),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [361] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1681),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [362] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2206),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [363] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2355),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [364] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2121),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [365] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1686),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [366] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2366),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [367] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1691),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [368] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1756),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [369] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2313),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [370] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1738),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [371] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1706),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [372] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1709),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [373] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1724),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [374] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1732),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [375] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1734),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [376] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1735),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [377] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1736),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [378] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1760),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [379] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1744),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [380] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2224),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(1992),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [381] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1830),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [382] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2372),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [383] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2312),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [384] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2377),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [385] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1748),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [386] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1833),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [387] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2390),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [388] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1840),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [389] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1628),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(1994),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [390] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1672),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [391] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1941),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [392] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2284),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [393] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2392),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [394] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1939),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [395] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2393),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [396] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2394),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [397] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2274),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [398] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2396),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [399] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1943),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [400] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1944),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [401] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2384),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [402] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1541),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [403] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2267),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [404] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1949),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [405] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1950),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [406] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1951),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [407] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1952),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [408] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2266),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [409] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1936),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [410] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2378),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [411] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1953),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [412] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1539),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [413] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(2092),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [414] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2296),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [415] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2297),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [416] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1708),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [417] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2150),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [418] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(2017),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [419] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1628),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [420] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2298),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [421] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1954),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [422] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2365),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(1996),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [423] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1538),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [424] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1911),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [425] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2352),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [426] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1831),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [427] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1957),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [428] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1787),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [429] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2261),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [430] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1958),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [431] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1916),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [432] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1960),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [433] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1968),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [434] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2245),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [435] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1834),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(1992),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [436] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2356),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [437] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1537),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [438] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2262),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [439] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1547),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [440] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1536),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [441] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1806),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [442] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2338),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(3285),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(3285),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1207),
    [sym_subscript_expression] = STATE(1207),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(3285),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1207),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1998),
    [anon_sym_export] = ACTIONS(862),
    [anon_sym_type] = ACTIONS(862),
    [anon_sym_namespace] = ACTIONS(864),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(862),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(862),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(2000),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(862),
    [anon_sym_readonly] = ACTIONS(862),
    [anon_sym_get] = ACTIONS(862),
    [anon_sym_set] = ACTIONS(862),
    [anon_sym_declare] = ACTIONS(862),
    [anon_sym_public] = ACTIONS(862),
    [anon_sym_private] = ACTIONS(862),
    [anon_sym_protected] = ACTIONS(862),
    [anon_sym_override] = ACTIONS(862),
    [anon_sym_module] = ACTIONS(862),
    [anon_sym_any] = ACTIONS(862),
    [anon_sym_number] = ACTIONS(862),
    [anon_sym_boolean] = ACTIONS(862),
    [anon_sym_string] = ACTIONS(862),
    [anon_sym_symbol] = ACTIONS(862),
    [anon_sym_property] = ACTIONS(862),
    [anon_sym_signal] = ACTIONS(862),
    [anon_sym_on] = ACTIONS(862),
    [anon_sym_required] = ACTIONS(862),
    [anon_sym_component] = ACTIONS(862),
  },
  [443] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1535),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [444] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2289),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [445] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1755),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [446] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1534),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [447] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1712),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [448] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1834),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [449] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(2028),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [450] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2301),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [451] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2363),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [452] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1533),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [453] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2294),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [454] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1532),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [455] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1531),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [456] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2365),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [457] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1792),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [458] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1868),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [459] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1838),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [460] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1789),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [461] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1628),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(1996),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [462] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1530),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [463] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2371),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [464] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2269),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [465] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2365),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(2002),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [466] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1783),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [467] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1778),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [468] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2333),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [469] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1843),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [470] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2197),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [471] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1773),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [472] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1795),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [473] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1848),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [474] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2257),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [475] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2354),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [476] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1796),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [477] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1849),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [478] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1850),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [479] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2224),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [480] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2268),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [481] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1628),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(1992),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [482] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1528),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [483] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1525),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [484] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1523),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [485] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1516),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [486] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2302),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [487] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2251),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(1992),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [488] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1927),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(2004),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [489] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2251),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [490] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1704),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [491] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2194),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [492] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1851),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [493] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1798),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [494] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1859),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [495] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1860),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [496] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1864),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [497] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1873),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [498] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1877),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [499] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1879),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [500] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1895),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [501] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1897),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [502] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2277),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [503] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1703),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [504] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1702),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [505] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1902),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [506] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1863),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [507] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1322),
    [sym_expression] = STATE(1837),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4934),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4934),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4932),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1322),
    [sym_subscript_expression] = STATE(1322),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2858),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4934),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1322),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(507),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_export] = ACTIONS(1182),
    [anon_sym_type] = ACTIONS(1182),
    [anon_sym_namespace] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1204),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1182),
    [anon_sym_BANG] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1190),
    [anon_sym_of] = ACTIONS(1182),
    [anon_sym_yield] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_TILDE] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1204),
    [anon_sym_delete] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1254),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1182),
    [anon_sym_readonly] = ACTIONS(1182),
    [anon_sym_get] = ACTIONS(1182),
    [anon_sym_set] = ACTIONS(1182),
    [anon_sym_declare] = ACTIONS(1182),
    [anon_sym_public] = ACTIONS(1182),
    [anon_sym_private] = ACTIONS(1182),
    [anon_sym_protected] = ACTIONS(1182),
    [anon_sym_override] = ACTIONS(1182),
    [anon_sym_module] = ACTIONS(1182),
    [anon_sym_any] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_boolean] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(1182),
    [anon_sym_symbol] = ACTIONS(1182),
    [anon_sym_property] = ACTIONS(1182),
    [anon_sym_signal] = ACTIONS(1182),
    [anon_sym_on] = ACTIONS(1182),
    [anon_sym_required] = ACTIONS(1182),
    [anon_sym_component] = ACTIONS(1182),
  },
  [508] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1628),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(2002),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [509] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2246),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [510] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2250),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [511] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1770),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [512] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1782),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [513] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1580),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [514] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2107),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [515] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1935),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [516] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1529),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [517] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1634),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [518] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1788),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [519] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2280),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [520] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2193),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [521] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2223),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [522] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2299),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [523] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2307),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [524] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2310),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [525] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2218),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [526] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1933),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [527] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1928),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [528] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2172),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [529] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1345),
    [sym_expression] = STATE(1927),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4830),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4830),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4828),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1345),
    [sym_subscript_expression] = STATE(1345),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2866),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4830),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1345),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(358),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_export] = ACTIONS(934),
    [anon_sym_type] = ACTIONS(934),
    [anon_sym_namespace] = ACTIONS(936),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(958),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_BANG] = ACTIONS(942),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(944),
    [anon_sym_of] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(946),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(950),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(958),
    [anon_sym_DASH] = ACTIONS(958),
    [anon_sym_TILDE] = ACTIONS(942),
    [anon_sym_void] = ACTIONS(958),
    [anon_sym_delete] = ACTIONS(958),
    [anon_sym_PLUS_PLUS] = ACTIONS(960),
    [anon_sym_DASH_DASH] = ACTIONS(960),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1262),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(934),
    [anon_sym_readonly] = ACTIONS(934),
    [anon_sym_get] = ACTIONS(934),
    [anon_sym_set] = ACTIONS(934),
    [anon_sym_declare] = ACTIONS(934),
    [anon_sym_public] = ACTIONS(934),
    [anon_sym_private] = ACTIONS(934),
    [anon_sym_protected] = ACTIONS(934),
    [anon_sym_override] = ACTIONS(934),
    [anon_sym_module] = ACTIONS(934),
    [anon_sym_any] = ACTIONS(934),
    [anon_sym_number] = ACTIONS(934),
    [anon_sym_boolean] = ACTIONS(934),
    [anon_sym_string] = ACTIONS(934),
    [anon_sym_symbol] = ACTIONS(934),
    [anon_sym_property] = ACTIONS(934),
    [anon_sym_signal] = ACTIONS(934),
    [anon_sym_on] = ACTIONS(934),
    [anon_sym_required] = ACTIONS(934),
    [anon_sym_component] = ACTIONS(934),
  },
  [530] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_expression] = STATE(2365),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4962),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4962),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4895),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1175),
    [sym_subscript_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2865),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4962),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1175),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(463),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_export] = ACTIONS(978),
    [anon_sym_type] = ACTIONS(978),
    [anon_sym_namespace] = ACTIONS(980),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(82),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(978),
    [anon_sym_BANG] = ACTIONS(78),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(43),
    [anon_sym_of] = ACTIONS(978),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(988),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(82),
    [anon_sym_DASH] = ACTIONS(82),
    [anon_sym_TILDE] = ACTIONS(78),
    [anon_sym_void] = ACTIONS(82),
    [anon_sym_delete] = ACTIONS(82),
    [anon_sym_PLUS_PLUS] = ACTIONS(782),
    [anon_sym_DASH_DASH] = ACTIONS(782),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(1992),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1290),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(978),
    [anon_sym_readonly] = ACTIONS(978),
    [anon_sym_get] = ACTIONS(978),
    [anon_sym_set] = ACTIONS(978),
    [anon_sym_declare] = ACTIONS(978),
    [anon_sym_public] = ACTIONS(978),
    [anon_sym_private] = ACTIONS(978),
    [anon_sym_protected] = ACTIONS(978),
    [anon_sym_override] = ACTIONS(978),
    [anon_sym_module] = ACTIONS(978),
    [anon_sym_any] = ACTIONS(978),
    [anon_sym_number] = ACTIONS(978),
    [anon_sym_boolean] = ACTIONS(978),
    [anon_sym_string] = ACTIONS(978),
    [anon_sym_symbol] = ACTIONS(978),
    [anon_sym_property] = ACTIONS(978),
    [anon_sym_signal] = ACTIONS(978),
    [anon_sym_on] = ACTIONS(978),
    [anon_sym_required] = ACTIONS(978),
    [anon_sym_component] = ACTIONS(978),
  },
  [531] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2183),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [532] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2177),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [533] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2170),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [534] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2311),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [535] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2228),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [536] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2226),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [537] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2279),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [538] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2164),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [539] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2162),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [540] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2309),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [541] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1285),
    [sym_expression] = STATE(1629),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4736),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4736),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4737),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1285),
    [sym_subscript_expression] = STATE(1285),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2861),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4736),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1285),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(516),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_export] = ACTIONS(842),
    [anon_sym_type] = ACTIONS(842),
    [anon_sym_namespace] = ACTIONS(844),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(678),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_BANG] = ACTIONS(652),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(654),
    [anon_sym_of] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(850),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1228),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_TILDE] = ACTIONS(652),
    [anon_sym_void] = ACTIONS(678),
    [anon_sym_delete] = ACTIONS(678),
    [anon_sym_PLUS_PLUS] = ACTIONS(680),
    [anon_sym_DASH_DASH] = ACTIONS(680),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1232),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(842),
    [anon_sym_readonly] = ACTIONS(842),
    [anon_sym_get] = ACTIONS(842),
    [anon_sym_set] = ACTIONS(842),
    [anon_sym_declare] = ACTIONS(842),
    [anon_sym_public] = ACTIONS(842),
    [anon_sym_private] = ACTIONS(842),
    [anon_sym_protected] = ACTIONS(842),
    [anon_sym_override] = ACTIONS(842),
    [anon_sym_module] = ACTIONS(842),
    [anon_sym_any] = ACTIONS(842),
    [anon_sym_number] = ACTIONS(842),
    [anon_sym_boolean] = ACTIONS(842),
    [anon_sym_string] = ACTIONS(842),
    [anon_sym_symbol] = ACTIONS(842),
    [anon_sym_property] = ACTIONS(842),
    [anon_sym_signal] = ACTIONS(842),
    [anon_sym_on] = ACTIONS(842),
    [anon_sym_required] = ACTIONS(842),
    [anon_sym_component] = ACTIONS(842),
  },
  [542] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2308),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [543] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2306),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [544] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2160),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [545] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1722),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(2004),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [546] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2305),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [547] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1813),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [548] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2281),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [549] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1901),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [550] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2283),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [551] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2130),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [552] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2276),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [553] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2234),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [554] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1794),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [555] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1707),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [556] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1794),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(2004),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [557] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1722),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [558] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2243),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [559] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2304),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [560] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2129),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [561] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1815),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [562] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2127),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [563] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2141),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [564] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1737),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [565] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2229),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(1992),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [566] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1351),
    [sym_expression] = STATE(2229),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4637),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4637),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4746),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1351),
    [sym_subscript_expression] = STATE(1351),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2863),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4637),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1351),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(434),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_export] = ACTIONS(1008),
    [anon_sym_type] = ACTIONS(1008),
    [anon_sym_namespace] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1268),
    [anon_sym_typeof] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1008),
    [anon_sym_BANG] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1018),
    [anon_sym_of] = ACTIONS(1008),
    [anon_sym_yield] = ACTIONS(1020),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1022),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1030),
    [anon_sym_DASH] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1016),
    [anon_sym_void] = ACTIONS(1030),
    [anon_sym_delete] = ACTIONS(1030),
    [anon_sym_PLUS_PLUS] = ACTIONS(1032),
    [anon_sym_DASH_DASH] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1008),
    [anon_sym_readonly] = ACTIONS(1008),
    [anon_sym_get] = ACTIONS(1008),
    [anon_sym_set] = ACTIONS(1008),
    [anon_sym_declare] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1008),
    [anon_sym_private] = ACTIONS(1008),
    [anon_sym_protected] = ACTIONS(1008),
    [anon_sym_override] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1008),
    [anon_sym_any] = ACTIONS(1008),
    [anon_sym_number] = ACTIONS(1008),
    [anon_sym_boolean] = ACTIONS(1008),
    [anon_sym_string] = ACTIONS(1008),
    [anon_sym_symbol] = ACTIONS(1008),
    [anon_sym_property] = ACTIONS(1008),
    [anon_sym_signal] = ACTIONS(1008),
    [anon_sym_on] = ACTIONS(1008),
    [anon_sym_required] = ACTIONS(1008),
    [anon_sym_component] = ACTIONS(1008),
  },
  [567] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2285),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [568] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2120),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [569] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1694),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [570] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1705),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [571] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1696),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [572] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1699),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [573] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_expression] = STATE(1670),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4732),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4732),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4734),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1304),
    [sym_subscript_expression] = STATE(1304),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2876),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4732),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1304),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(428),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1234),
    [anon_sym_export] = ACTIONS(892),
    [anon_sym_type] = ACTIONS(892),
    [anon_sym_namespace] = ACTIONS(894),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(145),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(892),
    [anon_sym_BANG] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_of] = ACTIONS(892),
    [anon_sym_yield] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(908),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(145),
    [anon_sym_DASH] = ACTIONS(145),
    [anon_sym_TILDE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(145),
    [anon_sym_delete] = ACTIONS(145),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(892),
    [anon_sym_readonly] = ACTIONS(892),
    [anon_sym_get] = ACTIONS(892),
    [anon_sym_set] = ACTIONS(892),
    [anon_sym_declare] = ACTIONS(892),
    [anon_sym_public] = ACTIONS(892),
    [anon_sym_private] = ACTIONS(892),
    [anon_sym_protected] = ACTIONS(892),
    [anon_sym_override] = ACTIONS(892),
    [anon_sym_module] = ACTIONS(892),
    [anon_sym_any] = ACTIONS(892),
    [anon_sym_number] = ACTIONS(892),
    [anon_sym_boolean] = ACTIONS(892),
    [anon_sym_string] = ACTIONS(892),
    [anon_sym_symbol] = ACTIONS(892),
    [anon_sym_property] = ACTIONS(892),
    [anon_sym_signal] = ACTIONS(892),
    [anon_sym_on] = ACTIONS(892),
    [anon_sym_required] = ACTIONS(892),
    [anon_sym_component] = ACTIONS(892),
  },
  [574] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2134),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [575] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2290),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [576] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2105),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [577] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2104),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [578] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2096),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [579] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2097),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [580] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1700),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [581] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2189),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [582] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2291),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [583] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2116),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [584] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1354),
    [sym_expression] = STATE(2117),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4912),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4912),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4902),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1354),
    [sym_subscript_expression] = STATE(1354),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2878),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4912),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1354),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(528),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_export] = ACTIONS(1076),
    [anon_sym_type] = ACTIONS(1076),
    [anon_sym_namespace] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(714),
    [anon_sym_typeof] = ACTIONS(1098),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1076),
    [anon_sym_BANG] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1084),
    [anon_sym_of] = ACTIONS(1076),
    [anon_sym_yield] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1088),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1098),
    [anon_sym_DASH] = ACTIONS(1098),
    [anon_sym_TILDE] = ACTIONS(1082),
    [anon_sym_void] = ACTIONS(1098),
    [anon_sym_delete] = ACTIONS(1098),
    [anon_sym_PLUS_PLUS] = ACTIONS(1100),
    [anon_sym_DASH_DASH] = ACTIONS(1100),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1298),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1076),
    [anon_sym_readonly] = ACTIONS(1076),
    [anon_sym_get] = ACTIONS(1076),
    [anon_sym_set] = ACTIONS(1076),
    [anon_sym_declare] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_override] = ACTIONS(1076),
    [anon_sym_module] = ACTIONS(1076),
    [anon_sym_any] = ACTIONS(1076),
    [anon_sym_number] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1076),
    [anon_sym_symbol] = ACTIONS(1076),
    [anon_sym_property] = ACTIONS(1076),
    [anon_sym_signal] = ACTIONS(1076),
    [anon_sym_on] = ACTIONS(1076),
    [anon_sym_required] = ACTIONS(1076),
    [anon_sym_component] = ACTIONS(1076),
  },
  [585] = {
    [sym_import] = STATE(2236),
    [sym_parenthesized_expression] = STATE(1311),
    [sym_expression] = STATE(1701),
    [sym_primary_expression] = STATE(1969),
    [sym_yield_expression] = STATE(2210),
    [sym_object] = STATE(2236),
    [sym_object_pattern] = STATE(4760),
    [sym_array] = STATE(2236),
    [sym_array_pattern] = STATE(4760),
    [sym_glimmer_template] = STATE(2210),
    [sym_glimmer_opening_tag] = STATE(3889),
    [sym_class] = STATE(2236),
    [sym_function] = STATE(2236),
    [sym_generator_function] = STATE(2236),
    [sym_arrow_function] = STATE(2236),
    [sym__call_signature] = STATE(4756),
    [sym_call_expression] = STATE(2236),
    [sym_new_expression] = STATE(2210),
    [sym_await_expression] = STATE(2210),
    [sym_member_expression] = STATE(1311),
    [sym_subscript_expression] = STATE(1311),
    [sym_assignment_expression] = STATE(2210),
    [sym__augmented_assignment_lhs] = STATE(2856),
    [sym_augmented_assignment_expression] = STATE(2210),
    [sym__destructuring_pattern] = STATE(4760),
    [sym_ternary_expression] = STATE(2210),
    [sym_binary_expression] = STATE(2210),
    [sym_unary_expression] = STATE(2210),
    [sym_update_expression] = STATE(2210),
    [sym_string] = STATE(2236),
    [sym_template_string] = STATE(2236),
    [sym_regex] = STATE(2236),
    [sym_meta_property] = STATE(2236),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1311),
    [sym_type_assertion] = STATE(2210),
    [sym_as_expression] = STATE(2210),
    [sym_internal_module] = STATE(2210),
    [sym_type_arguments] = STATE(466),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3887),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_export] = ACTIONS(1042),
    [anon_sym_type] = ACTIONS(1042),
    [anon_sym_namespace] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_typeof] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(900),
    [anon_sym_from] = ACTIONS(1042),
    [anon_sym_BANG] = ACTIONS(1048),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_await] = ACTIONS(1050),
    [anon_sym_of] = ACTIONS(1042),
    [anon_sym_yield] = ACTIONS(1052),
    [anon_sym_LBRACK] = ACTIONS(341),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(906),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_new] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1064),
    [anon_sym_DASH] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_void] = ACTIONS(1064),
    [anon_sym_delete] = ACTIONS(1064),
    [anon_sym_PLUS_PLUS] = ACTIONS(1066),
    [anon_sym_DASH_DASH] = ACTIONS(1066),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [sym_number] = ACTIONS(345),
    [sym_this] = ACTIONS(217),
    [sym_super] = ACTIONS(217),
    [sym_true] = ACTIONS(217),
    [sym_false] = ACTIONS(217),
    [sym_null] = ACTIONS(217),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1042),
    [anon_sym_readonly] = ACTIONS(1042),
    [anon_sym_get] = ACTIONS(1042),
    [anon_sym_set] = ACTIONS(1042),
    [anon_sym_declare] = ACTIONS(1042),
    [anon_sym_public] = ACTIONS(1042),
    [anon_sym_private] = ACTIONS(1042),
    [anon_sym_protected] = ACTIONS(1042),
    [anon_sym_override] = ACTIONS(1042),
    [anon_sym_module] = ACTIONS(1042),
    [anon_sym_any] = ACTIONS(1042),
    [anon_sym_number] = ACTIONS(1042),
    [anon_sym_boolean] = ACTIONS(1042),
    [anon_sym_string] = ACTIONS(1042),
    [anon_sym_symbol] = ACTIONS(1042),
    [anon_sym_property] = ACTIONS(1042),
    [anon_sym_signal] = ACTIONS(1042),
    [anon_sym_on] = ACTIONS(1042),
    [anon_sym_required] = ACTIONS(1042),
    [anon_sym_component] = ACTIONS(1042),
  },
  [586] = {
    [sym_import] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1356),
    [sym_expression] = STATE(2303),
    [sym_primary_expression] = STATE(1562),
    [sym_yield_expression] = STATE(1751),
    [sym_object] = STATE(1752),
    [sym_object_pattern] = STATE(4748),
    [sym_array] = STATE(1752),
    [sym_array_pattern] = STATE(4748),
    [sym_glimmer_template] = STATE(1751),
    [sym_glimmer_opening_tag] = STATE(3874),
    [sym_class] = STATE(1752),
    [sym_function] = STATE(1752),
    [sym_generator_function] = STATE(1752),
    [sym_arrow_function] = STATE(1752),
    [sym__call_signature] = STATE(4640),
    [sym_call_expression] = STATE(1752),
    [sym_new_expression] = STATE(1751),
    [sym_await_expression] = STATE(1751),
    [sym_member_expression] = STATE(1356),
    [sym_subscript_expression] = STATE(1356),
    [sym_assignment_expression] = STATE(1751),
    [sym__augmented_assignment_lhs] = STATE(2842),
    [sym_augmented_assignment_expression] = STATE(1751),
    [sym__destructuring_pattern] = STATE(4748),
    [sym_ternary_expression] = STATE(1751),
    [sym_binary_expression] = STATE(1751),
    [sym_unary_expression] = STATE(1751),
    [sym_update_expression] = STATE(1751),
    [sym_string] = STATE(1752),
    [sym_template_string] = STATE(1752),
    [sym_regex] = STATE(1752),
    [sym_meta_property] = STATE(1752),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3479),
    [sym_non_null_expression] = STATE(1356),
    [sym_type_assertion] = STATE(1751),
    [sym_as_expression] = STATE(1751),
    [sym_internal_module] = STATE(1751),
    [sym_type_arguments] = STATE(537),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_export_statement_repeat1] = STATE(3866),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_export] = ACTIONS(1110),
    [anon_sym_type] = ACTIONS(1110),
    [anon_sym_namespace] = ACTIONS(1112),
    [anon_sym_LBRACE] = ACTIONS(1220),
    [anon_sym_typeof] = ACTIONS(1132),
    [anon_sym_import] = ACTIONS(36),
    [anon_sym_from] = ACTIONS(1110),
    [anon_sym_BANG] = ACTIONS(1118),
    [anon_sym_LPAREN] = ACTIONS(1224),
    [anon_sym_await] = ACTIONS(1120),
    [anon_sym_of] = ACTIONS(1110),
    [anon_sym_yield] = ACTIONS(1122),
    [anon_sym_LBRACK] = ACTIONS(1226),
    [anon_sym_LTtemplate_GT] = ACTIONS(49),
    [anon_sym_LT] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(662),
    [anon_sym_class] = ACTIONS(56),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_function] = ACTIONS(60),
    [anon_sym_new] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_TILDE] = ACTIONS(1118),
    [anon_sym_void] = ACTIONS(1132),
    [anon_sym_delete] = ACTIONS(1132),
    [anon_sym_PLUS_PLUS] = ACTIONS(1134),
    [anon_sym_DASH_DASH] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_number] = ACTIONS(730),
    [sym_this] = ACTIONS(97),
    [sym_super] = ACTIONS(97),
    [sym_true] = ACTIONS(97),
    [sym_false] = ACTIONS(97),
    [sym_null] = ACTIONS(97),
    [sym_undefined] = ACTIONS(1282),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(1110),
    [anon_sym_readonly] = ACTIONS(1110),
    [anon_sym_get] = ACTIONS(1110),
    [anon_sym_set] = ACTIONS(1110),
    [anon_sym_declare] = ACTIONS(1110),
    [anon_sym_public] = ACTIONS(1110),
    [anon_sym_private] = ACTIONS(1110),
    [anon_sym_protected] = ACTIONS(1110),
    [anon_sym_override] = ACTIONS(1110),
    [anon_sym_module] = ACTIONS(1110),
    [anon_sym_any] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_boolean] = ACTIONS(1110),
    [anon_sym_string] = ACTIONS(1110),
    [anon_sym_symbol] = ACTIONS(1110),
    [anon_sym_property] = ACTIONS(1110),
    [anon_sym_signal] = ACTIONS(1110),
    [anon_sym_on] = ACTIONS(1110),
    [anon_sym_required] = ACTIONS(1110),
    [anon_sym_component] = ACTIONS(1110),
  },
  [587] = {
    [sym__call_signature] = STATE(4803),
    [sym_string] = STATE(3460),
    [sym_formal_parameters] = STATE(3479),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2006),
    [anon_sym_export] = ACTIONS(2008),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_type] = ACTIONS(2008),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2008),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(2008),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2027),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2008),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2008),
    [anon_sym_readonly] = ACTIONS(2008),
    [anon_sym_get] = ACTIONS(2035),
    [anon_sym_set] = ACTIONS(2035),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2008),
    [anon_sym_public] = ACTIONS(2008),
    [anon_sym_private] = ACTIONS(2008),
    [anon_sym_protected] = ACTIONS(2008),
    [anon_sym_override] = ACTIONS(2008),
    [anon_sym_module] = ACTIONS(2008),
    [anon_sym_any] = ACTIONS(2008),
    [anon_sym_number] = ACTIONS(2008),
    [anon_sym_boolean] = ACTIONS(2008),
    [anon_sym_string] = ACTIONS(2008),
    [anon_sym_symbol] = ACTIONS(2008),
    [anon_sym_property] = ACTIONS(2008),
    [anon_sym_signal] = ACTIONS(2008),
    [anon_sym_on] = ACTIONS(2008),
    [anon_sym_required] = ACTIONS(2008),
    [anon_sym_component] = ACTIONS(2008),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [588] = {
    [sym__call_signature] = STATE(4803),
    [sym_string] = STATE(3460),
    [sym_formal_parameters] = STATE(3479),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2006),
    [anon_sym_export] = ACTIONS(2008),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_type] = ACTIONS(2008),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2008),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2039),
    [anon_sym_from] = ACTIONS(2008),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2027),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2008),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2008),
    [anon_sym_readonly] = ACTIONS(2008),
    [anon_sym_get] = ACTIONS(2035),
    [anon_sym_set] = ACTIONS(2035),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2008),
    [anon_sym_public] = ACTIONS(2008),
    [anon_sym_private] = ACTIONS(2008),
    [anon_sym_protected] = ACTIONS(2008),
    [anon_sym_override] = ACTIONS(2008),
    [anon_sym_module] = ACTIONS(2008),
    [anon_sym_any] = ACTIONS(2008),
    [anon_sym_number] = ACTIONS(2008),
    [anon_sym_boolean] = ACTIONS(2008),
    [anon_sym_string] = ACTIONS(2008),
    [anon_sym_symbol] = ACTIONS(2008),
    [anon_sym_property] = ACTIONS(2008),
    [anon_sym_signal] = ACTIONS(2008),
    [anon_sym_on] = ACTIONS(2008),
    [anon_sym_required] = ACTIONS(2008),
    [anon_sym_component] = ACTIONS(2008),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [589] = {
    [sym__call_signature] = STATE(4803),
    [sym_string] = STATE(3460),
    [sym_formal_parameters] = STATE(3479),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2006),
    [anon_sym_export] = ACTIONS(2008),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_type] = ACTIONS(2008),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2008),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_from] = ACTIONS(2008),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2027),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2008),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2008),
    [anon_sym_readonly] = ACTIONS(2008),
    [anon_sym_get] = ACTIONS(2035),
    [anon_sym_set] = ACTIONS(2035),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2008),
    [anon_sym_public] = ACTIONS(2008),
    [anon_sym_private] = ACTIONS(2008),
    [anon_sym_protected] = ACTIONS(2008),
    [anon_sym_override] = ACTIONS(2008),
    [anon_sym_module] = ACTIONS(2008),
    [anon_sym_any] = ACTIONS(2008),
    [anon_sym_number] = ACTIONS(2008),
    [anon_sym_boolean] = ACTIONS(2008),
    [anon_sym_string] = ACTIONS(2008),
    [anon_sym_symbol] = ACTIONS(2008),
    [anon_sym_property] = ACTIONS(2008),
    [anon_sym_signal] = ACTIONS(2008),
    [anon_sym_on] = ACTIONS(2008),
    [anon_sym_required] = ACTIONS(2008),
    [anon_sym_component] = ACTIONS(2008),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [590] = {
    [sym__call_signature] = STATE(4803),
    [sym_string] = STATE(3460),
    [sym_formal_parameters] = STATE(3479),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [sym_type_parameters] = STATE(4523),
    [aux_sym_object_repeat1] = STATE(4186),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2006),
    [anon_sym_export] = ACTIONS(2008),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_type] = ACTIONS(2008),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2008),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2043),
    [anon_sym_from] = ACTIONS(2008),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2017),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2008),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2027),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2008),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2008),
    [anon_sym_readonly] = ACTIONS(2008),
    [anon_sym_get] = ACTIONS(2035),
    [anon_sym_set] = ACTIONS(2035),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2008),
    [anon_sym_public] = ACTIONS(2008),
    [anon_sym_private] = ACTIONS(2008),
    [anon_sym_protected] = ACTIONS(2008),
    [anon_sym_override] = ACTIONS(2008),
    [anon_sym_module] = ACTIONS(2008),
    [anon_sym_any] = ACTIONS(2008),
    [anon_sym_number] = ACTIONS(2008),
    [anon_sym_boolean] = ACTIONS(2008),
    [anon_sym_string] = ACTIONS(2008),
    [anon_sym_symbol] = ACTIONS(2008),
    [anon_sym_property] = ACTIONS(2008),
    [anon_sym_signal] = ACTIONS(2008),
    [anon_sym_on] = ACTIONS(2008),
    [anon_sym_required] = ACTIONS(2008),
    [anon_sym_component] = ACTIONS(2008),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [591] = {
    [sym_export_clause] = STATE(3923),
    [sym_declaration] = STATE(845),
    [sym_namespace_import_export] = STATE(4364),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_class_declaration] = STATE(826),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function_declaration] = STATE(826),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(826),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(840),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [aux_sym_export_statement_repeat1] = STATE(3695),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [anon_sym_STAR] = ACTIONS(2045),
    [anon_sym_default] = ACTIONS(2047),
    [anon_sym_type] = ACTIONS(2049),
    [anon_sym_EQ] = ACTIONS(2051),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2039),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_function] = ACTIONS(2077),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2079),
    [anon_sym_module] = ACTIONS(2081),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2087),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [592] = {
    [sym_export_clause] = STATE(3923),
    [sym_declaration] = STATE(845),
    [sym_namespace_import_export] = STATE(4364),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_class_declaration] = STATE(826),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function_declaration] = STATE(826),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(826),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(840),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [aux_sym_export_statement_repeat1] = STATE(3695),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [anon_sym_STAR] = ACTIONS(2045),
    [anon_sym_default] = ACTIONS(2047),
    [anon_sym_type] = ACTIONS(2049),
    [anon_sym_EQ] = ACTIONS(2051),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_function] = ACTIONS(2077),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2079),
    [anon_sym_module] = ACTIONS(2081),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2087),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [593] = {
    [sym_export_clause] = STATE(3923),
    [sym_declaration] = STATE(845),
    [sym_namespace_import_export] = STATE(4364),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_class_declaration] = STATE(826),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function_declaration] = STATE(826),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(826),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(840),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [aux_sym_export_statement_repeat1] = STATE(3695),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [anon_sym_STAR] = ACTIONS(2045),
    [anon_sym_default] = ACTIONS(2047),
    [anon_sym_type] = ACTIONS(2049),
    [anon_sym_EQ] = ACTIONS(2051),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2015),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_function] = ACTIONS(2077),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2079),
    [anon_sym_module] = ACTIONS(2081),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2087),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [594] = {
    [sym_export_clause] = STATE(3923),
    [sym_declaration] = STATE(845),
    [sym_namespace_import_export] = STATE(4364),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_class_declaration] = STATE(826),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function_declaration] = STATE(826),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(826),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(840),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [aux_sym_export_statement_repeat1] = STATE(3695),
    [aux_sym_object_repeat1] = STATE(4186),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [anon_sym_STAR] = ACTIONS(2045),
    [anon_sym_default] = ACTIONS(2047),
    [anon_sym_type] = ACTIONS(2049),
    [anon_sym_EQ] = ACTIONS(2051),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2043),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_function] = ACTIONS(2077),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2079),
    [anon_sym_module] = ACTIONS(2081),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2087),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [595] = {
    [sym_string] = STATE(3460),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [sym_override_modifier] = STATE(2502),
    [aux_sym_object_repeat1] = STATE(4186),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_export] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2043),
    [anon_sym_from] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2089),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2091),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2089),
    [anon_sym_readonly] = ACTIONS(2093),
    [anon_sym_get] = ACTIONS(2095),
    [anon_sym_set] = ACTIONS(2095),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2089),
    [anon_sym_public] = ACTIONS(2089),
    [anon_sym_private] = ACTIONS(2089),
    [anon_sym_protected] = ACTIONS(2089),
    [anon_sym_override] = ACTIONS(2097),
    [anon_sym_module] = ACTIONS(2089),
    [anon_sym_any] = ACTIONS(2089),
    [anon_sym_number] = ACTIONS(2089),
    [anon_sym_boolean] = ACTIONS(2089),
    [anon_sym_string] = ACTIONS(2089),
    [anon_sym_symbol] = ACTIONS(2089),
    [anon_sym_property] = ACTIONS(2089),
    [anon_sym_signal] = ACTIONS(2089),
    [anon_sym_on] = ACTIONS(2089),
    [anon_sym_required] = ACTIONS(2089),
    [anon_sym_component] = ACTIONS(2089),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [596] = {
    [sym_string] = STATE(3460),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [sym_override_modifier] = STATE(2502),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_export] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2089),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2091),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2089),
    [anon_sym_readonly] = ACTIONS(2093),
    [anon_sym_get] = ACTIONS(2095),
    [anon_sym_set] = ACTIONS(2095),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2089),
    [anon_sym_public] = ACTIONS(2089),
    [anon_sym_private] = ACTIONS(2089),
    [anon_sym_protected] = ACTIONS(2089),
    [anon_sym_override] = ACTIONS(2097),
    [anon_sym_module] = ACTIONS(2089),
    [anon_sym_any] = ACTIONS(2089),
    [anon_sym_number] = ACTIONS(2089),
    [anon_sym_boolean] = ACTIONS(2089),
    [anon_sym_string] = ACTIONS(2089),
    [anon_sym_symbol] = ACTIONS(2089),
    [anon_sym_property] = ACTIONS(2089),
    [anon_sym_signal] = ACTIONS(2089),
    [anon_sym_on] = ACTIONS(2089),
    [anon_sym_required] = ACTIONS(2089),
    [anon_sym_component] = ACTIONS(2089),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [597] = {
    [sym_string] = STATE(3460),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [sym_override_modifier] = STATE(2502),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_export] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2039),
    [anon_sym_from] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2089),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2091),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2089),
    [anon_sym_readonly] = ACTIONS(2093),
    [anon_sym_get] = ACTIONS(2095),
    [anon_sym_set] = ACTIONS(2095),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2089),
    [anon_sym_public] = ACTIONS(2089),
    [anon_sym_private] = ACTIONS(2089),
    [anon_sym_protected] = ACTIONS(2089),
    [anon_sym_override] = ACTIONS(2097),
    [anon_sym_module] = ACTIONS(2089),
    [anon_sym_any] = ACTIONS(2089),
    [anon_sym_number] = ACTIONS(2089),
    [anon_sym_boolean] = ACTIONS(2089),
    [anon_sym_string] = ACTIONS(2089),
    [anon_sym_symbol] = ACTIONS(2089),
    [anon_sym_property] = ACTIONS(2089),
    [anon_sym_signal] = ACTIONS(2089),
    [anon_sym_on] = ACTIONS(2089),
    [anon_sym_required] = ACTIONS(2089),
    [anon_sym_component] = ACTIONS(2089),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [598] = {
    [sym_string] = STATE(3460),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [sym_override_modifier] = STATE(2502),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_export] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_from] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2089),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2091),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2089),
    [anon_sym_readonly] = ACTIONS(2093),
    [anon_sym_get] = ACTIONS(2095),
    [anon_sym_set] = ACTIONS(2095),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2089),
    [anon_sym_public] = ACTIONS(2089),
    [anon_sym_private] = ACTIONS(2089),
    [anon_sym_protected] = ACTIONS(2089),
    [anon_sym_override] = ACTIONS(2097),
    [anon_sym_module] = ACTIONS(2089),
    [anon_sym_any] = ACTIONS(2089),
    [anon_sym_number] = ACTIONS(2089),
    [anon_sym_boolean] = ACTIONS(2089),
    [anon_sym_string] = ACTIONS(2089),
    [anon_sym_symbol] = ACTIONS(2089),
    [anon_sym_property] = ACTIONS(2089),
    [anon_sym_signal] = ACTIONS(2089),
    [anon_sym_on] = ACTIONS(2089),
    [anon_sym_required] = ACTIONS(2089),
    [anon_sym_component] = ACTIONS(2089),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [599] = {
    [sym_string] = STATE(3460),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_export] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_from] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2089),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2089),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2089),
    [anon_sym_readonly] = ACTIONS(2089),
    [anon_sym_get] = ACTIONS(2089),
    [anon_sym_set] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2089),
    [anon_sym_public] = ACTIONS(2089),
    [anon_sym_private] = ACTIONS(2089),
    [anon_sym_protected] = ACTIONS(2089),
    [anon_sym_override] = ACTIONS(2089),
    [anon_sym_module] = ACTIONS(2089),
    [anon_sym_any] = ACTIONS(2089),
    [anon_sym_number] = ACTIONS(2089),
    [anon_sym_boolean] = ACTIONS(2089),
    [anon_sym_string] = ACTIONS(2089),
    [anon_sym_symbol] = ACTIONS(2089),
    [anon_sym_property] = ACTIONS(2089),
    [anon_sym_signal] = ACTIONS(2089),
    [anon_sym_on] = ACTIONS(2089),
    [anon_sym_required] = ACTIONS(2089),
    [anon_sym_component] = ACTIONS(2089),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [600] = {
    [sym_string] = STATE(3460),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_export] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2039),
    [anon_sym_from] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2089),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2091),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2089),
    [anon_sym_readonly] = ACTIONS(2089),
    [anon_sym_get] = ACTIONS(2095),
    [anon_sym_set] = ACTIONS(2095),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2089),
    [anon_sym_public] = ACTIONS(2089),
    [anon_sym_private] = ACTIONS(2089),
    [anon_sym_protected] = ACTIONS(2089),
    [anon_sym_override] = ACTIONS(2089),
    [anon_sym_module] = ACTIONS(2089),
    [anon_sym_any] = ACTIONS(2089),
    [anon_sym_number] = ACTIONS(2089),
    [anon_sym_boolean] = ACTIONS(2089),
    [anon_sym_string] = ACTIONS(2089),
    [anon_sym_symbol] = ACTIONS(2089),
    [anon_sym_property] = ACTIONS(2089),
    [anon_sym_signal] = ACTIONS(2089),
    [anon_sym_on] = ACTIONS(2089),
    [anon_sym_required] = ACTIONS(2089),
    [anon_sym_component] = ACTIONS(2089),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [601] = {
    [sym_string] = STATE(3460),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_export] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2039),
    [anon_sym_from] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2089),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2089),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2089),
    [anon_sym_readonly] = ACTIONS(2089),
    [anon_sym_get] = ACTIONS(2089),
    [anon_sym_set] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2089),
    [anon_sym_public] = ACTIONS(2089),
    [anon_sym_private] = ACTIONS(2089),
    [anon_sym_protected] = ACTIONS(2089),
    [anon_sym_override] = ACTIONS(2089),
    [anon_sym_module] = ACTIONS(2089),
    [anon_sym_any] = ACTIONS(2089),
    [anon_sym_number] = ACTIONS(2089),
    [anon_sym_boolean] = ACTIONS(2089),
    [anon_sym_string] = ACTIONS(2089),
    [anon_sym_symbol] = ACTIONS(2089),
    [anon_sym_property] = ACTIONS(2089),
    [anon_sym_signal] = ACTIONS(2089),
    [anon_sym_on] = ACTIONS(2089),
    [anon_sym_required] = ACTIONS(2089),
    [anon_sym_component] = ACTIONS(2089),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [602] = {
    [sym_string] = STATE(3460),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_export] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2089),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2091),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2089),
    [anon_sym_readonly] = ACTIONS(2089),
    [anon_sym_get] = ACTIONS(2095),
    [anon_sym_set] = ACTIONS(2095),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2089),
    [anon_sym_public] = ACTIONS(2089),
    [anon_sym_private] = ACTIONS(2089),
    [anon_sym_protected] = ACTIONS(2089),
    [anon_sym_override] = ACTIONS(2089),
    [anon_sym_module] = ACTIONS(2089),
    [anon_sym_any] = ACTIONS(2089),
    [anon_sym_number] = ACTIONS(2089),
    [anon_sym_boolean] = ACTIONS(2089),
    [anon_sym_string] = ACTIONS(2089),
    [anon_sym_symbol] = ACTIONS(2089),
    [anon_sym_property] = ACTIONS(2089),
    [anon_sym_signal] = ACTIONS(2089),
    [anon_sym_on] = ACTIONS(2089),
    [anon_sym_required] = ACTIONS(2089),
    [anon_sym_component] = ACTIONS(2089),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [603] = {
    [sym_string] = STATE(3460),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_export] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2089),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2089),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2089),
    [anon_sym_readonly] = ACTIONS(2089),
    [anon_sym_get] = ACTIONS(2089),
    [anon_sym_set] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2089),
    [anon_sym_public] = ACTIONS(2089),
    [anon_sym_private] = ACTIONS(2089),
    [anon_sym_protected] = ACTIONS(2089),
    [anon_sym_override] = ACTIONS(2089),
    [anon_sym_module] = ACTIONS(2089),
    [anon_sym_any] = ACTIONS(2089),
    [anon_sym_number] = ACTIONS(2089),
    [anon_sym_boolean] = ACTIONS(2089),
    [anon_sym_string] = ACTIONS(2089),
    [anon_sym_symbol] = ACTIONS(2089),
    [anon_sym_property] = ACTIONS(2089),
    [anon_sym_signal] = ACTIONS(2089),
    [anon_sym_on] = ACTIONS(2089),
    [anon_sym_required] = ACTIONS(2089),
    [anon_sym_component] = ACTIONS(2089),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [604] = {
    [sym_string] = STATE(3460),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_export] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_from] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2089),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2091),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2089),
    [anon_sym_readonly] = ACTIONS(2089),
    [anon_sym_get] = ACTIONS(2095),
    [anon_sym_set] = ACTIONS(2095),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2089),
    [anon_sym_public] = ACTIONS(2089),
    [anon_sym_private] = ACTIONS(2089),
    [anon_sym_protected] = ACTIONS(2089),
    [anon_sym_override] = ACTIONS(2089),
    [anon_sym_module] = ACTIONS(2089),
    [anon_sym_any] = ACTIONS(2089),
    [anon_sym_number] = ACTIONS(2089),
    [anon_sym_boolean] = ACTIONS(2089),
    [anon_sym_string] = ACTIONS(2089),
    [anon_sym_symbol] = ACTIONS(2089),
    [anon_sym_property] = ACTIONS(2089),
    [anon_sym_signal] = ACTIONS(2089),
    [anon_sym_on] = ACTIONS(2089),
    [anon_sym_required] = ACTIONS(2089),
    [anon_sym_component] = ACTIONS(2089),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [605] = {
    [sym_string] = STATE(3460),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [aux_sym_object_repeat1] = STATE(4186),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_export] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2043),
    [anon_sym_from] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2089),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2089),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2089),
    [anon_sym_readonly] = ACTIONS(2089),
    [anon_sym_get] = ACTIONS(2089),
    [anon_sym_set] = ACTIONS(2089),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2089),
    [anon_sym_public] = ACTIONS(2089),
    [anon_sym_private] = ACTIONS(2089),
    [anon_sym_protected] = ACTIONS(2089),
    [anon_sym_override] = ACTIONS(2089),
    [anon_sym_module] = ACTIONS(2089),
    [anon_sym_any] = ACTIONS(2089),
    [anon_sym_number] = ACTIONS(2089),
    [anon_sym_boolean] = ACTIONS(2089),
    [anon_sym_string] = ACTIONS(2089),
    [anon_sym_symbol] = ACTIONS(2089),
    [anon_sym_property] = ACTIONS(2089),
    [anon_sym_signal] = ACTIONS(2089),
    [anon_sym_on] = ACTIONS(2089),
    [anon_sym_required] = ACTIONS(2089),
    [anon_sym_component] = ACTIONS(2089),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [606] = {
    [sym_string] = STATE(3460),
    [sym__property_name] = STATE(3460),
    [sym_computed_property_name] = STATE(3460),
    [aux_sym_object_repeat1] = STATE(4186),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2089),
    [anon_sym_export] = ACTIONS(2089),
    [anon_sym_STAR] = ACTIONS(2010),
    [anon_sym_type] = ACTIONS(2089),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2089),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2043),
    [anon_sym_from] = ACTIONS(2089),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2089),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(2091),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(2033),
    [sym_private_property_identifier] = ACTIONS(2033),
    [anon_sym_static] = ACTIONS(2089),
    [anon_sym_readonly] = ACTIONS(2089),
    [anon_sym_get] = ACTIONS(2095),
    [anon_sym_set] = ACTIONS(2095),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2089),
    [anon_sym_public] = ACTIONS(2089),
    [anon_sym_private] = ACTIONS(2089),
    [anon_sym_protected] = ACTIONS(2089),
    [anon_sym_override] = ACTIONS(2089),
    [anon_sym_module] = ACTIONS(2089),
    [anon_sym_any] = ACTIONS(2089),
    [anon_sym_number] = ACTIONS(2089),
    [anon_sym_boolean] = ACTIONS(2089),
    [anon_sym_string] = ACTIONS(2089),
    [anon_sym_symbol] = ACTIONS(2089),
    [anon_sym_property] = ACTIONS(2089),
    [anon_sym_signal] = ACTIONS(2089),
    [anon_sym_on] = ACTIONS(2089),
    [anon_sym_required] = ACTIONS(2089),
    [anon_sym_component] = ACTIONS(2089),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [607] = {
    [sym_declaration] = STATE(776),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_class_declaration] = STATE(826),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function_declaration] = STATE(826),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(826),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(840),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [aux_sym_export_statement_repeat1] = STATE(3695),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_function] = ACTIONS(2077),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2079),
    [anon_sym_module] = ACTIONS(2101),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_global] = ACTIONS(2103),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2087),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [608] = {
    [sym_identifier] = ACTIONS(2105),
    [anon_sym_export] = ACTIONS(2105),
    [anon_sym_default] = ACTIONS(2105),
    [anon_sym_type] = ACTIONS(2105),
    [anon_sym_EQ] = ACTIONS(2105),
    [anon_sym_namespace] = ACTIONS(2105),
    [anon_sym_LBRACE] = ACTIONS(2107),
    [anon_sym_COMMA] = ACTIONS(2107),
    [anon_sym_RBRACE] = ACTIONS(2107),
    [anon_sym_typeof] = ACTIONS(2105),
    [anon_sym_import] = ACTIONS(2105),
    [anon_sym_from] = ACTIONS(2105),
    [anon_sym_var] = ACTIONS(2105),
    [anon_sym_let] = ACTIONS(2105),
    [anon_sym_const] = ACTIONS(2105),
    [anon_sym_BANG] = ACTIONS(2107),
    [anon_sym_else] = ACTIONS(2105),
    [anon_sym_if] = ACTIONS(2105),
    [anon_sym_switch] = ACTIONS(2105),
    [anon_sym_for] = ACTIONS(2105),
    [anon_sym_LPAREN] = ACTIONS(2107),
    [anon_sym_RPAREN] = ACTIONS(2107),
    [anon_sym_await] = ACTIONS(2105),
    [anon_sym_of] = ACTIONS(2105),
    [anon_sym_while] = ACTIONS(2105),
    [anon_sym_do] = ACTIONS(2105),
    [anon_sym_try] = ACTIONS(2105),
    [anon_sym_with] = ACTIONS(2105),
    [anon_sym_break] = ACTIONS(2105),
    [anon_sym_continue] = ACTIONS(2105),
    [anon_sym_debugger] = ACTIONS(2105),
    [anon_sym_return] = ACTIONS(2105),
    [anon_sym_throw] = ACTIONS(2105),
    [anon_sym_SEMI] = ACTIONS(2107),
    [anon_sym_COLON] = ACTIONS(2107),
    [anon_sym_case] = ACTIONS(2105),
    [anon_sym_yield] = ACTIONS(2105),
    [anon_sym_LBRACK] = ACTIONS(2107),
    [anon_sym_RBRACK] = ACTIONS(2107),
    [anon_sym_LTtemplate_GT] = ACTIONS(2107),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_GT] = ACTIONS(2107),
    [anon_sym_SLASH] = ACTIONS(2105),
    [anon_sym_class] = ACTIONS(2105),
    [anon_sym_async] = ACTIONS(2105),
    [anon_sym_function] = ACTIONS(2105),
    [anon_sym_EQ_GT] = ACTIONS(2107),
    [anon_sym_new] = ACTIONS(2105),
    [anon_sym_AMP] = ACTIONS(2107),
    [anon_sym_PIPE] = ACTIONS(2107),
    [anon_sym_PLUS] = ACTIONS(2105),
    [anon_sym_DASH] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2107),
    [anon_sym_void] = ACTIONS(2105),
    [anon_sym_delete] = ACTIONS(2105),
    [anon_sym_PLUS_PLUS] = ACTIONS(2107),
    [anon_sym_DASH_DASH] = ACTIONS(2107),
    [anon_sym_DQUOTE] = ACTIONS(2107),
    [anon_sym_SQUOTE] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2107),
    [sym_number] = ACTIONS(2107),
    [sym_this] = ACTIONS(2105),
    [sym_super] = ACTIONS(2105),
    [sym_true] = ACTIONS(2105),
    [sym_false] = ACTIONS(2105),
    [sym_null] = ACTIONS(2105),
    [sym_undefined] = ACTIONS(2105),
    [anon_sym_AT] = ACTIONS(2107),
    [anon_sym_static] = ACTIONS(2105),
    [anon_sym_readonly] = ACTIONS(2105),
    [anon_sym_get] = ACTIONS(2105),
    [anon_sym_set] = ACTIONS(2105),
    [anon_sym_QMARK] = ACTIONS(2107),
    [anon_sym_declare] = ACTIONS(2105),
    [anon_sym_public] = ACTIONS(2105),
    [anon_sym_private] = ACTIONS(2105),
    [anon_sym_protected] = ACTIONS(2105),
    [anon_sym_override] = ACTIONS(2105),
    [anon_sym_module] = ACTIONS(2105),
    [anon_sym_any] = ACTIONS(2105),
    [anon_sym_number] = ACTIONS(2105),
    [anon_sym_boolean] = ACTIONS(2105),
    [anon_sym_string] = ACTIONS(2105),
    [anon_sym_symbol] = ACTIONS(2105),
    [anon_sym_property] = ACTIONS(2105),
    [anon_sym_signal] = ACTIONS(2105),
    [anon_sym_on] = ACTIONS(2105),
    [anon_sym_required] = ACTIONS(2105),
    [anon_sym_component] = ACTIONS(2105),
    [anon_sym_abstract] = ACTIONS(2105),
    [anon_sym_extends] = ACTIONS(2105),
    [anon_sym_interface] = ACTIONS(2105),
    [anon_sym_enum] = ACTIONS(2105),
  },
  [609] = {
    [sym_identifier] = ACTIONS(2109),
    [anon_sym_export] = ACTIONS(2109),
    [anon_sym_default] = ACTIONS(2109),
    [anon_sym_type] = ACTIONS(2109),
    [anon_sym_EQ] = ACTIONS(2109),
    [anon_sym_namespace] = ACTIONS(2109),
    [anon_sym_LBRACE] = ACTIONS(2111),
    [anon_sym_COMMA] = ACTIONS(2111),
    [anon_sym_RBRACE] = ACTIONS(2111),
    [anon_sym_typeof] = ACTIONS(2109),
    [anon_sym_import] = ACTIONS(2109),
    [anon_sym_from] = ACTIONS(2109),
    [anon_sym_var] = ACTIONS(2109),
    [anon_sym_let] = ACTIONS(2109),
    [anon_sym_const] = ACTIONS(2109),
    [anon_sym_BANG] = ACTIONS(2111),
    [anon_sym_else] = ACTIONS(2109),
    [anon_sym_if] = ACTIONS(2109),
    [anon_sym_switch] = ACTIONS(2109),
    [anon_sym_for] = ACTIONS(2109),
    [anon_sym_LPAREN] = ACTIONS(2111),
    [anon_sym_RPAREN] = ACTIONS(2111),
    [anon_sym_await] = ACTIONS(2109),
    [anon_sym_of] = ACTIONS(2109),
    [anon_sym_while] = ACTIONS(2109),
    [anon_sym_do] = ACTIONS(2109),
    [anon_sym_try] = ACTIONS(2109),
    [anon_sym_with] = ACTIONS(2109),
    [anon_sym_break] = ACTIONS(2109),
    [anon_sym_continue] = ACTIONS(2109),
    [anon_sym_debugger] = ACTIONS(2109),
    [anon_sym_return] = ACTIONS(2109),
    [anon_sym_throw] = ACTIONS(2109),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_COLON] = ACTIONS(2111),
    [anon_sym_case] = ACTIONS(2109),
    [anon_sym_yield] = ACTIONS(2109),
    [anon_sym_LBRACK] = ACTIONS(2111),
    [anon_sym_RBRACK] = ACTIONS(2111),
    [anon_sym_LTtemplate_GT] = ACTIONS(2111),
    [anon_sym_LT] = ACTIONS(2109),
    [anon_sym_GT] = ACTIONS(2111),
    [anon_sym_SLASH] = ACTIONS(2109),
    [anon_sym_class] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(2109),
    [anon_sym_function] = ACTIONS(2109),
    [anon_sym_EQ_GT] = ACTIONS(2111),
    [anon_sym_new] = ACTIONS(2109),
    [anon_sym_AMP] = ACTIONS(2111),
    [anon_sym_PIPE] = ACTIONS(2111),
    [anon_sym_PLUS] = ACTIONS(2109),
    [anon_sym_DASH] = ACTIONS(2109),
    [anon_sym_TILDE] = ACTIONS(2111),
    [anon_sym_void] = ACTIONS(2109),
    [anon_sym_delete] = ACTIONS(2109),
    [anon_sym_PLUS_PLUS] = ACTIONS(2111),
    [anon_sym_DASH_DASH] = ACTIONS(2111),
    [anon_sym_DQUOTE] = ACTIONS(2111),
    [anon_sym_SQUOTE] = ACTIONS(2111),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2111),
    [sym_number] = ACTIONS(2111),
    [sym_this] = ACTIONS(2109),
    [sym_super] = ACTIONS(2109),
    [sym_true] = ACTIONS(2109),
    [sym_false] = ACTIONS(2109),
    [sym_null] = ACTIONS(2109),
    [sym_undefined] = ACTIONS(2109),
    [anon_sym_AT] = ACTIONS(2111),
    [anon_sym_static] = ACTIONS(2109),
    [anon_sym_readonly] = ACTIONS(2109),
    [anon_sym_get] = ACTIONS(2109),
    [anon_sym_set] = ACTIONS(2109),
    [anon_sym_QMARK] = ACTIONS(2111),
    [anon_sym_declare] = ACTIONS(2109),
    [anon_sym_public] = ACTIONS(2109),
    [anon_sym_private] = ACTIONS(2109),
    [anon_sym_protected] = ACTIONS(2109),
    [anon_sym_override] = ACTIONS(2109),
    [anon_sym_module] = ACTIONS(2109),
    [anon_sym_any] = ACTIONS(2109),
    [anon_sym_number] = ACTIONS(2109),
    [anon_sym_boolean] = ACTIONS(2109),
    [anon_sym_string] = ACTIONS(2109),
    [anon_sym_symbol] = ACTIONS(2109),
    [anon_sym_property] = ACTIONS(2109),
    [anon_sym_signal] = ACTIONS(2109),
    [anon_sym_on] = ACTIONS(2109),
    [anon_sym_required] = ACTIONS(2109),
    [anon_sym_component] = ACTIONS(2109),
    [anon_sym_abstract] = ACTIONS(2109),
    [anon_sym_extends] = ACTIONS(2109),
    [anon_sym_interface] = ACTIONS(2109),
    [anon_sym_enum] = ACTIONS(2109),
  },
  [610] = {
    [sym_identifier] = ACTIONS(2113),
    [anon_sym_export] = ACTIONS(2113),
    [anon_sym_default] = ACTIONS(2113),
    [anon_sym_type] = ACTIONS(2113),
    [anon_sym_EQ] = ACTIONS(2113),
    [anon_sym_namespace] = ACTIONS(2113),
    [anon_sym_LBRACE] = ACTIONS(2115),
    [anon_sym_COMMA] = ACTIONS(2115),
    [anon_sym_RBRACE] = ACTIONS(2115),
    [anon_sym_typeof] = ACTIONS(2113),
    [anon_sym_import] = ACTIONS(2113),
    [anon_sym_from] = ACTIONS(2113),
    [anon_sym_var] = ACTIONS(2113),
    [anon_sym_let] = ACTIONS(2113),
    [anon_sym_const] = ACTIONS(2113),
    [anon_sym_BANG] = ACTIONS(2115),
    [anon_sym_else] = ACTIONS(2113),
    [anon_sym_if] = ACTIONS(2113),
    [anon_sym_switch] = ACTIONS(2113),
    [anon_sym_for] = ACTIONS(2113),
    [anon_sym_LPAREN] = ACTIONS(2115),
    [anon_sym_RPAREN] = ACTIONS(2115),
    [anon_sym_await] = ACTIONS(2113),
    [anon_sym_of] = ACTIONS(2113),
    [anon_sym_while] = ACTIONS(2113),
    [anon_sym_do] = ACTIONS(2113),
    [anon_sym_try] = ACTIONS(2113),
    [anon_sym_with] = ACTIONS(2113),
    [anon_sym_break] = ACTIONS(2113),
    [anon_sym_continue] = ACTIONS(2113),
    [anon_sym_debugger] = ACTIONS(2113),
    [anon_sym_return] = ACTIONS(2113),
    [anon_sym_throw] = ACTIONS(2113),
    [anon_sym_SEMI] = ACTIONS(2115),
    [anon_sym_COLON] = ACTIONS(2115),
    [anon_sym_case] = ACTIONS(2113),
    [anon_sym_yield] = ACTIONS(2113),
    [anon_sym_LBRACK] = ACTIONS(2115),
    [anon_sym_RBRACK] = ACTIONS(2115),
    [anon_sym_LTtemplate_GT] = ACTIONS(2115),
    [anon_sym_LT] = ACTIONS(2113),
    [anon_sym_GT] = ACTIONS(2115),
    [anon_sym_SLASH] = ACTIONS(2113),
    [anon_sym_class] = ACTIONS(2113),
    [anon_sym_async] = ACTIONS(2113),
    [anon_sym_function] = ACTIONS(2113),
    [anon_sym_EQ_GT] = ACTIONS(2115),
    [anon_sym_new] = ACTIONS(2113),
    [anon_sym_AMP] = ACTIONS(2115),
    [anon_sym_PIPE] = ACTIONS(2115),
    [anon_sym_PLUS] = ACTIONS(2113),
    [anon_sym_DASH] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(2115),
    [anon_sym_void] = ACTIONS(2113),
    [anon_sym_delete] = ACTIONS(2113),
    [anon_sym_PLUS_PLUS] = ACTIONS(2115),
    [anon_sym_DASH_DASH] = ACTIONS(2115),
    [anon_sym_DQUOTE] = ACTIONS(2115),
    [anon_sym_SQUOTE] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2115),
    [sym_number] = ACTIONS(2115),
    [sym_this] = ACTIONS(2113),
    [sym_super] = ACTIONS(2113),
    [sym_true] = ACTIONS(2113),
    [sym_false] = ACTIONS(2113),
    [sym_null] = ACTIONS(2113),
    [sym_undefined] = ACTIONS(2113),
    [anon_sym_AT] = ACTIONS(2115),
    [anon_sym_static] = ACTIONS(2113),
    [anon_sym_readonly] = ACTIONS(2113),
    [anon_sym_get] = ACTIONS(2113),
    [anon_sym_set] = ACTIONS(2113),
    [anon_sym_QMARK] = ACTIONS(2115),
    [anon_sym_declare] = ACTIONS(2113),
    [anon_sym_public] = ACTIONS(2113),
    [anon_sym_private] = ACTIONS(2113),
    [anon_sym_protected] = ACTIONS(2113),
    [anon_sym_override] = ACTIONS(2113),
    [anon_sym_module] = ACTIONS(2113),
    [anon_sym_any] = ACTIONS(2113),
    [anon_sym_number] = ACTIONS(2113),
    [anon_sym_boolean] = ACTIONS(2113),
    [anon_sym_string] = ACTIONS(2113),
    [anon_sym_symbol] = ACTIONS(2113),
    [anon_sym_property] = ACTIONS(2113),
    [anon_sym_signal] = ACTIONS(2113),
    [anon_sym_on] = ACTIONS(2113),
    [anon_sym_required] = ACTIONS(2113),
    [anon_sym_component] = ACTIONS(2113),
    [anon_sym_abstract] = ACTIONS(2113),
    [anon_sym_extends] = ACTIONS(2113),
    [anon_sym_interface] = ACTIONS(2113),
    [anon_sym_enum] = ACTIONS(2113),
  },
  [611] = {
    [sym_declaration] = STATE(776),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_class_declaration] = STATE(826),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function_declaration] = STATE(826),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(826),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(840),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [aux_sym_export_statement_repeat1] = STATE(3695),
    [aux_sym_object_repeat1] = STATE(4186),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2043),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_function] = ACTIONS(2077),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2079),
    [anon_sym_module] = ACTIONS(2101),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_global] = ACTIONS(2103),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2087),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [612] = {
    [sym_identifier] = ACTIONS(2117),
    [anon_sym_export] = ACTIONS(2117),
    [anon_sym_default] = ACTIONS(2117),
    [anon_sym_type] = ACTIONS(2117),
    [anon_sym_EQ] = ACTIONS(2117),
    [anon_sym_namespace] = ACTIONS(2117),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_COMMA] = ACTIONS(2119),
    [anon_sym_RBRACE] = ACTIONS(2119),
    [anon_sym_typeof] = ACTIONS(2117),
    [anon_sym_import] = ACTIONS(2117),
    [anon_sym_from] = ACTIONS(2117),
    [anon_sym_var] = ACTIONS(2117),
    [anon_sym_let] = ACTIONS(2117),
    [anon_sym_const] = ACTIONS(2117),
    [anon_sym_BANG] = ACTIONS(2119),
    [anon_sym_else] = ACTIONS(2117),
    [anon_sym_if] = ACTIONS(2117),
    [anon_sym_switch] = ACTIONS(2117),
    [anon_sym_for] = ACTIONS(2117),
    [anon_sym_LPAREN] = ACTIONS(2119),
    [anon_sym_RPAREN] = ACTIONS(2119),
    [anon_sym_await] = ACTIONS(2117),
    [anon_sym_of] = ACTIONS(2117),
    [anon_sym_while] = ACTIONS(2117),
    [anon_sym_do] = ACTIONS(2117),
    [anon_sym_try] = ACTIONS(2117),
    [anon_sym_with] = ACTIONS(2117),
    [anon_sym_break] = ACTIONS(2117),
    [anon_sym_continue] = ACTIONS(2117),
    [anon_sym_debugger] = ACTIONS(2117),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_throw] = ACTIONS(2117),
    [anon_sym_SEMI] = ACTIONS(2119),
    [anon_sym_COLON] = ACTIONS(2119),
    [anon_sym_case] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2117),
    [anon_sym_LBRACK] = ACTIONS(2119),
    [anon_sym_RBRACK] = ACTIONS(2119),
    [anon_sym_LTtemplate_GT] = ACTIONS(2119),
    [anon_sym_LT] = ACTIONS(2117),
    [anon_sym_GT] = ACTIONS(2119),
    [anon_sym_SLASH] = ACTIONS(2117),
    [anon_sym_class] = ACTIONS(2117),
    [anon_sym_async] = ACTIONS(2117),
    [anon_sym_function] = ACTIONS(2117),
    [anon_sym_EQ_GT] = ACTIONS(2119),
    [anon_sym_new] = ACTIONS(2117),
    [anon_sym_AMP] = ACTIONS(2119),
    [anon_sym_PIPE] = ACTIONS(2119),
    [anon_sym_PLUS] = ACTIONS(2117),
    [anon_sym_DASH] = ACTIONS(2117),
    [anon_sym_TILDE] = ACTIONS(2119),
    [anon_sym_void] = ACTIONS(2117),
    [anon_sym_delete] = ACTIONS(2117),
    [anon_sym_PLUS_PLUS] = ACTIONS(2119),
    [anon_sym_DASH_DASH] = ACTIONS(2119),
    [anon_sym_DQUOTE] = ACTIONS(2119),
    [anon_sym_SQUOTE] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2119),
    [sym_number] = ACTIONS(2119),
    [sym_this] = ACTIONS(2117),
    [sym_super] = ACTIONS(2117),
    [sym_true] = ACTIONS(2117),
    [sym_false] = ACTIONS(2117),
    [sym_null] = ACTIONS(2117),
    [sym_undefined] = ACTIONS(2117),
    [anon_sym_AT] = ACTIONS(2119),
    [anon_sym_static] = ACTIONS(2117),
    [anon_sym_readonly] = ACTIONS(2117),
    [anon_sym_get] = ACTIONS(2117),
    [anon_sym_set] = ACTIONS(2117),
    [anon_sym_QMARK] = ACTIONS(2119),
    [anon_sym_declare] = ACTIONS(2117),
    [anon_sym_public] = ACTIONS(2117),
    [anon_sym_private] = ACTIONS(2117),
    [anon_sym_protected] = ACTIONS(2117),
    [anon_sym_override] = ACTIONS(2117),
    [anon_sym_module] = ACTIONS(2117),
    [anon_sym_any] = ACTIONS(2117),
    [anon_sym_number] = ACTIONS(2117),
    [anon_sym_boolean] = ACTIONS(2117),
    [anon_sym_string] = ACTIONS(2117),
    [anon_sym_symbol] = ACTIONS(2117),
    [anon_sym_property] = ACTIONS(2117),
    [anon_sym_signal] = ACTIONS(2117),
    [anon_sym_on] = ACTIONS(2117),
    [anon_sym_required] = ACTIONS(2117),
    [anon_sym_component] = ACTIONS(2117),
    [anon_sym_abstract] = ACTIONS(2117),
    [anon_sym_extends] = ACTIONS(2117),
    [anon_sym_interface] = ACTIONS(2117),
    [anon_sym_enum] = ACTIONS(2117),
  },
  [613] = {
    [sym_identifier] = ACTIONS(2121),
    [anon_sym_export] = ACTIONS(2121),
    [anon_sym_default] = ACTIONS(2121),
    [anon_sym_type] = ACTIONS(2121),
    [anon_sym_EQ] = ACTIONS(2121),
    [anon_sym_namespace] = ACTIONS(2121),
    [anon_sym_LBRACE] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(2123),
    [anon_sym_RBRACE] = ACTIONS(2123),
    [anon_sym_typeof] = ACTIONS(2121),
    [anon_sym_import] = ACTIONS(2121),
    [anon_sym_from] = ACTIONS(2121),
    [anon_sym_var] = ACTIONS(2121),
    [anon_sym_let] = ACTIONS(2121),
    [anon_sym_const] = ACTIONS(2121),
    [anon_sym_BANG] = ACTIONS(2123),
    [anon_sym_else] = ACTIONS(2121),
    [anon_sym_if] = ACTIONS(2121),
    [anon_sym_switch] = ACTIONS(2121),
    [anon_sym_for] = ACTIONS(2121),
    [anon_sym_LPAREN] = ACTIONS(2123),
    [anon_sym_RPAREN] = ACTIONS(2123),
    [anon_sym_await] = ACTIONS(2121),
    [anon_sym_of] = ACTIONS(2121),
    [anon_sym_while] = ACTIONS(2121),
    [anon_sym_do] = ACTIONS(2121),
    [anon_sym_try] = ACTIONS(2121),
    [anon_sym_with] = ACTIONS(2121),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_continue] = ACTIONS(2121),
    [anon_sym_debugger] = ACTIONS(2121),
    [anon_sym_return] = ACTIONS(2121),
    [anon_sym_throw] = ACTIONS(2121),
    [anon_sym_SEMI] = ACTIONS(2123),
    [anon_sym_COLON] = ACTIONS(2123),
    [anon_sym_case] = ACTIONS(2121),
    [anon_sym_yield] = ACTIONS(2121),
    [anon_sym_LBRACK] = ACTIONS(2123),
    [anon_sym_RBRACK] = ACTIONS(2123),
    [anon_sym_LTtemplate_GT] = ACTIONS(2123),
    [anon_sym_LT] = ACTIONS(2121),
    [anon_sym_GT] = ACTIONS(2123),
    [anon_sym_SLASH] = ACTIONS(2121),
    [anon_sym_class] = ACTIONS(2121),
    [anon_sym_async] = ACTIONS(2121),
    [anon_sym_function] = ACTIONS(2121),
    [anon_sym_EQ_GT] = ACTIONS(2123),
    [anon_sym_new] = ACTIONS(2121),
    [anon_sym_AMP] = ACTIONS(2123),
    [anon_sym_PIPE] = ACTIONS(2123),
    [anon_sym_PLUS] = ACTIONS(2121),
    [anon_sym_DASH] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(2123),
    [anon_sym_void] = ACTIONS(2121),
    [anon_sym_delete] = ACTIONS(2121),
    [anon_sym_PLUS_PLUS] = ACTIONS(2123),
    [anon_sym_DASH_DASH] = ACTIONS(2123),
    [anon_sym_DQUOTE] = ACTIONS(2123),
    [anon_sym_SQUOTE] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2123),
    [sym_number] = ACTIONS(2123),
    [sym_this] = ACTIONS(2121),
    [sym_super] = ACTIONS(2121),
    [sym_true] = ACTIONS(2121),
    [sym_false] = ACTIONS(2121),
    [sym_null] = ACTIONS(2121),
    [sym_undefined] = ACTIONS(2121),
    [anon_sym_AT] = ACTIONS(2123),
    [anon_sym_static] = ACTIONS(2121),
    [anon_sym_readonly] = ACTIONS(2121),
    [anon_sym_get] = ACTIONS(2121),
    [anon_sym_set] = ACTIONS(2121),
    [anon_sym_QMARK] = ACTIONS(2123),
    [anon_sym_declare] = ACTIONS(2121),
    [anon_sym_public] = ACTIONS(2121),
    [anon_sym_private] = ACTIONS(2121),
    [anon_sym_protected] = ACTIONS(2121),
    [anon_sym_override] = ACTIONS(2121),
    [anon_sym_module] = ACTIONS(2121),
    [anon_sym_any] = ACTIONS(2121),
    [anon_sym_number] = ACTIONS(2121),
    [anon_sym_boolean] = ACTIONS(2121),
    [anon_sym_string] = ACTIONS(2121),
    [anon_sym_symbol] = ACTIONS(2121),
    [anon_sym_property] = ACTIONS(2121),
    [anon_sym_signal] = ACTIONS(2121),
    [anon_sym_on] = ACTIONS(2121),
    [anon_sym_required] = ACTIONS(2121),
    [anon_sym_component] = ACTIONS(2121),
    [anon_sym_abstract] = ACTIONS(2121),
    [anon_sym_extends] = ACTIONS(2121),
    [anon_sym_interface] = ACTIONS(2121),
    [anon_sym_enum] = ACTIONS(2121),
  },
  [614] = {
    [sym_declaration] = STATE(776),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_class_declaration] = STATE(826),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function_declaration] = STATE(826),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(826),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(840),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [aux_sym_export_statement_repeat1] = STATE(3695),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2015),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_function] = ACTIONS(2077),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2079),
    [anon_sym_module] = ACTIONS(2101),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_global] = ACTIONS(2103),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2087),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [615] = {
    [sym_declaration] = STATE(776),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_class_declaration] = STATE(826),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function_declaration] = STATE(826),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(826),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(840),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [aux_sym_export_statement_repeat1] = STATE(3695),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2039),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_function] = ACTIONS(2077),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(2079),
    [anon_sym_module] = ACTIONS(2101),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_global] = ACTIONS(2103),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2087),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [616] = {
    [sym_export_clause] = STATE(3917),
    [sym_declaration] = STATE(2588),
    [sym_namespace_import_export] = STATE(4498),
    [sym_variable_declaration] = STATE(2592),
    [sym_lexical_declaration] = STATE(2592),
    [sym_class_declaration] = STATE(2592),
    [sym_function_declaration] = STATE(2592),
    [sym_generator_function_declaration] = STATE(2592),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(2592),
    [sym_ambient_declaration] = STATE(2592),
    [sym_abstract_class_declaration] = STATE(2592),
    [sym_module] = STATE(2592),
    [sym_internal_module] = STATE(2632),
    [sym_import_alias] = STATE(2592),
    [sym_interface_declaration] = STATE(2592),
    [sym_enum_declaration] = STATE(2592),
    [sym_type_alias_declaration] = STATE(2592),
    [aux_sym_export_statement_repeat1] = STATE(3663),
    [anon_sym_STAR] = ACTIONS(2125),
    [anon_sym_default] = ACTIONS(2127),
    [anon_sym_type] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(2131),
    [anon_sym_as] = ACTIONS(2133),
    [anon_sym_namespace] = ACTIONS(2135),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_import] = ACTIONS(2137),
    [anon_sym_var] = ACTIONS(2139),
    [anon_sym_let] = ACTIONS(2141),
    [anon_sym_const] = ACTIONS(2143),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(26),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2147),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2151),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_declare] = ACTIONS(2153),
    [anon_sym_module] = ACTIONS(2155),
    [anon_sym_abstract] = ACTIONS(2157),
    [anon_sym_interface] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2161),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [617] = {
    [sym_export_clause] = STATE(3923),
    [sym_declaration] = STATE(845),
    [sym_namespace_import_export] = STATE(4364),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_class_declaration] = STATE(826),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function_declaration] = STATE(826),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(826),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(840),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [aux_sym_export_statement_repeat1] = STATE(3695),
    [anon_sym_STAR] = ACTIONS(2045),
    [anon_sym_default] = ACTIONS(2163),
    [anon_sym_type] = ACTIONS(2049),
    [anon_sym_EQ] = ACTIONS(2165),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2139),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(26),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2171),
    [anon_sym_function] = ACTIONS(2173),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_declare] = ACTIONS(2175),
    [anon_sym_module] = ACTIONS(2177),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2087),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [618] = {
    [sym_export_clause] = STATE(3923),
    [sym_declaration] = STATE(845),
    [sym_namespace_import_export] = STATE(4364),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_class_declaration] = STATE(826),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function_declaration] = STATE(826),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(826),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(840),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [aux_sym_export_statement_repeat1] = STATE(3695),
    [anon_sym_STAR] = ACTIONS(2045),
    [anon_sym_default] = ACTIONS(2047),
    [anon_sym_type] = ACTIONS(2049),
    [anon_sym_EQ] = ACTIONS(2165),
    [anon_sym_as] = ACTIONS(2053),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_LBRACE] = ACTIONS(2057),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(26),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_function] = ACTIONS(2077),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_declare] = ACTIONS(2079),
    [anon_sym_module] = ACTIONS(2081),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2087),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [619] = {
    [aux_sym_object_repeat1] = STATE(4186),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_export] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(1788),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2043),
    [anon_sym_from] = ACTIONS(1788),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(1788),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(1788),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_SQUOTE] = ACTIONS(1790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(1790),
    [sym_private_property_identifier] = ACTIONS(1790),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_readonly] = ACTIONS(1788),
    [anon_sym_get] = ACTIONS(1788),
    [anon_sym_set] = ACTIONS(1788),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(1788),
    [anon_sym_public] = ACTIONS(1788),
    [anon_sym_private] = ACTIONS(1788),
    [anon_sym_protected] = ACTIONS(1788),
    [anon_sym_override] = ACTIONS(1788),
    [anon_sym_module] = ACTIONS(1788),
    [anon_sym_any] = ACTIONS(1788),
    [anon_sym_number] = ACTIONS(1788),
    [anon_sym_boolean] = ACTIONS(1788),
    [anon_sym_string] = ACTIONS(1788),
    [anon_sym_symbol] = ACTIONS(1788),
    [anon_sym_property] = ACTIONS(1788),
    [anon_sym_signal] = ACTIONS(1788),
    [anon_sym_on] = ACTIONS(1788),
    [anon_sym_required] = ACTIONS(1788),
    [anon_sym_component] = ACTIONS(1788),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [620] = {
    [aux_sym_object_repeat1] = STATE(4186),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(1798),
    [anon_sym_export] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(1798),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2043),
    [anon_sym_from] = ACTIONS(1798),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(1798),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(1800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(1800),
    [sym_private_property_identifier] = ACTIONS(1800),
    [anon_sym_static] = ACTIONS(1798),
    [anon_sym_readonly] = ACTIONS(1798),
    [anon_sym_get] = ACTIONS(1798),
    [anon_sym_set] = ACTIONS(1798),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(1798),
    [anon_sym_public] = ACTIONS(1798),
    [anon_sym_private] = ACTIONS(1798),
    [anon_sym_protected] = ACTIONS(1798),
    [anon_sym_override] = ACTIONS(1798),
    [anon_sym_module] = ACTIONS(1798),
    [anon_sym_any] = ACTIONS(1798),
    [anon_sym_number] = ACTIONS(1798),
    [anon_sym_boolean] = ACTIONS(1798),
    [anon_sym_string] = ACTIONS(1798),
    [anon_sym_symbol] = ACTIONS(1798),
    [anon_sym_property] = ACTIONS(1798),
    [anon_sym_signal] = ACTIONS(1798),
    [anon_sym_on] = ACTIONS(1798),
    [anon_sym_required] = ACTIONS(1798),
    [anon_sym_component] = ACTIONS(1798),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [621] = {
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(1798),
    [anon_sym_export] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(1798),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(1798),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(1798),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(1800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(1800),
    [sym_private_property_identifier] = ACTIONS(1800),
    [anon_sym_static] = ACTIONS(1798),
    [anon_sym_readonly] = ACTIONS(1798),
    [anon_sym_get] = ACTIONS(1798),
    [anon_sym_set] = ACTIONS(1798),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(1798),
    [anon_sym_public] = ACTIONS(1798),
    [anon_sym_private] = ACTIONS(1798),
    [anon_sym_protected] = ACTIONS(1798),
    [anon_sym_override] = ACTIONS(1798),
    [anon_sym_module] = ACTIONS(1798),
    [anon_sym_any] = ACTIONS(1798),
    [anon_sym_number] = ACTIONS(1798),
    [anon_sym_boolean] = ACTIONS(1798),
    [anon_sym_string] = ACTIONS(1798),
    [anon_sym_symbol] = ACTIONS(1798),
    [anon_sym_property] = ACTIONS(1798),
    [anon_sym_signal] = ACTIONS(1798),
    [anon_sym_on] = ACTIONS(1798),
    [anon_sym_required] = ACTIONS(1798),
    [anon_sym_component] = ACTIONS(1798),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [622] = {
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_export] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(1788),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2015),
    [anon_sym_from] = ACTIONS(1788),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(1788),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(1788),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_SQUOTE] = ACTIONS(1790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(1790),
    [sym_private_property_identifier] = ACTIONS(1790),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_readonly] = ACTIONS(1788),
    [anon_sym_get] = ACTIONS(1788),
    [anon_sym_set] = ACTIONS(1788),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(1788),
    [anon_sym_public] = ACTIONS(1788),
    [anon_sym_private] = ACTIONS(1788),
    [anon_sym_protected] = ACTIONS(1788),
    [anon_sym_override] = ACTIONS(1788),
    [anon_sym_module] = ACTIONS(1788),
    [anon_sym_any] = ACTIONS(1788),
    [anon_sym_number] = ACTIONS(1788),
    [anon_sym_boolean] = ACTIONS(1788),
    [anon_sym_string] = ACTIONS(1788),
    [anon_sym_symbol] = ACTIONS(1788),
    [anon_sym_property] = ACTIONS(1788),
    [anon_sym_signal] = ACTIONS(1788),
    [anon_sym_on] = ACTIONS(1788),
    [anon_sym_required] = ACTIONS(1788),
    [anon_sym_component] = ACTIONS(1788),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [623] = {
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(1798),
    [anon_sym_export] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(1798),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_from] = ACTIONS(1798),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(1798),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(1800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(1800),
    [sym_private_property_identifier] = ACTIONS(1800),
    [anon_sym_static] = ACTIONS(1798),
    [anon_sym_readonly] = ACTIONS(1798),
    [anon_sym_get] = ACTIONS(1798),
    [anon_sym_set] = ACTIONS(1798),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(1798),
    [anon_sym_public] = ACTIONS(1798),
    [anon_sym_private] = ACTIONS(1798),
    [anon_sym_protected] = ACTIONS(1798),
    [anon_sym_override] = ACTIONS(1798),
    [anon_sym_module] = ACTIONS(1798),
    [anon_sym_any] = ACTIONS(1798),
    [anon_sym_number] = ACTIONS(1798),
    [anon_sym_boolean] = ACTIONS(1798),
    [anon_sym_string] = ACTIONS(1798),
    [anon_sym_symbol] = ACTIONS(1798),
    [anon_sym_property] = ACTIONS(1798),
    [anon_sym_signal] = ACTIONS(1798),
    [anon_sym_on] = ACTIONS(1798),
    [anon_sym_required] = ACTIONS(1798),
    [anon_sym_component] = ACTIONS(1798),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [624] = {
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(1798),
    [anon_sym_export] = ACTIONS(1798),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_type] = ACTIONS(1798),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(1798),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2039),
    [anon_sym_from] = ACTIONS(1798),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(1798),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(1800),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(1798),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(1800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(1800),
    [sym_private_property_identifier] = ACTIONS(1800),
    [anon_sym_static] = ACTIONS(1798),
    [anon_sym_readonly] = ACTIONS(1798),
    [anon_sym_get] = ACTIONS(1798),
    [anon_sym_set] = ACTIONS(1798),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(1798),
    [anon_sym_public] = ACTIONS(1798),
    [anon_sym_private] = ACTIONS(1798),
    [anon_sym_protected] = ACTIONS(1798),
    [anon_sym_override] = ACTIONS(1798),
    [anon_sym_module] = ACTIONS(1798),
    [anon_sym_any] = ACTIONS(1798),
    [anon_sym_number] = ACTIONS(1798),
    [anon_sym_boolean] = ACTIONS(1798),
    [anon_sym_string] = ACTIONS(1798),
    [anon_sym_symbol] = ACTIONS(1798),
    [anon_sym_property] = ACTIONS(1798),
    [anon_sym_signal] = ACTIONS(1798),
    [anon_sym_on] = ACTIONS(1798),
    [anon_sym_required] = ACTIONS(1798),
    [anon_sym_component] = ACTIONS(1798),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [625] = {
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_export] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(1788),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2039),
    [anon_sym_from] = ACTIONS(1788),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(1788),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(1788),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_SQUOTE] = ACTIONS(1790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(1790),
    [sym_private_property_identifier] = ACTIONS(1790),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_readonly] = ACTIONS(1788),
    [anon_sym_get] = ACTIONS(1788),
    [anon_sym_set] = ACTIONS(1788),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(1788),
    [anon_sym_public] = ACTIONS(1788),
    [anon_sym_private] = ACTIONS(1788),
    [anon_sym_protected] = ACTIONS(1788),
    [anon_sym_override] = ACTIONS(1788),
    [anon_sym_module] = ACTIONS(1788),
    [anon_sym_any] = ACTIONS(1788),
    [anon_sym_number] = ACTIONS(1788),
    [anon_sym_boolean] = ACTIONS(1788),
    [anon_sym_string] = ACTIONS(1788),
    [anon_sym_symbol] = ACTIONS(1788),
    [anon_sym_property] = ACTIONS(1788),
    [anon_sym_signal] = ACTIONS(1788),
    [anon_sym_on] = ACTIONS(1788),
    [anon_sym_required] = ACTIONS(1788),
    [anon_sym_component] = ACTIONS(1788),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [626] = {
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(1788),
    [anon_sym_export] = ACTIONS(1788),
    [anon_sym_STAR] = ACTIONS(1788),
    [anon_sym_type] = ACTIONS(1788),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(1788),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_from] = ACTIONS(1788),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(1788),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(26),
    [anon_sym_async] = ACTIONS(1788),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(1790),
    [anon_sym_SQUOTE] = ACTIONS(1790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [sym_number] = ACTIONS(1790),
    [sym_private_property_identifier] = ACTIONS(1790),
    [anon_sym_static] = ACTIONS(1788),
    [anon_sym_readonly] = ACTIONS(1788),
    [anon_sym_get] = ACTIONS(1788),
    [anon_sym_set] = ACTIONS(1788),
    [anon_sym_QMARK] = ACTIONS(2037),
    [anon_sym_declare] = ACTIONS(1788),
    [anon_sym_public] = ACTIONS(1788),
    [anon_sym_private] = ACTIONS(1788),
    [anon_sym_protected] = ACTIONS(1788),
    [anon_sym_override] = ACTIONS(1788),
    [anon_sym_module] = ACTIONS(1788),
    [anon_sym_any] = ACTIONS(1788),
    [anon_sym_number] = ACTIONS(1788),
    [anon_sym_boolean] = ACTIONS(1788),
    [anon_sym_string] = ACTIONS(1788),
    [anon_sym_symbol] = ACTIONS(1788),
    [anon_sym_property] = ACTIONS(1788),
    [anon_sym_signal] = ACTIONS(1788),
    [anon_sym_on] = ACTIONS(1788),
    [anon_sym_required] = ACTIONS(1788),
    [anon_sym_component] = ACTIONS(1788),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [627] = {
    [sym_declaration] = STATE(776),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_class_declaration] = STATE(826),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function_declaration] = STATE(826),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(826),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(840),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [aux_sym_export_statement_repeat1] = STATE(3695),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2139),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(26),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2171),
    [anon_sym_function] = ACTIONS(2173),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_declare] = ACTIONS(2175),
    [anon_sym_module] = ACTIONS(2181),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_global] = ACTIONS(2183),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2087),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [628] = {
    [sym_declaration] = STATE(776),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_class_declaration] = STATE(826),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function_declaration] = STATE(826),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(826),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(840),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [aux_sym_export_statement_repeat1] = STATE(3695),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(26),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_function] = ACTIONS(2077),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_declare] = ACTIONS(2079),
    [anon_sym_module] = ACTIONS(2101),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_global] = ACTIONS(2103),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2087),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [629] = {
    [sym_declaration] = STATE(2579),
    [sym_variable_declaration] = STATE(2592),
    [sym_lexical_declaration] = STATE(2592),
    [sym_class_declaration] = STATE(2592),
    [sym_function_declaration] = STATE(2592),
    [sym_generator_function_declaration] = STATE(2592),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(2592),
    [sym_ambient_declaration] = STATE(2592),
    [sym_abstract_class_declaration] = STATE(2592),
    [sym_module] = STATE(2592),
    [sym_internal_module] = STATE(2632),
    [sym_import_alias] = STATE(2592),
    [sym_interface_declaration] = STATE(2592),
    [sym_enum_declaration] = STATE(2592),
    [sym_type_alias_declaration] = STATE(2592),
    [aux_sym_export_statement_repeat1] = STATE(3663),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2185),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2135),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_import] = ACTIONS(2137),
    [anon_sym_var] = ACTIONS(2139),
    [anon_sym_let] = ACTIONS(2141),
    [anon_sym_const] = ACTIONS(2143),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(26),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2147),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2151),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_declare] = ACTIONS(2153),
    [anon_sym_module] = ACTIONS(2187),
    [anon_sym_abstract] = ACTIONS(2157),
    [anon_sym_global] = ACTIONS(2189),
    [anon_sym_interface] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2161),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [630] = {
    [sym__call_signature] = STATE(4638),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2191),
    [anon_sym_export] = ACTIONS(2193),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2193),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2193),
    [anon_sym_COMMA] = ACTIONS(1467),
    [anon_sym_RBRACE] = ACTIONS(1467),
    [anon_sym_from] = ACTIONS(2193),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_RPAREN] = ACTIONS(1467),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2193),
    [anon_sym_COLON] = ACTIONS(1467),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2193),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2193),
    [anon_sym_readonly] = ACTIONS(2193),
    [anon_sym_get] = ACTIONS(2193),
    [anon_sym_set] = ACTIONS(2193),
    [anon_sym_QMARK] = ACTIONS(2203),
    [anon_sym_declare] = ACTIONS(2193),
    [anon_sym_public] = ACTIONS(2193),
    [anon_sym_private] = ACTIONS(2193),
    [anon_sym_protected] = ACTIONS(2193),
    [anon_sym_override] = ACTIONS(2193),
    [anon_sym_module] = ACTIONS(2193),
    [anon_sym_any] = ACTIONS(2193),
    [anon_sym_number] = ACTIONS(2193),
    [anon_sym_boolean] = ACTIONS(2193),
    [anon_sym_string] = ACTIONS(2193),
    [anon_sym_symbol] = ACTIONS(2193),
    [anon_sym_property] = ACTIONS(2193),
    [anon_sym_signal] = ACTIONS(2193),
    [anon_sym_on] = ACTIONS(2193),
    [anon_sym_required] = ACTIONS(2193),
    [anon_sym_component] = ACTIONS(2193),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [631] = {
    [sym__call_signature] = STATE(4638),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2191),
    [anon_sym_export] = ACTIONS(2193),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2193),
    [anon_sym_EQ] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2193),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_RBRACE] = ACTIONS(32),
    [anon_sym_from] = ACTIONS(2193),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_RPAREN] = ACTIONS(32),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2193),
    [anon_sym_COLON] = ACTIONS(32),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2193),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2193),
    [anon_sym_readonly] = ACTIONS(2193),
    [anon_sym_get] = ACTIONS(2193),
    [anon_sym_set] = ACTIONS(2193),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(2193),
    [anon_sym_public] = ACTIONS(2193),
    [anon_sym_private] = ACTIONS(2193),
    [anon_sym_protected] = ACTIONS(2193),
    [anon_sym_override] = ACTIONS(2193),
    [anon_sym_module] = ACTIONS(2193),
    [anon_sym_any] = ACTIONS(2193),
    [anon_sym_number] = ACTIONS(2193),
    [anon_sym_boolean] = ACTIONS(2193),
    [anon_sym_string] = ACTIONS(2193),
    [anon_sym_symbol] = ACTIONS(2193),
    [anon_sym_property] = ACTIONS(2193),
    [anon_sym_signal] = ACTIONS(2193),
    [anon_sym_on] = ACTIONS(2193),
    [anon_sym_required] = ACTIONS(2193),
    [anon_sym_component] = ACTIONS(2193),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [632] = {
    [sym__call_signature] = STATE(4702),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2207),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2207),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2207),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_RBRACE] = ACTIONS(124),
    [anon_sym_from] = ACTIONS(2207),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2207),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2207),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2207),
    [anon_sym_readonly] = ACTIONS(2207),
    [anon_sym_get] = ACTIONS(2207),
    [anon_sym_set] = ACTIONS(2207),
    [anon_sym_QMARK] = ACTIONS(736),
    [anon_sym_declare] = ACTIONS(2207),
    [anon_sym_public] = ACTIONS(2207),
    [anon_sym_private] = ACTIONS(2207),
    [anon_sym_protected] = ACTIONS(2207),
    [anon_sym_override] = ACTIONS(2207),
    [anon_sym_module] = ACTIONS(2207),
    [anon_sym_any] = ACTIONS(2207),
    [anon_sym_number] = ACTIONS(2207),
    [anon_sym_boolean] = ACTIONS(2207),
    [anon_sym_string] = ACTIONS(2207),
    [anon_sym_symbol] = ACTIONS(2207),
    [anon_sym_property] = ACTIONS(2207),
    [anon_sym_signal] = ACTIONS(2207),
    [anon_sym_on] = ACTIONS(2207),
    [anon_sym_required] = ACTIONS(2207),
    [anon_sym_component] = ACTIONS(2207),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [633] = {
    [sym__call_signature] = STATE(4702),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2207),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2207),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2207),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(64),
    [anon_sym_from] = ACTIONS(2207),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_RPAREN] = ACTIONS(64),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2207),
    [anon_sym_COLON] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2207),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2207),
    [anon_sym_readonly] = ACTIONS(2207),
    [anon_sym_get] = ACTIONS(2207),
    [anon_sym_set] = ACTIONS(2207),
    [anon_sym_declare] = ACTIONS(2207),
    [anon_sym_public] = ACTIONS(2207),
    [anon_sym_private] = ACTIONS(2207),
    [anon_sym_protected] = ACTIONS(2207),
    [anon_sym_override] = ACTIONS(2207),
    [anon_sym_module] = ACTIONS(2207),
    [anon_sym_any] = ACTIONS(2207),
    [anon_sym_number] = ACTIONS(2207),
    [anon_sym_boolean] = ACTIONS(2207),
    [anon_sym_string] = ACTIONS(2207),
    [anon_sym_symbol] = ACTIONS(2207),
    [anon_sym_property] = ACTIONS(2207),
    [anon_sym_signal] = ACTIONS(2207),
    [anon_sym_on] = ACTIONS(2207),
    [anon_sym_required] = ACTIONS(2207),
    [anon_sym_component] = ACTIONS(2207),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [634] = {
    [sym__call_signature] = STATE(4803),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_initializer] = STATE(4549),
    [sym_identifier] = ACTIONS(2209),
    [anon_sym_export] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2211),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2211),
    [anon_sym_LBRACE] = ACTIONS(2213),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_from] = ACTIONS(2211),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2211),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(2215),
    [anon_sym_async] = ACTIONS(2211),
    [anon_sym_function] = ACTIONS(2218),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2211),
    [anon_sym_readonly] = ACTIONS(2211),
    [anon_sym_get] = ACTIONS(2211),
    [anon_sym_set] = ACTIONS(2211),
    [anon_sym_declare] = ACTIONS(2211),
    [anon_sym_public] = ACTIONS(2211),
    [anon_sym_private] = ACTIONS(2211),
    [anon_sym_protected] = ACTIONS(2211),
    [anon_sym_override] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(2211),
    [anon_sym_any] = ACTIONS(2211),
    [anon_sym_number] = ACTIONS(2211),
    [anon_sym_boolean] = ACTIONS(2211),
    [anon_sym_string] = ACTIONS(2211),
    [anon_sym_symbol] = ACTIONS(2211),
    [anon_sym_property] = ACTIONS(2211),
    [anon_sym_signal] = ACTIONS(2211),
    [anon_sym_on] = ACTIONS(2211),
    [anon_sym_required] = ACTIONS(2211),
    [anon_sym_component] = ACTIONS(2211),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [635] = {
    [sym__call_signature] = STATE(4702),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2207),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2207),
    [anon_sym_EQ] = ACTIONS(1402),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2207),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(64),
    [anon_sym_from] = ACTIONS(2207),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_RPAREN] = ACTIONS(64),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2207),
    [anon_sym_COLON] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2207),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2207),
    [anon_sym_readonly] = ACTIONS(2207),
    [anon_sym_get] = ACTIONS(2207),
    [anon_sym_set] = ACTIONS(2207),
    [anon_sym_declare] = ACTIONS(2207),
    [anon_sym_public] = ACTIONS(2207),
    [anon_sym_private] = ACTIONS(2207),
    [anon_sym_protected] = ACTIONS(2207),
    [anon_sym_override] = ACTIONS(2207),
    [anon_sym_module] = ACTIONS(2207),
    [anon_sym_any] = ACTIONS(2207),
    [anon_sym_number] = ACTIONS(2207),
    [anon_sym_boolean] = ACTIONS(2207),
    [anon_sym_string] = ACTIONS(2207),
    [anon_sym_symbol] = ACTIONS(2207),
    [anon_sym_property] = ACTIONS(2207),
    [anon_sym_signal] = ACTIONS(2207),
    [anon_sym_on] = ACTIONS(2207),
    [anon_sym_required] = ACTIONS(2207),
    [anon_sym_component] = ACTIONS(2207),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [636] = {
    [sym__call_signature] = STATE(4803),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_initializer] = STATE(2484),
    [sym_identifier] = ACTIONS(2209),
    [anon_sym_export] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2211),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2211),
    [anon_sym_LBRACE] = ACTIONS(2220),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_from] = ACTIONS(2211),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2211),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(2215),
    [anon_sym_async] = ACTIONS(2211),
    [anon_sym_function] = ACTIONS(2218),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2211),
    [anon_sym_readonly] = ACTIONS(2211),
    [anon_sym_get] = ACTIONS(2211),
    [anon_sym_set] = ACTIONS(2211),
    [anon_sym_declare] = ACTIONS(2211),
    [anon_sym_public] = ACTIONS(2211),
    [anon_sym_private] = ACTIONS(2211),
    [anon_sym_protected] = ACTIONS(2211),
    [anon_sym_override] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(2211),
    [anon_sym_any] = ACTIONS(2211),
    [anon_sym_number] = ACTIONS(2211),
    [anon_sym_boolean] = ACTIONS(2211),
    [anon_sym_string] = ACTIONS(2211),
    [anon_sym_symbol] = ACTIONS(2211),
    [anon_sym_property] = ACTIONS(2211),
    [anon_sym_signal] = ACTIONS(2211),
    [anon_sym_on] = ACTIONS(2211),
    [anon_sym_required] = ACTIONS(2211),
    [anon_sym_component] = ACTIONS(2211),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [637] = {
    [sym__call_signature] = STATE(4803),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2209),
    [anon_sym_export] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2211),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2211),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_from] = ACTIONS(2211),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2211),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2179),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2211),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2211),
    [anon_sym_readonly] = ACTIONS(2211),
    [anon_sym_get] = ACTIONS(2211),
    [anon_sym_set] = ACTIONS(2211),
    [anon_sym_declare] = ACTIONS(2211),
    [anon_sym_public] = ACTIONS(2211),
    [anon_sym_private] = ACTIONS(2211),
    [anon_sym_protected] = ACTIONS(2211),
    [anon_sym_override] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(2211),
    [anon_sym_any] = ACTIONS(2211),
    [anon_sym_number] = ACTIONS(2211),
    [anon_sym_boolean] = ACTIONS(2211),
    [anon_sym_string] = ACTIONS(2211),
    [anon_sym_symbol] = ACTIONS(2211),
    [anon_sym_property] = ACTIONS(2211),
    [anon_sym_signal] = ACTIONS(2211),
    [anon_sym_on] = ACTIONS(2211),
    [anon_sym_required] = ACTIONS(2211),
    [anon_sym_component] = ACTIONS(2211),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [638] = {
    [sym_declaration] = STATE(776),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_class_declaration] = STATE(826),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function_declaration] = STATE(826),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(826),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(840),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [aux_sym_export_statement_repeat1] = STATE(3695),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_EQ] = ACTIONS(1727),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2055),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2061),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(26),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2075),
    [anon_sym_function] = ACTIONS(2077),
    [anon_sym_EQ_GT] = ACTIONS(1729),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_declare] = ACTIONS(2079),
    [anon_sym_module] = ACTIONS(2101),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_global] = ACTIONS(2103),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2087),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [639] = {
    [sym__call_signature] = STATE(4803),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2209),
    [anon_sym_export] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2211),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2211),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(64),
    [anon_sym_from] = ACTIONS(2211),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2211),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2211),
    [anon_sym_function] = ACTIONS(2218),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2211),
    [anon_sym_readonly] = ACTIONS(2211),
    [anon_sym_get] = ACTIONS(2211),
    [anon_sym_set] = ACTIONS(2211),
    [anon_sym_declare] = ACTIONS(2211),
    [anon_sym_public] = ACTIONS(2211),
    [anon_sym_private] = ACTIONS(2211),
    [anon_sym_protected] = ACTIONS(2211),
    [anon_sym_override] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(2211),
    [anon_sym_any] = ACTIONS(2211),
    [anon_sym_number] = ACTIONS(2211),
    [anon_sym_boolean] = ACTIONS(2211),
    [anon_sym_string] = ACTIONS(2211),
    [anon_sym_symbol] = ACTIONS(2211),
    [anon_sym_property] = ACTIONS(2211),
    [anon_sym_signal] = ACTIONS(2211),
    [anon_sym_on] = ACTIONS(2211),
    [anon_sym_required] = ACTIONS(2211),
    [anon_sym_component] = ACTIONS(2211),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [640] = {
    [sym__call_signature] = STATE(4702),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_ui_object_initializer] = STATE(2484),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2207),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2207),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2207),
    [anon_sym_LBRACE] = ACTIONS(2220),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_from] = ACTIONS(2207),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2207),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(2215),
    [anon_sym_async] = ACTIONS(2207),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2207),
    [anon_sym_readonly] = ACTIONS(2207),
    [anon_sym_get] = ACTIONS(2207),
    [anon_sym_set] = ACTIONS(2207),
    [anon_sym_declare] = ACTIONS(2207),
    [anon_sym_public] = ACTIONS(2207),
    [anon_sym_private] = ACTIONS(2207),
    [anon_sym_protected] = ACTIONS(2207),
    [anon_sym_override] = ACTIONS(2207),
    [anon_sym_module] = ACTIONS(2207),
    [anon_sym_any] = ACTIONS(2207),
    [anon_sym_number] = ACTIONS(2207),
    [anon_sym_boolean] = ACTIONS(2207),
    [anon_sym_string] = ACTIONS(2207),
    [anon_sym_symbol] = ACTIONS(2207),
    [anon_sym_property] = ACTIONS(2207),
    [anon_sym_signal] = ACTIONS(2207),
    [anon_sym_on] = ACTIONS(2207),
    [anon_sym_required] = ACTIONS(2207),
    [anon_sym_component] = ACTIONS(2207),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [641] = {
    [sym__call_signature] = STATE(4803),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2209),
    [anon_sym_export] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2211),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2211),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_from] = ACTIONS(2211),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2211),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2169),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2211),
    [anon_sym_function] = ACTIONS(2222),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2211),
    [anon_sym_readonly] = ACTIONS(2211),
    [anon_sym_get] = ACTIONS(2211),
    [anon_sym_set] = ACTIONS(2211),
    [anon_sym_declare] = ACTIONS(2211),
    [anon_sym_public] = ACTIONS(2211),
    [anon_sym_private] = ACTIONS(2211),
    [anon_sym_protected] = ACTIONS(2211),
    [anon_sym_override] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(2211),
    [anon_sym_any] = ACTIONS(2211),
    [anon_sym_number] = ACTIONS(2211),
    [anon_sym_boolean] = ACTIONS(2211),
    [anon_sym_string] = ACTIONS(2211),
    [anon_sym_symbol] = ACTIONS(2211),
    [anon_sym_property] = ACTIONS(2211),
    [anon_sym_signal] = ACTIONS(2211),
    [anon_sym_on] = ACTIONS(2211),
    [anon_sym_required] = ACTIONS(2211),
    [anon_sym_component] = ACTIONS(2211),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [642] = {
    [sym__call_signature] = STATE(4803),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2209),
    [anon_sym_export] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2211),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2211),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_from] = ACTIONS(2211),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2211),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2145),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2211),
    [anon_sym_function] = ACTIONS(2224),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2211),
    [anon_sym_readonly] = ACTIONS(2211),
    [anon_sym_get] = ACTIONS(2211),
    [anon_sym_set] = ACTIONS(2211),
    [anon_sym_declare] = ACTIONS(2211),
    [anon_sym_public] = ACTIONS(2211),
    [anon_sym_private] = ACTIONS(2211),
    [anon_sym_protected] = ACTIONS(2211),
    [anon_sym_override] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(2211),
    [anon_sym_any] = ACTIONS(2211),
    [anon_sym_number] = ACTIONS(2211),
    [anon_sym_boolean] = ACTIONS(2211),
    [anon_sym_string] = ACTIONS(2211),
    [anon_sym_symbol] = ACTIONS(2211),
    [anon_sym_property] = ACTIONS(2211),
    [anon_sym_signal] = ACTIONS(2211),
    [anon_sym_on] = ACTIONS(2211),
    [anon_sym_required] = ACTIONS(2211),
    [anon_sym_component] = ACTIONS(2211),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [643] = {
    [sym_declaration] = STATE(2579),
    [sym_variable_declaration] = STATE(2592),
    [sym_lexical_declaration] = STATE(2592),
    [sym_class_declaration] = STATE(2592),
    [sym_function_declaration] = STATE(2592),
    [sym_generator_function_declaration] = STATE(2592),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(2592),
    [sym_ambient_declaration] = STATE(2592),
    [sym_abstract_class_declaration] = STATE(2592),
    [sym_module] = STATE(2592),
    [sym_internal_module] = STATE(2632),
    [sym_import_alias] = STATE(2592),
    [sym_interface_declaration] = STATE(2592),
    [sym_enum_declaration] = STATE(2592),
    [sym_type_alias_declaration] = STATE(2592),
    [aux_sym_export_statement_repeat1] = STATE(3663),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2185),
    [anon_sym_EQ] = ACTIONS(1727),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2135),
    [anon_sym_import] = ACTIONS(2137),
    [anon_sym_var] = ACTIONS(2139),
    [anon_sym_let] = ACTIONS(2141),
    [anon_sym_const] = ACTIONS(2143),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(26),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2147),
    [anon_sym_async] = ACTIONS(2149),
    [anon_sym_function] = ACTIONS(2151),
    [anon_sym_EQ_GT] = ACTIONS(1729),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_declare] = ACTIONS(2153),
    [anon_sym_module] = ACTIONS(2187),
    [anon_sym_abstract] = ACTIONS(2157),
    [anon_sym_global] = ACTIONS(2189),
    [anon_sym_interface] = ACTIONS(2159),
    [anon_sym_enum] = ACTIONS(2161),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [644] = {
    [sym_declaration] = STATE(3762),
    [sym_variable_declaration] = STATE(3792),
    [sym_lexical_declaration] = STATE(3792),
    [sym_class_declaration] = STATE(3792),
    [sym_function_declaration] = STATE(3792),
    [sym_generator_function_declaration] = STATE(3792),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(3792),
    [sym_ambient_declaration] = STATE(3792),
    [sym_abstract_class_declaration] = STATE(3792),
    [sym_module] = STATE(3792),
    [sym_internal_module] = STATE(3767),
    [sym_import_alias] = STATE(3792),
    [sym_interface_declaration] = STATE(3792),
    [sym_enum_declaration] = STATE(3792),
    [sym_type_alias_declaration] = STATE(3792),
    [aux_sym_export_statement_repeat1] = STATE(3590),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2226),
    [anon_sym_EQ] = ACTIONS(1727),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2228),
    [anon_sym_import] = ACTIONS(2230),
    [anon_sym_var] = ACTIONS(2232),
    [anon_sym_let] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2236),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(26),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2238),
    [anon_sym_async] = ACTIONS(2240),
    [anon_sym_function] = ACTIONS(2242),
    [anon_sym_EQ_GT] = ACTIONS(1729),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_declare] = ACTIONS(2244),
    [anon_sym_module] = ACTIONS(2246),
    [anon_sym_abstract] = ACTIONS(2248),
    [anon_sym_global] = ACTIONS(2250),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2254),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [645] = {
    [sym__call_signature] = STATE(4702),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2205),
    [anon_sym_export] = ACTIONS(2207),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2207),
    [anon_sym_EQ] = ACTIONS(1402),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2207),
    [anon_sym_COMMA] = ACTIONS(1464),
    [anon_sym_RBRACE] = ACTIONS(1464),
    [anon_sym_from] = ACTIONS(2207),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2207),
    [anon_sym_COLON] = ACTIONS(1467),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(1464),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2207),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2207),
    [anon_sym_readonly] = ACTIONS(2207),
    [anon_sym_get] = ACTIONS(2207),
    [anon_sym_set] = ACTIONS(2207),
    [anon_sym_declare] = ACTIONS(2207),
    [anon_sym_public] = ACTIONS(2207),
    [anon_sym_private] = ACTIONS(2207),
    [anon_sym_protected] = ACTIONS(2207),
    [anon_sym_override] = ACTIONS(2207),
    [anon_sym_module] = ACTIONS(2207),
    [anon_sym_any] = ACTIONS(2207),
    [anon_sym_number] = ACTIONS(2207),
    [anon_sym_boolean] = ACTIONS(2207),
    [anon_sym_string] = ACTIONS(2207),
    [anon_sym_symbol] = ACTIONS(2207),
    [anon_sym_property] = ACTIONS(2207),
    [anon_sym_signal] = ACTIONS(2207),
    [anon_sym_on] = ACTIONS(2207),
    [anon_sym_required] = ACTIONS(2207),
    [anon_sym_component] = ACTIONS(2207),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [646] = {
    [sym__call_signature] = STATE(4803),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2209),
    [anon_sym_export] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2211),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2211),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(64),
    [anon_sym_from] = ACTIONS(2211),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2211),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2211),
    [anon_sym_function] = ACTIONS(2218),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2211),
    [anon_sym_readonly] = ACTIONS(2211),
    [anon_sym_get] = ACTIONS(2211),
    [anon_sym_set] = ACTIONS(2211),
    [anon_sym_declare] = ACTIONS(2211),
    [anon_sym_public] = ACTIONS(2211),
    [anon_sym_private] = ACTIONS(2211),
    [anon_sym_protected] = ACTIONS(2211),
    [anon_sym_override] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(2211),
    [anon_sym_any] = ACTIONS(2211),
    [anon_sym_number] = ACTIONS(2211),
    [anon_sym_boolean] = ACTIONS(2211),
    [anon_sym_string] = ACTIONS(2211),
    [anon_sym_symbol] = ACTIONS(2211),
    [anon_sym_property] = ACTIONS(2211),
    [anon_sym_signal] = ACTIONS(2211),
    [anon_sym_on] = ACTIONS(2211),
    [anon_sym_required] = ACTIONS(2211),
    [anon_sym_component] = ACTIONS(2211),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [647] = {
    [sym_declaration] = STATE(776),
    [sym_variable_declaration] = STATE(826),
    [sym_lexical_declaration] = STATE(826),
    [sym_class_declaration] = STATE(826),
    [sym_function_declaration] = STATE(826),
    [sym_generator_function_declaration] = STATE(826),
    [sym_decorator] = STATE(1128),
    [sym_function_signature] = STATE(826),
    [sym_ambient_declaration] = STATE(826),
    [sym_abstract_class_declaration] = STATE(826),
    [sym_module] = STATE(826),
    [sym_internal_module] = STATE(840),
    [sym_import_alias] = STATE(826),
    [sym_interface_declaration] = STATE(826),
    [sym_enum_declaration] = STATE(826),
    [sym_type_alias_declaration] = STATE(826),
    [aux_sym_export_statement_repeat1] = STATE(3695),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2099),
    [anon_sym_EQ] = ACTIONS(1727),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2167),
    [anon_sym_import] = ACTIONS(2059),
    [anon_sym_var] = ACTIONS(2139),
    [anon_sym_let] = ACTIONS(2063),
    [anon_sym_const] = ACTIONS(2065),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(26),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_class] = ACTIONS(2073),
    [anon_sym_async] = ACTIONS(2171),
    [anon_sym_function] = ACTIONS(2173),
    [anon_sym_EQ_GT] = ACTIONS(1729),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(64),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_declare] = ACTIONS(2175),
    [anon_sym_module] = ACTIONS(2181),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_global] = ACTIONS(2183),
    [anon_sym_interface] = ACTIONS(2085),
    [anon_sym_enum] = ACTIONS(2087),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [648] = {
    [sym__call_signature] = STATE(4795),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_export] = ACTIONS(2258),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2258),
    [anon_sym_EQ] = ACTIONS(1452),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_from] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2258),
    [anon_sym_function] = ACTIONS(2218),
    [anon_sym_EQ_GT] = ACTIONS(1454),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2258),
    [anon_sym_readonly] = ACTIONS(2258),
    [anon_sym_get] = ACTIONS(2258),
    [anon_sym_set] = ACTIONS(2258),
    [anon_sym_declare] = ACTIONS(2258),
    [anon_sym_public] = ACTIONS(2258),
    [anon_sym_private] = ACTIONS(2258),
    [anon_sym_protected] = ACTIONS(2258),
    [anon_sym_override] = ACTIONS(2258),
    [anon_sym_module] = ACTIONS(2258),
    [anon_sym_any] = ACTIONS(2258),
    [anon_sym_number] = ACTIONS(2258),
    [anon_sym_boolean] = ACTIONS(2258),
    [anon_sym_string] = ACTIONS(2258),
    [anon_sym_symbol] = ACTIONS(2258),
    [anon_sym_property] = ACTIONS(2258),
    [anon_sym_signal] = ACTIONS(2258),
    [anon_sym_on] = ACTIONS(2258),
    [anon_sym_required] = ACTIONS(2258),
    [anon_sym_component] = ACTIONS(2258),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [649] = {
    [sym__call_signature] = STATE(4937),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_export] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2265),
    [anon_sym_EQ] = ACTIONS(1741),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2265),
    [anon_sym_LBRACE] = ACTIONS(64),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_from] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2265),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(1743),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2265),
    [anon_sym_readonly] = ACTIONS(2265),
    [anon_sym_get] = ACTIONS(2265),
    [anon_sym_set] = ACTIONS(2265),
    [anon_sym_declare] = ACTIONS(2265),
    [anon_sym_public] = ACTIONS(2265),
    [anon_sym_private] = ACTIONS(2265),
    [anon_sym_protected] = ACTIONS(2265),
    [anon_sym_override] = ACTIONS(2265),
    [anon_sym_module] = ACTIONS(2265),
    [anon_sym_any] = ACTIONS(2265),
    [anon_sym_number] = ACTIONS(2265),
    [anon_sym_boolean] = ACTIONS(2265),
    [anon_sym_string] = ACTIONS(2265),
    [anon_sym_symbol] = ACTIONS(2265),
    [anon_sym_property] = ACTIONS(2265),
    [anon_sym_signal] = ACTIONS(2265),
    [anon_sym_on] = ACTIONS(2265),
    [anon_sym_required] = ACTIONS(2265),
    [anon_sym_component] = ACTIONS(2265),
    [anon_sym_implements] = ACTIONS(26),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [650] = {
    [sym__call_signature] = STATE(4803),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2209),
    [anon_sym_export] = ACTIONS(2211),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2211),
    [anon_sym_EQ] = ACTIONS(1444),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2211),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_from] = ACTIONS(2211),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(2267),
    [anon_sym_of] = ACTIONS(2270),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2211),
    [anon_sym_function] = ACTIONS(2218),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2211),
    [anon_sym_readonly] = ACTIONS(2211),
    [anon_sym_get] = ACTIONS(2211),
    [anon_sym_set] = ACTIONS(2211),
    [anon_sym_declare] = ACTIONS(2211),
    [anon_sym_public] = ACTIONS(2211),
    [anon_sym_private] = ACTIONS(2211),
    [anon_sym_protected] = ACTIONS(2211),
    [anon_sym_override] = ACTIONS(2211),
    [anon_sym_module] = ACTIONS(2211),
    [anon_sym_any] = ACTIONS(2211),
    [anon_sym_number] = ACTIONS(2211),
    [anon_sym_boolean] = ACTIONS(2211),
    [anon_sym_string] = ACTIONS(2211),
    [anon_sym_symbol] = ACTIONS(2211),
    [anon_sym_property] = ACTIONS(2211),
    [anon_sym_signal] = ACTIONS(2211),
    [anon_sym_on] = ACTIONS(2211),
    [anon_sym_required] = ACTIONS(2211),
    [anon_sym_component] = ACTIONS(2211),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [651] = {
    [sym_catch_clause] = STATE(675),
    [sym_finally_clause] = STATE(813),
    [sym_identifier] = ACTIONS(2272),
    [anon_sym_export] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_type] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_import] = ACTIONS(2272),
    [anon_sym_from] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2274),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_of] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_with] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_debugger] = ACTIONS(2272),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_catch] = ACTIONS(2276),
    [anon_sym_finally] = ACTIONS(2278),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_LTtemplate_GT] = ACTIONS(2274),
    [anon_sym_LT] = ACTIONS(2272),
    [anon_sym_SLASH] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_function] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_void] = ACTIONS(2272),
    [anon_sym_delete] = ACTIONS(2272),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2274),
    [sym_number] = ACTIONS(2274),
    [sym_this] = ACTIONS(2272),
    [sym_super] = ACTIONS(2272),
    [sym_true] = ACTIONS(2272),
    [sym_false] = ACTIONS(2272),
    [sym_null] = ACTIONS(2272),
    [sym_undefined] = ACTIONS(2272),
    [anon_sym_AT] = ACTIONS(2274),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_declare] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_module] = ACTIONS(2272),
    [anon_sym_any] = ACTIONS(2272),
    [anon_sym_number] = ACTIONS(2272),
    [anon_sym_boolean] = ACTIONS(2272),
    [anon_sym_string] = ACTIONS(2272),
    [anon_sym_symbol] = ACTIONS(2272),
    [anon_sym_property] = ACTIONS(2272),
    [anon_sym_signal] = ACTIONS(2272),
    [anon_sym_on] = ACTIONS(2272),
    [anon_sym_required] = ACTIONS(2272),
    [anon_sym_component] = ACTIONS(2272),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
  },
  [652] = {
    [sym__call_signature] = STATE(4937),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2263),
    [anon_sym_export] = ACTIONS(2265),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2265),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2265),
    [anon_sym_LBRACE] = ACTIONS(64),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_from] = ACTIONS(2265),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2265),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2265),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(1743),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2265),
    [anon_sym_readonly] = ACTIONS(2265),
    [anon_sym_get] = ACTIONS(2265),
    [anon_sym_set] = ACTIONS(2265),
    [anon_sym_declare] = ACTIONS(2265),
    [anon_sym_public] = ACTIONS(2265),
    [anon_sym_private] = ACTIONS(2265),
    [anon_sym_protected] = ACTIONS(2265),
    [anon_sym_override] = ACTIONS(2265),
    [anon_sym_module] = ACTIONS(2265),
    [anon_sym_any] = ACTIONS(2265),
    [anon_sym_number] = ACTIONS(2265),
    [anon_sym_boolean] = ACTIONS(2265),
    [anon_sym_string] = ACTIONS(2265),
    [anon_sym_symbol] = ACTIONS(2265),
    [anon_sym_property] = ACTIONS(2265),
    [anon_sym_signal] = ACTIONS(2265),
    [anon_sym_on] = ACTIONS(2265),
    [anon_sym_required] = ACTIONS(2265),
    [anon_sym_component] = ACTIONS(2265),
    [anon_sym_implements] = ACTIONS(26),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [653] = {
    [sym__call_signature] = STATE(4795),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2256),
    [anon_sym_export] = ACTIONS(2258),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2258),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_from] = ACTIONS(2258),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2258),
    [anon_sym_function] = ACTIONS(2218),
    [anon_sym_EQ_GT] = ACTIONS(1454),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2258),
    [anon_sym_readonly] = ACTIONS(2258),
    [anon_sym_get] = ACTIONS(2258),
    [anon_sym_set] = ACTIONS(2258),
    [anon_sym_declare] = ACTIONS(2258),
    [anon_sym_public] = ACTIONS(2258),
    [anon_sym_private] = ACTIONS(2258),
    [anon_sym_protected] = ACTIONS(2258),
    [anon_sym_override] = ACTIONS(2258),
    [anon_sym_module] = ACTIONS(2258),
    [anon_sym_any] = ACTIONS(2258),
    [anon_sym_number] = ACTIONS(2258),
    [anon_sym_boolean] = ACTIONS(2258),
    [anon_sym_string] = ACTIONS(2258),
    [anon_sym_symbol] = ACTIONS(2258),
    [anon_sym_property] = ACTIONS(2258),
    [anon_sym_signal] = ACTIONS(2258),
    [anon_sym_on] = ACTIONS(2258),
    [anon_sym_required] = ACTIONS(2258),
    [anon_sym_component] = ACTIONS(2258),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [654] = {
    [sym__call_signature] = STATE(4797),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_from] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2282),
    [anon_sym_COLON] = ACTIONS(2287),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2282),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(1762),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2282),
    [anon_sym_readonly] = ACTIONS(2282),
    [anon_sym_get] = ACTIONS(2282),
    [anon_sym_set] = ACTIONS(2282),
    [anon_sym_declare] = ACTIONS(2282),
    [anon_sym_public] = ACTIONS(2282),
    [anon_sym_private] = ACTIONS(2282),
    [anon_sym_protected] = ACTIONS(2282),
    [anon_sym_override] = ACTIONS(2282),
    [anon_sym_module] = ACTIONS(2282),
    [anon_sym_any] = ACTIONS(2282),
    [anon_sym_number] = ACTIONS(2282),
    [anon_sym_boolean] = ACTIONS(2282),
    [anon_sym_string] = ACTIONS(2282),
    [anon_sym_symbol] = ACTIONS(2282),
    [anon_sym_property] = ACTIONS(2282),
    [anon_sym_signal] = ACTIONS(2282),
    [anon_sym_on] = ACTIONS(2282),
    [anon_sym_required] = ACTIONS(2282),
    [anon_sym_component] = ACTIONS(2282),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [655] = {
    [sym__call_signature] = STATE(4797),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2282),
    [anon_sym_from] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2282),
    [anon_sym_COLON] = ACTIONS(2287),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2282),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(1762),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2282),
    [anon_sym_readonly] = ACTIONS(2282),
    [anon_sym_get] = ACTIONS(2282),
    [anon_sym_set] = ACTIONS(2282),
    [anon_sym_declare] = ACTIONS(2282),
    [anon_sym_public] = ACTIONS(2282),
    [anon_sym_private] = ACTIONS(2282),
    [anon_sym_protected] = ACTIONS(2282),
    [anon_sym_override] = ACTIONS(2282),
    [anon_sym_module] = ACTIONS(2282),
    [anon_sym_any] = ACTIONS(2282),
    [anon_sym_number] = ACTIONS(2282),
    [anon_sym_boolean] = ACTIONS(2282),
    [anon_sym_string] = ACTIONS(2282),
    [anon_sym_symbol] = ACTIONS(2282),
    [anon_sym_property] = ACTIONS(2282),
    [anon_sym_signal] = ACTIONS(2282),
    [anon_sym_on] = ACTIONS(2282),
    [anon_sym_required] = ACTIONS(2282),
    [anon_sym_component] = ACTIONS(2282),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [656] = {
    [sym__call_signature] = STATE(4841),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2289),
    [anon_sym_export] = ACTIONS(2291),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2291),
    [anon_sym_EQ] = ACTIONS(1727),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2291),
    [anon_sym_from] = ACTIONS(2291),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2291),
    [anon_sym_function] = ACTIONS(2218),
    [anon_sym_EQ_GT] = ACTIONS(1729),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2291),
    [anon_sym_readonly] = ACTIONS(2291),
    [anon_sym_get] = ACTIONS(2291),
    [anon_sym_set] = ACTIONS(2291),
    [anon_sym_declare] = ACTIONS(2291),
    [anon_sym_public] = ACTIONS(2291),
    [anon_sym_private] = ACTIONS(2291),
    [anon_sym_protected] = ACTIONS(2291),
    [anon_sym_override] = ACTIONS(2291),
    [anon_sym_module] = ACTIONS(2291),
    [anon_sym_any] = ACTIONS(2291),
    [anon_sym_number] = ACTIONS(2291),
    [anon_sym_boolean] = ACTIONS(2291),
    [anon_sym_string] = ACTIONS(2291),
    [anon_sym_symbol] = ACTIONS(2291),
    [anon_sym_property] = ACTIONS(2291),
    [anon_sym_signal] = ACTIONS(2291),
    [anon_sym_on] = ACTIONS(2291),
    [anon_sym_required] = ACTIONS(2291),
    [anon_sym_component] = ACTIONS(2291),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [657] = {
    [sym__call_signature] = STATE(4841),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2289),
    [anon_sym_export] = ACTIONS(2291),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2291),
    [anon_sym_EQ] = ACTIONS(1727),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2291),
    [anon_sym_from] = ACTIONS(2291),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2291),
    [anon_sym_function] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(1729),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2291),
    [anon_sym_readonly] = ACTIONS(2291),
    [anon_sym_get] = ACTIONS(2291),
    [anon_sym_set] = ACTIONS(2291),
    [anon_sym_declare] = ACTIONS(2291),
    [anon_sym_public] = ACTIONS(2291),
    [anon_sym_private] = ACTIONS(2291),
    [anon_sym_protected] = ACTIONS(2291),
    [anon_sym_override] = ACTIONS(2291),
    [anon_sym_module] = ACTIONS(2291),
    [anon_sym_any] = ACTIONS(2291),
    [anon_sym_number] = ACTIONS(2291),
    [anon_sym_boolean] = ACTIONS(2291),
    [anon_sym_string] = ACTIONS(2291),
    [anon_sym_symbol] = ACTIONS(2291),
    [anon_sym_property] = ACTIONS(2291),
    [anon_sym_signal] = ACTIONS(2291),
    [anon_sym_on] = ACTIONS(2291),
    [anon_sym_required] = ACTIONS(2291),
    [anon_sym_component] = ACTIONS(2291),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [658] = {
    [sym__call_signature] = STATE(4841),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2289),
    [anon_sym_export] = ACTIONS(2291),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2291),
    [anon_sym_EQ] = ACTIONS(1727),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2291),
    [anon_sym_from] = ACTIONS(2291),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2291),
    [anon_sym_function] = ACTIONS(2224),
    [anon_sym_EQ_GT] = ACTIONS(1729),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2291),
    [anon_sym_readonly] = ACTIONS(2291),
    [anon_sym_get] = ACTIONS(2291),
    [anon_sym_set] = ACTIONS(2291),
    [anon_sym_declare] = ACTIONS(2291),
    [anon_sym_public] = ACTIONS(2291),
    [anon_sym_private] = ACTIONS(2291),
    [anon_sym_protected] = ACTIONS(2291),
    [anon_sym_override] = ACTIONS(2291),
    [anon_sym_module] = ACTIONS(2291),
    [anon_sym_any] = ACTIONS(2291),
    [anon_sym_number] = ACTIONS(2291),
    [anon_sym_boolean] = ACTIONS(2291),
    [anon_sym_string] = ACTIONS(2291),
    [anon_sym_symbol] = ACTIONS(2291),
    [anon_sym_property] = ACTIONS(2291),
    [anon_sym_signal] = ACTIONS(2291),
    [anon_sym_on] = ACTIONS(2291),
    [anon_sym_required] = ACTIONS(2291),
    [anon_sym_component] = ACTIONS(2291),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [659] = {
    [sym_identifier] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_default] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_COMMA] = ACTIONS(1611),
    [anon_sym_RBRACE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_from] = ACTIONS(1609),
    [anon_sym_var] = ACTIONS(1609),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_else] = ACTIONS(1609),
    [anon_sym_if] = ACTIONS(1609),
    [anon_sym_switch] = ACTIONS(1609),
    [anon_sym_for] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1611),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_of] = ACTIONS(1609),
    [anon_sym_while] = ACTIONS(1609),
    [anon_sym_do] = ACTIONS(1609),
    [anon_sym_try] = ACTIONS(1609),
    [anon_sym_with] = ACTIONS(1609),
    [anon_sym_break] = ACTIONS(1609),
    [anon_sym_continue] = ACTIONS(1609),
    [anon_sym_debugger] = ACTIONS(1609),
    [anon_sym_return] = ACTIONS(1609),
    [anon_sym_throw] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1611),
    [anon_sym_case] = ACTIONS(1609),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1611),
    [anon_sym_LTtemplate_GT] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1609),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1611),
    [sym_number] = ACTIONS(1611),
    [sym_this] = ACTIONS(1609),
    [sym_super] = ACTIONS(1609),
    [sym_true] = ACTIONS(1609),
    [sym_false] = ACTIONS(1609),
    [sym_null] = ACTIONS(1609),
    [sym_undefined] = ACTIONS(1609),
    [anon_sym_AT] = ACTIONS(1611),
    [anon_sym_static] = ACTIONS(1609),
    [anon_sym_readonly] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_override] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_property] = ACTIONS(1609),
    [anon_sym_signal] = ACTIONS(1609),
    [anon_sym_on] = ACTIONS(1609),
    [anon_sym_required] = ACTIONS(1609),
    [anon_sym_component] = ACTIONS(1609),
    [anon_sym_abstract] = ACTIONS(1609),
    [anon_sym_interface] = ACTIONS(1609),
    [anon_sym_enum] = ACTIONS(1609),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1611),
    [sym__automatic_semicolon] = ACTIONS(1611),
  },
  [660] = {
    [sym_identifier] = ACTIONS(1585),
    [anon_sym_export] = ACTIONS(1585),
    [anon_sym_default] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(1585),
    [anon_sym_namespace] = ACTIONS(1585),
    [anon_sym_LBRACE] = ACTIONS(1587),
    [anon_sym_COMMA] = ACTIONS(1587),
    [anon_sym_RBRACE] = ACTIONS(1587),
    [anon_sym_typeof] = ACTIONS(1585),
    [anon_sym_import] = ACTIONS(1585),
    [anon_sym_from] = ACTIONS(1585),
    [anon_sym_var] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(1585),
    [anon_sym_const] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_else] = ACTIONS(1585),
    [anon_sym_if] = ACTIONS(1585),
    [anon_sym_switch] = ACTIONS(1585),
    [anon_sym_for] = ACTIONS(1585),
    [anon_sym_LPAREN] = ACTIONS(1587),
    [anon_sym_await] = ACTIONS(1585),
    [anon_sym_of] = ACTIONS(1585),
    [anon_sym_while] = ACTIONS(1585),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_try] = ACTIONS(1585),
    [anon_sym_with] = ACTIONS(1585),
    [anon_sym_break] = ACTIONS(1585),
    [anon_sym_continue] = ACTIONS(1585),
    [anon_sym_debugger] = ACTIONS(1585),
    [anon_sym_return] = ACTIONS(1585),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_SEMI] = ACTIONS(1587),
    [anon_sym_case] = ACTIONS(1585),
    [anon_sym_yield] = ACTIONS(1585),
    [anon_sym_LBRACK] = ACTIONS(1587),
    [anon_sym_LTtemplate_GT] = ACTIONS(1587),
    [anon_sym_LT] = ACTIONS(1585),
    [anon_sym_SLASH] = ACTIONS(1585),
    [anon_sym_class] = ACTIONS(1585),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_function] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_void] = ACTIONS(1585),
    [anon_sym_delete] = ACTIONS(1585),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_DQUOTE] = ACTIONS(1587),
    [anon_sym_SQUOTE] = ACTIONS(1587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1587),
    [sym_number] = ACTIONS(1587),
    [sym_this] = ACTIONS(1585),
    [sym_super] = ACTIONS(1585),
    [sym_true] = ACTIONS(1585),
    [sym_false] = ACTIONS(1585),
    [sym_null] = ACTIONS(1585),
    [sym_undefined] = ACTIONS(1585),
    [anon_sym_AT] = ACTIONS(1587),
    [anon_sym_static] = ACTIONS(1585),
    [anon_sym_readonly] = ACTIONS(1585),
    [anon_sym_get] = ACTIONS(1585),
    [anon_sym_set] = ACTIONS(1585),
    [anon_sym_declare] = ACTIONS(1585),
    [anon_sym_public] = ACTIONS(1585),
    [anon_sym_private] = ACTIONS(1585),
    [anon_sym_protected] = ACTIONS(1585),
    [anon_sym_override] = ACTIONS(1585),
    [anon_sym_module] = ACTIONS(1585),
    [anon_sym_any] = ACTIONS(1585),
    [anon_sym_number] = ACTIONS(1585),
    [anon_sym_boolean] = ACTIONS(1585),
    [anon_sym_string] = ACTIONS(1585),
    [anon_sym_symbol] = ACTIONS(1585),
    [anon_sym_property] = ACTIONS(1585),
    [anon_sym_signal] = ACTIONS(1585),
    [anon_sym_on] = ACTIONS(1585),
    [anon_sym_required] = ACTIONS(1585),
    [anon_sym_component] = ACTIONS(1585),
    [anon_sym_abstract] = ACTIONS(1585),
    [anon_sym_interface] = ACTIONS(1585),
    [anon_sym_enum] = ACTIONS(1585),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1587),
    [sym__automatic_semicolon] = ACTIONS(1587),
  },
  [661] = {
    [sym__call_signature] = STATE(4797),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(2284),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2282),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_from] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2282),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(1762),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2282),
    [anon_sym_readonly] = ACTIONS(2282),
    [anon_sym_get] = ACTIONS(2282),
    [anon_sym_set] = ACTIONS(2282),
    [anon_sym_declare] = ACTIONS(2282),
    [anon_sym_public] = ACTIONS(2282),
    [anon_sym_private] = ACTIONS(2282),
    [anon_sym_protected] = ACTIONS(2282),
    [anon_sym_override] = ACTIONS(2282),
    [anon_sym_module] = ACTIONS(2282),
    [anon_sym_any] = ACTIONS(2282),
    [anon_sym_number] = ACTIONS(2282),
    [anon_sym_boolean] = ACTIONS(2282),
    [anon_sym_string] = ACTIONS(2282),
    [anon_sym_symbol] = ACTIONS(2282),
    [anon_sym_property] = ACTIONS(2282),
    [anon_sym_signal] = ACTIONS(2282),
    [anon_sym_on] = ACTIONS(2282),
    [anon_sym_required] = ACTIONS(2282),
    [anon_sym_component] = ACTIONS(2282),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [662] = {
    [sym__call_signature] = STATE(4841),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2289),
    [anon_sym_export] = ACTIONS(2291),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2291),
    [anon_sym_EQ] = ACTIONS(1727),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2291),
    [anon_sym_from] = ACTIONS(2291),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2291),
    [anon_sym_function] = ACTIONS(2031),
    [anon_sym_EQ_GT] = ACTIONS(1729),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2291),
    [anon_sym_readonly] = ACTIONS(2291),
    [anon_sym_get] = ACTIONS(2291),
    [anon_sym_set] = ACTIONS(2291),
    [anon_sym_declare] = ACTIONS(2291),
    [anon_sym_public] = ACTIONS(2291),
    [anon_sym_private] = ACTIONS(2291),
    [anon_sym_protected] = ACTIONS(2291),
    [anon_sym_override] = ACTIONS(2291),
    [anon_sym_module] = ACTIONS(2291),
    [anon_sym_any] = ACTIONS(2291),
    [anon_sym_number] = ACTIONS(2291),
    [anon_sym_boolean] = ACTIONS(2291),
    [anon_sym_string] = ACTIONS(2291),
    [anon_sym_symbol] = ACTIONS(2291),
    [anon_sym_property] = ACTIONS(2291),
    [anon_sym_signal] = ACTIONS(2291),
    [anon_sym_on] = ACTIONS(2291),
    [anon_sym_required] = ACTIONS(2291),
    [anon_sym_component] = ACTIONS(2291),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [663] = {
    [sym__call_signature] = STATE(4797),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2282),
    [anon_sym_from] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2282),
    [anon_sym_COLON] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2282),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(1762),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2282),
    [anon_sym_readonly] = ACTIONS(2282),
    [anon_sym_get] = ACTIONS(2282),
    [anon_sym_set] = ACTIONS(2282),
    [anon_sym_declare] = ACTIONS(2282),
    [anon_sym_public] = ACTIONS(2282),
    [anon_sym_private] = ACTIONS(2282),
    [anon_sym_protected] = ACTIONS(2282),
    [anon_sym_override] = ACTIONS(2282),
    [anon_sym_module] = ACTIONS(2282),
    [anon_sym_any] = ACTIONS(2282),
    [anon_sym_number] = ACTIONS(2282),
    [anon_sym_boolean] = ACTIONS(2282),
    [anon_sym_string] = ACTIONS(2282),
    [anon_sym_symbol] = ACTIONS(2282),
    [anon_sym_property] = ACTIONS(2282),
    [anon_sym_signal] = ACTIONS(2282),
    [anon_sym_on] = ACTIONS(2282),
    [anon_sym_required] = ACTIONS(2282),
    [anon_sym_component] = ACTIONS(2282),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [664] = {
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_type] = ACTIONS(1473),
    [anon_sym_namespace] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1479),
    [anon_sym_RBRACE] = ACTIONS(1479),
    [anon_sym_typeof] = ACTIONS(1473),
    [anon_sym_import] = ACTIONS(1473),
    [anon_sym_from] = ACTIONS(1473),
    [anon_sym_var] = ACTIONS(1473),
    [anon_sym_let] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_await] = ACTIONS(1473),
    [anon_sym_of] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_try] = ACTIONS(1473),
    [anon_sym_with] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_debugger] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_throw] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1479),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_catch] = ACTIONS(1473),
    [anon_sym_finally] = ACTIONS(1473),
    [anon_sym_yield] = ACTIONS(1473),
    [anon_sym_LBRACK] = ACTIONS(1479),
    [anon_sym_LTtemplate_GT] = ACTIONS(1479),
    [anon_sym_LT] = ACTIONS(1473),
    [anon_sym_SLASH] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_function] = ACTIONS(1473),
    [anon_sym_new] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_void] = ACTIONS(1473),
    [anon_sym_delete] = ACTIONS(1473),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_DQUOTE] = ACTIONS(1479),
    [anon_sym_SQUOTE] = ACTIONS(1479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1479),
    [sym_number] = ACTIONS(1479),
    [sym_this] = ACTIONS(1473),
    [sym_super] = ACTIONS(1473),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [sym_null] = ACTIONS(1473),
    [sym_undefined] = ACTIONS(1473),
    [anon_sym_AT] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_get] = ACTIONS(1473),
    [anon_sym_set] = ACTIONS(1473),
    [anon_sym_declare] = ACTIONS(1473),
    [anon_sym_public] = ACTIONS(1473),
    [anon_sym_private] = ACTIONS(1473),
    [anon_sym_protected] = ACTIONS(1473),
    [anon_sym_override] = ACTIONS(1473),
    [anon_sym_module] = ACTIONS(1473),
    [anon_sym_any] = ACTIONS(1473),
    [anon_sym_number] = ACTIONS(1473),
    [anon_sym_boolean] = ACTIONS(1473),
    [anon_sym_string] = ACTIONS(1473),
    [anon_sym_symbol] = ACTIONS(1473),
    [anon_sym_property] = ACTIONS(1473),
    [anon_sym_signal] = ACTIONS(1473),
    [anon_sym_on] = ACTIONS(1473),
    [anon_sym_required] = ACTIONS(1473),
    [anon_sym_component] = ACTIONS(1473),
    [anon_sym_abstract] = ACTIONS(1473),
    [anon_sym_interface] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [sym__automatic_semicolon] = ACTIONS(1483),
  },
  [665] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_export] = ACTIONS(1533),
    [anon_sym_default] = ACTIONS(1533),
    [anon_sym_type] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1533),
    [anon_sym_LBRACE] = ACTIONS(1535),
    [anon_sym_RBRACE] = ACTIONS(1535),
    [anon_sym_typeof] = ACTIONS(1533),
    [anon_sym_import] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(1533),
    [anon_sym_var] = ACTIONS(1533),
    [anon_sym_let] = ACTIONS(1533),
    [anon_sym_const] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_else] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_switch] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_of] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_do] = ACTIONS(1533),
    [anon_sym_try] = ACTIONS(1533),
    [anon_sym_with] = ACTIONS(1533),
    [anon_sym_break] = ACTIONS(1533),
    [anon_sym_continue] = ACTIONS(1533),
    [anon_sym_debugger] = ACTIONS(1533),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_throw] = ACTIONS(1533),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym_case] = ACTIONS(1533),
    [anon_sym_catch] = ACTIONS(1533),
    [anon_sym_finally] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1535),
    [anon_sym_LTtemplate_GT] = ACTIONS(1535),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(1533),
    [anon_sym_async] = ACTIONS(1533),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_new] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1533),
    [anon_sym_delete] = ACTIONS(1533),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1535),
    [sym_number] = ACTIONS(1535),
    [sym_this] = ACTIONS(1533),
    [sym_super] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_undefined] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(1535),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_readonly] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1533),
    [anon_sym_set] = ACTIONS(1533),
    [anon_sym_declare] = ACTIONS(1533),
    [anon_sym_public] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1533),
    [anon_sym_protected] = ACTIONS(1533),
    [anon_sym_override] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1533),
    [anon_sym_any] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1533),
    [anon_sym_property] = ACTIONS(1533),
    [anon_sym_signal] = ACTIONS(1533),
    [anon_sym_on] = ACTIONS(1533),
    [anon_sym_required] = ACTIONS(1533),
    [anon_sym_component] = ACTIONS(1533),
    [anon_sym_abstract] = ACTIONS(1533),
    [anon_sym_interface] = ACTIONS(1533),
    [anon_sym_enum] = ACTIONS(1533),
    [sym__automatic_semicolon] = ACTIONS(2297),
  },
  [666] = {
    [sym__call_signature] = STATE(4841),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2289),
    [anon_sym_export] = ACTIONS(2291),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2291),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2291),
    [anon_sym_from] = ACTIONS(2291),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2291),
    [anon_sym_function] = ACTIONS(2218),
    [anon_sym_EQ_GT] = ACTIONS(1729),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2291),
    [anon_sym_readonly] = ACTIONS(2291),
    [anon_sym_get] = ACTIONS(2291),
    [anon_sym_set] = ACTIONS(2291),
    [anon_sym_declare] = ACTIONS(2291),
    [anon_sym_public] = ACTIONS(2291),
    [anon_sym_private] = ACTIONS(2291),
    [anon_sym_protected] = ACTIONS(2291),
    [anon_sym_override] = ACTIONS(2291),
    [anon_sym_module] = ACTIONS(2291),
    [anon_sym_any] = ACTIONS(2291),
    [anon_sym_number] = ACTIONS(2291),
    [anon_sym_boolean] = ACTIONS(2291),
    [anon_sym_string] = ACTIONS(2291),
    [anon_sym_symbol] = ACTIONS(2291),
    [anon_sym_property] = ACTIONS(2291),
    [anon_sym_signal] = ACTIONS(2291),
    [anon_sym_on] = ACTIONS(2291),
    [anon_sym_required] = ACTIONS(2291),
    [anon_sym_component] = ACTIONS(2291),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [667] = {
    [sym__call_signature] = STATE(4841),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2289),
    [anon_sym_export] = ACTIONS(2291),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2291),
    [anon_sym_EQ] = ACTIONS(1727),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2291),
    [anon_sym_from] = ACTIONS(2291),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2291),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2291),
    [anon_sym_function] = ACTIONS(2222),
    [anon_sym_EQ_GT] = ACTIONS(1729),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2291),
    [anon_sym_readonly] = ACTIONS(2291),
    [anon_sym_get] = ACTIONS(2291),
    [anon_sym_set] = ACTIONS(2291),
    [anon_sym_declare] = ACTIONS(2291),
    [anon_sym_public] = ACTIONS(2291),
    [anon_sym_private] = ACTIONS(2291),
    [anon_sym_protected] = ACTIONS(2291),
    [anon_sym_override] = ACTIONS(2291),
    [anon_sym_module] = ACTIONS(2291),
    [anon_sym_any] = ACTIONS(2291),
    [anon_sym_number] = ACTIONS(2291),
    [anon_sym_boolean] = ACTIONS(2291),
    [anon_sym_string] = ACTIONS(2291),
    [anon_sym_symbol] = ACTIONS(2291),
    [anon_sym_property] = ACTIONS(2291),
    [anon_sym_signal] = ACTIONS(2291),
    [anon_sym_on] = ACTIONS(2291),
    [anon_sym_required] = ACTIONS(2291),
    [anon_sym_component] = ACTIONS(2291),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [668] = {
    [sym__call_signature] = STATE(4797),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2282),
    [anon_sym_from] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2282),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(1762),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2282),
    [anon_sym_readonly] = ACTIONS(2282),
    [anon_sym_get] = ACTIONS(2282),
    [anon_sym_set] = ACTIONS(2282),
    [anon_sym_declare] = ACTIONS(2282),
    [anon_sym_public] = ACTIONS(2282),
    [anon_sym_private] = ACTIONS(2282),
    [anon_sym_protected] = ACTIONS(2282),
    [anon_sym_override] = ACTIONS(2282),
    [anon_sym_module] = ACTIONS(2282),
    [anon_sym_any] = ACTIONS(2282),
    [anon_sym_number] = ACTIONS(2282),
    [anon_sym_boolean] = ACTIONS(2282),
    [anon_sym_string] = ACTIONS(2282),
    [anon_sym_symbol] = ACTIONS(2282),
    [anon_sym_property] = ACTIONS(2282),
    [anon_sym_signal] = ACTIONS(2282),
    [anon_sym_on] = ACTIONS(2282),
    [anon_sym_required] = ACTIONS(2282),
    [anon_sym_component] = ACTIONS(2282),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [669] = {
    [sym__call_signature] = STATE(4797),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2280),
    [anon_sym_export] = ACTIONS(2282),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2282),
    [anon_sym_from] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2282),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2282),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(1762),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2282),
    [anon_sym_readonly] = ACTIONS(2282),
    [anon_sym_get] = ACTIONS(2282),
    [anon_sym_set] = ACTIONS(2282),
    [anon_sym_declare] = ACTIONS(2282),
    [anon_sym_public] = ACTIONS(2282),
    [anon_sym_private] = ACTIONS(2282),
    [anon_sym_protected] = ACTIONS(2282),
    [anon_sym_override] = ACTIONS(2282),
    [anon_sym_module] = ACTIONS(2282),
    [anon_sym_any] = ACTIONS(2282),
    [anon_sym_number] = ACTIONS(2282),
    [anon_sym_boolean] = ACTIONS(2282),
    [anon_sym_string] = ACTIONS(2282),
    [anon_sym_symbol] = ACTIONS(2282),
    [anon_sym_property] = ACTIONS(2282),
    [anon_sym_signal] = ACTIONS(2282),
    [anon_sym_on] = ACTIONS(2282),
    [anon_sym_required] = ACTIONS(2282),
    [anon_sym_component] = ACTIONS(2282),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [670] = {
    [sym__call_signature] = STATE(4751),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_export] = ACTIONS(2301),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2301),
    [anon_sym_EQ] = ACTIONS(1764),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2301),
    [anon_sym_from] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2301),
    [anon_sym_COLON] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2301),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(1766),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2301),
    [anon_sym_readonly] = ACTIONS(2301),
    [anon_sym_get] = ACTIONS(2301),
    [anon_sym_set] = ACTIONS(2301),
    [anon_sym_declare] = ACTIONS(2301),
    [anon_sym_public] = ACTIONS(2301),
    [anon_sym_private] = ACTIONS(2301),
    [anon_sym_protected] = ACTIONS(2301),
    [anon_sym_override] = ACTIONS(2301),
    [anon_sym_module] = ACTIONS(2301),
    [anon_sym_any] = ACTIONS(2301),
    [anon_sym_number] = ACTIONS(2301),
    [anon_sym_boolean] = ACTIONS(2301),
    [anon_sym_string] = ACTIONS(2301),
    [anon_sym_symbol] = ACTIONS(2301),
    [anon_sym_property] = ACTIONS(2301),
    [anon_sym_signal] = ACTIONS(2301),
    [anon_sym_on] = ACTIONS(2301),
    [anon_sym_required] = ACTIONS(2301),
    [anon_sym_component] = ACTIONS(2301),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [671] = {
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_export] = ACTIONS(1519),
    [anon_sym_default] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(1519),
    [anon_sym_namespace] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_RBRACE] = ACTIONS(1521),
    [anon_sym_typeof] = ACTIONS(1519),
    [anon_sym_import] = ACTIONS(1519),
    [anon_sym_from] = ACTIONS(1519),
    [anon_sym_var] = ACTIONS(1519),
    [anon_sym_let] = ACTIONS(1519),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_else] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_switch] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_await] = ACTIONS(1519),
    [anon_sym_of] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_do] = ACTIONS(1519),
    [anon_sym_try] = ACTIONS(1519),
    [anon_sym_with] = ACTIONS(1519),
    [anon_sym_break] = ACTIONS(1519),
    [anon_sym_continue] = ACTIONS(1519),
    [anon_sym_debugger] = ACTIONS(1519),
    [anon_sym_return] = ACTIONS(1519),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_SEMI] = ACTIONS(1521),
    [anon_sym_case] = ACTIONS(1519),
    [anon_sym_catch] = ACTIONS(1519),
    [anon_sym_finally] = ACTIONS(1519),
    [anon_sym_yield] = ACTIONS(1519),
    [anon_sym_LBRACK] = ACTIONS(1521),
    [anon_sym_LTtemplate_GT] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1519),
    [anon_sym_class] = ACTIONS(1519),
    [anon_sym_async] = ACTIONS(1519),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_new] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_void] = ACTIONS(1519),
    [anon_sym_delete] = ACTIONS(1519),
    [anon_sym_PLUS_PLUS] = ACTIONS(1521),
    [anon_sym_DASH_DASH] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1521),
    [sym_number] = ACTIONS(1521),
    [sym_this] = ACTIONS(1519),
    [sym_super] = ACTIONS(1519),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_undefined] = ACTIONS(1519),
    [anon_sym_AT] = ACTIONS(1521),
    [anon_sym_static] = ACTIONS(1519),
    [anon_sym_readonly] = ACTIONS(1519),
    [anon_sym_get] = ACTIONS(1519),
    [anon_sym_set] = ACTIONS(1519),
    [anon_sym_declare] = ACTIONS(1519),
    [anon_sym_public] = ACTIONS(1519),
    [anon_sym_private] = ACTIONS(1519),
    [anon_sym_protected] = ACTIONS(1519),
    [anon_sym_override] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(1519),
    [anon_sym_any] = ACTIONS(1519),
    [anon_sym_number] = ACTIONS(1519),
    [anon_sym_boolean] = ACTIONS(1519),
    [anon_sym_string] = ACTIONS(1519),
    [anon_sym_symbol] = ACTIONS(1519),
    [anon_sym_property] = ACTIONS(1519),
    [anon_sym_signal] = ACTIONS(1519),
    [anon_sym_on] = ACTIONS(1519),
    [anon_sym_required] = ACTIONS(1519),
    [anon_sym_component] = ACTIONS(1519),
    [anon_sym_abstract] = ACTIONS(1519),
    [anon_sym_interface] = ACTIONS(1519),
    [anon_sym_enum] = ACTIONS(1519),
  },
  [672] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_export] = ACTIONS(1533),
    [anon_sym_default] = ACTIONS(1533),
    [anon_sym_type] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1533),
    [anon_sym_LBRACE] = ACTIONS(1535),
    [anon_sym_RBRACE] = ACTIONS(1535),
    [anon_sym_typeof] = ACTIONS(1533),
    [anon_sym_import] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(1533),
    [anon_sym_var] = ACTIONS(1533),
    [anon_sym_let] = ACTIONS(1533),
    [anon_sym_const] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_else] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_switch] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_of] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_do] = ACTIONS(1533),
    [anon_sym_try] = ACTIONS(1533),
    [anon_sym_with] = ACTIONS(1533),
    [anon_sym_break] = ACTIONS(1533),
    [anon_sym_continue] = ACTIONS(1533),
    [anon_sym_debugger] = ACTIONS(1533),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_throw] = ACTIONS(1533),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym_case] = ACTIONS(1533),
    [anon_sym_catch] = ACTIONS(1533),
    [anon_sym_finally] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1535),
    [anon_sym_LTtemplate_GT] = ACTIONS(1535),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(1533),
    [anon_sym_async] = ACTIONS(1533),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_new] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1533),
    [anon_sym_delete] = ACTIONS(1533),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1535),
    [sym_number] = ACTIONS(1535),
    [sym_this] = ACTIONS(1533),
    [sym_super] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_undefined] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(1535),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_readonly] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1533),
    [anon_sym_set] = ACTIONS(1533),
    [anon_sym_declare] = ACTIONS(1533),
    [anon_sym_public] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1533),
    [anon_sym_protected] = ACTIONS(1533),
    [anon_sym_override] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1533),
    [anon_sym_any] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1533),
    [anon_sym_property] = ACTIONS(1533),
    [anon_sym_signal] = ACTIONS(1533),
    [anon_sym_on] = ACTIONS(1533),
    [anon_sym_required] = ACTIONS(1533),
    [anon_sym_component] = ACTIONS(1533),
    [anon_sym_abstract] = ACTIONS(1533),
    [anon_sym_interface] = ACTIONS(1533),
    [anon_sym_enum] = ACTIONS(1533),
  },
  [673] = {
    [sym__call_signature] = STATE(4751),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2299),
    [anon_sym_export] = ACTIONS(2301),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2301),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2301),
    [anon_sym_from] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2301),
    [anon_sym_COLON] = ACTIONS(64),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2301),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(1766),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2301),
    [anon_sym_readonly] = ACTIONS(2301),
    [anon_sym_get] = ACTIONS(2301),
    [anon_sym_set] = ACTIONS(2301),
    [anon_sym_declare] = ACTIONS(2301),
    [anon_sym_public] = ACTIONS(2301),
    [anon_sym_private] = ACTIONS(2301),
    [anon_sym_protected] = ACTIONS(2301),
    [anon_sym_override] = ACTIONS(2301),
    [anon_sym_module] = ACTIONS(2301),
    [anon_sym_any] = ACTIONS(2301),
    [anon_sym_number] = ACTIONS(2301),
    [anon_sym_boolean] = ACTIONS(2301),
    [anon_sym_string] = ACTIONS(2301),
    [anon_sym_symbol] = ACTIONS(2301),
    [anon_sym_property] = ACTIONS(2301),
    [anon_sym_signal] = ACTIONS(2301),
    [anon_sym_on] = ACTIONS(2301),
    [anon_sym_required] = ACTIONS(2301),
    [anon_sym_component] = ACTIONS(2301),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [674] = {
    [sym_statement_block] = STATE(810),
    [sym_identifier] = ACTIONS(1487),
    [anon_sym_export] = ACTIONS(1487),
    [anon_sym_default] = ACTIONS(1487),
    [anon_sym_type] = ACTIONS(1487),
    [anon_sym_namespace] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(2303),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_import] = ACTIONS(1487),
    [anon_sym_from] = ACTIONS(1487),
    [anon_sym_var] = ACTIONS(1487),
    [anon_sym_let] = ACTIONS(1487),
    [anon_sym_const] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(1491),
    [anon_sym_await] = ACTIONS(1487),
    [anon_sym_of] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(1487),
    [anon_sym_try] = ACTIONS(1487),
    [anon_sym_with] = ACTIONS(1487),
    [anon_sym_break] = ACTIONS(1487),
    [anon_sym_continue] = ACTIONS(1487),
    [anon_sym_debugger] = ACTIONS(1487),
    [anon_sym_return] = ACTIONS(1487),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_case] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1491),
    [anon_sym_LTtemplate_GT] = ACTIONS(1491),
    [anon_sym_LT] = ACTIONS(1487),
    [anon_sym_SLASH] = ACTIONS(1487),
    [anon_sym_DOT] = ACTIONS(2305),
    [anon_sym_class] = ACTIONS(1487),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_new] = ACTIONS(1487),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(1491),
    [anon_sym_SQUOTE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1491),
    [sym_number] = ACTIONS(1491),
    [sym_this] = ACTIONS(1487),
    [sym_super] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_undefined] = ACTIONS(1487),
    [anon_sym_AT] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1487),
    [anon_sym_readonly] = ACTIONS(1487),
    [anon_sym_get] = ACTIONS(1487),
    [anon_sym_set] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1487),
    [anon_sym_public] = ACTIONS(1487),
    [anon_sym_private] = ACTIONS(1487),
    [anon_sym_protected] = ACTIONS(1487),
    [anon_sym_override] = ACTIONS(1487),
    [anon_sym_module] = ACTIONS(1487),
    [anon_sym_any] = ACTIONS(1487),
    [anon_sym_number] = ACTIONS(1487),
    [anon_sym_boolean] = ACTIONS(1487),
    [anon_sym_string] = ACTIONS(1487),
    [anon_sym_symbol] = ACTIONS(1487),
    [anon_sym_property] = ACTIONS(1487),
    [anon_sym_signal] = ACTIONS(1487),
    [anon_sym_on] = ACTIONS(1487),
    [anon_sym_required] = ACTIONS(1487),
    [anon_sym_component] = ACTIONS(1487),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_interface] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1487),
  },
  [675] = {
    [sym_finally_clause] = STATE(727),
    [sym_identifier] = ACTIONS(2307),
    [anon_sym_export] = ACTIONS(2307),
    [anon_sym_default] = ACTIONS(2307),
    [anon_sym_type] = ACTIONS(2307),
    [anon_sym_namespace] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2309),
    [anon_sym_RBRACE] = ACTIONS(2309),
    [anon_sym_typeof] = ACTIONS(2307),
    [anon_sym_import] = ACTIONS(2307),
    [anon_sym_from] = ACTIONS(2307),
    [anon_sym_var] = ACTIONS(2307),
    [anon_sym_let] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(2309),
    [anon_sym_else] = ACTIONS(2307),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_switch] = ACTIONS(2307),
    [anon_sym_for] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(2309),
    [anon_sym_await] = ACTIONS(2307),
    [anon_sym_of] = ACTIONS(2307),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(2307),
    [anon_sym_try] = ACTIONS(2307),
    [anon_sym_with] = ACTIONS(2307),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_continue] = ACTIONS(2307),
    [anon_sym_debugger] = ACTIONS(2307),
    [anon_sym_return] = ACTIONS(2307),
    [anon_sym_throw] = ACTIONS(2307),
    [anon_sym_SEMI] = ACTIONS(2309),
    [anon_sym_case] = ACTIONS(2307),
    [anon_sym_finally] = ACTIONS(2278),
    [anon_sym_yield] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2309),
    [anon_sym_LTtemplate_GT] = ACTIONS(2309),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2307),
    [anon_sym_class] = ACTIONS(2307),
    [anon_sym_async] = ACTIONS(2307),
    [anon_sym_function] = ACTIONS(2307),
    [anon_sym_new] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_TILDE] = ACTIONS(2309),
    [anon_sym_void] = ACTIONS(2307),
    [anon_sym_delete] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2309),
    [anon_sym_DASH_DASH] = ACTIONS(2309),
    [anon_sym_DQUOTE] = ACTIONS(2309),
    [anon_sym_SQUOTE] = ACTIONS(2309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2309),
    [sym_number] = ACTIONS(2309),
    [sym_this] = ACTIONS(2307),
    [sym_super] = ACTIONS(2307),
    [sym_true] = ACTIONS(2307),
    [sym_false] = ACTIONS(2307),
    [sym_null] = ACTIONS(2307),
    [sym_undefined] = ACTIONS(2307),
    [anon_sym_AT] = ACTIONS(2309),
    [anon_sym_static] = ACTIONS(2307),
    [anon_sym_readonly] = ACTIONS(2307),
    [anon_sym_get] = ACTIONS(2307),
    [anon_sym_set] = ACTIONS(2307),
    [anon_sym_declare] = ACTIONS(2307),
    [anon_sym_public] = ACTIONS(2307),
    [anon_sym_private] = ACTIONS(2307),
    [anon_sym_protected] = ACTIONS(2307),
    [anon_sym_override] = ACTIONS(2307),
    [anon_sym_module] = ACTIONS(2307),
    [anon_sym_any] = ACTIONS(2307),
    [anon_sym_number] = ACTIONS(2307),
    [anon_sym_boolean] = ACTIONS(2307),
    [anon_sym_string] = ACTIONS(2307),
    [anon_sym_symbol] = ACTIONS(2307),
    [anon_sym_property] = ACTIONS(2307),
    [anon_sym_signal] = ACTIONS(2307),
    [anon_sym_on] = ACTIONS(2307),
    [anon_sym_required] = ACTIONS(2307),
    [anon_sym_component] = ACTIONS(2307),
    [anon_sym_abstract] = ACTIONS(2307),
    [anon_sym_interface] = ACTIONS(2307),
    [anon_sym_enum] = ACTIONS(2307),
  },
  [676] = {
    [sym_identifier] = ACTIONS(1589),
    [anon_sym_export] = ACTIONS(1589),
    [anon_sym_default] = ACTIONS(1589),
    [anon_sym_type] = ACTIONS(1589),
    [anon_sym_namespace] = ACTIONS(1589),
    [anon_sym_LBRACE] = ACTIONS(1593),
    [anon_sym_RBRACE] = ACTIONS(1593),
    [anon_sym_typeof] = ACTIONS(1589),
    [anon_sym_import] = ACTIONS(1589),
    [anon_sym_from] = ACTIONS(1589),
    [anon_sym_var] = ACTIONS(1589),
    [anon_sym_let] = ACTIONS(1589),
    [anon_sym_const] = ACTIONS(1589),
    [anon_sym_BANG] = ACTIONS(1593),
    [anon_sym_else] = ACTIONS(1589),
    [anon_sym_if] = ACTIONS(1589),
    [anon_sym_switch] = ACTIONS(1589),
    [anon_sym_for] = ACTIONS(1589),
    [anon_sym_LPAREN] = ACTIONS(1593),
    [anon_sym_await] = ACTIONS(1589),
    [anon_sym_of] = ACTIONS(1589),
    [anon_sym_while] = ACTIONS(1589),
    [anon_sym_do] = ACTIONS(1589),
    [anon_sym_try] = ACTIONS(1589),
    [anon_sym_with] = ACTIONS(1589),
    [anon_sym_break] = ACTIONS(1589),
    [anon_sym_continue] = ACTIONS(1589),
    [anon_sym_debugger] = ACTIONS(1589),
    [anon_sym_return] = ACTIONS(1589),
    [anon_sym_throw] = ACTIONS(1589),
    [anon_sym_SEMI] = ACTIONS(1593),
    [anon_sym_case] = ACTIONS(1589),
    [anon_sym_yield] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(1593),
    [anon_sym_LTtemplate_GT] = ACTIONS(1593),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_SLASH] = ACTIONS(1589),
    [anon_sym_class] = ACTIONS(1589),
    [anon_sym_async] = ACTIONS(1589),
    [anon_sym_function] = ACTIONS(1589),
    [anon_sym_new] = ACTIONS(1589),
    [anon_sym_PLUS] = ACTIONS(1589),
    [anon_sym_DASH] = ACTIONS(1589),
    [anon_sym_TILDE] = ACTIONS(1593),
    [anon_sym_void] = ACTIONS(1589),
    [anon_sym_delete] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1593),
    [anon_sym_DASH_DASH] = ACTIONS(1593),
    [anon_sym_DQUOTE] = ACTIONS(1593),
    [anon_sym_SQUOTE] = ACTIONS(1593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1593),
    [sym_number] = ACTIONS(1593),
    [sym_this] = ACTIONS(1589),
    [sym_super] = ACTIONS(1589),
    [sym_true] = ACTIONS(1589),
    [sym_false] = ACTIONS(1589),
    [sym_null] = ACTIONS(1589),
    [sym_undefined] = ACTIONS(1589),
    [anon_sym_AT] = ACTIONS(1593),
    [anon_sym_static] = ACTIONS(1589),
    [anon_sym_readonly] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(1589),
    [anon_sym_set] = ACTIONS(1589),
    [anon_sym_declare] = ACTIONS(1589),
    [anon_sym_public] = ACTIONS(1589),
    [anon_sym_private] = ACTIONS(1589),
    [anon_sym_protected] = ACTIONS(1589),
    [anon_sym_override] = ACTIONS(1589),
    [anon_sym_module] = ACTIONS(1589),
    [anon_sym_any] = ACTIONS(1589),
    [anon_sym_number] = ACTIONS(1589),
    [anon_sym_boolean] = ACTIONS(1589),
    [anon_sym_string] = ACTIONS(1589),
    [anon_sym_symbol] = ACTIONS(1589),
    [anon_sym_property] = ACTIONS(1589),
    [anon_sym_signal] = ACTIONS(1589),
    [anon_sym_on] = ACTIONS(1589),
    [anon_sym_required] = ACTIONS(1589),
    [anon_sym_component] = ACTIONS(1589),
    [anon_sym_abstract] = ACTIONS(1589),
    [anon_sym_interface] = ACTIONS(1589),
    [anon_sym_enum] = ACTIONS(1589),
    [sym__automatic_semicolon] = ACTIONS(1597),
  },
  [677] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_export] = ACTIONS(1533),
    [anon_sym_default] = ACTIONS(1533),
    [anon_sym_type] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1533),
    [anon_sym_LBRACE] = ACTIONS(1535),
    [anon_sym_RBRACE] = ACTIONS(1535),
    [anon_sym_typeof] = ACTIONS(1533),
    [anon_sym_import] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(1533),
    [anon_sym_var] = ACTIONS(1533),
    [anon_sym_let] = ACTIONS(1533),
    [anon_sym_const] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_else] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_switch] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_of] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_do] = ACTIONS(1533),
    [anon_sym_try] = ACTIONS(1533),
    [anon_sym_with] = ACTIONS(1533),
    [anon_sym_break] = ACTIONS(1533),
    [anon_sym_continue] = ACTIONS(1533),
    [anon_sym_debugger] = ACTIONS(1533),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_throw] = ACTIONS(1533),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym_case] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1535),
    [anon_sym_LTtemplate_GT] = ACTIONS(1535),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(1533),
    [anon_sym_async] = ACTIONS(1533),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_new] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1533),
    [anon_sym_delete] = ACTIONS(1533),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1535),
    [sym_number] = ACTIONS(1535),
    [sym_this] = ACTIONS(1533),
    [sym_super] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_undefined] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(1535),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_readonly] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1533),
    [anon_sym_set] = ACTIONS(1533),
    [anon_sym_declare] = ACTIONS(1533),
    [anon_sym_public] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1533),
    [anon_sym_protected] = ACTIONS(1533),
    [anon_sym_override] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1533),
    [anon_sym_any] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1533),
    [anon_sym_property] = ACTIONS(1533),
    [anon_sym_signal] = ACTIONS(1533),
    [anon_sym_on] = ACTIONS(1533),
    [anon_sym_required] = ACTIONS(1533),
    [anon_sym_component] = ACTIONS(1533),
    [anon_sym_abstract] = ACTIONS(1533),
    [anon_sym_interface] = ACTIONS(1533),
    [anon_sym_enum] = ACTIONS(1533),
    [sym__automatic_semicolon] = ACTIONS(1535),
  },
  [678] = {
    [sym_identifier] = ACTIONS(2311),
    [anon_sym_export] = ACTIONS(2311),
    [anon_sym_default] = ACTIONS(2311),
    [anon_sym_type] = ACTIONS(2311),
    [anon_sym_namespace] = ACTIONS(2311),
    [anon_sym_LBRACE] = ACTIONS(2313),
    [anon_sym_RBRACE] = ACTIONS(2313),
    [anon_sym_typeof] = ACTIONS(2311),
    [anon_sym_import] = ACTIONS(2311),
    [anon_sym_from] = ACTIONS(2311),
    [anon_sym_var] = ACTIONS(2311),
    [anon_sym_let] = ACTIONS(2311),
    [anon_sym_const] = ACTIONS(2311),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_else] = ACTIONS(2311),
    [anon_sym_if] = ACTIONS(2311),
    [anon_sym_switch] = ACTIONS(2311),
    [anon_sym_for] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_await] = ACTIONS(2311),
    [anon_sym_of] = ACTIONS(2311),
    [anon_sym_while] = ACTIONS(2311),
    [anon_sym_do] = ACTIONS(2311),
    [anon_sym_try] = ACTIONS(2311),
    [anon_sym_with] = ACTIONS(2311),
    [anon_sym_break] = ACTIONS(2311),
    [anon_sym_continue] = ACTIONS(2311),
    [anon_sym_debugger] = ACTIONS(2311),
    [anon_sym_return] = ACTIONS(2311),
    [anon_sym_throw] = ACTIONS(2311),
    [anon_sym_SEMI] = ACTIONS(2313),
    [anon_sym_case] = ACTIONS(2311),
    [anon_sym_finally] = ACTIONS(2311),
    [anon_sym_yield] = ACTIONS(2311),
    [anon_sym_LBRACK] = ACTIONS(2313),
    [anon_sym_LTtemplate_GT] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2311),
    [anon_sym_class] = ACTIONS(2311),
    [anon_sym_async] = ACTIONS(2311),
    [anon_sym_function] = ACTIONS(2311),
    [anon_sym_new] = ACTIONS(2311),
    [anon_sym_PLUS] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2311),
    [anon_sym_TILDE] = ACTIONS(2313),
    [anon_sym_void] = ACTIONS(2311),
    [anon_sym_delete] = ACTIONS(2311),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2313),
    [anon_sym_SQUOTE] = ACTIONS(2313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2313),
    [sym_number] = ACTIONS(2313),
    [sym_this] = ACTIONS(2311),
    [sym_super] = ACTIONS(2311),
    [sym_true] = ACTIONS(2311),
    [sym_false] = ACTIONS(2311),
    [sym_null] = ACTIONS(2311),
    [sym_undefined] = ACTIONS(2311),
    [anon_sym_AT] = ACTIONS(2313),
    [anon_sym_static] = ACTIONS(2311),
    [anon_sym_readonly] = ACTIONS(2311),
    [anon_sym_get] = ACTIONS(2311),
    [anon_sym_set] = ACTIONS(2311),
    [anon_sym_declare] = ACTIONS(2311),
    [anon_sym_public] = ACTIONS(2311),
    [anon_sym_private] = ACTIONS(2311),
    [anon_sym_protected] = ACTIONS(2311),
    [anon_sym_override] = ACTIONS(2311),
    [anon_sym_module] = ACTIONS(2311),
    [anon_sym_any] = ACTIONS(2311),
    [anon_sym_number] = ACTIONS(2311),
    [anon_sym_boolean] = ACTIONS(2311),
    [anon_sym_string] = ACTIONS(2311),
    [anon_sym_symbol] = ACTIONS(2311),
    [anon_sym_property] = ACTIONS(2311),
    [anon_sym_signal] = ACTIONS(2311),
    [anon_sym_on] = ACTIONS(2311),
    [anon_sym_required] = ACTIONS(2311),
    [anon_sym_component] = ACTIONS(2311),
    [anon_sym_abstract] = ACTIONS(2311),
    [anon_sym_interface] = ACTIONS(2311),
    [anon_sym_enum] = ACTIONS(2311),
  },
  [679] = {
    [sym_identifier] = ACTIONS(2315),
    [anon_sym_export] = ACTIONS(2315),
    [anon_sym_default] = ACTIONS(2315),
    [anon_sym_type] = ACTIONS(2315),
    [anon_sym_namespace] = ACTIONS(2315),
    [anon_sym_LBRACE] = ACTIONS(2317),
    [anon_sym_RBRACE] = ACTIONS(2317),
    [anon_sym_typeof] = ACTIONS(2315),
    [anon_sym_import] = ACTIONS(2315),
    [anon_sym_from] = ACTIONS(2315),
    [anon_sym_var] = ACTIONS(2315),
    [anon_sym_let] = ACTIONS(2315),
    [anon_sym_const] = ACTIONS(2315),
    [anon_sym_BANG] = ACTIONS(2317),
    [anon_sym_else] = ACTIONS(2315),
    [anon_sym_if] = ACTIONS(2315),
    [anon_sym_switch] = ACTIONS(2315),
    [anon_sym_for] = ACTIONS(2315),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [anon_sym_RPAREN] = ACTIONS(2317),
    [anon_sym_await] = ACTIONS(2315),
    [anon_sym_of] = ACTIONS(2315),
    [anon_sym_while] = ACTIONS(2315),
    [anon_sym_do] = ACTIONS(2315),
    [anon_sym_try] = ACTIONS(2315),
    [anon_sym_with] = ACTIONS(2315),
    [anon_sym_break] = ACTIONS(2315),
    [anon_sym_continue] = ACTIONS(2315),
    [anon_sym_debugger] = ACTIONS(2315),
    [anon_sym_return] = ACTIONS(2315),
    [anon_sym_throw] = ACTIONS(2315),
    [anon_sym_SEMI] = ACTIONS(2317),
    [anon_sym_case] = ACTIONS(2315),
    [anon_sym_yield] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(2317),
    [anon_sym_LTtemplate_GT] = ACTIONS(2317),
    [anon_sym_LT] = ACTIONS(2315),
    [anon_sym_SLASH] = ACTIONS(2315),
    [anon_sym_class] = ACTIONS(2315),
    [anon_sym_async] = ACTIONS(2315),
    [anon_sym_function] = ACTIONS(2315),
    [anon_sym_new] = ACTIONS(2315),
    [anon_sym_PLUS] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2315),
    [anon_sym_TILDE] = ACTIONS(2317),
    [anon_sym_void] = ACTIONS(2315),
    [anon_sym_delete] = ACTIONS(2315),
    [anon_sym_PLUS_PLUS] = ACTIONS(2317),
    [anon_sym_DASH_DASH] = ACTIONS(2317),
    [anon_sym_DQUOTE] = ACTIONS(2317),
    [anon_sym_SQUOTE] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2317),
    [sym_number] = ACTIONS(2317),
    [sym_this] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_undefined] = ACTIONS(2315),
    [anon_sym_AT] = ACTIONS(2317),
    [anon_sym_static] = ACTIONS(2315),
    [anon_sym_readonly] = ACTIONS(2315),
    [anon_sym_get] = ACTIONS(2315),
    [anon_sym_set] = ACTIONS(2315),
    [anon_sym_declare] = ACTIONS(2315),
    [anon_sym_public] = ACTIONS(2315),
    [anon_sym_private] = ACTIONS(2315),
    [anon_sym_protected] = ACTIONS(2315),
    [anon_sym_override] = ACTIONS(2315),
    [anon_sym_module] = ACTIONS(2315),
    [anon_sym_any] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2315),
    [anon_sym_string] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2315),
    [anon_sym_property] = ACTIONS(2315),
    [anon_sym_signal] = ACTIONS(2315),
    [anon_sym_on] = ACTIONS(2315),
    [anon_sym_required] = ACTIONS(2315),
    [anon_sym_component] = ACTIONS(2315),
    [anon_sym_abstract] = ACTIONS(2315),
    [anon_sym_interface] = ACTIONS(2315),
    [anon_sym_enum] = ACTIONS(2315),
  },
  [680] = {
    [sym_identifier] = ACTIONS(1599),
    [anon_sym_export] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1599),
    [anon_sym_type] = ACTIONS(1599),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(1603),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_typeof] = ACTIONS(1599),
    [anon_sym_import] = ACTIONS(1599),
    [anon_sym_from] = ACTIONS(1599),
    [anon_sym_var] = ACTIONS(1599),
    [anon_sym_let] = ACTIONS(1599),
    [anon_sym_const] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1603),
    [anon_sym_else] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(1599),
    [anon_sym_switch] = ACTIONS(1599),
    [anon_sym_for] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(1603),
    [anon_sym_await] = ACTIONS(1599),
    [anon_sym_of] = ACTIONS(1599),
    [anon_sym_while] = ACTIONS(1599),
    [anon_sym_do] = ACTIONS(1599),
    [anon_sym_try] = ACTIONS(1599),
    [anon_sym_with] = ACTIONS(1599),
    [anon_sym_break] = ACTIONS(1599),
    [anon_sym_continue] = ACTIONS(1599),
    [anon_sym_debugger] = ACTIONS(1599),
    [anon_sym_return] = ACTIONS(1599),
    [anon_sym_throw] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1603),
    [anon_sym_case] = ACTIONS(1599),
    [anon_sym_yield] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(1603),
    [anon_sym_LTtemplate_GT] = ACTIONS(1603),
    [anon_sym_LT] = ACTIONS(1599),
    [anon_sym_SLASH] = ACTIONS(1599),
    [anon_sym_class] = ACTIONS(1599),
    [anon_sym_async] = ACTIONS(1599),
    [anon_sym_function] = ACTIONS(1599),
    [anon_sym_new] = ACTIONS(1599),
    [anon_sym_PLUS] = ACTIONS(1599),
    [anon_sym_DASH] = ACTIONS(1599),
    [anon_sym_TILDE] = ACTIONS(1603),
    [anon_sym_void] = ACTIONS(1599),
    [anon_sym_delete] = ACTIONS(1599),
    [anon_sym_PLUS_PLUS] = ACTIONS(1603),
    [anon_sym_DASH_DASH] = ACTIONS(1603),
    [anon_sym_DQUOTE] = ACTIONS(1603),
    [anon_sym_SQUOTE] = ACTIONS(1603),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1603),
    [sym_number] = ACTIONS(1603),
    [sym_this] = ACTIONS(1599),
    [sym_super] = ACTIONS(1599),
    [sym_true] = ACTIONS(1599),
    [sym_false] = ACTIONS(1599),
    [sym_null] = ACTIONS(1599),
    [sym_undefined] = ACTIONS(1599),
    [anon_sym_AT] = ACTIONS(1603),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_readonly] = ACTIONS(1599),
    [anon_sym_get] = ACTIONS(1599),
    [anon_sym_set] = ACTIONS(1599),
    [anon_sym_declare] = ACTIONS(1599),
    [anon_sym_public] = ACTIONS(1599),
    [anon_sym_private] = ACTIONS(1599),
    [anon_sym_protected] = ACTIONS(1599),
    [anon_sym_override] = ACTIONS(1599),
    [anon_sym_module] = ACTIONS(1599),
    [anon_sym_any] = ACTIONS(1599),
    [anon_sym_number] = ACTIONS(1599),
    [anon_sym_boolean] = ACTIONS(1599),
    [anon_sym_string] = ACTIONS(1599),
    [anon_sym_symbol] = ACTIONS(1599),
    [anon_sym_property] = ACTIONS(1599),
    [anon_sym_signal] = ACTIONS(1599),
    [anon_sym_on] = ACTIONS(1599),
    [anon_sym_required] = ACTIONS(1599),
    [anon_sym_component] = ACTIONS(1599),
    [anon_sym_abstract] = ACTIONS(1599),
    [anon_sym_interface] = ACTIONS(1599),
    [anon_sym_enum] = ACTIONS(1599),
    [sym__automatic_semicolon] = ACTIONS(1607),
  },
  [681] = {
    [sym_statement_block] = STATE(810),
    [sym_identifier] = ACTIONS(1487),
    [anon_sym_export] = ACTIONS(1487),
    [anon_sym_default] = ACTIONS(1487),
    [anon_sym_type] = ACTIONS(1487),
    [anon_sym_namespace] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(2303),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [anon_sym_typeof] = ACTIONS(1487),
    [anon_sym_import] = ACTIONS(1487),
    [anon_sym_from] = ACTIONS(1487),
    [anon_sym_var] = ACTIONS(1487),
    [anon_sym_let] = ACTIONS(1487),
    [anon_sym_const] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_switch] = ACTIONS(1487),
    [anon_sym_for] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(1491),
    [anon_sym_await] = ACTIONS(1487),
    [anon_sym_of] = ACTIONS(1487),
    [anon_sym_while] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(1487),
    [anon_sym_try] = ACTIONS(1487),
    [anon_sym_with] = ACTIONS(1487),
    [anon_sym_break] = ACTIONS(1487),
    [anon_sym_continue] = ACTIONS(1487),
    [anon_sym_debugger] = ACTIONS(1487),
    [anon_sym_return] = ACTIONS(1487),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_case] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1491),
    [anon_sym_LTtemplate_GT] = ACTIONS(1491),
    [anon_sym_LT] = ACTIONS(1487),
    [anon_sym_SLASH] = ACTIONS(1487),
    [anon_sym_class] = ACTIONS(1487),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_new] = ACTIONS(1487),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_TILDE] = ACTIONS(1491),
    [anon_sym_void] = ACTIONS(1487),
    [anon_sym_delete] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [anon_sym_DQUOTE] = ACTIONS(1491),
    [anon_sym_SQUOTE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1491),
    [sym_number] = ACTIONS(1491),
    [sym_this] = ACTIONS(1487),
    [sym_super] = ACTIONS(1487),
    [sym_true] = ACTIONS(1487),
    [sym_false] = ACTIONS(1487),
    [sym_null] = ACTIONS(1487),
    [sym_undefined] = ACTIONS(1487),
    [anon_sym_AT] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1487),
    [anon_sym_readonly] = ACTIONS(1487),
    [anon_sym_get] = ACTIONS(1487),
    [anon_sym_set] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1487),
    [anon_sym_public] = ACTIONS(1487),
    [anon_sym_private] = ACTIONS(1487),
    [anon_sym_protected] = ACTIONS(1487),
    [anon_sym_override] = ACTIONS(1487),
    [anon_sym_module] = ACTIONS(1487),
    [anon_sym_any] = ACTIONS(1487),
    [anon_sym_number] = ACTIONS(1487),
    [anon_sym_boolean] = ACTIONS(1487),
    [anon_sym_string] = ACTIONS(1487),
    [anon_sym_symbol] = ACTIONS(1487),
    [anon_sym_property] = ACTIONS(1487),
    [anon_sym_signal] = ACTIONS(1487),
    [anon_sym_on] = ACTIONS(1487),
    [anon_sym_required] = ACTIONS(1487),
    [anon_sym_component] = ACTIONS(1487),
    [anon_sym_abstract] = ACTIONS(1487),
    [anon_sym_interface] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1487),
  },
  [682] = {
    [sym_else_clause] = STATE(738),
    [sym_identifier] = ACTIONS(2319),
    [anon_sym_export] = ACTIONS(2319),
    [anon_sym_default] = ACTIONS(2319),
    [anon_sym_type] = ACTIONS(2319),
    [anon_sym_namespace] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_RBRACE] = ACTIONS(2321),
    [anon_sym_typeof] = ACTIONS(2319),
    [anon_sym_import] = ACTIONS(2319),
    [anon_sym_from] = ACTIONS(2319),
    [anon_sym_var] = ACTIONS(2319),
    [anon_sym_let] = ACTIONS(2319),
    [anon_sym_const] = ACTIONS(2319),
    [anon_sym_BANG] = ACTIONS(2321),
    [anon_sym_else] = ACTIONS(2323),
    [anon_sym_if] = ACTIONS(2319),
    [anon_sym_switch] = ACTIONS(2319),
    [anon_sym_for] = ACTIONS(2319),
    [anon_sym_LPAREN] = ACTIONS(2321),
    [anon_sym_await] = ACTIONS(2319),
    [anon_sym_of] = ACTIONS(2319),
    [anon_sym_while] = ACTIONS(2319),
    [anon_sym_do] = ACTIONS(2319),
    [anon_sym_try] = ACTIONS(2319),
    [anon_sym_with] = ACTIONS(2319),
    [anon_sym_break] = ACTIONS(2319),
    [anon_sym_continue] = ACTIONS(2319),
    [anon_sym_debugger] = ACTIONS(2319),
    [anon_sym_return] = ACTIONS(2319),
    [anon_sym_throw] = ACTIONS(2319),
    [anon_sym_SEMI] = ACTIONS(2321),
    [anon_sym_case] = ACTIONS(2319),
    [anon_sym_yield] = ACTIONS(2319),
    [anon_sym_LBRACK] = ACTIONS(2321),
    [anon_sym_LTtemplate_GT] = ACTIONS(2321),
    [anon_sym_LT] = ACTIONS(2319),
    [anon_sym_SLASH] = ACTIONS(2319),
    [anon_sym_class] = ACTIONS(2319),
    [anon_sym_async] = ACTIONS(2319),
    [anon_sym_function] = ACTIONS(2319),
    [anon_sym_new] = ACTIONS(2319),
    [anon_sym_PLUS] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2319),
    [anon_sym_TILDE] = ACTIONS(2321),
    [anon_sym_void] = ACTIONS(2319),
    [anon_sym_delete] = ACTIONS(2319),
    [anon_sym_PLUS_PLUS] = ACTIONS(2321),
    [anon_sym_DASH_DASH] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2321),
    [sym_number] = ACTIONS(2321),
    [sym_this] = ACTIONS(2319),
    [sym_super] = ACTIONS(2319),
    [sym_true] = ACTIONS(2319),
    [sym_false] = ACTIONS(2319),
    [sym_null] = ACTIONS(2319),
    [sym_undefined] = ACTIONS(2319),
    [anon_sym_AT] = ACTIONS(2321),
    [anon_sym_static] = ACTIONS(2319),
    [anon_sym_readonly] = ACTIONS(2319),
    [anon_sym_get] = ACTIONS(2319),
    [anon_sym_set] = ACTIONS(2319),
    [anon_sym_declare] = ACTIONS(2319),
    [anon_sym_public] = ACTIONS(2319),
    [anon_sym_private] = ACTIONS(2319),
    [anon_sym_protected] = ACTIONS(2319),
    [anon_sym_override] = ACTIONS(2319),
    [anon_sym_module] = ACTIONS(2319),
    [anon_sym_any] = ACTIONS(2319),
    [anon_sym_number] = ACTIONS(2319),
    [anon_sym_boolean] = ACTIONS(2319),
    [anon_sym_string] = ACTIONS(2319),
    [anon_sym_symbol] = ACTIONS(2319),
    [anon_sym_property] = ACTIONS(2319),
    [anon_sym_signal] = ACTIONS(2319),
    [anon_sym_on] = ACTIONS(2319),
    [anon_sym_required] = ACTIONS(2319),
    [anon_sym_component] = ACTIONS(2319),
    [anon_sym_abstract] = ACTIONS(2319),
    [anon_sym_interface] = ACTIONS(2319),
    [anon_sym_enum] = ACTIONS(2319),
  },
  [683] = {
    [sym_identifier] = ACTIONS(1537),
    [anon_sym_export] = ACTIONS(1537),
    [anon_sym_default] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(1537),
    [anon_sym_namespace] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1541),
    [anon_sym_RBRACE] = ACTIONS(1541),
    [anon_sym_typeof] = ACTIONS(1537),
    [anon_sym_import] = ACTIONS(1537),
    [anon_sym_from] = ACTIONS(1537),
    [anon_sym_var] = ACTIONS(1537),
    [anon_sym_let] = ACTIONS(1537),
    [anon_sym_const] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_else] = ACTIONS(1537),
    [anon_sym_if] = ACTIONS(1537),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_LPAREN] = ACTIONS(1541),
    [anon_sym_await] = ACTIONS(1537),
    [anon_sym_of] = ACTIONS(1537),
    [anon_sym_while] = ACTIONS(1537),
    [anon_sym_do] = ACTIONS(1537),
    [anon_sym_try] = ACTIONS(1537),
    [anon_sym_with] = ACTIONS(1537),
    [anon_sym_break] = ACTIONS(1537),
    [anon_sym_continue] = ACTIONS(1537),
    [anon_sym_debugger] = ACTIONS(1537),
    [anon_sym_return] = ACTIONS(1537),
    [anon_sym_throw] = ACTIONS(1537),
    [anon_sym_SEMI] = ACTIONS(1541),
    [anon_sym_case] = ACTIONS(1537),
    [anon_sym_yield] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [anon_sym_LTtemplate_GT] = ACTIONS(1541),
    [anon_sym_LT] = ACTIONS(1537),
    [anon_sym_SLASH] = ACTIONS(1537),
    [anon_sym_class] = ACTIONS(1537),
    [anon_sym_async] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1537),
    [anon_sym_new] = ACTIONS(1537),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_TILDE] = ACTIONS(1541),
    [anon_sym_void] = ACTIONS(1537),
    [anon_sym_delete] = ACTIONS(1537),
    [anon_sym_PLUS_PLUS] = ACTIONS(1541),
    [anon_sym_DASH_DASH] = ACTIONS(1541),
    [anon_sym_DQUOTE] = ACTIONS(1541),
    [anon_sym_SQUOTE] = ACTIONS(1541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1541),
    [sym_number] = ACTIONS(1541),
    [sym_this] = ACTIONS(1537),
    [sym_super] = ACTIONS(1537),
    [sym_true] = ACTIONS(1537),
    [sym_false] = ACTIONS(1537),
    [sym_null] = ACTIONS(1537),
    [sym_undefined] = ACTIONS(1537),
    [anon_sym_AT] = ACTIONS(1541),
    [anon_sym_static] = ACTIONS(1537),
    [anon_sym_readonly] = ACTIONS(1537),
    [anon_sym_get] = ACTIONS(1537),
    [anon_sym_set] = ACTIONS(1537),
    [anon_sym_declare] = ACTIONS(1537),
    [anon_sym_public] = ACTIONS(1537),
    [anon_sym_private] = ACTIONS(1537),
    [anon_sym_protected] = ACTIONS(1537),
    [anon_sym_override] = ACTIONS(1537),
    [anon_sym_module] = ACTIONS(1537),
    [anon_sym_any] = ACTIONS(1537),
    [anon_sym_number] = ACTIONS(1537),
    [anon_sym_boolean] = ACTIONS(1537),
    [anon_sym_string] = ACTIONS(1537),
    [anon_sym_symbol] = ACTIONS(1537),
    [anon_sym_property] = ACTIONS(1537),
    [anon_sym_signal] = ACTIONS(1537),
    [anon_sym_on] = ACTIONS(1537),
    [anon_sym_required] = ACTIONS(1537),
    [anon_sym_component] = ACTIONS(1537),
    [anon_sym_abstract] = ACTIONS(1537),
    [anon_sym_interface] = ACTIONS(1537),
    [anon_sym_enum] = ACTIONS(1537),
    [sym__automatic_semicolon] = ACTIONS(1545),
  },
  [684] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_export] = ACTIONS(1533),
    [anon_sym_default] = ACTIONS(1533),
    [anon_sym_type] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1533),
    [anon_sym_LBRACE] = ACTIONS(1535),
    [anon_sym_RBRACE] = ACTIONS(1535),
    [anon_sym_typeof] = ACTIONS(1533),
    [anon_sym_import] = ACTIONS(1533),
    [anon_sym_from] = ACTIONS(1533),
    [anon_sym_var] = ACTIONS(1533),
    [anon_sym_let] = ACTIONS(1533),
    [anon_sym_const] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_else] = ACTIONS(1533),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_switch] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_await] = ACTIONS(1533),
    [anon_sym_of] = ACTIONS(1533),
    [anon_sym_while] = ACTIONS(1533),
    [anon_sym_do] = ACTIONS(1533),
    [anon_sym_try] = ACTIONS(1533),
    [anon_sym_with] = ACTIONS(1533),
    [anon_sym_break] = ACTIONS(1533),
    [anon_sym_continue] = ACTIONS(1533),
    [anon_sym_debugger] = ACTIONS(1533),
    [anon_sym_return] = ACTIONS(1533),
    [anon_sym_throw] = ACTIONS(1533),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym_case] = ACTIONS(1533),
    [anon_sym_yield] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1535),
    [anon_sym_LTtemplate_GT] = ACTIONS(1535),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_class] = ACTIONS(1533),
    [anon_sym_async] = ACTIONS(1533),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_new] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_void] = ACTIONS(1533),
    [anon_sym_delete] = ACTIONS(1533),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1535),
    [sym_number] = ACTIONS(1535),
    [sym_this] = ACTIONS(1533),
    [sym_super] = ACTIONS(1533),
    [sym_true] = ACTIONS(1533),
    [sym_false] = ACTIONS(1533),
    [sym_null] = ACTIONS(1533),
    [sym_undefined] = ACTIONS(1533),
    [anon_sym_AT] = ACTIONS(1535),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_readonly] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1533),
    [anon_sym_set] = ACTIONS(1533),
    [anon_sym_declare] = ACTIONS(1533),
    [anon_sym_public] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1533),
    [anon_sym_protected] = ACTIONS(1533),
    [anon_sym_override] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1533),
    [anon_sym_any] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1533),
    [anon_sym_property] = ACTIONS(1533),
    [anon_sym_signal] = ACTIONS(1533),
    [anon_sym_on] = ACTIONS(1533),
    [anon_sym_required] = ACTIONS(1533),
    [anon_sym_component] = ACTIONS(1533),
    [anon_sym_abstract] = ACTIONS(1533),
    [anon_sym_interface] = ACTIONS(1533),
    [anon_sym_enum] = ACTIONS(1533),
    [sym__automatic_semicolon] = ACTIONS(2325),
  },
  [685] = {
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_export] = ACTIONS(1519),
    [anon_sym_default] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(1519),
    [anon_sym_namespace] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_RBRACE] = ACTIONS(1521),
    [anon_sym_typeof] = ACTIONS(1519),
    [anon_sym_import] = ACTIONS(1519),
    [anon_sym_from] = ACTIONS(1519),
    [anon_sym_var] = ACTIONS(1519),
    [anon_sym_let] = ACTIONS(1519),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_else] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_switch] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_await] = ACTIONS(1519),
    [anon_sym_of] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_do] = ACTIONS(1519),
    [anon_sym_try] = ACTIONS(1519),
    [anon_sym_with] = ACTIONS(1519),
    [anon_sym_break] = ACTIONS(1519),
    [anon_sym_continue] = ACTIONS(1519),
    [anon_sym_debugger] = ACTIONS(1519),
    [anon_sym_return] = ACTIONS(1519),
    [anon_sym_throw] = ACTIONS(1519),
    [anon_sym_SEMI] = ACTIONS(1521),
    [anon_sym_case] = ACTIONS(1519),
    [anon_sym_yield] = ACTIONS(1519),
    [anon_sym_LBRACK] = ACTIONS(1521),
    [anon_sym_LTtemplate_GT] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1519),
    [anon_sym_class] = ACTIONS(1519),
    [anon_sym_async] = ACTIONS(1519),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_new] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_TILDE] = ACTIONS(1521),
    [anon_sym_void] = ACTIONS(1519),
    [anon_sym_delete] = ACTIONS(1519),
    [anon_sym_PLUS_PLUS] = ACTIONS(1521),
    [anon_sym_DASH_DASH] = ACTIONS(1521),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_SQUOTE] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1521),
    [sym_number] = ACTIONS(1521),
    [sym_this] = ACTIONS(1519),
    [sym_super] = ACTIONS(1519),
    [sym_true] = ACTIONS(1519),
    [sym_false] = ACTIONS(1519),
    [sym_null] = ACTIONS(1519),
    [sym_undefined] = ACTIONS(1519),
    [anon_sym_AT] = ACTIONS(1521),
    [anon_sym_static] = ACTIONS(1519),
    [anon_sym_readonly] = ACTIONS(1519),
    [anon_sym_get] = ACTIONS(1519),
    [anon_sym_set] = ACTIONS(1519),
    [anon_sym_declare] = ACTIONS(1519),
    [anon_sym_public] = ACTIONS(1519),
    [anon_sym_private] = ACTIONS(1519),
    [anon_sym_protected] = ACTIONS(1519),
    [anon_sym_override] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(1519),
    [anon_sym_any] = ACTIONS(1519),
    [anon_sym_number] = ACTIONS(1519),
    [anon_sym_boolean] = ACTIONS(1519),
    [anon_sym_string] = ACTIONS(1519),
    [anon_sym_symbol] = ACTIONS(1519),
    [anon_sym_property] = ACTIONS(1519),
    [anon_sym_signal] = ACTIONS(1519),
    [anon_sym_on] = ACTIONS(1519),
    [anon_sym_required] = ACTIONS(1519),
    [anon_sym_component] = ACTIONS(1519),
    [anon_sym_abstract] = ACTIONS(1519),
    [anon_sym_interface] = ACTIONS(1519),
    [anon_sym_enum] = ACTIONS(1519),
    [sym__automatic_semicolon] = ACTIONS(1521),
  },
  [686] = {
    [sym_identifier] = ACTIONS(2327),
    [anon_sym_export] = ACTIONS(2327),
    [anon_sym_default] = ACTIONS(2327),
    [anon_sym_type] = ACTIONS(2327),
    [anon_sym_namespace] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(2329),
    [anon_sym_RBRACE] = ACTIONS(2329),
    [anon_sym_typeof] = ACTIONS(2327),
    [anon_sym_import] = ACTIONS(2327),
    [anon_sym_from] = ACTIONS(2327),
    [anon_sym_var] = ACTIONS(2327),
    [anon_sym_let] = ACTIONS(2327),
    [anon_sym_const] = ACTIONS(2327),
    [anon_sym_BANG] = ACTIONS(2329),
    [anon_sym_else] = ACTIONS(2327),
    [anon_sym_if] = ACTIONS(2327),
    [anon_sym_switch] = ACTIONS(2327),
    [anon_sym_for] = ACTIONS(2327),
    [anon_sym_LPAREN] = ACTIONS(2329),
    [anon_sym_await] = ACTIONS(2327),
    [anon_sym_of] = ACTIONS(2327),
    [anon_sym_while] = ACTIONS(2327),
    [anon_sym_do] = ACTIONS(2327),
    [anon_sym_try] = ACTIONS(2327),
    [anon_sym_with] = ACTIONS(2327),
    [anon_sym_break] = ACTIONS(2327),
    [anon_sym_continue] = ACTIONS(2327),
    [anon_sym_debugger] = ACTIONS(2327),
    [anon_sym_return] = ACTIONS(2327),
    [anon_sym_throw] = ACTIONS(2327),
    [anon_sym_SEMI] = ACTIONS(2329),
    [anon_sym_case] = ACTIONS(2327),
    [anon_sym_finally] = ACTIONS(2327),
    [anon_sym_yield] = ACTIONS(2327),
    [anon_sym_LBRACK] = ACTIONS(2329),
    [anon_sym_LTtemplate_GT] = ACTIONS(2329),
    [anon_sym_LT] = ACTIONS(2327),
    [anon_sym_SLASH] = ACTIONS(2327),
    [anon_sym_class] = ACTIONS(2327),
    [anon_sym_async] = ACTIONS(2327),
    [anon_sym_function] = ACTIONS(2327),
    [anon_sym_new] = ACTIONS(2327),
    [anon_sym_PLUS] = ACTIONS(2327),
    [anon_sym_DASH] = ACTIONS(2327),
    [anon_sym_TILDE] = ACTIONS(2329),
    [anon_sym_void] = ACTIONS(2327),
    [anon_sym_delete] = ACTIONS(2327),
    [anon_sym_PLUS_PLUS] = ACTIONS(2329),
    [anon_sym_DASH_DASH] = ACTIONS(2329),
    [anon_sym_DQUOTE] = ACTIONS(2329),
    [anon_sym_SQUOTE] = ACTIONS(2329),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2329),
    [sym_number] = ACTIONS(2329),
    [sym_this] = ACTIONS(2327),
    [sym_super] = ACTIONS(2327),
    [sym_true] = ACTIONS(2327),
    [sym_false] = ACTIONS(2327),
    [sym_null] = ACTIONS(2327),
    [sym_undefined] = ACTIONS(2327),
    [anon_sym_AT] = ACTIONS(2329),
    [anon_sym_static] = ACTIONS(2327),
    [anon_sym_readonly] = ACTIONS(2327),
    [anon_sym_get] = ACTIONS(2327),
    [anon_sym_set] = ACTIONS(2327),
    [anon_sym_declare] = ACTIONS(2327),
    [anon_sym_public] = ACTIONS(2327),
    [anon_sym_private] = ACTIONS(2327),
    [anon_sym_protected] = ACTIONS(2327),
    [anon_sym_override] = ACTIONS(2327),
    [anon_sym_module] = ACTIONS(2327),
    [anon_sym_any] = ACTIONS(2327),
    [anon_sym_number] = ACTIONS(2327),
    [anon_sym_boolean] = ACTIONS(2327),
    [anon_sym_string] = ACTIONS(2327),
    [anon_sym_symbol] = ACTIONS(2327),
    [anon_sym_property] = ACTIONS(2327),
    [anon_sym_signal] = ACTIONS(2327),
    [anon_sym_on] = ACTIONS(2327),
    [anon_sym_required] = ACTIONS(2327),
    [anon_sym_component] = ACTIONS(2327),
    [anon_sym_abstract] = ACTIONS(2327),
    [anon_sym_interface] = ACTIONS(2327),
    [anon_sym_enum] = ACTIONS(2327),
  },
  [687] = {
    [sym_identifier] = ACTIONS(1557),
    [anon_sym_export] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(1557),
    [anon_sym_type] = ACTIONS(1557),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1561),
    [anon_sym_RBRACE] = ACTIONS(1561),
    [anon_sym_typeof] = ACTIONS(1557),
    [anon_sym_import] = ACTIONS(1557),
    [anon_sym_from] = ACTIONS(1557),
    [anon_sym_var] = ACTIONS(1557),
    [anon_sym_let] = ACTIONS(1557),
    [anon_sym_const] = ACTIONS(1557),
    [anon_sym_BANG] = ACTIONS(1561),
    [anon_sym_else] = ACTIONS(1557),
    [anon_sym_if] = ACTIONS(1557),
    [anon_sym_switch] = ACTIONS(1557),
    [anon_sym_for] = ACTIONS(1557),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_of] = ACTIONS(1557),
    [anon_sym_while] = ACTIONS(1557),
    [anon_sym_do] = ACTIONS(1557),
    [anon_sym_try] = ACTIONS(1557),
    [anon_sym_with] = ACTIONS(1557),
    [anon_sym_break] = ACTIONS(1557),
    [anon_sym_continue] = ACTIONS(1557),
    [anon_sym_debugger] = ACTIONS(1557),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_throw] = ACTIONS(1557),
    [anon_sym_SEMI] = ACTIONS(1561),
    [anon_sym_case] = ACTIONS(1557),
    [anon_sym_yield] = ACTIONS(1557),
    [anon_sym_LBRACK] = ACTIONS(1561),
    [anon_sym_LTtemplate_GT] = ACTIONS(1561),
    [anon_sym_LT] = ACTIONS(1557),
    [anon_sym_SLASH] = ACTIONS(1557),
    [anon_sym_class] = ACTIONS(1557),
    [anon_sym_async] = ACTIONS(1557),
    [anon_sym_function] = ACTIONS(1557),
    [anon_sym_new] = ACTIONS(1557),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_TILDE] = ACTIONS(1561),
    [anon_sym_void] = ACTIONS(1557),
    [anon_sym_delete] = ACTIONS(1557),
    [anon_sym_PLUS_PLUS] = ACTIONS(1561),
    [anon_sym_DASH_DASH] = ACTIONS(1561),
    [anon_sym_DQUOTE] = ACTIONS(1561),
    [anon_sym_SQUOTE] = ACTIONS(1561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1561),
    [sym_number] = ACTIONS(1561),
    [sym_this] = ACTIONS(1557),
    [sym_super] = ACTIONS(1557),
    [sym_true] = ACTIONS(1557),
    [sym_false] = ACTIONS(1557),
    [sym_null] = ACTIONS(1557),
    [sym_undefined] = ACTIONS(1557),
    [anon_sym_AT] = ACTIONS(1561),
    [anon_sym_static] = ACTIONS(1557),
    [anon_sym_readonly] = ACTIONS(1557),
    [anon_sym_get] = ACTIONS(1557),
    [anon_sym_set] = ACTIONS(1557),
    [anon_sym_declare] = ACTIONS(1557),
    [anon_sym_public] = ACTIONS(1557),
    [anon_sym_private] = ACTIONS(1557),
    [anon_sym_protected] = ACTIONS(1557),
    [anon_sym_override] = ACTIONS(1557),
    [anon_sym_module] = ACTIONS(1557),
    [anon_sym_any] = ACTIONS(1557),
    [anon_sym_number] = ACTIONS(1557),
    [anon_sym_boolean] = ACTIONS(1557),
    [anon_sym_string] = ACTIONS(1557),
    [anon_sym_symbol] = ACTIONS(1557),
    [anon_sym_property] = ACTIONS(1557),
    [anon_sym_signal] = ACTIONS(1557),
    [anon_sym_on] = ACTIONS(1557),
    [anon_sym_required] = ACTIONS(1557),
    [anon_sym_component] = ACTIONS(1557),
    [anon_sym_abstract] = ACTIONS(1557),
    [anon_sym_interface] = ACTIONS(1557),
    [anon_sym_enum] = ACTIONS(1557),
    [sym__automatic_semicolon] = ACTIONS(1565),
  },
  [688] = {
    [sym_identifier] = ACTIONS(1709),
    [anon_sym_export] = ACTIONS(1709),
    [anon_sym_default] = ACTIONS(1709),
    [anon_sym_type] = ACTIONS(1709),
    [anon_sym_namespace] = ACTIONS(1709),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_RBRACE] = ACTIONS(1713),
    [anon_sym_typeof] = ACTIONS(1709),
    [anon_sym_import] = ACTIONS(1709),
    [anon_sym_from] = ACTIONS(1709),
    [anon_sym_var] = ACTIONS(1709),
    [anon_sym_let] = ACTIONS(1709),
    [anon_sym_const] = ACTIONS(1709),
    [anon_sym_BANG] = ACTIONS(1713),
    [anon_sym_else] = ACTIONS(1709),
    [anon_sym_if] = ACTIONS(1709),
    [anon_sym_switch] = ACTIONS(1709),
    [anon_sym_for] = ACTIONS(1709),
    [anon_sym_LPAREN] = ACTIONS(1713),
    [anon_sym_await] = ACTIONS(1709),
    [anon_sym_of] = ACTIONS(1709),
    [anon_sym_while] = ACTIONS(1709),
    [anon_sym_do] = ACTIONS(1709),
    [anon_sym_try] = ACTIONS(1709),
    [anon_sym_with] = ACTIONS(1709),
    [anon_sym_break] = ACTIONS(1709),
    [anon_sym_continue] = ACTIONS(1709),
    [anon_sym_debugger] = ACTIONS(1709),
    [anon_sym_return] = ACTIONS(1709),
    [anon_sym_throw] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1713),
    [anon_sym_case] = ACTIONS(1709),
    [anon_sym_yield] = ACTIONS(1709),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LTtemplate_GT] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1709),
    [anon_sym_SLASH] = ACTIONS(1709),
    [anon_sym_class] = ACTIONS(1709),
    [anon_sym_async] = ACTIONS(1709),
    [anon_sym_function] = ACTIONS(1709),
    [anon_sym_new] = ACTIONS(1709),
    [anon_sym_PLUS] = ACTIONS(1709),
    [anon_sym_DASH] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1713),
    [anon_sym_void] = ACTIONS(1709),
    [anon_sym_delete] = ACTIONS(1709),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_DQUOTE] = ACTIONS(1713),
    [anon_sym_SQUOTE] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1713),
    [sym_number] = ACTIONS(1713),
    [sym_this] = ACTIONS(1709),
    [sym_super] = ACTIONS(1709),
    [sym_true] = ACTIONS(1709),
    [sym_false] = ACTIONS(1709),
    [sym_null] = ACTIONS(1709),
    [sym_undefined] = ACTIONS(1709),
    [anon_sym_AT] = ACTIONS(1713),
    [anon_sym_static] = ACTIONS(1709),
    [anon_sym_readonly] = ACTIONS(1709),
    [anon_sym_get] = ACTIONS(1709),
    [anon_sym_set] = ACTIONS(1709),
    [anon_sym_declare] = ACTIONS(1709),
    [anon_sym_public] = ACTIONS(1709),
    [anon_sym_private] = ACTIONS(1709),
    [anon_sym_protected] = ACTIONS(1709),
    [anon_sym_override] = ACTIONS(1709),
    [anon_sym_module] = ACTIONS(1709),
    [anon_sym_any] = ACTIONS(1709),
    [anon_sym_number] = ACTIONS(1709),
    [anon_sym_boolean] = ACTIONS(1709),
    [anon_sym_string] = ACTIONS(1709),
    [anon_sym_symbol] = ACTIONS(1709),
    [anon_sym_property] = ACTIONS(1709),
    [anon_sym_signal] = ACTIONS(1709),
    [anon_sym_on] = ACTIONS(1709),
    [anon_sym_required] = ACTIONS(1709),
    [anon_sym_component] = ACTIONS(1709),
    [anon_sym_abstract] = ACTIONS(1709),
    [anon_sym_interface] = ACTIONS(1709),
    [anon_sym_enum] = ACTIONS(1709),
    [sym__automatic_semicolon] = ACTIONS(1717),
  },
  [689] = {
    [sym_identifier] = ACTIONS(1689),
    [anon_sym_export] = ACTIONS(1689),
    [anon_sym_default] = ACTIONS(1689),
    [anon_sym_type] = ACTIONS(1689),
    [anon_sym_namespace] = ACTIONS(1689),
    [anon_sym_LBRACE] = ACTIONS(1693),
    [anon_sym_RBRACE] = ACTIONS(1693),
    [anon_sym_typeof] = ACTIONS(1689),
    [anon_sym_import] = ACTIONS(1689),
    [anon_sym_from] = ACTIONS(1689),
    [anon_sym_var] = ACTIONS(1689),
    [anon_sym_let] = ACTIONS(1689),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(1693),
    [anon_sym_else] = ACTIONS(1689),
    [anon_sym_if] = ACTIONS(1689),
    [anon_sym_switch] = ACTIONS(1689),
    [anon_sym_for] = ACTIONS(1689),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [anon_sym_await] = ACTIONS(1689),
    [anon_sym_of] = ACTIONS(1689),
    [anon_sym_while] = ACTIONS(1689),
    [anon_sym_do] = ACTIONS(1689),
    [anon_sym_try] = ACTIONS(1689),
    [anon_sym_with] = ACTIONS(1689),
    [anon_sym_break] = ACTIONS(1689),
    [anon_sym_continue] = ACTIONS(1689),
    [anon_sym_debugger] = ACTIONS(1689),
    [anon_sym_return] = ACTIONS(1689),
    [anon_sym_throw] = ACTIONS(1689),
    [anon_sym_SEMI] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(1689),
    [anon_sym_yield] = ACTIONS(1689),
    [anon_sym_LBRACK] = ACTIONS(1693),
    [anon_sym_LTtemplate_GT] = ACTIONS(1693),
    [anon_sym_LT] = ACTIONS(1689),
    [anon_sym_SLASH] = ACTIONS(1689),
    [anon_sym_class] = ACTIONS(1689),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(1689),
    [anon_sym_new] = ACTIONS(1689),
    [anon_sym_PLUS] = ACTIONS(1689),
    [anon_sym_DASH] = ACTIONS(1689),
    [anon_sym_TILDE] = ACTIONS(1693),
    [anon_sym_void] = ACTIONS(1689),
    [anon_sym_delete] = ACTIONS(1689),
    [anon_sym_PLUS_PLUS] = ACTIONS(1693),
    [anon_sym_DASH_DASH] = ACTIONS(1693),
    [anon_sym_DQUOTE] = ACTIONS(1693),
    [anon_sym_SQUOTE] = ACTIONS(1693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1693),
    [sym_number] = ACTIONS(1693),
    [sym_this] = ACTIONS(1689),
    [sym_super] = ACTIONS(1689),
    [sym_true] = ACTIONS(1689),
    [sym_false] = ACTIONS(1689),
    [sym_null] = ACTIONS(1689),
    [sym_undefined] = ACTIONS(1689),
    [anon_sym_AT] = ACTIONS(1693),
    [anon_sym_static] = ACTIONS(1689),
    [anon_sym_readonly] = ACTIONS(1689),
    [anon_sym_get] = ACTIONS(1689),
    [anon_sym_set] = ACTIONS(1689),
    [anon_sym_declare] = ACTIONS(1689),
    [anon_sym_public] = ACTIONS(1689),
    [anon_sym_private] = ACTIONS(1689),
    [anon_sym_protected] = ACTIONS(1689),
    [anon_sym_override] = ACTIONS(1689),
    [anon_sym_module] = ACTIONS(1689),
    [anon_sym_any] = ACTIONS(1689),
    [anon_sym_number] = ACTIONS(1689),
    [anon_sym_boolean] = ACTIONS(1689),
    [anon_sym_string] = ACTIONS(1689),
    [anon_sym_symbol] = ACTIONS(1689),
    [anon_sym_property] = ACTIONS(1689),
    [anon_sym_signal] = ACTIONS(1689),
    [anon_sym_on] = ACTIONS(1689),
    [anon_sym_required] = ACTIONS(1689),
    [anon_sym_component] = ACTIONS(1689),
    [anon_sym_abstract] = ACTIONS(1689),
    [anon_sym_interface] = ACTIONS(1689),
    [anon_sym_enum] = ACTIONS(1689),
    [sym__automatic_semicolon] = ACTIONS(1697),
  },
  [690] = {
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_default] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_namespace] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(1551),
    [anon_sym_RBRACE] = ACTIONS(1551),
    [anon_sym_typeof] = ACTIONS(1547),
    [anon_sym_import] = ACTIONS(1547),
    [anon_sym_from] = ACTIONS(1547),
    [anon_sym_var] = ACTIONS(1547),
    [anon_sym_let] = ACTIONS(1547),
    [anon_sym_const] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1551),
    [anon_sym_else] = ACTIONS(1547),
    [anon_sym_if] = ACTIONS(1547),
    [anon_sym_switch] = ACTIONS(1547),
    [anon_sym_for] = ACTIONS(1547),
    [anon_sym_LPAREN] = ACTIONS(1551),
    [anon_sym_await] = ACTIONS(1547),
    [anon_sym_of] = ACTIONS(1547),
    [anon_sym_while] = ACTIONS(1547),
    [anon_sym_do] = ACTIONS(1547),
    [anon_sym_try] = ACTIONS(1547),
    [anon_sym_with] = ACTIONS(1547),
    [anon_sym_break] = ACTIONS(1547),
    [anon_sym_continue] = ACTIONS(1547),
    [anon_sym_debugger] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1547),
    [anon_sym_throw] = ACTIONS(1547),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym_case] = ACTIONS(1547),
    [anon_sym_yield] = ACTIONS(1547),
    [anon_sym_LBRACK] = ACTIONS(1551),
    [anon_sym_LTtemplate_GT] = ACTIONS(1551),
    [anon_sym_LT] = ACTIONS(1547),
    [anon_sym_SLASH] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_new] = ACTIONS(1547),
    [anon_sym_PLUS] = ACTIONS(1547),
    [anon_sym_DASH] = ACTIONS(1547),
    [anon_sym_TILDE] = ACTIONS(1551),
    [anon_sym_void] = ACTIONS(1547),
    [anon_sym_delete] = ACTIONS(1547),
    [anon_sym_PLUS_PLUS] = ACTIONS(1551),
    [anon_sym_DASH_DASH] = ACTIONS(1551),
    [anon_sym_DQUOTE] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1551),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1551),
    [sym_number] = ACTIONS(1551),
    [sym_this] = ACTIONS(1547),
    [sym_super] = ACTIONS(1547),
    [sym_true] = ACTIONS(1547),
    [sym_false] = ACTIONS(1547),
    [sym_null] = ACTIONS(1547),
    [sym_undefined] = ACTIONS(1547),
    [anon_sym_AT] = ACTIONS(1551),
    [anon_sym_static] = ACTIONS(1547),
    [anon_sym_readonly] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_override] = ACTIONS(1547),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_property] = ACTIONS(1547),
    [anon_sym_signal] = ACTIONS(1547),
    [anon_sym_on] = ACTIONS(1547),
    [anon_sym_required] = ACTIONS(1547),
    [anon_sym_component] = ACTIONS(1547),
    [anon_sym_abstract] = ACTIONS(1547),
    [anon_sym_interface] = ACTIONS(1547),
    [anon_sym_enum] = ACTIONS(1547),
    [sym__automatic_semicolon] = ACTIONS(1555),
  },
  [691] = {
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_type] = ACTIONS(1473),
    [anon_sym_namespace] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(1479),
    [anon_sym_RBRACE] = ACTIONS(1479),
    [anon_sym_typeof] = ACTIONS(1473),
    [anon_sym_import] = ACTIONS(1473),
    [anon_sym_from] = ACTIONS(1473),
    [anon_sym_var] = ACTIONS(1473),
    [anon_sym_let] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_switch] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_await] = ACTIONS(1473),
    [anon_sym_of] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_do] = ACTIONS(1473),
    [anon_sym_try] = ACTIONS(1473),
    [anon_sym_with] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_debugger] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_throw] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1479),
    [anon_sym_case] = ACTIONS(1473),
    [anon_sym_yield] = ACTIONS(1473),
    [anon_sym_LBRACK] = ACTIONS(1479),
    [anon_sym_LTtemplate_GT] = ACTIONS(1479),
    [anon_sym_LT] = ACTIONS(1473),
    [anon_sym_SLASH] = ACTIONS(1473),
    [anon_sym_class] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_function] = ACTIONS(1473),
    [anon_sym_new] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_TILDE] = ACTIONS(1479),
    [anon_sym_void] = ACTIONS(1473),
    [anon_sym_delete] = ACTIONS(1473),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [anon_sym_DQUOTE] = ACTIONS(1479),
    [anon_sym_SQUOTE] = ACTIONS(1479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1479),
    [sym_number] = ACTIONS(1479),
    [sym_this] = ACTIONS(1473),
    [sym_super] = ACTIONS(1473),
    [sym_true] = ACTIONS(1473),
    [sym_false] = ACTIONS(1473),
    [sym_null] = ACTIONS(1473),
    [sym_undefined] = ACTIONS(1473),
    [anon_sym_AT] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_get] = ACTIONS(1473),
    [anon_sym_set] = ACTIONS(1473),
    [anon_sym_declare] = ACTIONS(1473),
    [anon_sym_public] = ACTIONS(1473),
    [anon_sym_private] = ACTIONS(1473),
    [anon_sym_protected] = ACTIONS(1473),
    [anon_sym_override] = ACTIONS(1473),
    [anon_sym_module] = ACTIONS(1473),
    [anon_sym_any] = ACTIONS(1473),
    [anon_sym_number] = ACTIONS(1473),
    [anon_sym_boolean] = ACTIONS(1473),
    [anon_sym_string] = ACTIONS(1473),
    [anon_sym_symbol] = ACTIONS(1473),
    [anon_sym_property] = ACTIONS(1473),
    [anon_sym_signal] = ACTIONS(1473),
    [anon_sym_on] = ACTIONS(1473),
    [anon_sym_required] = ACTIONS(1473),
    [anon_sym_component] = ACTIONS(1473),
    [anon_sym_abstract] = ACTIONS(1473),
    [anon_sym_interface] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [sym__automatic_semicolon] = ACTIONS(2331),
  },
  [692] = {
    [sym_identifier] = ACTIONS(1699),
    [anon_sym_export] = ACTIONS(1699),
    [anon_sym_default] = ACTIONS(1699),
    [anon_sym_type] = ACTIONS(1699),
    [anon_sym_namespace] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_typeof] = ACTIONS(1699),
    [anon_sym_import] = ACTIONS(1699),
    [anon_sym_from] = ACTIONS(1699),
    [anon_sym_var] = ACTIONS(1699),
    [anon_sym_let] = ACTIONS(1699),
    [anon_sym_const] = ACTIONS(1699),
    [anon_sym_BANG] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_switch] = ACTIONS(1699),
    [anon_sym_for] = ACTIONS(1699),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_await] = ACTIONS(1699),
    [anon_sym_of] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_try] = ACTIONS(1699),
    [anon_sym_with] = ACTIONS(1699),
    [anon_sym_break] = ACTIONS(1699),
    [anon_sym_continue] = ACTIONS(1699),
    [anon_sym_debugger] = ACTIONS(1699),
    [anon_sym_return] = ACTIONS(1699),
    [anon_sym_throw] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_case] = ACTIONS(1699),
    [anon_sym_yield] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_LTtemplate_GT] = ACTIONS(1703),
    [anon_sym_LT] = ACTIONS(1699),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_class] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(1699),
    [anon_sym_function] = ACTIONS(1699),
    [anon_sym_new] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_TILDE] = ACTIONS(1703),
    [anon_sym_void] = ACTIONS(1699),
    [anon_sym_delete] = ACTIONS(1699),
    [anon_sym_PLUS_PLUS] = ACTIONS(1703),
    [anon_sym_DASH_DASH] = ACTIONS(1703),
    [anon_sym_DQUOTE] = ACTIONS(1703),
    [anon_sym_SQUOTE] = ACTIONS(1703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1703),
    [sym_number] = ACTIONS(1703),
    [sym_this] = ACTIONS(1699),
    [sym_super] = ACTIONS(1699),
    [sym_true] = ACTIONS(1699),
    [sym_false] = ACTIONS(1699),
    [sym_null] = ACTIONS(1699),
    [sym_undefined] = ACTIONS(1699),
    [anon_sym_AT] = ACTIONS(1703),
    [anon_sym_static] = ACTIONS(1699),
    [anon_sym_readonly] = ACTIONS(1699),
    [anon_sym_get] = ACTIONS(1699),
    [anon_sym_set] = ACTIONS(1699),
    [anon_sym_declare] = ACTIONS(1699),
    [anon_sym_public] = ACTIONS(1699),
    [anon_sym_private] = ACTIONS(1699),
    [anon_sym_protected] = ACTIONS(1699),
    [anon_sym_override] = ACTIONS(1699),
    [anon_sym_module] = ACTIONS(1699),
    [anon_sym_any] = ACTIONS(1699),
    [anon_sym_number] = ACTIONS(1699),
    [anon_sym_boolean] = ACTIONS(1699),
    [anon_sym_string] = ACTIONS(1699),
    [anon_sym_symbol] = ACTIONS(1699),
    [anon_sym_property] = ACTIONS(1699),
    [anon_sym_signal] = ACTIONS(1699),
    [anon_sym_on] = ACTIONS(1699),
    [anon_sym_required] = ACTIONS(1699),
    [anon_sym_component] = ACTIONS(1699),
    [anon_sym_abstract] = ACTIONS(1699),
    [anon_sym_interface] = ACTIONS(1699),
    [anon_sym_enum] = ACTIONS(1699),
    [sym__automatic_semicolon] = ACTIONS(1707),
  },
  [693] = {
    [sym__call_signature] = STATE(4946),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2333),
    [anon_sym_export] = ACTIONS(2335),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_EQ] = ACTIONS(1756),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2335),
    [anon_sym_from] = ACTIONS(2335),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2337),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2335),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(1758),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2335),
    [anon_sym_readonly] = ACTIONS(2335),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
    [anon_sym_declare] = ACTIONS(2335),
    [anon_sym_public] = ACTIONS(2335),
    [anon_sym_private] = ACTIONS(2335),
    [anon_sym_protected] = ACTIONS(2335),
    [anon_sym_override] = ACTIONS(2335),
    [anon_sym_module] = ACTIONS(2335),
    [anon_sym_any] = ACTIONS(2335),
    [anon_sym_number] = ACTIONS(2335),
    [anon_sym_boolean] = ACTIONS(2335),
    [anon_sym_string] = ACTIONS(2335),
    [anon_sym_symbol] = ACTIONS(2335),
    [anon_sym_property] = ACTIONS(2335),
    [anon_sym_signal] = ACTIONS(2335),
    [anon_sym_on] = ACTIONS(2335),
    [anon_sym_required] = ACTIONS(2335),
    [anon_sym_component] = ACTIONS(2335),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [694] = {
    [sym__call_signature] = STATE(4946),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2333),
    [anon_sym_export] = ACTIONS(2335),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2335),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2335),
    [anon_sym_from] = ACTIONS(2335),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2337),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2335),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(1758),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2335),
    [anon_sym_readonly] = ACTIONS(2335),
    [anon_sym_get] = ACTIONS(2335),
    [anon_sym_set] = ACTIONS(2335),
    [anon_sym_declare] = ACTIONS(2335),
    [anon_sym_public] = ACTIONS(2335),
    [anon_sym_private] = ACTIONS(2335),
    [anon_sym_protected] = ACTIONS(2335),
    [anon_sym_override] = ACTIONS(2335),
    [anon_sym_module] = ACTIONS(2335),
    [anon_sym_any] = ACTIONS(2335),
    [anon_sym_number] = ACTIONS(2335),
    [anon_sym_boolean] = ACTIONS(2335),
    [anon_sym_string] = ACTIONS(2335),
    [anon_sym_symbol] = ACTIONS(2335),
    [anon_sym_property] = ACTIONS(2335),
    [anon_sym_signal] = ACTIONS(2335),
    [anon_sym_on] = ACTIONS(2335),
    [anon_sym_required] = ACTIONS(2335),
    [anon_sym_component] = ACTIONS(2335),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [695] = {
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_default] = ACTIONS(1623),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_typeof] = ACTIONS(1623),
    [anon_sym_import] = ACTIONS(1623),
    [anon_sym_from] = ACTIONS(1623),
    [anon_sym_var] = ACTIONS(1623),
    [anon_sym_let] = ACTIONS(1623),
    [anon_sym_const] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_else] = ACTIONS(1623),
    [anon_sym_if] = ACTIONS(1623),
    [anon_sym_switch] = ACTIONS(1623),
    [anon_sym_for] = ACTIONS(1623),
    [anon_sym_LPAREN] = ACTIONS(1625),
    [anon_sym_await] = ACTIONS(1623),
    [anon_sym_of] = ACTIONS(1623),
    [anon_sym_while] = ACTIONS(1623),
    [anon_sym_do] = ACTIONS(1623),
    [anon_sym_try] = ACTIONS(1623),
    [anon_sym_with] = ACTIONS(1623),
    [anon_sym_break] = ACTIONS(1623),
    [anon_sym_continue] = ACTIONS(1623),
    [anon_sym_debugger] = ACTIONS(1623),
    [anon_sym_return] = ACTIONS(1623),
    [anon_sym_throw] = ACTIONS(1623),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_case] = ACTIONS(1623),
    [anon_sym_yield] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_LTtemplate_GT] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1623),
    [anon_sym_DOT] = ACTIONS(1623),
    [anon_sym_class] = ACTIONS(1623),
    [anon_sym_async] = ACTIONS(1623),
    [anon_sym_function] = ACTIONS(1623),
    [anon_sym_new] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1623),
    [anon_sym_DASH] = ACTIONS(1623),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_void] = ACTIONS(1623),
    [anon_sym_delete] = ACTIONS(1623),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_DQUOTE] = ACTIONS(1625),
    [anon_sym_SQUOTE] = ACTIONS(1625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [sym_number] = ACTIONS(1625),
    [sym_this] = ACTIONS(1623),
    [sym_super] = ACTIONS(1623),
    [sym_true] = ACTIONS(1623),
    [sym_false] = ACTIONS(1623),
    [sym_null] = ACTIONS(1623),
    [sym_undefined] = ACTIONS(1623),
    [anon_sym_AT] = ACTIONS(1625),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_readonly] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1623),
    [anon_sym_set] = ACTIONS(1623),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_override] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [anon_sym_property] = ACTIONS(1623),
    [anon_sym_signal] = ACTIONS(1623),
    [anon_sym_on] = ACTIONS(1623),
    [anon_sym_required] = ACTIONS(1623),
    [anon_sym_component] = ACTIONS(1623),
    [anon_sym_abstract] = ACTIONS(1623),
    [anon_sym_interface] = ACTIONS(1623),
    [anon_sym_enum] = ACTIONS(1623),
  },
  [696] = {
    [sym_identifier] = ACTIONS(2340),
    [anon_sym_export] = ACTIONS(2340),
    [anon_sym_default] = ACTIONS(2340),
    [anon_sym_type] = ACTIONS(2340),
    [anon_sym_namespace] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_typeof] = ACTIONS(2340),
    [anon_sym_import] = ACTIONS(2340),
    [anon_sym_from] = ACTIONS(2340),
    [anon_sym_var] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_const] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_else] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_switch] = ACTIONS(2340),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_await] = ACTIONS(2340),
    [anon_sym_of] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_with] = ACTIONS(2340),
    [anon_sym_break] = ACTIONS(2340),
    [anon_sym_continue] = ACTIONS(2340),
    [anon_sym_debugger] = ACTIONS(2340),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_throw] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_case] = ACTIONS(2340),
    [anon_sym_finally] = ACTIONS(2340),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_LTtemplate_GT] = ACTIONS(2342),
    [anon_sym_LT] = ACTIONS(2340),
    [anon_sym_SLASH] = ACTIONS(2340),
    [anon_sym_class] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(2340),
    [anon_sym_function] = ACTIONS(2340),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_TILDE] = ACTIONS(2342),
    [anon_sym_void] = ACTIONS(2340),
    [anon_sym_delete] = ACTIONS(2340),
    [anon_sym_PLUS_PLUS] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2342),
    [anon_sym_DQUOTE] = ACTIONS(2342),
    [anon_sym_SQUOTE] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2342),
    [sym_number] = ACTIONS(2342),
    [sym_this] = ACTIONS(2340),
    [sym_super] = ACTIONS(2340),
    [sym_true] = ACTIONS(2340),
    [sym_false] = ACTIONS(2340),
    [sym_null] = ACTIONS(2340),
    [sym_undefined] = ACTIONS(2340),
    [anon_sym_AT] = ACTIONS(2342),
    [anon_sym_static] = ACTIONS(2340),
    [anon_sym_readonly] = ACTIONS(2340),
    [anon_sym_get] = ACTIONS(2340),
    [anon_sym_set] = ACTIONS(2340),
    [anon_sym_declare] = ACTIONS(2340),
    [anon_sym_public] = ACTIONS(2340),
    [anon_sym_private] = ACTIONS(2340),
    [anon_sym_protected] = ACTIONS(2340),
    [anon_sym_override] = ACTIONS(2340),
    [anon_sym_module] = ACTIONS(2340),
    [anon_sym_any] = ACTIONS(2340),
    [anon_sym_number] = ACTIONS(2340),
    [anon_sym_boolean] = ACTIONS(2340),
    [anon_sym_string] = ACTIONS(2340),
    [anon_sym_symbol] = ACTIONS(2340),
    [anon_sym_property] = ACTIONS(2340),
    [anon_sym_signal] = ACTIONS(2340),
    [anon_sym_on] = ACTIONS(2340),
    [anon_sym_required] = ACTIONS(2340),
    [anon_sym_component] = ACTIONS(2340),
    [anon_sym_abstract] = ACTIONS(2340),
    [anon_sym_interface] = ACTIONS(2340),
    [anon_sym_enum] = ACTIONS(2340),
  },
  [697] = {
    [sym__call_signature] = STATE(4638),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2191),
    [anon_sym_export] = ACTIONS(2193),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2193),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2193),
    [anon_sym_from] = ACTIONS(2193),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(2267),
    [anon_sym_of] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2193),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2193),
    [anon_sym_readonly] = ACTIONS(2193),
    [anon_sym_get] = ACTIONS(2193),
    [anon_sym_set] = ACTIONS(2193),
    [anon_sym_declare] = ACTIONS(2193),
    [anon_sym_public] = ACTIONS(2193),
    [anon_sym_private] = ACTIONS(2193),
    [anon_sym_protected] = ACTIONS(2193),
    [anon_sym_override] = ACTIONS(2193),
    [anon_sym_module] = ACTIONS(2193),
    [anon_sym_any] = ACTIONS(2193),
    [anon_sym_number] = ACTIONS(2193),
    [anon_sym_boolean] = ACTIONS(2193),
    [anon_sym_string] = ACTIONS(2193),
    [anon_sym_symbol] = ACTIONS(2193),
    [anon_sym_property] = ACTIONS(2193),
    [anon_sym_signal] = ACTIONS(2193),
    [anon_sym_on] = ACTIONS(2193),
    [anon_sym_required] = ACTIONS(2193),
    [anon_sym_component] = ACTIONS(2193),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [698] = {
    [sym__call_signature] = STATE(4638),
    [sym_formal_parameters] = STATE(3479),
    [sym_type_parameters] = STATE(4523),
    [sym_identifier] = ACTIONS(2191),
    [anon_sym_export] = ACTIONS(2193),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_type] = ACTIONS(2193),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_namespace] = ACTIONS(2193),
    [anon_sym_from] = ACTIONS(2193),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_of] = ACTIONS(2193),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2198),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_async] = ACTIONS(2193),
    [anon_sym_function] = ACTIONS(2201),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_static] = ACTIONS(2193),
    [anon_sym_readonly] = ACTIONS(2193),
    [anon_sym_get] = ACTIONS(2193),
    [anon_sym_set] = ACTIONS(2193),
    [anon_sym_declare] = ACTIONS(2193),
    [anon_sym_public] = ACTIONS(2193),
    [anon_sym_private] = ACTIONS(2193),
    [anon_sym_protected] = ACTIONS(2193),
    [anon_sym_override] = ACTIONS(2193),
    [anon_sym_module] = ACTIONS(2193),
    [anon_sym_any] = ACTIONS(2193),
    [anon_sym_number] = ACTIONS(2193),
    [anon_sym_boolean] = ACTIONS(2193),
    [anon_sym_string] = ACTIONS(2193),
    [anon_sym_symbol] = ACTIONS(2193),
    [anon_sym_property] = ACTIONS(2193),
    [anon_sym_signal] = ACTIONS(2193),
    [anon_sym_on] = ACTIONS(2193),
    [anon_sym_required] = ACTIONS(2193),
    [anon_sym_component] = ACTIONS(2193),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [699] = {
    [sym_identifier] = ACTIONS(1575),
    [anon_sym_export] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(1575),
    [anon_sym_type] = ACTIONS(1575),
    [anon_sym_namespace] = ACTIONS(1575),
    [anon_sym_LBRACE] = ACTIONS(1579),
    [anon_sym_RBRACE] = ACTIONS(1579),
    [anon_sym_typeof] = ACTIONS(1575),
    [anon_sym_import] = ACTIONS(1575),
    [anon_sym_from] = ACTIONS(1575),
    [anon_sym_var] = ACTIONS(1575),
    [anon_sym_let] = ACTIONS(1575),
    [anon_sym_const] = ACTIONS(1575),
    [anon_sym_BANG] = ACTIONS(1579),
    [anon_sym_else] = ACTIONS(1575),
    [anon_sym_if] = ACTIONS(1575),
    [anon_sym_switch] = ACTIONS(1575),
    [anon_sym_for] = ACTIONS(1575),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_of] = ACTIONS(1575),
    [anon_sym_while] = ACTIONS(1575),
    [anon_sym_do] = ACTIONS(1575),
    [anon_sym_try] = ACTIONS(1575),
    [anon_sym_with] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1575),
    [anon_sym_continue] = ACTIONS(1575),
    [anon_sym_debugger] = ACTIONS(1575),
    [anon_sym_return] = ACTIONS(1575),
    [anon_sym_throw] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1579),
    [anon_sym_case] = ACTIONS(1575),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(1579),
    [anon_sym_LTtemplate_GT] = ACTIONS(1579),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_SLASH] = ACTIONS(1575),
    [anon_sym_class] = ACTIONS(1575),
    [anon_sym_async] = ACTIONS(1575),
    [anon_sym_function] = ACTIONS(1575),
    [anon_sym_new] = ACTIONS(1575),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_DASH] = ACTIONS(1575),
    [anon_sym_TILDE] = ACTIONS(1579),
    [anon_sym_void] = ACTIONS(1575),
    [anon_sym_delete] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1579),
    [anon_sym_DASH_DASH] = ACTIONS(1579),
    [anon_sym_DQUOTE] = ACTIONS(1579),
    [anon_sym_SQUOTE] = ACTIONS(1579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1579),
    [sym_number] = ACTIONS(1579),
    [sym_this] = ACTIONS(1575),
    [sym_super] = ACTIONS(1575),
    [sym_true] = ACTIONS(1575),
    [sym_false] = ACTIONS(1575),
    [sym_null] = ACTIONS(1575),
    [sym_undefined] = ACTIONS(1575),
    [anon_sym_AT] = ACTIONS(1579),
    [anon_sym_static] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_get] = ACTIONS(1575),
    [anon_sym_set] = ACTIONS(1575),
    [anon_sym_declare] = ACTIONS(1575),
    [anon_sym_public] = ACTIONS(1575),
    [anon_sym_private] = ACTIONS(1575),
    [anon_sym_protected] = ACTIONS(1575),
    [anon_sym_override] = ACTIONS(1575),
    [anon_sym_module] = ACTIONS(1575),
    [anon_sym_any] = ACTIONS(1575),
    [anon_sym_number] = ACTIONS(1575),
    [anon_sym_boolean] = ACTIONS(1575),
    [anon_sym_string] = ACTIONS(1575),
    [anon_sym_symbol] = ACTIONS(1575),
    [anon_sym_property] = ACTIONS(1575),
    [anon_sym_signal] = ACTIONS(1575),
    [anon_sym_on] = ACTIONS(1575),
    [anon_sym_required] = ACTIONS(1575),
    [anon_sym_component] = ACTIONS(1575),
    [anon_sym_abstract] = ACTIONS(1575),
    [anon_sym_interface] = ACTIONS(1575),
    [anon_sym_enum] = ACTIONS(1575),
    [sym__automatic_semicolon] = ACTIONS(1583),
  },
  [700] = {
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(1731),
    [anon_sym_default] = ACTIONS(1731),
    [anon_sym_type] = ACTIONS(1731),
    [anon_sym_namespace] = ACTIONS(1731),
    [anon_sym_LBRACE] = ACTIONS(1735),
    [anon_sym_RBRACE] = ACTIONS(1735),
    [anon_sym_typeof] = ACTIONS(1731),
    [anon_sym_import] = ACTIONS(1731),
    [anon_sym_from] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1731),
    [anon_sym_let] = ACTIONS(1731),
    [anon_sym_const] = ACTIONS(1731),
    [anon_sym_BANG] = ACTIONS(1735),
    [anon_sym_else] = ACTIONS(1731),
    [anon_sym_if] = ACTIONS(1731),
    [anon_sym_switch] = ACTIONS(1731),
    [anon_sym_for] = ACTIONS(1731),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_await] = ACTIONS(1731),
    [anon_sym_of] = ACTIONS(1731),
    [anon_sym_while] = ACTIONS(1731),
    [anon_sym_do] = ACTIONS(1731),
    [anon_sym_try] = ACTIONS(1731),
    [anon_sym_with] = ACTIONS(1731),
    [anon_sym_break] = ACTIONS(1731),
    [anon_sym_continue] = ACTIONS(1731),
    [anon_sym_debugger] = ACTIONS(1731),
    [anon_sym_return] = ACTIONS(1731),
    [anon_sym_throw] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_case] = ACTIONS(1731),
    [anon_sym_yield] = ACTIONS(1731),
    [anon_sym_LBRACK] = ACTIONS(1735),
    [anon_sym_LTtemplate_GT] = ACTIONS(1735),
    [anon_sym_LT] = ACTIONS(1731),
    [anon_sym_SLASH] = ACTIONS(1731),
    [anon_sym_class] = ACTIONS(1731),
    [anon_sym_async] = ACTIONS(1731),
    [anon_sym_function] = ACTIONS(1731),
    [anon_sym_new] = ACTIONS(1731),
    [anon_sym_PLUS] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_TILDE] = ACTIONS(1735),
    [anon_sym_void] = ACTIONS(1731),
    [anon_sym_delete] = ACTIONS(1731),
    [anon_sym_PLUS_PLUS] = ACTIONS(1735),
    [anon_sym_DASH_DASH] = ACTIONS(1735),
    [anon_sym_DQUOTE] = ACTIONS(1735),
    [anon_sym_SQUOTE] = ACTIONS(1735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1735),
    [sym_number] = ACTIONS(1735),
    [sym_this] = ACTIONS(1731),
    [sym_super] = ACTIONS(1731),
    [sym_true] = ACTIONS(1731),
    [sym_false] = ACTIONS(1731),
    [sym_null] = ACTIONS(1731),
    [sym_undefined] = ACTIONS(1731),
    [anon_sym_AT] = ACTIONS(1735),
    [anon_sym_static] = ACTIONS(1731),
    [anon_sym_readonly] = ACTIONS(1731),
    [anon_sym_get] = ACTIONS(1731),
    [anon_sym_set] = ACTIONS(1731),
    [anon_sym_declare] = ACTIONS(1731),
    [anon_sym_public] = ACTIONS(1731),
    [anon_sym_private] = ACTIONS(1731),
    [anon_sym_protected] = ACTIONS(1731),
    [anon_sym_override] = ACTIONS(1731),
    [anon_sym_module] = ACTIONS(1731),
    [anon_sym_any] = ACTIONS(1731),
    [anon_sym_number] = ACTIONS(1731),
    [anon_sym_boolean] = ACTIONS(1731),
    [anon_sym_string] = ACTIONS(1731),
    [anon_sym_symbol] = ACTIONS(1731),
    [anon_sym_property] = ACTIONS(1731),
    [anon_sym_signal] = ACTIONS(1731),
    [anon_sym_on] = ACTIONS(1731),
    [anon_sym_required] = ACTIONS(1731),
    [anon_sym_component] = ACTIONS(1731),
    [anon_sym_abstract] = ACTIONS(1731),
    [anon_sym_interface] = ACTIONS(1731),
    [anon_sym_enum] = ACTIONS(1731),
    [sym__automatic_semicolon] = ACTIONS(1739),
  },
  [701] = {
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_export] = ACTIONS(1613),
    [anon_sym_default] = ACTIONS(1613),
    [anon_sym_type] = ACTIONS(1613),
    [anon_sym_namespace] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_RBRACE] = ACTIONS(1617),
    [anon_sym_typeof] = ACTIONS(1613),
    [anon_sym_import] = ACTIONS(1613),
    [anon_sym_from] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1613),
    [anon_sym_let] = ACTIONS(1613),
    [anon_sym_const] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_else] = ACTIONS(1613),
    [anon_sym_if] = ACTIONS(1613),
    [anon_sym_switch] = ACTIONS(1613),
    [anon_sym_for] = ACTIONS(1613),
    [anon_sym_LPAREN] = ACTIONS(1617),
    [anon_sym_await] = ACTIONS(1613),
    [anon_sym_of] = ACTIONS(1613),
    [anon_sym_while] = ACTIONS(1613),
    [anon_sym_do] = ACTIONS(1613),
    [anon_sym_try] = ACTIONS(1613),
    [anon_sym_with] = ACTIONS(1613),
    [anon_sym_break] = ACTIONS(1613),
    [anon_sym_continue] = ACTIONS(1613),
    [anon_sym_debugger] = ACTIONS(1613),
    [anon_sym_return] = ACTIONS(1613),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(1617),
    [anon_sym_case] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(1613),
    [anon_sym_LBRACK] = ACTIONS(1617),
    [anon_sym_LTtemplate_GT] = ACTIONS(1617),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_SLASH] = ACTIONS(1613),
    [anon_sym_class] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(1613),
    [anon_sym_new] = ACTIONS(1613),
    [anon_sym_PLUS] = ACTIONS(1613),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_TILDE] = ACTIONS(1617),
    [anon_sym_void] = ACTIONS(1613),
    [anon_sym_delete] = ACTIONS(1613),
    [anon_sym_PLUS_PLUS] = ACTIONS(1617),
    [anon_sym_DASH_DASH] = ACTIONS(1617),
    [anon_sym_DQUOTE] = ACTIONS(1617),
    [anon_sym_SQUOTE] = ACTIONS(1617),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1617),
    [sym_number] = ACTIONS(1617),
    [sym_this] = ACTIONS(1613),
    [sym_super] = ACTIONS(1613),
    [sym_true] = ACTIONS(1613),
    [sym_false] = ACTIONS(1613),
    [sym_null] = ACTIONS(1613),
    [sym_undefined] = ACTIONS(1613),
    [anon_sym_AT] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1613),
    [anon_sym_readonly] = ACTIONS(1613),
    [anon_sym_get] = ACTIONS(1613),
    [anon_sym_set] = ACTIONS(1613),
    [anon_sym_declare] = ACTIONS(1613),
    [anon_sym_public] = ACTIONS(1613),
    [anon_sym_private] = ACTIONS(1613),
    [anon_sym_protected] = ACTIONS(1613),
    [anon_sym_override] = ACTIONS(1613),
    [anon_sym_module] = ACTIONS(1613),
    [anon_sym_any] = ACTIONS(1613),
    [anon_sym_number] = ACTIONS(1613),
    [anon_sym_boolean] = ACTIONS(1613),
    [anon_sym_string] = ACTIONS(1613),
    [anon_sym_symbol] = ACTIONS(1613),
    [anon_sym_property] = ACTIONS(1613),
    [anon_sym_signal] = ACTIONS(1613),
    [anon_sym_on] = ACTIONS(1613),
    [anon_sym_required] = ACTIONS(1613),
    [anon_sym_component] = ACTIONS(1613),
    [anon_sym_abstract] = ACTIONS(1613),
    [anon_sym_interface] = ACTIONS(1613),
    [anon_sym_enum] = ACTIONS(1613),
    [sym__automatic_semicolon] = ACTIONS(1621),
  },
  [702] = {
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_default] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_namespace] = ACTIONS(1523),
    [anon_sym_LBRACE] = ACTIONS(1527),
    [anon_sym_RBRACE] = ACTIONS(1527),
    [anon_sym_typeof] = ACTIONS(1523),
    [anon_sym_import] = ACTIONS(1523),
    [anon_sym_from] = ACTIONS(1523),
    [anon_sym_var] = ACTIONS(1523),
    [anon_sym_let] = ACTIONS(1523),
    [anon_sym_const] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1527),
    [anon_sym_else] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_switch] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_LPAREN] = ACTIONS(1527),
    [anon_sym_await] = ACTIONS(1523),
    [anon_sym_of] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_do] = ACTIONS(1523),
    [anon_sym_try] = ACTIONS(1523),
    [anon_sym_with] = ACTIONS(1523),
    [anon_sym_break] = ACTIONS(1523),
    [anon_sym_continue] = ACTIONS(1523),
    [anon_sym_debugger] = ACTIONS(1523),
    [anon_sym_return] = ACTIONS(1523),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_SEMI] = ACTIONS(1527),
    [anon_sym_case] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(1523),
    [anon_sym_LBRACK] = ACTIONS(1527),
    [anon_sym_LTtemplate_GT] = ACTIONS(1527),
    [anon_sym_LT] = ACTIONS(1523),
    [anon_sym_SLASH] = ACTIONS(1523),
    [anon_sym_class] = ACTIONS(1523),
    [anon_sym_async] = ACTIONS(1523),
    [anon_sym_function] = ACTIONS(1523),
    [anon_sym_new] = ACTIONS(1523),
    [anon_sym_PLUS] = ACTIONS(1523),
    [anon_sym_DASH] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1527),
    [anon_sym_void] = ACTIONS(1523),
    [anon_sym_delete] = ACTIONS(1523),
    [anon_sym_PLUS_PLUS] = ACTIONS(1527),
    [anon_sym_DASH_DASH] = ACTIONS(1527),
    [anon_sym_DQUOTE] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1527),
    [sym_number] = ACTIONS(1527),
    [sym_this] = ACTIONS(1523),
    [sym_super] = ACTIONS(1523),
    [sym_true] = ACTIONS(1523),
    [sym_false] = ACTIONS(1523),
    [sym_null] = ACTIONS(1523),
    [sym_undefined] = ACTIONS(1523),
    [anon_sym_AT] = ACTIONS(1527),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_override] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
    [anon_sym_property] = ACTIONS(1523),
    [anon_sym_signal] = ACTIONS(1523),
    [anon_sym_on] = ACTIONS(1523),
    [anon_sym_required] = ACTIONS(1523),
    [anon_sym_component] = ACTIONS(1523),
    [anon_sym_abstract] = ACTIONS(1523),
    [anon_sym_interface] = ACTIONS(1523),
    [anon_sym_enum] = ACTIONS(1523),
    [sym__automatic_semicolon] = ACTIONS(1531),
  },
  [703] = {
    [sym_identifier] = ACTIONS(2346),
    [anon_sym_export] = ACTIONS(2346),
    [anon_sym_default] = ACTIONS(2346),
    [anon_sym_type] = ACTIONS(2346),
    [anon_sym_namespace] = ACTIONS(2346),
    [anon_sym_LBRACE] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(2348),
    [anon_sym_typeof] = ACTIONS(2346),
    [anon_sym_import] = ACTIONS(2346),
    [anon_sym_from] = ACTIONS(2346),
    [anon_sym_var] = ACTIONS(2346),
    [anon_sym_let] = ACTIONS(2346),
    [anon_sym_const] = ACTIONS(2346),
    [anon_sym_BANG] = ACTIONS(2348),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_if] = ACTIONS(2346),
    [anon_sym_switch] = ACTIONS(2346),
    [anon_sym_for] = ACTIONS(2346),
    [anon_sym_LPAREN] = ACTIONS(2348),
    [anon_sym_RPAREN] = ACTIONS(2348),
    [anon_sym_await] = ACTIONS(2346),
    [anon_sym_of] = ACTIONS(2346),
    [anon_sym_while] = ACTIONS(2346),
    [anon_sym_do] = ACTIONS(2346),
    [anon_sym_try] = ACTIONS(2346),
    [anon_sym_with] = ACTIONS(2346),
    [anon_sym_break] = ACTIONS(2346),
    [anon_sym_continue] = ACTIONS(2346),
    [anon_sym_debugger] = ACTIONS(2346),
    [anon_sym_return] = ACTIONS(2346),
    [anon_sym_throw] = ACTIONS(2346),
    [anon_sym_SEMI] = ACTIONS(2348),
    [anon_sym_case] = ACTIONS(2346),
    [anon_sym_yield] = ACTIONS(2346),
    [anon_sym_LBRACK] = ACTIONS(2348),
    [anon_sym_LTtemplate_GT] = ACTIONS(2348),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_SLASH] = ACTIONS(2346),
    [anon_sym_class] = ACTIONS(2346),
    [anon_sym_async] = ACTIONS(2346),
    [anon_sym_function] = ACTIONS(2346),
    [anon_sym_new] = ACTIONS(2346),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_TILDE] = ACTIONS(2348),
    [anon_sym_void] = ACTIONS(2346),
    [anon_sym_delete] = ACTIONS(2346),
    [anon_sym_PLUS_PLUS] = ACTIONS(2348),
    [anon_sym_DASH_DASH] = ACTIONS(2348),
    [anon_sym_DQUOTE] = ACTIONS(2348),
    [anon_sym_SQUOTE] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2348),
    [sym_number] = ACTIONS(2348),
    [sym_this] = ACTIONS(2346),
    [sym_super] = ACTIONS(2346),
    [sym_true] = ACTIONS(2346),
    [sym_false] = ACTIONS(2346),
    [sym_null] = ACTIONS(2346),
    [sym_undefined] = ACTIONS(2346),
    [anon_sym_AT] = ACTIONS(2348),
    [anon_sym_static] = ACTIONS(2346),
    [anon_sym_readonly] = ACTIONS(2346),
    [anon_sym_get] = ACTIONS(2346),
    [anon_sym_set] = ACTIONS(2346),
    [anon_sym_declare] = ACTIONS(2346),
    [anon_sym_public] = ACTIONS(2346),
    [anon_sym_private] = ACTIONS(2346),
    [anon_sym_protected] = ACTIONS(2346),
    [anon_sym_override] = ACTIONS(2346),
    [anon_sym_module] = ACTIONS(2346),
    [anon_sym_any] = ACTIONS(2346),
    [anon_sym_number] = ACTIONS(2346),
    [anon_sym_boolean] = ACTIONS(2346),
    [anon_sym_string] = ACTIONS(2346),
    [anon_sym_symbol] = ACTIONS(2346),
    [anon_sym_property] = ACTIONS(2346),
    [anon_sym_signal] = ACTIONS(2346),
    [anon_sym_on] = ACTIONS(2346),
    [anon_sym_required] = ACTIONS(2346),
    [anon_sym_component] = ACTIONS(2346),
    [anon_sym_abstract] = ACTIONS(2346),
    [anon_sym_interface] = ACTIONS(2346),
    [anon_sym_enum] = ACTIONS(2346),
  },
  [704] = {
    [sym_identifier] = ACTIONS(2350),
    [anon_sym_export] = ACTIONS(2350),
    [anon_sym_default] = ACTIONS(2350),
    [anon_sym_type] = ACTIONS(2350),
    [anon_sym_namespace] = ACTIONS(2350),
    [anon_sym_LBRACE] = ACTIONS(2352),
    [anon_sym_RBRACE] = ACTIONS(2352),
    [anon_sym_typeof] = ACTIONS(2350),
    [anon_sym_import] = ACTIONS(2350),
    [anon_sym_from] = ACTIONS(2350),
    [anon_sym_var] = ACTIONS(2350),
    [anon_sym_let] = ACTIONS(2350),
    [anon_sym_const] = ACTIONS(2350),
    [anon_sym_BANG] = ACTIONS(2352),
    [anon_sym_else] = ACTIONS(2350),
    [anon_sym_if] = ACTIONS(2350),
    [anon_sym_switch] = ACTIONS(2350),
    [anon_sym_for] = ACTIONS(2350),
    [anon_sym_LPAREN] = ACTIONS(2352),
    [anon_sym_await] = ACTIONS(2350),
    [anon_sym_of] = ACTIONS(2350),
    [anon_sym_while] = ACTIONS(2350),
    [anon_sym_do] = ACTIONS(2350),
    [anon_sym_try] = ACTIONS(2350),
    [anon_sym_with] = ACTIONS(2350),
    [anon_sym_break] = ACTIONS(2350),
    [anon_sym_continue] = ACTIONS(2350),
    [anon_sym_debugger] = ACTIONS(2350),
    [anon_sym_return] = ACTIONS(2350),
    [anon_sym_throw] = ACTIONS(2350),
    [anon_sym_SEMI] = ACTIONS(2352),
    [anon_sym_case] = ACTIONS(2350),
    [anon_sym_yield] = ACTIONS(2350),
    [anon_sym_LBRACK] = ACTIONS(2352),
    [anon_sym_LTtemplate_GT] = ACTIONS(2352),
    [anon_sym_LT] = ACTIONS(2350),
    [anon_sym_SLASH] = ACTIONS(2350),
    [anon_sym_class] = ACTIONS(2350),
    [anon_sym_async] = ACTIONS(2350),
    [anon_sym_function] = ACTIONS(2350),
    [anon_sym_new] = ACTIONS(2350),
    [anon_sym_PLUS] = ACTIONS(2350),
    [anon_sym_DASH] = ACTIONS(2350),
    [anon_sym_TILDE] = ACTIONS(2352),
    [anon_sym_void] = ACTIONS(2350),
    [anon_sym_delete] = ACTIONS(2350),
    [anon_sym_PLUS_PLUS] = ACTIONS(2352),
    [anon_sym_DASH_DASH] = ACTIONS(2352),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [anon_sym_SQUOTE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2352),
    [sym_number] = ACTIONS(2352),
    [sym_this] = ACTIONS(2350),
    [sym_super] = ACTIONS(2350),
    [sym_true] = ACTIONS(2350),
    [sym_false] = ACTIONS(2350),
    [sym_null] = ACTIONS(2350),
    [sym_undefined] = ACTIONS(2350),
    [anon_sym_AT] = ACTIONS(2352),
    [anon_sym_static] = ACTIONS(2350),
    [anon_sym_readonly] = ACTIONS(2350),
    [anon_sym_get] = ACTIONS(2350),
    [anon_sym_set] = ACTIONS(2350),
    [anon_sym_declare] = ACTIONS(2350),
    [anon_sym_public] = ACTIONS(2350),
    [anon_sym_private] = ACTIONS(2350),
    [anon_sym_protected] = ACTIONS(2350),
    [anon_sym_override] = ACTIONS(2350),
    [anon_sym_module] = ACTIONS(2350),
    [anon_sym_any] = ACTIONS(2350),
    [anon_sym_number] = ACTIONS(2350),
    [anon_sym_boolean] = ACTIONS(2350),
    [anon_sym_string] = ACTIONS(2350),
    [anon_sym_symbol] = ACTIONS(2350),
    [anon_sym_property] = ACTIONS(2350),
    [anon_sym_signal] = ACTIONS(2350),
    [anon_sym_on] = ACTIONS(2350),
    [anon_sym_required] = ACTIONS(2350),
    [anon_sym_component] = ACTIONS(2350),
    [anon_sym_abstract] = ACTIONS(2350),
    [anon_sym_interface] = ACTIONS(2350),
    [anon_sym_enum] = ACTIONS(2350),
  },
  [705] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [706] = {
    [sym_identifier] = ACTIONS(2358),
    [anon_sym_export] = ACTIONS(2358),
    [anon_sym_default] = ACTIONS(2358),
    [anon_sym_type] = ACTIONS(2358),
    [anon_sym_namespace] = ACTIONS(2358),
    [anon_sym_LBRACE] = ACTIONS(2360),
    [anon_sym_RBRACE] = ACTIONS(2360),
    [anon_sym_typeof] = ACTIONS(2358),
    [anon_sym_import] = ACTIONS(2358),
    [anon_sym_from] = ACTIONS(2358),
    [anon_sym_var] = ACTIONS(2358),
    [anon_sym_let] = ACTIONS(2358),
    [anon_sym_const] = ACTIONS(2358),
    [anon_sym_BANG] = ACTIONS(2360),
    [anon_sym_else] = ACTIONS(2358),
    [anon_sym_if] = ACTIONS(2358),
    [anon_sym_switch] = ACTIONS(2358),
    [anon_sym_for] = ACTIONS(2358),
    [anon_sym_LPAREN] = ACTIONS(2360),
    [anon_sym_await] = ACTIONS(2358),
    [anon_sym_of] = ACTIONS(2358),
    [anon_sym_while] = ACTIONS(2358),
    [anon_sym_do] = ACTIONS(2358),
    [anon_sym_try] = ACTIONS(2358),
    [anon_sym_with] = ACTIONS(2358),
    [anon_sym_break] = ACTIONS(2358),
    [anon_sym_continue] = ACTIONS(2358),
    [anon_sym_debugger] = ACTIONS(2358),
    [anon_sym_return] = ACTIONS(2358),
    [anon_sym_throw] = ACTIONS(2358),
    [anon_sym_SEMI] = ACTIONS(2360),
    [anon_sym_case] = ACTIONS(2358),
    [anon_sym_yield] = ACTIONS(2358),
    [anon_sym_LBRACK] = ACTIONS(2360),
    [anon_sym_LTtemplate_GT] = ACTIONS(2360),
    [anon_sym_LT] = ACTIONS(2358),
    [anon_sym_SLASH] = ACTIONS(2358),
    [anon_sym_class] = ACTIONS(2358),
    [anon_sym_async] = ACTIONS(2358),
    [anon_sym_function] = ACTIONS(2358),
    [anon_sym_new] = ACTIONS(2358),
    [anon_sym_PLUS] = ACTIONS(2358),
    [anon_sym_DASH] = ACTIONS(2358),
    [anon_sym_TILDE] = ACTIONS(2360),
    [anon_sym_void] = ACTIONS(2358),
    [anon_sym_delete] = ACTIONS(2358),
    [anon_sym_PLUS_PLUS] = ACTIONS(2360),
    [anon_sym_DASH_DASH] = ACTIONS(2360),
    [anon_sym_DQUOTE] = ACTIONS(2360),
    [anon_sym_SQUOTE] = ACTIONS(2360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2360),
    [sym_number] = ACTIONS(2360),
    [sym_this] = ACTIONS(2358),
    [sym_super] = ACTIONS(2358),
    [sym_true] = ACTIONS(2358),
    [sym_false] = ACTIONS(2358),
    [sym_null] = ACTIONS(2358),
    [sym_undefined] = ACTIONS(2358),
    [anon_sym_AT] = ACTIONS(2360),
    [anon_sym_static] = ACTIONS(2358),
    [anon_sym_readonly] = ACTIONS(2358),
    [anon_sym_get] = ACTIONS(2358),
    [anon_sym_set] = ACTIONS(2358),
    [anon_sym_declare] = ACTIONS(2358),
    [anon_sym_public] = ACTIONS(2358),
    [anon_sym_private] = ACTIONS(2358),
    [anon_sym_protected] = ACTIONS(2358),
    [anon_sym_override] = ACTIONS(2358),
    [anon_sym_module] = ACTIONS(2358),
    [anon_sym_any] = ACTIONS(2358),
    [anon_sym_number] = ACTIONS(2358),
    [anon_sym_boolean] = ACTIONS(2358),
    [anon_sym_string] = ACTIONS(2358),
    [anon_sym_symbol] = ACTIONS(2358),
    [anon_sym_property] = ACTIONS(2358),
    [anon_sym_signal] = ACTIONS(2358),
    [anon_sym_on] = ACTIONS(2358),
    [anon_sym_required] = ACTIONS(2358),
    [anon_sym_component] = ACTIONS(2358),
    [anon_sym_abstract] = ACTIONS(2358),
    [anon_sym_interface] = ACTIONS(2358),
    [anon_sym_enum] = ACTIONS(2358),
  },
  [707] = {
    [sym_identifier] = ACTIONS(2362),
    [anon_sym_export] = ACTIONS(2362),
    [anon_sym_default] = ACTIONS(2362),
    [anon_sym_type] = ACTIONS(2362),
    [anon_sym_namespace] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2364),
    [anon_sym_RBRACE] = ACTIONS(2364),
    [anon_sym_typeof] = ACTIONS(2362),
    [anon_sym_import] = ACTIONS(2362),
    [anon_sym_from] = ACTIONS(2362),
    [anon_sym_var] = ACTIONS(2362),
    [anon_sym_let] = ACTIONS(2362),
    [anon_sym_const] = ACTIONS(2362),
    [anon_sym_BANG] = ACTIONS(2364),
    [anon_sym_else] = ACTIONS(2362),
    [anon_sym_if] = ACTIONS(2362),
    [anon_sym_switch] = ACTIONS(2362),
    [anon_sym_for] = ACTIONS(2362),
    [anon_sym_LPAREN] = ACTIONS(2364),
    [anon_sym_await] = ACTIONS(2362),
    [anon_sym_of] = ACTIONS(2362),
    [anon_sym_while] = ACTIONS(2362),
    [anon_sym_do] = ACTIONS(2362),
    [anon_sym_try] = ACTIONS(2362),
    [anon_sym_with] = ACTIONS(2362),
    [anon_sym_break] = ACTIONS(2362),
    [anon_sym_continue] = ACTIONS(2362),
    [anon_sym_debugger] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2362),
    [anon_sym_throw] = ACTIONS(2362),
    [anon_sym_SEMI] = ACTIONS(2364),
    [anon_sym_case] = ACTIONS(2362),
    [anon_sym_yield] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2364),
    [anon_sym_LTtemplate_GT] = ACTIONS(2364),
    [anon_sym_LT] = ACTIONS(2362),
    [anon_sym_SLASH] = ACTIONS(2362),
    [anon_sym_class] = ACTIONS(2362),
    [anon_sym_async] = ACTIONS(2362),
    [anon_sym_function] = ACTIONS(2362),
    [anon_sym_new] = ACTIONS(2362),
    [anon_sym_PLUS] = ACTIONS(2362),
    [anon_sym_DASH] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2364),
    [anon_sym_void] = ACTIONS(2362),
    [anon_sym_delete] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2364),
    [anon_sym_DASH_DASH] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2364),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2364),
    [sym_number] = ACTIONS(2364),
    [sym_this] = ACTIONS(2362),
    [sym_super] = ACTIONS(2362),
    [sym_true] = ACTIONS(2362),
    [sym_false] = ACTIONS(2362),
    [sym_null] = ACTIONS(2362),
    [sym_undefined] = ACTIONS(2362),
    [anon_sym_AT] = ACTIONS(2364),
    [anon_sym_static] = ACTIONS(2362),
    [anon_sym_readonly] = ACTIONS(2362),
    [anon_sym_get] = ACTIONS(2362),
    [anon_sym_set] = ACTIONS(2362),
    [anon_sym_declare] = ACTIONS(2362),
    [anon_sym_public] = ACTIONS(2362),
    [anon_sym_private] = ACTIONS(2362),
    [anon_sym_protected] = ACTIONS(2362),
    [anon_sym_override] = ACTIONS(2362),
    [anon_sym_module] = ACTIONS(2362),
    [anon_sym_any] = ACTIONS(2362),
    [anon_sym_number] = ACTIONS(2362),
    [anon_sym_boolean] = ACTIONS(2362),
    [anon_sym_string] = ACTIONS(2362),
    [anon_sym_symbol] = ACTIONS(2362),
    [anon_sym_property] = ACTIONS(2362),
    [anon_sym_signal] = ACTIONS(2362),
    [anon_sym_on] = ACTIONS(2362),
    [anon_sym_required] = ACTIONS(2362),
    [anon_sym_component] = ACTIONS(2362),
    [anon_sym_abstract] = ACTIONS(2362),
    [anon_sym_interface] = ACTIONS(2362),
    [anon_sym_enum] = ACTIONS(2362),
  },
  [708] = {
    [sym_identifier] = ACTIONS(2366),
    [anon_sym_export] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2366),
    [anon_sym_type] = ACTIONS(2366),
    [anon_sym_namespace] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2368),
    [anon_sym_RBRACE] = ACTIONS(2368),
    [anon_sym_typeof] = ACTIONS(2366),
    [anon_sym_import] = ACTIONS(2366),
    [anon_sym_from] = ACTIONS(2366),
    [anon_sym_var] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_BANG] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2366),
    [anon_sym_if] = ACTIONS(2366),
    [anon_sym_switch] = ACTIONS(2366),
    [anon_sym_for] = ACTIONS(2366),
    [anon_sym_LPAREN] = ACTIONS(2368),
    [anon_sym_await] = ACTIONS(2366),
    [anon_sym_of] = ACTIONS(2366),
    [anon_sym_while] = ACTIONS(2366),
    [anon_sym_do] = ACTIONS(2366),
    [anon_sym_try] = ACTIONS(2366),
    [anon_sym_with] = ACTIONS(2366),
    [anon_sym_break] = ACTIONS(2366),
    [anon_sym_continue] = ACTIONS(2366),
    [anon_sym_debugger] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2366),
    [anon_sym_throw] = ACTIONS(2366),
    [anon_sym_SEMI] = ACTIONS(2368),
    [anon_sym_case] = ACTIONS(2366),
    [anon_sym_yield] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_LTtemplate_GT] = ACTIONS(2368),
    [anon_sym_LT] = ACTIONS(2366),
    [anon_sym_SLASH] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_async] = ACTIONS(2366),
    [anon_sym_function] = ACTIONS(2366),
    [anon_sym_new] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(2366),
    [anon_sym_DASH] = ACTIONS(2366),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_void] = ACTIONS(2366),
    [anon_sym_delete] = ACTIONS(2366),
    [anon_sym_PLUS_PLUS] = ACTIONS(2368),
    [anon_sym_DASH_DASH] = ACTIONS(2368),
    [anon_sym_DQUOTE] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2368),
    [sym_number] = ACTIONS(2368),
    [sym_this] = ACTIONS(2366),
    [sym_super] = ACTIONS(2366),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [sym_null] = ACTIONS(2366),
    [sym_undefined] = ACTIONS(2366),
    [anon_sym_AT] = ACTIONS(2368),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_readonly] = ACTIONS(2366),
    [anon_sym_get] = ACTIONS(2366),
    [anon_sym_set] = ACTIONS(2366),
    [anon_sym_declare] = ACTIONS(2366),
    [anon_sym_public] = ACTIONS(2366),
    [anon_sym_private] = ACTIONS(2366),
    [anon_sym_protected] = ACTIONS(2366),
    [anon_sym_override] = ACTIONS(2366),
    [anon_sym_module] = ACTIONS(2366),
    [anon_sym_any] = ACTIONS(2366),
    [anon_sym_number] = ACTIONS(2366),
    [anon_sym_boolean] = ACTIONS(2366),
    [anon_sym_string] = ACTIONS(2366),
    [anon_sym_symbol] = ACTIONS(2366),
    [anon_sym_property] = ACTIONS(2366),
    [anon_sym_signal] = ACTIONS(2366),
    [anon_sym_on] = ACTIONS(2366),
    [anon_sym_required] = ACTIONS(2366),
    [anon_sym_component] = ACTIONS(2366),
    [anon_sym_abstract] = ACTIONS(2366),
    [anon_sym_interface] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
  },
  [709] = {
    [sym_identifier] = ACTIONS(2370),
    [anon_sym_export] = ACTIONS(2370),
    [anon_sym_default] = ACTIONS(2370),
    [anon_sym_type] = ACTIONS(2370),
    [anon_sym_namespace] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_RBRACE] = ACTIONS(2372),
    [anon_sym_typeof] = ACTIONS(2370),
    [anon_sym_import] = ACTIONS(2370),
    [anon_sym_from] = ACTIONS(2370),
    [anon_sym_var] = ACTIONS(2370),
    [anon_sym_let] = ACTIONS(2370),
    [anon_sym_const] = ACTIONS(2370),
    [anon_sym_BANG] = ACTIONS(2372),
    [anon_sym_else] = ACTIONS(2370),
    [anon_sym_if] = ACTIONS(2370),
    [anon_sym_switch] = ACTIONS(2370),
    [anon_sym_for] = ACTIONS(2370),
    [anon_sym_LPAREN] = ACTIONS(2372),
    [anon_sym_await] = ACTIONS(2370),
    [anon_sym_of] = ACTIONS(2370),
    [anon_sym_while] = ACTIONS(2370),
    [anon_sym_do] = ACTIONS(2370),
    [anon_sym_try] = ACTIONS(2370),
    [anon_sym_with] = ACTIONS(2370),
    [anon_sym_break] = ACTIONS(2370),
    [anon_sym_continue] = ACTIONS(2370),
    [anon_sym_debugger] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2370),
    [anon_sym_throw] = ACTIONS(2370),
    [anon_sym_SEMI] = ACTIONS(2372),
    [anon_sym_case] = ACTIONS(2370),
    [anon_sym_yield] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2372),
    [anon_sym_LTtemplate_GT] = ACTIONS(2372),
    [anon_sym_LT] = ACTIONS(2370),
    [anon_sym_SLASH] = ACTIONS(2370),
    [anon_sym_class] = ACTIONS(2370),
    [anon_sym_async] = ACTIONS(2370),
    [anon_sym_function] = ACTIONS(2370),
    [anon_sym_new] = ACTIONS(2370),
    [anon_sym_PLUS] = ACTIONS(2370),
    [anon_sym_DASH] = ACTIONS(2370),
    [anon_sym_TILDE] = ACTIONS(2372),
    [anon_sym_void] = ACTIONS(2370),
    [anon_sym_delete] = ACTIONS(2370),
    [anon_sym_PLUS_PLUS] = ACTIONS(2372),
    [anon_sym_DASH_DASH] = ACTIONS(2372),
    [anon_sym_DQUOTE] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2372),
    [sym_number] = ACTIONS(2372),
    [sym_this] = ACTIONS(2370),
    [sym_super] = ACTIONS(2370),
    [sym_true] = ACTIONS(2370),
    [sym_false] = ACTIONS(2370),
    [sym_null] = ACTIONS(2370),
    [sym_undefined] = ACTIONS(2370),
    [anon_sym_AT] = ACTIONS(2372),
    [anon_sym_static] = ACTIONS(2370),
    [anon_sym_readonly] = ACTIONS(2370),
    [anon_sym_get] = ACTIONS(2370),
    [anon_sym_set] = ACTIONS(2370),
    [anon_sym_declare] = ACTIONS(2370),
    [anon_sym_public] = ACTIONS(2370),
    [anon_sym_private] = ACTIONS(2370),
    [anon_sym_protected] = ACTIONS(2370),
    [anon_sym_override] = ACTIONS(2370),
    [anon_sym_module] = ACTIONS(2370),
    [anon_sym_any] = ACTIONS(2370),
    [anon_sym_number] = ACTIONS(2370),
    [anon_sym_boolean] = ACTIONS(2370),
    [anon_sym_string] = ACTIONS(2370),
    [anon_sym_symbol] = ACTIONS(2370),
    [anon_sym_property] = ACTIONS(2370),
    [anon_sym_signal] = ACTIONS(2370),
    [anon_sym_on] = ACTIONS(2370),
    [anon_sym_required] = ACTIONS(2370),
    [anon_sym_component] = ACTIONS(2370),
    [anon_sym_abstract] = ACTIONS(2370),
    [anon_sym_interface] = ACTIONS(2370),
    [anon_sym_enum] = ACTIONS(2370),
  },
  [710] = {
    [sym_identifier] = ACTIONS(1585),
    [anon_sym_export] = ACTIONS(1585),
    [anon_sym_default] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(1585),
    [anon_sym_namespace] = ACTIONS(1585),
    [anon_sym_LBRACE] = ACTIONS(1587),
    [anon_sym_RBRACE] = ACTIONS(1587),
    [anon_sym_typeof] = ACTIONS(1585),
    [anon_sym_import] = ACTIONS(1585),
    [anon_sym_from] = ACTIONS(1585),
    [anon_sym_var] = ACTIONS(1585),
    [anon_sym_let] = ACTIONS(1585),
    [anon_sym_const] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_else] = ACTIONS(1585),
    [anon_sym_if] = ACTIONS(1585),
    [anon_sym_switch] = ACTIONS(1585),
    [anon_sym_for] = ACTIONS(1585),
    [anon_sym_LPAREN] = ACTIONS(1587),
    [anon_sym_await] = ACTIONS(1585),
    [anon_sym_of] = ACTIONS(1585),
    [anon_sym_while] = ACTIONS(1585),
    [anon_sym_do] = ACTIONS(1585),
    [anon_sym_try] = ACTIONS(1585),
    [anon_sym_with] = ACTIONS(1585),
    [anon_sym_break] = ACTIONS(1585),
    [anon_sym_continue] = ACTIONS(1585),
    [anon_sym_debugger] = ACTIONS(1585),
    [anon_sym_return] = ACTIONS(1585),
    [anon_sym_throw] = ACTIONS(1585),
    [anon_sym_SEMI] = ACTIONS(1587),
    [anon_sym_case] = ACTIONS(1585),
    [anon_sym_yield] = ACTIONS(1585),
    [anon_sym_LBRACK] = ACTIONS(1587),
    [anon_sym_LTtemplate_GT] = ACTIONS(1587),
    [anon_sym_LT] = ACTIONS(1585),
    [anon_sym_SLASH] = ACTIONS(1585),
    [anon_sym_class] = ACTIONS(1585),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_function] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_TILDE] = ACTIONS(1587),
    [anon_sym_void] = ACTIONS(1585),
    [anon_sym_delete] = ACTIONS(1585),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [anon_sym_DQUOTE] = ACTIONS(1587),
    [anon_sym_SQUOTE] = ACTIONS(1587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1587),
    [sym_number] = ACTIONS(1587),
    [sym_this] = ACTIONS(1585),
    [sym_super] = ACTIONS(1585),
    [sym_true] = ACTIONS(1585),
    [sym_false] = ACTIONS(1585),
    [sym_null] = ACTIONS(1585),
    [sym_undefined] = ACTIONS(1585),
    [anon_sym_AT] = ACTIONS(1587),
    [anon_sym_static] = ACTIONS(1585),
    [anon_sym_readonly] = ACTIONS(1585),
    [anon_sym_get] = ACTIONS(1585),
    [anon_sym_set] = ACTIONS(1585),
    [anon_sym_declare] = ACTIONS(1585),
    [anon_sym_public] = ACTIONS(1585),
    [anon_sym_private] = ACTIONS(1585),
    [anon_sym_protected] = ACTIONS(1585),
    [anon_sym_override] = ACTIONS(1585),
    [anon_sym_module] = ACTIONS(1585),
    [anon_sym_any] = ACTIONS(1585),
    [anon_sym_number] = ACTIONS(1585),
    [anon_sym_boolean] = ACTIONS(1585),
    [anon_sym_string] = ACTIONS(1585),
    [anon_sym_symbol] = ACTIONS(1585),
    [anon_sym_property] = ACTIONS(1585),
    [anon_sym_signal] = ACTIONS(1585),
    [anon_sym_on] = ACTIONS(1585),
    [anon_sym_required] = ACTIONS(1585),
    [anon_sym_component] = ACTIONS(1585),
    [anon_sym_abstract] = ACTIONS(1585),
    [anon_sym_interface] = ACTIONS(1585),
    [anon_sym_enum] = ACTIONS(1585),
  },
  [711] = {
    [sym_identifier] = ACTIONS(2374),
    [anon_sym_export] = ACTIONS(2374),
    [anon_sym_default] = ACTIONS(2374),
    [anon_sym_type] = ACTIONS(2374),
    [anon_sym_namespace] = ACTIONS(2374),
    [anon_sym_LBRACE] = ACTIONS(2376),
    [anon_sym_RBRACE] = ACTIONS(2376),
    [anon_sym_typeof] = ACTIONS(2374),
    [anon_sym_import] = ACTIONS(2374),
    [anon_sym_from] = ACTIONS(2374),
    [anon_sym_var] = ACTIONS(2374),
    [anon_sym_let] = ACTIONS(2374),
    [anon_sym_const] = ACTIONS(2374),
    [anon_sym_BANG] = ACTIONS(2376),
    [anon_sym_else] = ACTIONS(2374),
    [anon_sym_if] = ACTIONS(2374),
    [anon_sym_switch] = ACTIONS(2374),
    [anon_sym_for] = ACTIONS(2374),
    [anon_sym_LPAREN] = ACTIONS(2376),
    [anon_sym_await] = ACTIONS(2374),
    [anon_sym_of] = ACTIONS(2374),
    [anon_sym_while] = ACTIONS(2374),
    [anon_sym_do] = ACTIONS(2374),
    [anon_sym_try] = ACTIONS(2374),
    [anon_sym_with] = ACTIONS(2374),
    [anon_sym_break] = ACTIONS(2374),
    [anon_sym_continue] = ACTIONS(2374),
    [anon_sym_debugger] = ACTIONS(2374),
    [anon_sym_return] = ACTIONS(2374),
    [anon_sym_throw] = ACTIONS(2374),
    [anon_sym_SEMI] = ACTIONS(2376),
    [anon_sym_case] = ACTIONS(2374),
    [anon_sym_yield] = ACTIONS(2374),
    [anon_sym_LBRACK] = ACTIONS(2376),
    [anon_sym_LTtemplate_GT] = ACTIONS(2376),
    [anon_sym_LT] = ACTIONS(2374),
    [anon_sym_SLASH] = ACTIONS(2374),
    [anon_sym_class] = ACTIONS(2374),
    [anon_sym_async] = ACTIONS(2374),
    [anon_sym_function] = ACTIONS(2374),
    [anon_sym_new] = ACTIONS(2374),
    [anon_sym_PLUS] = ACTIONS(2374),
    [anon_sym_DASH] = ACTIONS(2374),
    [anon_sym_TILDE] = ACTIONS(2376),
    [anon_sym_void] = ACTIONS(2374),
    [anon_sym_delete] = ACTIONS(2374),
    [anon_sym_PLUS_PLUS] = ACTIONS(2376),
    [anon_sym_DASH_DASH] = ACTIONS(2376),
    [anon_sym_DQUOTE] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2376),
    [sym_number] = ACTIONS(2376),
    [sym_this] = ACTIONS(2374),
    [sym_super] = ACTIONS(2374),
    [sym_true] = ACTIONS(2374),
    [sym_false] = ACTIONS(2374),
    [sym_null] = ACTIONS(2374),
    [sym_undefined] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2374),
    [anon_sym_readonly] = ACTIONS(2374),
    [anon_sym_get] = ACTIONS(2374),
    [anon_sym_set] = ACTIONS(2374),
    [anon_sym_declare] = ACTIONS(2374),
    [anon_sym_public] = ACTIONS(2374),
    [anon_sym_private] = ACTIONS(2374),
    [anon_sym_protected] = ACTIONS(2374),
    [anon_sym_override] = ACTIONS(2374),
    [anon_sym_module] = ACTIONS(2374),
    [anon_sym_any] = ACTIONS(2374),
    [anon_sym_number] = ACTIONS(2374),
    [anon_sym_boolean] = ACTIONS(2374),
    [anon_sym_string] = ACTIONS(2374),
    [anon_sym_symbol] = ACTIONS(2374),
    [anon_sym_property] = ACTIONS(2374),
    [anon_sym_signal] = ACTIONS(2374),
    [anon_sym_on] = ACTIONS(2374),
    [anon_sym_required] = ACTIONS(2374),
    [anon_sym_component] = ACTIONS(2374),
    [anon_sym_abstract] = ACTIONS(2374),
    [anon_sym_interface] = ACTIONS(2374),
    [anon_sym_enum] = ACTIONS(2374),
  },
  [712] = {
    [sym_identifier] = ACTIONS(2366),
    [anon_sym_export] = ACTIONS(2366),
    [anon_sym_default] = ACTIONS(2366),
    [anon_sym_type] = ACTIONS(2366),
    [anon_sym_namespace] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2368),
    [anon_sym_RBRACE] = ACTIONS(2368),
    [anon_sym_typeof] = ACTIONS(2366),
    [anon_sym_import] = ACTIONS(2366),
    [anon_sym_from] = ACTIONS(2366),
    [anon_sym_var] = ACTIONS(2366),
    [anon_sym_let] = ACTIONS(2366),
    [anon_sym_const] = ACTIONS(2366),
    [anon_sym_BANG] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2366),
    [anon_sym_if] = ACTIONS(2366),
    [anon_sym_switch] = ACTIONS(2366),
    [anon_sym_for] = ACTIONS(2366),
    [anon_sym_LPAREN] = ACTIONS(2368),
    [anon_sym_await] = ACTIONS(2366),
    [anon_sym_of] = ACTIONS(2366),
    [anon_sym_while] = ACTIONS(2366),
    [anon_sym_do] = ACTIONS(2366),
    [anon_sym_try] = ACTIONS(2366),
    [anon_sym_with] = ACTIONS(2366),
    [anon_sym_break] = ACTIONS(2366),
    [anon_sym_continue] = ACTIONS(2366),
    [anon_sym_debugger] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2366),
    [anon_sym_throw] = ACTIONS(2366),
    [anon_sym_SEMI] = ACTIONS(2368),
    [anon_sym_case] = ACTIONS(2366),
    [anon_sym_yield] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_LTtemplate_GT] = ACTIONS(2368),
    [anon_sym_LT] = ACTIONS(2366),
    [anon_sym_SLASH] = ACTIONS(2366),
    [anon_sym_class] = ACTIONS(2366),
    [anon_sym_async] = ACTIONS(2366),
    [anon_sym_function] = ACTIONS(2366),
    [anon_sym_new] = ACTIONS(2366),
    [anon_sym_PLUS] = ACTIONS(2366),
    [anon_sym_DASH] = ACTIONS(2366),
    [anon_sym_TILDE] = ACTIONS(2368),
    [anon_sym_void] = ACTIONS(2366),
    [anon_sym_delete] = ACTIONS(2366),
    [anon_sym_PLUS_PLUS] = ACTIONS(2368),
    [anon_sym_DASH_DASH] = ACTIONS(2368),
    [anon_sym_DQUOTE] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2368),
    [sym_number] = ACTIONS(2368),
    [sym_this] = ACTIONS(2366),
    [sym_super] = ACTIONS(2366),
    [sym_true] = ACTIONS(2366),
    [sym_false] = ACTIONS(2366),
    [sym_null] = ACTIONS(2366),
    [sym_undefined] = ACTIONS(2366),
    [anon_sym_AT] = ACTIONS(2368),
    [anon_sym_static] = ACTIONS(2366),
    [anon_sym_readonly] = ACTIONS(2366),
    [anon_sym_get] = ACTIONS(2366),
    [anon_sym_set] = ACTIONS(2366),
    [anon_sym_declare] = ACTIONS(2366),
    [anon_sym_public] = ACTIONS(2366),
    [anon_sym_private] = ACTIONS(2366),
    [anon_sym_protected] = ACTIONS(2366),
    [anon_sym_override] = ACTIONS(2366),
    [anon_sym_module] = ACTIONS(2366),
    [anon_sym_any] = ACTIONS(2366),
    [anon_sym_number] = ACTIONS(2366),
    [anon_sym_boolean] = ACTIONS(2366),
    [anon_sym_string] = ACTIONS(2366),
    [anon_sym_symbol] = ACTIONS(2366),
    [anon_sym_property] = ACTIONS(2366),
    [anon_sym_signal] = ACTIONS(2366),
    [anon_sym_on] = ACTIONS(2366),
    [anon_sym_required] = ACTIONS(2366),
    [anon_sym_component] = ACTIONS(2366),
    [anon_sym_abstract] = ACTIONS(2366),
    [anon_sym_interface] = ACTIONS(2366),
    [anon_sym_enum] = ACTIONS(2366),
  },
  [713] = {
    [sym_identifier] = ACTIONS(2378),
    [anon_sym_export] = ACTIONS(2378),
    [anon_sym_default] = ACTIONS(2378),
    [anon_sym_type] = ACTIONS(2378),
    [anon_sym_namespace] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2380),
    [anon_sym_RBRACE] = ACTIONS(2380),
    [anon_sym_typeof] = ACTIONS(2378),
    [anon_sym_import] = ACTIONS(2378),
    [anon_sym_from] = ACTIONS(2378),
    [anon_sym_var] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(2378),
    [anon_sym_const] = ACTIONS(2378),
    [anon_sym_BANG] = ACTIONS(2380),
    [anon_sym_else] = ACTIONS(2378),
    [anon_sym_if] = ACTIONS(2378),
    [anon_sym_switch] = ACTIONS(2378),
    [anon_sym_for] = ACTIONS(2378),
    [anon_sym_LPAREN] = ACTIONS(2380),
    [anon_sym_await] = ACTIONS(2378),
    [anon_sym_of] = ACTIONS(2378),
    [anon_sym_while] = ACTIONS(2378),
    [anon_sym_do] = ACTIONS(2378),
    [anon_sym_try] = ACTIONS(2378),
    [anon_sym_with] = ACTIONS(2378),
    [anon_sym_break] = ACTIONS(2378),
    [anon_sym_continue] = ACTIONS(2378),
    [anon_sym_debugger] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2378),
    [anon_sym_throw] = ACTIONS(2378),
    [anon_sym_SEMI] = ACTIONS(2380),
    [anon_sym_case] = ACTIONS(2378),
    [anon_sym_yield] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2380),
    [anon_sym_LTtemplate_GT] = ACTIONS(2380),
    [anon_sym_LT] = ACTIONS(2378),
    [anon_sym_SLASH] = ACTIONS(2378),
    [anon_sym_class] = ACTIONS(2378),
    [anon_sym_async] = ACTIONS(2378),
    [anon_sym_function] = ACTIONS(2378),
    [anon_sym_new] = ACTIONS(2378),
    [anon_sym_PLUS] = ACTIONS(2378),
    [anon_sym_DASH] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2380),
    [anon_sym_void] = ACTIONS(2378),
    [anon_sym_delete] = ACTIONS(2378),
    [anon_sym_PLUS_PLUS] = ACTIONS(2380),
    [anon_sym_DASH_DASH] = ACTIONS(2380),
    [anon_sym_DQUOTE] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2380),
    [sym_number] = ACTIONS(2380),
    [sym_this] = ACTIONS(2378),
    [sym_super] = ACTIONS(2378),
    [sym_true] = ACTIONS(2378),
    [sym_false] = ACTIONS(2378),
    [sym_null] = ACTIONS(2378),
    [sym_undefined] = ACTIONS(2378),
    [anon_sym_AT] = ACTIONS(2380),
    [anon_sym_static] = ACTIONS(2378),
    [anon_sym_readonly] = ACTIONS(2378),
    [anon_sym_get] = ACTIONS(2378),
    [anon_sym_set] = ACTIONS(2378),
    [anon_sym_declare] = ACTIONS(2378),
    [anon_sym_public] = ACTIONS(2378),
    [anon_sym_private] = ACTIONS(2378),
    [anon_sym_protected] = ACTIONS(2378),
    [anon_sym_override] = ACTIONS(2378),
    [anon_sym_module] = ACTIONS(2378),
    [anon_sym_any] = ACTIONS(2378),
    [anon_sym_number] = ACTIONS(2378),
    [anon_sym_boolean] = ACTIONS(2378),
    [anon_sym_string] = ACTIONS(2378),
    [anon_sym_symbol] = ACTIONS(2378),
    [anon_sym_property] = ACTIONS(2378),
    [anon_sym_signal] = ACTIONS(2378),
    [anon_sym_on] = ACTIONS(2378),
    [anon_sym_required] = ACTIONS(2378),
    [anon_sym_component] = ACTIONS(2378),
    [anon_sym_abstract] = ACTIONS(2378),
    [anon_sym_interface] = ACTIONS(2378),
    [anon_sym_enum] = ACTIONS(2378),
  },
  [714] = {
    [sym_identifier] = ACTIONS(2382),
    [anon_sym_export] = ACTIONS(2382),
    [anon_sym_default] = ACTIONS(2382),
    [anon_sym_type] = ACTIONS(2382),
    [anon_sym_namespace] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(2384),
    [anon_sym_RBRACE] = ACTIONS(2384),
    [anon_sym_typeof] = ACTIONS(2382),
    [anon_sym_import] = ACTIONS(2382),
    [anon_sym_from] = ACTIONS(2382),
    [anon_sym_var] = ACTIONS(2382),
    [anon_sym_let] = ACTIONS(2382),
    [anon_sym_const] = ACTIONS(2382),
    [anon_sym_BANG] = ACTIONS(2384),
    [anon_sym_else] = ACTIONS(2382),
    [anon_sym_if] = ACTIONS(2382),
    [anon_sym_switch] = ACTIONS(2382),
    [anon_sym_for] = ACTIONS(2382),
    [anon_sym_LPAREN] = ACTIONS(2384),
    [anon_sym_await] = ACTIONS(2382),
    [anon_sym_of] = ACTIONS(2382),
    [anon_sym_while] = ACTIONS(2382),
    [anon_sym_do] = ACTIONS(2382),
    [anon_sym_try] = ACTIONS(2382),
    [anon_sym_with] = ACTIONS(2382),
    [anon_sym_break] = ACTIONS(2382),
    [anon_sym_continue] = ACTIONS(2382),
    [anon_sym_debugger] = ACTIONS(2382),
    [anon_sym_return] = ACTIONS(2382),
    [anon_sym_throw] = ACTIONS(2382),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_yield] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2384),
    [anon_sym_LTtemplate_GT] = ACTIONS(2384),
    [anon_sym_LT] = ACTIONS(2382),
    [anon_sym_SLASH] = ACTIONS(2382),
    [anon_sym_class] = ACTIONS(2382),
    [anon_sym_async] = ACTIONS(2382),
    [anon_sym_function] = ACTIONS(2382),
    [anon_sym_new] = ACTIONS(2382),
    [anon_sym_PLUS] = ACTIONS(2382),
    [anon_sym_DASH] = ACTIONS(2382),
    [anon_sym_TILDE] = ACTIONS(2384),
    [anon_sym_void] = ACTIONS(2382),
    [anon_sym_delete] = ACTIONS(2382),
    [anon_sym_PLUS_PLUS] = ACTIONS(2384),
    [anon_sym_DASH_DASH] = ACTIONS(2384),
    [anon_sym_DQUOTE] = ACTIONS(2384),
    [anon_sym_SQUOTE] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2384),
    [sym_number] = ACTIONS(2384),
    [sym_this] = ACTIONS(2382),
    [sym_super] = ACTIONS(2382),
    [sym_true] = ACTIONS(2382),
    [sym_false] = ACTIONS(2382),
    [sym_null] = ACTIONS(2382),
    [sym_undefined] = ACTIONS(2382),
    [anon_sym_AT] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2382),
    [anon_sym_readonly] = ACTIONS(2382),
    [anon_sym_get] = ACTIONS(2382),
    [anon_sym_set] = ACTIONS(2382),
    [anon_sym_declare] = ACTIONS(2382),
    [anon_sym_public] = ACTIONS(2382),
    [anon_sym_private] = ACTIONS(2382),
    [anon_sym_protected] = ACTIONS(2382),
    [anon_sym_override] = ACTIONS(2382),
    [anon_sym_module] = ACTIONS(2382),
    [anon_sym_any] = ACTIONS(2382),
    [anon_sym_number] = ACTIONS(2382),
    [anon_sym_boolean] = ACTIONS(2382),
    [anon_sym_string] = ACTIONS(2382),
    [anon_sym_symbol] = ACTIONS(2382),
    [anon_sym_property] = ACTIONS(2382),
    [anon_sym_signal] = ACTIONS(2382),
    [anon_sym_on] = ACTIONS(2382),
    [anon_sym_required] = ACTIONS(2382),
    [anon_sym_component] = ACTIONS(2382),
    [anon_sym_abstract] = ACTIONS(2382),
    [anon_sym_interface] = ACTIONS(2382),
    [anon_sym_enum] = ACTIONS(2382),
  },
  [715] = {
    [sym_identifier] = ACTIONS(2386),
    [anon_sym_export] = ACTIONS(2386),
    [anon_sym_default] = ACTIONS(2386),
    [anon_sym_type] = ACTIONS(2386),
    [anon_sym_namespace] = ACTIONS(2386),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_typeof] = ACTIONS(2386),
    [anon_sym_import] = ACTIONS(2386),
    [anon_sym_from] = ACTIONS(2386),
    [anon_sym_var] = ACTIONS(2386),
    [anon_sym_let] = ACTIONS(2386),
    [anon_sym_const] = ACTIONS(2386),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_else] = ACTIONS(2386),
    [anon_sym_if] = ACTIONS(2386),
    [anon_sym_switch] = ACTIONS(2386),
    [anon_sym_for] = ACTIONS(2386),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_await] = ACTIONS(2386),
    [anon_sym_of] = ACTIONS(2386),
    [anon_sym_while] = ACTIONS(2386),
    [anon_sym_do] = ACTIONS(2386),
    [anon_sym_try] = ACTIONS(2386),
    [anon_sym_with] = ACTIONS(2386),
    [anon_sym_break] = ACTIONS(2386),
    [anon_sym_continue] = ACTIONS(2386),
    [anon_sym_debugger] = ACTIONS(2386),
    [anon_sym_return] = ACTIONS(2386),
    [anon_sym_throw] = ACTIONS(2386),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym_case] = ACTIONS(2386),
    [anon_sym_yield] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_LTtemplate_GT] = ACTIONS(2388),
    [anon_sym_LT] = ACTIONS(2386),
    [anon_sym_SLASH] = ACTIONS(2386),
    [anon_sym_class] = ACTIONS(2386),
    [anon_sym_async] = ACTIONS(2386),
    [anon_sym_function] = ACTIONS(2386),
    [anon_sym_new] = ACTIONS(2386),
    [anon_sym_PLUS] = ACTIONS(2386),
    [anon_sym_DASH] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2388),
    [anon_sym_void] = ACTIONS(2386),
    [anon_sym_delete] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [anon_sym_DQUOTE] = ACTIONS(2388),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2388),
    [sym_number] = ACTIONS(2388),
    [sym_this] = ACTIONS(2386),
    [sym_super] = ACTIONS(2386),
    [sym_true] = ACTIONS(2386),
    [sym_false] = ACTIONS(2386),
    [sym_null] = ACTIONS(2386),
    [sym_undefined] = ACTIONS(2386),
    [anon_sym_AT] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2386),
    [anon_sym_readonly] = ACTIONS(2386),
    [anon_sym_get] = ACTIONS(2386),
    [anon_sym_set] = ACTIONS(2386),
    [anon_sym_declare] = ACTIONS(2386),
    [anon_sym_public] = ACTIONS(2386),
    [anon_sym_private] = ACTIONS(2386),
    [anon_sym_protected] = ACTIONS(2386),
    [anon_sym_override] = ACTIONS(2386),
    [anon_sym_module] = ACTIONS(2386),
    [anon_sym_any] = ACTIONS(2386),
    [anon_sym_number] = ACTIONS(2386),
    [anon_sym_boolean] = ACTIONS(2386),
    [anon_sym_string] = ACTIONS(2386),
    [anon_sym_symbol] = ACTIONS(2386),
    [anon_sym_property] = ACTIONS(2386),
    [anon_sym_signal] = ACTIONS(2386),
    [anon_sym_on] = ACTIONS(2386),
    [anon_sym_required] = ACTIONS(2386),
    [anon_sym_component] = ACTIONS(2386),
    [anon_sym_abstract] = ACTIONS(2386),
    [anon_sym_interface] = ACTIONS(2386),
    [anon_sym_enum] = ACTIONS(2386),
  },
  [716] = {
    [sym_identifier] = ACTIONS(2390),
    [anon_sym_export] = ACTIONS(2390),
    [anon_sym_default] = ACTIONS(2390),
    [anon_sym_type] = ACTIONS(2390),
    [anon_sym_namespace] = ACTIONS(2390),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_typeof] = ACTIONS(2390),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_from] = ACTIONS(2390),
    [anon_sym_var] = ACTIONS(2390),
    [anon_sym_let] = ACTIONS(2390),
    [anon_sym_const] = ACTIONS(2390),
    [anon_sym_BANG] = ACTIONS(2392),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_switch] = ACTIONS(2390),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_await] = ACTIONS(2390),
    [anon_sym_of] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_do] = ACTIONS(2390),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_with] = ACTIONS(2390),
    [anon_sym_break] = ACTIONS(2390),
    [anon_sym_continue] = ACTIONS(2390),
    [anon_sym_debugger] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_throw] = ACTIONS(2390),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym_case] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_LTtemplate_GT] = ACTIONS(2392),
    [anon_sym_LT] = ACTIONS(2390),
    [anon_sym_SLASH] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_function] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2392),
    [anon_sym_void] = ACTIONS(2390),
    [anon_sym_delete] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [anon_sym_DQUOTE] = ACTIONS(2392),
    [anon_sym_SQUOTE] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2392),
    [sym_number] = ACTIONS(2392),
    [sym_this] = ACTIONS(2390),
    [sym_super] = ACTIONS(2390),
    [sym_true] = ACTIONS(2390),
    [sym_false] = ACTIONS(2390),
    [sym_null] = ACTIONS(2390),
    [sym_undefined] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2390),
    [anon_sym_readonly] = ACTIONS(2390),
    [anon_sym_get] = ACTIONS(2390),
    [anon_sym_set] = ACTIONS(2390),
    [anon_sym_declare] = ACTIONS(2390),
    [anon_sym_public] = ACTIONS(2390),
    [anon_sym_private] = ACTIONS(2390),
    [anon_sym_protected] = ACTIONS(2390),
    [anon_sym_override] = ACTIONS(2390),
    [anon_sym_module] = ACTIONS(2390),
    [anon_sym_any] = ACTIONS(2390),
    [anon_sym_number] = ACTIONS(2390),
    [anon_sym_boolean] = ACTIONS(2390),
    [anon_sym_string] = ACTIONS(2390),
    [anon_sym_symbol] = ACTIONS(2390),
    [anon_sym_property] = ACTIONS(2390),
    [anon_sym_signal] = ACTIONS(2390),
    [anon_sym_on] = ACTIONS(2390),
    [anon_sym_required] = ACTIONS(2390),
    [anon_sym_component] = ACTIONS(2390),
    [anon_sym_abstract] = ACTIONS(2390),
    [anon_sym_interface] = ACTIONS(2390),
    [anon_sym_enum] = ACTIONS(2390),
  },
  [717] = {
    [sym_identifier] = ACTIONS(2394),
    [anon_sym_export] = ACTIONS(2394),
    [anon_sym_default] = ACTIONS(2394),
    [anon_sym_type] = ACTIONS(2394),
    [anon_sym_namespace] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2396),
    [anon_sym_RBRACE] = ACTIONS(2396),
    [anon_sym_typeof] = ACTIONS(2394),
    [anon_sym_import] = ACTIONS(2394),
    [anon_sym_from] = ACTIONS(2394),
    [anon_sym_var] = ACTIONS(2394),
    [anon_sym_let] = ACTIONS(2394),
    [anon_sym_const] = ACTIONS(2394),
    [anon_sym_BANG] = ACTIONS(2396),
    [anon_sym_else] = ACTIONS(2394),
    [anon_sym_if] = ACTIONS(2394),
    [anon_sym_switch] = ACTIONS(2394),
    [anon_sym_for] = ACTIONS(2394),
    [anon_sym_LPAREN] = ACTIONS(2396),
    [anon_sym_await] = ACTIONS(2394),
    [anon_sym_of] = ACTIONS(2394),
    [anon_sym_while] = ACTIONS(2394),
    [anon_sym_do] = ACTIONS(2394),
    [anon_sym_try] = ACTIONS(2394),
    [anon_sym_with] = ACTIONS(2394),
    [anon_sym_break] = ACTIONS(2394),
    [anon_sym_continue] = ACTIONS(2394),
    [anon_sym_debugger] = ACTIONS(2394),
    [anon_sym_return] = ACTIONS(2394),
    [anon_sym_throw] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2396),
    [anon_sym_case] = ACTIONS(2394),
    [anon_sym_yield] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2396),
    [anon_sym_LTtemplate_GT] = ACTIONS(2396),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2394),
    [anon_sym_class] = ACTIONS(2394),
    [anon_sym_async] = ACTIONS(2394),
    [anon_sym_function] = ACTIONS(2394),
    [anon_sym_new] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_TILDE] = ACTIONS(2396),
    [anon_sym_void] = ACTIONS(2394),
    [anon_sym_delete] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2396),
    [anon_sym_DASH_DASH] = ACTIONS(2396),
    [anon_sym_DQUOTE] = ACTIONS(2396),
    [anon_sym_SQUOTE] = ACTIONS(2396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2396),
    [sym_number] = ACTIONS(2396),
    [sym_this] = ACTIONS(2394),
    [sym_super] = ACTIONS(2394),
    [sym_true] = ACTIONS(2394),
    [sym_false] = ACTIONS(2394),
    [sym_null] = ACTIONS(2394),
    [sym_undefined] = ACTIONS(2394),
    [anon_sym_AT] = ACTIONS(2396),
    [anon_sym_static] = ACTIONS(2394),
    [anon_sym_readonly] = ACTIONS(2394),
    [anon_sym_get] = ACTIONS(2394),
    [anon_sym_set] = ACTIONS(2394),
    [anon_sym_declare] = ACTIONS(2394),
    [anon_sym_public] = ACTIONS(2394),
    [anon_sym_private] = ACTIONS(2394),
    [anon_sym_protected] = ACTIONS(2394),
    [anon_sym_override] = ACTIONS(2394),
    [anon_sym_module] = ACTIONS(2394),
    [anon_sym_any] = ACTIONS(2394),
    [anon_sym_number] = ACTIONS(2394),
    [anon_sym_boolean] = ACTIONS(2394),
    [anon_sym_string] = ACTIONS(2394),
    [anon_sym_symbol] = ACTIONS(2394),
    [anon_sym_property] = ACTIONS(2394),
    [anon_sym_signal] = ACTIONS(2394),
    [anon_sym_on] = ACTIONS(2394),
    [anon_sym_required] = ACTIONS(2394),
    [anon_sym_component] = ACTIONS(2394),
    [anon_sym_abstract] = ACTIONS(2394),
    [anon_sym_interface] = ACTIONS(2394),
    [anon_sym_enum] = ACTIONS(2394),
  },
  [718] = {
    [sym_identifier] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_default] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1611),
    [anon_sym_RBRACE] = ACTIONS(1611),
    [anon_sym_typeof] = ACTIONS(1609),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_from] = ACTIONS(1609),
    [anon_sym_var] = ACTIONS(1609),
    [anon_sym_let] = ACTIONS(1609),
    [anon_sym_const] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1611),
    [anon_sym_else] = ACTIONS(1609),
    [anon_sym_if] = ACTIONS(1609),
    [anon_sym_switch] = ACTIONS(1609),
    [anon_sym_for] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1611),
    [anon_sym_await] = ACTIONS(1609),
    [anon_sym_of] = ACTIONS(1609),
    [anon_sym_while] = ACTIONS(1609),
    [anon_sym_do] = ACTIONS(1609),
    [anon_sym_try] = ACTIONS(1609),
    [anon_sym_with] = ACTIONS(1609),
    [anon_sym_break] = ACTIONS(1609),
    [anon_sym_continue] = ACTIONS(1609),
    [anon_sym_debugger] = ACTIONS(1609),
    [anon_sym_return] = ACTIONS(1609),
    [anon_sym_throw] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1611),
    [anon_sym_case] = ACTIONS(1609),
    [anon_sym_yield] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1611),
    [anon_sym_LTtemplate_GT] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1609),
    [anon_sym_class] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(1609),
    [anon_sym_new] = ACTIONS(1609),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_TILDE] = ACTIONS(1611),
    [anon_sym_void] = ACTIONS(1609),
    [anon_sym_delete] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1611),
    [sym_number] = ACTIONS(1611),
    [sym_this] = ACTIONS(1609),
    [sym_super] = ACTIONS(1609),
    [sym_true] = ACTIONS(1609),
    [sym_false] = ACTIONS(1609),
    [sym_null] = ACTIONS(1609),
    [sym_undefined] = ACTIONS(1609),
    [anon_sym_AT] = ACTIONS(1611),
    [anon_sym_static] = ACTIONS(1609),
    [anon_sym_readonly] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_override] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_property] = ACTIONS(1609),
    [anon_sym_signal] = ACTIONS(1609),
    [anon_sym_on] = ACTIONS(1609),
    [anon_sym_required] = ACTIONS(1609),
    [anon_sym_component] = ACTIONS(1609),
    [anon_sym_abstract] = ACTIONS(1609),
    [anon_sym_interface] = ACTIONS(1609),
    [anon_sym_enum] = ACTIONS(1609),
  },
  [719] = {
    [sym_identifier] = ACTIONS(2398),
    [anon_sym_export] = ACTIONS(2398),
    [anon_sym_default] = ACTIONS(2398),
    [anon_sym_type] = ACTIONS(2398),
    [anon_sym_namespace] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_typeof] = ACTIONS(2398),
    [anon_sym_import] = ACTIONS(2398),
    [anon_sym_from] = ACTIONS(2398),
    [anon_sym_var] = ACTIONS(2398),
    [anon_sym_let] = ACTIONS(2398),
    [anon_sym_const] = ACTIONS(2398),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_else] = ACTIONS(2398),
    [anon_sym_if] = ACTIONS(2398),
    [anon_sym_switch] = ACTIONS(2398),
    [anon_sym_for] = ACTIONS(2398),
    [anon_sym_LPAREN] = ACTIONS(2400),
    [anon_sym_await] = ACTIONS(2398),
    [anon_sym_of] = ACTIONS(2398),
    [anon_sym_while] = ACTIONS(2398),
    [anon_sym_do] = ACTIONS(2398),
    [anon_sym_try] = ACTIONS(2398),
    [anon_sym_with] = ACTIONS(2398),
    [anon_sym_break] = ACTIONS(2398),
    [anon_sym_continue] = ACTIONS(2398),
    [anon_sym_debugger] = ACTIONS(2398),
    [anon_sym_return] = ACTIONS(2398),
    [anon_sym_throw] = ACTIONS(2398),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_case] = ACTIONS(2398),
    [anon_sym_yield] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_LTtemplate_GT] = ACTIONS(2400),
    [anon_sym_LT] = ACTIONS(2398),
    [anon_sym_SLASH] = ACTIONS(2398),
    [anon_sym_class] = ACTIONS(2398),
    [anon_sym_async] = ACTIONS(2398),
    [anon_sym_function] = ACTIONS(2398),
    [anon_sym_new] = ACTIONS(2398),
    [anon_sym_PLUS] = ACTIONS(2398),
    [anon_sym_DASH] = ACTIONS(2398),
    [anon_sym_TILDE] = ACTIONS(2400),
    [anon_sym_void] = ACTIONS(2398),
    [anon_sym_delete] = ACTIONS(2398),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [anon_sym_DQUOTE] = ACTIONS(2400),
    [anon_sym_SQUOTE] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2400),
    [sym_number] = ACTIONS(2400),
    [sym_this] = ACTIONS(2398),
    [sym_super] = ACTIONS(2398),
    [sym_true] = ACTIONS(2398),
    [sym_false] = ACTIONS(2398),
    [sym_null] = ACTIONS(2398),
    [sym_undefined] = ACTIONS(2398),
    [anon_sym_AT] = ACTIONS(2400),
    [anon_sym_static] = ACTIONS(2398),
    [anon_sym_readonly] = ACTIONS(2398),
    [anon_sym_get] = ACTIONS(2398),
    [anon_sym_set] = ACTIONS(2398),
    [anon_sym_declare] = ACTIONS(2398),
    [anon_sym_public] = ACTIONS(2398),
    [anon_sym_private] = ACTIONS(2398),
    [anon_sym_protected] = ACTIONS(2398),
    [anon_sym_override] = ACTIONS(2398),
    [anon_sym_module] = ACTIONS(2398),
    [anon_sym_any] = ACTIONS(2398),
    [anon_sym_number] = ACTIONS(2398),
    [anon_sym_boolean] = ACTIONS(2398),
    [anon_sym_string] = ACTIONS(2398),
    [anon_sym_symbol] = ACTIONS(2398),
    [anon_sym_property] = ACTIONS(2398),
    [anon_sym_signal] = ACTIONS(2398),
    [anon_sym_on] = ACTIONS(2398),
    [anon_sym_required] = ACTIONS(2398),
    [anon_sym_component] = ACTIONS(2398),
    [anon_sym_abstract] = ACTIONS(2398),
    [anon_sym_interface] = ACTIONS(2398),
    [anon_sym_enum] = ACTIONS(2398),
  },
  [720] = {
    [sym_identifier] = ACTIONS(2402),
    [anon_sym_export] = ACTIONS(2402),
    [anon_sym_default] = ACTIONS(2402),
    [anon_sym_type] = ACTIONS(2402),
    [anon_sym_namespace] = ACTIONS(2402),
    [anon_sym_LBRACE] = ACTIONS(2404),
    [anon_sym_RBRACE] = ACTIONS(2404),
    [anon_sym_typeof] = ACTIONS(2402),
    [anon_sym_import] = ACTIONS(2402),
    [anon_sym_from] = ACTIONS(2402),
    [anon_sym_var] = ACTIONS(2402),
    [anon_sym_let] = ACTIONS(2402),
    [anon_sym_const] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2404),
    [anon_sym_else] = ACTIONS(2402),
    [anon_sym_if] = ACTIONS(2402),
    [anon_sym_switch] = ACTIONS(2402),
    [anon_sym_for] = ACTIONS(2402),
    [anon_sym_LPAREN] = ACTIONS(2404),
    [anon_sym_await] = ACTIONS(2402),
    [anon_sym_of] = ACTIONS(2402),
    [anon_sym_while] = ACTIONS(2402),
    [anon_sym_do] = ACTIONS(2402),
    [anon_sym_try] = ACTIONS(2402),
    [anon_sym_with] = ACTIONS(2402),
    [anon_sym_break] = ACTIONS(2402),
    [anon_sym_continue] = ACTIONS(2402),
    [anon_sym_debugger] = ACTIONS(2402),
    [anon_sym_return] = ACTIONS(2402),
    [anon_sym_throw] = ACTIONS(2402),
    [anon_sym_SEMI] = ACTIONS(2404),
    [anon_sym_case] = ACTIONS(2402),
    [anon_sym_yield] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_LTtemplate_GT] = ACTIONS(2404),
    [anon_sym_LT] = ACTIONS(2402),
    [anon_sym_SLASH] = ACTIONS(2402),
    [anon_sym_class] = ACTIONS(2402),
    [anon_sym_async] = ACTIONS(2402),
    [anon_sym_function] = ACTIONS(2402),
    [anon_sym_new] = ACTIONS(2402),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2402),
    [anon_sym_TILDE] = ACTIONS(2404),
    [anon_sym_void] = ACTIONS(2402),
    [anon_sym_delete] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2404),
    [anon_sym_DQUOTE] = ACTIONS(2404),
    [anon_sym_SQUOTE] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2404),
    [sym_number] = ACTIONS(2404),
    [sym_this] = ACTIONS(2402),
    [sym_super] = ACTIONS(2402),
    [sym_true] = ACTIONS(2402),
    [sym_false] = ACTIONS(2402),
    [sym_null] = ACTIONS(2402),
    [sym_undefined] = ACTIONS(2402),
    [anon_sym_AT] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2402),
    [anon_sym_readonly] = ACTIONS(2402),
    [anon_sym_get] = ACTIONS(2402),
    [anon_sym_set] = ACTIONS(2402),
    [anon_sym_declare] = ACTIONS(2402),
    [anon_sym_public] = ACTIONS(2402),
    [anon_sym_private] = ACTIONS(2402),
    [anon_sym_protected] = ACTIONS(2402),
    [anon_sym_override] = ACTIONS(2402),
    [anon_sym_module] = ACTIONS(2402),
    [anon_sym_any] = ACTIONS(2402),
    [anon_sym_number] = ACTIONS(2402),
    [anon_sym_boolean] = ACTIONS(2402),
    [anon_sym_string] = ACTIONS(2402),
    [anon_sym_symbol] = ACTIONS(2402),
    [anon_sym_property] = ACTIONS(2402),
    [anon_sym_signal] = ACTIONS(2402),
    [anon_sym_on] = ACTIONS(2402),
    [anon_sym_required] = ACTIONS(2402),
    [anon_sym_component] = ACTIONS(2402),
    [anon_sym_abstract] = ACTIONS(2402),
    [anon_sym_interface] = ACTIONS(2402),
    [anon_sym_enum] = ACTIONS(2402),
  },
  [721] = {
    [sym_identifier] = ACTIONS(2406),
    [anon_sym_export] = ACTIONS(2406),
    [anon_sym_default] = ACTIONS(2406),
    [anon_sym_type] = ACTIONS(2406),
    [anon_sym_namespace] = ACTIONS(2406),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_typeof] = ACTIONS(2406),
    [anon_sym_import] = ACTIONS(2406),
    [anon_sym_from] = ACTIONS(2406),
    [anon_sym_var] = ACTIONS(2406),
    [anon_sym_let] = ACTIONS(2406),
    [anon_sym_const] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_else] = ACTIONS(2406),
    [anon_sym_if] = ACTIONS(2406),
    [anon_sym_switch] = ACTIONS(2406),
    [anon_sym_for] = ACTIONS(2406),
    [anon_sym_LPAREN] = ACTIONS(2408),
    [anon_sym_await] = ACTIONS(2406),
    [anon_sym_of] = ACTIONS(2406),
    [anon_sym_while] = ACTIONS(2406),
    [anon_sym_do] = ACTIONS(2406),
    [anon_sym_try] = ACTIONS(2406),
    [anon_sym_with] = ACTIONS(2406),
    [anon_sym_break] = ACTIONS(2406),
    [anon_sym_continue] = ACTIONS(2406),
    [anon_sym_debugger] = ACTIONS(2406),
    [anon_sym_return] = ACTIONS(2406),
    [anon_sym_throw] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_case] = ACTIONS(2406),
    [anon_sym_yield] = ACTIONS(2406),
    [anon_sym_LBRACK] = ACTIONS(2408),
    [anon_sym_LTtemplate_GT] = ACTIONS(2408),
    [anon_sym_LT] = ACTIONS(2406),
    [anon_sym_SLASH] = ACTIONS(2406),
    [anon_sym_class] = ACTIONS(2406),
    [anon_sym_async] = ACTIONS(2406),
    [anon_sym_function] = ACTIONS(2406),
    [anon_sym_new] = ACTIONS(2406),
    [anon_sym_PLUS] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2406),
    [anon_sym_TILDE] = ACTIONS(2408),
    [anon_sym_void] = ACTIONS(2406),
    [anon_sym_delete] = ACTIONS(2406),
    [anon_sym_PLUS_PLUS] = ACTIONS(2408),
    [anon_sym_DASH_DASH] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(2408),
    [anon_sym_SQUOTE] = ACTIONS(2408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2408),
    [sym_number] = ACTIONS(2408),
    [sym_this] = ACTIONS(2406),
    [sym_super] = ACTIONS(2406),
    [sym_true] = ACTIONS(2406),
    [sym_false] = ACTIONS(2406),
    [sym_null] = ACTIONS(2406),
    [sym_undefined] = ACTIONS(2406),
    [anon_sym_AT] = ACTIONS(2408),
    [anon_sym_static] = ACTIONS(2406),
    [anon_sym_readonly] = ACTIONS(2406),
    [anon_sym_get] = ACTIONS(2406),
    [anon_sym_set] = ACTIONS(2406),
    [anon_sym_declare] = ACTIONS(2406),
    [anon_sym_public] = ACTIONS(2406),
    [anon_sym_private] = ACTIONS(2406),
    [anon_sym_protected] = ACTIONS(2406),
    [anon_sym_override] = ACTIONS(2406),
    [anon_sym_module] = ACTIONS(2406),
    [anon_sym_any] = ACTIONS(2406),
    [anon_sym_number] = ACTIONS(2406),
    [anon_sym_boolean] = ACTIONS(2406),
    [anon_sym_string] = ACTIONS(2406),
    [anon_sym_symbol] = ACTIONS(2406),
    [anon_sym_property] = ACTIONS(2406),
    [anon_sym_signal] = ACTIONS(2406),
    [anon_sym_on] = ACTIONS(2406),
    [anon_sym_required] = ACTIONS(2406),
    [anon_sym_component] = ACTIONS(2406),
    [anon_sym_abstract] = ACTIONS(2406),
    [anon_sym_interface] = ACTIONS(2406),
    [anon_sym_enum] = ACTIONS(2406),
  },
  [722] = {
    [sym_identifier] = ACTIONS(2410),
    [anon_sym_export] = ACTIONS(2410),
    [anon_sym_default] = ACTIONS(2410),
    [anon_sym_type] = ACTIONS(2410),
    [anon_sym_namespace] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_typeof] = ACTIONS(2410),
    [anon_sym_import] = ACTIONS(2410),
    [anon_sym_from] = ACTIONS(2410),
    [anon_sym_var] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_switch] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [anon_sym_await] = ACTIONS(2410),
    [anon_sym_of] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [anon_sym_with] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_debugger] = ACTIONS(2410),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_throw] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym_case] = ACTIONS(2410),
    [anon_sym_yield] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_LTtemplate_GT] = ACTIONS(2412),
    [anon_sym_LT] = ACTIONS(2410),
    [anon_sym_SLASH] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_async] = ACTIONS(2410),
    [anon_sym_function] = ACTIONS(2410),
    [anon_sym_new] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_void] = ACTIONS(2410),
    [anon_sym_delete] = ACTIONS(2410),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2412),
    [sym_number] = ACTIONS(2412),
    [sym_this] = ACTIONS(2410),
    [sym_super] = ACTIONS(2410),
    [sym_true] = ACTIONS(2410),
    [sym_false] = ACTIONS(2410),
    [sym_null] = ACTIONS(2410),
    [sym_undefined] = ACTIONS(2410),
    [anon_sym_AT] = ACTIONS(2412),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_readonly] = ACTIONS(2410),
    [anon_sym_get] = ACTIONS(2410),
    [anon_sym_set] = ACTIONS(2410),
    [anon_sym_declare] = ACTIONS(2410),
    [anon_sym_public] = ACTIONS(2410),
    [anon_sym_private] = ACTIONS(2410),
    [anon_sym_protected] = ACTIONS(2410),
    [anon_sym_override] = ACTIONS(2410),
    [anon_sym_module] = ACTIONS(2410),
    [anon_sym_any] = ACTIONS(2410),
    [anon_sym_number] = ACTIONS(2410),
    [anon_sym_boolean] = ACTIONS(2410),
    [anon_sym_string] = ACTIONS(2410),
    [anon_sym_symbol] = ACTIONS(2410),
    [anon_sym_property] = ACTIONS(2410),
    [anon_sym_signal] = ACTIONS(2410),
    [anon_sym_on] = ACTIONS(2410),
    [anon_sym_required] = ACTIONS(2410),
    [anon_sym_component] = ACTIONS(2410),
    [anon_sym_abstract] = ACTIONS(2410),
    [anon_sym_interface] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
  },
  [723] = {
    [sym_identifier] = ACTIONS(2414),
    [anon_sym_export] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_type] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_typeof] = ACTIONS(2414),
    [anon_sym_import] = ACTIONS(2414),
    [anon_sym_from] = ACTIONS(2414),
    [anon_sym_var] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_else] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_await] = ACTIONS(2414),
    [anon_sym_of] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_with] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_debugger] = ACTIONS(2414),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym_case] = ACTIONS(2414),
    [anon_sym_yield] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_LTtemplate_GT] = ACTIONS(2416),
    [anon_sym_LT] = ACTIONS(2414),
    [anon_sym_SLASH] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_async] = ACTIONS(2414),
    [anon_sym_function] = ACTIONS(2414),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_void] = ACTIONS(2414),
    [anon_sym_delete] = ACTIONS(2414),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [sym_number] = ACTIONS(2416),
    [sym_this] = ACTIONS(2414),
    [sym_super] = ACTIONS(2414),
    [sym_true] = ACTIONS(2414),
    [sym_false] = ACTIONS(2414),
    [sym_null] = ACTIONS(2414),
    [sym_undefined] = ACTIONS(2414),
    [anon_sym_AT] = ACTIONS(2416),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_readonly] = ACTIONS(2414),
    [anon_sym_get] = ACTIONS(2414),
    [anon_sym_set] = ACTIONS(2414),
    [anon_sym_declare] = ACTIONS(2414),
    [anon_sym_public] = ACTIONS(2414),
    [anon_sym_private] = ACTIONS(2414),
    [anon_sym_protected] = ACTIONS(2414),
    [anon_sym_override] = ACTIONS(2414),
    [anon_sym_module] = ACTIONS(2414),
    [anon_sym_any] = ACTIONS(2414),
    [anon_sym_number] = ACTIONS(2414),
    [anon_sym_boolean] = ACTIONS(2414),
    [anon_sym_string] = ACTIONS(2414),
    [anon_sym_symbol] = ACTIONS(2414),
    [anon_sym_property] = ACTIONS(2414),
    [anon_sym_signal] = ACTIONS(2414),
    [anon_sym_on] = ACTIONS(2414),
    [anon_sym_required] = ACTIONS(2414),
    [anon_sym_component] = ACTIONS(2414),
    [anon_sym_abstract] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
  },
  [724] = {
    [sym_identifier] = ACTIONS(2418),
    [anon_sym_export] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_type] = ACTIONS(2418),
    [anon_sym_namespace] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_typeof] = ACTIONS(2418),
    [anon_sym_import] = ACTIONS(2418),
    [anon_sym_from] = ACTIONS(2418),
    [anon_sym_var] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_else] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_switch] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_await] = ACTIONS(2418),
    [anon_sym_of] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_with] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_debugger] = ACTIONS(2418),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_case] = ACTIONS(2418),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_LTtemplate_GT] = ACTIONS(2420),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_async] = ACTIONS(2418),
    [anon_sym_function] = ACTIONS(2418),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_void] = ACTIONS(2418),
    [anon_sym_delete] = ACTIONS(2418),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2420),
    [sym_number] = ACTIONS(2420),
    [sym_this] = ACTIONS(2418),
    [sym_super] = ACTIONS(2418),
    [sym_true] = ACTIONS(2418),
    [sym_false] = ACTIONS(2418),
    [sym_null] = ACTIONS(2418),
    [sym_undefined] = ACTIONS(2418),
    [anon_sym_AT] = ACTIONS(2420),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_readonly] = ACTIONS(2418),
    [anon_sym_get] = ACTIONS(2418),
    [anon_sym_set] = ACTIONS(2418),
    [anon_sym_declare] = ACTIONS(2418),
    [anon_sym_public] = ACTIONS(2418),
    [anon_sym_private] = ACTIONS(2418),
    [anon_sym_protected] = ACTIONS(2418),
    [anon_sym_override] = ACTIONS(2418),
    [anon_sym_module] = ACTIONS(2418),
    [anon_sym_any] = ACTIONS(2418),
    [anon_sym_number] = ACTIONS(2418),
    [anon_sym_boolean] = ACTIONS(2418),
    [anon_sym_string] = ACTIONS(2418),
    [anon_sym_symbol] = ACTIONS(2418),
    [anon_sym_property] = ACTIONS(2418),
    [anon_sym_signal] = ACTIONS(2418),
    [anon_sym_on] = ACTIONS(2418),
    [anon_sym_required] = ACTIONS(2418),
    [anon_sym_component] = ACTIONS(2418),
    [anon_sym_abstract] = ACTIONS(2418),
    [anon_sym_interface] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
  },
  [725] = {
    [sym_identifier] = ACTIONS(2422),
    [anon_sym_export] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_type] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_typeof] = ACTIONS(2422),
    [anon_sym_import] = ACTIONS(2422),
    [anon_sym_from] = ACTIONS(2422),
    [anon_sym_var] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_BANG] = ACTIONS(2424),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_await] = ACTIONS(2422),
    [anon_sym_of] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_with] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_debugger] = ACTIONS(2422),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_LTtemplate_GT] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2422),
    [anon_sym_SLASH] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_async] = ACTIONS(2422),
    [anon_sym_function] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_TILDE] = ACTIONS(2424),
    [anon_sym_void] = ACTIONS(2422),
    [anon_sym_delete] = ACTIONS(2422),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [anon_sym_DQUOTE] = ACTIONS(2424),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [sym_number] = ACTIONS(2424),
    [sym_this] = ACTIONS(2422),
    [sym_super] = ACTIONS(2422),
    [sym_true] = ACTIONS(2422),
    [sym_false] = ACTIONS(2422),
    [sym_null] = ACTIONS(2422),
    [sym_undefined] = ACTIONS(2422),
    [anon_sym_AT] = ACTIONS(2424),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_readonly] = ACTIONS(2422),
    [anon_sym_get] = ACTIONS(2422),
    [anon_sym_set] = ACTIONS(2422),
    [anon_sym_declare] = ACTIONS(2422),
    [anon_sym_public] = ACTIONS(2422),
    [anon_sym_private] = ACTIONS(2422),
    [anon_sym_protected] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_module] = ACTIONS(2422),
    [anon_sym_any] = ACTIONS(2422),
    [anon_sym_number] = ACTIONS(2422),
    [anon_sym_boolean] = ACTIONS(2422),
    [anon_sym_string] = ACTIONS(2422),
    [anon_sym_symbol] = ACTIONS(2422),
    [anon_sym_property] = ACTIONS(2422),
    [anon_sym_signal] = ACTIONS(2422),
    [anon_sym_on] = ACTIONS(2422),
    [anon_sym_required] = ACTIONS(2422),
    [anon_sym_component] = ACTIONS(2422),
    [anon_sym_abstract] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
  },
  [726] = {
    [sym_identifier] = ACTIONS(2426),
    [anon_sym_export] = ACTIONS(2426),
    [anon_sym_default] = ACTIONS(2426),
    [anon_sym_type] = ACTIONS(2426),
    [anon_sym_namespace] = ACTIONS(2426),
    [anon_sym_LBRACE] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_typeof] = ACTIONS(2426),
    [anon_sym_import] = ACTIONS(2426),
    [anon_sym_from] = ACTIONS(2426),
    [anon_sym_var] = ACTIONS(2426),
    [anon_sym_let] = ACTIONS(2426),
    [anon_sym_const] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2428),
    [anon_sym_else] = ACTIONS(2426),
    [anon_sym_if] = ACTIONS(2426),
    [anon_sym_switch] = ACTIONS(2426),
    [anon_sym_for] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_await] = ACTIONS(2426),
    [anon_sym_of] = ACTIONS(2426),
    [anon_sym_while] = ACTIONS(2426),
    [anon_sym_do] = ACTIONS(2426),
    [anon_sym_try] = ACTIONS(2426),
    [anon_sym_with] = ACTIONS(2426),
    [anon_sym_break] = ACTIONS(2426),
    [anon_sym_continue] = ACTIONS(2426),
    [anon_sym_debugger] = ACTIONS(2426),
    [anon_sym_return] = ACTIONS(2426),
    [anon_sym_throw] = ACTIONS(2426),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_case] = ACTIONS(2426),
    [anon_sym_yield] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_LTtemplate_GT] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2426),
    [anon_sym_class] = ACTIONS(2426),
    [anon_sym_async] = ACTIONS(2426),
    [anon_sym_function] = ACTIONS(2426),
    [anon_sym_new] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_TILDE] = ACTIONS(2428),
    [anon_sym_void] = ACTIONS(2426),
    [anon_sym_delete] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_DQUOTE] = ACTIONS(2428),
    [anon_sym_SQUOTE] = ACTIONS(2428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2428),
    [sym_number] = ACTIONS(2428),
    [sym_this] = ACTIONS(2426),
    [sym_super] = ACTIONS(2426),
    [sym_true] = ACTIONS(2426),
    [sym_false] = ACTIONS(2426),
    [sym_null] = ACTIONS(2426),
    [sym_undefined] = ACTIONS(2426),
    [anon_sym_AT] = ACTIONS(2428),
    [anon_sym_static] = ACTIONS(2426),
    [anon_sym_readonly] = ACTIONS(2426),
    [anon_sym_get] = ACTIONS(2426),
    [anon_sym_set] = ACTIONS(2426),
    [anon_sym_declare] = ACTIONS(2426),
    [anon_sym_public] = ACTIONS(2426),
    [anon_sym_private] = ACTIONS(2426),
    [anon_sym_protected] = ACTIONS(2426),
    [anon_sym_override] = ACTIONS(2426),
    [anon_sym_module] = ACTIONS(2426),
    [anon_sym_any] = ACTIONS(2426),
    [anon_sym_number] = ACTIONS(2426),
    [anon_sym_boolean] = ACTIONS(2426),
    [anon_sym_string] = ACTIONS(2426),
    [anon_sym_symbol] = ACTIONS(2426),
    [anon_sym_property] = ACTIONS(2426),
    [anon_sym_signal] = ACTIONS(2426),
    [anon_sym_on] = ACTIONS(2426),
    [anon_sym_required] = ACTIONS(2426),
    [anon_sym_component] = ACTIONS(2426),
    [anon_sym_abstract] = ACTIONS(2426),
    [anon_sym_interface] = ACTIONS(2426),
    [anon_sym_enum] = ACTIONS(2426),
  },
  [727] = {
    [sym_identifier] = ACTIONS(2430),
    [anon_sym_export] = ACTIONS(2430),
    [anon_sym_default] = ACTIONS(2430),
    [anon_sym_type] = ACTIONS(2430),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_LBRACE] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_typeof] = ACTIONS(2430),
    [anon_sym_import] = ACTIONS(2430),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_var] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_const] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(2432),
    [anon_sym_else] = ACTIONS(2430),
    [anon_sym_if] = ACTIONS(2430),
    [anon_sym_switch] = ACTIONS(2430),
    [anon_sym_for] = ACTIONS(2430),
    [anon_sym_LPAREN] = ACTIONS(2432),
    [anon_sym_await] = ACTIONS(2430),
    [anon_sym_of] = ACTIONS(2430),
    [anon_sym_while] = ACTIONS(2430),
    [anon_sym_do] = ACTIONS(2430),
    [anon_sym_try] = ACTIONS(2430),
    [anon_sym_with] = ACTIONS(2430),
    [anon_sym_break] = ACTIONS(2430),
    [anon_sym_continue] = ACTIONS(2430),
    [anon_sym_debugger] = ACTIONS(2430),
    [anon_sym_return] = ACTIONS(2430),
    [anon_sym_throw] = ACTIONS(2430),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_case] = ACTIONS(2430),
    [anon_sym_yield] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LTtemplate_GT] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2430),
    [anon_sym_class] = ACTIONS(2430),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_function] = ACTIONS(2430),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_TILDE] = ACTIONS(2432),
    [anon_sym_void] = ACTIONS(2430),
    [anon_sym_delete] = ACTIONS(2430),
    [anon_sym_PLUS_PLUS] = ACTIONS(2432),
    [anon_sym_DASH_DASH] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2432),
    [anon_sym_SQUOTE] = ACTIONS(2432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2432),
    [sym_number] = ACTIONS(2432),
    [sym_this] = ACTIONS(2430),
    [sym_super] = ACTIONS(2430),
    [sym_true] = ACTIONS(2430),
    [sym_false] = ACTIONS(2430),
    [sym_null] = ACTIONS(2430),
    [sym_undefined] = ACTIONS(2430),
    [anon_sym_AT] = ACTIONS(2432),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_declare] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_module] = ACTIONS(2430),
    [anon_sym_any] = ACTIONS(2430),
    [anon_sym_number] = ACTIONS(2430),
    [anon_sym_boolean] = ACTIONS(2430),
    [anon_sym_string] = ACTIONS(2430),
    [anon_sym_symbol] = ACTIONS(2430),
    [anon_sym_property] = ACTIONS(2430),
    [anon_sym_signal] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_required] = ACTIONS(2430),
    [anon_sym_component] = ACTIONS(2430),
    [anon_sym_abstract] = ACTIONS(2430),
    [anon_sym_interface] = ACTIONS(2430),
    [anon_sym_enum] = ACTIONS(2430),
  },
  [728] = {
    [sym_identifier] = ACTIONS(2434),
    [anon_sym_export] = ACTIONS(2434),
    [anon_sym_default] = ACTIONS(2434),
    [anon_sym_type] = ACTIONS(2434),
    [anon_sym_namespace] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(2436),
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_typeof] = ACTIONS(2434),
    [anon_sym_import] = ACTIONS(2434),
    [anon_sym_from] = ACTIONS(2434),
    [anon_sym_var] = ACTIONS(2434),
    [anon_sym_let] = ACTIONS(2434),
    [anon_sym_const] = ACTIONS(2434),
    [anon_sym_BANG] = ACTIONS(2436),
    [anon_sym_else] = ACTIONS(2434),
    [anon_sym_if] = ACTIONS(2434),
    [anon_sym_switch] = ACTIONS(2434),
    [anon_sym_for] = ACTIONS(2434),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_await] = ACTIONS(2434),
    [anon_sym_of] = ACTIONS(2434),
    [anon_sym_while] = ACTIONS(2434),
    [anon_sym_do] = ACTIONS(2434),
    [anon_sym_try] = ACTIONS(2434),
    [anon_sym_with] = ACTIONS(2434),
    [anon_sym_break] = ACTIONS(2434),
    [anon_sym_continue] = ACTIONS(2434),
    [anon_sym_debugger] = ACTIONS(2434),
    [anon_sym_return] = ACTIONS(2434),
    [anon_sym_throw] = ACTIONS(2434),
    [anon_sym_SEMI] = ACTIONS(2436),
    [anon_sym_case] = ACTIONS(2434),
    [anon_sym_yield] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_LTtemplate_GT] = ACTIONS(2436),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_SLASH] = ACTIONS(2434),
    [anon_sym_class] = ACTIONS(2434),
    [anon_sym_async] = ACTIONS(2434),
    [anon_sym_function] = ACTIONS(2434),
    [anon_sym_new] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(2434),
    [anon_sym_DASH] = ACTIONS(2434),
    [anon_sym_TILDE] = ACTIONS(2436),
    [anon_sym_void] = ACTIONS(2434),
    [anon_sym_delete] = ACTIONS(2434),
    [anon_sym_PLUS_PLUS] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2436),
    [anon_sym_DQUOTE] = ACTIONS(2436),
    [anon_sym_SQUOTE] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2436),
    [sym_number] = ACTIONS(2436),
    [sym_this] = ACTIONS(2434),
    [sym_super] = ACTIONS(2434),
    [sym_true] = ACTIONS(2434),
    [sym_false] = ACTIONS(2434),
    [sym_null] = ACTIONS(2434),
    [sym_undefined] = ACTIONS(2434),
    [anon_sym_AT] = ACTIONS(2436),
    [anon_sym_static] = ACTIONS(2434),
    [anon_sym_readonly] = ACTIONS(2434),
    [anon_sym_get] = ACTIONS(2434),
    [anon_sym_set] = ACTIONS(2434),
    [anon_sym_declare] = ACTIONS(2434),
    [anon_sym_public] = ACTIONS(2434),
    [anon_sym_private] = ACTIONS(2434),
    [anon_sym_protected] = ACTIONS(2434),
    [anon_sym_override] = ACTIONS(2434),
    [anon_sym_module] = ACTIONS(2434),
    [anon_sym_any] = ACTIONS(2434),
    [anon_sym_number] = ACTIONS(2434),
    [anon_sym_boolean] = ACTIONS(2434),
    [anon_sym_string] = ACTIONS(2434),
    [anon_sym_symbol] = ACTIONS(2434),
    [anon_sym_property] = ACTIONS(2434),
    [anon_sym_signal] = ACTIONS(2434),
    [anon_sym_on] = ACTIONS(2434),
    [anon_sym_required] = ACTIONS(2434),
    [anon_sym_component] = ACTIONS(2434),
    [anon_sym_abstract] = ACTIONS(2434),
    [anon_sym_interface] = ACTIONS(2434),
    [anon_sym_enum] = ACTIONS(2434),
  },
  [729] = {
    [sym_identifier] = ACTIONS(2438),
    [anon_sym_export] = ACTIONS(2438),
    [anon_sym_default] = ACTIONS(2438),
    [anon_sym_type] = ACTIONS(2438),
    [anon_sym_namespace] = ACTIONS(2438),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_RBRACE] = ACTIONS(2440),
    [anon_sym_typeof] = ACTIONS(2438),
    [anon_sym_import] = ACTIONS(2438),
    [anon_sym_from] = ACTIONS(2438),
    [anon_sym_var] = ACTIONS(2438),
    [anon_sym_let] = ACTIONS(2438),
    [anon_sym_const] = ACTIONS(2438),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_else] = ACTIONS(2438),
    [anon_sym_if] = ACTIONS(2438),
    [anon_sym_switch] = ACTIONS(2438),
    [anon_sym_for] = ACTIONS(2438),
    [anon_sym_LPAREN] = ACTIONS(2440),
    [anon_sym_await] = ACTIONS(2438),
    [anon_sym_of] = ACTIONS(2438),
    [anon_sym_while] = ACTIONS(2438),
    [anon_sym_do] = ACTIONS(2438),
    [anon_sym_try] = ACTIONS(2438),
    [anon_sym_with] = ACTIONS(2438),
    [anon_sym_break] = ACTIONS(2438),
    [anon_sym_continue] = ACTIONS(2438),
    [anon_sym_debugger] = ACTIONS(2438),
    [anon_sym_return] = ACTIONS(2438),
    [anon_sym_throw] = ACTIONS(2438),
    [anon_sym_SEMI] = ACTIONS(2440),
    [anon_sym_case] = ACTIONS(2438),
    [anon_sym_yield] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(2440),
    [anon_sym_LTtemplate_GT] = ACTIONS(2440),
    [anon_sym_LT] = ACTIONS(2438),
    [anon_sym_SLASH] = ACTIONS(2438),
    [anon_sym_class] = ACTIONS(2438),
    [anon_sym_async] = ACTIONS(2438),
    [anon_sym_function] = ACTIONS(2438),
    [anon_sym_new] = ACTIONS(2438),
    [anon_sym_PLUS] = ACTIONS(2438),
    [anon_sym_DASH] = ACTIONS(2438),
    [anon_sym_TILDE] = ACTIONS(2440),
    [anon_sym_void] = ACTIONS(2438),
    [anon_sym_delete] = ACTIONS(2438),
    [anon_sym_PLUS_PLUS] = ACTIONS(2440),
    [anon_sym_DASH_DASH] = ACTIONS(2440),
    [anon_sym_DQUOTE] = ACTIONS(2440),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2440),
    [sym_number] = ACTIONS(2440),
    [sym_this] = ACTIONS(2438),
    [sym_super] = ACTIONS(2438),
    [sym_true] = ACTIONS(2438),
    [sym_false] = ACTIONS(2438),
    [sym_null] = ACTIONS(2438),
    [sym_undefined] = ACTIONS(2438),
    [anon_sym_AT] = ACTIONS(2440),
    [anon_sym_static] = ACTIONS(2438),
    [anon_sym_readonly] = ACTIONS(2438),
    [anon_sym_get] = ACTIONS(2438),
    [anon_sym_set] = ACTIONS(2438),
    [anon_sym_declare] = ACTIONS(2438),
    [anon_sym_public] = ACTIONS(2438),
    [anon_sym_private] = ACTIONS(2438),
    [anon_sym_protected] = ACTIONS(2438),
    [anon_sym_override] = ACTIONS(2438),
    [anon_sym_module] = ACTIONS(2438),
    [anon_sym_any] = ACTIONS(2438),
    [anon_sym_number] = ACTIONS(2438),
    [anon_sym_boolean] = ACTIONS(2438),
    [anon_sym_string] = ACTIONS(2438),
    [anon_sym_symbol] = ACTIONS(2438),
    [anon_sym_property] = ACTIONS(2438),
    [anon_sym_signal] = ACTIONS(2438),
    [anon_sym_on] = ACTIONS(2438),
    [anon_sym_required] = ACTIONS(2438),
    [anon_sym_component] = ACTIONS(2438),
    [anon_sym_abstract] = ACTIONS(2438),
    [anon_sym_interface] = ACTIONS(2438),
    [anon_sym_enum] = ACTIONS(2438),
  },
  [730] = {
    [sym_identifier] = ACTIONS(2442),
    [anon_sym_export] = ACTIONS(2442),
    [anon_sym_default] = ACTIONS(2442),
    [anon_sym_type] = ACTIONS(2442),
    [anon_sym_namespace] = ACTIONS(2442),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_typeof] = ACTIONS(2442),
    [anon_sym_import] = ACTIONS(2442),
    [anon_sym_from] = ACTIONS(2442),
    [anon_sym_var] = ACTIONS(2442),
    [anon_sym_let] = ACTIONS(2442),
    [anon_sym_const] = ACTIONS(2442),
    [anon_sym_BANG] = ACTIONS(2444),
    [anon_sym_else] = ACTIONS(2442),
    [anon_sym_if] = ACTIONS(2442),
    [anon_sym_switch] = ACTIONS(2442),
    [anon_sym_for] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_await] = ACTIONS(2442),
    [anon_sym_of] = ACTIONS(2442),
    [anon_sym_while] = ACTIONS(2442),
    [anon_sym_do] = ACTIONS(2442),
    [anon_sym_try] = ACTIONS(2442),
    [anon_sym_with] = ACTIONS(2442),
    [anon_sym_break] = ACTIONS(2442),
    [anon_sym_continue] = ACTIONS(2442),
    [anon_sym_debugger] = ACTIONS(2442),
    [anon_sym_return] = ACTIONS(2442),
    [anon_sym_throw] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_case] = ACTIONS(2442),
    [anon_sym_yield] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_LTtemplate_GT] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2442),
    [anon_sym_SLASH] = ACTIONS(2442),
    [anon_sym_class] = ACTIONS(2442),
    [anon_sym_async] = ACTIONS(2442),
    [anon_sym_function] = ACTIONS(2442),
    [anon_sym_new] = ACTIONS(2442),
    [anon_sym_PLUS] = ACTIONS(2442),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_TILDE] = ACTIONS(2444),
    [anon_sym_void] = ACTIONS(2442),
    [anon_sym_delete] = ACTIONS(2442),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_DQUOTE] = ACTIONS(2444),
    [anon_sym_SQUOTE] = ACTIONS(2444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2444),
    [sym_number] = ACTIONS(2444),
    [sym_this] = ACTIONS(2442),
    [sym_super] = ACTIONS(2442),
    [sym_true] = ACTIONS(2442),
    [sym_false] = ACTIONS(2442),
    [sym_null] = ACTIONS(2442),
    [sym_undefined] = ACTIONS(2442),
    [anon_sym_AT] = ACTIONS(2444),
    [anon_sym_static] = ACTIONS(2442),
    [anon_sym_readonly] = ACTIONS(2442),
    [anon_sym_get] = ACTIONS(2442),
    [anon_sym_set] = ACTIONS(2442),
    [anon_sym_declare] = ACTIONS(2442),
    [anon_sym_public] = ACTIONS(2442),
    [anon_sym_private] = ACTIONS(2442),
    [anon_sym_protected] = ACTIONS(2442),
    [anon_sym_override] = ACTIONS(2442),
    [anon_sym_module] = ACTIONS(2442),
    [anon_sym_any] = ACTIONS(2442),
    [anon_sym_number] = ACTIONS(2442),
    [anon_sym_boolean] = ACTIONS(2442),
    [anon_sym_string] = ACTIONS(2442),
    [anon_sym_symbol] = ACTIONS(2442),
    [anon_sym_property] = ACTIONS(2442),
    [anon_sym_signal] = ACTIONS(2442),
    [anon_sym_on] = ACTIONS(2442),
    [anon_sym_required] = ACTIONS(2442),
    [anon_sym_component] = ACTIONS(2442),
    [anon_sym_abstract] = ACTIONS(2442),
    [anon_sym_interface] = ACTIONS(2442),
    [anon_sym_enum] = ACTIONS(2442),
  },
  [731] = {
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_export] = ACTIONS(2446),
    [anon_sym_default] = ACTIONS(2446),
    [anon_sym_type] = ACTIONS(2446),
    [anon_sym_namespace] = ACTIONS(2446),
    [anon_sym_LBRACE] = ACTIONS(2448),
    [anon_sym_RBRACE] = ACTIONS(2448),
    [anon_sym_typeof] = ACTIONS(2446),
    [anon_sym_import] = ACTIONS(2446),
    [anon_sym_from] = ACTIONS(2446),
    [anon_sym_var] = ACTIONS(2446),
    [anon_sym_let] = ACTIONS(2446),
    [anon_sym_const] = ACTIONS(2446),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_else] = ACTIONS(2446),
    [anon_sym_if] = ACTIONS(2446),
    [anon_sym_switch] = ACTIONS(2446),
    [anon_sym_for] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2448),
    [anon_sym_await] = ACTIONS(2446),
    [anon_sym_of] = ACTIONS(2446),
    [anon_sym_while] = ACTIONS(2446),
    [anon_sym_do] = ACTIONS(2446),
    [anon_sym_try] = ACTIONS(2446),
    [anon_sym_with] = ACTIONS(2446),
    [anon_sym_break] = ACTIONS(2446),
    [anon_sym_continue] = ACTIONS(2446),
    [anon_sym_debugger] = ACTIONS(2446),
    [anon_sym_return] = ACTIONS(2446),
    [anon_sym_throw] = ACTIONS(2446),
    [anon_sym_SEMI] = ACTIONS(2448),
    [anon_sym_case] = ACTIONS(2446),
    [anon_sym_yield] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_LTtemplate_GT] = ACTIONS(2448),
    [anon_sym_LT] = ACTIONS(2446),
    [anon_sym_SLASH] = ACTIONS(2446),
    [anon_sym_class] = ACTIONS(2446),
    [anon_sym_async] = ACTIONS(2446),
    [anon_sym_function] = ACTIONS(2446),
    [anon_sym_new] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_TILDE] = ACTIONS(2448),
    [anon_sym_void] = ACTIONS(2446),
    [anon_sym_delete] = ACTIONS(2446),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_DQUOTE] = ACTIONS(2448),
    [anon_sym_SQUOTE] = ACTIONS(2448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2448),
    [sym_number] = ACTIONS(2448),
    [sym_this] = ACTIONS(2446),
    [sym_super] = ACTIONS(2446),
    [sym_true] = ACTIONS(2446),
    [sym_false] = ACTIONS(2446),
    [sym_null] = ACTIONS(2446),
    [sym_undefined] = ACTIONS(2446),
    [anon_sym_AT] = ACTIONS(2448),
    [anon_sym_static] = ACTIONS(2446),
    [anon_sym_readonly] = ACTIONS(2446),
    [anon_sym_get] = ACTIONS(2446),
    [anon_sym_set] = ACTIONS(2446),
    [anon_sym_declare] = ACTIONS(2446),
    [anon_sym_public] = ACTIONS(2446),
    [anon_sym_private] = ACTIONS(2446),
    [anon_sym_protected] = ACTIONS(2446),
    [anon_sym_override] = ACTIONS(2446),
    [anon_sym_module] = ACTIONS(2446),
    [anon_sym_any] = ACTIONS(2446),
    [anon_sym_number] = ACTIONS(2446),
    [anon_sym_boolean] = ACTIONS(2446),
    [anon_sym_string] = ACTIONS(2446),
    [anon_sym_symbol] = ACTIONS(2446),
    [anon_sym_property] = ACTIONS(2446),
    [anon_sym_signal] = ACTIONS(2446),
    [anon_sym_on] = ACTIONS(2446),
    [anon_sym_required] = ACTIONS(2446),
    [anon_sym_component] = ACTIONS(2446),
    [anon_sym_abstract] = ACTIONS(2446),
    [anon_sym_interface] = ACTIONS(2446),
    [anon_sym_enum] = ACTIONS(2446),
  },
  [732] = {
    [sym_identifier] = ACTIONS(2450),
    [anon_sym_export] = ACTIONS(2450),
    [anon_sym_default] = ACTIONS(2450),
    [anon_sym_type] = ACTIONS(2450),
    [anon_sym_namespace] = ACTIONS(2450),
    [anon_sym_LBRACE] = ACTIONS(2452),
    [anon_sym_RBRACE] = ACTIONS(2452),
    [anon_sym_typeof] = ACTIONS(2450),
    [anon_sym_import] = ACTIONS(2450),
    [anon_sym_from] = ACTIONS(2450),
    [anon_sym_var] = ACTIONS(2450),
    [anon_sym_let] = ACTIONS(2450),
    [anon_sym_const] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_else] = ACTIONS(2450),
    [anon_sym_if] = ACTIONS(2450),
    [anon_sym_switch] = ACTIONS(2450),
    [anon_sym_for] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(2452),
    [anon_sym_await] = ACTIONS(2450),
    [anon_sym_of] = ACTIONS(2450),
    [anon_sym_while] = ACTIONS(2450),
    [anon_sym_do] = ACTIONS(2450),
    [anon_sym_try] = ACTIONS(2450),
    [anon_sym_with] = ACTIONS(2450),
    [anon_sym_break] = ACTIONS(2450),
    [anon_sym_continue] = ACTIONS(2450),
    [anon_sym_debugger] = ACTIONS(2450),
    [anon_sym_return] = ACTIONS(2450),
    [anon_sym_throw] = ACTIONS(2450),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_case] = ACTIONS(2450),
    [anon_sym_yield] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_LTtemplate_GT] = ACTIONS(2452),
    [anon_sym_LT] = ACTIONS(2450),
    [anon_sym_SLASH] = ACTIONS(2450),
    [anon_sym_class] = ACTIONS(2450),
    [anon_sym_async] = ACTIONS(2450),
    [anon_sym_function] = ACTIONS(2450),
    [anon_sym_new] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2452),
    [anon_sym_void] = ACTIONS(2450),
    [anon_sym_delete] = ACTIONS(2450),
    [anon_sym_PLUS_PLUS] = ACTIONS(2452),
    [anon_sym_DASH_DASH] = ACTIONS(2452),
    [anon_sym_DQUOTE] = ACTIONS(2452),
    [anon_sym_SQUOTE] = ACTIONS(2452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2452),
    [sym_number] = ACTIONS(2452),
    [sym_this] = ACTIONS(2450),
    [sym_super] = ACTIONS(2450),
    [sym_true] = ACTIONS(2450),
    [sym_false] = ACTIONS(2450),
    [sym_null] = ACTIONS(2450),
    [sym_undefined] = ACTIONS(2450),
    [anon_sym_AT] = ACTIONS(2452),
    [anon_sym_static] = ACTIONS(2450),
    [anon_sym_readonly] = ACTIONS(2450),
    [anon_sym_get] = ACTIONS(2450),
    [anon_sym_set] = ACTIONS(2450),
    [anon_sym_declare] = ACTIONS(2450),
    [anon_sym_public] = ACTIONS(2450),
    [anon_sym_private] = ACTIONS(2450),
    [anon_sym_protected] = ACTIONS(2450),
    [anon_sym_override] = ACTIONS(2450),
    [anon_sym_module] = ACTIONS(2450),
    [anon_sym_any] = ACTIONS(2450),
    [anon_sym_number] = ACTIONS(2450),
    [anon_sym_boolean] = ACTIONS(2450),
    [anon_sym_string] = ACTIONS(2450),
    [anon_sym_symbol] = ACTIONS(2450),
    [anon_sym_property] = ACTIONS(2450),
    [anon_sym_signal] = ACTIONS(2450),
    [anon_sym_on] = ACTIONS(2450),
    [anon_sym_required] = ACTIONS(2450),
    [anon_sym_component] = ACTIONS(2450),
    [anon_sym_abstract] = ACTIONS(2450),
    [anon_sym_interface] = ACTIONS(2450),
    [anon_sym_enum] = ACTIONS(2450),
  },
  [733] = {
    [sym_identifier] = ACTIONS(2454),
    [anon_sym_export] = ACTIONS(2454),
    [anon_sym_default] = ACTIONS(2454),
    [anon_sym_type] = ACTIONS(2454),
    [anon_sym_namespace] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_RBRACE] = ACTIONS(2456),
    [anon_sym_typeof] = ACTIONS(2454),
    [anon_sym_import] = ACTIONS(2454),
    [anon_sym_from] = ACTIONS(2454),
    [anon_sym_var] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_const] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2456),
    [anon_sym_else] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_switch] = ACTIONS(2454),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2456),
    [anon_sym_await] = ACTIONS(2454),
    [anon_sym_of] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_with] = ACTIONS(2454),
    [anon_sym_break] = ACTIONS(2454),
    [anon_sym_continue] = ACTIONS(2454),
    [anon_sym_debugger] = ACTIONS(2454),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_throw] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_case] = ACTIONS(2454),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2456),
    [anon_sym_LTtemplate_GT] = ACTIONS(2456),
    [anon_sym_LT] = ACTIONS(2454),
    [anon_sym_SLASH] = ACTIONS(2454),
    [anon_sym_class] = ACTIONS(2454),
    [anon_sym_async] = ACTIONS(2454),
    [anon_sym_function] = ACTIONS(2454),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2456),
    [anon_sym_void] = ACTIONS(2454),
    [anon_sym_delete] = ACTIONS(2454),
    [anon_sym_PLUS_PLUS] = ACTIONS(2456),
    [anon_sym_DASH_DASH] = ACTIONS(2456),
    [anon_sym_DQUOTE] = ACTIONS(2456),
    [anon_sym_SQUOTE] = ACTIONS(2456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2456),
    [sym_number] = ACTIONS(2456),
    [sym_this] = ACTIONS(2454),
    [sym_super] = ACTIONS(2454),
    [sym_true] = ACTIONS(2454),
    [sym_false] = ACTIONS(2454),
    [sym_null] = ACTIONS(2454),
    [sym_undefined] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2456),
    [anon_sym_static] = ACTIONS(2454),
    [anon_sym_readonly] = ACTIONS(2454),
    [anon_sym_get] = ACTIONS(2454),
    [anon_sym_set] = ACTIONS(2454),
    [anon_sym_declare] = ACTIONS(2454),
    [anon_sym_public] = ACTIONS(2454),
    [anon_sym_private] = ACTIONS(2454),
    [anon_sym_protected] = ACTIONS(2454),
    [anon_sym_override] = ACTIONS(2454),
    [anon_sym_module] = ACTIONS(2454),
    [anon_sym_any] = ACTIONS(2454),
    [anon_sym_number] = ACTIONS(2454),
    [anon_sym_boolean] = ACTIONS(2454),
    [anon_sym_string] = ACTIONS(2454),
    [anon_sym_symbol] = ACTIONS(2454),
    [anon_sym_property] = ACTIONS(2454),
    [anon_sym_signal] = ACTIONS(2454),
    [anon_sym_on] = ACTIONS(2454),
    [anon_sym_required] = ACTIONS(2454),
    [anon_sym_component] = ACTIONS(2454),
    [anon_sym_abstract] = ACTIONS(2454),
    [anon_sym_interface] = ACTIONS(2454),
    [anon_sym_enum] = ACTIONS(2454),
  },
  [734] = {
    [sym_identifier] = ACTIONS(2458),
    [anon_sym_export] = ACTIONS(2458),
    [anon_sym_default] = ACTIONS(2458),
    [anon_sym_type] = ACTIONS(2458),
    [anon_sym_namespace] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_RBRACE] = ACTIONS(2460),
    [anon_sym_typeof] = ACTIONS(2458),
    [anon_sym_import] = ACTIONS(2458),
    [anon_sym_from] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_else] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_switch] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_await] = ACTIONS(2458),
    [anon_sym_of] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_do] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [anon_sym_with] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_debugger] = ACTIONS(2458),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_throw] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_case] = ACTIONS(2458),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_LTtemplate_GT] = ACTIONS(2460),
    [anon_sym_LT] = ACTIONS(2458),
    [anon_sym_SLASH] = ACTIONS(2458),
    [anon_sym_class] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_function] = ACTIONS(2458),
    [anon_sym_new] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_TILDE] = ACTIONS(2460),
    [anon_sym_void] = ACTIONS(2458),
    [anon_sym_delete] = ACTIONS(2458),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(2460),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [sym_number] = ACTIONS(2460),
    [sym_this] = ACTIONS(2458),
    [sym_super] = ACTIONS(2458),
    [sym_true] = ACTIONS(2458),
    [sym_false] = ACTIONS(2458),
    [sym_null] = ACTIONS(2458),
    [sym_undefined] = ACTIONS(2458),
    [anon_sym_AT] = ACTIONS(2460),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_readonly] = ACTIONS(2458),
    [anon_sym_get] = ACTIONS(2458),
    [anon_sym_set] = ACTIONS(2458),
    [anon_sym_declare] = ACTIONS(2458),
    [anon_sym_public] = ACTIONS(2458),
    [anon_sym_private] = ACTIONS(2458),
    [anon_sym_protected] = ACTIONS(2458),
    [anon_sym_override] = ACTIONS(2458),
    [anon_sym_module] = ACTIONS(2458),
    [anon_sym_any] = ACTIONS(2458),
    [anon_sym_number] = ACTIONS(2458),
    [anon_sym_boolean] = ACTIONS(2458),
    [anon_sym_string] = ACTIONS(2458),
    [anon_sym_symbol] = ACTIONS(2458),
    [anon_sym_property] = ACTIONS(2458),
    [anon_sym_signal] = ACTIONS(2458),
    [anon_sym_on] = ACTIONS(2458),
    [anon_sym_required] = ACTIONS(2458),
    [anon_sym_component] = ACTIONS(2458),
    [anon_sym_abstract] = ACTIONS(2458),
    [anon_sym_interface] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
  },
  [735] = {
    [sym_identifier] = ACTIONS(2462),
    [anon_sym_export] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_type] = ACTIONS(2462),
    [anon_sym_namespace] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_typeof] = ACTIONS(2462),
    [anon_sym_import] = ACTIONS(2462),
    [anon_sym_from] = ACTIONS(2462),
    [anon_sym_var] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_else] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_switch] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_await] = ACTIONS(2462),
    [anon_sym_of] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_with] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_debugger] = ACTIONS(2462),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_throw] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_case] = ACTIONS(2462),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2464),
    [anon_sym_LTtemplate_GT] = ACTIONS(2464),
    [anon_sym_LT] = ACTIONS(2462),
    [anon_sym_SLASH] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_async] = ACTIONS(2462),
    [anon_sym_function] = ACTIONS(2462),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_void] = ACTIONS(2462),
    [anon_sym_delete] = ACTIONS(2462),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2464),
    [sym_number] = ACTIONS(2464),
    [sym_this] = ACTIONS(2462),
    [sym_super] = ACTIONS(2462),
    [sym_true] = ACTIONS(2462),
    [sym_false] = ACTIONS(2462),
    [sym_null] = ACTIONS(2462),
    [sym_undefined] = ACTIONS(2462),
    [anon_sym_AT] = ACTIONS(2464),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_readonly] = ACTIONS(2462),
    [anon_sym_get] = ACTIONS(2462),
    [anon_sym_set] = ACTIONS(2462),
    [anon_sym_declare] = ACTIONS(2462),
    [anon_sym_public] = ACTIONS(2462),
    [anon_sym_private] = ACTIONS(2462),
    [anon_sym_protected] = ACTIONS(2462),
    [anon_sym_override] = ACTIONS(2462),
    [anon_sym_module] = ACTIONS(2462),
    [anon_sym_any] = ACTIONS(2462),
    [anon_sym_number] = ACTIONS(2462),
    [anon_sym_boolean] = ACTIONS(2462),
    [anon_sym_string] = ACTIONS(2462),
    [anon_sym_symbol] = ACTIONS(2462),
    [anon_sym_property] = ACTIONS(2462),
    [anon_sym_signal] = ACTIONS(2462),
    [anon_sym_on] = ACTIONS(2462),
    [anon_sym_required] = ACTIONS(2462),
    [anon_sym_component] = ACTIONS(2462),
    [anon_sym_abstract] = ACTIONS(2462),
    [anon_sym_interface] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
  },
  [736] = {
    [sym_identifier] = ACTIONS(2466),
    [anon_sym_export] = ACTIONS(2466),
    [anon_sym_default] = ACTIONS(2466),
    [anon_sym_type] = ACTIONS(2466),
    [anon_sym_namespace] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_typeof] = ACTIONS(2466),
    [anon_sym_import] = ACTIONS(2466),
    [anon_sym_from] = ACTIONS(2466),
    [anon_sym_var] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_else] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_switch] = ACTIONS(2466),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2468),
    [anon_sym_await] = ACTIONS(2466),
    [anon_sym_of] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_with] = ACTIONS(2466),
    [anon_sym_break] = ACTIONS(2466),
    [anon_sym_continue] = ACTIONS(2466),
    [anon_sym_debugger] = ACTIONS(2466),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_throw] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_case] = ACTIONS(2466),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2468),
    [anon_sym_LTtemplate_GT] = ACTIONS(2468),
    [anon_sym_LT] = ACTIONS(2466),
    [anon_sym_SLASH] = ACTIONS(2466),
    [anon_sym_class] = ACTIONS(2466),
    [anon_sym_async] = ACTIONS(2466),
    [anon_sym_function] = ACTIONS(2466),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_TILDE] = ACTIONS(2468),
    [anon_sym_void] = ACTIONS(2466),
    [anon_sym_delete] = ACTIONS(2466),
    [anon_sym_PLUS_PLUS] = ACTIONS(2468),
    [anon_sym_DASH_DASH] = ACTIONS(2468),
    [anon_sym_DQUOTE] = ACTIONS(2468),
    [anon_sym_SQUOTE] = ACTIONS(2468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2468),
    [sym_number] = ACTIONS(2468),
    [sym_this] = ACTIONS(2466),
    [sym_super] = ACTIONS(2466),
    [sym_true] = ACTIONS(2466),
    [sym_false] = ACTIONS(2466),
    [sym_null] = ACTIONS(2466),
    [sym_undefined] = ACTIONS(2466),
    [anon_sym_AT] = ACTIONS(2468),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_readonly] = ACTIONS(2466),
    [anon_sym_get] = ACTIONS(2466),
    [anon_sym_set] = ACTIONS(2466),
    [anon_sym_declare] = ACTIONS(2466),
    [anon_sym_public] = ACTIONS(2466),
    [anon_sym_private] = ACTIONS(2466),
    [anon_sym_protected] = ACTIONS(2466),
    [anon_sym_override] = ACTIONS(2466),
    [anon_sym_module] = ACTIONS(2466),
    [anon_sym_any] = ACTIONS(2466),
    [anon_sym_number] = ACTIONS(2466),
    [anon_sym_boolean] = ACTIONS(2466),
    [anon_sym_string] = ACTIONS(2466),
    [anon_sym_symbol] = ACTIONS(2466),
    [anon_sym_property] = ACTIONS(2466),
    [anon_sym_signal] = ACTIONS(2466),
    [anon_sym_on] = ACTIONS(2466),
    [anon_sym_required] = ACTIONS(2466),
    [anon_sym_component] = ACTIONS(2466),
    [anon_sym_abstract] = ACTIONS(2466),
    [anon_sym_interface] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
  },
  [737] = {
    [sym_identifier] = ACTIONS(2470),
    [anon_sym_export] = ACTIONS(2470),
    [anon_sym_default] = ACTIONS(2470),
    [anon_sym_type] = ACTIONS(2470),
    [anon_sym_namespace] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_typeof] = ACTIONS(2470),
    [anon_sym_import] = ACTIONS(2470),
    [anon_sym_from] = ACTIONS(2470),
    [anon_sym_var] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_else] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_switch] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_await] = ACTIONS(2470),
    [anon_sym_of] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_with] = ACTIONS(2470),
    [anon_sym_break] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(2470),
    [anon_sym_debugger] = ACTIONS(2470),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_throw] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_case] = ACTIONS(2470),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_LTtemplate_GT] = ACTIONS(2472),
    [anon_sym_LT] = ACTIONS(2470),
    [anon_sym_SLASH] = ACTIONS(2470),
    [anon_sym_class] = ACTIONS(2470),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_function] = ACTIONS(2470),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_void] = ACTIONS(2470),
    [anon_sym_delete] = ACTIONS(2470),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [anon_sym_DQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2472),
    [sym_number] = ACTIONS(2472),
    [sym_this] = ACTIONS(2470),
    [sym_super] = ACTIONS(2470),
    [sym_true] = ACTIONS(2470),
    [sym_false] = ACTIONS(2470),
    [sym_null] = ACTIONS(2470),
    [sym_undefined] = ACTIONS(2470),
    [anon_sym_AT] = ACTIONS(2472),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_readonly] = ACTIONS(2470),
    [anon_sym_get] = ACTIONS(2470),
    [anon_sym_set] = ACTIONS(2470),
    [anon_sym_declare] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2470),
    [anon_sym_private] = ACTIONS(2470),
    [anon_sym_protected] = ACTIONS(2470),
    [anon_sym_override] = ACTIONS(2470),
    [anon_sym_module] = ACTIONS(2470),
    [anon_sym_any] = ACTIONS(2470),
    [anon_sym_number] = ACTIONS(2470),
    [anon_sym_boolean] = ACTIONS(2470),
    [anon_sym_string] = ACTIONS(2470),
    [anon_sym_symbol] = ACTIONS(2470),
    [anon_sym_property] = ACTIONS(2470),
    [anon_sym_signal] = ACTIONS(2470),
    [anon_sym_on] = ACTIONS(2470),
    [anon_sym_required] = ACTIONS(2470),
    [anon_sym_component] = ACTIONS(2470),
    [anon_sym_abstract] = ACTIONS(2470),
    [anon_sym_interface] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
  },
  [738] = {
    [sym_identifier] = ACTIONS(2474),
    [anon_sym_export] = ACTIONS(2474),
    [anon_sym_default] = ACTIONS(2474),
    [anon_sym_type] = ACTIONS(2474),
    [anon_sym_namespace] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_typeof] = ACTIONS(2474),
    [anon_sym_import] = ACTIONS(2474),
    [anon_sym_from] = ACTIONS(2474),
    [anon_sym_var] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_const] = ACTIONS(2474),
    [anon_sym_BANG] = ACTIONS(2476),
    [anon_sym_else] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_switch] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_await] = ACTIONS(2474),
    [anon_sym_of] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_with] = ACTIONS(2474),
    [anon_sym_break] = ACTIONS(2474),
    [anon_sym_continue] = ACTIONS(2474),
    [anon_sym_debugger] = ACTIONS(2474),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_throw] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_case] = ACTIONS(2474),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_LTtemplate_GT] = ACTIONS(2476),
    [anon_sym_LT] = ACTIONS(2474),
    [anon_sym_SLASH] = ACTIONS(2474),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_async] = ACTIONS(2474),
    [anon_sym_function] = ACTIONS(2474),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_TILDE] = ACTIONS(2476),
    [anon_sym_void] = ACTIONS(2474),
    [anon_sym_delete] = ACTIONS(2474),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2476),
    [anon_sym_SQUOTE] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2476),
    [sym_number] = ACTIONS(2476),
    [sym_this] = ACTIONS(2474),
    [sym_super] = ACTIONS(2474),
    [sym_true] = ACTIONS(2474),
    [sym_false] = ACTIONS(2474),
    [sym_null] = ACTIONS(2474),
    [sym_undefined] = ACTIONS(2474),
    [anon_sym_AT] = ACTIONS(2476),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_readonly] = ACTIONS(2474),
    [anon_sym_get] = ACTIONS(2474),
    [anon_sym_set] = ACTIONS(2474),
    [anon_sym_declare] = ACTIONS(2474),
    [anon_sym_public] = ACTIONS(2474),
    [anon_sym_private] = ACTIONS(2474),
    [anon_sym_protected] = ACTIONS(2474),
    [anon_sym_override] = ACTIONS(2474),
    [anon_sym_module] = ACTIONS(2474),
    [anon_sym_any] = ACTIONS(2474),
    [anon_sym_number] = ACTIONS(2474),
    [anon_sym_boolean] = ACTIONS(2474),
    [anon_sym_string] = ACTIONS(2474),
    [anon_sym_symbol] = ACTIONS(2474),
    [anon_sym_property] = ACTIONS(2474),
    [anon_sym_signal] = ACTIONS(2474),
    [anon_sym_on] = ACTIONS(2474),
    [anon_sym_required] = ACTIONS(2474),
    [anon_sym_component] = ACTIONS(2474),
    [anon_sym_abstract] = ACTIONS(2474),
    [anon_sym_interface] = ACTIONS(2474),
    [anon_sym_enum] = ACTIONS(2474),
  },
  [739] = {
    [sym_identifier] = ACTIONS(2478),
    [anon_sym_export] = ACTIONS(2478),
    [anon_sym_default] = ACTIONS(2478),
    [anon_sym_type] = ACTIONS(2478),
    [anon_sym_namespace] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_typeof] = ACTIONS(2478),
    [anon_sym_import] = ACTIONS(2478),
    [anon_sym_from] = ACTIONS(2478),
    [anon_sym_var] = ACTIONS(2478),
    [anon_sym_let] = ACTIONS(2478),
    [anon_sym_const] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2480),
    [anon_sym_else] = ACTIONS(2478),
    [anon_sym_if] = ACTIONS(2478),
    [anon_sym_switch] = ACTIONS(2478),
    [anon_sym_for] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_await] = ACTIONS(2478),
    [anon_sym_of] = ACTIONS(2478),
    [anon_sym_while] = ACTIONS(2478),
    [anon_sym_do] = ACTIONS(2478),
    [anon_sym_try] = ACTIONS(2478),
    [anon_sym_with] = ACTIONS(2478),
    [anon_sym_break] = ACTIONS(2478),
    [anon_sym_continue] = ACTIONS(2478),
    [anon_sym_debugger] = ACTIONS(2478),
    [anon_sym_return] = ACTIONS(2478),
    [anon_sym_throw] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_case] = ACTIONS(2478),
    [anon_sym_yield] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_LTtemplate_GT] = ACTIONS(2480),
    [anon_sym_LT] = ACTIONS(2478),
    [anon_sym_SLASH] = ACTIONS(2478),
    [anon_sym_class] = ACTIONS(2478),
    [anon_sym_async] = ACTIONS(2478),
    [anon_sym_function] = ACTIONS(2478),
    [anon_sym_new] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_TILDE] = ACTIONS(2480),
    [anon_sym_void] = ACTIONS(2478),
    [anon_sym_delete] = ACTIONS(2478),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [anon_sym_SQUOTE] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2480),
    [sym_number] = ACTIONS(2480),
    [sym_this] = ACTIONS(2478),
    [sym_super] = ACTIONS(2478),
    [sym_true] = ACTIONS(2478),
    [sym_false] = ACTIONS(2478),
    [sym_null] = ACTIONS(2478),
    [sym_undefined] = ACTIONS(2478),
    [anon_sym_AT] = ACTIONS(2480),
    [anon_sym_static] = ACTIONS(2478),
    [anon_sym_readonly] = ACTIONS(2478),
    [anon_sym_get] = ACTIONS(2478),
    [anon_sym_set] = ACTIONS(2478),
    [anon_sym_declare] = ACTIONS(2478),
    [anon_sym_public] = ACTIONS(2478),
    [anon_sym_private] = ACTIONS(2478),
    [anon_sym_protected] = ACTIONS(2478),
    [anon_sym_override] = ACTIONS(2478),
    [anon_sym_module] = ACTIONS(2478),
    [anon_sym_any] = ACTIONS(2478),
    [anon_sym_number] = ACTIONS(2478),
    [anon_sym_boolean] = ACTIONS(2478),
    [anon_sym_string] = ACTIONS(2478),
    [anon_sym_symbol] = ACTIONS(2478),
    [anon_sym_property] = ACTIONS(2478),
    [anon_sym_signal] = ACTIONS(2478),
    [anon_sym_on] = ACTIONS(2478),
    [anon_sym_required] = ACTIONS(2478),
    [anon_sym_component] = ACTIONS(2478),
    [anon_sym_abstract] = ACTIONS(2478),
    [anon_sym_interface] = ACTIONS(2478),
    [anon_sym_enum] = ACTIONS(2478),
  },
  [740] = {
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_of] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_case] = ACTIONS(2482),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LTtemplate_GT] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2482),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [sym_number] = ACTIONS(2484),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_property] = ACTIONS(2482),
    [anon_sym_signal] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_required] = ACTIONS(2482),
    [anon_sym_component] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
  },
  [741] = {
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_of] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_case] = ACTIONS(2482),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LTtemplate_GT] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2482),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [sym_number] = ACTIONS(2484),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_property] = ACTIONS(2482),
    [anon_sym_signal] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_required] = ACTIONS(2482),
    [anon_sym_component] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
  },
  [742] = {
    [sym_identifier] = ACTIONS(2486),
    [anon_sym_export] = ACTIONS(2486),
    [anon_sym_default] = ACTIONS(2486),
    [anon_sym_type] = ACTIONS(2486),
    [anon_sym_namespace] = ACTIONS(2486),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_typeof] = ACTIONS(2486),
    [anon_sym_import] = ACTIONS(2486),
    [anon_sym_from] = ACTIONS(2486),
    [anon_sym_var] = ACTIONS(2486),
    [anon_sym_let] = ACTIONS(2486),
    [anon_sym_const] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_else] = ACTIONS(2486),
    [anon_sym_if] = ACTIONS(2486),
    [anon_sym_switch] = ACTIONS(2486),
    [anon_sym_for] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2488),
    [anon_sym_await] = ACTIONS(2486),
    [anon_sym_of] = ACTIONS(2486),
    [anon_sym_while] = ACTIONS(2486),
    [anon_sym_do] = ACTIONS(2486),
    [anon_sym_try] = ACTIONS(2486),
    [anon_sym_with] = ACTIONS(2486),
    [anon_sym_break] = ACTIONS(2486),
    [anon_sym_continue] = ACTIONS(2486),
    [anon_sym_debugger] = ACTIONS(2486),
    [anon_sym_return] = ACTIONS(2486),
    [anon_sym_throw] = ACTIONS(2486),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_case] = ACTIONS(2486),
    [anon_sym_yield] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_LTtemplate_GT] = ACTIONS(2488),
    [anon_sym_LT] = ACTIONS(2486),
    [anon_sym_SLASH] = ACTIONS(2486),
    [anon_sym_class] = ACTIONS(2486),
    [anon_sym_async] = ACTIONS(2486),
    [anon_sym_function] = ACTIONS(2486),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2486),
    [anon_sym_TILDE] = ACTIONS(2488),
    [anon_sym_void] = ACTIONS(2486),
    [anon_sym_delete] = ACTIONS(2486),
    [anon_sym_PLUS_PLUS] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2488),
    [anon_sym_SQUOTE] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2488),
    [sym_number] = ACTIONS(2488),
    [sym_this] = ACTIONS(2486),
    [sym_super] = ACTIONS(2486),
    [sym_true] = ACTIONS(2486),
    [sym_false] = ACTIONS(2486),
    [sym_null] = ACTIONS(2486),
    [sym_undefined] = ACTIONS(2486),
    [anon_sym_AT] = ACTIONS(2488),
    [anon_sym_static] = ACTIONS(2486),
    [anon_sym_readonly] = ACTIONS(2486),
    [anon_sym_get] = ACTIONS(2486),
    [anon_sym_set] = ACTIONS(2486),
    [anon_sym_declare] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2486),
    [anon_sym_private] = ACTIONS(2486),
    [anon_sym_protected] = ACTIONS(2486),
    [anon_sym_override] = ACTIONS(2486),
    [anon_sym_module] = ACTIONS(2486),
    [anon_sym_any] = ACTIONS(2486),
    [anon_sym_number] = ACTIONS(2486),
    [anon_sym_boolean] = ACTIONS(2486),
    [anon_sym_string] = ACTIONS(2486),
    [anon_sym_symbol] = ACTIONS(2486),
    [anon_sym_property] = ACTIONS(2486),
    [anon_sym_signal] = ACTIONS(2486),
    [anon_sym_on] = ACTIONS(2486),
    [anon_sym_required] = ACTIONS(2486),
    [anon_sym_component] = ACTIONS(2486),
    [anon_sym_abstract] = ACTIONS(2486),
    [anon_sym_interface] = ACTIONS(2486),
    [anon_sym_enum] = ACTIONS(2486),
  },
  [743] = {
    [sym_identifier] = ACTIONS(2490),
    [anon_sym_export] = ACTIONS(2490),
    [anon_sym_default] = ACTIONS(2490),
    [anon_sym_type] = ACTIONS(2490),
    [anon_sym_namespace] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_typeof] = ACTIONS(2490),
    [anon_sym_import] = ACTIONS(2490),
    [anon_sym_from] = ACTIONS(2490),
    [anon_sym_var] = ACTIONS(2490),
    [anon_sym_let] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_else] = ACTIONS(2490),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_switch] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2492),
    [anon_sym_await] = ACTIONS(2490),
    [anon_sym_of] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_with] = ACTIONS(2490),
    [anon_sym_break] = ACTIONS(2490),
    [anon_sym_continue] = ACTIONS(2490),
    [anon_sym_debugger] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_throw] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_case] = ACTIONS(2490),
    [anon_sym_yield] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_LTtemplate_GT] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2490),
    [anon_sym_SLASH] = ACTIONS(2490),
    [anon_sym_class] = ACTIONS(2490),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_function] = ACTIONS(2490),
    [anon_sym_new] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_TILDE] = ACTIONS(2492),
    [anon_sym_void] = ACTIONS(2490),
    [anon_sym_delete] = ACTIONS(2490),
    [anon_sym_PLUS_PLUS] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_SQUOTE] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [sym_number] = ACTIONS(2492),
    [sym_this] = ACTIONS(2490),
    [sym_super] = ACTIONS(2490),
    [sym_true] = ACTIONS(2490),
    [sym_false] = ACTIONS(2490),
    [sym_null] = ACTIONS(2490),
    [sym_undefined] = ACTIONS(2490),
    [anon_sym_AT] = ACTIONS(2492),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_readonly] = ACTIONS(2490),
    [anon_sym_get] = ACTIONS(2490),
    [anon_sym_set] = ACTIONS(2490),
    [anon_sym_declare] = ACTIONS(2490),
    [anon_sym_public] = ACTIONS(2490),
    [anon_sym_private] = ACTIONS(2490),
    [anon_sym_protected] = ACTIONS(2490),
    [anon_sym_override] = ACTIONS(2490),
    [anon_sym_module] = ACTIONS(2490),
    [anon_sym_any] = ACTIONS(2490),
    [anon_sym_number] = ACTIONS(2490),
    [anon_sym_boolean] = ACTIONS(2490),
    [anon_sym_string] = ACTIONS(2490),
    [anon_sym_symbol] = ACTIONS(2490),
    [anon_sym_property] = ACTIONS(2490),
    [anon_sym_signal] = ACTIONS(2490),
    [anon_sym_on] = ACTIONS(2490),
    [anon_sym_required] = ACTIONS(2490),
    [anon_sym_component] = ACTIONS(2490),
    [anon_sym_abstract] = ACTIONS(2490),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_enum] = ACTIONS(2490),
  },
  [744] = {
    [sym_identifier] = ACTIONS(2494),
    [anon_sym_export] = ACTIONS(2494),
    [anon_sym_default] = ACTIONS(2494),
    [anon_sym_type] = ACTIONS(2494),
    [anon_sym_namespace] = ACTIONS(2494),
    [anon_sym_LBRACE] = ACTIONS(2496),
    [anon_sym_RBRACE] = ACTIONS(2496),
    [anon_sym_typeof] = ACTIONS(2494),
    [anon_sym_import] = ACTIONS(2494),
    [anon_sym_from] = ACTIONS(2494),
    [anon_sym_var] = ACTIONS(2494),
    [anon_sym_let] = ACTIONS(2494),
    [anon_sym_const] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2496),
    [anon_sym_else] = ACTIONS(2494),
    [anon_sym_if] = ACTIONS(2494),
    [anon_sym_switch] = ACTIONS(2494),
    [anon_sym_for] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_await] = ACTIONS(2494),
    [anon_sym_of] = ACTIONS(2494),
    [anon_sym_while] = ACTIONS(2494),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_try] = ACTIONS(2494),
    [anon_sym_with] = ACTIONS(2494),
    [anon_sym_break] = ACTIONS(2494),
    [anon_sym_continue] = ACTIONS(2494),
    [anon_sym_debugger] = ACTIONS(2494),
    [anon_sym_return] = ACTIONS(2494),
    [anon_sym_throw] = ACTIONS(2494),
    [anon_sym_SEMI] = ACTIONS(2496),
    [anon_sym_case] = ACTIONS(2494),
    [anon_sym_yield] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_LTtemplate_GT] = ACTIONS(2496),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_SLASH] = ACTIONS(2494),
    [anon_sym_class] = ACTIONS(2494),
    [anon_sym_async] = ACTIONS(2494),
    [anon_sym_function] = ACTIONS(2494),
    [anon_sym_new] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2494),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_void] = ACTIONS(2494),
    [anon_sym_delete] = ACTIONS(2494),
    [anon_sym_PLUS_PLUS] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2496),
    [anon_sym_DQUOTE] = ACTIONS(2496),
    [anon_sym_SQUOTE] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2496),
    [sym_number] = ACTIONS(2496),
    [sym_this] = ACTIONS(2494),
    [sym_super] = ACTIONS(2494),
    [sym_true] = ACTIONS(2494),
    [sym_false] = ACTIONS(2494),
    [sym_null] = ACTIONS(2494),
    [sym_undefined] = ACTIONS(2494),
    [anon_sym_AT] = ACTIONS(2496),
    [anon_sym_static] = ACTIONS(2494),
    [anon_sym_readonly] = ACTIONS(2494),
    [anon_sym_get] = ACTIONS(2494),
    [anon_sym_set] = ACTIONS(2494),
    [anon_sym_declare] = ACTIONS(2494),
    [anon_sym_public] = ACTIONS(2494),
    [anon_sym_private] = ACTIONS(2494),
    [anon_sym_protected] = ACTIONS(2494),
    [anon_sym_override] = ACTIONS(2494),
    [anon_sym_module] = ACTIONS(2494),
    [anon_sym_any] = ACTIONS(2494),
    [anon_sym_number] = ACTIONS(2494),
    [anon_sym_boolean] = ACTIONS(2494),
    [anon_sym_string] = ACTIONS(2494),
    [anon_sym_symbol] = ACTIONS(2494),
    [anon_sym_property] = ACTIONS(2494),
    [anon_sym_signal] = ACTIONS(2494),
    [anon_sym_on] = ACTIONS(2494),
    [anon_sym_required] = ACTIONS(2494),
    [anon_sym_component] = ACTIONS(2494),
    [anon_sym_abstract] = ACTIONS(2494),
    [anon_sym_interface] = ACTIONS(2494),
    [anon_sym_enum] = ACTIONS(2494),
  },
  [745] = {
    [sym_identifier] = ACTIONS(2498),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_default] = ACTIONS(2498),
    [anon_sym_type] = ACTIONS(2498),
    [anon_sym_namespace] = ACTIONS(2498),
    [anon_sym_LBRACE] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2500),
    [anon_sym_typeof] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2498),
    [anon_sym_from] = ACTIONS(2498),
    [anon_sym_var] = ACTIONS(2498),
    [anon_sym_let] = ACTIONS(2498),
    [anon_sym_const] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2500),
    [anon_sym_else] = ACTIONS(2498),
    [anon_sym_if] = ACTIONS(2498),
    [anon_sym_switch] = ACTIONS(2498),
    [anon_sym_for] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2500),
    [anon_sym_await] = ACTIONS(2498),
    [anon_sym_of] = ACTIONS(2498),
    [anon_sym_while] = ACTIONS(2498),
    [anon_sym_do] = ACTIONS(2498),
    [anon_sym_try] = ACTIONS(2498),
    [anon_sym_with] = ACTIONS(2498),
    [anon_sym_break] = ACTIONS(2498),
    [anon_sym_continue] = ACTIONS(2498),
    [anon_sym_debugger] = ACTIONS(2498),
    [anon_sym_return] = ACTIONS(2498),
    [anon_sym_throw] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(2500),
    [anon_sym_case] = ACTIONS(2498),
    [anon_sym_yield] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_LTtemplate_GT] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2498),
    [anon_sym_SLASH] = ACTIONS(2498),
    [anon_sym_class] = ACTIONS(2498),
    [anon_sym_async] = ACTIONS(2498),
    [anon_sym_function] = ACTIONS(2498),
    [anon_sym_new] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2500),
    [anon_sym_void] = ACTIONS(2498),
    [anon_sym_delete] = ACTIONS(2498),
    [anon_sym_PLUS_PLUS] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_SQUOTE] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [sym_number] = ACTIONS(2500),
    [sym_this] = ACTIONS(2498),
    [sym_super] = ACTIONS(2498),
    [sym_true] = ACTIONS(2498),
    [sym_false] = ACTIONS(2498),
    [sym_null] = ACTIONS(2498),
    [sym_undefined] = ACTIONS(2498),
    [anon_sym_AT] = ACTIONS(2500),
    [anon_sym_static] = ACTIONS(2498),
    [anon_sym_readonly] = ACTIONS(2498),
    [anon_sym_get] = ACTIONS(2498),
    [anon_sym_set] = ACTIONS(2498),
    [anon_sym_declare] = ACTIONS(2498),
    [anon_sym_public] = ACTIONS(2498),
    [anon_sym_private] = ACTIONS(2498),
    [anon_sym_protected] = ACTIONS(2498),
    [anon_sym_override] = ACTIONS(2498),
    [anon_sym_module] = ACTIONS(2498),
    [anon_sym_any] = ACTIONS(2498),
    [anon_sym_number] = ACTIONS(2498),
    [anon_sym_boolean] = ACTIONS(2498),
    [anon_sym_string] = ACTIONS(2498),
    [anon_sym_symbol] = ACTIONS(2498),
    [anon_sym_property] = ACTIONS(2498),
    [anon_sym_signal] = ACTIONS(2498),
    [anon_sym_on] = ACTIONS(2498),
    [anon_sym_required] = ACTIONS(2498),
    [anon_sym_component] = ACTIONS(2498),
    [anon_sym_abstract] = ACTIONS(2498),
    [anon_sym_interface] = ACTIONS(2498),
    [anon_sym_enum] = ACTIONS(2498),
  },
  [746] = {
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_export] = ACTIONS(2502),
    [anon_sym_default] = ACTIONS(2502),
    [anon_sym_type] = ACTIONS(2502),
    [anon_sym_namespace] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2504),
    [anon_sym_RBRACE] = ACTIONS(2504),
    [anon_sym_typeof] = ACTIONS(2502),
    [anon_sym_import] = ACTIONS(2502),
    [anon_sym_from] = ACTIONS(2502),
    [anon_sym_var] = ACTIONS(2502),
    [anon_sym_let] = ACTIONS(2502),
    [anon_sym_const] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2504),
    [anon_sym_else] = ACTIONS(2502),
    [anon_sym_if] = ACTIONS(2502),
    [anon_sym_switch] = ACTIONS(2502),
    [anon_sym_for] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2504),
    [anon_sym_await] = ACTIONS(2502),
    [anon_sym_of] = ACTIONS(2502),
    [anon_sym_while] = ACTIONS(2502),
    [anon_sym_do] = ACTIONS(2502),
    [anon_sym_try] = ACTIONS(2502),
    [anon_sym_with] = ACTIONS(2502),
    [anon_sym_break] = ACTIONS(2502),
    [anon_sym_continue] = ACTIONS(2502),
    [anon_sym_debugger] = ACTIONS(2502),
    [anon_sym_return] = ACTIONS(2502),
    [anon_sym_throw] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(2502),
    [anon_sym_yield] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_LTtemplate_GT] = ACTIONS(2504),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_SLASH] = ACTIONS(2502),
    [anon_sym_class] = ACTIONS(2502),
    [anon_sym_async] = ACTIONS(2502),
    [anon_sym_function] = ACTIONS(2502),
    [anon_sym_new] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2504),
    [anon_sym_void] = ACTIONS(2502),
    [anon_sym_delete] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2504),
    [anon_sym_DASH_DASH] = ACTIONS(2504),
    [anon_sym_DQUOTE] = ACTIONS(2504),
    [anon_sym_SQUOTE] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2504),
    [sym_number] = ACTIONS(2504),
    [sym_this] = ACTIONS(2502),
    [sym_super] = ACTIONS(2502),
    [sym_true] = ACTIONS(2502),
    [sym_false] = ACTIONS(2502),
    [sym_null] = ACTIONS(2502),
    [sym_undefined] = ACTIONS(2502),
    [anon_sym_AT] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2502),
    [anon_sym_readonly] = ACTIONS(2502),
    [anon_sym_get] = ACTIONS(2502),
    [anon_sym_set] = ACTIONS(2502),
    [anon_sym_declare] = ACTIONS(2502),
    [anon_sym_public] = ACTIONS(2502),
    [anon_sym_private] = ACTIONS(2502),
    [anon_sym_protected] = ACTIONS(2502),
    [anon_sym_override] = ACTIONS(2502),
    [anon_sym_module] = ACTIONS(2502),
    [anon_sym_any] = ACTIONS(2502),
    [anon_sym_number] = ACTIONS(2502),
    [anon_sym_boolean] = ACTIONS(2502),
    [anon_sym_string] = ACTIONS(2502),
    [anon_sym_symbol] = ACTIONS(2502),
    [anon_sym_property] = ACTIONS(2502),
    [anon_sym_signal] = ACTIONS(2502),
    [anon_sym_on] = ACTIONS(2502),
    [anon_sym_required] = ACTIONS(2502),
    [anon_sym_component] = ACTIONS(2502),
    [anon_sym_abstract] = ACTIONS(2502),
    [anon_sym_interface] = ACTIONS(2502),
    [anon_sym_enum] = ACTIONS(2502),
  },
  [747] = {
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_export] = ACTIONS(2506),
    [anon_sym_default] = ACTIONS(2506),
    [anon_sym_type] = ACTIONS(2506),
    [anon_sym_namespace] = ACTIONS(2506),
    [anon_sym_LBRACE] = ACTIONS(2508),
    [anon_sym_RBRACE] = ACTIONS(2508),
    [anon_sym_typeof] = ACTIONS(2506),
    [anon_sym_import] = ACTIONS(2506),
    [anon_sym_from] = ACTIONS(2506),
    [anon_sym_var] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_const] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2508),
    [anon_sym_else] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_switch] = ACTIONS(2506),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2508),
    [anon_sym_await] = ACTIONS(2506),
    [anon_sym_of] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_with] = ACTIONS(2506),
    [anon_sym_break] = ACTIONS(2506),
    [anon_sym_continue] = ACTIONS(2506),
    [anon_sym_debugger] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_throw] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2508),
    [anon_sym_case] = ACTIONS(2506),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_LTtemplate_GT] = ACTIONS(2508),
    [anon_sym_LT] = ACTIONS(2506),
    [anon_sym_SLASH] = ACTIONS(2506),
    [anon_sym_class] = ACTIONS(2506),
    [anon_sym_async] = ACTIONS(2506),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_TILDE] = ACTIONS(2508),
    [anon_sym_void] = ACTIONS(2506),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_PLUS_PLUS] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2508),
    [anon_sym_DQUOTE] = ACTIONS(2508),
    [anon_sym_SQUOTE] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2508),
    [sym_number] = ACTIONS(2508),
    [sym_this] = ACTIONS(2506),
    [sym_super] = ACTIONS(2506),
    [sym_true] = ACTIONS(2506),
    [sym_false] = ACTIONS(2506),
    [sym_null] = ACTIONS(2506),
    [sym_undefined] = ACTIONS(2506),
    [anon_sym_AT] = ACTIONS(2508),
    [anon_sym_static] = ACTIONS(2506),
    [anon_sym_readonly] = ACTIONS(2506),
    [anon_sym_get] = ACTIONS(2506),
    [anon_sym_set] = ACTIONS(2506),
    [anon_sym_declare] = ACTIONS(2506),
    [anon_sym_public] = ACTIONS(2506),
    [anon_sym_private] = ACTIONS(2506),
    [anon_sym_protected] = ACTIONS(2506),
    [anon_sym_override] = ACTIONS(2506),
    [anon_sym_module] = ACTIONS(2506),
    [anon_sym_any] = ACTIONS(2506),
    [anon_sym_number] = ACTIONS(2506),
    [anon_sym_boolean] = ACTIONS(2506),
    [anon_sym_string] = ACTIONS(2506),
    [anon_sym_symbol] = ACTIONS(2506),
    [anon_sym_property] = ACTIONS(2506),
    [anon_sym_signal] = ACTIONS(2506),
    [anon_sym_on] = ACTIONS(2506),
    [anon_sym_required] = ACTIONS(2506),
    [anon_sym_component] = ACTIONS(2506),
    [anon_sym_abstract] = ACTIONS(2506),
    [anon_sym_interface] = ACTIONS(2506),
    [anon_sym_enum] = ACTIONS(2506),
  },
  [748] = {
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_export] = ACTIONS(2510),
    [anon_sym_default] = ACTIONS(2510),
    [anon_sym_type] = ACTIONS(2510),
    [anon_sym_namespace] = ACTIONS(2510),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_typeof] = ACTIONS(2510),
    [anon_sym_import] = ACTIONS(2510),
    [anon_sym_from] = ACTIONS(2510),
    [anon_sym_var] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_else] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_switch] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(2512),
    [anon_sym_await] = ACTIONS(2510),
    [anon_sym_of] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_with] = ACTIONS(2510),
    [anon_sym_break] = ACTIONS(2510),
    [anon_sym_continue] = ACTIONS(2510),
    [anon_sym_debugger] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_throw] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym_case] = ACTIONS(2510),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_LTtemplate_GT] = ACTIONS(2512),
    [anon_sym_LT] = ACTIONS(2510),
    [anon_sym_SLASH] = ACTIONS(2510),
    [anon_sym_class] = ACTIONS(2510),
    [anon_sym_async] = ACTIONS(2510),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_void] = ACTIONS(2510),
    [anon_sym_delete] = ACTIONS(2510),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2512),
    [sym_number] = ACTIONS(2512),
    [sym_this] = ACTIONS(2510),
    [sym_super] = ACTIONS(2510),
    [sym_true] = ACTIONS(2510),
    [sym_false] = ACTIONS(2510),
    [sym_null] = ACTIONS(2510),
    [sym_undefined] = ACTIONS(2510),
    [anon_sym_AT] = ACTIONS(2512),
    [anon_sym_static] = ACTIONS(2510),
    [anon_sym_readonly] = ACTIONS(2510),
    [anon_sym_get] = ACTIONS(2510),
    [anon_sym_set] = ACTIONS(2510),
    [anon_sym_declare] = ACTIONS(2510),
    [anon_sym_public] = ACTIONS(2510),
    [anon_sym_private] = ACTIONS(2510),
    [anon_sym_protected] = ACTIONS(2510),
    [anon_sym_override] = ACTIONS(2510),
    [anon_sym_module] = ACTIONS(2510),
    [anon_sym_any] = ACTIONS(2510),
    [anon_sym_number] = ACTIONS(2510),
    [anon_sym_boolean] = ACTIONS(2510),
    [anon_sym_string] = ACTIONS(2510),
    [anon_sym_symbol] = ACTIONS(2510),
    [anon_sym_property] = ACTIONS(2510),
    [anon_sym_signal] = ACTIONS(2510),
    [anon_sym_on] = ACTIONS(2510),
    [anon_sym_required] = ACTIONS(2510),
    [anon_sym_component] = ACTIONS(2510),
    [anon_sym_abstract] = ACTIONS(2510),
    [anon_sym_interface] = ACTIONS(2510),
    [anon_sym_enum] = ACTIONS(2510),
  },
  [749] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_default] = ACTIONS(2514),
    [anon_sym_type] = ACTIONS(2514),
    [anon_sym_namespace] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_from] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_else] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_await] = ACTIONS(2514),
    [anon_sym_of] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_with] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_debugger] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_case] = ACTIONS(2514),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_LTtemplate_GT] = ACTIONS(2516),
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_SLASH] = ACTIONS(2514),
    [anon_sym_class] = ACTIONS(2514),
    [anon_sym_async] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_void] = ACTIONS(2514),
    [anon_sym_delete] = ACTIONS(2514),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2516),
    [sym_number] = ACTIONS(2516),
    [sym_this] = ACTIONS(2514),
    [sym_super] = ACTIONS(2514),
    [sym_true] = ACTIONS(2514),
    [sym_false] = ACTIONS(2514),
    [sym_null] = ACTIONS(2514),
    [sym_undefined] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2516),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_readonly] = ACTIONS(2514),
    [anon_sym_get] = ACTIONS(2514),
    [anon_sym_set] = ACTIONS(2514),
    [anon_sym_declare] = ACTIONS(2514),
    [anon_sym_public] = ACTIONS(2514),
    [anon_sym_private] = ACTIONS(2514),
    [anon_sym_protected] = ACTIONS(2514),
    [anon_sym_override] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_any] = ACTIONS(2514),
    [anon_sym_number] = ACTIONS(2514),
    [anon_sym_boolean] = ACTIONS(2514),
    [anon_sym_string] = ACTIONS(2514),
    [anon_sym_symbol] = ACTIONS(2514),
    [anon_sym_property] = ACTIONS(2514),
    [anon_sym_signal] = ACTIONS(2514),
    [anon_sym_on] = ACTIONS(2514),
    [anon_sym_required] = ACTIONS(2514),
    [anon_sym_component] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_interface] = ACTIONS(2514),
    [anon_sym_enum] = ACTIONS(2514),
  },
  [750] = {
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_of] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_case] = ACTIONS(2482),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LTtemplate_GT] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2482),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [sym_number] = ACTIONS(2484),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_property] = ACTIONS(2482),
    [anon_sym_signal] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_required] = ACTIONS(2482),
    [anon_sym_component] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
  },
  [751] = {
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_export] = ACTIONS(2518),
    [anon_sym_default] = ACTIONS(2518),
    [anon_sym_type] = ACTIONS(2518),
    [anon_sym_namespace] = ACTIONS(2518),
    [anon_sym_LBRACE] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_typeof] = ACTIONS(2518),
    [anon_sym_import] = ACTIONS(2518),
    [anon_sym_from] = ACTIONS(2518),
    [anon_sym_var] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_const] = ACTIONS(2518),
    [anon_sym_BANG] = ACTIONS(2520),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_switch] = ACTIONS(2518),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2520),
    [anon_sym_await] = ACTIONS(2518),
    [anon_sym_of] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_with] = ACTIONS(2518),
    [anon_sym_break] = ACTIONS(2518),
    [anon_sym_continue] = ACTIONS(2518),
    [anon_sym_debugger] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_throw] = ACTIONS(2518),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_case] = ACTIONS(2518),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_LTtemplate_GT] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2518),
    [anon_sym_SLASH] = ACTIONS(2518),
    [anon_sym_class] = ACTIONS(2518),
    [anon_sym_async] = ACTIONS(2518),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_TILDE] = ACTIONS(2520),
    [anon_sym_void] = ACTIONS(2518),
    [anon_sym_delete] = ACTIONS(2518),
    [anon_sym_PLUS_PLUS] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [anon_sym_SQUOTE] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2520),
    [sym_number] = ACTIONS(2520),
    [sym_this] = ACTIONS(2518),
    [sym_super] = ACTIONS(2518),
    [sym_true] = ACTIONS(2518),
    [sym_false] = ACTIONS(2518),
    [sym_null] = ACTIONS(2518),
    [sym_undefined] = ACTIONS(2518),
    [anon_sym_AT] = ACTIONS(2520),
    [anon_sym_static] = ACTIONS(2518),
    [anon_sym_readonly] = ACTIONS(2518),
    [anon_sym_get] = ACTIONS(2518),
    [anon_sym_set] = ACTIONS(2518),
    [anon_sym_declare] = ACTIONS(2518),
    [anon_sym_public] = ACTIONS(2518),
    [anon_sym_private] = ACTIONS(2518),
    [anon_sym_protected] = ACTIONS(2518),
    [anon_sym_override] = ACTIONS(2518),
    [anon_sym_module] = ACTIONS(2518),
    [anon_sym_any] = ACTIONS(2518),
    [anon_sym_number] = ACTIONS(2518),
    [anon_sym_boolean] = ACTIONS(2518),
    [anon_sym_string] = ACTIONS(2518),
    [anon_sym_symbol] = ACTIONS(2518),
    [anon_sym_property] = ACTIONS(2518),
    [anon_sym_signal] = ACTIONS(2518),
    [anon_sym_on] = ACTIONS(2518),
    [anon_sym_required] = ACTIONS(2518),
    [anon_sym_component] = ACTIONS(2518),
    [anon_sym_abstract] = ACTIONS(2518),
    [anon_sym_interface] = ACTIONS(2518),
    [anon_sym_enum] = ACTIONS(2518),
  },
  [752] = {
    [sym_identifier] = ACTIONS(2482),
    [anon_sym_export] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_type] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_import] = ACTIONS(2482),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_of] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_with] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_debugger] = ACTIONS(2482),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_case] = ACTIONS(2482),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_LTtemplate_GT] = ACTIONS(2484),
    [anon_sym_LT] = ACTIONS(2482),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_function] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_void] = ACTIONS(2482),
    [anon_sym_delete] = ACTIONS(2482),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2484),
    [sym_number] = ACTIONS(2484),
    [sym_this] = ACTIONS(2482),
    [sym_super] = ACTIONS(2482),
    [sym_true] = ACTIONS(2482),
    [sym_false] = ACTIONS(2482),
    [sym_null] = ACTIONS(2482),
    [sym_undefined] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2484),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_declare] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_module] = ACTIONS(2482),
    [anon_sym_any] = ACTIONS(2482),
    [anon_sym_number] = ACTIONS(2482),
    [anon_sym_boolean] = ACTIONS(2482),
    [anon_sym_string] = ACTIONS(2482),
    [anon_sym_symbol] = ACTIONS(2482),
    [anon_sym_property] = ACTIONS(2482),
    [anon_sym_signal] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_required] = ACTIONS(2482),
    [anon_sym_component] = ACTIONS(2482),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
  },
  [753] = {
    [sym_identifier] = ACTIONS(2522),
    [anon_sym_export] = ACTIONS(2522),
    [anon_sym_default] = ACTIONS(2522),
    [anon_sym_type] = ACTIONS(2522),
    [anon_sym_namespace] = ACTIONS(2522),
    [anon_sym_LBRACE] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(2524),
    [anon_sym_typeof] = ACTIONS(2522),
    [anon_sym_import] = ACTIONS(2522),
    [anon_sym_from] = ACTIONS(2522),
    [anon_sym_var] = ACTIONS(2522),
    [anon_sym_let] = ACTIONS(2522),
    [anon_sym_const] = ACTIONS(2522),
    [anon_sym_BANG] = ACTIONS(2524),
    [anon_sym_else] = ACTIONS(2522),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_switch] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2524),
    [anon_sym_await] = ACTIONS(2522),
    [anon_sym_of] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [anon_sym_do] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_with] = ACTIONS(2522),
    [anon_sym_break] = ACTIONS(2522),
    [anon_sym_continue] = ACTIONS(2522),
    [anon_sym_debugger] = ACTIONS(2522),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_throw] = ACTIONS(2522),
    [anon_sym_SEMI] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2522),
    [anon_sym_yield] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_LTtemplate_GT] = ACTIONS(2524),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_SLASH] = ACTIONS(2522),
    [anon_sym_class] = ACTIONS(2522),
    [anon_sym_async] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(2522),
    [anon_sym_new] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_TILDE] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2522),
    [anon_sym_delete] = ACTIONS(2522),
    [anon_sym_PLUS_PLUS] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2524),
    [anon_sym_SQUOTE] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2524),
    [sym_number] = ACTIONS(2524),
    [sym_this] = ACTIONS(2522),
    [sym_super] = ACTIONS(2522),
    [sym_true] = ACTIONS(2522),
    [sym_false] = ACTIONS(2522),
    [sym_null] = ACTIONS(2522),
    [sym_undefined] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2522),
    [anon_sym_readonly] = ACTIONS(2522),
    [anon_sym_get] = ACTIONS(2522),
    [anon_sym_set] = ACTIONS(2522),
    [anon_sym_declare] = ACTIONS(2522),
    [anon_sym_public] = ACTIONS(2522),
    [anon_sym_private] = ACTIONS(2522),
    [anon_sym_protected] = ACTIONS(2522),
    [anon_sym_override] = ACTIONS(2522),
    [anon_sym_module] = ACTIONS(2522),
    [anon_sym_any] = ACTIONS(2522),
    [anon_sym_number] = ACTIONS(2522),
    [anon_sym_boolean] = ACTIONS(2522),
    [anon_sym_string] = ACTIONS(2522),
    [anon_sym_symbol] = ACTIONS(2522),
    [anon_sym_property] = ACTIONS(2522),
    [anon_sym_signal] = ACTIONS(2522),
    [anon_sym_on] = ACTIONS(2522),
    [anon_sym_required] = ACTIONS(2522),
    [anon_sym_component] = ACTIONS(2522),
    [anon_sym_abstract] = ACTIONS(2522),
    [anon_sym_interface] = ACTIONS(2522),
    [anon_sym_enum] = ACTIONS(2522),
  },
  [754] = {
    [sym_identifier] = ACTIONS(2522),
    [anon_sym_export] = ACTIONS(2522),
    [anon_sym_default] = ACTIONS(2522),
    [anon_sym_type] = ACTIONS(2522),
    [anon_sym_namespace] = ACTIONS(2522),
    [anon_sym_LBRACE] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(2524),
    [anon_sym_typeof] = ACTIONS(2522),
    [anon_sym_import] = ACTIONS(2522),
    [anon_sym_from] = ACTIONS(2522),
    [anon_sym_var] = ACTIONS(2522),
    [anon_sym_let] = ACTIONS(2522),
    [anon_sym_const] = ACTIONS(2522),
    [anon_sym_BANG] = ACTIONS(2524),
    [anon_sym_else] = ACTIONS(2522),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_switch] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2524),
    [anon_sym_await] = ACTIONS(2522),
    [anon_sym_of] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [anon_sym_do] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_with] = ACTIONS(2522),
    [anon_sym_break] = ACTIONS(2522),
    [anon_sym_continue] = ACTIONS(2522),
    [anon_sym_debugger] = ACTIONS(2522),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_throw] = ACTIONS(2522),
    [anon_sym_SEMI] = ACTIONS(2524),
    [anon_sym_case] = ACTIONS(2522),
    [anon_sym_yield] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_LTtemplate_GT] = ACTIONS(2524),
    [anon_sym_LT] = ACTIONS(2522),
    [anon_sym_SLASH] = ACTIONS(2522),
    [anon_sym_class] = ACTIONS(2522),
    [anon_sym_async] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(2522),
    [anon_sym_new] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_TILDE] = ACTIONS(2524),
    [anon_sym_void] = ACTIONS(2522),
    [anon_sym_delete] = ACTIONS(2522),
    [anon_sym_PLUS_PLUS] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2524),
    [anon_sym_SQUOTE] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2524),
    [sym_number] = ACTIONS(2524),
    [sym_this] = ACTIONS(2522),
    [sym_super] = ACTIONS(2522),
    [sym_true] = ACTIONS(2522),
    [sym_false] = ACTIONS(2522),
    [sym_null] = ACTIONS(2522),
    [sym_undefined] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(2524),
    [anon_sym_static] = ACTIONS(2522),
    [anon_sym_readonly] = ACTIONS(2522),
    [anon_sym_get] = ACTIONS(2522),
    [anon_sym_set] = ACTIONS(2522),
    [anon_sym_declare] = ACTIONS(2522),
    [anon_sym_public] = ACTIONS(2522),
    [anon_sym_private] = ACTIONS(2522),
    [anon_sym_protected] = ACTIONS(2522),
    [anon_sym_override] = ACTIONS(2522),
    [anon_sym_module] = ACTIONS(2522),
    [anon_sym_any] = ACTIONS(2522),
    [anon_sym_number] = ACTIONS(2522),
    [anon_sym_boolean] = ACTIONS(2522),
    [anon_sym_string] = ACTIONS(2522),
    [anon_sym_symbol] = ACTIONS(2522),
    [anon_sym_property] = ACTIONS(2522),
    [anon_sym_signal] = ACTIONS(2522),
    [anon_sym_on] = ACTIONS(2522),
    [anon_sym_required] = ACTIONS(2522),
    [anon_sym_component] = ACTIONS(2522),
    [anon_sym_abstract] = ACTIONS(2522),
    [anon_sym_interface] = ACTIONS(2522),
    [anon_sym_enum] = ACTIONS(2522),
  },
  [755] = {
    [sym_identifier] = ACTIONS(2526),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_default] = ACTIONS(2526),
    [anon_sym_type] = ACTIONS(2526),
    [anon_sym_namespace] = ACTIONS(2526),
    [anon_sym_LBRACE] = ACTIONS(2528),
    [anon_sym_RBRACE] = ACTIONS(2528),
    [anon_sym_typeof] = ACTIONS(2526),
    [anon_sym_import] = ACTIONS(2526),
    [anon_sym_from] = ACTIONS(2526),
    [anon_sym_var] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2528),
    [anon_sym_else] = ACTIONS(2526),
    [anon_sym_if] = ACTIONS(2526),
    [anon_sym_switch] = ACTIONS(2526),
    [anon_sym_for] = ACTIONS(2526),
    [anon_sym_LPAREN] = ACTIONS(2528),
    [anon_sym_await] = ACTIONS(2526),
    [anon_sym_of] = ACTIONS(2526),
    [anon_sym_while] = ACTIONS(2526),
    [anon_sym_do] = ACTIONS(2526),
    [anon_sym_try] = ACTIONS(2526),
    [anon_sym_with] = ACTIONS(2526),
    [anon_sym_break] = ACTIONS(2526),
    [anon_sym_continue] = ACTIONS(2526),
    [anon_sym_debugger] = ACTIONS(2526),
    [anon_sym_return] = ACTIONS(2526),
    [anon_sym_throw] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(2528),
    [anon_sym_case] = ACTIONS(2526),
    [anon_sym_yield] = ACTIONS(2526),
    [anon_sym_LBRACK] = ACTIONS(2528),
    [anon_sym_LTtemplate_GT] = ACTIONS(2528),
    [anon_sym_LT] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2526),
    [anon_sym_class] = ACTIONS(2526),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2526),
    [anon_sym_new] = ACTIONS(2526),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2528),
    [anon_sym_void] = ACTIONS(2526),
    [anon_sym_delete] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2528),
    [anon_sym_DASH_DASH] = ACTIONS(2528),
    [anon_sym_DQUOTE] = ACTIONS(2528),
    [anon_sym_SQUOTE] = ACTIONS(2528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2528),
    [sym_number] = ACTIONS(2528),
    [sym_this] = ACTIONS(2526),
    [sym_super] = ACTIONS(2526),
    [sym_true] = ACTIONS(2526),
    [sym_false] = ACTIONS(2526),
    [sym_null] = ACTIONS(2526),
    [sym_undefined] = ACTIONS(2526),
    [anon_sym_AT] = ACTIONS(2528),
    [anon_sym_static] = ACTIONS(2526),
    [anon_sym_readonly] = ACTIONS(2526),
    [anon_sym_get] = ACTIONS(2526),
    [anon_sym_set] = ACTIONS(2526),
    [anon_sym_declare] = ACTIONS(2526),
    [anon_sym_public] = ACTIONS(2526),
    [anon_sym_private] = ACTIONS(2526),
    [anon_sym_protected] = ACTIONS(2526),
    [anon_sym_override] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_any] = ACTIONS(2526),
    [anon_sym_number] = ACTIONS(2526),
    [anon_sym_boolean] = ACTIONS(2526),
    [anon_sym_string] = ACTIONS(2526),
    [anon_sym_symbol] = ACTIONS(2526),
    [anon_sym_property] = ACTIONS(2526),
    [anon_sym_signal] = ACTIONS(2526),
    [anon_sym_on] = ACTIONS(2526),
    [anon_sym_required] = ACTIONS(2526),
    [anon_sym_component] = ACTIONS(2526),
    [anon_sym_abstract] = ACTIONS(2526),
    [anon_sym_interface] = ACTIONS(2526),
    [anon_sym_enum] = ACTIONS(2526),
  },
  [756] = {
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_export] = ACTIONS(2530),
    [anon_sym_default] = ACTIONS(2530),
    [anon_sym_type] = ACTIONS(2530),
    [anon_sym_namespace] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_typeof] = ACTIONS(2530),
    [anon_sym_import] = ACTIONS(2530),
    [anon_sym_from] = ACTIONS(2530),
    [anon_sym_var] = ACTIONS(2530),
    [anon_sym_let] = ACTIONS(2530),
    [anon_sym_const] = ACTIONS(2530),
    [anon_sym_BANG] = ACTIONS(2532),
    [anon_sym_else] = ACTIONS(2530),
    [anon_sym_if] = ACTIONS(2530),
    [anon_sym_switch] = ACTIONS(2530),
    [anon_sym_for] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_await] = ACTIONS(2530),
    [anon_sym_of] = ACTIONS(2530),
    [anon_sym_while] = ACTIONS(2530),
    [anon_sym_do] = ACTIONS(2530),
    [anon_sym_try] = ACTIONS(2530),
    [anon_sym_with] = ACTIONS(2530),
    [anon_sym_break] = ACTIONS(2530),
    [anon_sym_continue] = ACTIONS(2530),
    [anon_sym_debugger] = ACTIONS(2530),
    [anon_sym_return] = ACTIONS(2530),
    [anon_sym_throw] = ACTIONS(2530),
    [anon_sym_SEMI] = ACTIONS(2532),
    [anon_sym_case] = ACTIONS(2530),
    [anon_sym_yield] = ACTIONS(2530),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_LTtemplate_GT] = ACTIONS(2532),
    [anon_sym_LT] = ACTIONS(2530),
    [anon_sym_SLASH] = ACTIONS(2530),
    [anon_sym_class] = ACTIONS(2530),
    [anon_sym_async] = ACTIONS(2530),
    [anon_sym_function] = ACTIONS(2530),
    [anon_sym_new] = ACTIONS(2530),
    [anon_sym_PLUS] = ACTIONS(2530),
    [anon_sym_DASH] = ACTIONS(2530),
    [anon_sym_TILDE] = ACTIONS(2532),
    [anon_sym_void] = ACTIONS(2530),
    [anon_sym_delete] = ACTIONS(2530),
    [anon_sym_PLUS_PLUS] = ACTIONS(2532),
    [anon_sym_DASH_DASH] = ACTIONS(2532),
    [anon_sym_DQUOTE] = ACTIONS(2532),
    [anon_sym_SQUOTE] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2532),
    [sym_number] = ACTIONS(2532),
    [sym_this] = ACTIONS(2530),
    [sym_super] = ACTIONS(2530),
    [sym_true] = ACTIONS(2530),
    [sym_false] = ACTIONS(2530),
    [sym_null] = ACTIONS(2530),
    [sym_undefined] = ACTIONS(2530),
    [anon_sym_AT] = ACTIONS(2532),
    [anon_sym_static] = ACTIONS(2530),
    [anon_sym_readonly] = ACTIONS(2530),
    [anon_sym_get] = ACTIONS(2530),
    [anon_sym_set] = ACTIONS(2530),
    [anon_sym_declare] = ACTIONS(2530),
    [anon_sym_public] = ACTIONS(2530),
    [anon_sym_private] = ACTIONS(2530),
    [anon_sym_protected] = ACTIONS(2530),
    [anon_sym_override] = ACTIONS(2530),
    [anon_sym_module] = ACTIONS(2530),
    [anon_sym_any] = ACTIONS(2530),
    [anon_sym_number] = ACTIONS(2530),
    [anon_sym_boolean] = ACTIONS(2530),
    [anon_sym_string] = ACTIONS(2530),
    [anon_sym_symbol] = ACTIONS(2530),
    [anon_sym_property] = ACTIONS(2530),
    [anon_sym_signal] = ACTIONS(2530),
    [anon_sym_on] = ACTIONS(2530),
    [anon_sym_required] = ACTIONS(2530),
    [anon_sym_component] = ACTIONS(2530),
    [anon_sym_abstract] = ACTIONS(2530),
    [anon_sym_interface] = ACTIONS(2530),
    [anon_sym_enum] = ACTIONS(2530),
  },
  [757] = {
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_export] = ACTIONS(2534),
    [anon_sym_default] = ACTIONS(2534),
    [anon_sym_type] = ACTIONS(2534),
    [anon_sym_namespace] = ACTIONS(2534),
    [anon_sym_LBRACE] = ACTIONS(2536),
    [anon_sym_RBRACE] = ACTIONS(2536),
    [anon_sym_typeof] = ACTIONS(2534),
    [anon_sym_import] = ACTIONS(2534),
    [anon_sym_from] = ACTIONS(2534),
    [anon_sym_var] = ACTIONS(2534),
    [anon_sym_let] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2536),
    [anon_sym_else] = ACTIONS(2534),
    [anon_sym_if] = ACTIONS(2534),
    [anon_sym_switch] = ACTIONS(2534),
    [anon_sym_for] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [anon_sym_await] = ACTIONS(2534),
    [anon_sym_of] = ACTIONS(2534),
    [anon_sym_while] = ACTIONS(2534),
    [anon_sym_do] = ACTIONS(2534),
    [anon_sym_try] = ACTIONS(2534),
    [anon_sym_with] = ACTIONS(2534),
    [anon_sym_break] = ACTIONS(2534),
    [anon_sym_continue] = ACTIONS(2534),
    [anon_sym_debugger] = ACTIONS(2534),
    [anon_sym_return] = ACTIONS(2534),
    [anon_sym_throw] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_case] = ACTIONS(2534),
    [anon_sym_yield] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_LTtemplate_GT] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2534),
    [anon_sym_SLASH] = ACTIONS(2534),
    [anon_sym_class] = ACTIONS(2534),
    [anon_sym_async] = ACTIONS(2534),
    [anon_sym_function] = ACTIONS(2534),
    [anon_sym_new] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2534),
    [anon_sym_TILDE] = ACTIONS(2536),
    [anon_sym_void] = ACTIONS(2534),
    [anon_sym_delete] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [anon_sym_SQUOTE] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2536),
    [sym_number] = ACTIONS(2536),
    [sym_this] = ACTIONS(2534),
    [sym_super] = ACTIONS(2534),
    [sym_true] = ACTIONS(2534),
    [sym_false] = ACTIONS(2534),
    [sym_null] = ACTIONS(2534),
    [sym_undefined] = ACTIONS(2534),
    [anon_sym_AT] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2534),
    [anon_sym_readonly] = ACTIONS(2534),
    [anon_sym_get] = ACTIONS(2534),
    [anon_sym_set] = ACTIONS(2534),
    [anon_sym_declare] = ACTIONS(2534),
    [anon_sym_public] = ACTIONS(2534),
    [anon_sym_private] = ACTIONS(2534),
    [anon_sym_protected] = ACTIONS(2534),
    [anon_sym_override] = ACTIONS(2534),
    [anon_sym_module] = ACTIONS(2534),
    [anon_sym_any] = ACTIONS(2534),
    [anon_sym_number] = ACTIONS(2534),
    [anon_sym_boolean] = ACTIONS(2534),
    [anon_sym_string] = ACTIONS(2534),
    [anon_sym_symbol] = ACTIONS(2534),
    [anon_sym_property] = ACTIONS(2534),
    [anon_sym_signal] = ACTIONS(2534),
    [anon_sym_on] = ACTIONS(2534),
    [anon_sym_required] = ACTIONS(2534),
    [anon_sym_component] = ACTIONS(2534),
    [anon_sym_abstract] = ACTIONS(2534),
    [anon_sym_interface] = ACTIONS(2534),
    [anon_sym_enum] = ACTIONS(2534),
  },
  [758] = {
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2538),
    [anon_sym_default] = ACTIONS(2538),
    [anon_sym_type] = ACTIONS(2538),
    [anon_sym_namespace] = ACTIONS(2538),
    [anon_sym_LBRACE] = ACTIONS(2540),
    [anon_sym_RBRACE] = ACTIONS(2540),
    [anon_sym_typeof] = ACTIONS(2538),
    [anon_sym_import] = ACTIONS(2538),
    [anon_sym_from] = ACTIONS(2538),
    [anon_sym_var] = ACTIONS(2538),
    [anon_sym_let] = ACTIONS(2538),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_BANG] = ACTIONS(2540),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_switch] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_LPAREN] = ACTIONS(2540),
    [anon_sym_await] = ACTIONS(2538),
    [anon_sym_of] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_do] = ACTIONS(2538),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_with] = ACTIONS(2538),
    [anon_sym_break] = ACTIONS(2538),
    [anon_sym_continue] = ACTIONS(2538),
    [anon_sym_debugger] = ACTIONS(2538),
    [anon_sym_return] = ACTIONS(2538),
    [anon_sym_throw] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_case] = ACTIONS(2538),
    [anon_sym_yield] = ACTIONS(2538),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_LTtemplate_GT] = ACTIONS(2540),
    [anon_sym_LT] = ACTIONS(2538),
    [anon_sym_SLASH] = ACTIONS(2538),
    [anon_sym_class] = ACTIONS(2538),
    [anon_sym_async] = ACTIONS(2538),
    [anon_sym_function] = ACTIONS(2538),
    [anon_sym_new] = ACTIONS(2538),
    [anon_sym_PLUS] = ACTIONS(2538),
    [anon_sym_DASH] = ACTIONS(2538),
    [anon_sym_TILDE] = ACTIONS(2540),
    [anon_sym_void] = ACTIONS(2538),
    [anon_sym_delete] = ACTIONS(2538),
    [anon_sym_PLUS_PLUS] = ACTIONS(2540),
    [anon_sym_DASH_DASH] = ACTIONS(2540),
    [anon_sym_DQUOTE] = ACTIONS(2540),
    [anon_sym_SQUOTE] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2540),
    [sym_number] = ACTIONS(2540),
    [sym_this] = ACTIONS(2538),
    [sym_super] = ACTIONS(2538),
    [sym_true] = ACTIONS(2538),
    [sym_false] = ACTIONS(2538),
    [sym_null] = ACTIONS(2538),
    [sym_undefined] = ACTIONS(2538),
    [anon_sym_AT] = ACTIONS(2540),
    [anon_sym_static] = ACTIONS(2538),
    [anon_sym_readonly] = ACTIONS(2538),
    [anon_sym_get] = ACTIONS(2538),
    [anon_sym_set] = ACTIONS(2538),
    [anon_sym_declare] = ACTIONS(2538),
    [anon_sym_public] = ACTIONS(2538),
    [anon_sym_private] = ACTIONS(2538),
    [anon_sym_protected] = ACTIONS(2538),
    [anon_sym_override] = ACTIONS(2538),
    [anon_sym_module] = ACTIONS(2538),
    [anon_sym_any] = ACTIONS(2538),
    [anon_sym_number] = ACTIONS(2538),
    [anon_sym_boolean] = ACTIONS(2538),
    [anon_sym_string] = ACTIONS(2538),
    [anon_sym_symbol] = ACTIONS(2538),
    [anon_sym_property] = ACTIONS(2538),
    [anon_sym_signal] = ACTIONS(2538),
    [anon_sym_on] = ACTIONS(2538),
    [anon_sym_required] = ACTIONS(2538),
    [anon_sym_component] = ACTIONS(2538),
    [anon_sym_abstract] = ACTIONS(2538),
    [anon_sym_interface] = ACTIONS(2538),
    [anon_sym_enum] = ACTIONS(2538),
  },
  [759] = {
    [sym_identifier] = ACTIONS(2542),
    [anon_sym_export] = ACTIONS(2542),
    [anon_sym_default] = ACTIONS(2542),
    [anon_sym_type] = ACTIONS(2542),
    [anon_sym_namespace] = ACTIONS(2542),
    [anon_sym_LBRACE] = ACTIONS(2544),
    [anon_sym_RBRACE] = ACTIONS(2544),
    [anon_sym_typeof] = ACTIONS(2542),
    [anon_sym_import] = ACTIONS(2542),
    [anon_sym_from] = ACTIONS(2542),
    [anon_sym_var] = ACTIONS(2542),
    [anon_sym_let] = ACTIONS(2542),
    [anon_sym_const] = ACTIONS(2542),
    [anon_sym_BANG] = ACTIONS(2544),
    [anon_sym_else] = ACTIONS(2542),
    [anon_sym_if] = ACTIONS(2542),
    [anon_sym_switch] = ACTIONS(2542),
    [anon_sym_for] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(2544),
    [anon_sym_await] = ACTIONS(2542),
    [anon_sym_of] = ACTIONS(2542),
    [anon_sym_while] = ACTIONS(2542),
    [anon_sym_do] = ACTIONS(2542),
    [anon_sym_try] = ACTIONS(2542),
    [anon_sym_with] = ACTIONS(2542),
    [anon_sym_break] = ACTIONS(2542),
    [anon_sym_continue] = ACTIONS(2542),
    [anon_sym_debugger] = ACTIONS(2542),
    [anon_sym_return] = ACTIONS(2542),
    [anon_sym_throw] = ACTIONS(2542),
    [anon_sym_SEMI] = ACTIONS(2544),
    [anon_sym_case] = ACTIONS(2542),
    [anon_sym_yield] = ACTIONS(2542),
    [anon_sym_LBRACK] = ACTIONS(2544),
    [anon_sym_LTtemplate_GT] = ACTIONS(2544),
    [anon_sym_LT] = ACTIONS(2542),
    [anon_sym_SLASH] = ACTIONS(2542),
    [anon_sym_class] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2542),
    [anon_sym_function] = ACTIONS(2542),
    [anon_sym_new] = ACTIONS(2542),
    [anon_sym_PLUS] = ACTIONS(2542),
    [anon_sym_DASH] = ACTIONS(2542),
    [anon_sym_TILDE] = ACTIONS(2544),
    [anon_sym_void] = ACTIONS(2542),
    [anon_sym_delete] = ACTIONS(2542),
    [anon_sym_PLUS_PLUS] = ACTIONS(2544),
    [anon_sym_DASH_DASH] = ACTIONS(2544),
    [anon_sym_DQUOTE] = ACTIONS(2544),
    [anon_sym_SQUOTE] = ACTIONS(2544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2544),
    [sym_number] = ACTIONS(2544),
    [sym_this] = ACTIONS(2542),
    [sym_super] = ACTIONS(2542),
    [sym_true] = ACTIONS(2542),
    [sym_false] = ACTIONS(2542),
    [sym_null] = ACTIONS(2542),
    [sym_undefined] = ACTIONS(2542),
    [anon_sym_AT] = ACTIONS(2544),
    [anon_sym_static] = ACTIONS(2542),
    [anon_sym_readonly] = ACTIONS(2542),
    [anon_sym_get] = ACTIONS(2542),
    [anon_sym_set] = ACTIONS(2542),
    [anon_sym_declare] = ACTIONS(2542),
    [anon_sym_public] = ACTIONS(2542),
    [anon_sym_private] = ACTIONS(2542),
    [anon_sym_protected] = ACTIONS(2542),
    [anon_sym_override] = ACTIONS(2542),
    [anon_sym_module] = ACTIONS(2542),
    [anon_sym_any] = ACTIONS(2542),
    [anon_sym_number] = ACTIONS(2542),
    [anon_sym_boolean] = ACTIONS(2542),
    [anon_sym_string] = ACTIONS(2542),
    [anon_sym_symbol] = ACTIONS(2542),
    [anon_sym_property] = ACTIONS(2542),
    [anon_sym_signal] = ACTIONS(2542),
    [anon_sym_on] = ACTIONS(2542),
    [anon_sym_required] = ACTIONS(2542),
    [anon_sym_component] = ACTIONS(2542),
    [anon_sym_abstract] = ACTIONS(2542),
    [anon_sym_interface] = ACTIONS(2542),
    [anon_sym_enum] = ACTIONS(2542),
  },
  [760] = {
    [sym_identifier] = ACTIONS(2546),
    [anon_sym_export] = ACTIONS(2546),
    [anon_sym_default] = ACTIONS(2546),
    [anon_sym_type] = ACTIONS(2546),
    [anon_sym_namespace] = ACTIONS(2546),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_RBRACE] = ACTIONS(2548),
    [anon_sym_typeof] = ACTIONS(2546),
    [anon_sym_import] = ACTIONS(2546),
    [anon_sym_from] = ACTIONS(2546),
    [anon_sym_var] = ACTIONS(2546),
    [anon_sym_let] = ACTIONS(2546),
    [anon_sym_const] = ACTIONS(2546),
    [anon_sym_BANG] = ACTIONS(2548),
    [anon_sym_else] = ACTIONS(2546),
    [anon_sym_if] = ACTIONS(2546),
    [anon_sym_switch] = ACTIONS(2546),
    [anon_sym_for] = ACTIONS(2546),
    [anon_sym_LPAREN] = ACTIONS(2548),
    [anon_sym_await] = ACTIONS(2546),
    [anon_sym_of] = ACTIONS(2546),
    [anon_sym_while] = ACTIONS(2546),
    [anon_sym_do] = ACTIONS(2546),
    [anon_sym_try] = ACTIONS(2546),
    [anon_sym_with] = ACTIONS(2546),
    [anon_sym_break] = ACTIONS(2546),
    [anon_sym_continue] = ACTIONS(2546),
    [anon_sym_debugger] = ACTIONS(2546),
    [anon_sym_return] = ACTIONS(2546),
    [anon_sym_throw] = ACTIONS(2546),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_case] = ACTIONS(2546),
    [anon_sym_yield] = ACTIONS(2546),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_LTtemplate_GT] = ACTIONS(2548),
    [anon_sym_LT] = ACTIONS(2546),
    [anon_sym_SLASH] = ACTIONS(2546),
    [anon_sym_class] = ACTIONS(2546),
    [anon_sym_async] = ACTIONS(2546),
    [anon_sym_function] = ACTIONS(2546),
    [anon_sym_new] = ACTIONS(2546),
    [anon_sym_PLUS] = ACTIONS(2546),
    [anon_sym_DASH] = ACTIONS(2546),
    [anon_sym_TILDE] = ACTIONS(2548),
    [anon_sym_void] = ACTIONS(2546),
    [anon_sym_delete] = ACTIONS(2546),
    [anon_sym_PLUS_PLUS] = ACTIONS(2548),
    [anon_sym_DASH_DASH] = ACTIONS(2548),
    [anon_sym_DQUOTE] = ACTIONS(2548),
    [anon_sym_SQUOTE] = ACTIONS(2548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2548),
    [sym_number] = ACTIONS(2548),
    [sym_this] = ACTIONS(2546),
    [sym_super] = ACTIONS(2546),
    [sym_true] = ACTIONS(2546),
    [sym_false] = ACTIONS(2546),
    [sym_null] = ACTIONS(2546),
    [sym_undefined] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2548),
    [anon_sym_static] = ACTIONS(2546),
    [anon_sym_readonly] = ACTIONS(2546),
    [anon_sym_get] = ACTIONS(2546),
    [anon_sym_set] = ACTIONS(2546),
    [anon_sym_declare] = ACTIONS(2546),
    [anon_sym_public] = ACTIONS(2546),
    [anon_sym_private] = ACTIONS(2546),
    [anon_sym_protected] = ACTIONS(2546),
    [anon_sym_override] = ACTIONS(2546),
    [anon_sym_module] = ACTIONS(2546),
    [anon_sym_any] = ACTIONS(2546),
    [anon_sym_number] = ACTIONS(2546),
    [anon_sym_boolean] = ACTIONS(2546),
    [anon_sym_string] = ACTIONS(2546),
    [anon_sym_symbol] = ACTIONS(2546),
    [anon_sym_property] = ACTIONS(2546),
    [anon_sym_signal] = ACTIONS(2546),
    [anon_sym_on] = ACTIONS(2546),
    [anon_sym_required] = ACTIONS(2546),
    [anon_sym_component] = ACTIONS(2546),
    [anon_sym_abstract] = ACTIONS(2546),
    [anon_sym_interface] = ACTIONS(2546),
    [anon_sym_enum] = ACTIONS(2546),
  },
  [761] = {
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_export] = ACTIONS(2550),
    [anon_sym_default] = ACTIONS(2550),
    [anon_sym_type] = ACTIONS(2550),
    [anon_sym_namespace] = ACTIONS(2550),
    [anon_sym_LBRACE] = ACTIONS(2552),
    [anon_sym_RBRACE] = ACTIONS(2552),
    [anon_sym_typeof] = ACTIONS(2550),
    [anon_sym_import] = ACTIONS(2550),
    [anon_sym_from] = ACTIONS(2550),
    [anon_sym_var] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2552),
    [anon_sym_else] = ACTIONS(2550),
    [anon_sym_if] = ACTIONS(2550),
    [anon_sym_switch] = ACTIONS(2550),
    [anon_sym_for] = ACTIONS(2550),
    [anon_sym_LPAREN] = ACTIONS(2552),
    [anon_sym_await] = ACTIONS(2550),
    [anon_sym_of] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_try] = ACTIONS(2550),
    [anon_sym_with] = ACTIONS(2550),
    [anon_sym_break] = ACTIONS(2550),
    [anon_sym_continue] = ACTIONS(2550),
    [anon_sym_debugger] = ACTIONS(2550),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_throw] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_case] = ACTIONS(2550),
    [anon_sym_yield] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2552),
    [anon_sym_LTtemplate_GT] = ACTIONS(2552),
    [anon_sym_LT] = ACTIONS(2550),
    [anon_sym_SLASH] = ACTIONS(2550),
    [anon_sym_class] = ACTIONS(2550),
    [anon_sym_async] = ACTIONS(2550),
    [anon_sym_function] = ACTIONS(2550),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_DASH] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2552),
    [anon_sym_void] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(2550),
    [anon_sym_PLUS_PLUS] = ACTIONS(2552),
    [anon_sym_DASH_DASH] = ACTIONS(2552),
    [anon_sym_DQUOTE] = ACTIONS(2552),
    [anon_sym_SQUOTE] = ACTIONS(2552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2552),
    [sym_number] = ACTIONS(2552),
    [sym_this] = ACTIONS(2550),
    [sym_super] = ACTIONS(2550),
    [sym_true] = ACTIONS(2550),
    [sym_false] = ACTIONS(2550),
    [sym_null] = ACTIONS(2550),
    [sym_undefined] = ACTIONS(2550),
    [anon_sym_AT] = ACTIONS(2552),
    [anon_sym_static] = ACTIONS(2550),
    [anon_sym_readonly] = ACTIONS(2550),
    [anon_sym_get] = ACTIONS(2550),
    [anon_sym_set] = ACTIONS(2550),
    [anon_sym_declare] = ACTIONS(2550),
    [anon_sym_public] = ACTIONS(2550),
    [anon_sym_private] = ACTIONS(2550),
    [anon_sym_protected] = ACTIONS(2550),
    [anon_sym_override] = ACTIONS(2550),
    [anon_sym_module] = ACTIONS(2550),
    [anon_sym_any] = ACTIONS(2550),
    [anon_sym_number] = ACTIONS(2550),
    [anon_sym_boolean] = ACTIONS(2550),
    [anon_sym_string] = ACTIONS(2550),
    [anon_sym_symbol] = ACTIONS(2550),
    [anon_sym_property] = ACTIONS(2550),
    [anon_sym_signal] = ACTIONS(2550),
    [anon_sym_on] = ACTIONS(2550),
    [anon_sym_required] = ACTIONS(2550),
    [anon_sym_component] = ACTIONS(2550),
    [anon_sym_abstract] = ACTIONS(2550),
    [anon_sym_interface] = ACTIONS(2550),
    [anon_sym_enum] = ACTIONS(2550),
  },
  [762] = {
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_export] = ACTIONS(2554),
    [anon_sym_default] = ACTIONS(2554),
    [anon_sym_type] = ACTIONS(2554),
    [anon_sym_namespace] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2556),
    [anon_sym_RBRACE] = ACTIONS(2556),
    [anon_sym_typeof] = ACTIONS(2554),
    [anon_sym_import] = ACTIONS(2554),
    [anon_sym_from] = ACTIONS(2554),
    [anon_sym_var] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2556),
    [anon_sym_else] = ACTIONS(2554),
    [anon_sym_if] = ACTIONS(2554),
    [anon_sym_switch] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2554),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_await] = ACTIONS(2554),
    [anon_sym_of] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2554),
    [anon_sym_do] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(2554),
    [anon_sym_with] = ACTIONS(2554),
    [anon_sym_break] = ACTIONS(2554),
    [anon_sym_continue] = ACTIONS(2554),
    [anon_sym_debugger] = ACTIONS(2554),
    [anon_sym_return] = ACTIONS(2554),
    [anon_sym_throw] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_yield] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_LTtemplate_GT] = ACTIONS(2556),
    [anon_sym_LT] = ACTIONS(2554),
    [anon_sym_SLASH] = ACTIONS(2554),
    [anon_sym_class] = ACTIONS(2554),
    [anon_sym_async] = ACTIONS(2554),
    [anon_sym_function] = ACTIONS(2554),
    [anon_sym_new] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_DASH] = ACTIONS(2554),
    [anon_sym_TILDE] = ACTIONS(2556),
    [anon_sym_void] = ACTIONS(2554),
    [anon_sym_delete] = ACTIONS(2554),
    [anon_sym_PLUS_PLUS] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2556),
    [anon_sym_DQUOTE] = ACTIONS(2556),
    [anon_sym_SQUOTE] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2556),
    [sym_number] = ACTIONS(2556),
    [sym_this] = ACTIONS(2554),
    [sym_super] = ACTIONS(2554),
    [sym_true] = ACTIONS(2554),
    [sym_false] = ACTIONS(2554),
    [sym_null] = ACTIONS(2554),
    [sym_undefined] = ACTIONS(2554),
    [anon_sym_AT] = ACTIONS(2556),
    [anon_sym_static] = ACTIONS(2554),
    [anon_sym_readonly] = ACTIONS(2554),
    [anon_sym_get] = ACTIONS(2554),
    [anon_sym_set] = ACTIONS(2554),
    [anon_sym_declare] = ACTIONS(2554),
    [anon_sym_public] = ACTIONS(2554),
    [anon_sym_private] = ACTIONS(2554),
    [anon_sym_protected] = ACTIONS(2554),
    [anon_sym_override] = ACTIONS(2554),
    [anon_sym_module] = ACTIONS(2554),
    [anon_sym_any] = ACTIONS(2554),
    [anon_sym_number] = ACTIONS(2554),
    [anon_sym_boolean] = ACTIONS(2554),
    [anon_sym_string] = ACTIONS(2554),
    [anon_sym_symbol] = ACTIONS(2554),
    [anon_sym_property] = ACTIONS(2554),
    [anon_sym_signal] = ACTIONS(2554),
    [anon_sym_on] = ACTIONS(2554),
    [anon_sym_required] = ACTIONS(2554),
    [anon_sym_component] = ACTIONS(2554),
    [anon_sym_abstract] = ACTIONS(2554),
    [anon_sym_interface] = ACTIONS(2554),
    [anon_sym_enum] = ACTIONS(2554),
  },
  [763] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [764] = {
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_default] = ACTIONS(2558),
    [anon_sym_type] = ACTIONS(2558),
    [anon_sym_namespace] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_RBRACE] = ACTIONS(2560),
    [anon_sym_typeof] = ACTIONS(2558),
    [anon_sym_import] = ACTIONS(2558),
    [anon_sym_from] = ACTIONS(2558),
    [anon_sym_var] = ACTIONS(2558),
    [anon_sym_let] = ACTIONS(2558),
    [anon_sym_const] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2560),
    [anon_sym_else] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_switch] = ACTIONS(2558),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2560),
    [anon_sym_await] = ACTIONS(2558),
    [anon_sym_of] = ACTIONS(2558),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_do] = ACTIONS(2558),
    [anon_sym_try] = ACTIONS(2558),
    [anon_sym_with] = ACTIONS(2558),
    [anon_sym_break] = ACTIONS(2558),
    [anon_sym_continue] = ACTIONS(2558),
    [anon_sym_debugger] = ACTIONS(2558),
    [anon_sym_return] = ACTIONS(2558),
    [anon_sym_throw] = ACTIONS(2558),
    [anon_sym_SEMI] = ACTIONS(2560),
    [anon_sym_case] = ACTIONS(2558),
    [anon_sym_yield] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_LTtemplate_GT] = ACTIONS(2560),
    [anon_sym_LT] = ACTIONS(2558),
    [anon_sym_SLASH] = ACTIONS(2558),
    [anon_sym_class] = ACTIONS(2558),
    [anon_sym_async] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_new] = ACTIONS(2558),
    [anon_sym_PLUS] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2558),
    [anon_sym_TILDE] = ACTIONS(2560),
    [anon_sym_void] = ACTIONS(2558),
    [anon_sym_delete] = ACTIONS(2558),
    [anon_sym_PLUS_PLUS] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(2560),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [anon_sym_SQUOTE] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2560),
    [sym_number] = ACTIONS(2560),
    [sym_this] = ACTIONS(2558),
    [sym_super] = ACTIONS(2558),
    [sym_true] = ACTIONS(2558),
    [sym_false] = ACTIONS(2558),
    [sym_null] = ACTIONS(2558),
    [sym_undefined] = ACTIONS(2558),
    [anon_sym_AT] = ACTIONS(2560),
    [anon_sym_static] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_get] = ACTIONS(2558),
    [anon_sym_set] = ACTIONS(2558),
    [anon_sym_declare] = ACTIONS(2558),
    [anon_sym_public] = ACTIONS(2558),
    [anon_sym_private] = ACTIONS(2558),
    [anon_sym_protected] = ACTIONS(2558),
    [anon_sym_override] = ACTIONS(2558),
    [anon_sym_module] = ACTIONS(2558),
    [anon_sym_any] = ACTIONS(2558),
    [anon_sym_number] = ACTIONS(2558),
    [anon_sym_boolean] = ACTIONS(2558),
    [anon_sym_string] = ACTIONS(2558),
    [anon_sym_symbol] = ACTIONS(2558),
    [anon_sym_property] = ACTIONS(2558),
    [anon_sym_signal] = ACTIONS(2558),
    [anon_sym_on] = ACTIONS(2558),
    [anon_sym_required] = ACTIONS(2558),
    [anon_sym_component] = ACTIONS(2558),
    [anon_sym_abstract] = ACTIONS(2558),
    [anon_sym_interface] = ACTIONS(2558),
    [anon_sym_enum] = ACTIONS(2558),
  },
  [765] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [766] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [767] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [768] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [769] = {
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_export] = ACTIONS(2562),
    [anon_sym_default] = ACTIONS(2562),
    [anon_sym_type] = ACTIONS(2562),
    [anon_sym_namespace] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_typeof] = ACTIONS(2562),
    [anon_sym_import] = ACTIONS(2562),
    [anon_sym_from] = ACTIONS(2562),
    [anon_sym_var] = ACTIONS(2562),
    [anon_sym_let] = ACTIONS(2562),
    [anon_sym_const] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2564),
    [anon_sym_else] = ACTIONS(2562),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_switch] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2564),
    [anon_sym_await] = ACTIONS(2562),
    [anon_sym_of] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [anon_sym_do] = ACTIONS(2562),
    [anon_sym_try] = ACTIONS(2562),
    [anon_sym_with] = ACTIONS(2562),
    [anon_sym_break] = ACTIONS(2562),
    [anon_sym_continue] = ACTIONS(2562),
    [anon_sym_debugger] = ACTIONS(2562),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_throw] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_case] = ACTIONS(2562),
    [anon_sym_yield] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_LTtemplate_GT] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2562),
    [anon_sym_SLASH] = ACTIONS(2562),
    [anon_sym_class] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2562),
    [anon_sym_function] = ACTIONS(2562),
    [anon_sym_new] = ACTIONS(2562),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2562),
    [anon_sym_TILDE] = ACTIONS(2564),
    [anon_sym_void] = ACTIONS(2562),
    [anon_sym_delete] = ACTIONS(2562),
    [anon_sym_PLUS_PLUS] = ACTIONS(2564),
    [anon_sym_DASH_DASH] = ACTIONS(2564),
    [anon_sym_DQUOTE] = ACTIONS(2564),
    [anon_sym_SQUOTE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2564),
    [sym_number] = ACTIONS(2564),
    [sym_this] = ACTIONS(2562),
    [sym_super] = ACTIONS(2562),
    [sym_true] = ACTIONS(2562),
    [sym_false] = ACTIONS(2562),
    [sym_null] = ACTIONS(2562),
    [sym_undefined] = ACTIONS(2562),
    [anon_sym_AT] = ACTIONS(2564),
    [anon_sym_static] = ACTIONS(2562),
    [anon_sym_readonly] = ACTIONS(2562),
    [anon_sym_get] = ACTIONS(2562),
    [anon_sym_set] = ACTIONS(2562),
    [anon_sym_declare] = ACTIONS(2562),
    [anon_sym_public] = ACTIONS(2562),
    [anon_sym_private] = ACTIONS(2562),
    [anon_sym_protected] = ACTIONS(2562),
    [anon_sym_override] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_any] = ACTIONS(2562),
    [anon_sym_number] = ACTIONS(2562),
    [anon_sym_boolean] = ACTIONS(2562),
    [anon_sym_string] = ACTIONS(2562),
    [anon_sym_symbol] = ACTIONS(2562),
    [anon_sym_property] = ACTIONS(2562),
    [anon_sym_signal] = ACTIONS(2562),
    [anon_sym_on] = ACTIONS(2562),
    [anon_sym_required] = ACTIONS(2562),
    [anon_sym_component] = ACTIONS(2562),
    [anon_sym_abstract] = ACTIONS(2562),
    [anon_sym_interface] = ACTIONS(2562),
    [anon_sym_enum] = ACTIONS(2562),
  },
  [770] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [771] = {
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_export] = ACTIONS(2566),
    [anon_sym_default] = ACTIONS(2566),
    [anon_sym_type] = ACTIONS(2566),
    [anon_sym_namespace] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2568),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_typeof] = ACTIONS(2566),
    [anon_sym_import] = ACTIONS(2566),
    [anon_sym_from] = ACTIONS(2566),
    [anon_sym_var] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2568),
    [anon_sym_else] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_switch] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2568),
    [anon_sym_await] = ACTIONS(2566),
    [anon_sym_of] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_with] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_continue] = ACTIONS(2566),
    [anon_sym_debugger] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_throw] = ACTIONS(2566),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_case] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_LTtemplate_GT] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_SLASH] = ACTIONS(2566),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_async] = ACTIONS(2566),
    [anon_sym_function] = ACTIONS(2566),
    [anon_sym_new] = ACTIONS(2566),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_DASH] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2568),
    [anon_sym_void] = ACTIONS(2566),
    [anon_sym_delete] = ACTIONS(2566),
    [anon_sym_PLUS_PLUS] = ACTIONS(2568),
    [anon_sym_DASH_DASH] = ACTIONS(2568),
    [anon_sym_DQUOTE] = ACTIONS(2568),
    [anon_sym_SQUOTE] = ACTIONS(2568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2568),
    [sym_number] = ACTIONS(2568),
    [sym_this] = ACTIONS(2566),
    [sym_super] = ACTIONS(2566),
    [sym_true] = ACTIONS(2566),
    [sym_false] = ACTIONS(2566),
    [sym_null] = ACTIONS(2566),
    [sym_undefined] = ACTIONS(2566),
    [anon_sym_AT] = ACTIONS(2568),
    [anon_sym_static] = ACTIONS(2566),
    [anon_sym_readonly] = ACTIONS(2566),
    [anon_sym_get] = ACTIONS(2566),
    [anon_sym_set] = ACTIONS(2566),
    [anon_sym_declare] = ACTIONS(2566),
    [anon_sym_public] = ACTIONS(2566),
    [anon_sym_private] = ACTIONS(2566),
    [anon_sym_protected] = ACTIONS(2566),
    [anon_sym_override] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_any] = ACTIONS(2566),
    [anon_sym_number] = ACTIONS(2566),
    [anon_sym_boolean] = ACTIONS(2566),
    [anon_sym_string] = ACTIONS(2566),
    [anon_sym_symbol] = ACTIONS(2566),
    [anon_sym_property] = ACTIONS(2566),
    [anon_sym_signal] = ACTIONS(2566),
    [anon_sym_on] = ACTIONS(2566),
    [anon_sym_required] = ACTIONS(2566),
    [anon_sym_component] = ACTIONS(2566),
    [anon_sym_abstract] = ACTIONS(2566),
    [anon_sym_interface] = ACTIONS(2566),
    [anon_sym_enum] = ACTIONS(2566),
  },
  [772] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [773] = {
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_default] = ACTIONS(2570),
    [anon_sym_type] = ACTIONS(2570),
    [anon_sym_namespace] = ACTIONS(2570),
    [anon_sym_LBRACE] = ACTIONS(2572),
    [anon_sym_RBRACE] = ACTIONS(2572),
    [anon_sym_typeof] = ACTIONS(2570),
    [anon_sym_import] = ACTIONS(2570),
    [anon_sym_from] = ACTIONS(2570),
    [anon_sym_var] = ACTIONS(2570),
    [anon_sym_let] = ACTIONS(2570),
    [anon_sym_const] = ACTIONS(2570),
    [anon_sym_BANG] = ACTIONS(2572),
    [anon_sym_else] = ACTIONS(2570),
    [anon_sym_if] = ACTIONS(2570),
    [anon_sym_switch] = ACTIONS(2570),
    [anon_sym_for] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [anon_sym_await] = ACTIONS(2570),
    [anon_sym_of] = ACTIONS(2570),
    [anon_sym_while] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2570),
    [anon_sym_try] = ACTIONS(2570),
    [anon_sym_with] = ACTIONS(2570),
    [anon_sym_break] = ACTIONS(2570),
    [anon_sym_continue] = ACTIONS(2570),
    [anon_sym_debugger] = ACTIONS(2570),
    [anon_sym_return] = ACTIONS(2570),
    [anon_sym_throw] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2572),
    [anon_sym_case] = ACTIONS(2570),
    [anon_sym_yield] = ACTIONS(2570),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_LTtemplate_GT] = ACTIONS(2572),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_SLASH] = ACTIONS(2570),
    [anon_sym_class] = ACTIONS(2570),
    [anon_sym_async] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2570),
    [anon_sym_new] = ACTIONS(2570),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(2570),
    [anon_sym_TILDE] = ACTIONS(2572),
    [anon_sym_void] = ACTIONS(2570),
    [anon_sym_delete] = ACTIONS(2570),
    [anon_sym_PLUS_PLUS] = ACTIONS(2572),
    [anon_sym_DASH_DASH] = ACTIONS(2572),
    [anon_sym_DQUOTE] = ACTIONS(2572),
    [anon_sym_SQUOTE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2572),
    [sym_number] = ACTIONS(2572),
    [sym_this] = ACTIONS(2570),
    [sym_super] = ACTIONS(2570),
    [sym_true] = ACTIONS(2570),
    [sym_false] = ACTIONS(2570),
    [sym_null] = ACTIONS(2570),
    [sym_undefined] = ACTIONS(2570),
    [anon_sym_AT] = ACTIONS(2572),
    [anon_sym_static] = ACTIONS(2570),
    [anon_sym_readonly] = ACTIONS(2570),
    [anon_sym_get] = ACTIONS(2570),
    [anon_sym_set] = ACTIONS(2570),
    [anon_sym_declare] = ACTIONS(2570),
    [anon_sym_public] = ACTIONS(2570),
    [anon_sym_private] = ACTIONS(2570),
    [anon_sym_protected] = ACTIONS(2570),
    [anon_sym_override] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_any] = ACTIONS(2570),
    [anon_sym_number] = ACTIONS(2570),
    [anon_sym_boolean] = ACTIONS(2570),
    [anon_sym_string] = ACTIONS(2570),
    [anon_sym_symbol] = ACTIONS(2570),
    [anon_sym_property] = ACTIONS(2570),
    [anon_sym_signal] = ACTIONS(2570),
    [anon_sym_on] = ACTIONS(2570),
    [anon_sym_required] = ACTIONS(2570),
    [anon_sym_component] = ACTIONS(2570),
    [anon_sym_abstract] = ACTIONS(2570),
    [anon_sym_interface] = ACTIONS(2570),
    [anon_sym_enum] = ACTIONS(2570),
  },
  [774] = {
    [sym_identifier] = ACTIONS(2574),
    [anon_sym_export] = ACTIONS(2574),
    [anon_sym_default] = ACTIONS(2574),
    [anon_sym_type] = ACTIONS(2574),
    [anon_sym_namespace] = ACTIONS(2574),
    [anon_sym_LBRACE] = ACTIONS(2576),
    [anon_sym_RBRACE] = ACTIONS(2576),
    [anon_sym_typeof] = ACTIONS(2574),
    [anon_sym_import] = ACTIONS(2574),
    [anon_sym_from] = ACTIONS(2574),
    [anon_sym_var] = ACTIONS(2574),
    [anon_sym_let] = ACTIONS(2574),
    [anon_sym_const] = ACTIONS(2574),
    [anon_sym_BANG] = ACTIONS(2576),
    [anon_sym_else] = ACTIONS(2574),
    [anon_sym_if] = ACTIONS(2574),
    [anon_sym_switch] = ACTIONS(2574),
    [anon_sym_for] = ACTIONS(2574),
    [anon_sym_LPAREN] = ACTIONS(2576),
    [anon_sym_await] = ACTIONS(2574),
    [anon_sym_of] = ACTIONS(2574),
    [anon_sym_while] = ACTIONS(2574),
    [anon_sym_do] = ACTIONS(2574),
    [anon_sym_try] = ACTIONS(2574),
    [anon_sym_with] = ACTIONS(2574),
    [anon_sym_break] = ACTIONS(2574),
    [anon_sym_continue] = ACTIONS(2574),
    [anon_sym_debugger] = ACTIONS(2574),
    [anon_sym_return] = ACTIONS(2574),
    [anon_sym_throw] = ACTIONS(2574),
    [anon_sym_SEMI] = ACTIONS(2576),
    [anon_sym_case] = ACTIONS(2574),
    [anon_sym_yield] = ACTIONS(2574),
    [anon_sym_LBRACK] = ACTIONS(2576),
    [anon_sym_LTtemplate_GT] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2574),
    [anon_sym_SLASH] = ACTIONS(2574),
    [anon_sym_class] = ACTIONS(2574),
    [anon_sym_async] = ACTIONS(2574),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_new] = ACTIONS(2574),
    [anon_sym_PLUS] = ACTIONS(2574),
    [anon_sym_DASH] = ACTIONS(2574),
    [anon_sym_TILDE] = ACTIONS(2576),
    [anon_sym_void] = ACTIONS(2574),
    [anon_sym_delete] = ACTIONS(2574),
    [anon_sym_PLUS_PLUS] = ACTIONS(2576),
    [anon_sym_DASH_DASH] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2576),
    [anon_sym_SQUOTE] = ACTIONS(2576),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2576),
    [sym_number] = ACTIONS(2576),
    [sym_this] = ACTIONS(2574),
    [sym_super] = ACTIONS(2574),
    [sym_true] = ACTIONS(2574),
    [sym_false] = ACTIONS(2574),
    [sym_null] = ACTIONS(2574),
    [sym_undefined] = ACTIONS(2574),
    [anon_sym_AT] = ACTIONS(2576),
    [anon_sym_static] = ACTIONS(2574),
    [anon_sym_readonly] = ACTIONS(2574),
    [anon_sym_get] = ACTIONS(2574),
    [anon_sym_set] = ACTIONS(2574),
    [anon_sym_declare] = ACTIONS(2574),
    [anon_sym_public] = ACTIONS(2574),
    [anon_sym_private] = ACTIONS(2574),
    [anon_sym_protected] = ACTIONS(2574),
    [anon_sym_override] = ACTIONS(2574),
    [anon_sym_module] = ACTIONS(2574),
    [anon_sym_any] = ACTIONS(2574),
    [anon_sym_number] = ACTIONS(2574),
    [anon_sym_boolean] = ACTIONS(2574),
    [anon_sym_string] = ACTIONS(2574),
    [anon_sym_symbol] = ACTIONS(2574),
    [anon_sym_property] = ACTIONS(2574),
    [anon_sym_signal] = ACTIONS(2574),
    [anon_sym_on] = ACTIONS(2574),
    [anon_sym_required] = ACTIONS(2574),
    [anon_sym_component] = ACTIONS(2574),
    [anon_sym_abstract] = ACTIONS(2574),
    [anon_sym_interface] = ACTIONS(2574),
    [anon_sym_enum] = ACTIONS(2574),
  },
  [775] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [776] = {
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_export] = ACTIONS(2578),
    [anon_sym_default] = ACTIONS(2578),
    [anon_sym_type] = ACTIONS(2578),
    [anon_sym_namespace] = ACTIONS(2578),
    [anon_sym_LBRACE] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_typeof] = ACTIONS(2578),
    [anon_sym_import] = ACTIONS(2578),
    [anon_sym_from] = ACTIONS(2578),
    [anon_sym_var] = ACTIONS(2578),
    [anon_sym_let] = ACTIONS(2578),
    [anon_sym_const] = ACTIONS(2578),
    [anon_sym_BANG] = ACTIONS(2580),
    [anon_sym_else] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_switch] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2580),
    [anon_sym_await] = ACTIONS(2578),
    [anon_sym_of] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_try] = ACTIONS(2578),
    [anon_sym_with] = ACTIONS(2578),
    [anon_sym_break] = ACTIONS(2578),
    [anon_sym_continue] = ACTIONS(2578),
    [anon_sym_debugger] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_throw] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_case] = ACTIONS(2578),
    [anon_sym_yield] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_LTtemplate_GT] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_SLASH] = ACTIONS(2578),
    [anon_sym_class] = ACTIONS(2578),
    [anon_sym_async] = ACTIONS(2578),
    [anon_sym_function] = ACTIONS(2578),
    [anon_sym_new] = ACTIONS(2578),
    [anon_sym_PLUS] = ACTIONS(2578),
    [anon_sym_DASH] = ACTIONS(2578),
    [anon_sym_TILDE] = ACTIONS(2580),
    [anon_sym_void] = ACTIONS(2578),
    [anon_sym_delete] = ACTIONS(2578),
    [anon_sym_PLUS_PLUS] = ACTIONS(2580),
    [anon_sym_DASH_DASH] = ACTIONS(2580),
    [anon_sym_DQUOTE] = ACTIONS(2580),
    [anon_sym_SQUOTE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2580),
    [sym_number] = ACTIONS(2580),
    [sym_this] = ACTIONS(2578),
    [sym_super] = ACTIONS(2578),
    [sym_true] = ACTIONS(2578),
    [sym_false] = ACTIONS(2578),
    [sym_null] = ACTIONS(2578),
    [sym_undefined] = ACTIONS(2578),
    [anon_sym_AT] = ACTIONS(2580),
    [anon_sym_static] = ACTIONS(2578),
    [anon_sym_readonly] = ACTIONS(2578),
    [anon_sym_get] = ACTIONS(2578),
    [anon_sym_set] = ACTIONS(2578),
    [anon_sym_declare] = ACTIONS(2578),
    [anon_sym_public] = ACTIONS(2578),
    [anon_sym_private] = ACTIONS(2578),
    [anon_sym_protected] = ACTIONS(2578),
    [anon_sym_override] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_any] = ACTIONS(2578),
    [anon_sym_number] = ACTIONS(2578),
    [anon_sym_boolean] = ACTIONS(2578),
    [anon_sym_string] = ACTIONS(2578),
    [anon_sym_symbol] = ACTIONS(2578),
    [anon_sym_property] = ACTIONS(2578),
    [anon_sym_signal] = ACTIONS(2578),
    [anon_sym_on] = ACTIONS(2578),
    [anon_sym_required] = ACTIONS(2578),
    [anon_sym_component] = ACTIONS(2578),
    [anon_sym_abstract] = ACTIONS(2578),
    [anon_sym_interface] = ACTIONS(2578),
    [anon_sym_enum] = ACTIONS(2578),
  },
  [777] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [778] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [779] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [780] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [781] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [782] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [783] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [784] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [785] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [786] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [787] = {
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_export] = ACTIONS(2582),
    [anon_sym_default] = ACTIONS(2582),
    [anon_sym_type] = ACTIONS(2582),
    [anon_sym_namespace] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_typeof] = ACTIONS(2582),
    [anon_sym_import] = ACTIONS(2582),
    [anon_sym_from] = ACTIONS(2582),
    [anon_sym_var] = ACTIONS(2582),
    [anon_sym_let] = ACTIONS(2582),
    [anon_sym_const] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2584),
    [anon_sym_else] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_switch] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_await] = ACTIONS(2582),
    [anon_sym_of] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_try] = ACTIONS(2582),
    [anon_sym_with] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_continue] = ACTIONS(2582),
    [anon_sym_debugger] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_throw] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LTtemplate_GT] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_SLASH] = ACTIONS(2582),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_async] = ACTIONS(2582),
    [anon_sym_function] = ACTIONS(2582),
    [anon_sym_new] = ACTIONS(2582),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_DASH] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [anon_sym_void] = ACTIONS(2582),
    [anon_sym_delete] = ACTIONS(2582),
    [anon_sym_PLUS_PLUS] = ACTIONS(2584),
    [anon_sym_DASH_DASH] = ACTIONS(2584),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_SQUOTE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [sym_number] = ACTIONS(2584),
    [sym_this] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_null] = ACTIONS(2582),
    [sym_undefined] = ACTIONS(2582),
    [anon_sym_AT] = ACTIONS(2584),
    [anon_sym_static] = ACTIONS(2582),
    [anon_sym_readonly] = ACTIONS(2582),
    [anon_sym_get] = ACTIONS(2582),
    [anon_sym_set] = ACTIONS(2582),
    [anon_sym_declare] = ACTIONS(2582),
    [anon_sym_public] = ACTIONS(2582),
    [anon_sym_private] = ACTIONS(2582),
    [anon_sym_protected] = ACTIONS(2582),
    [anon_sym_override] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_any] = ACTIONS(2582),
    [anon_sym_number] = ACTIONS(2582),
    [anon_sym_boolean] = ACTIONS(2582),
    [anon_sym_string] = ACTIONS(2582),
    [anon_sym_symbol] = ACTIONS(2582),
    [anon_sym_property] = ACTIONS(2582),
    [anon_sym_signal] = ACTIONS(2582),
    [anon_sym_on] = ACTIONS(2582),
    [anon_sym_required] = ACTIONS(2582),
    [anon_sym_component] = ACTIONS(2582),
    [anon_sym_abstract] = ACTIONS(2582),
    [anon_sym_interface] = ACTIONS(2582),
    [anon_sym_enum] = ACTIONS(2582),
  },
  [788] = {
    [sym_identifier] = ACTIONS(2354),
    [anon_sym_export] = ACTIONS(2354),
    [anon_sym_default] = ACTIONS(2354),
    [anon_sym_type] = ACTIONS(2354),
    [anon_sym_namespace] = ACTIONS(2354),
    [anon_sym_LBRACE] = ACTIONS(2356),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2354),
    [anon_sym_import] = ACTIONS(2354),
    [anon_sym_from] = ACTIONS(2354),
    [anon_sym_var] = ACTIONS(2354),
    [anon_sym_let] = ACTIONS(2354),
    [anon_sym_const] = ACTIONS(2354),
    [anon_sym_BANG] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(2354),
    [anon_sym_switch] = ACTIONS(2354),
    [anon_sym_for] = ACTIONS(2354),
    [anon_sym_LPAREN] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2354),
    [anon_sym_of] = ACTIONS(2354),
    [anon_sym_while] = ACTIONS(2354),
    [anon_sym_do] = ACTIONS(2354),
    [anon_sym_try] = ACTIONS(2354),
    [anon_sym_with] = ACTIONS(2354),
    [anon_sym_break] = ACTIONS(2354),
    [anon_sym_continue] = ACTIONS(2354),
    [anon_sym_debugger] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2354),
    [anon_sym_throw] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2354),
    [anon_sym_yield] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(2356),
    [anon_sym_LTtemplate_GT] = ACTIONS(2356),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_SLASH] = ACTIONS(2354),
    [anon_sym_class] = ACTIONS(2354),
    [anon_sym_async] = ACTIONS(2354),
    [anon_sym_function] = ACTIONS(2354),
    [anon_sym_new] = ACTIONS(2354),
    [anon_sym_PLUS] = ACTIONS(2354),
    [anon_sym_DASH] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2356),
    [anon_sym_void] = ACTIONS(2354),
    [anon_sym_delete] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2356),
    [anon_sym_DASH_DASH] = ACTIONS(2356),
    [anon_sym_DQUOTE] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2356),
    [sym_number] = ACTIONS(2356),
    [sym_this] = ACTIONS(2354),
    [sym_super] = ACTIONS(2354),
    [sym_true] = ACTIONS(2354),
    [sym_false] = ACTIONS(2354),
    [sym_null] = ACTIONS(2354),
    [sym_undefined] = ACTIONS(2354),
    [anon_sym_AT] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2354),
    [anon_sym_readonly] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2354),
    [anon_sym_set] = ACTIONS(2354),
    [anon_sym_declare] = ACTIONS(2354),
    [anon_sym_public] = ACTIONS(2354),
    [anon_sym_private] = ACTIONS(2354),
    [anon_sym_protected] = ACTIONS(2354),
    [anon_sym_override] = ACTIONS(2354),
    [anon_sym_module] = ACTIONS(2354),
    [anon_sym_any] = ACTIONS(2354),
    [anon_sym_number] = ACTIONS(2354),
    [anon_sym_boolean] = ACTIONS(2354),
    [anon_sym_string] = ACTIONS(2354),
    [anon_sym_symbol] = ACTIONS(2354),
    [anon_sym_property] = ACTIONS(2354),
    [anon_sym_signal] = ACTIONS(2354),
    [anon_sym_on] = ACTIONS(2354),
    [anon_sym_required] = ACTIONS(2354),
    [anon_sym_component] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2354),
    [anon_sym_interface] = ACTIONS(2354),
    [anon_sym_enum] = ACTIONS(2354),
  },
  [789] = {
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_export] = ACTIONS(2502),
    [anon_sym_default] = ACTIONS(2502),
    [anon_sym_type] = ACTIONS(2502),
    [anon_sym_namespace] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2504),
    [anon_sym_RBRACE] = ACTIONS(2504),
    [anon_sym_typeof] = ACTIONS(2502),
    [anon_sym_import] = ACTIONS(2502),
    [anon_sym_from] = ACTIONS(2502),
    [anon_sym_var] = ACTIONS(2502),
    [anon_sym_let] = ACTIONS(2502),
    [anon_sym_const] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2504),
    [anon_sym_else] = ACTIONS(2502),
    [anon_sym_if] = ACTIONS(2502),
    [anon_sym_switch] = ACTIONS(2502),
    [anon_sym_for] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2504),
    [anon_sym_await] = ACTIONS(2502),
    [anon_sym_of] = ACTIONS(2502),
    [anon_sym_while] = ACTIONS(2502),
    [anon_sym_do] = ACTIONS(2502),
    [anon_sym_try] = ACTIONS(2502),
    [anon_sym_with] = ACTIONS(2502),
    [anon_sym_break] = ACTIONS(2502),
    [anon_sym_continue] = ACTIONS(2502),
    [anon_sym_debugger] = ACTIONS(2502),
    [anon_sym_return] = ACTIONS(2502),
    [anon_sym_throw] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_case] = ACTIONS(2502),
    [anon_sym_yield] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_LTtemplate_GT] = ACTIONS(2504),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_SLASH] = ACTIONS(2502),
    [anon_sym_class] = ACTIONS(2502),
    [anon_sym_async] = ACTIONS(2502),
    [anon_sym_function] = ACTIONS(2502),
    [anon_sym_new] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2502),
    [anon_sym_TILDE] = ACTIONS(2504),
    [anon_sym_void] = ACTIONS(2502),
    [anon_sym_delete] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2504),
    [anon_sym_DASH_DASH] = ACTIONS(2504),
    [anon_sym_DQUOTE] = ACTIONS(2504),
    [anon_sym_SQUOTE] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2504),
    [sym_number] = ACTIONS(2504),
    [sym_this] = ACTIONS(2502),
    [sym_super] = ACTIONS(2502),
    [sym_true] = ACTIONS(2502),
    [sym_false] = ACTIONS(2502),
    [sym_null] = ACTIONS(2502),
    [sym_undefined] = ACTIONS(2502),
    [anon_sym_AT] = ACTIONS(2504),
    [anon_sym_static] = ACTIONS(2502),
    [anon_sym_readonly] = ACTIONS(2502),
    [anon_sym_get] = ACTIONS(2502),
    [anon_sym_set] = ACTIONS(2502),
    [anon_sym_declare] = ACTIONS(2502),
    [anon_sym_public] = ACTIONS(2502),
    [anon_sym_private] = ACTIONS(2502),
    [anon_sym_protected] = ACTIONS(2502),
    [anon_sym_override] = ACTIONS(2502),
    [anon_sym_module] = ACTIONS(2502),
    [anon_sym_any] = ACTIONS(2502),
    [anon_sym_number] = ACTIONS(2502),
    [anon_sym_boolean] = ACTIONS(2502),
    [anon_sym_string] = ACTIONS(2502),
    [anon_sym_symbol] = ACTIONS(2502),
    [anon_sym_property] = ACTIONS(2502),
    [anon_sym_signal] = ACTIONS(2502),
    [anon_sym_on] = ACTIONS(2502),
    [anon_sym_required] = ACTIONS(2502),
    [anon_sym_component] = ACTIONS(2502),
    [anon_sym_abstract] = ACTIONS(2502),
    [anon_sym_interface] = ACTIONS(2502),
    [anon_sym_enum] = ACTIONS(2502),
  },
  [790] = {
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_export] = ACTIONS(2586),
    [anon_sym_default] = ACTIONS(2586),
    [anon_sym_type] = ACTIONS(2586),
    [anon_sym_namespace] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_typeof] = ACTIONS(2586),
    [anon_sym_import] = ACTIONS(2586),
    [anon_sym_from] = ACTIONS(2586),
    [anon_sym_var] = ACTIONS(2586),
    [anon_sym_let] = ACTIONS(2586),
    [anon_sym_const] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_else] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_switch] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_await] = ACTIONS(2586),
    [anon_sym_of] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [anon_sym_do] = ACTIONS(2586),
    [anon_sym_try] = ACTIONS(2586),
    [anon_sym_with] = ACTIONS(2586),
    [anon_sym_break] = ACTIONS(2586),
    [anon_sym_continue] = ACTIONS(2586),
    [anon_sym_debugger] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_throw] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2586),
    [anon_sym_yield] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LTtemplate_GT] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_SLASH] = ACTIONS(2586),
    [anon_sym_class] = ACTIONS(2586),
    [anon_sym_async] = ACTIONS(2586),
    [anon_sym_function] = ACTIONS(2586),
    [anon_sym_new] = ACTIONS(2586),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_DASH] = ACTIONS(2586),
    [anon_sym_TILDE] = ACTIONS(2588),
    [anon_sym_void] = ACTIONS(2586),
    [anon_sym_delete] = ACTIONS(2586),
    [anon_sym_PLUS_PLUS] = ACTIONS(2588),
    [anon_sym_DASH_DASH] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2588),
    [anon_sym_SQUOTE] = ACTIONS(2588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2588),
    [sym_number] = ACTIONS(2588),
    [sym_this] = ACTIONS(2586),
    [sym_super] = ACTIONS(2586),
    [sym_true] = ACTIONS(2586),
    [sym_false] = ACTIONS(2586),
    [sym_null] = ACTIONS(2586),
    [sym_undefined] = ACTIONS(2586),
    [anon_sym_AT] = ACTIONS(2588),
    [anon_sym_static] = ACTIONS(2586),
    [anon_sym_readonly] = ACTIONS(2586),
    [anon_sym_get] = ACTIONS(2586),
    [anon_sym_set] = ACTIONS(2586),
    [anon_sym_declare] = ACTIONS(2586),
    [anon_sym_public] = ACTIONS(2586),
    [anon_sym_private] = ACTIONS(2586),
    [anon_sym_protected] = ACTIONS(2586),
    [anon_sym_override] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_any] = ACTIONS(2586),
    [anon_sym_number] = ACTIONS(2586),
    [anon_sym_boolean] = ACTIONS(2586),
    [anon_sym_string] = ACTIONS(2586),
    [anon_sym_symbol] = ACTIONS(2586),
    [anon_sym_property] = ACTIONS(2586),
    [anon_sym_signal] = ACTIONS(2586),
    [anon_sym_on] = ACTIONS(2586),
    [anon_sym_required] = ACTIONS(2586),
    [anon_sym_component] = ACTIONS(2586),
    [anon_sym_abstract] = ACTIONS(2586),
    [anon_sym_interface] = ACTIONS(2586),
    [anon_sym_enum] = ACTIONS(2586),
  },
  [791] = {
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1627),
    [anon_sym_default] = ACTIONS(1627),
    [anon_sym_type] = ACTIONS(1627),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(1629),
    [anon_sym_RBRACE] = ACTIONS(1629),
    [anon_sym_typeof] = ACTIONS(1627),
    [anon_sym_import] = ACTIONS(1627),
    [anon_sym_from] = ACTIONS(1627),
    [anon_sym_var] = ACTIONS(1627),
    [anon_sym_let] = ACTIONS(1627),
    [anon_sym_const] = ACTIONS(1627),
    [anon_sym_BANG] = ACTIONS(1629),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_switch] = ACTIONS(1627),
    [anon_sym_for] = ACTIONS(1627),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_await] = ACTIONS(1627),
    [anon_sym_of] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_try] = ACTIONS(1627),
    [anon_sym_with] = ACTIONS(1627),
    [anon_sym_break] = ACTIONS(1627),
    [anon_sym_continue] = ACTIONS(1627),
    [anon_sym_debugger] = ACTIONS(1627),
    [anon_sym_return] = ACTIONS(1627),
    [anon_sym_throw] = ACTIONS(1627),
    [anon_sym_SEMI] = ACTIONS(1629),
    [anon_sym_case] = ACTIONS(1627),
    [anon_sym_yield] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1629),
    [anon_sym_LTtemplate_GT] = ACTIONS(1629),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1627),
    [anon_sym_class] = ACTIONS(1627),
    [anon_sym_async] = ACTIONS(1627),
    [anon_sym_function] = ACTIONS(1627),
    [anon_sym_new] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_TILDE] = ACTIONS(1629),
    [anon_sym_void] = ACTIONS(1627),
    [anon_sym_delete] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1629),
    [anon_sym_DASH_DASH] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(1629),
    [anon_sym_SQUOTE] = ACTIONS(1629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1629),
    [sym_number] = ACTIONS(1629),
    [sym_this] = ACTIONS(1627),
    [sym_super] = ACTIONS(1627),
    [sym_true] = ACTIONS(1627),
    [sym_false] = ACTIONS(1627),
    [sym_null] = ACTIONS(1627),
    [sym_undefined] = ACTIONS(1627),
    [anon_sym_AT] = ACTIONS(1629),
    [anon_sym_static] = ACTIONS(1627),
    [anon_sym_readonly] = ACTIONS(1627),
    [anon_sym_get] = ACTIONS(1627),
    [anon_sym_set] = ACTIONS(1627),
    [anon_sym_declare] = ACTIONS(1627),
    [anon_sym_public] = ACTIONS(1627),
    [anon_sym_private] = ACTIONS(1627),
    [anon_sym_protected] = ACTIONS(1627),
    [anon_sym_override] = ACTIONS(1627),
    [anon_sym_module] = ACTIONS(1627),
    [anon_sym_any] = ACTIONS(1627),
    [anon_sym_number] = ACTIONS(1627),
    [anon_sym_boolean] = ACTIONS(1627),
    [anon_sym_string] = ACTIONS(1627),
    [anon_sym_symbol] = ACTIONS(1627),
    [anon_sym_property] = ACTIONS(1627),
    [anon_sym_signal] = ACTIONS(1627),
    [anon_sym_on] = ACTIONS(1627),
    [anon_sym_required] = ACTIONS(1627),
    [anon_sym_component] = ACTIONS(1627),
    [anon_sym_abstract] = ACTIONS(1627),
    [anon_sym_interface] = ACTIONS(1627),
    [anon_sym_enum] = ACTIONS(1627),
  },
  [792] = {
    [sym_identifier] = ACTIONS(2590),
    [anon_sym_export] = ACTIONS(2590),
    [anon_sym_default] = ACTIONS(2590),
    [anon_sym_type] = ACTIONS(2590),
    [anon_sym_namespace] = ACTIONS(2590),
    [anon_sym_LBRACE] = ACTIONS(2592),
    [anon_sym_RBRACE] = ACTIONS(2592),
    [anon_sym_typeof] = ACTIONS(2590),
    [anon_sym_import] = ACTIONS(2590),
    [anon_sym_from] = ACTIONS(2590),
    [anon_sym_var] = ACTIONS(2590),
    [anon_sym_let] = ACTIONS(2590),
    [anon_sym_const] = ACTIONS(2590),
    [anon_sym_BANG] = ACTIONS(2592),
    [anon_sym_else] = ACTIONS(2590),
    [anon_sym_if] = ACTIONS(2590),
    [anon_sym_switch] = ACTIONS(2590),
    [anon_sym_for] = ACTIONS(2590),
    [anon_sym_LPAREN] = ACTIONS(2592),
    [anon_sym_await] = ACTIONS(2590),
    [anon_sym_of] = ACTIONS(2590),
    [anon_sym_while] = ACTIONS(2590),
    [anon_sym_do] = ACTIONS(2590),
    [anon_sym_try] = ACTIONS(2590),
    [anon_sym_with] = ACTIONS(2590),
    [anon_sym_break] = ACTIONS(2590),
    [anon_sym_continue] = ACTIONS(2590),
    [anon_sym_debugger] = ACTIONS(2590),
    [anon_sym_return] = ACTIONS(2590),
    [anon_sym_throw] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym_case] = ACTIONS(2590),
    [anon_sym_yield] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2592),
    [anon_sym_LTtemplate_GT] = ACTIONS(2592),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_SLASH] = ACTIONS(2590),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_async] = ACTIONS(2590),
    [anon_sym_function] = ACTIONS(2590),
    [anon_sym_new] = ACTIONS(2590),
    [anon_sym_PLUS] = ACTIONS(2590),
    [anon_sym_DASH] = ACTIONS(2590),
    [anon_sym_TILDE] = ACTIONS(2592),
    [anon_sym_void] = ACTIONS(2590),
    [anon_sym_delete] = ACTIONS(2590),
    [anon_sym_PLUS_PLUS] = ACTIONS(2592),
    [anon_sym_DASH_DASH] = ACTIONS(2592),
    [anon_sym_DQUOTE] = ACTIONS(2592),
    [anon_sym_SQUOTE] = ACTIONS(2592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2592),
    [sym_number] = ACTIONS(2592),
    [sym_this] = ACTIONS(2590),
    [sym_super] = ACTIONS(2590),
    [sym_true] = ACTIONS(2590),
    [sym_false] = ACTIONS(2590),
    [sym_null] = ACTIONS(2590),
    [sym_undefined] = ACTIONS(2590),
    [anon_sym_AT] = ACTIONS(2592),
    [anon_sym_static] = ACTIONS(2590),
    [anon_sym_readonly] = ACTIONS(2590),
    [anon_sym_get] = ACTIONS(2590),
    [anon_sym_set] = ACTIONS(2590),
    [anon_sym_declare] = ACTIONS(2590),
    [anon_sym_public] = ACTIONS(2590),
    [anon_sym_private] = ACTIONS(2590),
    [anon_sym_protected] = ACTIONS(2590),
    [anon_sym_override] = ACTIONS(2590),
    [anon_sym_module] = ACTIONS(2590),
    [anon_sym_any] = ACTIONS(2590),
    [anon_sym_number] = ACTIONS(2590),
    [anon_sym_boolean] = ACTIONS(2590),
    [anon_sym_string] = ACTIONS(2590),
    [anon_sym_symbol] = ACTIONS(2590),
    [anon_sym_property] = ACTIONS(2590),
    [anon_sym_signal] = ACTIONS(2590),
    [anon_sym_on] = ACTIONS(2590),
    [anon_sym_required] = ACTIONS(2590),
    [anon_sym_component] = ACTIONS(2590),
    [anon_sym_abstract] = ACTIONS(2590),
    [anon_sym_interface] = ACTIONS(2590),
    [anon_sym_enum] = ACTIONS(2590),
  },
  [793] = {
    [sym_identifier] = ACTIONS(2594),
    [anon_sym_export] = ACTIONS(2594),
    [anon_sym_default] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2594),
    [anon_sym_namespace] = ACTIONS(2594),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_RBRACE] = ACTIONS(2596),
    [anon_sym_typeof] = ACTIONS(2594),
    [anon_sym_import] = ACTIONS(2594),
    [anon_sym_from] = ACTIONS(2594),
    [anon_sym_var] = ACTIONS(2594),
    [anon_sym_let] = ACTIONS(2594),
    [anon_sym_const] = ACTIONS(2594),
    [anon_sym_BANG] = ACTIONS(2596),
    [anon_sym_else] = ACTIONS(2594),
    [anon_sym_if] = ACTIONS(2594),
    [anon_sym_switch] = ACTIONS(2594),
    [anon_sym_for] = ACTIONS(2594),
    [anon_sym_LPAREN] = ACTIONS(2596),
    [anon_sym_await] = ACTIONS(2594),
    [anon_sym_of] = ACTIONS(2594),
    [anon_sym_while] = ACTIONS(2594),
    [anon_sym_do] = ACTIONS(2594),
    [anon_sym_try] = ACTIONS(2594),
    [anon_sym_with] = ACTIONS(2594),
    [anon_sym_break] = ACTIONS(2594),
    [anon_sym_continue] = ACTIONS(2594),
    [anon_sym_debugger] = ACTIONS(2594),
    [anon_sym_return] = ACTIONS(2594),
    [anon_sym_throw] = ACTIONS(2594),
    [anon_sym_SEMI] = ACTIONS(2596),
    [anon_sym_case] = ACTIONS(2594),
    [anon_sym_yield] = ACTIONS(2594),
    [anon_sym_LBRACK] = ACTIONS(2596),
    [anon_sym_LTtemplate_GT] = ACTIONS(2596),
    [anon_sym_LT] = ACTIONS(2594),
    [anon_sym_SLASH] = ACTIONS(2594),
    [anon_sym_class] = ACTIONS(2594),
    [anon_sym_async] = ACTIONS(2594),
    [anon_sym_function] = ACTIONS(2594),
    [anon_sym_new] = ACTIONS(2594),
    [anon_sym_PLUS] = ACTIONS(2594),
    [anon_sym_DASH] = ACTIONS(2594),
    [anon_sym_TILDE] = ACTIONS(2596),
    [anon_sym_void] = ACTIONS(2594),
    [anon_sym_delete] = ACTIONS(2594),
    [anon_sym_PLUS_PLUS] = ACTIONS(2596),
    [anon_sym_DASH_DASH] = ACTIONS(2596),
    [anon_sym_DQUOTE] = ACTIONS(2596),
    [anon_sym_SQUOTE] = ACTIONS(2596),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2596),
    [sym_number] = ACTIONS(2596),
    [sym_this] = ACTIONS(2594),
    [sym_super] = ACTIONS(2594),
    [sym_true] = ACTIONS(2594),
    [sym_false] = ACTIONS(2594),
    [sym_null] = ACTIONS(2594),
    [sym_undefined] = ACTIONS(2594),
    [anon_sym_AT] = ACTIONS(2596),
    [anon_sym_static] = ACTIONS(2594),
    [anon_sym_readonly] = ACTIONS(2594),
    [anon_sym_get] = ACTIONS(2594),
    [anon_sym_set] = ACTIONS(2594),
    [anon_sym_declare] = ACTIONS(2594),
    [anon_sym_public] = ACTIONS(2594),
    [anon_sym_private] = ACTIONS(2594),
    [anon_sym_protected] = ACTIONS(2594),
    [anon_sym_override] = ACTIONS(2594),
    [anon_sym_module] = ACTIONS(2594),
    [anon_sym_any] = ACTIONS(2594),
    [anon_sym_number] = ACTIONS(2594),
    [anon_sym_boolean] = ACTIONS(2594),
    [anon_sym_string] = ACTIONS(2594),
    [anon_sym_symbol] = ACTIONS(2594),
    [anon_sym_property] = ACTIONS(2594),
    [anon_sym_signal] = ACTIONS(2594),
    [anon_sym_on] = ACTIONS(2594),
    [anon_sym_required] = ACTIONS(2594),
    [anon_sym_component] = ACTIONS(2594),
    [anon_sym_abstract] = ACTIONS(2594),
    [anon_sym_interface] = ACTIONS(2594),
    [anon_sym_enum] = ACTIONS(2594),
  },
  [794] = {
    [sym_identifier] = ACTIONS(2598),
    [anon_sym_export] = ACTIONS(2598),
    [anon_sym_default] = ACTIONS(2598),
    [anon_sym_type] = ACTIONS(2598),
    [anon_sym_namespace] = ACTIONS(2598),
    [anon_sym_LBRACE] = ACTIONS(2600),
    [anon_sym_RBRACE] = ACTIONS(2600),
    [anon_sym_typeof] = ACTIONS(2598),
    [anon_sym_import] = ACTIONS(2598),
    [anon_sym_from] = ACTIONS(2598),
    [anon_sym_var] = ACTIONS(2598),
    [anon_sym_let] = ACTIONS(2598),
    [anon_sym_const] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2600),
    [anon_sym_else] = ACTIONS(2598),
    [anon_sym_if] = ACTIONS(2598),
    [anon_sym_switch] = ACTIONS(2598),
    [anon_sym_for] = ACTIONS(2598),
    [anon_sym_LPAREN] = ACTIONS(2600),
    [anon_sym_await] = ACTIONS(2598),
    [anon_sym_of] = ACTIONS(2598),
    [anon_sym_while] = ACTIONS(2598),
    [anon_sym_do] = ACTIONS(2598),
    [anon_sym_try] = ACTIONS(2598),
    [anon_sym_with] = ACTIONS(2598),
    [anon_sym_break] = ACTIONS(2598),
    [anon_sym_continue] = ACTIONS(2598),
    [anon_sym_debugger] = ACTIONS(2598),
    [anon_sym_return] = ACTIONS(2598),
    [anon_sym_throw] = ACTIONS(2598),
    [anon_sym_SEMI] = ACTIONS(2600),
    [anon_sym_case] = ACTIONS(2598),
    [anon_sym_yield] = ACTIONS(2598),
    [anon_sym_LBRACK] = ACTIONS(2600),
    [anon_sym_LTtemplate_GT] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(2598),
    [anon_sym_SLASH] = ACTIONS(2598),
    [anon_sym_class] = ACTIONS(2598),
    [anon_sym_async] = ACTIONS(2598),
    [anon_sym_function] = ACTIONS(2598),
    [anon_sym_new] = ACTIONS(2598),
    [anon_sym_PLUS] = ACTIONS(2598),
    [anon_sym_DASH] = ACTIONS(2598),
    [anon_sym_TILDE] = ACTIONS(2600),
    [anon_sym_void] = ACTIONS(2598),
    [anon_sym_delete] = ACTIONS(2598),
    [anon_sym_PLUS_PLUS] = ACTIONS(2600),
    [anon_sym_DASH_DASH] = ACTIONS(2600),
    [anon_sym_DQUOTE] = ACTIONS(2600),
    [anon_sym_SQUOTE] = ACTIONS(2600),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2600),
    [sym_number] = ACTIONS(2600),
    [sym_this] = ACTIONS(2598),
    [sym_super] = ACTIONS(2598),
    [sym_true] = ACTIONS(2598),
    [sym_false] = ACTIONS(2598),
    [sym_null] = ACTIONS(2598),
    [sym_undefined] = ACTIONS(2598),
    [anon_sym_AT] = ACTIONS(2600),
    [anon_sym_static] = ACTIONS(2598),
    [anon_sym_readonly] = ACTIONS(2598),
    [anon_sym_get] = ACTIONS(2598),
    [anon_sym_set] = ACTIONS(2598),
    [anon_sym_declare] = ACTIONS(2598),
    [anon_sym_public] = ACTIONS(2598),
    [anon_sym_private] = ACTIONS(2598),
    [anon_sym_protected] = ACTIONS(2598),
    [anon_sym_override] = ACTIONS(2598),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_any] = ACTIONS(2598),
    [anon_sym_number] = ACTIONS(2598),
    [anon_sym_boolean] = ACTIONS(2598),
    [anon_sym_string] = ACTIONS(2598),
    [anon_sym_symbol] = ACTIONS(2598),
    [anon_sym_property] = ACTIONS(2598),
    [anon_sym_signal] = ACTIONS(2598),
    [anon_sym_on] = ACTIONS(2598),
    [anon_sym_required] = ACTIONS(2598),
    [anon_sym_component] = ACTIONS(2598),
    [anon_sym_abstract] = ACTIONS(2598),
    [anon_sym_interface] = ACTIONS(2598),
    [anon_sym_enum] = ACTIONS(2598),
  },
  [795] = {
    [sym_identifier] = ACTIONS(2602),
    [anon_sym_export] = ACTIONS(2602),
    [anon_sym_default] = ACTIONS(2602),
    [anon_sym_type] = ACTIONS(2602),
    [anon_sym_namespace] = ACTIONS(2602),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_RBRACE] = ACTIONS(2604),
    [anon_sym_typeof] = ACTIONS(2602),
    [anon_sym_import] = ACTIONS(2602),
    [anon_sym_from] = ACTIONS(2602),
    [anon_sym_var] = ACTIONS(2602),
    [anon_sym_let] = ACTIONS(2602),
    [anon_sym_const] = ACTIONS(2602),
    [anon_sym_BANG] = ACTIONS(2604),
    [anon_sym_else] = ACTIONS(2602),
    [anon_sym_if] = ACTIONS(2602),
    [anon_sym_switch] = ACTIONS(2602),
    [anon_sym_for] = ACTIONS(2602),
    [anon_sym_LPAREN] = ACTIONS(2604),
    [anon_sym_await] = ACTIONS(2602),
    [anon_sym_of] = ACTIONS(2602),
    [anon_sym_while] = ACTIONS(2602),
    [anon_sym_do] = ACTIONS(2602),
    [anon_sym_try] = ACTIONS(2602),
    [anon_sym_with] = ACTIONS(2602),
    [anon_sym_break] = ACTIONS(2602),
    [anon_sym_continue] = ACTIONS(2602),
    [anon_sym_debugger] = ACTIONS(2602),
    [anon_sym_return] = ACTIONS(2602),
    [anon_sym_throw] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2604),
    [anon_sym_case] = ACTIONS(2602),
    [anon_sym_yield] = ACTIONS(2602),
    [anon_sym_LBRACK] = ACTIONS(2604),
    [anon_sym_LTtemplate_GT] = ACTIONS(2604),
    [anon_sym_LT] = ACTIONS(2602),
    [anon_sym_SLASH] = ACTIONS(2602),
    [anon_sym_class] = ACTIONS(2602),
    [anon_sym_async] = ACTIONS(2602),
    [anon_sym_function] = ACTIONS(2602),
    [anon_sym_new] = ACTIONS(2602),
    [anon_sym_PLUS] = ACTIONS(2602),
    [anon_sym_DASH] = ACTIONS(2602),
    [anon_sym_TILDE] = ACTIONS(2604),
    [anon_sym_void] = ACTIONS(2602),
    [anon_sym_delete] = ACTIONS(2602),
    [anon_sym_PLUS_PLUS] = ACTIONS(2604),
    [anon_sym_DASH_DASH] = ACTIONS(2604),
    [anon_sym_DQUOTE] = ACTIONS(2604),
    [anon_sym_SQUOTE] = ACTIONS(2604),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2604),
    [sym_number] = ACTIONS(2604),
    [sym_this] = ACTIONS(2602),
    [sym_super] = ACTIONS(2602),
    [sym_true] = ACTIONS(2602),
    [sym_false] = ACTIONS(2602),
    [sym_null] = ACTIONS(2602),
    [sym_undefined] = ACTIONS(2602),
    [anon_sym_AT] = ACTIONS(2604),
    [anon_sym_static] = ACTIONS(2602),
    [anon_sym_readonly] = ACTIONS(2602),
    [anon_sym_get] = ACTIONS(2602),
    [anon_sym_set] = ACTIONS(2602),
    [anon_sym_declare] = ACTIONS(2602),
    [anon_sym_public] = ACTIONS(2602),
    [anon_sym_private] = ACTIONS(2602),
    [anon_sym_protected] = ACTIONS(2602),
    [anon_sym_override] = ACTIONS(2602),
    [anon_sym_module] = ACTIONS(2602),
    [anon_sym_any] = ACTIONS(2602),
    [anon_sym_number] = ACTIONS(2602),
    [anon_sym_boolean] = ACTIONS(2602),
    [anon_sym_string] = ACTIONS(2602),
    [anon_sym_symbol] = ACTIONS(2602),
    [anon_sym_property] = ACTIONS(2602),
    [anon_sym_signal] = ACTIONS(2602),
    [anon_sym_on] = ACTIONS(2602),
    [anon_sym_required] = ACTIONS(2602),
    [anon_sym_component] = ACTIONS(2602),
    [anon_sym_abstract] = ACTIONS(2602),
    [anon_sym_interface] = ACTIONS(2602),
    [anon_sym_enum] = ACTIONS(2602),
  },
  [796] = {
    [sym_identifier] = ACTIONS(2606),
    [anon_sym_export] = ACTIONS(2606),
    [anon_sym_default] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2606),
    [anon_sym_namespace] = ACTIONS(2606),
    [anon_sym_LBRACE] = ACTIONS(2608),
    [anon_sym_RBRACE] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2606),
    [anon_sym_import] = ACTIONS(2606),
    [anon_sym_from] = ACTIONS(2606),
    [anon_sym_var] = ACTIONS(2606),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_const] = ACTIONS(2606),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_else] = ACTIONS(2606),
    [anon_sym_if] = ACTIONS(2606),
    [anon_sym_switch] = ACTIONS(2606),
    [anon_sym_for] = ACTIONS(2606),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_await] = ACTIONS(2606),
    [anon_sym_of] = ACTIONS(2606),
    [anon_sym_while] = ACTIONS(2606),
    [anon_sym_do] = ACTIONS(2606),
    [anon_sym_try] = ACTIONS(2606),
    [anon_sym_with] = ACTIONS(2606),
    [anon_sym_break] = ACTIONS(2606),
    [anon_sym_continue] = ACTIONS(2606),
    [anon_sym_debugger] = ACTIONS(2606),
    [anon_sym_return] = ACTIONS(2606),
    [anon_sym_throw] = ACTIONS(2606),
    [anon_sym_SEMI] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2606),
    [anon_sym_yield] = ACTIONS(2606),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LTtemplate_GT] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2606),
    [anon_sym_SLASH] = ACTIONS(2606),
    [anon_sym_class] = ACTIONS(2606),
    [anon_sym_async] = ACTIONS(2606),
    [anon_sym_function] = ACTIONS(2606),
    [anon_sym_new] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2606),
    [anon_sym_DASH] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2608),
    [anon_sym_void] = ACTIONS(2606),
    [anon_sym_delete] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(2608),
    [anon_sym_DASH_DASH] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2608),
    [anon_sym_SQUOTE] = ACTIONS(2608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2608),
    [sym_number] = ACTIONS(2608),
    [sym_this] = ACTIONS(2606),
    [sym_super] = ACTIONS(2606),
    [sym_true] = ACTIONS(2606),
    [sym_false] = ACTIONS(2606),
    [sym_null] = ACTIONS(2606),
    [sym_undefined] = ACTIONS(2606),
    [anon_sym_AT] = ACTIONS(2608),
    [anon_sym_static] = ACTIONS(2606),
    [anon_sym_readonly] = ACTIONS(2606),
    [anon_sym_get] = ACTIONS(2606),
    [anon_sym_set] = ACTIONS(2606),
    [anon_sym_declare] = ACTIONS(2606),
    [anon_sym_public] = ACTIONS(2606),
    [anon_sym_private] = ACTIONS(2606),
    [anon_sym_protected] = ACTIONS(2606),
    [anon_sym_override] = ACTIONS(2606),
    [anon_sym_module] = ACTIONS(2606),
    [anon_sym_any] = ACTIONS(2606),
    [anon_sym_number] = ACTIONS(2606),
    [anon_sym_boolean] = ACTIONS(2606),
    [anon_sym_string] = ACTIONS(2606),
    [anon_sym_symbol] = ACTIONS(2606),
    [anon_sym_property] = ACTIONS(2606),
    [anon_sym_signal] = ACTIONS(2606),
    [anon_sym_on] = ACTIONS(2606),
    [anon_sym_required] = ACTIONS(2606),
    [anon_sym_component] = ACTIONS(2606),
    [anon_sym_abstract] = ACTIONS(2606),
    [anon_sym_interface] = ACTIONS(2606),
    [anon_sym_enum] = ACTIONS(2606),
  },
  [797] = {
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_export] = ACTIONS(2582),
    [anon_sym_default] = ACTIONS(2582),
    [anon_sym_type] = ACTIONS(2582),
    [anon_sym_namespace] = ACTIONS(2582),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_typeof] = ACTIONS(2582),
    [anon_sym_import] = ACTIONS(2582),
    [anon_sym_from] = ACTIONS(2582),
    [anon_sym_var] = ACTIONS(2582),
    [anon_sym_let] = ACTIONS(2582),
    [anon_sym_const] = ACTIONS(2582),
    [anon_sym_BANG] = ACTIONS(2584),
    [anon_sym_else] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_switch] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_await] = ACTIONS(2582),
    [anon_sym_of] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_try] = ACTIONS(2582),
    [anon_sym_with] = ACTIONS(2582),
    [anon_sym_break] = ACTIONS(2582),
    [anon_sym_continue] = ACTIONS(2582),
    [anon_sym_debugger] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_throw] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_case] = ACTIONS(2582),
    [anon_sym_yield] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_LTtemplate_GT] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_SLASH] = ACTIONS(2582),
    [anon_sym_class] = ACTIONS(2582),
    [anon_sym_async] = ACTIONS(2582),
    [anon_sym_function] = ACTIONS(2582),
    [anon_sym_new] = ACTIONS(2582),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_DASH] = ACTIONS(2582),
    [anon_sym_TILDE] = ACTIONS(2584),
    [anon_sym_void] = ACTIONS(2582),
    [anon_sym_delete] = ACTIONS(2582),
    [anon_sym_PLUS_PLUS] = ACTIONS(2584),
    [anon_sym_DASH_DASH] = ACTIONS(2584),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_SQUOTE] = ACTIONS(2584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [sym_number] = ACTIONS(2584),
    [sym_this] = ACTIONS(2582),
    [sym_super] = ACTIONS(2582),
    [sym_true] = ACTIONS(2582),
    [sym_false] = ACTIONS(2582),
    [sym_null] = ACTIONS(2582),
    [sym_undefined] = ACTIONS(2582),
    [anon_sym_AT] = ACTIONS(2584),
    [anon_sym_static] = ACTIONS(2582),
    [anon_sym_readonly] = ACTIONS(2582),
    [anon_sym_get] = ACTIONS(2582),
    [anon_sym_set] = ACTIONS(2582),
    [anon_sym_declare] = ACTIONS(2582),
    [anon_sym_public] = ACTIONS(2582),
    [anon_sym_private] = ACTIONS(2582),
    [anon_sym_protected] = ACTIONS(2582),
    [anon_sym_override] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_any] = ACTIONS(2582),
    [anon_sym_number] = ACTIONS(2582),
    [anon_sym_boolean] = ACTIONS(2582),
    [anon_sym_string] = ACTIONS(2582),
    [anon_sym_symbol] = ACTIONS(2582),
    [anon_sym_property] = ACTIONS(2582),
    [anon_sym_signal] = ACTIONS(2582),
    [anon_sym_on] = ACTIONS(2582),
    [anon_sym_required] = ACTIONS(2582),
    [anon_sym_component] = ACTIONS(2582),
    [anon_sym_abstract] = ACTIONS(2582),
    [anon_sym_interface] = ACTIONS(2582),
    [anon_sym_enum] = ACTIONS(2582),
  },
  [798] = {
    [sym_identifier] = ACTIONS(2610),
    [anon_sym_export] = ACTIONS(2610),
    [anon_sym_default] = ACTIONS(2610),
    [anon_sym_type] = ACTIONS(2610),
    [anon_sym_namespace] = ACTIONS(2610),
    [anon_sym_LBRACE] = ACTIONS(2612),
    [anon_sym_RBRACE] = ACTIONS(2612),
    [anon_sym_typeof] = ACTIONS(2610),
    [anon_sym_import] = ACTIONS(2610),
    [anon_sym_from] = ACTIONS(2610),
    [anon_sym_var] = ACTIONS(2610),
    [anon_sym_let] = ACTIONS(2610),
    [anon_sym_const] = ACTIONS(2610),
    [anon_sym_BANG] = ACTIONS(2612),
    [anon_sym_else] = ACTIONS(2610),
    [anon_sym_if] = ACTIONS(2610),
    [anon_sym_switch] = ACTIONS(2610),
    [anon_sym_for] = ACTIONS(2610),
    [anon_sym_LPAREN] = ACTIONS(2612),
    [anon_sym_await] = ACTIONS(2610),
    [anon_sym_of] = ACTIONS(2610),
    [anon_sym_while] = ACTIONS(2610),
    [anon_sym_do] = ACTIONS(2610),
    [anon_sym_try] = ACTIONS(2610),
    [anon_sym_with] = ACTIONS(2610),
    [anon_sym_break] = ACTIONS(2610),
    [anon_sym_continue] = ACTIONS(2610),
    [anon_sym_debugger] = ACTIONS(2610),
    [anon_sym_return] = ACTIONS(2610),
    [anon_sym_throw] = ACTIONS(2610),
    [anon_sym_SEMI] = ACTIONS(2612),
    [anon_sym_case] = ACTIONS(2610),
    [anon_sym_yield] = ACTIONS(2610),
    [anon_sym_LBRACK] = ACTIONS(2612),
    [anon_sym_LTtemplate_GT] = ACTIONS(2612),
    [anon_sym_LT] = ACTIONS(2610),
    [anon_sym_SLASH] = ACTIONS(2610),
    [anon_sym_class] = ACTIONS(2610),
    [anon_sym_async] = ACTIONS(2610),
    [anon_sym_function] = ACTIONS(2610),
    [anon_sym_new] = ACTIONS(2610),
    [anon_sym_PLUS] = ACTIONS(2610),
    [anon_sym_DASH] = ACTIONS(2610),
    [anon_sym_TILDE] = ACTIONS(2612),
    [anon_sym_void] = ACTIONS(2610),
    [anon_sym_delete] = ACTIONS(2610),
    [anon_sym_PLUS_PLUS] = ACTIONS(2612),
    [anon_sym_DASH_DASH] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_SQUOTE] = ACTIONS(2612),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [sym_number] = ACTIONS(2612),
    [sym_this] = ACTIONS(2610),
    [sym_super] = ACTIONS(2610),
    [sym_true] = ACTIONS(2610),
    [sym_false] = ACTIONS(2610),
    [sym_null] = ACTIONS(2610),
    [sym_undefined] = ACTIONS(2610),
    [anon_sym_AT] = ACTIONS(2612),
    [anon_sym_static] = ACTIONS(2610),
    [anon_sym_readonly] = ACTIONS(2610),
    [anon_sym_get] = ACTIONS(2610),
    [anon_sym_set] = ACTIONS(2610),
    [anon_sym_declare] = ACTIONS(2610),
    [anon_sym_public] = ACTIONS(2610),
    [anon_sym_private] = ACTIONS(2610),
    [anon_sym_protected] = ACTIONS(2610),
    [anon_sym_override] = ACTIONS(2610),
    [anon_sym_module] = ACTIONS(2610),
    [anon_sym_any] = ACTIONS(2610),
    [anon_sym_number] = ACTIONS(2610),
    [anon_sym_boolean] = ACTIONS(2610),
    [anon_sym_string] = ACTIONS(2610),
    [anon_sym_symbol] = ACTIONS(2610),
    [anon_sym_property] = ACTIONS(2610),
    [anon_sym_signal] = ACTIONS(2610),
    [anon_sym_on] = ACTIONS(2610),
    [anon_sym_required] = ACTIONS(2610),
    [anon_sym_component] = ACTIONS(2610),
    [anon_sym_abstract] = ACTIONS(2610),
    [anon_sym_interface] = ACTIONS(2610),
    [anon_sym_enum] = ACTIONS(2610),
  },
  [799] = {
    [sym_identifier] = ACTIONS(2614),
    [anon_sym_export] = ACTIONS(2614),
    [anon_sym_default] = ACTIONS(2614),
    [anon_sym_type] = ACTIONS(2614),
    [anon_sym_namespace] = ACTIONS(2614),
    [anon_sym_LBRACE] = ACTIONS(2616),
    [anon_sym_RBRACE] = ACTIONS(2616),
    [anon_sym_typeof] = ACTIONS(2614),
    [anon_sym_import] = ACTIONS(2614),
    [anon_sym_from] = ACTIONS(2614),
    [anon_sym_var] = ACTIONS(2614),
    [anon_sym_let] = ACTIONS(2614),
    [anon_sym_const] = ACTIONS(2614),
    [anon_sym_BANG] = ACTIONS(2616),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_if] = ACTIONS(2614),
    [anon_sym_switch] = ACTIONS(2614),
    [anon_sym_for] = ACTIONS(2614),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_await] = ACTIONS(2614),
    [anon_sym_of] = ACTIONS(2614),
    [anon_sym_while] = ACTIONS(2614),
    [anon_sym_do] = ACTIONS(2614),
    [anon_sym_try] = ACTIONS(2614),
    [anon_sym_with] = ACTIONS(2614),
    [anon_sym_break] = ACTIONS(2614),
    [anon_sym_continue] = ACTIONS(2614),
    [anon_sym_debugger] = ACTIONS(2614),
    [anon_sym_return] = ACTIONS(2614),
    [anon_sym_throw] = ACTIONS(2614),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_case] = ACTIONS(2614),
    [anon_sym_yield] = ACTIONS(2614),
    [anon_sym_LBRACK] = ACTIONS(2616),
    [anon_sym_LTtemplate_GT] = ACTIONS(2616),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_SLASH] = ACTIONS(2614),
    [anon_sym_class] = ACTIONS(2614),
    [anon_sym_async] = ACTIONS(2614),
    [anon_sym_function] = ACTIONS(2614),
    [anon_sym_new] = ACTIONS(2614),
    [anon_sym_PLUS] = ACTIONS(2614),
    [anon_sym_DASH] = ACTIONS(2614),
    [anon_sym_TILDE] = ACTIONS(2616),
    [anon_sym_void] = ACTIONS(2614),
    [anon_sym_delete] = ACTIONS(2614),
    [anon_sym_PLUS_PLUS] = ACTIONS(2616),
    [anon_sym_DASH_DASH] = ACTIONS(2616),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [anon_sym_SQUOTE] = ACTIONS(2616),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [sym_number] = ACTIONS(2616),
    [sym_this] = ACTIONS(2614),
    [sym_super] = ACTIONS(2614),
    [sym_true] = ACTIONS(2614),
    [sym_false] = ACTIONS(2614),
    [sym_null] = ACTIONS(2614),
    [sym_undefined] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(2616),
    [anon_sym_static] = ACTIONS(2614),
    [anon_sym_readonly] = ACTIONS(2614),
    [anon_sym_get] = ACTIONS(2614),
    [anon_sym_set] = ACTIONS(2614),
    [anon_sym_declare] = ACTIONS(2614),
    [anon_sym_public] = ACTIONS(2614),
    [anon_sym_private] = ACTIONS(2614),
    [anon_sym_protected] = ACTIONS(2614),
    [anon_sym_override] = ACTIONS(2614),
    [anon_sym_module] = ACTIONS(2614),
    [anon_sym_any] = ACTIONS(2614),
    [anon_sym_number] = ACTIONS(2614),
    [anon_sym_boolean] = ACTIONS(2614),
    [anon_sym_string] = ACTIONS(2614),
    [anon_sym_symbol] = ACTIONS(2614),
    [anon_sym_property] = ACTIONS(2614),
    [anon_sym_signal] = ACTIONS(2614),
    [anon_sym_on] = ACTIONS(2614),
    [anon_sym_required] = ACTIONS(2614),
    [anon_sym_component] = ACTIONS(2614),
    [anon_sym_abstract] = ACTIONS(2614),
    [anon_sym_interface] = ACTIONS(2614),
    [anon_sym_enum] = ACTIONS(2614),
  },
  [800] = {
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_default] = ACTIONS(2618),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_RBRACE] = ACTIONS(2620),
    [anon_sym_typeof] = ACTIONS(2618),
    [anon_sym_import] = ACTIONS(2618),
    [anon_sym_from] = ACTIONS(2618),
    [anon_sym_var] = ACTIONS(2618),
    [anon_sym_let] = ACTIONS(2618),
    [anon_sym_const] = ACTIONS(2618),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_else] = ACTIONS(2618),
    [anon_sym_if] = ACTIONS(2618),
    [anon_sym_switch] = ACTIONS(2618),
    [anon_sym_for] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(2620),
    [anon_sym_await] = ACTIONS(2618),
    [anon_sym_of] = ACTIONS(2618),
    [anon_sym_while] = ACTIONS(2618),
    [anon_sym_do] = ACTIONS(2618),
    [anon_sym_try] = ACTIONS(2618),
    [anon_sym_with] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2618),
    [anon_sym_continue] = ACTIONS(2618),
    [anon_sym_debugger] = ACTIONS(2618),
    [anon_sym_return] = ACTIONS(2618),
    [anon_sym_throw] = ACTIONS(2618),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_case] = ACTIONS(2618),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LTtemplate_GT] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_SLASH] = ACTIONS(2618),
    [anon_sym_class] = ACTIONS(2618),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_function] = ACTIONS(2618),
    [anon_sym_new] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2618),
    [anon_sym_DASH] = ACTIONS(2618),
    [anon_sym_TILDE] = ACTIONS(2620),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_delete] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(2620),
    [anon_sym_DASH_DASH] = ACTIONS(2620),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2620),
    [sym_number] = ACTIONS(2620),
    [sym_this] = ACTIONS(2618),
    [sym_super] = ACTIONS(2618),
    [sym_true] = ACTIONS(2618),
    [sym_false] = ACTIONS(2618),
    [sym_null] = ACTIONS(2618),
    [sym_undefined] = ACTIONS(2618),
    [anon_sym_AT] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_readonly] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_override] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [anon_sym_property] = ACTIONS(2618),
    [anon_sym_signal] = ACTIONS(2618),
    [anon_sym_on] = ACTIONS(2618),
    [anon_sym_required] = ACTIONS(2618),
    [anon_sym_component] = ACTIONS(2618),
    [anon_sym_abstract] = ACTIONS(2618),
    [anon_sym_interface] = ACTIONS(2618),
    [anon_sym_enum] = ACTIONS(2618),
  },
  [801] = {
    [sym_identifier] = ACTIONS(2606),
    [anon_sym_export] = ACTIONS(2606),
    [anon_sym_default] = ACTIONS(2606),
    [anon_sym_type] = ACTIONS(2606),
    [anon_sym_namespace] = ACTIONS(2606),
    [anon_sym_LBRACE] = ACTIONS(2608),
    [anon_sym_RBRACE] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2606),
    [anon_sym_import] = ACTIONS(2606),
    [anon_sym_from] = ACTIONS(2606),
    [anon_sym_var] = ACTIONS(2606),
    [anon_sym_let] = ACTIONS(2606),
    [anon_sym_const] = ACTIONS(2606),
    [anon_sym_BANG] = ACTIONS(2608),
    [anon_sym_else] = ACTIONS(2606),
    [anon_sym_if] = ACTIONS(2606),
    [anon_sym_switch] = ACTIONS(2606),
    [anon_sym_for] = ACTIONS(2606),
    [anon_sym_LPAREN] = ACTIONS(2608),
    [anon_sym_await] = ACTIONS(2606),
    [anon_sym_of] = ACTIONS(2606),
    [anon_sym_while] = ACTIONS(2606),
    [anon_sym_do] = ACTIONS(2606),
    [anon_sym_try] = ACTIONS(2606),
    [anon_sym_with] = ACTIONS(2606),
    [anon_sym_break] = ACTIONS(2606),
    [anon_sym_continue] = ACTIONS(2606),
    [anon_sym_debugger] = ACTIONS(2606),
    [anon_sym_return] = ACTIONS(2606),
    [anon_sym_throw] = ACTIONS(2606),
    [anon_sym_SEMI] = ACTIONS(2608),
    [anon_sym_case] = ACTIONS(2606),
    [anon_sym_yield] = ACTIONS(2606),
    [anon_sym_LBRACK] = ACTIONS(2608),
    [anon_sym_LTtemplate_GT] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2606),
    [anon_sym_SLASH] = ACTIONS(2606),
    [anon_sym_class] = ACTIONS(2606),
    [anon_sym_async] = ACTIONS(2606),
    [anon_sym_function] = ACTIONS(2606),
    [anon_sym_new] = ACTIONS(2606),
    [anon_sym_PLUS] = ACTIONS(2606),
    [anon_sym_DASH] = ACTIONS(2606),
    [anon_sym_TILDE] = ACTIONS(2608),
    [anon_sym_void] = ACTIONS(2606),
    [anon_sym_delete] = ACTIONS(2606),
    [anon_sym_PLUS_PLUS] = ACTIONS(2608),
    [anon_sym_DASH_DASH] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2608),
    [anon_sym_SQUOTE] = ACTIONS(2608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2608),
    [sym_number] = ACTIONS(2608),
    [sym_this] = ACTIONS(2606),
    [sym_super] = ACTIONS(2606),
    [sym_true] = ACTIONS(2606),
    [sym_false] = ACTIONS(2606),
    [sym_null] = ACTIONS(2606),
    [sym_undefined] = ACTIONS(2606),
    [anon_sym_AT] = ACTIONS(2608),
    [anon_sym_static] = ACTIONS(2606),
    [anon_sym_readonly] = ACTIONS(2606),
    [anon_sym_get] = ACTIONS(2606),
    [anon_sym_set] = ACTIONS(2606),
    [anon_sym_declare] = ACTIONS(2606),
    [anon_sym_public] = ACTIONS(2606),
    [anon_sym_private] = ACTIONS(2606),
    [anon_sym_protected] = ACTIONS(2606),
    [anon_sym_override] = ACTIONS(2606),
    [anon_sym_module] = ACTIONS(2606),
    [anon_sym_any] = ACTIONS(2606),
    [anon_sym_number] = ACTIONS(2606),
    [anon_sym_boolean] = ACTIONS(2606),
    [anon_sym_string] = ACTIONS(2606),
    [anon_sym_symbol] = ACTIONS(2606),
    [anon_sym_property] = ACTIONS(2606),
    [anon_sym_signal] = ACTIONS(2606),
    [anon_sym_on] = ACTIONS(2606),
    [anon_sym_required] = ACTIONS(2606),
    [anon_sym_component] = ACTIONS(2606),
    [anon_sym_abstract] = ACTIONS(2606),
    [anon_sym_interface] = ACTIONS(2606),
    [anon_sym_enum] = ACTIONS(2606),
  },
  [802] = {
    [sym_identifier] = ACTIONS(1631),
    [anon_sym_export] = ACTIONS(1631),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1631),
    [anon_sym_namespace] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_RBRACE] = ACTIONS(1633),
    [anon_sym_typeof] = ACTIONS(1631),
    [anon_sym_import] = ACTIONS(1631),
    [anon_sym_from] = ACTIONS(1631),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1631),
    [anon_sym_const] = ACTIONS(1631),
    [anon_sym_BANG] = ACTIONS(1633),
    [anon_sym_else] = ACTIONS(1631),
    [anon_sym_if] = ACTIONS(1631),
    [anon_sym_switch] = ACTIONS(1631),
    [anon_sym_for] = ACTIONS(1631),
    [anon_sym_LPAREN] = ACTIONS(1633),
    [anon_sym_await] = ACTIONS(1631),
    [anon_sym_of] = ACTIONS(1631),
    [anon_sym_while] = ACTIONS(1631),
    [anon_sym_do] = ACTIONS(1631),
    [anon_sym_try] = ACTIONS(1631),
    [anon_sym_with] = ACTIONS(1631),
    [anon_sym_break] = ACTIONS(1631),
    [anon_sym_continue] = ACTIONS(1631),
    [anon_sym_debugger] = ACTIONS(1631),
    [anon_sym_return] = ACTIONS(1631),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_case] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(1631),
    [anon_sym_LBRACK] = ACTIONS(1633),
    [anon_sym_LTtemplate_GT] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1631),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_class] = ACTIONS(1631),
    [anon_sym_async] = ACTIONS(1631),
    [anon_sym_function] = ACTIONS(1631),
    [anon_sym_new] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1631),
    [anon_sym_DASH] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1633),
    [anon_sym_void] = ACTIONS(1631),
    [anon_sym_delete] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1633),
    [anon_sym_DASH_DASH] = ACTIONS(1633),
    [anon_sym_DQUOTE] = ACTIONS(1633),
    [anon_sym_SQUOTE] = ACTIONS(1633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1633),
    [sym_number] = ACTIONS(1633),
    [sym_this] = ACTIONS(1631),
    [sym_super] = ACTIONS(1631),
    [sym_true] = ACTIONS(1631),
    [sym_false] = ACTIONS(1631),
    [sym_null] = ACTIONS(1631),
    [sym_undefined] = ACTIONS(1631),
    [anon_sym_AT] = ACTIONS(1633),
    [anon_sym_static] = ACTIONS(1631),
    [anon_sym_readonly] = ACTIONS(1631),
    [anon_sym_get] = ACTIONS(1631),
    [anon_sym_set] = ACTIONS(1631),
    [anon_sym_declare] = ACTIONS(1631),
    [anon_sym_public] = ACTIONS(1631),
    [anon_sym_private] = ACTIONS(1631),
    [anon_sym_protected] = ACTIONS(1631),
    [anon_sym_override] = ACTIONS(1631),
    [anon_sym_module] = ACTIONS(1631),
    [anon_sym_any] = ACTIONS(1631),
    [anon_sym_number] = ACTIONS(1631),
    [anon_sym_boolean] = ACTIONS(1631),
    [anon_sym_string] = ACTIONS(1631),
    [anon_sym_symbol] = ACTIONS(1631),
    [anon_sym_property] = ACTIONS(1631),
    [anon_sym_signal] = ACTIONS(1631),
    [anon_sym_on] = ACTIONS(1631),
    [anon_sym_required] = ACTIONS(1631),
    [anon_sym_component] = ACTIONS(1631),
    [anon_sym_abstract] = ACTIONS(1631),
    [anon_sym_interface] = ACTIONS(1631),
    [anon_sym_enum] = ACTIONS(1631),
  },
  [803] = {
    [sym_identifier] = ACTIONS(2622),
    [anon_sym_export] = ACTIONS(2622),
    [anon_sym_default] = ACTIONS(2622),
    [anon_sym_type] = ACTIONS(2622),
    [anon_sym_namespace] = ACTIONS(2622),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_RBRACE] = ACTIONS(2624),
    [anon_sym_typeof] = ACTIONS(2622),
    [anon_sym_import] = ACTIONS(2622),
    [anon_sym_from] = ACTIONS(2622),
    [anon_sym_var] = ACTIONS(2622),
    [anon_sym_let] = ACTIONS(2622),
    [anon_sym_const] = ACTIONS(2622),
    [anon_sym_BANG] = ACTIONS(2624),
    [anon_sym_else] = ACTIONS(2622),
    [anon_sym_if] = ACTIONS(2622),
    [anon_sym_switch] = ACTIONS(2622),
    [anon_sym_for] = ACTIONS(2622),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_await] = ACTIONS(2622),
    [anon_sym_of] = ACTIONS(2622),
    [anon_sym_while] = ACTIONS(2622),
    [anon_sym_do] = ACTIONS(2622),
    [anon_sym_try] = ACTIONS(2622),
    [anon_sym_with] = ACTIONS(2622),
    [anon_sym_break] = ACTIONS(2622),
    [anon_sym_continue] = ACTIONS(2622),
    [anon_sym_debugger] = ACTIONS(2622),
    [anon_sym_return] = ACTIONS(2622),
    [anon_sym_throw] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2624),
    [anon_sym_case] = ACTIONS(2622),
    [anon_sym_yield] = ACTIONS(2622),
    [anon_sym_LBRACK] = ACTIONS(2624),
    [anon_sym_LTtemplate_GT] = ACTIONS(2624),
    [anon_sym_LT] = ACTIONS(2622),
    [anon_sym_SLASH] = ACTIONS(2622),
    [anon_sym_class] = ACTIONS(2622),
    [anon_sym_async] = ACTIONS(2622),
    [anon_sym_function] = ACTIONS(2622),
    [anon_sym_new] = ACTIONS(2622),
    [anon_sym_PLUS] = ACTIONS(2622),
    [anon_sym_DASH] = ACTIONS(2622),
    [anon_sym_TILDE] = ACTIONS(2624),
    [anon_sym_void] = ACTIONS(2622),
    [anon_sym_delete] = ACTIONS(2622),
    [anon_sym_PLUS_PLUS] = ACTIONS(2624),
    [anon_sym_DASH_DASH] = ACTIONS(2624),
    [anon_sym_DQUOTE] = ACTIONS(2624),
    [anon_sym_SQUOTE] = ACTIONS(2624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2624),
    [sym_number] = ACTIONS(2624),
    [sym_this] = ACTIONS(2622),
    [sym_super] = ACTIONS(2622),
    [sym_true] = ACTIONS(2622),
    [sym_false] = ACTIONS(2622),
    [sym_null] = ACTIONS(2622),
    [sym_undefined] = ACTIONS(2622),
    [anon_sym_AT] = ACTIONS(2624),
    [anon_sym_static] = ACTIONS(2622),
    [anon_sym_readonly] = ACTIONS(2622),
    [anon_sym_get] = ACTIONS(2622),
    [anon_sym_set] = ACTIONS(2622),
    [anon_sym_declare] = ACTIONS(2622),
    [anon_sym_public] = ACTIONS(2622),
    [anon_sym_private] = ACTIONS(2622),
    [anon_sym_protected] = ACTIONS(2622),
    [anon_sym_override] = ACTIONS(2622),
    [anon_sym_module] = ACTIONS(2622),
    [anon_sym_any] = ACTIONS(2622),
    [anon_sym_number] = ACTIONS(2622),
    [anon_sym_boolean] = ACTIONS(2622),
    [anon_sym_string] = ACTIONS(2622),
    [anon_sym_symbol] = ACTIONS(2622),
    [anon_sym_property] = ACTIONS(2622),
    [anon_sym_signal] = ACTIONS(2622),
    [anon_sym_on] = ACTIONS(2622),
    [anon_sym_required] = ACTIONS(2622),
    [anon_sym_component] = ACTIONS(2622),
    [anon_sym_abstract] = ACTIONS(2622),
    [anon_sym_interface] = ACTIONS(2622),
    [anon_sym_enum] = ACTIONS(2622),
  },
  [804] = {
    [sym_identifier] = ACTIONS(2626),
    [anon_sym_export] = ACTIONS(2626),
    [anon_sym_default] = ACTIONS(2626),
    [anon_sym_type] = ACTIONS(2626),
    [anon_sym_namespace] = ACTIONS(2626),
    [anon_sym_LBRACE] = ACTIONS(2628),
    [anon_sym_RBRACE] = ACTIONS(2628),
    [anon_sym_typeof] = ACTIONS(2626),
    [anon_sym_import] = ACTIONS(2626),
    [anon_sym_from] = ACTIONS(2626),
    [anon_sym_var] = ACTIONS(2626),
    [anon_sym_let] = ACTIONS(2626),
    [anon_sym_const] = ACTIONS(2626),
    [anon_sym_BANG] = ACTIONS(2628),
    [anon_sym_else] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2626),
    [anon_sym_switch] = ACTIONS(2626),
    [anon_sym_for] = ACTIONS(2626),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_await] = ACTIONS(2626),
    [anon_sym_of] = ACTIONS(2626),
    [anon_sym_while] = ACTIONS(2626),
    [anon_sym_do] = ACTIONS(2626),
    [anon_sym_try] = ACTIONS(2626),
    [anon_sym_with] = ACTIONS(2626),
    [anon_sym_break] = ACTIONS(2626),
    [anon_sym_continue] = ACTIONS(2626),
    [anon_sym_debugger] = ACTIONS(2626),
    [anon_sym_return] = ACTIONS(2626),
    [anon_sym_throw] = ACTIONS(2626),
    [anon_sym_SEMI] = ACTIONS(2628),
    [anon_sym_case] = ACTIONS(2626),
    [anon_sym_yield] = ACTIONS(2626),
    [anon_sym_LBRACK] = ACTIONS(2628),
    [anon_sym_LTtemplate_GT] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2626),
    [anon_sym_SLASH] = ACTIONS(2626),
    [anon_sym_class] = ACTIONS(2626),
    [anon_sym_async] = ACTIONS(2626),
    [anon_sym_function] = ACTIONS(2626),
    [anon_sym_new] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2626),
    [anon_sym_DASH] = ACTIONS(2626),
    [anon_sym_TILDE] = ACTIONS(2628),
    [anon_sym_void] = ACTIONS(2626),
    [anon_sym_delete] = ACTIONS(2626),
    [anon_sym_PLUS_PLUS] = ACTIONS(2628),
    [anon_sym_DASH_DASH] = ACTIONS(2628),
    [anon_sym_DQUOTE] = ACTIONS(2628),
    [anon_sym_SQUOTE] = ACTIONS(2628),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2628),
    [sym_number] = ACTIONS(2628),
    [sym_this] = ACTIONS(2626),
    [sym_super] = ACTIONS(2626),
    [sym_true] = ACTIONS(2626),
    [sym_false] = ACTIONS(2626),
    [sym_null] = ACTIONS(2626),
    [sym_undefined] = ACTIONS(2626),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_static] = ACTIONS(2626),
    [anon_sym_readonly] = ACTIONS(2626),
    [anon_sym_get] = ACTIONS(2626),
    [anon_sym_set] = ACTIONS(2626),
    [anon_sym_declare] = ACTIONS(2626),
    [anon_sym_public] = ACTIONS(2626),
    [anon_sym_private] = ACTIONS(2626),
    [anon_sym_protected] = ACTIONS(2626),
    [anon_sym_override] = ACTIONS(2626),
    [anon_sym_module] = ACTIONS(2626),
    [anon_sym_any] = ACTIONS(2626),
    [anon_sym_number] = ACTIONS(2626),
    [anon_sym_boolean] = ACTIONS(2626),
    [anon_sym_string] = ACTIONS(2626),
    [anon_sym_symbol] = ACTIONS(2626),
    [anon_sym_property] = ACTIONS(2626),
    [anon_sym_signal] = ACTIONS(2626),
    [anon_sym_on] = ACTIONS(2626),
    [anon_sym_required] = ACTIONS(2626),
    [anon_sym_component] = ACTIONS(2626),
    [anon_sym_abstract] = ACTIONS(2626),
    [anon_sym_interface] = ACTIONS(2626),
    [anon_sym_enum] = ACTIONS(2626),
  },
  [805] = {
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_default] = ACTIONS(2618),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_RBRACE] = ACTIONS(2620),
    [anon_sym_typeof] = ACTIONS(2618),
    [anon_sym_import] = ACTIONS(2618),
    [anon_sym_from] = ACTIONS(2618),
    [anon_sym_var] = ACTIONS(2618),
    [anon_sym_let] = ACTIONS(2618),
    [anon_sym_const] = ACTIONS(2618),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_else] = ACTIONS(2618),
    [anon_sym_if] = ACTIONS(2618),
    [anon_sym_switch] = ACTIONS(2618),
    [anon_sym_for] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(2620),
    [anon_sym_await] = ACTIONS(2618),
    [anon_sym_of] = ACTIONS(2618),
    [anon_sym_while] = ACTIONS(2618),
    [anon_sym_do] = ACTIONS(2618),
    [anon_sym_try] = ACTIONS(2618),
    [anon_sym_with] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2618),
    [anon_sym_continue] = ACTIONS(2618),
    [anon_sym_debugger] = ACTIONS(2618),
    [anon_sym_return] = ACTIONS(2618),
    [anon_sym_throw] = ACTIONS(2618),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_case] = ACTIONS(2618),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LTtemplate_GT] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_SLASH] = ACTIONS(2618),
    [anon_sym_class] = ACTIONS(2618),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_function] = ACTIONS(2618),
    [anon_sym_new] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2618),
    [anon_sym_DASH] = ACTIONS(2618),
    [anon_sym_TILDE] = ACTIONS(2620),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_delete] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(2620),
    [anon_sym_DASH_DASH] = ACTIONS(2620),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2620),
    [sym_number] = ACTIONS(2620),
    [sym_this] = ACTIONS(2618),
    [sym_super] = ACTIONS(2618),
    [sym_true] = ACTIONS(2618),
    [sym_false] = ACTIONS(2618),
    [sym_null] = ACTIONS(2618),
    [sym_undefined] = ACTIONS(2618),
    [anon_sym_AT] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_readonly] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_override] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [anon_sym_property] = ACTIONS(2618),
    [anon_sym_signal] = ACTIONS(2618),
    [anon_sym_on] = ACTIONS(2618),
    [anon_sym_required] = ACTIONS(2618),
    [anon_sym_component] = ACTIONS(2618),
    [anon_sym_abstract] = ACTIONS(2618),
    [anon_sym_interface] = ACTIONS(2618),
    [anon_sym_enum] = ACTIONS(2618),
  },
  [806] = {
    [sym_identifier] = ACTIONS(2630),
    [anon_sym_export] = ACTIONS(2630),
    [anon_sym_default] = ACTIONS(2630),
    [anon_sym_type] = ACTIONS(2630),
    [anon_sym_namespace] = ACTIONS(2630),
    [anon_sym_LBRACE] = ACTIONS(2632),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_typeof] = ACTIONS(2630),
    [anon_sym_import] = ACTIONS(2630),
    [anon_sym_from] = ACTIONS(2630),
    [anon_sym_var] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(2630),
    [anon_sym_const] = ACTIONS(2630),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2630),
    [anon_sym_if] = ACTIONS(2630),
    [anon_sym_switch] = ACTIONS(2630),
    [anon_sym_for] = ACTIONS(2630),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_await] = ACTIONS(2630),
    [anon_sym_of] = ACTIONS(2630),
    [anon_sym_while] = ACTIONS(2630),
    [anon_sym_do] = ACTIONS(2630),
    [anon_sym_try] = ACTIONS(2630),
    [anon_sym_with] = ACTIONS(2630),
    [anon_sym_break] = ACTIONS(2630),
    [anon_sym_continue] = ACTIONS(2630),
    [anon_sym_debugger] = ACTIONS(2630),
    [anon_sym_return] = ACTIONS(2630),
    [anon_sym_throw] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2630),
    [anon_sym_yield] = ACTIONS(2630),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_LTtemplate_GT] = ACTIONS(2632),
    [anon_sym_LT] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2630),
    [anon_sym_class] = ACTIONS(2630),
    [anon_sym_async] = ACTIONS(2630),
    [anon_sym_function] = ACTIONS(2630),
    [anon_sym_new] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2630),
    [anon_sym_DASH] = ACTIONS(2630),
    [anon_sym_TILDE] = ACTIONS(2632),
    [anon_sym_void] = ACTIONS(2630),
    [anon_sym_delete] = ACTIONS(2630),
    [anon_sym_PLUS_PLUS] = ACTIONS(2632),
    [anon_sym_DASH_DASH] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [anon_sym_SQUOTE] = ACTIONS(2632),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [sym_number] = ACTIONS(2632),
    [sym_this] = ACTIONS(2630),
    [sym_super] = ACTIONS(2630),
    [sym_true] = ACTIONS(2630),
    [sym_false] = ACTIONS(2630),
    [sym_null] = ACTIONS(2630),
    [sym_undefined] = ACTIONS(2630),
    [anon_sym_AT] = ACTIONS(2632),
    [anon_sym_static] = ACTIONS(2630),
    [anon_sym_readonly] = ACTIONS(2630),
    [anon_sym_get] = ACTIONS(2630),
    [anon_sym_set] = ACTIONS(2630),
    [anon_sym_declare] = ACTIONS(2630),
    [anon_sym_public] = ACTIONS(2630),
    [anon_sym_private] = ACTIONS(2630),
    [anon_sym_protected] = ACTIONS(2630),
    [anon_sym_override] = ACTIONS(2630),
    [anon_sym_module] = ACTIONS(2630),
    [anon_sym_any] = ACTIONS(2630),
    [anon_sym_number] = ACTIONS(2630),
    [anon_sym_boolean] = ACTIONS(2630),
    [anon_sym_string] = ACTIONS(2630),
    [anon_sym_symbol] = ACTIONS(2630),
    [anon_sym_property] = ACTIONS(2630),
    [anon_sym_signal] = ACTIONS(2630),
    [anon_sym_on] = ACTIONS(2630),
    [anon_sym_required] = ACTIONS(2630),
    [anon_sym_component] = ACTIONS(2630),
    [anon_sym_abstract] = ACTIONS(2630),
    [anon_sym_interface] = ACTIONS(2630),
    [anon_sym_enum] = ACTIONS(2630),
  },
  [807] = {
    [sym_identifier] = ACTIONS(2634),
    [anon_sym_export] = ACTIONS(2634),
    [anon_sym_default] = ACTIONS(2634),
    [anon_sym_type] = ACTIONS(2634),
    [anon_sym_namespace] = ACTIONS(2634),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_typeof] = ACTIONS(2634),
    [anon_sym_import] = ACTIONS(2634),
    [anon_sym_from] = ACTIONS(2634),
    [anon_sym_var] = ACTIONS(2634),
    [anon_sym_let] = ACTIONS(2634),
    [anon_sym_const] = ACTIONS(2634),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_else] = ACTIONS(2634),
    [anon_sym_if] = ACTIONS(2634),
    [anon_sym_switch] = ACTIONS(2634),
    [anon_sym_for] = ACTIONS(2634),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_await] = ACTIONS(2634),
    [anon_sym_of] = ACTIONS(2634),
    [anon_sym_while] = ACTIONS(2634),
    [anon_sym_do] = ACTIONS(2634),
    [anon_sym_try] = ACTIONS(2634),
    [anon_sym_with] = ACTIONS(2634),
    [anon_sym_break] = ACTIONS(2634),
    [anon_sym_continue] = ACTIONS(2634),
    [anon_sym_debugger] = ACTIONS(2634),
    [anon_sym_return] = ACTIONS(2634),
    [anon_sym_throw] = ACTIONS(2634),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_yield] = ACTIONS(2634),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_LTtemplate_GT] = ACTIONS(2636),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_SLASH] = ACTIONS(2634),
    [anon_sym_class] = ACTIONS(2634),
    [anon_sym_async] = ACTIONS(2634),
    [anon_sym_function] = ACTIONS(2634),
    [anon_sym_new] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_TILDE] = ACTIONS(2636),
    [anon_sym_void] = ACTIONS(2634),
    [anon_sym_delete] = ACTIONS(2634),
    [anon_sym_PLUS_PLUS] = ACTIONS(2636),
    [anon_sym_DASH_DASH] = ACTIONS(2636),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [anon_sym_SQUOTE] = ACTIONS(2636),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [sym_number] = ACTIONS(2636),
    [sym_this] = ACTIONS(2634),
    [sym_super] = ACTIONS(2634),
    [sym_true] = ACTIONS(2634),
    [sym_false] = ACTIONS(2634),
    [sym_null] = ACTIONS(2634),
    [sym_undefined] = ACTIONS(2634),
    [anon_sym_AT] = ACTIONS(2636),
    [anon_sym_static] = ACTIONS(2634),
    [anon_sym_readonly] = ACTIONS(2634),
    [anon_sym_get] = ACTIONS(2634),
    [anon_sym_set] = ACTIONS(2634),
    [anon_sym_declare] = ACTIONS(2634),
    [anon_sym_public] = ACTIONS(2634),
    [anon_sym_private] = ACTIONS(2634),
    [anon_sym_protected] = ACTIONS(2634),
    [anon_sym_override] = ACTIONS(2634),
    [anon_sym_module] = ACTIONS(2634),
    [anon_sym_any] = ACTIONS(2634),
    [anon_sym_number] = ACTIONS(2634),
    [anon_sym_boolean] = ACTIONS(2634),
    [anon_sym_string] = ACTIONS(2634),
    [anon_sym_symbol] = ACTIONS(2634),
    [anon_sym_property] = ACTIONS(2634),
    [anon_sym_signal] = ACTIONS(2634),
    [anon_sym_on] = ACTIONS(2634),
    [anon_sym_required] = ACTIONS(2634),
    [anon_sym_component] = ACTIONS(2634),
    [anon_sym_abstract] = ACTIONS(2634),
    [anon_sym_interface] = ACTIONS(2634),
    [anon_sym_enum] = ACTIONS(2634),
  },
  [808] = {
    [sym_identifier] = ACTIONS(2618),
    [anon_sym_export] = ACTIONS(2618),
    [anon_sym_default] = ACTIONS(2618),
    [anon_sym_type] = ACTIONS(2618),
    [anon_sym_namespace] = ACTIONS(2618),
    [anon_sym_LBRACE] = ACTIONS(2620),
    [anon_sym_RBRACE] = ACTIONS(2620),
    [anon_sym_typeof] = ACTIONS(2618),
    [anon_sym_import] = ACTIONS(2618),
    [anon_sym_from] = ACTIONS(2618),
    [anon_sym_var] = ACTIONS(2618),
    [anon_sym_let] = ACTIONS(2618),
    [anon_sym_const] = ACTIONS(2618),
    [anon_sym_BANG] = ACTIONS(2620),
    [anon_sym_else] = ACTIONS(2618),
    [anon_sym_if] = ACTIONS(2618),
    [anon_sym_switch] = ACTIONS(2618),
    [anon_sym_for] = ACTIONS(2618),
    [anon_sym_LPAREN] = ACTIONS(2620),
    [anon_sym_await] = ACTIONS(2618),
    [anon_sym_of] = ACTIONS(2618),
    [anon_sym_while] = ACTIONS(2618),
    [anon_sym_do] = ACTIONS(2618),
    [anon_sym_try] = ACTIONS(2618),
    [anon_sym_with] = ACTIONS(2618),
    [anon_sym_break] = ACTIONS(2618),
    [anon_sym_continue] = ACTIONS(2618),
    [anon_sym_debugger] = ACTIONS(2618),
    [anon_sym_return] = ACTIONS(2618),
    [anon_sym_throw] = ACTIONS(2618),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_case] = ACTIONS(2618),
    [anon_sym_yield] = ACTIONS(2618),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_LTtemplate_GT] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_SLASH] = ACTIONS(2618),
    [anon_sym_class] = ACTIONS(2618),
    [anon_sym_async] = ACTIONS(2618),
    [anon_sym_function] = ACTIONS(2618),
    [anon_sym_new] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2618),
    [anon_sym_DASH] = ACTIONS(2618),
    [anon_sym_TILDE] = ACTIONS(2620),
    [anon_sym_void] = ACTIONS(2618),
    [anon_sym_delete] = ACTIONS(2618),
    [anon_sym_PLUS_PLUS] = ACTIONS(2620),
    [anon_sym_DASH_DASH] = ACTIONS(2620),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2620),
    [sym_number] = ACTIONS(2620),
    [sym_this] = ACTIONS(2618),
    [sym_super] = ACTIONS(2618),
    [sym_true] = ACTIONS(2618),
    [sym_false] = ACTIONS(2618),
    [sym_null] = ACTIONS(2618),
    [sym_undefined] = ACTIONS(2618),
    [anon_sym_AT] = ACTIONS(2620),
    [anon_sym_static] = ACTIONS(2618),
    [anon_sym_readonly] = ACTIONS(2618),
    [anon_sym_get] = ACTIONS(2618),
    [anon_sym_set] = ACTIONS(2618),
    [anon_sym_declare] = ACTIONS(2618),
    [anon_sym_public] = ACTIONS(2618),
    [anon_sym_private] = ACTIONS(2618),
    [anon_sym_protected] = ACTIONS(2618),
    [anon_sym_override] = ACTIONS(2618),
    [anon_sym_module] = ACTIONS(2618),
    [anon_sym_any] = ACTIONS(2618),
    [anon_sym_number] = ACTIONS(2618),
    [anon_sym_boolean] = ACTIONS(2618),
    [anon_sym_string] = ACTIONS(2618),
    [anon_sym_symbol] = ACTIONS(2618),
    [anon_sym_property] = ACTIONS(2618),
    [anon_sym_signal] = ACTIONS(2618),
    [anon_sym_on] = ACTIONS(2618),
    [anon_sym_required] = ACTIONS(2618),
    [anon_sym_component] = ACTIONS(2618),
    [anon_sym_abstract] = ACTIONS(2618),
    [anon_sym_interface] = ACTIONS(2618),
    [anon_sym_enum] = ACTIONS(2618),
  },
  [809] = {
    [sym_identifier] = ACTIONS(2638),
    [anon_sym_export] = ACTIONS(2638),
    [anon_sym_default] = ACTIONS(2638),
    [anon_sym_type] = ACTIONS(2638),
    [anon_sym_namespace] = ACTIONS(2638),
    [anon_sym_LBRACE] = ACTIONS(2640),
    [anon_sym_RBRACE] = ACTIONS(2640),
    [anon_sym_typeof] = ACTIONS(2638),
    [anon_sym_import] = ACTIONS(2638),
    [anon_sym_from] = ACTIONS(2638),
    [anon_sym_var] = ACTIONS(2638),
    [anon_sym_let] = ACTIONS(2638),
    [anon_sym_const] = ACTIONS(2638),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_else] = ACTIONS(2638),
    [anon_sym_if] = ACTIONS(2638),
    [anon_sym_switch] = ACTIONS(2638),
    [anon_sym_for] = ACTIONS(2638),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_await] = ACTIONS(2638),
    [anon_sym_of] = ACTIONS(2638),
    [anon_sym_while] = ACTIONS(2638),
    [anon_sym_do] = ACTIONS(2638),
    [anon_sym_try] = ACTIONS(2638),
    [anon_sym_with] = ACTIONS(2638),
    [anon_sym_break] = ACTIONS(2638),
    [anon_sym_continue] = ACTIONS(2638),
    [anon_sym_debugger] = ACTIONS(2638),
    [anon_sym_return] = ACTIONS(2638),
    [anon_sym_throw] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2640),
    [anon_sym_case] = ACTIONS(2638),
    [anon_sym_yield] = ACTIONS(2638),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_LTtemplate_GT] = ACTIONS(2640),
    [anon_sym_LT] = ACTIONS(2638),
    [anon_sym_SLASH] = ACTIONS(2638),
    [anon_sym_class] = ACTIONS(2638),
    [anon_sym_async] = ACTIONS(2638),
    [anon_sym_function] = ACTIONS(2638),
    [anon_sym_new] = ACTIONS(2638),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_TILDE] = ACTIONS(2640),
    [anon_sym_void] = ACTIONS(2638),
    [anon_sym_delete] = ACTIONS(2638),
    [anon_sym_PLUS_PLUS] = ACTIONS(2640),
    [anon_sym_DASH_DASH] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(2640),
    [anon_sym_SQUOTE] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2640),
    [sym_number] = ACTIONS(2640),
    [sym_this] = ACTIONS(2638),
    [sym_super] = ACTIONS(2638),
    [sym_true] = ACTIONS(2638),
    [sym_false] = ACTIONS(2638),
    [sym_null] = ACTIONS(2638),
    [sym_undefined] = ACTIONS(2638),
    [anon_sym_AT] = ACTIONS(2640),
    [anon_sym_static] = ACTIONS(2638),
    [anon_sym_readonly] = ACTIONS(2638),
    [anon_sym_get] = ACTIONS(2638),
    [anon_sym_set] = ACTIONS(2638),
    [anon_sym_declare] = ACTIONS(2638),
    [anon_sym_public] = ACTIONS(2638),
    [anon_sym_private] = ACTIONS(2638),
    [anon_sym_protected] = ACTIONS(2638),
    [anon_sym_override] = ACTIONS(2638),
    [anon_sym_module] = ACTIONS(2638),
    [anon_sym_any] = ACTIONS(2638),
    [anon_sym_number] = ACTIONS(2638),
    [anon_sym_boolean] = ACTIONS(2638),
    [anon_sym_string] = ACTIONS(2638),
    [anon_sym_symbol] = ACTIONS(2638),
    [anon_sym_property] = ACTIONS(2638),
    [anon_sym_signal] = ACTIONS(2638),
    [anon_sym_on] = ACTIONS(2638),
    [anon_sym_required] = ACTIONS(2638),
    [anon_sym_component] = ACTIONS(2638),
    [anon_sym_abstract] = ACTIONS(2638),
    [anon_sym_interface] = ACTIONS(2638),
    [anon_sym_enum] = ACTIONS(2638),
  },
  [810] = {
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1719),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_type] = ACTIONS(1719),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1721),
    [anon_sym_RBRACE] = ACTIONS(1721),
    [anon_sym_typeof] = ACTIONS(1719),
    [anon_sym_import] = ACTIONS(1719),
    [anon_sym_from] = ACTIONS(1719),
    [anon_sym_var] = ACTIONS(1719),
    [anon_sym_let] = ACTIONS(1719),
    [anon_sym_const] = ACTIONS(1719),
    [anon_sym_BANG] = ACTIONS(1721),
    [anon_sym_else] = ACTIONS(1719),
    [anon_sym_if] = ACTIONS(1719),
    [anon_sym_switch] = ACTIONS(1719),
    [anon_sym_for] = ACTIONS(1719),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_await] = ACTIONS(1719),
    [anon_sym_of] = ACTIONS(1719),
    [anon_sym_while] = ACTIONS(1719),
    [anon_sym_do] = ACTIONS(1719),
    [anon_sym_try] = ACTIONS(1719),
    [anon_sym_with] = ACTIONS(1719),
    [anon_sym_break] = ACTIONS(1719),
    [anon_sym_continue] = ACTIONS(1719),
    [anon_sym_debugger] = ACTIONS(1719),
    [anon_sym_return] = ACTIONS(1719),
    [anon_sym_throw] = ACTIONS(1719),
    [anon_sym_SEMI] = ACTIONS(1721),
    [anon_sym_case] = ACTIONS(1719),
    [anon_sym_yield] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1721),
    [anon_sym_LTtemplate_GT] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1719),
    [anon_sym_SLASH] = ACTIONS(1719),
    [anon_sym_class] = ACTIONS(1719),
    [anon_sym_async] = ACTIONS(1719),
    [anon_sym_function] = ACTIONS(1719),
    [anon_sym_new] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(1719),
    [anon_sym_DASH] = ACTIONS(1719),
    [anon_sym_TILDE] = ACTIONS(1721),
    [anon_sym_void] = ACTIONS(1719),
    [anon_sym_delete] = ACTIONS(1719),
    [anon_sym_PLUS_PLUS] = ACTIONS(1721),
    [anon_sym_DASH_DASH] = ACTIONS(1721),
    [anon_sym_DQUOTE] = ACTIONS(1721),
    [anon_sym_SQUOTE] = ACTIONS(1721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1721),
    [sym_number] = ACTIONS(1721),
    [sym_this] = ACTIONS(1719),
    [sym_super] = ACTIONS(1719),
    [sym_true] = ACTIONS(1719),
    [sym_false] = ACTIONS(1719),
    [sym_null] = ACTIONS(1719),
    [sym_undefined] = ACTIONS(1719),
    [anon_sym_AT] = ACTIONS(1721),
    [anon_sym_static] = ACTIONS(1719),
    [anon_sym_readonly] = ACTIONS(1719),
    [anon_sym_get] = ACTIONS(1719),
    [anon_sym_set] = ACTIONS(1719),
    [anon_sym_declare] = ACTIONS(1719),
    [anon_sym_public] = ACTIONS(1719),
    [anon_sym_private] = ACTIONS(1719),
    [anon_sym_protected] = ACTIONS(1719),
    [anon_sym_override] = ACTIONS(1719),
    [anon_sym_module] = ACTIONS(1719),
    [anon_sym_any] = ACTIONS(1719),
    [anon_sym_number] = ACTIONS(1719),
    [anon_sym_boolean] = ACTIONS(1719),
    [anon_sym_string] = ACTIONS(1719),
    [anon_sym_symbol] = ACTIONS(1719),
    [anon_sym_property] = ACTIONS(1719),
    [anon_sym_signal] = ACTIONS(1719),
    [anon_sym_on] = ACTIONS(1719),
    [anon_sym_required] = ACTIONS(1719),
    [anon_sym_component] = ACTIONS(1719),
    [anon_sym_abstract] = ACTIONS(1719),
    [anon_sym_interface] = ACTIONS(1719),
    [anon_sym_enum] = ACTIONS(1719),
  },
  [811] = {
    [sym_identifier] = ACTIONS(2642),
    [anon_sym_export] = ACTIONS(2642),
    [anon_sym_default] = ACTIONS(2642),
    [anon_sym_type] = ACTIONS(2642),
    [anon_sym_namespace] = ACTIONS(2642),
    [anon_sym_LBRACE] = ACTIONS(2644),
    [anon_sym_RBRACE] = ACTIONS(2644),
    [anon_sym_typeof] = ACTIONS(2642),
    [anon_sym_import] = ACTIONS(2642),
    [anon_sym_from] = ACTIONS(2642),
    [anon_sym_var] = ACTIONS(2642),
    [anon_sym_let] = ACTIONS(2642),
    [anon_sym_const] = ACTIONS(2642),
    [anon_sym_BANG] = ACTIONS(2644),
    [anon_sym_else] = ACTIONS(2642),
    [anon_sym_if] = ACTIONS(2642),
    [anon_sym_switch] = ACTIONS(2642),
    [anon_sym_for] = ACTIONS(2642),
    [anon_sym_LPAREN] = ACTIONS(2644),
    [anon_sym_await] = ACTIONS(2642),
    [anon_sym_of] = ACTIONS(2642),
    [anon_sym_while] = ACTIONS(2642),
    [anon_sym_do] = ACTIONS(2642),
    [anon_sym_try] = ACTIONS(2642),
    [anon_sym_with] = ACTIONS(2642),
    [anon_sym_break] = ACTIONS(2642),
    [anon_sym_continue] = ACTIONS(2642),
    [anon_sym_debugger] = ACTIONS(2642),
    [anon_sym_return] = ACTIONS(2642),
    [anon_sym_throw] = ACTIONS(2642),
    [anon_sym_SEMI] = ACTIONS(2644),
    [anon_sym_case] = ACTIONS(2642),
    [anon_sym_yield] = ACTIONS(2642),
    [anon_sym_LBRACK] = ACTIONS(2644),
    [anon_sym_LTtemplate_GT] = ACTIONS(2644),
    [anon_sym_LT] = ACTIONS(2642),
    [anon_sym_SLASH] = ACTIONS(2642),
    [anon_sym_class] = ACTIONS(2642),
    [anon_sym_async] = ACTIONS(2642),
    [anon_sym_function] = ACTIONS(2642),
    [anon_sym_new] = ACTIONS(2642),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_DASH] = ACTIONS(2642),
    [anon_sym_TILDE] = ACTIONS(2644),
    [anon_sym_void] = ACTIONS(2642),
    [anon_sym_delete] = ACTIONS(2642),
    [anon_sym_PLUS_PLUS] = ACTIONS(2644),
    [anon_sym_DASH_DASH] = ACTIONS(2644),
    [anon_sym_DQUOTE] = ACTIONS(2644),
    [anon_sym_SQUOTE] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2644),
    [sym_number] = ACTIONS(2644),
    [sym_this] = ACTIONS(2642),
    [sym_super] = ACTIONS(2642),
    [sym_true] = ACTIONS(2642),
    [sym_false] = ACTIONS(2642),
    [sym_null] = ACTIONS(2642),
    [sym_undefined] = ACTIONS(2642),
    [anon_sym_AT] = ACTIONS(2644),
    [anon_sym_static] = ACTIONS(2642),
    [anon_sym_readonly] = ACTIONS(2642),
    [anon_sym_get] = ACTIONS(2642),
    [anon_sym_set] = ACTIONS(2642),
    [anon_sym_declare] = ACTIONS(2642),
    [anon_sym_public] = ACTIONS(2642),
    [anon_sym_private] = ACTIONS(2642),
    [anon_sym_protected] = ACTIONS(2642),
    [anon_sym_override] = ACTIONS(2642),
    [anon_sym_module] = ACTIONS(2642),
    [anon_sym_any] = ACTIONS(2642),
    [anon_sym_number] = ACTIONS(2642),
    [anon_sym_boolean] = ACTIONS(2642),
    [anon_sym_string] = ACTIONS(2642),
    [anon_sym_symbol] = ACTIONS(2642),
    [anon_sym_property] = ACTIONS(2642),
    [anon_sym_signal] = ACTIONS(2642),
    [anon_sym_on] = ACTIONS(2642),
    [anon_sym_required] = ACTIONS(2642),
    [anon_sym_component] = ACTIONS(2642),
    [anon_sym_abstract] = ACTIONS(2642),
    [anon_sym_interface] = ACTIONS(2642),
    [anon_sym_enum] = ACTIONS(2642),
  },
  [812] = {
    [sym_identifier] = ACTIONS(2646),
    [anon_sym_export] = ACTIONS(2646),
    [anon_sym_default] = ACTIONS(2646),
    [anon_sym_type] = ACTIONS(2646),
    [anon_sym_namespace] = ACTIONS(2646),
    [anon_sym_LBRACE] = ACTIONS(2648),
    [anon_sym_RBRACE] = ACTIONS(2648),
    [anon_sym_typeof] = ACTIONS(2646),
    [anon_sym_import] = ACTIONS(2646),
    [anon_sym_from] = ACTIONS(2646),
    [anon_sym_var] = ACTIONS(2646),
    [anon_sym_let] = ACTIONS(2646),
    [anon_sym_const] = ACTIONS(2646),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_else] = ACTIONS(2646),
    [anon_sym_if] = ACTIONS(2646),
    [anon_sym_switch] = ACTIONS(2646),
    [anon_sym_for] = ACTIONS(2646),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_await] = ACTIONS(2646),
    [anon_sym_of] = ACTIONS(2646),
    [anon_sym_while] = ACTIONS(2646),
    [anon_sym_do] = ACTIONS(2646),
    [anon_sym_try] = ACTIONS(2646),
    [anon_sym_with] = ACTIONS(2646),
    [anon_sym_break] = ACTIONS(2646),
    [anon_sym_continue] = ACTIONS(2646),
    [anon_sym_debugger] = ACTIONS(2646),
    [anon_sym_return] = ACTIONS(2646),
    [anon_sym_throw] = ACTIONS(2646),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_case] = ACTIONS(2646),
    [anon_sym_yield] = ACTIONS(2646),
    [anon_sym_LBRACK] = ACTIONS(2648),
    [anon_sym_LTtemplate_GT] = ACTIONS(2648),
    [anon_sym_LT] = ACTIONS(2646),
    [anon_sym_SLASH] = ACTIONS(2646),
    [anon_sym_class] = ACTIONS(2646),
    [anon_sym_async] = ACTIONS(2646),
    [anon_sym_function] = ACTIONS(2646),
    [anon_sym_new] = ACTIONS(2646),
    [anon_sym_PLUS] = ACTIONS(2646),
    [anon_sym_DASH] = ACTIONS(2646),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_void] = ACTIONS(2646),
    [anon_sym_delete] = ACTIONS(2646),
    [anon_sym_PLUS_PLUS] = ACTIONS(2648),
    [anon_sym_DASH_DASH] = ACTIONS(2648),
    [anon_sym_DQUOTE] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2648),
    [sym_number] = ACTIONS(2648),
    [sym_this] = ACTIONS(2646),
    [sym_super] = ACTIONS(2646),
    [sym_true] = ACTIONS(2646),
    [sym_false] = ACTIONS(2646),
    [sym_null] = ACTIONS(2646),
    [sym_undefined] = ACTIONS(2646),
    [anon_sym_AT] = ACTIONS(2648),
    [anon_sym_static] = ACTIONS(2646),
    [anon_sym_readonly] = ACTIONS(2646),
    [anon_sym_get] = ACTIONS(2646),
    [anon_sym_set] = ACTIONS(2646),
    [anon_sym_declare] = ACTIONS(2646),
    [anon_sym_public] = ACTIONS(2646),
    [anon_sym_private] = ACTIONS(2646),
    [anon_sym_protected] = ACTIONS(2646),
    [anon_sym_override] = ACTIONS(2646),
    [anon_sym_module] = ACTIONS(2646),
    [anon_sym_any] = ACTIONS(2646),
    [anon_sym_number] = ACTIONS(2646),
    [anon_sym_boolean] = ACTIONS(2646),
    [anon_sym_string] = ACTIONS(2646),
    [anon_sym_symbol] = ACTIONS(2646),
    [anon_sym_property] = ACTIONS(2646),
    [anon_sym_signal] = ACTIONS(2646),
    [anon_sym_on] = ACTIONS(2646),
    [anon_sym_required] = ACTIONS(2646),
    [anon_sym_component] = ACTIONS(2646),
    [anon_sym_abstract] = ACTIONS(2646),
    [anon_sym_interface] = ACTIONS(2646),
    [anon_sym_enum] = ACTIONS(2646),
  },
  [813] = {
    [sym_identifier] = ACTIONS(2650),
    [anon_sym_export] = ACTIONS(2650),
    [anon_sym_default] = ACTIONS(2650),
    [anon_sym_type] = ACTIONS(2650),
    [anon_sym_namespace] = ACTIONS(2650),
    [anon_sym_LBRACE] = ACTIONS(2652),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_typeof] = ACTIONS(2650),
    [anon_sym_import] = ACTIONS(2650),
    [anon_sym_from] = ACTIONS(2650),
    [anon_sym_var] = ACTIONS(2650),
    [anon_sym_let] = ACTIONS(2650),
    [anon_sym_const] = ACTIONS(2650),
    [anon_sym_BANG] = ACTIONS(2652),
    [anon_sym_else] = ACTIONS(2650),
    [anon_sym_if] = ACTIONS(2650),
    [anon_sym_switch] = ACTIONS(2650),
    [anon_sym_for] = ACTIONS(2650),
    [anon_sym_LPAREN] = ACTIONS(2652),
    [anon_sym_await] = ACTIONS(2650),
    [anon_sym_of] = ACTIONS(2650),
    [anon_sym_while] = ACTIONS(2650),
    [anon_sym_do] = ACTIONS(2650),
    [anon_sym_try] = ACTIONS(2650),
    [anon_sym_with] = ACTIONS(2650),
    [anon_sym_break] = ACTIONS(2650),
    [anon_sym_continue] = ACTIONS(2650),
    [anon_sym_debugger] = ACTIONS(2650),
    [anon_sym_return] = ACTIONS(2650),
    [anon_sym_throw] = ACTIONS(2650),
    [anon_sym_SEMI] = ACTIONS(2652),
    [anon_sym_case] = ACTIONS(2650),
    [anon_sym_yield] = ACTIONS(2650),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [anon_sym_LTtemplate_GT] = ACTIONS(2652),
    [anon_sym_LT] = ACTIONS(2650),
    [anon_sym_SLASH] = ACTIONS(2650),
    [anon_sym_class] = ACTIONS(2650),
    [anon_sym_async] = ACTIONS(2650),
    [anon_sym_function] = ACTIONS(2650),
    [anon_sym_new] = ACTIONS(2650),
    [anon_sym_PLUS] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(2650),
    [anon_sym_TILDE] = ACTIONS(2652),
    [anon_sym_void] = ACTIONS(2650),
    [anon_sym_delete] = ACTIONS(2650),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_DQUOTE] = ACTIONS(2652),
    [anon_sym_SQUOTE] = ACTIONS(2652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2652),
    [sym_number] = ACTIONS(2652),
    [sym_this] = ACTIONS(2650),
    [sym_super] = ACTIONS(2650),
    [sym_true] = ACTIONS(2650),
    [sym_false] = ACTIONS(2650),
    [sym_null] = ACTIONS(2650),
    [sym_undefined] = ACTIONS(2650),
    [anon_sym_AT] = ACTIONS(2652),
    [anon_sym_static] = ACTIONS(2650),
    [anon_sym_readonly] = ACTIONS(2650),
    [anon_sym_get] = ACTIONS(2650),
    [anon_sym_set] = ACTIONS(2650),
    [anon_sym_declare] = ACTIONS(2650),
    [anon_sym_public] = ACTIONS(2650),
    [anon_sym_private] = ACTIONS(2650),
    [anon_sym_protected] = ACTIONS(2650),
    [anon_sym_override] = ACTIONS(2650),
    [anon_sym_module] = ACTIONS(2650),
    [anon_sym_any] = ACTIONS(2650),
    [anon_sym_number] = ACTIONS(2650),
    [anon_sym_boolean] = ACTIONS(2650),
    [anon_sym_string] = ACTIONS(2650),
    [anon_sym_symbol] = ACTIONS(2650),
    [anon_sym_property] = ACTIONS(2650),
    [anon_sym_signal] = ACTIONS(2650),
    [anon_sym_on] = ACTIONS(2650),
    [anon_sym_required] = ACTIONS(2650),
    [anon_sym_component] = ACTIONS(2650),
    [anon_sym_abstract] = ACTIONS(2650),
    [anon_sym_interface] = ACTIONS(2650),
    [anon_sym_enum] = ACTIONS(2650),
  },
  [814] = {
    [sym_identifier] = ACTIONS(2654),
    [anon_sym_export] = ACTIONS(2654),
    [anon_sym_default] = ACTIONS(2654),
    [anon_sym_type] = ACTIONS(2654),
    [anon_sym_namespace] = ACTIONS(2654),
    [anon_sym_LBRACE] = ACTIONS(2656),
    [anon_sym_RBRACE] = ACTIONS(2656),
    [anon_sym_typeof] = ACTIONS(2654),
    [anon_sym_import] = ACTIONS(2654),
    [anon_sym_from] = ACTIONS(2654),
    [anon_sym_var] = ACTIONS(2654),
    [anon_sym_let] = ACTIONS(2654),
    [anon_sym_const] = ACTIONS(2654),
    [anon_sym_BANG] = ACTIONS(2656),
    [anon_sym_else] = ACTIONS(2654),
    [anon_sym_if] = ACTIONS(2654),
    [anon_sym_switch] = ACTIONS(2654),
    [anon_sym_for] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_await] = ACTIONS(2654),
    [anon_sym_of] = ACTIONS(2654),
    [anon_sym_while] = ACTIONS(2654),
    [anon_sym_do] = ACTIONS(2654),
    [anon_sym_try] = ACTIONS(2654),
    [anon_sym_with] = ACTIONS(2654),
    [anon_sym_break] = ACTIONS(2654),
    [anon_sym_continue] = ACTIONS(2654),
    [anon_sym_debugger] = ACTIONS(2654),
    [anon_sym_return] = ACTIONS(2654),
    [anon_sym_throw] = ACTIONS(2654),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_case] = ACTIONS(2654),
    [anon_sym_yield] = ACTIONS(2654),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_LTtemplate_GT] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2654),
    [anon_sym_class] = ACTIONS(2654),
    [anon_sym_async] = ACTIONS(2654),
    [anon_sym_function] = ACTIONS(2654),
    [anon_sym_new] = ACTIONS(2654),
    [anon_sym_PLUS] = ACTIONS(2654),
    [anon_sym_DASH] = ACTIONS(2654),
    [anon_sym_TILDE] = ACTIONS(2656),
    [anon_sym_void] = ACTIONS(2654),
    [anon_sym_delete] = ACTIONS(2654),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_DQUOTE] = ACTIONS(2656),
    [anon_sym_SQUOTE] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2656),
    [sym_number] = ACTIONS(2656),
    [sym_this] = ACTIONS(2654),
    [sym_super] = ACTIONS(2654),
    [sym_true] = ACTIONS(2654),
    [sym_false] = ACTIONS(2654),
    [sym_null] = ACTIONS(2654),
    [sym_undefined] = ACTIONS(2654),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_static] = ACTIONS(2654),
    [anon_sym_readonly] = ACTIONS(2654),
    [anon_sym_get] = ACTIONS(2654),
    [anon_sym_set] = ACTIONS(2654),
    [anon_sym_declare] = ACTIONS(2654),
    [anon_sym_public] = ACTIONS(2654),
    [anon_sym_private] = ACTIONS(2654),
    [anon_sym_protected] = ACTIONS(2654),
    [anon_sym_override] = ACTIONS(2654),
    [anon_sym_module] = ACTIONS(2654),
    [anon_sym_any] = ACTIONS(2654),
    [anon_sym_number] = ACTIONS(2654),
    [anon_sym_boolean] = ACTIONS(2654),
    [anon_sym_string] = ACTIONS(2654),
    [anon_sym_symbol] = ACTIONS(2654),
    [anon_sym_property] = ACTIONS(2654),
    [anon_sym_signal] = ACTIONS(2654),
    [anon_sym_on] = ACTIONS(2654),
    [anon_sym_required] = ACTIONS(2654),
    [anon_sym_component] = ACTIONS(2654),
    [anon_sym_abstract] = ACTIONS(2654),
    [anon_sym_interface] = ACTIONS(2654),
    [anon_sym_enum] = ACTIONS(2654),
  },
  [815] = {
    [sym_identifier] = ACTIONS(2658),
    [anon_sym_export] = ACTIONS(2658),
    [anon_sym_default] = ACTIONS(2658),
    [anon_sym_type] = ACTIONS(2658),
    [anon_sym_namespace] = ACTIONS(2658),
    [anon_sym_LBRACE] = ACTIONS(2660),
    [anon_sym_RBRACE] = ACTIONS(2660),
    [anon_sym_typeof] = ACTIONS(2658),
    [anon_sym_import] = ACTIONS(2658),
    [anon_sym_from] = ACTIONS(2658),
    [anon_sym_var] = ACTIONS(2658),
    [anon_sym_let] = ACTIONS(2658),
    [anon_sym_const] = ACTIONS(2658),
    [anon_sym_BANG] = ACTIONS(2660),
    [anon_sym_else] = ACTIONS(2658),
    [anon_sym_if] = ACTIONS(2658),
    [anon_sym_switch] = ACTIONS(2658),
    [anon_sym_for] = ACTIONS(2658),
    [anon_sym_LPAREN] = ACTIONS(2660),
    [anon_sym_await] = ACTIONS(2658),
    [anon_sym_of] = ACTIONS(2658),
    [anon_sym_while] = ACTIONS(2658),
    [anon_sym_do] = ACTIONS(2658),
    [anon_sym_try] = ACTIONS(2658),
    [anon_sym_with] = ACTIONS(2658),
    [anon_sym_break] = ACTIONS(2658),
    [anon_sym_continue] = ACTIONS(2658),
    [anon_sym_debugger] = ACTIONS(2658),
    [anon_sym_return] = ACTIONS(2658),
    [anon_sym_throw] = ACTIONS(2658),
    [anon_sym_SEMI] = ACTIONS(2660),
    [anon_sym_case] = ACTIONS(2658),
    [anon_sym_yield] = ACTIONS(2658),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [anon_sym_LTtemplate_GT] = ACTIONS(2660),
    [anon_sym_LT] = ACTIONS(2658),
    [anon_sym_SLASH] = ACTIONS(2658),
    [anon_sym_class] = ACTIONS(2658),
    [anon_sym_async] = ACTIONS(2658),
    [anon_sym_function] = ACTIONS(2658),
    [anon_sym_new] = ACTIONS(2658),
    [anon_sym_PLUS] = ACTIONS(2658),
    [anon_sym_DASH] = ACTIONS(2658),
    [anon_sym_TILDE] = ACTIONS(2660),
    [anon_sym_void] = ACTIONS(2658),
    [anon_sym_delete] = ACTIONS(2658),
    [anon_sym_PLUS_PLUS] = ACTIONS(2660),
    [anon_sym_DASH_DASH] = ACTIONS(2660),
    [anon_sym_DQUOTE] = ACTIONS(2660),
    [anon_sym_SQUOTE] = ACTIONS(2660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2660),
    [sym_number] = ACTIONS(2660),
    [sym_this] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_undefined] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2660),
    [anon_sym_static] = ACTIONS(2658),
    [anon_sym_readonly] = ACTIONS(2658),
    [anon_sym_get] = ACTIONS(2658),
    [anon_sym_set] = ACTIONS(2658),
    [anon_sym_declare] = ACTIONS(2658),
    [anon_sym_public] = ACTIONS(2658),
    [anon_sym_private] = ACTIONS(2658),
    [anon_sym_protected] = ACTIONS(2658),
    [anon_sym_override] = ACTIONS(2658),
    [anon_sym_module] = ACTIONS(2658),
    [anon_sym_any] = ACTIONS(2658),
    [anon_sym_number] = ACTIONS(2658),
    [anon_sym_boolean] = ACTIONS(2658),
    [anon_sym_string] = ACTIONS(2658),
    [anon_sym_symbol] = ACTIONS(2658),
    [anon_sym_property] = ACTIONS(2658),
    [anon_sym_signal] = ACTIONS(2658),
    [anon_sym_on] = ACTIONS(2658),
    [anon_sym_required] = ACTIONS(2658),
    [anon_sym_component] = ACTIONS(2658),
    [anon_sym_abstract] = ACTIONS(2658),
    [anon_sym_interface] = ACTIONS(2658),
    [anon_sym_enum] = ACTIONS(2658),
  },
  [816] = {
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2662),
    [anon_sym_default] = ACTIONS(2662),
    [anon_sym_type] = ACTIONS(2662),
    [anon_sym_namespace] = ACTIONS(2662),
    [anon_sym_LBRACE] = ACTIONS(2664),
    [anon_sym_RBRACE] = ACTIONS(2664),
    [anon_sym_typeof] = ACTIONS(2662),
    [anon_sym_import] = ACTIONS(2662),
    [anon_sym_from] = ACTIONS(2662),
    [anon_sym_var] = ACTIONS(2662),
    [anon_sym_let] = ACTIONS(2662),
    [anon_sym_const] = ACTIONS(2662),
    [anon_sym_BANG] = ACTIONS(2664),
    [anon_sym_else] = ACTIONS(2662),
    [anon_sym_if] = ACTIONS(2662),
    [anon_sym_switch] = ACTIONS(2662),
    [anon_sym_for] = ACTIONS(2662),
    [anon_sym_LPAREN] = ACTIONS(2664),
    [anon_sym_await] = ACTIONS(2662),
    [anon_sym_of] = ACTIONS(2662),
    [anon_sym_while] = ACTIONS(2662),
    [anon_sym_do] = ACTIONS(2662),
    [anon_sym_try] = ACTIONS(2662),
    [anon_sym_with] = ACTIONS(2662),
    [anon_sym_break] = ACTIONS(2662),
    [anon_sym_continue] = ACTIONS(2662),
    [anon_sym_debugger] = ACTIONS(2662),
    [anon_sym_return] = ACTIONS(2662),
    [anon_sym_throw] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2664),
    [anon_sym_case] = ACTIONS(2662),
    [anon_sym_yield] = ACTIONS(2662),
    [anon_sym_LBRACK] = ACTIONS(2664),
    [anon_sym_LTtemplate_GT] = ACTIONS(2664),
    [anon_sym_LT] = ACTIONS(2662),
    [anon_sym_SLASH] = ACTIONS(2662),
    [anon_sym_class] = ACTIONS(2662),
    [anon_sym_async] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(2662),
    [anon_sym_new] = ACTIONS(2662),
    [anon_sym_PLUS] = ACTIONS(2662),
    [anon_sym_DASH] = ACTIONS(2662),
    [anon_sym_TILDE] = ACTIONS(2664),
    [anon_sym_void] = ACTIONS(2662),
    [anon_sym_delete] = ACTIONS(2662),
    [anon_sym_PLUS_PLUS] = ACTIONS(2664),
    [anon_sym_DASH_DASH] = ACTIONS(2664),
    [anon_sym_DQUOTE] = ACTIONS(2664),
    [anon_sym_SQUOTE] = ACTIONS(2664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2664),
    [sym_number] = ACTIONS(2664),
    [sym_this] = ACTIONS(2662),
    [sym_super] = ACTIONS(2662),
    [sym_true] = ACTIONS(2662),
    [sym_false] = ACTIONS(2662),
    [sym_null] = ACTIONS(2662),
    [sym_undefined] = ACTIONS(2662),
    [anon_sym_AT] = ACTIONS(2664),
    [anon_sym_static] = ACTIONS(2662),
    [anon_sym_readonly] = ACTIONS(2662),
    [anon_sym_get] = ACTIONS(2662),
    [anon_sym_set] = ACTIONS(2662),
    [anon_sym_declare] = ACTIONS(2662),
    [anon_sym_public] = ACTIONS(2662),
    [anon_sym_private] = ACTIONS(2662),
    [anon_sym_protected] = ACTIONS(2662),
    [anon_sym_override] = ACTIONS(2662),
    [anon_sym_module] = ACTIONS(2662),
    [anon_sym_any] = ACTIONS(2662),
    [anon_sym_number] = ACTIONS(2662),
    [anon_sym_boolean] = ACTIONS(2662),
    [anon_sym_string] = ACTIONS(2662),
    [anon_sym_symbol] = ACTIONS(2662),
    [anon_sym_property] = ACTIONS(2662),
    [anon_sym_signal] = ACTIONS(2662),
    [anon_sym_on] = ACTIONS(2662),
    [anon_sym_required] = ACTIONS(2662),
    [anon_sym_component] = ACTIONS(2662),
    [anon_sym_abstract] = ACTIONS(2662),
    [anon_sym_interface] = ACTIONS(2662),
    [anon_sym_enum] = ACTIONS(2662),
  },
  [817] = {
    [sym_identifier] = ACTIONS(2666),
    [anon_sym_export] = ACTIONS(2666),
    [anon_sym_default] = ACTIONS(2666),
    [anon_sym_type] = ACTIONS(2666),
    [anon_sym_namespace] = ACTIONS(2666),
    [anon_sym_LBRACE] = ACTIONS(2668),
    [anon_sym_RBRACE] = ACTIONS(2668),
    [anon_sym_typeof] = ACTIONS(2666),
    [anon_sym_import] = ACTIONS(2666),
    [anon_sym_from] = ACTIONS(2666),
    [anon_sym_var] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(2666),
    [anon_sym_const] = ACTIONS(2666),
    [anon_sym_BANG] = ACTIONS(2668),
    [anon_sym_else] = ACTIONS(2666),
    [anon_sym_if] = ACTIONS(2666),
    [anon_sym_switch] = ACTIONS(2666),
    [anon_sym_for] = ACTIONS(2666),
    [anon_sym_LPAREN] = ACTIONS(2668),
    [anon_sym_await] = ACTIONS(2666),
    [anon_sym_of] = ACTIONS(2666),
    [anon_sym_while] = ACTIONS(2666),
    [anon_sym_do] = ACTIONS(2666),
    [anon_sym_try] = ACTIONS(2666),
    [anon_sym_with] = ACTIONS(2666),
    [anon_sym_break] = ACTIONS(2666),
    [anon_sym_continue] = ACTIONS(2666),
    [anon_sym_debugger] = ACTIONS(2666),
    [anon_sym_return] = ACTIONS(2666),
    [anon_sym_throw] = ACTIONS(2666),
    [anon_sym_SEMI] = ACTIONS(2668),
    [anon_sym_case] = ACTIONS(2666),
    [anon_sym_yield] = ACTIONS(2666),
    [anon_sym_LBRACK] = ACTIONS(2668),
    [anon_sym_LTtemplate_GT] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2666),
    [anon_sym_SLASH] = ACTIONS(2666),
    [anon_sym_class] = ACTIONS(2666),
    [anon_sym_async] = ACTIONS(2666),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_new] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2666),
    [anon_sym_DASH] = ACTIONS(2666),
    [anon_sym_TILDE] = ACTIONS(2668),
    [anon_sym_void] = ACTIONS(2666),
    [anon_sym_delete] = ACTIONS(2666),
    [anon_sym_PLUS_PLUS] = ACTIONS(2668),
    [anon_sym_DASH_DASH] = ACTIONS(2668),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_SQUOTE] = ACTIONS(2668),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2668),
    [sym_number] = ACTIONS(2668),
    [sym_this] = ACTIONS(2666),
    [sym_super] = ACTIONS(2666),
    [sym_true] = ACTIONS(2666),
    [sym_false] = ACTIONS(2666),
    [sym_null] = ACTIONS(2666),
    [sym_undefined] = ACTIONS(2666),
    [anon_sym_AT] = ACTIONS(2668),
    [anon_sym_static] = ACTIONS(2666),
    [anon_sym_readonly] = ACTIONS(2666),
    [anon_sym_get] = ACTIONS(2666),
    [anon_sym_set] = ACTIONS(2666),
    [anon_sym_declare] = ACTIONS(2666),
    [anon_sym_public] = ACTIONS(2666),
    [anon_sym_private] = ACTIONS(2666),
    [anon_sym_protected] = ACTIONS(2666),
    [anon_sym_override] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2666),
    [anon_sym_any] = ACTIONS(2666),
    [anon_sym_number] = ACTIONS(2666),
    [anon_sym_boolean] = ACTIONS(2666),
    [anon_sym_string] = ACTIONS(2666),
    [anon_sym_symbol] = ACTIONS(2666),
    [anon_sym_property] = ACTIONS(2666),
    [anon_sym_signal] = ACTIONS(2666),
    [anon_sym_on] = ACTIONS(2666),
    [anon_sym_required] = ACTIONS(2666),
    [anon_sym_component] = ACTIONS(2666),
    [anon_sym_abstract] = ACTIONS(2666),
    [anon_sym_interface] = ACTIONS(2666),
    [anon_sym_enum] = ACTIONS(2666),
  },
  [818] = {
    [sym_identifier] = ACTIONS(2670),
    [anon_sym_export] = ACTIONS(2670),
    [anon_sym_default] = ACTIONS(2670),
    [anon_sym_type] = ACTIONS(2670),
    [anon_sym_namespace] = ACTIONS(2670),
    [anon_sym_LBRACE] = ACTIONS(2672),
    [anon_sym_RBRACE] = ACTIONS(2672),
    [anon_sym_typeof] = ACTIONS(2670),
    [anon_sym_import] = ACTIONS(2670),
    [anon_sym_from] = ACTIONS(2670),
    [anon_sym_var] = ACTIONS(2670),
    [anon_sym_let] = ACTIONS(2670),
    [anon_sym_const] = ACTIONS(2670),
    [anon_sym_BANG] = ACTIONS(2672),
    [anon_sym_else] = ACTIONS(2670),
    [anon_sym_if] = ACTIONS(2670),
    [anon_sym_switch] = ACTIONS(2670),
    [anon_sym_for] = ACTIONS(2670),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [anon_sym_await] = ACTIONS(2670),
    [anon_sym_of] = ACTIONS(2670),
    [anon_sym_while] = ACTIONS(2670),
    [anon_sym_do] = ACTIONS(2670),
    [anon_sym_try] = ACTIONS(2670),
    [anon_sym_with] = ACTIONS(2670),
    [anon_sym_break] = ACTIONS(2670),
    [anon_sym_continue] = ACTIONS(2670),
    [anon_sym_debugger] = ACTIONS(2670),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_throw] = ACTIONS(2670),
    [anon_sym_SEMI] = ACTIONS(2672),
    [anon_sym_case] = ACTIONS(2670),
    [anon_sym_yield] = ACTIONS(2670),
    [anon_sym_LBRACK] = ACTIONS(2672),
    [anon_sym_LTtemplate_GT] = ACTIONS(2672),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_SLASH] = ACTIONS(2670),
    [anon_sym_class] = ACTIONS(2670),
    [anon_sym_async] = ACTIONS(2670),
    [anon_sym_function] = ACTIONS(2670),
    [anon_sym_new] = ACTIONS(2670),
    [anon_sym_PLUS] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(2670),
    [anon_sym_TILDE] = ACTIONS(2672),
    [anon_sym_void] = ACTIONS(2670),
    [anon_sym_delete] = ACTIONS(2670),
    [anon_sym_PLUS_PLUS] = ACTIONS(2672),
    [anon_sym_DASH_DASH] = ACTIONS(2672),
    [anon_sym_DQUOTE] = ACTIONS(2672),
    [anon_sym_SQUOTE] = ACTIONS(2672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2672),
    [sym_number] = ACTIONS(2672),
    [sym_this] = ACTIONS(2670),
    [sym_super] = ACTIONS(2670),
    [sym_true] = ACTIONS(2670),
    [sym_false] = ACTIONS(2670),
    [sym_null] = ACTIONS(2670),
    [sym_undefined] = ACTIONS(2670),
    [anon_sym_AT] = ACTIONS(2672),
    [anon_sym_static] = ACTIONS(2670),
    [anon_sym_readonly] = ACTIONS(2670),
    [anon_sym_get] = ACTIONS(2670),
    [anon_sym_set] = ACTIONS(2670),
    [anon_sym_declare] = ACTIONS(2670),
    [anon_sym_public] = ACTIONS(2670),
    [anon_sym_private] = ACTIONS(2670),
    [anon_sym_protected] = ACTIONS(2670),
    [anon_sym_override] = ACTIONS(2670),
    [anon_sym_module] = ACTIONS(2670),
    [anon_sym_any] = ACTIONS(2670),
    [anon_sym_number] = ACTIONS(2670),
    [anon_sym_boolean] = ACTIONS(2670),
    [anon_sym_string] = ACTIONS(2670),
    [anon_sym_symbol] = ACTIONS(2670),
    [anon_sym_property] = ACTIONS(2670),
    [anon_sym_signal] = ACTIONS(2670),
    [anon_sym_on] = ACTIONS(2670),
    [anon_sym_required] = ACTIONS(2670),
    [anon_sym_component] = ACTIONS(2670),
    [anon_sym_abstract] = ACTIONS(2670),
    [anon_sym_interface] = ACTIONS(2670),
    [anon_sym_enum] = ACTIONS(2670),
  },
  [819] = {
    [sym_identifier] = ACTIONS(1635),
    [anon_sym_export] = ACTIONS(1635),
    [anon_sym_default] = ACTIONS(1635),
    [anon_sym_type] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1635),
    [anon_sym_LBRACE] = ACTIONS(1637),
    [anon_sym_RBRACE] = ACTIONS(1637),
    [anon_sym_typeof] = ACTIONS(1635),
    [anon_sym_import] = ACTIONS(1635),
    [anon_sym_from] = ACTIONS(1635),
    [anon_sym_var] = ACTIONS(1635),
    [anon_sym_let] = ACTIONS(1635),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(1637),
    [anon_sym_else] = ACTIONS(1635),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_switch] = ACTIONS(1635),
    [anon_sym_for] = ACTIONS(1635),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_await] = ACTIONS(1635),
    [anon_sym_of] = ACTIONS(1635),
    [anon_sym_while] = ACTIONS(1635),
    [anon_sym_do] = ACTIONS(1635),
    [anon_sym_try] = ACTIONS(1635),
    [anon_sym_with] = ACTIONS(1635),
    [anon_sym_break] = ACTIONS(1635),
    [anon_sym_continue] = ACTIONS(1635),
    [anon_sym_debugger] = ACTIONS(1635),
    [anon_sym_return] = ACTIONS(1635),
    [anon_sym_throw] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_case] = ACTIONS(1635),
    [anon_sym_yield] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LTtemplate_GT] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1635),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_class] = ACTIONS(1635),
    [anon_sym_async] = ACTIONS(1635),
    [anon_sym_function] = ACTIONS(1635),
    [anon_sym_new] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_TILDE] = ACTIONS(1637),
    [anon_sym_void] = ACTIONS(1635),
    [anon_sym_delete] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1637),
    [anon_sym_DQUOTE] = ACTIONS(1637),
    [anon_sym_SQUOTE] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1637),
    [sym_number] = ACTIONS(1637),
    [sym_this] = ACTIONS(1635),
    [sym_super] = ACTIONS(1635),
    [sym_true] = ACTIONS(1635),
    [sym_false] = ACTIONS(1635),
    [sym_null] = ACTIONS(1635),
    [sym_undefined] = ACTIONS(1635),
    [anon_sym_AT] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1635),
    [anon_sym_readonly] = ACTIONS(1635),
    [anon_sym_get] = ACTIONS(1635),
    [anon_sym_set] = ACTIONS(1635),
    [anon_sym_declare] = ACTIONS(1635),
    [anon_sym_public] = ACTIONS(1635),
    [anon_sym_private] = ACTIONS(1635),
    [anon_sym_protected] = ACTIONS(1635),
    [anon_sym_override] = ACTIONS(1635),
    [anon_sym_module] = ACTIONS(1635),
    [anon_sym_any] = ACTIONS(1635),
    [anon_sym_number] = ACTIONS(1635),
    [anon_sym_boolean] = ACTIONS(1635),
    [anon_sym_string] = ACTIONS(1635),
    [anon_sym_symbol] = ACTIONS(1635),
    [anon_sym_property] = ACTIONS(1635),
    [anon_sym_signal] = ACTIONS(1635),
    [anon_sym_on] = ACTIONS(1635),
    [anon_sym_required] = ACTIONS(1635),
    [anon_sym_component] = ACTIONS(1635),
    [anon_sym_abstract] = ACTIONS(1635),
    [anon_sym_interface] = ACTIONS(1635),
    [anon_sym_enum] = ACTIONS(1635),
  },
  [820] = {
    [sym_identifier] = ACTIONS(2674),
    [anon_sym_export] = ACTIONS(2674),
    [anon_sym_default] = ACTIONS(2674),
    [anon_sym_type] = ACTIONS(2674),
    [anon_sym_namespace] = ACTIONS(2674),
    [anon_sym_LBRACE] = ACTIONS(2676),
    [anon_sym_RBRACE] = ACTIONS(2676),
    [anon_sym_typeof] = ACTIONS(2674),
    [anon_sym_import] = ACTIONS(2674),
    [anon_sym_from] = ACTIONS(2674),
    [anon_sym_var] = ACTIONS(2674),
    [anon_sym_let] = ACTIONS(2674),
    [anon_sym_const] = ACTIONS(2674),
    [anon_sym_BANG] = ACTIONS(2676),
    [anon_sym_else] = ACTIONS(2674),
    [anon_sym_if] = ACTIONS(2674),
    [anon_sym_switch] = ACTIONS(2674),
    [anon_sym_for] = ACTIONS(2674),
    [anon_sym_LPAREN] = ACTIONS(2676),
    [anon_sym_await] = ACTIONS(2674),
    [anon_sym_of] = ACTIONS(2674),
    [anon_sym_while] = ACTIONS(2674),
    [anon_sym_do] = ACTIONS(2674),
    [anon_sym_try] = ACTIONS(2674),
    [anon_sym_with] = ACTIONS(2674),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_continue] = ACTIONS(2674),
    [anon_sym_debugger] = ACTIONS(2674),
    [anon_sym_return] = ACTIONS(2674),
    [anon_sym_throw] = ACTIONS(2674),
    [anon_sym_SEMI] = ACTIONS(2676),
    [anon_sym_case] = ACTIONS(2674),
    [anon_sym_yield] = ACTIONS(2674),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_LTtemplate_GT] = ACTIONS(2676),
    [anon_sym_LT] = ACTIONS(2674),
    [anon_sym_SLASH] = ACTIONS(2674),
    [anon_sym_class] = ACTIONS(2674),
    [anon_sym_async] = ACTIONS(2674),
    [anon_sym_function] = ACTIONS(2674),
    [anon_sym_new] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2674),
    [anon_sym_DASH] = ACTIONS(2674),
    [anon_sym_TILDE] = ACTIONS(2676),
    [anon_sym_void] = ACTIONS(2674),
    [anon_sym_delete] = ACTIONS(2674),
    [anon_sym_PLUS_PLUS] = ACTIONS(2676),
    [anon_sym_DASH_DASH] = ACTIONS(2676),
    [anon_sym_DQUOTE] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2676),
    [sym_number] = ACTIONS(2676),
    [sym_this] = ACTIONS(2674),
    [sym_super] = ACTIONS(2674),
    [sym_true] = ACTIONS(2674),
    [sym_false] = ACTIONS(2674),
    [sym_null] = ACTIONS(2674),
    [sym_undefined] = ACTIONS(2674),
    [anon_sym_AT] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2674),
    [anon_sym_readonly] = ACTIONS(2674),
    [anon_sym_get] = ACTIONS(2674),
    [anon_sym_set] = ACTIONS(2674),
    [anon_sym_declare] = ACTIONS(2674),
    [anon_sym_public] = ACTIONS(2674),
    [anon_sym_private] = ACTIONS(2674),
    [anon_sym_protected] = ACTIONS(2674),
    [anon_sym_override] = ACTIONS(2674),
    [anon_sym_module] = ACTIONS(2674),
    [anon_sym_any] = ACTIONS(2674),
    [anon_sym_number] = ACTIONS(2674),
    [anon_sym_boolean] = ACTIONS(2674),
    [anon_sym_string] = ACTIONS(2674),
    [anon_sym_symbol] = ACTIONS(2674),
    [anon_sym_property] = ACTIONS(2674),
    [anon_sym_signal] = ACTIONS(2674),
    [anon_sym_on] = ACTIONS(2674),
    [anon_sym_required] = ACTIONS(2674),
    [anon_sym_component] = ACTIONS(2674),
    [anon_sym_abstract] = ACTIONS(2674),
    [anon_sym_interface] = ACTIONS(2674),
    [anon_sym_enum] = ACTIONS(2674),
  },
  [821] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [822] = {
    [sym_identifier] = ACTIONS(2674),
    [anon_sym_export] = ACTIONS(2674),
    [anon_sym_default] = ACTIONS(2674),
    [anon_sym_type] = ACTIONS(2674),
    [anon_sym_namespace] = ACTIONS(2674),
    [anon_sym_LBRACE] = ACTIONS(2676),
    [anon_sym_RBRACE] = ACTIONS(2676),
    [anon_sym_typeof] = ACTIONS(2674),
    [anon_sym_import] = ACTIONS(2674),
    [anon_sym_from] = ACTIONS(2674),
    [anon_sym_var] = ACTIONS(2674),
    [anon_sym_let] = ACTIONS(2674),
    [anon_sym_const] = ACTIONS(2674),
    [anon_sym_BANG] = ACTIONS(2676),
    [anon_sym_else] = ACTIONS(2674),
    [anon_sym_if] = ACTIONS(2674),
    [anon_sym_switch] = ACTIONS(2674),
    [anon_sym_for] = ACTIONS(2674),
    [anon_sym_LPAREN] = ACTIONS(2676),
    [anon_sym_await] = ACTIONS(2674),
    [anon_sym_of] = ACTIONS(2674),
    [anon_sym_while] = ACTIONS(2674),
    [anon_sym_do] = ACTIONS(2674),
    [anon_sym_try] = ACTIONS(2674),
    [anon_sym_with] = ACTIONS(2674),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_continue] = ACTIONS(2674),
    [anon_sym_debugger] = ACTIONS(2674),
    [anon_sym_return] = ACTIONS(2674),
    [anon_sym_throw] = ACTIONS(2674),
    [anon_sym_SEMI] = ACTIONS(2676),
    [anon_sym_case] = ACTIONS(2674),
    [anon_sym_yield] = ACTIONS(2674),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_LTtemplate_GT] = ACTIONS(2676),
    [anon_sym_LT] = ACTIONS(2674),
    [anon_sym_SLASH] = ACTIONS(2674),
    [anon_sym_class] = ACTIONS(2674),
    [anon_sym_async] = ACTIONS(2674),
    [anon_sym_function] = ACTIONS(2674),
    [anon_sym_new] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2674),
    [anon_sym_DASH] = ACTIONS(2674),
    [anon_sym_TILDE] = ACTIONS(2676),
    [anon_sym_void] = ACTIONS(2674),
    [anon_sym_delete] = ACTIONS(2674),
    [anon_sym_PLUS_PLUS] = ACTIONS(2676),
    [anon_sym_DASH_DASH] = ACTIONS(2676),
    [anon_sym_DQUOTE] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2676),
    [sym_number] = ACTIONS(2676),
    [sym_this] = ACTIONS(2674),
    [sym_super] = ACTIONS(2674),
    [sym_true] = ACTIONS(2674),
    [sym_false] = ACTIONS(2674),
    [sym_null] = ACTIONS(2674),
    [sym_undefined] = ACTIONS(2674),
    [anon_sym_AT] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2674),
    [anon_sym_readonly] = ACTIONS(2674),
    [anon_sym_get] = ACTIONS(2674),
    [anon_sym_set] = ACTIONS(2674),
    [anon_sym_declare] = ACTIONS(2674),
    [anon_sym_public] = ACTIONS(2674),
    [anon_sym_private] = ACTIONS(2674),
    [anon_sym_protected] = ACTIONS(2674),
    [anon_sym_override] = ACTIONS(2674),
    [anon_sym_module] = ACTIONS(2674),
    [anon_sym_any] = ACTIONS(2674),
    [anon_sym_number] = ACTIONS(2674),
    [anon_sym_boolean] = ACTIONS(2674),
    [anon_sym_string] = ACTIONS(2674),
    [anon_sym_symbol] = ACTIONS(2674),
    [anon_sym_property] = ACTIONS(2674),
    [anon_sym_signal] = ACTIONS(2674),
    [anon_sym_on] = ACTIONS(2674),
    [anon_sym_required] = ACTIONS(2674),
    [anon_sym_component] = ACTIONS(2674),
    [anon_sym_abstract] = ACTIONS(2674),
    [anon_sym_interface] = ACTIONS(2674),
    [anon_sym_enum] = ACTIONS(2674),
  },
  [823] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [824] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [825] = {
    [sym_identifier] = ACTIONS(2682),
    [anon_sym_export] = ACTIONS(2682),
    [anon_sym_default] = ACTIONS(2682),
    [anon_sym_type] = ACTIONS(2682),
    [anon_sym_namespace] = ACTIONS(2682),
    [anon_sym_LBRACE] = ACTIONS(2684),
    [anon_sym_RBRACE] = ACTIONS(2684),
    [anon_sym_typeof] = ACTIONS(2682),
    [anon_sym_import] = ACTIONS(2682),
    [anon_sym_from] = ACTIONS(2682),
    [anon_sym_var] = ACTIONS(2682),
    [anon_sym_let] = ACTIONS(2682),
    [anon_sym_const] = ACTIONS(2682),
    [anon_sym_BANG] = ACTIONS(2684),
    [anon_sym_else] = ACTIONS(2682),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_switch] = ACTIONS(2682),
    [anon_sym_for] = ACTIONS(2682),
    [anon_sym_LPAREN] = ACTIONS(2684),
    [anon_sym_await] = ACTIONS(2682),
    [anon_sym_of] = ACTIONS(2682),
    [anon_sym_while] = ACTIONS(2682),
    [anon_sym_do] = ACTIONS(2682),
    [anon_sym_try] = ACTIONS(2682),
    [anon_sym_with] = ACTIONS(2682),
    [anon_sym_break] = ACTIONS(2682),
    [anon_sym_continue] = ACTIONS(2682),
    [anon_sym_debugger] = ACTIONS(2682),
    [anon_sym_return] = ACTIONS(2682),
    [anon_sym_throw] = ACTIONS(2682),
    [anon_sym_SEMI] = ACTIONS(2684),
    [anon_sym_case] = ACTIONS(2682),
    [anon_sym_yield] = ACTIONS(2682),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_LTtemplate_GT] = ACTIONS(2684),
    [anon_sym_LT] = ACTIONS(2682),
    [anon_sym_SLASH] = ACTIONS(2682),
    [anon_sym_class] = ACTIONS(2682),
    [anon_sym_async] = ACTIONS(2682),
    [anon_sym_function] = ACTIONS(2682),
    [anon_sym_new] = ACTIONS(2682),
    [anon_sym_PLUS] = ACTIONS(2682),
    [anon_sym_DASH] = ACTIONS(2682),
    [anon_sym_TILDE] = ACTIONS(2684),
    [anon_sym_void] = ACTIONS(2682),
    [anon_sym_delete] = ACTIONS(2682),
    [anon_sym_PLUS_PLUS] = ACTIONS(2684),
    [anon_sym_DASH_DASH] = ACTIONS(2684),
    [anon_sym_DQUOTE] = ACTIONS(2684),
    [anon_sym_SQUOTE] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2684),
    [sym_number] = ACTIONS(2684),
    [sym_this] = ACTIONS(2682),
    [sym_super] = ACTIONS(2682),
    [sym_true] = ACTIONS(2682),
    [sym_false] = ACTIONS(2682),
    [sym_null] = ACTIONS(2682),
    [sym_undefined] = ACTIONS(2682),
    [anon_sym_AT] = ACTIONS(2684),
    [anon_sym_static] = ACTIONS(2682),
    [anon_sym_readonly] = ACTIONS(2682),
    [anon_sym_get] = ACTIONS(2682),
    [anon_sym_set] = ACTIONS(2682),
    [anon_sym_declare] = ACTIONS(2682),
    [anon_sym_public] = ACTIONS(2682),
    [anon_sym_private] = ACTIONS(2682),
    [anon_sym_protected] = ACTIONS(2682),
    [anon_sym_override] = ACTIONS(2682),
    [anon_sym_module] = ACTIONS(2682),
    [anon_sym_any] = ACTIONS(2682),
    [anon_sym_number] = ACTIONS(2682),
    [anon_sym_boolean] = ACTIONS(2682),
    [anon_sym_string] = ACTIONS(2682),
    [anon_sym_symbol] = ACTIONS(2682),
    [anon_sym_property] = ACTIONS(2682),
    [anon_sym_signal] = ACTIONS(2682),
    [anon_sym_on] = ACTIONS(2682),
    [anon_sym_required] = ACTIONS(2682),
    [anon_sym_component] = ACTIONS(2682),
    [anon_sym_abstract] = ACTIONS(2682),
    [anon_sym_interface] = ACTIONS(2682),
    [anon_sym_enum] = ACTIONS(2682),
  },
  [826] = {
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_export] = ACTIONS(1567),
    [anon_sym_default] = ACTIONS(1567),
    [anon_sym_type] = ACTIONS(1567),
    [anon_sym_namespace] = ACTIONS(1567),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_RBRACE] = ACTIONS(1571),
    [anon_sym_typeof] = ACTIONS(1567),
    [anon_sym_import] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(1567),
    [anon_sym_var] = ACTIONS(1567),
    [anon_sym_let] = ACTIONS(1567),
    [anon_sym_const] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_else] = ACTIONS(1567),
    [anon_sym_if] = ACTIONS(1567),
    [anon_sym_switch] = ACTIONS(1567),
    [anon_sym_for] = ACTIONS(1567),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_of] = ACTIONS(1567),
    [anon_sym_while] = ACTIONS(1567),
    [anon_sym_do] = ACTIONS(1567),
    [anon_sym_try] = ACTIONS(1567),
    [anon_sym_with] = ACTIONS(1567),
    [anon_sym_break] = ACTIONS(1567),
    [anon_sym_continue] = ACTIONS(1567),
    [anon_sym_debugger] = ACTIONS(1567),
    [anon_sym_return] = ACTIONS(1567),
    [anon_sym_throw] = ACTIONS(1567),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_case] = ACTIONS(1567),
    [anon_sym_yield] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(1571),
    [anon_sym_LTtemplate_GT] = ACTIONS(1571),
    [anon_sym_LT] = ACTIONS(1567),
    [anon_sym_SLASH] = ACTIONS(1567),
    [anon_sym_class] = ACTIONS(1567),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_function] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(1567),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_void] = ACTIONS(1567),
    [anon_sym_delete] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_DQUOTE] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1571),
    [sym_number] = ACTIONS(1571),
    [sym_this] = ACTIONS(1567),
    [sym_super] = ACTIONS(1567),
    [sym_true] = ACTIONS(1567),
    [sym_false] = ACTIONS(1567),
    [sym_null] = ACTIONS(1567),
    [sym_undefined] = ACTIONS(1567),
    [anon_sym_AT] = ACTIONS(1571),
    [anon_sym_static] = ACTIONS(1567),
    [anon_sym_readonly] = ACTIONS(1567),
    [anon_sym_get] = ACTIONS(1567),
    [anon_sym_set] = ACTIONS(1567),
    [anon_sym_declare] = ACTIONS(1567),
    [anon_sym_public] = ACTIONS(1567),
    [anon_sym_private] = ACTIONS(1567),
    [anon_sym_protected] = ACTIONS(1567),
    [anon_sym_override] = ACTIONS(1567),
    [anon_sym_module] = ACTIONS(1567),
    [anon_sym_any] = ACTIONS(1567),
    [anon_sym_number] = ACTIONS(1567),
    [anon_sym_boolean] = ACTIONS(1567),
    [anon_sym_string] = ACTIONS(1567),
    [anon_sym_symbol] = ACTIONS(1567),
    [anon_sym_property] = ACTIONS(1567),
    [anon_sym_signal] = ACTIONS(1567),
    [anon_sym_on] = ACTIONS(1567),
    [anon_sym_required] = ACTIONS(1567),
    [anon_sym_component] = ACTIONS(1567),
    [anon_sym_abstract] = ACTIONS(1567),
    [anon_sym_interface] = ACTIONS(1567),
    [anon_sym_enum] = ACTIONS(1567),
  },
  [827] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [828] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [829] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [830] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [831] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [832] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [833] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [834] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [835] = {
    [sym_identifier] = ACTIONS(2674),
    [anon_sym_export] = ACTIONS(2674),
    [anon_sym_default] = ACTIONS(2674),
    [anon_sym_type] = ACTIONS(2674),
    [anon_sym_namespace] = ACTIONS(2674),
    [anon_sym_LBRACE] = ACTIONS(2676),
    [anon_sym_RBRACE] = ACTIONS(2676),
    [anon_sym_typeof] = ACTIONS(2674),
    [anon_sym_import] = ACTIONS(2674),
    [anon_sym_from] = ACTIONS(2674),
    [anon_sym_var] = ACTIONS(2674),
    [anon_sym_let] = ACTIONS(2674),
    [anon_sym_const] = ACTIONS(2674),
    [anon_sym_BANG] = ACTIONS(2676),
    [anon_sym_else] = ACTIONS(2674),
    [anon_sym_if] = ACTIONS(2674),
    [anon_sym_switch] = ACTIONS(2674),
    [anon_sym_for] = ACTIONS(2674),
    [anon_sym_LPAREN] = ACTIONS(2676),
    [anon_sym_await] = ACTIONS(2674),
    [anon_sym_of] = ACTIONS(2674),
    [anon_sym_while] = ACTIONS(2674),
    [anon_sym_do] = ACTIONS(2674),
    [anon_sym_try] = ACTIONS(2674),
    [anon_sym_with] = ACTIONS(2674),
    [anon_sym_break] = ACTIONS(2674),
    [anon_sym_continue] = ACTIONS(2674),
    [anon_sym_debugger] = ACTIONS(2674),
    [anon_sym_return] = ACTIONS(2674),
    [anon_sym_throw] = ACTIONS(2674),
    [anon_sym_SEMI] = ACTIONS(2676),
    [anon_sym_case] = ACTIONS(2674),
    [anon_sym_yield] = ACTIONS(2674),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_LTtemplate_GT] = ACTIONS(2676),
    [anon_sym_LT] = ACTIONS(2674),
    [anon_sym_SLASH] = ACTIONS(2674),
    [anon_sym_class] = ACTIONS(2674),
    [anon_sym_async] = ACTIONS(2674),
    [anon_sym_function] = ACTIONS(2674),
    [anon_sym_new] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2674),
    [anon_sym_DASH] = ACTIONS(2674),
    [anon_sym_TILDE] = ACTIONS(2676),
    [anon_sym_void] = ACTIONS(2674),
    [anon_sym_delete] = ACTIONS(2674),
    [anon_sym_PLUS_PLUS] = ACTIONS(2676),
    [anon_sym_DASH_DASH] = ACTIONS(2676),
    [anon_sym_DQUOTE] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2676),
    [sym_number] = ACTIONS(2676),
    [sym_this] = ACTIONS(2674),
    [sym_super] = ACTIONS(2674),
    [sym_true] = ACTIONS(2674),
    [sym_false] = ACTIONS(2674),
    [sym_null] = ACTIONS(2674),
    [sym_undefined] = ACTIONS(2674),
    [anon_sym_AT] = ACTIONS(2676),
    [anon_sym_static] = ACTIONS(2674),
    [anon_sym_readonly] = ACTIONS(2674),
    [anon_sym_get] = ACTIONS(2674),
    [anon_sym_set] = ACTIONS(2674),
    [anon_sym_declare] = ACTIONS(2674),
    [anon_sym_public] = ACTIONS(2674),
    [anon_sym_private] = ACTIONS(2674),
    [anon_sym_protected] = ACTIONS(2674),
    [anon_sym_override] = ACTIONS(2674),
    [anon_sym_module] = ACTIONS(2674),
    [anon_sym_any] = ACTIONS(2674),
    [anon_sym_number] = ACTIONS(2674),
    [anon_sym_boolean] = ACTIONS(2674),
    [anon_sym_string] = ACTIONS(2674),
    [anon_sym_symbol] = ACTIONS(2674),
    [anon_sym_property] = ACTIONS(2674),
    [anon_sym_signal] = ACTIONS(2674),
    [anon_sym_on] = ACTIONS(2674),
    [anon_sym_required] = ACTIONS(2674),
    [anon_sym_component] = ACTIONS(2674),
    [anon_sym_abstract] = ACTIONS(2674),
    [anon_sym_interface] = ACTIONS(2674),
    [anon_sym_enum] = ACTIONS(2674),
  },
  [836] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [837] = {
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_default] = ACTIONS(2686),
    [anon_sym_type] = ACTIONS(2686),
    [anon_sym_namespace] = ACTIONS(2686),
    [anon_sym_LBRACE] = ACTIONS(2688),
    [anon_sym_RBRACE] = ACTIONS(2688),
    [anon_sym_typeof] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2686),
    [anon_sym_from] = ACTIONS(2686),
    [anon_sym_var] = ACTIONS(2686),
    [anon_sym_let] = ACTIONS(2686),
    [anon_sym_const] = ACTIONS(2686),
    [anon_sym_BANG] = ACTIONS(2688),
    [anon_sym_else] = ACTIONS(2686),
    [anon_sym_if] = ACTIONS(2686),
    [anon_sym_switch] = ACTIONS(2686),
    [anon_sym_for] = ACTIONS(2686),
    [anon_sym_LPAREN] = ACTIONS(2688),
    [anon_sym_await] = ACTIONS(2686),
    [anon_sym_of] = ACTIONS(2686),
    [anon_sym_while] = ACTIONS(2686),
    [anon_sym_do] = ACTIONS(2686),
    [anon_sym_try] = ACTIONS(2686),
    [anon_sym_with] = ACTIONS(2686),
    [anon_sym_break] = ACTIONS(2686),
    [anon_sym_continue] = ACTIONS(2686),
    [anon_sym_debugger] = ACTIONS(2686),
    [anon_sym_return] = ACTIONS(2686),
    [anon_sym_throw] = ACTIONS(2686),
    [anon_sym_SEMI] = ACTIONS(2688),
    [anon_sym_case] = ACTIONS(2686),
    [anon_sym_yield] = ACTIONS(2686),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_LTtemplate_GT] = ACTIONS(2688),
    [anon_sym_LT] = ACTIONS(2686),
    [anon_sym_SLASH] = ACTIONS(2686),
    [anon_sym_class] = ACTIONS(2686),
    [anon_sym_async] = ACTIONS(2686),
    [anon_sym_function] = ACTIONS(2686),
    [anon_sym_new] = ACTIONS(2686),
    [anon_sym_PLUS] = ACTIONS(2686),
    [anon_sym_DASH] = ACTIONS(2686),
    [anon_sym_TILDE] = ACTIONS(2688),
    [anon_sym_void] = ACTIONS(2686),
    [anon_sym_delete] = ACTIONS(2686),
    [anon_sym_PLUS_PLUS] = ACTIONS(2688),
    [anon_sym_DASH_DASH] = ACTIONS(2688),
    [anon_sym_DQUOTE] = ACTIONS(2688),
    [anon_sym_SQUOTE] = ACTIONS(2688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2688),
    [sym_number] = ACTIONS(2688),
    [sym_this] = ACTIONS(2686),
    [sym_super] = ACTIONS(2686),
    [sym_true] = ACTIONS(2686),
    [sym_false] = ACTIONS(2686),
    [sym_null] = ACTIONS(2686),
    [sym_undefined] = ACTIONS(2686),
    [anon_sym_AT] = ACTIONS(2688),
    [anon_sym_static] = ACTIONS(2686),
    [anon_sym_readonly] = ACTIONS(2686),
    [anon_sym_get] = ACTIONS(2686),
    [anon_sym_set] = ACTIONS(2686),
    [anon_sym_declare] = ACTIONS(2686),
    [anon_sym_public] = ACTIONS(2686),
    [anon_sym_private] = ACTIONS(2686),
    [anon_sym_protected] = ACTIONS(2686),
    [anon_sym_override] = ACTIONS(2686),
    [anon_sym_module] = ACTIONS(2686),
    [anon_sym_any] = ACTIONS(2686),
    [anon_sym_number] = ACTIONS(2686),
    [anon_sym_boolean] = ACTIONS(2686),
    [anon_sym_string] = ACTIONS(2686),
    [anon_sym_symbol] = ACTIONS(2686),
    [anon_sym_property] = ACTIONS(2686),
    [anon_sym_signal] = ACTIONS(2686),
    [anon_sym_on] = ACTIONS(2686),
    [anon_sym_required] = ACTIONS(2686),
    [anon_sym_component] = ACTIONS(2686),
    [anon_sym_abstract] = ACTIONS(2686),
    [anon_sym_interface] = ACTIONS(2686),
    [anon_sym_enum] = ACTIONS(2686),
  },
  [838] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [839] = {
    [sym_identifier] = ACTIONS(2690),
    [anon_sym_export] = ACTIONS(2690),
    [anon_sym_default] = ACTIONS(2690),
    [anon_sym_type] = ACTIONS(2690),
    [anon_sym_namespace] = ACTIONS(2690),
    [anon_sym_LBRACE] = ACTIONS(2692),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [anon_sym_typeof] = ACTIONS(2690),
    [anon_sym_import] = ACTIONS(2690),
    [anon_sym_from] = ACTIONS(2690),
    [anon_sym_var] = ACTIONS(2690),
    [anon_sym_let] = ACTIONS(2690),
    [anon_sym_const] = ACTIONS(2690),
    [anon_sym_BANG] = ACTIONS(2692),
    [anon_sym_else] = ACTIONS(2690),
    [anon_sym_if] = ACTIONS(2690),
    [anon_sym_switch] = ACTIONS(2690),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_await] = ACTIONS(2690),
    [anon_sym_of] = ACTIONS(2690),
    [anon_sym_while] = ACTIONS(2690),
    [anon_sym_do] = ACTIONS(2690),
    [anon_sym_try] = ACTIONS(2690),
    [anon_sym_with] = ACTIONS(2690),
    [anon_sym_break] = ACTIONS(2690),
    [anon_sym_continue] = ACTIONS(2690),
    [anon_sym_debugger] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2690),
    [anon_sym_throw] = ACTIONS(2690),
    [anon_sym_SEMI] = ACTIONS(2692),
    [anon_sym_case] = ACTIONS(2690),
    [anon_sym_yield] = ACTIONS(2690),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_LTtemplate_GT] = ACTIONS(2692),
    [anon_sym_LT] = ACTIONS(2690),
    [anon_sym_SLASH] = ACTIONS(2690),
    [anon_sym_class] = ACTIONS(2690),
    [anon_sym_async] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2690),
    [anon_sym_new] = ACTIONS(2690),
    [anon_sym_PLUS] = ACTIONS(2690),
    [anon_sym_DASH] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2692),
    [anon_sym_void] = ACTIONS(2690),
    [anon_sym_delete] = ACTIONS(2690),
    [anon_sym_PLUS_PLUS] = ACTIONS(2692),
    [anon_sym_DASH_DASH] = ACTIONS(2692),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [anon_sym_SQUOTE] = ACTIONS(2692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2692),
    [sym_number] = ACTIONS(2692),
    [sym_this] = ACTIONS(2690),
    [sym_super] = ACTIONS(2690),
    [sym_true] = ACTIONS(2690),
    [sym_false] = ACTIONS(2690),
    [sym_null] = ACTIONS(2690),
    [sym_undefined] = ACTIONS(2690),
    [anon_sym_AT] = ACTIONS(2692),
    [anon_sym_static] = ACTIONS(2690),
    [anon_sym_readonly] = ACTIONS(2690),
    [anon_sym_get] = ACTIONS(2690),
    [anon_sym_set] = ACTIONS(2690),
    [anon_sym_declare] = ACTIONS(2690),
    [anon_sym_public] = ACTIONS(2690),
    [anon_sym_private] = ACTIONS(2690),
    [anon_sym_protected] = ACTIONS(2690),
    [anon_sym_override] = ACTIONS(2690),
    [anon_sym_module] = ACTIONS(2690),
    [anon_sym_any] = ACTIONS(2690),
    [anon_sym_number] = ACTIONS(2690),
    [anon_sym_boolean] = ACTIONS(2690),
    [anon_sym_string] = ACTIONS(2690),
    [anon_sym_symbol] = ACTIONS(2690),
    [anon_sym_property] = ACTIONS(2690),
    [anon_sym_signal] = ACTIONS(2690),
    [anon_sym_on] = ACTIONS(2690),
    [anon_sym_required] = ACTIONS(2690),
    [anon_sym_component] = ACTIONS(2690),
    [anon_sym_abstract] = ACTIONS(2690),
    [anon_sym_interface] = ACTIONS(2690),
    [anon_sym_enum] = ACTIONS(2690),
  },
  [840] = {
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_export] = ACTIONS(1567),
    [anon_sym_default] = ACTIONS(1567),
    [anon_sym_type] = ACTIONS(1567),
    [anon_sym_namespace] = ACTIONS(1567),
    [anon_sym_LBRACE] = ACTIONS(1571),
    [anon_sym_RBRACE] = ACTIONS(1571),
    [anon_sym_typeof] = ACTIONS(1567),
    [anon_sym_import] = ACTIONS(1567),
    [anon_sym_from] = ACTIONS(1567),
    [anon_sym_var] = ACTIONS(1567),
    [anon_sym_let] = ACTIONS(1567),
    [anon_sym_const] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_else] = ACTIONS(1567),
    [anon_sym_if] = ACTIONS(1567),
    [anon_sym_switch] = ACTIONS(1567),
    [anon_sym_for] = ACTIONS(1567),
    [anon_sym_LPAREN] = ACTIONS(1571),
    [anon_sym_await] = ACTIONS(1567),
    [anon_sym_of] = ACTIONS(1567),
    [anon_sym_while] = ACTIONS(1567),
    [anon_sym_do] = ACTIONS(1567),
    [anon_sym_try] = ACTIONS(1567),
    [anon_sym_with] = ACTIONS(1567),
    [anon_sym_break] = ACTIONS(1567),
    [anon_sym_continue] = ACTIONS(1567),
    [anon_sym_debugger] = ACTIONS(1567),
    [anon_sym_return] = ACTIONS(1567),
    [anon_sym_throw] = ACTIONS(1567),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_case] = ACTIONS(1567),
    [anon_sym_yield] = ACTIONS(1567),
    [anon_sym_LBRACK] = ACTIONS(1571),
    [anon_sym_LTtemplate_GT] = ACTIONS(1571),
    [anon_sym_LT] = ACTIONS(1567),
    [anon_sym_SLASH] = ACTIONS(1567),
    [anon_sym_class] = ACTIONS(1567),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_function] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(1567),
    [anon_sym_PLUS] = ACTIONS(1567),
    [anon_sym_DASH] = ACTIONS(1567),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_void] = ACTIONS(1567),
    [anon_sym_delete] = ACTIONS(1567),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_DQUOTE] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1571),
    [sym_number] = ACTIONS(1571),
    [sym_this] = ACTIONS(1567),
    [sym_super] = ACTIONS(1567),
    [sym_true] = ACTIONS(1567),
    [sym_false] = ACTIONS(1567),
    [sym_null] = ACTIONS(1567),
    [sym_undefined] = ACTIONS(1567),
    [anon_sym_AT] = ACTIONS(1571),
    [anon_sym_static] = ACTIONS(1567),
    [anon_sym_readonly] = ACTIONS(1567),
    [anon_sym_get] = ACTIONS(1567),
    [anon_sym_set] = ACTIONS(1567),
    [anon_sym_declare] = ACTIONS(1567),
    [anon_sym_public] = ACTIONS(1567),
    [anon_sym_private] = ACTIONS(1567),
    [anon_sym_protected] = ACTIONS(1567),
    [anon_sym_override] = ACTIONS(1567),
    [anon_sym_module] = ACTIONS(1567),
    [anon_sym_any] = ACTIONS(1567),
    [anon_sym_number] = ACTIONS(1567),
    [anon_sym_boolean] = ACTIONS(1567),
    [anon_sym_string] = ACTIONS(1567),
    [anon_sym_symbol] = ACTIONS(1567),
    [anon_sym_property] = ACTIONS(1567),
    [anon_sym_signal] = ACTIONS(1567),
    [anon_sym_on] = ACTIONS(1567),
    [anon_sym_required] = ACTIONS(1567),
    [anon_sym_component] = ACTIONS(1567),
    [anon_sym_abstract] = ACTIONS(1567),
    [anon_sym_interface] = ACTIONS(1567),
    [anon_sym_enum] = ACTIONS(1567),
  },
  [841] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [842] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [843] = {
    [sym_identifier] = ACTIONS(2694),
    [anon_sym_export] = ACTIONS(2694),
    [anon_sym_default] = ACTIONS(2694),
    [anon_sym_type] = ACTIONS(2694),
    [anon_sym_namespace] = ACTIONS(2694),
    [anon_sym_LBRACE] = ACTIONS(2696),
    [anon_sym_RBRACE] = ACTIONS(2696),
    [anon_sym_typeof] = ACTIONS(2694),
    [anon_sym_import] = ACTIONS(2694),
    [anon_sym_from] = ACTIONS(2694),
    [anon_sym_var] = ACTIONS(2694),
    [anon_sym_let] = ACTIONS(2694),
    [anon_sym_const] = ACTIONS(2694),
    [anon_sym_BANG] = ACTIONS(2696),
    [anon_sym_else] = ACTIONS(2694),
    [anon_sym_if] = ACTIONS(2694),
    [anon_sym_switch] = ACTIONS(2694),
    [anon_sym_for] = ACTIONS(2694),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_await] = ACTIONS(2694),
    [anon_sym_of] = ACTIONS(2694),
    [anon_sym_while] = ACTIONS(2694),
    [anon_sym_do] = ACTIONS(2694),
    [anon_sym_try] = ACTIONS(2694),
    [anon_sym_with] = ACTIONS(2694),
    [anon_sym_break] = ACTIONS(2694),
    [anon_sym_continue] = ACTIONS(2694),
    [anon_sym_debugger] = ACTIONS(2694),
    [anon_sym_return] = ACTIONS(2694),
    [anon_sym_throw] = ACTIONS(2694),
    [anon_sym_SEMI] = ACTIONS(2696),
    [anon_sym_case] = ACTIONS(2694),
    [anon_sym_yield] = ACTIONS(2694),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_LTtemplate_GT] = ACTIONS(2696),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_SLASH] = ACTIONS(2694),
    [anon_sym_class] = ACTIONS(2694),
    [anon_sym_async] = ACTIONS(2694),
    [anon_sym_function] = ACTIONS(2694),
    [anon_sym_new] = ACTIONS(2694),
    [anon_sym_PLUS] = ACTIONS(2694),
    [anon_sym_DASH] = ACTIONS(2694),
    [anon_sym_TILDE] = ACTIONS(2696),
    [anon_sym_void] = ACTIONS(2694),
    [anon_sym_delete] = ACTIONS(2694),
    [anon_sym_PLUS_PLUS] = ACTIONS(2696),
    [anon_sym_DASH_DASH] = ACTIONS(2696),
    [anon_sym_DQUOTE] = ACTIONS(2696),
    [anon_sym_SQUOTE] = ACTIONS(2696),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2696),
    [sym_number] = ACTIONS(2696),
    [sym_this] = ACTIONS(2694),
    [sym_super] = ACTIONS(2694),
    [sym_true] = ACTIONS(2694),
    [sym_false] = ACTIONS(2694),
    [sym_null] = ACTIONS(2694),
    [sym_undefined] = ACTIONS(2694),
    [anon_sym_AT] = ACTIONS(2696),
    [anon_sym_static] = ACTIONS(2694),
    [anon_sym_readonly] = ACTIONS(2694),
    [anon_sym_get] = ACTIONS(2694),
    [anon_sym_set] = ACTIONS(2694),
    [anon_sym_declare] = ACTIONS(2694),
    [anon_sym_public] = ACTIONS(2694),
    [anon_sym_private] = ACTIONS(2694),
    [anon_sym_protected] = ACTIONS(2694),
    [anon_sym_override] = ACTIONS(2694),
    [anon_sym_module] = ACTIONS(2694),
    [anon_sym_any] = ACTIONS(2694),
    [anon_sym_number] = ACTIONS(2694),
    [anon_sym_boolean] = ACTIONS(2694),
    [anon_sym_string] = ACTIONS(2694),
    [anon_sym_symbol] = ACTIONS(2694),
    [anon_sym_property] = ACTIONS(2694),
    [anon_sym_signal] = ACTIONS(2694),
    [anon_sym_on] = ACTIONS(2694),
    [anon_sym_required] = ACTIONS(2694),
    [anon_sym_component] = ACTIONS(2694),
    [anon_sym_abstract] = ACTIONS(2694),
    [anon_sym_interface] = ACTIONS(2694),
    [anon_sym_enum] = ACTIONS(2694),
  },
  [844] = {
    [sym_identifier] = ACTIONS(2698),
    [anon_sym_export] = ACTIONS(2698),
    [anon_sym_default] = ACTIONS(2698),
    [anon_sym_type] = ACTIONS(2698),
    [anon_sym_namespace] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2700),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_typeof] = ACTIONS(2698),
    [anon_sym_import] = ACTIONS(2698),
    [anon_sym_from] = ACTIONS(2698),
    [anon_sym_var] = ACTIONS(2698),
    [anon_sym_let] = ACTIONS(2698),
    [anon_sym_const] = ACTIONS(2698),
    [anon_sym_BANG] = ACTIONS(2700),
    [anon_sym_else] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_switch] = ACTIONS(2698),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2700),
    [anon_sym_await] = ACTIONS(2698),
    [anon_sym_of] = ACTIONS(2698),
    [anon_sym_while] = ACTIONS(2698),
    [anon_sym_do] = ACTIONS(2698),
    [anon_sym_try] = ACTIONS(2698),
    [anon_sym_with] = ACTIONS(2698),
    [anon_sym_break] = ACTIONS(2698),
    [anon_sym_continue] = ACTIONS(2698),
    [anon_sym_debugger] = ACTIONS(2698),
    [anon_sym_return] = ACTIONS(2698),
    [anon_sym_throw] = ACTIONS(2698),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_case] = ACTIONS(2698),
    [anon_sym_yield] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2700),
    [anon_sym_LTtemplate_GT] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2698),
    [anon_sym_class] = ACTIONS(2698),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_function] = ACTIONS(2698),
    [anon_sym_new] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_TILDE] = ACTIONS(2700),
    [anon_sym_void] = ACTIONS(2698),
    [anon_sym_delete] = ACTIONS(2698),
    [anon_sym_PLUS_PLUS] = ACTIONS(2700),
    [anon_sym_DASH_DASH] = ACTIONS(2700),
    [anon_sym_DQUOTE] = ACTIONS(2700),
    [anon_sym_SQUOTE] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [sym_number] = ACTIONS(2700),
    [sym_this] = ACTIONS(2698),
    [sym_super] = ACTIONS(2698),
    [sym_true] = ACTIONS(2698),
    [sym_false] = ACTIONS(2698),
    [sym_null] = ACTIONS(2698),
    [sym_undefined] = ACTIONS(2698),
    [anon_sym_AT] = ACTIONS(2700),
    [anon_sym_static] = ACTIONS(2698),
    [anon_sym_readonly] = ACTIONS(2698),
    [anon_sym_get] = ACTIONS(2698),
    [anon_sym_set] = ACTIONS(2698),
    [anon_sym_declare] = ACTIONS(2698),
    [anon_sym_public] = ACTIONS(2698),
    [anon_sym_private] = ACTIONS(2698),
    [anon_sym_protected] = ACTIONS(2698),
    [anon_sym_override] = ACTIONS(2698),
    [anon_sym_module] = ACTIONS(2698),
    [anon_sym_any] = ACTIONS(2698),
    [anon_sym_number] = ACTIONS(2698),
    [anon_sym_boolean] = ACTIONS(2698),
    [anon_sym_string] = ACTIONS(2698),
    [anon_sym_symbol] = ACTIONS(2698),
    [anon_sym_property] = ACTIONS(2698),
    [anon_sym_signal] = ACTIONS(2698),
    [anon_sym_on] = ACTIONS(2698),
    [anon_sym_required] = ACTIONS(2698),
    [anon_sym_component] = ACTIONS(2698),
    [anon_sym_abstract] = ACTIONS(2698),
    [anon_sym_interface] = ACTIONS(2698),
    [anon_sym_enum] = ACTIONS(2698),
  },
  [845] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_default] = ACTIONS(2702),
    [anon_sym_type] = ACTIONS(2702),
    [anon_sym_namespace] = ACTIONS(2702),
    [anon_sym_LBRACE] = ACTIONS(2704),
    [anon_sym_RBRACE] = ACTIONS(2704),
    [anon_sym_typeof] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_from] = ACTIONS(2702),
    [anon_sym_var] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_BANG] = ACTIONS(2704),
    [anon_sym_else] = ACTIONS(2702),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_switch] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2704),
    [anon_sym_await] = ACTIONS(2702),
    [anon_sym_of] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [anon_sym_do] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_with] = ACTIONS(2702),
    [anon_sym_break] = ACTIONS(2702),
    [anon_sym_continue] = ACTIONS(2702),
    [anon_sym_debugger] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_throw] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2704),
    [anon_sym_case] = ACTIONS(2702),
    [anon_sym_yield] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(2704),
    [anon_sym_LTtemplate_GT] = ACTIONS(2704),
    [anon_sym_LT] = ACTIONS(2702),
    [anon_sym_SLASH] = ACTIONS(2702),
    [anon_sym_class] = ACTIONS(2702),
    [anon_sym_async] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_new] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_DASH] = ACTIONS(2702),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_void] = ACTIONS(2702),
    [anon_sym_delete] = ACTIONS(2702),
    [anon_sym_PLUS_PLUS] = ACTIONS(2704),
    [anon_sym_DASH_DASH] = ACTIONS(2704),
    [anon_sym_DQUOTE] = ACTIONS(2704),
    [anon_sym_SQUOTE] = ACTIONS(2704),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2704),
    [sym_number] = ACTIONS(2704),
    [sym_this] = ACTIONS(2702),
    [sym_super] = ACTIONS(2702),
    [sym_true] = ACTIONS(2702),
    [sym_false] = ACTIONS(2702),
    [sym_null] = ACTIONS(2702),
    [sym_undefined] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2704),
    [anon_sym_static] = ACTIONS(2702),
    [anon_sym_readonly] = ACTIONS(2702),
    [anon_sym_get] = ACTIONS(2702),
    [anon_sym_set] = ACTIONS(2702),
    [anon_sym_declare] = ACTIONS(2702),
    [anon_sym_public] = ACTIONS(2702),
    [anon_sym_private] = ACTIONS(2702),
    [anon_sym_protected] = ACTIONS(2702),
    [anon_sym_override] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_any] = ACTIONS(2702),
    [anon_sym_number] = ACTIONS(2702),
    [anon_sym_boolean] = ACTIONS(2702),
    [anon_sym_string] = ACTIONS(2702),
    [anon_sym_symbol] = ACTIONS(2702),
    [anon_sym_property] = ACTIONS(2702),
    [anon_sym_signal] = ACTIONS(2702),
    [anon_sym_on] = ACTIONS(2702),
    [anon_sym_required] = ACTIONS(2702),
    [anon_sym_component] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_interface] = ACTIONS(2702),
    [anon_sym_enum] = ACTIONS(2702),
  },
  [846] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [847] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [848] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [849] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [850] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_default] = ACTIONS(2678),
    [anon_sym_type] = ACTIONS(2678),
    [anon_sym_namespace] = ACTIONS(2678),
    [anon_sym_LBRACE] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_typeof] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_from] = ACTIONS(2678),
    [anon_sym_var] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_BANG] = ACTIONS(2680),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_switch] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_await] = ACTIONS(2678),
    [anon_sym_of] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [anon_sym_do] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_with] = ACTIONS(2678),
    [anon_sym_break] = ACTIONS(2678),
    [anon_sym_continue] = ACTIONS(2678),
    [anon_sym_debugger] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_throw] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_case] = ACTIONS(2678),
    [anon_sym_yield] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_LTtemplate_GT] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_SLASH] = ACTIONS(2678),
    [anon_sym_class] = ACTIONS(2678),
    [anon_sym_async] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_DASH] = ACTIONS(2678),
    [anon_sym_TILDE] = ACTIONS(2680),
    [anon_sym_void] = ACTIONS(2678),
    [anon_sym_delete] = ACTIONS(2678),
    [anon_sym_PLUS_PLUS] = ACTIONS(2680),
    [anon_sym_DASH_DASH] = ACTIONS(2680),
    [anon_sym_DQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2680),
    [sym_number] = ACTIONS(2680),
    [sym_this] = ACTIONS(2678),
    [sym_super] = ACTIONS(2678),
    [sym_true] = ACTIONS(2678),
    [sym_false] = ACTIONS(2678),
    [sym_null] = ACTIONS(2678),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [anon_sym_static] = ACTIONS(2678),
    [anon_sym_readonly] = ACTIONS(2678),
    [anon_sym_get] = ACTIONS(2678),
    [anon_sym_set] = ACTIONS(2678),
    [anon_sym_declare] = ACTIONS(2678),
    [anon_sym_public] = ACTIONS(2678),
    [anon_sym_private] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(2678),
    [anon_sym_override] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(2678),
    [anon_sym_number] = ACTIONS(2678),
    [anon_sym_boolean] = ACTIONS(2678),
    [anon_sym_string] = ACTIONS(2678),
    [anon_sym_symbol] = ACTIONS(2678),
    [anon_sym_property] = ACTIONS(2678),
    [anon_sym_signal] = ACTIONS(2678),
    [anon_sym_on] = ACTIONS(2678),
    [anon_sym_required] = ACTIONS(2678),
    [anon_sym_component] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_interface] = ACTIONS(2678),
    [anon_sym_enum] = ACTIONS(2678),
  },
  [851] = {
    [sym_identifier] = ACTIONS(2706),
    [anon_sym_export] = ACTIONS(2706),
    [anon_sym_default] = ACTIONS(2706),
    [anon_sym_type] = ACTIONS(2706),
    [anon_sym_namespace] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2708),
    [anon_sym_RBRACE] = ACTIONS(2708),
    [anon_sym_typeof] = ACTIONS(2706),
    [anon_sym_import] = ACTIONS(2706),
    [anon_sym_from] = ACTIONS(2706),
    [anon_sym_var] = ACTIONS(2706),
    [anon_sym_let] = ACTIONS(2706),
    [anon_sym_const] = ACTIONS(2706),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_else] = ACTIONS(2706),
    [anon_sym_if] = ACTIONS(2706),
    [anon_sym_switch] = ACTIONS(2706),
    [anon_sym_for] = ACTIONS(2706),
    [anon_sym_LPAREN] = ACTIONS(2708),
    [anon_sym_await] = ACTIONS(2706),
    [anon_sym_of] = ACTIONS(2706),
    [anon_sym_while] = ACTIONS(2706),
    [anon_sym_do] = ACTIONS(2706),
    [anon_sym_try] = ACTIONS(2706),
    [anon_sym_with] = ACTIONS(2706),
    [anon_sym_break] = ACTIONS(2706),
    [anon_sym_continue] = ACTIONS(2706),
    [anon_sym_debugger] = ACTIONS(2706),
    [anon_sym_return] = ACTIONS(2706),
    [anon_sym_throw] = ACTIONS(2706),
    [anon_sym_SEMI] = ACTIONS(2708),
    [anon_sym_case] = ACTIONS(2706),
    [anon_sym_yield] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(2708),
    [anon_sym_LTtemplate_GT] = ACTIONS(2708),
    [anon_sym_LT] = ACTIONS(2706),
    [anon_sym_SLASH] = ACTIONS(2706),
    [anon_sym_class] = ACTIONS(2706),
    [anon_sym_async] = ACTIONS(2706),
    [anon_sym_function] = ACTIONS(2706),
    [anon_sym_new] = ACTIONS(2706),
    [anon_sym_PLUS] = ACTIONS(2706),
    [anon_sym_DASH] = ACTIONS(2706),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_void] = ACTIONS(2706),
    [anon_sym_delete] = ACTIONS(2706),
    [anon_sym_PLUS_PLUS] = ACTIONS(2708),
    [anon_sym_DASH_DASH] = ACTIONS(2708),
    [anon_sym_DQUOTE] = ACTIONS(2708),
    [anon_sym_SQUOTE] = ACTIONS(2708),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2708),
    [sym_number] = ACTIONS(2708),
    [sym_this] = ACTIONS(2706),
    [sym_super] = ACTIONS(2706),
    [sym_true] = ACTIONS(2706),
    [sym_false] = ACTIONS(2706),
    [sym_null] = ACTIONS(2706),
    [sym_undefined] = ACTIONS(2706),
    [anon_sym_AT] = ACTIONS(2708),
    [anon_sym_static] = ACTIONS(2706),
    [anon_sym_readonly] = ACTIONS(2706),
    [anon_sym_get] = ACTIONS(2706),
    [anon_sym_set] = ACTIONS(2706),
    [anon_sym_declare] = ACTIONS(2706),
    [anon_sym_public] = ACTIONS(2706),
    [anon_sym_private] = ACTIONS(2706),
    [anon_sym_protected] = ACTIONS(2706),
    [anon_sym_override] = ACTIONS(2706),
    [anon_sym_module] = ACTIONS(2706),
    [anon_sym_any] = ACTIONS(2706),
    [anon_sym_number] = ACTIONS(2706),
    [anon_sym_boolean] = ACTIONS(2706),
    [anon_sym_string] = ACTIONS(2706),
    [anon_sym_symbol] = ACTIONS(2706),
    [anon_sym_property] = ACTIONS(2706),
    [anon_sym_signal] = ACTIONS(2706),
    [anon_sym_on] = ACTIONS(2706),
    [anon_sym_required] = ACTIONS(2706),
    [anon_sym_component] = ACTIONS(2706),
    [anon_sym_abstract] = ACTIONS(2706),
    [anon_sym_interface] = ACTIONS(2706),
    [anon_sym_enum] = ACTIONS(2706),
  },
  [852] = {
    [sym_identifier] = ACTIONS(2710),
    [anon_sym_export] = ACTIONS(2710),
    [anon_sym_type] = ACTIONS(2710),
    [anon_sym_namespace] = ACTIONS(2710),
    [anon_sym_LBRACE] = ACTIONS(2712),
    [anon_sym_typeof] = ACTIONS(2710),
    [anon_sym_import] = ACTIONS(2710),
    [anon_sym_from] = ACTIONS(2710),
    [anon_sym_var] = ACTIONS(2710),
    [anon_sym_let] = ACTIONS(2710),
    [anon_sym_const] = ACTIONS(2710),
    [anon_sym_BANG] = ACTIONS(2712),
    [anon_sym_if] = ACTIONS(2710),
    [anon_sym_switch] = ACTIONS(2710),
    [anon_sym_for] = ACTIONS(2710),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [anon_sym_await] = ACTIONS(2710),
    [anon_sym_of] = ACTIONS(2710),
    [anon_sym_while] = ACTIONS(2710),
    [anon_sym_do] = ACTIONS(2710),
    [anon_sym_try] = ACTIONS(2710),
    [anon_sym_with] = ACTIONS(2710),
    [anon_sym_break] = ACTIONS(2710),
    [anon_sym_continue] = ACTIONS(2710),
    [anon_sym_debugger] = ACTIONS(2710),
    [anon_sym_return] = ACTIONS(2710),
    [anon_sym_throw] = ACTIONS(2710),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_yield] = ACTIONS(2710),
    [anon_sym_LBRACK] = ACTIONS(2712),
    [anon_sym_LTtemplate_GT] = ACTIONS(2712),
    [anon_sym_LT] = ACTIONS(2710),
    [anon_sym_SLASH] = ACTIONS(2710),
    [anon_sym_class] = ACTIONS(2710),
    [anon_sym_async] = ACTIONS(2710),
    [anon_sym_function] = ACTIONS(2710),
    [anon_sym_new] = ACTIONS(2710),
    [anon_sym_PLUS] = ACTIONS(2710),
    [anon_sym_DASH] = ACTIONS(2710),
    [anon_sym_TILDE] = ACTIONS(2712),
    [anon_sym_void] = ACTIONS(2710),
    [anon_sym_delete] = ACTIONS(2710),
    [anon_sym_PLUS_PLUS] = ACTIONS(2712),
    [anon_sym_DASH_DASH] = ACTIONS(2712),
    [anon_sym_DQUOTE] = ACTIONS(2712),
    [anon_sym_SQUOTE] = ACTIONS(2712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2712),
    [sym_number] = ACTIONS(2712),
    [sym_this] = ACTIONS(2710),
    [sym_super] = ACTIONS(2710),
    [sym_true] = ACTIONS(2710),
    [sym_false] = ACTIONS(2710),
    [sym_null] = ACTIONS(2710),
    [sym_undefined] = ACTIONS(2710),
    [anon_sym_AT] = ACTIONS(2712),
    [anon_sym_static] = ACTIONS(2710),
    [anon_sym_readonly] = ACTIONS(2710),
    [anon_sym_get] = ACTIONS(2710),
    [anon_sym_set] = ACTIONS(2710),
    [anon_sym_declare] = ACTIONS(2710),
    [anon_sym_public] = ACTIONS(2710),
    [anon_sym_private] = ACTIONS(2710),
    [anon_sym_protected] = ACTIONS(2710),
    [anon_sym_override] = ACTIONS(2710),
    [anon_sym_module] = ACTIONS(2710),
    [anon_sym_any] = ACTIONS(2710),
    [anon_sym_number] = ACTIONS(2710),
    [anon_sym_boolean] = ACTIONS(2710),
    [anon_sym_string] = ACTIONS(2710),
    [anon_sym_symbol] = ACTIONS(2710),
    [anon_sym_property] = ACTIONS(2710),
    [anon_sym_signal] = ACTIONS(2710),
    [anon_sym_on] = ACTIONS(2710),
    [anon_sym_required] = ACTIONS(2710),
    [anon_sym_component] = ACTIONS(2710),
    [anon_sym_abstract] = ACTIONS(2710),
    [anon_sym_interface] = ACTIONS(2710),
    [anon_sym_enum] = ACTIONS(2710),
  },
  [853] = {
    [sym_identifier] = ACTIONS(2714),
    [anon_sym_export] = ACTIONS(2714),
    [anon_sym_type] = ACTIONS(2714),
    [anon_sym_namespace] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(2716),
    [anon_sym_typeof] = ACTIONS(2714),
    [anon_sym_import] = ACTIONS(2714),
    [anon_sym_from] = ACTIONS(2714),
    [anon_sym_var] = ACTIONS(2714),
    [anon_sym_let] = ACTIONS(2714),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_BANG] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2714),
    [anon_sym_switch] = ACTIONS(2714),
    [anon_sym_for] = ACTIONS(2714),
    [anon_sym_LPAREN] = ACTIONS(2716),
    [anon_sym_await] = ACTIONS(2714),
    [anon_sym_of] = ACTIONS(2714),
    [anon_sym_while] = ACTIONS(2714),
    [anon_sym_do] = ACTIONS(2714),
    [anon_sym_try] = ACTIONS(2714),
    [anon_sym_with] = ACTIONS(2714),
    [anon_sym_break] = ACTIONS(2714),
    [anon_sym_continue] = ACTIONS(2714),
    [anon_sym_debugger] = ACTIONS(2714),
    [anon_sym_return] = ACTIONS(2714),
    [anon_sym_throw] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2716),
    [anon_sym_yield] = ACTIONS(2714),
    [anon_sym_LBRACK] = ACTIONS(2716),
    [anon_sym_LTtemplate_GT] = ACTIONS(2716),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2714),
    [anon_sym_class] = ACTIONS(2714),
    [anon_sym_async] = ACTIONS(2714),
    [anon_sym_function] = ACTIONS(2714),
    [anon_sym_new] = ACTIONS(2714),
    [anon_sym_PLUS] = ACTIONS(2714),
    [anon_sym_DASH] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_void] = ACTIONS(2714),
    [anon_sym_delete] = ACTIONS(2714),
    [anon_sym_PLUS_PLUS] = ACTIONS(2716),
    [anon_sym_DASH_DASH] = ACTIONS(2716),
    [anon_sym_DQUOTE] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2716),
    [sym_number] = ACTIONS(2716),
    [sym_this] = ACTIONS(2714),
    [sym_super] = ACTIONS(2714),
    [sym_true] = ACTIONS(2714),
    [sym_false] = ACTIONS(2714),
    [sym_null] = ACTIONS(2714),
    [sym_undefined] = ACTIONS(2714),
    [anon_sym_AT] = ACTIONS(2716),
    [anon_sym_static] = ACTIONS(2714),
    [anon_sym_readonly] = ACTIONS(2714),
    [anon_sym_get] = ACTIONS(2714),
    [anon_sym_set] = ACTIONS(2714),
    [anon_sym_declare] = ACTIONS(2714),
    [anon_sym_public] = ACTIONS(2714),
    [anon_sym_private] = ACTIONS(2714),
    [anon_sym_protected] = ACTIONS(2714),
    [anon_sym_override] = ACTIONS(2714),
    [anon_sym_module] = ACTIONS(2714),
    [anon_sym_any] = ACTIONS(2714),
    [anon_sym_number] = ACTIONS(2714),
    [anon_sym_boolean] = ACTIONS(2714),
    [anon_sym_string] = ACTIONS(2714),
    [anon_sym_symbol] = ACTIONS(2714),
    [anon_sym_property] = ACTIONS(2714),
    [anon_sym_signal] = ACTIONS(2714),
    [anon_sym_on] = ACTIONS(2714),
    [anon_sym_required] = ACTIONS(2714),
    [anon_sym_component] = ACTIONS(2714),
    [anon_sym_abstract] = ACTIONS(2714),
    [anon_sym_interface] = ACTIONS(2714),
    [anon_sym_enum] = ACTIONS(2714),
  },
  [854] = {
    [sym_identifier] = ACTIONS(2714),
    [anon_sym_export] = ACTIONS(2714),
    [anon_sym_type] = ACTIONS(2714),
    [anon_sym_namespace] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(2716),
    [anon_sym_typeof] = ACTIONS(2714),
    [anon_sym_import] = ACTIONS(2714),
    [anon_sym_from] = ACTIONS(2714),
    [anon_sym_var] = ACTIONS(2714),
    [anon_sym_let] = ACTIONS(2714),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_BANG] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2714),
    [anon_sym_switch] = ACTIONS(2714),
    [anon_sym_for] = ACTIONS(2714),
    [anon_sym_LPAREN] = ACTIONS(2716),
    [anon_sym_await] = ACTIONS(2714),
    [anon_sym_of] = ACTIONS(2714),
    [anon_sym_while] = ACTIONS(2714),
    [anon_sym_do] = ACTIONS(2714),
    [anon_sym_try] = ACTIONS(2714),
    [anon_sym_with] = ACTIONS(2714),
    [anon_sym_break] = ACTIONS(2714),
    [anon_sym_continue] = ACTIONS(2714),
    [anon_sym_debugger] = ACTIONS(2714),
    [anon_sym_return] = ACTIONS(2714),
    [anon_sym_throw] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2716),
    [anon_sym_yield] = ACTIONS(2714),
    [anon_sym_LBRACK] = ACTIONS(2716),
    [anon_sym_LTtemplate_GT] = ACTIONS(2716),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2714),
    [anon_sym_class] = ACTIONS(2714),
    [anon_sym_async] = ACTIONS(2714),
    [anon_sym_function] = ACTIONS(2714),
    [anon_sym_new] = ACTIONS(2714),
    [anon_sym_PLUS] = ACTIONS(2714),
    [anon_sym_DASH] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_void] = ACTIONS(2714),
    [anon_sym_delete] = ACTIONS(2714),
    [anon_sym_PLUS_PLUS] = ACTIONS(2716),
    [anon_sym_DASH_DASH] = ACTIONS(2716),
    [anon_sym_DQUOTE] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2716),
    [sym_number] = ACTIONS(2716),
    [sym_this] = ACTIONS(2714),
    [sym_super] = ACTIONS(2714),
    [sym_true] = ACTIONS(2714),
    [sym_false] = ACTIONS(2714),
    [sym_null] = ACTIONS(2714),
    [sym_undefined] = ACTIONS(2714),
    [anon_sym_AT] = ACTIONS(2716),
    [anon_sym_static] = ACTIONS(2714),
    [anon_sym_readonly] = ACTIONS(2714),
    [anon_sym_get] = ACTIONS(2714),
    [anon_sym_set] = ACTIONS(2714),
    [anon_sym_declare] = ACTIONS(2714),
    [anon_sym_public] = ACTIONS(2714),
    [anon_sym_private] = ACTIONS(2714),
    [anon_sym_protected] = ACTIONS(2714),
    [anon_sym_override] = ACTIONS(2714),
    [anon_sym_module] = ACTIONS(2714),
    [anon_sym_any] = ACTIONS(2714),
    [anon_sym_number] = ACTIONS(2714),
    [anon_sym_boolean] = ACTIONS(2714),
    [anon_sym_string] = ACTIONS(2714),
    [anon_sym_symbol] = ACTIONS(2714),
    [anon_sym_property] = ACTIONS(2714),
    [anon_sym_signal] = ACTIONS(2714),
    [anon_sym_on] = ACTIONS(2714),
    [anon_sym_required] = ACTIONS(2714),
    [anon_sym_component] = ACTIONS(2714),
    [anon_sym_abstract] = ACTIONS(2714),
    [anon_sym_interface] = ACTIONS(2714),
    [anon_sym_enum] = ACTIONS(2714),
  },
  [855] = {
    [sym_identifier] = ACTIONS(2718),
    [anon_sym_export] = ACTIONS(2718),
    [anon_sym_type] = ACTIONS(2718),
    [anon_sym_namespace] = ACTIONS(2718),
    [anon_sym_LBRACE] = ACTIONS(2720),
    [anon_sym_typeof] = ACTIONS(2718),
    [anon_sym_import] = ACTIONS(2718),
    [anon_sym_from] = ACTIONS(2718),
    [anon_sym_var] = ACTIONS(2718),
    [anon_sym_let] = ACTIONS(2718),
    [anon_sym_const] = ACTIONS(2718),
    [anon_sym_BANG] = ACTIONS(2720),
    [anon_sym_if] = ACTIONS(2718),
    [anon_sym_switch] = ACTIONS(2718),
    [anon_sym_for] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(2720),
    [anon_sym_await] = ACTIONS(2718),
    [anon_sym_of] = ACTIONS(2718),
    [anon_sym_while] = ACTIONS(2718),
    [anon_sym_do] = ACTIONS(2718),
    [anon_sym_try] = ACTIONS(2718),
    [anon_sym_with] = ACTIONS(2718),
    [anon_sym_break] = ACTIONS(2718),
    [anon_sym_continue] = ACTIONS(2718),
    [anon_sym_debugger] = ACTIONS(2718),
    [anon_sym_return] = ACTIONS(2718),
    [anon_sym_throw] = ACTIONS(2718),
    [anon_sym_SEMI] = ACTIONS(2720),
    [anon_sym_yield] = ACTIONS(2718),
    [anon_sym_LBRACK] = ACTIONS(2720),
    [anon_sym_LTtemplate_GT] = ACTIONS(2720),
    [anon_sym_LT] = ACTIONS(2718),
    [anon_sym_SLASH] = ACTIONS(2718),
    [anon_sym_class] = ACTIONS(2718),
    [anon_sym_async] = ACTIONS(2718),
    [anon_sym_function] = ACTIONS(2718),
    [anon_sym_new] = ACTIONS(2718),
    [anon_sym_PLUS] = ACTIONS(2718),
    [anon_sym_DASH] = ACTIONS(2718),
    [anon_sym_TILDE] = ACTIONS(2720),
    [anon_sym_void] = ACTIONS(2718),
    [anon_sym_delete] = ACTIONS(2718),
    [anon_sym_PLUS_PLUS] = ACTIONS(2720),
    [anon_sym_DASH_DASH] = ACTIONS(2720),
    [anon_sym_DQUOTE] = ACTIONS(2720),
    [anon_sym_SQUOTE] = ACTIONS(2720),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2720),
    [sym_number] = ACTIONS(2720),
    [sym_this] = ACTIONS(2718),
    [sym_super] = ACTIONS(2718),
    [sym_true] = ACTIONS(2718),
    [sym_false] = ACTIONS(2718),
    [sym_null] = ACTIONS(2718),
    [sym_undefined] = ACTIONS(2718),
    [anon_sym_AT] = ACTIONS(2720),
    [anon_sym_static] = ACTIONS(2718),
    [anon_sym_readonly] = ACTIONS(2718),
    [anon_sym_get] = ACTIONS(2718),
    [anon_sym_set] = ACTIONS(2718),
    [anon_sym_declare] = ACTIONS(2718),
    [anon_sym_public] = ACTIONS(2718),
    [anon_sym_private] = ACTIONS(2718),
    [anon_sym_protected] = ACTIONS(2718),
    [anon_sym_override] = ACTIONS(2718),
    [anon_sym_module] = ACTIONS(2718),
    [anon_sym_any] = ACTIONS(2718),
    [anon_sym_number] = ACTIONS(2718),
    [anon_sym_boolean] = ACTIONS(2718),
    [anon_sym_string] = ACTIONS(2718),
    [anon_sym_symbol] = ACTIONS(2718),
    [anon_sym_property] = ACTIONS(2718),
    [anon_sym_signal] = ACTIONS(2718),
    [anon_sym_on] = ACTIONS(2718),
    [anon_sym_required] = ACTIONS(2718),
    [anon_sym_component] = ACTIONS(2718),
    [anon_sym_abstract] = ACTIONS(2718),
    [anon_sym_interface] = ACTIONS(2718),
    [anon_sym_enum] = ACTIONS(2718),
  },
  [856] = {
    [sym_identifier] = ACTIONS(2714),
    [anon_sym_export] = ACTIONS(2714),
    [anon_sym_type] = ACTIONS(2714),
    [anon_sym_namespace] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(2716),
    [anon_sym_typeof] = ACTIONS(2714),
    [anon_sym_import] = ACTIONS(2714),
    [anon_sym_from] = ACTIONS(2714),
    [anon_sym_var] = ACTIONS(2714),
    [anon_sym_let] = ACTIONS(2714),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_BANG] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2714),
    [anon_sym_switch] = ACTIONS(2714),
    [anon_sym_for] = ACTIONS(2714),
    [anon_sym_LPAREN] = ACTIONS(2716),
    [anon_sym_await] = ACTIONS(2714),
    [anon_sym_of] = ACTIONS(2714),
    [anon_sym_while] = ACTIONS(2714),
    [anon_sym_do] = ACTIONS(2714),
    [anon_sym_try] = ACTIONS(2714),
    [anon_sym_with] = ACTIONS(2714),
    [anon_sym_break] = ACTIONS(2714),
    [anon_sym_continue] = ACTIONS(2714),
    [anon_sym_debugger] = ACTIONS(2714),
    [anon_sym_return] = ACTIONS(2714),
    [anon_sym_throw] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2716),
    [anon_sym_yield] = ACTIONS(2714),
    [anon_sym_LBRACK] = ACTIONS(2716),
    [anon_sym_LTtemplate_GT] = ACTIONS(2716),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2714),
    [anon_sym_class] = ACTIONS(2714),
    [anon_sym_async] = ACTIONS(2714),
    [anon_sym_function] = ACTIONS(2714),
    [anon_sym_new] = ACTIONS(2714),
    [anon_sym_PLUS] = ACTIONS(2714),
    [anon_sym_DASH] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_void] = ACTIONS(2714),
    [anon_sym_delete] = ACTIONS(2714),
    [anon_sym_PLUS_PLUS] = ACTIONS(2716),
    [anon_sym_DASH_DASH] = ACTIONS(2716),
    [anon_sym_DQUOTE] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2716),
    [sym_number] = ACTIONS(2716),
    [sym_this] = ACTIONS(2714),
    [sym_super] = ACTIONS(2714),
    [sym_true] = ACTIONS(2714),
    [sym_false] = ACTIONS(2714),
    [sym_null] = ACTIONS(2714),
    [sym_undefined] = ACTIONS(2714),
    [anon_sym_AT] = ACTIONS(2716),
    [anon_sym_static] = ACTIONS(2714),
    [anon_sym_readonly] = ACTIONS(2714),
    [anon_sym_get] = ACTIONS(2714),
    [anon_sym_set] = ACTIONS(2714),
    [anon_sym_declare] = ACTIONS(2714),
    [anon_sym_public] = ACTIONS(2714),
    [anon_sym_private] = ACTIONS(2714),
    [anon_sym_protected] = ACTIONS(2714),
    [anon_sym_override] = ACTIONS(2714),
    [anon_sym_module] = ACTIONS(2714),
    [anon_sym_any] = ACTIONS(2714),
    [anon_sym_number] = ACTIONS(2714),
    [anon_sym_boolean] = ACTIONS(2714),
    [anon_sym_string] = ACTIONS(2714),
    [anon_sym_symbol] = ACTIONS(2714),
    [anon_sym_property] = ACTIONS(2714),
    [anon_sym_signal] = ACTIONS(2714),
    [anon_sym_on] = ACTIONS(2714),
    [anon_sym_required] = ACTIONS(2714),
    [anon_sym_component] = ACTIONS(2714),
    [anon_sym_abstract] = ACTIONS(2714),
    [anon_sym_interface] = ACTIONS(2714),
    [anon_sym_enum] = ACTIONS(2714),
  },
  [857] = {
    [sym_identifier] = ACTIONS(2722),
    [anon_sym_export] = ACTIONS(2722),
    [anon_sym_type] = ACTIONS(2722),
    [anon_sym_namespace] = ACTIONS(2722),
    [anon_sym_LBRACE] = ACTIONS(2724),
    [anon_sym_typeof] = ACTIONS(2722),
    [anon_sym_import] = ACTIONS(2722),
    [anon_sym_from] = ACTIONS(2722),
    [anon_sym_var] = ACTIONS(2722),
    [anon_sym_let] = ACTIONS(2722),
    [anon_sym_const] = ACTIONS(2722),
    [anon_sym_BANG] = ACTIONS(2724),
    [anon_sym_if] = ACTIONS(2722),
    [anon_sym_switch] = ACTIONS(2722),
    [anon_sym_for] = ACTIONS(2722),
    [anon_sym_LPAREN] = ACTIONS(2724),
    [anon_sym_await] = ACTIONS(2722),
    [anon_sym_of] = ACTIONS(2722),
    [anon_sym_while] = ACTIONS(2722),
    [anon_sym_do] = ACTIONS(2722),
    [anon_sym_try] = ACTIONS(2722),
    [anon_sym_with] = ACTIONS(2722),
    [anon_sym_break] = ACTIONS(2722),
    [anon_sym_continue] = ACTIONS(2722),
    [anon_sym_debugger] = ACTIONS(2722),
    [anon_sym_return] = ACTIONS(2722),
    [anon_sym_throw] = ACTIONS(2722),
    [anon_sym_SEMI] = ACTIONS(2724),
    [anon_sym_yield] = ACTIONS(2722),
    [anon_sym_LBRACK] = ACTIONS(2724),
    [anon_sym_LTtemplate_GT] = ACTIONS(2724),
    [anon_sym_LT] = ACTIONS(2722),
    [anon_sym_SLASH] = ACTIONS(2722),
    [anon_sym_class] = ACTIONS(2722),
    [anon_sym_async] = ACTIONS(2722),
    [anon_sym_function] = ACTIONS(2722),
    [anon_sym_new] = ACTIONS(2722),
    [anon_sym_PLUS] = ACTIONS(2722),
    [anon_sym_DASH] = ACTIONS(2722),
    [anon_sym_TILDE] = ACTIONS(2724),
    [anon_sym_void] = ACTIONS(2722),
    [anon_sym_delete] = ACTIONS(2722),
    [anon_sym_PLUS_PLUS] = ACTIONS(2724),
    [anon_sym_DASH_DASH] = ACTIONS(2724),
    [anon_sym_DQUOTE] = ACTIONS(2724),
    [anon_sym_SQUOTE] = ACTIONS(2724),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2724),
    [sym_number] = ACTIONS(2724),
    [sym_this] = ACTIONS(2722),
    [sym_super] = ACTIONS(2722),
    [sym_true] = ACTIONS(2722),
    [sym_false] = ACTIONS(2722),
    [sym_null] = ACTIONS(2722),
    [sym_undefined] = ACTIONS(2722),
    [anon_sym_AT] = ACTIONS(2724),
    [anon_sym_static] = ACTIONS(2722),
    [anon_sym_readonly] = ACTIONS(2722),
    [anon_sym_get] = ACTIONS(2722),
    [anon_sym_set] = ACTIONS(2722),
    [anon_sym_declare] = ACTIONS(2722),
    [anon_sym_public] = ACTIONS(2722),
    [anon_sym_private] = ACTIONS(2722),
    [anon_sym_protected] = ACTIONS(2722),
    [anon_sym_override] = ACTIONS(2722),
    [anon_sym_module] = ACTIONS(2722),
    [anon_sym_any] = ACTIONS(2722),
    [anon_sym_number] = ACTIONS(2722),
    [anon_sym_boolean] = ACTIONS(2722),
    [anon_sym_string] = ACTIONS(2722),
    [anon_sym_symbol] = ACTIONS(2722),
    [anon_sym_property] = ACTIONS(2722),
    [anon_sym_signal] = ACTIONS(2722),
    [anon_sym_on] = ACTIONS(2722),
    [anon_sym_required] = ACTIONS(2722),
    [anon_sym_component] = ACTIONS(2722),
    [anon_sym_abstract] = ACTIONS(2722),
    [anon_sym_interface] = ACTIONS(2722),
    [anon_sym_enum] = ACTIONS(2722),
  },
  [858] = {
    [sym_identifier] = ACTIONS(2714),
    [anon_sym_export] = ACTIONS(2714),
    [anon_sym_type] = ACTIONS(2714),
    [anon_sym_namespace] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(2716),
    [anon_sym_typeof] = ACTIONS(2714),
    [anon_sym_import] = ACTIONS(2714),
    [anon_sym_from] = ACTIONS(2714),
    [anon_sym_var] = ACTIONS(2714),
    [anon_sym_let] = ACTIONS(2714),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_BANG] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2714),
    [anon_sym_switch] = ACTIONS(2714),
    [anon_sym_for] = ACTIONS(2714),
    [anon_sym_LPAREN] = ACTIONS(2716),
    [anon_sym_await] = ACTIONS(2714),
    [anon_sym_of] = ACTIONS(2714),
    [anon_sym_while] = ACTIONS(2714),
    [anon_sym_do] = ACTIONS(2714),
    [anon_sym_try] = ACTIONS(2714),
    [anon_sym_with] = ACTIONS(2714),
    [anon_sym_break] = ACTIONS(2714),
    [anon_sym_continue] = ACTIONS(2714),
    [anon_sym_debugger] = ACTIONS(2714),
    [anon_sym_return] = ACTIONS(2714),
    [anon_sym_throw] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2716),
    [anon_sym_yield] = ACTIONS(2714),
    [anon_sym_LBRACK] = ACTIONS(2716),
    [anon_sym_LTtemplate_GT] = ACTIONS(2716),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2714),
    [anon_sym_class] = ACTIONS(2714),
    [anon_sym_async] = ACTIONS(2714),
    [anon_sym_function] = ACTIONS(2714),
    [anon_sym_new] = ACTIONS(2714),
    [anon_sym_PLUS] = ACTIONS(2714),
    [anon_sym_DASH] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_void] = ACTIONS(2714),
    [anon_sym_delete] = ACTIONS(2714),
    [anon_sym_PLUS_PLUS] = ACTIONS(2716),
    [anon_sym_DASH_DASH] = ACTIONS(2716),
    [anon_sym_DQUOTE] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2716),
    [sym_number] = ACTIONS(2716),
    [sym_this] = ACTIONS(2714),
    [sym_super] = ACTIONS(2714),
    [sym_true] = ACTIONS(2714),
    [sym_false] = ACTIONS(2714),
    [sym_null] = ACTIONS(2714),
    [sym_undefined] = ACTIONS(2714),
    [anon_sym_AT] = ACTIONS(2716),
    [anon_sym_static] = ACTIONS(2714),
    [anon_sym_readonly] = ACTIONS(2714),
    [anon_sym_get] = ACTIONS(2714),
    [anon_sym_set] = ACTIONS(2714),
    [anon_sym_declare] = ACTIONS(2714),
    [anon_sym_public] = ACTIONS(2714),
    [anon_sym_private] = ACTIONS(2714),
    [anon_sym_protected] = ACTIONS(2714),
    [anon_sym_override] = ACTIONS(2714),
    [anon_sym_module] = ACTIONS(2714),
    [anon_sym_any] = ACTIONS(2714),
    [anon_sym_number] = ACTIONS(2714),
    [anon_sym_boolean] = ACTIONS(2714),
    [anon_sym_string] = ACTIONS(2714),
    [anon_sym_symbol] = ACTIONS(2714),
    [anon_sym_property] = ACTIONS(2714),
    [anon_sym_signal] = ACTIONS(2714),
    [anon_sym_on] = ACTIONS(2714),
    [anon_sym_required] = ACTIONS(2714),
    [anon_sym_component] = ACTIONS(2714),
    [anon_sym_abstract] = ACTIONS(2714),
    [anon_sym_interface] = ACTIONS(2714),
    [anon_sym_enum] = ACTIONS(2714),
  },
  [859] = {
    [sym_identifier] = ACTIONS(2726),
    [anon_sym_export] = ACTIONS(2726),
    [anon_sym_type] = ACTIONS(2726),
    [anon_sym_namespace] = ACTIONS(2726),
    [anon_sym_LBRACE] = ACTIONS(2728),
    [anon_sym_typeof] = ACTIONS(2726),
    [anon_sym_import] = ACTIONS(2726),
    [anon_sym_from] = ACTIONS(2726),
    [anon_sym_var] = ACTIONS(2726),
    [anon_sym_let] = ACTIONS(2726),
    [anon_sym_const] = ACTIONS(2726),
    [anon_sym_BANG] = ACTIONS(2728),
    [anon_sym_if] = ACTIONS(2726),
    [anon_sym_switch] = ACTIONS(2726),
    [anon_sym_for] = ACTIONS(2726),
    [anon_sym_LPAREN] = ACTIONS(2728),
    [anon_sym_await] = ACTIONS(2726),
    [anon_sym_of] = ACTIONS(2726),
    [anon_sym_while] = ACTIONS(2726),
    [anon_sym_do] = ACTIONS(2726),
    [anon_sym_try] = ACTIONS(2726),
    [anon_sym_with] = ACTIONS(2726),
    [anon_sym_break] = ACTIONS(2726),
    [anon_sym_continue] = ACTIONS(2726),
    [anon_sym_debugger] = ACTIONS(2726),
    [anon_sym_return] = ACTIONS(2726),
    [anon_sym_throw] = ACTIONS(2726),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_yield] = ACTIONS(2726),
    [anon_sym_LBRACK] = ACTIONS(2728),
    [anon_sym_LTtemplate_GT] = ACTIONS(2728),
    [anon_sym_LT] = ACTIONS(2726),
    [anon_sym_SLASH] = ACTIONS(2726),
    [anon_sym_class] = ACTIONS(2726),
    [anon_sym_async] = ACTIONS(2726),
    [anon_sym_function] = ACTIONS(2726),
    [anon_sym_new] = ACTIONS(2726),
    [anon_sym_PLUS] = ACTIONS(2726),
    [anon_sym_DASH] = ACTIONS(2726),
    [anon_sym_TILDE] = ACTIONS(2728),
    [anon_sym_void] = ACTIONS(2726),
    [anon_sym_delete] = ACTIONS(2726),
    [anon_sym_PLUS_PLUS] = ACTIONS(2728),
    [anon_sym_DASH_DASH] = ACTIONS(2728),
    [anon_sym_DQUOTE] = ACTIONS(2728),
    [anon_sym_SQUOTE] = ACTIONS(2728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2728),
    [sym_number] = ACTIONS(2728),
    [sym_this] = ACTIONS(2726),
    [sym_super] = ACTIONS(2726),
    [sym_true] = ACTIONS(2726),
    [sym_false] = ACTIONS(2726),
    [sym_null] = ACTIONS(2726),
    [sym_undefined] = ACTIONS(2726),
    [anon_sym_AT] = ACTIONS(2728),
    [anon_sym_static] = ACTIONS(2726),
    [anon_sym_readonly] = ACTIONS(2726),
    [anon_sym_get] = ACTIONS(2726),
    [anon_sym_set] = ACTIONS(2726),
    [anon_sym_declare] = ACTIONS(2726),
    [anon_sym_public] = ACTIONS(2726),
    [anon_sym_private] = ACTIONS(2726),
    [anon_sym_protected] = ACTIONS(2726),
    [anon_sym_override] = ACTIONS(2726),
    [anon_sym_module] = ACTIONS(2726),
    [anon_sym_any] = ACTIONS(2726),
    [anon_sym_number] = ACTIONS(2726),
    [anon_sym_boolean] = ACTIONS(2726),
    [anon_sym_string] = ACTIONS(2726),
    [anon_sym_symbol] = ACTIONS(2726),
    [anon_sym_property] = ACTIONS(2726),
    [anon_sym_signal] = ACTIONS(2726),
    [anon_sym_on] = ACTIONS(2726),
    [anon_sym_required] = ACTIONS(2726),
    [anon_sym_component] = ACTIONS(2726),
    [anon_sym_abstract] = ACTIONS(2726),
    [anon_sym_interface] = ACTIONS(2726),
    [anon_sym_enum] = ACTIONS(2726),
  },
  [860] = {
    [sym_identifier] = ACTIONS(2730),
    [anon_sym_export] = ACTIONS(2730),
    [anon_sym_type] = ACTIONS(2730),
    [anon_sym_namespace] = ACTIONS(2730),
    [anon_sym_LBRACE] = ACTIONS(2732),
    [anon_sym_typeof] = ACTIONS(2730),
    [anon_sym_import] = ACTIONS(2730),
    [anon_sym_from] = ACTIONS(2730),
    [anon_sym_var] = ACTIONS(2730),
    [anon_sym_let] = ACTIONS(2730),
    [anon_sym_const] = ACTIONS(2730),
    [anon_sym_BANG] = ACTIONS(2732),
    [anon_sym_if] = ACTIONS(2730),
    [anon_sym_switch] = ACTIONS(2730),
    [anon_sym_for] = ACTIONS(2730),
    [anon_sym_LPAREN] = ACTIONS(2732),
    [anon_sym_await] = ACTIONS(2730),
    [anon_sym_of] = ACTIONS(2730),
    [anon_sym_while] = ACTIONS(2730),
    [anon_sym_do] = ACTIONS(2730),
    [anon_sym_try] = ACTIONS(2730),
    [anon_sym_with] = ACTIONS(2730),
    [anon_sym_break] = ACTIONS(2730),
    [anon_sym_continue] = ACTIONS(2730),
    [anon_sym_debugger] = ACTIONS(2730),
    [anon_sym_return] = ACTIONS(2730),
    [anon_sym_throw] = ACTIONS(2730),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_yield] = ACTIONS(2730),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_LTtemplate_GT] = ACTIONS(2732),
    [anon_sym_LT] = ACTIONS(2730),
    [anon_sym_SLASH] = ACTIONS(2730),
    [anon_sym_class] = ACTIONS(2730),
    [anon_sym_async] = ACTIONS(2730),
    [anon_sym_function] = ACTIONS(2730),
    [anon_sym_new] = ACTIONS(2730),
    [anon_sym_PLUS] = ACTIONS(2730),
    [anon_sym_DASH] = ACTIONS(2730),
    [anon_sym_TILDE] = ACTIONS(2732),
    [anon_sym_void] = ACTIONS(2730),
    [anon_sym_delete] = ACTIONS(2730),
    [anon_sym_PLUS_PLUS] = ACTIONS(2732),
    [anon_sym_DASH_DASH] = ACTIONS(2732),
    [anon_sym_DQUOTE] = ACTIONS(2732),
    [anon_sym_SQUOTE] = ACTIONS(2732),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2732),
    [sym_number] = ACTIONS(2732),
    [sym_this] = ACTIONS(2730),
    [sym_super] = ACTIONS(2730),
    [sym_true] = ACTIONS(2730),
    [sym_false] = ACTIONS(2730),
    [sym_null] = ACTIONS(2730),
    [sym_undefined] = ACTIONS(2730),
    [anon_sym_AT] = ACTIONS(2732),
    [anon_sym_static] = ACTIONS(2730),
    [anon_sym_readonly] = ACTIONS(2730),
    [anon_sym_get] = ACTIONS(2730),
    [anon_sym_set] = ACTIONS(2730),
    [anon_sym_declare] = ACTIONS(2730),
    [anon_sym_public] = ACTIONS(2730),
    [anon_sym_private] = ACTIONS(2730),
    [anon_sym_protected] = ACTIONS(2730),
    [anon_sym_override] = ACTIONS(2730),
    [anon_sym_module] = ACTIONS(2730),
    [anon_sym_any] = ACTIONS(2730),
    [anon_sym_number] = ACTIONS(2730),
    [anon_sym_boolean] = ACTIONS(2730),
    [anon_sym_string] = ACTIONS(2730),
    [anon_sym_symbol] = ACTIONS(2730),
    [anon_sym_property] = ACTIONS(2730),
    [anon_sym_signal] = ACTIONS(2730),
    [anon_sym_on] = ACTIONS(2730),
    [anon_sym_required] = ACTIONS(2730),
    [anon_sym_component] = ACTIONS(2730),
    [anon_sym_abstract] = ACTIONS(2730),
    [anon_sym_interface] = ACTIONS(2730),
    [anon_sym_enum] = ACTIONS(2730),
  },
  [861] = {
    [sym_identifier] = ACTIONS(2714),
    [anon_sym_export] = ACTIONS(2714),
    [anon_sym_type] = ACTIONS(2714),
    [anon_sym_namespace] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(2716),
    [anon_sym_typeof] = ACTIONS(2714),
    [anon_sym_import] = ACTIONS(2714),
    [anon_sym_from] = ACTIONS(2714),
    [anon_sym_var] = ACTIONS(2714),
    [anon_sym_let] = ACTIONS(2714),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_BANG] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2714),
    [anon_sym_switch] = ACTIONS(2714),
    [anon_sym_for] = ACTIONS(2714),
    [anon_sym_LPAREN] = ACTIONS(2716),
    [anon_sym_await] = ACTIONS(2714),
    [anon_sym_of] = ACTIONS(2714),
    [anon_sym_while] = ACTIONS(2714),
    [anon_sym_do] = ACTIONS(2714),
    [anon_sym_try] = ACTIONS(2714),
    [anon_sym_with] = ACTIONS(2714),
    [anon_sym_break] = ACTIONS(2714),
    [anon_sym_continue] = ACTIONS(2714),
    [anon_sym_debugger] = ACTIONS(2714),
    [anon_sym_return] = ACTIONS(2714),
    [anon_sym_throw] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2716),
    [anon_sym_yield] = ACTIONS(2714),
    [anon_sym_LBRACK] = ACTIONS(2716),
    [anon_sym_LTtemplate_GT] = ACTIONS(2716),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2714),
    [anon_sym_class] = ACTIONS(2714),
    [anon_sym_async] = ACTIONS(2714),
    [anon_sym_function] = ACTIONS(2714),
    [anon_sym_new] = ACTIONS(2714),
    [anon_sym_PLUS] = ACTIONS(2714),
    [anon_sym_DASH] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_void] = ACTIONS(2714),
    [anon_sym_delete] = ACTIONS(2714),
    [anon_sym_PLUS_PLUS] = ACTIONS(2716),
    [anon_sym_DASH_DASH] = ACTIONS(2716),
    [anon_sym_DQUOTE] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2716),
    [sym_number] = ACTIONS(2716),
    [sym_this] = ACTIONS(2714),
    [sym_super] = ACTIONS(2714),
    [sym_true] = ACTIONS(2714),
    [sym_false] = ACTIONS(2714),
    [sym_null] = ACTIONS(2714),
    [sym_undefined] = ACTIONS(2714),
    [anon_sym_AT] = ACTIONS(2716),
    [anon_sym_static] = ACTIONS(2714),
    [anon_sym_readonly] = ACTIONS(2714),
    [anon_sym_get] = ACTIONS(2714),
    [anon_sym_set] = ACTIONS(2714),
    [anon_sym_declare] = ACTIONS(2714),
    [anon_sym_public] = ACTIONS(2714),
    [anon_sym_private] = ACTIONS(2714),
    [anon_sym_protected] = ACTIONS(2714),
    [anon_sym_override] = ACTIONS(2714),
    [anon_sym_module] = ACTIONS(2714),
    [anon_sym_any] = ACTIONS(2714),
    [anon_sym_number] = ACTIONS(2714),
    [anon_sym_boolean] = ACTIONS(2714),
    [anon_sym_string] = ACTIONS(2714),
    [anon_sym_symbol] = ACTIONS(2714),
    [anon_sym_property] = ACTIONS(2714),
    [anon_sym_signal] = ACTIONS(2714),
    [anon_sym_on] = ACTIONS(2714),
    [anon_sym_required] = ACTIONS(2714),
    [anon_sym_component] = ACTIONS(2714),
    [anon_sym_abstract] = ACTIONS(2714),
    [anon_sym_interface] = ACTIONS(2714),
    [anon_sym_enum] = ACTIONS(2714),
  },
  [862] = {
    [sym_identifier] = ACTIONS(2714),
    [anon_sym_export] = ACTIONS(2714),
    [anon_sym_type] = ACTIONS(2714),
    [anon_sym_namespace] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(2716),
    [anon_sym_typeof] = ACTIONS(2714),
    [anon_sym_import] = ACTIONS(2714),
    [anon_sym_from] = ACTIONS(2714),
    [anon_sym_var] = ACTIONS(2714),
    [anon_sym_let] = ACTIONS(2714),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_BANG] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2714),
    [anon_sym_switch] = ACTIONS(2714),
    [anon_sym_for] = ACTIONS(2714),
    [anon_sym_LPAREN] = ACTIONS(2716),
    [anon_sym_await] = ACTIONS(2714),
    [anon_sym_of] = ACTIONS(2714),
    [anon_sym_while] = ACTIONS(2714),
    [anon_sym_do] = ACTIONS(2714),
    [anon_sym_try] = ACTIONS(2714),
    [anon_sym_with] = ACTIONS(2714),
    [anon_sym_break] = ACTIONS(2714),
    [anon_sym_continue] = ACTIONS(2714),
    [anon_sym_debugger] = ACTIONS(2714),
    [anon_sym_return] = ACTIONS(2714),
    [anon_sym_throw] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2716),
    [anon_sym_yield] = ACTIONS(2714),
    [anon_sym_LBRACK] = ACTIONS(2716),
    [anon_sym_LTtemplate_GT] = ACTIONS(2716),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2714),
    [anon_sym_class] = ACTIONS(2714),
    [anon_sym_async] = ACTIONS(2714),
    [anon_sym_function] = ACTIONS(2714),
    [anon_sym_new] = ACTIONS(2714),
    [anon_sym_PLUS] = ACTIONS(2714),
    [anon_sym_DASH] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_void] = ACTIONS(2714),
    [anon_sym_delete] = ACTIONS(2714),
    [anon_sym_PLUS_PLUS] = ACTIONS(2716),
    [anon_sym_DASH_DASH] = ACTIONS(2716),
    [anon_sym_DQUOTE] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2716),
    [sym_number] = ACTIONS(2716),
    [sym_this] = ACTIONS(2714),
    [sym_super] = ACTIONS(2714),
    [sym_true] = ACTIONS(2714),
    [sym_false] = ACTIONS(2714),
    [sym_null] = ACTIONS(2714),
    [sym_undefined] = ACTIONS(2714),
    [anon_sym_AT] = ACTIONS(2716),
    [anon_sym_static] = ACTIONS(2714),
    [anon_sym_readonly] = ACTIONS(2714),
    [anon_sym_get] = ACTIONS(2714),
    [anon_sym_set] = ACTIONS(2714),
    [anon_sym_declare] = ACTIONS(2714),
    [anon_sym_public] = ACTIONS(2714),
    [anon_sym_private] = ACTIONS(2714),
    [anon_sym_protected] = ACTIONS(2714),
    [anon_sym_override] = ACTIONS(2714),
    [anon_sym_module] = ACTIONS(2714),
    [anon_sym_any] = ACTIONS(2714),
    [anon_sym_number] = ACTIONS(2714),
    [anon_sym_boolean] = ACTIONS(2714),
    [anon_sym_string] = ACTIONS(2714),
    [anon_sym_symbol] = ACTIONS(2714),
    [anon_sym_property] = ACTIONS(2714),
    [anon_sym_signal] = ACTIONS(2714),
    [anon_sym_on] = ACTIONS(2714),
    [anon_sym_required] = ACTIONS(2714),
    [anon_sym_component] = ACTIONS(2714),
    [anon_sym_abstract] = ACTIONS(2714),
    [anon_sym_interface] = ACTIONS(2714),
    [anon_sym_enum] = ACTIONS(2714),
  },
  [863] = {
    [sym_identifier] = ACTIONS(2714),
    [anon_sym_export] = ACTIONS(2714),
    [anon_sym_type] = ACTIONS(2714),
    [anon_sym_namespace] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(2716),
    [anon_sym_typeof] = ACTIONS(2714),
    [anon_sym_import] = ACTIONS(2714),
    [anon_sym_from] = ACTIONS(2714),
    [anon_sym_var] = ACTIONS(2714),
    [anon_sym_let] = ACTIONS(2714),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_BANG] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2714),
    [anon_sym_switch] = ACTIONS(2714),
    [anon_sym_for] = ACTIONS(2714),
    [anon_sym_LPAREN] = ACTIONS(2716),
    [anon_sym_await] = ACTIONS(2714),
    [anon_sym_of] = ACTIONS(2714),
    [anon_sym_while] = ACTIONS(2714),
    [anon_sym_do] = ACTIONS(2714),
    [anon_sym_try] = ACTIONS(2714),
    [anon_sym_with] = ACTIONS(2714),
    [anon_sym_break] = ACTIONS(2714),
    [anon_sym_continue] = ACTIONS(2714),
    [anon_sym_debugger] = ACTIONS(2714),
    [anon_sym_return] = ACTIONS(2714),
    [anon_sym_throw] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2716),
    [anon_sym_yield] = ACTIONS(2714),
    [anon_sym_LBRACK] = ACTIONS(2716),
    [anon_sym_LTtemplate_GT] = ACTIONS(2716),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2714),
    [anon_sym_class] = ACTIONS(2714),
    [anon_sym_async] = ACTIONS(2714),
    [anon_sym_function] = ACTIONS(2714),
    [anon_sym_new] = ACTIONS(2714),
    [anon_sym_PLUS] = ACTIONS(2714),
    [anon_sym_DASH] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_void] = ACTIONS(2714),
    [anon_sym_delete] = ACTIONS(2714),
    [anon_sym_PLUS_PLUS] = ACTIONS(2716),
    [anon_sym_DASH_DASH] = ACTIONS(2716),
    [anon_sym_DQUOTE] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2716),
    [sym_number] = ACTIONS(2716),
    [sym_this] = ACTIONS(2714),
    [sym_super] = ACTIONS(2714),
    [sym_true] = ACTIONS(2714),
    [sym_false] = ACTIONS(2714),
    [sym_null] = ACTIONS(2714),
    [sym_undefined] = ACTIONS(2714),
    [anon_sym_AT] = ACTIONS(2716),
    [anon_sym_static] = ACTIONS(2714),
    [anon_sym_readonly] = ACTIONS(2714),
    [anon_sym_get] = ACTIONS(2714),
    [anon_sym_set] = ACTIONS(2714),
    [anon_sym_declare] = ACTIONS(2714),
    [anon_sym_public] = ACTIONS(2714),
    [anon_sym_private] = ACTIONS(2714),
    [anon_sym_protected] = ACTIONS(2714),
    [anon_sym_override] = ACTIONS(2714),
    [anon_sym_module] = ACTIONS(2714),
    [anon_sym_any] = ACTIONS(2714),
    [anon_sym_number] = ACTIONS(2714),
    [anon_sym_boolean] = ACTIONS(2714),
    [anon_sym_string] = ACTIONS(2714),
    [anon_sym_symbol] = ACTIONS(2714),
    [anon_sym_property] = ACTIONS(2714),
    [anon_sym_signal] = ACTIONS(2714),
    [anon_sym_on] = ACTIONS(2714),
    [anon_sym_required] = ACTIONS(2714),
    [anon_sym_component] = ACTIONS(2714),
    [anon_sym_abstract] = ACTIONS(2714),
    [anon_sym_interface] = ACTIONS(2714),
    [anon_sym_enum] = ACTIONS(2714),
  },
  [864] = {
    [sym_identifier] = ACTIONS(2714),
    [anon_sym_export] = ACTIONS(2714),
    [anon_sym_type] = ACTIONS(2714),
    [anon_sym_namespace] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(2716),
    [anon_sym_typeof] = ACTIONS(2714),
    [anon_sym_import] = ACTIONS(2714),
    [anon_sym_from] = ACTIONS(2714),
    [anon_sym_var] = ACTIONS(2714),
    [anon_sym_let] = ACTIONS(2714),
    [anon_sym_const] = ACTIONS(2714),
    [anon_sym_BANG] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2714),
    [anon_sym_switch] = ACTIONS(2714),
    [anon_sym_for] = ACTIONS(2714),
    [anon_sym_LPAREN] = ACTIONS(2716),
    [anon_sym_await] = ACTIONS(2714),
    [anon_sym_of] = ACTIONS(2714),
    [anon_sym_while] = ACTIONS(2714),
    [anon_sym_do] = ACTIONS(2714),
    [anon_sym_try] = ACTIONS(2714),
    [anon_sym_with] = ACTIONS(2714),
    [anon_sym_break] = ACTIONS(2714),
    [anon_sym_continue] = ACTIONS(2714),
    [anon_sym_debugger] = ACTIONS(2714),
    [anon_sym_return] = ACTIONS(2714),
    [anon_sym_throw] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2716),
    [anon_sym_yield] = ACTIONS(2714),
    [anon_sym_LBRACK] = ACTIONS(2716),
    [anon_sym_LTtemplate_GT] = ACTIONS(2716),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2714),
    [anon_sym_class] = ACTIONS(2714),
    [anon_sym_async] = ACTIONS(2714),
    [anon_sym_function] = ACTIONS(2714),
    [anon_sym_new] = ACTIONS(2714),
    [anon_sym_PLUS] = ACTIONS(2714),
    [anon_sym_DASH] = ACTIONS(2714),
    [anon_sym_TILDE] = ACTIONS(2716),
    [anon_sym_void] = ACTIONS(2714),
    [anon_sym_delete] = ACTIONS(2714),
    [anon_sym_PLUS_PLUS] = ACTIONS(2716),
    [anon_sym_DASH_DASH] = ACTIONS(2716),
    [anon_sym_DQUOTE] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2716),
    [sym_number] = ACTIONS(2716),
    [sym_this] = ACTIONS(2714),
    [sym_super] = ACTIONS(2714),
    [sym_true] = ACTIONS(2714),
    [sym_false] = ACTIONS(2714),
    [sym_null] = ACTIONS(2714),
    [sym_undefined] = ACTIONS(2714),
    [anon_sym_AT] = ACTIONS(2716),
    [anon_sym_static] = ACTIONS(2714),
    [anon_sym_readonly] = ACTIONS(2714),
    [anon_sym_get] = ACTIONS(2714),
    [anon_sym_set] = ACTIONS(2714),
    [anon_sym_declare] = ACTIONS(2714),
    [anon_sym_public] = ACTIONS(2714),
    [anon_sym_private] = ACTIONS(2714),
    [anon_sym_protected] = ACTIONS(2714),
    [anon_sym_override] = ACTIONS(2714),
    [anon_sym_module] = ACTIONS(2714),
    [anon_sym_any] = ACTIONS(2714),
    [anon_sym_number] = ACTIONS(2714),
    [anon_sym_boolean] = ACTIONS(2714),
    [anon_sym_string] = ACTIONS(2714),
    [anon_sym_symbol] = ACTIONS(2714),
    [anon_sym_property] = ACTIONS(2714),
    [anon_sym_signal] = ACTIONS(2714),
    [anon_sym_on] = ACTIONS(2714),
    [anon_sym_required] = ACTIONS(2714),
    [anon_sym_component] = ACTIONS(2714),
    [anon_sym_abstract] = ACTIONS(2714),
    [anon_sym_interface] = ACTIONS(2714),
    [anon_sym_enum] = ACTIONS(2714),
  },
  [865] = {
    [sym_statement_block] = STATE(896),
    [sym_identifier] = ACTIONS(1487),
    [anon_sym_export] = ACTIONS(1487),
    [anon_sym_STAR] = ACTIONS(1487),
    [anon_sym_default] = ACTIONS(1487),
    [anon_sym_type] = ACTIONS(1487),
    [anon_sym_as] = ACTIONS(1487),
    [anon_sym_namespace] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(1491),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1487),
    [anon_sym_var] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(1491),
    [anon_sym_in] = ACTIONS(1487),
    [anon_sym_of] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1491),
    [anon_sym_LT] = ACTIONS(1487),
    [anon_sym_GT] = ACTIONS(1487),
    [anon_sym_SLASH] = ACTIONS(1487),
    [anon_sym_DOT] = ACTIONS(2736),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_QMARK_DOT] = ACTIONS(1491),
    [anon_sym_AMP_AMP] = ACTIONS(1491),
    [anon_sym_PIPE_PIPE] = ACTIONS(1491),
    [anon_sym_GT_GT] = ACTIONS(1487),
    [anon_sym_GT_GT_GT] = ACTIONS(1491),
    [anon_sym_LT_LT] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1487),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1487),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_PERCENT] = ACTIONS(1491),
    [anon_sym_STAR_STAR] = ACTIONS(1491),
    [anon_sym_LT_EQ] = ACTIONS(1491),
    [anon_sym_EQ_EQ] = ACTIONS(1487),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1491),
    [anon_sym_BANG_EQ] = ACTIONS(1487),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1491),
    [anon_sym_GT_EQ] = ACTIONS(1491),
    [anon_sym_QMARK_QMARK] = ACTIONS(1491),
    [anon_sym_instanceof] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1491),
    [anon_sym_AT] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1487),
    [anon_sym_readonly] = ACTIONS(1487),
    [anon_sym_get] = ACTIONS(1487),
    [anon_sym_set] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1487),
    [anon_sym_public] = ACTIONS(1487),
    [anon_sym_private] = ACTIONS(1487),
    [anon_sym_protected] = ACTIONS(1487),
    [anon_sym_override] = ACTIONS(1487),
    [anon_sym_module] = ACTIONS(1487),
    [anon_sym_any] = ACTIONS(1487),
    [anon_sym_number] = ACTIONS(1487),
    [anon_sym_boolean] = ACTIONS(1487),
    [anon_sym_string] = ACTIONS(1487),
    [anon_sym_symbol] = ACTIONS(1487),
    [anon_sym_property] = ACTIONS(1487),
    [anon_sym_signal] = ACTIONS(1487),
    [anon_sym_on] = ACTIONS(1487),
    [anon_sym_required] = ACTIONS(1487),
    [anon_sym_component] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1487),
    [sym__automatic_semicolon] = ACTIONS(1491),
    [sym__ternary_qmark] = ACTIONS(1491),
  },
  [866] = {
    [sym_statement_block] = STATE(896),
    [sym_identifier] = ACTIONS(1487),
    [anon_sym_export] = ACTIONS(1487),
    [anon_sym_STAR] = ACTIONS(1487),
    [anon_sym_default] = ACTIONS(1487),
    [anon_sym_type] = ACTIONS(1487),
    [anon_sym_as] = ACTIONS(1487),
    [anon_sym_namespace] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(1491),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [anon_sym_from] = ACTIONS(1487),
    [anon_sym_var] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_else] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(1491),
    [anon_sym_in] = ACTIONS(1487),
    [anon_sym_of] = ACTIONS(1487),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1491),
    [anon_sym_LT] = ACTIONS(1487),
    [anon_sym_GT] = ACTIONS(1487),
    [anon_sym_SLASH] = ACTIONS(1487),
    [anon_sym_DOT] = ACTIONS(1491),
    [anon_sym_async] = ACTIONS(1487),
    [anon_sym_function] = ACTIONS(1487),
    [anon_sym_QMARK_DOT] = ACTIONS(1491),
    [anon_sym_AMP_AMP] = ACTIONS(1491),
    [anon_sym_PIPE_PIPE] = ACTIONS(1491),
    [anon_sym_GT_GT] = ACTIONS(1487),
    [anon_sym_GT_GT_GT] = ACTIONS(1491),
    [anon_sym_LT_LT] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1487),
    [anon_sym_CARET] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1487),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_PERCENT] = ACTIONS(1491),
    [anon_sym_STAR_STAR] = ACTIONS(1491),
    [anon_sym_LT_EQ] = ACTIONS(1491),
    [anon_sym_EQ_EQ] = ACTIONS(1487),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1491),
    [anon_sym_BANG_EQ] = ACTIONS(1487),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1491),
    [anon_sym_GT_EQ] = ACTIONS(1491),
    [anon_sym_QMARK_QMARK] = ACTIONS(1491),
    [anon_sym_instanceof] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1491),
    [anon_sym_DASH_DASH] = ACTIONS(1491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1491),
    [anon_sym_AT] = ACTIONS(1491),
    [anon_sym_static] = ACTIONS(1487),
    [anon_sym_readonly] = ACTIONS(1487),
    [anon_sym_get] = ACTIONS(1487),
    [anon_sym_set] = ACTIONS(1487),
    [anon_sym_declare] = ACTIONS(1487),
    [anon_sym_public] = ACTIONS(1487),
    [anon_sym_private] = ACTIONS(1487),
    [anon_sym_protected] = ACTIONS(1487),
    [anon_sym_override] = ACTIONS(1487),
    [anon_sym_module] = ACTIONS(1487),
    [anon_sym_any] = ACTIONS(1487),
    [anon_sym_number] = ACTIONS(1487),
    [anon_sym_boolean] = ACTIONS(1487),
    [anon_sym_string] = ACTIONS(1487),
    [anon_sym_symbol] = ACTIONS(1487),
    [anon_sym_property] = ACTIONS(1487),
    [anon_sym_signal] = ACTIONS(1487),
    [anon_sym_on] = ACTIONS(1487),
    [anon_sym_required] = ACTIONS(1487),
    [anon_sym_component] = ACTIONS(1487),
    [anon_sym_enum] = ACTIONS(1487),
    [sym__automatic_semicolon] = ACTIONS(1491),
    [sym__ternary_qmark] = ACTIONS(1491),
  },
  [867] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4254),
    [sym_optional_tuple_parameter] = STATE(4254),
    [sym_optional_type] = STATE(4254),
    [sym_rest_type] = STATE(4254),
    [sym__tuple_type_member] = STATE(4254),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2742),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [868] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4174),
    [sym_optional_tuple_parameter] = STATE(4174),
    [sym_optional_type] = STATE(4174),
    [sym_rest_type] = STATE(4174),
    [sym__tuple_type_member] = STATE(4174),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2752),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [869] = {
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_export] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1627),
    [anon_sym_default] = ACTIONS(1627),
    [anon_sym_type] = ACTIONS(1627),
    [anon_sym_as] = ACTIONS(1627),
    [anon_sym_namespace] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(1629),
    [anon_sym_COMMA] = ACTIONS(1629),
    [anon_sym_RBRACE] = ACTIONS(1629),
    [anon_sym_from] = ACTIONS(1627),
    [anon_sym_var] = ACTIONS(1627),
    [anon_sym_BANG] = ACTIONS(1627),
    [anon_sym_else] = ACTIONS(1627),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_in] = ACTIONS(1627),
    [anon_sym_of] = ACTIONS(1627),
    [anon_sym_SEMI] = ACTIONS(1629),
    [anon_sym_LBRACK] = ACTIONS(1629),
    [anon_sym_LT] = ACTIONS(1627),
    [anon_sym_GT] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1627),
    [anon_sym_DOT] = ACTIONS(1629),
    [anon_sym_async] = ACTIONS(1627),
    [anon_sym_function] = ACTIONS(1627),
    [anon_sym_QMARK_DOT] = ACTIONS(1629),
    [anon_sym_AMP_AMP] = ACTIONS(1629),
    [anon_sym_PIPE_PIPE] = ACTIONS(1629),
    [anon_sym_GT_GT] = ACTIONS(1627),
    [anon_sym_GT_GT_GT] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1627),
    [anon_sym_CARET] = ACTIONS(1629),
    [anon_sym_PIPE] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_PERCENT] = ACTIONS(1629),
    [anon_sym_STAR_STAR] = ACTIONS(1629),
    [anon_sym_LT_EQ] = ACTIONS(1629),
    [anon_sym_EQ_EQ] = ACTIONS(1627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1629),
    [anon_sym_BANG_EQ] = ACTIONS(1627),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1629),
    [anon_sym_GT_EQ] = ACTIONS(1629),
    [anon_sym_QMARK_QMARK] = ACTIONS(1629),
    [anon_sym_instanceof] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1629),
    [anon_sym_DASH_DASH] = ACTIONS(1629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1629),
    [anon_sym_AT] = ACTIONS(1629),
    [anon_sym_static] = ACTIONS(1627),
    [anon_sym_readonly] = ACTIONS(1627),
    [anon_sym_get] = ACTIONS(1627),
    [anon_sym_set] = ACTIONS(1627),
    [anon_sym_declare] = ACTIONS(1627),
    [anon_sym_public] = ACTIONS(1627),
    [anon_sym_private] = ACTIONS(1627),
    [anon_sym_protected] = ACTIONS(1627),
    [anon_sym_override] = ACTIONS(1627),
    [anon_sym_module] = ACTIONS(1627),
    [anon_sym_any] = ACTIONS(1627),
    [anon_sym_number] = ACTIONS(1627),
    [anon_sym_boolean] = ACTIONS(1627),
    [anon_sym_string] = ACTIONS(1627),
    [anon_sym_symbol] = ACTIONS(1627),
    [anon_sym_property] = ACTIONS(1627),
    [anon_sym_signal] = ACTIONS(1627),
    [anon_sym_on] = ACTIONS(1627),
    [anon_sym_required] = ACTIONS(1627),
    [anon_sym_component] = ACTIONS(1627),
    [anon_sym_enum] = ACTIONS(1627),
    [sym__automatic_semicolon] = ACTIONS(1629),
    [sym__ternary_qmark] = ACTIONS(1629),
  },
  [870] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4112),
    [sym_optional_tuple_parameter] = STATE(4112),
    [sym_optional_type] = STATE(4112),
    [sym_rest_type] = STATE(4112),
    [sym__tuple_type_member] = STATE(4112),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(2754),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2756),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [871] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4115),
    [sym_optional_tuple_parameter] = STATE(4115),
    [sym_optional_type] = STATE(4115),
    [sym_rest_type] = STATE(4115),
    [sym__tuple_type_member] = STATE(4115),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2760),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [872] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4101),
    [sym_optional_tuple_parameter] = STATE(4101),
    [sym_optional_type] = STATE(4101),
    [sym_rest_type] = STATE(4101),
    [sym__tuple_type_member] = STATE(4101),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2764),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [873] = {
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1475),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_type] = ACTIONS(1473),
    [anon_sym_EQ] = ACTIONS(1477),
    [anon_sym_as] = ACTIONS(1475),
    [anon_sym_namespace] = ACTIONS(1473),
    [anon_sym_COMMA] = ACTIONS(1481),
    [anon_sym_RBRACE] = ACTIONS(1479),
    [anon_sym_from] = ACTIONS(1473),
    [anon_sym_var] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_in] = ACTIONS(1475),
    [anon_sym_of] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1481),
    [anon_sym_LT] = ACTIONS(1475),
    [anon_sym_GT] = ACTIONS(1475),
    [anon_sym_SLASH] = ACTIONS(1475),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_function] = ACTIONS(1473),
    [anon_sym_QMARK_DOT] = ACTIONS(1481),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1481),
    [anon_sym_GT_GT] = ACTIONS(1475),
    [anon_sym_GT_GT_GT] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_PLUS] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(1475),
    [anon_sym_PERCENT] = ACTIONS(1481),
    [anon_sym_STAR_STAR] = ACTIONS(1481),
    [anon_sym_LT_EQ] = ACTIONS(1481),
    [anon_sym_EQ_EQ] = ACTIONS(1475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1481),
    [anon_sym_BANG_EQ] = ACTIONS(1475),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1481),
    [anon_sym_GT_EQ] = ACTIONS(1481),
    [anon_sym_QMARK_QMARK] = ACTIONS(1481),
    [anon_sym_instanceof] = ACTIONS(1475),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1481),
    [anon_sym_AT] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_get] = ACTIONS(1473),
    [anon_sym_set] = ACTIONS(1473),
    [anon_sym_declare] = ACTIONS(1473),
    [anon_sym_public] = ACTIONS(1473),
    [anon_sym_private] = ACTIONS(1473),
    [anon_sym_protected] = ACTIONS(1473),
    [anon_sym_override] = ACTIONS(1473),
    [anon_sym_module] = ACTIONS(1473),
    [anon_sym_any] = ACTIONS(1473),
    [anon_sym_number] = ACTIONS(1473),
    [anon_sym_boolean] = ACTIONS(1473),
    [anon_sym_string] = ACTIONS(1473),
    [anon_sym_symbol] = ACTIONS(1473),
    [anon_sym_property] = ACTIONS(1473),
    [anon_sym_signal] = ACTIONS(1473),
    [anon_sym_on] = ACTIONS(1473),
    [anon_sym_required] = ACTIONS(1473),
    [anon_sym_component] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [sym__automatic_semicolon] = ACTIONS(2766),
    [sym__ternary_qmark] = ACTIONS(1481),
  },
  [874] = {
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_export] = ACTIONS(1623),
    [anon_sym_STAR] = ACTIONS(1623),
    [anon_sym_default] = ACTIONS(1623),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_as] = ACTIONS(1623),
    [anon_sym_namespace] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_COMMA] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_from] = ACTIONS(1623),
    [anon_sym_var] = ACTIONS(1623),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_else] = ACTIONS(1623),
    [anon_sym_LPAREN] = ACTIONS(1625),
    [anon_sym_in] = ACTIONS(1623),
    [anon_sym_of] = ACTIONS(1623),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_LT] = ACTIONS(1623),
    [anon_sym_GT] = ACTIONS(1623),
    [anon_sym_SLASH] = ACTIONS(1623),
    [anon_sym_DOT] = ACTIONS(1625),
    [anon_sym_async] = ACTIONS(1623),
    [anon_sym_function] = ACTIONS(1623),
    [anon_sym_QMARK_DOT] = ACTIONS(1625),
    [anon_sym_AMP_AMP] = ACTIONS(1625),
    [anon_sym_PIPE_PIPE] = ACTIONS(1625),
    [anon_sym_GT_GT] = ACTIONS(1623),
    [anon_sym_GT_GT_GT] = ACTIONS(1625),
    [anon_sym_LT_LT] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1623),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(1623),
    [anon_sym_PLUS] = ACTIONS(1623),
    [anon_sym_DASH] = ACTIONS(1623),
    [anon_sym_PERCENT] = ACTIONS(1625),
    [anon_sym_STAR_STAR] = ACTIONS(1625),
    [anon_sym_LT_EQ] = ACTIONS(1625),
    [anon_sym_EQ_EQ] = ACTIONS(1623),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1625),
    [anon_sym_BANG_EQ] = ACTIONS(1623),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1625),
    [anon_sym_GT_EQ] = ACTIONS(1625),
    [anon_sym_QMARK_QMARK] = ACTIONS(1625),
    [anon_sym_instanceof] = ACTIONS(1623),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1625),
    [anon_sym_AT] = ACTIONS(1625),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_readonly] = ACTIONS(1623),
    [anon_sym_get] = ACTIONS(1623),
    [anon_sym_set] = ACTIONS(1623),
    [anon_sym_declare] = ACTIONS(1623),
    [anon_sym_public] = ACTIONS(1623),
    [anon_sym_private] = ACTIONS(1623),
    [anon_sym_protected] = ACTIONS(1623),
    [anon_sym_override] = ACTIONS(1623),
    [anon_sym_module] = ACTIONS(1623),
    [anon_sym_any] = ACTIONS(1623),
    [anon_sym_number] = ACTIONS(1623),
    [anon_sym_boolean] = ACTIONS(1623),
    [anon_sym_string] = ACTIONS(1623),
    [anon_sym_symbol] = ACTIONS(1623),
    [anon_sym_property] = ACTIONS(1623),
    [anon_sym_signal] = ACTIONS(1623),
    [anon_sym_on] = ACTIONS(1623),
    [anon_sym_required] = ACTIONS(1623),
    [anon_sym_component] = ACTIONS(1623),
    [anon_sym_enum] = ACTIONS(1623),
    [sym__automatic_semicolon] = ACTIONS(1625),
    [sym__ternary_qmark] = ACTIONS(1625),
  },
  [875] = {
    [sym_identifier] = ACTIONS(1631),
    [anon_sym_export] = ACTIONS(1631),
    [anon_sym_STAR] = ACTIONS(1631),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1631),
    [anon_sym_as] = ACTIONS(1631),
    [anon_sym_namespace] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_COMMA] = ACTIONS(1633),
    [anon_sym_RBRACE] = ACTIONS(1633),
    [anon_sym_from] = ACTIONS(1631),
    [anon_sym_var] = ACTIONS(1631),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_else] = ACTIONS(1631),
    [anon_sym_LPAREN] = ACTIONS(1633),
    [anon_sym_in] = ACTIONS(1631),
    [anon_sym_of] = ACTIONS(1631),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1633),
    [anon_sym_LT] = ACTIONS(1631),
    [anon_sym_GT] = ACTIONS(1631),
    [anon_sym_SLASH] = ACTIONS(1631),
    [anon_sym_DOT] = ACTIONS(1633),
    [anon_sym_async] = ACTIONS(1631),
    [anon_sym_function] = ACTIONS(1631),
    [anon_sym_QMARK_DOT] = ACTIONS(1633),
    [anon_sym_AMP_AMP] = ACTIONS(1633),
    [anon_sym_PIPE_PIPE] = ACTIONS(1633),
    [anon_sym_GT_GT] = ACTIONS(1631),
    [anon_sym_GT_GT_GT] = ACTIONS(1633),
    [anon_sym_LT_LT] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1631),
    [anon_sym_CARET] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1631),
    [anon_sym_PLUS] = ACTIONS(1631),
    [anon_sym_DASH] = ACTIONS(1631),
    [anon_sym_PERCENT] = ACTIONS(1633),
    [anon_sym_STAR_STAR] = ACTIONS(1633),
    [anon_sym_LT_EQ] = ACTIONS(1633),
    [anon_sym_EQ_EQ] = ACTIONS(1631),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1633),
    [anon_sym_BANG_EQ] = ACTIONS(1631),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1633),
    [anon_sym_GT_EQ] = ACTIONS(1633),
    [anon_sym_QMARK_QMARK] = ACTIONS(1633),
    [anon_sym_instanceof] = ACTIONS(1631),
    [anon_sym_PLUS_PLUS] = ACTIONS(1633),
    [anon_sym_DASH_DASH] = ACTIONS(1633),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1633),
    [anon_sym_AT] = ACTIONS(1633),
    [anon_sym_static] = ACTIONS(1631),
    [anon_sym_readonly] = ACTIONS(1631),
    [anon_sym_get] = ACTIONS(1631),
    [anon_sym_set] = ACTIONS(1631),
    [anon_sym_declare] = ACTIONS(1631),
    [anon_sym_public] = ACTIONS(1631),
    [anon_sym_private] = ACTIONS(1631),
    [anon_sym_protected] = ACTIONS(1631),
    [anon_sym_override] = ACTIONS(1631),
    [anon_sym_module] = ACTIONS(1631),
    [anon_sym_any] = ACTIONS(1631),
    [anon_sym_number] = ACTIONS(1631),
    [anon_sym_boolean] = ACTIONS(1631),
    [anon_sym_string] = ACTIONS(1631),
    [anon_sym_symbol] = ACTIONS(1631),
    [anon_sym_property] = ACTIONS(1631),
    [anon_sym_signal] = ACTIONS(1631),
    [anon_sym_on] = ACTIONS(1631),
    [anon_sym_required] = ACTIONS(1631),
    [anon_sym_component] = ACTIONS(1631),
    [anon_sym_enum] = ACTIONS(1631),
    [sym__automatic_semicolon] = ACTIONS(1633),
    [sym__ternary_qmark] = ACTIONS(1633),
  },
  [876] = {
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_export] = ACTIONS(1567),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_default] = ACTIONS(1567),
    [anon_sym_type] = ACTIONS(1567),
    [anon_sym_as] = ACTIONS(1569),
    [anon_sym_namespace] = ACTIONS(1567),
    [anon_sym_COMMA] = ACTIONS(1573),
    [anon_sym_RBRACE] = ACTIONS(1571),
    [anon_sym_from] = ACTIONS(1567),
    [anon_sym_var] = ACTIONS(1567),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_else] = ACTIONS(1567),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_in] = ACTIONS(1569),
    [anon_sym_of] = ACTIONS(1567),
    [anon_sym_SEMI] = ACTIONS(1573),
    [anon_sym_LBRACK] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(1569),
    [anon_sym_GT] = ACTIONS(1569),
    [anon_sym_SLASH] = ACTIONS(1569),
    [anon_sym_DOT] = ACTIONS(1573),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_function] = ACTIONS(1567),
    [anon_sym_QMARK_DOT] = ACTIONS(1573),
    [anon_sym_AMP_AMP] = ACTIONS(1573),
    [anon_sym_PIPE_PIPE] = ACTIONS(1573),
    [anon_sym_GT_GT] = ACTIONS(1569),
    [anon_sym_GT_GT_GT] = ACTIONS(1573),
    [anon_sym_LT_LT] = ACTIONS(1573),
    [anon_sym_AMP] = ACTIONS(1569),
    [anon_sym_CARET] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_PLUS] = ACTIONS(1569),
    [anon_sym_DASH] = ACTIONS(1569),
    [anon_sym_PERCENT] = ACTIONS(1573),
    [anon_sym_STAR_STAR] = ACTIONS(1573),
    [anon_sym_LT_EQ] = ACTIONS(1573),
    [anon_sym_EQ_EQ] = ACTIONS(1569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1573),
    [anon_sym_BANG_EQ] = ACTIONS(1569),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1573),
    [anon_sym_GT_EQ] = ACTIONS(1573),
    [anon_sym_QMARK_QMARK] = ACTIONS(1573),
    [anon_sym_instanceof] = ACTIONS(1569),
    [anon_sym_PLUS_PLUS] = ACTIONS(1573),
    [anon_sym_DASH_DASH] = ACTIONS(1573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1573),
    [anon_sym_AT] = ACTIONS(1571),
    [anon_sym_static] = ACTIONS(1567),
    [anon_sym_readonly] = ACTIONS(1567),
    [anon_sym_get] = ACTIONS(1567),
    [anon_sym_set] = ACTIONS(1567),
    [anon_sym_declare] = ACTIONS(1567),
    [anon_sym_public] = ACTIONS(1567),
    [anon_sym_private] = ACTIONS(1567),
    [anon_sym_protected] = ACTIONS(1567),
    [anon_sym_override] = ACTIONS(1567),
    [anon_sym_module] = ACTIONS(1567),
    [anon_sym_any] = ACTIONS(1567),
    [anon_sym_number] = ACTIONS(1567),
    [anon_sym_boolean] = ACTIONS(1567),
    [anon_sym_string] = ACTIONS(1567),
    [anon_sym_symbol] = ACTIONS(1567),
    [anon_sym_property] = ACTIONS(1567),
    [anon_sym_signal] = ACTIONS(1567),
    [anon_sym_on] = ACTIONS(1567),
    [anon_sym_required] = ACTIONS(1567),
    [anon_sym_component] = ACTIONS(1567),
    [anon_sym_enum] = ACTIONS(1567),
    [sym__automatic_semicolon] = ACTIONS(1573),
    [sym__ternary_qmark] = ACTIONS(1573),
  },
  [877] = {
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_export] = ACTIONS(1547),
    [anon_sym_STAR] = ACTIONS(1549),
    [anon_sym_default] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_as] = ACTIONS(1549),
    [anon_sym_namespace] = ACTIONS(1547),
    [anon_sym_COMMA] = ACTIONS(1553),
    [anon_sym_RBRACE] = ACTIONS(1551),
    [anon_sym_from] = ACTIONS(1547),
    [anon_sym_var] = ACTIONS(1547),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_else] = ACTIONS(1547),
    [anon_sym_LPAREN] = ACTIONS(1553),
    [anon_sym_in] = ACTIONS(1549),
    [anon_sym_of] = ACTIONS(1547),
    [anon_sym_SEMI] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(1553),
    [anon_sym_LT] = ACTIONS(1549),
    [anon_sym_GT] = ACTIONS(1549),
    [anon_sym_SLASH] = ACTIONS(1549),
    [anon_sym_DOT] = ACTIONS(1553),
    [anon_sym_async] = ACTIONS(1547),
    [anon_sym_function] = ACTIONS(1547),
    [anon_sym_QMARK_DOT] = ACTIONS(1553),
    [anon_sym_AMP_AMP] = ACTIONS(1553),
    [anon_sym_PIPE_PIPE] = ACTIONS(1553),
    [anon_sym_GT_GT] = ACTIONS(1549),
    [anon_sym_GT_GT_GT] = ACTIONS(1553),
    [anon_sym_LT_LT] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1549),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1549),
    [anon_sym_PLUS] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_PERCENT] = ACTIONS(1553),
    [anon_sym_STAR_STAR] = ACTIONS(1553),
    [anon_sym_LT_EQ] = ACTIONS(1553),
    [anon_sym_EQ_EQ] = ACTIONS(1549),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1553),
    [anon_sym_BANG_EQ] = ACTIONS(1549),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1553),
    [anon_sym_GT_EQ] = ACTIONS(1553),
    [anon_sym_QMARK_QMARK] = ACTIONS(1553),
    [anon_sym_instanceof] = ACTIONS(1549),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1553),
    [anon_sym_AT] = ACTIONS(1551),
    [anon_sym_static] = ACTIONS(1547),
    [anon_sym_readonly] = ACTIONS(1547),
    [anon_sym_get] = ACTIONS(1547),
    [anon_sym_set] = ACTIONS(1547),
    [anon_sym_declare] = ACTIONS(1547),
    [anon_sym_public] = ACTIONS(1547),
    [anon_sym_private] = ACTIONS(1547),
    [anon_sym_protected] = ACTIONS(1547),
    [anon_sym_override] = ACTIONS(1547),
    [anon_sym_module] = ACTIONS(1547),
    [anon_sym_any] = ACTIONS(1547),
    [anon_sym_number] = ACTIONS(1547),
    [anon_sym_boolean] = ACTIONS(1547),
    [anon_sym_string] = ACTIONS(1547),
    [anon_sym_symbol] = ACTIONS(1547),
    [anon_sym_property] = ACTIONS(1547),
    [anon_sym_signal] = ACTIONS(1547),
    [anon_sym_on] = ACTIONS(1547),
    [anon_sym_required] = ACTIONS(1547),
    [anon_sym_component] = ACTIONS(1547),
    [anon_sym_enum] = ACTIONS(1547),
    [sym__automatic_semicolon] = ACTIONS(2768),
    [sym__ternary_qmark] = ACTIONS(1553),
  },
  [878] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_export] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_default] = ACTIONS(1533),
    [anon_sym_type] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1533),
    [anon_sym_COMMA] = ACTIONS(1535),
    [anon_sym_RBRACE] = ACTIONS(1535),
    [anon_sym_from] = ACTIONS(1533),
    [anon_sym_var] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_else] = ACTIONS(1533),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_in] = ACTIONS(1533),
    [anon_sym_of] = ACTIONS(1533),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1535),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(1535),
    [anon_sym_async] = ACTIONS(1533),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_QMARK_DOT] = ACTIONS(1535),
    [anon_sym_AMP_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1535),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_GT_GT_GT] = ACTIONS(1535),
    [anon_sym_LT_LT] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1535),
    [anon_sym_STAR_STAR] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1535),
    [anon_sym_EQ_EQ] = ACTIONS(1533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1533),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1535),
    [anon_sym_GT_EQ] = ACTIONS(1535),
    [anon_sym_QMARK_QMARK] = ACTIONS(1535),
    [anon_sym_instanceof] = ACTIONS(1533),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1535),
    [anon_sym_AT] = ACTIONS(1535),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_readonly] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1533),
    [anon_sym_set] = ACTIONS(1533),
    [anon_sym_declare] = ACTIONS(1533),
    [anon_sym_public] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1533),
    [anon_sym_protected] = ACTIONS(1533),
    [anon_sym_override] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1533),
    [anon_sym_any] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1533),
    [anon_sym_property] = ACTIONS(1533),
    [anon_sym_signal] = ACTIONS(1533),
    [anon_sym_on] = ACTIONS(1533),
    [anon_sym_required] = ACTIONS(1533),
    [anon_sym_component] = ACTIONS(1533),
    [anon_sym_enum] = ACTIONS(1533),
    [sym__automatic_semicolon] = ACTIONS(2770),
    [sym__ternary_qmark] = ACTIONS(1535),
  },
  [879] = {
    [sym_identifier] = ACTIONS(1613),
    [anon_sym_export] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(1615),
    [anon_sym_default] = ACTIONS(1613),
    [anon_sym_type] = ACTIONS(1613),
    [anon_sym_as] = ACTIONS(1615),
    [anon_sym_namespace] = ACTIONS(1613),
    [anon_sym_COMMA] = ACTIONS(1619),
    [anon_sym_RBRACE] = ACTIONS(1617),
    [anon_sym_from] = ACTIONS(1613),
    [anon_sym_var] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1615),
    [anon_sym_else] = ACTIONS(1613),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_in] = ACTIONS(1615),
    [anon_sym_of] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_LBRACK] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1615),
    [anon_sym_SLASH] = ACTIONS(1615),
    [anon_sym_DOT] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1613),
    [anon_sym_function] = ACTIONS(1613),
    [anon_sym_QMARK_DOT] = ACTIONS(1619),
    [anon_sym_AMP_AMP] = ACTIONS(1619),
    [anon_sym_PIPE_PIPE] = ACTIONS(1619),
    [anon_sym_GT_GT] = ACTIONS(1615),
    [anon_sym_GT_GT_GT] = ACTIONS(1619),
    [anon_sym_LT_LT] = ACTIONS(1619),
    [anon_sym_AMP] = ACTIONS(1615),
    [anon_sym_CARET] = ACTIONS(1619),
    [anon_sym_PIPE] = ACTIONS(1615),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_DASH] = ACTIONS(1615),
    [anon_sym_PERCENT] = ACTIONS(1619),
    [anon_sym_STAR_STAR] = ACTIONS(1619),
    [anon_sym_LT_EQ] = ACTIONS(1619),
    [anon_sym_EQ_EQ] = ACTIONS(1615),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1619),
    [anon_sym_BANG_EQ] = ACTIONS(1615),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1619),
    [anon_sym_GT_EQ] = ACTIONS(1619),
    [anon_sym_QMARK_QMARK] = ACTIONS(1619),
    [anon_sym_instanceof] = ACTIONS(1615),
    [anon_sym_PLUS_PLUS] = ACTIONS(1619),
    [anon_sym_DASH_DASH] = ACTIONS(1619),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1619),
    [anon_sym_AT] = ACTIONS(1617),
    [anon_sym_static] = ACTIONS(1613),
    [anon_sym_readonly] = ACTIONS(1613),
    [anon_sym_get] = ACTIONS(1613),
    [anon_sym_set] = ACTIONS(1613),
    [anon_sym_declare] = ACTIONS(1613),
    [anon_sym_public] = ACTIONS(1613),
    [anon_sym_private] = ACTIONS(1613),
    [anon_sym_protected] = ACTIONS(1613),
    [anon_sym_override] = ACTIONS(1613),
    [anon_sym_module] = ACTIONS(1613),
    [anon_sym_any] = ACTIONS(1613),
    [anon_sym_number] = ACTIONS(1613),
    [anon_sym_boolean] = ACTIONS(1613),
    [anon_sym_string] = ACTIONS(1613),
    [anon_sym_symbol] = ACTIONS(1613),
    [anon_sym_property] = ACTIONS(1613),
    [anon_sym_signal] = ACTIONS(1613),
    [anon_sym_on] = ACTIONS(1613),
    [anon_sym_required] = ACTIONS(1613),
    [anon_sym_component] = ACTIONS(1613),
    [anon_sym_enum] = ACTIONS(1613),
    [sym__automatic_semicolon] = ACTIONS(2772),
    [sym__ternary_qmark] = ACTIONS(1619),
  },
  [880] = {
    [sym_identifier] = ACTIONS(1699),
    [anon_sym_export] = ACTIONS(1699),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_default] = ACTIONS(1699),
    [anon_sym_type] = ACTIONS(1699),
    [anon_sym_as] = ACTIONS(1701),
    [anon_sym_namespace] = ACTIONS(1699),
    [anon_sym_COMMA] = ACTIONS(1705),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_from] = ACTIONS(1699),
    [anon_sym_var] = ACTIONS(1699),
    [anon_sym_BANG] = ACTIONS(1701),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_LPAREN] = ACTIONS(1705),
    [anon_sym_in] = ACTIONS(1701),
    [anon_sym_of] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LBRACK] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [anon_sym_DOT] = ACTIONS(1705),
    [anon_sym_async] = ACTIONS(1699),
    [anon_sym_function] = ACTIONS(1699),
    [anon_sym_QMARK_DOT] = ACTIONS(1705),
    [anon_sym_AMP_AMP] = ACTIONS(1705),
    [anon_sym_PIPE_PIPE] = ACTIONS(1705),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_GT_GT_GT] = ACTIONS(1705),
    [anon_sym_LT_LT] = ACTIONS(1705),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_CARET] = ACTIONS(1705),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_DASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1705),
    [anon_sym_STAR_STAR] = ACTIONS(1705),
    [anon_sym_LT_EQ] = ACTIONS(1705),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1705),
    [anon_sym_BANG_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1705),
    [anon_sym_GT_EQ] = ACTIONS(1705),
    [anon_sym_QMARK_QMARK] = ACTIONS(1705),
    [anon_sym_instanceof] = ACTIONS(1701),
    [anon_sym_PLUS_PLUS] = ACTIONS(1705),
    [anon_sym_DASH_DASH] = ACTIONS(1705),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1705),
    [anon_sym_AT] = ACTIONS(1703),
    [anon_sym_static] = ACTIONS(1699),
    [anon_sym_readonly] = ACTIONS(1699),
    [anon_sym_get] = ACTIONS(1699),
    [anon_sym_set] = ACTIONS(1699),
    [anon_sym_declare] = ACTIONS(1699),
    [anon_sym_public] = ACTIONS(1699),
    [anon_sym_private] = ACTIONS(1699),
    [anon_sym_protected] = ACTIONS(1699),
    [anon_sym_override] = ACTIONS(1699),
    [anon_sym_module] = ACTIONS(1699),
    [anon_sym_any] = ACTIONS(1699),
    [anon_sym_number] = ACTIONS(1699),
    [anon_sym_boolean] = ACTIONS(1699),
    [anon_sym_string] = ACTIONS(1699),
    [anon_sym_symbol] = ACTIONS(1699),
    [anon_sym_property] = ACTIONS(1699),
    [anon_sym_signal] = ACTIONS(1699),
    [anon_sym_on] = ACTIONS(1699),
    [anon_sym_required] = ACTIONS(1699),
    [anon_sym_component] = ACTIONS(1699),
    [anon_sym_enum] = ACTIONS(1699),
    [sym__automatic_semicolon] = ACTIONS(2774),
    [sym__ternary_qmark] = ACTIONS(1705),
  },
  [881] = {
    [sym_identifier] = ACTIONS(1589),
    [anon_sym_export] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(1591),
    [anon_sym_default] = ACTIONS(1589),
    [anon_sym_type] = ACTIONS(1589),
    [anon_sym_as] = ACTIONS(1591),
    [anon_sym_namespace] = ACTIONS(1589),
    [anon_sym_COMMA] = ACTIONS(1595),
    [anon_sym_RBRACE] = ACTIONS(1593),
    [anon_sym_from] = ACTIONS(1589),
    [anon_sym_var] = ACTIONS(1589),
    [anon_sym_BANG] = ACTIONS(1591),
    [anon_sym_else] = ACTIONS(1589),
    [anon_sym_LPAREN] = ACTIONS(1595),
    [anon_sym_in] = ACTIONS(1591),
    [anon_sym_of] = ACTIONS(1589),
    [anon_sym_SEMI] = ACTIONS(1595),
    [anon_sym_LBRACK] = ACTIONS(1595),
    [anon_sym_LT] = ACTIONS(1591),
    [anon_sym_GT] = ACTIONS(1591),
    [anon_sym_SLASH] = ACTIONS(1591),
    [anon_sym_DOT] = ACTIONS(1595),
    [anon_sym_async] = ACTIONS(1589),
    [anon_sym_function] = ACTIONS(1589),
    [anon_sym_QMARK_DOT] = ACTIONS(1595),
    [anon_sym_AMP_AMP] = ACTIONS(1595),
    [anon_sym_PIPE_PIPE] = ACTIONS(1595),
    [anon_sym_GT_GT] = ACTIONS(1591),
    [anon_sym_GT_GT_GT] = ACTIONS(1595),
    [anon_sym_LT_LT] = ACTIONS(1595),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_CARET] = ACTIONS(1595),
    [anon_sym_PIPE] = ACTIONS(1591),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_PERCENT] = ACTIONS(1595),
    [anon_sym_STAR_STAR] = ACTIONS(1595),
    [anon_sym_LT_EQ] = ACTIONS(1595),
    [anon_sym_EQ_EQ] = ACTIONS(1591),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1595),
    [anon_sym_BANG_EQ] = ACTIONS(1591),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1595),
    [anon_sym_GT_EQ] = ACTIONS(1595),
    [anon_sym_QMARK_QMARK] = ACTIONS(1595),
    [anon_sym_instanceof] = ACTIONS(1591),
    [anon_sym_PLUS_PLUS] = ACTIONS(1595),
    [anon_sym_DASH_DASH] = ACTIONS(1595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1595),
    [anon_sym_AT] = ACTIONS(1593),
    [anon_sym_static] = ACTIONS(1589),
    [anon_sym_readonly] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(1589),
    [anon_sym_set] = ACTIONS(1589),
    [anon_sym_declare] = ACTIONS(1589),
    [anon_sym_public] = ACTIONS(1589),
    [anon_sym_private] = ACTIONS(1589),
    [anon_sym_protected] = ACTIONS(1589),
    [anon_sym_override] = ACTIONS(1589),
    [anon_sym_module] = ACTIONS(1589),
    [anon_sym_any] = ACTIONS(1589),
    [anon_sym_number] = ACTIONS(1589),
    [anon_sym_boolean] = ACTIONS(1589),
    [anon_sym_string] = ACTIONS(1589),
    [anon_sym_symbol] = ACTIONS(1589),
    [anon_sym_property] = ACTIONS(1589),
    [anon_sym_signal] = ACTIONS(1589),
    [anon_sym_on] = ACTIONS(1589),
    [anon_sym_required] = ACTIONS(1589),
    [anon_sym_component] = ACTIONS(1589),
    [anon_sym_enum] = ACTIONS(1589),
    [sym__automatic_semicolon] = ACTIONS(2776),
    [sym__ternary_qmark] = ACTIONS(1595),
  },
  [882] = {
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_export] = ACTIONS(1523),
    [anon_sym_STAR] = ACTIONS(1525),
    [anon_sym_default] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_as] = ACTIONS(1525),
    [anon_sym_namespace] = ACTIONS(1523),
    [anon_sym_COMMA] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1527),
    [anon_sym_from] = ACTIONS(1523),
    [anon_sym_var] = ACTIONS(1523),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_else] = ACTIONS(1523),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_in] = ACTIONS(1525),
    [anon_sym_of] = ACTIONS(1523),
    [anon_sym_SEMI] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_LT] = ACTIONS(1525),
    [anon_sym_GT] = ACTIONS(1525),
    [anon_sym_SLASH] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1523),
    [anon_sym_function] = ACTIONS(1523),
    [anon_sym_QMARK_DOT] = ACTIONS(1529),
    [anon_sym_AMP_AMP] = ACTIONS(1529),
    [anon_sym_PIPE_PIPE] = ACTIONS(1529),
    [anon_sym_GT_GT] = ACTIONS(1525),
    [anon_sym_GT_GT_GT] = ACTIONS(1529),
    [anon_sym_LT_LT] = ACTIONS(1529),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_CARET] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1525),
    [anon_sym_PLUS] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_PERCENT] = ACTIONS(1529),
    [anon_sym_STAR_STAR] = ACTIONS(1529),
    [anon_sym_LT_EQ] = ACTIONS(1529),
    [anon_sym_EQ_EQ] = ACTIONS(1525),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1529),
    [anon_sym_BANG_EQ] = ACTIONS(1525),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1529),
    [anon_sym_GT_EQ] = ACTIONS(1529),
    [anon_sym_QMARK_QMARK] = ACTIONS(1529),
    [anon_sym_instanceof] = ACTIONS(1525),
    [anon_sym_PLUS_PLUS] = ACTIONS(1529),
    [anon_sym_DASH_DASH] = ACTIONS(1529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(1527),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_readonly] = ACTIONS(1523),
    [anon_sym_get] = ACTIONS(1523),
    [anon_sym_set] = ACTIONS(1523),
    [anon_sym_declare] = ACTIONS(1523),
    [anon_sym_public] = ACTIONS(1523),
    [anon_sym_private] = ACTIONS(1523),
    [anon_sym_protected] = ACTIONS(1523),
    [anon_sym_override] = ACTIONS(1523),
    [anon_sym_module] = ACTIONS(1523),
    [anon_sym_any] = ACTIONS(1523),
    [anon_sym_number] = ACTIONS(1523),
    [anon_sym_boolean] = ACTIONS(1523),
    [anon_sym_string] = ACTIONS(1523),
    [anon_sym_symbol] = ACTIONS(1523),
    [anon_sym_property] = ACTIONS(1523),
    [anon_sym_signal] = ACTIONS(1523),
    [anon_sym_on] = ACTIONS(1523),
    [anon_sym_required] = ACTIONS(1523),
    [anon_sym_component] = ACTIONS(1523),
    [anon_sym_enum] = ACTIONS(1523),
    [sym__automatic_semicolon] = ACTIONS(2778),
    [sym__ternary_qmark] = ACTIONS(1529),
  },
  [883] = {
    [sym_identifier] = ACTIONS(2780),
    [anon_sym_export] = ACTIONS(2780),
    [anon_sym_type] = ACTIONS(2780),
    [anon_sym_EQ] = ACTIONS(2780),
    [anon_sym_namespace] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2782),
    [anon_sym_RBRACE] = ACTIONS(2782),
    [anon_sym_typeof] = ACTIONS(2780),
    [anon_sym_import] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2780),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_LPAREN] = ACTIONS(2782),
    [anon_sym_RPAREN] = ACTIONS(2782),
    [anon_sym_await] = ACTIONS(2780),
    [anon_sym_of] = ACTIONS(2780),
    [anon_sym_COLON] = ACTIONS(2782),
    [anon_sym_yield] = ACTIONS(2780),
    [anon_sym_LBRACK] = ACTIONS(2782),
    [anon_sym_RBRACK] = ACTIONS(2782),
    [anon_sym_LTtemplate_GT] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2780),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_SLASH] = ACTIONS(2780),
    [anon_sym_class] = ACTIONS(2780),
    [anon_sym_async] = ACTIONS(2780),
    [anon_sym_function] = ACTIONS(2780),
    [anon_sym_EQ_GT] = ACTIONS(2782),
    [anon_sym_new] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_PLUS] = ACTIONS(2780),
    [anon_sym_DASH] = ACTIONS(2780),
    [anon_sym_TILDE] = ACTIONS(2782),
    [anon_sym_void] = ACTIONS(2780),
    [anon_sym_delete] = ACTIONS(2780),
    [anon_sym_PLUS_PLUS] = ACTIONS(2782),
    [anon_sym_DASH_DASH] = ACTIONS(2782),
    [anon_sym_DQUOTE] = ACTIONS(2782),
    [anon_sym_SQUOTE] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2782),
    [sym_number] = ACTIONS(2782),
    [sym_this] = ACTIONS(2780),
    [sym_super] = ACTIONS(2780),
    [sym_true] = ACTIONS(2780),
    [sym_false] = ACTIONS(2780),
    [sym_null] = ACTIONS(2780),
    [sym_undefined] = ACTIONS(2780),
    [anon_sym_AT] = ACTIONS(2782),
    [anon_sym_static] = ACTIONS(2780),
    [anon_sym_readonly] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2780),
    [anon_sym_set] = ACTIONS(2780),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_declare] = ACTIONS(2780),
    [anon_sym_public] = ACTIONS(2780),
    [anon_sym_private] = ACTIONS(2780),
    [anon_sym_protected] = ACTIONS(2780),
    [anon_sym_override] = ACTIONS(2780),
    [anon_sym_module] = ACTIONS(2780),
    [anon_sym_any] = ACTIONS(2780),
    [anon_sym_number] = ACTIONS(2780),
    [anon_sym_boolean] = ACTIONS(2780),
    [anon_sym_string] = ACTIONS(2780),
    [anon_sym_symbol] = ACTIONS(2780),
    [anon_sym_property] = ACTIONS(2780),
    [anon_sym_signal] = ACTIONS(2780),
    [anon_sym_on] = ACTIONS(2780),
    [anon_sym_required] = ACTIONS(2780),
    [anon_sym_component] = ACTIONS(2780),
    [anon_sym_extends] = ACTIONS(2780),
    [anon_sym_implements] = ACTIONS(2780),
  },
  [884] = {
    [sym_export_statement] = STATE(3377),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4052),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4052),
    [sym_pair] = STATE(4052),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3377),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3377),
    [sym_property_signature] = STATE(3377),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3377),
    [sym_index_signature] = STATE(3377),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [aux_sym_object_repeat1] = STATE(4037),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_export] = ACTIONS(2786),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2784),
    [anon_sym_namespace] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2802),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2810),
    [anon_sym_readonly] = ACTIONS(2812),
    [anon_sym_get] = ACTIONS(2814),
    [anon_sym_set] = ACTIONS(2814),
    [anon_sym_declare] = ACTIONS(2784),
    [anon_sym_public] = ACTIONS(2816),
    [anon_sym_private] = ACTIONS(2816),
    [anon_sym_protected] = ACTIONS(2816),
    [anon_sym_override] = ACTIONS(2818),
    [anon_sym_module] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [anon_sym_property] = ACTIONS(2784),
    [anon_sym_signal] = ACTIONS(2784),
    [anon_sym_on] = ACTIONS(2784),
    [anon_sym_required] = ACTIONS(2784),
    [anon_sym_component] = ACTIONS(2784),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2822),
  },
  [885] = {
    [sym_export_statement] = STATE(3377),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4052),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4052),
    [sym_pair] = STATE(4052),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3377),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3377),
    [sym_property_signature] = STATE(3377),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3377),
    [sym_index_signature] = STATE(3377),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [aux_sym_object_repeat1] = STATE(4037),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2824),
    [anon_sym_export] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2824),
    [anon_sym_namespace] = ACTIONS(2824),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2828),
    [anon_sym_from] = ACTIONS(2824),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2824),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2830),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2832),
    [anon_sym_readonly] = ACTIONS(2834),
    [anon_sym_get] = ACTIONS(2836),
    [anon_sym_set] = ACTIONS(2836),
    [anon_sym_declare] = ACTIONS(2824),
    [anon_sym_public] = ACTIONS(2838),
    [anon_sym_private] = ACTIONS(2838),
    [anon_sym_protected] = ACTIONS(2838),
    [anon_sym_override] = ACTIONS(2840),
    [anon_sym_module] = ACTIONS(2824),
    [anon_sym_any] = ACTIONS(2824),
    [anon_sym_number] = ACTIONS(2824),
    [anon_sym_boolean] = ACTIONS(2824),
    [anon_sym_string] = ACTIONS(2824),
    [anon_sym_symbol] = ACTIONS(2824),
    [anon_sym_property] = ACTIONS(2824),
    [anon_sym_signal] = ACTIONS(2824),
    [anon_sym_on] = ACTIONS(2824),
    [anon_sym_required] = ACTIONS(2824),
    [anon_sym_component] = ACTIONS(2824),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2822),
  },
  [886] = {
    [sym_export_statement] = STATE(3447),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4052),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4052),
    [sym_pair] = STATE(4052),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3447),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3447),
    [sym_property_signature] = STATE(3447),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3447),
    [sym_index_signature] = STATE(3447),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [aux_sym_object_repeat1] = STATE(4037),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2842),
    [anon_sym_export] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2842),
    [anon_sym_namespace] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2846),
    [anon_sym_RBRACE] = ACTIONS(2848),
    [anon_sym_from] = ACTIONS(2842),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2852),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2854),
    [anon_sym_readonly] = ACTIONS(2856),
    [anon_sym_get] = ACTIONS(2858),
    [anon_sym_set] = ACTIONS(2858),
    [anon_sym_declare] = ACTIONS(2842),
    [anon_sym_public] = ACTIONS(2860),
    [anon_sym_private] = ACTIONS(2860),
    [anon_sym_protected] = ACTIONS(2860),
    [anon_sym_override] = ACTIONS(2862),
    [anon_sym_module] = ACTIONS(2842),
    [anon_sym_any] = ACTIONS(2842),
    [anon_sym_number] = ACTIONS(2842),
    [anon_sym_boolean] = ACTIONS(2842),
    [anon_sym_string] = ACTIONS(2842),
    [anon_sym_symbol] = ACTIONS(2842),
    [anon_sym_property] = ACTIONS(2842),
    [anon_sym_signal] = ACTIONS(2842),
    [anon_sym_on] = ACTIONS(2842),
    [anon_sym_required] = ACTIONS(2842),
    [anon_sym_component] = ACTIONS(2842),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2864),
  },
  [887] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4487),
    [sym_optional_tuple_parameter] = STATE(4487),
    [sym_optional_type] = STATE(4487),
    [sym_rest_type] = STATE(4487),
    [sym__tuple_type_member] = STATE(4487),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2866),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [888] = {
    [sym_export_statement] = STATE(3377),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4052),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4052),
    [sym_pair] = STATE(4052),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3377),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3377),
    [sym_property_signature] = STATE(3377),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3377),
    [sym_index_signature] = STATE(3377),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [aux_sym_object_repeat1] = STATE(4037),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_export] = ACTIONS(2786),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2784),
    [anon_sym_namespace] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2868),
    [anon_sym_from] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2802),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2810),
    [anon_sym_readonly] = ACTIONS(2812),
    [anon_sym_get] = ACTIONS(2814),
    [anon_sym_set] = ACTIONS(2814),
    [anon_sym_declare] = ACTIONS(2784),
    [anon_sym_public] = ACTIONS(2816),
    [anon_sym_private] = ACTIONS(2816),
    [anon_sym_protected] = ACTIONS(2816),
    [anon_sym_override] = ACTIONS(2818),
    [anon_sym_module] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [anon_sym_property] = ACTIONS(2784),
    [anon_sym_signal] = ACTIONS(2784),
    [anon_sym_on] = ACTIONS(2784),
    [anon_sym_required] = ACTIONS(2784),
    [anon_sym_component] = ACTIONS(2784),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2822),
  },
  [889] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4487),
    [sym_optional_tuple_parameter] = STATE(4487),
    [sym_optional_type] = STATE(4487),
    [sym_rest_type] = STATE(4487),
    [sym__tuple_type_member] = STATE(4487),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2870),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [890] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4487),
    [sym_optional_tuple_parameter] = STATE(4487),
    [sym_optional_type] = STATE(4487),
    [sym_rest_type] = STATE(4487),
    [sym__tuple_type_member] = STATE(4487),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2872),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [891] = {
    [sym_identifier] = ACTIONS(1575),
    [anon_sym_export] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(1577),
    [anon_sym_default] = ACTIONS(1575),
    [anon_sym_type] = ACTIONS(1575),
    [anon_sym_as] = ACTIONS(1577),
    [anon_sym_namespace] = ACTIONS(1575),
    [anon_sym_COMMA] = ACTIONS(1581),
    [anon_sym_RBRACE] = ACTIONS(1579),
    [anon_sym_from] = ACTIONS(1575),
    [anon_sym_var] = ACTIONS(1575),
    [anon_sym_BANG] = ACTIONS(1577),
    [anon_sym_else] = ACTIONS(1575),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_in] = ACTIONS(1577),
    [anon_sym_of] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(1581),
    [anon_sym_LT] = ACTIONS(1577),
    [anon_sym_GT] = ACTIONS(1577),
    [anon_sym_SLASH] = ACTIONS(1577),
    [anon_sym_DOT] = ACTIONS(1581),
    [anon_sym_async] = ACTIONS(1575),
    [anon_sym_function] = ACTIONS(1575),
    [anon_sym_QMARK_DOT] = ACTIONS(1581),
    [anon_sym_AMP_AMP] = ACTIONS(1581),
    [anon_sym_PIPE_PIPE] = ACTIONS(1581),
    [anon_sym_GT_GT] = ACTIONS(1577),
    [anon_sym_GT_GT_GT] = ACTIONS(1581),
    [anon_sym_LT_LT] = ACTIONS(1581),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_CARET] = ACTIONS(1581),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_PLUS] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_PERCENT] = ACTIONS(1581),
    [anon_sym_STAR_STAR] = ACTIONS(1581),
    [anon_sym_LT_EQ] = ACTIONS(1581),
    [anon_sym_EQ_EQ] = ACTIONS(1577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1581),
    [anon_sym_BANG_EQ] = ACTIONS(1577),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1581),
    [anon_sym_GT_EQ] = ACTIONS(1581),
    [anon_sym_QMARK_QMARK] = ACTIONS(1581),
    [anon_sym_instanceof] = ACTIONS(1577),
    [anon_sym_PLUS_PLUS] = ACTIONS(1581),
    [anon_sym_DASH_DASH] = ACTIONS(1581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1581),
    [anon_sym_AT] = ACTIONS(1579),
    [anon_sym_static] = ACTIONS(1575),
    [anon_sym_readonly] = ACTIONS(1575),
    [anon_sym_get] = ACTIONS(1575),
    [anon_sym_set] = ACTIONS(1575),
    [anon_sym_declare] = ACTIONS(1575),
    [anon_sym_public] = ACTIONS(1575),
    [anon_sym_private] = ACTIONS(1575),
    [anon_sym_protected] = ACTIONS(1575),
    [anon_sym_override] = ACTIONS(1575),
    [anon_sym_module] = ACTIONS(1575),
    [anon_sym_any] = ACTIONS(1575),
    [anon_sym_number] = ACTIONS(1575),
    [anon_sym_boolean] = ACTIONS(1575),
    [anon_sym_string] = ACTIONS(1575),
    [anon_sym_symbol] = ACTIONS(1575),
    [anon_sym_property] = ACTIONS(1575),
    [anon_sym_signal] = ACTIONS(1575),
    [anon_sym_on] = ACTIONS(1575),
    [anon_sym_required] = ACTIONS(1575),
    [anon_sym_component] = ACTIONS(1575),
    [anon_sym_enum] = ACTIONS(1575),
    [sym__automatic_semicolon] = ACTIONS(2874),
    [sym__ternary_qmark] = ACTIONS(1581),
  },
  [892] = {
    [sym_export_statement] = STATE(3377),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4034),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4034),
    [sym_pair] = STATE(4034),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3377),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3377),
    [sym_property_signature] = STATE(3377),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3377),
    [sym_index_signature] = STATE(3377),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [aux_sym_object_repeat1] = STATE(4031),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2876),
    [anon_sym_export] = ACTIONS(2878),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2876),
    [anon_sym_namespace] = ACTIONS(2876),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2880),
    [anon_sym_from] = ACTIONS(2876),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2882),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2884),
    [anon_sym_readonly] = ACTIONS(2886),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_declare] = ACTIONS(2876),
    [anon_sym_public] = ACTIONS(2890),
    [anon_sym_private] = ACTIONS(2890),
    [anon_sym_protected] = ACTIONS(2890),
    [anon_sym_override] = ACTIONS(2892),
    [anon_sym_module] = ACTIONS(2876),
    [anon_sym_any] = ACTIONS(2876),
    [anon_sym_number] = ACTIONS(2876),
    [anon_sym_boolean] = ACTIONS(2876),
    [anon_sym_string] = ACTIONS(2876),
    [anon_sym_symbol] = ACTIONS(2876),
    [anon_sym_property] = ACTIONS(2876),
    [anon_sym_signal] = ACTIONS(2876),
    [anon_sym_on] = ACTIONS(2876),
    [anon_sym_required] = ACTIONS(2876),
    [anon_sym_component] = ACTIONS(2876),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2822),
  },
  [893] = {
    [sym_export_statement] = STATE(3377),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4052),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4052),
    [sym_pair] = STATE(4052),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3377),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3377),
    [sym_property_signature] = STATE(3377),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3377),
    [sym_index_signature] = STATE(3377),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [aux_sym_object_repeat1] = STATE(4037),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2894),
    [anon_sym_export] = ACTIONS(2896),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2894),
    [anon_sym_namespace] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2868),
    [anon_sym_from] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2894),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2898),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2902),
    [anon_sym_get] = ACTIONS(2904),
    [anon_sym_set] = ACTIONS(2904),
    [anon_sym_declare] = ACTIONS(2894),
    [anon_sym_public] = ACTIONS(2906),
    [anon_sym_private] = ACTIONS(2906),
    [anon_sym_protected] = ACTIONS(2906),
    [anon_sym_override] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2894),
    [anon_sym_any] = ACTIONS(2894),
    [anon_sym_number] = ACTIONS(2894),
    [anon_sym_boolean] = ACTIONS(2894),
    [anon_sym_string] = ACTIONS(2894),
    [anon_sym_symbol] = ACTIONS(2894),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_signal] = ACTIONS(2894),
    [anon_sym_on] = ACTIONS(2894),
    [anon_sym_required] = ACTIONS(2894),
    [anon_sym_component] = ACTIONS(2894),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2822),
  },
  [894] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4487),
    [sym_optional_tuple_parameter] = STATE(4487),
    [sym_optional_type] = STATE(4487),
    [sym_rest_type] = STATE(4487),
    [sym__tuple_type_member] = STATE(4487),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2910),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [895] = {
    [sym_export_statement] = STATE(3377),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4052),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4052),
    [sym_pair] = STATE(4052),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3377),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3377),
    [sym_property_signature] = STATE(3377),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3377),
    [sym_index_signature] = STATE(3377),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [aux_sym_object_repeat1] = STATE(4037),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2894),
    [anon_sym_export] = ACTIONS(2896),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2894),
    [anon_sym_namespace] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2912),
    [anon_sym_from] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2894),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2898),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2902),
    [anon_sym_get] = ACTIONS(2904),
    [anon_sym_set] = ACTIONS(2904),
    [anon_sym_declare] = ACTIONS(2894),
    [anon_sym_public] = ACTIONS(2906),
    [anon_sym_private] = ACTIONS(2906),
    [anon_sym_protected] = ACTIONS(2906),
    [anon_sym_override] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2894),
    [anon_sym_any] = ACTIONS(2894),
    [anon_sym_number] = ACTIONS(2894),
    [anon_sym_boolean] = ACTIONS(2894),
    [anon_sym_string] = ACTIONS(2894),
    [anon_sym_symbol] = ACTIONS(2894),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_signal] = ACTIONS(2894),
    [anon_sym_on] = ACTIONS(2894),
    [anon_sym_required] = ACTIONS(2894),
    [anon_sym_component] = ACTIONS(2894),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2822),
  },
  [896] = {
    [sym_identifier] = ACTIONS(1719),
    [anon_sym_export] = ACTIONS(1719),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_default] = ACTIONS(1719),
    [anon_sym_type] = ACTIONS(1719),
    [anon_sym_as] = ACTIONS(1719),
    [anon_sym_namespace] = ACTIONS(1719),
    [anon_sym_COMMA] = ACTIONS(1721),
    [anon_sym_RBRACE] = ACTIONS(1721),
    [anon_sym_from] = ACTIONS(1719),
    [anon_sym_var] = ACTIONS(1719),
    [anon_sym_BANG] = ACTIONS(1719),
    [anon_sym_else] = ACTIONS(1719),
    [anon_sym_LPAREN] = ACTIONS(1721),
    [anon_sym_in] = ACTIONS(1719),
    [anon_sym_of] = ACTIONS(1719),
    [anon_sym_SEMI] = ACTIONS(1721),
    [anon_sym_LBRACK] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1719),
    [anon_sym_GT] = ACTIONS(1719),
    [anon_sym_SLASH] = ACTIONS(1719),
    [anon_sym_DOT] = ACTIONS(1721),
    [anon_sym_async] = ACTIONS(1719),
    [anon_sym_function] = ACTIONS(1719),
    [anon_sym_QMARK_DOT] = ACTIONS(1721),
    [anon_sym_AMP_AMP] = ACTIONS(1721),
    [anon_sym_PIPE_PIPE] = ACTIONS(1721),
    [anon_sym_GT_GT] = ACTIONS(1719),
    [anon_sym_GT_GT_GT] = ACTIONS(1721),
    [anon_sym_LT_LT] = ACTIONS(1721),
    [anon_sym_AMP] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1721),
    [anon_sym_PIPE] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(1719),
    [anon_sym_DASH] = ACTIONS(1719),
    [anon_sym_PERCENT] = ACTIONS(1721),
    [anon_sym_STAR_STAR] = ACTIONS(1721),
    [anon_sym_LT_EQ] = ACTIONS(1721),
    [anon_sym_EQ_EQ] = ACTIONS(1719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1721),
    [anon_sym_BANG_EQ] = ACTIONS(1719),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1721),
    [anon_sym_GT_EQ] = ACTIONS(1721),
    [anon_sym_QMARK_QMARK] = ACTIONS(1721),
    [anon_sym_instanceof] = ACTIONS(1719),
    [anon_sym_PLUS_PLUS] = ACTIONS(1721),
    [anon_sym_DASH_DASH] = ACTIONS(1721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1721),
    [anon_sym_AT] = ACTIONS(1721),
    [anon_sym_static] = ACTIONS(1719),
    [anon_sym_readonly] = ACTIONS(1719),
    [anon_sym_get] = ACTIONS(1719),
    [anon_sym_set] = ACTIONS(1719),
    [anon_sym_declare] = ACTIONS(1719),
    [anon_sym_public] = ACTIONS(1719),
    [anon_sym_private] = ACTIONS(1719),
    [anon_sym_protected] = ACTIONS(1719),
    [anon_sym_override] = ACTIONS(1719),
    [anon_sym_module] = ACTIONS(1719),
    [anon_sym_any] = ACTIONS(1719),
    [anon_sym_number] = ACTIONS(1719),
    [anon_sym_boolean] = ACTIONS(1719),
    [anon_sym_string] = ACTIONS(1719),
    [anon_sym_symbol] = ACTIONS(1719),
    [anon_sym_property] = ACTIONS(1719),
    [anon_sym_signal] = ACTIONS(1719),
    [anon_sym_on] = ACTIONS(1719),
    [anon_sym_required] = ACTIONS(1719),
    [anon_sym_component] = ACTIONS(1719),
    [anon_sym_enum] = ACTIONS(1719),
    [sym__automatic_semicolon] = ACTIONS(1721),
    [sym__ternary_qmark] = ACTIONS(1721),
  },
  [897] = {
    [sym_export_statement] = STATE(3377),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4052),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4052),
    [sym_pair] = STATE(4052),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3377),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3377),
    [sym_property_signature] = STATE(3377),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3377),
    [sym_index_signature] = STATE(3377),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [aux_sym_object_repeat1] = STATE(4037),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2784),
    [anon_sym_export] = ACTIONS(2786),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2784),
    [anon_sym_namespace] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2914),
    [anon_sym_from] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2802),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2810),
    [anon_sym_readonly] = ACTIONS(2812),
    [anon_sym_get] = ACTIONS(2814),
    [anon_sym_set] = ACTIONS(2814),
    [anon_sym_declare] = ACTIONS(2784),
    [anon_sym_public] = ACTIONS(2816),
    [anon_sym_private] = ACTIONS(2816),
    [anon_sym_protected] = ACTIONS(2816),
    [anon_sym_override] = ACTIONS(2818),
    [anon_sym_module] = ACTIONS(2784),
    [anon_sym_any] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2784),
    [anon_sym_boolean] = ACTIONS(2784),
    [anon_sym_string] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2784),
    [anon_sym_property] = ACTIONS(2784),
    [anon_sym_signal] = ACTIONS(2784),
    [anon_sym_on] = ACTIONS(2784),
    [anon_sym_required] = ACTIONS(2784),
    [anon_sym_component] = ACTIONS(2784),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2822),
  },
  [898] = {
    [sym_identifier] = ACTIONS(1557),
    [anon_sym_export] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1559),
    [anon_sym_default] = ACTIONS(1557),
    [anon_sym_type] = ACTIONS(1557),
    [anon_sym_as] = ACTIONS(1559),
    [anon_sym_namespace] = ACTIONS(1557),
    [anon_sym_COMMA] = ACTIONS(1563),
    [anon_sym_RBRACE] = ACTIONS(1561),
    [anon_sym_from] = ACTIONS(1557),
    [anon_sym_var] = ACTIONS(1557),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_else] = ACTIONS(1557),
    [anon_sym_LPAREN] = ACTIONS(1563),
    [anon_sym_in] = ACTIONS(1559),
    [anon_sym_of] = ACTIONS(1557),
    [anon_sym_SEMI] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(1563),
    [anon_sym_LT] = ACTIONS(1559),
    [anon_sym_GT] = ACTIONS(1559),
    [anon_sym_SLASH] = ACTIONS(1559),
    [anon_sym_DOT] = ACTIONS(1563),
    [anon_sym_async] = ACTIONS(1557),
    [anon_sym_function] = ACTIONS(1557),
    [anon_sym_QMARK_DOT] = ACTIONS(1563),
    [anon_sym_AMP_AMP] = ACTIONS(1563),
    [anon_sym_PIPE_PIPE] = ACTIONS(1563),
    [anon_sym_GT_GT] = ACTIONS(1559),
    [anon_sym_GT_GT_GT] = ACTIONS(1563),
    [anon_sym_LT_LT] = ACTIONS(1563),
    [anon_sym_AMP] = ACTIONS(1559),
    [anon_sym_CARET] = ACTIONS(1563),
    [anon_sym_PIPE] = ACTIONS(1559),
    [anon_sym_PLUS] = ACTIONS(1559),
    [anon_sym_DASH] = ACTIONS(1559),
    [anon_sym_PERCENT] = ACTIONS(1563),
    [anon_sym_STAR_STAR] = ACTIONS(1563),
    [anon_sym_LT_EQ] = ACTIONS(1563),
    [anon_sym_EQ_EQ] = ACTIONS(1559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1563),
    [anon_sym_BANG_EQ] = ACTIONS(1559),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1563),
    [anon_sym_GT_EQ] = ACTIONS(1563),
    [anon_sym_QMARK_QMARK] = ACTIONS(1563),
    [anon_sym_instanceof] = ACTIONS(1559),
    [anon_sym_PLUS_PLUS] = ACTIONS(1563),
    [anon_sym_DASH_DASH] = ACTIONS(1563),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1563),
    [anon_sym_AT] = ACTIONS(1561),
    [anon_sym_static] = ACTIONS(1557),
    [anon_sym_readonly] = ACTIONS(1557),
    [anon_sym_get] = ACTIONS(1557),
    [anon_sym_set] = ACTIONS(1557),
    [anon_sym_declare] = ACTIONS(1557),
    [anon_sym_public] = ACTIONS(1557),
    [anon_sym_private] = ACTIONS(1557),
    [anon_sym_protected] = ACTIONS(1557),
    [anon_sym_override] = ACTIONS(1557),
    [anon_sym_module] = ACTIONS(1557),
    [anon_sym_any] = ACTIONS(1557),
    [anon_sym_number] = ACTIONS(1557),
    [anon_sym_boolean] = ACTIONS(1557),
    [anon_sym_string] = ACTIONS(1557),
    [anon_sym_symbol] = ACTIONS(1557),
    [anon_sym_property] = ACTIONS(1557),
    [anon_sym_signal] = ACTIONS(1557),
    [anon_sym_on] = ACTIONS(1557),
    [anon_sym_required] = ACTIONS(1557),
    [anon_sym_component] = ACTIONS(1557),
    [anon_sym_enum] = ACTIONS(1557),
    [sym__automatic_semicolon] = ACTIONS(2916),
    [sym__ternary_qmark] = ACTIONS(1563),
  },
  [899] = {
    [sym_identifier] = ACTIONS(2918),
    [anon_sym_export] = ACTIONS(2918),
    [anon_sym_type] = ACTIONS(2918),
    [anon_sym_EQ] = ACTIONS(2918),
    [anon_sym_namespace] = ACTIONS(2918),
    [anon_sym_LBRACE] = ACTIONS(2920),
    [anon_sym_COMMA] = ACTIONS(2920),
    [anon_sym_RBRACE] = ACTIONS(2920),
    [anon_sym_typeof] = ACTIONS(2918),
    [anon_sym_import] = ACTIONS(2918),
    [anon_sym_from] = ACTIONS(2918),
    [anon_sym_BANG] = ACTIONS(2920),
    [anon_sym_LPAREN] = ACTIONS(2920),
    [anon_sym_RPAREN] = ACTIONS(2920),
    [anon_sym_await] = ACTIONS(2918),
    [anon_sym_of] = ACTIONS(2918),
    [anon_sym_COLON] = ACTIONS(2920),
    [anon_sym_yield] = ACTIONS(2918),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_RBRACK] = ACTIONS(2920),
    [anon_sym_LTtemplate_GT] = ACTIONS(2920),
    [anon_sym_LT] = ACTIONS(2918),
    [anon_sym_GT] = ACTIONS(2920),
    [anon_sym_SLASH] = ACTIONS(2918),
    [anon_sym_class] = ACTIONS(2918),
    [anon_sym_async] = ACTIONS(2918),
    [anon_sym_function] = ACTIONS(2918),
    [anon_sym_EQ_GT] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2918),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_PIPE] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2918),
    [anon_sym_DASH] = ACTIONS(2918),
    [anon_sym_TILDE] = ACTIONS(2920),
    [anon_sym_void] = ACTIONS(2918),
    [anon_sym_delete] = ACTIONS(2918),
    [anon_sym_PLUS_PLUS] = ACTIONS(2920),
    [anon_sym_DASH_DASH] = ACTIONS(2920),
    [anon_sym_DQUOTE] = ACTIONS(2920),
    [anon_sym_SQUOTE] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2920),
    [sym_number] = ACTIONS(2920),
    [sym_this] = ACTIONS(2918),
    [sym_super] = ACTIONS(2918),
    [sym_true] = ACTIONS(2918),
    [sym_false] = ACTIONS(2918),
    [sym_null] = ACTIONS(2918),
    [sym_undefined] = ACTIONS(2918),
    [anon_sym_AT] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2918),
    [anon_sym_readonly] = ACTIONS(2918),
    [anon_sym_get] = ACTIONS(2918),
    [anon_sym_set] = ACTIONS(2918),
    [anon_sym_QMARK] = ACTIONS(2920),
    [anon_sym_declare] = ACTIONS(2918),
    [anon_sym_public] = ACTIONS(2918),
    [anon_sym_private] = ACTIONS(2918),
    [anon_sym_protected] = ACTIONS(2918),
    [anon_sym_override] = ACTIONS(2918),
    [anon_sym_module] = ACTIONS(2918),
    [anon_sym_any] = ACTIONS(2918),
    [anon_sym_number] = ACTIONS(2918),
    [anon_sym_boolean] = ACTIONS(2918),
    [anon_sym_string] = ACTIONS(2918),
    [anon_sym_symbol] = ACTIONS(2918),
    [anon_sym_property] = ACTIONS(2918),
    [anon_sym_signal] = ACTIONS(2918),
    [anon_sym_on] = ACTIONS(2918),
    [anon_sym_required] = ACTIONS(2918),
    [anon_sym_component] = ACTIONS(2918),
    [anon_sym_extends] = ACTIONS(2918),
    [anon_sym_implements] = ACTIONS(2918),
  },
  [900] = {
    [sym_identifier] = ACTIONS(1537),
    [anon_sym_export] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(1537),
    [anon_sym_type] = ACTIONS(1537),
    [anon_sym_as] = ACTIONS(1539),
    [anon_sym_namespace] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1543),
    [anon_sym_RBRACE] = ACTIONS(1541),
    [anon_sym_from] = ACTIONS(1537),
    [anon_sym_var] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1539),
    [anon_sym_else] = ACTIONS(1537),
    [anon_sym_LPAREN] = ACTIONS(1543),
    [anon_sym_in] = ACTIONS(1539),
    [anon_sym_of] = ACTIONS(1537),
    [anon_sym_SEMI] = ACTIONS(1543),
    [anon_sym_LBRACK] = ACTIONS(1543),
    [anon_sym_LT] = ACTIONS(1539),
    [anon_sym_GT] = ACTIONS(1539),
    [anon_sym_SLASH] = ACTIONS(1539),
    [anon_sym_DOT] = ACTIONS(1543),
    [anon_sym_async] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1537),
    [anon_sym_QMARK_DOT] = ACTIONS(1543),
    [anon_sym_AMP_AMP] = ACTIONS(1543),
    [anon_sym_PIPE_PIPE] = ACTIONS(1543),
    [anon_sym_GT_GT] = ACTIONS(1539),
    [anon_sym_GT_GT_GT] = ACTIONS(1543),
    [anon_sym_LT_LT] = ACTIONS(1543),
    [anon_sym_AMP] = ACTIONS(1539),
    [anon_sym_CARET] = ACTIONS(1543),
    [anon_sym_PIPE] = ACTIONS(1539),
    [anon_sym_PLUS] = ACTIONS(1539),
    [anon_sym_DASH] = ACTIONS(1539),
    [anon_sym_PERCENT] = ACTIONS(1543),
    [anon_sym_STAR_STAR] = ACTIONS(1543),
    [anon_sym_LT_EQ] = ACTIONS(1543),
    [anon_sym_EQ_EQ] = ACTIONS(1539),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1543),
    [anon_sym_BANG_EQ] = ACTIONS(1539),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1543),
    [anon_sym_GT_EQ] = ACTIONS(1543),
    [anon_sym_QMARK_QMARK] = ACTIONS(1543),
    [anon_sym_instanceof] = ACTIONS(1539),
    [anon_sym_PLUS_PLUS] = ACTIONS(1543),
    [anon_sym_DASH_DASH] = ACTIONS(1543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1543),
    [anon_sym_AT] = ACTIONS(1541),
    [anon_sym_static] = ACTIONS(1537),
    [anon_sym_readonly] = ACTIONS(1537),
    [anon_sym_get] = ACTIONS(1537),
    [anon_sym_set] = ACTIONS(1537),
    [anon_sym_declare] = ACTIONS(1537),
    [anon_sym_public] = ACTIONS(1537),
    [anon_sym_private] = ACTIONS(1537),
    [anon_sym_protected] = ACTIONS(1537),
    [anon_sym_override] = ACTIONS(1537),
    [anon_sym_module] = ACTIONS(1537),
    [anon_sym_any] = ACTIONS(1537),
    [anon_sym_number] = ACTIONS(1537),
    [anon_sym_boolean] = ACTIONS(1537),
    [anon_sym_string] = ACTIONS(1537),
    [anon_sym_symbol] = ACTIONS(1537),
    [anon_sym_property] = ACTIONS(1537),
    [anon_sym_signal] = ACTIONS(1537),
    [anon_sym_on] = ACTIONS(1537),
    [anon_sym_required] = ACTIONS(1537),
    [anon_sym_component] = ACTIONS(1537),
    [anon_sym_enum] = ACTIONS(1537),
    [sym__automatic_semicolon] = ACTIONS(2922),
    [sym__ternary_qmark] = ACTIONS(1543),
  },
  [901] = {
    [sym_export_statement] = STATE(3377),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4034),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4034),
    [sym_pair] = STATE(4034),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3377),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3377),
    [sym_property_signature] = STATE(3377),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3377),
    [sym_index_signature] = STATE(3377),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [aux_sym_object_repeat1] = STATE(4031),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2876),
    [anon_sym_export] = ACTIONS(2878),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2876),
    [anon_sym_namespace] = ACTIONS(2876),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2924),
    [anon_sym_from] = ACTIONS(2876),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2882),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2884),
    [anon_sym_readonly] = ACTIONS(2886),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_declare] = ACTIONS(2876),
    [anon_sym_public] = ACTIONS(2890),
    [anon_sym_private] = ACTIONS(2890),
    [anon_sym_protected] = ACTIONS(2890),
    [anon_sym_override] = ACTIONS(2892),
    [anon_sym_module] = ACTIONS(2876),
    [anon_sym_any] = ACTIONS(2876),
    [anon_sym_number] = ACTIONS(2876),
    [anon_sym_boolean] = ACTIONS(2876),
    [anon_sym_string] = ACTIONS(2876),
    [anon_sym_symbol] = ACTIONS(2876),
    [anon_sym_property] = ACTIONS(2876),
    [anon_sym_signal] = ACTIONS(2876),
    [anon_sym_on] = ACTIONS(2876),
    [anon_sym_required] = ACTIONS(2876),
    [anon_sym_component] = ACTIONS(2876),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2822),
  },
  [902] = {
    [sym_identifier] = ACTIONS(1709),
    [anon_sym_export] = ACTIONS(1709),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_default] = ACTIONS(1709),
    [anon_sym_type] = ACTIONS(1709),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_namespace] = ACTIONS(1709),
    [anon_sym_COMMA] = ACTIONS(1715),
    [anon_sym_RBRACE] = ACTIONS(1713),
    [anon_sym_from] = ACTIONS(1709),
    [anon_sym_var] = ACTIONS(1709),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_else] = ACTIONS(1709),
    [anon_sym_LPAREN] = ACTIONS(1715),
    [anon_sym_in] = ACTIONS(1711),
    [anon_sym_of] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1715),
    [anon_sym_LBRACK] = ACTIONS(1715),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_GT] = ACTIONS(1711),
    [anon_sym_SLASH] = ACTIONS(1711),
    [anon_sym_DOT] = ACTIONS(1715),
    [anon_sym_async] = ACTIONS(1709),
    [anon_sym_function] = ACTIONS(1709),
    [anon_sym_QMARK_DOT] = ACTIONS(1715),
    [anon_sym_AMP_AMP] = ACTIONS(1715),
    [anon_sym_PIPE_PIPE] = ACTIONS(1715),
    [anon_sym_GT_GT] = ACTIONS(1711),
    [anon_sym_GT_GT_GT] = ACTIONS(1715),
    [anon_sym_LT_LT] = ACTIONS(1715),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_CARET] = ACTIONS(1715),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_PLUS] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_PERCENT] = ACTIONS(1715),
    [anon_sym_STAR_STAR] = ACTIONS(1715),
    [anon_sym_LT_EQ] = ACTIONS(1715),
    [anon_sym_EQ_EQ] = ACTIONS(1711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1715),
    [anon_sym_BANG_EQ] = ACTIONS(1711),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1715),
    [anon_sym_GT_EQ] = ACTIONS(1715),
    [anon_sym_QMARK_QMARK] = ACTIONS(1715),
    [anon_sym_instanceof] = ACTIONS(1711),
    [anon_sym_PLUS_PLUS] = ACTIONS(1715),
    [anon_sym_DASH_DASH] = ACTIONS(1715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1715),
    [anon_sym_AT] = ACTIONS(1713),
    [anon_sym_static] = ACTIONS(1709),
    [anon_sym_readonly] = ACTIONS(1709),
    [anon_sym_get] = ACTIONS(1709),
    [anon_sym_set] = ACTIONS(1709),
    [anon_sym_declare] = ACTIONS(1709),
    [anon_sym_public] = ACTIONS(1709),
    [anon_sym_private] = ACTIONS(1709),
    [anon_sym_protected] = ACTIONS(1709),
    [anon_sym_override] = ACTIONS(1709),
    [anon_sym_module] = ACTIONS(1709),
    [anon_sym_any] = ACTIONS(1709),
    [anon_sym_number] = ACTIONS(1709),
    [anon_sym_boolean] = ACTIONS(1709),
    [anon_sym_string] = ACTIONS(1709),
    [anon_sym_symbol] = ACTIONS(1709),
    [anon_sym_property] = ACTIONS(1709),
    [anon_sym_signal] = ACTIONS(1709),
    [anon_sym_on] = ACTIONS(1709),
    [anon_sym_required] = ACTIONS(1709),
    [anon_sym_component] = ACTIONS(1709),
    [anon_sym_enum] = ACTIONS(1709),
    [sym__automatic_semicolon] = ACTIONS(2926),
    [sym__ternary_qmark] = ACTIONS(1715),
  },
  [903] = {
    [sym_export_statement] = STATE(3377),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4052),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4052),
    [sym_pair] = STATE(4052),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3377),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3377),
    [sym_property_signature] = STATE(3377),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3377),
    [sym_index_signature] = STATE(3377),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [aux_sym_object_repeat1] = STATE(4037),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2842),
    [anon_sym_export] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2842),
    [anon_sym_namespace] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2928),
    [anon_sym_from] = ACTIONS(2842),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2852),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2854),
    [anon_sym_readonly] = ACTIONS(2856),
    [anon_sym_get] = ACTIONS(2858),
    [anon_sym_set] = ACTIONS(2858),
    [anon_sym_declare] = ACTIONS(2842),
    [anon_sym_public] = ACTIONS(2860),
    [anon_sym_private] = ACTIONS(2860),
    [anon_sym_protected] = ACTIONS(2860),
    [anon_sym_override] = ACTIONS(2862),
    [anon_sym_module] = ACTIONS(2842),
    [anon_sym_any] = ACTIONS(2842),
    [anon_sym_number] = ACTIONS(2842),
    [anon_sym_boolean] = ACTIONS(2842),
    [anon_sym_string] = ACTIONS(2842),
    [anon_sym_symbol] = ACTIONS(2842),
    [anon_sym_property] = ACTIONS(2842),
    [anon_sym_signal] = ACTIONS(2842),
    [anon_sym_on] = ACTIONS(2842),
    [anon_sym_required] = ACTIONS(2842),
    [anon_sym_component] = ACTIONS(2842),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2822),
  },
  [904] = {
    [sym_identifier] = ACTIONS(1635),
    [anon_sym_export] = ACTIONS(1635),
    [anon_sym_STAR] = ACTIONS(1635),
    [anon_sym_default] = ACTIONS(1635),
    [anon_sym_type] = ACTIONS(1635),
    [anon_sym_as] = ACTIONS(1635),
    [anon_sym_namespace] = ACTIONS(1635),
    [anon_sym_COMMA] = ACTIONS(1637),
    [anon_sym_RBRACE] = ACTIONS(1637),
    [anon_sym_from] = ACTIONS(1635),
    [anon_sym_var] = ACTIONS(1635),
    [anon_sym_BANG] = ACTIONS(1635),
    [anon_sym_else] = ACTIONS(1635),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_in] = ACTIONS(1635),
    [anon_sym_of] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_LT] = ACTIONS(1635),
    [anon_sym_GT] = ACTIONS(1635),
    [anon_sym_SLASH] = ACTIONS(1635),
    [anon_sym_DOT] = ACTIONS(1637),
    [anon_sym_async] = ACTIONS(1635),
    [anon_sym_function] = ACTIONS(1635),
    [anon_sym_QMARK_DOT] = ACTIONS(1637),
    [anon_sym_AMP_AMP] = ACTIONS(1637),
    [anon_sym_PIPE_PIPE] = ACTIONS(1637),
    [anon_sym_GT_GT] = ACTIONS(1635),
    [anon_sym_GT_GT_GT] = ACTIONS(1637),
    [anon_sym_LT_LT] = ACTIONS(1637),
    [anon_sym_AMP] = ACTIONS(1635),
    [anon_sym_CARET] = ACTIONS(1637),
    [anon_sym_PIPE] = ACTIONS(1635),
    [anon_sym_PLUS] = ACTIONS(1635),
    [anon_sym_DASH] = ACTIONS(1635),
    [anon_sym_PERCENT] = ACTIONS(1637),
    [anon_sym_STAR_STAR] = ACTIONS(1637),
    [anon_sym_LT_EQ] = ACTIONS(1637),
    [anon_sym_EQ_EQ] = ACTIONS(1635),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1637),
    [anon_sym_BANG_EQ] = ACTIONS(1635),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1637),
    [anon_sym_GT_EQ] = ACTIONS(1637),
    [anon_sym_QMARK_QMARK] = ACTIONS(1637),
    [anon_sym_instanceof] = ACTIONS(1635),
    [anon_sym_PLUS_PLUS] = ACTIONS(1637),
    [anon_sym_DASH_DASH] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1637),
    [anon_sym_AT] = ACTIONS(1637),
    [anon_sym_static] = ACTIONS(1635),
    [anon_sym_readonly] = ACTIONS(1635),
    [anon_sym_get] = ACTIONS(1635),
    [anon_sym_set] = ACTIONS(1635),
    [anon_sym_declare] = ACTIONS(1635),
    [anon_sym_public] = ACTIONS(1635),
    [anon_sym_private] = ACTIONS(1635),
    [anon_sym_protected] = ACTIONS(1635),
    [anon_sym_override] = ACTIONS(1635),
    [anon_sym_module] = ACTIONS(1635),
    [anon_sym_any] = ACTIONS(1635),
    [anon_sym_number] = ACTIONS(1635),
    [anon_sym_boolean] = ACTIONS(1635),
    [anon_sym_string] = ACTIONS(1635),
    [anon_sym_symbol] = ACTIONS(1635),
    [anon_sym_property] = ACTIONS(1635),
    [anon_sym_signal] = ACTIONS(1635),
    [anon_sym_on] = ACTIONS(1635),
    [anon_sym_required] = ACTIONS(1635),
    [anon_sym_component] = ACTIONS(1635),
    [anon_sym_enum] = ACTIONS(1635),
    [sym__automatic_semicolon] = ACTIONS(1637),
    [sym__ternary_qmark] = ACTIONS(1637),
  },
  [905] = {
    [sym_identifier] = ACTIONS(1689),
    [anon_sym_export] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1691),
    [anon_sym_default] = ACTIONS(1689),
    [anon_sym_type] = ACTIONS(1689),
    [anon_sym_as] = ACTIONS(1691),
    [anon_sym_namespace] = ACTIONS(1689),
    [anon_sym_COMMA] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(1693),
    [anon_sym_from] = ACTIONS(1689),
    [anon_sym_var] = ACTIONS(1689),
    [anon_sym_BANG] = ACTIONS(1691),
    [anon_sym_else] = ACTIONS(1689),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1691),
    [anon_sym_of] = ACTIONS(1689),
    [anon_sym_SEMI] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(1691),
    [anon_sym_GT] = ACTIONS(1691),
    [anon_sym_SLASH] = ACTIONS(1691),
    [anon_sym_DOT] = ACTIONS(1695),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_function] = ACTIONS(1689),
    [anon_sym_QMARK_DOT] = ACTIONS(1695),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_GT_GT] = ACTIONS(1691),
    [anon_sym_GT_GT_GT] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_CARET] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(1691),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_PERCENT] = ACTIONS(1695),
    [anon_sym_STAR_STAR] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1691),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BANG_EQ] = ACTIONS(1691),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_QMARK_QMARK] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1691),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_AT] = ACTIONS(1693),
    [anon_sym_static] = ACTIONS(1689),
    [anon_sym_readonly] = ACTIONS(1689),
    [anon_sym_get] = ACTIONS(1689),
    [anon_sym_set] = ACTIONS(1689),
    [anon_sym_declare] = ACTIONS(1689),
    [anon_sym_public] = ACTIONS(1689),
    [anon_sym_private] = ACTIONS(1689),
    [anon_sym_protected] = ACTIONS(1689),
    [anon_sym_override] = ACTIONS(1689),
    [anon_sym_module] = ACTIONS(1689),
    [anon_sym_any] = ACTIONS(1689),
    [anon_sym_number] = ACTIONS(1689),
    [anon_sym_boolean] = ACTIONS(1689),
    [anon_sym_string] = ACTIONS(1689),
    [anon_sym_symbol] = ACTIONS(1689),
    [anon_sym_property] = ACTIONS(1689),
    [anon_sym_signal] = ACTIONS(1689),
    [anon_sym_on] = ACTIONS(1689),
    [anon_sym_required] = ACTIONS(1689),
    [anon_sym_component] = ACTIONS(1689),
    [anon_sym_enum] = ACTIONS(1689),
    [sym__automatic_semicolon] = ACTIONS(2930),
    [sym__ternary_qmark] = ACTIONS(1695),
  },
  [906] = {
    [sym_export_statement] = STATE(3377),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4052),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4052),
    [sym_pair] = STATE(4052),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3377),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3377),
    [sym_property_signature] = STATE(3377),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3377),
    [sym_index_signature] = STATE(3377),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [aux_sym_object_repeat1] = STATE(4037),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2894),
    [anon_sym_export] = ACTIONS(2896),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2894),
    [anon_sym_namespace] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2932),
    [anon_sym_from] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2894),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2898),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2900),
    [anon_sym_readonly] = ACTIONS(2902),
    [anon_sym_get] = ACTIONS(2904),
    [anon_sym_set] = ACTIONS(2904),
    [anon_sym_declare] = ACTIONS(2894),
    [anon_sym_public] = ACTIONS(2906),
    [anon_sym_private] = ACTIONS(2906),
    [anon_sym_protected] = ACTIONS(2906),
    [anon_sym_override] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2894),
    [anon_sym_any] = ACTIONS(2894),
    [anon_sym_number] = ACTIONS(2894),
    [anon_sym_boolean] = ACTIONS(2894),
    [anon_sym_string] = ACTIONS(2894),
    [anon_sym_symbol] = ACTIONS(2894),
    [anon_sym_property] = ACTIONS(2894),
    [anon_sym_signal] = ACTIONS(2894),
    [anon_sym_on] = ACTIONS(2894),
    [anon_sym_required] = ACTIONS(2894),
    [anon_sym_component] = ACTIONS(2894),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2822),
  },
  [907] = {
    [sym_identifier] = ACTIONS(2934),
    [anon_sym_export] = ACTIONS(2934),
    [anon_sym_type] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2934),
    [anon_sym_namespace] = ACTIONS(2934),
    [anon_sym_LBRACE] = ACTIONS(2936),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_typeof] = ACTIONS(2934),
    [anon_sym_import] = ACTIONS(2934),
    [anon_sym_from] = ACTIONS(2934),
    [anon_sym_BANG] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2936),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_await] = ACTIONS(2934),
    [anon_sym_of] = ACTIONS(2934),
    [anon_sym_COLON] = ACTIONS(2936),
    [anon_sym_yield] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2936),
    [anon_sym_RBRACK] = ACTIONS(2936),
    [anon_sym_LTtemplate_GT] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2934),
    [anon_sym_GT] = ACTIONS(2936),
    [anon_sym_SLASH] = ACTIONS(2934),
    [anon_sym_class] = ACTIONS(2934),
    [anon_sym_async] = ACTIONS(2934),
    [anon_sym_function] = ACTIONS(2934),
    [anon_sym_EQ_GT] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2934),
    [anon_sym_AMP] = ACTIONS(2936),
    [anon_sym_PIPE] = ACTIONS(2936),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2936),
    [anon_sym_void] = ACTIONS(2934),
    [anon_sym_delete] = ACTIONS(2934),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_DQUOTE] = ACTIONS(2936),
    [anon_sym_SQUOTE] = ACTIONS(2936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2936),
    [sym_number] = ACTIONS(2936),
    [sym_this] = ACTIONS(2934),
    [sym_super] = ACTIONS(2934),
    [sym_true] = ACTIONS(2934),
    [sym_false] = ACTIONS(2934),
    [sym_null] = ACTIONS(2934),
    [sym_undefined] = ACTIONS(2934),
    [anon_sym_AT] = ACTIONS(2936),
    [anon_sym_static] = ACTIONS(2934),
    [anon_sym_readonly] = ACTIONS(2934),
    [anon_sym_get] = ACTIONS(2934),
    [anon_sym_set] = ACTIONS(2934),
    [anon_sym_QMARK] = ACTIONS(2936),
    [anon_sym_declare] = ACTIONS(2934),
    [anon_sym_public] = ACTIONS(2934),
    [anon_sym_private] = ACTIONS(2934),
    [anon_sym_protected] = ACTIONS(2934),
    [anon_sym_override] = ACTIONS(2934),
    [anon_sym_module] = ACTIONS(2934),
    [anon_sym_any] = ACTIONS(2934),
    [anon_sym_number] = ACTIONS(2934),
    [anon_sym_boolean] = ACTIONS(2934),
    [anon_sym_string] = ACTIONS(2934),
    [anon_sym_symbol] = ACTIONS(2934),
    [anon_sym_property] = ACTIONS(2934),
    [anon_sym_signal] = ACTIONS(2934),
    [anon_sym_on] = ACTIONS(2934),
    [anon_sym_required] = ACTIONS(2934),
    [anon_sym_component] = ACTIONS(2934),
    [anon_sym_extends] = ACTIONS(2934),
    [anon_sym_implements] = ACTIONS(2934),
  },
  [908] = {
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_export] = ACTIONS(1473),
    [anon_sym_STAR] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_type] = ACTIONS(1473),
    [anon_sym_as] = ACTIONS(1473),
    [anon_sym_namespace] = ACTIONS(1473),
    [anon_sym_COMMA] = ACTIONS(1479),
    [anon_sym_RBRACE] = ACTIONS(1479),
    [anon_sym_from] = ACTIONS(1473),
    [anon_sym_var] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(1473),
    [anon_sym_else] = ACTIONS(1473),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_in] = ACTIONS(1473),
    [anon_sym_of] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1479),
    [anon_sym_LT] = ACTIONS(1473),
    [anon_sym_GT] = ACTIONS(1473),
    [anon_sym_SLASH] = ACTIONS(1473),
    [anon_sym_DOT] = ACTIONS(1479),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_function] = ACTIONS(1473),
    [anon_sym_QMARK_DOT] = ACTIONS(1479),
    [anon_sym_AMP_AMP] = ACTIONS(1479),
    [anon_sym_PIPE_PIPE] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1473),
    [anon_sym_GT_GT_GT] = ACTIONS(1479),
    [anon_sym_LT_LT] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1473),
    [anon_sym_CARET] = ACTIONS(1479),
    [anon_sym_PIPE] = ACTIONS(1473),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_DASH] = ACTIONS(1473),
    [anon_sym_PERCENT] = ACTIONS(1479),
    [anon_sym_STAR_STAR] = ACTIONS(1479),
    [anon_sym_LT_EQ] = ACTIONS(1479),
    [anon_sym_EQ_EQ] = ACTIONS(1473),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1479),
    [anon_sym_BANG_EQ] = ACTIONS(1473),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1479),
    [anon_sym_GT_EQ] = ACTIONS(1479),
    [anon_sym_QMARK_QMARK] = ACTIONS(1479),
    [anon_sym_instanceof] = ACTIONS(1473),
    [anon_sym_PLUS_PLUS] = ACTIONS(1479),
    [anon_sym_DASH_DASH] = ACTIONS(1479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1479),
    [anon_sym_AT] = ACTIONS(1479),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_readonly] = ACTIONS(1473),
    [anon_sym_get] = ACTIONS(1473),
    [anon_sym_set] = ACTIONS(1473),
    [anon_sym_declare] = ACTIONS(1473),
    [anon_sym_public] = ACTIONS(1473),
    [anon_sym_private] = ACTIONS(1473),
    [anon_sym_protected] = ACTIONS(1473),
    [anon_sym_override] = ACTIONS(1473),
    [anon_sym_module] = ACTIONS(1473),
    [anon_sym_any] = ACTIONS(1473),
    [anon_sym_number] = ACTIONS(1473),
    [anon_sym_boolean] = ACTIONS(1473),
    [anon_sym_string] = ACTIONS(1473),
    [anon_sym_symbol] = ACTIONS(1473),
    [anon_sym_property] = ACTIONS(1473),
    [anon_sym_signal] = ACTIONS(1473),
    [anon_sym_on] = ACTIONS(1473),
    [anon_sym_required] = ACTIONS(1473),
    [anon_sym_component] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [sym__automatic_semicolon] = ACTIONS(2938),
    [sym__ternary_qmark] = ACTIONS(1479),
  },
  [909] = {
    [sym_identifier] = ACTIONS(1585),
    [anon_sym_export] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1585),
    [anon_sym_default] = ACTIONS(1585),
    [anon_sym_type] = ACTIONS(1585),
    [anon_sym_as] = ACTIONS(1585),
    [anon_sym_namespace] = ACTIONS(1585),
    [anon_sym_COMMA] = ACTIONS(1587),
    [anon_sym_RBRACE] = ACTIONS(1587),
    [anon_sym_from] = ACTIONS(1585),
    [anon_sym_var] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_else] = ACTIONS(1585),
    [anon_sym_LPAREN] = ACTIONS(1587),
    [anon_sym_in] = ACTIONS(1585),
    [anon_sym_of] = ACTIONS(1585),
    [anon_sym_SEMI] = ACTIONS(1587),
    [anon_sym_LBRACK] = ACTIONS(1587),
    [anon_sym_LT] = ACTIONS(1585),
    [anon_sym_GT] = ACTIONS(1585),
    [anon_sym_SLASH] = ACTIONS(1585),
    [anon_sym_DOT] = ACTIONS(1587),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_function] = ACTIONS(1585),
    [anon_sym_QMARK_DOT] = ACTIONS(1587),
    [anon_sym_AMP_AMP] = ACTIONS(1587),
    [anon_sym_PIPE_PIPE] = ACTIONS(1587),
    [anon_sym_GT_GT] = ACTIONS(1585),
    [anon_sym_GT_GT_GT] = ACTIONS(1587),
    [anon_sym_LT_LT] = ACTIONS(1587),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_CARET] = ACTIONS(1587),
    [anon_sym_PIPE] = ACTIONS(1585),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_PERCENT] = ACTIONS(1587),
    [anon_sym_STAR_STAR] = ACTIONS(1587),
    [anon_sym_LT_EQ] = ACTIONS(1587),
    [anon_sym_EQ_EQ] = ACTIONS(1585),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1587),
    [anon_sym_BANG_EQ] = ACTIONS(1585),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1587),
    [anon_sym_GT_EQ] = ACTIONS(1587),
    [anon_sym_QMARK_QMARK] = ACTIONS(1587),
    [anon_sym_instanceof] = ACTIONS(1585),
    [anon_sym_PLUS_PLUS] = ACTIONS(1587),
    [anon_sym_DASH_DASH] = ACTIONS(1587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1587),
    [anon_sym_AT] = ACTIONS(1587),
    [anon_sym_static] = ACTIONS(1585),
    [anon_sym_readonly] = ACTIONS(1585),
    [anon_sym_get] = ACTIONS(1585),
    [anon_sym_set] = ACTIONS(1585),
    [anon_sym_declare] = ACTIONS(1585),
    [anon_sym_public] = ACTIONS(1585),
    [anon_sym_private] = ACTIONS(1585),
    [anon_sym_protected] = ACTIONS(1585),
    [anon_sym_override] = ACTIONS(1585),
    [anon_sym_module] = ACTIONS(1585),
    [anon_sym_any] = ACTIONS(1585),
    [anon_sym_number] = ACTIONS(1585),
    [anon_sym_boolean] = ACTIONS(1585),
    [anon_sym_string] = ACTIONS(1585),
    [anon_sym_symbol] = ACTIONS(1585),
    [anon_sym_property] = ACTIONS(1585),
    [anon_sym_signal] = ACTIONS(1585),
    [anon_sym_on] = ACTIONS(1585),
    [anon_sym_required] = ACTIONS(1585),
    [anon_sym_component] = ACTIONS(1585),
    [anon_sym_enum] = ACTIONS(1585),
    [sym__automatic_semicolon] = ACTIONS(1587),
    [sym__ternary_qmark] = ACTIONS(1587),
  },
  [910] = {
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_export] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1733),
    [anon_sym_default] = ACTIONS(1731),
    [anon_sym_type] = ACTIONS(1731),
    [anon_sym_as] = ACTIONS(1733),
    [anon_sym_namespace] = ACTIONS(1731),
    [anon_sym_COMMA] = ACTIONS(1737),
    [anon_sym_RBRACE] = ACTIONS(1735),
    [anon_sym_from] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1731),
    [anon_sym_BANG] = ACTIONS(1733),
    [anon_sym_else] = ACTIONS(1731),
    [anon_sym_LPAREN] = ACTIONS(1737),
    [anon_sym_in] = ACTIONS(1733),
    [anon_sym_of] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1737),
    [anon_sym_LBRACK] = ACTIONS(1737),
    [anon_sym_LT] = ACTIONS(1733),
    [anon_sym_GT] = ACTIONS(1733),
    [anon_sym_SLASH] = ACTIONS(1733),
    [anon_sym_DOT] = ACTIONS(1737),
    [anon_sym_async] = ACTIONS(1731),
    [anon_sym_function] = ACTIONS(1731),
    [anon_sym_QMARK_DOT] = ACTIONS(1737),
    [anon_sym_AMP_AMP] = ACTIONS(1737),
    [anon_sym_PIPE_PIPE] = ACTIONS(1737),
    [anon_sym_GT_GT] = ACTIONS(1733),
    [anon_sym_GT_GT_GT] = ACTIONS(1737),
    [anon_sym_LT_LT] = ACTIONS(1737),
    [anon_sym_AMP] = ACTIONS(1733),
    [anon_sym_CARET] = ACTIONS(1737),
    [anon_sym_PIPE] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1733),
    [anon_sym_DASH] = ACTIONS(1733),
    [anon_sym_PERCENT] = ACTIONS(1737),
    [anon_sym_STAR_STAR] = ACTIONS(1737),
    [anon_sym_LT_EQ] = ACTIONS(1737),
    [anon_sym_EQ_EQ] = ACTIONS(1733),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1737),
    [anon_sym_BANG_EQ] = ACTIONS(1733),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1737),
    [anon_sym_GT_EQ] = ACTIONS(1737),
    [anon_sym_QMARK_QMARK] = ACTIONS(1737),
    [anon_sym_instanceof] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1737),
    [anon_sym_DASH_DASH] = ACTIONS(1737),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1737),
    [anon_sym_AT] = ACTIONS(1735),
    [anon_sym_static] = ACTIONS(1731),
    [anon_sym_readonly] = ACTIONS(1731),
    [anon_sym_get] = ACTIONS(1731),
    [anon_sym_set] = ACTIONS(1731),
    [anon_sym_declare] = ACTIONS(1731),
    [anon_sym_public] = ACTIONS(1731),
    [anon_sym_private] = ACTIONS(1731),
    [anon_sym_protected] = ACTIONS(1731),
    [anon_sym_override] = ACTIONS(1731),
    [anon_sym_module] = ACTIONS(1731),
    [anon_sym_any] = ACTIONS(1731),
    [anon_sym_number] = ACTIONS(1731),
    [anon_sym_boolean] = ACTIONS(1731),
    [anon_sym_string] = ACTIONS(1731),
    [anon_sym_symbol] = ACTIONS(1731),
    [anon_sym_property] = ACTIONS(1731),
    [anon_sym_signal] = ACTIONS(1731),
    [anon_sym_on] = ACTIONS(1731),
    [anon_sym_required] = ACTIONS(1731),
    [anon_sym_component] = ACTIONS(1731),
    [anon_sym_enum] = ACTIONS(1731),
    [sym__automatic_semicolon] = ACTIONS(2940),
    [sym__ternary_qmark] = ACTIONS(1737),
  },
  [911] = {
    [sym_identifier] = ACTIONS(1599),
    [anon_sym_export] = ACTIONS(1599),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_default] = ACTIONS(1599),
    [anon_sym_type] = ACTIONS(1599),
    [anon_sym_as] = ACTIONS(1601),
    [anon_sym_namespace] = ACTIONS(1599),
    [anon_sym_COMMA] = ACTIONS(1605),
    [anon_sym_RBRACE] = ACTIONS(1603),
    [anon_sym_from] = ACTIONS(1599),
    [anon_sym_var] = ACTIONS(1599),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_else] = ACTIONS(1599),
    [anon_sym_LPAREN] = ACTIONS(1605),
    [anon_sym_in] = ACTIONS(1601),
    [anon_sym_of] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1605),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_GT] = ACTIONS(1601),
    [anon_sym_SLASH] = ACTIONS(1601),
    [anon_sym_DOT] = ACTIONS(1605),
    [anon_sym_async] = ACTIONS(1599),
    [anon_sym_function] = ACTIONS(1599),
    [anon_sym_QMARK_DOT] = ACTIONS(1605),
    [anon_sym_AMP_AMP] = ACTIONS(1605),
    [anon_sym_PIPE_PIPE] = ACTIONS(1605),
    [anon_sym_GT_GT] = ACTIONS(1601),
    [anon_sym_GT_GT_GT] = ACTIONS(1605),
    [anon_sym_LT_LT] = ACTIONS(1605),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_CARET] = ACTIONS(1605),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_PLUS] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_PERCENT] = ACTIONS(1605),
    [anon_sym_STAR_STAR] = ACTIONS(1605),
    [anon_sym_LT_EQ] = ACTIONS(1605),
    [anon_sym_EQ_EQ] = ACTIONS(1601),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1605),
    [anon_sym_BANG_EQ] = ACTIONS(1601),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1605),
    [anon_sym_GT_EQ] = ACTIONS(1605),
    [anon_sym_QMARK_QMARK] = ACTIONS(1605),
    [anon_sym_instanceof] = ACTIONS(1601),
    [anon_sym_PLUS_PLUS] = ACTIONS(1605),
    [anon_sym_DASH_DASH] = ACTIONS(1605),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1605),
    [anon_sym_AT] = ACTIONS(1603),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_readonly] = ACTIONS(1599),
    [anon_sym_get] = ACTIONS(1599),
    [anon_sym_set] = ACTIONS(1599),
    [anon_sym_declare] = ACTIONS(1599),
    [anon_sym_public] = ACTIONS(1599),
    [anon_sym_private] = ACTIONS(1599),
    [anon_sym_protected] = ACTIONS(1599),
    [anon_sym_override] = ACTIONS(1599),
    [anon_sym_module] = ACTIONS(1599),
    [anon_sym_any] = ACTIONS(1599),
    [anon_sym_number] = ACTIONS(1599),
    [anon_sym_boolean] = ACTIONS(1599),
    [anon_sym_string] = ACTIONS(1599),
    [anon_sym_symbol] = ACTIONS(1599),
    [anon_sym_property] = ACTIONS(1599),
    [anon_sym_signal] = ACTIONS(1599),
    [anon_sym_on] = ACTIONS(1599),
    [anon_sym_required] = ACTIONS(1599),
    [anon_sym_component] = ACTIONS(1599),
    [anon_sym_enum] = ACTIONS(1599),
    [sym__automatic_semicolon] = ACTIONS(2942),
    [sym__ternary_qmark] = ACTIONS(1605),
  },
  [912] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4487),
    [sym_optional_tuple_parameter] = STATE(4487),
    [sym_optional_type] = STATE(4487),
    [sym_rest_type] = STATE(4487),
    [sym__tuple_type_member] = STATE(4487),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2944),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [913] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4487),
    [sym_optional_tuple_parameter] = STATE(4487),
    [sym_optional_type] = STATE(4487),
    [sym_rest_type] = STATE(4487),
    [sym__tuple_type_member] = STATE(4487),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2946),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [914] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4487),
    [sym_optional_tuple_parameter] = STATE(4487),
    [sym_optional_type] = STATE(4487),
    [sym_rest_type] = STATE(4487),
    [sym__tuple_type_member] = STATE(4487),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [915] = {
    [sym_export_statement] = STATE(3377),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4052),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4052),
    [sym_pair] = STATE(4052),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3377),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3377),
    [sym_property_signature] = STATE(3377),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3377),
    [sym_index_signature] = STATE(3377),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [aux_sym_object_repeat1] = STATE(4037),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_export] = ACTIONS(2952),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2950),
    [anon_sym_namespace] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2868),
    [anon_sym_from] = ACTIONS(2950),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2954),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2956),
    [anon_sym_readonly] = ACTIONS(2958),
    [anon_sym_get] = ACTIONS(2960),
    [anon_sym_set] = ACTIONS(2960),
    [anon_sym_declare] = ACTIONS(2950),
    [anon_sym_public] = ACTIONS(2962),
    [anon_sym_private] = ACTIONS(2962),
    [anon_sym_protected] = ACTIONS(2962),
    [anon_sym_override] = ACTIONS(2964),
    [anon_sym_module] = ACTIONS(2950),
    [anon_sym_any] = ACTIONS(2950),
    [anon_sym_number] = ACTIONS(2950),
    [anon_sym_boolean] = ACTIONS(2950),
    [anon_sym_string] = ACTIONS(2950),
    [anon_sym_symbol] = ACTIONS(2950),
    [anon_sym_property] = ACTIONS(2950),
    [anon_sym_signal] = ACTIONS(2950),
    [anon_sym_on] = ACTIONS(2950),
    [anon_sym_required] = ACTIONS(2950),
    [anon_sym_component] = ACTIONS(2950),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2822),
  },
  [916] = {
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_export] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_default] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(1519),
    [anon_sym_as] = ACTIONS(1519),
    [anon_sym_namespace] = ACTIONS(1519),
    [anon_sym_COMMA] = ACTIONS(1521),
    [anon_sym_RBRACE] = ACTIONS(1521),
    [anon_sym_from] = ACTIONS(1519),
    [anon_sym_var] = ACTIONS(1519),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_else] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_in] = ACTIONS(1519),
    [anon_sym_of] = ACTIONS(1519),
    [anon_sym_SEMI] = ACTIONS(1521),
    [anon_sym_LBRACK] = ACTIONS(1521),
    [anon_sym_LT] = ACTIONS(1519),
    [anon_sym_GT] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(1519),
    [anon_sym_DOT] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1519),
    [anon_sym_function] = ACTIONS(1519),
    [anon_sym_QMARK_DOT] = ACTIONS(1521),
    [anon_sym_AMP_AMP] = ACTIONS(1521),
    [anon_sym_PIPE_PIPE] = ACTIONS(1521),
    [anon_sym_GT_GT] = ACTIONS(1519),
    [anon_sym_GT_GT_GT] = ACTIONS(1521),
    [anon_sym_LT_LT] = ACTIONS(1521),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_CARET] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1519),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_PERCENT] = ACTIONS(1521),
    [anon_sym_STAR_STAR] = ACTIONS(1521),
    [anon_sym_LT_EQ] = ACTIONS(1521),
    [anon_sym_EQ_EQ] = ACTIONS(1519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1521),
    [anon_sym_BANG_EQ] = ACTIONS(1519),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1521),
    [anon_sym_GT_EQ] = ACTIONS(1521),
    [anon_sym_QMARK_QMARK] = ACTIONS(1521),
    [anon_sym_instanceof] = ACTIONS(1519),
    [anon_sym_PLUS_PLUS] = ACTIONS(1521),
    [anon_sym_DASH_DASH] = ACTIONS(1521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1521),
    [anon_sym_AT] = ACTIONS(1521),
    [anon_sym_static] = ACTIONS(1519),
    [anon_sym_readonly] = ACTIONS(1519),
    [anon_sym_get] = ACTIONS(1519),
    [anon_sym_set] = ACTIONS(1519),
    [anon_sym_declare] = ACTIONS(1519),
    [anon_sym_public] = ACTIONS(1519),
    [anon_sym_private] = ACTIONS(1519),
    [anon_sym_protected] = ACTIONS(1519),
    [anon_sym_override] = ACTIONS(1519),
    [anon_sym_module] = ACTIONS(1519),
    [anon_sym_any] = ACTIONS(1519),
    [anon_sym_number] = ACTIONS(1519),
    [anon_sym_boolean] = ACTIONS(1519),
    [anon_sym_string] = ACTIONS(1519),
    [anon_sym_symbol] = ACTIONS(1519),
    [anon_sym_property] = ACTIONS(1519),
    [anon_sym_signal] = ACTIONS(1519),
    [anon_sym_on] = ACTIONS(1519),
    [anon_sym_required] = ACTIONS(1519),
    [anon_sym_component] = ACTIONS(1519),
    [anon_sym_enum] = ACTIONS(1519),
    [sym__automatic_semicolon] = ACTIONS(1521),
    [sym__ternary_qmark] = ACTIONS(1521),
  },
  [917] = {
    [sym_identifier] = ACTIONS(1609),
    [anon_sym_export] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1609),
    [anon_sym_default] = ACTIONS(1609),
    [anon_sym_type] = ACTIONS(1609),
    [anon_sym_as] = ACTIONS(1609),
    [anon_sym_namespace] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1611),
    [anon_sym_RBRACE] = ACTIONS(1611),
    [anon_sym_from] = ACTIONS(1609),
    [anon_sym_var] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1609),
    [anon_sym_else] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1611),
    [anon_sym_in] = ACTIONS(1609),
    [anon_sym_of] = ACTIONS(1609),
    [anon_sym_SEMI] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1609),
    [anon_sym_GT] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1609),
    [anon_sym_DOT] = ACTIONS(1611),
    [anon_sym_async] = ACTIONS(1609),
    [anon_sym_function] = ACTIONS(1609),
    [anon_sym_QMARK_DOT] = ACTIONS(1611),
    [anon_sym_AMP_AMP] = ACTIONS(1611),
    [anon_sym_PIPE_PIPE] = ACTIONS(1611),
    [anon_sym_GT_GT] = ACTIONS(1609),
    [anon_sym_GT_GT_GT] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_AMP] = ACTIONS(1609),
    [anon_sym_CARET] = ACTIONS(1611),
    [anon_sym_PIPE] = ACTIONS(1609),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PERCENT] = ACTIONS(1611),
    [anon_sym_STAR_STAR] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1611),
    [anon_sym_EQ_EQ] = ACTIONS(1609),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1611),
    [anon_sym_BANG_EQ] = ACTIONS(1609),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1611),
    [anon_sym_GT_EQ] = ACTIONS(1611),
    [anon_sym_QMARK_QMARK] = ACTIONS(1611),
    [anon_sym_instanceof] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1611),
    [anon_sym_DASH_DASH] = ACTIONS(1611),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(1611),
    [anon_sym_static] = ACTIONS(1609),
    [anon_sym_readonly] = ACTIONS(1609),
    [anon_sym_get] = ACTIONS(1609),
    [anon_sym_set] = ACTIONS(1609),
    [anon_sym_declare] = ACTIONS(1609),
    [anon_sym_public] = ACTIONS(1609),
    [anon_sym_private] = ACTIONS(1609),
    [anon_sym_protected] = ACTIONS(1609),
    [anon_sym_override] = ACTIONS(1609),
    [anon_sym_module] = ACTIONS(1609),
    [anon_sym_any] = ACTIONS(1609),
    [anon_sym_number] = ACTIONS(1609),
    [anon_sym_boolean] = ACTIONS(1609),
    [anon_sym_string] = ACTIONS(1609),
    [anon_sym_symbol] = ACTIONS(1609),
    [anon_sym_property] = ACTIONS(1609),
    [anon_sym_signal] = ACTIONS(1609),
    [anon_sym_on] = ACTIONS(1609),
    [anon_sym_required] = ACTIONS(1609),
    [anon_sym_component] = ACTIONS(1609),
    [anon_sym_enum] = ACTIONS(1609),
    [sym__automatic_semicolon] = ACTIONS(1611),
    [sym__ternary_qmark] = ACTIONS(1611),
  },
  [918] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4487),
    [sym_optional_tuple_parameter] = STATE(4487),
    [sym_optional_type] = STATE(4487),
    [sym_rest_type] = STATE(4487),
    [sym__tuple_type_member] = STATE(4487),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2966),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [919] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4487),
    [sym_optional_tuple_parameter] = STATE(4487),
    [sym_optional_type] = STATE(4487),
    [sym_rest_type] = STATE(4487),
    [sym__tuple_type_member] = STATE(4487),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2968),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [920] = {
    [sym_export_statement] = STATE(3377),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4148),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4052),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4148),
    [sym_method_definition] = STATE(4052),
    [sym_pair] = STATE(4052),
    [sym_pair_pattern] = STATE(4148),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3377),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3377),
    [sym_property_signature] = STATE(3377),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3377),
    [sym_index_signature] = STATE(3377),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [aux_sym_object_repeat1] = STATE(4037),
    [aux_sym_object_pattern_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2842),
    [anon_sym_export] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2842),
    [anon_sym_namespace] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2792),
    [anon_sym_RBRACE] = ACTIONS(2828),
    [anon_sym_from] = ACTIONS(2842),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2798),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2852),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2854),
    [anon_sym_readonly] = ACTIONS(2856),
    [anon_sym_get] = ACTIONS(2858),
    [anon_sym_set] = ACTIONS(2858),
    [anon_sym_declare] = ACTIONS(2842),
    [anon_sym_public] = ACTIONS(2860),
    [anon_sym_private] = ACTIONS(2860),
    [anon_sym_protected] = ACTIONS(2860),
    [anon_sym_override] = ACTIONS(2862),
    [anon_sym_module] = ACTIONS(2842),
    [anon_sym_any] = ACTIONS(2842),
    [anon_sym_number] = ACTIONS(2842),
    [anon_sym_boolean] = ACTIONS(2842),
    [anon_sym_string] = ACTIONS(2842),
    [anon_sym_symbol] = ACTIONS(2842),
    [anon_sym_property] = ACTIONS(2842),
    [anon_sym_signal] = ACTIONS(2842),
    [anon_sym_on] = ACTIONS(2842),
    [anon_sym_required] = ACTIONS(2842),
    [anon_sym_component] = ACTIONS(2842),
    [anon_sym_abstract] = ACTIONS(2820),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2822),
  },
  [921] = {
    [sym_identifier] = ACTIONS(1533),
    [anon_sym_export] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_default] = ACTIONS(1533),
    [anon_sym_type] = ACTIONS(1533),
    [anon_sym_as] = ACTIONS(1533),
    [anon_sym_namespace] = ACTIONS(1533),
    [anon_sym_COMMA] = ACTIONS(1535),
    [anon_sym_RBRACE] = ACTIONS(1535),
    [anon_sym_from] = ACTIONS(1533),
    [anon_sym_var] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_else] = ACTIONS(1533),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_in] = ACTIONS(1533),
    [anon_sym_of] = ACTIONS(1533),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym_LBRACK] = ACTIONS(1535),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_GT] = ACTIONS(1533),
    [anon_sym_SLASH] = ACTIONS(1533),
    [anon_sym_DOT] = ACTIONS(1535),
    [anon_sym_async] = ACTIONS(1533),
    [anon_sym_function] = ACTIONS(1533),
    [anon_sym_QMARK_DOT] = ACTIONS(1535),
    [anon_sym_AMP_AMP] = ACTIONS(1535),
    [anon_sym_PIPE_PIPE] = ACTIONS(1535),
    [anon_sym_GT_GT] = ACTIONS(1533),
    [anon_sym_GT_GT_GT] = ACTIONS(1535),
    [anon_sym_LT_LT] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_PLUS] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_PERCENT] = ACTIONS(1535),
    [anon_sym_STAR_STAR] = ACTIONS(1535),
    [anon_sym_LT_EQ] = ACTIONS(1535),
    [anon_sym_EQ_EQ] = ACTIONS(1533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1535),
    [anon_sym_BANG_EQ] = ACTIONS(1533),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1535),
    [anon_sym_GT_EQ] = ACTIONS(1535),
    [anon_sym_QMARK_QMARK] = ACTIONS(1535),
    [anon_sym_instanceof] = ACTIONS(1533),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1535),
    [anon_sym_AT] = ACTIONS(1535),
    [anon_sym_static] = ACTIONS(1533),
    [anon_sym_readonly] = ACTIONS(1533),
    [anon_sym_get] = ACTIONS(1533),
    [anon_sym_set] = ACTIONS(1533),
    [anon_sym_declare] = ACTIONS(1533),
    [anon_sym_public] = ACTIONS(1533),
    [anon_sym_private] = ACTIONS(1533),
    [anon_sym_protected] = ACTIONS(1533),
    [anon_sym_override] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1533),
    [anon_sym_any] = ACTIONS(1533),
    [anon_sym_number] = ACTIONS(1533),
    [anon_sym_boolean] = ACTIONS(1533),
    [anon_sym_string] = ACTIONS(1533),
    [anon_sym_symbol] = ACTIONS(1533),
    [anon_sym_property] = ACTIONS(1533),
    [anon_sym_signal] = ACTIONS(1533),
    [anon_sym_on] = ACTIONS(1533),
    [anon_sym_required] = ACTIONS(1533),
    [anon_sym_component] = ACTIONS(1533),
    [anon_sym_enum] = ACTIONS(1533),
    [sym__automatic_semicolon] = ACTIONS(1535),
    [sym__ternary_qmark] = ACTIONS(1535),
  },
  [922] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4487),
    [sym_optional_tuple_parameter] = STATE(4487),
    [sym_optional_type] = STATE(4487),
    [sym_rest_type] = STATE(4487),
    [sym__tuple_type_member] = STATE(4487),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(2970),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [923] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_rest_pattern] = STATE(4559),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3419),
    [sym_tuple_parameter] = STATE(4487),
    [sym_optional_tuple_parameter] = STATE(4487),
    [sym_optional_type] = STATE(4487),
    [sym_rest_type] = STATE(4487),
    [sym__tuple_type_member] = STATE(4487),
    [sym_constructor_type] = STATE(3419),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3419),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3419),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3419),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [924] = {
    [sym_export_statement] = STATE(3540),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4385),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4414),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4385),
    [sym_method_definition] = STATE(4414),
    [sym_pair] = STATE(4414),
    [sym_pair_pattern] = STATE(4385),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3540),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3540),
    [sym_property_signature] = STATE(3540),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3540),
    [sym_index_signature] = STATE(3540),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [sym_identifier] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_RBRACE] = ACTIONS(2976),
    [anon_sym_from] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2979),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2981),
    [anon_sym_readonly] = ACTIONS(2983),
    [anon_sym_get] = ACTIONS(2985),
    [anon_sym_set] = ACTIONS(2985),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_public] = ACTIONS(2987),
    [anon_sym_private] = ACTIONS(2987),
    [anon_sym_protected] = ACTIONS(2987),
    [anon_sym_override] = ACTIONS(2989),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_property] = ACTIONS(2972),
    [anon_sym_signal] = ACTIONS(2972),
    [anon_sym_on] = ACTIONS(2972),
    [anon_sym_required] = ACTIONS(2972),
    [anon_sym_component] = ACTIONS(2972),
    [anon_sym_abstract] = ACTIONS(2820),
  },
  [925] = {
    [sym_export_statement] = STATE(3497),
    [sym_object_pattern] = STATE(4722),
    [sym_object_assignment_pattern] = STATE(4385),
    [sym_array_pattern] = STATE(4722),
    [sym__call_signature] = STATE(3763),
    [sym__destructuring_pattern] = STATE(4722),
    [sym_spread_element] = STATE(4414),
    [sym_string] = STATE(2972),
    [sym_decorator] = STATE(1128),
    [sym_formal_parameters] = STATE(3122),
    [sym_rest_pattern] = STATE(4385),
    [sym_method_definition] = STATE(4414),
    [sym_pair] = STATE(4414),
    [sym_pair_pattern] = STATE(4385),
    [sym__property_name] = STATE(2972),
    [sym_computed_property_name] = STATE(2972),
    [sym_method_signature] = STATE(3497),
    [sym_accessibility_modifier] = STATE(2463),
    [sym_override_modifier] = STATE(2490),
    [sym_call_signature] = STATE(3497),
    [sym_property_signature] = STATE(3497),
    [sym_type_parameters] = STATE(4401),
    [sym_construct_signature] = STATE(3497),
    [sym_index_signature] = STATE(3497),
    [aux_sym_export_statement_repeat1] = STATE(3872),
    [sym_identifier] = ACTIONS(2972),
    [anon_sym_export] = ACTIONS(2974),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_type] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2976),
    [anon_sym_RBRACE] = ACTIONS(2976),
    [anon_sym_from] = ACTIONS(2972),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_of] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_async] = ACTIONS(2979),
    [anon_sym_new] = ACTIONS(2804),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_DASH] = ACTIONS(2806),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym_number] = ACTIONS(2808),
    [sym_private_property_identifier] = ACTIONS(2808),
    [anon_sym_AT] = ACTIONS(103),
    [anon_sym_static] = ACTIONS(2981),
    [anon_sym_readonly] = ACTIONS(2983),
    [anon_sym_get] = ACTIONS(2985),
    [anon_sym_set] = ACTIONS(2985),
    [anon_sym_declare] = ACTIONS(2972),
    [anon_sym_public] = ACTIONS(2987),
    [anon_sym_private] = ACTIONS(2987),
    [anon_sym_protected] = ACTIONS(2987),
    [anon_sym_override] = ACTIONS(2989),
    [anon_sym_module] = ACTIONS(2972),
    [anon_sym_any] = ACTIONS(2972),
    [anon_sym_number] = ACTIONS(2972),
    [anon_sym_boolean] = ACTIONS(2972),
    [anon_sym_string] = ACTIONS(2972),
    [anon_sym_symbol] = ACTIONS(2972),
    [anon_sym_property] = ACTIONS(2972),
    [anon_sym_signal] = ACTIONS(2972),
    [anon_sym_on] = ACTIONS(2972),
    [anon_sym_required] = ACTIONS(2972),
    [anon_sym_component] = ACTIONS(2972),
    [anon_sym_abstract] = ACTIONS(2820),
  },
  [926] = {
    [sym_nested_identifier] = STATE(674),
    [sym_string] = STATE(681),
    [sym__module] = STATE(774),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2991),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_QMARK] = ACTIONS(2037),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [927] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3235),
    [sym_constructor_type] = STATE(3235),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3235),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_predicate] = STATE(3563),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3107),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3235),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3235),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3027),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_asserts] = ACTIONS(3037),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [928] = {
    [sym_nested_identifier] = STATE(151),
    [sym_string] = STATE(149),
    [sym__module] = STATE(178),
    [aux_sym_object_repeat1] = STATE(4186),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2043),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_QMARK] = ACTIONS(2037),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [929] = {
    [sym_nested_identifier] = STATE(674),
    [sym_string] = STATE(681),
    [sym__module] = STATE(774),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2991),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_QMARK] = ACTIONS(2037),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [930] = {
    [sym_nested_identifier] = STATE(151),
    [sym_string] = STATE(149),
    [sym__module] = STATE(178),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2039),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_QMARK] = ACTIONS(2037),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [931] = {
    [sym_nested_identifier] = STATE(674),
    [sym_string] = STATE(681),
    [sym__module] = STATE(774),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2991),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2039),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_QMARK] = ACTIONS(2037),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [932] = {
    [sym_nested_identifier] = STATE(151),
    [sym_string] = STATE(149),
    [sym__module] = STATE(178),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_QMARK] = ACTIONS(2037),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [933] = {
    [sym_nested_identifier] = STATE(151),
    [sym_string] = STATE(149),
    [sym__module] = STATE(178),
    [aux_sym_object_repeat1] = STATE(4109),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_QMARK] = ACTIONS(2037),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [934] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3101),
    [sym_constructor_type] = STATE(3101),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3101),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_predicate] = STATE(3527),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3003),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3101),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3101),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(3055),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_asserts] = ACTIONS(3057),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [935] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3205),
    [sym_constructor_type] = STATE(3205),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3205),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_predicate] = STATE(4439),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2862),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3205),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3205),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(3061),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_asserts] = ACTIONS(3063),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [936] = {
    [sym_nested_identifier] = STATE(674),
    [sym_string] = STATE(681),
    [sym__module] = STATE(774),
    [aux_sym_object_repeat1] = STATE(4186),
    [aux_sym_object_pattern_repeat1] = STATE(4079),
    [sym_identifier] = ACTIONS(2991),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_COMMA] = ACTIONS(64),
    [anon_sym_RBRACE] = ACTIONS(2043),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(2067),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_SEMI] = ACTIONS(64),
    [anon_sym_COLON] = ACTIONS(2021),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_LT] = ACTIONS(2070),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_EQ_GT] = ACTIONS(1446),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(2993),
    [anon_sym_SQUOTE] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_QMARK] = ACTIONS(2037),
    [sym__automatic_semicolon] = ACTIONS(64),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [937] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3412),
    [sym_constructor_type] = STATE(3412),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3412),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3412),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3412),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_GT] = ACTIONS(3065),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [938] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3389),
    [sym_constructor_type] = STATE(3389),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3389),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_type_parameter] = STATE(4072),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3389),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3389),
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [939] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3412),
    [sym_constructor_type] = STATE(3412),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3412),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3412),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3412),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_GT] = ACTIONS(3069),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [940] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1639),
    [sym_constructor_type] = STATE(1639),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(1639),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_predicate] = STATE(1640),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1509),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1639),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1639),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3097),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [941] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3412),
    [sym_constructor_type] = STATE(3412),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3412),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3412),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3412),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_GT] = ACTIONS(3113),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [942] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3412),
    [sym_constructor_type] = STATE(3412),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3412),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3412),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3412),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_GT] = ACTIONS(3115),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [943] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(3514),
    [sym_constructor_type] = STATE(3514),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3514),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_predicate] = STATE(2851),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(3326),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3514),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3514),
    [sym_identifier] = ACTIONS(3117),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(3131),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [944] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1657),
    [sym_constructor_type] = STATE(1657),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(1657),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_predicate] = STATE(1660),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1509),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1657),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1657),
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3097),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [945] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3412),
    [sym_constructor_type] = STATE(3412),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3412),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3412),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3412),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_GT] = ACTIONS(3143),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [946] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3046),
    [sym_constructor_type] = STATE(3046),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3046),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_predicate] = STATE(3059),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3003),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3046),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3046),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(3055),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [947] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3412),
    [sym_constructor_type] = STATE(3412),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3412),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3412),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3412),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_GT] = ACTIONS(3145),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [948] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3907),
    [sym_constructor_type] = STATE(3907),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3907),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3907),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3907),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(3147),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [949] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3412),
    [sym_constructor_type] = STATE(3412),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3412),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3412),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3412),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_GT] = ACTIONS(3149),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [950] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3148),
    [sym_constructor_type] = STATE(3148),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3148),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_predicate] = STATE(3149),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3107),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3148),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3148),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3027),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [951] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2914),
    [sym_constructor_type] = STATE(2914),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2914),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_predicate] = STATE(2851),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2862),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2914),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2914),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(3061),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [952] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(2081),
    [sym_constructor_type] = STATE(2081),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(2081),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_predicate] = STATE(2082),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(1853),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(2081),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(2081),
    [sym_identifier] = ACTIONS(3151),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3177),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [953] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3073),
    [sym_constructor_type] = STATE(3073),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3073),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_predicate] = STATE(3067),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3003),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3073),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3073),
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(3055),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [954] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2913),
    [sym_constructor_type] = STATE(2913),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2913),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_predicate] = STATE(2848),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2862),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2913),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2913),
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(3061),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [955] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3981),
    [sym_constructor_type] = STATE(3981),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3981),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3981),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3981),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(3193),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [956] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3412),
    [sym_constructor_type] = STATE(3412),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3412),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3412),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3412),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_GT] = ACTIONS(3195),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [957] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(3534),
    [sym_constructor_type] = STATE(3534),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3534),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_predicate] = STATE(2848),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(3326),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3534),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3534),
    [sym_identifier] = ACTIONS(3117),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(3131),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [958] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3204),
    [sym_constructor_type] = STATE(3204),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3204),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_predicate] = STATE(3195),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3107),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3204),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3204),
    [sym_identifier] = ACTIONS(2997),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3027),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [959] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3412),
    [sym_constructor_type] = STATE(3412),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3412),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3412),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3412),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_GT] = ACTIONS(3197),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [960] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(1924),
    [sym_constructor_type] = STATE(1924),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(1924),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_predicate] = STATE(1921),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(1853),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(1924),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(1924),
    [sym_identifier] = ACTIONS(3151),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3177),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [961] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3958),
    [sym_constructor_type] = STATE(3958),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3958),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3958),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3958),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(3199),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [962] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3995),
    [sym_constructor_type] = STATE(3995),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3995),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3995),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3995),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(3201),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [963] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3412),
    [sym_constructor_type] = STATE(3412),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3412),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3412),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3412),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_GT] = ACTIONS(3203),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [964] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3412),
    [sym_constructor_type] = STATE(3412),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3412),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3412),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3412),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_GT] = ACTIONS(3205),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [965] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3412),
    [sym_constructor_type] = STATE(3412),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3412),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3412),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3412),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [966] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3899),
    [sym_constructor_type] = STATE(3899),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3899),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3899),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3899),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_RBRACK] = ACTIONS(3209),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [967] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(2838),
    [sym_constructor_type] = STATE(2838),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2838),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2838),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2838),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [968] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2910),
    [sym_constructor_type] = STATE(2910),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2910),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2910),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2910),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [969] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3163),
    [sym_constructor_type] = STATE(3163),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3163),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3139),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3163),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3163),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3215),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [970] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3162),
    [sym_constructor_type] = STATE(3162),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3162),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3139),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3162),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3162),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3215),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [971] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3151),
    [sym_constructor_type] = STATE(3151),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3151),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3139),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3151),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3151),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3215),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [972] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3150),
    [sym_constructor_type] = STATE(3150),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3150),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3139),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3150),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3150),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3215),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [973] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3144),
    [sym_constructor_type] = STATE(3144),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3144),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3139),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3144),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3144),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3215),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [974] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3985),
    [sym_constructor_type] = STATE(3985),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3985),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3985),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3985),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [975] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3064),
    [sym_constructor_type] = STATE(3064),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3064),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3064),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3064),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [976] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3183),
    [sym_constructor_type] = STATE(3183),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3183),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3139),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3183),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3183),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3215),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [977] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3185),
    [sym_constructor_type] = STATE(3185),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3185),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3139),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3185),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3185),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3215),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [978] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(4257),
    [sym_constructor_type] = STATE(4257),
    [sym__primary_type] = STATE(3203),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(4257),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3139),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(4257),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(4257),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3215),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [979] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(4257),
    [sym_constructor_type] = STATE(4257),
    [sym__primary_type] = STATE(3182),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(4257),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3139),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(4257),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(4257),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3215),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [980] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3172),
    [sym_constructor_type] = STATE(3172),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3172),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3139),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3172),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3172),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3215),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [981] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3132),
    [sym_constructor_type] = STATE(3132),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3132),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3139),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3132),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3132),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3215),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [982] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3133),
    [sym_constructor_type] = STATE(3133),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3133),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3139),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3133),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3133),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3215),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [983] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3984),
    [sym_constructor_type] = STATE(3984),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3984),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3984),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3984),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [984] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3063),
    [sym_constructor_type] = STATE(3063),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3063),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3063),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3063),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [985] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1581),
    [sym_constructor_type] = STATE(1581),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(1581),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1581),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1581),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [986] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1583),
    [sym_constructor_type] = STATE(1583),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(1583),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1583),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1583),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [987] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1615),
    [sym_constructor_type] = STATE(1615),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(1615),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1615),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1615),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [988] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1616),
    [sym_constructor_type] = STATE(1616),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(1616),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1616),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1616),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [989] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1662),
    [sym_constructor_type] = STATE(1662),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(1662),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1662),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1662),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [990] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1661),
    [sym_constructor_type] = STATE(1661),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(1661),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1661),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1661),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [991] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1651),
    [sym_constructor_type] = STATE(1651),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(1651),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1651),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1651),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [992] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3593),
    [sym_constructor_type] = STATE(3593),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3593),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3593),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3593),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [993] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3974),
    [sym_constructor_type] = STATE(3974),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3974),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3974),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3974),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [994] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3432),
    [sym_constructor_type] = STATE(3432),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3432),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3432),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3432),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [995] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3938),
    [sym_constructor_type] = STATE(3938),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3938),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3938),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3938),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [996] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3496),
    [sym_constructor_type] = STATE(3496),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3496),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3496),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3496),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [997] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3519),
    [sym_constructor_type] = STATE(3519),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3519),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3519),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3519),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [998] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3418),
    [sym_constructor_type] = STATE(3418),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3418),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3418),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3418),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [999] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1642),
    [sym_constructor_type] = STATE(1642),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(1642),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1642),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1642),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [1000] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1641),
    [sym_constructor_type] = STATE(1641),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(1641),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1641),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1641),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [1001] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3178),
    [sym_constructor_type] = STATE(3178),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3178),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3139),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3178),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3178),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3215),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [1002] = {
    [sym_nested_identifier] = STATE(1560),
    [sym_string] = STATE(1559),
    [sym__module] = STATE(1743),
    [sym_identifier] = ACTIONS(3221),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_EQ] = ACTIONS(1778),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_COMMA] = ACTIONS(1467),
    [anon_sym_RBRACE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_RPAREN] = ACTIONS(1467),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_COLON] = ACTIONS(1467),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(1467),
    [anon_sym_LT] = ACTIONS(26),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_QMARK] = ACTIONS(2203),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [1003] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3085),
    [sym_constructor_type] = STATE(3085),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3085),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3085),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3085),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1004] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3671),
    [sym_constructor_type] = STATE(3671),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3671),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3671),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3671),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1005] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3622),
    [sym_constructor_type] = STATE(3622),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3622),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3622),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3622),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1006] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3964),
    [sym_constructor_type] = STATE(3964),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3964),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3964),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3964),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1007] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3079),
    [sym_constructor_type] = STATE(3079),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3079),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3079),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3079),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1008] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3047),
    [sym_constructor_type] = STATE(3047),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3047),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3047),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3047),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1009] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3237),
    [sym_constructor_type] = STATE(3237),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3237),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3237),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3237),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1010] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3233),
    [sym_constructor_type] = STATE(3233),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3233),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3233),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3233),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1011] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3864),
    [sym_constructor_type] = STATE(3864),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3864),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3864),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3864),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1012] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3861),
    [sym_constructor_type] = STATE(3861),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3861),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3861),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3861),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1013] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(4128),
    [sym_constructor_type] = STATE(4128),
    [sym__primary_type] = STATE(3640),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3944),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(4128),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(4128),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1014] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3986),
    [sym_constructor_type] = STATE(3986),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3986),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3986),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3986),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1015] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2844),
    [sym_constructor_type] = STATE(2844),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2844),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2844),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2844),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1016] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3922),
    [sym_constructor_type] = STATE(3922),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3922),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3922),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3922),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1017] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3837),
    [sym_constructor_type] = STATE(3837),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3837),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3837),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3837),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1018] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(4116),
    [sym_constructor_type] = STATE(4116),
    [sym__primary_type] = STATE(1600),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(4116),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(4116),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(4116),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [1019] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3422),
    [sym_constructor_type] = STATE(3422),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3422),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3422),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3422),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1020] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(4116),
    [sym_constructor_type] = STATE(4116),
    [sym__primary_type] = STATE(1595),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(4116),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(4116),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(4116),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [1021] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3389),
    [sym_constructor_type] = STATE(3389),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3389),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3389),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3389),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1022] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3092),
    [sym_constructor_type] = STATE(3092),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3092),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3092),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3092),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1023] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1594),
    [sym_constructor_type] = STATE(1594),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(1594),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1594),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1594),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [1024] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3989),
    [sym_constructor_type] = STATE(3989),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3989),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3989),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3989),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1025] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1590),
    [sym_constructor_type] = STATE(1590),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(1590),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1590),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1590),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [1026] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1589),
    [sym_constructor_type] = STATE(1589),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1519),
    [sym_infer_type] = STATE(1589),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1589),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1589),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [1027] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3087),
    [sym_constructor_type] = STATE(3087),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3087),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3087),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3087),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1028] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2904),
    [sym_constructor_type] = STATE(2904),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2904),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2904),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2904),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1029] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3043),
    [sym_constructor_type] = STATE(3043),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3043),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3043),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3043),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1030] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2905),
    [sym_constructor_type] = STATE(2905),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2905),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2905),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2905),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1031] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3583),
    [sym_constructor_type] = STATE(3583),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3583),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3583),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3583),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1032] = {
    [sym_nested_identifier] = STATE(1560),
    [sym_string] = STATE(1559),
    [sym__module] = STATE(1743),
    [sym_identifier] = ACTIONS(3221),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_EQ] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_COMMA] = ACTIONS(32),
    [anon_sym_RBRACE] = ACTIONS(32),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_RPAREN] = ACTIONS(32),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_COLON] = ACTIONS(32),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(32),
    [anon_sym_LT] = ACTIONS(26),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_EQ_GT] = ACTIONS(62),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_QMARK] = ACTIONS(736),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [1033] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(2854),
    [sym_constructor_type] = STATE(2854),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2854),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2854),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2854),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [1034] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2850),
    [sym_constructor_type] = STATE(2850),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2850),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2850),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2850),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1035] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(2076),
    [sym_constructor_type] = STATE(2076),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(2076),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(2076),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(2076),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1036] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(3510),
    [sym_constructor_type] = STATE(3510),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3510),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3510),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3510),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [1037] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3088),
    [sym_constructor_type] = STATE(3088),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3088),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3088),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3088),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1038] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3884),
    [sym_constructor_type] = STATE(3884),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3884),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3884),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3884),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1039] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3871),
    [sym_constructor_type] = STATE(3871),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3871),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3871),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3871),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1040] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3205),
    [sym_constructor_type] = STATE(3205),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3205),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3205),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3205),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1041] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(2074),
    [sym_constructor_type] = STATE(2074),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(2074),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(2074),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(2074),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1042] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(2065),
    [sym_constructor_type] = STATE(2065),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2056),
    [sym_infer_type] = STATE(2065),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(2065),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(2065),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1043] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3580),
    [sym_constructor_type] = STATE(3580),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3580),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3580),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3580),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1044] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2868),
    [sym_constructor_type] = STATE(2868),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2868),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2868),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2868),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1045] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3972),
    [sym_constructor_type] = STATE(3972),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3972),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3972),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3972),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1046] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2838),
    [sym_constructor_type] = STATE(2838),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2838),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2838),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2838),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1047] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3469),
    [sym_constructor_type] = STATE(3469),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3469),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3469),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3469),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1048] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(4175),
    [sym_constructor_type] = STATE(4175),
    [sym__primary_type] = STATE(3070),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(4175),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(4175),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(4175),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1049] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(4175),
    [sym_constructor_type] = STATE(4175),
    [sym__primary_type] = STATE(3048),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(4175),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(4175),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(4175),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1050] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3633),
    [sym_constructor_type] = STATE(3633),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3633),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3633),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3633),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1051] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3101),
    [sym_constructor_type] = STATE(3101),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3101),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3101),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3101),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1052] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3711),
    [sym_constructor_type] = STATE(3711),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3711),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3711),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3711),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1053] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3051),
    [sym_constructor_type] = STATE(3051),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3051),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3051),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3051),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1054] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3951),
    [sym_constructor_type] = STATE(3951),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3951),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3951),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3951),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1055] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(4128),
    [sym_constructor_type] = STATE(4128),
    [sym__primary_type] = STATE(2857),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(4128),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(4128),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(4128),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1056] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3058),
    [sym_constructor_type] = STATE(3058),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3058),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3058),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3058),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1057] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(2843),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [1058] = {
    [sym_nested_identifier] = STATE(1560),
    [sym_string] = STATE(1559),
    [sym__module] = STATE(1743),
    [sym_identifier] = ACTIONS(3221),
    [anon_sym_STAR] = ACTIONS(26),
    [anon_sym_EQ] = ACTIONS(121),
    [anon_sym_as] = ACTIONS(26),
    [anon_sym_COMMA] = ACTIONS(124),
    [anon_sym_RBRACE] = ACTIONS(124),
    [anon_sym_BANG] = ACTIONS(26),
    [anon_sym_LPAREN] = ACTIONS(64),
    [anon_sym_RPAREN] = ACTIONS(124),
    [anon_sym_in] = ACTIONS(26),
    [anon_sym_COLON] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(64),
    [anon_sym_RBRACK] = ACTIONS(124),
    [anon_sym_LT] = ACTIONS(26),
    [anon_sym_GT] = ACTIONS(26),
    [anon_sym_SLASH] = ACTIONS(26),
    [anon_sym_DOT] = ACTIONS(64),
    [anon_sym_EQ_GT] = ACTIONS(127),
    [anon_sym_QMARK_DOT] = ACTIONS(64),
    [anon_sym_PLUS_EQ] = ACTIONS(68),
    [anon_sym_DASH_EQ] = ACTIONS(68),
    [anon_sym_STAR_EQ] = ACTIONS(68),
    [anon_sym_SLASH_EQ] = ACTIONS(68),
    [anon_sym_PERCENT_EQ] = ACTIONS(68),
    [anon_sym_CARET_EQ] = ACTIONS(68),
    [anon_sym_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(68),
    [anon_sym_LT_LT_EQ] = ACTIONS(68),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(68),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(68),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(68),
    [anon_sym_AMP_AMP] = ACTIONS(26),
    [anon_sym_PIPE_PIPE] = ACTIONS(26),
    [anon_sym_GT_GT] = ACTIONS(26),
    [anon_sym_GT_GT_GT] = ACTIONS(26),
    [anon_sym_LT_LT] = ACTIONS(26),
    [anon_sym_AMP] = ACTIONS(26),
    [anon_sym_CARET] = ACTIONS(26),
    [anon_sym_PIPE] = ACTIONS(26),
    [anon_sym_PLUS] = ACTIONS(26),
    [anon_sym_DASH] = ACTIONS(26),
    [anon_sym_PERCENT] = ACTIONS(26),
    [anon_sym_STAR_STAR] = ACTIONS(26),
    [anon_sym_LT_EQ] = ACTIONS(64),
    [anon_sym_EQ_EQ] = ACTIONS(26),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(64),
    [anon_sym_BANG_EQ] = ACTIONS(26),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(64),
    [anon_sym_GT_EQ] = ACTIONS(64),
    [anon_sym_QMARK_QMARK] = ACTIONS(26),
    [anon_sym_instanceof] = ACTIONS(26),
    [anon_sym_PLUS_PLUS] = ACTIONS(64),
    [anon_sym_DASH_DASH] = ACTIONS(64),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(64),
    [anon_sym_QMARK] = ACTIONS(736),
    [sym__ternary_qmark] = ACTIONS(64),
  },
  [1059] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3927),
    [sym_constructor_type] = STATE(3927),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3927),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3927),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3927),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1060] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3642),
    [sym_constructor_type] = STATE(3642),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3642),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3642),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3642),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1061] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(1932),
    [sym_constructor_type] = STATE(1932),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(1932),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(1932),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(1932),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1062] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(1920),
    [sym_constructor_type] = STATE(1920),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(1920),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(1920),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(1920),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1063] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(3395),
    [sym_constructor_type] = STATE(3395),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3395),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3395),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3395),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [1064] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(3396),
    [sym_constructor_type] = STATE(3396),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3396),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3396),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3396),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [1065] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(4032),
    [sym_constructor_type] = STATE(4032),
    [sym__primary_type] = STATE(2849),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(4032),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(4032),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(4032),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [1066] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(4032),
    [sym_constructor_type] = STATE(4032),
    [sym__primary_type] = STATE(2857),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(4032),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(4032),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(4032),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [1067] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3942),
    [sym_constructor_type] = STATE(3942),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3942),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3942),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3942),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1068] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(1918),
    [sym_constructor_type] = STATE(1918),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(1918),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(1918),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(1918),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1069] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(1919),
    [sym_constructor_type] = STATE(1919),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(1919),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(1919),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(1919),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1070] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(1985),
    [sym_constructor_type] = STATE(1985),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(1985),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(1985),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(1985),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1071] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(1986),
    [sym_constructor_type] = STATE(1986),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(1986),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(1986),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(1986),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1072] = {
    [sym_nested_identifier] = STATE(4758),
    [sym_string] = STATE(1526),
    [sym_formal_parameters] = STATE(4781),
    [sym_nested_type_identifier] = STATE(1456),
    [sym__type] = STATE(1555),
    [sym_constructor_type] = STATE(1555),
    [sym__primary_type] = STATE(1520),
    [sym_template_literal_type] = STATE(1556),
    [sym_infer_type] = STATE(1555),
    [sym_conditional_type] = STATE(1519),
    [sym_generic_type] = STATE(1519),
    [sym_type_query] = STATE(1519),
    [sym_index_type_query] = STATE(1519),
    [sym_lookup_type] = STATE(1519),
    [sym_literal_type] = STATE(1519),
    [sym__number] = STATE(1518),
    [sym_existential_type] = STATE(1519),
    [sym_flow_maybe_type] = STATE(1519),
    [sym_parenthesized_type] = STATE(1519),
    [sym_predefined_type] = STATE(1519),
    [sym_object_type] = STATE(1519),
    [sym_type_parameters] = STATE(4489),
    [sym_array_type] = STATE(1519),
    [sym_tuple_type] = STATE(1519),
    [sym_readonly_type] = STATE(1555),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_function_type] = STATE(1555),
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_typeof] = ACTIONS(3077),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3081),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_PIPE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_void] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_SQUOTE] = ACTIONS(89),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3093),
    [sym_number] = ACTIONS(3095),
    [sym_this] = ACTIONS(3219),
    [sym_true] = ACTIONS(3099),
    [sym_false] = ACTIONS(3099),
    [sym_null] = ACTIONS(3099),
    [sym_undefined] = ACTIONS(3099),
    [anon_sym_readonly] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_any] = ACTIONS(3091),
    [anon_sym_number] = ACTIONS(3091),
    [anon_sym_boolean] = ACTIONS(3091),
    [anon_sym_string] = ACTIONS(3091),
    [anon_sym_symbol] = ACTIONS(3091),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_infer] = ACTIONS(3107),
    [anon_sym_keyof] = ACTIONS(3109),
    [anon_sym_unknown] = ACTIONS(3091),
    [anon_sym_never] = ACTIONS(3091),
    [anon_sym_object] = ACTIONS(3091),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3111),
  },
  [1073] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3941),
    [sym_constructor_type] = STATE(3941),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3941),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3941),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3941),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1074] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(1990),
    [sym_constructor_type] = STATE(1990),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(1990),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(1990),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(1990),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1075] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2920),
    [sym_constructor_type] = STATE(2920),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2920),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2920),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2920),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1076] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3412),
    [sym_constructor_type] = STATE(3412),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3412),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3412),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3412),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1077] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(1929),
    [sym_constructor_type] = STATE(1929),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(1929),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(1929),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(1929),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1078] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(4098),
    [sym_constructor_type] = STATE(4098),
    [sym__primary_type] = STATE(1993),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(4098),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(4098),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(4098),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1079] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(4098),
    [sym_constructor_type] = STATE(4098),
    [sym__primary_type] = STATE(2002),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(4098),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(4098),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(4098),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1080] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2854),
    [sym_constructor_type] = STATE(2854),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2854),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2854),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2854),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1081] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3936),
    [sym_constructor_type] = STATE(3936),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3936),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3936),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3936),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1082] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(3658),
    [sym_constructor_type] = STATE(3658),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3658),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3658),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3658),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [1083] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3925),
    [sym_constructor_type] = STATE(3925),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3925),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3925),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3925),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1084] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3076),
    [sym_constructor_type] = STATE(3076),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3076),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3076),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3076),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1085] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(4128),
    [sym_constructor_type] = STATE(4128),
    [sym__primary_type] = STATE(2849),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(4128),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(4128),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(4128),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1086] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2919),
    [sym_constructor_type] = STATE(2919),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2919),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2919),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2919),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1087] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2883),
    [sym_constructor_type] = STATE(2883),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2883),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2883),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2883),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1088] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(2843),
    [sym_constructor_type] = STATE(2843),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2843),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2843),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2843),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1089] = {
    [sym_nested_identifier] = STATE(4634),
    [sym_string] = STATE(3066),
    [sym_formal_parameters] = STATE(4683),
    [sym_nested_type_identifier] = STATE(2974),
    [sym__type] = STATE(3596),
    [sym_constructor_type] = STATE(3596),
    [sym__primary_type] = STATE(3084),
    [sym_template_literal_type] = STATE(3086),
    [sym_infer_type] = STATE(3596),
    [sym_conditional_type] = STATE(3086),
    [sym_generic_type] = STATE(3086),
    [sym_type_query] = STATE(3086),
    [sym_index_type_query] = STATE(3086),
    [sym_lookup_type] = STATE(3086),
    [sym_literal_type] = STATE(3086),
    [sym__number] = STATE(3089),
    [sym_existential_type] = STATE(3086),
    [sym_flow_maybe_type] = STATE(3086),
    [sym_parenthesized_type] = STATE(3086),
    [sym_predefined_type] = STATE(3086),
    [sym_object_type] = STATE(3086),
    [sym_type_parameters] = STATE(4469),
    [sym_array_type] = STATE(3086),
    [sym_tuple_type] = STATE(3086),
    [sym_readonly_type] = STATE(3596),
    [sym_union_type] = STATE(3086),
    [sym_intersection_type] = STATE(3086),
    [sym_function_type] = STATE(3596),
    [sym_identifier] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(794),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_typeof] = ACTIONS(1659),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_void] = ACTIONS(836),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_number] = ACTIONS(1679),
    [sym_this] = ACTIONS(1681),
    [sym_true] = ACTIONS(1683),
    [sym_false] = ACTIONS(1683),
    [sym_null] = ACTIONS(1683),
    [sym_undefined] = ACTIONS(1683),
    [anon_sym_readonly] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(826),
    [anon_sym_any] = ACTIONS(836),
    [anon_sym_number] = ACTIONS(836),
    [anon_sym_boolean] = ACTIONS(836),
    [anon_sym_string] = ACTIONS(836),
    [anon_sym_symbol] = ACTIONS(836),
    [anon_sym_abstract] = ACTIONS(830),
    [anon_sym_infer] = ACTIONS(832),
    [anon_sym_keyof] = ACTIONS(834),
    [anon_sym_unknown] = ACTIONS(836),
    [anon_sym_never] = ACTIONS(836),
    [anon_sym_object] = ACTIONS(836),
    [anon_sym_LBRACE_PIPE] = ACTIONS(838),
  },
  [1090] = {
    [sym_nested_identifier] = STATE(4870),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4768),
    [sym_nested_type_identifier] = STATE(2837),
    [sym__type] = STATE(3369),
    [sym_constructor_type] = STATE(3369),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3369),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4478),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3369),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3369),
    [sym_identifier] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(1414),
    [anon_sym_AMP] = ACTIONS(670),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_SQUOTE] = ACTIONS(1420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(1430),
    [anon_sym_QMARK] = ACTIONS(688),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(111),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(115),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(119),
  },
  [1091] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(2850),
    [sym_constructor_type] = STATE(2850),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2850),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2850),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2850),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [1092] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(3371),
    [sym_constructor_type] = STATE(3371),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3371),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3371),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3371),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [1093] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(3493),
    [sym_constructor_type] = STATE(3493),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3493),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3493),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3493),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [1094] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(2844),
    [sym_constructor_type] = STATE(2844),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2844),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2844),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2844),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [1095] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(2090),
    [sym_constructor_type] = STATE(2090),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(2090),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(2090),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(2090),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1096] = {
    [sym_nested_identifier] = STATE(4665),
    [sym_string] = STATE(2058),
    [sym_formal_parameters] = STATE(4708),
    [sym_nested_type_identifier] = STATE(1855),
    [sym__type] = STATE(2083),
    [sym_constructor_type] = STATE(2083),
    [sym__primary_type] = STATE(2035),
    [sym_template_literal_type] = STATE(2022),
    [sym_infer_type] = STATE(2083),
    [sym_conditional_type] = STATE(2022),
    [sym_generic_type] = STATE(2022),
    [sym_type_query] = STATE(2022),
    [sym_index_type_query] = STATE(2022),
    [sym_lookup_type] = STATE(2022),
    [sym_literal_type] = STATE(2022),
    [sym__number] = STATE(2007),
    [sym_existential_type] = STATE(2022),
    [sym_flow_maybe_type] = STATE(2022),
    [sym_parenthesized_type] = STATE(2022),
    [sym_predefined_type] = STATE(2022),
    [sym_object_type] = STATE(2022),
    [sym_type_parameters] = STATE(4591),
    [sym_array_type] = STATE(2022),
    [sym_tuple_type] = STATE(2022),
    [sym_readonly_type] = STATE(2083),
    [sym_union_type] = STATE(2022),
    [sym_intersection_type] = STATE(2022),
    [sym_function_type] = STATE(2083),
    [sym_identifier] = ACTIONS(3223),
    [anon_sym_STAR] = ACTIONS(3153),
    [anon_sym_LBRACE] = ACTIONS(3155),
    [anon_sym_typeof] = ACTIONS(3157),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_LBRACK] = ACTIONS(3161),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [anon_sym_void] = ACTIONS(3171),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_SQUOTE] = ACTIONS(209),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3173),
    [sym_number] = ACTIONS(3175),
    [sym_this] = ACTIONS(3225),
    [sym_true] = ACTIONS(3179),
    [sym_false] = ACTIONS(3179),
    [sym_null] = ACTIONS(3179),
    [sym_undefined] = ACTIONS(3179),
    [anon_sym_readonly] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_any] = ACTIONS(3171),
    [anon_sym_number] = ACTIONS(3171),
    [anon_sym_boolean] = ACTIONS(3171),
    [anon_sym_string] = ACTIONS(3171),
    [anon_sym_symbol] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3185),
    [anon_sym_infer] = ACTIONS(3187),
    [anon_sym_keyof] = ACTIONS(3189),
    [anon_sym_unknown] = ACTIONS(3171),
    [anon_sym_never] = ACTIONS(3171),
    [anon_sym_object] = ACTIONS(3171),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3191),
  },
  [1097] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(2868),
    [sym_constructor_type] = STATE(2868),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(2868),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(2868),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(2868),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
  [1098] = {
    [sym_nested_identifier] = STATE(4811),
    [sym_string] = STATE(3145),
    [sym_formal_parameters] = STATE(4938),
    [sym_nested_type_identifier] = STATE(3056),
    [sym__type] = STATE(3176),
    [sym_constructor_type] = STATE(3176),
    [sym__primary_type] = STATE(3140),
    [sym_template_literal_type] = STATE(3139),
    [sym_infer_type] = STATE(3176),
    [sym_conditional_type] = STATE(3139),
    [sym_generic_type] = STATE(3139),
    [sym_type_query] = STATE(3139),
    [sym_index_type_query] = STATE(3139),
    [sym_lookup_type] = STATE(3139),
    [sym_literal_type] = STATE(3139),
    [sym__number] = STATE(3138),
    [sym_existential_type] = STATE(3139),
    [sym_flow_maybe_type] = STATE(3139),
    [sym_parenthesized_type] = STATE(3139),
    [sym_predefined_type] = STATE(3139),
    [sym_object_type] = STATE(3139),
    [sym_type_parameters] = STATE(4464),
    [sym_array_type] = STATE(3139),
    [sym_tuple_type] = STATE(3139),
    [sym_readonly_type] = STATE(3176),
    [sym_union_type] = STATE(3139),
    [sym_intersection_type] = STATE(3139),
    [sym_function_type] = STATE(3176),
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_STAR] = ACTIONS(2999),
    [anon_sym_LBRACE] = ACTIONS(3001),
    [anon_sym_typeof] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_AMP] = ACTIONS(3011),
    [anon_sym_PIPE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3015),
    [anon_sym_void] = ACTIONS(3017),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3023),
    [sym_number] = ACTIONS(3025),
    [sym_this] = ACTIONS(3215),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_null] = ACTIONS(3029),
    [sym_undefined] = ACTIONS(3029),
    [anon_sym_readonly] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_any] = ACTIONS(3017),
    [anon_sym_number] = ACTIONS(3017),
    [anon_sym_boolean] = ACTIONS(3017),
    [anon_sym_string] = ACTIONS(3017),
    [anon_sym_symbol] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3035),
    [anon_sym_infer] = ACTIONS(3039),
    [anon_sym_keyof] = ACTIONS(3041),
    [anon_sym_unknown] = ACTIONS(3017),
    [anon_sym_never] = ACTIONS(3017),
    [anon_sym_object] = ACTIONS(3017),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3043),
  },
  [1099] = {
    [sym_nested_identifier] = STATE(4789),
    [sym_string] = STATE(2869),
    [sym_formal_parameters] = STATE(4787),
    [sym_nested_type_identifier] = STATE(3236),
    [sym__type] = STATE(3506),
    [sym_constructor_type] = STATE(3506),
    [sym__primary_type] = STATE(2839),
    [sym_template_literal_type] = STATE(2840),
    [sym_infer_type] = STATE(3506),
    [sym_conditional_type] = STATE(2840),
    [sym_generic_type] = STATE(2840),
    [sym_type_query] = STATE(2840),
    [sym_index_type_query] = STATE(2840),
    [sym_lookup_type] = STATE(2840),
    [sym_literal_type] = STATE(2840),
    [sym__number] = STATE(2880),
    [sym_existential_type] = STATE(2840),
    [sym_flow_maybe_type] = STATE(2840),
    [sym_parenthesized_type] = STATE(2840),
    [sym_predefined_type] = STATE(2840),
    [sym_object_type] = STATE(2840),
    [sym_type_parameters] = STATE(4409),
    [sym_array_type] = STATE(2840),
    [sym_tuple_type] = STATE(2840),
    [sym_readonly_type] = STATE(3506),
    [sym_union_type] = STATE(2840),
    [sym_intersection_type] = STATE(2840),
    [sym_function_type] = STATE(3506),
    [sym_identifier] = ACTIONS(3211),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_typeof] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_LBRACK] = ACTIONS(1410),
    [anon_sym_LT] = ACTIONS(2744),
    [anon_sym_new] = ACTIONS(3121),
    [anon_sym_AMP] = ACTIONS(3123),
    [anon_sym_PIPE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(2748),
    [anon_sym_DASH] = ACTIONS(2748),
    [anon_sym_void] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_number] = ACTIONS(1424),
    [sym_this] = ACTIONS(1426),
    [sym_true] = ACTIONS(1428),
    [sym_false] = ACTIONS(1428),
    [sym_null] = ACTIONS(1428),
    [sym_undefined] = ACTIONS(1428),
    [anon_sym_readonly] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_any] = ACTIONS(117),
    [anon_sym_number] = ACTIONS(117),
    [anon_sym_boolean] = ACTIONS(117),
    [anon_sym_string] = ACTIONS(117),
    [anon_sym_symbol] = ACTIONS(117),
    [anon_sym_abstract] = ACTIONS(3137),
    [anon_sym_infer] = ACTIONS(113),
    [anon_sym_keyof] = ACTIONS(3139),
    [anon_sym_unknown] = ACTIONS(117),
    [anon_sym_never] = ACTIONS(117),
    [anon_sym_object] = ACTIONS(117),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3141),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1402), 1,
      anon_sym_EQ,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 17,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [89] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(207), 1,
      anon_sym_DQUOTE,
    ACTIONS(209), 1,
      anon_sym_SQUOTE,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2213), 1,
      anon_sym_LBRACE,
    ACTIONS(2215), 1,
      anon_sym_DOT,
    ACTIONS(3227), 1,
      sym_identifier,
    STATE(1446), 1,
      sym_nested_identifier,
    STATE(1459), 1,
      sym_string,
    STATE(1713), 1,
      sym__module,
    STATE(4549), 1,
      sym_ui_object_initializer,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [184] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(207), 1,
      anon_sym_DQUOTE,
    ACTIONS(209), 1,
      anon_sym_SQUOTE,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2215), 1,
      anon_sym_DOT,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(3227), 1,
      sym_identifier,
    STATE(1446), 1,
      sym_nested_identifier,
    STATE(1459), 1,
      sym_string,
    STATE(1713), 1,
      sym__module,
    STATE(2484), 1,
      sym_ui_object_initializer,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [279] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 17,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [368] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2145), 1,
      anon_sym_COLON,
    ACTIONS(3229), 1,
      sym_identifier,
    ACTIONS(3231), 1,
      anon_sym_DQUOTE,
    ACTIONS(3233), 1,
      anon_sym_SQUOTE,
    STATE(865), 1,
      sym_nested_identifier,
    STATE(866), 1,
      sym_string,
    STATE(904), 1,
      sym__module,
    ACTIONS(64), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [458] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1454), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [546] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2169), 1,
      anon_sym_COLON,
    ACTIONS(3235), 1,
      sym_identifier,
    STATE(774), 1,
      sym__module,
    STATE(3845), 1,
      sym_nested_identifier,
    STATE(3898), 1,
      sym_string,
    ACTIONS(64), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3241), 1,
      anon_sym_LPAREN,
    ACTIONS(3243), 1,
      anon_sym_DOT,
    STATE(1129), 1,
      sym_arguments,
    ACTIONS(3239), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3237), 46,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_from,
      anon_sym_await,
      anon_sym_of,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [712] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(207), 1,
      anon_sym_DQUOTE,
    ACTIONS(209), 1,
      anon_sym_SQUOTE,
    ACTIONS(1452), 1,
      anon_sym_EQ,
    ACTIONS(1454), 1,
      anon_sym_EQ_GT,
    ACTIONS(3227), 1,
      sym_identifier,
    STATE(1446), 1,
      sym_nested_identifier,
    STATE(1459), 1,
      sym_string,
    STATE(1713), 1,
      sym__module,
    ACTIONS(64), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [800] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(207), 1,
      anon_sym_DQUOTE,
    ACTIONS(209), 1,
      anon_sym_SQUOTE,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2169), 1,
      anon_sym_COLON,
    ACTIONS(3227), 1,
      sym_identifier,
    STATE(1446), 1,
      sym_nested_identifier,
    STATE(1459), 1,
      sym_string,
    STATE(1713), 1,
      sym__module,
    ACTIONS(64), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [890] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_AT,
    STATE(1110), 1,
      aux_sym_export_statement_repeat1,
    STATE(1128), 1,
      sym_decorator,
    ACTIONS(3247), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(3245), 46,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_from,
      anon_sym_await,
      anon_sym_of,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [966] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(207), 1,
      anon_sym_DQUOTE,
    ACTIONS(209), 1,
      anon_sym_SQUOTE,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(3227), 1,
      sym_identifier,
    STATE(1446), 1,
      sym_nested_identifier,
    STATE(1459), 1,
      sym_string,
    STATE(1713), 1,
      sym__module,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1054] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(207), 1,
      anon_sym_DQUOTE,
    ACTIONS(209), 1,
      anon_sym_SQUOTE,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2267), 1,
      anon_sym_in,
    ACTIONS(3227), 1,
      sym_identifier,
    ACTIONS(3252), 1,
      anon_sym_of,
    STATE(1446), 1,
      sym_nested_identifier,
    STATE(1459), 1,
      sym_string,
    STATE(1713), 1,
      sym__module,
    ACTIONS(64), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1146] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2145), 1,
      anon_sym_COLON,
    ACTIONS(3254), 1,
      sym_identifier,
    STATE(2446), 1,
      sym_nested_identifier,
    STATE(2486), 1,
      sym_string,
    STATE(2586), 1,
      sym__module,
    ACTIONS(64), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1236] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2179), 1,
      anon_sym_COLON,
    ACTIONS(2991), 1,
      sym_identifier,
    ACTIONS(2993), 1,
      anon_sym_DQUOTE,
    ACTIONS(2995), 1,
      anon_sym_SQUOTE,
    STATE(674), 1,
      sym_nested_identifier,
    STATE(681), 1,
      sym_string,
    STATE(774), 1,
      sym__module,
    ACTIONS(64), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1326] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1402), 1,
      anon_sym_EQ,
    ACTIONS(1467), 1,
      anon_sym_COLON,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(1464), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(64), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1418] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_EQ,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(2215), 1,
      anon_sym_DOT,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    STATE(2484), 1,
      sym_ui_object_initializer,
    ACTIONS(124), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(64), 11,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1514] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2179), 1,
      anon_sym_COLON,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_DQUOTE,
    ACTIONS(3049), 1,
      anon_sym_SQUOTE,
    STATE(149), 1,
      sym_string,
    STATE(151), 1,
      sym_nested_identifier,
    STATE(178), 1,
      sym__module,
    ACTIONS(64), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1604] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1692] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3249), 1,
      anon_sym_AT,
    ACTIONS(3256), 1,
      anon_sym_class,
    STATE(1110), 1,
      aux_sym_export_statement_repeat1,
    STATE(1128), 1,
      sym_decorator,
    ACTIONS(3247), 13,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
    ACTIONS(3245), 45,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_from,
      anon_sym_await,
      anon_sym_of,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [1770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3259), 47,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_from,
      anon_sym_await,
      anon_sym_of,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [1839] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2013), 1,
      anon_sym_EQ,
    ACTIONS(2021), 1,
      anon_sym_COLON,
    ACTIONS(2037), 1,
      anon_sym_QMARK,
    ACTIONS(2043), 1,
      anon_sym_RBRACE,
    ACTIONS(2067), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LT,
    ACTIONS(3263), 1,
      sym_identifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3239), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3237), 47,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_from,
      anon_sym_await,
      anon_sym_of,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [1999] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2013), 1,
      anon_sym_EQ,
    ACTIONS(2021), 1,
      anon_sym_COLON,
    ACTIONS(2037), 1,
      anon_sym_QMARK,
    ACTIONS(2041), 1,
      anon_sym_RBRACE,
    ACTIONS(2067), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LT,
    ACTIONS(3263), 1,
      sym_identifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3267), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3265), 47,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_from,
      anon_sym_await,
      anon_sym_of,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [2159] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2013), 1,
      anon_sym_EQ,
    ACTIONS(2015), 1,
      anon_sym_RBRACE,
    ACTIONS(2021), 1,
      anon_sym_COLON,
    ACTIONS(2037), 1,
      anon_sym_QMARK,
    ACTIONS(2067), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LT,
    ACTIONS(3263), 1,
      sym_identifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3271), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3269), 47,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_from,
      anon_sym_await,
      anon_sym_of,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [2319] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(32), 1,
      anon_sym_COMMA,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(124), 1,
      anon_sym_RBRACK,
    ACTIONS(1762), 1,
      anon_sym_EQ_GT,
    ACTIONS(2284), 1,
      anon_sym_EQ,
    ACTIONS(2287), 1,
      anon_sym_COLON,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3275), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3273), 47,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_from,
      anon_sym_await,
      anon_sym_of,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [2481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3279), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3277), 47,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_from,
      anon_sym_await,
      anon_sym_of,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [2550] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2013), 1,
      anon_sym_EQ,
    ACTIONS(2021), 1,
      anon_sym_COLON,
    ACTIONS(2037), 1,
      anon_sym_QMARK,
    ACTIONS(2039), 1,
      anon_sym_RBRACE,
    ACTIONS(2067), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LT,
    ACTIONS(3263), 1,
      sym_identifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2641] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1743), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 14,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [2728] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1741), 1,
      anon_sym_EQ,
    ACTIONS(1743), 1,
      anon_sym_EQ_GT,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 14,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [2815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3283), 14,
      anon_sym_LBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LTtemplate_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(3281), 47,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_typeof,
      anon_sym_import,
      anon_sym_from,
      anon_sym_await,
      anon_sym_of,
      anon_sym_yield,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [2884] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(1727), 1,
      anon_sym_EQ,
    ACTIONS(1729), 1,
      anon_sym_EQ_GT,
    ACTIONS(3254), 1,
      sym_identifier,
    STATE(2446), 1,
      sym_nested_identifier,
    STATE(2486), 1,
      sym_string,
    STATE(2586), 1,
      sym__module,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [2970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3285), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(3287), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(3291), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3106] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1760), 1,
      anon_sym_EQ,
    ACTIONS(1762), 1,
      anon_sym_EQ_GT,
    ACTIONS(2287), 1,
      anon_sym_COLON,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [3194] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 1,
      anon_sym_COLON,
    ACTIONS(2037), 1,
      anon_sym_QMARK,
    ACTIONS(2043), 1,
      anon_sym_RBRACE,
    ACTIONS(3295), 1,
      anon_sym_EQ,
    ACTIONS(3299), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_LT,
    ACTIONS(3305), 1,
      anon_sym_EQ_GT,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3282] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2013), 1,
      anon_sym_EQ,
    ACTIONS(2021), 1,
      anon_sym_COLON,
    ACTIONS(2037), 1,
      anon_sym_QMARK,
    ACTIONS(2043), 1,
      anon_sym_RBRACE,
    ACTIONS(2067), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LT,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3309), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(3311), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3438] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1729), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [3524] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(1727), 1,
      anon_sym_EQ,
    ACTIONS(1729), 1,
      anon_sym_EQ_GT,
    ACTIONS(3235), 1,
      sym_identifier,
    STATE(774), 1,
      sym__module,
    STATE(3845), 1,
      sym_nested_identifier,
    STATE(3898), 1,
      sym_string,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [3610] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2013), 1,
      anon_sym_EQ,
    ACTIONS(2015), 1,
      anon_sym_RBRACE,
    ACTIONS(2021), 1,
      anon_sym_COLON,
    ACTIONS(2037), 1,
      anon_sym_QMARK,
    ACTIONS(2067), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LT,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3698] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2013), 1,
      anon_sym_EQ,
    ACTIONS(2021), 1,
      anon_sym_COLON,
    ACTIONS(2037), 1,
      anon_sym_QMARK,
    ACTIONS(2039), 1,
      anon_sym_RBRACE,
    ACTIONS(2067), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LT,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [3786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3313), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(3315), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(3319), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [3922] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(1727), 1,
      anon_sym_EQ,
    ACTIONS(1729), 1,
      anon_sym_EQ_GT,
    ACTIONS(3321), 1,
      sym_identifier,
    STATE(3224), 1,
      sym_nested_identifier,
    STATE(3248), 1,
      sym_string,
    STATE(3715), 1,
      sym__module,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [4008] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 1,
      anon_sym_EQ,
    ACTIONS(1729), 1,
      anon_sym_EQ_GT,
    ACTIONS(3045), 1,
      sym_identifier,
    ACTIONS(3047), 1,
      anon_sym_DQUOTE,
    ACTIONS(3049), 1,
      anon_sym_SQUOTE,
    STATE(149), 1,
      sym_string,
    STATE(151), 1,
      sym_nested_identifier,
    STATE(178), 1,
      sym__module,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [4094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3323), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(3325), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4162] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2013), 1,
      anon_sym_EQ,
    ACTIONS(2021), 1,
      anon_sym_COLON,
    ACTIONS(2037), 1,
      anon_sym_QMARK,
    ACTIONS(2041), 1,
      anon_sym_RBRACE,
    ACTIONS(2067), 1,
      anon_sym_LPAREN,
    ACTIONS(2070), 1,
      anon_sym_LT,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4250] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 1,
      anon_sym_COLON,
    ACTIONS(2037), 1,
      anon_sym_QMARK,
    ACTIONS(2041), 1,
      anon_sym_RBRACE,
    ACTIONS(3295), 1,
      anon_sym_EQ,
    ACTIONS(3299), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_LT,
    ACTIONS(3305), 1,
      anon_sym_EQ_GT,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 23,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_QMARK,
    ACTIONS(3329), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [4406] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2021), 1,
      anon_sym_COLON,
    ACTIONS(2037), 1,
      anon_sym_QMARK,
    ACTIONS(2039), 1,
      anon_sym_RBRACE,
    ACTIONS(3295), 1,
      anon_sym_EQ,
    ACTIONS(3299), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_LT,
    ACTIONS(3305), 1,
      anon_sym_EQ_GT,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4494] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 1,
      anon_sym_EQ,
    ACTIONS(1729), 1,
      anon_sym_EQ_GT,
    ACTIONS(2991), 1,
      sym_identifier,
    ACTIONS(2993), 1,
      anon_sym_DQUOTE,
    ACTIONS(2995), 1,
      anon_sym_SQUOTE,
    STATE(674), 1,
      sym_nested_identifier,
    STATE(681), 1,
      sym_string,
    STATE(774), 1,
      sym__module,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [4580] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2015), 1,
      anon_sym_RBRACE,
    ACTIONS(2021), 1,
      anon_sym_COLON,
    ACTIONS(2037), 1,
      anon_sym_QMARK,
    ACTIONS(3295), 1,
      anon_sym_EQ,
    ACTIONS(3299), 1,
      anon_sym_LPAREN,
    ACTIONS(3302), 1,
      anon_sym_LT,
    ACTIONS(3305), 1,
      anon_sym_EQ_GT,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [4668] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 1,
      anon_sym_EQ,
    ACTIONS(1729), 1,
      anon_sym_EQ_GT,
    ACTIONS(3229), 1,
      sym_identifier,
    ACTIONS(3231), 1,
      anon_sym_DQUOTE,
    ACTIONS(3233), 1,
      anon_sym_SQUOTE,
    STATE(865), 1,
      sym_nested_identifier,
    STATE(866), 1,
      sym_string,
    STATE(904), 1,
      sym__module,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [4754] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(32), 1,
      anon_sym_COMMA,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(124), 1,
      anon_sym_RBRACK,
    ACTIONS(1762), 1,
      anon_sym_EQ_GT,
    ACTIONS(2284), 1,
      anon_sym_EQ,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [4844] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(207), 1,
      anon_sym_DQUOTE,
    ACTIONS(209), 1,
      anon_sym_SQUOTE,
    ACTIONS(1727), 1,
      anon_sym_EQ,
    ACTIONS(1729), 1,
      anon_sym_EQ_GT,
    ACTIONS(3227), 1,
      sym_identifier,
    STATE(1446), 1,
      sym_nested_identifier,
    STATE(1459), 1,
      sym_string,
    STATE(1713), 1,
      sym__module,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [4930] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1760), 1,
      anon_sym_EQ,
    ACTIONS(1762), 1,
      anon_sym_EQ_GT,
    ACTIONS(2295), 1,
      anon_sym_COLON,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [5018] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1764), 1,
      anon_sym_EQ,
    ACTIONS(1766), 1,
      anon_sym_EQ_GT,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [5103] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1758), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [5188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2718), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2720), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [5255] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(2798), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2822), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3377), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [5378] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(2850), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2864), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3447), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [5501] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3353), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3355), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3450), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [5624] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_EQ,
    ACTIONS(3364), 1,
      anon_sym_COLON,
    ACTIONS(3366), 1,
      anon_sym_LBRACK,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3380), 1,
      anon_sym_QMARK,
    ACTIONS(3383), 1,
      anon_sym_extends,
    STATE(2847), 1,
      sym_type_arguments,
    STATE(4517), 1,
      sym_type_annotation,
    ACTIONS(3360), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3377), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5717] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_DOT,
    ACTIONS(3395), 1,
      anon_sym_QMARK_DOT,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3387), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3391), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5802] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3397), 1,
      anon_sym_LPAREN,
    ACTIONS(3399), 1,
      anon_sym_DOT,
    ACTIONS(3401), 1,
      anon_sym_QMARK_DOT,
    STATE(2971), 1,
      sym_arguments,
    ACTIONS(3391), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3387), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3297), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5887] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3383), 1,
      anon_sym_extends,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3366), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3377), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5972] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3403), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3405), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3530), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [6095] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3407), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3409), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3503), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [6218] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3411), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3413), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3446), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [6341] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_EQ,
    ACTIONS(3366), 1,
      anon_sym_LBRACK,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3415), 1,
      anon_sym_LT,
    ACTIONS(3418), 1,
      anon_sym_DOT,
    STATE(3052), 1,
      sym_type_arguments,
    ACTIONS(3360), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3377), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3383), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3297), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2732), 37,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [6495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [6566] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1760), 1,
      anon_sym_EQ,
    ACTIONS(1762), 1,
      anon_sym_EQ_GT,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [6651] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(62), 1,
      anon_sym_EQ_GT,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(2267), 1,
      anon_sym_in,
    ACTIONS(3221), 1,
      sym_identifier,
    ACTIONS(3252), 1,
      anon_sym_of,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 22,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [6740] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1766), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [6825] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1756), 1,
      anon_sym_EQ,
    ACTIONS(1758), 1,
      anon_sym_EQ_GT,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 24,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [6910] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1762), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 13,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [6995] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3423), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3425), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3401), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [7118] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_DOT,
    ACTIONS(3395), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3429), 1,
      anon_sym_EQ_GT,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3387), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3391), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7202] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_EQ,
    ACTIONS(3360), 1,
      anon_sym_RPAREN,
    ACTIONS(3366), 1,
      anon_sym_LBRACK,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3383), 1,
      anon_sym_extends,
    ACTIONS(3434), 1,
      anon_sym_QMARK,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3377), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3431), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3297), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7292] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3305), 1,
      anon_sym_EQ_GT,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3383), 1,
      anon_sym_extends,
    ACTIONS(3436), 1,
      anon_sym_EQ,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3366), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3377), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7376] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_EQ,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3434), 1,
      anon_sym_QMARK,
    ACTIONS(3431), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7452] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 1,
      anon_sym_LBRACK,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3383), 1,
      anon_sym_extends,
    ACTIONS(3434), 1,
      anon_sym_QMARK,
    ACTIONS(3438), 1,
      anon_sym_EQ,
    ACTIONS(3443), 1,
      anon_sym_RPAREN,
    ACTIONS(3446), 1,
      anon_sym_EQ_GT,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3377), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3441), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3297), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7542] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_EQ,
    ACTIONS(62), 1,
      anon_sym_EQ_GT,
    ACTIONS(736), 1,
      anon_sym_QMARK,
    ACTIONS(32), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(64), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7618] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1402), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_extends,
    ACTIONS(3448), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3451), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7696] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(62), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(2203), 1,
      anon_sym_QMARK,
    ACTIONS(1467), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(64), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7772] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3434), 1,
      anon_sym_QMARK,
    ACTIONS(3438), 1,
      anon_sym_EQ,
    ACTIONS(3446), 1,
      anon_sym_EQ_GT,
    ACTIONS(3441), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7848] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3383), 1,
      anon_sym_extends,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3429), 1,
      anon_sym_EQ_GT,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3366), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3377), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7932] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3305), 1,
      anon_sym_EQ_GT,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_DOT,
    ACTIONS(3395), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3436), 1,
      anon_sym_EQ,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3387), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3391), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8016] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3446), 1,
      anon_sym_EQ_GT,
    ACTIONS(3456), 1,
      anon_sym_QMARK,
    ACTIONS(3454), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8092] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_DOT,
    ACTIONS(3395), 1,
      anon_sym_QMARK_DOT,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3391), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3387), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3297), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8176] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      anon_sym_EQ,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(3448), 1,
      anon_sym_LBRACK,
    ACTIONS(3451), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1460), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(64), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8254] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      anon_sym_EQ,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(736), 1,
      anon_sym_QMARK,
    ACTIONS(124), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(64), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8330] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(62), 1,
      anon_sym_EQ_GT,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      anon_sym_SQUOTE,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(3221), 1,
      sym_identifier,
    STATE(1559), 1,
      sym_string,
    STATE(1560), 1,
      sym_nested_identifier,
    STATE(1743), 1,
      sym__module,
    ACTIONS(64), 12,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [8414] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3458), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [8533] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3460), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [8652] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3462), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [8771] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_EQ,
    ACTIONS(62), 1,
      anon_sym_EQ_GT,
    ACTIONS(736), 1,
      anon_sym_QMARK,
    ACTIONS(3448), 1,
      anon_sym_LBRACK,
    ACTIONS(32), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1460), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3451), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(64), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8852] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2169), 1,
      anon_sym_COLON,
    ACTIONS(3263), 1,
      sym_identifier,
    ACTIONS(64), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [8927] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_DOT,
    ACTIONS(3395), 1,
      anon_sym_QMARK_DOT,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3391), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(3387), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3297), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9010] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 1,
      anon_sym_LBRACK,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3446), 1,
      anon_sym_EQ_GT,
    ACTIONS(3454), 1,
      anon_sym_COLON,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3377), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3383), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3297), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9095] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3464), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [9214] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3466), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [9333] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3456), 1,
      anon_sym_QMARK,
    ACTIONS(3454), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9406] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2179), 1,
      anon_sym_COLON,
    ACTIONS(3263), 1,
      sym_identifier,
    ACTIONS(64), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [9481] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(3305), 1,
      anon_sym_EQ_GT,
    ACTIONS(3436), 1,
      anon_sym_EQ,
    ACTIONS(3468), 1,
      anon_sym_DOT,
    STATE(2483), 1,
      sym_ui_object_initializer,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9558] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3471), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [9677] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3473), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [9796] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 1,
      anon_sym_LBRACK,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3383), 1,
      anon_sym_extends,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3454), 1,
      anon_sym_COLON,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3377), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3475), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3297), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [9883] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3479), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [10002] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_DOT,
    ACTIONS(3395), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3481), 1,
      anon_sym_EQ,
    ACTIONS(3483), 1,
      anon_sym_EQ_GT,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3387), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3391), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 12,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10085] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1402), 1,
      anon_sym_EQ,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10156] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_DOT,
    ACTIONS(3395), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3485), 1,
      anon_sym_EQ,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3387), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3391), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10239] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3489), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [10358] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2145), 1,
      anon_sym_COLON,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(64), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [10433] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3493), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [10552] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_EQ,
    ACTIONS(1454), 1,
      anon_sym_EQ_GT,
    ACTIONS(1460), 1,
      anon_sym_extends,
    ACTIONS(3448), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3451), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [10629] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3495), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [10748] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3497), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [10867] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3499), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [10986] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2215), 1,
      anon_sym_DOT,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    STATE(2484), 1,
      sym_ui_object_initializer,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11063] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3501), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [11182] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3503), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [11301] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3505), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [11420] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3507), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [11539] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(1460), 1,
      anon_sym_extends,
    ACTIONS(3448), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3451), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11616] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3509), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [11735] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3511), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [11854] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2213), 1,
      anon_sym_LBRACE,
    ACTIONS(2215), 1,
      anon_sym_DOT,
    STATE(4549), 1,
      sym_ui_object_initializer,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [11931] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_LBRACE,
    ACTIONS(3305), 1,
      anon_sym_EQ_GT,
    ACTIONS(3436), 1,
      anon_sym_EQ,
    ACTIONS(3468), 1,
      anon_sym_DOT,
    STATE(4551), 1,
      sym_ui_object_initializer,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12008] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12079] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3383), 1,
      anon_sym_extends,
    ACTIONS(3485), 1,
      anon_sym_EQ,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3366), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3377), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12162] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3513), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [12281] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12423] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 1,
      anon_sym_LBRACK,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3481), 1,
      anon_sym_EQ,
    ACTIONS(3483), 1,
      anon_sym_EQ_GT,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3383), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3377), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12506] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3434), 1,
      anon_sym_QMARK,
    ACTIONS(3438), 1,
      anon_sym_EQ,
    ACTIONS(3441), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12579] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      anon_sym_EQ,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(736), 1,
      anon_sym_QMARK,
    ACTIONS(3448), 1,
      anon_sym_LBRACK,
    ACTIONS(124), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1460), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(3451), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(64), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12660] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_EQ,
    ACTIONS(3434), 1,
      anon_sym_QMARK,
    ACTIONS(3431), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12733] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3515), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [12852] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      anon_sym_EQ,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(2215), 1,
      anon_sym_DOT,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    STATE(2484), 1,
      sym_ui_object_initializer,
    ACTIONS(124), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(64), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [12930] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 1,
      anon_sym_COLON,
    ACTIONS(3305), 1,
      anon_sym_EQ_GT,
    ACTIONS(3436), 1,
      anon_sym_EQ,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13002] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 1,
      anon_sym_LBRACK,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3517), 1,
      anon_sym_EQ,
    ACTIONS(3519), 1,
      anon_sym_EQ_GT,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3383), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3377), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3289), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3291), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13148] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_DOT,
    ACTIONS(3395), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3517), 1,
      anon_sym_EQ,
    ACTIONS(3519), 1,
      anon_sym_EQ_GT,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3387), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3391), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13230] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2267), 1,
      anon_sym_in,
    ACTIONS(3521), 1,
      anon_sym_of,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13304] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3429), 1,
      anon_sym_EQ_GT,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3323), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3325), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2718), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2720), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13502] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2169), 1,
      anon_sym_COLON,
    ACTIONS(3305), 1,
      anon_sym_EQ_GT,
    ACTIONS(3436), 1,
      anon_sym_EQ,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13574] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2169), 1,
      anon_sym_COLON,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13646] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 1,
      anon_sym_LBRACK,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3523), 1,
      anon_sym_EQ,
    ACTIONS(3525), 1,
      anon_sym_EQ_GT,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3383), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3377), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13728] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1402), 1,
      anon_sym_EQ,
    ACTIONS(1467), 1,
      anon_sym_COLON,
    ACTIONS(1464), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(64), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13802] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 1,
      anon_sym_extends,
    ACTIONS(1741), 1,
      anon_sym_EQ,
    ACTIONS(1743), 1,
      anon_sym_EQ_GT,
    ACTIONS(3448), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(3451), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(64), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [13878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3317), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3319), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3309), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3311), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14006] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_DOT,
    ACTIONS(3395), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3523), 1,
      anon_sym_EQ,
    ACTIONS(3525), 1,
      anon_sym_EQ_GT,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3387), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3391), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14088] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3429), 1,
      anon_sym_EQ_GT,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(2732), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14222] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14290] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_DOT,
    ACTIONS(3395), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3446), 1,
      anon_sym_EQ_GT,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3391), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3387), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3297), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14372] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 1,
      anon_sym_LBRACK,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3527), 1,
      anon_sym_EQ,
    ACTIONS(3529), 1,
      anon_sym_EQ_GT,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3383), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3377), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14454] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1452), 1,
      anon_sym_EQ,
    ACTIONS(1454), 1,
      anon_sym_EQ_GT,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14524] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3305), 1,
      anon_sym_EQ_GT,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14594] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(62), 1,
      anon_sym_EQ_GT,
    ACTIONS(1467), 1,
      anon_sym_COLON,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(3448), 1,
      anon_sym_LBRACK,
    ACTIONS(3451), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1460), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(64), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14672] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(3357), 1,
      anon_sym_EQ,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3468), 1,
      anon_sym_DOT,
    STATE(2483), 1,
      sym_ui_object_initializer,
    ACTIONS(3431), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3297), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14750] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2179), 1,
      anon_sym_COLON,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3327), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3329), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14886] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3383), 1,
      anon_sym_extends,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3366), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3377), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [14968] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15038] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2179), 1,
      anon_sym_COLON,
    ACTIONS(3305), 1,
      anon_sym_EQ_GT,
    ACTIONS(3436), 1,
      anon_sym_EQ,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3285), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3287), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15174] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_DOT,
    ACTIONS(3395), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3527), 1,
      anon_sym_EQ,
    ACTIONS(3529), 1,
      anon_sym_EQ_GT,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3387), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3391), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15256] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1454), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15326] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(2145), 1,
      anon_sym_COLON,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3313), 22,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(3315), 34,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15462] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1402), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_extends,
    ACTIONS(1467), 1,
      anon_sym_COLON,
    ACTIONS(3448), 1,
      anon_sym_LBRACK,
    ACTIONS(3451), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3531), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(64), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15542] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3305), 1,
      anon_sym_EQ_GT,
    ACTIONS(3436), 1,
      anon_sym_EQ,
    ACTIONS(3535), 1,
      anon_sym_in,
    ACTIONS(3538), 1,
      anon_sym_of,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15616] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      anon_sym_EQ,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1462), 1,
      anon_sym_QMARK,
    ACTIONS(3448), 1,
      anon_sym_LBRACK,
    ACTIONS(3451), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1460), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(64), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15694] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_EQ,
    ACTIONS(1446), 1,
      anon_sym_EQ_GT,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15764] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3305), 1,
      anon_sym_EQ_GT,
    ACTIONS(3436), 1,
      anon_sym_EQ,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15834] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15902] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 1,
      anon_sym_EQ,
    ACTIONS(1729), 1,
      anon_sym_EQ_GT,
    ACTIONS(3448), 1,
      anon_sym_LBRACK,
    ACTIONS(1460), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3451), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(64), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [15978] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3485), 1,
      anon_sym_EQ,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16047] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16116] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 1,
      anon_sym_EQ,
    ACTIONS(1729), 1,
      anon_sym_EQ_GT,
    ACTIONS(3540), 1,
      sym_identifier,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16187] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(32), 1,
      anon_sym_COMMA,
    ACTIONS(124), 1,
      anon_sym_RBRACK,
    ACTIONS(1762), 1,
      anon_sym_EQ_GT,
    ACTIONS(2284), 1,
      anon_sym_EQ,
    ACTIONS(2287), 1,
      anon_sym_COLON,
    ACTIONS(64), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16262] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3416), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [16377] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3497), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [16492] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_DOT,
    ACTIONS(3395), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3446), 1,
      anon_sym_EQ_GT,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3387), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3391), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16573] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1743), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16642] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_RBRACK,
    ACTIONS(3441), 1,
      anon_sym_COMMA,
    ACTIONS(3529), 1,
      anon_sym_EQ_GT,
    ACTIONS(3542), 1,
      anon_sym_EQ,
    ACTIONS(3545), 1,
      anon_sym_in,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16719] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(127), 1,
      anon_sym_EQ_GT,
    ACTIONS(1402), 1,
      anon_sym_EQ,
    ACTIONS(1460), 1,
      anon_sym_extends,
    ACTIONS(3448), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(3451), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(64), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [16794] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3398), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [16909] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3382), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [17024] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3540), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [17139] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 1,
      anon_sym_EQ,
    ACTIONS(1729), 1,
      anon_sym_EQ_GT,
    ACTIONS(3263), 1,
      sym_identifier,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [17210] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1760), 1,
      anon_sym_EQ,
    ACTIONS(1762), 1,
      anon_sym_EQ_GT,
    ACTIONS(3448), 1,
      anon_sym_LBRACK,
    ACTIONS(1460), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3451), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(64), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17285] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_DOT,
    ACTIONS(3395), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3446), 1,
      anon_sym_EQ_GT,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3391), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3387), 3,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3297), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 19,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17366] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1741), 1,
      anon_sym_EQ,
    ACTIONS(1743), 1,
      anon_sym_EQ_GT,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17435] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3436), 1,
      anon_sym_EQ,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17502] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1764), 1,
      anon_sym_EQ,
    ACTIONS(1766), 1,
      anon_sym_EQ_GT,
    ACTIONS(3448), 1,
      anon_sym_LBRACK,
    ACTIONS(1460), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3451), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(64), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17577] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3436), 1,
      anon_sym_EQ,
    ACTIONS(3535), 1,
      anon_sym_in,
    ACTIONS(3538), 1,
      anon_sym_of,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17648] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3455), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [17763] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3366), 1,
      anon_sym_LBRACK,
    ACTIONS(3369), 1,
      anon_sym_LT,
    ACTIONS(3372), 1,
      anon_sym_DOT,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3446), 1,
      anon_sym_EQ_GT,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3383), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3377), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3297), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 17,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [17844] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3505), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [17959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 1,
      anon_sym_EQ,
    ACTIONS(1729), 1,
      anon_sym_EQ_GT,
    ACTIONS(3491), 1,
      sym_identifier,
    ACTIONS(64), 14,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 23,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [18030] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18097] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2804), 1,
      anon_sym_new,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(2820), 1,
      anon_sym_abstract,
    ACTIONS(3333), 1,
      anon_sym_export,
    ACTIONS(3335), 1,
      anon_sym_STAR,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3339), 1,
      anon_sym_async,
    ACTIONS(3343), 1,
      anon_sym_static,
    ACTIONS(3345), 1,
      anon_sym_readonly,
    ACTIONS(3351), 1,
      anon_sym_override,
    STATE(1128), 1,
      sym_decorator,
    STATE(2443), 1,
      sym_accessibility_modifier,
    STATE(2488), 1,
      sym_override_modifier,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3763), 1,
      sym__call_signature,
    STATE(3872), 1,
      aux_sym_export_statement_repeat1,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(3341), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3347), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2964), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(3828), 6,
      sym_export_statement,
      sym_method_signature,
      sym_call_signature,
      sym_property_signature,
      sym_construct_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [18212] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1756), 1,
      anon_sym_EQ,
    ACTIONS(1758), 1,
      anon_sym_EQ_GT,
    ACTIONS(3448), 1,
      anon_sym_LBRACK,
    ACTIONS(1460), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3451), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(64), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18287] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3454), 1,
      anon_sym_COLON,
    ACTIONS(3549), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18358] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_EQ_GT,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3549), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18429] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3483), 1,
      anon_sym_EQ_GT,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18497] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_RBRACK,
    ACTIONS(3441), 1,
      anon_sym_COMMA,
    ACTIONS(3529), 1,
      anon_sym_EQ_GT,
    ACTIONS(3542), 1,
      anon_sym_EQ,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18569] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1760), 1,
      anon_sym_EQ,
    ACTIONS(1762), 1,
      anon_sym_EQ_GT,
    ACTIONS(2295), 1,
      anon_sym_COLON,
    ACTIONS(64), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18639] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_EQ,
    ACTIONS(3483), 1,
      anon_sym_EQ_GT,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18707] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(32), 1,
      anon_sym_COMMA,
    ACTIONS(124), 1,
      anon_sym_RBRACK,
    ACTIONS(1762), 1,
      anon_sym_EQ_GT,
    ACTIONS(2284), 1,
      anon_sym_EQ,
    ACTIONS(64), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18779] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 1,
      anon_sym_EQ,
    ACTIONS(1729), 1,
      anon_sym_EQ_GT,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18847] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3485), 1,
      anon_sym_EQ,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18913] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_EQ,
    ACTIONS(3529), 1,
      anon_sym_EQ_GT,
    ACTIONS(3545), 1,
      anon_sym_in,
    ACTIONS(3552), 1,
      anon_sym_COLON,
    ACTIONS(3297), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [18985] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1760), 1,
      anon_sym_EQ,
    ACTIONS(1762), 1,
      anon_sym_EQ_GT,
    ACTIONS(2287), 1,
      anon_sym_COLON,
    ACTIONS(64), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19055] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_EQ,
    ACTIONS(3529), 1,
      anon_sym_EQ_GT,
    ACTIONS(3545), 1,
      anon_sym_in,
    ACTIONS(3547), 1,
      anon_sym_COLON,
    ACTIONS(3297), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19127] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(62), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(3448), 1,
      anon_sym_LBRACK,
    ACTIONS(1460), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(3451), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(64), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 18,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(64), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19269] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(203), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(3556), 1,
      anon_sym_RBRACE,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3560), 1,
      anon_sym_async,
    ACTIONS(3562), 1,
      anon_sym_static,
    ACTIONS(3564), 1,
      anon_sym_readonly,
    ACTIONS(3570), 1,
      anon_sym_override,
    STATE(2476), 1,
      sym_accessibility_modifier,
    STATE(2491), 1,
      sym_override_modifier,
    STATE(4037), 1,
      aux_sym_object_repeat1,
    STATE(4142), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(215), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3566), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3568), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3324), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4052), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4148), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4722), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3554), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [19374] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(203), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3574), 1,
      anon_sym_RBRACE,
    ACTIONS(3576), 1,
      anon_sym_async,
    ACTIONS(3578), 1,
      anon_sym_static,
    ACTIONS(3580), 1,
      anon_sym_readonly,
    ACTIONS(3586), 1,
      anon_sym_override,
    STATE(2476), 1,
      sym_accessibility_modifier,
    STATE(2491), 1,
      sym_override_modifier,
    STATE(4037), 1,
      aux_sym_object_repeat1,
    STATE(4142), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(215), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3582), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3584), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3324), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4052), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4148), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4722), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3572), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [19479] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1762), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(64), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19546] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1764), 1,
      anon_sym_EQ,
    ACTIONS(1766), 1,
      anon_sym_EQ_GT,
    ACTIONS(64), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19613] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1760), 1,
      anon_sym_EQ,
    ACTIONS(1762), 1,
      anon_sym_EQ_GT,
    ACTIONS(64), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19680] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1756), 1,
      anon_sym_EQ,
    ACTIONS(1758), 1,
      anon_sym_EQ_GT,
    ACTIONS(64), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19747] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3446), 1,
      anon_sym_EQ_GT,
    ACTIONS(3535), 1,
      anon_sym_in,
    ACTIONS(3538), 1,
      anon_sym_of,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19818] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_EQ,
    ACTIONS(3525), 1,
      anon_sym_EQ_GT,
    ACTIONS(3297), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19885] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3529), 1,
      anon_sym_EQ_GT,
    ACTIONS(3297), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [19952] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(203), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3590), 1,
      anon_sym_RBRACE,
    ACTIONS(3592), 1,
      anon_sym_async,
    ACTIONS(3594), 1,
      anon_sym_static,
    ACTIONS(3596), 1,
      anon_sym_readonly,
    ACTIONS(3602), 1,
      anon_sym_override,
    STATE(2476), 1,
      sym_accessibility_modifier,
    STATE(2491), 1,
      sym_override_modifier,
    STATE(4031), 1,
      aux_sym_object_repeat1,
    STATE(4142), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(215), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3598), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3600), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3324), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4034), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4148), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4722), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3588), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [20057] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1758), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(64), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20124] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(203), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3606), 1,
      anon_sym_RBRACE,
    ACTIONS(3608), 1,
      anon_sym_async,
    ACTIONS(3610), 1,
      anon_sym_static,
    ACTIONS(3612), 1,
      anon_sym_readonly,
    ACTIONS(3618), 1,
      anon_sym_override,
    STATE(2476), 1,
      sym_accessibility_modifier,
    STATE(2491), 1,
      sym_override_modifier,
    STATE(4037), 1,
      aux_sym_object_repeat1,
    STATE(4142), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(215), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3614), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3616), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3324), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4052), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4148), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4722), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3604), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [20229] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(203), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3622), 1,
      anon_sym_RBRACE,
    ACTIONS(3624), 1,
      anon_sym_async,
    ACTIONS(3626), 1,
      anon_sym_static,
    ACTIONS(3628), 1,
      anon_sym_readonly,
    ACTIONS(3634), 1,
      anon_sym_override,
    STATE(2476), 1,
      sym_accessibility_modifier,
    STATE(2491), 1,
      sym_override_modifier,
    STATE(4031), 1,
      aux_sym_object_repeat1,
    STATE(4142), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(215), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3630), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3632), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3324), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4034), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4148), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4722), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3620), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [20334] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3519), 1,
      anon_sym_EQ_GT,
    ACTIONS(3297), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20401] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(62), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(2267), 1,
      anon_sym_in,
    ACTIONS(3521), 1,
      anon_sym_of,
    ACTIONS(64), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20472] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(203), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3638), 1,
      anon_sym_RBRACE,
    ACTIONS(3640), 1,
      anon_sym_async,
    ACTIONS(3642), 1,
      anon_sym_static,
    ACTIONS(3644), 1,
      anon_sym_readonly,
    ACTIONS(3650), 1,
      anon_sym_override,
    STATE(2476), 1,
      sym_accessibility_modifier,
    STATE(2491), 1,
      sym_override_modifier,
    STATE(4037), 1,
      aux_sym_object_repeat1,
    STATE(4142), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(215), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3646), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3648), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3324), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4052), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4148), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4722), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3636), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [20577] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1766), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(64), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_EQ,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3297), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20709] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3525), 1,
      anon_sym_EQ_GT,
    ACTIONS(3297), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20776] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_EQ,
    ACTIONS(3529), 1,
      anon_sym_EQ_GT,
    ACTIONS(3297), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20843] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_RBRACK,
    ACTIONS(3441), 1,
      anon_sym_COMMA,
    ACTIONS(3542), 1,
      anon_sym_EQ,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [20912] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(203), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3654), 1,
      anon_sym_RBRACE,
    ACTIONS(3656), 1,
      anon_sym_async,
    ACTIONS(3658), 1,
      anon_sym_static,
    ACTIONS(3660), 1,
      anon_sym_readonly,
    ACTIONS(3666), 1,
      anon_sym_override,
    STATE(2476), 1,
      sym_accessibility_modifier,
    STATE(2491), 1,
      sym_override_modifier,
    STATE(4037), 1,
      aux_sym_object_repeat1,
    STATE(4142), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(215), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3662), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3664), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3324), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4052), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4148), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4722), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3652), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [21017] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_EQ,
    ACTIONS(3519), 1,
      anon_sym_EQ_GT,
    ACTIONS(3297), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21084] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_EQ,
    ACTIONS(3297), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21148] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(62), 1,
      anon_sym_EQ_GT,
    ACTIONS(1778), 1,
      anon_sym_EQ,
    ACTIONS(64), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(68), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(26), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21214] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3446), 1,
      anon_sym_EQ_GT,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21280] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_EQ,
    ACTIONS(3297), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21344] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3535), 1,
      anon_sym_in,
    ACTIONS(3538), 1,
      anon_sym_of,
    ACTIONS(3297), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 20,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21412] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_EQ,
    ACTIONS(3297), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3307), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3293), 21,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [21476] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(558), 1,
      anon_sym_var,
    ACTIONS(3668), 1,
      sym_identifier,
    ACTIONS(3672), 1,
      anon_sym_default,
    ACTIONS(3674), 1,
      anon_sym_RBRACE,
    ACTIONS(3676), 1,
      anon_sym_async,
    ACTIONS(3678), 1,
      anon_sym_function,
    ACTIONS(3680), 1,
      anon_sym_readonly,
    ACTIONS(3682), 1,
      anon_sym_property,
    ACTIONS(3684), 1,
      anon_sym_signal,
    ACTIONS(3686), 1,
      anon_sym_required,
    ACTIONS(3688), 1,
      anon_sym_component,
    ACTIONS(3690), 1,
      anon_sym_enum,
    STATE(1407), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(2715), 1,
      sym__qml_enum_declaration,
    STATE(2769), 1,
      sym_ui_annotation,
    STATE(3611), 1,
      sym_ui_nested_identifier,
    STATE(3508), 2,
      sym_ui_property_modifier,
      aux_sym_ui_property_repeat1,
    STATE(1361), 12,
      sym_variable_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ui_object_definition,
      sym_ui_annotated_object_member,
      sym_ui_object_definition_binding,
      sym_ui_binding,
      sym_ui_property,
      sym_ui_required,
      sym_ui_signal,
      sym_ui_inline_component,
      aux_sym_ui_object_initializer_repeat1,
    ACTIONS(3670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_on,
  [21571] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(558), 1,
      anon_sym_var,
    ACTIONS(3668), 1,
      sym_identifier,
    ACTIONS(3672), 1,
      anon_sym_default,
    ACTIONS(3676), 1,
      anon_sym_async,
    ACTIONS(3678), 1,
      anon_sym_function,
    ACTIONS(3680), 1,
      anon_sym_readonly,
    ACTIONS(3682), 1,
      anon_sym_property,
    ACTIONS(3684), 1,
      anon_sym_signal,
    ACTIONS(3686), 1,
      anon_sym_required,
    ACTIONS(3688), 1,
      anon_sym_component,
    ACTIONS(3690), 1,
      anon_sym_enum,
    ACTIONS(3692), 1,
      anon_sym_RBRACE,
    STATE(1407), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(2715), 1,
      sym__qml_enum_declaration,
    STATE(2769), 1,
      sym_ui_annotation,
    STATE(3611), 1,
      sym_ui_nested_identifier,
    STATE(3508), 2,
      sym_ui_property_modifier,
      aux_sym_ui_property_repeat1,
    STATE(1362), 12,
      sym_variable_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ui_object_definition,
      sym_ui_annotated_object_member,
      sym_ui_object_definition_binding,
      sym_ui_binding,
      sym_ui_property,
      sym_ui_required,
      sym_ui_signal,
      sym_ui_inline_component,
      aux_sym_ui_object_initializer_repeat1,
    ACTIONS(3670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_on,
  [21666] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(203), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3696), 1,
      anon_sym_async,
    ACTIONS(3698), 1,
      anon_sym_static,
    ACTIONS(3700), 1,
      anon_sym_readonly,
    ACTIONS(3706), 1,
      anon_sym_override,
    STATE(2476), 1,
      sym_accessibility_modifier,
    STATE(2491), 1,
      sym_override_modifier,
    ACTIONS(215), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2976), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3702), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3704), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3324), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4385), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4414), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    STATE(4722), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3694), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [21763] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3708), 1,
      sym_identifier,
    ACTIONS(3714), 1,
      anon_sym_default,
    ACTIONS(3717), 1,
      anon_sym_RBRACE,
    ACTIONS(3719), 1,
      anon_sym_var,
    ACTIONS(3722), 1,
      anon_sym_async,
    ACTIONS(3725), 1,
      anon_sym_function,
    ACTIONS(3728), 1,
      anon_sym_AT,
    ACTIONS(3731), 1,
      anon_sym_readonly,
    ACTIONS(3734), 1,
      anon_sym_property,
    ACTIONS(3737), 1,
      anon_sym_signal,
    ACTIONS(3740), 1,
      anon_sym_required,
    ACTIONS(3743), 1,
      anon_sym_component,
    ACTIONS(3746), 1,
      anon_sym_enum,
    STATE(1407), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(2715), 1,
      sym__qml_enum_declaration,
    STATE(2769), 1,
      sym_ui_annotation,
    STATE(3611), 1,
      sym_ui_nested_identifier,
    STATE(3508), 2,
      sym_ui_property_modifier,
      aux_sym_ui_property_repeat1,
    STATE(1360), 12,
      sym_variable_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ui_object_definition,
      sym_ui_annotated_object_member,
      sym_ui_object_definition_binding,
      sym_ui_binding,
      sym_ui_property,
      sym_ui_required,
      sym_ui_signal,
      sym_ui_inline_component,
      aux_sym_ui_object_initializer_repeat1,
    ACTIONS(3711), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_on,
  [21858] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(558), 1,
      anon_sym_var,
    ACTIONS(3668), 1,
      sym_identifier,
    ACTIONS(3672), 1,
      anon_sym_default,
    ACTIONS(3676), 1,
      anon_sym_async,
    ACTIONS(3678), 1,
      anon_sym_function,
    ACTIONS(3680), 1,
      anon_sym_readonly,
    ACTIONS(3682), 1,
      anon_sym_property,
    ACTIONS(3684), 1,
      anon_sym_signal,
    ACTIONS(3686), 1,
      anon_sym_required,
    ACTIONS(3688), 1,
      anon_sym_component,
    ACTIONS(3690), 1,
      anon_sym_enum,
    ACTIONS(3749), 1,
      anon_sym_RBRACE,
    STATE(1407), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(2715), 1,
      sym__qml_enum_declaration,
    STATE(2769), 1,
      sym_ui_annotation,
    STATE(3611), 1,
      sym_ui_nested_identifier,
    STATE(3508), 2,
      sym_ui_property_modifier,
      aux_sym_ui_property_repeat1,
    STATE(1360), 12,
      sym_variable_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ui_object_definition,
      sym_ui_annotated_object_member,
      sym_ui_object_definition_binding,
      sym_ui_binding,
      sym_ui_property,
      sym_ui_required,
      sym_ui_signal,
      sym_ui_inline_component,
      aux_sym_ui_object_initializer_repeat1,
    ACTIONS(3670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_on,
  [21953] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(558), 1,
      anon_sym_var,
    ACTIONS(3668), 1,
      sym_identifier,
    ACTIONS(3672), 1,
      anon_sym_default,
    ACTIONS(3676), 1,
      anon_sym_async,
    ACTIONS(3678), 1,
      anon_sym_function,
    ACTIONS(3680), 1,
      anon_sym_readonly,
    ACTIONS(3682), 1,
      anon_sym_property,
    ACTIONS(3684), 1,
      anon_sym_signal,
    ACTIONS(3686), 1,
      anon_sym_required,
    ACTIONS(3688), 1,
      anon_sym_component,
    ACTIONS(3690), 1,
      anon_sym_enum,
    ACTIONS(3751), 1,
      anon_sym_RBRACE,
    STATE(1407), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(2715), 1,
      sym__qml_enum_declaration,
    STATE(2769), 1,
      sym_ui_annotation,
    STATE(3611), 1,
      sym_ui_nested_identifier,
    STATE(3508), 2,
      sym_ui_property_modifier,
      aux_sym_ui_property_repeat1,
    STATE(1360), 12,
      sym_variable_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_ui_object_definition,
      sym_ui_annotated_object_member,
      sym_ui_object_definition_binding,
      sym_ui_binding,
      sym_ui_property,
      sym_ui_required,
      sym_ui_signal,
      sym_ui_inline_component,
      aux_sym_ui_object_initializer_repeat1,
    ACTIONS(3670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_on,
  [22048] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2057), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      anon_sym_namespace,
    ACTIONS(2230), 1,
      anon_sym_import,
    ACTIONS(2232), 1,
      anon_sym_var,
    ACTIONS(2234), 1,
      anon_sym_let,
    ACTIONS(2236), 1,
      anon_sym_const,
    ACTIONS(2238), 1,
      anon_sym_class,
    ACTIONS(2240), 1,
      anon_sym_async,
    ACTIONS(2242), 1,
      anon_sym_function,
    ACTIONS(2244), 1,
      anon_sym_declare,
    ACTIONS(2248), 1,
      anon_sym_abstract,
    ACTIONS(2252), 1,
      anon_sym_interface,
    ACTIONS(2254), 1,
      anon_sym_enum,
    ACTIONS(3753), 1,
      anon_sym_STAR,
    ACTIONS(3755), 1,
      anon_sym_default,
    ACTIONS(3757), 1,
      anon_sym_type,
    ACTIONS(3759), 1,
      anon_sym_EQ,
    ACTIONS(3761), 1,
      anon_sym_as,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3766), 1,
      anon_sym_RBRACE,
    ACTIONS(3771), 1,
      anon_sym_module,
    STATE(1128), 1,
      sym_decorator,
    STATE(3590), 1,
      aux_sym_export_statement_repeat1,
    STATE(3767), 1,
      sym_internal_module,
    STATE(3768), 1,
      sym_declaration,
    STATE(3857), 1,
      sym_export_clause,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    STATE(4588), 1,
      sym_namespace_import_export,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3792), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [22166] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2057), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      anon_sym_namespace,
    ACTIONS(2230), 1,
      anon_sym_import,
    ACTIONS(2232), 1,
      anon_sym_var,
    ACTIONS(2234), 1,
      anon_sym_let,
    ACTIONS(2236), 1,
      anon_sym_const,
    ACTIONS(2238), 1,
      anon_sym_class,
    ACTIONS(2240), 1,
      anon_sym_async,
    ACTIONS(2242), 1,
      anon_sym_function,
    ACTIONS(2244), 1,
      anon_sym_declare,
    ACTIONS(2248), 1,
      anon_sym_abstract,
    ACTIONS(2252), 1,
      anon_sym_interface,
    ACTIONS(2254), 1,
      anon_sym_enum,
    ACTIONS(3753), 1,
      anon_sym_STAR,
    ACTIONS(3755), 1,
      anon_sym_default,
    ACTIONS(3757), 1,
      anon_sym_type,
    ACTIONS(3759), 1,
      anon_sym_EQ,
    ACTIONS(3761), 1,
      anon_sym_as,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3771), 1,
      anon_sym_module,
    ACTIONS(3773), 1,
      anon_sym_RBRACE,
    STATE(1128), 1,
      sym_decorator,
    STATE(3590), 1,
      aux_sym_export_statement_repeat1,
    STATE(3767), 1,
      sym_internal_module,
    STATE(3768), 1,
      sym_declaration,
    STATE(3857), 1,
      sym_export_clause,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    STATE(4588), 1,
      sym_namespace_import_export,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3792), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [22284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1629), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_QMARK,
    ACTIONS(1627), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_EQ,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_extends,
      anon_sym_enum,
  [22342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_QMARK,
    ACTIONS(1631), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_EQ,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_extends,
      anon_sym_enum,
  [22400] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2057), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      anon_sym_namespace,
    ACTIONS(2230), 1,
      anon_sym_import,
    ACTIONS(2232), 1,
      anon_sym_var,
    ACTIONS(2234), 1,
      anon_sym_let,
    ACTIONS(2236), 1,
      anon_sym_const,
    ACTIONS(2238), 1,
      anon_sym_class,
    ACTIONS(2240), 1,
      anon_sym_async,
    ACTIONS(2242), 1,
      anon_sym_function,
    ACTIONS(2244), 1,
      anon_sym_declare,
    ACTIONS(2248), 1,
      anon_sym_abstract,
    ACTIONS(2252), 1,
      anon_sym_interface,
    ACTIONS(2254), 1,
      anon_sym_enum,
    ACTIONS(3753), 1,
      anon_sym_STAR,
    ACTIONS(3755), 1,
      anon_sym_default,
    ACTIONS(3757), 1,
      anon_sym_type,
    ACTIONS(3759), 1,
      anon_sym_EQ,
    ACTIONS(3761), 1,
      anon_sym_as,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3771), 1,
      anon_sym_module,
    ACTIONS(3776), 1,
      anon_sym_RBRACE,
    STATE(1128), 1,
      sym_decorator,
    STATE(3590), 1,
      aux_sym_export_statement_repeat1,
    STATE(3767), 1,
      sym_internal_module,
    STATE(3768), 1,
      sym_declaration,
    STATE(3857), 1,
      sym_export_clause,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    STATE(4588), 1,
      sym_namespace_import_export,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3792), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [22518] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2057), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      anon_sym_namespace,
    ACTIONS(2230), 1,
      anon_sym_import,
    ACTIONS(2232), 1,
      anon_sym_var,
    ACTIONS(2234), 1,
      anon_sym_let,
    ACTIONS(2236), 1,
      anon_sym_const,
    ACTIONS(2238), 1,
      anon_sym_class,
    ACTIONS(2240), 1,
      anon_sym_async,
    ACTIONS(2242), 1,
      anon_sym_function,
    ACTIONS(2244), 1,
      anon_sym_declare,
    ACTIONS(2248), 1,
      anon_sym_abstract,
    ACTIONS(2252), 1,
      anon_sym_interface,
    ACTIONS(2254), 1,
      anon_sym_enum,
    ACTIONS(3753), 1,
      anon_sym_STAR,
    ACTIONS(3755), 1,
      anon_sym_default,
    ACTIONS(3757), 1,
      anon_sym_type,
    ACTIONS(3759), 1,
      anon_sym_EQ,
    ACTIONS(3761), 1,
      anon_sym_as,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3771), 1,
      anon_sym_module,
    ACTIONS(3779), 1,
      anon_sym_RBRACE,
    STATE(1128), 1,
      sym_decorator,
    STATE(3590), 1,
      aux_sym_export_statement_repeat1,
    STATE(3767), 1,
      sym_internal_module,
    STATE(3768), 1,
      sym_declaration,
    STATE(3857), 1,
      sym_export_clause,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    STATE(4588), 1,
      sym_namespace_import_export,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3792), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [22636] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2057), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      anon_sym_namespace,
    ACTIONS(2230), 1,
      anon_sym_import,
    ACTIONS(2232), 1,
      anon_sym_var,
    ACTIONS(2234), 1,
      anon_sym_let,
    ACTIONS(2236), 1,
      anon_sym_const,
    ACTIONS(2238), 1,
      anon_sym_class,
    ACTIONS(2240), 1,
      anon_sym_async,
    ACTIONS(2242), 1,
      anon_sym_function,
    ACTIONS(2244), 1,
      anon_sym_declare,
    ACTIONS(2248), 1,
      anon_sym_abstract,
    ACTIONS(2252), 1,
      anon_sym_interface,
    ACTIONS(2254), 1,
      anon_sym_enum,
    ACTIONS(3753), 1,
      anon_sym_STAR,
    ACTIONS(3755), 1,
      anon_sym_default,
    ACTIONS(3757), 1,
      anon_sym_type,
    ACTIONS(3759), 1,
      anon_sym_EQ,
    ACTIONS(3761), 1,
      anon_sym_as,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3771), 1,
      anon_sym_module,
    ACTIONS(3782), 1,
      anon_sym_RBRACE,
    STATE(1128), 1,
      sym_decorator,
    STATE(3590), 1,
      aux_sym_export_statement_repeat1,
    STATE(3767), 1,
      sym_internal_module,
    STATE(3768), 1,
      sym_declaration,
    STATE(3857), 1,
      sym_export_clause,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    STATE(4588), 1,
      sym_namespace_import_export,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3792), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [22754] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2057), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      anon_sym_namespace,
    ACTIONS(2230), 1,
      anon_sym_import,
    ACTIONS(2232), 1,
      anon_sym_var,
    ACTIONS(2234), 1,
      anon_sym_let,
    ACTIONS(2236), 1,
      anon_sym_const,
    ACTIONS(2238), 1,
      anon_sym_class,
    ACTIONS(2240), 1,
      anon_sym_async,
    ACTIONS(2242), 1,
      anon_sym_function,
    ACTIONS(2244), 1,
      anon_sym_declare,
    ACTIONS(2248), 1,
      anon_sym_abstract,
    ACTIONS(2252), 1,
      anon_sym_interface,
    ACTIONS(2254), 1,
      anon_sym_enum,
    ACTIONS(3753), 1,
      anon_sym_STAR,
    ACTIONS(3755), 1,
      anon_sym_default,
    ACTIONS(3757), 1,
      anon_sym_type,
    ACTIONS(3759), 1,
      anon_sym_EQ,
    ACTIONS(3761), 1,
      anon_sym_as,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3771), 1,
      anon_sym_module,
    ACTIONS(3785), 1,
      anon_sym_RBRACE,
    STATE(1128), 1,
      sym_decorator,
    STATE(3590), 1,
      aux_sym_export_statement_repeat1,
    STATE(3767), 1,
      sym_internal_module,
    STATE(3768), 1,
      sym_declaration,
    STATE(3857), 1,
      sym_export_clause,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    STATE(4588), 1,
      sym_namespace_import_export,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3792), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [22872] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3776), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3798), 1,
      anon_sym_readonly,
    STATE(2496), 1,
      sym_override_modifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [22961] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3804), 1,
      anon_sym_RBRACE,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1374), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [23062] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3822), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1378), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [23163] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3827), 1,
      anon_sym_STAR,
    ACTIONS(3830), 1,
      anon_sym_RBRACE,
    ACTIONS(3832), 1,
      anon_sym_LBRACK,
    ACTIONS(3835), 1,
      anon_sym_async,
    ACTIONS(3838), 1,
      anon_sym_DASH,
    ACTIONS(3841), 1,
      anon_sym_DQUOTE,
    ACTIONS(3844), 1,
      anon_sym_SQUOTE,
    ACTIONS(3850), 1,
      anon_sym_AT,
    ACTIONS(3853), 1,
      anon_sym_static,
    ACTIONS(3856), 1,
      anon_sym_readonly,
    ACTIONS(3862), 1,
      anon_sym_declare,
    ACTIONS(3868), 1,
      anon_sym_override,
    ACTIONS(3871), 1,
      anon_sym_abstract,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3847), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3859), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1374), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3865), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3824), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [23264] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3874), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1374), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [23365] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3876), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1374), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [23466] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3878), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1393), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [23567] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3880), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1374), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [23668] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3882), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1374), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [23769] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3782), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3798), 1,
      anon_sym_readonly,
    STATE(2496), 1,
      sym_override_modifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [23858] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3884), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1379), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [23959] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3785), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3798), 1,
      anon_sym_readonly,
    STATE(2496), 1,
      sym_override_modifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [24048] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3766), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3798), 1,
      anon_sym_readonly,
    STATE(2496), 1,
      sym_override_modifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [24137] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3886), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1374), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [24238] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3888), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1384), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [24339] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3773), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3798), 1,
      anon_sym_readonly,
    STATE(2496), 1,
      sym_override_modifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [24428] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3890), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1395), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [24529] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3779), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3798), 1,
      anon_sym_readonly,
    STATE(2496), 1,
      sym_override_modifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [24618] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3892), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1376), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [24719] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3894), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1375), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [24820] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3896), 1,
      sym_identifier,
    ACTIONS(3898), 1,
      anon_sym_STAR,
    ACTIONS(3904), 1,
      anon_sym_LBRACE,
    STATE(4500), 1,
      sym_import_clause,
    STATE(4569), 1,
      sym_import_require_clause,
    STATE(4570), 1,
      sym_string,
    ACTIONS(3900), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(4842), 2,
      sym_namespace_import_export,
      sym_named_imports,
    ACTIONS(3902), 14,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3906), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24897] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3908), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1372), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [24998] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3910), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1374), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [25099] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3898), 1,
      anon_sym_STAR,
    ACTIONS(3904), 1,
      anon_sym_LBRACE,
    ACTIONS(3912), 1,
      sym_identifier,
    STATE(4425), 1,
      sym_import_clause,
    STATE(4431), 1,
      sym_string,
    STATE(4432), 1,
      sym_import_require_clause,
    ACTIONS(3914), 2,
      anon_sym_type,
      anon_sym_typeof,
    STATE(4842), 2,
      sym_namespace_import_export,
      sym_named_imports,
    ACTIONS(3902), 14,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3906), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [25176] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(2806), 1,
      anon_sym_DASH,
    ACTIONS(3337), 1,
      anon_sym_LBRACK,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3802), 1,
      anon_sym_STAR,
    ACTIONS(3806), 1,
      anon_sym_async,
    ACTIONS(3810), 1,
      anon_sym_AT,
    ACTIONS(3812), 1,
      anon_sym_static,
    ACTIONS(3814), 1,
      anon_sym_readonly,
    ACTIONS(3818), 1,
      anon_sym_declare,
    ACTIONS(3820), 1,
      anon_sym_abstract,
    ACTIONS(3916), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      sym_method_definition,
    STATE(2437), 1,
      sym_accessibility_modifier,
    STATE(2505), 1,
      sym_override_modifier,
    STATE(3904), 1,
      sym_method_signature,
    ACTIONS(3808), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3816), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1374), 2,
      sym_decorator,
      aux_sym_class_body_repeat1,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(2923), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4161), 3,
      sym_public_field_definition,
      sym_abstract_method_signature,
      sym_index_signature,
    ACTIONS(3331), 17,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [25277] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3785), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3918), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [25359] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3779), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3924), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [25439] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3766), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3918), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [25521] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3776), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3918), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [25603] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3782), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3918), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [25685] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3773), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3918), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [25767] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3776), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3924), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [25847] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3773), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3924), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [25927] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3782), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3924), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [26007] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3766), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3924), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [26087] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2057), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      anon_sym_namespace,
    ACTIONS(2230), 1,
      anon_sym_import,
    ACTIONS(2232), 1,
      anon_sym_var,
    ACTIONS(2234), 1,
      anon_sym_let,
    ACTIONS(2236), 1,
      anon_sym_const,
    ACTIONS(2238), 1,
      anon_sym_class,
    ACTIONS(2240), 1,
      anon_sym_async,
    ACTIONS(2242), 1,
      anon_sym_function,
    ACTIONS(2244), 1,
      anon_sym_declare,
    ACTIONS(2248), 1,
      anon_sym_abstract,
    ACTIONS(2252), 1,
      anon_sym_interface,
    ACTIONS(2254), 1,
      anon_sym_enum,
    ACTIONS(3753), 1,
      anon_sym_STAR,
    ACTIONS(3755), 1,
      anon_sym_default,
    ACTIONS(3757), 1,
      anon_sym_type,
    ACTIONS(3759), 1,
      anon_sym_EQ,
    ACTIONS(3761), 1,
      anon_sym_as,
    ACTIONS(3771), 1,
      anon_sym_module,
    STATE(1128), 1,
      sym_decorator,
    STATE(3590), 1,
      aux_sym_export_statement_repeat1,
    STATE(3767), 1,
      sym_internal_module,
    STATE(3768), 1,
      sym_declaration,
    STATE(3857), 1,
      sym_export_clause,
    STATE(4588), 1,
      sym_namespace_import_export,
    ACTIONS(3926), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3792), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [26197] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(558), 1,
      anon_sym_var,
    ACTIONS(3668), 1,
      sym_identifier,
    ACTIONS(3672), 1,
      anon_sym_default,
    ACTIONS(3676), 1,
      anon_sym_async,
    ACTIONS(3678), 1,
      anon_sym_function,
    ACTIONS(3680), 1,
      anon_sym_readonly,
    ACTIONS(3682), 1,
      anon_sym_property,
    ACTIONS(3684), 1,
      anon_sym_signal,
    ACTIONS(3686), 1,
      anon_sym_required,
    ACTIONS(3688), 1,
      anon_sym_component,
    ACTIONS(3690), 1,
      anon_sym_enum,
    STATE(2591), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(2732), 1,
      sym_variable_declaration,
    STATE(2744), 1,
      sym_function_declaration,
    STATE(2753), 1,
      sym_generator_function_declaration,
    STATE(2754), 1,
      sym_ui_object_definition,
    STATE(2755), 1,
      sym_ui_object_definition_binding,
    STATE(2756), 1,
      sym_ui_binding,
    STATE(2757), 1,
      sym_ui_property,
    STATE(2758), 1,
      sym_ui_required,
    STATE(2759), 1,
      sym_ui_signal,
    STATE(2761), 1,
      sym_ui_inline_component,
    STATE(2763), 1,
      sym__qml_enum_declaration,
    STATE(2769), 1,
      sym_ui_annotation,
    STATE(3611), 1,
      sym_ui_nested_identifier,
    STATE(3508), 2,
      sym_ui_property_modifier,
      aux_sym_ui_property_repeat1,
    ACTIONS(3670), 20,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_on,
  [26305] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2057), 1,
      anon_sym_LBRACE,
    ACTIONS(2228), 1,
      anon_sym_namespace,
    ACTIONS(2230), 1,
      anon_sym_import,
    ACTIONS(2232), 1,
      anon_sym_var,
    ACTIONS(2234), 1,
      anon_sym_let,
    ACTIONS(2236), 1,
      anon_sym_const,
    ACTIONS(2238), 1,
      anon_sym_class,
    ACTIONS(2240), 1,
      anon_sym_async,
    ACTIONS(2242), 1,
      anon_sym_function,
    ACTIONS(2244), 1,
      anon_sym_declare,
    ACTIONS(2248), 1,
      anon_sym_abstract,
    ACTIONS(2252), 1,
      anon_sym_interface,
    ACTIONS(2254), 1,
      anon_sym_enum,
    ACTIONS(3753), 1,
      anon_sym_STAR,
    ACTIONS(3755), 1,
      anon_sym_default,
    ACTIONS(3757), 1,
      anon_sym_type,
    ACTIONS(3761), 1,
      anon_sym_as,
    ACTIONS(3771), 1,
      anon_sym_module,
    ACTIONS(3930), 1,
      anon_sym_EQ,
    STATE(1128), 1,
      sym_decorator,
    STATE(3590), 1,
      aux_sym_export_statement_repeat1,
    STATE(3767), 1,
      sym_internal_module,
    STATE(3768), 1,
      sym_declaration,
    STATE(3857), 1,
      sym_export_clause,
    STATE(4588), 1,
      sym_namespace_import_export,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    STATE(3792), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [26413] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3785), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3924), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [26493] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3779), 1,
      anon_sym_RBRACE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3918), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [26575] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3766), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [26650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1631), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1633), 33,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [26705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1627), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1629), 33,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [26760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1535), 13,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1533), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
      anon_sym_enum,
  [26815] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3773), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [26890] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3798), 1,
      anon_sym_readonly,
    STATE(2496), 1,
      sym_override_modifier,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3926), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [26971] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3779), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3932), 1,
      sym__automatic_semicolon,
    ACTIONS(1479), 12,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1473), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
      anon_sym_enum,
  [27103] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3785), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27178] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3776), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1521), 13,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1519), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
      anon_sym_enum,
  [27308] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3782), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3934), 1,
      sym__automatic_semicolon,
    ACTIONS(1535), 12,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1533), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
      anon_sym_enum,
  [27440] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3938), 1,
      anon_sym_static,
    ACTIONS(3940), 1,
      anon_sym_readonly,
    ACTIONS(3942), 1,
      anon_sym_abstract,
    STATE(2466), 1,
      sym_accessibility_modifier,
    STATE(2539), 1,
      sym_override_modifier,
    ACTIONS(3936), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3349), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3166), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3331), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27519] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3918), 1,
      anon_sym_LBRACK,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3926), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27593] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(2093), 1,
      anon_sym_readonly,
    ACTIONS(2097), 1,
      anon_sym_override,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_RBRACE,
    STATE(2502), 1,
      sym_override_modifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27679] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3948), 1,
      anon_sym_STAR,
    ACTIONS(3950), 1,
      anon_sym_async,
    ACTIONS(3954), 1,
      anon_sym_readonly,
    STATE(2493), 1,
      sym_override_modifier,
    ACTIONS(3952), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3956), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2957), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27755] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(70), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_COMMA,
    ACTIONS(3962), 1,
      anon_sym_RBRACE,
    STATE(4123), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3964), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4129), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4721), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4722), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3958), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27831] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(2093), 1,
      anon_sym_readonly,
    ACTIONS(2097), 1,
      anon_sym_override,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3966), 1,
      anon_sym_RBRACE,
    STATE(2502), 1,
      sym_override_modifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27917] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3968), 1,
      anon_sym_STAR,
    ACTIONS(3970), 1,
      anon_sym_async,
    ACTIONS(3974), 1,
      anon_sym_readonly,
    STATE(2482), 1,
      sym_override_modifier,
    ACTIONS(3972), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3976), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2966), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [27993] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(70), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3960), 1,
      anon_sym_COMMA,
    ACTIONS(3980), 1,
      anon_sym_RBRACE,
    STATE(4142), 1,
      aux_sym_object_pattern_repeat1,
    ACTIONS(3964), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(4148), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4721), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4722), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(3978), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28069] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      anon_sym_RBRACE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(2093), 1,
      anon_sym_readonly,
    ACTIONS(2097), 1,
      anon_sym_override,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    STATE(2502), 1,
      sym_override_modifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28155] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_STAR,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3988), 1,
      anon_sym_readonly,
    STATE(2487), 1,
      sym_override_modifier,
    ACTIONS(3986), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3990), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2968), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28231] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4000), 1,
      anon_sym_LT,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4004), 1,
      anon_sym_QMARK_DOT,
    STATE(1553), 1,
      sym_type_arguments,
    STATE(1727), 1,
      sym_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(3992), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3994), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [28301] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4000), 1,
      anon_sym_LT,
    ACTIONS(4008), 1,
      anon_sym_DOT,
    ACTIONS(4010), 1,
      anon_sym_is,
    STATE(1593), 1,
      sym_type_arguments,
    ACTIONS(4006), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3383), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [28363] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2015), 1,
      anon_sym_RBRACE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(2093), 1,
      anon_sym_readonly,
    ACTIONS(2097), 1,
      anon_sym_override,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    STATE(2502), 1,
      sym_override_modifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28449] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4012), 1,
      anon_sym_STAR,
    ACTIONS(4014), 1,
      anon_sym_async,
    ACTIONS(4018), 1,
      anon_sym_readonly,
    STATE(2485), 1,
      sym_override_modifier,
    ACTIONS(4016), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4020), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2922), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3331), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28525] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4012), 1,
      anon_sym_STAR,
    ACTIONS(4014), 1,
      anon_sym_async,
    ACTIONS(4022), 1,
      anon_sym_abstract,
    ACTIONS(4016), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4020), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2922), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28597] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3924), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3926), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28669] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2041), 1,
      anon_sym_RBRACE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(2093), 1,
      anon_sym_readonly,
    ACTIONS(2097), 1,
      anon_sym_override,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    STATE(2502), 1,
      sym_override_modifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28755] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(2093), 1,
      anon_sym_readonly,
    ACTIONS(2097), 1,
      anon_sym_override,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(4024), 1,
      anon_sym_RBRACE,
    STATE(2502), 1,
      sym_override_modifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28841] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3918), 1,
      anon_sym_LBRACK,
    ACTIONS(4026), 1,
      anon_sym_STAR,
    ACTIONS(4028), 1,
      anon_sym_async,
    ACTIONS(4034), 1,
      anon_sym_abstract,
    ACTIONS(4030), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4032), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2908), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28913] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2039), 1,
      anon_sym_RBRACE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(2093), 1,
      anon_sym_readonly,
    ACTIONS(2097), 1,
      anon_sym_override,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    STATE(2502), 1,
      sym_override_modifier,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [28999] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4026), 1,
      anon_sym_STAR,
    ACTIONS(4028), 1,
      anon_sym_async,
    ACTIONS(4036), 1,
      anon_sym_readonly,
    STATE(2480), 1,
      sym_override_modifier,
    ACTIONS(4030), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4032), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2908), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3331), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [29075] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3948), 1,
      anon_sym_STAR,
    ACTIONS(4038), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4040), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3513), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [29142] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    ACTIONS(4044), 1,
      anon_sym_DOT,
    STATE(1824), 1,
      sym_statement_block,
    ACTIONS(1487), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1491), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [29201] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3926), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [29268] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4046), 1,
      anon_sym_STAR,
    ACTIONS(4048), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4050), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3465), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [29335] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4054), 1,
      anon_sym_async,
    ACTIONS(4056), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4058), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2952), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [29404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1462), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1460), 32,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_is,
  [29457] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4052), 1,
      anon_sym_STAR,
    ACTIONS(4060), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4062), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3494), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [29524] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4064), 1,
      anon_sym_STAR,
    ACTIONS(4066), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4068), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3478), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [29591] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [29668] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4070), 1,
      anon_sym_STAR,
    ACTIONS(4072), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4074), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3491), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [29735] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4046), 1,
      anon_sym_STAR,
    ACTIONS(4076), 1,
      anon_sym_async,
    ACTIONS(4078), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4080), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2924), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [29804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4000), 1,
      anon_sym_LT,
    STATE(1601), 1,
      sym_type_arguments,
    ACTIONS(4082), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4084), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [29861] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      anon_sym_RBRACE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [29940] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_STAR,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3986), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3990), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2968), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30009] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    STATE(1824), 1,
      sym_statement_block,
    ACTIONS(1487), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1491), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [30066] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3948), 1,
      anon_sym_STAR,
    ACTIONS(3950), 1,
      anon_sym_async,
    ACTIONS(3952), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3956), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2957), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1627), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1629), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [30188] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4086), 1,
      anon_sym_STAR,
    ACTIONS(4088), 1,
      anon_sym_async,
    ACTIONS(4090), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4092), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2937), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30257] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4086), 1,
      anon_sym_STAR,
    ACTIONS(4094), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4096), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30324] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_STAR,
    ACTIONS(4098), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4100), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3413), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30391] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4000), 1,
      anon_sym_LT,
    ACTIONS(4008), 1,
      anon_sym_DOT,
    STATE(1593), 1,
      sym_type_arguments,
    ACTIONS(4006), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3383), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [30450] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4102), 1,
      anon_sym_STAR,
    ACTIONS(4104), 1,
      anon_sym_async,
    ACTIONS(4106), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4108), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2956), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30519] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4110), 1,
      anon_sym_STAR,
    ACTIONS(4112), 1,
      anon_sym_async,
    ACTIONS(4114), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4116), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2958), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1631), 14,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
    ACTIONS(1633), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [30641] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(70), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(3558), 1,
      anon_sym_LBRACK,
    ACTIONS(3964), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4120), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(4385), 3,
      sym_object_assignment_pattern,
      sym_rest_pattern,
      sym_pair_pattern,
    STATE(4721), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4722), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
    ACTIONS(4118), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30712] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4122), 1,
      anon_sym_STAR,
    ACTIONS(4124), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4126), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3463), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30779] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4110), 1,
      anon_sym_STAR,
    ACTIONS(4128), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4130), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3388), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [30846] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(4132), 1,
      anon_sym_DOT,
    STATE(1606), 1,
      sym_arguments,
    ACTIONS(3391), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3387), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [30905] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(4138), 1,
      anon_sym_DOT,
    STATE(1612), 1,
      sym_arguments,
    ACTIONS(4134), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4136), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [30964] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4102), 1,
      anon_sym_STAR,
    ACTIONS(4140), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4142), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3498), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31031] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2039), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31108] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4012), 1,
      anon_sym_STAR,
    ACTIONS(4144), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4146), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3425), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31175] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4012), 1,
      anon_sym_STAR,
    ACTIONS(4014), 1,
      anon_sym_async,
    ACTIONS(4016), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4020), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2922), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31244] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3776), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31309] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3779), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31374] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3779), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31439] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4148), 1,
      anon_sym_STAR,
    ACTIONS(4150), 1,
      anon_sym_async,
    ACTIONS(4152), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4154), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2976), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31508] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3766), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31573] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3766), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31638] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4148), 1,
      anon_sym_STAR,
    ACTIONS(4156), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4158), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3489), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31705] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(4160), 1,
      sym__automatic_semicolon,
    ACTIONS(1473), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1479), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [31762] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4026), 1,
      anon_sym_STAR,
    ACTIONS(4162), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4164), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3391), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31829] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(4024), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31906] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [31985] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3946), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32062] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(4024), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32141] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2015), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32218] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3782), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32283] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3782), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32348] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2015), 1,
      anon_sym_RBRACE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32427] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3966), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32506] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(4170), 1,
      anon_sym_DOT,
    STATE(1630), 1,
      sym_arguments,
    ACTIONS(4166), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4168), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [32565] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(3966), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1788), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [32697] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3773), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32762] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3773), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32827] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3918), 1,
      anon_sym_LBRACK,
    ACTIONS(3968), 1,
      anon_sym_STAR,
    ACTIONS(3970), 1,
      anon_sym_async,
    ACTIONS(3972), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3976), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2966), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32896] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2041), 1,
      anon_sym_RBRACE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [32975] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2041), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33052] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3968), 1,
      anon_sym_STAR,
    ACTIONS(4172), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4174), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33119] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3785), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33184] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3785), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33249] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3776), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4010), 1,
      anon_sym_is,
    ACTIONS(4176), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4178), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4180), 1,
      anon_sym_is,
    ACTIONS(4082), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4084), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33424] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2039), 1,
      anon_sym_RBRACE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33503] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4066), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3478), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [33565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4182), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4184), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33617] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4190), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [33725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4236), 1,
      anon_sym_DOT,
    ACTIONS(4232), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4234), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2113), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2115), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33831] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4238), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [33939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4244), 1,
      anon_sym_DOT,
    ACTIONS(4240), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [33993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4247), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4249), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4082), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4084), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4255), 1,
      anon_sym_LBRACK,
    ACTIONS(4251), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4253), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4176), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4178), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [34257] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4257), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [34365] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4259), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [34473] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 19,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [34547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4268), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4270), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4272), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4274), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [34651] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [34735] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(4196), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4276), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4278), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [34799] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [34897] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [34997] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [35077] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4261), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4263), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [35169] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [35263] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 10,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [35359] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [35437] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4265), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 18,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [35515] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4261), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [35603] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [35705] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4280), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [35813] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4282), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [35921] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4038), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3513), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [35983] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4284), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [36091] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4286), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [36199] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4288), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [36307] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4140), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3498), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36369] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4290), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [36477] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4060), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3494), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36539] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4072), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3491), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36601] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4162), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3391), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4292), 1,
      sym__automatic_semicolon,
    ACTIONS(1533), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1535), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4160), 1,
      sym__automatic_semicolon,
    ACTIONS(1473), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1479), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    STATE(1777), 1,
      sym_arguments,
    ACTIONS(4294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4296), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36827] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4024), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [36899] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(4304), 1,
      anon_sym_PIPE,
    ACTIONS(4306), 1,
      anon_sym_extends,
    ACTIONS(4298), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4300), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [36957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_extends,
    ACTIONS(4298), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4300), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37011] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4310), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [37121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3259), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3261), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37173] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4312), 1,
      anon_sym_LBRACE,
    STATE(1683), 1,
      sym_statement_block,
    ACTIONS(1487), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1491), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37229] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4312), 1,
      anon_sym_LBRACE,
    ACTIONS(4314), 1,
      anon_sym_DOT,
    STATE(1683), 1,
      sym_statement_block,
    ACTIONS(1487), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1491), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37287] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4172), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37349] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4004), 1,
      anon_sym_QMARK_DOT,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(1569), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1573), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [37463] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4098), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3413), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37525] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4144), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3425), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3269), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3271), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [37639] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(133), 1,
      anon_sym_STAR,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(1786), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4320), 1,
      anon_sym_async,
    ACTIONS(4324), 1,
      anon_sym_static,
    ACTIONS(4326), 1,
      anon_sym_readonly,
    ACTIONS(4332), 1,
      anon_sym_override,
    STATE(2476), 1,
      sym_accessibility_modifier,
    STATE(2491), 1,
      sym_override_modifier,
    ACTIONS(4318), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4322), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4328), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4330), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
    STATE(3350), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(4414), 3,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
    ACTIONS(4316), 18,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37723] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37795] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4156), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3489), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37857] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2039), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37929] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4048), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3465), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [37991] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(2093), 1,
      anon_sym_readonly,
    ACTIONS(2097), 1,
      anon_sym_override,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    STATE(2502), 1,
      sym_override_modifier,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4334), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3267), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38121] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4128), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3388), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38183] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4094), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38245] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4124), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3463), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1625), 31,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [38359] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2041), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38431] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3966), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38503] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4337), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [38611] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(4304), 1,
      anon_sym_PIPE,
    ACTIONS(4339), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4341), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38667] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2015), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4343), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4345), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38791] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3946), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [38863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4349), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4349), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [38967] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4351), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3515), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4353), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4355), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4357), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4359), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(4361), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4363), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4365), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4367), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4369), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39343] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(4304), 1,
      anon_sym_PIPE,
    ACTIONS(4306), 1,
      anon_sym_extends,
    ACTIONS(4377), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4379), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39401] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4253), 1,
      anon_sym_extends,
    ACTIONS(4255), 1,
      anon_sym_LBRACK,
    ACTIONS(4251), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4381), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4383), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [39515] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4385), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3193), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3331), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4387), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4389), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39629] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4391), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3444), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [39691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4255), 1,
      anon_sym_LBRACK,
    ACTIONS(4393), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4395), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4397), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4399), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4349), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2111), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4403), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [39953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4403), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4403), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4409), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4411), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4409), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4411), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4409), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4411), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2782), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4413), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4415), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4417), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4419), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2105), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2107), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4421), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4423), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4425), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4427), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4429), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4431), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4437), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4439), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4437), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4439), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2936), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4437), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4439), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [40993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4443), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [41045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4443), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [41097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4443), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [41149] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4449), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4445), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4447), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41221] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4456), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4452), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4454), 19,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [41297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4461), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [41349] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(2115), 1,
      anon_sym_extends,
    ACTIONS(4463), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4466), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1475), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41409] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_extends,
    ACTIONS(4471), 1,
      anon_sym_EQ,
    ACTIONS(4475), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4478), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4469), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41469] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4481), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [41577] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4487), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4483), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4485), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [41647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4490), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4492), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [41699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4494), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4496), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [41751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4498), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4500), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [41803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4502), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4504), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [41855] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(4304), 1,
      anon_sym_PIPE,
    ACTIONS(4306), 1,
      anon_sym_extends,
    ACTIONS(4506), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [41913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [41965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4510), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4512), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(4514), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4516), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2121), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2123), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4365), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4367), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 28,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4524), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2117), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2119), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4526), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4528), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4530), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4532), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4534), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4536), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4538), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4540), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4542), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4544), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4534), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4536), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4542), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4544), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4546), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4548), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4550), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42803] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(4304), 1,
      anon_sym_PIPE,
    ACTIONS(4306), 1,
      anon_sym_extends,
    ACTIONS(4554), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4556), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [42861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4560), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4524), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [42965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4554), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4556), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [43017] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(4304), 1,
      anon_sym_PIPE,
    ACTIONS(4306), 1,
      anon_sym_extends,
    ACTIONS(4562), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4564), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43075] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4302), 1,
      anon_sym_AMP,
    ACTIONS(4304), 1,
      anon_sym_PIPE,
    ACTIONS(4306), 1,
      anon_sym_extends,
    ACTIONS(4566), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4568), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [43133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2918), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2920), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [43185] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3194), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3331), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [43247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4572), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4574), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [43299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4546), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4548), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [43351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4560), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [43403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4572), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4574), 31,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_implements,
  [43455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1609), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1611), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [43506] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4337), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [43613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1535), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [43664] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4628), 1,
      anon_sym_COMMA,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4662), 1,
      sym__ternary_qmark,
    STATE(3239), 1,
      sym_type_arguments,
    STATE(3867), 1,
      aux_sym_extends_clause_repeat1,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4626), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [43775] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4696), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4698), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4288), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [43882] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4696), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4698), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4286), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [43989] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4696), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4698), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4284), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [44096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4702), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1623), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1625), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44198] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3926), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [44255] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3926), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [44312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4704), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4706), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44363] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4257), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [44470] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4710), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4714), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4708), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4712), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [44525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1719), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1721), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44576] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4259), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [44683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4190), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44734] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4718), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [44807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4721), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4723), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4725), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4727), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4729), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4731), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [44960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4733), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4735), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [45011] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [45094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1587), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [45145] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_LT,
    ACTIONS(4739), 1,
      anon_sym_DOT,
    ACTIONS(4741), 1,
      anon_sym_is,
    STATE(1989), 1,
      sym_type_arguments,
    ACTIONS(4006), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3383), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [45204] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4696), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4698), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4282), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [45311] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4696), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4698), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4280), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [45418] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [45519] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4743), 1,
      anon_sym_abstract,
    ACTIONS(4570), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3194), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3331), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [45582] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4745), 1,
      anon_sym_readonly,
    STATE(2514), 1,
      sym_override_modifier,
    ACTIONS(4570), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3194), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3331), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [45649] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4261), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 12,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [45736] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4747), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [45813] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4747), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [45890] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [45985] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [46078] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [46169] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4747), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [46248] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [46347] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [46446] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [46543] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4718), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [46622] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4178), 1,
      anon_sym_extends,
    ACTIONS(4750), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4753), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1585), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1587), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46730] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [46813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1637), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [46864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4756), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [46915] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4747), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [46988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1581), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47039] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4696), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4698), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4259), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [47146] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_extends,
    ACTIONS(4760), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4763), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4756), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4766), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4770), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4772), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47305] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4696), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4698), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4257), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [47412] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4774), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4445), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4447), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [47483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4777), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47534] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [47625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4781), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4783), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4785), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4787), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4789), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4791), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47778] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3364), 1,
      anon_sym_COLON,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(4793), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(4678), 1,
      sym_type_annotation,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [47891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4795), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4797), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [47942] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4471), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4799), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4469), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [47997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4801), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4259), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48048] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [48141] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3364), 1,
      anon_sym_COLON,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(4803), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(4724), 1,
      sym_type_annotation,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [48254] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [48349] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4718), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48426] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4718), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48503] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4805), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4452), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4454), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [48578] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 9,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [48675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4808), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4810), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4812), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4814), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4818), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4820), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4280), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1637), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [48930] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [49031] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4481), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [49138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4822), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4824), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49189] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4280), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [49296] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4282), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [49403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4828), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49454] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4270), 1,
      anon_sym_extends,
    ACTIONS(4830), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1573), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4838), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3902), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [49715] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4238), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [49822] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4696), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4698), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4238), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [49929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4840), 1,
      sym__automatic_semicolon,
    ACTIONS(1473), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1479), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [49982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4842), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4844), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4846), 1,
      sym__automatic_semicolon,
    ACTIONS(1533), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1535), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [50086] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4261), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 12,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [50173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4850), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1609), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1611), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1525), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1529), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1591), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1595), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4852), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4854), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4856), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4284), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4858), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4860), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4286), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [50581] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4737), 1,
      anon_sym_LT,
    ACTIONS(4864), 1,
      anon_sym_QMARK_DOT,
    STATE(2080), 1,
      sym_type_arguments,
    STATE(2112), 1,
      sym_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(3992), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3994), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [50648] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4866), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4483), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4485), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [50717] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4869), 1,
      anon_sym_readonly,
    STATE(2511), 1,
      sym_override_modifier,
    ACTIONS(4385), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3193), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3331), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [50784] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4696), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4698), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4190), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [50891] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4696), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4698), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4337), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [50998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4288), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4873), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4875), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1705), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4877), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51202] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4666), 1,
      anon_sym_GT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4696), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4698), 1,
      sym__ternary_qmark,
    ACTIONS(4883), 1,
      anon_sym_in,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4881), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [51311] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4022), 1,
      anon_sym_abstract,
    ACTIONS(4385), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3193), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3331), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [51374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4886), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4888), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1615), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1619), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51476] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4696), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4698), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4290), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [51583] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4668), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4276), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4278), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [51646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4890), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4892), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4896), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [51748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1521), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [51799] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4588), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4276), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4278), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [51862] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4898), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [51969] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4900), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4483), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4485), 21,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [52038] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3364), 1,
      anon_sym_COLON,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(4903), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(4808), 1,
      sym_type_annotation,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52151] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4668), 1,
      anon_sym_LT,
    ACTIONS(4670), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4672), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4674), 1,
      anon_sym_GT_GT,
    ACTIONS(4678), 1,
      anon_sym_AMP,
    ACTIONS(4680), 1,
      anon_sym_CARET,
    ACTIONS(4682), 1,
      anon_sym_PIPE,
    ACTIONS(4686), 1,
      anon_sym_PERCENT,
    ACTIONS(4688), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4696), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4698), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4666), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4676), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4684), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4692), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4694), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4690), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4481), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
  [52258] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4905), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4452), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4454), 18,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52333] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3364), 1,
      anon_sym_COLON,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(4908), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(4726), 1,
      sym_type_annotation,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52446] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4910), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4445), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4447), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [52517] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    ACTIONS(4913), 1,
      anon_sym_COMMA,
    ACTIONS(4916), 1,
      anon_sym_RBRACE,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4918), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52628] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4916), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4920), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52737] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4922), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1475), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [52792] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    ACTIONS(4913), 1,
      anon_sym_COMMA,
    ACTIONS(4916), 1,
      anon_sym_RBRACE,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4337), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [52903] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4334), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [52974] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4334), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [53043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1691), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1695), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4471), 1,
      anon_sym_EQ,
    ACTIONS(4469), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4926), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1737), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1715), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53300] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4290), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [53407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1539), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1543), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1559), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1563), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4928), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4930), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53560] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4288), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [53667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1601), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1605), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1553), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53769] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    ACTIONS(4916), 1,
      anon_sym_RBRACE,
    ACTIONS(4932), 1,
      anon_sym_COMMA,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4257), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [53880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(1475), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [53933] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    ACTIONS(4935), 1,
      anon_sym_COMMA,
    ACTIONS(4938), 1,
      anon_sym_RBRACE,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4257), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1625), 1,
      anon_sym_DOT,
    ACTIONS(4242), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(4240), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_EQ,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_extends,
  [54097] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(2093), 1,
      anon_sym_readonly,
    ACTIONS(2097), 1,
      anon_sym_override,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    STATE(2502), 1,
      sym_override_modifier,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4940), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [54172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1521), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [54223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_EQ,
    ACTIONS(4708), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4712), 29,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [54276] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4286), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [54383] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4284), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [54490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1535), 30,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [54541] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4190), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [54648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1719), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1721), 30,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_while,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE_RBRACE,
  [54699] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    ACTIONS(4942), 1,
      anon_sym_COMMA,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4944), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54807] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4662), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4259), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [54913] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4471), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4946), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4469), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [54967] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3434), 1,
      anon_sym_QMARK,
    ACTIONS(3438), 1,
      anon_sym_EQ,
    ACTIONS(3441), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [55023] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4949), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(4274), 1,
      aux_sym_array_repeat1,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55133] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4951), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4483), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4485), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [55201] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4337), 1,
      anon_sym_COMMA,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4918), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55309] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4662), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4481), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55415] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4954), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4452), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4454), 17,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [55489] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4957), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4445), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4447), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [55559] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(2041), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [55621] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(2041), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [55683] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(4632), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4276), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4278), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_implements,
  [55745] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4662), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4290), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55851] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4662), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4288), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [55957] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4881), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [56063] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4662), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4286), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56169] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4662), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4284), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56275] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4662), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4282), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56381] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4662), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4280), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [56487] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4940), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [56555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1462), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1460), 29,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
      anon_sym_is,
  [56605] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(4940), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [56671] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [56771] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4261), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [56857] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4960), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 16,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [56933] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4960), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [57009] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4963), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3210), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3331), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [57069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4965), 1,
      anon_sym_is,
    ACTIONS(4082), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4084), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57121] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    ACTIONS(4942), 1,
      anon_sym_COMMA,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4310), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57229] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_LT,
    STATE(2006), 1,
      sym_type_arguments,
    ACTIONS(4082), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4084), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57283] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4967), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3129), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_QMARK,
    ACTIONS(3331), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [57343] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4969), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(4164), 1,
      aux_sym_array_repeat1,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4741), 1,
      anon_sym_is,
    ACTIONS(4176), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4178), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [57505] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [57599] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [57691] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(4270), 1,
      anon_sym_extends,
    ACTIONS(4830), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [57749] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    ACTIONS(4942), 1,
      anon_sym_COMMA,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4971), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57857] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4662), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4337), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [57963] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [58053] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3966), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [58115] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(4463), 1,
      anon_sym_LBRACK,
    ACTIONS(4466), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4973), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(2115), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1475), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58175] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3966), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [58237] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4881), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [58343] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4977), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(4180), 1,
      aux_sym_array_repeat1,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [58453] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(4024), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [58515] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(4024), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [58577] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(2015), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [58639] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4960), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [58717] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(2015), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [58779] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4334), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [58843] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4471), 1,
      anon_sym_EQ,
    ACTIONS(4475), 1,
      anon_sym_LBRACK,
    ACTIONS(4478), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4979), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(4355), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4469), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [58903] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [59001] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4662), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4190), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59107] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
      anon_sym_implements,
  [59203] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4983), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(4150), 1,
      aux_sym_array_repeat1,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59313] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4985), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(3996), 1,
      aux_sym_array_repeat1,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59423] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_EQ,
    ACTIONS(4830), 1,
      anon_sym_LBRACK,
    ACTIONS(4833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4270), 6,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59481] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3456), 1,
      anon_sym_QMARK,
    ACTIONS(3454), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59537] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_EQ,
    ACTIONS(3434), 1,
      anon_sym_QMARK,
    ACTIONS(3431), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [59593] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4662), 1,
      sym__ternary_qmark,
    STATE(3317), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4987), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [59699] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(2039), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [59761] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(2039), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [59823] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4989), 1,
      anon_sym_RBRACK,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(3999), 1,
      aux_sym_array_repeat1,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [59933] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    ACTIONS(4942), 1,
      anon_sym_COMMA,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4991), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60041] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4993), 1,
      anon_sym_DOT,
    STATE(2071), 1,
      sym_arguments,
    ACTIONS(4166), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4168), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60097] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3946), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [60159] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    ACTIONS(4942), 1,
      anon_sym_COMMA,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4995), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60267] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3946), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [60329] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4997), 1,
      anon_sym_RBRACK,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(4159), 1,
      aux_sym_array_repeat1,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60439] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [60521] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4999), 1,
      anon_sym_RBRACK,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(3999), 1,
      aux_sym_array_repeat1,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60631] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4960), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_implements,
  [60703] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(5001), 1,
      anon_sym_DOT,
    STATE(2070), 1,
      sym_arguments,
    ACTIONS(4134), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4136), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60759] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(5003), 1,
      anon_sym_DOT,
    STATE(2042), 1,
      sym_arguments,
    ACTIONS(3391), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3387), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [60815] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(2115), 1,
      anon_sym_extends,
    ACTIONS(4463), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4466), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1475), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [60873] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4337), 1,
      anon_sym_COMMA,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5005), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [60981] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4662), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4238), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61087] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(5007), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(4146), 1,
      aux_sym_array_repeat1,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61197] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    ACTIONS(4942), 1,
      anon_sym_COMMA,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5009), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61305] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4588), 1,
      anon_sym_LT,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4592), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4594), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4596), 1,
      anon_sym_GT_GT,
    ACTIONS(4600), 1,
      anon_sym_AMP,
    ACTIONS(4602), 1,
      anon_sym_CARET,
    ACTIONS(4604), 1,
      anon_sym_PIPE,
    ACTIONS(4608), 1,
      anon_sym_PERCENT,
    ACTIONS(4610), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4618), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4622), 1,
      sym__ternary_qmark,
    ACTIONS(4942), 1,
      anon_sym_COMMA,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4576), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4584), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4598), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4606), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4614), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4616), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5011), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4612), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61413] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4710), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5013), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(4708), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4712), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61467] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(2043), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [61529] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(2043), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [61591] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_extends,
    ACTIONS(4471), 1,
      anon_sym_EQ,
    ACTIONS(4475), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4478), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4469), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [61649] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4632), 1,
      anon_sym_LT,
    ACTIONS(4634), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4638), 1,
      anon_sym_GT_GT,
    ACTIONS(4642), 1,
      anon_sym_AMP,
    ACTIONS(4644), 1,
      anon_sym_CARET,
    ACTIONS(4646), 1,
      anon_sym_PIPE,
    ACTIONS(4650), 1,
      anon_sym_PERCENT,
    ACTIONS(4652), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4660), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4662), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4624), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4630), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4640), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4648), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4656), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4658), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4257), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
    ACTIONS(4654), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [61755] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5016), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [61861] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(5018), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [61967] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5020), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1475), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62021] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_LT,
    ACTIONS(4739), 1,
      anon_sym_DOT,
    STATE(1989), 1,
      sym_type_arguments,
    ACTIONS(4006), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3383), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62077] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(5023), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(4235), 1,
      aux_sym_array_repeat1,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62187] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4261), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 10,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [62272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4542), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4544), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62321] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5043), 1,
      anon_sym_AMP,
    ACTIONS(5045), 1,
      anon_sym_PIPE,
    ACTIONS(5047), 1,
      anon_sym_extends,
    ACTIONS(4566), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4568), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62376] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5043), 1,
      anon_sym_AMP,
    ACTIONS(5045), 1,
      anon_sym_PIPE,
    ACTIONS(5047), 1,
      anon_sym_extends,
    ACTIONS(4562), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4564), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4425), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4427), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4554), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4556), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62529] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4337), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62634] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4190), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [62739] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5043), 1,
      anon_sym_AMP,
    ACTIONS(5045), 1,
      anon_sym_PIPE,
    ACTIONS(5047), 1,
      anon_sym_extends,
    ACTIONS(4554), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4556), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [62794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4550), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4552), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4244), 1,
      anon_sym_DOT,
    ACTIONS(4240), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4242), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [62894] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5067), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4445), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4447), 17,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [62963] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5070), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4452), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4454), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [63036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4538), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4540), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63085] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4481), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4182), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4184), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4421), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4423), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63288] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5073), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4483), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4485), 19,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [63355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2918), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2920), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [63404] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4238), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63509] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4938), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63614] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_extends,
    ACTIONS(4760), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4763), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4756), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63669] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4365), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4367), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63722] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4916), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63827] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [63880] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4257), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [63985] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4259), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64090] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5076), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 16,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [64161] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 13,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [64242] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5079), 1,
      anon_sym_RBRACK,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [64349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4572), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4574), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [64398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4546), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4548), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [64447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4572), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4574), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [64496] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [64591] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 6,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [64688] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5076), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [64765] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [64854] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 8,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [64945] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 7,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [65038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2113), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2115), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4443), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65136] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5076), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [65211] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5076), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 15,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [65286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4272), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4274), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65335] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 5,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
  [65434] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_extends,
    ACTIONS(4475), 1,
      anon_sym_LBRACK,
    ACTIONS(5081), 1,
      anon_sym_RPAREN,
    ACTIONS(4471), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4478), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4799), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4469), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [65495] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(5029), 1,
      anon_sym_LT,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4276), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4278), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [65556] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5084), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2121), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2123), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4490), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4492), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [65761] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4280), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65866] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    ACTIONS(5086), 1,
      anon_sym_SEMI,
    ACTIONS(5088), 1,
      sym__automatic_semicolon,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [65973] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4282), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66078] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(4864), 1,
      anon_sym_QMARK_DOT,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(1569), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1573), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4546), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4548), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66184] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5090), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66289] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5092), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4524), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3267), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4560), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66543] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5094), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66648] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(5096), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [66753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2782), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4471), 1,
      anon_sym_EQ,
    ACTIONS(4469), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [66853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2105), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2107), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4417), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4419), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [66951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4524), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4560), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4353), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4355), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4357), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4359), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67147] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5043), 1,
      anon_sym_AMP,
    ACTIONS(4361), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4363), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4365), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4367), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4369), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4371), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4375), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67345] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5043), 1,
      anon_sym_AMP,
    ACTIONS(5045), 1,
      anon_sym_PIPE,
    ACTIONS(5047), 1,
      anon_sym_extends,
    ACTIONS(4377), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4379), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67400] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4178), 1,
      anon_sym_extends,
    ACTIONS(4750), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_RPAREN,
    ACTIONS(4753), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5098), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5100), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67461] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3434), 1,
      anon_sym_QMARK,
    ACTIONS(3438), 1,
      anon_sym_EQ,
    ACTIONS(4830), 1,
      anon_sym_LBRACK,
    ACTIONS(3441), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4270), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67522] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4253), 1,
      anon_sym_extends,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(4251), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4381), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4383), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67577] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4284), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4443), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67731] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4286), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [67836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5107), 1,
      anon_sym_DOT,
    ACTIONS(4232), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4234), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [67938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4409), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4411), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [67987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4387), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4389), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(4393), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4395), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4437), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4439), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4409), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4411), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4429), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4431), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4397), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4399), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4247), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4249), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4534), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4536), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4542), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4544), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4534), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4536), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68528] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4288), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68633] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5109), 1,
      anon_sym_RBRACK,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [68740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4530), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4532), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4526), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4528), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 27,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [68889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2117), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2119), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [68938] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4920), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69043] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4365), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4367), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69096] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4178), 1,
      anon_sym_extends,
    ACTIONS(4750), 1,
      anon_sym_LBRACK,
    ACTIONS(5115), 1,
      anon_sym_RPAREN,
    ACTIONS(4753), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5111), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5113), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4437), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4439), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 1,
      sym_regex_flags,
    ACTIONS(5118), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(5120), 25,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4082), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4084), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69355] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    ACTIONS(5124), 1,
      anon_sym_SEMI,
    ACTIONS(5126), 1,
      sym__automatic_semicolon,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2936), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [69511] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3436), 1,
      anon_sym_EQ,
    ACTIONS(4270), 1,
      anon_sym_extends,
    ACTIONS(4830), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69568] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4178), 1,
      anon_sym_extends,
    ACTIONS(4750), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4753), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69623] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4290), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69728] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5128), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69835] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5130), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [69942] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4753), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4750), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4178), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [69997] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5132), 1,
      anon_sym_RBRACK,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70104] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4763), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4760), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4371), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(4756), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4409), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4411), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [70208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5105), 1,
      anon_sym_LBRACK,
    ACTIONS(4251), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4253), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [70259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4435), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [70308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3259), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3261), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [70357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4403), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [70406] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4830), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4270), 4,
      sym__automatic_semicolon,
      anon_sym_SEMI,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70461] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4353), 1,
      anon_sym_QMARK,
    ACTIONS(4355), 1,
      anon_sym_extends,
    ACTIONS(4471), 1,
      anon_sym_EQ,
    ACTIONS(4475), 1,
      anon_sym_LBRACK,
    ACTIONS(4799), 1,
      anon_sym_COLON,
    ACTIONS(4478), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4979), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4469), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(2111), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [70573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4407), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [70622] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(2113), 1,
      anon_sym_QMARK,
    ACTIONS(2115), 1,
      anon_sym_extends,
    ACTIONS(4463), 1,
      anon_sym_LBRACK,
    ACTIONS(4922), 1,
      anon_sym_COLON,
    ACTIONS(4466), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4973), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1475), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70685] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(4270), 1,
      anon_sym_extends,
    ACTIONS(4830), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4403), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [70791] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5134), 1,
      anon_sym_COLON,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [70898] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_EQ,
    ACTIONS(3434), 1,
      anon_sym_QMARK,
    ACTIONS(4830), 1,
      anon_sym_LBRACK,
    ACTIONS(3431), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4270), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [70959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4403), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71008] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4178), 1,
      anon_sym_extends,
    ACTIONS(4750), 1,
      anon_sym_LBRACK,
    ACTIONS(5139), 1,
      anon_sym_RPAREN,
    ACTIONS(4753), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5098), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5136), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71069] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5143), 1,
      anon_sym_RBRACK,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4176), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4178), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4437), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4439), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4349), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4349), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71372] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4578), 1,
      anon_sym_as,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5029), 1,
      anon_sym_LT,
    ACTIONS(5031), 1,
      anon_sym_GT_GT,
    ACTIONS(5037), 1,
      anon_sym_PERCENT,
    ACTIONS(5039), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5049), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5051), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5053), 1,
      anon_sym_AMP,
    ACTIONS(5055), 1,
      anon_sym_CARET,
    ACTIONS(5057), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5065), 1,
      sym__ternary_qmark,
    ACTIONS(5145), 1,
      anon_sym_SEMI,
    ACTIONS(5147), 1,
      sym__automatic_semicolon,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4620), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5025), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5027), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5033), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5035), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5059), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5061), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5041), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [71479] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4084), 1,
      anon_sym_extends,
    ACTIONS(4298), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4300), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71530] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4270), 1,
      anon_sym_extends,
    ACTIONS(4830), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4268), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4270), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4349), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(1475), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71734] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4940), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [71795] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_extends,
    ACTIONS(4475), 1,
      anon_sym_LBRACK,
    ACTIONS(4979), 1,
      anon_sym_RPAREN,
    ACTIONS(4471), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4478), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4946), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(4469), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3269), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3271), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [71905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_EQ,
    ACTIONS(4708), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4712), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [71956] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5043), 1,
      anon_sym_AMP,
    ACTIONS(5045), 1,
      anon_sym_PIPE,
    ACTIONS(5047), 1,
      anon_sym_extends,
    ACTIONS(4298), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4300), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72011] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5149), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72118] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2115), 1,
      anon_sym_extends,
    ACTIONS(4463), 1,
      anon_sym_LBRACK,
    ACTIONS(5151), 1,
      anon_sym_RPAREN,
    ACTIONS(1477), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4466), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4922), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1475), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72179] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5154), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72286] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2115), 1,
      anon_sym_extends,
    ACTIONS(4463), 1,
      anon_sym_LBRACK,
    ACTIONS(4973), 1,
      anon_sym_RPAREN,
    ACTIONS(1477), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4466), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5020), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1475), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4413), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4415), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4461), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72445] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(4463), 1,
      anon_sym_LBRACK,
    ACTIONS(2115), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4466), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1475), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72502] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4471), 1,
      anon_sym_EQ,
    ACTIONS(4475), 1,
      anon_sym_LBRACK,
    ACTIONS(4355), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4478), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4469), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4343), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4345), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4494), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4496), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72657] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5043), 1,
      anon_sym_AMP,
    ACTIONS(5045), 1,
      anon_sym_PIPE,
    ACTIONS(4339), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4341), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4498), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4500), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72759] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5156), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [72866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4502), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4504), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [72915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    STATE(2149), 1,
      sym_arguments,
    ACTIONS(4294), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4296), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [72968] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5043), 1,
      anon_sym_AMP,
    ACTIONS(5045), 1,
      anon_sym_PIPE,
    ACTIONS(5047), 1,
      anon_sym_extends,
    ACTIONS(4506), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4508), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [73072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4510), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4512), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [73121] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(2766), 1,
      sym__automatic_semicolon,
    ACTIONS(1479), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1475), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4443), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [73225] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5158), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73332] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(4840), 1,
      sym__automatic_semicolon,
    ACTIONS(1473), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1479), 26,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73385] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5160), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73492] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5162), 1,
      anon_sym_RBRACE,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5043), 1,
      anon_sym_AMP,
    ACTIONS(4514), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4516), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [73650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4520), 28,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_extends,
  [73699] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5164), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73804] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4196), 1,
      anon_sym_LT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4200), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4202), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4204), 1,
      anon_sym_GT_GT,
    ACTIONS(4208), 1,
      anon_sym_AMP,
    ACTIONS(4210), 1,
      anon_sym_CARET,
    ACTIONS(4212), 1,
      anon_sym_PIPE,
    ACTIONS(4216), 1,
      anon_sym_PERCENT,
    ACTIONS(4218), 1,
      anon_sym_STAR_STAR,
    ACTIONS(4226), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(4230), 1,
      sym__ternary_qmark,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(5166), 1,
      anon_sym_RPAREN,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4186), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(4194), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(4206), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(4214), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(4222), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4224), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4220), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [73911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4808), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4810), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [73959] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2097), 1,
      anon_sym_override,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5168), 1,
      anon_sym_STAR,
    ACTIONS(5170), 1,
      anon_sym_async,
    ACTIONS(5174), 1,
      anon_sym_readonly,
    STATE(2495), 1,
      sym_override_modifier,
    ACTIONS(5172), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5176), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [74029] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5178), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 14,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [74103] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5178), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [74177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4729), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4731), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4886), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4888), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74273] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3485), 1,
      anon_sym_EQ,
    ACTIONS(4270), 1,
      anon_sym_extends,
    ACTIONS(4830), 2,
      anon_sym_COMMA,
      anon_sym_LBRACK,
    ACTIONS(4833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [74329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1581), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4770), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4772), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      sym__automatic_semicolon,
    ACTIONS(1551), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1549), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1553), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74477] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4261), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [74561] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_QMARK_QMARK,
  [74659] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 1,
      sym__automatic_semicolon,
    ACTIONS(1603), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1601), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1605), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74711] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4881), 1,
      anon_sym_of,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5187), 1,
      anon_sym_GT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    ACTIONS(5213), 1,
      anon_sym_in,
    ACTIONS(5216), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5218), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74817] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4280), 1,
      anon_sym_of,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    ACTIONS(5216), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5218), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [74921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4777), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4779), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [74969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4781), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4783), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4785), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4787), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4789), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4791), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75113] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_EQ,
    ACTIONS(4714), 1,
      anon_sym_of,
    ACTIONS(5220), 1,
      anon_sym_in,
    ACTIONS(4708), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4712), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4795), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4797), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75215] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(4922), 1,
      anon_sym_of,
    ACTIONS(5223), 1,
      anon_sym_in,
    ACTIONS(1475), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75269] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [75359] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [75447] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5226), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5228), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4801), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4259), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75547] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5178), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [75623] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5234), 1,
      anon_sym_COLON,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [75727] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4471), 1,
      anon_sym_EQ,
    ACTIONS(4799), 1,
      anon_sym_of,
    ACTIONS(5268), 1,
      anon_sym_in,
    ACTIONS(4469), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75781] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5271), 1,
      anon_sym_LPAREN,
    ACTIONS(5274), 1,
      anon_sym_COLON,
    ACTIONS(5276), 1,
      anon_sym_LT,
    ACTIONS(5279), 1,
      anon_sym_QMARK,
    ACTIONS(4704), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4706), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75837] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5283), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75889] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(4463), 1,
      anon_sym_LBRACK,
    ACTIONS(4922), 1,
      anon_sym_COLON,
    ACTIONS(4466), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(2115), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(1475), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [75947] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4471), 1,
      anon_sym_EQ,
    ACTIONS(4475), 1,
      anon_sym_LBRACK,
    ACTIONS(4799), 1,
      anon_sym_COLON,
    ACTIONS(4478), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4355), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4469), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76005] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [76101] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3436), 1,
      anon_sym_EQ,
    ACTIONS(3535), 1,
      anon_sym_in,
    ACTIONS(3538), 1,
      anon_sym_of,
    ACTIONS(3293), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76155] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [76249] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [76329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 1,
      sym__automatic_semicolon,
    ACTIONS(1561), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1559), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1563), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76381] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1545), 1,
      sym__automatic_semicolon,
    ACTIONS(1541), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1539), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1543), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5285), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5287), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76485] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4282), 1,
      anon_sym_of,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    ACTIONS(5216), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5218), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76589] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4284), 1,
      anon_sym_of,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    ACTIONS(5216), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5218), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76693] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4286), 1,
      anon_sym_of,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    ACTIONS(5216), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5218), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76797] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_of,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    ACTIONS(5216), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5218), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [76901] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2926), 1,
      sym__automatic_semicolon,
    ACTIONS(1713), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1711), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1715), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [76953] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2940), 1,
      sym__automatic_semicolon,
    ACTIONS(1735), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1733), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1737), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77005] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5226), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5228), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77057] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4290), 1,
      anon_sym_of,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    ACTIONS(5216), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5218), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77161] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 1,
      anon_sym_extends,
    ACTIONS(4763), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4760), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(4756), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1697), 1,
      sym__automatic_semicolon,
    ACTIONS(1693), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1691), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1695), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1571), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1569), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1573), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77317] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_EQ,
    ACTIONS(4830), 1,
      anon_sym_LBRACK,
    ACTIONS(4270), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5226), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5228), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 1,
      sym_regex_flags,
    ACTIONS(5118), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(5120), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3427), 1,
      anon_sym_EQ,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4877), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4879), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77573] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    ACTIONS(5291), 1,
      anon_sym_COLON,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [77677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1705), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1559), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1563), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4928), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4930), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4873), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4875), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1539), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1543), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4838), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [77965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4288), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4716), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4190), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78061] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(4463), 1,
      anon_sym_LBRACK,
    ACTIONS(2115), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4466), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1475), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78117] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5178), 1,
      anon_sym_LT,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [78187] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4259), 1,
      anon_sym_of,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    ACTIONS(5216), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5218), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78291] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4257), 1,
      anon_sym_of,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    ACTIONS(5216), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5218), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78395] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4471), 1,
      anon_sym_EQ,
    ACTIONS(4475), 1,
      anon_sym_LBRACK,
    ACTIONS(4355), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4478), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4469), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78451] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4238), 1,
      anon_sym_of,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    ACTIONS(5216), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5218), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1715), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1737), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1615), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1619), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4924), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4926), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [78747] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4190), 1,
      anon_sym_of,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    ACTIONS(5216), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5218), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78851] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4337), 1,
      anon_sym_of,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    ACTIONS(5216), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5218), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [78955] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4750), 1,
      anon_sym_LBRACK,
    ACTIONS(4178), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4753), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79009] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(5189), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4276), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4278), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [79069] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(4334), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [79123] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5098), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5100), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79175] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(4334), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [79229] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4268), 1,
      anon_sym_QMARK,
    ACTIONS(4270), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4830), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79285] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    ACTIONS(5293), 1,
      anon_sym_COLON,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4286), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4858), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4860), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4828), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79533] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4270), 1,
      anon_sym_extends,
    ACTIONS(4833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4830), 3,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4890), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4892), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79635] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    ACTIONS(5295), 1,
      anon_sym_COLON,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [79739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4856), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4284), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4852), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4854), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1591), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1595), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79883] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5297), 1,
      anon_sym_LPAREN,
    ACTIONS(5299), 1,
      anon_sym_DOT,
    STATE(2444), 1,
      sym_arguments,
    ACTIONS(3239), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3237), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [79937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1525), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1529), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [79985] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [80077] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5301), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5303), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80129] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1571), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1569), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1573), 25,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5307), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80231] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5313), 1,
      anon_sym_RBRACK,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5343), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5345), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80335] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5343), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5345), 1,
      sym__ternary_qmark,
    ACTIONS(5347), 1,
      anon_sym_RBRACK,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4894), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4896), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80487] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1621), 1,
      sym__automatic_semicolon,
    ACTIONS(1617), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1615), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1619), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80539] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    ACTIONS(5349), 1,
      anon_sym_COLON,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [80643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4812), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4814), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4818), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4721), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4723), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4820), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4280), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4725), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4727), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4756), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      sym__automatic_semicolon,
    ACTIONS(1703), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1701), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1705), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [80983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1691), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1695), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81031] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    ACTIONS(5351), 1,
      anon_sym_COLON,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [81135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4733), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4735), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5289), 1,
      sym_regex_flags,
    ACTIONS(5118), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(5120), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4842), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4844), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1573), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      sym__automatic_semicolon,
    ACTIONS(1593), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1591), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1595), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81381] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1531), 1,
      sym__automatic_semicolon,
    ACTIONS(1527), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1525), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1529), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4766), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4768), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1579), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1577), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1581), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81531] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1551), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1549), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1553), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4365), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4367), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_extends,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81633] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5353), 1,
      sym__automatic_semicolon,
    ACTIONS(1603), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1601), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1605), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81685] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5355), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4483), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4485), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [81751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4848), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4850), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81799] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4830), 1,
      anon_sym_LBRACK,
    ACTIONS(4270), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81853] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3357), 1,
      anon_sym_EQ,
    ACTIONS(4268), 1,
      anon_sym_QMARK,
    ACTIONS(4830), 1,
      anon_sym_LBRACK,
    ACTIONS(4833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4270), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [81911] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4481), 1,
      anon_sym_of,
    ACTIONS(5181), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5185), 1,
      anon_sym_PERCENT,
    ACTIONS(5189), 1,
      anon_sym_LT,
    ACTIONS(5191), 1,
      anon_sym_GT_GT,
    ACTIONS(5199), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5201), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5203), 1,
      anon_sym_AMP,
    ACTIONS(5205), 1,
      anon_sym_CARET,
    ACTIONS(5207), 1,
      anon_sym_PIPE,
    ACTIONS(5216), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5218), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5183), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5187), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5193), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5195), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5209), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5197), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82015] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5358), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4452), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4454), 15,
      sym__ternary_qmark,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82087] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5361), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4445), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4447), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_of,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82155] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5098), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5136), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82207] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5364), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4483), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4485), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [82273] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4481), 1,
      anon_sym_COLON,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82377] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5367), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4452), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4454), 15,
      sym__ternary_qmark,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82449] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5370), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4445), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4447), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [82517] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 1,
      anon_sym_LPAREN,
    ACTIONS(5376), 1,
      anon_sym_COLON,
    ACTIONS(5378), 1,
      anon_sym_LT,
    ACTIONS(5381), 1,
      anon_sym_QMARK,
    ACTIONS(3293), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82573] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4369), 1,
      anon_sym_QMARK,
    ACTIONS(4371), 2,
      anon_sym_RPAREN,
      anon_sym_extends,
    ACTIONS(4763), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4760), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(4756), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3902), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3906), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82677] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5283), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82729] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [82833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1559), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1563), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3436), 1,
      anon_sym_EQ,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 26,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [82981] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5281), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5283), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1527), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1525), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1529), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83083] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1591), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1595), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5385), 1,
      sym__automatic_semicolon,
    ACTIONS(1703), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1701), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1705), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1617), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1615), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1619), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83235] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    ACTIONS(5387), 1,
      anon_sym_COLON,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83339] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3454), 1,
      anon_sym_COLON,
    ACTIONS(4830), 1,
      anon_sym_LBRACK,
    ACTIONS(4833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4270), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83397] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(5236), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4276), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4278), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [83457] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5389), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4483), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4485), 18,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [83523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1553), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83571] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1583), 1,
      sym__automatic_semicolon,
    ACTIONS(1579), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(1577), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1581), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83623] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4481), 1,
      anon_sym_RBRACK,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5343), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5345), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [83727] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5392), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4452), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4454), 15,
      sym__ternary_qmark,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [83799] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5395), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4445), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4447), 16,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [83867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1541), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1539), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1543), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1601), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1605), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [83965] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5398), 1,
      sym__automatic_semicolon,
    ACTIONS(1713), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1711), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1715), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84017] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5400), 1,
      sym__automatic_semicolon,
    ACTIONS(1735), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1733), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1737), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1693), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
    ACTIONS(1691), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1695), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84119] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4290), 1,
      anon_sym_COLON,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84223] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_COLON,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84327] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4286), 1,
      anon_sym_COLON,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84431] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4284), 1,
      anon_sym_COLON,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84535] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4337), 1,
      anon_sym_COLON,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84639] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4282), 1,
      anon_sym_COLON,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84743] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4190), 1,
      anon_sym_COLON,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84847] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4280), 1,
      anon_sym_COLON,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [84951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4704), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4706), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [84999] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_QMARK_QMARK,
  [85097] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4261), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [85181] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4238), 1,
      anon_sym_COLON,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85285] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4257), 1,
      anon_sym_COLON,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4700), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4702), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85437] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5402), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5404), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85489] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4760), 1,
      anon_sym_LBRACK,
    ACTIONS(4371), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4763), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4756), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 24,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85543] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5111), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5113), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85595] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    ACTIONS(5406), 1,
      anon_sym_COLON,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85699] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4259), 1,
      anon_sym_COLON,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5240), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5266), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [85803] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5408), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 14,
      sym__ternary_qmark,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [85877] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5408), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [85951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4822), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4824), 27,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [85999] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(5315), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4276), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4278), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [86059] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4290), 1,
      anon_sym_RBRACK,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5343), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5345), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86163] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4337), 1,
      anon_sym_RBRACK,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5343), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5345), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86267] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4190), 1,
      anon_sym_RBRACK,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5343), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5345), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86371] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4238), 1,
      anon_sym_RBRACK,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5343), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5345), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86475] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [86567] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4257), 1,
      anon_sym_RBRACK,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5343), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5345), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86671] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4259), 1,
      anon_sym_RBRACK,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5343), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5345), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86775] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3454), 1,
      anon_sym_COLON,
    ACTIONS(4270), 1,
      anon_sym_extends,
    ACTIONS(4830), 1,
      anon_sym_LBRACK,
    ACTIONS(4833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5411), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [86835] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4288), 1,
      anon_sym_RBRACK,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5343), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5345), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [86939] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [87029] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5415), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [87099] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [87179] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4286), 1,
      anon_sym_RBRACK,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5343), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5345), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87283] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4284), 1,
      anon_sym_RBRACK,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5343), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5345), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87387] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [87475] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5408), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [87551] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5238), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [87647] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5246), 1,
      anon_sym_AMP,
    ACTIONS(5248), 1,
      anon_sym_CARET,
    ACTIONS(5250), 1,
      anon_sym_PIPE,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5232), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5260), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5262), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5258), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [87741] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5236), 1,
      anon_sym_LT,
    ACTIONS(5242), 1,
      anon_sym_GT_GT,
    ACTIONS(5254), 1,
      anon_sym_PERCENT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5230), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5244), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5252), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 12,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [87821] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4282), 1,
      anon_sym_RBRACK,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5343), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5345), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [87925] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4280), 1,
      anon_sym_RBRACK,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5343), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5345), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [88029] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5256), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5408), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [88099] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [88193] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [88289] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5415), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [88365] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [88453] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 7,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [88543] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5317), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5319), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5329), 1,
      anon_sym_PIPE,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [88641] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5325), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      anon_sym_CARET,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5339), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5341), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [88733] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5415), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [88807] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5315), 1,
      anon_sym_LT,
    ACTIONS(5321), 1,
      anon_sym_GT_GT,
    ACTIONS(5333), 1,
      anon_sym_PERCENT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5309), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5311), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5323), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5331), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5337), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4261), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 9,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [88891] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5335), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5415), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 14,
      sym__ternary_qmark,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [88965] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 3,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [89052] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 4,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [89147] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5452), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [89248] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5452), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [89349] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_EQ,
    ACTIONS(4830), 1,
      anon_sym_LBRACK,
    ACTIONS(4270), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [89404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5454), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [89451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5460), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5458), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [89498] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_EQ,
    ACTIONS(4830), 1,
      anon_sym_LBRACK,
    ACTIONS(4270), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [89553] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5462), 1,
      anon_sym_STAR,
    ACTIONS(5464), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5466), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3516), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [89614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5468), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [89661] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4760), 1,
      anon_sym_LBRACK,
    ACTIONS(4371), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4763), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4756), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [89714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 1,
      sym__automatic_semicolon,
    ACTIONS(1535), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1533), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [89763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5476), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5474), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [89810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2766), 1,
      sym__automatic_semicolon,
    ACTIONS(1479), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1473), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [89859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5480), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5478), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [89906] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4365), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(4367), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [89957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5484), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5482), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [90004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5488), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5486), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [90051] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4940), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1790), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1788), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [90102] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4830), 1,
      anon_sym_LBRACK,
    ACTIONS(4270), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [90155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5490), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [90202] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5494), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4483), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4485), 17,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [90267] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_EQ,
    ACTIONS(4714), 1,
      anon_sym_COMMA,
    ACTIONS(5013), 1,
      anon_sym_RBRACK,
    ACTIONS(4708), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4712), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [90320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5497), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [90367] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5168), 1,
      anon_sym_STAR,
    ACTIONS(5170), 1,
      anon_sym_async,
    ACTIONS(5172), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5176), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [90430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3485), 1,
      anon_sym_EQ,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 25,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
      anon_sym_implements,
  [90479] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5452), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [90580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5501), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [90627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5476), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5474), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [90674] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4940), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [90725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5505), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [90772] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(4922), 1,
      anon_sym_COMMA,
    ACTIONS(5020), 1,
      anon_sym_RBRACK,
    ACTIONS(1475), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [90825] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_EQ,
    ACTIONS(4830), 1,
      anon_sym_LBRACK,
    ACTIONS(4270), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [90880] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5509), 1,
      anon_sym_STAR,
    ACTIONS(5511), 1,
      anon_sym_async,
    ACTIONS(5513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5515), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [90943] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5517), 1,
      anon_sym_STAR,
    ACTIONS(5519), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5521), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3428), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [91004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5523), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [91051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 1,
      sym_regex_flags,
    ACTIONS(5118), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      anon_sym_implements,
    ACTIONS(5120), 22,
      sym__ternary_qmark,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [91100] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5452), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5460), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5458), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [91248] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 14,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [91317] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5452), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91418] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5452), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91519] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5530), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4452), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4454), 14,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [91590] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 7,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 11,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [91669] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5452), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91770] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5452), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [91871] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 1,
      anon_sym_catch,
    ACTIONS(5535), 1,
      anon_sym_finally,
    STATE(2451), 1,
      sym_catch_clause,
    STATE(2530), 1,
      sym_finally_clause,
    ACTIONS(2274), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2272), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [91926] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5452), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [92027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5501), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [92074] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5509), 1,
      anon_sym_STAR,
    ACTIONS(5513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5515), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [92135] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4750), 1,
      anon_sym_LBRACK,
    ACTIONS(4178), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4753), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 23,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [92188] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5452), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [92289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5490), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [92336] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5537), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4445), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4447), 15,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [92403] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [92496] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5462), 1,
      anon_sym_STAR,
    ACTIONS(5540), 1,
      anon_sym_async,
    ACTIONS(5464), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5466), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3516), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [92559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5523), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [92606] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(4270), 1,
      anon_sym_extends,
    ACTIONS(4830), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [92661] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_EQ,
    ACTIONS(3549), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [92712] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(5422), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4276), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4278), 20,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [92771] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 8,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [92846] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4176), 1,
      anon_sym_QMARK,
    ACTIONS(4178), 1,
      anon_sym_extends,
    ACTIONS(4753), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4750), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [92901] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4580), 1,
      anon_sym_BANG,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(4586), 1,
      anon_sym_LBRACK,
    ACTIONS(4590), 1,
      anon_sym_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5452), 1,
      sym__ternary_qmark,
    STATE(3878), 1,
      sym_type_arguments,
    STATE(4122), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(2098), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [93002] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_EQ,
    ACTIONS(4714), 1,
      anon_sym_COLON,
    ACTIONS(5013), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(4708), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4712), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [93055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3283), 10,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3281), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_DOT,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [93102] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 6,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [93191] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5452), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [93292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4471), 1,
      anon_sym_EQ,
    ACTIONS(4799), 1,
      anon_sym_COMMA,
    ACTIONS(4946), 1,
      anon_sym_RBRACK,
    ACTIONS(4469), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [93345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5544), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5542), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [93392] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(2115), 1,
      anon_sym_extends,
    ACTIONS(4463), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4466), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1475), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [93447] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 1,
      anon_sym_extends,
    ACTIONS(4471), 1,
      anon_sym_EQ,
    ACTIONS(4475), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4478), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4469), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [93502] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5550), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5548), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5546), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [93551] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5452), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [93652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5484), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5482), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [93699] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5450), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5452), 1,
      sym__ternary_qmark,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [93800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5505), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [93847] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5168), 1,
      anon_sym_STAR,
    ACTIONS(5172), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5176), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 25,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [93908] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(1886), 1,
      anon_sym_EQ_GT,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5172), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [93967] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(4261), 2,
      anon_sym_BANG,
      anon_sym_PIPE,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4263), 5,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK_QMARK,
  [94058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5554), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5552), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [94105] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 10,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 13,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [94178] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4188), 1,
      anon_sym_as,
    ACTIONS(4192), 1,
      anon_sym_BANG,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5527), 1,
      anon_sym_LT,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4261), 11,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 13,
      sym__ternary_qmark,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [94251] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(4261), 5,
      anon_sym_BANG,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4263), 8,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_QMARK_QMARK,
  [94334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5480), 11,
      sym__automatic_semicolon,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5478), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [94381] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(3998), 1,
      anon_sym_LBRACK,
    ACTIONS(4002), 1,
      anon_sym_DOT,
    ACTIONS(4198), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4261), 1,
      anon_sym_BANG,
    ACTIONS(5422), 1,
      anon_sym_LT,
    ACTIONS(5424), 1,
      anon_sym_GT_GT,
    ACTIONS(5430), 1,
      anon_sym_PERCENT,
    ACTIONS(5432), 1,
      anon_sym_STAR_STAR,
    ACTIONS(5440), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5442), 1,
      anon_sym_AMP,
    ACTIONS(5444), 1,
      anon_sym_CARET,
    ACTIONS(5446), 1,
      anon_sym_PIPE,
    ACTIONS(5448), 1,
      anon_sym_PIPE_PIPE,
    STATE(3882), 1,
      sym_type_arguments,
    STATE(4075), 1,
      sym_optional_chain,
    ACTIONS(4228), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5418), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(5420), 2,
      anon_sym_in,
      anon_sym_GT,
    ACTIONS(5426), 2,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(5428), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5436), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5438), 2,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    STATE(1689), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(4263), 3,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_QMARK_QMARK,
    ACTIONS(5434), 3,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [94478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5556), 1,
      sym_identifier,
    ACTIONS(3902), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3906), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [94526] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1619), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5558), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5561), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [94574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_LPAREN,
    STATE(2971), 1,
      sym_arguments,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [94624] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4124), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3463), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [94680] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1563), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5564), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5567), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [94728] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4038), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3513), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [94784] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4760), 1,
      anon_sym_LBRACK,
    ACTIONS(4763), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4371), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(4756), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4758), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [94836] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_import,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(15), 1,
      anon_sym_pragma,
    STATE(2768), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(2769), 1,
      sym_ui_annotation,
    STATE(4261), 1,
      sym_ui_nested_identifier,
    STATE(4941), 2,
      sym_ui_object_definition,
      sym_ui_annotated_object,
    STATE(2707), 3,
      sym_ui_pragma,
      sym_ui_import,
      aux_sym_program_repeat1,
    ACTIONS(9), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [94898] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4830), 1,
      anon_sym_LBRACK,
    ACTIONS(4833), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4270), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [94950] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5570), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3393), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3481), 1,
      anon_sym_EQ,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 24,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [95054] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5519), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3428), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95110] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4066), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3478), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95166] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5172), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95222] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4144), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3425), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1535), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1533), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [95324] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4128), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3388), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95380] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5572), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3405), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95436] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_import,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(15), 1,
      anon_sym_pragma,
    STATE(2768), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(2769), 1,
      sym_ui_annotation,
    STATE(4261), 1,
      sym_ui_nested_identifier,
    STATE(4978), 2,
      sym_ui_object_definition,
      sym_ui_annotated_object,
    STATE(2404), 3,
      sym_ui_pragma,
      sym_ui_import,
      aux_sym_program_repeat1,
    ACTIONS(9), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5574), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5577), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [95546] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(4830), 1,
      anon_sym_LBRACK,
    ACTIONS(4270), 2,
      anon_sym_COMMA,
      anon_sym_extends,
    ACTIONS(4833), 3,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 10,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [95600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4824), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5580), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5583), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [95648] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4156), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3489), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1521), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1519), 35,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [95750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4930), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5586), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5589), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [95798] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4140), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3498), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95854] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4060), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3494), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95910] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4072), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3491), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [95966] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5592), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [96022] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [96078] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4048), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3465), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [96134] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4750), 1,
      anon_sym_LBRACK,
    ACTIONS(4753), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(4178), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_extends,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 21,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [96186] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_RBRACK,
    ACTIONS(3441), 1,
      anon_sym_COMMA,
    ACTIONS(3542), 1,
      anon_sym_EQ,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [96238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 1,
      sym_identifier,
    ACTIONS(3902), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3906), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [96286] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5596), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3454), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [96342] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4094), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [96398] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_import,
    ACTIONS(13), 1,
      anon_sym_AT,
    ACTIONS(15), 1,
      anon_sym_pragma,
    STATE(2768), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(2769), 1,
      sym_ui_annotation,
    STATE(4261), 1,
      sym_ui_nested_identifier,
    STATE(4978), 2,
      sym_ui_object_definition,
      sym_ui_annotated_object,
    STATE(2707), 3,
      sym_ui_pragma,
      sym_ui_import,
      aux_sym_program_repeat1,
    ACTIONS(9), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [96460] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4098), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3413), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [96516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 1,
      sym_identifier,
    ACTIONS(3902), 15,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(3906), 22,
      sym__automatic_semicolon,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [96564] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5464), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    STATE(3516), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [96620] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4026), 1,
      anon_sym_STAR,
    ACTIONS(4028), 1,
      anon_sym_async,
    ACTIONS(5600), 1,
      anon_sym_static,
    ACTIONS(5602), 1,
      anon_sym_readonly,
    ACTIONS(5604), 1,
      anon_sym_abstract,
    STATE(2480), 1,
      sym_override_modifier,
    ACTIONS(4030), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4032), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2908), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [96690] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4896), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5606), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5609), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [96738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4892), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5612), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5615), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [96786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1543), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(5618), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5621), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [96834] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4178), 1,
      anon_sym_extends,
    ACTIONS(4750), 2,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
    ACTIONS(4753), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(3293), 11,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [96886] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5624), 1,
      anon_sym_RBRACE,
    STATE(4568), 1,
      sym_enum_assignment,
    ACTIONS(5626), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [96943] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3968), 1,
      anon_sym_STAR,
    ACTIONS(3970), 1,
      anon_sym_async,
    ACTIONS(3974), 1,
      anon_sym_readonly,
    ACTIONS(5628), 1,
      anon_sym_static,
    STATE(2482), 1,
      sym_override_modifier,
    ACTIONS(3972), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3976), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2966), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [97010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3279), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3277), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [97055] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4471), 1,
      anon_sym_EQ,
    ACTIONS(4799), 1,
      anon_sym_of,
    ACTIONS(5268), 1,
      anon_sym_in,
    ACTIONS(4469), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4473), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [97106] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    ACTIONS(5632), 1,
      anon_sym_DOT,
    STATE(2630), 1,
      sym_statement_block,
    ACTIONS(1491), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1487), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [97157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 1,
      sym_regex_flags,
    ACTIONS(5118), 16,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_of,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(5120), 20,
      sym__ternary_qmark,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [97204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3239), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3237), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [97249] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1477), 1,
      anon_sym_EQ,
    ACTIONS(4922), 1,
      anon_sym_of,
    ACTIONS(5223), 1,
      anon_sym_in,
    ACTIONS(1475), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1481), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [97300] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5634), 1,
      anon_sym_RBRACE,
    STATE(4568), 1,
      sym_enum_assignment,
    ACTIONS(5626), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [97357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5535), 1,
      anon_sym_finally,
    STATE(2555), 1,
      sym_finally_clause,
    ACTIONS(2309), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2307), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [97406] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5636), 1,
      anon_sym_RBRACE,
    STATE(4568), 1,
      sym_enum_assignment,
    ACTIONS(5626), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [97463] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5638), 1,
      anon_sym_RBRACE,
    STATE(4568), 1,
      sym_enum_assignment,
    ACTIONS(5626), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [97520] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5640), 1,
      anon_sym_RBRACE,
    STATE(4568), 1,
      sym_enum_assignment,
    ACTIONS(5626), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [97577] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5642), 1,
      anon_sym_RBRACE,
    STATE(4568), 1,
      sym_enum_assignment,
    ACTIONS(5626), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [97634] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5644), 1,
      anon_sym_RBRACE,
    STATE(4171), 1,
      sym_enum_assignment,
    ACTIONS(5646), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3739), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [97691] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5648), 1,
      anon_sym_RBRACE,
    STATE(4568), 1,
      sym_enum_assignment,
    ACTIONS(5626), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [97748] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5650), 1,
      anon_sym_RBRACE,
    STATE(4568), 1,
      sym_enum_assignment,
    ACTIONS(5626), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [97805] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5652), 1,
      anon_sym_RBRACE,
    STATE(4568), 1,
      sym_enum_assignment,
    ACTIONS(5626), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [97862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1625), 4,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(1623), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [97907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3523), 1,
      anon_sym_EQ,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [97954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3527), 1,
      anon_sym_EQ,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [98001] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3798), 1,
      anon_sym_readonly,
    ACTIONS(5654), 1,
      anon_sym_static,
    STATE(2496), 1,
      sym_override_modifier,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [98068] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4710), 1,
      anon_sym_EQ,
    ACTIONS(4714), 1,
      anon_sym_of,
    ACTIONS(5220), 1,
      anon_sym_in,
    ACTIONS(4708), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(4712), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [98119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3830), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(5656), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [98164] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3351), 1,
      anon_sym_override,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(5658), 1,
      anon_sym_static,
    ACTIONS(5660), 1,
      anon_sym_readonly,
    ACTIONS(5662), 1,
      anon_sym_abstract,
    STATE(2511), 1,
      sym_override_modifier,
    ACTIONS(4385), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3193), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [98227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3517), 1,
      anon_sym_EQ,
    ACTIONS(3293), 13,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 23,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [98274] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5664), 1,
      anon_sym_RBRACE,
    STATE(4568), 1,
      sym_enum_assignment,
    ACTIONS(5626), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [98331] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5666), 1,
      anon_sym_RBRACE,
    STATE(4047), 1,
      sym_enum_assignment,
    ACTIONS(5668), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3667), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [98388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3267), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3265), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [98433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3271), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3269), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [98478] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5670), 1,
      anon_sym_RBRACE,
    STATE(4568), 1,
      sym_enum_assignment,
    ACTIONS(5626), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [98535] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5672), 1,
      anon_sym_RBRACE,
    STATE(4219), 1,
      sym_enum_assignment,
    ACTIONS(5674), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3607), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [98592] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5676), 1,
      anon_sym_RBRACE,
    STATE(4568), 1,
      sym_enum_assignment,
    ACTIONS(5626), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [98649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 9,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
      anon_sym_AT,
    ACTIONS(3259), 28,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_abstract,
  [98694] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(2093), 1,
      anon_sym_readonly,
    ACTIONS(2097), 1,
      anon_sym_override,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(5678), 1,
      anon_sym_static,
    STATE(2502), 1,
      sym_override_modifier,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 21,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [98761] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_EQ,
    ACTIONS(3535), 1,
      anon_sym_in,
    ACTIONS(3538), 1,
      anon_sym_of,
    ACTIONS(3293), 12,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(3297), 22,
      sym__ternary_qmark,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [98812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_AT,
    ACTIONS(5682), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [98856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2340), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [98900] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4012), 1,
      anon_sym_STAR,
    ACTIONS(4014), 1,
      anon_sym_async,
    ACTIONS(4018), 1,
      anon_sym_readonly,
    ACTIONS(4016), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4020), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2922), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [98960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2311), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [99004] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3982), 1,
      anon_sym_STAR,
    ACTIONS(3984), 1,
      anon_sym_async,
    ACTIONS(3988), 1,
      anon_sym_readonly,
    ACTIONS(3986), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3990), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2968), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [99064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_AT,
    ACTIONS(5686), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [99108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_AT,
    ACTIONS(5690), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [99152] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4046), 1,
      anon_sym_STAR,
    ACTIONS(4076), 1,
      anon_sym_async,
    ACTIONS(5692), 1,
      anon_sym_readonly,
    ACTIONS(4078), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4080), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2924), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [99212] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(2630), 1,
      sym_statement_block,
    ACTIONS(1491), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1487), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [99260] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4148), 1,
      anon_sym_STAR,
    ACTIONS(4150), 1,
      anon_sym_async,
    ACTIONS(5694), 1,
      anon_sym_readonly,
    ACTIONS(4152), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4154), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2976), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [99320] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3968), 1,
      anon_sym_STAR,
    ACTIONS(3970), 1,
      anon_sym_async,
    ACTIONS(3974), 1,
      anon_sym_readonly,
    ACTIONS(3972), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3976), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2966), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [99380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 1,
      sym__automatic_semicolon,
    ACTIONS(1603), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1599), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [99426] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3788), 1,
      anon_sym_STAR,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3794), 1,
      anon_sym_async,
    ACTIONS(3798), 1,
      anon_sym_readonly,
    ACTIONS(3796), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3800), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2955), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [99486] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(2091), 1,
      anon_sym_async,
    ACTIONS(2093), 1,
      anon_sym_readonly,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3944), 1,
      anon_sym_STAR,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(2095), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [99546] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4869), 1,
      anon_sym_readonly,
    ACTIONS(5696), 1,
      anon_sym_STAR,
    ACTIONS(5698), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5700), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2912), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [99604] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4102), 1,
      anon_sym_STAR,
    ACTIONS(4104), 1,
      anon_sym_async,
    ACTIONS(5702), 1,
      anon_sym_readonly,
    ACTIONS(4106), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4108), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2956), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [99664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      sym__automatic_semicolon,
    ACTIONS(1703), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1699), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [99710] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5509), 1,
      anon_sym_STAR,
    ACTIONS(5511), 1,
      anon_sym_async,
    ACTIONS(5704), 1,
      anon_sym_readonly,
    ACTIONS(5513), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5515), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [99770] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(3948), 1,
      anon_sym_STAR,
    ACTIONS(3950), 1,
      anon_sym_async,
    ACTIONS(3954), 1,
      anon_sym_readonly,
    ACTIONS(3952), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(3956), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2957), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [99830] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(5706), 1,
      anon_sym_STAR,
    ACTIONS(5710), 1,
      anon_sym_readonly,
    ACTIONS(5708), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5712), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2903), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 24,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [99888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2329), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2327), 34,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_finally,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [99932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(1800), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(1798), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [99978] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    STATE(4568), 1,
      sym_enum_assignment,
    ACTIONS(5626), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3962), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [100032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5714), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_AT,
    ACTIONS(5716), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [100076] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5168), 1,
      anon_sym_STAR,
    ACTIONS(5170), 1,
      anon_sym_async,
    ACTIONS(5174), 1,
      anon_sym_readonly,
    ACTIONS(5172), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(5176), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(3537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [100136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2940), 1,
      sym__automatic_semicolon,
    ACTIONS(1735), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1731), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [100182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2926), 1,
      sym__automatic_semicolon,
    ACTIONS(1713), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1709), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [100228] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4026), 1,
      anon_sym_STAR,
    ACTIONS(4028), 1,
      anon_sym_async,
    ACTIONS(4036), 1,
      anon_sym_readonly,
    ACTIONS(4030), 2,
      sym_number,
      sym_private_property_identifier,
    ACTIONS(4032), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(2908), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 23,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      sym_identifier,
      anon_sym_static,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [100288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2916), 1,
      sym__automatic_semicolon,
    ACTIONS(1561), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1557), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [100333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2448), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2446), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [100376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2672), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2670), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [100419] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4570), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3194), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [100470] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5718), 1,
      anon_sym_else,
    STATE(2554), 1,
      sym_else_clause,
    ACTIONS(2321), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2319), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [100517] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4745), 1,
      anon_sym_readonly,
    ACTIONS(4570), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3194), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [100570] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4094), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3452), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [100621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2496), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2494), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [100664] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(5720), 1,
      anon_sym_readonly,
    ACTIONS(4963), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3210), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [100717] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4963), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3210), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [100768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2640), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2638), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [100811] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(2033), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3460), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [100862] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4048), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3465), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [100913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2930), 1,
      sym__automatic_semicolon,
    ACTIONS(1693), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1689), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [100958] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4098), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3413), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101009] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5592), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3488), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101060] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4072), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3491), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101111] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4060), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3494), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101162] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5513), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3467), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101213] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4140), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3498), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101264] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5596), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3454), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2768), 1,
      sym__automatic_semicolon,
    ACTIONS(1551), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1547), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [101360] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4038), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3513), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2648), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2646), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [101454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2650), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [101497] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(3922), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3531), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2404), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2402), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [101591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2408), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2406), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [101634] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4144), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3425), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101685] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4066), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3478), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101736] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4385), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3193), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2346), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [101830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2922), 1,
      sym__automatic_semicolon,
    ACTIONS(1541), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1537), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [101875] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3792), 1,
      anon_sym_LBRACK,
    ACTIONS(4869), 1,
      anon_sym_readonly,
    ACTIONS(4385), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3193), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(3331), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [101928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 3,
      sym__automatic_semicolon,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1585), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [101971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2317), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2315), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [102014] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5572), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3405), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [102065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1611), 3,
      sym__automatic_semicolon,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1609), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [102108] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4351), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3515), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [102159] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5464), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3516), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [102210] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5172), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3537), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [102261] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4124), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3463), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [102312] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4391), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3444), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [102363] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      sym__automatic_semicolon,
    ACTIONS(1617), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1613), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [102408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 1,
      sym__automatic_semicolon,
    ACTIONS(1593), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1589), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [102453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2470), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [102496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2778), 1,
      sym__automatic_semicolon,
    ACTIONS(1527), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1523), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [102541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2468), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2466), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [102584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2476), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2474), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [102627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2432), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2430), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [102670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2874), 1,
      sym__automatic_semicolon,
    ACTIONS(1579), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1575), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [102715] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4128), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3388), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [102766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2392), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2390), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [102809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2388), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2386), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [102852] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4172), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3490), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [102903] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5570), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3393), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [102954] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4162), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3391), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [103005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2384), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2382), 33,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_while,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103048] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(5519), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3428), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [103099] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(3920), 1,
      anon_sym_LBRACK,
    ACTIONS(4156), 2,
      sym_number,
      sym_private_property_identifier,
    STATE(3489), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2089), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [103150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2674), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2622), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2636), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2634), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2350), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2684), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2682), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2692), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2690), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2674), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2674), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2644), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2642), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2602), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2590), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2594), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2578), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2426), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1611), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1609), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2708), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2706), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2368), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2366), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2368), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2366), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2360), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2358), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [103990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2574), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2480), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2478), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2704), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2702), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2504), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2502), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2504), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2502), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104200] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5724), 1,
      anon_sym_AT,
    STATE(2591), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(2769), 1,
      sym_ui_annotation,
    ACTIONS(5722), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1571), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1567), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2700), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2698), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2696), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2694), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2688), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2686), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2664), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2662), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2660), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2658), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2654), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2107), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2105), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2608), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2606), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2600), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2598), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [104960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2586), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2412), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2410), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2450), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1585), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1637), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1635), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2456), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2454), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2546), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2500), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2498), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2620), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2618), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1721), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1719), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2620), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2618), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1571), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(1567), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [105968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2620), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2618), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2668), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2666), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2608), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2606), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2560), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2558), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2490), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2486), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2482), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2482), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2552), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2550), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2540), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2538), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2414), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2534), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2512), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2510), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2572), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2570), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [106976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2438), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2460), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2458), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2528), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2526), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2506), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2354), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2376), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2374), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2464), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2462), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2418), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2115), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2113), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2516), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2514), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2518), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2532), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2530), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2678), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2372), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2370), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2630), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2626), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [107984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2582), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2400), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2398), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2396), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2394), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2111), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2109), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2442), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2582), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2542), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2434), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2422), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2610), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2362), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2380), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2378), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2119), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2117), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2616), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2614), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2123), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2121), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2556), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2554), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2568), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2566), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2562), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2524), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2522), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2524), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2522), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2482), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(2482), 32,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_else,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5729), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5727), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5733), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5731), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [108990] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2055), 1,
      anon_sym_namespace,
    ACTIONS(2059), 1,
      anon_sym_import,
    ACTIONS(2061), 1,
      anon_sym_var,
    ACTIONS(2063), 1,
      anon_sym_let,
    ACTIONS(2065), 1,
      anon_sym_const,
    ACTIONS(2073), 1,
      anon_sym_class,
    ACTIONS(2075), 1,
      anon_sym_async,
    ACTIONS(2077), 1,
      anon_sym_function,
    ACTIONS(2079), 1,
      anon_sym_declare,
    ACTIONS(2083), 1,
      anon_sym_abstract,
    ACTIONS(2085), 1,
      anon_sym_interface,
    ACTIONS(2087), 1,
      anon_sym_enum,
    ACTIONS(2099), 1,
      anon_sym_type,
    ACTIONS(2101), 1,
      anon_sym_module,
    ACTIONS(2103), 1,
      anon_sym_global,
    STATE(776), 1,
      sym_declaration,
    STATE(840), 1,
      sym_internal_module,
    STATE(1128), 1,
      sym_decorator,
    STATE(3695), 1,
      aux_sym_export_statement_repeat1,
    STATE(826), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [109069] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2226), 1,
      anon_sym_type,
    ACTIONS(2228), 1,
      anon_sym_namespace,
    ACTIONS(2230), 1,
      anon_sym_import,
    ACTIONS(2232), 1,
      anon_sym_var,
    ACTIONS(2234), 1,
      anon_sym_let,
    ACTIONS(2236), 1,
      anon_sym_const,
    ACTIONS(2238), 1,
      anon_sym_class,
    ACTIONS(2240), 1,
      anon_sym_async,
    ACTIONS(2242), 1,
      anon_sym_function,
    ACTIONS(2244), 1,
      anon_sym_declare,
    ACTIONS(2248), 1,
      anon_sym_abstract,
    ACTIONS(2252), 1,
      anon_sym_interface,
    ACTIONS(2254), 1,
      anon_sym_enum,
    ACTIONS(3771), 1,
      anon_sym_module,
    ACTIONS(5735), 1,
      anon_sym_default,
    STATE(1128), 1,
      sym_decorator,
    STATE(3590), 1,
      aux_sym_export_statement_repeat1,
    STATE(3626), 1,
      sym_declaration,
    STATE(3767), 1,
      sym_internal_module,
    STATE(3792), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [109148] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 1,
      anon_sym_import,
    ACTIONS(5742), 1,
      anon_sym_AT,
    ACTIONS(5744), 1,
      anon_sym_pragma,
    STATE(2707), 3,
      sym_ui_pragma,
      sym_ui_import,
      aux_sym_program_repeat1,
    ACTIONS(5737), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [109195] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2226), 1,
      anon_sym_type,
    ACTIONS(2228), 1,
      anon_sym_namespace,
    ACTIONS(2230), 1,
      anon_sym_import,
    ACTIONS(2232), 1,
      anon_sym_var,
    ACTIONS(2234), 1,
      anon_sym_let,
    ACTIONS(2236), 1,
      anon_sym_const,
    ACTIONS(2238), 1,
      anon_sym_class,
    ACTIONS(2240), 1,
      anon_sym_async,
    ACTIONS(2242), 1,
      anon_sym_function,
    ACTIONS(2244), 1,
      anon_sym_declare,
    ACTIONS(2246), 1,
      anon_sym_module,
    ACTIONS(2248), 1,
      anon_sym_abstract,
    ACTIONS(2250), 1,
      anon_sym_global,
    ACTIONS(2252), 1,
      anon_sym_interface,
    ACTIONS(2254), 1,
      anon_sym_enum,
    STATE(1128), 1,
      sym_decorator,
    STATE(3590), 1,
      aux_sym_export_statement_repeat1,
    STATE(3762), 1,
      sym_declaration,
    STATE(3767), 1,
      sym_internal_module,
    STATE(3792), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [109274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5749), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5747), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [109315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5753), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5751), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [109356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5757), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5755), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [109397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5761), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5759), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [109438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5765), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5763), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [109479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5769), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5767), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [109520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5773), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5771), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [109561] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2135), 1,
      anon_sym_namespace,
    ACTIONS(2137), 1,
      anon_sym_import,
    ACTIONS(2139), 1,
      anon_sym_var,
    ACTIONS(2141), 1,
      anon_sym_let,
    ACTIONS(2143), 1,
      anon_sym_const,
    ACTIONS(2147), 1,
      anon_sym_class,
    ACTIONS(2149), 1,
      anon_sym_async,
    ACTIONS(2151), 1,
      anon_sym_function,
    ACTIONS(2153), 1,
      anon_sym_declare,
    ACTIONS(2157), 1,
      anon_sym_abstract,
    ACTIONS(2159), 1,
      anon_sym_interface,
    ACTIONS(2161), 1,
      anon_sym_enum,
    ACTIONS(2185), 1,
      anon_sym_type,
    ACTIONS(2187), 1,
      anon_sym_module,
    ACTIONS(2189), 1,
      anon_sym_global,
    STATE(1128), 1,
      sym_decorator,
    STATE(2579), 1,
      sym_declaration,
    STATE(2632), 1,
      sym_internal_module,
    STATE(3663), 1,
      aux_sym_export_statement_repeat1,
    STATE(2592), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [109640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5777), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5775), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [109681] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2135), 1,
      anon_sym_namespace,
    ACTIONS(2137), 1,
      anon_sym_import,
    ACTIONS(2139), 1,
      anon_sym_var,
    ACTIONS(2141), 1,
      anon_sym_let,
    ACTIONS(2143), 1,
      anon_sym_const,
    ACTIONS(2147), 1,
      anon_sym_class,
    ACTIONS(2149), 1,
      anon_sym_async,
    ACTIONS(2151), 1,
      anon_sym_function,
    ACTIONS(2153), 1,
      anon_sym_declare,
    ACTIONS(2155), 1,
      anon_sym_module,
    ACTIONS(2157), 1,
      anon_sym_abstract,
    ACTIONS(2159), 1,
      anon_sym_interface,
    ACTIONS(2161), 1,
      anon_sym_enum,
    ACTIONS(2185), 1,
      anon_sym_type,
    ACTIONS(5779), 1,
      anon_sym_default,
    STATE(1128), 1,
      sym_decorator,
    STATE(2632), 1,
      sym_internal_module,
    STATE(2691), 1,
      sym_declaration,
    STATE(3663), 1,
      aux_sym_export_statement_repeat1,
    STATE(2592), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [109760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5783), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5781), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [109801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5787), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5785), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [109842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5791), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5789), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [109883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5795), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5793), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [109924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5799), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5797), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [109965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5803), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5801), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5807), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5805), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5811), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5809), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5815), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5813), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5819), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5817), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5823), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5821), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5827), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5825), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5831), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5829), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5833), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5839), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5837), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110375] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2059), 1,
      anon_sym_import,
    ACTIONS(2063), 1,
      anon_sym_let,
    ACTIONS(2065), 1,
      anon_sym_const,
    ACTIONS(2073), 1,
      anon_sym_class,
    ACTIONS(2083), 1,
      anon_sym_abstract,
    ACTIONS(2085), 1,
      anon_sym_interface,
    ACTIONS(2087), 1,
      anon_sym_enum,
    ACTIONS(2099), 1,
      anon_sym_type,
    ACTIONS(2139), 1,
      anon_sym_var,
    ACTIONS(2167), 1,
      anon_sym_namespace,
    ACTIONS(2171), 1,
      anon_sym_async,
    ACTIONS(2173), 1,
      anon_sym_function,
    ACTIONS(2175), 1,
      anon_sym_declare,
    ACTIONS(2181), 1,
      anon_sym_module,
    ACTIONS(2183), 1,
      anon_sym_global,
    STATE(776), 1,
      sym_declaration,
    STATE(840), 1,
      sym_internal_module,
    STATE(1128), 1,
      sym_decorator,
    STATE(3695), 1,
      aux_sym_export_statement_repeat1,
    STATE(826), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [110454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5841), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5847), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5845), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5851), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5849), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110577] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2059), 1,
      anon_sym_import,
    ACTIONS(2063), 1,
      anon_sym_let,
    ACTIONS(2065), 1,
      anon_sym_const,
    ACTIONS(2073), 1,
      anon_sym_class,
    ACTIONS(2083), 1,
      anon_sym_abstract,
    ACTIONS(2085), 1,
      anon_sym_interface,
    ACTIONS(2087), 1,
      anon_sym_enum,
    ACTIONS(2099), 1,
      anon_sym_type,
    ACTIONS(2139), 1,
      anon_sym_var,
    ACTIONS(2167), 1,
      anon_sym_namespace,
    ACTIONS(2171), 1,
      anon_sym_async,
    ACTIONS(2173), 1,
      anon_sym_function,
    ACTIONS(2175), 1,
      anon_sym_declare,
    ACTIONS(2177), 1,
      anon_sym_module,
    ACTIONS(5853), 1,
      anon_sym_default,
    STATE(707), 1,
      sym_declaration,
    STATE(840), 1,
      sym_internal_module,
    STATE(1128), 1,
      sym_decorator,
    STATE(3695), 1,
      aux_sym_export_statement_repeat1,
    STATE(826), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [110656] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(2055), 1,
      anon_sym_namespace,
    ACTIONS(2059), 1,
      anon_sym_import,
    ACTIONS(2061), 1,
      anon_sym_var,
    ACTIONS(2063), 1,
      anon_sym_let,
    ACTIONS(2065), 1,
      anon_sym_const,
    ACTIONS(2073), 1,
      anon_sym_class,
    ACTIONS(2075), 1,
      anon_sym_async,
    ACTIONS(2077), 1,
      anon_sym_function,
    ACTIONS(2079), 1,
      anon_sym_declare,
    ACTIONS(2081), 1,
      anon_sym_module,
    ACTIONS(2083), 1,
      anon_sym_abstract,
    ACTIONS(2085), 1,
      anon_sym_interface,
    ACTIONS(2087), 1,
      anon_sym_enum,
    ACTIONS(2099), 1,
      anon_sym_type,
    ACTIONS(5855), 1,
      anon_sym_default,
    STATE(707), 1,
      sym_declaration,
    STATE(840), 1,
      sym_internal_module,
    STATE(1128), 1,
      sym_decorator,
    STATE(3695), 1,
      aux_sym_export_statement_repeat1,
    STATE(826), 13,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
      sym_function_signature,
      sym_ambient_declaration,
      sym_abstract_class_declaration,
      sym_module,
      sym_import_alias,
      sym_interface_declaration,
      sym_enum_declaration,
      sym_type_alias_declaration,
  [110735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5859), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5857), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5863), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5861), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5867), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5865), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5871), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5869), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5833), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5875), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5873), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [110981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5877), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5883), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5881), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5887), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5885), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5891), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5889), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5895), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5893), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5899), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5897), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5903), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5901), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5833), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5833), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5833), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5833), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5833), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5833), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5833), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5907), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5905), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5835), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5833), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5911), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5909), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5915), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5913), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5919), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5917), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5923), 2,
      anon_sym_RBRACE,
      anon_sym_AT,
    ACTIONS(5921), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5927), 1,
      anon_sym_AT,
    ACTIONS(5925), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111841] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(5929), 1,
      sym_identifier,
    ACTIONS(5933), 1,
      anon_sym_default,
    ACTIONS(5935), 1,
      anon_sym_COLON,
    ACTIONS(5937), 1,
      anon_sym_DOT,
    ACTIONS(5942), 1,
      anon_sym_on,
    STATE(2484), 1,
      sym_ui_object_initializer,
    ACTIONS(5939), 3,
      anon_sym_readonly,
      anon_sym_property,
      anon_sym_required,
    ACTIONS(5931), 22,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_signal,
      anon_sym_component,
  [111895] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_AT,
    STATE(2591), 1,
      aux_sym_ui_annotated_object_repeat1,
    STATE(2769), 1,
      sym_ui_annotation,
    STATE(4261), 1,
      sym_ui_nested_identifier,
    STATE(4943), 1,
      sym_ui_object_definition,
    ACTIONS(9), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [111945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5946), 1,
      anon_sym_AT,
    ACTIONS(5944), 31,
      anon_sym_export,
      anon_sym_default,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_var,
      anon_sym_of,
      anon_sym_async,
      anon_sym_function,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_enum,
  [111985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5950), 1,
      anon_sym_AT,
    ACTIONS(5948), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [112023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5954), 1,
      anon_sym_AT,
    ACTIONS(5952), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [112061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5958), 1,
      anon_sym_AT,
    ACTIONS(5956), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [112099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5962), 1,
      anon_sym_AT,
    ACTIONS(5960), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [112137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5966), 1,
      anon_sym_AT,
    ACTIONS(5964), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [112175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5970), 1,
      anon_sym_AT,
    ACTIONS(5968), 29,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_import,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
      anon_sym_pragma,
  [112213] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5972), 1,
      sym_identifier,
    STATE(4133), 1,
      sym_ui_nested_identifier,
    ACTIONS(5976), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(5974), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_identifier,
    STATE(4261), 1,
      sym_ui_nested_identifier,
    STATE(4472), 1,
      sym_ui_object_definition,
    ACTIONS(9), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112296] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_identifier,
    STATE(2713), 1,
      sym_ui_object_definition,
    STATE(4261), 1,
      sym_ui_nested_identifier,
    ACTIONS(9), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5978), 1,
      sym_identifier,
    STATE(4821), 1,
      sym_mapped_type_clause,
    ACTIONS(5980), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112375] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 1,
      sym_identifier,
    ACTIONS(5986), 1,
      anon_sym_DOT,
    ACTIONS(5984), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5972), 1,
      sym_identifier,
    STATE(4133), 1,
      sym_ui_nested_identifier,
    ACTIONS(5974), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5988), 1,
      sym_identifier,
    STATE(4058), 1,
      sym_ui_nested_identifier,
    ACTIONS(5990), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112489] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      anon_sym_DOT,
    ACTIONS(5992), 1,
      sym_identifier,
    ACTIONS(5994), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5996), 1,
      sym_identifier,
    ACTIONS(5998), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6000), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6002), 1,
      sym_identifier,
    ACTIONS(6004), 26,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6006), 27,
      anon_sym_export,
      anon_sym_type,
      anon_sym_namespace,
      anon_sym_from,
      anon_sym_of,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_readonly,
      anon_sym_get,
      anon_sym_set,
      anon_sym_declare,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_override,
      anon_sym_module,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_property,
      anon_sym_signal,
      anon_sym_on,
      anon_sym_required,
      anon_sym_component,
  [112663] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(6008), 1,
      anon_sym_DOT,
    ACTIONS(6010), 1,
      anon_sym_QMARK_DOT,
    STATE(2828), 1,
      sym_arguments,
    ACTIONS(4166), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4168), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112698] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(6012), 1,
      anon_sym_DOT,
    ACTIONS(6014), 1,
      anon_sym_QMARK_DOT,
    STATE(2829), 1,
      sym_arguments,
    ACTIONS(4134), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4136), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112733] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      anon_sym_DOT,
    ACTIONS(3395), 1,
      anon_sym_QMARK_DOT,
    STATE(2830), 1,
      sym_arguments,
    ACTIONS(3391), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3387), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4524), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4403), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4534), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4536), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4349), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1627), 1,
      anon_sym_PIPE,
    ACTIONS(1629), 17,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
      aux_sym_ui_version_specifier_token1,
  [112898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4435), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4403), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4409), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4411), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [112976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4530), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4532), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4435), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4435), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4409), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4411), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4409), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4411), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4417), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4419), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4437), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4439), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4437), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4439), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4546), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4548), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4560), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4572), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4574), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4546), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4548), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4349), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4524), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4542), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4544), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4349), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4534), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4536), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4542), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4544), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4437), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4439), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4572), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4574), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4526), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4528), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4443), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113548] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4006), 1,
      anon_sym_EQ,
    ACTIONS(5986), 1,
      anon_sym_DOT,
    ACTIONS(6016), 1,
      anon_sym_LT,
    ACTIONS(6018), 1,
      anon_sym_is,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3383), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [113582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4403), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4560), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1631), 1,
      anon_sym_PIPE,
    ACTIONS(1633), 17,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
      aux_sym_ui_version_specifier_token1,
  [113660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4490), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4492), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4443), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4443), 16,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4461), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4413), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4415), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4407), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113813] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4006), 1,
      anon_sym_EQ,
    ACTIONS(5986), 1,
      anon_sym_DOT,
    ACTIONS(6016), 1,
      anon_sym_LT,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3383), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [113844] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6020), 1,
      anon_sym_DOT,
    ACTIONS(6022), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4232), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(4234), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3267), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3259), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3261), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3269), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(3271), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_EQ_GT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [113948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1462), 1,
      anon_sym_EQ,
    ACTIONS(1460), 15,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
      anon_sym_is,
  [113972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_EQ,
    ACTIONS(6016), 1,
      anon_sym_LT,
    STATE(2860), 1,
      sym_type_arguments,
    ACTIONS(4084), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4425), 1,
      anon_sym_EQ,
    ACTIONS(4427), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4251), 1,
      anon_sym_EQ,
    ACTIONS(6024), 1,
      anon_sym_LBRACK,
    ACTIONS(4253), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_EQ,
    ACTIONS(4084), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4353), 1,
      anon_sym_EQ,
    ACTIONS(4355), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6026), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [114115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4357), 1,
      anon_sym_EQ,
    ACTIONS(4359), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4343), 1,
      anon_sym_EQ,
    ACTIONS(4345), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4365), 1,
      anon_sym_EQ,
    ACTIONS(4367), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4369), 1,
      anon_sym_EQ,
    ACTIONS(4371), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_EQ,
    ACTIONS(4375), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_EQ,
    ACTIONS(4508), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114253] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4381), 1,
      anon_sym_EQ,
    ACTIONS(6024), 1,
      anon_sym_LBRACK,
    ACTIONS(4253), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(4383), 10,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [114280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4510), 1,
      anon_sym_EQ,
    ACTIONS(4512), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4554), 1,
      anon_sym_EQ,
    ACTIONS(4556), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4550), 1,
      anon_sym_EQ,
    ACTIONS(4552), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_EQ,
    ACTIONS(4520), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4538), 1,
      anon_sym_EQ,
    ACTIONS(4540), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4387), 1,
      anon_sym_EQ,
    ACTIONS(4389), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6028), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [114439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4393), 1,
      anon_sym_EQ,
    ACTIONS(6024), 1,
      anon_sym_LBRACK,
    ACTIONS(4395), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6030), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [114485] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4006), 1,
      anon_sym_PIPE,
    ACTIONS(6032), 1,
      anon_sym_LT,
    ACTIONS(6034), 1,
      anon_sym_DOT,
    ACTIONS(6036), 1,
      anon_sym_is,
    STATE(3052), 1,
      sym_type_arguments,
    ACTIONS(3383), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [114516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4397), 1,
      anon_sym_EQ,
    ACTIONS(4399), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6038), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [114560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_EQ,
    ACTIONS(6040), 1,
      anon_sym_is,
    ACTIONS(4084), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6042), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [114606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4272), 1,
      anon_sym_EQ,
    ACTIONS(4274), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6044), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [114650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6046), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [114671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4502), 1,
      anon_sym_EQ,
    ACTIONS(4504), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_EQ,
    ACTIONS(4423), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4268), 1,
      anon_sym_EQ,
    ACTIONS(4270), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114740] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_LPAREN,
    ACTIONS(4166), 1,
      anon_sym_PIPE,
    ACTIONS(6048), 1,
      anon_sym_DOT,
    ACTIONS(6050), 1,
      anon_sym_QMARK_DOT,
    STATE(2973), 1,
      sym_arguments,
    ACTIONS(4168), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [114771] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_LPAREN,
    ACTIONS(4134), 1,
      anon_sym_PIPE,
    ACTIONS(6052), 1,
      anon_sym_DOT,
    ACTIONS(6054), 1,
      anon_sym_QMARK_DOT,
    STATE(2978), 1,
      sym_arguments,
    ACTIONS(4136), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [114802] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3391), 1,
      anon_sym_PIPE,
    ACTIONS(3397), 1,
      anon_sym_LPAREN,
    ACTIONS(3399), 1,
      anon_sym_DOT,
    ACTIONS(3401), 1,
      anon_sym_QMARK_DOT,
    STATE(2971), 1,
      sym_arguments,
    ACTIONS(3387), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [114833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4498), 1,
      anon_sym_EQ,
    ACTIONS(4500), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4176), 1,
      anon_sym_EQ,
    ACTIONS(4178), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4429), 1,
      anon_sym_EQ,
    ACTIONS(4431), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6056), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [114923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4176), 1,
      anon_sym_EQ,
    ACTIONS(6018), 1,
      anon_sym_is,
    ACTIONS(4178), 13,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6058), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [114969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4182), 1,
      anon_sym_EQ,
    ACTIONS(4184), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [114992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4247), 1,
      anon_sym_EQ,
    ACTIONS(4249), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [115015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4494), 1,
      anon_sym_EQ,
    ACTIONS(4496), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [115038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4526), 1,
      anon_sym_PIPE,
    ACTIONS(4528), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4361), 1,
      anon_sym_EQ,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(4363), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [115084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4572), 1,
      anon_sym_PIPE,
    ACTIONS(4574), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4572), 1,
      anon_sym_PIPE,
    ACTIONS(4574), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_PIPE,
    ACTIONS(4524), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_PIPE,
    ACTIONS(4435), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 1,
      anon_sym_PIPE,
    ACTIONS(4560), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4522), 1,
      anon_sym_PIPE,
    ACTIONS(4524), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4558), 1,
      anon_sym_PIPE,
    ACTIONS(4560), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4548), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4542), 1,
      anon_sym_PIPE,
    ACTIONS(4544), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4534), 1,
      anon_sym_PIPE,
    ACTIONS(4536), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4542), 1,
      anon_sym_PIPE,
    ACTIONS(4544), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4490), 1,
      anon_sym_PIPE,
    ACTIONS(4492), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 1,
      anon_sym_PIPE,
    ACTIONS(4443), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115370] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6064), 1,
      sym_number,
    STATE(4782), 1,
      sym_predefined_type,
    STATE(4784), 1,
      sym_string,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [115400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 1,
      anon_sym_PIPE,
    ACTIONS(4443), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115422] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6066), 1,
      sym_number,
    STATE(4747), 1,
      sym_predefined_type,
    STATE(4755), 1,
      sym_string,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [115452] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6068), 1,
      sym_number,
    STATE(4786), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [115480] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4006), 1,
      anon_sym_PIPE,
    ACTIONS(6032), 1,
      anon_sym_LT,
    ACTIONS(6034), 1,
      anon_sym_DOT,
    STATE(3052), 1,
      sym_type_arguments,
    ACTIONS(3383), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4534), 1,
      anon_sym_PIPE,
    ACTIONS(4536), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115530] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6074), 1,
      anon_sym_BANG,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6078), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3657), 1,
      sym_type_annotation,
    STATE(4121), 1,
      sym__call_signature,
    STATE(4137), 1,
      sym__initializer,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6072), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115572] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4566), 1,
      anon_sym_EQ,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(4568), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [115600] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4562), 1,
      anon_sym_EQ,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(4564), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [115628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4530), 1,
      anon_sym_PIPE,
    ACTIONS(4532), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4441), 1,
      anon_sym_PIPE,
    ACTIONS(4443), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115672] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6074), 1,
      anon_sym_BANG,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    ACTIONS(6086), 1,
      anon_sym_QMARK,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3439), 1,
      sym__call_signature,
    STATE(3657), 1,
      sym_type_annotation,
    STATE(4043), 1,
      sym__initializer,
    STATE(4512), 1,
      sym_type_parameters,
    ACTIONS(6072), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4437), 1,
      anon_sym_PIPE,
    ACTIONS(4439), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4514), 1,
      anon_sym_EQ,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(4516), 12,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
      anon_sym_extends,
  [115760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4546), 1,
      anon_sym_PIPE,
    ACTIONS(4548), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [115782] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6090), 1,
      anon_sym_BANG,
    ACTIONS(6092), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3801), 1,
      sym_type_annotation,
    STATE(4063), 1,
      sym__initializer,
    STATE(4064), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6088), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [115824] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_EQ,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(4508), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [115852] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4554), 1,
      anon_sym_EQ,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(4556), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [115880] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6094), 1,
      sym_number,
    STATE(4865), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [115908] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6096), 1,
      sym_number,
    STATE(4856), 1,
      sym_predefined_type,
    STATE(4857), 1,
      sym_string,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [115938] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6098), 1,
      sym_number,
    STATE(4847), 1,
      sym_predefined_type,
    STATE(4851), 1,
      sym_string,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [115968] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6100), 1,
      sym_number,
    STATE(4824), 1,
      sym_predefined_type,
    STATE(4845), 1,
      sym_string,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [115998] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4377), 1,
      anon_sym_EQ,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(4379), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
  [116026] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4339), 1,
      anon_sym_EQ,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(4341), 11,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_extends,
  [116052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4409), 1,
      anon_sym_PIPE,
    ACTIONS(4411), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116074] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    ACTIONS(6090), 1,
      anon_sym_BANG,
    ACTIONS(6102), 1,
      anon_sym_QMARK,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3449), 1,
      sym__call_signature,
    STATE(3801), 1,
      sym_type_annotation,
    STATE(4080), 1,
      sym__initializer,
    STATE(4512), 1,
      sym_type_parameters,
    ACTIONS(6088), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116116] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    ACTIONS(6106), 1,
      anon_sym_BANG,
    ACTIONS(6108), 1,
      anon_sym_QMARK,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3379), 1,
      sym__call_signature,
    STATE(3843), 1,
      sym_type_annotation,
    STATE(4089), 1,
      sym__initializer,
    STATE(4512), 1,
      sym_type_parameters,
    ACTIONS(6104), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116158] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    ACTIONS(6112), 1,
      anon_sym_BANG,
    ACTIONS(6114), 1,
      anon_sym_QMARK,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3536), 1,
      sym__call_signature,
    STATE(3600), 1,
      sym_type_annotation,
    STATE(4221), 1,
      sym__initializer,
    STATE(4512), 1,
      sym_type_parameters,
    ACTIONS(6110), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_PIPE,
    ACTIONS(4435), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116222] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6116), 1,
      sym_number,
    STATE(4947), 1,
      sym_predefined_type,
    STATE(4948), 1,
      sym_string,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [116252] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6118), 1,
      sym_number,
    STATE(4951), 1,
      sym_predefined_type,
    STATE(4952), 1,
      sym_string,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [116282] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6120), 1,
      sym_number,
    STATE(4957), 1,
      sym_predefined_type,
    STATE(4958), 1,
      sym_string,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [116312] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6122), 1,
      sym_number,
    STATE(4961), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [116340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4437), 1,
      anon_sym_PIPE,
    ACTIONS(4439), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4417), 1,
      anon_sym_PIPE,
    ACTIONS(4419), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116384] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6124), 1,
      sym_number,
    STATE(4739), 1,
      sym_predefined_type,
    STATE(4742), 1,
      sym_string,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [116414] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6126), 1,
      sym_number,
    STATE(4892), 1,
      sym_string,
    STATE(4893), 1,
      sym_predefined_type,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [116444] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6128), 1,
      sym_number,
    STATE(4889), 1,
      sym_string,
    STATE(4890), 1,
      sym_predefined_type,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [116474] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6130), 1,
      sym_number,
    STATE(4885), 1,
      sym_predefined_type,
    STATE(4894), 1,
      sym_string,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [116504] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6132), 1,
      sym_number,
    STATE(4882), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [116532] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    ACTIONS(6136), 1,
      anon_sym_BANG,
    ACTIONS(6138), 1,
      anon_sym_QMARK,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3440), 1,
      sym__call_signature,
    STATE(3794), 1,
      sym_type_annotation,
    STATE(4093), 1,
      sym__initializer,
    STATE(4512), 1,
      sym_type_parameters,
    ACTIONS(6134), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [116574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4437), 1,
      anon_sym_PIPE,
    ACTIONS(4439), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4433), 1,
      anon_sym_PIPE,
    ACTIONS(4435), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116662] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6140), 1,
      sym_number,
    STATE(4689), 2,
      sym_string,
      sym_predefined_type,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [116690] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6142), 1,
      sym_number,
    STATE(4693), 1,
      sym_string,
    STATE(4695), 1,
      sym_predefined_type,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [116720] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6144), 1,
      sym_number,
    STATE(4699), 1,
      sym_string,
    STATE(4700), 1,
      sym_predefined_type,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [116750] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6146), 1,
      sym_number,
    STATE(4711), 1,
      sym_string,
    STATE(4712), 1,
      sym_predefined_type,
    ACTIONS(6062), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [116780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4409), 1,
      anon_sym_PIPE,
    ACTIONS(4411), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4347), 1,
      anon_sym_PIPE,
    ACTIONS(4349), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4409), 1,
      anon_sym_PIPE,
    ACTIONS(4411), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_PIPE,
    ACTIONS(4403), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_PIPE,
    ACTIONS(4403), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4401), 1,
      anon_sym_PIPE,
    ACTIONS(4403), 13,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116912] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6150), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3312), 1,
      sym__call_signature,
    STATE(3686), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6148), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [116947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LT,
    ACTIONS(6154), 1,
      anon_sym_DOT,
    ACTIONS(6156), 1,
      anon_sym_is,
    STATE(3170), 1,
      sym_type_arguments,
    ACTIONS(3383), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [116974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1625), 1,
      anon_sym_DOT,
    ACTIONS(4240), 1,
      anon_sym_PIPE,
    ACTIONS(4242), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [116997] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6160), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3291), 1,
      sym__call_signature,
    STATE(3765), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6158), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117032] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6164), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3288), 1,
      sym__call_signature,
    STATE(3713), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6162), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117067] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6168), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3254), 1,
      sym__call_signature,
    STATE(3683), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6166), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117102] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6170), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3685), 1,
      sym__call_signature,
    STATE(3686), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6148), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117137] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4232), 1,
      anon_sym_PIPE,
    ACTIONS(6172), 1,
      anon_sym_DOT,
    ACTIONS(6174), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4234), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [117162] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6176), 1,
      anon_sym_LPAREN,
    ACTIONS(6178), 1,
      anon_sym_DOT,
    ACTIONS(6180), 1,
      anon_sym_QMARK_DOT,
    STATE(3083), 1,
      sym_arguments,
    ACTIONS(4168), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [117189] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6176), 1,
      anon_sym_LPAREN,
    ACTIONS(6182), 1,
      anon_sym_DOT,
    ACTIONS(6184), 1,
      anon_sym_QMARK_DOT,
    STATE(3082), 1,
      sym_arguments,
    ACTIONS(4136), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [117216] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6176), 1,
      anon_sym_LPAREN,
    ACTIONS(6186), 1,
      anon_sym_DOT,
    ACTIONS(6188), 1,
      anon_sym_QMARK_DOT,
    STATE(3081), 1,
      sym_arguments,
    ACTIONS(3387), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [117243] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4596), 1,
      sym_type_predicate,
    STATE(4917), 1,
      sym_predefined_type,
    ACTIONS(6190), 2,
      sym_identifier,
      sym_this,
    ACTIONS(117), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [117268] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6194), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3576), 1,
      sym_type_annotation,
    STATE(3582), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6192), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3259), 1,
      anon_sym_PIPE,
    ACTIONS(3261), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [117324] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6196), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3765), 1,
      sym_type_annotation,
    STATE(3810), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6158), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3400), 1,
      sym_type_predicate,
    STATE(4970), 1,
      sym_predefined_type,
    ACTIONS(6198), 2,
      sym_identifier,
      sym_this,
    ACTIONS(117), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [117384] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6200), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3681), 1,
      sym__call_signature,
    STATE(3683), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6166), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3269), 1,
      anon_sym_PIPE,
    ACTIONS(3271), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [117440] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      anon_sym_DOT,
    ACTIONS(6016), 1,
      anon_sym_LT,
    ACTIONS(6202), 1,
      anon_sym_EQ,
    ACTIONS(6207), 1,
      anon_sym_COLON,
    ACTIONS(6209), 1,
      anon_sym_extends,
    STATE(2847), 1,
      sym_type_arguments,
    STATE(3877), 1,
      sym_constraint,
    STATE(4530), 1,
      sym_default_type,
    ACTIONS(6204), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(3383), 3,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
  [117477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4405), 1,
      anon_sym_PIPE,
    ACTIONS(4407), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [117498] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6212), 1,
      anon_sym_COLON,
    ACTIONS(6214), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3330), 1,
      sym__call_signature,
    STATE(3576), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6192), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_PIPE,
    ACTIONS(4461), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [117554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_PIPE,
    ACTIONS(6032), 1,
      anon_sym_LT,
    STATE(3050), 1,
      sym_type_arguments,
    ACTIONS(4084), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [117579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3265), 1,
      anon_sym_PIPE,
    ACTIONS(3267), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [117600] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6216), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3713), 1,
      sym_type_annotation,
    STATE(3814), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6162), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117635] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3659), 1,
      sym_type_predicate,
    STATE(4639), 1,
      sym_predefined_type,
    ACTIONS(6218), 2,
      sym_identifier,
      sym_this,
    ACTIONS(117), 9,
      anon_sym_void,
      anon_sym_any,
      anon_sym_number,
      anon_sym_boolean,
      anon_sym_string,
      anon_sym_symbol,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_object,
  [117660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4413), 1,
      anon_sym_PIPE,
    ACTIONS(4415), 12,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [117681] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LT,
    ACTIONS(6154), 1,
      anon_sym_DOT,
    STATE(3170), 1,
      sym_type_arguments,
    ACTIONS(3383), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [117705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4435), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [117723] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3766), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [117751] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3643), 1,
      sym_type_annotation,
    STATE(3645), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6220), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117783] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3781), 1,
      sym_type_annotation,
    STATE(3796), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6222), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117815] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3793), 1,
      sym_type_annotation,
    STATE(4067), 1,
      sym__initializer,
    STATE(4068), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6224), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117851] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3253), 1,
      sym__call_signature,
    STATE(3689), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6226), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117883] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3307), 1,
      sym__call_signature,
    STATE(3662), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6228), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117915] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3742), 1,
      sym_type_annotation,
    STATE(4244), 1,
      sym__call_signature,
    STATE(4272), 1,
      sym__initializer,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6230), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [117951] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3274), 1,
      sym__call_signature,
    STATE(3802), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6232), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [117983] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3289), 1,
      sym__call_signature,
    STATE(3781), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6222), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118015] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3504), 1,
      sym__call_signature,
    STATE(3742), 1,
      sym_type_annotation,
    STATE(4177), 1,
      sym__initializer,
    STATE(4512), 1,
      sym_type_parameters,
    ACTIONS(6230), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118051] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3445), 1,
      sym__call_signature,
    STATE(3793), 1,
      sym_type_annotation,
    STATE(4077), 1,
      sym__initializer,
    STATE(4512), 1,
      sym_type_parameters,
    ACTIONS(6224), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118087] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3329), 1,
      sym__call_signature,
    STATE(3643), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6220), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118119] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3785), 1,
      sym__call_signature,
    STATE(3802), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6232), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4528), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4532), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4536), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4176), 1,
      anon_sym_PIPE,
    ACTIONS(6036), 1,
      anon_sym_is,
    ACTIONS(4178), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [118227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4544), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4536), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4544), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4560), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118299] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3776), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [118327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_PIPE,
    ACTIONS(6234), 1,
      anon_sym_is,
    ACTIONS(4084), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [118349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4524), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4560), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4524), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4548), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4574), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118439] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 1,
      anon_sym_COLON,
    ACTIONS(5986), 1,
      anon_sym_DOT,
    ACTIONS(6016), 1,
      anon_sym_LT,
    ACTIONS(6236), 1,
      anon_sym_QMARK,
    STATE(2847), 1,
      sym_type_arguments,
    STATE(4517), 1,
      sym_type_annotation,
    ACTIONS(3383), 6,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118469] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3785), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [118497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1462), 1,
      anon_sym_PIPE,
    ACTIONS(1460), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_is,
      anon_sym_PIPE_RBRACE,
  [118517] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3457), 1,
      sym__call_signature,
    STATE(3776), 1,
      sym_type_annotation,
    STATE(4141), 1,
      sym__initializer,
    STATE(4512), 1,
      sym_type_parameters,
    ACTIONS(6239), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4548), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4574), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4492), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118607] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3688), 1,
      sym__call_signature,
    STATE(3689), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6226), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [118639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118675] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3392), 1,
      sym__call_signature,
    STATE(3621), 1,
      sym_type_annotation,
    STATE(4018), 1,
      sym__initializer,
    STATE(4512), 1,
      sym_type_parameters,
    ACTIONS(6241), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [118711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4349), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4349), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4349), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4403), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4403), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4403), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4411), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4411), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118891] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3779), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [118919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4411), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4419), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4435), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [118973] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3773), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [119001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4435), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [119019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [119037] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3484), 1,
      sym__call_signature,
    STATE(3718), 1,
      sym_type_annotation,
    STATE(4185), 1,
      sym__initializer,
    STATE(4512), 1,
      sym_type_parameters,
    ACTIONS(6243), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [119073] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3763), 1,
      anon_sym_COMMA,
    ACTIONS(3782), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [119101] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3661), 1,
      sym__call_signature,
    STATE(3662), 1,
      sym_type_annotation,
    STATE(4401), 1,
      sym_type_parameters,
    ACTIONS(6228), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4439), 12,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [119151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2918), 1,
      anon_sym_PIPE,
    ACTIONS(2920), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4498), 1,
      anon_sym_PIPE,
    ACTIONS(4500), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4343), 1,
      anon_sym_PIPE,
    ACTIONS(4345), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3769), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [119225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4387), 1,
      anon_sym_PIPE,
    ACTIONS(4389), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119244] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6247), 1,
      anon_sym_PIPE,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(4556), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [119267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6247), 1,
      anon_sym_PIPE,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(4568), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [119290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4251), 1,
      anon_sym_PIPE,
    ACTIONS(6251), 1,
      anon_sym_LBRACK,
    ACTIONS(4253), 2,
      anon_sym_AMP,
      anon_sym_extends,
    ACTIONS(4383), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [119313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3267), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [119330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4397), 1,
      anon_sym_PIPE,
    ACTIONS(4399), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119349] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6247), 1,
      anon_sym_PIPE,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(4379), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [119372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_PIPE,
    ACTIONS(4375), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4272), 1,
      anon_sym_PIPE,
    ACTIONS(4274), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4369), 1,
      anon_sym_PIPE,
    ACTIONS(4371), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4518), 1,
      anon_sym_PIPE,
    ACTIONS(4520), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6152), 1,
      anon_sym_LT,
    STATE(3208), 1,
      sym_type_arguments,
    ACTIONS(4084), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [119469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4365), 1,
      anon_sym_PIPE,
    ACTIONS(4367), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4361), 1,
      anon_sym_PIPE,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(4363), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4554), 1,
      anon_sym_PIPE,
    ACTIONS(4556), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2121), 1,
      anon_sym_PIPE,
    ACTIONS(2123), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4494), 1,
      anon_sym_PIPE,
    ACTIONS(4496), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1625), 1,
      anon_sym_DOT,
    ACTIONS(4242), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [119585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4514), 1,
      anon_sym_PIPE,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(4516), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4510), 1,
      anon_sym_PIPE,
    ACTIONS(4512), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 1,
      anon_sym_PIPE,
    ACTIONS(2782), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4268), 1,
      anon_sym_PIPE,
    ACTIONS(4270), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4506), 1,
      anon_sym_PIPE,
    ACTIONS(4508), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4176), 1,
      anon_sym_PIPE,
    ACTIONS(4178), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_PIPE,
    ACTIONS(2119), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4393), 1,
      anon_sym_PIPE,
    ACTIONS(6251), 1,
      anon_sym_LBRACK,
    ACTIONS(4395), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2109), 1,
      anon_sym_PIPE,
    ACTIONS(2111), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6253), 1,
      anon_sym_DOT,
    ACTIONS(6255), 1,
      anon_sym_QMARK_DOT,
    ACTIONS(4234), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [119781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6247), 1,
      anon_sym_PIPE,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(4508), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [119804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4182), 1,
      anon_sym_PIPE,
    ACTIONS(4184), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1625), 1,
      anon_sym_DOT,
    ACTIONS(4240), 1,
      anon_sym_LBRACE,
    ACTIONS(4242), 9,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [119844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4357), 1,
      anon_sym_PIPE,
    ACTIONS(4359), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3271), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [119880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4550), 1,
      anon_sym_PIPE,
    ACTIONS(4552), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119899] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6247), 1,
      anon_sym_PIPE,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(4564), 8,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE_RBRACE,
  [119922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4502), 1,
      anon_sym_PIPE,
    ACTIONS(4504), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [119941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4407), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [119958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4415), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [119975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4461), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [119992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4251), 1,
      anon_sym_PIPE,
    ACTIONS(6251), 1,
      anon_sym_LBRACK,
    ACTIONS(4253), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [120013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4538), 1,
      anon_sym_PIPE,
    ACTIONS(4540), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [120032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4082), 1,
      anon_sym_PIPE,
    ACTIONS(4084), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [120051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4421), 1,
      anon_sym_PIPE,
    ACTIONS(4423), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [120070] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6247), 1,
      anon_sym_PIPE,
    ACTIONS(4341), 9,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [120091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4247), 1,
      anon_sym_PIPE,
    ACTIONS(4249), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [120110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2113), 1,
      anon_sym_PIPE,
    ACTIONS(2115), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [120129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3261), 11,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_QMARK_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [120146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4425), 1,
      anon_sym_PIPE,
    ACTIONS(4427), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [120165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    ACTIONS(4431), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [120184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4353), 1,
      anon_sym_PIPE,
    ACTIONS(4355), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [120203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2105), 1,
      anon_sym_PIPE,
    ACTIONS(2107), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [120222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 1,
      anon_sym_PIPE,
    ACTIONS(2936), 10,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_extends,
      anon_sym_PIPE_RBRACE,
  [120241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5274), 11,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [120258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6259), 1,
      anon_sym_COLON,
    STATE(3525), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(6257), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120278] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6261), 1,
      sym_identifier,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6265), 1,
      anon_sym_extends,
    ACTIONS(6267), 1,
      anon_sym_implements,
    STATE(2278), 1,
      sym_class_body,
    STATE(3287), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4476), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [120312] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(5935), 1,
      anon_sym_COLON,
    ACTIONS(5937), 1,
      anon_sym_DOT,
    ACTIONS(6269), 1,
      sym_identifier,
    ACTIONS(6271), 1,
      anon_sym_on,
    ACTIONS(6273), 1,
      anon_sym_list,
    STATE(2484), 1,
      sym_ui_object_initializer,
    STATE(4870), 1,
      sym_nested_identifier,
    STATE(2786), 2,
      sym_nested_type_identifier,
      sym_ui_list_property_type,
  [120344] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6247), 1,
      anon_sym_PIPE,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(6275), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120366] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6277), 1,
      anon_sym_LT,
    ACTIONS(6279), 1,
      anon_sym_DOT,
    ACTIONS(6281), 1,
      anon_sym_is,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3383), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [120390] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6283), 1,
      anon_sym_EQ,
    ACTIONS(6287), 1,
      anon_sym_BANG,
    STATE(3605), 1,
      sym__initializer,
    STATE(3824), 1,
      sym_type_annotation,
    ACTIONS(6289), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(6285), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120418] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6265), 1,
      anon_sym_extends,
    ACTIONS(6267), 1,
      anon_sym_implements,
    ACTIONS(6291), 1,
      sym_identifier,
    STATE(2278), 1,
      sym_class_body,
    STATE(3287), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4476), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [120452] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6265), 1,
      anon_sym_extends,
    ACTIONS(6267), 1,
      anon_sym_implements,
    ACTIONS(6293), 1,
      sym_identifier,
    STATE(2213), 1,
      sym_class_body,
    STATE(3353), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4474), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [120486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6156), 1,
      anon_sym_is,
    ACTIONS(4178), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [120504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 1,
      anon_sym_is,
    ACTIONS(4084), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [120522] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6265), 1,
      anon_sym_extends,
    ACTIONS(6267), 1,
      anon_sym_implements,
    ACTIONS(6297), 1,
      sym_identifier,
    STATE(2213), 1,
      sym_class_body,
    STATE(3353), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4474), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [120556] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6287), 1,
      anon_sym_BANG,
    STATE(3824), 1,
      sym_type_annotation,
    STATE(4113), 1,
      sym__initializer,
    ACTIONS(6289), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(6285), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [120584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3926), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3769), 7,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
      anon_sym_PIPE_RBRACE,
  [120604] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6265), 1,
      anon_sym_extends,
    ACTIONS(6267), 1,
      anon_sym_implements,
    ACTIONS(6299), 1,
      sym_identifier,
    STATE(2278), 1,
      sym_class_body,
    STATE(3287), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4476), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [120638] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6265), 1,
      anon_sym_extends,
    ACTIONS(6267), 1,
      anon_sym_implements,
    ACTIONS(6301), 1,
      sym_identifier,
    STATE(2213), 1,
      sym_class_body,
    STATE(3353), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4474), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [120672] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6265), 1,
      anon_sym_extends,
    ACTIONS(6267), 1,
      anon_sym_implements,
    ACTIONS(6303), 1,
      sym_identifier,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    STATE(1719), 1,
      sym_class_body,
    STATE(3357), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4618), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [120706] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6265), 1,
      anon_sym_extends,
    ACTIONS(6267), 1,
      anon_sym_implements,
    ACTIONS(6307), 1,
      sym_identifier,
    STATE(2213), 1,
      sym_class_body,
    STATE(3353), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4474), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [120740] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6265), 1,
      anon_sym_extends,
    ACTIONS(6267), 1,
      anon_sym_implements,
    ACTIONS(6309), 1,
      sym_identifier,
    STATE(2278), 1,
      sym_class_body,
    STATE(3287), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4476), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [120774] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3904), 1,
      anon_sym_LBRACE,
    ACTIONS(6311), 1,
      sym_identifier,
    ACTIONS(6313), 1,
      anon_sym_STAR,
    STATE(4356), 1,
      sym_import_require_clause,
    STATE(4358), 1,
      sym_string,
    STATE(4359), 1,
      sym_import_clause,
    STATE(4842), 2,
      sym_namespace_import_export,
      sym_named_imports,
  [120806] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3904), 1,
      anon_sym_LBRACE,
    ACTIONS(6311), 1,
      sym_identifier,
    ACTIONS(6313), 1,
      anon_sym_STAR,
    STATE(4313), 1,
      sym_import_require_clause,
    STATE(4321), 1,
      sym_string,
    STATE(4532), 1,
      sym_import_clause,
    STATE(4842), 2,
      sym_namespace_import_export,
      sym_named_imports,
  [120838] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6265), 1,
      anon_sym_extends,
    ACTIONS(6267), 1,
      anon_sym_implements,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    ACTIONS(6315), 1,
      sym_identifier,
    STATE(1746), 1,
      sym_class_body,
    STATE(3264), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4367), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [120872] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6265), 1,
      anon_sym_extends,
    ACTIONS(6267), 1,
      anon_sym_implements,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    ACTIONS(6317), 1,
      sym_identifier,
    STATE(2418), 1,
      sym_class_body,
    STATE(3313), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4575), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [120906] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6265), 1,
      anon_sym_extends,
    ACTIONS(6267), 1,
      anon_sym_implements,
    ACTIONS(6319), 1,
      sym_identifier,
    STATE(2278), 1,
      sym_class_body,
    STATE(3287), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4476), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [120940] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6265), 1,
      anon_sym_extends,
    ACTIONS(6267), 1,
      anon_sym_implements,
    ACTIONS(6321), 1,
      sym_identifier,
    STATE(2213), 1,
      sym_class_body,
    STATE(3353), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4474), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [120974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6259), 1,
      anon_sym_COLON,
    STATE(3443), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(6323), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [120994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1460), 10,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_is,
  [121010] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2101), 1,
      sym_class_body,
    STATE(3283), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4481), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [121041] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2242), 1,
      sym_class_body,
    STATE(3299), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4402), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [121072] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2196), 1,
      sym_class_body,
    STATE(3263), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4331), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [121103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4371), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121118] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6329), 1,
      anon_sym_LBRACE,
    STATE(169), 1,
      sym_class_body,
    STATE(3347), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4354), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [121149] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3614), 1,
      sym_type_annotation,
    STATE(4024), 1,
      sym__initializer,
    ACTIONS(6333), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6331), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2119), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4367), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_AMP,
    ACTIONS(4363), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [121221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4359), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4355), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2115), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6337), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [121281] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6329), 1,
      anon_sym_LBRACE,
    STATE(174), 1,
      sym_class_body,
    STATE(3316), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4493), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [121312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4249), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4084), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6339), 1,
      anon_sym_LBRACK,
    ACTIONS(4253), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6341), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [121374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4178), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4184), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4540), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4270), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 1,
      anon_sym_LBRACE,
    ACTIONS(2782), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [121451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4552), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE,
    ACTIONS(6345), 1,
      anon_sym_extends,
    ACTIONS(4556), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [121487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4556), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121502] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE,
    ACTIONS(6345), 1,
      anon_sym_extends,
    ACTIONS(4564), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [121523] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE,
    ACTIONS(6345), 1,
      anon_sym_extends,
    ACTIONS(4568), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [121544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2123), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121559] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3243), 1,
      sym_type_parameters,
    STATE(3678), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4573), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [121590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4274), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121605] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(701), 1,
      sym_class_body,
    STATE(3247), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4306), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [121636] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(1716), 1,
      sym_class_body,
    STATE(3280), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4320), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [121667] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3361), 1,
      sym_type_parameters,
    STATE(3747), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4587), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [121698] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6349), 1,
      anon_sym_LBRACE,
    STATE(2627), 1,
      sym_class_body,
    STATE(3260), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4328), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [121729] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6351), 1,
      anon_sym_LBRACE,
    STATE(2549), 1,
      sym_class_body,
    STATE(3268), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4371), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [121760] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6353), 1,
      anon_sym_LBRACE,
    STATE(879), 1,
      sym_class_body,
    STATE(3359), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4619), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [121791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4431), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4427), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4423), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121836] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(2039), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [121861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2107), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121876] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3657), 1,
      sym_type_annotation,
    STATE(4060), 1,
      sym__initializer,
    ACTIONS(6074), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6072), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121901] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3362), 1,
      sym_type_parameters,
    STATE(3815), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4621), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [121932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6355), 1,
      anon_sym_COLON,
    STATE(3568), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(6257), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [121951] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6351), 1,
      anon_sym_LBRACE,
    STATE(2556), 1,
      sym_class_body,
    STATE(3259), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4318), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [121982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4375), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [121997] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3356), 1,
      sym_type_parameters,
    STATE(3789), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4617), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [122028] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE,
    ACTIONS(6345), 1,
      anon_sym_extends,
    ACTIONS(4379), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [122049] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2398), 1,
      sym_class_body,
    STATE(3318), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4505), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [122080] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6349), 1,
      anon_sym_LBRACE,
    STATE(2611), 1,
      sym_class_body,
    STATE(3271), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4390), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [122111] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(5935), 1,
      anon_sym_COLON,
    ACTIONS(5937), 1,
      anon_sym_DOT,
    ACTIONS(6359), 1,
      anon_sym_on,
    STATE(2484), 1,
      sym_ui_object_initializer,
    ACTIONS(6357), 4,
      anon_sym_default,
      anon_sym_readonly,
      anon_sym_property,
      anon_sym_required,
  [122136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4345), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122151] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2214), 1,
      sym_class_body,
    STATE(3308), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4417), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [122182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE,
    ACTIONS(4341), 7,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_extends,
  [122201] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(699), 1,
      sym_class_body,
    STATE(3251), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4299), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [122232] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6361), 1,
      anon_sym_LBRACE,
    STATE(760), 1,
      sym_class_body,
    STATE(3290), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4330), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [122263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4520), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6339), 1,
      anon_sym_LBRACK,
    ACTIONS(4253), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
    ACTIONS(4383), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_AMP,
    ACTIONS(4516), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [122314] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(2043), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [122339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4512), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6363), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [122369] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6353), 1,
      anon_sym_LBRACE,
    STATE(891), 1,
      sym_class_body,
    STATE(3348), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4612), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [122400] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(4024), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [122425] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2248), 1,
      sym_class_body,
    STATE(3250), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4277), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [122456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2918), 1,
      anon_sym_LBRACE,
    ACTIONS(2920), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [122473] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3946), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [122498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4389), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122513] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3801), 1,
      sym_type_annotation,
    STATE(4070), 1,
      sym__initializer,
    ACTIONS(6090), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6088), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122538] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3600), 1,
      sym_type_annotation,
    STATE(4223), 1,
      sym__initializer,
    ACTIONS(6112), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6110), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4508), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122578] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(2015), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [122603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122618] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(2041), 1,
      anon_sym_RBRACE,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4109), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [122643] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6361), 1,
      anon_sym_LBRACE,
    STATE(790), 1,
      sym_class_body,
    STATE(3267), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4363), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [122674] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(1781), 1,
      sym_class_body,
    STATE(3258), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4312), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [122705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6365), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [122720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6367), 9,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [122735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6339), 1,
      anon_sym_LBRACK,
    ACTIONS(4395), 8,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE,
    ACTIONS(6345), 1,
      anon_sym_extends,
    ACTIONS(4508), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
  [122773] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(6369), 1,
      anon_sym_EQ,
    ACTIONS(6275), 5,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
  [122796] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3966), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
    STATE(4186), 1,
      aux_sym_object_repeat1,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [122821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4504), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4399), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2920), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122866] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3794), 1,
      sym_type_annotation,
    STATE(4127), 1,
      sym__initializer,
    ACTIONS(6136), 2,
      anon_sym_BANG,
      anon_sym_QMARK,
    ACTIONS(6134), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [122891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1625), 9,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_PIPE_RBRACE,
      aux_sym_ui_version_specifier_token1,
  [122906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4500), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2782), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122936] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2167), 1,
      sym_class_body,
    STATE(3332), 1,
      sym_type_parameters,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4342), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [122967] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6277), 1,
      anon_sym_LT,
    ACTIONS(6279), 1,
      anon_sym_DOT,
    STATE(2847), 1,
      sym_type_arguments,
    ACTIONS(3383), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [122988] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3824), 1,
      sym_type_annotation,
    STATE(4091), 1,
      sym__initializer,
    ACTIONS(6289), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(6285), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1629), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [123028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [123043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4496), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [123058] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6283), 1,
      anon_sym_EQ,
    STATE(3609), 1,
      sym__initializer,
    STATE(3824), 1,
      sym_type_annotation,
    ACTIONS(6289), 2,
      anon_sym_in,
      anon_sym_of,
    ACTIONS(6285), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123083] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6355), 1,
      anon_sym_COLON,
    STATE(3752), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
    ACTIONS(6323), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2111), 9,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [123117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 1,
      anon_sym_LBRACE,
    ACTIONS(2936), 8,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [123134] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    ACTIONS(6373), 1,
      anon_sym_DOT,
    STATE(3676), 1,
      sym_statement_block,
    ACTIONS(1491), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123154] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6375), 1,
      sym_escape_sequence,
    ACTIONS(6377), 1,
      anon_sym_BQUOTE,
    ACTIONS(6379), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6381), 1,
      sym__template_chars,
    STATE(3380), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3798), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [123178] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6375), 1,
      sym_escape_sequence,
    ACTIONS(6379), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6381), 1,
      sym__template_chars,
    ACTIONS(6383), 1,
      anon_sym_BQUOTE,
    STATE(3380), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3798), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [123202] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6379), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6381), 1,
      sym__template_chars,
    ACTIONS(6385), 1,
      sym_escape_sequence,
    ACTIONS(6387), 1,
      anon_sym_BQUOTE,
    STATE(3381), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3798), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [123226] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6287), 1,
      anon_sym_BANG,
    STATE(3824), 1,
      sym_type_annotation,
    STATE(4113), 1,
      sym__initializer,
    ACTIONS(6285), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123250] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6389), 1,
      sym_identifier,
    ACTIONS(6391), 1,
      anon_sym_LBRACE,
    ACTIONS(6393), 1,
      anon_sym_LBRACK,
    ACTIONS(6395), 1,
      anon_sym_enum,
    STATE(3858), 1,
      sym_variable_declarator,
    STATE(3270), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [123274] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6375), 1,
      sym_escape_sequence,
    ACTIONS(6379), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6381), 1,
      sym__template_chars,
    ACTIONS(6397), 1,
      anon_sym_BQUOTE,
    STATE(3380), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3798), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [123298] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6389), 1,
      sym_identifier,
    ACTIONS(6391), 1,
      anon_sym_LBRACE,
    ACTIONS(6393), 1,
      anon_sym_LBRACK,
    ACTIONS(6399), 1,
      anon_sym_enum,
    STATE(3859), 1,
      sym_variable_declarator,
    STATE(3270), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [123322] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6375), 1,
      sym_escape_sequence,
    ACTIONS(6379), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6381), 1,
      sym__template_chars,
    ACTIONS(6401), 1,
      anon_sym_BQUOTE,
    STATE(3380), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3798), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [123346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6247), 1,
      anon_sym_PIPE,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(6403), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123366] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6375), 1,
      sym_escape_sequence,
    ACTIONS(6379), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6381), 1,
      sym__template_chars,
    ACTIONS(6405), 1,
      anon_sym_BQUOTE,
    STATE(3380), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3798), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [123390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE,
    ACTIONS(6345), 1,
      anon_sym_extends,
    ACTIONS(6275), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6277), 1,
      anon_sym_LT,
    STATE(2860), 1,
      sym_type_arguments,
    ACTIONS(4084), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [123428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6247), 1,
      anon_sym_PIPE,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(6407), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123448] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6389), 1,
      sym_identifier,
    ACTIONS(6391), 1,
      anon_sym_LBRACE,
    ACTIONS(6393), 1,
      anon_sym_LBRACK,
    ACTIONS(6409), 1,
      anon_sym_enum,
    STATE(3855), 1,
      sym_variable_declarator,
    STATE(3270), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [123472] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(4628), 1,
      anon_sym_COMMA,
    STATE(3945), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(6411), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
    STATE(1739), 2,
      sym_template_string,
      sym_arguments,
  [123496] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6375), 1,
      sym_escape_sequence,
    ACTIONS(6379), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6381), 1,
      sym__template_chars,
    ACTIONS(6413), 1,
      anon_sym_BQUOTE,
    STATE(3380), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3732), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [123520] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6379), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6381), 1,
      sym__template_chars,
    ACTIONS(6385), 1,
      sym_escape_sequence,
    ACTIONS(6415), 1,
      anon_sym_BQUOTE,
    STATE(3381), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
    STATE(3798), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [123544] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_LBRACE,
    ACTIONS(6393), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      sym_identifier,
    STATE(3855), 1,
      sym_variable_declarator,
    STATE(3270), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [123565] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3628), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4553), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [123590] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3776), 1,
      sym_type_annotation,
    STATE(4144), 1,
      sym__initializer,
    ACTIONS(6239), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [123611] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6419), 1,
      sym_identifier,
    ACTIONS(6421), 1,
      anon_sym_STAR,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4455), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [123636] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6425), 1,
      sym_identifier,
    ACTIONS(6427), 1,
      anon_sym_STAR,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4446), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [123661] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(687), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4633), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [123686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(3676), 1,
      sym_statement_block,
    ACTIONS(1491), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6367), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [123716] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2211), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4326), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [123741] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(676), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4297), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [123766] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6429), 1,
      sym_identifier,
    ACTIONS(6431), 1,
      anon_sym_STAR,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4455), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [123791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4386), 1,
      sym_statement_block,
    ACTIONS(6433), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4383), 1,
      sym_statement_block,
    ACTIONS(6435), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4340), 1,
      sym_statement_block,
    ACTIONS(6435), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123842] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6437), 1,
      sym_identifier,
    ACTIONS(6439), 1,
      anon_sym_STAR,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4446), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [123867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4319), 1,
      sym_statement_block,
    ACTIONS(6433), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [123884] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(1808), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4368), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [123909] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6351), 1,
      anon_sym_LBRACE,
    STATE(2550), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4369), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [123934] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6349), 1,
      anon_sym_LBRACE,
    STATE(2571), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4377), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [123959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_LBRACE,
    ACTIONS(6393), 1,
      anon_sym_LBRACK,
    ACTIONS(6441), 1,
      sym_identifier,
    STATE(3859), 1,
      sym_variable_declarator,
    STATE(3216), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [123980] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_LBRACE,
    ACTIONS(6393), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      sym_identifier,
    STATE(3940), 1,
      sym_variable_declarator,
    STATE(3270), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [124001] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2131), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4389), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [124026] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(1785), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4314), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [124051] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_EQ,
    STATE(3877), 1,
      sym_constraint,
    STATE(4530), 1,
      sym_default_type,
    ACTIONS(6207), 2,
      anon_sym_COLON,
      anon_sym_extends,
    ACTIONS(6443), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [124072] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_LBRACE,
    ACTIONS(6393), 1,
      anon_sym_LBRACK,
    ACTIONS(6445), 1,
      sym_identifier,
    STATE(3988), 1,
      sym_variable_declarator,
    STATE(3220), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [124093] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6361), 1,
      anon_sym_LBRACE,
    STATE(730), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4545), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [124118] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6351), 1,
      anon_sym_LBRACE,
    STATE(2506), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4423), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [124143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3830), 1,
      sym_type_annotation,
    ACTIONS(6447), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124160] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3824), 1,
      sym_type_annotation,
    STATE(4091), 1,
      sym__initializer,
    ACTIONS(6285), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124181] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6349), 1,
      anon_sym_LBRACE,
    STATE(2685), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4497), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [124206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6449), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [124219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4583), 1,
      sym_statement_block,
    ACTIONS(6451), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124236] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4391), 1,
      sym_statement_block,
    ACTIONS(6453), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124253] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6455), 1,
      sym_identifier,
    ACTIONS(6457), 1,
      anon_sym_STAR,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4455), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [124278] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6459), 1,
      sym_identifier,
    ACTIONS(6461), 1,
      anon_sym_STAR,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4446), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [124303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3829), 1,
      sym_type_annotation,
    ACTIONS(6463), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124320] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6465), 1,
      sym_identifier,
    ACTIONS(6467), 1,
      anon_sym_STAR,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4446), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [124345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [124358] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(1764), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4301), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [124383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6469), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [124396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4799), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [124409] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2186), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4448), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [124434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6365), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [124447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6471), 1,
      anon_sym_EQ,
    ACTIONS(3454), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [124462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4490), 1,
      sym_statement_block,
    ACTIONS(6473), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124479] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2195), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4597), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [124504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4392), 1,
      sym_statement_block,
    ACTIONS(6451), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4485), 1,
      sym_statement_block,
    ACTIONS(6475), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124538] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6361), 1,
      anon_sym_LBRACE,
    STATE(825), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4346), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [124563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4348), 1,
      sym_statement_block,
    ACTIONS(6477), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4442), 1,
      sym_statement_block,
    ACTIONS(6477), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6341), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [124610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4278), 1,
      sym_statement_block,
    ACTIONS(6479), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124627] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6277), 1,
      anon_sym_LT,
    ACTIONS(6279), 1,
      anon_sym_DOT,
    ACTIONS(6481), 1,
      anon_sym_LBRACE,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(6485), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3956), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(4168), 1,
      sym_type_arguments,
  [124652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6487), 1,
      anon_sym_EQ,
    ACTIONS(3441), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [124667] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3742), 1,
      sym_type_annotation,
    STATE(4163), 1,
      sym__initializer,
    ACTIONS(6230), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3441), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [124701] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2235), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4379), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [124726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(4334), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [124743] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_LBRACE,
    ACTIONS(6393), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      sym_identifier,
    STATE(4226), 1,
      sym_variable_declarator,
    STATE(3270), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [124764] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3621), 1,
      sym_type_annotation,
    STATE(4028), 1,
      sym__initializer,
    ACTIONS(6241), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [124785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5274), 7,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [124798] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4284), 1,
      sym_statement_block,
    ACTIONS(6490), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4714), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [124828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6363), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [124841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4347), 1,
      sym_statement_block,
    ACTIONS(6479), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124858] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2240), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4405), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [124883] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_LBRACE,
    ACTIONS(6393), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      sym_identifier,
    STATE(3858), 1,
      sym_variable_declarator,
    STATE(3270), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [124904] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_LBRACE,
    ACTIONS(6393), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      sym_identifier,
    STATE(3893), 1,
      sym_variable_declarator,
    STATE(3270), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [124925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6337), 7,
      sym__automatic_semicolon,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_COLON,
  [124938] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4399), 1,
      sym_statement_block,
    ACTIONS(6490), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124955] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2438), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4508), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [124980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4547), 1,
      sym_statement_block,
    ACTIONS(6492), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [124997] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(6494), 1,
      sym_identifier,
    ACTIONS(6496), 1,
      anon_sym_DOT,
    STATE(3224), 1,
      sym_nested_identifier,
    STATE(3248), 1,
      sym_string,
    STATE(3715), 1,
      sym__module,
  [125022] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6329), 1,
      anon_sym_LBRACE,
    STATE(167), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4360), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [125047] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    STATE(1739), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(6498), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_implements,
  [125066] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2401), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4374), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [125091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3793), 1,
      sym_type_annotation,
    STATE(4078), 1,
      sym__initializer,
    ACTIONS(6224), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125112] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_LBRACE,
    ACTIONS(6393), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      sym_identifier,
    STATE(3859), 1,
      sym_variable_declarator,
    STATE(3270), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [125133] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6500), 1,
      sym_identifier,
    ACTIONS(6502), 1,
      anon_sym_STAR,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4446), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [125158] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6504), 1,
      anon_sym_LBRACE,
    ACTIONS(6506), 1,
      anon_sym_LT,
    ACTIONS(6508), 1,
      anon_sym_extends,
    ACTIONS(6510), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2657), 1,
      sym_object_type,
    STATE(3551), 1,
      sym_type_parameters,
    STATE(4273), 1,
      sym_extends_type_clause,
  [125183] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6512), 1,
      sym_identifier,
    ACTIONS(6514), 1,
      anon_sym_DOT,
    STATE(774), 1,
      sym__module,
    STATE(3845), 1,
      sym_nested_identifier,
    STATE(3898), 1,
      sym_string,
  [125208] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6516), 1,
      anon_sym_COLON,
    ACTIONS(6518), 1,
      anon_sym_QMARK,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4519), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [125233] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 1,
      anon_sym_COLON,
    ACTIONS(6520), 1,
      anon_sym_EQ,
    ACTIONS(6524), 1,
      anon_sym_QMARK,
    STATE(3992), 1,
      sym_type_annotation,
    STATE(4536), 1,
      sym__initializer,
    ACTIONS(6522), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [125256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6526), 1,
      anon_sym_is,
    ACTIONS(4084), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [125271] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6528), 1,
      sym_identifier,
    ACTIONS(6530), 1,
      anon_sym_STAR,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4455), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [125296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 1,
      anon_sym_is,
    ACTIONS(4178), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [125311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4400), 1,
      sym_statement_block,
    ACTIONS(6492), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4420), 1,
      sym_statement_block,
    ACTIONS(6532), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125345] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6534), 1,
      sym_identifier,
    ACTIONS(6536), 1,
      anon_sym_DOT,
    STATE(2446), 1,
      sym_nested_identifier,
    STATE(2486), 1,
      sym_string,
    STATE(2586), 1,
      sym__module,
  [125370] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2152), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4345), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [125395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4520), 1,
      sym_statement_block,
    ACTIONS(6538), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125412] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 1,
      anon_sym_DQUOTE,
    ACTIONS(2995), 1,
      anon_sym_SQUOTE,
    ACTIONS(6514), 1,
      anon_sym_DOT,
    ACTIONS(6540), 1,
      sym_identifier,
    STATE(674), 1,
      sym_nested_identifier,
    STATE(681), 1,
      sym_string,
    STATE(774), 1,
      sym__module,
  [125437] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1404), 1,
      anon_sym_LBRACE,
    ACTIONS(6506), 1,
      anon_sym_LT,
    ACTIONS(6508), 1,
      anon_sym_extends,
    STATE(729), 1,
      sym_object_type,
    STATE(3751), 1,
      sym_type_parameters,
    STATE(4160), 1,
      sym_extends_type_clause,
  [125462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 1,
      anon_sym_is,
    ACTIONS(6542), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4522), 1,
      sym_statement_block,
    ACTIONS(6544), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125494] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(838), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1657), 1,
      anon_sym_LBRACE,
    ACTIONS(6506), 1,
      anon_sym_LT,
    ACTIONS(6508), 1,
      anon_sym_extends,
    STATE(3608), 1,
      sym_object_type,
    STATE(3782), 1,
      sym_type_parameters,
    STATE(4073), 1,
      sym_extends_type_clause,
  [125519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3675), 1,
      sym_type_annotation,
    ACTIONS(6546), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4539), 1,
      sym_statement_block,
    ACTIONS(6548), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6550), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [125566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6552), 7,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_PIPE_RBRACE,
  [125579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4592), 1,
      sym_statement_block,
    ACTIONS(6453), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125596] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3559), 1,
      sym_type_annotation,
    STATE(4009), 1,
      sym__initializer,
    ACTIONS(6554), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3700), 1,
      sym_type_annotation,
    ACTIONS(6556), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [125634] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    ACTIONS(6016), 1,
      anon_sym_LT,
    STATE(1740), 1,
      sym_arguments,
    STATE(4381), 1,
      sym_type_arguments,
    ACTIONS(6558), 3,
      anon_sym_LBRACK,
      sym_identifier,
      sym_private_property_identifier,
  [125655] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6329), 1,
      anon_sym_LBRACE,
    STATE(171), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4465), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [125680] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6353), 1,
      anon_sym_LBRACE,
    STATE(881), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4624), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [125705] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(3718), 1,
      sym_type_annotation,
    STATE(4139), 1,
      sym__initializer,
    ACTIONS(6243), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [125726] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6518), 1,
      anon_sym_QMARK,
    ACTIONS(6560), 1,
      anon_sym_COLON,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4519), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [125751] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    ACTIONS(6016), 1,
      anon_sym_LT,
    STATE(2198), 1,
      sym_arguments,
    STATE(4295), 1,
      sym_type_arguments,
    ACTIONS(6558), 3,
      anon_sym_LBRACK,
      sym_identifier,
      sym_private_property_identifier,
  [125772] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6562), 1,
      sym_identifier,
    ACTIONS(6564), 1,
      anon_sym_STAR,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4451), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [125797] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(2109), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4463), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [125822] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3241), 1,
      anon_sym_LPAREN,
    ACTIONS(6566), 1,
      anon_sym_DOT,
    STATE(1129), 1,
      sym_arguments,
    ACTIONS(3239), 4,
      anon_sym_export,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
  [125841] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6568), 1,
      sym_identifier,
    ACTIONS(6570), 1,
      anon_sym_STAR,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4455), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [125866] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3754), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4593), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [125891] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    STATE(1723), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4452), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [125916] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 1,
      anon_sym_LBRACE,
    ACTIONS(6393), 1,
      anon_sym_LBRACK,
    ACTIONS(6417), 1,
      sym_identifier,
    STATE(3988), 1,
      sym_variable_declarator,
    STATE(3270), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [125937] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6353), 1,
      anon_sym_LBRACE,
    STATE(898), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4574), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [125962] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6572), 1,
      sym_identifier,
    ACTIONS(6574), 1,
      anon_sym_STAR,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4523), 1,
      sym_type_parameters,
    STATE(4627), 1,
      sym__call_signature,
  [125987] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3778), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4555), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [126012] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6325), 1,
      anon_sym_extends,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3704), 1,
      sym_class_body,
    STATE(4083), 1,
      sym_extends_clause,
    STATE(4579), 1,
      sym_class_heritage,
    STATE(4796), 1,
      sym_implements_clause,
  [126037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6576), 1,
      anon_sym_EQ,
    ACTIONS(3441), 6,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [126052] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6579), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6581), 1,
      anon_sym_QMARK_COLON,
    STATE(3648), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [126070] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(6583), 1,
      anon_sym_export,
    ACTIONS(6585), 1,
      anon_sym_class,
    ACTIONS(6587), 1,
      anon_sym_abstract,
    STATE(1128), 1,
      sym_decorator,
    STATE(3434), 1,
      aux_sym_export_statement_repeat1,
  [126092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2321), 1,
      sym_statement_block,
    ACTIONS(6544), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2329), 1,
      sym_statement_block,
    ACTIONS(6548), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126124] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6589), 1,
      sym_identifier,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4454), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [126146] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(6591), 1,
      anon_sym_COMMA,
    ACTIONS(6593), 1,
      anon_sym_GT,
    STATE(4176), 1,
      aux_sym_implements_clause_repeat1,
  [126168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3503), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6595), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      anon_sym_AMP,
    ACTIONS(4516), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [126198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 1,
      anon_sym_default,
    ACTIONS(6601), 1,
      anon_sym_RBRACE,
    ACTIONS(6603), 1,
      anon_sym_case,
    STATE(3441), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [126216] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6579), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6581), 1,
      anon_sym_QMARK_COLON,
    STATE(3550), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [126234] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(6605), 1,
      anon_sym_export,
    ACTIONS(6607), 1,
      anon_sym_class,
    ACTIONS(6609), 1,
      anon_sym_abstract,
    STATE(1128), 1,
      sym_decorator,
    STATE(3434), 1,
      aux_sym_export_statement_repeat1,
  [126256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 1,
      anon_sym_default,
    ACTIONS(6603), 1,
      anon_sym_case,
    ACTIONS(6611), 1,
      anon_sym_RBRACE,
    STATE(3372), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [126274] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 1,
      sym_identifier,
    ACTIONS(6615), 1,
      anon_sym_import,
    STATE(2870), 1,
      sym__type_query_subscript_expression,
    STATE(2871), 1,
      sym__type_query_member_expression,
    STATE(2959), 1,
      sym__type_query_call_expression,
    STATE(4496), 1,
      sym_import,
  [126296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3522), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6619), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6617), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3464), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6621), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2335), 1,
      sym_statement_block,
    ACTIONS(6532), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126344] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6625), 1,
      anon_sym_BQUOTE,
    ACTIONS(6627), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6623), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3481), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [126362] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6629), 1,
      anon_sym_BQUOTE,
    ACTIONS(6623), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3481), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [126380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3370), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3464), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6621), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2317), 1,
      sym_statement_block,
    ACTIONS(6538), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6550), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [126424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3458), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6631), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126440] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6633), 1,
      sym_identifier,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4450), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [126462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3511), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6635), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126478] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6637), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3660), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [126500] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(6639), 1,
      anon_sym_COMMA,
    ACTIONS(6641), 1,
      anon_sym_GT,
    STATE(4136), 1,
      aux_sym_implements_clause_repeat1,
  [126522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6646), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6643), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126538] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    ACTIONS(6648), 1,
      anon_sym_QMARK,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3424), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [126560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2326), 1,
      sym_statement_block,
    ACTIONS(6492), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126576] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    ACTIONS(6650), 1,
      anon_sym_QMARK,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3366), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [126598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6469), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [126610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      anon_sym_AMP,
    ACTIONS(4363), 5,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_extends,
  [126624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      anon_sym_AMP,
    ACTIONS(6652), 1,
      anon_sym_PIPE,
    ACTIONS(6654), 1,
      anon_sym_extends,
    ACTIONS(4379), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [126642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      sym_statement_block,
    ACTIONS(6473), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3385), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3511), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6635), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126674] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6579), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6581), 1,
      anon_sym_QMARK_COLON,
    STATE(3641), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [126692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [126704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3378), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6658), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6656), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3283), 6,
      anon_sym_export,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_AT,
      anon_sym_abstract,
  [126732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_COLON,
    ACTIONS(6257), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(4458), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [126748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2395), 1,
      sym_statement_block,
    ACTIONS(6492), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [126764] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6662), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3560), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [126786] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6664), 1,
      sym_identifier,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4302), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [126808] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6512), 1,
      sym_identifier,
    STATE(819), 1,
      sym__module,
    STATE(3845), 1,
      sym_nested_identifier,
    STATE(3898), 1,
      sym_string,
  [126830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6579), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6581), 1,
      anon_sym_QMARK_COLON,
    STATE(3571), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [126848] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6512), 1,
      sym_identifier,
    STATE(774), 1,
      sym__module,
    STATE(3845), 1,
      sym_nested_identifier,
    STATE(3898), 1,
      sym_string,
  [126870] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6534), 1,
      sym_identifier,
    STATE(2446), 1,
      sym_nested_identifier,
    STATE(2486), 1,
      sym_string,
    STATE(2586), 1,
      sym__module,
  [126892] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    ACTIONS(6534), 1,
      sym_identifier,
    STATE(2446), 1,
      sym_nested_identifier,
    STATE(2486), 1,
      sym_string,
    STATE(2619), 1,
      sym__module,
  [126914] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(6666), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_GT,
  [126932] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6668), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3674), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [126954] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6579), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6581), 1,
      anon_sym_QMARK_COLON,
    STATE(3672), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [126972] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6670), 1,
      sym_identifier,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4516), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [126994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3472), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3462), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6672), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127010] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6674), 1,
      sym_identifier,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4454), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [127032] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(6676), 1,
      anon_sym_COMMA,
    ACTIONS(6678), 1,
      anon_sym_GT,
    STATE(4094), 1,
      aux_sym_implements_clause_repeat1,
  [127054] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(6682), 1,
      anon_sym_QMARK,
    ACTIONS(6680), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [127074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6579), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6581), 1,
      anon_sym_QMARK_COLON,
    STATE(3629), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [127092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4940), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(3769), 4,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_QMARK,
  [127106] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(6684), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [127124] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6615), 1,
      anon_sym_import,
    ACTIONS(6686), 1,
      sym_identifier,
    STATE(1890), 1,
      sym__type_query_subscript_expression,
    STATE(1898), 1,
      sym__type_query_member_expression,
    STATE(1997), 1,
      sym__type_query_call_expression,
    STATE(4594), 1,
      sym_import,
  [127146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2340), 1,
      sym_statement_block,
    ACTIONS(6477), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127162] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    ACTIONS(6688), 1,
      anon_sym_QMARK,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3470), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [127184] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6277), 1,
      anon_sym_LT,
    ACTIONS(6279), 1,
      anon_sym_DOT,
    ACTIONS(6690), 1,
      anon_sym_LBRACE,
    STATE(4168), 1,
      sym_type_arguments,
    ACTIONS(6692), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [127204] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(6609), 1,
      anon_sym_abstract,
    ACTIONS(6694), 1,
      anon_sym_export,
    ACTIONS(6696), 1,
      anon_sym_class,
    STATE(1128), 1,
      sym_decorator,
    STATE(3434), 1,
      aux_sym_export_statement_repeat1,
  [127226] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6698), 1,
      anon_sym_QMARK,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4282), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [127248] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6615), 1,
      anon_sym_import,
    ACTIONS(6700), 1,
      sym_identifier,
    STATE(2788), 1,
      sym__type_query_subscript_expression,
    STATE(2789), 1,
      sym__type_query_member_expression,
    STATE(2832), 1,
      sym__type_query_call_expression,
    STATE(4599), 1,
      sym_import,
  [127270] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6615), 1,
      anon_sym_import,
    ACTIONS(6702), 1,
      sym_identifier,
    STATE(1473), 1,
      sym__type_query_member_expression,
    STATE(1496), 1,
      sym__type_query_subscript_expression,
    STATE(1514), 1,
      sym__type_query_call_expression,
    STATE(4438), 1,
      sym_import,
  [127292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3515), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6704), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127308] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(6706), 1,
      anon_sym_COMMA,
    ACTIONS(6708), 1,
      anon_sym_GT,
    STATE(4118), 1,
      aux_sym_implements_clause_repeat1,
  [127330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6449), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [127342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6710), 1,
      anon_sym_AT,
    STATE(1128), 1,
      sym_decorator,
    STATE(3434), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3247), 3,
      anon_sym_export,
      anon_sym_class,
      anon_sym_abstract,
  [127360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2339), 1,
      sym_statement_block,
    ACTIONS(6453), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127376] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(6494), 1,
      sym_identifier,
    STATE(3224), 1,
      sym_nested_identifier,
    STATE(3248), 1,
      sym_string,
    STATE(3697), 1,
      sym__module,
  [127398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6156), 1,
      anon_sym_is,
    ACTIONS(6542), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127412] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 1,
      anon_sym_default,
    ACTIONS(6603), 1,
      anon_sym_case,
    ACTIONS(6713), 1,
      anon_sym_RBRACE,
    STATE(3538), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [127430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2324), 1,
      sym_statement_block,
    ACTIONS(6477), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2318), 1,
      sym_statement_block,
    ACTIONS(6490), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6715), 1,
      anon_sym_default,
    ACTIONS(6718), 1,
      anon_sym_RBRACE,
    ACTIONS(6720), 1,
      anon_sym_case,
    STATE(3441), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [127480] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(6494), 1,
      sym_identifier,
    STATE(3224), 1,
      sym_nested_identifier,
    STATE(3248), 1,
      sym_string,
    STATE(3715), 1,
      sym__module,
  [127502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6723), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [127514] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6725), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(4242), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [127536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2387), 1,
      sym_statement_block,
    ACTIONS(6433), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3387), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6729), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6727), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3542), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6733), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6731), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2332), 1,
      sym_statement_block,
    ACTIONS(6451), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2385), 1,
      sym_statement_block,
    ACTIONS(6435), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127616] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3456), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6737), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6735), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127632] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6739), 1,
      sym_identifier,
    ACTIONS(6743), 1,
      anon_sym_COMMA,
    ACTIONS(6745), 1,
      anon_sym_RBRACE,
    STATE(4239), 1,
      sym__import_export_specifier,
    ACTIONS(6741), 2,
      anon_sym_type,
      anon_sym_typeof,
  [127652] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    ACTIONS(6747), 1,
      anon_sym_QMARK,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3464), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [127674] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 1,
      anon_sym_COLON,
    ACTIONS(6520), 1,
      anon_sym_EQ,
    STATE(3873), 1,
      sym_type_annotation,
    STATE(4468), 1,
      sym__initializer,
    ACTIONS(6749), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [127694] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6751), 1,
      anon_sym_QMARK,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4373), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [127716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3459), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3501), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6753), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3501), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6753), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2368), 1,
      sym_statement_block,
    ACTIONS(6479), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127764] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6277), 1,
      anon_sym_LT,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(6755), 1,
      anon_sym_LBRACE,
    ACTIONS(6757), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3955), 1,
      aux_sym_extends_type_clause_repeat1,
    STATE(4169), 1,
      sym_type_arguments,
  [127786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3499), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6759), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127802] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6761), 1,
      anon_sym_QMARK,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4382), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [127824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6552), 6,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [127836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3769), 6,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [127848] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    ACTIONS(6763), 1,
      anon_sym_QMARK,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3397), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [127870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2350), 1,
      sym_statement_block,
    ACTIONS(6490), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127886] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    ACTIONS(6765), 1,
      anon_sym_QMARK,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3448), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [127908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2347), 1,
      sym_statement_block,
    ACTIONS(6479), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [127924] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6767), 1,
      anon_sym_QMARK,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4344), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [127946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6769), 1,
      anon_sym_BQUOTE,
    ACTIONS(6375), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3380), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [127964] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(6771), 1,
      anon_sym_LBRACE,
    ACTIONS(6773), 1,
      anon_sym_COMMA,
    STATE(4104), 1,
      aux_sym_implements_clause_repeat1,
  [127986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2328), 1,
      sym_statement_block,
    ACTIONS(6435), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2342), 1,
      sym_statement_block,
    ACTIONS(6433), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3495), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6775), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6579), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6581), 1,
      anon_sym_QMARK_COLON,
    STATE(3646), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [128052] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6777), 1,
      sym_identifier,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4516), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [128074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(6779), 1,
      sym_identifier,
    ACTIONS(6781), 1,
      anon_sym_LBRACK,
    STATE(4336), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [128092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6579), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6581), 1,
      anon_sym_QMARK_COLON,
    STATE(3647), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [128110] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(6781), 1,
      anon_sym_LBRACK,
    ACTIONS(6783), 1,
      sym_identifier,
    STATE(3959), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [128128] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6785), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3687), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [128150] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_COLON,
    ACTIONS(6323), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
    STATE(4378), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [128166] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(6781), 1,
      anon_sym_LBRACK,
    ACTIONS(6787), 1,
      sym_identifier,
    STATE(4138), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [128184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6792), 1,
      anon_sym_BQUOTE,
    ACTIONS(6794), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6789), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3481), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [128202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6797), 1,
      anon_sym_BQUOTE,
    ACTIONS(6385), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(3381), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [128220] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 1,
      anon_sym_DQUOTE,
    ACTIONS(2995), 1,
      anon_sym_SQUOTE,
    ACTIONS(6540), 1,
      sym_identifier,
    STATE(674), 1,
      sym_nested_identifier,
    STATE(681), 1,
      sym_string,
    STATE(774), 1,
      sym__module,
  [128242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2380), 1,
      sym_statement_block,
    ACTIONS(6475), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128258] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6739), 1,
      sym_identifier,
    ACTIONS(6799), 1,
      anon_sym_COMMA,
    ACTIONS(6801), 1,
      anon_sym_RBRACE,
    STATE(4097), 1,
      sym__import_export_specifier,
    ACTIONS(6741), 2,
      anon_sym_type,
      anon_sym_typeof,
  [128278] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    ACTIONS(6579), 1,
      anon_sym_DASH_QMARK_COLON,
    ACTIONS(6581), 1,
      anon_sym_QMARK_COLON,
    STATE(3838), 3,
      sym_omitting_type_annotation,
      sym_opting_type_annotation,
      sym_type_annotation,
  [128296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6806), 1,
      anon_sym_property,
    STATE(3487), 2,
      sym_ui_property_modifier,
      aux_sym_ui_property_repeat1,
    ACTIONS(6803), 3,
      anon_sym_default,
      anon_sym_readonly,
      anon_sym_required,
  [128312] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6808), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3337), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [128334] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6810), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3543), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [128356] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6812), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3799), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [128378] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6814), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3286), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [128400] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 1,
      anon_sym_DQUOTE,
    ACTIONS(2995), 1,
      anon_sym_SQUOTE,
    ACTIONS(6540), 1,
      sym_identifier,
    STATE(674), 1,
      sym_nested_identifier,
    STATE(681), 1,
      sym_string,
    STATE(819), 1,
      sym__module,
  [128422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      anon_sym_AMP,
    ACTIONS(6652), 1,
      anon_sym_PIPE,
    ACTIONS(4341), 4,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_extends,
  [128438] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6816), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3304), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [128460] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6615), 1,
      anon_sym_import,
    ACTIONS(6818), 1,
      sym_identifier,
    STATE(2960), 1,
      sym__type_query_subscript_expression,
    STATE(2961), 1,
      sym__type_query_member_expression,
    STATE(3072), 1,
      sym__type_query_call_expression,
    STATE(4298), 1,
      sym_import,
  [128482] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(6820), 1,
      anon_sym_COMMA,
    ACTIONS(6822), 1,
      anon_sym_GT,
    STATE(4259), 1,
      aux_sym_implements_clause_repeat1,
  [128504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3431), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3509), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6824), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128520] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6826), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3273), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [128542] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6828), 1,
      sym_identifier,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4454), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [128564] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6830), 1,
      sym_identifier,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4516), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [128586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3462), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6672), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128602] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LBRACE,
    ACTIONS(6781), 1,
      anon_sym_LBRACK,
    ACTIONS(6832), 1,
      sym_identifier,
    STATE(3998), 3,
      sym_object_pattern,
      sym_array_pattern,
      sym__destructuring_pattern,
  [128620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3507), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6836), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6834), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2360), 1,
      sym_statement_block,
    ACTIONS(6453), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3511), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3479), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6838), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128668] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      anon_sym_AMP,
    ACTIONS(6652), 1,
      anon_sym_PIPE,
    ACTIONS(6654), 1,
      anon_sym_extends,
    ACTIONS(4568), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [128686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3479), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6838), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6842), 1,
      anon_sym_property,
    STATE(3487), 2,
      sym_ui_property_modifier,
      aux_sym_ui_property_repeat1,
    ACTIONS(6840), 3,
      anon_sym_default,
      anon_sym_readonly,
      anon_sym_required,
  [128718] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(5935), 1,
      anon_sym_COLON,
    ACTIONS(5937), 1,
      anon_sym_DOT,
    ACTIONS(6271), 1,
      anon_sym_on,
    ACTIONS(6844), 1,
      sym_identifier,
    STATE(2484), 1,
      sym_ui_object_initializer,
  [128740] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      anon_sym_AMP,
    ACTIONS(6652), 1,
      anon_sym_PIPE,
    ACTIONS(6654), 1,
      anon_sym_extends,
    ACTIONS(4564), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [128758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3473), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6846), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128774] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(5935), 1,
      anon_sym_COLON,
    ACTIONS(5937), 1,
      anon_sym_DOT,
    ACTIONS(6271), 1,
      anon_sym_on,
    ACTIONS(6848), 1,
      sym_identifier,
    STATE(2484), 1,
      sym_ui_object_initializer,
  [128796] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6850), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3255), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [128818] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      anon_sym_AMP,
    ACTIONS(6652), 1,
      anon_sym_PIPE,
    ACTIONS(6654), 1,
      anon_sym_extends,
    ACTIONS(4556), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [128836] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6852), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(4069), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [128858] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6854), 1,
      anon_sym_QMARK,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4523), 1,
      sym_type_parameters,
    STATE(4581), 1,
      sym__call_signature,
  [128880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3507), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6856), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128896] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(5935), 1,
      anon_sym_COLON,
    ACTIONS(5937), 1,
      anon_sym_DOT,
    ACTIONS(6359), 1,
      anon_sym_on,
    ACTIONS(6858), 1,
      anon_sym_function,
    STATE(2484), 1,
      sym_ui_object_initializer,
  [128918] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(6860), 1,
      anon_sym_COMMA,
    ACTIONS(6862), 1,
      anon_sym_GT,
    STATE(4193), 1,
      aux_sym_implements_clause_repeat1,
  [128940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1633), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [128952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1629), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [128964] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3509), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6824), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [128980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2107), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [128992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2123), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [129004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [129016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2119), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [129028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6866), 6,
      sym__automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [129040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2111), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [129052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2115), 6,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [129064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3501), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(6870), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6868), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [129080] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(6872), 1,
      anon_sym_QMARK,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3292), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [129102] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6874), 1,
      sym_identifier,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4454), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [129124] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6373), 1,
      anon_sym_DOT,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      aux_sym_ui_version_specifier_token1,
    STATE(4166), 1,
      sym_ui_version_specifier,
    ACTIONS(6878), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [129144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      anon_sym_AMP,
    ACTIONS(6652), 1,
      anon_sym_PIPE,
    ACTIONS(6654), 1,
      anon_sym_extends,
    ACTIONS(4508), 3,
      anon_sym_as,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [129162] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6882), 1,
      sym_identifier,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4516), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [129184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2364), 1,
      sym_statement_block,
    ACTIONS(6451), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [129200] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6884), 1,
      anon_sym_QMARK,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4467), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [129222] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6599), 1,
      anon_sym_default,
    ACTIONS(6603), 1,
      anon_sym_case,
    ACTIONS(6886), 1,
      anon_sym_RBRACE,
    STATE(3441), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [129240] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6888), 1,
      sym_identifier,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4516), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [129262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3517), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3497), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6890), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [129278] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    ACTIONS(6892), 1,
      sym_identifier,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4454), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [129300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3390), 1,
      aux_sym_object_type_repeat1,
    ACTIONS(3497), 2,
      anon_sym_RBRACE,
      anon_sym_PIPE_RBRACE,
    ACTIONS(6890), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [129316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6451), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [129327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym_EQ,
    ACTIONS(3454), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [129340] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4308), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [129359] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3594), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [129378] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6739), 1,
      sym_identifier,
    ACTIONS(6896), 1,
      anon_sym_RBRACE,
    STATE(4290), 1,
      sym__import_export_specifier,
    ACTIONS(6741), 2,
      anon_sym_type,
      anon_sym_typeof,
  [129395] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    ACTIONS(6898), 1,
      sym_identifier,
    STATE(3533), 1,
      sym_nested_identifier,
    STATE(3585), 1,
      sym_string,
  [129414] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_SEMI,
    ACTIONS(6902), 1,
      sym__automatic_semicolon,
    ACTIONS(6904), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2204), 1,
      sym_statement_block,
  [129433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6906), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [129444] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6504), 1,
      anon_sym_LBRACE,
    ACTIONS(6508), 1,
      anon_sym_extends,
    ACTIONS(6510), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2625), 1,
      sym_object_type,
    STATE(4220), 1,
      sym_extends_type_clause,
  [129463] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6908), 1,
      anon_sym_BQUOTE,
    ACTIONS(6910), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6912), 1,
      sym__template_chars,
    STATE(3732), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [129480] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6914), 1,
      anon_sym_BQUOTE,
    ACTIONS(6916), 1,
      sym__template_chars,
    STATE(3636), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [129497] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3561), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [129516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6739), 1,
      sym_identifier,
    ACTIONS(6918), 1,
      anon_sym_RBRACE,
    STATE(4290), 1,
      sym__import_export_specifier,
    ACTIONS(6741), 2,
      anon_sym_type,
      anon_sym_typeof,
  [129533] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3602), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [129552] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4327), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [129571] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4488), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [129590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    STATE(4099), 1,
      sym__initializer,
    ACTIONS(6920), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [129605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6544), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [129616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [129627] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(4092), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [129646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6866), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [129657] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_COLON,
    ACTIONS(6922), 1,
      anon_sym_EQ_GT,
    STATE(4378), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [129672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_COLON,
    ACTIONS(6925), 1,
      anon_sym_EQ_GT,
    STATE(4458), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [129687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6928), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [129698] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4352), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [129717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [129728] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_LBRACE,
    ACTIONS(6932), 1,
      anon_sym_SEMI,
    ACTIONS(6934), 1,
      sym__automatic_semicolon,
    ACTIONS(6936), 1,
      sym__function_signature_automatic_semicolon,
    STATE(700), 1,
      sym_statement_block,
  [129747] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3569), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [129766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6938), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [129777] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6900), 1,
      anon_sym_SEMI,
    ACTIONS(6902), 1,
      sym__automatic_semicolon,
    ACTIONS(6904), 1,
      sym__function_signature_automatic_semicolon,
    ACTIONS(6930), 1,
      anon_sym_LBRACE,
    STATE(692), 1,
      sym_statement_block,
  [129796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6940), 1,
      anon_sym_BQUOTE,
    ACTIONS(6942), 1,
      sym__template_chars,
    STATE(3553), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [129813] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3639), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [129832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [129843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [129854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3367), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [129873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5100), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [129884] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4375), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [129903] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(6948), 1,
      anon_sym_PIPE,
    ACTIONS(6946), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [129920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5113), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [129931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [129942] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(6948), 1,
      anon_sym_PIPE,
    ACTIONS(6950), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [129959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [129970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6876), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      aux_sym_ui_version_specifier_token1,
    STATE(4166), 1,
      sym_ui_version_specifier,
    ACTIONS(6878), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [129987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2372), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [129998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2380), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2496), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5353), 1,
      sym__automatic_semicolon,
    ACTIONS(1603), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130033] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(6952), 1,
      anon_sym_class,
    ACTIONS(6954), 1,
      anon_sym_abstract,
    STATE(1128), 1,
      sym_decorator,
    STATE(3434), 1,
      aux_sym_export_statement_repeat1,
  [130052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2700), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2688), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(6948), 1,
      anon_sym_PIPE,
    ACTIONS(6956), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [130091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_SEMI,
    ACTIONS(6902), 1,
      sym__automatic_semicolon,
    ACTIONS(6904), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2494), 1,
      sym_statement_block,
  [130110] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6739), 1,
      sym_identifier,
    ACTIONS(6958), 1,
      anon_sym_RBRACE,
    STATE(4322), 1,
      sym__import_export_specifier,
    ACTIONS(6741), 2,
      anon_sym_type,
      anon_sym_typeof,
  [130127] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(6948), 1,
      anon_sym_PIPE,
    ACTIONS(6960), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [130144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130155] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4523), 1,
      sym_type_parameters,
    STATE(4525), 1,
      sym__call_signature,
  [130174] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3471), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [130193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    STATE(4140), 1,
      sym__initializer,
    ACTIONS(6962), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130208] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(6607), 1,
      anon_sym_class,
    ACTIONS(6609), 1,
      anon_sym_abstract,
    STATE(1128), 1,
      sym_decorator,
    STATE(3434), 1,
      aux_sym_export_statement_repeat1,
  [130227] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    ACTIONS(6932), 1,
      anon_sym_SEMI,
    ACTIONS(6934), 1,
      sym__automatic_semicolon,
    ACTIONS(6936), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2139), 1,
      sym_statement_block,
  [130246] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(5935), 1,
      anon_sym_COLON,
    ACTIONS(5937), 1,
      anon_sym_DOT,
    ACTIONS(6359), 1,
      anon_sym_on,
    STATE(2484), 1,
      sym_ui_object_initializer,
  [130265] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4303), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [130284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6966), 1,
      anon_sym_in,
    ACTIONS(6968), 1,
      anon_sym_of,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2460), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130310] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_EQ,
    ACTIONS(6970), 1,
      anon_sym_COMMA,
    ACTIONS(6972), 1,
      anon_sym_RBRACE,
    STATE(4211), 1,
      aux_sym_enum_body_repeat1,
    STATE(4349), 1,
      sym__initializer,
  [130329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6974), 1,
      anon_sym_in,
    ACTIONS(6976), 1,
      anon_sym_of,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2396), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130366] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(6978), 1,
      anon_sym_COLON,
    ACTIONS(6980), 1,
      anon_sym_DOT,
    ACTIONS(6982), 1,
      anon_sym_on,
    STATE(2483), 1,
      sym_ui_object_initializer,
  [130385] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4418), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [130404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    STATE(4007), 1,
      sym__initializer,
    ACTIONS(6984), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130430] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4523), 1,
      sym_type_parameters,
    STATE(4584), 1,
      sym__call_signature,
  [130449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1551), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2512), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6277), 1,
      anon_sym_LT,
    ACTIONS(6986), 1,
      anon_sym_LBRACE,
    STATE(4169), 1,
      sym_type_arguments,
    ACTIONS(6988), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [130488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2540), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    STATE(4012), 1,
      sym__initializer,
    ACTIONS(6990), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [130525] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(6948), 1,
      anon_sym_PIPE,
    ACTIONS(6992), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [130542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2560), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_COLON,
    ACTIONS(6994), 1,
      anon_sym_EQ_GT,
    STATE(4458), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [130579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6739), 1,
      sym_identifier,
    ACTIONS(6997), 1,
      anon_sym_RBRACE,
    STATE(4322), 1,
      sym__import_export_specifier,
    ACTIONS(6741), 2,
      anon_sym_type,
      anon_sym_typeof,
  [130607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6999), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130629] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4286), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [130648] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3257), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [130667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5398), 1,
      sym__automatic_semicolon,
    ACTIONS(1713), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(6948), 1,
      anon_sym_PIPE,
    ACTIONS(7001), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [130697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5400), 1,
      sym__automatic_semicolon,
    ACTIONS(1735), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130710] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3383), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [130729] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7003), 1,
      anon_sym_BQUOTE,
    ACTIONS(7005), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7008), 1,
      sym__template_chars,
    STATE(3636), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [130746] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    ACTIONS(7011), 1,
      anon_sym_SEMI,
    ACTIONS(7013), 1,
      sym__automatic_semicolon,
    ACTIONS(7015), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2503), 1,
      sym_statement_block,
  [130765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7017), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [130776] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    ACTIONS(6932), 1,
      anon_sym_SEMI,
    ACTIONS(6934), 1,
      sym__automatic_semicolon,
    ACTIONS(6936), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2503), 1,
      sym_statement_block,
  [130795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6024), 1,
      anon_sym_LBRACK,
    ACTIONS(7019), 1,
      anon_sym_RBRACE,
    ACTIONS(4253), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [130810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7021), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130821] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(6948), 1,
      anon_sym_PIPE,
    ACTIONS(7023), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [130838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7025), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5307), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [130860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7029), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130904] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4523), 1,
      sym_type_parameters,
    STATE(4585), 1,
      sym__call_signature,
  [130923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6479), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1693), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130956] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3709), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [130975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2504), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [130986] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7033), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [131003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2572), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    STATE(4076), 1,
      sym__initializer,
    ACTIONS(7035), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131029] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      anon_sym_AMP,
    ACTIONS(6652), 1,
      anon_sym_PIPE,
    ACTIONS(6654), 1,
      anon_sym_extends,
    ACTIONS(7037), 1,
      anon_sym_as,
    ACTIONS(7039), 1,
      anon_sym_RBRACK,
  [131048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6490), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6479), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7041), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131092] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(6587), 1,
      anon_sym_abstract,
    ACTIONS(7043), 1,
      anon_sym_class,
    STATE(1128), 1,
      sym_decorator,
    STATE(3434), 1,
      aux_sym_export_statement_repeat1,
  [131111] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4523), 1,
      sym_type_parameters,
    STATE(4526), 1,
      sym__call_signature,
  [131130] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7045), 1,
      sym_identifier,
    ACTIONS(7047), 1,
      anon_sym_RPAREN,
    STATE(4269), 1,
      sym_ui_signal_parameter,
    STATE(4870), 1,
      sym_nested_identifier,
    STATE(5010), 1,
      sym_nested_type_identifier,
  [131149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4922), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [131160] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_EQ,
    ACTIONS(7049), 1,
      anon_sym_COMMA,
    ACTIONS(7051), 1,
      anon_sym_RBRACE,
    STATE(4030), 1,
      aux_sym_enum_body_repeat1,
    STATE(4349), 1,
      sym__initializer,
  [131179] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3343), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [131198] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4494), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [131217] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3549), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [131236] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(6948), 1,
      anon_sym_PIPE,
    ACTIONS(7053), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [131253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7055), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131264] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3745), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [131283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6435), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7057), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1721), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131316] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3294), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [131335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2608), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131357] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3314), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [131376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6435), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131387] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3333), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [131406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7059), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131417] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3340), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [131436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6490), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7061), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6433), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7063), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131491] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3404), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [131510] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4366), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [131529] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6273), 1,
      anon_sym_list,
    ACTIONS(7065), 1,
      sym_identifier,
    STATE(4870), 1,
      sym_nested_identifier,
    STATE(2784), 2,
      sym_nested_type_identifier,
      sym_ui_list_property_type,
  [131546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2608), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131568] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(6609), 1,
      anon_sym_abstract,
    ACTIONS(7067), 1,
      anon_sym_class,
    STATE(1128), 1,
      sym_decorator,
    STATE(3434), 1,
      aux_sym_export_statement_repeat1,
  [131587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2524), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1637), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131609] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3723), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [131628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2636), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7069), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131650] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    ACTIONS(7011), 1,
      anon_sym_SEMI,
    ACTIONS(7013), 1,
      sym__automatic_semicolon,
    ACTIONS(7015), 1,
      sym__function_signature_automatic_semicolon,
    STATE(910), 1,
      sym_statement_block,
  [131669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2352), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131680] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3769), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [131699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2684), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2692), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131732] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4473), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [131751] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4408), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [131770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6492), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131781] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4416), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [131800] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(6948), 1,
      anon_sym_PIPE,
    ACTIONS(7071), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [131817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7073), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131839] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1489), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      anon_sym_SEMI,
    ACTIONS(6902), 1,
      sym__automatic_semicolon,
    ACTIONS(6904), 1,
      sym__function_signature_automatic_semicolon,
    STATE(182), 1,
      sym_statement_block,
  [131858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [131880] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    ACTIONS(7075), 1,
      anon_sym_SEMI,
    ACTIONS(7077), 1,
      sym__automatic_semicolon,
    ACTIONS(7079), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2494), 1,
      sym_statement_block,
  [131899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    STATE(4066), 1,
      sym__initializer,
    ACTIONS(7081), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [131914] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4338), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [131933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 1,
      anon_sym_COLON,
    STATE(4517), 1,
      sym_type_annotation,
    ACTIONS(3441), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [131948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_COLON,
    ACTIONS(7083), 1,
      anon_sym_EQ_GT,
    STATE(4378), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [131963] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4341), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [131982] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1489), 1,
      anon_sym_LBRACE,
    ACTIONS(6932), 1,
      anon_sym_SEMI,
    ACTIONS(6934), 1,
      sym__automatic_semicolon,
    ACTIONS(6936), 1,
      sym__function_signature_automatic_semicolon,
    STATE(189), 1,
      sym_statement_block,
  [132001] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(6609), 1,
      anon_sym_abstract,
    ACTIONS(6696), 1,
      anon_sym_class,
    STATE(1128), 1,
      sym_decorator,
    STATE(3434), 1,
      aux_sym_export_statement_repeat1,
  [132020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2708), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132031] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4380), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [132050] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3738), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [132069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5228), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [132080] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4404), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [132099] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3757), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [132118] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7086), 1,
      anon_sym_BQUOTE,
    ACTIONS(7088), 1,
      sym__template_chars,
    STATE(3798), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [132135] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6916), 1,
      sym__template_chars,
    ACTIONS(7090), 1,
      anon_sym_BQUOTE,
    STATE(3636), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [132152] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3761), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [132171] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4337), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [132190] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(6954), 1,
      anon_sym_abstract,
    ACTIONS(7092), 1,
      anon_sym_class,
    STATE(1128), 1,
      sym_decorator,
    STATE(3434), 1,
      aux_sym_export_statement_repeat1,
  [132209] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4521), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [132228] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3714), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [132247] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    ACTIONS(7094), 1,
      anon_sym_SEMI,
    ACTIONS(7096), 1,
      sym__automatic_semicolon,
    ACTIONS(7098), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3634), 1,
      sym_statement_block,
  [132266] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_EQ,
    ACTIONS(7100), 1,
      anon_sym_COMMA,
    ACTIONS(7102), 1,
      anon_sym_RBRACE,
    STATE(4217), 1,
      aux_sym_enum_body_repeat1,
    STATE(4349), 1,
      sym__initializer,
  [132285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_COLON,
    ACTIONS(7104), 1,
      anon_sym_EQ_GT,
    STATE(4378), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [132300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2360), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132311] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    STATE(4192), 1,
      sym__initializer,
    ACTIONS(7107), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [132326] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3788), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [132345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2408), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6453), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2404), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1617), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132389] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3466), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [132408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4799), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [132419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4714), 5,
      anon_sym_EQ,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_of,
      anon_sym_COLON,
  [132430] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1404), 1,
      anon_sym_LBRACE,
    ACTIONS(6508), 1,
      anon_sym_extends,
    STATE(733), 1,
      sym_object_type,
    STATE(4173), 1,
      sym_extends_type_clause,
  [132449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6723), 5,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [132460] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3769), 1,
      anon_sym_COLON,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_COMMA,
    ACTIONS(7109), 1,
      anon_sym_RBRACE,
    STATE(4079), 1,
      aux_sym_object_pattern_repeat1,
  [132479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1527), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132512] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    ACTIONS(7094), 1,
      anon_sym_SEMI,
    ACTIONS(7096), 1,
      sym__automatic_semicolon,
    ACTIONS(7098), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2255), 1,
      sym_statement_block,
  [132531] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_COLON,
    ACTIONS(7111), 1,
      anon_sym_EQ_GT,
    STATE(4458), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [132546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5287), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [132557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5283), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [132568] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    ACTIONS(7114), 1,
      anon_sym_SEMI,
    ACTIONS(7116), 1,
      sym__automatic_semicolon,
    ACTIONS(7118), 1,
      sym__function_signature_automatic_semicolon,
    STATE(3840), 1,
      sym_statement_block,
  [132587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7120), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2480), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5228), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [132642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1571), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2704), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6538), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132675] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(4230), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [132694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1541), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132716] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3650), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [132735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7124), 5,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_extends,
      anon_sym_implements,
  [132746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5228), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [132757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    STATE(4029), 1,
      sym__initializer,
    ACTIONS(7126), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [132772] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4307), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [132791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(838), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1657), 1,
      anon_sym_LBRACE,
    ACTIONS(6508), 1,
      anon_sym_extends,
    STATE(3811), 1,
      sym_object_type,
    STATE(4050), 1,
      sym_extends_type_clause,
  [132854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2468), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132865] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    ACTIONS(7075), 1,
      anon_sym_SEMI,
    ACTIONS(7077), 1,
      sym__automatic_semicolon,
    ACTIONS(7079), 1,
      sym__function_signature_automatic_semicolon,
    STATE(880), 1,
      sym_statement_block,
  [132884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6453), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132895] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4447), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [132914] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3769), 1,
      anon_sym_COLON,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(3960), 1,
      anon_sym_COMMA,
    ACTIONS(7130), 1,
      anon_sym_RBRACE,
    STATE(4165), 1,
      aux_sym_object_pattern_repeat1,
  [132933] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    ACTIONS(7114), 1,
      anon_sym_SEMI,
    ACTIONS(7116), 1,
      sym__automatic_semicolon,
    ACTIONS(7118), 1,
      sym__function_signature_automatic_semicolon,
    STATE(2241), 1,
      sym_statement_block,
  [132952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1579), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2504), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2640), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1571), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [132996] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    STATE(4247), 1,
      sym__initializer,
    ACTIONS(7132), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [133011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    STATE(4026), 1,
      sym__initializer,
    ACTIONS(7134), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [133026] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7136), 1,
      anon_sym_BQUOTE,
    ACTIONS(7138), 1,
      sym__template_chars,
    STATE(3808), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [133043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6475), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133054] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3122), 1,
      sym_formal_parameters,
    STATE(3651), 1,
      sym__call_signature,
    STATE(4401), 1,
      sym_type_parameters,
  [133073] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6916), 1,
      sym__template_chars,
    ACTIONS(7140), 1,
      anon_sym_BQUOTE,
    STATE(3636), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [133090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2384), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    STATE(4179), 1,
      sym__initializer,
    ACTIONS(7142), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [133127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5303), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [133149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3435), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [133168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2524), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2620), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2412), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133201] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6916), 1,
      sym__template_chars,
    ACTIONS(7146), 1,
      anon_sym_BQUOTE,
    STATE(3636), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [133218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2456), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(7148), 1,
      anon_sym_BQUOTE,
    ACTIONS(7150), 1,
      sym__template_chars,
    STATE(3832), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [133268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2500), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6451), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2620), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5283), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [133323] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4339), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [133342] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4523), 1,
      sym_type_parameters,
    STATE(4580), 1,
      sym__call_signature,
  [133361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3637), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [133380] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4523), 1,
      sym_type_parameters,
    STATE(4623), 1,
      sym__call_signature,
  [133399] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3701), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [133418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5283), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [133429] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    STATE(4224), 1,
      sym__initializer,
    ACTIONS(7152), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [133444] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3717), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [133463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133474] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(6585), 1,
      anon_sym_class,
    ACTIONS(6587), 1,
      anon_sym_abstract,
    STATE(1128), 1,
      sym_decorator,
    STATE(3434), 1,
      aux_sym_export_statement_repeat1,
  [133493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6646), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7156), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133526] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4362), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [133545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6910), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(6916), 1,
      sym__template_chars,
    ACTIONS(7158), 1,
      anon_sym_BQUOTE,
    STATE(3636), 2,
      sym_template_type,
      aux_sym_template_literal_type_repeat1,
  [133562] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4523), 1,
      sym_type_parameters,
    STATE(4590), 1,
      sym__call_signature,
  [133581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2620), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_COLON,
    ACTIONS(7160), 1,
      anon_sym_EQ_GT,
    STATE(4458), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [133607] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3784), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [133626] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7163), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [133643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7165), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133654] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3479), 1,
      sym_formal_parameters,
    STATE(4453), 1,
      sym__call_signature,
    STATE(4523), 1,
      sym_type_parameters,
  [133673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5385), 1,
      sym__automatic_semicolon,
    ACTIONS(1703), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6070), 1,
      anon_sym_EQ,
    STATE(4187), 1,
      sym__initializer,
    ACTIONS(7167), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [133723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5404), 5,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
  [133734] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    ACTIONS(5632), 1,
      anon_sym_DOT,
    STATE(810), 1,
      sym_statement_block,
    ACTIONS(1491), 2,
      anon_sym_else,
      anon_sym_while,
  [133751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6660), 1,
      anon_sym_COLON,
    ACTIONS(7169), 1,
      anon_sym_EQ_GT,
    STATE(4378), 3,
      sym_type_annotation,
      sym_asserts,
      sym_type_predicate_annotation,
  [133766] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3221), 1,
      sym_formal_parameters,
    STATE(3572), 1,
      sym__call_signature,
    STATE(4512), 1,
      sym_type_parameters,
  [133785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_RBRACE,
  [133796] = 4,
    ACTIONS(7172), 1,
      anon_sym_DQUOTE,
    ACTIONS(7176), 1,
      sym_comment,
    STATE(3921), 1,
      aux_sym_string_repeat1,
    ACTIONS(7174), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [133810] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7178), 1,
      anon_sym_DQUOTE,
    STATE(3921), 1,
      aux_sym_string_repeat1,
    ACTIONS(7174), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [133824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_COMMA,
    ACTIONS(7180), 1,
      anon_sym_EQ,
    ACTIONS(7182), 1,
      anon_sym_RBRACK,
    STATE(4202), 1,
      aux_sym_array_pattern_repeat1,
  [133840] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7178), 1,
      anon_sym_SQUOTE,
    STATE(3920), 1,
      aux_sym_string_repeat2,
    ACTIONS(7184), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [133854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7186), 1,
      anon_sym_COMMA,
    STATE(3853), 1,
      aux_sym_implements_clause_repeat1,
    ACTIONS(6666), 2,
      anon_sym_LBRACE,
      anon_sym_GT,
  [133868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7189), 1,
      anon_sym_RPAREN,
  [133884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_COMMA,
    STATE(3924), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7193), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [133898] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4564), 1,
      sym_type_parameters,
    STATE(4641), 1,
      sym_formal_parameters,
  [133914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    STATE(4608), 1,
      sym__from_clause,
    ACTIONS(7197), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [133928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_COMMA,
    STATE(3879), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7199), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [133942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_COMMA,
    STATE(3990), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7201), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [133956] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7203), 1,
      anon_sym_RPAREN,
  [133972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7205), 1,
      anon_sym_RBRACK,
  [133988] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4577), 1,
      sym_type_parameters,
    STATE(4668), 1,
      sym_formal_parameters,
  [134004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_COMMA,
    STATE(3968), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7207), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [134018] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7209), 1,
      anon_sym_RBRACK,
  [134034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7211), 1,
      anon_sym_RPAREN,
  [134050] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(7213), 1,
      anon_sym_class,
    STATE(1128), 1,
      sym_decorator,
    STATE(3434), 1,
      aux_sym_export_statement_repeat1,
  [134066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_COMMA,
    STATE(3949), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(7215), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [134080] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7217), 1,
      anon_sym_DQUOTE,
    STATE(3850), 1,
      aux_sym_string_repeat1,
    ACTIONS(7219), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [134094] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7217), 1,
      anon_sym_SQUOTE,
    STATE(3852), 1,
      aux_sym_string_repeat2,
    ACTIONS(7221), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [134108] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4509), 1,
      sym_type_parameters,
    STATE(4772), 1,
      sym_formal_parameters,
  [134124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7223), 1,
      anon_sym_COLON,
  [134140] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(7225), 1,
      anon_sym_export,
    STATE(1128), 1,
      sym_decorator,
    STATE(3434), 1,
      aux_sym_export_statement_repeat1,
  [134156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_EQ,
    STATE(4504), 1,
      sym__initializer,
    ACTIONS(7227), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [134170] = 5,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7229), 1,
      sym__glimmer_template_content,
    ACTIONS(7231), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(1687), 1,
      sym_glimmer_closing_tag,
    STATE(3900), 1,
      aux_sym_glimmer_template_repeat1,
  [134186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    STATE(4629), 1,
      sym__from_clause,
    ACTIONS(4920), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [134200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_COMMA,
    STATE(3968), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7233), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [134214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6202), 1,
      anon_sym_EQ,
    STATE(4531), 1,
      sym_default_type,
    ACTIONS(7235), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [134228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 1,
      anon_sym_BQUOTE,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    STATE(2094), 2,
      sym_template_string,
      sym_arguments,
  [134242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_COMMA,
    STATE(3968), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7237), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [134256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4524), 1,
      sym_type_parameters,
    STATE(4728), 1,
      sym_formal_parameters,
  [134272] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_COMMA,
    ACTIONS(7180), 1,
      anon_sym_EQ,
    ACTIONS(7239), 1,
      anon_sym_RBRACK,
    STATE(4103), 1,
      aux_sym_array_pattern_repeat1,
  [134288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 1,
      anon_sym_BQUOTE,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    STATE(1739), 2,
      sym_template_string,
      sym_arguments,
  [134302] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7241), 1,
      anon_sym_SQUOTE,
    STATE(3920), 1,
      aux_sym_string_repeat2,
    ACTIONS(7184), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [134316] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7243), 1,
      anon_sym_QMARK,
  [134332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_COMMA,
    STATE(3968), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7245), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [134346] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7241), 1,
      anon_sym_DQUOTE,
    STATE(3921), 1,
      aux_sym_string_repeat1,
    ACTIONS(7174), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [134360] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 1,
      anon_sym_AT,
    ACTIONS(7247), 1,
      anon_sym_class,
    STATE(1128), 1,
      sym_decorator,
    STATE(3434), 1,
      aux_sym_export_statement_repeat1,
  [134376] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7249), 1,
      anon_sym_SQUOTE,
    STATE(3883), 1,
      aux_sym_string_repeat2,
    ACTIONS(7251), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [134390] = 5,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7253), 1,
      sym__glimmer_template_content,
    ACTIONS(7255), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(2200), 1,
      sym_glimmer_closing_tag,
    STATE(3891), 1,
      aux_sym_glimmer_template_repeat1,
  [134406] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7249), 1,
      anon_sym_DQUOTE,
    STATE(3886), 1,
      aux_sym_string_repeat1,
    ACTIONS(7257), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [134420] = 5,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7255), 1,
      anon_sym_LT_SLASHtemplate_GT,
    ACTIONS(7259), 1,
      sym__glimmer_template_content,
    STATE(2199), 1,
      sym_glimmer_closing_tag,
    STATE(4246), 1,
      aux_sym_glimmer_template_repeat1,
  [134436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7261), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [134446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_COMMA,
    STATE(3885), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7263), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [134460] = 4,
    ACTIONS(7172), 1,
      anon_sym_SQUOTE,
    ACTIONS(7176), 1,
      sym_comment,
    STATE(3920), 1,
      aux_sym_string_repeat2,
    ACTIONS(7184), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [134474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1886), 1,
      anon_sym_EQ_GT,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [134486] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7265), 1,
      anon_sym_SQUOTE,
    STATE(3894), 1,
      aux_sym_string_repeat2,
    ACTIONS(7267), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [134500] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7265), 1,
      anon_sym_DQUOTE,
    STATE(3849), 1,
      aux_sym_string_repeat1,
    ACTIONS(7269), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [134514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(810), 1,
      sym_statement_block,
    ACTIONS(1491), 2,
      anon_sym_else,
      anon_sym_while,
  [134528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7271), 1,
      anon_sym_RBRACK,
  [134544] = 5,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7231), 1,
      anon_sym_LT_SLASHtemplate_GT,
    ACTIONS(7259), 1,
      sym__glimmer_template_content,
    STATE(1741), 1,
      sym_glimmer_closing_tag,
    STATE(4246), 1,
      aux_sym_glimmer_template_repeat1,
  [134560] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7273), 1,
      sym_identifier,
    STATE(3458), 1,
      sym_nested_type_identifier,
    STATE(3976), 1,
      sym_generic_type,
    STATE(4789), 1,
      sym_nested_identifier,
  [134576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3269), 1,
      sym_formal_parameters,
    STATE(4365), 1,
      sym_type_parameters,
  [134592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7275), 1,
      anon_sym_EQ_GT,
    ACTIONS(3769), 3,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_QMARK,
  [134604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5550), 4,
      sym__automatic_semicolon,
      sym__function_signature_automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [134614] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    STATE(4384), 1,
      sym__from_clause,
    ACTIONS(4918), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [134628] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4484), 1,
      sym_type_parameters,
    STATE(4827), 1,
      sym_formal_parameters,
  [134644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7277), 1,
      anon_sym_RBRACK,
  [134660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3769), 1,
      anon_sym_COLON,
    ACTIONS(3790), 1,
      anon_sym_EQ,
    ACTIONS(7279), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [134674] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7281), 1,
      anon_sym_RPAREN,
  [134690] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4480), 1,
      sym_type_parameters,
    STATE(4850), 1,
      sym_formal_parameters,
  [134706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6739), 1,
      sym_identifier,
    STATE(4290), 1,
      sym__import_export_specifier,
    ACTIONS(6741), 2,
      anon_sym_type,
      anon_sym_typeof,
  [134720] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7283), 1,
      anon_sym_SQUOTE,
    STATE(3920), 1,
      aux_sym_string_repeat2,
    ACTIONS(7184), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [134734] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7283), 1,
      anon_sym_DQUOTE,
    STATE(3921), 1,
      aux_sym_string_repeat1,
    ACTIONS(7174), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [134748] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym_SQUOTE,
    STATE(3912), 1,
      aux_sym_string_repeat2,
    ACTIONS(7287), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [134762] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7285), 1,
      anon_sym_DQUOTE,
    STATE(3913), 1,
      aux_sym_string_repeat1,
    ACTIONS(7289), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [134776] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4461), 1,
      sym_type_parameters,
    STATE(4985), 1,
      sym_formal_parameters,
  [134792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    STATE(4332), 1,
      sym__from_clause,
    ACTIONS(7291), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [134806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7293), 1,
      anon_sym_COMMA,
    STATE(3918), 1,
      aux_sym_array_repeat1,
    ACTIONS(5018), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [134820] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4456), 1,
      sym_type_parameters,
    STATE(4998), 1,
      sym_formal_parameters,
  [134836] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7296), 1,
      anon_sym_SQUOTE,
    STATE(3920), 1,
      aux_sym_string_repeat2,
    ACTIONS(7298), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [134850] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7301), 1,
      anon_sym_DQUOTE,
    STATE(3921), 1,
      aux_sym_string_repeat1,
    ACTIONS(7303), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [134864] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7306), 1,
      anon_sym_COLON,
  [134880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    STATE(4424), 1,
      sym__from_clause,
    ACTIONS(7308), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [134894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_COMMA,
    STATE(3968), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7310), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [134908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7312), 1,
      anon_sym_RBRACK,
  [134924] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7314), 1,
      anon_sym_SQUOTE,
    STATE(3920), 1,
      aux_sym_string_repeat2,
    ACTIONS(7184), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [134938] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7316), 1,
      anon_sym_COLON,
  [134954] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7314), 1,
      anon_sym_DQUOTE,
    STATE(3921), 1,
      aux_sym_string_repeat1,
    ACTIONS(7174), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [134968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6739), 1,
      sym_identifier,
    STATE(4322), 1,
      sym__import_export_specifier,
    ACTIONS(6741), 2,
      anon_sym_type,
      anon_sym_typeof,
  [134982] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7045), 1,
      sym_identifier,
    STATE(4562), 1,
      sym_ui_signal_parameter,
    STATE(4870), 1,
      sym_nested_identifier,
    STATE(5010), 1,
      sym_nested_type_identifier,
  [134998] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7318), 1,
      anon_sym_SQUOTE,
    STATE(3926), 1,
      aux_sym_string_repeat2,
    ACTIONS(7320), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [135012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      sym_escape_sequence,
    ACTIONS(7324), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [135024] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4403), 1,
      sym_type_parameters,
    STATE(4740), 1,
      sym_formal_parameters,
  [135040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4396), 1,
      sym_type_parameters,
    STATE(4635), 1,
      sym_formal_parameters,
  [135056] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7318), 1,
      anon_sym_DQUOTE,
    STATE(3928), 1,
      aux_sym_string_repeat1,
    ACTIONS(7327), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [135070] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7329), 1,
      anon_sym_RBRACK,
  [135086] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4541), 1,
      sym_type_parameters,
    STATE(4713), 1,
      sym_formal_parameters,
  [135102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7331), 1,
      anon_sym_QMARK,
  [135118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7333), 1,
      anon_sym_LPAREN,
    STATE(4615), 1,
      sym_ui_signal_parameters,
    ACTIONS(7335), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [135132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_COMMA,
    STATE(3863), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7337), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [135146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7339), 1,
      anon_sym_RBRACK,
  [135162] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7341), 1,
      anon_sym_RBRACK,
  [135178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7343), 4,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_on,
  [135188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7019), 1,
      anon_sym_RBRACE,
    ACTIONS(4253), 3,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_extends,
  [135200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4628), 1,
      anon_sym_COMMA,
    STATE(3949), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(7345), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [135214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7349), 1,
      anon_sym_DOT,
    ACTIONS(7347), 3,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
  [135226] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7351), 1,
      anon_sym_SQUOTE,
    STATE(3920), 1,
      aux_sym_string_repeat2,
    ACTIONS(7184), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [135240] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7351), 1,
      anon_sym_DQUOTE,
    STATE(3921), 1,
      aux_sym_string_repeat1,
    ACTIONS(7174), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [135254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7355), 1,
      anon_sym_COMMA,
    STATE(3949), 1,
      aux_sym_extends_clause_repeat1,
    ACTIONS(7353), 2,
      anon_sym_LBRACE,
      anon_sym_implements,
  [135268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 4,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_on,
  [135278] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7360), 1,
      anon_sym_RBRACK,
  [135294] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7362), 1,
      anon_sym_DQUOTE,
    STATE(3965), 1,
      aux_sym_string_repeat1,
    ACTIONS(7364), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [135308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4544), 1,
      sym_type_parameters,
    STATE(4986), 1,
      sym_formal_parameters,
  [135324] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(7366), 1,
      anon_sym_LBRACE,
    ACTIONS(7368), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3960), 1,
      aux_sym_extends_type_clause_repeat1,
  [135340] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(7366), 1,
      anon_sym_LBRACE,
    ACTIONS(7368), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3960), 1,
      aux_sym_extends_type_clause_repeat1,
  [135356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(7370), 1,
      anon_sym_LBRACE,
    ACTIONS(7372), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3960), 1,
      aux_sym_extends_type_clause_repeat1,
  [135372] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 1,
      sym_identifier,
    STATE(3618), 1,
      sym_nested_type_identifier,
    STATE(4023), 1,
      sym_generic_type,
    STATE(4789), 1,
      sym_nested_identifier,
  [135388] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7376), 1,
      anon_sym_RBRACK,
  [135404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 1,
      anon_sym_EQ,
    STATE(4603), 1,
      sym__initializer,
    ACTIONS(6289), 2,
      anon_sym_in,
      anon_sym_of,
  [135418] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7380), 1,
      anon_sym_LBRACE,
    ACTIONS(7382), 1,
      anon_sym_COMMA,
    ACTIONS(7385), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3960), 1,
      aux_sym_extends_type_clause_repeat1,
  [135434] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    STATE(4315), 1,
      sym__from_clause,
    ACTIONS(5005), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [135448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_EQ,
    STATE(4349), 1,
      sym__initializer,
    ACTIONS(7387), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [135462] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7362), 1,
      anon_sym_SQUOTE,
    STATE(3967), 1,
      aux_sym_string_repeat2,
    ACTIONS(7389), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [135476] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7391), 1,
      anon_sym_COLON,
  [135492] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7393), 1,
      anon_sym_DQUOTE,
    STATE(3921), 1,
      aux_sym_string_repeat1,
    ACTIONS(7174), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [135506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6357), 4,
      anon_sym_default,
      anon_sym_readonly,
      anon_sym_property,
      anon_sym_required,
  [135516] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7393), 1,
      anon_sym_SQUOTE,
    STATE(3920), 1,
      aux_sym_string_repeat2,
    ACTIONS(7184), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [135530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7395), 1,
      anon_sym_COMMA,
    STATE(3968), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7398), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [135544] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_DQUOTE,
    STATE(3921), 1,
      aux_sym_string_repeat1,
    ACTIONS(7174), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [135558] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7402), 1,
      anon_sym_SQUOTE,
    STATE(3920), 1,
      aux_sym_string_repeat2,
    ACTIONS(7184), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [135572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3345), 1,
      sym_formal_parameters,
    STATE(4600), 1,
      sym_type_parameters,
  [135588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7404), 1,
      anon_sym_COLON,
  [135604] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7402), 1,
      anon_sym_DQUOTE,
    STATE(3921), 1,
      aux_sym_string_repeat1,
    ACTIONS(7174), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [135618] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7406), 1,
      anon_sym_QMARK,
  [135634] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7408), 1,
      anon_sym_SQUOTE,
    STATE(3970), 1,
      aux_sym_string_repeat2,
    ACTIONS(7410), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [135648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 1,
      anon_sym_COMMA,
    ACTIONS(6755), 1,
      anon_sym_LBRACE,
    ACTIONS(6757), 1,
      anon_sym_LBRACE_PIPE,
    STATE(3954), 1,
      aux_sym_extends_type_clause_repeat1,
  [135664] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7412), 1,
      anon_sym_SQUOTE,
    STATE(3947), 1,
      aux_sym_string_repeat2,
    ACTIONS(7414), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [135678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4310), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [135688] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7412), 1,
      anon_sym_DQUOTE,
    STATE(3948), 1,
      aux_sym_string_repeat1,
    ACTIONS(7416), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [135702] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7408), 1,
      anon_sym_DQUOTE,
    STATE(3973), 1,
      aux_sym_string_repeat1,
    ACTIONS(7418), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [135716] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7420), 1,
      anon_sym_RBRACK,
  [135732] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7422), 1,
      anon_sym_DQUOTE,
    STATE(3969), 1,
      aux_sym_string_repeat1,
    ACTIONS(7424), 2,
      sym_unescaped_double_string_fragment,
      sym_escape_sequence,
  [135746] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7422), 1,
      anon_sym_SQUOTE,
    STATE(3994), 1,
      aux_sym_string_repeat2,
    ACTIONS(7426), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [135760] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7428), 1,
      anon_sym_QMARK,
  [135776] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7430), 1,
      anon_sym_QMARK,
  [135792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7432), 1,
      anon_sym_COLON,
  [135808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3904), 1,
      anon_sym_LBRACE,
    ACTIONS(6313), 1,
      anon_sym_STAR,
    STATE(4813), 2,
      sym_namespace_import_export,
      sym_named_imports,
  [135822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_COMMA,
    STATE(3876), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7434), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [135836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7436), 1,
      anon_sym_QMARK,
  [135852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7191), 1,
      anon_sym_COMMA,
    STATE(3968), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(7438), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [135866] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7440), 1,
      anon_sym_RPAREN,
  [135882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6520), 1,
      anon_sym_EQ,
    STATE(4471), 1,
      sym__initializer,
    ACTIONS(7442), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [135896] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7444), 1,
      anon_sym_EQ,
    ACTIONS(7446), 1,
      anon_sym_COMMA,
    ACTIONS(7448), 1,
      anon_sym_RBRACE,
    STATE(4010), 1,
      aux_sym__qml_enum_body_repeat1,
  [135912] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_SQUOTE,
    STATE(3920), 1,
      aux_sym_string_repeat2,
    ACTIONS(7184), 2,
      sym_unescaped_single_string_fragment,
      sym_escape_sequence,
  [135926] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
    ACTIONS(7450), 1,
      anon_sym_RBRACK,
  [135942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(7452), 1,
      anon_sym_RPAREN,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [135955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7454), 1,
      anon_sym_COMMA,
    ACTIONS(7456), 1,
      anon_sym_RPAREN,
    STATE(4005), 1,
      aux_sym_formal_parameters_repeat1,
  [135968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 1,
      anon_sym_COLON,
    ACTIONS(7458), 1,
      anon_sym_RPAREN,
    STATE(4696), 1,
      sym_type_annotation,
  [135981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(7460), 1,
      anon_sym_RBRACK,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [135994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5018), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [136003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7462), 3,
      sym__template_chars,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [136012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    ACTIONS(7464), 1,
      anon_sym_LPAREN,
    STATE(2479), 1,
      sym_statement_block,
  [136025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7466), 1,
      anon_sym_DASH,
    ACTIONS(7468), 1,
      sym_number,
    STATE(4477), 1,
      sym__qml_enum_negative_number,
  [136038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 1,
      sym_identifier,
    ACTIONS(7472), 1,
      anon_sym_require,
    STATE(4231), 1,
      sym_nested_identifier,
  [136051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1440), 1,
      anon_sym_RPAREN,
    ACTIONS(7474), 1,
      anon_sym_COMMA,
    STATE(4086), 1,
      aux_sym_formal_parameters_repeat1,
  [136064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6469), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [136073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7476), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(4989), 1,
      anon_sym_RBRACK,
    STATE(3999), 1,
      aux_sym_array_repeat1,
  [136095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_COMMA,
    ACTIONS(7480), 1,
      anon_sym_RBRACE,
    STATE(4191), 1,
      aux_sym__qml_enum_body_repeat1,
  [136117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 1,
      anon_sym_COMMA,
    ACTIONS(7485), 1,
      anon_sym_RBRACE,
    STATE(4011), 1,
      aux_sym_object_repeat1,
  [136130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7487), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(4997), 1,
      anon_sym_RBRACK,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [136152] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7489), 1,
      anon_sym_COMMA,
    ACTIONS(7491), 1,
      anon_sym_RBRACK,
    STATE(4019), 1,
      aux_sym_ui_object_array_repeat1,
  [136165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7489), 1,
      anon_sym_COMMA,
    ACTIONS(7493), 1,
      anon_sym_RBRACK,
    STATE(4162), 1,
      aux_sym_ui_object_array_repeat1,
  [136178] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(4989), 1,
      anon_sym_RBRACK,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [136191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7495), 1,
      anon_sym_COMMA,
    ACTIONS(7498), 1,
      anon_sym_RBRACK,
    STATE(4017), 1,
      aux_sym_tuple_type_repeat1,
  [136204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7500), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7489), 1,
      anon_sym_COMMA,
    ACTIONS(7502), 1,
      anon_sym_RBRACK,
    STATE(4183), 1,
      aux_sym_ui_object_array_repeat1,
  [136226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7504), 1,
      anon_sym_COMMA,
    ACTIONS(7507), 1,
      anon_sym_RBRACE,
    STATE(4020), 1,
      aux_sym_enum_body_repeat1,
  [136239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(4997), 1,
      anon_sym_RBRACK,
    STATE(4159), 1,
      aux_sym_array_repeat1,
  [136252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6550), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [136261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6986), 1,
      anon_sym_LBRACE,
    ACTIONS(6988), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [136272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7509), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7511), 1,
      anon_sym_COMMA,
    ACTIONS(7513), 1,
      anon_sym_RPAREN,
    STATE(4151), 1,
      aux_sym_formal_parameters_repeat1,
  [136294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7515), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7517), 1,
      anon_sym_COMMA,
    ACTIONS(7519), 1,
      anon_sym_RBRACE,
    STATE(4020), 1,
      aux_sym_enum_body_repeat1,
  [136316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7500), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7521), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7523), 1,
      anon_sym_COMMA,
    ACTIONS(7525), 1,
      anon_sym_RBRACE,
    STATE(4020), 1,
      aux_sym_enum_body_repeat1,
  [136347] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_COMMA,
    ACTIONS(7529), 1,
      anon_sym_RBRACE,
    STATE(4011), 1,
      aux_sym_object_repeat1,
  [136360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6597), 1,
      anon_sym_AMP,
    ACTIONS(6652), 1,
      anon_sym_PIPE,
    ACTIONS(6654), 1,
      anon_sym_extends,
  [136373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7531), 1,
      anon_sym_COMMA,
    ACTIONS(7533), 1,
      anon_sym_GT,
    STATE(4181), 1,
      aux_sym_type_parameters_repeat1,
  [136386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_COMMA,
    ACTIONS(7529), 1,
      anon_sym_RBRACE,
    STATE(4036), 1,
      aux_sym_object_repeat1,
  [136399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7535), 1,
      sym_identifier,
    ACTIONS(7537), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [136410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_COMMA,
    ACTIONS(7539), 1,
      anon_sym_RBRACE,
    STATE(4011), 1,
      aux_sym_object_repeat1,
  [136423] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_COMMA,
    ACTIONS(7541), 1,
      anon_sym_RBRACE,
    STATE(4011), 1,
      aux_sym_object_repeat1,
  [136436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7543), 1,
      sym_identifier,
    ACTIONS(7545), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [136447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7549), 1,
      anon_sym_await,
    STATE(37), 1,
      sym__for_header,
  [136460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2872), 1,
      anon_sym_RBRACK,
    ACTIONS(7551), 1,
      anon_sym_COMMA,
    STATE(4017), 1,
      aux_sym_tuple_type_repeat1,
  [136473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 1,
      anon_sym_DQUOTE,
    ACTIONS(1675), 1,
      anon_sym_SQUOTE,
    STATE(4394), 1,
      sym_string,
  [136486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7553), 3,
      sym__automatic_semicolon,
      anon_sym_as,
      anon_sym_SEMI,
  [136495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7555), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_COMMA,
    ACTIONS(7182), 1,
      anon_sym_RBRACK,
    STATE(4202), 1,
      aux_sym_array_pattern_repeat1,
  [136517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7559), 1,
      anon_sym_COLON,
    ACTIONS(7557), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [136528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7561), 1,
      sym_identifier,
    ACTIONS(7563), 1,
      anon_sym_GT,
    STATE(4510), 1,
      sym_type_parameter,
  [136541] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(7567), 1,
      anon_sym_RBRACE,
    STATE(4027), 1,
      aux_sym_enum_body_repeat1,
  [136554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7569), 1,
      anon_sym_COMMA,
    ACTIONS(7572), 1,
      anon_sym_GT,
    STATE(4048), 1,
      aux_sym_type_parameters_repeat1,
  [136567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2057), 1,
      anon_sym_LBRACE,
    ACTIONS(7574), 1,
      sym_identifier,
    STATE(3961), 1,
      sym_export_clause,
  [136580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(838), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1657), 1,
      anon_sym_LBRACE,
    STATE(3702), 1,
      sym_object_type,
  [136593] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    ACTIONS(7576), 1,
      anon_sym_as,
    STATE(4350), 1,
      sym__from_clause,
  [136606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_COMMA,
    ACTIONS(7541), 1,
      anon_sym_RBRACE,
    STATE(4126), 1,
      aux_sym_object_repeat1,
  [136619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7580), 1,
      anon_sym_COLON,
    ACTIONS(7578), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [136630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7582), 1,
      sym_identifier,
    STATE(4870), 1,
      sym_nested_identifier,
    STATE(4989), 1,
      sym_nested_type_identifier,
  [136643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7586), 1,
      anon_sym_COLON,
    ACTIONS(7584), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [136654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7590), 1,
      anon_sym_COLON,
    ACTIONS(7588), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [136665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6373), 1,
      anon_sym_DOT,
    ACTIONS(7592), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [136676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(6980), 1,
      anon_sym_DOT,
    STATE(2750), 1,
      sym_ui_object_initializer,
  [136689] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(5937), 1,
      anon_sym_DOT,
    STATE(2751), 1,
      sym_ui_object_initializer,
  [136702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7555), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7594), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [136720] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_COMMA,
    ACTIONS(7596), 1,
      anon_sym_RBRACE,
    STATE(4191), 1,
      aux_sym__qml_enum_body_repeat1,
  [136733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7598), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7600), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2970), 1,
      anon_sym_RBRACK,
    ACTIONS(7602), 1,
      anon_sym_COMMA,
    STATE(4017), 1,
      aux_sym_tuple_type_repeat1,
  [136764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7604), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7608), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7600), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7598), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7610), 1,
      sym_identifier,
    STATE(4582), 1,
      sym_nested_type_identifier,
    STATE(4870), 1,
      sym_nested_identifier,
  [136822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7612), 1,
      anon_sym_COMMA,
    ACTIONS(7614), 1,
      anon_sym_GT,
    STATE(4149), 1,
      aux_sym_type_parameters_repeat1,
  [136835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(838), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1657), 1,
      anon_sym_LBRACE,
    STATE(3813), 1,
      sym_object_type,
  [136848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7616), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [136857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7618), 1,
      sym_identifier,
    ACTIONS(7620), 1,
      anon_sym_LBRACK,
    ACTIONS(7622), 1,
      sym_private_property_identifier,
  [136870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7624), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7606), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 1,
      anon_sym_COMMA,
    ACTIONS(7626), 1,
      anon_sym_RBRACE,
    STATE(4172), 1,
      aux_sym_object_pattern_repeat1,
  [136910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7598), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [136919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(4985), 1,
      anon_sym_RPAREN,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [136932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      sym_identifier,
    ACTIONS(7630), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [136943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6327), 1,
      anon_sym_implements,
    ACTIONS(7632), 1,
      anon_sym_LBRACE,
    STATE(4792), 1,
      sym_implements_clause,
  [136956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(4985), 1,
      anon_sym_RPAREN,
    STATE(3996), 1,
      aux_sym_array_repeat1,
  [136969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 1,
      anon_sym_COMMA,
    ACTIONS(7634), 1,
      anon_sym_RBRACE,
    STATE(4172), 1,
      aux_sym_object_pattern_repeat1,
  [136982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7636), 1,
      anon_sym_COMMA,
    ACTIONS(7639), 1,
      anon_sym_RPAREN,
    STATE(4086), 1,
      aux_sym_formal_parameters_repeat1,
  [136995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7641), 1,
      sym_identifier,
    ACTIONS(7643), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [137006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6449), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [137015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7645), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7647), 1,
      anon_sym_EQ,
    ACTIONS(7649), 1,
      anon_sym_COMMA,
    ACTIONS(7651), 1,
      anon_sym_from,
  [137037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7653), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7655), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_GT,
    ACTIONS(7657), 1,
      anon_sym_COMMA,
    STATE(3853), 1,
      aux_sym_implements_clause_repeat1,
  [137077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7659), 1,
      anon_sym_LPAREN,
    ACTIONS(7661), 1,
      anon_sym_await,
    STATE(35), 1,
      sym__for_header,
  [137090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      anon_sym_as,
    ACTIONS(7665), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [137101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      anon_sym_COMMA,
    ACTIONS(7669), 1,
      anon_sym_RBRACE,
    STATE(4182), 1,
      aux_sym_export_clause_repeat1,
  [137114] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5047), 1,
      anon_sym_extends,
    ACTIONS(7671), 1,
      anon_sym_AMP,
    ACTIONS(7673), 1,
      anon_sym_PIPE,
  [137127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7675), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7677), 1,
      anon_sym_EQ,
    ACTIONS(3441), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [137147] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7680), 1,
      anon_sym_COMMA,
    ACTIONS(7682), 1,
      anon_sym_RBRACK,
    STATE(4065), 1,
      aux_sym_tuple_type_repeat1,
  [137160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7684), 1,
      anon_sym_COMMA,
    ACTIONS(7686), 1,
      anon_sym_RPAREN,
    STATE(4158), 1,
      aux_sym_ui_signal_parameters_repeat1,
  [137173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_COMMA,
    ACTIONS(7688), 1,
      anon_sym_RBRACK,
    STATE(4203), 1,
      aux_sym_array_pattern_repeat1,
  [137186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6773), 1,
      anon_sym_COMMA,
    ACTIONS(7690), 1,
      anon_sym_LBRACE,
    STATE(3853), 1,
      aux_sym_implements_clause_repeat1,
  [137199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 1,
      anon_sym_RPAREN,
    ACTIONS(7692), 1,
      anon_sym_COMMA,
    STATE(4086), 1,
      aux_sym_formal_parameters_repeat1,
  [137212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    ACTIONS(7576), 1,
      anon_sym_as,
    STATE(4604), 1,
      sym__from_clause,
  [137225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      anon_sym_DOT,
    ACTIONS(7694), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [137236] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2057), 1,
      anon_sym_LBRACE,
    ACTIONS(7696), 1,
      sym_identifier,
    STATE(3875), 1,
      sym_export_clause,
  [137249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_COMMA,
    ACTIONS(7698), 1,
      anon_sym_RBRACE,
    STATE(4011), 1,
      aux_sym_object_repeat1,
  [137262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7700), 1,
      anon_sym_LBRACE,
    ACTIONS(7017), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [137273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6558), 3,
      anon_sym_LBRACK,
      sym_identifier,
      sym_private_property_identifier,
  [137282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_COMMA,
    ACTIONS(7704), 1,
      anon_sym_RBRACK,
    STATE(4145), 1,
      aux_sym_tuple_type_repeat1,
  [137295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6964), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_COMMA,
    ACTIONS(7182), 1,
      anon_sym_RBRACK,
    STATE(4203), 1,
      aux_sym_array_pattern_repeat1,
  [137317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7706), 1,
      anon_sym_COMMA,
    ACTIONS(7708), 1,
      anon_sym_RBRACK,
    STATE(4040), 1,
      aux_sym_tuple_type_repeat1,
  [137330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4306), 1,
      anon_sym_extends,
    ACTIONS(7710), 1,
      anon_sym_AMP,
    ACTIONS(7712), 1,
      anon_sym_PIPE,
  [137343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    ACTIONS(7576), 1,
      anon_sym_as,
    STATE(4492), 1,
      sym__from_clause,
  [137356] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3203), 1,
      anon_sym_GT,
    ACTIONS(7714), 1,
      anon_sym_COMMA,
    STATE(3853), 1,
      aux_sym_implements_clause_repeat1,
  [137369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7716), 1,
      anon_sym_COMMA,
    ACTIONS(7718), 1,
      anon_sym_RPAREN,
    STATE(4105), 1,
      aux_sym_formal_parameters_repeat1,
  [137382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      sym_identifier,
    STATE(2187), 1,
      sym_decorator_member_expression,
    STATE(2448), 1,
      sym_decorator_call_expression,
  [137395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7722), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7724), 1,
      sym_identifier,
    ACTIONS(7726), 1,
      anon_sym_LBRACK,
    ACTIONS(7728), 1,
      sym_private_property_identifier,
  [137417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 1,
      anon_sym_COMMA,
    ACTIONS(7730), 1,
      anon_sym_RBRACE,
    STATE(4172), 1,
      aux_sym_object_pattern_repeat1,
  [137430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(4983), 1,
      anon_sym_RPAREN,
    STATE(4150), 1,
      aux_sym_array_repeat1,
  [137443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(4983), 1,
      anon_sym_RPAREN,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [137456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_COMMA,
    ACTIONS(7732), 1,
      anon_sym_RBRACE,
    STATE(4011), 1,
      aux_sym_object_repeat1,
  [137469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7655), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6080), 1,
      anon_sym_PIPE,
    ACTIONS(6082), 1,
      anon_sym_extends,
  [137491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 1,
      anon_sym_COMMA,
    ACTIONS(7730), 1,
      anon_sym_RBRACE,
    STATE(4170), 1,
      aux_sym_object_pattern_repeat1,
  [137504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7734), 1,
      anon_sym_LPAREN,
    ACTIONS(7736), 1,
      anon_sym_await,
    STATE(40), 1,
      sym__for_header,
  [137517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_COMMA,
    ACTIONS(7239), 1,
      anon_sym_RBRACK,
    STATE(4203), 1,
      aux_sym_array_pattern_repeat1,
  [137530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2321), 1,
      anon_sym_while,
    ACTIONS(7738), 1,
      anon_sym_else,
    STATE(2554), 1,
      sym_else_clause,
  [137543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(6980), 1,
      anon_sym_DOT,
    STATE(2736), 1,
      sym_ui_object_initializer,
  [137556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_COMMA,
    ACTIONS(7239), 1,
      anon_sym_RBRACK,
    STATE(4103), 1,
      aux_sym_array_pattern_repeat1,
  [137569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(5937), 1,
      anon_sym_DOT,
    STATE(2721), 1,
      sym_ui_object_initializer,
  [137582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3207), 1,
      anon_sym_GT,
    ACTIONS(7740), 1,
      anon_sym_COMMA,
    STATE(3853), 1,
      aux_sym_implements_clause_repeat1,
  [137595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7555), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 1,
      anon_sym_COLON,
    ACTIONS(7742), 1,
      anon_sym_RPAREN,
    STATE(4873), 1,
      sym_type_annotation,
  [137617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7744), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7746), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7748), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137644] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 1,
      anon_sym_COMMA,
    ACTIONS(7750), 1,
      anon_sym_RBRACE,
    STATE(4172), 1,
      aux_sym_object_pattern_repeat1,
  [137657] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7561), 1,
      sym_identifier,
    ACTIONS(7752), 1,
      anon_sym_GT,
    STATE(4510), 1,
      sym_type_parameter,
  [137670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7748), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2946), 1,
      anon_sym_RBRACK,
    ACTIONS(7754), 1,
      anon_sym_COMMA,
    STATE(4017), 1,
      aux_sym_tuple_type_repeat1,
  [137692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(7756), 1,
      anon_sym_RPAREN,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [137705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(4969), 1,
      anon_sym_RPAREN,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [137718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 1,
      anon_sym_COMMA,
    ACTIONS(7750), 1,
      anon_sym_RBRACE,
    STATE(4085), 1,
      aux_sym_object_pattern_repeat1,
  [137731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7752), 1,
      anon_sym_GT,
    ACTIONS(7758), 1,
      anon_sym_COMMA,
    STATE(4048), 1,
      aux_sym_type_parameters_repeat1,
  [137744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(7760), 1,
      anon_sym_RPAREN,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [137757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1450), 1,
      anon_sym_RPAREN,
    ACTIONS(7762), 1,
      anon_sym_COMMA,
    STATE(4086), 1,
      aux_sym_formal_parameters_repeat1,
  [137770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7764), 1,
      sym_identifier,
    STATE(1122), 1,
      sym_decorator_call_expression,
    STATE(3354), 1,
      sym_decorator_member_expression,
  [137783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6552), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ_GT,
  [137792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(5007), 1,
      anon_sym_RPAREN,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [137805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(5007), 1,
      anon_sym_RPAREN,
    STATE(4146), 1,
      aux_sym_array_repeat1,
  [137818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 1,
      anon_sym_LBRACE,
    ACTIONS(7766), 1,
      anon_sym_LPAREN,
    STATE(696), 1,
      sym_statement_block,
  [137831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(7768), 1,
      anon_sym_EQ,
    STATE(4897), 1,
      sym_type_parameters,
  [137844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7770), 1,
      anon_sym_COMMA,
    ACTIONS(7773), 1,
      anon_sym_RPAREN,
    STATE(4158), 1,
      aux_sym_ui_signal_parameters_repeat1,
  [137857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(7775), 1,
      anon_sym_RBRACK,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [137870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1404), 1,
      anon_sym_LBRACE,
    STATE(745), 1,
      sym_object_type,
  [137883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5550), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7489), 1,
      anon_sym_COMMA,
    ACTIONS(7777), 1,
      anon_sym_RBRACK,
    STATE(4183), 1,
      aux_sym_ui_object_array_repeat1,
  [137905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7779), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [137914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(7781), 1,
      anon_sym_RPAREN,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [137927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 1,
      anon_sym_COMMA,
    ACTIONS(7783), 1,
      anon_sym_RBRACE,
    STATE(4172), 1,
      aux_sym_object_pattern_repeat1,
  [137940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7785), 1,
      anon_sym_as,
    ACTIONS(7787), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [137951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 1,
      anon_sym_EQ,
    ACTIONS(7789), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [137962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4373), 1,
      anon_sym_LBRACE,
    ACTIONS(4375), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [137973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4397), 1,
      anon_sym_LBRACE,
    ACTIONS(4399), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE_PIPE,
  [137984] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3960), 1,
      anon_sym_COMMA,
    ACTIONS(7791), 1,
      anon_sym_RBRACE,
    STATE(4172), 1,
      aux_sym_object_pattern_repeat1,
  [137997] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7793), 1,
      anon_sym_COMMA,
    ACTIONS(7795), 1,
      anon_sym_RBRACE,
    STATE(4216), 1,
      aux_sym_enum_body_repeat1,
  [138010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7797), 1,
      anon_sym_COMMA,
    ACTIONS(7800), 1,
      anon_sym_RBRACE,
    STATE(4172), 1,
      aux_sym_object_pattern_repeat1,
  [138023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      anon_sym_LBRACE_PIPE,
    ACTIONS(1404), 1,
      anon_sym_LBRACE,
    STATE(704), 1,
      sym_object_type,
  [138036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7802), 1,
      anon_sym_COMMA,
    ACTIONS(7804), 1,
      anon_sym_RBRACK,
    STATE(4240), 1,
      aux_sym_tuple_type_repeat1,
  [138049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6245), 1,
      anon_sym_AMP,
    ACTIONS(6249), 1,
      anon_sym_extends,
    ACTIONS(6948), 1,
      anon_sym_PIPE,
  [138062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3195), 1,
      anon_sym_GT,
    ACTIONS(7806), 1,
      anon_sym_COMMA,
    STATE(3853), 1,
      aux_sym_implements_clause_repeat1,
  [138075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7779), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [138084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7561), 1,
      sym_identifier,
    ACTIONS(7808), 1,
      anon_sym_GT,
    STATE(4510), 1,
      sym_type_parameter,
  [138097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7810), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [138106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(7812), 1,
      anon_sym_RPAREN,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [138119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7808), 1,
      anon_sym_GT,
    ACTIONS(7814), 1,
      anon_sym_COMMA,
    STATE(4048), 1,
      aux_sym_type_parameters_repeat1,
  [138132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7816), 1,
      anon_sym_COMMA,
    ACTIONS(7818), 1,
      anon_sym_RBRACE,
    STATE(4243), 1,
      aux_sym_export_clause_repeat1,
  [138145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7820), 1,
      anon_sym_COMMA,
    ACTIONS(7823), 1,
      anon_sym_RBRACK,
    STATE(4183), 1,
      aux_sym_ui_object_array_repeat1,
  [138158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7444), 1,
      anon_sym_EQ,
    ACTIONS(7825), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [138169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7744), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [138178] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7527), 1,
      anon_sym_COMMA,
    ACTIONS(7827), 1,
      anon_sym_RBRACE,
    STATE(4011), 1,
      aux_sym_object_repeat1,
  [138191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7829), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [138200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(4977), 1,
      anon_sym_RPAREN,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [138213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7831), 1,
      anon_sym_LBRACE,
    ACTIONS(6928), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [138224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(4977), 1,
      anon_sym_RPAREN,
    STATE(4180), 1,
      aux_sym_array_repeat1,
  [138237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7833), 1,
      anon_sym_COMMA,
    ACTIONS(7836), 1,
      anon_sym_RBRACE,
    STATE(4191), 1,
      aux_sym__qml_enum_body_repeat1,
  [138250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7838), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [138259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3145), 1,
      anon_sym_GT,
    ACTIONS(7840), 1,
      anon_sym_COMMA,
    STATE(3853), 1,
      aux_sym_implements_clause_repeat1,
  [138272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6373), 1,
      anon_sym_DOT,
    ACTIONS(7842), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [138283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7844), 1,
      anon_sym_COMMA,
    ACTIONS(7846), 1,
      anon_sym_RBRACE,
    STATE(4227), 1,
      aux_sym_named_imports_repeat1,
  [138296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7848), 1,
      sym_identifier,
    STATE(1107), 1,
      sym_decorator_member_expression,
    STATE(1122), 1,
      sym_decorator_call_expression,
  [138309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 1,
      anon_sym_EQ,
    ACTIONS(7850), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [138320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym_COMMA,
    ACTIONS(7651), 1,
      anon_sym_from,
    ACTIONS(7852), 1,
      anon_sym_EQ,
  [138333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(5023), 1,
      anon_sym_RPAREN,
    STATE(4235), 1,
      aux_sym_array_repeat1,
  [138346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(5023), 1,
      anon_sym_RPAREN,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [138359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(4969), 1,
      anon_sym_RPAREN,
    STATE(4164), 1,
      aux_sym_array_repeat1,
  [138372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 1,
      anon_sym_COMMA,
    ACTIONS(7854), 1,
      anon_sym_RBRACK,
    STATE(4203), 1,
      aux_sym_array_pattern_repeat1,
  [138385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7850), 1,
      anon_sym_RBRACK,
    ACTIONS(7856), 1,
      anon_sym_COMMA,
    STATE(4203), 1,
      aux_sym_array_pattern_repeat1,
  [138398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(5937), 1,
      anon_sym_DOT,
    STATE(2484), 1,
      sym_ui_object_initializer,
  [138411] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(7859), 1,
      anon_sym_EQ,
    STATE(4861), 1,
      sym_type_parameters,
  [138424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7861), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [138433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      anon_sym_COMMA,
    ACTIONS(7651), 1,
      anon_sym_from,
    ACTIONS(7863), 1,
      anon_sym_EQ,
  [138446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7865), 1,
      sym_identifier,
    ACTIONS(7867), 1,
      anon_sym_LBRACK,
    ACTIONS(7869), 1,
      sym_private_property_identifier,
  [138459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6471), 1,
      anon_sym_EQ,
    ACTIONS(3538), 2,
      anon_sym_in,
      anon_sym_of,
  [138470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7871), 1,
      anon_sym_COMMA,
    ACTIONS(7873), 1,
      anon_sym_RBRACE,
    STATE(4020), 1,
      aux_sym_enum_body_repeat1,
  [138483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7875), 1,
      anon_sym_COMMA,
    ACTIONS(7877), 1,
      anon_sym_RBRACE,
    STATE(4020), 1,
      aux_sym_enum_body_repeat1,
  [138496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7881), 1,
      anon_sym_LBRACK,
    ACTIONS(7883), 1,
      sym_private_property_identifier,
  [138509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7885), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [138518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7887), 1,
      anon_sym_as,
    ACTIONS(7889), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [138529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6018), 1,
      anon_sym_is,
    ACTIONS(6542), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [138540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7891), 1,
      anon_sym_COMMA,
    ACTIONS(7893), 1,
      anon_sym_RBRACE,
    STATE(4020), 1,
      aux_sym_enum_body_repeat1,
  [138553] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7895), 1,
      anon_sym_COMMA,
    ACTIONS(7897), 1,
      anon_sym_RBRACE,
    STATE(4020), 1,
      aux_sym_enum_body_repeat1,
  [138566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7899), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [138575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7901), 1,
      anon_sym_COMMA,
    ACTIONS(7903), 1,
      anon_sym_RBRACE,
    STATE(4210), 1,
      aux_sym_enum_body_repeat1,
  [138588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6504), 1,
      anon_sym_LBRACE,
    ACTIONS(6510), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2570), 1,
      sym_object_type,
  [138601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7905), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [138610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
    ACTIONS(1420), 1,
      anon_sym_SQUOTE,
    STATE(4651), 1,
      sym_string,
  [138623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7905), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [138632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7907), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [138641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7909), 1,
      anon_sym_EQ,
    ACTIONS(3538), 2,
      anon_sym_in,
      anon_sym_of,
  [138652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7398), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [138661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7911), 1,
      anon_sym_COMMA,
    ACTIONS(7914), 1,
      anon_sym_RBRACE,
    STATE(4227), 1,
      aux_sym_named_imports_repeat1,
  [138674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7916), 1,
      anon_sym_LBRACE,
    ACTIONS(7124), 2,
      anon_sym_extends,
      anon_sym_LBRACE_PIPE,
  [138685] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_LBRACE,
    ACTIONS(6980), 1,
      anon_sym_DOT,
    STATE(4551), 1,
      sym_ui_object_initializer,
  [138698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7918), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [138707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6373), 1,
      anon_sym_DOT,
    ACTIONS(7920), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [138718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7924), 1,
      anon_sym_COLON,
    ACTIONS(7922), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [138729] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(5632), 1,
      anon_sym_DOT,
    STATE(2766), 1,
      sym_ui_object_initializer,
  [138742] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_LT,
    ACTIONS(7926), 1,
      anon_sym_EQ,
    STATE(4969), 1,
      sym_type_parameters,
  [138755] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(7928), 1,
      anon_sym_RPAREN,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [138768] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7930), 1,
      sym_identifier,
    ACTIONS(7932), 1,
      anon_sym_LBRACK,
    ACTIONS(7934), 1,
      sym_private_property_identifier,
  [138781] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7561), 1,
      sym_identifier,
    ACTIONS(7936), 1,
      anon_sym_GT,
    STATE(4510), 1,
      sym_type_parameter,
  [138794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7938), 1,
      sym_identifier,
    ACTIONS(7940), 1,
      anon_sym_LBRACK,
    ACTIONS(7942), 1,
      sym_private_property_identifier,
  [138807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7944), 1,
      anon_sym_COMMA,
    ACTIONS(7946), 1,
      anon_sym_RBRACE,
    STATE(4195), 1,
      aux_sym_named_imports_repeat1,
  [138820] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_RBRACK,
    ACTIONS(7948), 1,
      anon_sym_COMMA,
    STATE(4017), 1,
      aux_sym_tuple_type_repeat1,
  [138833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2057), 1,
      anon_sym_LBRACE,
    ACTIONS(7950), 1,
      sym_identifier,
    STATE(3905), 1,
      sym_export_clause,
  [138846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7952), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [138855] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7954), 1,
      anon_sym_COMMA,
    ACTIONS(7957), 1,
      anon_sym_RBRACE,
    STATE(4243), 1,
      aux_sym_export_clause_repeat1,
  [138868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7918), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [138877] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7472), 1,
      anon_sym_require,
    ACTIONS(7959), 1,
      sym_identifier,
    STATE(4194), 1,
      sym_nested_identifier,
  [138890] = 4,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(7961), 1,
      sym__glimmer_template_content,
    ACTIONS(7964), 1,
      anon_sym_LT_SLASHtemplate_GT,
    STATE(4246), 1,
      aux_sym_glimmer_template_repeat1,
  [138903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7966), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [138912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7968), 1,
      sym_identifier,
    ACTIONS(7970), 1,
      anon_sym_LBRACK,
    ACTIONS(7972), 1,
      sym_private_property_identifier,
  [138925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7885), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [138934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7976), 1,
      anon_sym_COLON,
    ACTIONS(7974), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [138945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7980), 1,
      anon_sym_COLON,
    ACTIONS(7978), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [138956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7982), 1,
      sym_identifier,
    ACTIONS(7984), 1,
      anon_sym_LBRACK,
    ACTIONS(7986), 1,
      sym_private_property_identifier,
  [138969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7988), 1,
      sym_identifier,
    ACTIONS(7990), 1,
      anon_sym_LBRACK,
    ACTIONS(7992), 1,
      sym_private_property_identifier,
  [138982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7994), 1,
      anon_sym_COMMA,
    ACTIONS(7996), 1,
      anon_sym_RBRACK,
    STATE(4271), 1,
      aux_sym_tuple_type_repeat1,
  [138995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7998), 1,
      sym_identifier,
    ACTIONS(8000), 1,
      anon_sym_LBRACK,
    ACTIONS(8002), 1,
      sym_private_property_identifier,
  [139008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8006), 1,
      anon_sym_COLON,
    ACTIONS(8004), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [139019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 1,
      anon_sym_AMP,
    ACTIONS(6343), 1,
      anon_sym_PIPE,
    ACTIONS(6345), 1,
      anon_sym_extends,
  [139032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8010), 1,
      anon_sym_COLON,
    ACTIONS(8008), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [139043] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3205), 1,
      anon_sym_GT,
    ACTIONS(8012), 1,
      anon_sym_COMMA,
    STATE(3853), 1,
      aux_sym_implements_clause_repeat1,
  [139056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      anon_sym_COMMA,
    ACTIONS(8014), 1,
      anon_sym_RBRACE,
    STATE(4062), 1,
      aux_sym__qml_enum_body_repeat1,
  [139069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_LBRACE,
    ACTIONS(6980), 1,
      anon_sym_DOT,
    STATE(2483), 1,
      sym_ui_object_initializer,
  [139082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(4949), 1,
      anon_sym_RPAREN,
    STATE(4274), 1,
      aux_sym_array_repeat1,
  [139095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(4949), 1,
      anon_sym_RPAREN,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [139108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8016), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [139117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      sym_identifier,
    ACTIONS(8020), 1,
      anon_sym_LBRACK,
    ACTIONS(8022), 1,
      sym_private_property_identifier,
  [139130] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8024), 1,
      sym_identifier,
    ACTIONS(8026), 1,
      anon_sym_LBRACK,
    ACTIONS(8028), 1,
      sym_private_property_identifier,
  [139143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8030), 1,
      sym_identifier,
    ACTIONS(8032), 1,
      anon_sym_LBRACK,
    ACTIONS(8034), 1,
      sym_private_property_identifier,
  [139156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8036), 1,
      sym_identifier,
    ACTIONS(8038), 1,
      anon_sym_LBRACK,
    ACTIONS(8040), 1,
      sym_private_property_identifier,
  [139169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7684), 1,
      anon_sym_COMMA,
    ACTIONS(8042), 1,
      anon_sym_RPAREN,
    STATE(4102), 1,
      aux_sym_ui_signal_parameters_repeat1,
  [139182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      anon_sym_DOT,
    ACTIONS(8044), 1,
      sym_identifier,
    ACTIONS(8046), 1,
      anon_sym_COLON,
  [139195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 1,
      anon_sym_RBRACK,
    ACTIONS(8048), 1,
      anon_sym_COMMA,
    STATE(4017), 1,
      aux_sym_tuple_type_repeat1,
  [139208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7779), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [139217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6504), 1,
      anon_sym_LBRACE,
    ACTIONS(6510), 1,
      anon_sym_LBRACE_PIPE,
    STATE(2628), 1,
      sym_object_type,
  [139230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      anon_sym_COMMA,
    ACTIONS(8050), 1,
      anon_sym_RPAREN,
    STATE(3918), 1,
      aux_sym_array_repeat1,
  [139243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8052), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [139251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8054), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [139259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2212), 1,
      sym_class_body,
  [139269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [139277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      sym_identifier,
    ACTIONS(8022), 1,
      sym_private_property_identifier,
  [139287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7998), 1,
      sym_identifier,
    ACTIONS(8002), 1,
      sym_private_property_identifier,
  [139297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8056), 1,
      sym_identifier,
    ACTIONS(8058), 1,
      sym_private_property_identifier,
  [139307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4490), 1,
      sym_statement_block,
  [139317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8060), 1,
      sym_identifier,
    ACTIONS(8062), 1,
      sym_private_property_identifier,
  [139327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5460), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [139335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8064), 1,
      sym_identifier,
    ACTIONS(8066), 1,
      sym_private_property_identifier,
  [139345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4547), 1,
      sym_statement_block,
  [139355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8068), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [139363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8070), 1,
      anon_sym_SEMI,
    ACTIONS(8072), 1,
      sym__automatic_semicolon,
  [139373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8074), 1,
      sym_identifier,
    ACTIONS(8076), 1,
      sym_private_property_identifier,
  [139383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8078), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [139391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8080), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [139399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8082), 1,
      sym_identifier,
    STATE(4233), 1,
      sym_nested_identifier,
  [139409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8084), 1,
      sym_identifier,
    ACTIONS(8086), 1,
      sym_private_property_identifier,
  [139419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8088), 1,
      sym_identifier,
    ACTIONS(8090), 1,
      sym_private_property_identifier,
  [139429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    STATE(2099), 1,
      sym_arguments,
  [139439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8092), 1,
      sym_identifier,
    STATE(4194), 1,
      sym_nested_identifier,
  [139449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(689), 1,
      sym_class_body,
  [139459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6176), 1,
      anon_sym_LPAREN,
    STATE(3081), 1,
      sym_arguments,
  [139469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(702), 1,
      sym_class_body,
  [139479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8094), 1,
      sym_identifier,
    ACTIONS(8096), 1,
      anon_sym_STAR,
  [139489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    STATE(1801), 1,
      sym_class_body,
  [139499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4312), 1,
      anon_sym_LBRACE,
    STATE(1803), 1,
      sym_statement_block,
  [139509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4312), 1,
      anon_sym_LBRACE,
    STATE(1804), 1,
      sym_statement_block,
  [139519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8098), 1,
      sym_identifier,
    ACTIONS(8100), 1,
      anon_sym_STAR,
  [139529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7938), 1,
      sym_identifier,
    ACTIONS(7942), 1,
      sym_private_property_identifier,
  [139539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(683), 1,
      sym_class_body,
  [139549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4319), 1,
      sym_statement_block,
  [139559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4312), 1,
      anon_sym_LBRACE,
    STATE(1805), 1,
      sym_statement_block,
  [139569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8102), 1,
      anon_sym_SEMI,
    ACTIONS(8104), 1,
      sym__automatic_semicolon,
  [139579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8106), 1,
      sym_identifier,
    ACTIONS(8108), 1,
      anon_sym_STAR,
  [139589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      anon_sym_DOT,
    ACTIONS(8110), 1,
      anon_sym_GT,
  [139599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    STATE(1807), 1,
      sym_class_body,
  [139609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8112), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [139617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    STATE(1809), 1,
      sym_class_body,
  [139627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8114), 1,
      anon_sym_SEMI,
    ACTIONS(8116), 1,
      sym__automatic_semicolon,
  [139637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8118), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [139645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8120), 1,
      sym_identifier,
    ACTIONS(8122), 1,
      anon_sym_STAR,
  [139655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6351), 1,
      anon_sym_LBRACE,
    STATE(2552), 1,
      sym_class_body,
  [139665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [139673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    STATE(1763), 1,
      sym_class_body,
  [139683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8124), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [139691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8126), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [139699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8128), 1,
      anon_sym_SEMI,
    ACTIONS(8130), 1,
      sym__automatic_semicolon,
  [139709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8132), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [139717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8134), 1,
      anon_sym_LBRACE,
    STATE(806), 1,
      sym_enum_body,
  [139727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2143), 1,
      sym_class_body,
  [139737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    STATE(2138), 1,
      sym_statement_block,
  [139747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6349), 1,
      anon_sym_LBRACE,
    STATE(2572), 1,
      sym_class_body,
  [139757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8136), 1,
      anon_sym_SEMI,
    ACTIONS(8138), 1,
      sym__automatic_semicolon,
  [139767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6361), 1,
      anon_sym_LBRACE,
    STATE(839), 1,
      sym_class_body,
  [139777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2132), 1,
      sym_class_body,
  [139787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8140), 1,
      anon_sym_SEMI,
    ACTIONS(8142), 1,
      sym__automatic_semicolon,
  [139797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8144), 1,
      sym_identifier,
    ACTIONS(8146), 1,
      sym_private_property_identifier,
  [139807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8122), 1,
      anon_sym_STAR,
    ACTIONS(8148), 1,
      sym_identifier,
  [139817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8150), 1,
      anon_sym_LPAREN,
    STATE(42), 1,
      sym_parenthesized_expression,
  [139827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6289), 2,
      anon_sym_in,
      anon_sym_of,
  [139835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2504), 1,
      sym_statement_block,
  [139845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4592), 1,
      sym_statement_block,
  [139855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2503), 1,
      sym_statement_block,
  [139865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5484), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [139873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1489), 1,
      anon_sym_LBRACE,
    STATE(172), 1,
      sym_statement_block,
  [139883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2155), 1,
      sym_class_body,
  [139893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8152), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [139901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4583), 1,
      sym_statement_block,
  [139911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2247), 1,
      sym_class_body,
  [139921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6361), 1,
      anon_sym_LBRACE,
    STATE(724), 1,
      sym_class_body,
  [139931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5525), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [139939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5476), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [139947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8154), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [139955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8156), 1,
      anon_sym_SEMI,
    ACTIONS(8158), 1,
      sym__automatic_semicolon,
  [139965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8160), 1,
      sym_identifier,
    ACTIONS(8162), 1,
      anon_sym_STAR,
  [139975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4312), 1,
      anon_sym_LBRACE,
    STATE(1811), 1,
      sym_statement_block,
  [139985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 1,
      anon_sym_LBRACE,
    STATE(651), 1,
      sym_statement_block,
  [139995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6329), 1,
      anon_sym_LBRACE,
    STATE(162), 1,
      sym_class_body,
  [140005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8150), 1,
      anon_sym_LPAREN,
    STATE(39), 1,
      sym_parenthesized_expression,
  [140015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8164), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8166), 1,
      anon_sym_LPAREN,
    STATE(4482), 1,
      sym_parenthesized_expression,
  [140033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8168), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    STATE(4309), 1,
      sym__from_clause,
  [140051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6329), 1,
      anon_sym_LBRACE,
    STATE(166), 1,
      sym_class_body,
  [140061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7850), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [140069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    STATE(2253), 1,
      sym_statement_block,
  [140079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6361), 1,
      anon_sym_LBRACE,
    STATE(728), 1,
      sym_class_body,
  [140089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    STATE(4422), 1,
      sym__from_clause,
  [140099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3339), 1,
      sym_formal_parameters,
  [140109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_LBRACE,
    STATE(680), 1,
      sym_statement_block,
  [140119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    STATE(1784), 1,
      sym_class_body,
  [140129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    STATE(1812), 1,
      sym_class_body,
  [140139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6351), 1,
      anon_sym_LBRACE,
    STATE(2519), 1,
      sym_class_body,
  [140149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6351), 1,
      anon_sym_LBRACE,
    STATE(2538), 1,
      sym_class_body,
  [140167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_LBRACE,
    STATE(2679), 1,
      sym_enum_body,
  [140177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4522), 1,
      sym_statement_block,
  [140187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    STATE(2416), 1,
      sym_class_body,
  [140197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    STATE(2106), 1,
      sym_statement_block,
  [140207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4944), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6349), 1,
      anon_sym_LBRACE,
    STATE(2668), 1,
      sym_class_body,
  [140225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6723), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [140233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2215), 1,
      sym_class_body,
  [140243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    STATE(2217), 1,
      sym_statement_block,
  [140253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    STATE(1780), 1,
      sym_arguments,
  [140263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4442), 1,
      sym_statement_block,
  [140273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5484), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [140281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8172), 1,
      anon_sym_SEMI,
    ACTIONS(8174), 1,
      sym__automatic_semicolon,
  [140291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7800), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [140299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5507), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [140307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8176), 1,
      sym_identifier,
    ACTIONS(8178), 1,
      sym_private_property_identifier,
  [140317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8108), 1,
      anon_sym_STAR,
    ACTIONS(8180), 1,
      sym_identifier,
  [140327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2103), 1,
      sym_class_body,
  [140337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6349), 1,
      anon_sym_LBRACE,
    STATE(2688), 1,
      sym_class_body,
  [140347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [140355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [140363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 1,
      anon_sym_LBRACE,
    STATE(678), 1,
      sym_statement_block,
  [140373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8182), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5976), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4705), 1,
      sym_formal_parameters,
  [140399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8108), 1,
      anon_sym_STAR,
    ACTIONS(8184), 1,
      sym_identifier,
  [140409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8186), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5460), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [140425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5480), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [140433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3098), 1,
      sym_formal_parameters,
  [140443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2252), 1,
      sym_class_body,
  [140453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4716), 1,
      sym_formal_parameters,
  [140463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    STATE(2254), 1,
      sym_statement_block,
  [140473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2256), 1,
      sym_class_body,
  [140483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8188), 1,
      sym_identifier,
    ACTIONS(8190), 1,
      sym_private_property_identifier,
  [140493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8122), 1,
      anon_sym_STAR,
    ACTIONS(8192), 1,
      sym_identifier,
  [140503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    STATE(2165), 1,
      sym_statement_block,
  [140513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4731), 1,
      sym_formal_parameters,
  [140523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8194), 1,
      sym_identifier,
    ACTIONS(8196), 1,
      sym_private_property_identifier,
  [140533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8198), 1,
      sym_identifier,
    ACTIONS(8200), 1,
      sym_private_property_identifier,
  [140543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8202), 1,
      sym_identifier,
    ACTIONS(8204), 1,
      sym_private_property_identifier,
  [140553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8206), 1,
      sym_identifier,
    ACTIONS(8208), 1,
      sym_private_property_identifier,
  [140563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7485), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [140571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8210), 1,
      anon_sym_LBRACE,
    STATE(2719), 1,
      sym__qml_enum_body,
  [140581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    STATE(2166), 1,
      sym_statement_block,
  [140591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2239), 1,
      sym_class_body,
  [140601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4485), 1,
      sym_statement_block,
  [140611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8212), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5499), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [140627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8214), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [140635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8216), 1,
      anon_sym_SEMI,
    ACTIONS(8218), 1,
      sym__automatic_semicolon,
  [140645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6351), 1,
      anon_sym_LBRACE,
    STATE(2527), 1,
      sym_class_body,
  [140655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8220), 1,
      anon_sym_SEMI,
    ACTIONS(8222), 1,
      sym__automatic_semicolon,
  [140665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    STATE(4288), 1,
      sym__from_clause,
  [140675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8224), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8226), 1,
      sym_identifier,
    ACTIONS(8228), 1,
      sym_private_property_identifier,
  [140693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8230), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 1,
      anon_sym_LBRACE,
    STATE(686), 1,
      sym_statement_block,
  [140711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8232), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8234), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8236), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8238), 1,
      anon_sym_in,
    ACTIONS(8240), 1,
      anon_sym_COLON,
  [140745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8150), 1,
      anon_sym_LPAREN,
    STATE(55), 1,
      sym_parenthesized_expression,
  [140755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8150), 1,
      anon_sym_LPAREN,
    STATE(4513), 1,
      sym_parenthesized_expression,
  [140765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5879), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8150), 1,
      anon_sym_LPAREN,
    STATE(58), 1,
      sym_parenthesized_expression,
  [140783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3996), 1,
      anon_sym_LPAREN,
    STATE(1606), 1,
      sym_arguments,
  [140793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6866), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [140801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4310), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8242), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [140817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5476), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [140825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8244), 1,
      sym_identifier,
    ACTIONS(8246), 1,
      anon_sym_STAR,
  [140835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(3606), 1,
      sym_statement_block,
  [140845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7561), 1,
      sym_identifier,
    STATE(4033), 1,
      sym_type_parameter,
  [140855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    STATE(2110), 1,
      sym_statement_block,
  [140865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4312), 1,
      anon_sym_LBRACE,
    STATE(1776), 1,
      sym_statement_block,
  [140875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2205), 1,
      sym_class_body,
  [140885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5919), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4312), 1,
      anon_sym_LBRACE,
    STATE(1775), 1,
      sym_statement_block,
  [140903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4312), 1,
      anon_sym_LBRACE,
    STATE(1767), 1,
      sym_statement_block,
  [140913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    STATE(1765), 1,
      sym_class_body,
  [140923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    STATE(2151), 1,
      sym_statement_block,
  [140933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    STATE(2154), 1,
      sym_statement_block,
  [140943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    STATE(2179), 1,
      sym_statement_block,
  [140953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4965), 1,
      sym_formal_parameters,
  [140963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7639), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [140971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [140979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8248), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8250), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [140995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(5000), 1,
      sym_formal_parameters,
  [141005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8252), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2185), 1,
      sym_class_body,
  [141023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(5007), 1,
      sym_formal_parameters,
  [141033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6329), 1,
      anon_sym_LBRACE,
    STATE(181), 1,
      sym_class_body,
  [141043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8254), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4340), 1,
      sym_statement_block,
  [141061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8256), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [141069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4779), 1,
      sym_formal_parameters,
  [141079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8258), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8260), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [141095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7823), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [141103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1489), 1,
      anon_sym_LBRACE,
    STATE(184), 1,
      sym_statement_block,
  [141113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2102), 1,
      sym_class_body,
  [141123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4991), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2182), 1,
      sym_class_body,
  [141141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8262), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [141149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4733), 1,
      sym_formal_parameters,
  [141159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4995), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4879), 1,
      sym_formal_parameters,
  [141177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2188), 1,
      sym_class_body,
  [141187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8264), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7789), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [141203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4838), 1,
      sym_formal_parameters,
  [141213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5544), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [141221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8150), 1,
      anon_sym_LPAREN,
    STATE(60), 1,
      sym_parenthesized_expression,
  [141231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7498), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [141239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4520), 1,
      sym_statement_block,
  [141249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4832), 1,
      sym_formal_parameters,
  [141259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5554), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [141267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 1,
      anon_sym_LBRACE,
    STATE(734), 1,
      sym_statement_block,
  [141277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8266), 1,
      anon_sym_SEMI,
    ACTIONS(8268), 1,
      sym__automatic_semicolon,
  [141287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6329), 1,
      anon_sym_LBRACE,
    STATE(164), 1,
      sym_class_body,
  [141297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(3632), 1,
      sym_statement_block,
  [141307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8150), 1,
      anon_sym_LPAREN,
    STATE(4576), 1,
      sym_parenthesized_expression,
  [141317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3397), 1,
      anon_sym_LPAREN,
    STATE(2971), 1,
      sym_arguments,
  [141327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6349), 1,
      anon_sym_LBRACE,
    STATE(2636), 1,
      sym_class_body,
  [141337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    STATE(4329), 1,
      sym__from_clause,
  [141347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8150), 1,
      anon_sym_LPAREN,
    STATE(45), 1,
      sym_parenthesized_expression,
  [141357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    STATE(4630), 1,
      sym__from_clause,
  [141367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(2481), 1,
      sym_statement_block,
  [141377] = 2,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(8270), 2,
      sym__glimmer_template_content,
      anon_sym_LT_SLASHtemplate_GT,
  [141385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 1,
      anon_sym_LBRACE,
    STATE(731), 1,
      sym_statement_block,
  [141395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8272), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [141403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    STATE(2440), 1,
      sym_class_body,
  [141413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(2358), 1,
      sym_statement_block,
  [141423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3565), 1,
      sym_formal_parameters,
  [141433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    STATE(2421), 1,
      sym_class_body,
  [141443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4987), 1,
      sym_formal_parameters,
  [141453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7572), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [141461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8134), 1,
      anon_sym_LBRACE,
    STATE(723), 1,
      sym_enum_body,
  [141471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6084), 1,
      anon_sym_LPAREN,
    STATE(3168), 1,
      sym_formal_parameters,
  [141481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8274), 1,
      anon_sym_LBRACE,
    STATE(818), 1,
      sym_switch_body,
  [141491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4971), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8276), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [141507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_LBRACE,
    STATE(2168), 1,
      sym_statement_block,
  [141517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [141525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2720), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4420), 1,
      sym_statement_block,
  [141543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [141551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4539), 1,
      sym_statement_block,
  [141561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [141569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3403), 1,
      sym_formal_parameters,
  [141579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4717), 1,
      sym_formal_parameters,
  [141589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2489), 1,
      sym_statement_block,
  [141599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(3589), 1,
      sym_statement_block,
  [141609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8280), 1,
      sym_identifier,
    STATE(4441), 1,
      sym__qml_enum_assignment,
  [141619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8282), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8150), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym_parenthesized_expression,
  [141637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8284), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [141645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8286), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [141653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    STATE(4323), 1,
      sym__from_clause,
  [141663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_LBRACE,
    STATE(2647), 1,
      sym_enum_body,
  [141673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(2498), 1,
      sym_statement_block,
  [141683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8166), 1,
      anon_sym_LPAREN,
    STATE(4324), 1,
      sym_parenthesized_expression,
  [141693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8288), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [141701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8290), 1,
      anon_sym_LPAREN,
    STATE(54), 1,
      sym__for_header,
  [141711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(734), 1,
      sym_statement_block,
  [141721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5488), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [141729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3625), 1,
      sym_formal_parameters,
  [141739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4661), 1,
      sym_formal_parameters,
  [141749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5009), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3758), 1,
      sym_formal_parameters,
  [141767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4901), 1,
      sym_formal_parameters,
  [141777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6361), 1,
      anon_sym_LBRACE,
    STATE(764), 1,
      sym_class_body,
  [141787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(2507), 1,
      sym_statement_block,
  [141797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5480), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [141805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8150), 1,
      anon_sym_LPAREN,
    STATE(36), 1,
      sym_parenthesized_expression,
  [141815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8292), 1,
      sym_identifier,
    STATE(4231), 1,
      sym_nested_identifier,
  [141833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5684), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5714), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3624), 1,
      sym_class_body,
  [141859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3616), 1,
      sym_class_body,
  [141877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8294), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8296), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8298), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 1,
      anon_sym_COLON,
    STATE(4517), 1,
      sym_type_annotation,
  [141911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6076), 1,
      anon_sym_COLON,
    STATE(4206), 1,
      sym_type_annotation,
  [141921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7561), 1,
      sym_identifier,
    STATE(4510), 1,
      sym_type_parameter,
  [141931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7773), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [141939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8300), 1,
      sym_identifier,
    STATE(4057), 1,
      sym_nested_identifier,
  [141949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4675), 1,
      sym_formal_parameters,
  [141959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8302), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [141967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8290), 1,
      anon_sym_LPAREN,
    STATE(59), 1,
      sym__for_header,
  [141977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(3835), 1,
      sym_formal_parameters,
  [141987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8304), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [141995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8306), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [142003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8308), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [142011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8290), 1,
      anon_sym_LPAREN,
    STATE(50), 1,
      sym__for_header,
  [142021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8310), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [142029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3613), 1,
      sym_class_body,
  [142039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6353), 1,
      anon_sym_LBRACE,
    STATE(877), 1,
      sym_class_body,
  [142049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    STATE(2439), 1,
      sym_class_body,
  [142059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8312), 1,
      anon_sym_LBRACE,
    STATE(2508), 1,
      sym_switch_body,
  [142069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4642), 1,
      sym_formal_parameters,
  [142079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8314), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [142087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3575), 1,
      sym_class_body,
  [142097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    STATE(911), 1,
      sym_statement_block,
  [142107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4284), 1,
      sym_statement_block,
  [142117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8316), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [142125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5492), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [142133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(4278), 1,
      sym_statement_block,
  [142143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 1,
      anon_sym_LBRACE,
    STATE(2494), 1,
      sym_statement_block,
  [142153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    STATE(2658), 1,
      sym_statement_block,
  [142163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3771), 1,
      sym_class_body,
  [142173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7195), 1,
      anon_sym_from,
    STATE(4609), 1,
      sym__from_clause,
  [142183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8318), 1,
      anon_sym_LBRACE,
    STATE(3623), 1,
      sym_enum_body,
  [142193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym_LBRACE,
    STATE(688), 1,
      sym_statement_block,
  [142203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym_LPAREN,
    STATE(4664), 1,
      sym_formal_parameters,
  [142213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5503), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [142221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3652), 1,
      sym_class_body,
  [142231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4582), 1,
      anon_sym_LPAREN,
    STATE(2042), 1,
      sym_arguments,
  [142241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8320), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [142249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6542), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [142257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_LBRACE,
    STATE(2153), 1,
      sym_class_body,
  [142267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8150), 1,
      anon_sym_LPAREN,
    STATE(41), 1,
      sym_parenthesized_expression,
  [142277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3389), 1,
      anon_sym_LPAREN,
    STATE(2830), 1,
      sym_arguments,
  [142287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    STATE(3277), 1,
      sym_formal_parameters,
  [142297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8322), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [142305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8324), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [142313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6966), 1,
      anon_sym_in,
    ACTIONS(6968), 1,
      anon_sym_of,
  [142323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8326), 1,
      anon_sym_SEMI,
    ACTIONS(8328), 1,
      sym__automatic_semicolon,
  [142333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8330), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [142341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8332), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [142349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3364), 1,
      anon_sym_COLON,
    STATE(4421), 1,
      sym_type_annotation,
  [142359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8334), 1,
      anon_sym_SEMI,
    ACTIONS(8336), 1,
      sym__automatic_semicolon,
  [142369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8338), 1,
      anon_sym_SEMI,
    ACTIONS(8340), 1,
      sym__automatic_semicolon,
  [142379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8318), 1,
      anon_sym_LBRACE,
    STATE(3841), 1,
      sym_enum_body,
  [142389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8342), 1,
      sym_identifier,
    STATE(4260), 1,
      sym__qml_enum_assignment,
  [142399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6353), 1,
      anon_sym_LBRACE,
    STATE(882), 1,
      sym_class_body,
  [142409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8344), 1,
      sym_identifier,
    ACTIONS(8346), 1,
      sym_private_property_identifier,
  [142419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8348), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [142427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8350), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [142435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8352), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [142443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3756), 1,
      sym_class_body,
  [142453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LBRACE,
    STATE(1720), 1,
      sym_class_body,
  [142463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6353), 1,
      anon_sym_LBRACE,
    STATE(900), 1,
      sym_class_body,
  [142473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8354), 1,
      sym_identifier,
    ACTIONS(8356), 1,
      sym_private_property_identifier,
  [142483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(3705), 1,
      sym_class_body,
  [142493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8358), 1,
      sym_identifier,
    ACTIONS(8360), 1,
      sym_private_property_identifier,
  [142503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
    STATE(902), 1,
      sym_statement_block,
  [142513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6353), 1,
      anon_sym_LBRACE,
    STATE(905), 1,
      sym_class_body,
  [142523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8362), 1,
      sym_identifier,
    ACTIONS(8364), 1,
      sym_private_property_identifier,
  [142533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8366), 1,
      sym_identifier,
    ACTIONS(8368), 1,
      sym_private_property_identifier,
  [142543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4312), 1,
      anon_sym_LBRACE,
    STATE(1725), 1,
      sym_statement_block,
  [142553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8370), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [142561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8372), 1,
      anon_sym_SEMI,
    ACTIONS(8374), 1,
      sym__automatic_semicolon,
  [142571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8376), 1,
      anon_sym_SEMI,
    ACTIONS(8378), 1,
      sym__automatic_semicolon,
  [142581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5011), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [142589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7561), 1,
      sym_identifier,
    STATE(4072), 1,
      sym_type_parameter,
  [142599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_LBRACE,
    STATE(690), 1,
      sym_class_body,
  [142609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6034), 1,
      anon_sym_DOT,
  [142616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8380), 1,
      anon_sym_EQ_GT,
  [142623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8382), 1,
      anon_sym_EQ_GT,
  [142630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8384), 1,
      anon_sym_EQ,
  [142637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8386), 1,
      anon_sym_EQ_GT,
  [142644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 1,
      anon_sym_is,
  [142651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8388), 1,
      anon_sym_EQ_GT,
  [142658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8390), 1,
      anon_sym_EQ_GT,
  [142665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8392), 1,
      anon_sym_EQ_GT,
  [142672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8394), 1,
      anon_sym_readonly,
  [142679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8396), 1,
      anon_sym_new,
  [142686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8398), 1,
      anon_sym_target,
  [142693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8400), 1,
      anon_sym_RBRACK,
  [142700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8402), 1,
      anon_sym_EQ_GT,
  [142707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8404), 1,
      sym_identifier,
  [142714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1884), 1,
      anon_sym_EQ_GT,
  [142721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8406), 1,
      anon_sym_RBRACK,
  [142728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8408), 1,
      anon_sym_RPAREN,
  [142735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8410), 1,
      anon_sym_RBRACK,
  [142742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5128), 1,
      anon_sym_RPAREN,
  [142749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8412), 1,
      anon_sym_RBRACK,
  [142756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8414), 1,
      anon_sym_RBRACK,
  [142763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8416), 1,
      anon_sym_RBRACK,
  [142770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8418), 1,
      anon_sym_RBRACK,
  [142777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8420), 1,
      anon_sym_RBRACK,
  [142784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8422), 1,
      anon_sym_RBRACK,
  [142791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8424), 1,
      anon_sym_RBRACK,
  [142798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8426), 1,
      anon_sym_EQ_GT,
  [142805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8428), 1,
      sym_identifier,
  [142812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8430), 1,
      sym_identifier,
  [142819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8432), 1,
      anon_sym_EQ_GT,
  [142826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4739), 1,
      anon_sym_DOT,
  [142833] = 2,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(8434), 1,
      sym_regex_pattern,
  [142840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8436), 1,
      anon_sym_RBRACK,
  [142847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8438), 1,
      anon_sym_EQ_GT,
  [142854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7682), 1,
      anon_sym_RBRACK,
  [142861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8440), 1,
      anon_sym_RBRACK,
  [142868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8442), 1,
      sym_identifier,
  [142875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8444), 1,
      sym_identifier,
  [142882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8446), 1,
      anon_sym_RBRACK,
  [142889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8448), 1,
      anon_sym_RBRACK,
  [142896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8450), 1,
      anon_sym_EQ_GT,
  [142903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8452), 1,
      anon_sym_class,
  [142910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8454), 1,
      sym_identifier,
  [142917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8456), 1,
      anon_sym_RPAREN,
  [142924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8458), 1,
      sym_identifier,
  [142931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8460), 1,
      sym_identifier,
  [142938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8462), 1,
      anon_sym_EQ,
  [142945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8464), 1,
      sym_identifier,
  [142952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8466), 1,
      anon_sym_EQ_GT,
  [142959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8468), 1,
      sym_identifier,
  [142966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5084), 1,
      anon_sym_RPAREN,
  [142973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8470), 1,
      anon_sym_RBRACK,
  [142980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8472), 1,
      anon_sym_RBRACK,
  [142987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8474), 1,
      sym_identifier,
  [142994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8476), 1,
      anon_sym_RBRACK,
  [143001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8478), 1,
      sym_identifier,
  [143008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8480), 1,
      anon_sym_RBRACK,
  [143015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8482), 1,
      sym_identifier,
  [143022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8484), 1,
      anon_sym_RBRACK,
  [143029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7708), 1,
      anon_sym_RBRACK,
  [143036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8486), 1,
      anon_sym_RBRACK,
  [143043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8488), 1,
      anon_sym_RPAREN,
  [143050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8490), 1,
      sym_identifier,
  [143057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8492), 1,
      anon_sym_RBRACK,
  [143064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8494), 1,
      anon_sym_RBRACK,
  [143071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8496), 1,
      anon_sym_RBRACK,
  [143078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4803), 1,
      anon_sym_RPAREN,
  [143085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8498), 1,
      anon_sym_EQ_GT,
  [143092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8500), 1,
      anon_sym_EQ_GT,
  [143099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8502), 1,
      anon_sym_EQ_GT,
  [143106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8504), 1,
      anon_sym_EQ_GT,
  [143113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8506), 1,
      anon_sym_SLASH2,
  [143120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8508), 1,
      anon_sym_RBRACK,
  [143127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8510), 1,
      anon_sym_EQ_GT,
  [143134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8512), 1,
      sym_identifier,
  [143141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8514), 1,
      sym_number,
  [143148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8516), 1,
      anon_sym_RBRACK,
  [143155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8518), 1,
      anon_sym_RBRACK,
  [143162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8520), 1,
      anon_sym_EQ_GT,
  [143169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4793), 1,
      anon_sym_RPAREN,
  [143176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8522), 1,
      anon_sym_COLON,
  [143183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8524), 1,
      anon_sym_EQ_GT,
  [143190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8526), 1,
      anon_sym_EQ_GT,
  [143197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5134), 1,
      anon_sym_COLON,
  [143204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8528), 1,
      sym_identifier,
  [143211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8530), 1,
      sym_number,
  [143218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8532), 1,
      anon_sym_COLON,
  [143225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8534), 1,
      anon_sym_EQ,
  [143232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8536), 1,
      sym_identifier,
  [143239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8538), 1,
      anon_sym_RPAREN,
  [143246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8540), 1,
      sym_identifier,
  [143253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8542), 1,
      anon_sym_RPAREN,
  [143260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8544), 1,
      sym_identifier,
  [143267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8546), 1,
      anon_sym_EQ_GT,
  [143274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8548), 1,
      anon_sym_class,
  [143281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4908), 1,
      anon_sym_RPAREN,
  [143288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8550), 1,
      anon_sym_EQ_GT,
  [143295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7909), 1,
      anon_sym_EQ,
  [143302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8552), 1,
      anon_sym_EQ_GT,
  [143309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8554), 1,
      anon_sym_EQ_GT,
  [143316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8556), 1,
      sym_identifier,
  [143323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym_EQ,
  [143330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8558), 1,
      anon_sym_EQ_GT,
  [143337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8560), 1,
      sym_identifier,
  [143344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8562), 1,
      anon_sym_RBRACK,
  [143351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8564), 1,
      anon_sym_EQ_GT,
  [143358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8566), 1,
      sym_identifier,
  [143365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8568), 1,
      anon_sym_RBRACK,
  [143372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_from,
  [143379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8572), 1,
      sym_identifier,
  [143386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8574), 1,
      sym_identifier,
  [143393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8576), 1,
      anon_sym_EQ_GT,
  [143400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8578), 1,
      anon_sym_RBRACK,
  [143407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8580), 1,
      anon_sym_EQ,
  [143414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8582), 1,
      anon_sym_EQ_GT,
  [143421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8584), 1,
      anon_sym_EQ_GT,
  [143428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8586), 1,
      anon_sym_EQ_GT,
  [143435] = 2,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(8588), 1,
      sym_regex_pattern,
  [143442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_SLASH2,
  [143449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8592), 1,
      sym_identifier,
  [143456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8594), 1,
      anon_sym_RBRACK,
  [143463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8596), 1,
      anon_sym_EQ_GT,
  [143470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8598), 1,
      sym_identifier,
  [143477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4008), 1,
      anon_sym_DOT,
  [143484] = 2,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(8600), 1,
      sym_regex_pattern,
  [143491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8602), 1,
      anon_sym_EQ,
  [143498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7950), 1,
      sym_identifier,
  [143505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8604), 1,
      sym_identifier,
  [143512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8606), 1,
      sym_identifier,
  [143519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_new,
  [143526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8610), 1,
      sym_number,
  [143533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8612), 1,
      sym_identifier,
  [143540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8614), 1,
      anon_sym_RBRACK,
  [143547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8616), 1,
      anon_sym_EQ_GT,
  [143554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8618), 1,
      sym_identifier,
  [143561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8620), 1,
      anon_sym_RBRACE,
  [143568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7804), 1,
      anon_sym_RBRACK,
  [143575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8622), 1,
      anon_sym_EQ_GT,
  [143582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8624), 1,
      anon_sym_RBRACK,
  [143589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4903), 1,
      anon_sym_RPAREN,
  [143596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8626), 1,
      anon_sym_RBRACK,
  [143603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8628), 1,
      anon_sym_COLON,
  [143610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8630), 1,
      anon_sym_SLASH2,
  [143617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8632), 1,
      sym_number,
  [143624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym_EQ_GT,
  [143631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8636), 1,
      sym_identifier,
  [143638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8638), 1,
      anon_sym_EQ_GT,
  [143645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8640), 1,
      anon_sym_RBRACK,
  [143652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8642), 1,
      sym_identifier,
  [143659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8644), 1,
      anon_sym_RBRACK,
  [143666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8646), 1,
      anon_sym_RBRACK,
  [143673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8648), 1,
      anon_sym_RBRACK,
  [143680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8650), 1,
      anon_sym_EQ_GT,
  [143687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8652), 1,
      anon_sym_SLASH2,
  [143694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6279), 1,
      anon_sym_DOT,
  [143701] = 2,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(8654), 1,
      sym_regex_pattern,
  [143708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8656), 1,
      aux_sym_ui_version_specifier_token1,
  [143715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8658), 1,
      anon_sym_LBRACE,
  [143722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8660), 1,
      anon_sym_EQ_GT,
  [143729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8662), 1,
      anon_sym_EQ_GT,
  [143736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8664), 1,
      anon_sym_EQ_GT,
  [143743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7632), 1,
      anon_sym_LBRACE,
  [143750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8666), 1,
      anon_sym_EQ_GT,
  [143757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7275), 1,
      anon_sym_EQ_GT,
  [143764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8668), 1,
      anon_sym_while,
  [143771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8670), 1,
      sym_identifier,
  [143778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8672), 1,
      sym_identifier,
  [143785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8674), 1,
      anon_sym_RBRACK,
  [143792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8676), 1,
      anon_sym_EQ_GT,
  [143799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8678), 1,
      anon_sym_RBRACE,
  [143806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8680), 1,
      anon_sym_COLON,
  [143813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8682), 1,
      anon_sym_EQ,
  [143820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 1,
      anon_sym_RBRACE,
  [143827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8684), 1,
      anon_sym_RPAREN,
  [143834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8686), 1,
      sym_identifier,
  [143841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8688), 1,
      anon_sym_target,
  [143848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6154), 1,
      anon_sym_DOT,
  [143855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8690), 1,
      sym_identifier,
  [143862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8692), 1,
      anon_sym_from,
  [143869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8694), 1,
      anon_sym_LPAREN,
  [143876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8696), 1,
      anon_sym_from,
  [143883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8698), 1,
      sym_identifier,
  [143890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5079), 1,
      anon_sym_RBRACK,
  [143897] = 2,
    ACTIONS(7176), 1,
      sym_comment,
    ACTIONS(8700), 1,
      sym_regex_pattern,
  [143904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8702), 1,
      sym_identifier,
  [143911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8704), 1,
      sym_identifier,
  [143918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8706), 1,
      anon_sym_RBRACK,
  [143925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1886), 1,
      anon_sym_EQ_GT,
  [143932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8708), 1,
      anon_sym_EQ_GT,
  [143939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8710), 1,
      anon_sym_RBRACK,
  [143946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8712), 1,
      sym_identifier,
  [143953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7704), 1,
      anon_sym_RBRACK,
  [143960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8714), 1,
      anon_sym_EQ_GT,
  [143967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8716), 1,
      anon_sym_EQ_GT,
  [143974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8718), 1,
      sym_identifier,
  [143981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8720), 1,
      anon_sym_EQ,
  [143988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8722), 1,
      sym_identifier,
  [143995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8724), 1,
      anon_sym_EQ_GT,
  [144002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7576), 1,
      anon_sym_as,
  [144009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8726), 1,
      anon_sym_class,
  [144016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8728), 1,
      sym_identifier,
  [144023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8730), 1,
      anon_sym_from,
  [144030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8732), 1,
      anon_sym_new,
  [144037] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8734), 1,
      anon_sym_EQ_GT,
  [144044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8736), 1,
      anon_sym_EQ_GT,
  [144051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8738), 1,
      anon_sym_EQ_GT,
  [144058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8740), 1,
      anon_sym_EQ_GT,
  [144065] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7651), 1,
      anon_sym_from,
  [144072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8742), 1,
      anon_sym_namespace,
  [144079] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8744), 1,
      sym_number,
  [144086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8746), 1,
      anon_sym_RBRACK,
  [144093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8748), 1,
      anon_sym_RBRACK,
  [144100] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8750), 1,
      anon_sym_RBRACK,
  [144107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8752), 1,
      anon_sym_COLON,
  [144114] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8754), 1,
      anon_sym_while,
  [144121] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8756), 1,
      anon_sym_EQ_GT,
  [144128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8758), 1,
      anon_sym_RBRACK,
  [144135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7574), 1,
      sym_identifier,
  [144142] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8760), 1,
      anon_sym_class,
  [144149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3906), 1,
      anon_sym_LPAREN,
  [144156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8762), 1,
      anon_sym_RBRACK,
  [144163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8764), 1,
      anon_sym_RBRACK,
  [144170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8766), 1,
      anon_sym_RBRACK,
  [144177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8768), 1,
      anon_sym_RBRACK,
  [144184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8770), 1,
      anon_sym_EQ,
  [144191] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8772), 1,
      anon_sym_RBRACK,
  [144198] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8774), 1,
      anon_sym_EQ,
  [144205] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8776), 1,
      anon_sym_RBRACK,
  [144212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8778), 1,
      anon_sym_RBRACK,
  [144219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8780), 1,
      anon_sym_RBRACK,
  [144226] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8782), 1,
      anon_sym_RBRACK,
  [144233] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8784), 1,
      anon_sym_COLON,
  [144240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8786), 1,
      anon_sym_RBRACK,
  [144247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8788), 1,
      anon_sym_RBRACK,
  [144254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8790), 1,
      sym_identifier,
  [144261] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5986), 1,
      anon_sym_DOT,
  [144268] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8792), 1,
      anon_sym_LT,
  [144275] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8794), 1,
      anon_sym_RBRACK,
  [144282] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8796), 1,
      anon_sym_RPAREN,
  [144289] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8798), 1,
      anon_sym_RBRACK,
  [144296] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8800), 1,
      sym_identifier,
  [144303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8802), 1,
      anon_sym_RBRACK,
  [144310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8804), 1,
      anon_sym_RBRACK,
  [144317] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8806), 1,
      anon_sym_RBRACK,
  [144324] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8808), 1,
      anon_sym_EQ_GT,
  [144331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8810), 1,
      sym_identifier,
  [144338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8812), 1,
      sym_identifier,
  [144345] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_RBRACK,
  [144352] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8816), 1,
      anon_sym_RBRACK,
  [144359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5130), 1,
      anon_sym_RPAREN,
  [144366] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8818), 1,
      anon_sym_RBRACK,
  [144373] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8820), 1,
      anon_sym_RBRACK,
  [144380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8822), 1,
      sym_identifier,
  [144387] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8824), 1,
      sym_identifier,
  [144394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8826), 1,
      anon_sym_RBRACK,
  [144401] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8828), 1,
      anon_sym_RBRACK,
  [144408] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8830), 1,
      anon_sym_RBRACK,
  [144415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8832), 1,
      anon_sym_RBRACK,
  [144422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8834), 1,
      anon_sym_RBRACK,
  [144429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8836), 1,
      anon_sym_RBRACK,
  [144436] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8838), 1,
      anon_sym_EQ_GT,
  [144443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5143), 1,
      anon_sym_RBRACK,
  [144450] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8840), 1,
      anon_sym_EQ,
  [144457] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8842), 1,
      sym_identifier,
  [144464] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8844), 1,
      anon_sym_function,
  [144471] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8846), 1,
      sym_identifier,
  [144478] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8848), 1,
      anon_sym_EQ_GT,
  [144485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8850), 1,
      anon_sym_EQ_GT,
  [144492] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5132), 1,
      anon_sym_RBRACK,
  [144499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8852), 1,
      anon_sym_LBRACK,
  [144506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8854), 1,
      anon_sym_RBRACK,
  [144513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8856), 1,
      anon_sym_RBRACK,
  [144520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8858), 1,
      anon_sym_RBRACK,
  [144527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8860), 1,
      anon_sym_RBRACK,
  [144534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8862), 1,
      anon_sym_RBRACK,
  [144541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8864), 1,
      anon_sym_RBRACK,
  [144548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8866), 1,
      anon_sym_RBRACK,
  [144555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8868), 1,
      anon_sym_EQ,
  [144562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8870), 1,
      anon_sym_RBRACK,
  [144569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8872), 1,
      anon_sym_RBRACK,
  [144576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8874), 1,
      sym_identifier,
  [144583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8876), 1,
      anon_sym_RBRACK,
  [144590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6040), 1,
      anon_sym_is,
  [144597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8878), 1,
      sym_identifier,
  [144604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8880), 1,
      sym_identifier,
  [144611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8882), 1,
      sym_identifier,
  [144618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8884), 1,
      sym_identifier,
  [144625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8886), 1,
      anon_sym_RBRACK,
  [144632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8888), 1,
      anon_sym_RBRACK,
  [144639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5149), 1,
      anon_sym_RPAREN,
  [144646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8890), 1,
      sym_identifier,
  [144653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5154), 1,
      anon_sym_RPAREN,
  [144660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8892), 1,
      anon_sym_from,
  [144667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8894), 1,
      sym_identifier,
  [144674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8896), 1,
      anon_sym_from,
  [144681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8898), 1,
      anon_sym_namespace,
  [144688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8900), 1,
      sym_number,
  [144695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8902), 1,
      anon_sym_EQ_GT,
  [144702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8904), 1,
      sym_identifier,
  [144709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8906), 1,
      anon_sym_EQ,
  [144716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_EQ_GT,
  [144723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8910), 1,
      anon_sym_EQ_GT,
  [144730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8912), 1,
      anon_sym_EQ_GT,
  [144737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8914), 1,
      anon_sym_EQ_GT,
  [144744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8916), 1,
      anon_sym_SLASH2,
  [144751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5156), 1,
      anon_sym_RPAREN,
  [144758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      ts_builtin_sym_end,
  [144765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8920), 1,
      anon_sym_EQ_GT,
  [144772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8922), 1,
      ts_builtin_sym_end,
  [144779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8924), 1,
      anon_sym_EQ_GT,
  [144786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_from,
  [144793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8928), 1,
      anon_sym_EQ_GT,
  [144800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8930), 1,
      anon_sym_RBRACK,
  [144807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8932), 1,
      anon_sym_RBRACK,
  [144814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8926), 1,
      anon_sym_from,
  [144821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8934), 1,
      anon_sym_RBRACK,
  [144828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8936), 1,
      anon_sym_RBRACK,
  [144835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8938), 1,
      anon_sym_RBRACK,
  [144842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8940), 1,
      anon_sym_RBRACK,
  [144849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8942), 1,
      anon_sym_class,
  [144856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8944), 1,
      anon_sym_new,
  [144863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8946), 1,
      anon_sym_namespace,
  [144870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8948), 1,
      anon_sym_RBRACK,
  [144877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8950), 1,
      anon_sym_RBRACK,
  [144884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8952), 1,
      anon_sym_RBRACK,
  [144891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8954), 1,
      sym_identifier,
  [144898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8956), 1,
      anon_sym_RBRACK,
  [144905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6471), 1,
      anon_sym_EQ,
  [144912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7696), 1,
      sym_identifier,
  [144919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8958), 1,
      anon_sym_class,
  [144926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8960), 1,
      anon_sym_EQ_GT,
  [144933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8962), 1,
      anon_sym_require,
  [144940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8964), 1,
      anon_sym_EQ,
  [144947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8966), 1,
      anon_sym_RBRACK,
  [144954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8968), 1,
      anon_sym_EQ,
  [144961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6234), 1,
      anon_sym_is,
  [144968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5109), 1,
      anon_sym_RBRACK,
  [144975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8970), 1,
      anon_sym_COLON,
  [144982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8972), 1,
      anon_sym_RBRACK,
  [144989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8974), 1,
      anon_sym_RBRACK,
  [144996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      anon_sym_RBRACK,
  [145003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8978), 1,
      sym_identifier,
  [145010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8980), 1,
      anon_sym_RBRACK,
  [145017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8982), 1,
      ts_builtin_sym_end,
  [145024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8984), 1,
      anon_sym_RBRACK,
  [145031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8986), 1,
      anon_sym_new,
  [145038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8988), 1,
      anon_sym_RBRACK,
  [145045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      anon_sym_RBRACK,
  [145052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8992), 1,
      anon_sym_RBRACK,
  [145059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8994), 1,
      anon_sym_RBRACK,
  [145066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8996), 1,
      anon_sym_EQ_GT,
  [145073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8998), 1,
      anon_sym_EQ_GT,
  [145080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9000), 1,
      anon_sym_EQ_GT,
  [145087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9002), 1,
      anon_sym_new,
  [145094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9004), 1,
      anon_sym_GT,
  [145101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9006), 1,
      sym_identifier,
  [145108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9008), 1,
      sym_identifier,
  [145115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9010), 1,
      anon_sym_RPAREN,
  [145122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9012), 1,
      anon_sym_new,
  [145129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9014), 1,
      anon_sym_RPAREN,
  [145136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9016), 1,
      sym_identifier,
  [145143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9018), 1,
      anon_sym_function,
  [145150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9020), 1,
      ts_builtin_sym_end,
  [145157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9022), 1,
      anon_sym_EQ_GT,
  [145164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      sym_identifier,
  [145171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9026), 1,
      anon_sym_EQ_GT,
  [145178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9028), 1,
      ts_builtin_sym_end,
  [145185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7996), 1,
      anon_sym_RBRACK,
  [145192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9030), 1,
      sym_identifier,
  [145199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9032), 1,
      sym_identifier,
  [145206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9034), 1,
      anon_sym_function,
  [145213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9036), 1,
      anon_sym_RBRACK,
  [145220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9038), 1,
      anon_sym_EQ_GT,
  [145227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9040), 1,
      sym_identifier,
  [145234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9042), 1,
      anon_sym_function,
  [145241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9044), 1,
      sym_identifier,
  [145248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9046), 1,
      anon_sym_RPAREN,
  [145255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9048), 1,
      anon_sym_RPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1100)] = 0,
  [SMALL_STATE(1101)] = 89,
  [SMALL_STATE(1102)] = 184,
  [SMALL_STATE(1103)] = 279,
  [SMALL_STATE(1104)] = 368,
  [SMALL_STATE(1105)] = 458,
  [SMALL_STATE(1106)] = 546,
  [SMALL_STATE(1107)] = 636,
  [SMALL_STATE(1108)] = 712,
  [SMALL_STATE(1109)] = 800,
  [SMALL_STATE(1110)] = 890,
  [SMALL_STATE(1111)] = 966,
  [SMALL_STATE(1112)] = 1054,
  [SMALL_STATE(1113)] = 1146,
  [SMALL_STATE(1114)] = 1236,
  [SMALL_STATE(1115)] = 1326,
  [SMALL_STATE(1116)] = 1418,
  [SMALL_STATE(1117)] = 1514,
  [SMALL_STATE(1118)] = 1604,
  [SMALL_STATE(1119)] = 1692,
  [SMALL_STATE(1120)] = 1770,
  [SMALL_STATE(1121)] = 1839,
  [SMALL_STATE(1122)] = 1930,
  [SMALL_STATE(1123)] = 1999,
  [SMALL_STATE(1124)] = 2090,
  [SMALL_STATE(1125)] = 2159,
  [SMALL_STATE(1126)] = 2250,
  [SMALL_STATE(1127)] = 2319,
  [SMALL_STATE(1128)] = 2412,
  [SMALL_STATE(1129)] = 2481,
  [SMALL_STATE(1130)] = 2550,
  [SMALL_STATE(1131)] = 2641,
  [SMALL_STATE(1132)] = 2728,
  [SMALL_STATE(1133)] = 2815,
  [SMALL_STATE(1134)] = 2884,
  [SMALL_STATE(1135)] = 2970,
  [SMALL_STATE(1136)] = 3038,
  [SMALL_STATE(1137)] = 3106,
  [SMALL_STATE(1138)] = 3194,
  [SMALL_STATE(1139)] = 3282,
  [SMALL_STATE(1140)] = 3370,
  [SMALL_STATE(1141)] = 3438,
  [SMALL_STATE(1142)] = 3524,
  [SMALL_STATE(1143)] = 3610,
  [SMALL_STATE(1144)] = 3698,
  [SMALL_STATE(1145)] = 3786,
  [SMALL_STATE(1146)] = 3854,
  [SMALL_STATE(1147)] = 3922,
  [SMALL_STATE(1148)] = 4008,
  [SMALL_STATE(1149)] = 4094,
  [SMALL_STATE(1150)] = 4162,
  [SMALL_STATE(1151)] = 4250,
  [SMALL_STATE(1152)] = 4338,
  [SMALL_STATE(1153)] = 4406,
  [SMALL_STATE(1154)] = 4494,
  [SMALL_STATE(1155)] = 4580,
  [SMALL_STATE(1156)] = 4668,
  [SMALL_STATE(1157)] = 4754,
  [SMALL_STATE(1158)] = 4844,
  [SMALL_STATE(1159)] = 4930,
  [SMALL_STATE(1160)] = 5018,
  [SMALL_STATE(1161)] = 5103,
  [SMALL_STATE(1162)] = 5188,
  [SMALL_STATE(1163)] = 5255,
  [SMALL_STATE(1164)] = 5378,
  [SMALL_STATE(1165)] = 5501,
  [SMALL_STATE(1166)] = 5624,
  [SMALL_STATE(1167)] = 5717,
  [SMALL_STATE(1168)] = 5802,
  [SMALL_STATE(1169)] = 5887,
  [SMALL_STATE(1170)] = 5972,
  [SMALL_STATE(1171)] = 6095,
  [SMALL_STATE(1172)] = 6218,
  [SMALL_STATE(1173)] = 6341,
  [SMALL_STATE(1174)] = 6428,
  [SMALL_STATE(1175)] = 6495,
  [SMALL_STATE(1176)] = 6566,
  [SMALL_STATE(1177)] = 6651,
  [SMALL_STATE(1178)] = 6740,
  [SMALL_STATE(1179)] = 6825,
  [SMALL_STATE(1180)] = 6910,
  [SMALL_STATE(1181)] = 6995,
  [SMALL_STATE(1182)] = 7118,
  [SMALL_STATE(1183)] = 7202,
  [SMALL_STATE(1184)] = 7292,
  [SMALL_STATE(1185)] = 7376,
  [SMALL_STATE(1186)] = 7452,
  [SMALL_STATE(1187)] = 7542,
  [SMALL_STATE(1188)] = 7618,
  [SMALL_STATE(1189)] = 7696,
  [SMALL_STATE(1190)] = 7772,
  [SMALL_STATE(1191)] = 7848,
  [SMALL_STATE(1192)] = 7932,
  [SMALL_STATE(1193)] = 8016,
  [SMALL_STATE(1194)] = 8092,
  [SMALL_STATE(1195)] = 8176,
  [SMALL_STATE(1196)] = 8254,
  [SMALL_STATE(1197)] = 8330,
  [SMALL_STATE(1198)] = 8414,
  [SMALL_STATE(1199)] = 8533,
  [SMALL_STATE(1200)] = 8652,
  [SMALL_STATE(1201)] = 8771,
  [SMALL_STATE(1202)] = 8852,
  [SMALL_STATE(1203)] = 8927,
  [SMALL_STATE(1204)] = 9010,
  [SMALL_STATE(1205)] = 9095,
  [SMALL_STATE(1206)] = 9214,
  [SMALL_STATE(1207)] = 9333,
  [SMALL_STATE(1208)] = 9406,
  [SMALL_STATE(1209)] = 9481,
  [SMALL_STATE(1210)] = 9558,
  [SMALL_STATE(1211)] = 9677,
  [SMALL_STATE(1212)] = 9796,
  [SMALL_STATE(1213)] = 9883,
  [SMALL_STATE(1214)] = 10002,
  [SMALL_STATE(1215)] = 10085,
  [SMALL_STATE(1216)] = 10156,
  [SMALL_STATE(1217)] = 10239,
  [SMALL_STATE(1218)] = 10358,
  [SMALL_STATE(1219)] = 10433,
  [SMALL_STATE(1220)] = 10552,
  [SMALL_STATE(1221)] = 10629,
  [SMALL_STATE(1222)] = 10748,
  [SMALL_STATE(1223)] = 10867,
  [SMALL_STATE(1224)] = 10986,
  [SMALL_STATE(1225)] = 11063,
  [SMALL_STATE(1226)] = 11182,
  [SMALL_STATE(1227)] = 11301,
  [SMALL_STATE(1228)] = 11420,
  [SMALL_STATE(1229)] = 11539,
  [SMALL_STATE(1230)] = 11616,
  [SMALL_STATE(1231)] = 11735,
  [SMALL_STATE(1232)] = 11854,
  [SMALL_STATE(1233)] = 11931,
  [SMALL_STATE(1234)] = 12008,
  [SMALL_STATE(1235)] = 12079,
  [SMALL_STATE(1236)] = 12162,
  [SMALL_STATE(1237)] = 12281,
  [SMALL_STATE(1238)] = 12352,
  [SMALL_STATE(1239)] = 12423,
  [SMALL_STATE(1240)] = 12506,
  [SMALL_STATE(1241)] = 12579,
  [SMALL_STATE(1242)] = 12660,
  [SMALL_STATE(1243)] = 12733,
  [SMALL_STATE(1244)] = 12852,
  [SMALL_STATE(1245)] = 12930,
  [SMALL_STATE(1246)] = 13002,
  [SMALL_STATE(1247)] = 13084,
  [SMALL_STATE(1248)] = 13148,
  [SMALL_STATE(1249)] = 13230,
  [SMALL_STATE(1250)] = 13304,
  [SMALL_STATE(1251)] = 13374,
  [SMALL_STATE(1252)] = 13438,
  [SMALL_STATE(1253)] = 13502,
  [SMALL_STATE(1254)] = 13574,
  [SMALL_STATE(1255)] = 13646,
  [SMALL_STATE(1256)] = 13728,
  [SMALL_STATE(1257)] = 13802,
  [SMALL_STATE(1258)] = 13878,
  [SMALL_STATE(1259)] = 13942,
  [SMALL_STATE(1260)] = 14006,
  [SMALL_STATE(1261)] = 14088,
  [SMALL_STATE(1262)] = 14158,
  [SMALL_STATE(1263)] = 14222,
  [SMALL_STATE(1264)] = 14290,
  [SMALL_STATE(1265)] = 14372,
  [SMALL_STATE(1266)] = 14454,
  [SMALL_STATE(1267)] = 14524,
  [SMALL_STATE(1268)] = 14594,
  [SMALL_STATE(1269)] = 14672,
  [SMALL_STATE(1270)] = 14750,
  [SMALL_STATE(1271)] = 14822,
  [SMALL_STATE(1272)] = 14886,
  [SMALL_STATE(1273)] = 14968,
  [SMALL_STATE(1274)] = 15038,
  [SMALL_STATE(1275)] = 15110,
  [SMALL_STATE(1276)] = 15174,
  [SMALL_STATE(1277)] = 15256,
  [SMALL_STATE(1278)] = 15326,
  [SMALL_STATE(1279)] = 15398,
  [SMALL_STATE(1280)] = 15462,
  [SMALL_STATE(1281)] = 15542,
  [SMALL_STATE(1282)] = 15616,
  [SMALL_STATE(1283)] = 15694,
  [SMALL_STATE(1284)] = 15764,
  [SMALL_STATE(1285)] = 15834,
  [SMALL_STATE(1286)] = 15902,
  [SMALL_STATE(1287)] = 15978,
  [SMALL_STATE(1288)] = 16047,
  [SMALL_STATE(1289)] = 16116,
  [SMALL_STATE(1290)] = 16187,
  [SMALL_STATE(1291)] = 16262,
  [SMALL_STATE(1292)] = 16377,
  [SMALL_STATE(1293)] = 16492,
  [SMALL_STATE(1294)] = 16573,
  [SMALL_STATE(1295)] = 16642,
  [SMALL_STATE(1296)] = 16719,
  [SMALL_STATE(1297)] = 16794,
  [SMALL_STATE(1298)] = 16909,
  [SMALL_STATE(1299)] = 17024,
  [SMALL_STATE(1300)] = 17139,
  [SMALL_STATE(1301)] = 17210,
  [SMALL_STATE(1302)] = 17285,
  [SMALL_STATE(1303)] = 17366,
  [SMALL_STATE(1304)] = 17435,
  [SMALL_STATE(1305)] = 17502,
  [SMALL_STATE(1306)] = 17577,
  [SMALL_STATE(1307)] = 17648,
  [SMALL_STATE(1308)] = 17763,
  [SMALL_STATE(1309)] = 17844,
  [SMALL_STATE(1310)] = 17959,
  [SMALL_STATE(1311)] = 18030,
  [SMALL_STATE(1312)] = 18097,
  [SMALL_STATE(1313)] = 18212,
  [SMALL_STATE(1314)] = 18287,
  [SMALL_STATE(1315)] = 18358,
  [SMALL_STATE(1316)] = 18429,
  [SMALL_STATE(1317)] = 18497,
  [SMALL_STATE(1318)] = 18569,
  [SMALL_STATE(1319)] = 18639,
  [SMALL_STATE(1320)] = 18707,
  [SMALL_STATE(1321)] = 18779,
  [SMALL_STATE(1322)] = 18847,
  [SMALL_STATE(1323)] = 18913,
  [SMALL_STATE(1324)] = 18985,
  [SMALL_STATE(1325)] = 19055,
  [SMALL_STATE(1326)] = 19127,
  [SMALL_STATE(1327)] = 19201,
  [SMALL_STATE(1328)] = 19269,
  [SMALL_STATE(1329)] = 19374,
  [SMALL_STATE(1330)] = 19479,
  [SMALL_STATE(1331)] = 19546,
  [SMALL_STATE(1332)] = 19613,
  [SMALL_STATE(1333)] = 19680,
  [SMALL_STATE(1334)] = 19747,
  [SMALL_STATE(1335)] = 19818,
  [SMALL_STATE(1336)] = 19885,
  [SMALL_STATE(1337)] = 19952,
  [SMALL_STATE(1338)] = 20057,
  [SMALL_STATE(1339)] = 20124,
  [SMALL_STATE(1340)] = 20229,
  [SMALL_STATE(1341)] = 20334,
  [SMALL_STATE(1342)] = 20401,
  [SMALL_STATE(1343)] = 20472,
  [SMALL_STATE(1344)] = 20577,
  [SMALL_STATE(1345)] = 20644,
  [SMALL_STATE(1346)] = 20709,
  [SMALL_STATE(1347)] = 20776,
  [SMALL_STATE(1348)] = 20843,
  [SMALL_STATE(1349)] = 20912,
  [SMALL_STATE(1350)] = 21017,
  [SMALL_STATE(1351)] = 21084,
  [SMALL_STATE(1352)] = 21148,
  [SMALL_STATE(1353)] = 21214,
  [SMALL_STATE(1354)] = 21280,
  [SMALL_STATE(1355)] = 21344,
  [SMALL_STATE(1356)] = 21412,
  [SMALL_STATE(1357)] = 21476,
  [SMALL_STATE(1358)] = 21571,
  [SMALL_STATE(1359)] = 21666,
  [SMALL_STATE(1360)] = 21763,
  [SMALL_STATE(1361)] = 21858,
  [SMALL_STATE(1362)] = 21953,
  [SMALL_STATE(1363)] = 22048,
  [SMALL_STATE(1364)] = 22166,
  [SMALL_STATE(1365)] = 22284,
  [SMALL_STATE(1366)] = 22342,
  [SMALL_STATE(1367)] = 22400,
  [SMALL_STATE(1368)] = 22518,
  [SMALL_STATE(1369)] = 22636,
  [SMALL_STATE(1370)] = 22754,
  [SMALL_STATE(1371)] = 22872,
  [SMALL_STATE(1372)] = 22961,
  [SMALL_STATE(1373)] = 23062,
  [SMALL_STATE(1374)] = 23163,
  [SMALL_STATE(1375)] = 23264,
  [SMALL_STATE(1376)] = 23365,
  [SMALL_STATE(1377)] = 23466,
  [SMALL_STATE(1378)] = 23567,
  [SMALL_STATE(1379)] = 23668,
  [SMALL_STATE(1380)] = 23769,
  [SMALL_STATE(1381)] = 23858,
  [SMALL_STATE(1382)] = 23959,
  [SMALL_STATE(1383)] = 24048,
  [SMALL_STATE(1384)] = 24137,
  [SMALL_STATE(1385)] = 24238,
  [SMALL_STATE(1386)] = 24339,
  [SMALL_STATE(1387)] = 24428,
  [SMALL_STATE(1388)] = 24529,
  [SMALL_STATE(1389)] = 24618,
  [SMALL_STATE(1390)] = 24719,
  [SMALL_STATE(1391)] = 24820,
  [SMALL_STATE(1392)] = 24897,
  [SMALL_STATE(1393)] = 24998,
  [SMALL_STATE(1394)] = 25099,
  [SMALL_STATE(1395)] = 25176,
  [SMALL_STATE(1396)] = 25277,
  [SMALL_STATE(1397)] = 25359,
  [SMALL_STATE(1398)] = 25439,
  [SMALL_STATE(1399)] = 25521,
  [SMALL_STATE(1400)] = 25603,
  [SMALL_STATE(1401)] = 25685,
  [SMALL_STATE(1402)] = 25767,
  [SMALL_STATE(1403)] = 25847,
  [SMALL_STATE(1404)] = 25927,
  [SMALL_STATE(1405)] = 26007,
  [SMALL_STATE(1406)] = 26087,
  [SMALL_STATE(1407)] = 26197,
  [SMALL_STATE(1408)] = 26305,
  [SMALL_STATE(1409)] = 26413,
  [SMALL_STATE(1410)] = 26493,
  [SMALL_STATE(1411)] = 26575,
  [SMALL_STATE(1412)] = 26650,
  [SMALL_STATE(1413)] = 26705,
  [SMALL_STATE(1414)] = 26760,
  [SMALL_STATE(1415)] = 26815,
  [SMALL_STATE(1416)] = 26890,
  [SMALL_STATE(1417)] = 26971,
  [SMALL_STATE(1418)] = 27046,
  [SMALL_STATE(1419)] = 27103,
  [SMALL_STATE(1420)] = 27178,
  [SMALL_STATE(1421)] = 27253,
  [SMALL_STATE(1422)] = 27308,
  [SMALL_STATE(1423)] = 27383,
  [SMALL_STATE(1424)] = 27440,
  [SMALL_STATE(1425)] = 27519,
  [SMALL_STATE(1426)] = 27593,
  [SMALL_STATE(1427)] = 27679,
  [SMALL_STATE(1428)] = 27755,
  [SMALL_STATE(1429)] = 27831,
  [SMALL_STATE(1430)] = 27917,
  [SMALL_STATE(1431)] = 27993,
  [SMALL_STATE(1432)] = 28069,
  [SMALL_STATE(1433)] = 28155,
  [SMALL_STATE(1434)] = 28231,
  [SMALL_STATE(1435)] = 28301,
  [SMALL_STATE(1436)] = 28363,
  [SMALL_STATE(1437)] = 28449,
  [SMALL_STATE(1438)] = 28525,
  [SMALL_STATE(1439)] = 28597,
  [SMALL_STATE(1440)] = 28669,
  [SMALL_STATE(1441)] = 28755,
  [SMALL_STATE(1442)] = 28841,
  [SMALL_STATE(1443)] = 28913,
  [SMALL_STATE(1444)] = 28999,
  [SMALL_STATE(1445)] = 29075,
  [SMALL_STATE(1446)] = 29142,
  [SMALL_STATE(1447)] = 29201,
  [SMALL_STATE(1448)] = 29268,
  [SMALL_STATE(1449)] = 29335,
  [SMALL_STATE(1450)] = 29404,
  [SMALL_STATE(1451)] = 29457,
  [SMALL_STATE(1452)] = 29524,
  [SMALL_STATE(1453)] = 29591,
  [SMALL_STATE(1454)] = 29668,
  [SMALL_STATE(1455)] = 29735,
  [SMALL_STATE(1456)] = 29804,
  [SMALL_STATE(1457)] = 29861,
  [SMALL_STATE(1458)] = 29940,
  [SMALL_STATE(1459)] = 30009,
  [SMALL_STATE(1460)] = 30066,
  [SMALL_STATE(1461)] = 30135,
  [SMALL_STATE(1462)] = 30188,
  [SMALL_STATE(1463)] = 30257,
  [SMALL_STATE(1464)] = 30324,
  [SMALL_STATE(1465)] = 30391,
  [SMALL_STATE(1466)] = 30450,
  [SMALL_STATE(1467)] = 30519,
  [SMALL_STATE(1468)] = 30588,
  [SMALL_STATE(1469)] = 30641,
  [SMALL_STATE(1470)] = 30712,
  [SMALL_STATE(1471)] = 30779,
  [SMALL_STATE(1472)] = 30846,
  [SMALL_STATE(1473)] = 30905,
  [SMALL_STATE(1474)] = 30964,
  [SMALL_STATE(1475)] = 31031,
  [SMALL_STATE(1476)] = 31108,
  [SMALL_STATE(1477)] = 31175,
  [SMALL_STATE(1478)] = 31244,
  [SMALL_STATE(1479)] = 31309,
  [SMALL_STATE(1480)] = 31374,
  [SMALL_STATE(1481)] = 31439,
  [SMALL_STATE(1482)] = 31508,
  [SMALL_STATE(1483)] = 31573,
  [SMALL_STATE(1484)] = 31638,
  [SMALL_STATE(1485)] = 31705,
  [SMALL_STATE(1486)] = 31762,
  [SMALL_STATE(1487)] = 31829,
  [SMALL_STATE(1488)] = 31906,
  [SMALL_STATE(1489)] = 31985,
  [SMALL_STATE(1490)] = 32062,
  [SMALL_STATE(1491)] = 32141,
  [SMALL_STATE(1492)] = 32218,
  [SMALL_STATE(1493)] = 32283,
  [SMALL_STATE(1494)] = 32348,
  [SMALL_STATE(1495)] = 32427,
  [SMALL_STATE(1496)] = 32506,
  [SMALL_STATE(1497)] = 32565,
  [SMALL_STATE(1498)] = 32642,
  [SMALL_STATE(1499)] = 32697,
  [SMALL_STATE(1500)] = 32762,
  [SMALL_STATE(1501)] = 32827,
  [SMALL_STATE(1502)] = 32896,
  [SMALL_STATE(1503)] = 32975,
  [SMALL_STATE(1504)] = 33052,
  [SMALL_STATE(1505)] = 33119,
  [SMALL_STATE(1506)] = 33184,
  [SMALL_STATE(1507)] = 33249,
  [SMALL_STATE(1508)] = 33314,
  [SMALL_STATE(1509)] = 33369,
  [SMALL_STATE(1510)] = 33424,
  [SMALL_STATE(1511)] = 33503,
  [SMALL_STATE(1512)] = 33565,
  [SMALL_STATE(1513)] = 33617,
  [SMALL_STATE(1514)] = 33725,
  [SMALL_STATE(1515)] = 33779,
  [SMALL_STATE(1516)] = 33831,
  [SMALL_STATE(1517)] = 33939,
  [SMALL_STATE(1518)] = 33993,
  [SMALL_STATE(1519)] = 34045,
  [SMALL_STATE(1520)] = 34097,
  [SMALL_STATE(1521)] = 34151,
  [SMALL_STATE(1522)] = 34203,
  [SMALL_STATE(1523)] = 34257,
  [SMALL_STATE(1524)] = 34365,
  [SMALL_STATE(1525)] = 34473,
  [SMALL_STATE(1526)] = 34547,
  [SMALL_STATE(1527)] = 34599,
  [SMALL_STATE(1528)] = 34651,
  [SMALL_STATE(1529)] = 34735,
  [SMALL_STATE(1530)] = 34799,
  [SMALL_STATE(1531)] = 34897,
  [SMALL_STATE(1532)] = 34997,
  [SMALL_STATE(1533)] = 35077,
  [SMALL_STATE(1534)] = 35169,
  [SMALL_STATE(1535)] = 35263,
  [SMALL_STATE(1536)] = 35359,
  [SMALL_STATE(1537)] = 35437,
  [SMALL_STATE(1538)] = 35515,
  [SMALL_STATE(1539)] = 35603,
  [SMALL_STATE(1540)] = 35705,
  [SMALL_STATE(1541)] = 35813,
  [SMALL_STATE(1542)] = 35921,
  [SMALL_STATE(1543)] = 35983,
  [SMALL_STATE(1544)] = 36091,
  [SMALL_STATE(1545)] = 36199,
  [SMALL_STATE(1546)] = 36307,
  [SMALL_STATE(1547)] = 36369,
  [SMALL_STATE(1548)] = 36477,
  [SMALL_STATE(1549)] = 36539,
  [SMALL_STATE(1550)] = 36601,
  [SMALL_STATE(1551)] = 36663,
  [SMALL_STATE(1552)] = 36717,
  [SMALL_STATE(1553)] = 36771,
  [SMALL_STATE(1554)] = 36827,
  [SMALL_STATE(1555)] = 36899,
  [SMALL_STATE(1556)] = 36957,
  [SMALL_STATE(1557)] = 37011,
  [SMALL_STATE(1558)] = 37121,
  [SMALL_STATE(1559)] = 37173,
  [SMALL_STATE(1560)] = 37229,
  [SMALL_STATE(1561)] = 37287,
  [SMALL_STATE(1562)] = 37349,
  [SMALL_STATE(1563)] = 37409,
  [SMALL_STATE(1564)] = 37463,
  [SMALL_STATE(1565)] = 37525,
  [SMALL_STATE(1566)] = 37587,
  [SMALL_STATE(1567)] = 37639,
  [SMALL_STATE(1568)] = 37723,
  [SMALL_STATE(1569)] = 37795,
  [SMALL_STATE(1570)] = 37857,
  [SMALL_STATE(1571)] = 37929,
  [SMALL_STATE(1572)] = 37991,
  [SMALL_STATE(1573)] = 38069,
  [SMALL_STATE(1574)] = 38121,
  [SMALL_STATE(1575)] = 38183,
  [SMALL_STATE(1576)] = 38245,
  [SMALL_STATE(1577)] = 38307,
  [SMALL_STATE(1578)] = 38359,
  [SMALL_STATE(1579)] = 38431,
  [SMALL_STATE(1580)] = 38503,
  [SMALL_STATE(1581)] = 38611,
  [SMALL_STATE(1582)] = 38667,
  [SMALL_STATE(1583)] = 38739,
  [SMALL_STATE(1584)] = 38791,
  [SMALL_STATE(1585)] = 38863,
  [SMALL_STATE(1586)] = 38915,
  [SMALL_STATE(1587)] = 38967,
  [SMALL_STATE(1588)] = 39029,
  [SMALL_STATE(1589)] = 39081,
  [SMALL_STATE(1590)] = 39133,
  [SMALL_STATE(1591)] = 39187,
  [SMALL_STATE(1592)] = 39239,
  [SMALL_STATE(1593)] = 39291,
  [SMALL_STATE(1594)] = 39343,
  [SMALL_STATE(1595)] = 39401,
  [SMALL_STATE(1596)] = 39459,
  [SMALL_STATE(1597)] = 39515,
  [SMALL_STATE(1598)] = 39577,
  [SMALL_STATE(1599)] = 39629,
  [SMALL_STATE(1600)] = 39691,
  [SMALL_STATE(1601)] = 39745,
  [SMALL_STATE(1602)] = 39797,
  [SMALL_STATE(1603)] = 39849,
  [SMALL_STATE(1604)] = 39901,
  [SMALL_STATE(1605)] = 39953,
  [SMALL_STATE(1606)] = 40005,
  [SMALL_STATE(1607)] = 40057,
  [SMALL_STATE(1608)] = 40109,
  [SMALL_STATE(1609)] = 40161,
  [SMALL_STATE(1610)] = 40213,
  [SMALL_STATE(1611)] = 40265,
  [SMALL_STATE(1612)] = 40317,
  [SMALL_STATE(1613)] = 40369,
  [SMALL_STATE(1614)] = 40421,
  [SMALL_STATE(1615)] = 40473,
  [SMALL_STATE(1616)] = 40525,
  [SMALL_STATE(1617)] = 40577,
  [SMALL_STATE(1618)] = 40629,
  [SMALL_STATE(1619)] = 40681,
  [SMALL_STATE(1620)] = 40733,
  [SMALL_STATE(1621)] = 40785,
  [SMALL_STATE(1622)] = 40837,
  [SMALL_STATE(1623)] = 40889,
  [SMALL_STATE(1624)] = 40941,
  [SMALL_STATE(1625)] = 40993,
  [SMALL_STATE(1626)] = 41045,
  [SMALL_STATE(1627)] = 41097,
  [SMALL_STATE(1628)] = 41149,
  [SMALL_STATE(1629)] = 41221,
  [SMALL_STATE(1630)] = 41297,
  [SMALL_STATE(1631)] = 41349,
  [SMALL_STATE(1632)] = 41409,
  [SMALL_STATE(1633)] = 41469,
  [SMALL_STATE(1634)] = 41577,
  [SMALL_STATE(1635)] = 41647,
  [SMALL_STATE(1636)] = 41699,
  [SMALL_STATE(1637)] = 41751,
  [SMALL_STATE(1638)] = 41803,
  [SMALL_STATE(1639)] = 41855,
  [SMALL_STATE(1640)] = 41913,
  [SMALL_STATE(1641)] = 41965,
  [SMALL_STATE(1642)] = 42017,
  [SMALL_STATE(1643)] = 42071,
  [SMALL_STATE(1644)] = 42123,
  [SMALL_STATE(1645)] = 42175,
  [SMALL_STATE(1646)] = 42231,
  [SMALL_STATE(1647)] = 42283,
  [SMALL_STATE(1648)] = 42335,
  [SMALL_STATE(1649)] = 42387,
  [SMALL_STATE(1650)] = 42439,
  [SMALL_STATE(1651)] = 42491,
  [SMALL_STATE(1652)] = 42543,
  [SMALL_STATE(1653)] = 42595,
  [SMALL_STATE(1654)] = 42647,
  [SMALL_STATE(1655)] = 42699,
  [SMALL_STATE(1656)] = 42751,
  [SMALL_STATE(1657)] = 42803,
  [SMALL_STATE(1658)] = 42861,
  [SMALL_STATE(1659)] = 42913,
  [SMALL_STATE(1660)] = 42965,
  [SMALL_STATE(1661)] = 43017,
  [SMALL_STATE(1662)] = 43075,
  [SMALL_STATE(1663)] = 43133,
  [SMALL_STATE(1664)] = 43185,
  [SMALL_STATE(1665)] = 43247,
  [SMALL_STATE(1666)] = 43299,
  [SMALL_STATE(1667)] = 43351,
  [SMALL_STATE(1668)] = 43403,
  [SMALL_STATE(1669)] = 43455,
  [SMALL_STATE(1670)] = 43506,
  [SMALL_STATE(1671)] = 43613,
  [SMALL_STATE(1672)] = 43664,
  [SMALL_STATE(1673)] = 43775,
  [SMALL_STATE(1674)] = 43882,
  [SMALL_STATE(1675)] = 43989,
  [SMALL_STATE(1676)] = 44096,
  [SMALL_STATE(1677)] = 44147,
  [SMALL_STATE(1678)] = 44198,
  [SMALL_STATE(1679)] = 44255,
  [SMALL_STATE(1680)] = 44312,
  [SMALL_STATE(1681)] = 44363,
  [SMALL_STATE(1682)] = 44470,
  [SMALL_STATE(1683)] = 44525,
  [SMALL_STATE(1684)] = 44576,
  [SMALL_STATE(1685)] = 44683,
  [SMALL_STATE(1686)] = 44734,
  [SMALL_STATE(1687)] = 44807,
  [SMALL_STATE(1688)] = 44858,
  [SMALL_STATE(1689)] = 44909,
  [SMALL_STATE(1690)] = 44960,
  [SMALL_STATE(1691)] = 45011,
  [SMALL_STATE(1692)] = 45094,
  [SMALL_STATE(1693)] = 45145,
  [SMALL_STATE(1694)] = 45204,
  [SMALL_STATE(1695)] = 45311,
  [SMALL_STATE(1696)] = 45418,
  [SMALL_STATE(1697)] = 45519,
  [SMALL_STATE(1698)] = 45582,
  [SMALL_STATE(1699)] = 45649,
  [SMALL_STATE(1700)] = 45736,
  [SMALL_STATE(1701)] = 45813,
  [SMALL_STATE(1702)] = 45890,
  [SMALL_STATE(1703)] = 45985,
  [SMALL_STATE(1704)] = 46078,
  [SMALL_STATE(1705)] = 46169,
  [SMALL_STATE(1706)] = 46248,
  [SMALL_STATE(1707)] = 46347,
  [SMALL_STATE(1708)] = 46446,
  [SMALL_STATE(1709)] = 46543,
  [SMALL_STATE(1710)] = 46622,
  [SMALL_STATE(1711)] = 46679,
  [SMALL_STATE(1712)] = 46730,
  [SMALL_STATE(1713)] = 46813,
  [SMALL_STATE(1714)] = 46864,
  [SMALL_STATE(1715)] = 46915,
  [SMALL_STATE(1716)] = 46988,
  [SMALL_STATE(1717)] = 47039,
  [SMALL_STATE(1718)] = 47146,
  [SMALL_STATE(1719)] = 47203,
  [SMALL_STATE(1720)] = 47254,
  [SMALL_STATE(1721)] = 47305,
  [SMALL_STATE(1722)] = 47412,
  [SMALL_STATE(1723)] = 47483,
  [SMALL_STATE(1724)] = 47534,
  [SMALL_STATE(1725)] = 47625,
  [SMALL_STATE(1726)] = 47676,
  [SMALL_STATE(1727)] = 47727,
  [SMALL_STATE(1728)] = 47778,
  [SMALL_STATE(1729)] = 47891,
  [SMALL_STATE(1730)] = 47942,
  [SMALL_STATE(1731)] = 47997,
  [SMALL_STATE(1732)] = 48048,
  [SMALL_STATE(1733)] = 48141,
  [SMALL_STATE(1734)] = 48254,
  [SMALL_STATE(1735)] = 48349,
  [SMALL_STATE(1736)] = 48426,
  [SMALL_STATE(1737)] = 48503,
  [SMALL_STATE(1738)] = 48578,
  [SMALL_STATE(1739)] = 48675,
  [SMALL_STATE(1740)] = 48726,
  [SMALL_STATE(1741)] = 48777,
  [SMALL_STATE(1742)] = 48828,
  [SMALL_STATE(1743)] = 48879,
  [SMALL_STATE(1744)] = 48930,
  [SMALL_STATE(1745)] = 49031,
  [SMALL_STATE(1746)] = 49138,
  [SMALL_STATE(1747)] = 49189,
  [SMALL_STATE(1748)] = 49296,
  [SMALL_STATE(1749)] = 49403,
  [SMALL_STATE(1750)] = 49454,
  [SMALL_STATE(1751)] = 49511,
  [SMALL_STATE(1752)] = 49562,
  [SMALL_STATE(1753)] = 49613,
  [SMALL_STATE(1754)] = 49664,
  [SMALL_STATE(1755)] = 49715,
  [SMALL_STATE(1756)] = 49822,
  [SMALL_STATE(1757)] = 49929,
  [SMALL_STATE(1758)] = 49982,
  [SMALL_STATE(1759)] = 50033,
  [SMALL_STATE(1760)] = 50086,
  [SMALL_STATE(1761)] = 50173,
  [SMALL_STATE(1762)] = 50224,
  [SMALL_STATE(1763)] = 50275,
  [SMALL_STATE(1764)] = 50326,
  [SMALL_STATE(1765)] = 50377,
  [SMALL_STATE(1766)] = 50428,
  [SMALL_STATE(1767)] = 50479,
  [SMALL_STATE(1768)] = 50530,
  [SMALL_STATE(1769)] = 50581,
  [SMALL_STATE(1770)] = 50648,
  [SMALL_STATE(1771)] = 50717,
  [SMALL_STATE(1772)] = 50784,
  [SMALL_STATE(1773)] = 50891,
  [SMALL_STATE(1774)] = 50998,
  [SMALL_STATE(1775)] = 51049,
  [SMALL_STATE(1776)] = 51100,
  [SMALL_STATE(1777)] = 51151,
  [SMALL_STATE(1778)] = 51202,
  [SMALL_STATE(1779)] = 51311,
  [SMALL_STATE(1780)] = 51374,
  [SMALL_STATE(1781)] = 51425,
  [SMALL_STATE(1782)] = 51476,
  [SMALL_STATE(1783)] = 51583,
  [SMALL_STATE(1784)] = 51646,
  [SMALL_STATE(1785)] = 51697,
  [SMALL_STATE(1786)] = 51748,
  [SMALL_STATE(1787)] = 51799,
  [SMALL_STATE(1788)] = 51862,
  [SMALL_STATE(1789)] = 51969,
  [SMALL_STATE(1790)] = 52038,
  [SMALL_STATE(1791)] = 52151,
  [SMALL_STATE(1792)] = 52258,
  [SMALL_STATE(1793)] = 52333,
  [SMALL_STATE(1794)] = 52446,
  [SMALL_STATE(1795)] = 52517,
  [SMALL_STATE(1796)] = 52628,
  [SMALL_STATE(1797)] = 52737,
  [SMALL_STATE(1798)] = 52792,
  [SMALL_STATE(1799)] = 52903,
  [SMALL_STATE(1800)] = 52974,
  [SMALL_STATE(1801)] = 53043,
  [SMALL_STATE(1802)] = 53094,
  [SMALL_STATE(1803)] = 53147,
  [SMALL_STATE(1804)] = 53198,
  [SMALL_STATE(1805)] = 53249,
  [SMALL_STATE(1806)] = 53300,
  [SMALL_STATE(1807)] = 53407,
  [SMALL_STATE(1808)] = 53458,
  [SMALL_STATE(1809)] = 53509,
  [SMALL_STATE(1810)] = 53560,
  [SMALL_STATE(1811)] = 53667,
  [SMALL_STATE(1812)] = 53718,
  [SMALL_STATE(1813)] = 53769,
  [SMALL_STATE(1814)] = 53880,
  [SMALL_STATE(1815)] = 53933,
  [SMALL_STATE(1816)] = 54044,
  [SMALL_STATE(1817)] = 54097,
  [SMALL_STATE(1818)] = 54172,
  [SMALL_STATE(1819)] = 54223,
  [SMALL_STATE(1820)] = 54276,
  [SMALL_STATE(1821)] = 54383,
  [SMALL_STATE(1822)] = 54490,
  [SMALL_STATE(1823)] = 54541,
  [SMALL_STATE(1824)] = 54648,
  [SMALL_STATE(1825)] = 54699,
  [SMALL_STATE(1826)] = 54807,
  [SMALL_STATE(1827)] = 54913,
  [SMALL_STATE(1828)] = 54967,
  [SMALL_STATE(1829)] = 55023,
  [SMALL_STATE(1830)] = 55133,
  [SMALL_STATE(1831)] = 55201,
  [SMALL_STATE(1832)] = 55309,
  [SMALL_STATE(1833)] = 55415,
  [SMALL_STATE(1834)] = 55489,
  [SMALL_STATE(1835)] = 55559,
  [SMALL_STATE(1836)] = 55621,
  [SMALL_STATE(1837)] = 55683,
  [SMALL_STATE(1838)] = 55745,
  [SMALL_STATE(1839)] = 55851,
  [SMALL_STATE(1840)] = 55957,
  [SMALL_STATE(1841)] = 56063,
  [SMALL_STATE(1842)] = 56169,
  [SMALL_STATE(1843)] = 56275,
  [SMALL_STATE(1844)] = 56381,
  [SMALL_STATE(1845)] = 56487,
  [SMALL_STATE(1846)] = 56555,
  [SMALL_STATE(1847)] = 56605,
  [SMALL_STATE(1848)] = 56671,
  [SMALL_STATE(1849)] = 56771,
  [SMALL_STATE(1850)] = 56857,
  [SMALL_STATE(1851)] = 56933,
  [SMALL_STATE(1852)] = 57009,
  [SMALL_STATE(1853)] = 57069,
  [SMALL_STATE(1854)] = 57121,
  [SMALL_STATE(1855)] = 57229,
  [SMALL_STATE(1856)] = 57283,
  [SMALL_STATE(1857)] = 57343,
  [SMALL_STATE(1858)] = 57453,
  [SMALL_STATE(1859)] = 57505,
  [SMALL_STATE(1860)] = 57599,
  [SMALL_STATE(1861)] = 57691,
  [SMALL_STATE(1862)] = 57749,
  [SMALL_STATE(1863)] = 57857,
  [SMALL_STATE(1864)] = 57963,
  [SMALL_STATE(1865)] = 58053,
  [SMALL_STATE(1866)] = 58115,
  [SMALL_STATE(1867)] = 58175,
  [SMALL_STATE(1868)] = 58237,
  [SMALL_STATE(1869)] = 58343,
  [SMALL_STATE(1870)] = 58453,
  [SMALL_STATE(1871)] = 58515,
  [SMALL_STATE(1872)] = 58577,
  [SMALL_STATE(1873)] = 58639,
  [SMALL_STATE(1874)] = 58717,
  [SMALL_STATE(1875)] = 58779,
  [SMALL_STATE(1876)] = 58843,
  [SMALL_STATE(1877)] = 58903,
  [SMALL_STATE(1878)] = 59001,
  [SMALL_STATE(1879)] = 59107,
  [SMALL_STATE(1880)] = 59203,
  [SMALL_STATE(1881)] = 59313,
  [SMALL_STATE(1882)] = 59423,
  [SMALL_STATE(1883)] = 59481,
  [SMALL_STATE(1884)] = 59537,
  [SMALL_STATE(1885)] = 59593,
  [SMALL_STATE(1886)] = 59699,
  [SMALL_STATE(1887)] = 59761,
  [SMALL_STATE(1888)] = 59823,
  [SMALL_STATE(1889)] = 59933,
  [SMALL_STATE(1890)] = 60041,
  [SMALL_STATE(1891)] = 60097,
  [SMALL_STATE(1892)] = 60159,
  [SMALL_STATE(1893)] = 60267,
  [SMALL_STATE(1894)] = 60329,
  [SMALL_STATE(1895)] = 60439,
  [SMALL_STATE(1896)] = 60521,
  [SMALL_STATE(1897)] = 60631,
  [SMALL_STATE(1898)] = 60703,
  [SMALL_STATE(1899)] = 60759,
  [SMALL_STATE(1900)] = 60815,
  [SMALL_STATE(1901)] = 60873,
  [SMALL_STATE(1902)] = 60981,
  [SMALL_STATE(1903)] = 61087,
  [SMALL_STATE(1904)] = 61197,
  [SMALL_STATE(1905)] = 61305,
  [SMALL_STATE(1906)] = 61413,
  [SMALL_STATE(1907)] = 61467,
  [SMALL_STATE(1908)] = 61529,
  [SMALL_STATE(1909)] = 61591,
  [SMALL_STATE(1910)] = 61649,
  [SMALL_STATE(1911)] = 61755,
  [SMALL_STATE(1912)] = 61861,
  [SMALL_STATE(1913)] = 61967,
  [SMALL_STATE(1914)] = 62021,
  [SMALL_STATE(1915)] = 62077,
  [SMALL_STATE(1916)] = 62187,
  [SMALL_STATE(1917)] = 62272,
  [SMALL_STATE(1918)] = 62321,
  [SMALL_STATE(1919)] = 62376,
  [SMALL_STATE(1920)] = 62431,
  [SMALL_STATE(1921)] = 62480,
  [SMALL_STATE(1922)] = 62529,
  [SMALL_STATE(1923)] = 62634,
  [SMALL_STATE(1924)] = 62739,
  [SMALL_STATE(1925)] = 62794,
  [SMALL_STATE(1926)] = 62843,
  [SMALL_STATE(1927)] = 62894,
  [SMALL_STATE(1928)] = 62963,
  [SMALL_STATE(1929)] = 63036,
  [SMALL_STATE(1930)] = 63085,
  [SMALL_STATE(1931)] = 63190,
  [SMALL_STATE(1932)] = 63239,
  [SMALL_STATE(1933)] = 63288,
  [SMALL_STATE(1934)] = 63355,
  [SMALL_STATE(1935)] = 63404,
  [SMALL_STATE(1936)] = 63509,
  [SMALL_STATE(1937)] = 63614,
  [SMALL_STATE(1938)] = 63669,
  [SMALL_STATE(1939)] = 63722,
  [SMALL_STATE(1940)] = 63827,
  [SMALL_STATE(1941)] = 63880,
  [SMALL_STATE(1942)] = 63985,
  [SMALL_STATE(1943)] = 64090,
  [SMALL_STATE(1944)] = 64161,
  [SMALL_STATE(1945)] = 64242,
  [SMALL_STATE(1946)] = 64349,
  [SMALL_STATE(1947)] = 64398,
  [SMALL_STATE(1948)] = 64447,
  [SMALL_STATE(1949)] = 64496,
  [SMALL_STATE(1950)] = 64591,
  [SMALL_STATE(1951)] = 64688,
  [SMALL_STATE(1952)] = 64765,
  [SMALL_STATE(1953)] = 64854,
  [SMALL_STATE(1954)] = 64945,
  [SMALL_STATE(1955)] = 65038,
  [SMALL_STATE(1956)] = 65087,
  [SMALL_STATE(1957)] = 65136,
  [SMALL_STATE(1958)] = 65211,
  [SMALL_STATE(1959)] = 65286,
  [SMALL_STATE(1960)] = 65335,
  [SMALL_STATE(1961)] = 65434,
  [SMALL_STATE(1962)] = 65495,
  [SMALL_STATE(1963)] = 65556,
  [SMALL_STATE(1964)] = 65663,
  [SMALL_STATE(1965)] = 65712,
  [SMALL_STATE(1966)] = 65761,
  [SMALL_STATE(1967)] = 65866,
  [SMALL_STATE(1968)] = 65973,
  [SMALL_STATE(1969)] = 66078,
  [SMALL_STATE(1970)] = 66135,
  [SMALL_STATE(1971)] = 66184,
  [SMALL_STATE(1972)] = 66289,
  [SMALL_STATE(1973)] = 66396,
  [SMALL_STATE(1974)] = 66445,
  [SMALL_STATE(1975)] = 66494,
  [SMALL_STATE(1976)] = 66543,
  [SMALL_STATE(1977)] = 66648,
  [SMALL_STATE(1978)] = 66753,
  [SMALL_STATE(1979)] = 66802,
  [SMALL_STATE(1980)] = 66853,
  [SMALL_STATE(1981)] = 66902,
  [SMALL_STATE(1982)] = 66951,
  [SMALL_STATE(1983)] = 67000,
  [SMALL_STATE(1984)] = 67049,
  [SMALL_STATE(1985)] = 67098,
  [SMALL_STATE(1986)] = 67147,
  [SMALL_STATE(1987)] = 67198,
  [SMALL_STATE(1988)] = 67247,
  [SMALL_STATE(1989)] = 67296,
  [SMALL_STATE(1990)] = 67345,
  [SMALL_STATE(1991)] = 67400,
  [SMALL_STATE(1992)] = 67461,
  [SMALL_STATE(1993)] = 67522,
  [SMALL_STATE(1994)] = 67577,
  [SMALL_STATE(1995)] = 67682,
  [SMALL_STATE(1996)] = 67731,
  [SMALL_STATE(1997)] = 67836,
  [SMALL_STATE(1998)] = 67887,
  [SMALL_STATE(1999)] = 67938,
  [SMALL_STATE(2000)] = 67987,
  [SMALL_STATE(2001)] = 68036,
  [SMALL_STATE(2002)] = 68085,
  [SMALL_STATE(2003)] = 68136,
  [SMALL_STATE(2004)] = 68185,
  [SMALL_STATE(2005)] = 68234,
  [SMALL_STATE(2006)] = 68283,
  [SMALL_STATE(2007)] = 68332,
  [SMALL_STATE(2008)] = 68381,
  [SMALL_STATE(2009)] = 68430,
  [SMALL_STATE(2010)] = 68479,
  [SMALL_STATE(2011)] = 68528,
  [SMALL_STATE(2012)] = 68633,
  [SMALL_STATE(2013)] = 68740,
  [SMALL_STATE(2014)] = 68789,
  [SMALL_STATE(2015)] = 68838,
  [SMALL_STATE(2016)] = 68889,
  [SMALL_STATE(2017)] = 68938,
  [SMALL_STATE(2018)] = 69043,
  [SMALL_STATE(2019)] = 69096,
  [SMALL_STATE(2020)] = 69157,
  [SMALL_STATE(2021)] = 69206,
  [SMALL_STATE(2022)] = 69257,
  [SMALL_STATE(2023)] = 69306,
  [SMALL_STATE(2024)] = 69355,
  [SMALL_STATE(2025)] = 69462,
  [SMALL_STATE(2026)] = 69511,
  [SMALL_STATE(2027)] = 69568,
  [SMALL_STATE(2028)] = 69623,
  [SMALL_STATE(2029)] = 69728,
  [SMALL_STATE(2030)] = 69835,
  [SMALL_STATE(2031)] = 69942,
  [SMALL_STATE(2032)] = 69997,
  [SMALL_STATE(2033)] = 70104,
  [SMALL_STATE(2034)] = 70159,
  [SMALL_STATE(2035)] = 70208,
  [SMALL_STATE(2036)] = 70259,
  [SMALL_STATE(2037)] = 70308,
  [SMALL_STATE(2038)] = 70357,
  [SMALL_STATE(2039)] = 70406,
  [SMALL_STATE(2040)] = 70461,
  [SMALL_STATE(2041)] = 70524,
  [SMALL_STATE(2042)] = 70573,
  [SMALL_STATE(2043)] = 70622,
  [SMALL_STATE(2044)] = 70685,
  [SMALL_STATE(2045)] = 70742,
  [SMALL_STATE(2046)] = 70791,
  [SMALL_STATE(2047)] = 70898,
  [SMALL_STATE(2048)] = 70959,
  [SMALL_STATE(2049)] = 71008,
  [SMALL_STATE(2050)] = 71069,
  [SMALL_STATE(2051)] = 71176,
  [SMALL_STATE(2052)] = 71225,
  [SMALL_STATE(2053)] = 71274,
  [SMALL_STATE(2054)] = 71323,
  [SMALL_STATE(2055)] = 71372,
  [SMALL_STATE(2056)] = 71479,
  [SMALL_STATE(2057)] = 71530,
  [SMALL_STATE(2058)] = 71585,
  [SMALL_STATE(2059)] = 71634,
  [SMALL_STATE(2060)] = 71683,
  [SMALL_STATE(2061)] = 71734,
  [SMALL_STATE(2062)] = 71795,
  [SMALL_STATE(2063)] = 71856,
  [SMALL_STATE(2064)] = 71905,
  [SMALL_STATE(2065)] = 71956,
  [SMALL_STATE(2066)] = 72011,
  [SMALL_STATE(2067)] = 72118,
  [SMALL_STATE(2068)] = 72179,
  [SMALL_STATE(2069)] = 72286,
  [SMALL_STATE(2070)] = 72347,
  [SMALL_STATE(2071)] = 72396,
  [SMALL_STATE(2072)] = 72445,
  [SMALL_STATE(2073)] = 72502,
  [SMALL_STATE(2074)] = 72559,
  [SMALL_STATE(2075)] = 72608,
  [SMALL_STATE(2076)] = 72657,
  [SMALL_STATE(2077)] = 72710,
  [SMALL_STATE(2078)] = 72759,
  [SMALL_STATE(2079)] = 72866,
  [SMALL_STATE(2080)] = 72915,
  [SMALL_STATE(2081)] = 72968,
  [SMALL_STATE(2082)] = 73023,
  [SMALL_STATE(2083)] = 73072,
  [SMALL_STATE(2084)] = 73121,
  [SMALL_STATE(2085)] = 73176,
  [SMALL_STATE(2086)] = 73225,
  [SMALL_STATE(2087)] = 73332,
  [SMALL_STATE(2088)] = 73385,
  [SMALL_STATE(2089)] = 73492,
  [SMALL_STATE(2090)] = 73599,
  [SMALL_STATE(2091)] = 73650,
  [SMALL_STATE(2092)] = 73699,
  [SMALL_STATE(2093)] = 73804,
  [SMALL_STATE(2094)] = 73911,
  [SMALL_STATE(2095)] = 73959,
  [SMALL_STATE(2096)] = 74029,
  [SMALL_STATE(2097)] = 74103,
  [SMALL_STATE(2098)] = 74177,
  [SMALL_STATE(2099)] = 74225,
  [SMALL_STATE(2100)] = 74273,
  [SMALL_STATE(2101)] = 74329,
  [SMALL_STATE(2102)] = 74377,
  [SMALL_STATE(2103)] = 74425,
  [SMALL_STATE(2104)] = 74477,
  [SMALL_STATE(2105)] = 74561,
  [SMALL_STATE(2106)] = 74659,
  [SMALL_STATE(2107)] = 74711,
  [SMALL_STATE(2108)] = 74817,
  [SMALL_STATE(2109)] = 74921,
  [SMALL_STATE(2110)] = 74969,
  [SMALL_STATE(2111)] = 75017,
  [SMALL_STATE(2112)] = 75065,
  [SMALL_STATE(2113)] = 75113,
  [SMALL_STATE(2114)] = 75167,
  [SMALL_STATE(2115)] = 75215,
  [SMALL_STATE(2116)] = 75269,
  [SMALL_STATE(2117)] = 75359,
  [SMALL_STATE(2118)] = 75447,
  [SMALL_STATE(2119)] = 75499,
  [SMALL_STATE(2120)] = 75547,
  [SMALL_STATE(2121)] = 75623,
  [SMALL_STATE(2122)] = 75727,
  [SMALL_STATE(2123)] = 75781,
  [SMALL_STATE(2124)] = 75837,
  [SMALL_STATE(2125)] = 75889,
  [SMALL_STATE(2126)] = 75947,
  [SMALL_STATE(2127)] = 76005,
  [SMALL_STATE(2128)] = 76101,
  [SMALL_STATE(2129)] = 76155,
  [SMALL_STATE(2130)] = 76249,
  [SMALL_STATE(2131)] = 76329,
  [SMALL_STATE(2132)] = 76381,
  [SMALL_STATE(2133)] = 76433,
  [SMALL_STATE(2134)] = 76485,
  [SMALL_STATE(2135)] = 76589,
  [SMALL_STATE(2136)] = 76693,
  [SMALL_STATE(2137)] = 76797,
  [SMALL_STATE(2138)] = 76901,
  [SMALL_STATE(2139)] = 76953,
  [SMALL_STATE(2140)] = 77005,
  [SMALL_STATE(2141)] = 77057,
  [SMALL_STATE(2142)] = 77161,
  [SMALL_STATE(2143)] = 77215,
  [SMALL_STATE(2144)] = 77267,
  [SMALL_STATE(2145)] = 77317,
  [SMALL_STATE(2146)] = 77373,
  [SMALL_STATE(2147)] = 77425,
  [SMALL_STATE(2148)] = 77475,
  [SMALL_STATE(2149)] = 77525,
  [SMALL_STATE(2150)] = 77573,
  [SMALL_STATE(2151)] = 77677,
  [SMALL_STATE(2152)] = 77725,
  [SMALL_STATE(2153)] = 77773,
  [SMALL_STATE(2154)] = 77821,
  [SMALL_STATE(2155)] = 77869,
  [SMALL_STATE(2156)] = 77917,
  [SMALL_STATE(2157)] = 77965,
  [SMALL_STATE(2158)] = 78013,
  [SMALL_STATE(2159)] = 78061,
  [SMALL_STATE(2160)] = 78117,
  [SMALL_STATE(2161)] = 78187,
  [SMALL_STATE(2162)] = 78291,
  [SMALL_STATE(2163)] = 78395,
  [SMALL_STATE(2164)] = 78451,
  [SMALL_STATE(2165)] = 78555,
  [SMALL_STATE(2166)] = 78603,
  [SMALL_STATE(2167)] = 78651,
  [SMALL_STATE(2168)] = 78699,
  [SMALL_STATE(2169)] = 78747,
  [SMALL_STATE(2170)] = 78851,
  [SMALL_STATE(2171)] = 78955,
  [SMALL_STATE(2172)] = 79009,
  [SMALL_STATE(2173)] = 79069,
  [SMALL_STATE(2174)] = 79123,
  [SMALL_STATE(2175)] = 79175,
  [SMALL_STATE(2176)] = 79229,
  [SMALL_STATE(2177)] = 79285,
  [SMALL_STATE(2178)] = 79389,
  [SMALL_STATE(2179)] = 79437,
  [SMALL_STATE(2180)] = 79485,
  [SMALL_STATE(2181)] = 79533,
  [SMALL_STATE(2182)] = 79587,
  [SMALL_STATE(2183)] = 79635,
  [SMALL_STATE(2184)] = 79739,
  [SMALL_STATE(2185)] = 79787,
  [SMALL_STATE(2186)] = 79835,
  [SMALL_STATE(2187)] = 79883,
  [SMALL_STATE(2188)] = 79937,
  [SMALL_STATE(2189)] = 79985,
  [SMALL_STATE(2190)] = 80077,
  [SMALL_STATE(2191)] = 80129,
  [SMALL_STATE(2192)] = 80179,
  [SMALL_STATE(2193)] = 80231,
  [SMALL_STATE(2194)] = 80335,
  [SMALL_STATE(2195)] = 80439,
  [SMALL_STATE(2196)] = 80487,
  [SMALL_STATE(2197)] = 80539,
  [SMALL_STATE(2198)] = 80643,
  [SMALL_STATE(2199)] = 80691,
  [SMALL_STATE(2200)] = 80739,
  [SMALL_STATE(2201)] = 80787,
  [SMALL_STATE(2202)] = 80835,
  [SMALL_STATE(2203)] = 80883,
  [SMALL_STATE(2204)] = 80931,
  [SMALL_STATE(2205)] = 80983,
  [SMALL_STATE(2206)] = 81031,
  [SMALL_STATE(2207)] = 81135,
  [SMALL_STATE(2208)] = 81183,
  [SMALL_STATE(2209)] = 81233,
  [SMALL_STATE(2210)] = 81281,
  [SMALL_STATE(2211)] = 81329,
  [SMALL_STATE(2212)] = 81381,
  [SMALL_STATE(2213)] = 81433,
  [SMALL_STATE(2214)] = 81481,
  [SMALL_STATE(2215)] = 81531,
  [SMALL_STATE(2216)] = 81581,
  [SMALL_STATE(2217)] = 81633,
  [SMALL_STATE(2218)] = 81685,
  [SMALL_STATE(2219)] = 81751,
  [SMALL_STATE(2220)] = 81799,
  [SMALL_STATE(2221)] = 81853,
  [SMALL_STATE(2222)] = 81911,
  [SMALL_STATE(2223)] = 82015,
  [SMALL_STATE(2224)] = 82087,
  [SMALL_STATE(2225)] = 82155,
  [SMALL_STATE(2226)] = 82207,
  [SMALL_STATE(2227)] = 82273,
  [SMALL_STATE(2228)] = 82377,
  [SMALL_STATE(2229)] = 82449,
  [SMALL_STATE(2230)] = 82517,
  [SMALL_STATE(2231)] = 82573,
  [SMALL_STATE(2232)] = 82629,
  [SMALL_STATE(2233)] = 82677,
  [SMALL_STATE(2234)] = 82729,
  [SMALL_STATE(2235)] = 82833,
  [SMALL_STATE(2236)] = 82883,
  [SMALL_STATE(2237)] = 82931,
  [SMALL_STATE(2238)] = 82981,
  [SMALL_STATE(2239)] = 83033,
  [SMALL_STATE(2240)] = 83083,
  [SMALL_STATE(2241)] = 83133,
  [SMALL_STATE(2242)] = 83185,
  [SMALL_STATE(2243)] = 83235,
  [SMALL_STATE(2244)] = 83339,
  [SMALL_STATE(2245)] = 83397,
  [SMALL_STATE(2246)] = 83457,
  [SMALL_STATE(2247)] = 83523,
  [SMALL_STATE(2248)] = 83571,
  [SMALL_STATE(2249)] = 83623,
  [SMALL_STATE(2250)] = 83727,
  [SMALL_STATE(2251)] = 83799,
  [SMALL_STATE(2252)] = 83867,
  [SMALL_STATE(2253)] = 83917,
  [SMALL_STATE(2254)] = 83965,
  [SMALL_STATE(2255)] = 84017,
  [SMALL_STATE(2256)] = 84069,
  [SMALL_STATE(2257)] = 84119,
  [SMALL_STATE(2258)] = 84223,
  [SMALL_STATE(2259)] = 84327,
  [SMALL_STATE(2260)] = 84431,
  [SMALL_STATE(2261)] = 84535,
  [SMALL_STATE(2262)] = 84639,
  [SMALL_STATE(2263)] = 84743,
  [SMALL_STATE(2264)] = 84847,
  [SMALL_STATE(2265)] = 84951,
  [SMALL_STATE(2266)] = 84999,
  [SMALL_STATE(2267)] = 85097,
  [SMALL_STATE(2268)] = 85181,
  [SMALL_STATE(2269)] = 85285,
  [SMALL_STATE(2270)] = 85389,
  [SMALL_STATE(2271)] = 85437,
  [SMALL_STATE(2272)] = 85489,
  [SMALL_STATE(2273)] = 85543,
  [SMALL_STATE(2274)] = 85595,
  [SMALL_STATE(2275)] = 85699,
  [SMALL_STATE(2276)] = 85803,
  [SMALL_STATE(2277)] = 85877,
  [SMALL_STATE(2278)] = 85951,
  [SMALL_STATE(2279)] = 85999,
  [SMALL_STATE(2280)] = 86059,
  [SMALL_STATE(2281)] = 86163,
  [SMALL_STATE(2282)] = 86267,
  [SMALL_STATE(2283)] = 86371,
  [SMALL_STATE(2284)] = 86475,
  [SMALL_STATE(2285)] = 86567,
  [SMALL_STATE(2286)] = 86671,
  [SMALL_STATE(2287)] = 86775,
  [SMALL_STATE(2288)] = 86835,
  [SMALL_STATE(2289)] = 86939,
  [SMALL_STATE(2290)] = 87029,
  [SMALL_STATE(2291)] = 87099,
  [SMALL_STATE(2292)] = 87179,
  [SMALL_STATE(2293)] = 87283,
  [SMALL_STATE(2294)] = 87387,
  [SMALL_STATE(2295)] = 87475,
  [SMALL_STATE(2296)] = 87551,
  [SMALL_STATE(2297)] = 87647,
  [SMALL_STATE(2298)] = 87741,
  [SMALL_STATE(2299)] = 87821,
  [SMALL_STATE(2300)] = 87925,
  [SMALL_STATE(2301)] = 88029,
  [SMALL_STATE(2302)] = 88099,
  [SMALL_STATE(2303)] = 88193,
  [SMALL_STATE(2304)] = 88289,
  [SMALL_STATE(2305)] = 88365,
  [SMALL_STATE(2306)] = 88453,
  [SMALL_STATE(2307)] = 88543,
  [SMALL_STATE(2308)] = 88641,
  [SMALL_STATE(2309)] = 88733,
  [SMALL_STATE(2310)] = 88807,
  [SMALL_STATE(2311)] = 88891,
  [SMALL_STATE(2312)] = 88965,
  [SMALL_STATE(2313)] = 89052,
  [SMALL_STATE(2314)] = 89147,
  [SMALL_STATE(2315)] = 89248,
  [SMALL_STATE(2316)] = 89349,
  [SMALL_STATE(2317)] = 89404,
  [SMALL_STATE(2318)] = 89451,
  [SMALL_STATE(2319)] = 89498,
  [SMALL_STATE(2320)] = 89553,
  [SMALL_STATE(2321)] = 89614,
  [SMALL_STATE(2322)] = 89661,
  [SMALL_STATE(2323)] = 89714,
  [SMALL_STATE(2324)] = 89763,
  [SMALL_STATE(2325)] = 89810,
  [SMALL_STATE(2326)] = 89859,
  [SMALL_STATE(2327)] = 89906,
  [SMALL_STATE(2328)] = 89957,
  [SMALL_STATE(2329)] = 90004,
  [SMALL_STATE(2330)] = 90051,
  [SMALL_STATE(2331)] = 90102,
  [SMALL_STATE(2332)] = 90155,
  [SMALL_STATE(2333)] = 90202,
  [SMALL_STATE(2334)] = 90267,
  [SMALL_STATE(2335)] = 90320,
  [SMALL_STATE(2336)] = 90367,
  [SMALL_STATE(2337)] = 90430,
  [SMALL_STATE(2338)] = 90479,
  [SMALL_STATE(2339)] = 90580,
  [SMALL_STATE(2340)] = 90627,
  [SMALL_STATE(2341)] = 90674,
  [SMALL_STATE(2342)] = 90725,
  [SMALL_STATE(2343)] = 90772,
  [SMALL_STATE(2344)] = 90825,
  [SMALL_STATE(2345)] = 90880,
  [SMALL_STATE(2346)] = 90943,
  [SMALL_STATE(2347)] = 91004,
  [SMALL_STATE(2348)] = 91051,
  [SMALL_STATE(2349)] = 91100,
  [SMALL_STATE(2350)] = 91201,
  [SMALL_STATE(2351)] = 91248,
  [SMALL_STATE(2352)] = 91317,
  [SMALL_STATE(2353)] = 91418,
  [SMALL_STATE(2354)] = 91519,
  [SMALL_STATE(2355)] = 91590,
  [SMALL_STATE(2356)] = 91669,
  [SMALL_STATE(2357)] = 91770,
  [SMALL_STATE(2358)] = 91871,
  [SMALL_STATE(2359)] = 91926,
  [SMALL_STATE(2360)] = 92027,
  [SMALL_STATE(2361)] = 92074,
  [SMALL_STATE(2362)] = 92135,
  [SMALL_STATE(2363)] = 92188,
  [SMALL_STATE(2364)] = 92289,
  [SMALL_STATE(2365)] = 92336,
  [SMALL_STATE(2366)] = 92403,
  [SMALL_STATE(2367)] = 92496,
  [SMALL_STATE(2368)] = 92559,
  [SMALL_STATE(2369)] = 92606,
  [SMALL_STATE(2370)] = 92661,
  [SMALL_STATE(2371)] = 92712,
  [SMALL_STATE(2372)] = 92771,
  [SMALL_STATE(2373)] = 92846,
  [SMALL_STATE(2374)] = 92901,
  [SMALL_STATE(2375)] = 93002,
  [SMALL_STATE(2376)] = 93055,
  [SMALL_STATE(2377)] = 93102,
  [SMALL_STATE(2378)] = 93191,
  [SMALL_STATE(2379)] = 93292,
  [SMALL_STATE(2380)] = 93345,
  [SMALL_STATE(2381)] = 93392,
  [SMALL_STATE(2382)] = 93447,
  [SMALL_STATE(2383)] = 93502,
  [SMALL_STATE(2384)] = 93551,
  [SMALL_STATE(2385)] = 93652,
  [SMALL_STATE(2386)] = 93699,
  [SMALL_STATE(2387)] = 93800,
  [SMALL_STATE(2388)] = 93847,
  [SMALL_STATE(2389)] = 93908,
  [SMALL_STATE(2390)] = 93967,
  [SMALL_STATE(2391)] = 94058,
  [SMALL_STATE(2392)] = 94105,
  [SMALL_STATE(2393)] = 94178,
  [SMALL_STATE(2394)] = 94251,
  [SMALL_STATE(2395)] = 94334,
  [SMALL_STATE(2396)] = 94381,
  [SMALL_STATE(2397)] = 94478,
  [SMALL_STATE(2398)] = 94526,
  [SMALL_STATE(2399)] = 94574,
  [SMALL_STATE(2400)] = 94624,
  [SMALL_STATE(2401)] = 94680,
  [SMALL_STATE(2402)] = 94728,
  [SMALL_STATE(2403)] = 94784,
  [SMALL_STATE(2404)] = 94836,
  [SMALL_STATE(2405)] = 94898,
  [SMALL_STATE(2406)] = 94950,
  [SMALL_STATE(2407)] = 95006,
  [SMALL_STATE(2408)] = 95054,
  [SMALL_STATE(2409)] = 95110,
  [SMALL_STATE(2410)] = 95166,
  [SMALL_STATE(2411)] = 95222,
  [SMALL_STATE(2412)] = 95278,
  [SMALL_STATE(2413)] = 95324,
  [SMALL_STATE(2414)] = 95380,
  [SMALL_STATE(2415)] = 95436,
  [SMALL_STATE(2416)] = 95498,
  [SMALL_STATE(2417)] = 95546,
  [SMALL_STATE(2418)] = 95600,
  [SMALL_STATE(2419)] = 95648,
  [SMALL_STATE(2420)] = 95704,
  [SMALL_STATE(2421)] = 95750,
  [SMALL_STATE(2422)] = 95798,
  [SMALL_STATE(2423)] = 95854,
  [SMALL_STATE(2424)] = 95910,
  [SMALL_STATE(2425)] = 95966,
  [SMALL_STATE(2426)] = 96022,
  [SMALL_STATE(2427)] = 96078,
  [SMALL_STATE(2428)] = 96134,
  [SMALL_STATE(2429)] = 96186,
  [SMALL_STATE(2430)] = 96238,
  [SMALL_STATE(2431)] = 96286,
  [SMALL_STATE(2432)] = 96342,
  [SMALL_STATE(2433)] = 96398,
  [SMALL_STATE(2434)] = 96460,
  [SMALL_STATE(2435)] = 96516,
  [SMALL_STATE(2436)] = 96564,
  [SMALL_STATE(2437)] = 96620,
  [SMALL_STATE(2438)] = 96690,
  [SMALL_STATE(2439)] = 96738,
  [SMALL_STATE(2440)] = 96786,
  [SMALL_STATE(2441)] = 96834,
  [SMALL_STATE(2442)] = 96886,
  [SMALL_STATE(2443)] = 96943,
  [SMALL_STATE(2444)] = 97010,
  [SMALL_STATE(2445)] = 97055,
  [SMALL_STATE(2446)] = 97106,
  [SMALL_STATE(2447)] = 97157,
  [SMALL_STATE(2448)] = 97204,
  [SMALL_STATE(2449)] = 97249,
  [SMALL_STATE(2450)] = 97300,
  [SMALL_STATE(2451)] = 97357,
  [SMALL_STATE(2452)] = 97406,
  [SMALL_STATE(2453)] = 97463,
  [SMALL_STATE(2454)] = 97520,
  [SMALL_STATE(2455)] = 97577,
  [SMALL_STATE(2456)] = 97634,
  [SMALL_STATE(2457)] = 97691,
  [SMALL_STATE(2458)] = 97748,
  [SMALL_STATE(2459)] = 97805,
  [SMALL_STATE(2460)] = 97862,
  [SMALL_STATE(2461)] = 97907,
  [SMALL_STATE(2462)] = 97954,
  [SMALL_STATE(2463)] = 98001,
  [SMALL_STATE(2464)] = 98068,
  [SMALL_STATE(2465)] = 98119,
  [SMALL_STATE(2466)] = 98164,
  [SMALL_STATE(2467)] = 98227,
  [SMALL_STATE(2468)] = 98274,
  [SMALL_STATE(2469)] = 98331,
  [SMALL_STATE(2470)] = 98388,
  [SMALL_STATE(2471)] = 98433,
  [SMALL_STATE(2472)] = 98478,
  [SMALL_STATE(2473)] = 98535,
  [SMALL_STATE(2474)] = 98592,
  [SMALL_STATE(2475)] = 98649,
  [SMALL_STATE(2476)] = 98694,
  [SMALL_STATE(2477)] = 98761,
  [SMALL_STATE(2478)] = 98812,
  [SMALL_STATE(2479)] = 98856,
  [SMALL_STATE(2480)] = 98900,
  [SMALL_STATE(2481)] = 98960,
  [SMALL_STATE(2482)] = 99004,
  [SMALL_STATE(2483)] = 99064,
  [SMALL_STATE(2484)] = 99108,
  [SMALL_STATE(2485)] = 99152,
  [SMALL_STATE(2486)] = 99212,
  [SMALL_STATE(2487)] = 99260,
  [SMALL_STATE(2488)] = 99320,
  [SMALL_STATE(2489)] = 99380,
  [SMALL_STATE(2490)] = 99426,
  [SMALL_STATE(2491)] = 99486,
  [SMALL_STATE(2492)] = 99546,
  [SMALL_STATE(2493)] = 99604,
  [SMALL_STATE(2494)] = 99664,
  [SMALL_STATE(2495)] = 99710,
  [SMALL_STATE(2496)] = 99770,
  [SMALL_STATE(2497)] = 99830,
  [SMALL_STATE(2498)] = 99888,
  [SMALL_STATE(2499)] = 99932,
  [SMALL_STATE(2500)] = 99978,
  [SMALL_STATE(2501)] = 100032,
  [SMALL_STATE(2502)] = 100076,
  [SMALL_STATE(2503)] = 100136,
  [SMALL_STATE(2504)] = 100182,
  [SMALL_STATE(2505)] = 100228,
  [SMALL_STATE(2506)] = 100288,
  [SMALL_STATE(2507)] = 100333,
  [SMALL_STATE(2508)] = 100376,
  [SMALL_STATE(2509)] = 100419,
  [SMALL_STATE(2510)] = 100470,
  [SMALL_STATE(2511)] = 100517,
  [SMALL_STATE(2512)] = 100570,
  [SMALL_STATE(2513)] = 100621,
  [SMALL_STATE(2514)] = 100664,
  [SMALL_STATE(2515)] = 100717,
  [SMALL_STATE(2516)] = 100768,
  [SMALL_STATE(2517)] = 100811,
  [SMALL_STATE(2518)] = 100862,
  [SMALL_STATE(2519)] = 100913,
  [SMALL_STATE(2520)] = 100958,
  [SMALL_STATE(2521)] = 101009,
  [SMALL_STATE(2522)] = 101060,
  [SMALL_STATE(2523)] = 101111,
  [SMALL_STATE(2524)] = 101162,
  [SMALL_STATE(2525)] = 101213,
  [SMALL_STATE(2526)] = 101264,
  [SMALL_STATE(2527)] = 101315,
  [SMALL_STATE(2528)] = 101360,
  [SMALL_STATE(2529)] = 101411,
  [SMALL_STATE(2530)] = 101454,
  [SMALL_STATE(2531)] = 101497,
  [SMALL_STATE(2532)] = 101548,
  [SMALL_STATE(2533)] = 101591,
  [SMALL_STATE(2534)] = 101634,
  [SMALL_STATE(2535)] = 101685,
  [SMALL_STATE(2536)] = 101736,
  [SMALL_STATE(2537)] = 101787,
  [SMALL_STATE(2538)] = 101830,
  [SMALL_STATE(2539)] = 101875,
  [SMALL_STATE(2540)] = 101928,
  [SMALL_STATE(2541)] = 101971,
  [SMALL_STATE(2542)] = 102014,
  [SMALL_STATE(2543)] = 102065,
  [SMALL_STATE(2544)] = 102108,
  [SMALL_STATE(2545)] = 102159,
  [SMALL_STATE(2546)] = 102210,
  [SMALL_STATE(2547)] = 102261,
  [SMALL_STATE(2548)] = 102312,
  [SMALL_STATE(2549)] = 102363,
  [SMALL_STATE(2550)] = 102408,
  [SMALL_STATE(2551)] = 102453,
  [SMALL_STATE(2552)] = 102496,
  [SMALL_STATE(2553)] = 102541,
  [SMALL_STATE(2554)] = 102584,
  [SMALL_STATE(2555)] = 102627,
  [SMALL_STATE(2556)] = 102670,
  [SMALL_STATE(2557)] = 102715,
  [SMALL_STATE(2558)] = 102766,
  [SMALL_STATE(2559)] = 102809,
  [SMALL_STATE(2560)] = 102852,
  [SMALL_STATE(2561)] = 102903,
  [SMALL_STATE(2562)] = 102954,
  [SMALL_STATE(2563)] = 103005,
  [SMALL_STATE(2564)] = 103048,
  [SMALL_STATE(2565)] = 103099,
  [SMALL_STATE(2566)] = 103150,
  [SMALL_STATE(2567)] = 103192,
  [SMALL_STATE(2568)] = 103234,
  [SMALL_STATE(2569)] = 103276,
  [SMALL_STATE(2570)] = 103318,
  [SMALL_STATE(2571)] = 103360,
  [SMALL_STATE(2572)] = 103402,
  [SMALL_STATE(2573)] = 103444,
  [SMALL_STATE(2574)] = 103486,
  [SMALL_STATE(2575)] = 103528,
  [SMALL_STATE(2576)] = 103570,
  [SMALL_STATE(2577)] = 103612,
  [SMALL_STATE(2578)] = 103654,
  [SMALL_STATE(2579)] = 103696,
  [SMALL_STATE(2580)] = 103738,
  [SMALL_STATE(2581)] = 103780,
  [SMALL_STATE(2582)] = 103822,
  [SMALL_STATE(2583)] = 103864,
  [SMALL_STATE(2584)] = 103906,
  [SMALL_STATE(2585)] = 103948,
  [SMALL_STATE(2586)] = 103990,
  [SMALL_STATE(2587)] = 104032,
  [SMALL_STATE(2588)] = 104074,
  [SMALL_STATE(2589)] = 104116,
  [SMALL_STATE(2590)] = 104158,
  [SMALL_STATE(2591)] = 104200,
  [SMALL_STATE(2592)] = 104246,
  [SMALL_STATE(2593)] = 104288,
  [SMALL_STATE(2594)] = 104330,
  [SMALL_STATE(2595)] = 104372,
  [SMALL_STATE(2596)] = 104414,
  [SMALL_STATE(2597)] = 104456,
  [SMALL_STATE(2598)] = 104498,
  [SMALL_STATE(2599)] = 104540,
  [SMALL_STATE(2600)] = 104582,
  [SMALL_STATE(2601)] = 104624,
  [SMALL_STATE(2602)] = 104666,
  [SMALL_STATE(2603)] = 104708,
  [SMALL_STATE(2604)] = 104750,
  [SMALL_STATE(2605)] = 104792,
  [SMALL_STATE(2606)] = 104834,
  [SMALL_STATE(2607)] = 104876,
  [SMALL_STATE(2608)] = 104918,
  [SMALL_STATE(2609)] = 104960,
  [SMALL_STATE(2610)] = 105002,
  [SMALL_STATE(2611)] = 105044,
  [SMALL_STATE(2612)] = 105086,
  [SMALL_STATE(2613)] = 105128,
  [SMALL_STATE(2614)] = 105170,
  [SMALL_STATE(2615)] = 105212,
  [SMALL_STATE(2616)] = 105254,
  [SMALL_STATE(2617)] = 105296,
  [SMALL_STATE(2618)] = 105338,
  [SMALL_STATE(2619)] = 105380,
  [SMALL_STATE(2620)] = 105422,
  [SMALL_STATE(2621)] = 105464,
  [SMALL_STATE(2622)] = 105506,
  [SMALL_STATE(2623)] = 105548,
  [SMALL_STATE(2624)] = 105590,
  [SMALL_STATE(2625)] = 105632,
  [SMALL_STATE(2626)] = 105674,
  [SMALL_STATE(2627)] = 105716,
  [SMALL_STATE(2628)] = 105758,
  [SMALL_STATE(2629)] = 105800,
  [SMALL_STATE(2630)] = 105842,
  [SMALL_STATE(2631)] = 105884,
  [SMALL_STATE(2632)] = 105926,
  [SMALL_STATE(2633)] = 105968,
  [SMALL_STATE(2634)] = 106010,
  [SMALL_STATE(2635)] = 106052,
  [SMALL_STATE(2636)] = 106094,
  [SMALL_STATE(2637)] = 106136,
  [SMALL_STATE(2638)] = 106178,
  [SMALL_STATE(2639)] = 106220,
  [SMALL_STATE(2640)] = 106262,
  [SMALL_STATE(2641)] = 106304,
  [SMALL_STATE(2642)] = 106346,
  [SMALL_STATE(2643)] = 106388,
  [SMALL_STATE(2644)] = 106430,
  [SMALL_STATE(2645)] = 106472,
  [SMALL_STATE(2646)] = 106514,
  [SMALL_STATE(2647)] = 106556,
  [SMALL_STATE(2648)] = 106598,
  [SMALL_STATE(2649)] = 106640,
  [SMALL_STATE(2650)] = 106682,
  [SMALL_STATE(2651)] = 106724,
  [SMALL_STATE(2652)] = 106766,
  [SMALL_STATE(2653)] = 106808,
  [SMALL_STATE(2654)] = 106850,
  [SMALL_STATE(2655)] = 106892,
  [SMALL_STATE(2656)] = 106934,
  [SMALL_STATE(2657)] = 106976,
  [SMALL_STATE(2658)] = 107018,
  [SMALL_STATE(2659)] = 107060,
  [SMALL_STATE(2660)] = 107102,
  [SMALL_STATE(2661)] = 107144,
  [SMALL_STATE(2662)] = 107186,
  [SMALL_STATE(2663)] = 107228,
  [SMALL_STATE(2664)] = 107270,
  [SMALL_STATE(2665)] = 107312,
  [SMALL_STATE(2666)] = 107354,
  [SMALL_STATE(2667)] = 107396,
  [SMALL_STATE(2668)] = 107438,
  [SMALL_STATE(2669)] = 107480,
  [SMALL_STATE(2670)] = 107522,
  [SMALL_STATE(2671)] = 107564,
  [SMALL_STATE(2672)] = 107606,
  [SMALL_STATE(2673)] = 107648,
  [SMALL_STATE(2674)] = 107690,
  [SMALL_STATE(2675)] = 107732,
  [SMALL_STATE(2676)] = 107774,
  [SMALL_STATE(2677)] = 107816,
  [SMALL_STATE(2678)] = 107858,
  [SMALL_STATE(2679)] = 107900,
  [SMALL_STATE(2680)] = 107942,
  [SMALL_STATE(2681)] = 107984,
  [SMALL_STATE(2682)] = 108026,
  [SMALL_STATE(2683)] = 108068,
  [SMALL_STATE(2684)] = 108110,
  [SMALL_STATE(2685)] = 108152,
  [SMALL_STATE(2686)] = 108194,
  [SMALL_STATE(2687)] = 108236,
  [SMALL_STATE(2688)] = 108278,
  [SMALL_STATE(2689)] = 108320,
  [SMALL_STATE(2690)] = 108362,
  [SMALL_STATE(2691)] = 108404,
  [SMALL_STATE(2692)] = 108446,
  [SMALL_STATE(2693)] = 108488,
  [SMALL_STATE(2694)] = 108530,
  [SMALL_STATE(2695)] = 108572,
  [SMALL_STATE(2696)] = 108614,
  [SMALL_STATE(2697)] = 108656,
  [SMALL_STATE(2698)] = 108698,
  [SMALL_STATE(2699)] = 108740,
  [SMALL_STATE(2700)] = 108782,
  [SMALL_STATE(2701)] = 108824,
  [SMALL_STATE(2702)] = 108866,
  [SMALL_STATE(2703)] = 108908,
  [SMALL_STATE(2704)] = 108949,
  [SMALL_STATE(2705)] = 108990,
  [SMALL_STATE(2706)] = 109069,
  [SMALL_STATE(2707)] = 109148,
  [SMALL_STATE(2708)] = 109195,
  [SMALL_STATE(2709)] = 109274,
  [SMALL_STATE(2710)] = 109315,
  [SMALL_STATE(2711)] = 109356,
  [SMALL_STATE(2712)] = 109397,
  [SMALL_STATE(2713)] = 109438,
  [SMALL_STATE(2714)] = 109479,
  [SMALL_STATE(2715)] = 109520,
  [SMALL_STATE(2716)] = 109561,
  [SMALL_STATE(2717)] = 109640,
  [SMALL_STATE(2718)] = 109681,
  [SMALL_STATE(2719)] = 109760,
  [SMALL_STATE(2720)] = 109801,
  [SMALL_STATE(2721)] = 109842,
  [SMALL_STATE(2722)] = 109883,
  [SMALL_STATE(2723)] = 109924,
  [SMALL_STATE(2724)] = 109965,
  [SMALL_STATE(2725)] = 110006,
  [SMALL_STATE(2726)] = 110047,
  [SMALL_STATE(2727)] = 110088,
  [SMALL_STATE(2728)] = 110129,
  [SMALL_STATE(2729)] = 110170,
  [SMALL_STATE(2730)] = 110211,
  [SMALL_STATE(2731)] = 110252,
  [SMALL_STATE(2732)] = 110293,
  [SMALL_STATE(2733)] = 110334,
  [SMALL_STATE(2734)] = 110375,
  [SMALL_STATE(2735)] = 110454,
  [SMALL_STATE(2736)] = 110495,
  [SMALL_STATE(2737)] = 110536,
  [SMALL_STATE(2738)] = 110577,
  [SMALL_STATE(2739)] = 110656,
  [SMALL_STATE(2740)] = 110735,
  [SMALL_STATE(2741)] = 110776,
  [SMALL_STATE(2742)] = 110817,
  [SMALL_STATE(2743)] = 110858,
  [SMALL_STATE(2744)] = 110899,
  [SMALL_STATE(2745)] = 110940,
  [SMALL_STATE(2746)] = 110981,
  [SMALL_STATE(2747)] = 111022,
  [SMALL_STATE(2748)] = 111063,
  [SMALL_STATE(2749)] = 111104,
  [SMALL_STATE(2750)] = 111145,
  [SMALL_STATE(2751)] = 111186,
  [SMALL_STATE(2752)] = 111227,
  [SMALL_STATE(2753)] = 111268,
  [SMALL_STATE(2754)] = 111309,
  [SMALL_STATE(2755)] = 111350,
  [SMALL_STATE(2756)] = 111391,
  [SMALL_STATE(2757)] = 111432,
  [SMALL_STATE(2758)] = 111473,
  [SMALL_STATE(2759)] = 111514,
  [SMALL_STATE(2760)] = 111555,
  [SMALL_STATE(2761)] = 111596,
  [SMALL_STATE(2762)] = 111637,
  [SMALL_STATE(2763)] = 111678,
  [SMALL_STATE(2764)] = 111719,
  [SMALL_STATE(2765)] = 111760,
  [SMALL_STATE(2766)] = 111801,
  [SMALL_STATE(2767)] = 111841,
  [SMALL_STATE(2768)] = 111895,
  [SMALL_STATE(2769)] = 111945,
  [SMALL_STATE(2770)] = 111985,
  [SMALL_STATE(2771)] = 112023,
  [SMALL_STATE(2772)] = 112061,
  [SMALL_STATE(2773)] = 112099,
  [SMALL_STATE(2774)] = 112137,
  [SMALL_STATE(2775)] = 112175,
  [SMALL_STATE(2776)] = 112213,
  [SMALL_STATE(2777)] = 112255,
  [SMALL_STATE(2778)] = 112296,
  [SMALL_STATE(2779)] = 112337,
  [SMALL_STATE(2780)] = 112375,
  [SMALL_STATE(2781)] = 112413,
  [SMALL_STATE(2782)] = 112451,
  [SMALL_STATE(2783)] = 112489,
  [SMALL_STATE(2784)] = 112527,
  [SMALL_STATE(2785)] = 112562,
  [SMALL_STATE(2786)] = 112595,
  [SMALL_STATE(2787)] = 112630,
  [SMALL_STATE(2788)] = 112663,
  [SMALL_STATE(2789)] = 112698,
  [SMALL_STATE(2790)] = 112733,
  [SMALL_STATE(2791)] = 112768,
  [SMALL_STATE(2792)] = 112794,
  [SMALL_STATE(2793)] = 112820,
  [SMALL_STATE(2794)] = 112846,
  [SMALL_STATE(2795)] = 112872,
  [SMALL_STATE(2796)] = 112898,
  [SMALL_STATE(2797)] = 112924,
  [SMALL_STATE(2798)] = 112950,
  [SMALL_STATE(2799)] = 112976,
  [SMALL_STATE(2800)] = 113002,
  [SMALL_STATE(2801)] = 113028,
  [SMALL_STATE(2802)] = 113054,
  [SMALL_STATE(2803)] = 113080,
  [SMALL_STATE(2804)] = 113106,
  [SMALL_STATE(2805)] = 113132,
  [SMALL_STATE(2806)] = 113158,
  [SMALL_STATE(2807)] = 113184,
  [SMALL_STATE(2808)] = 113210,
  [SMALL_STATE(2809)] = 113236,
  [SMALL_STATE(2810)] = 113262,
  [SMALL_STATE(2811)] = 113288,
  [SMALL_STATE(2812)] = 113314,
  [SMALL_STATE(2813)] = 113340,
  [SMALL_STATE(2814)] = 113366,
  [SMALL_STATE(2815)] = 113392,
  [SMALL_STATE(2816)] = 113418,
  [SMALL_STATE(2817)] = 113444,
  [SMALL_STATE(2818)] = 113470,
  [SMALL_STATE(2819)] = 113496,
  [SMALL_STATE(2820)] = 113522,
  [SMALL_STATE(2821)] = 113548,
  [SMALL_STATE(2822)] = 113582,
  [SMALL_STATE(2823)] = 113608,
  [SMALL_STATE(2824)] = 113634,
  [SMALL_STATE(2825)] = 113660,
  [SMALL_STATE(2826)] = 113686,
  [SMALL_STATE(2827)] = 113712,
  [SMALL_STATE(2828)] = 113738,
  [SMALL_STATE(2829)] = 113763,
  [SMALL_STATE(2830)] = 113788,
  [SMALL_STATE(2831)] = 113813,
  [SMALL_STATE(2832)] = 113844,
  [SMALL_STATE(2833)] = 113873,
  [SMALL_STATE(2834)] = 113898,
  [SMALL_STATE(2835)] = 113923,
  [SMALL_STATE(2836)] = 113948,
  [SMALL_STATE(2837)] = 113972,
  [SMALL_STATE(2838)] = 114000,
  [SMALL_STATE(2839)] = 114023,
  [SMALL_STATE(2840)] = 114048,
  [SMALL_STATE(2841)] = 114071,
  [SMALL_STATE(2842)] = 114094,
  [SMALL_STATE(2843)] = 114115,
  [SMALL_STATE(2844)] = 114138,
  [SMALL_STATE(2845)] = 114161,
  [SMALL_STATE(2846)] = 114184,
  [SMALL_STATE(2847)] = 114207,
  [SMALL_STATE(2848)] = 114230,
  [SMALL_STATE(2849)] = 114253,
  [SMALL_STATE(2850)] = 114280,
  [SMALL_STATE(2851)] = 114303,
  [SMALL_STATE(2852)] = 114326,
  [SMALL_STATE(2853)] = 114349,
  [SMALL_STATE(2854)] = 114372,
  [SMALL_STATE(2855)] = 114395,
  [SMALL_STATE(2856)] = 114418,
  [SMALL_STATE(2857)] = 114439,
  [SMALL_STATE(2858)] = 114464,
  [SMALL_STATE(2859)] = 114485,
  [SMALL_STATE(2860)] = 114516,
  [SMALL_STATE(2861)] = 114539,
  [SMALL_STATE(2862)] = 114560,
  [SMALL_STATE(2863)] = 114585,
  [SMALL_STATE(2864)] = 114606,
  [SMALL_STATE(2865)] = 114629,
  [SMALL_STATE(2866)] = 114650,
  [SMALL_STATE(2867)] = 114671,
  [SMALL_STATE(2868)] = 114694,
  [SMALL_STATE(2869)] = 114717,
  [SMALL_STATE(2870)] = 114740,
  [SMALL_STATE(2871)] = 114771,
  [SMALL_STATE(2872)] = 114802,
  [SMALL_STATE(2873)] = 114833,
  [SMALL_STATE(2874)] = 114856,
  [SMALL_STATE(2875)] = 114879,
  [SMALL_STATE(2876)] = 114902,
  [SMALL_STATE(2877)] = 114923,
  [SMALL_STATE(2878)] = 114948,
  [SMALL_STATE(2879)] = 114969,
  [SMALL_STATE(2880)] = 114992,
  [SMALL_STATE(2881)] = 115015,
  [SMALL_STATE(2882)] = 115038,
  [SMALL_STATE(2883)] = 115060,
  [SMALL_STATE(2884)] = 115084,
  [SMALL_STATE(2885)] = 115106,
  [SMALL_STATE(2886)] = 115128,
  [SMALL_STATE(2887)] = 115150,
  [SMALL_STATE(2888)] = 115172,
  [SMALL_STATE(2889)] = 115194,
  [SMALL_STATE(2890)] = 115216,
  [SMALL_STATE(2891)] = 115238,
  [SMALL_STATE(2892)] = 115260,
  [SMALL_STATE(2893)] = 115282,
  [SMALL_STATE(2894)] = 115304,
  [SMALL_STATE(2895)] = 115326,
  [SMALL_STATE(2896)] = 115348,
  [SMALL_STATE(2897)] = 115370,
  [SMALL_STATE(2898)] = 115400,
  [SMALL_STATE(2899)] = 115422,
  [SMALL_STATE(2900)] = 115452,
  [SMALL_STATE(2901)] = 115480,
  [SMALL_STATE(2902)] = 115508,
  [SMALL_STATE(2903)] = 115530,
  [SMALL_STATE(2904)] = 115572,
  [SMALL_STATE(2905)] = 115600,
  [SMALL_STATE(2906)] = 115628,
  [SMALL_STATE(2907)] = 115650,
  [SMALL_STATE(2908)] = 115672,
  [SMALL_STATE(2909)] = 115714,
  [SMALL_STATE(2910)] = 115736,
  [SMALL_STATE(2911)] = 115760,
  [SMALL_STATE(2912)] = 115782,
  [SMALL_STATE(2913)] = 115824,
  [SMALL_STATE(2914)] = 115852,
  [SMALL_STATE(2915)] = 115880,
  [SMALL_STATE(2916)] = 115908,
  [SMALL_STATE(2917)] = 115938,
  [SMALL_STATE(2918)] = 115968,
  [SMALL_STATE(2919)] = 115998,
  [SMALL_STATE(2920)] = 116026,
  [SMALL_STATE(2921)] = 116052,
  [SMALL_STATE(2922)] = 116074,
  [SMALL_STATE(2923)] = 116116,
  [SMALL_STATE(2924)] = 116158,
  [SMALL_STATE(2925)] = 116200,
  [SMALL_STATE(2926)] = 116222,
  [SMALL_STATE(2927)] = 116252,
  [SMALL_STATE(2928)] = 116282,
  [SMALL_STATE(2929)] = 116312,
  [SMALL_STATE(2930)] = 116340,
  [SMALL_STATE(2931)] = 116362,
  [SMALL_STATE(2932)] = 116384,
  [SMALL_STATE(2933)] = 116414,
  [SMALL_STATE(2934)] = 116444,
  [SMALL_STATE(2935)] = 116474,
  [SMALL_STATE(2936)] = 116504,
  [SMALL_STATE(2937)] = 116532,
  [SMALL_STATE(2938)] = 116574,
  [SMALL_STATE(2939)] = 116596,
  [SMALL_STATE(2940)] = 116618,
  [SMALL_STATE(2941)] = 116640,
  [SMALL_STATE(2942)] = 116662,
  [SMALL_STATE(2943)] = 116690,
  [SMALL_STATE(2944)] = 116720,
  [SMALL_STATE(2945)] = 116750,
  [SMALL_STATE(2946)] = 116780,
  [SMALL_STATE(2947)] = 116802,
  [SMALL_STATE(2948)] = 116824,
  [SMALL_STATE(2949)] = 116846,
  [SMALL_STATE(2950)] = 116868,
  [SMALL_STATE(2951)] = 116890,
  [SMALL_STATE(2952)] = 116912,
  [SMALL_STATE(2953)] = 116947,
  [SMALL_STATE(2954)] = 116974,
  [SMALL_STATE(2955)] = 116997,
  [SMALL_STATE(2956)] = 117032,
  [SMALL_STATE(2957)] = 117067,
  [SMALL_STATE(2958)] = 117102,
  [SMALL_STATE(2959)] = 117137,
  [SMALL_STATE(2960)] = 117162,
  [SMALL_STATE(2961)] = 117189,
  [SMALL_STATE(2962)] = 117216,
  [SMALL_STATE(2963)] = 117243,
  [SMALL_STATE(2964)] = 117268,
  [SMALL_STATE(2965)] = 117303,
  [SMALL_STATE(2966)] = 117324,
  [SMALL_STATE(2967)] = 117359,
  [SMALL_STATE(2968)] = 117384,
  [SMALL_STATE(2969)] = 117419,
  [SMALL_STATE(2970)] = 117440,
  [SMALL_STATE(2971)] = 117477,
  [SMALL_STATE(2972)] = 117498,
  [SMALL_STATE(2973)] = 117533,
  [SMALL_STATE(2974)] = 117554,
  [SMALL_STATE(2975)] = 117579,
  [SMALL_STATE(2976)] = 117600,
  [SMALL_STATE(2977)] = 117635,
  [SMALL_STATE(2978)] = 117660,
  [SMALL_STATE(2979)] = 117681,
  [SMALL_STATE(2980)] = 117705,
  [SMALL_STATE(2981)] = 117723,
  [SMALL_STATE(2982)] = 117751,
  [SMALL_STATE(2983)] = 117783,
  [SMALL_STATE(2984)] = 117815,
  [SMALL_STATE(2985)] = 117851,
  [SMALL_STATE(2986)] = 117883,
  [SMALL_STATE(2987)] = 117915,
  [SMALL_STATE(2988)] = 117951,
  [SMALL_STATE(2989)] = 117983,
  [SMALL_STATE(2990)] = 118015,
  [SMALL_STATE(2991)] = 118051,
  [SMALL_STATE(2992)] = 118087,
  [SMALL_STATE(2993)] = 118119,
  [SMALL_STATE(2994)] = 118151,
  [SMALL_STATE(2995)] = 118169,
  [SMALL_STATE(2996)] = 118187,
  [SMALL_STATE(2997)] = 118205,
  [SMALL_STATE(2998)] = 118227,
  [SMALL_STATE(2999)] = 118245,
  [SMALL_STATE(3000)] = 118263,
  [SMALL_STATE(3001)] = 118281,
  [SMALL_STATE(3002)] = 118299,
  [SMALL_STATE(3003)] = 118327,
  [SMALL_STATE(3004)] = 118349,
  [SMALL_STATE(3005)] = 118367,
  [SMALL_STATE(3006)] = 118385,
  [SMALL_STATE(3007)] = 118403,
  [SMALL_STATE(3008)] = 118421,
  [SMALL_STATE(3009)] = 118439,
  [SMALL_STATE(3010)] = 118469,
  [SMALL_STATE(3011)] = 118497,
  [SMALL_STATE(3012)] = 118517,
  [SMALL_STATE(3013)] = 118553,
  [SMALL_STATE(3014)] = 118571,
  [SMALL_STATE(3015)] = 118589,
  [SMALL_STATE(3016)] = 118607,
  [SMALL_STATE(3017)] = 118639,
  [SMALL_STATE(3018)] = 118657,
  [SMALL_STATE(3019)] = 118675,
  [SMALL_STATE(3020)] = 118711,
  [SMALL_STATE(3021)] = 118729,
  [SMALL_STATE(3022)] = 118747,
  [SMALL_STATE(3023)] = 118765,
  [SMALL_STATE(3024)] = 118783,
  [SMALL_STATE(3025)] = 118801,
  [SMALL_STATE(3026)] = 118819,
  [SMALL_STATE(3027)] = 118837,
  [SMALL_STATE(3028)] = 118855,
  [SMALL_STATE(3029)] = 118873,
  [SMALL_STATE(3030)] = 118891,
  [SMALL_STATE(3031)] = 118919,
  [SMALL_STATE(3032)] = 118937,
  [SMALL_STATE(3033)] = 118955,
  [SMALL_STATE(3034)] = 118973,
  [SMALL_STATE(3035)] = 119001,
  [SMALL_STATE(3036)] = 119019,
  [SMALL_STATE(3037)] = 119037,
  [SMALL_STATE(3038)] = 119073,
  [SMALL_STATE(3039)] = 119101,
  [SMALL_STATE(3040)] = 119133,
  [SMALL_STATE(3041)] = 119151,
  [SMALL_STATE(3042)] = 119170,
  [SMALL_STATE(3043)] = 119189,
  [SMALL_STATE(3044)] = 119208,
  [SMALL_STATE(3045)] = 119225,
  [SMALL_STATE(3046)] = 119244,
  [SMALL_STATE(3047)] = 119267,
  [SMALL_STATE(3048)] = 119290,
  [SMALL_STATE(3049)] = 119313,
  [SMALL_STATE(3050)] = 119330,
  [SMALL_STATE(3051)] = 119349,
  [SMALL_STATE(3052)] = 119372,
  [SMALL_STATE(3053)] = 119391,
  [SMALL_STATE(3054)] = 119410,
  [SMALL_STATE(3055)] = 119429,
  [SMALL_STATE(3056)] = 119448,
  [SMALL_STATE(3057)] = 119469,
  [SMALL_STATE(3058)] = 119488,
  [SMALL_STATE(3059)] = 119509,
  [SMALL_STATE(3060)] = 119528,
  [SMALL_STATE(3061)] = 119547,
  [SMALL_STATE(3062)] = 119566,
  [SMALL_STATE(3063)] = 119585,
  [SMALL_STATE(3064)] = 119606,
  [SMALL_STATE(3065)] = 119625,
  [SMALL_STATE(3066)] = 119644,
  [SMALL_STATE(3067)] = 119663,
  [SMALL_STATE(3068)] = 119682,
  [SMALL_STATE(3069)] = 119701,
  [SMALL_STATE(3070)] = 119720,
  [SMALL_STATE(3071)] = 119741,
  [SMALL_STATE(3072)] = 119760,
  [SMALL_STATE(3073)] = 119781,
  [SMALL_STATE(3074)] = 119804,
  [SMALL_STATE(3075)] = 119823,
  [SMALL_STATE(3076)] = 119844,
  [SMALL_STATE(3077)] = 119863,
  [SMALL_STATE(3078)] = 119880,
  [SMALL_STATE(3079)] = 119899,
  [SMALL_STATE(3080)] = 119922,
  [SMALL_STATE(3081)] = 119941,
  [SMALL_STATE(3082)] = 119958,
  [SMALL_STATE(3083)] = 119975,
  [SMALL_STATE(3084)] = 119992,
  [SMALL_STATE(3085)] = 120013,
  [SMALL_STATE(3086)] = 120032,
  [SMALL_STATE(3087)] = 120051,
  [SMALL_STATE(3088)] = 120070,
  [SMALL_STATE(3089)] = 120091,
  [SMALL_STATE(3090)] = 120110,
  [SMALL_STATE(3091)] = 120129,
  [SMALL_STATE(3092)] = 120146,
  [SMALL_STATE(3093)] = 120165,
  [SMALL_STATE(3094)] = 120184,
  [SMALL_STATE(3095)] = 120203,
  [SMALL_STATE(3096)] = 120222,
  [SMALL_STATE(3097)] = 120241,
  [SMALL_STATE(3098)] = 120258,
  [SMALL_STATE(3099)] = 120278,
  [SMALL_STATE(3100)] = 120312,
  [SMALL_STATE(3101)] = 120344,
  [SMALL_STATE(3102)] = 120366,
  [SMALL_STATE(3103)] = 120390,
  [SMALL_STATE(3104)] = 120418,
  [SMALL_STATE(3105)] = 120452,
  [SMALL_STATE(3106)] = 120486,
  [SMALL_STATE(3107)] = 120504,
  [SMALL_STATE(3108)] = 120522,
  [SMALL_STATE(3109)] = 120556,
  [SMALL_STATE(3110)] = 120584,
  [SMALL_STATE(3111)] = 120604,
  [SMALL_STATE(3112)] = 120638,
  [SMALL_STATE(3113)] = 120672,
  [SMALL_STATE(3114)] = 120706,
  [SMALL_STATE(3115)] = 120740,
  [SMALL_STATE(3116)] = 120774,
  [SMALL_STATE(3117)] = 120806,
  [SMALL_STATE(3118)] = 120838,
  [SMALL_STATE(3119)] = 120872,
  [SMALL_STATE(3120)] = 120906,
  [SMALL_STATE(3121)] = 120940,
  [SMALL_STATE(3122)] = 120974,
  [SMALL_STATE(3123)] = 120994,
  [SMALL_STATE(3124)] = 121010,
  [SMALL_STATE(3125)] = 121041,
  [SMALL_STATE(3126)] = 121072,
  [SMALL_STATE(3127)] = 121103,
  [SMALL_STATE(3128)] = 121118,
  [SMALL_STATE(3129)] = 121149,
  [SMALL_STATE(3130)] = 121174,
  [SMALL_STATE(3131)] = 121189,
  [SMALL_STATE(3132)] = 121204,
  [SMALL_STATE(3133)] = 121221,
  [SMALL_STATE(3134)] = 121236,
  [SMALL_STATE(3135)] = 121251,
  [SMALL_STATE(3136)] = 121266,
  [SMALL_STATE(3137)] = 121281,
  [SMALL_STATE(3138)] = 121312,
  [SMALL_STATE(3139)] = 121327,
  [SMALL_STATE(3140)] = 121342,
  [SMALL_STATE(3141)] = 121359,
  [SMALL_STATE(3142)] = 121374,
  [SMALL_STATE(3143)] = 121389,
  [SMALL_STATE(3144)] = 121404,
  [SMALL_STATE(3145)] = 121419,
  [SMALL_STATE(3146)] = 121434,
  [SMALL_STATE(3147)] = 121451,
  [SMALL_STATE(3148)] = 121466,
  [SMALL_STATE(3149)] = 121487,
  [SMALL_STATE(3150)] = 121502,
  [SMALL_STATE(3151)] = 121523,
  [SMALL_STATE(3152)] = 121544,
  [SMALL_STATE(3153)] = 121559,
  [SMALL_STATE(3154)] = 121590,
  [SMALL_STATE(3155)] = 121605,
  [SMALL_STATE(3156)] = 121636,
  [SMALL_STATE(3157)] = 121667,
  [SMALL_STATE(3158)] = 121698,
  [SMALL_STATE(3159)] = 121729,
  [SMALL_STATE(3160)] = 121760,
  [SMALL_STATE(3161)] = 121791,
  [SMALL_STATE(3162)] = 121806,
  [SMALL_STATE(3163)] = 121821,
  [SMALL_STATE(3164)] = 121836,
  [SMALL_STATE(3165)] = 121861,
  [SMALL_STATE(3166)] = 121876,
  [SMALL_STATE(3167)] = 121901,
  [SMALL_STATE(3168)] = 121932,
  [SMALL_STATE(3169)] = 121951,
  [SMALL_STATE(3170)] = 121982,
  [SMALL_STATE(3171)] = 121997,
  [SMALL_STATE(3172)] = 122028,
  [SMALL_STATE(3173)] = 122049,
  [SMALL_STATE(3174)] = 122080,
  [SMALL_STATE(3175)] = 122111,
  [SMALL_STATE(3176)] = 122136,
  [SMALL_STATE(3177)] = 122151,
  [SMALL_STATE(3178)] = 122182,
  [SMALL_STATE(3179)] = 122201,
  [SMALL_STATE(3180)] = 122232,
  [SMALL_STATE(3181)] = 122263,
  [SMALL_STATE(3182)] = 122278,
  [SMALL_STATE(3183)] = 122297,
  [SMALL_STATE(3184)] = 122314,
  [SMALL_STATE(3185)] = 122339,
  [SMALL_STATE(3186)] = 122354,
  [SMALL_STATE(3187)] = 122369,
  [SMALL_STATE(3188)] = 122400,
  [SMALL_STATE(3189)] = 122425,
  [SMALL_STATE(3190)] = 122456,
  [SMALL_STATE(3191)] = 122473,
  [SMALL_STATE(3192)] = 122498,
  [SMALL_STATE(3193)] = 122513,
  [SMALL_STATE(3194)] = 122538,
  [SMALL_STATE(3195)] = 122563,
  [SMALL_STATE(3196)] = 122578,
  [SMALL_STATE(3197)] = 122603,
  [SMALL_STATE(3198)] = 122618,
  [SMALL_STATE(3199)] = 122643,
  [SMALL_STATE(3200)] = 122674,
  [SMALL_STATE(3201)] = 122705,
  [SMALL_STATE(3202)] = 122720,
  [SMALL_STATE(3203)] = 122735,
  [SMALL_STATE(3204)] = 122752,
  [SMALL_STATE(3205)] = 122773,
  [SMALL_STATE(3206)] = 122796,
  [SMALL_STATE(3207)] = 122821,
  [SMALL_STATE(3208)] = 122836,
  [SMALL_STATE(3209)] = 122851,
  [SMALL_STATE(3210)] = 122866,
  [SMALL_STATE(3211)] = 122891,
  [SMALL_STATE(3212)] = 122906,
  [SMALL_STATE(3213)] = 122921,
  [SMALL_STATE(3214)] = 122936,
  [SMALL_STATE(3215)] = 122967,
  [SMALL_STATE(3216)] = 122988,
  [SMALL_STATE(3217)] = 123013,
  [SMALL_STATE(3218)] = 123028,
  [SMALL_STATE(3219)] = 123043,
  [SMALL_STATE(3220)] = 123058,
  [SMALL_STATE(3221)] = 123083,
  [SMALL_STATE(3222)] = 123102,
  [SMALL_STATE(3223)] = 123117,
  [SMALL_STATE(3224)] = 123134,
  [SMALL_STATE(3225)] = 123154,
  [SMALL_STATE(3226)] = 123178,
  [SMALL_STATE(3227)] = 123202,
  [SMALL_STATE(3228)] = 123226,
  [SMALL_STATE(3229)] = 123250,
  [SMALL_STATE(3230)] = 123274,
  [SMALL_STATE(3231)] = 123298,
  [SMALL_STATE(3232)] = 123322,
  [SMALL_STATE(3233)] = 123346,
  [SMALL_STATE(3234)] = 123366,
  [SMALL_STATE(3235)] = 123390,
  [SMALL_STATE(3236)] = 123410,
  [SMALL_STATE(3237)] = 123428,
  [SMALL_STATE(3238)] = 123448,
  [SMALL_STATE(3239)] = 123472,
  [SMALL_STATE(3240)] = 123496,
  [SMALL_STATE(3241)] = 123520,
  [SMALL_STATE(3242)] = 123544,
  [SMALL_STATE(3243)] = 123565,
  [SMALL_STATE(3244)] = 123590,
  [SMALL_STATE(3245)] = 123611,
  [SMALL_STATE(3246)] = 123636,
  [SMALL_STATE(3247)] = 123661,
  [SMALL_STATE(3248)] = 123686,
  [SMALL_STATE(3249)] = 123703,
  [SMALL_STATE(3250)] = 123716,
  [SMALL_STATE(3251)] = 123741,
  [SMALL_STATE(3252)] = 123766,
  [SMALL_STATE(3253)] = 123791,
  [SMALL_STATE(3254)] = 123808,
  [SMALL_STATE(3255)] = 123825,
  [SMALL_STATE(3256)] = 123842,
  [SMALL_STATE(3257)] = 123867,
  [SMALL_STATE(3258)] = 123884,
  [SMALL_STATE(3259)] = 123909,
  [SMALL_STATE(3260)] = 123934,
  [SMALL_STATE(3261)] = 123959,
  [SMALL_STATE(3262)] = 123980,
  [SMALL_STATE(3263)] = 124001,
  [SMALL_STATE(3264)] = 124026,
  [SMALL_STATE(3265)] = 124051,
  [SMALL_STATE(3266)] = 124072,
  [SMALL_STATE(3267)] = 124093,
  [SMALL_STATE(3268)] = 124118,
  [SMALL_STATE(3269)] = 124143,
  [SMALL_STATE(3270)] = 124160,
  [SMALL_STATE(3271)] = 124181,
  [SMALL_STATE(3272)] = 124206,
  [SMALL_STATE(3273)] = 124219,
  [SMALL_STATE(3274)] = 124236,
  [SMALL_STATE(3275)] = 124253,
  [SMALL_STATE(3276)] = 124278,
  [SMALL_STATE(3277)] = 124303,
  [SMALL_STATE(3278)] = 124320,
  [SMALL_STATE(3279)] = 124345,
  [SMALL_STATE(3280)] = 124358,
  [SMALL_STATE(3281)] = 124383,
  [SMALL_STATE(3282)] = 124396,
  [SMALL_STATE(3283)] = 124409,
  [SMALL_STATE(3284)] = 124434,
  [SMALL_STATE(3285)] = 124447,
  [SMALL_STATE(3286)] = 124462,
  [SMALL_STATE(3287)] = 124479,
  [SMALL_STATE(3288)] = 124504,
  [SMALL_STATE(3289)] = 124521,
  [SMALL_STATE(3290)] = 124538,
  [SMALL_STATE(3291)] = 124563,
  [SMALL_STATE(3292)] = 124580,
  [SMALL_STATE(3293)] = 124597,
  [SMALL_STATE(3294)] = 124610,
  [SMALL_STATE(3295)] = 124627,
  [SMALL_STATE(3296)] = 124652,
  [SMALL_STATE(3297)] = 124667,
  [SMALL_STATE(3298)] = 124688,
  [SMALL_STATE(3299)] = 124701,
  [SMALL_STATE(3300)] = 124726,
  [SMALL_STATE(3301)] = 124743,
  [SMALL_STATE(3302)] = 124764,
  [SMALL_STATE(3303)] = 124785,
  [SMALL_STATE(3304)] = 124798,
  [SMALL_STATE(3305)] = 124815,
  [SMALL_STATE(3306)] = 124828,
  [SMALL_STATE(3307)] = 124841,
  [SMALL_STATE(3308)] = 124858,
  [SMALL_STATE(3309)] = 124883,
  [SMALL_STATE(3310)] = 124904,
  [SMALL_STATE(3311)] = 124925,
  [SMALL_STATE(3312)] = 124938,
  [SMALL_STATE(3313)] = 124955,
  [SMALL_STATE(3314)] = 124980,
  [SMALL_STATE(3315)] = 124997,
  [SMALL_STATE(3316)] = 125022,
  [SMALL_STATE(3317)] = 125047,
  [SMALL_STATE(3318)] = 125066,
  [SMALL_STATE(3319)] = 125091,
  [SMALL_STATE(3320)] = 125112,
  [SMALL_STATE(3321)] = 125133,
  [SMALL_STATE(3322)] = 125158,
  [SMALL_STATE(3323)] = 125183,
  [SMALL_STATE(3324)] = 125208,
  [SMALL_STATE(3325)] = 125233,
  [SMALL_STATE(3326)] = 125256,
  [SMALL_STATE(3327)] = 125271,
  [SMALL_STATE(3328)] = 125296,
  [SMALL_STATE(3329)] = 125311,
  [SMALL_STATE(3330)] = 125328,
  [SMALL_STATE(3331)] = 125345,
  [SMALL_STATE(3332)] = 125370,
  [SMALL_STATE(3333)] = 125395,
  [SMALL_STATE(3334)] = 125412,
  [SMALL_STATE(3335)] = 125437,
  [SMALL_STATE(3336)] = 125462,
  [SMALL_STATE(3337)] = 125477,
  [SMALL_STATE(3338)] = 125494,
  [SMALL_STATE(3339)] = 125519,
  [SMALL_STATE(3340)] = 125536,
  [SMALL_STATE(3341)] = 125553,
  [SMALL_STATE(3342)] = 125566,
  [SMALL_STATE(3343)] = 125579,
  [SMALL_STATE(3344)] = 125596,
  [SMALL_STATE(3345)] = 125617,
  [SMALL_STATE(3346)] = 125634,
  [SMALL_STATE(3347)] = 125655,
  [SMALL_STATE(3348)] = 125680,
  [SMALL_STATE(3349)] = 125705,
  [SMALL_STATE(3350)] = 125726,
  [SMALL_STATE(3351)] = 125751,
  [SMALL_STATE(3352)] = 125772,
  [SMALL_STATE(3353)] = 125797,
  [SMALL_STATE(3354)] = 125822,
  [SMALL_STATE(3355)] = 125841,
  [SMALL_STATE(3356)] = 125866,
  [SMALL_STATE(3357)] = 125891,
  [SMALL_STATE(3358)] = 125916,
  [SMALL_STATE(3359)] = 125937,
  [SMALL_STATE(3360)] = 125962,
  [SMALL_STATE(3361)] = 125987,
  [SMALL_STATE(3362)] = 126012,
  [SMALL_STATE(3363)] = 126037,
  [SMALL_STATE(3364)] = 126052,
  [SMALL_STATE(3365)] = 126070,
  [SMALL_STATE(3366)] = 126092,
  [SMALL_STATE(3367)] = 126108,
  [SMALL_STATE(3368)] = 126124,
  [SMALL_STATE(3369)] = 126146,
  [SMALL_STATE(3370)] = 126168,
  [SMALL_STATE(3371)] = 126184,
  [SMALL_STATE(3372)] = 126198,
  [SMALL_STATE(3373)] = 126216,
  [SMALL_STATE(3374)] = 126234,
  [SMALL_STATE(3375)] = 126256,
  [SMALL_STATE(3376)] = 126274,
  [SMALL_STATE(3377)] = 126296,
  [SMALL_STATE(3378)] = 126312,
  [SMALL_STATE(3379)] = 126328,
  [SMALL_STATE(3380)] = 126344,
  [SMALL_STATE(3381)] = 126362,
  [SMALL_STATE(3382)] = 126380,
  [SMALL_STATE(3383)] = 126396,
  [SMALL_STATE(3384)] = 126412,
  [SMALL_STATE(3385)] = 126424,
  [SMALL_STATE(3386)] = 126440,
  [SMALL_STATE(3387)] = 126462,
  [SMALL_STATE(3388)] = 126478,
  [SMALL_STATE(3389)] = 126500,
  [SMALL_STATE(3390)] = 126522,
  [SMALL_STATE(3391)] = 126538,
  [SMALL_STATE(3392)] = 126560,
  [SMALL_STATE(3393)] = 126576,
  [SMALL_STATE(3394)] = 126598,
  [SMALL_STATE(3395)] = 126610,
  [SMALL_STATE(3396)] = 126624,
  [SMALL_STATE(3397)] = 126642,
  [SMALL_STATE(3398)] = 126658,
  [SMALL_STATE(3399)] = 126674,
  [SMALL_STATE(3400)] = 126692,
  [SMALL_STATE(3401)] = 126704,
  [SMALL_STATE(3402)] = 126720,
  [SMALL_STATE(3403)] = 126732,
  [SMALL_STATE(3404)] = 126748,
  [SMALL_STATE(3405)] = 126764,
  [SMALL_STATE(3406)] = 126786,
  [SMALL_STATE(3407)] = 126808,
  [SMALL_STATE(3408)] = 126830,
  [SMALL_STATE(3409)] = 126848,
  [SMALL_STATE(3410)] = 126870,
  [SMALL_STATE(3411)] = 126892,
  [SMALL_STATE(3412)] = 126914,
  [SMALL_STATE(3413)] = 126932,
  [SMALL_STATE(3414)] = 126954,
  [SMALL_STATE(3415)] = 126972,
  [SMALL_STATE(3416)] = 126994,
  [SMALL_STATE(3417)] = 127010,
  [SMALL_STATE(3418)] = 127032,
  [SMALL_STATE(3419)] = 127054,
  [SMALL_STATE(3420)] = 127074,
  [SMALL_STATE(3421)] = 127092,
  [SMALL_STATE(3422)] = 127106,
  [SMALL_STATE(3423)] = 127124,
  [SMALL_STATE(3424)] = 127146,
  [SMALL_STATE(3425)] = 127162,
  [SMALL_STATE(3426)] = 127184,
  [SMALL_STATE(3427)] = 127204,
  [SMALL_STATE(3428)] = 127226,
  [SMALL_STATE(3429)] = 127248,
  [SMALL_STATE(3430)] = 127270,
  [SMALL_STATE(3431)] = 127292,
  [SMALL_STATE(3432)] = 127308,
  [SMALL_STATE(3433)] = 127330,
  [SMALL_STATE(3434)] = 127342,
  [SMALL_STATE(3435)] = 127360,
  [SMALL_STATE(3436)] = 127376,
  [SMALL_STATE(3437)] = 127398,
  [SMALL_STATE(3438)] = 127412,
  [SMALL_STATE(3439)] = 127430,
  [SMALL_STATE(3440)] = 127446,
  [SMALL_STATE(3441)] = 127462,
  [SMALL_STATE(3442)] = 127480,
  [SMALL_STATE(3443)] = 127502,
  [SMALL_STATE(3444)] = 127514,
  [SMALL_STATE(3445)] = 127536,
  [SMALL_STATE(3446)] = 127552,
  [SMALL_STATE(3447)] = 127568,
  [SMALL_STATE(3448)] = 127584,
  [SMALL_STATE(3449)] = 127600,
  [SMALL_STATE(3450)] = 127616,
  [SMALL_STATE(3451)] = 127632,
  [SMALL_STATE(3452)] = 127652,
  [SMALL_STATE(3453)] = 127674,
  [SMALL_STATE(3454)] = 127694,
  [SMALL_STATE(3455)] = 127716,
  [SMALL_STATE(3456)] = 127732,
  [SMALL_STATE(3457)] = 127748,
  [SMALL_STATE(3458)] = 127764,
  [SMALL_STATE(3459)] = 127786,
  [SMALL_STATE(3460)] = 127802,
  [SMALL_STATE(3461)] = 127824,
  [SMALL_STATE(3462)] = 127836,
  [SMALL_STATE(3463)] = 127848,
  [SMALL_STATE(3464)] = 127870,
  [SMALL_STATE(3465)] = 127886,
  [SMALL_STATE(3466)] = 127908,
  [SMALL_STATE(3467)] = 127924,
  [SMALL_STATE(3468)] = 127946,
  [SMALL_STATE(3469)] = 127964,
  [SMALL_STATE(3470)] = 127986,
  [SMALL_STATE(3471)] = 128002,
  [SMALL_STATE(3472)] = 128018,
  [SMALL_STATE(3473)] = 128034,
  [SMALL_STATE(3474)] = 128052,
  [SMALL_STATE(3475)] = 128074,
  [SMALL_STATE(3476)] = 128092,
  [SMALL_STATE(3477)] = 128110,
  [SMALL_STATE(3478)] = 128128,
  [SMALL_STATE(3479)] = 128150,
  [SMALL_STATE(3480)] = 128166,
  [SMALL_STATE(3481)] = 128184,
  [SMALL_STATE(3482)] = 128202,
  [SMALL_STATE(3483)] = 128220,
  [SMALL_STATE(3484)] = 128242,
  [SMALL_STATE(3485)] = 128258,
  [SMALL_STATE(3486)] = 128278,
  [SMALL_STATE(3487)] = 128296,
  [SMALL_STATE(3488)] = 128312,
  [SMALL_STATE(3489)] = 128334,
  [SMALL_STATE(3490)] = 128356,
  [SMALL_STATE(3491)] = 128378,
  [SMALL_STATE(3492)] = 128400,
  [SMALL_STATE(3493)] = 128422,
  [SMALL_STATE(3494)] = 128438,
  [SMALL_STATE(3495)] = 128460,
  [SMALL_STATE(3496)] = 128482,
  [SMALL_STATE(3497)] = 128504,
  [SMALL_STATE(3498)] = 128520,
  [SMALL_STATE(3499)] = 128542,
  [SMALL_STATE(3500)] = 128564,
  [SMALL_STATE(3501)] = 128586,
  [SMALL_STATE(3502)] = 128602,
  [SMALL_STATE(3503)] = 128620,
  [SMALL_STATE(3504)] = 128636,
  [SMALL_STATE(3505)] = 128652,
  [SMALL_STATE(3506)] = 128668,
  [SMALL_STATE(3507)] = 128686,
  [SMALL_STATE(3508)] = 128702,
  [SMALL_STATE(3509)] = 128718,
  [SMALL_STATE(3510)] = 128740,
  [SMALL_STATE(3511)] = 128758,
  [SMALL_STATE(3512)] = 128774,
  [SMALL_STATE(3513)] = 128796,
  [SMALL_STATE(3514)] = 128818,
  [SMALL_STATE(3515)] = 128836,
  [SMALL_STATE(3516)] = 128858,
  [SMALL_STATE(3517)] = 128880,
  [SMALL_STATE(3518)] = 128896,
  [SMALL_STATE(3519)] = 128918,
  [SMALL_STATE(3520)] = 128940,
  [SMALL_STATE(3521)] = 128952,
  [SMALL_STATE(3522)] = 128964,
  [SMALL_STATE(3523)] = 128980,
  [SMALL_STATE(3524)] = 128992,
  [SMALL_STATE(3525)] = 129004,
  [SMALL_STATE(3526)] = 129016,
  [SMALL_STATE(3527)] = 129028,
  [SMALL_STATE(3528)] = 129040,
  [SMALL_STATE(3529)] = 129052,
  [SMALL_STATE(3530)] = 129064,
  [SMALL_STATE(3531)] = 129080,
  [SMALL_STATE(3532)] = 129102,
  [SMALL_STATE(3533)] = 129124,
  [SMALL_STATE(3534)] = 129144,
  [SMALL_STATE(3535)] = 129162,
  [SMALL_STATE(3536)] = 129184,
  [SMALL_STATE(3537)] = 129200,
  [SMALL_STATE(3538)] = 129222,
  [SMALL_STATE(3539)] = 129240,
  [SMALL_STATE(3540)] = 129262,
  [SMALL_STATE(3541)] = 129278,
  [SMALL_STATE(3542)] = 129300,
  [SMALL_STATE(3543)] = 129316,
  [SMALL_STATE(3544)] = 129327,
  [SMALL_STATE(3545)] = 129340,
  [SMALL_STATE(3546)] = 129359,
  [SMALL_STATE(3547)] = 129378,
  [SMALL_STATE(3548)] = 129395,
  [SMALL_STATE(3549)] = 129414,
  [SMALL_STATE(3550)] = 129433,
  [SMALL_STATE(3551)] = 129444,
  [SMALL_STATE(3552)] = 129463,
  [SMALL_STATE(3553)] = 129480,
  [SMALL_STATE(3554)] = 129497,
  [SMALL_STATE(3555)] = 129516,
  [SMALL_STATE(3556)] = 129533,
  [SMALL_STATE(3557)] = 129552,
  [SMALL_STATE(3558)] = 129571,
  [SMALL_STATE(3559)] = 129590,
  [SMALL_STATE(3560)] = 129605,
  [SMALL_STATE(3561)] = 129616,
  [SMALL_STATE(3562)] = 129627,
  [SMALL_STATE(3563)] = 129646,
  [SMALL_STATE(3564)] = 129657,
  [SMALL_STATE(3565)] = 129672,
  [SMALL_STATE(3566)] = 129687,
  [SMALL_STATE(3567)] = 129698,
  [SMALL_STATE(3568)] = 129717,
  [SMALL_STATE(3569)] = 129728,
  [SMALL_STATE(3570)] = 129747,
  [SMALL_STATE(3571)] = 129766,
  [SMALL_STATE(3572)] = 129777,
  [SMALL_STATE(3573)] = 129796,
  [SMALL_STATE(3574)] = 129813,
  [SMALL_STATE(3575)] = 129832,
  [SMALL_STATE(3576)] = 129843,
  [SMALL_STATE(3577)] = 129854,
  [SMALL_STATE(3578)] = 129873,
  [SMALL_STATE(3579)] = 129884,
  [SMALL_STATE(3580)] = 129903,
  [SMALL_STATE(3581)] = 129920,
  [SMALL_STATE(3582)] = 129931,
  [SMALL_STATE(3583)] = 129942,
  [SMALL_STATE(3584)] = 129959,
  [SMALL_STATE(3585)] = 129970,
  [SMALL_STATE(3586)] = 129987,
  [SMALL_STATE(3587)] = 129998,
  [SMALL_STATE(3588)] = 130009,
  [SMALL_STATE(3589)] = 130020,
  [SMALL_STATE(3590)] = 130033,
  [SMALL_STATE(3591)] = 130052,
  [SMALL_STATE(3592)] = 130063,
  [SMALL_STATE(3593)] = 130074,
  [SMALL_STATE(3594)] = 130091,
  [SMALL_STATE(3595)] = 130110,
  [SMALL_STATE(3596)] = 130127,
  [SMALL_STATE(3597)] = 130144,
  [SMALL_STATE(3598)] = 130155,
  [SMALL_STATE(3599)] = 130174,
  [SMALL_STATE(3600)] = 130193,
  [SMALL_STATE(3601)] = 130208,
  [SMALL_STATE(3602)] = 130227,
  [SMALL_STATE(3603)] = 130246,
  [SMALL_STATE(3604)] = 130265,
  [SMALL_STATE(3605)] = 130284,
  [SMALL_STATE(3606)] = 130299,
  [SMALL_STATE(3607)] = 130310,
  [SMALL_STATE(3608)] = 130329,
  [SMALL_STATE(3609)] = 130340,
  [SMALL_STATE(3610)] = 130355,
  [SMALL_STATE(3611)] = 130366,
  [SMALL_STATE(3612)] = 130385,
  [SMALL_STATE(3613)] = 130404,
  [SMALL_STATE(3614)] = 130415,
  [SMALL_STATE(3615)] = 130430,
  [SMALL_STATE(3616)] = 130449,
  [SMALL_STATE(3617)] = 130460,
  [SMALL_STATE(3618)] = 130471,
  [SMALL_STATE(3619)] = 130488,
  [SMALL_STATE(3620)] = 130499,
  [SMALL_STATE(3621)] = 130510,
  [SMALL_STATE(3622)] = 130525,
  [SMALL_STATE(3623)] = 130542,
  [SMALL_STATE(3624)] = 130553,
  [SMALL_STATE(3625)] = 130564,
  [SMALL_STATE(3626)] = 130579,
  [SMALL_STATE(3627)] = 130590,
  [SMALL_STATE(3628)] = 130607,
  [SMALL_STATE(3629)] = 130618,
  [SMALL_STATE(3630)] = 130629,
  [SMALL_STATE(3631)] = 130648,
  [SMALL_STATE(3632)] = 130667,
  [SMALL_STATE(3633)] = 130680,
  [SMALL_STATE(3634)] = 130697,
  [SMALL_STATE(3635)] = 130710,
  [SMALL_STATE(3636)] = 130729,
  [SMALL_STATE(3637)] = 130746,
  [SMALL_STATE(3638)] = 130765,
  [SMALL_STATE(3639)] = 130776,
  [SMALL_STATE(3640)] = 130795,
  [SMALL_STATE(3641)] = 130810,
  [SMALL_STATE(3642)] = 130821,
  [SMALL_STATE(3643)] = 130838,
  [SMALL_STATE(3644)] = 130849,
  [SMALL_STATE(3645)] = 130860,
  [SMALL_STATE(3646)] = 130871,
  [SMALL_STATE(3647)] = 130882,
  [SMALL_STATE(3648)] = 130893,
  [SMALL_STATE(3649)] = 130904,
  [SMALL_STATE(3650)] = 130923,
  [SMALL_STATE(3651)] = 130934,
  [SMALL_STATE(3652)] = 130945,
  [SMALL_STATE(3653)] = 130956,
  [SMALL_STATE(3654)] = 130975,
  [SMALL_STATE(3655)] = 130986,
  [SMALL_STATE(3656)] = 131003,
  [SMALL_STATE(3657)] = 131014,
  [SMALL_STATE(3658)] = 131029,
  [SMALL_STATE(3659)] = 131048,
  [SMALL_STATE(3660)] = 131059,
  [SMALL_STATE(3661)] = 131070,
  [SMALL_STATE(3662)] = 131081,
  [SMALL_STATE(3663)] = 131092,
  [SMALL_STATE(3664)] = 131111,
  [SMALL_STATE(3665)] = 131130,
  [SMALL_STATE(3666)] = 131149,
  [SMALL_STATE(3667)] = 131160,
  [SMALL_STATE(3668)] = 131179,
  [SMALL_STATE(3669)] = 131198,
  [SMALL_STATE(3670)] = 131217,
  [SMALL_STATE(3671)] = 131236,
  [SMALL_STATE(3672)] = 131253,
  [SMALL_STATE(3673)] = 131264,
  [SMALL_STATE(3674)] = 131283,
  [SMALL_STATE(3675)] = 131294,
  [SMALL_STATE(3676)] = 131305,
  [SMALL_STATE(3677)] = 131316,
  [SMALL_STATE(3678)] = 131335,
  [SMALL_STATE(3679)] = 131346,
  [SMALL_STATE(3680)] = 131357,
  [SMALL_STATE(3681)] = 131376,
  [SMALL_STATE(3682)] = 131387,
  [SMALL_STATE(3683)] = 131406,
  [SMALL_STATE(3684)] = 131417,
  [SMALL_STATE(3685)] = 131436,
  [SMALL_STATE(3686)] = 131447,
  [SMALL_STATE(3687)] = 131458,
  [SMALL_STATE(3688)] = 131469,
  [SMALL_STATE(3689)] = 131480,
  [SMALL_STATE(3690)] = 131491,
  [SMALL_STATE(3691)] = 131510,
  [SMALL_STATE(3692)] = 131529,
  [SMALL_STATE(3693)] = 131546,
  [SMALL_STATE(3694)] = 131557,
  [SMALL_STATE(3695)] = 131568,
  [SMALL_STATE(3696)] = 131587,
  [SMALL_STATE(3697)] = 131598,
  [SMALL_STATE(3698)] = 131609,
  [SMALL_STATE(3699)] = 131628,
  [SMALL_STATE(3700)] = 131639,
  [SMALL_STATE(3701)] = 131650,
  [SMALL_STATE(3702)] = 131669,
  [SMALL_STATE(3703)] = 131680,
  [SMALL_STATE(3704)] = 131699,
  [SMALL_STATE(3705)] = 131710,
  [SMALL_STATE(3706)] = 131721,
  [SMALL_STATE(3707)] = 131732,
  [SMALL_STATE(3708)] = 131751,
  [SMALL_STATE(3709)] = 131770,
  [SMALL_STATE(3710)] = 131781,
  [SMALL_STATE(3711)] = 131800,
  [SMALL_STATE(3712)] = 131817,
  [SMALL_STATE(3713)] = 131828,
  [SMALL_STATE(3714)] = 131839,
  [SMALL_STATE(3715)] = 131858,
  [SMALL_STATE(3716)] = 131869,
  [SMALL_STATE(3717)] = 131880,
  [SMALL_STATE(3718)] = 131899,
  [SMALL_STATE(3719)] = 131914,
  [SMALL_STATE(3720)] = 131933,
  [SMALL_STATE(3721)] = 131948,
  [SMALL_STATE(3722)] = 131963,
  [SMALL_STATE(3723)] = 131982,
  [SMALL_STATE(3724)] = 132001,
  [SMALL_STATE(3725)] = 132020,
  [SMALL_STATE(3726)] = 132031,
  [SMALL_STATE(3727)] = 132050,
  [SMALL_STATE(3728)] = 132069,
  [SMALL_STATE(3729)] = 132080,
  [SMALL_STATE(3730)] = 132099,
  [SMALL_STATE(3731)] = 132118,
  [SMALL_STATE(3732)] = 132135,
  [SMALL_STATE(3733)] = 132152,
  [SMALL_STATE(3734)] = 132171,
  [SMALL_STATE(3735)] = 132190,
  [SMALL_STATE(3736)] = 132209,
  [SMALL_STATE(3737)] = 132228,
  [SMALL_STATE(3738)] = 132247,
  [SMALL_STATE(3739)] = 132266,
  [SMALL_STATE(3740)] = 132285,
  [SMALL_STATE(3741)] = 132300,
  [SMALL_STATE(3742)] = 132311,
  [SMALL_STATE(3743)] = 132326,
  [SMALL_STATE(3744)] = 132345,
  [SMALL_STATE(3745)] = 132356,
  [SMALL_STATE(3746)] = 132367,
  [SMALL_STATE(3747)] = 132378,
  [SMALL_STATE(3748)] = 132389,
  [SMALL_STATE(3749)] = 132408,
  [SMALL_STATE(3750)] = 132419,
  [SMALL_STATE(3751)] = 132430,
  [SMALL_STATE(3752)] = 132449,
  [SMALL_STATE(3753)] = 132460,
  [SMALL_STATE(3754)] = 132479,
  [SMALL_STATE(3755)] = 132490,
  [SMALL_STATE(3756)] = 132501,
  [SMALL_STATE(3757)] = 132512,
  [SMALL_STATE(3758)] = 132531,
  [SMALL_STATE(3759)] = 132546,
  [SMALL_STATE(3760)] = 132557,
  [SMALL_STATE(3761)] = 132568,
  [SMALL_STATE(3762)] = 132587,
  [SMALL_STATE(3763)] = 132598,
  [SMALL_STATE(3764)] = 132609,
  [SMALL_STATE(3765)] = 132620,
  [SMALL_STATE(3766)] = 132631,
  [SMALL_STATE(3767)] = 132642,
  [SMALL_STATE(3768)] = 132653,
  [SMALL_STATE(3769)] = 132664,
  [SMALL_STATE(3770)] = 132675,
  [SMALL_STATE(3771)] = 132694,
  [SMALL_STATE(3772)] = 132705,
  [SMALL_STATE(3773)] = 132716,
  [SMALL_STATE(3774)] = 132735,
  [SMALL_STATE(3775)] = 132746,
  [SMALL_STATE(3776)] = 132757,
  [SMALL_STATE(3777)] = 132772,
  [SMALL_STATE(3778)] = 132791,
  [SMALL_STATE(3779)] = 132802,
  [SMALL_STATE(3780)] = 132813,
  [SMALL_STATE(3781)] = 132824,
  [SMALL_STATE(3782)] = 132835,
  [SMALL_STATE(3783)] = 132854,
  [SMALL_STATE(3784)] = 132865,
  [SMALL_STATE(3785)] = 132884,
  [SMALL_STATE(3786)] = 132895,
  [SMALL_STATE(3787)] = 132914,
  [SMALL_STATE(3788)] = 132933,
  [SMALL_STATE(3789)] = 132952,
  [SMALL_STATE(3790)] = 132963,
  [SMALL_STATE(3791)] = 132974,
  [SMALL_STATE(3792)] = 132985,
  [SMALL_STATE(3793)] = 132996,
  [SMALL_STATE(3794)] = 133011,
  [SMALL_STATE(3795)] = 133026,
  [SMALL_STATE(3796)] = 133043,
  [SMALL_STATE(3797)] = 133054,
  [SMALL_STATE(3798)] = 133073,
  [SMALL_STATE(3799)] = 133090,
  [SMALL_STATE(3800)] = 133101,
  [SMALL_STATE(3801)] = 133112,
  [SMALL_STATE(3802)] = 133127,
  [SMALL_STATE(3803)] = 133138,
  [SMALL_STATE(3804)] = 133149,
  [SMALL_STATE(3805)] = 133168,
  [SMALL_STATE(3806)] = 133179,
  [SMALL_STATE(3807)] = 133190,
  [SMALL_STATE(3808)] = 133201,
  [SMALL_STATE(3809)] = 133218,
  [SMALL_STATE(3810)] = 133229,
  [SMALL_STATE(3811)] = 133240,
  [SMALL_STATE(3812)] = 133251,
  [SMALL_STATE(3813)] = 133268,
  [SMALL_STATE(3814)] = 133279,
  [SMALL_STATE(3815)] = 133290,
  [SMALL_STATE(3816)] = 133301,
  [SMALL_STATE(3817)] = 133312,
  [SMALL_STATE(3818)] = 133323,
  [SMALL_STATE(3819)] = 133342,
  [SMALL_STATE(3820)] = 133361,
  [SMALL_STATE(3821)] = 133380,
  [SMALL_STATE(3822)] = 133399,
  [SMALL_STATE(3823)] = 133418,
  [SMALL_STATE(3824)] = 133429,
  [SMALL_STATE(3825)] = 133444,
  [SMALL_STATE(3826)] = 133463,
  [SMALL_STATE(3827)] = 133474,
  [SMALL_STATE(3828)] = 133493,
  [SMALL_STATE(3829)] = 133504,
  [SMALL_STATE(3830)] = 133515,
  [SMALL_STATE(3831)] = 133526,
  [SMALL_STATE(3832)] = 133545,
  [SMALL_STATE(3833)] = 133562,
  [SMALL_STATE(3834)] = 133581,
  [SMALL_STATE(3835)] = 133592,
  [SMALL_STATE(3836)] = 133607,
  [SMALL_STATE(3837)] = 133626,
  [SMALL_STATE(3838)] = 133643,
  [SMALL_STATE(3839)] = 133654,
  [SMALL_STATE(3840)] = 133673,
  [SMALL_STATE(3841)] = 133686,
  [SMALL_STATE(3842)] = 133697,
  [SMALL_STATE(3843)] = 133708,
  [SMALL_STATE(3844)] = 133723,
  [SMALL_STATE(3845)] = 133734,
  [SMALL_STATE(3846)] = 133751,
  [SMALL_STATE(3847)] = 133766,
  [SMALL_STATE(3848)] = 133785,
  [SMALL_STATE(3849)] = 133796,
  [SMALL_STATE(3850)] = 133810,
  [SMALL_STATE(3851)] = 133824,
  [SMALL_STATE(3852)] = 133840,
  [SMALL_STATE(3853)] = 133854,
  [SMALL_STATE(3854)] = 133868,
  [SMALL_STATE(3855)] = 133884,
  [SMALL_STATE(3856)] = 133898,
  [SMALL_STATE(3857)] = 133914,
  [SMALL_STATE(3858)] = 133928,
  [SMALL_STATE(3859)] = 133942,
  [SMALL_STATE(3860)] = 133956,
  [SMALL_STATE(3861)] = 133972,
  [SMALL_STATE(3862)] = 133988,
  [SMALL_STATE(3863)] = 134004,
  [SMALL_STATE(3864)] = 134018,
  [SMALL_STATE(3865)] = 134034,
  [SMALL_STATE(3866)] = 134050,
  [SMALL_STATE(3867)] = 134066,
  [SMALL_STATE(3868)] = 134080,
  [SMALL_STATE(3869)] = 134094,
  [SMALL_STATE(3870)] = 134108,
  [SMALL_STATE(3871)] = 134124,
  [SMALL_STATE(3872)] = 134140,
  [SMALL_STATE(3873)] = 134156,
  [SMALL_STATE(3874)] = 134170,
  [SMALL_STATE(3875)] = 134186,
  [SMALL_STATE(3876)] = 134200,
  [SMALL_STATE(3877)] = 134214,
  [SMALL_STATE(3878)] = 134228,
  [SMALL_STATE(3879)] = 134242,
  [SMALL_STATE(3880)] = 134256,
  [SMALL_STATE(3881)] = 134272,
  [SMALL_STATE(3882)] = 134288,
  [SMALL_STATE(3883)] = 134302,
  [SMALL_STATE(3884)] = 134316,
  [SMALL_STATE(3885)] = 134332,
  [SMALL_STATE(3886)] = 134346,
  [SMALL_STATE(3887)] = 134360,
  [SMALL_STATE(3888)] = 134376,
  [SMALL_STATE(3889)] = 134390,
  [SMALL_STATE(3890)] = 134406,
  [SMALL_STATE(3891)] = 134420,
  [SMALL_STATE(3892)] = 134436,
  [SMALL_STATE(3893)] = 134446,
  [SMALL_STATE(3894)] = 134460,
  [SMALL_STATE(3895)] = 134474,
  [SMALL_STATE(3896)] = 134486,
  [SMALL_STATE(3897)] = 134500,
  [SMALL_STATE(3898)] = 134514,
  [SMALL_STATE(3899)] = 134528,
  [SMALL_STATE(3900)] = 134544,
  [SMALL_STATE(3901)] = 134560,
  [SMALL_STATE(3902)] = 134576,
  [SMALL_STATE(3903)] = 134592,
  [SMALL_STATE(3904)] = 134604,
  [SMALL_STATE(3905)] = 134614,
  [SMALL_STATE(3906)] = 134628,
  [SMALL_STATE(3907)] = 134644,
  [SMALL_STATE(3908)] = 134660,
  [SMALL_STATE(3909)] = 134674,
  [SMALL_STATE(3910)] = 134690,
  [SMALL_STATE(3911)] = 134706,
  [SMALL_STATE(3912)] = 134720,
  [SMALL_STATE(3913)] = 134734,
  [SMALL_STATE(3914)] = 134748,
  [SMALL_STATE(3915)] = 134762,
  [SMALL_STATE(3916)] = 134776,
  [SMALL_STATE(3917)] = 134792,
  [SMALL_STATE(3918)] = 134806,
  [SMALL_STATE(3919)] = 134820,
  [SMALL_STATE(3920)] = 134836,
  [SMALL_STATE(3921)] = 134850,
  [SMALL_STATE(3922)] = 134864,
  [SMALL_STATE(3923)] = 134880,
  [SMALL_STATE(3924)] = 134894,
  [SMALL_STATE(3925)] = 134908,
  [SMALL_STATE(3926)] = 134924,
  [SMALL_STATE(3927)] = 134938,
  [SMALL_STATE(3928)] = 134954,
  [SMALL_STATE(3929)] = 134968,
  [SMALL_STATE(3930)] = 134982,
  [SMALL_STATE(3931)] = 134998,
  [SMALL_STATE(3932)] = 135012,
  [SMALL_STATE(3933)] = 135024,
  [SMALL_STATE(3934)] = 135040,
  [SMALL_STATE(3935)] = 135056,
  [SMALL_STATE(3936)] = 135070,
  [SMALL_STATE(3937)] = 135086,
  [SMALL_STATE(3938)] = 135102,
  [SMALL_STATE(3939)] = 135118,
  [SMALL_STATE(3940)] = 135132,
  [SMALL_STATE(3941)] = 135146,
  [SMALL_STATE(3942)] = 135162,
  [SMALL_STATE(3943)] = 135178,
  [SMALL_STATE(3944)] = 135188,
  [SMALL_STATE(3945)] = 135200,
  [SMALL_STATE(3946)] = 135214,
  [SMALL_STATE(3947)] = 135226,
  [SMALL_STATE(3948)] = 135240,
  [SMALL_STATE(3949)] = 135254,
  [SMALL_STATE(3950)] = 135268,
  [SMALL_STATE(3951)] = 135278,
  [SMALL_STATE(3952)] = 135294,
  [SMALL_STATE(3953)] = 135308,
  [SMALL_STATE(3954)] = 135324,
  [SMALL_STATE(3955)] = 135340,
  [SMALL_STATE(3956)] = 135356,
  [SMALL_STATE(3957)] = 135372,
  [SMALL_STATE(3958)] = 135388,
  [SMALL_STATE(3959)] = 135404,
  [SMALL_STATE(3960)] = 135418,
  [SMALL_STATE(3961)] = 135434,
  [SMALL_STATE(3962)] = 135448,
  [SMALL_STATE(3963)] = 135462,
  [SMALL_STATE(3964)] = 135476,
  [SMALL_STATE(3965)] = 135492,
  [SMALL_STATE(3966)] = 135506,
  [SMALL_STATE(3967)] = 135516,
  [SMALL_STATE(3968)] = 135530,
  [SMALL_STATE(3969)] = 135544,
  [SMALL_STATE(3970)] = 135558,
  [SMALL_STATE(3971)] = 135572,
  [SMALL_STATE(3972)] = 135588,
  [SMALL_STATE(3973)] = 135604,
  [SMALL_STATE(3974)] = 135618,
  [SMALL_STATE(3975)] = 135634,
  [SMALL_STATE(3976)] = 135648,
  [SMALL_STATE(3977)] = 135664,
  [SMALL_STATE(3978)] = 135678,
  [SMALL_STATE(3979)] = 135688,
  [SMALL_STATE(3980)] = 135702,
  [SMALL_STATE(3981)] = 135716,
  [SMALL_STATE(3982)] = 135732,
  [SMALL_STATE(3983)] = 135746,
  [SMALL_STATE(3984)] = 135760,
  [SMALL_STATE(3985)] = 135776,
  [SMALL_STATE(3986)] = 135792,
  [SMALL_STATE(3987)] = 135808,
  [SMALL_STATE(3988)] = 135822,
  [SMALL_STATE(3989)] = 135836,
  [SMALL_STATE(3990)] = 135852,
  [SMALL_STATE(3991)] = 135866,
  [SMALL_STATE(3992)] = 135882,
  [SMALL_STATE(3993)] = 135896,
  [SMALL_STATE(3994)] = 135912,
  [SMALL_STATE(3995)] = 135926,
  [SMALL_STATE(3996)] = 135942,
  [SMALL_STATE(3997)] = 135955,
  [SMALL_STATE(3998)] = 135968,
  [SMALL_STATE(3999)] = 135981,
  [SMALL_STATE(4000)] = 135994,
  [SMALL_STATE(4001)] = 136003,
  [SMALL_STATE(4002)] = 136012,
  [SMALL_STATE(4003)] = 136025,
  [SMALL_STATE(4004)] = 136038,
  [SMALL_STATE(4005)] = 136051,
  [SMALL_STATE(4006)] = 136064,
  [SMALL_STATE(4007)] = 136073,
  [SMALL_STATE(4008)] = 136082,
  [SMALL_STATE(4009)] = 136095,
  [SMALL_STATE(4010)] = 136104,
  [SMALL_STATE(4011)] = 136117,
  [SMALL_STATE(4012)] = 136130,
  [SMALL_STATE(4013)] = 136139,
  [SMALL_STATE(4014)] = 136152,
  [SMALL_STATE(4015)] = 136165,
  [SMALL_STATE(4016)] = 136178,
  [SMALL_STATE(4017)] = 136191,
  [SMALL_STATE(4018)] = 136204,
  [SMALL_STATE(4019)] = 136213,
  [SMALL_STATE(4020)] = 136226,
  [SMALL_STATE(4021)] = 136239,
  [SMALL_STATE(4022)] = 136252,
  [SMALL_STATE(4023)] = 136261,
  [SMALL_STATE(4024)] = 136272,
  [SMALL_STATE(4025)] = 136281,
  [SMALL_STATE(4026)] = 136294,
  [SMALL_STATE(4027)] = 136303,
  [SMALL_STATE(4028)] = 136316,
  [SMALL_STATE(4029)] = 136325,
  [SMALL_STATE(4030)] = 136334,
  [SMALL_STATE(4031)] = 136347,
  [SMALL_STATE(4032)] = 136360,
  [SMALL_STATE(4033)] = 136373,
  [SMALL_STATE(4034)] = 136386,
  [SMALL_STATE(4035)] = 136399,
  [SMALL_STATE(4036)] = 136410,
  [SMALL_STATE(4037)] = 136423,
  [SMALL_STATE(4038)] = 136436,
  [SMALL_STATE(4039)] = 136447,
  [SMALL_STATE(4040)] = 136460,
  [SMALL_STATE(4041)] = 136473,
  [SMALL_STATE(4042)] = 136486,
  [SMALL_STATE(4043)] = 136495,
  [SMALL_STATE(4044)] = 136504,
  [SMALL_STATE(4045)] = 136517,
  [SMALL_STATE(4046)] = 136528,
  [SMALL_STATE(4047)] = 136541,
  [SMALL_STATE(4048)] = 136554,
  [SMALL_STATE(4049)] = 136567,
  [SMALL_STATE(4050)] = 136580,
  [SMALL_STATE(4051)] = 136593,
  [SMALL_STATE(4052)] = 136606,
  [SMALL_STATE(4053)] = 136619,
  [SMALL_STATE(4054)] = 136630,
  [SMALL_STATE(4055)] = 136643,
  [SMALL_STATE(4056)] = 136654,
  [SMALL_STATE(4057)] = 136665,
  [SMALL_STATE(4058)] = 136676,
  [SMALL_STATE(4059)] = 136689,
  [SMALL_STATE(4060)] = 136702,
  [SMALL_STATE(4061)] = 136711,
  [SMALL_STATE(4062)] = 136720,
  [SMALL_STATE(4063)] = 136733,
  [SMALL_STATE(4064)] = 136742,
  [SMALL_STATE(4065)] = 136751,
  [SMALL_STATE(4066)] = 136764,
  [SMALL_STATE(4067)] = 136773,
  [SMALL_STATE(4068)] = 136782,
  [SMALL_STATE(4069)] = 136791,
  [SMALL_STATE(4070)] = 136800,
  [SMALL_STATE(4071)] = 136809,
  [SMALL_STATE(4072)] = 136822,
  [SMALL_STATE(4073)] = 136835,
  [SMALL_STATE(4074)] = 136848,
  [SMALL_STATE(4075)] = 136857,
  [SMALL_STATE(4076)] = 136870,
  [SMALL_STATE(4077)] = 136879,
  [SMALL_STATE(4078)] = 136888,
  [SMALL_STATE(4079)] = 136897,
  [SMALL_STATE(4080)] = 136910,
  [SMALL_STATE(4081)] = 136919,
  [SMALL_STATE(4082)] = 136932,
  [SMALL_STATE(4083)] = 136943,
  [SMALL_STATE(4084)] = 136956,
  [SMALL_STATE(4085)] = 136969,
  [SMALL_STATE(4086)] = 136982,
  [SMALL_STATE(4087)] = 136995,
  [SMALL_STATE(4088)] = 137006,
  [SMALL_STATE(4089)] = 137015,
  [SMALL_STATE(4090)] = 137024,
  [SMALL_STATE(4091)] = 137037,
  [SMALL_STATE(4092)] = 137046,
  [SMALL_STATE(4093)] = 137055,
  [SMALL_STATE(4094)] = 137064,
  [SMALL_STATE(4095)] = 137077,
  [SMALL_STATE(4096)] = 137090,
  [SMALL_STATE(4097)] = 137101,
  [SMALL_STATE(4098)] = 137114,
  [SMALL_STATE(4099)] = 137127,
  [SMALL_STATE(4100)] = 137136,
  [SMALL_STATE(4101)] = 137147,
  [SMALL_STATE(4102)] = 137160,
  [SMALL_STATE(4103)] = 137173,
  [SMALL_STATE(4104)] = 137186,
  [SMALL_STATE(4105)] = 137199,
  [SMALL_STATE(4106)] = 137212,
  [SMALL_STATE(4107)] = 137225,
  [SMALL_STATE(4108)] = 137236,
  [SMALL_STATE(4109)] = 137249,
  [SMALL_STATE(4110)] = 137262,
  [SMALL_STATE(4111)] = 137273,
  [SMALL_STATE(4112)] = 137282,
  [SMALL_STATE(4113)] = 137295,
  [SMALL_STATE(4114)] = 137304,
  [SMALL_STATE(4115)] = 137317,
  [SMALL_STATE(4116)] = 137330,
  [SMALL_STATE(4117)] = 137343,
  [SMALL_STATE(4118)] = 137356,
  [SMALL_STATE(4119)] = 137369,
  [SMALL_STATE(4120)] = 137382,
  [SMALL_STATE(4121)] = 137395,
  [SMALL_STATE(4122)] = 137404,
  [SMALL_STATE(4123)] = 137417,
  [SMALL_STATE(4124)] = 137430,
  [SMALL_STATE(4125)] = 137443,
  [SMALL_STATE(4126)] = 137456,
  [SMALL_STATE(4127)] = 137469,
  [SMALL_STATE(4128)] = 137478,
  [SMALL_STATE(4129)] = 137491,
  [SMALL_STATE(4130)] = 137504,
  [SMALL_STATE(4131)] = 137517,
  [SMALL_STATE(4132)] = 137530,
  [SMALL_STATE(4133)] = 137543,
  [SMALL_STATE(4134)] = 137556,
  [SMALL_STATE(4135)] = 137569,
  [SMALL_STATE(4136)] = 137582,
  [SMALL_STATE(4137)] = 137595,
  [SMALL_STATE(4138)] = 137604,
  [SMALL_STATE(4139)] = 137617,
  [SMALL_STATE(4140)] = 137626,
  [SMALL_STATE(4141)] = 137635,
  [SMALL_STATE(4142)] = 137644,
  [SMALL_STATE(4143)] = 137657,
  [SMALL_STATE(4144)] = 137670,
  [SMALL_STATE(4145)] = 137679,
  [SMALL_STATE(4146)] = 137692,
  [SMALL_STATE(4147)] = 137705,
  [SMALL_STATE(4148)] = 137718,
  [SMALL_STATE(4149)] = 137731,
  [SMALL_STATE(4150)] = 137744,
  [SMALL_STATE(4151)] = 137757,
  [SMALL_STATE(4152)] = 137770,
  [SMALL_STATE(4153)] = 137783,
  [SMALL_STATE(4154)] = 137792,
  [SMALL_STATE(4155)] = 137805,
  [SMALL_STATE(4156)] = 137818,
  [SMALL_STATE(4157)] = 137831,
  [SMALL_STATE(4158)] = 137844,
  [SMALL_STATE(4159)] = 137857,
  [SMALL_STATE(4160)] = 137870,
  [SMALL_STATE(4161)] = 137883,
  [SMALL_STATE(4162)] = 137892,
  [SMALL_STATE(4163)] = 137905,
  [SMALL_STATE(4164)] = 137914,
  [SMALL_STATE(4165)] = 137927,
  [SMALL_STATE(4166)] = 137940,
  [SMALL_STATE(4167)] = 137951,
  [SMALL_STATE(4168)] = 137962,
  [SMALL_STATE(4169)] = 137973,
  [SMALL_STATE(4170)] = 137984,
  [SMALL_STATE(4171)] = 137997,
  [SMALL_STATE(4172)] = 138010,
  [SMALL_STATE(4173)] = 138023,
  [SMALL_STATE(4174)] = 138036,
  [SMALL_STATE(4175)] = 138049,
  [SMALL_STATE(4176)] = 138062,
  [SMALL_STATE(4177)] = 138075,
  [SMALL_STATE(4178)] = 138084,
  [SMALL_STATE(4179)] = 138097,
  [SMALL_STATE(4180)] = 138106,
  [SMALL_STATE(4181)] = 138119,
  [SMALL_STATE(4182)] = 138132,
  [SMALL_STATE(4183)] = 138145,
  [SMALL_STATE(4184)] = 138158,
  [SMALL_STATE(4185)] = 138169,
  [SMALL_STATE(4186)] = 138178,
  [SMALL_STATE(4187)] = 138191,
  [SMALL_STATE(4188)] = 138200,
  [SMALL_STATE(4189)] = 138213,
  [SMALL_STATE(4190)] = 138224,
  [SMALL_STATE(4191)] = 138237,
  [SMALL_STATE(4192)] = 138250,
  [SMALL_STATE(4193)] = 138259,
  [SMALL_STATE(4194)] = 138272,
  [SMALL_STATE(4195)] = 138283,
  [SMALL_STATE(4196)] = 138296,
  [SMALL_STATE(4197)] = 138309,
  [SMALL_STATE(4198)] = 138320,
  [SMALL_STATE(4199)] = 138333,
  [SMALL_STATE(4200)] = 138346,
  [SMALL_STATE(4201)] = 138359,
  [SMALL_STATE(4202)] = 138372,
  [SMALL_STATE(4203)] = 138385,
  [SMALL_STATE(4204)] = 138398,
  [SMALL_STATE(4205)] = 138411,
  [SMALL_STATE(4206)] = 138424,
  [SMALL_STATE(4207)] = 138433,
  [SMALL_STATE(4208)] = 138446,
  [SMALL_STATE(4209)] = 138459,
  [SMALL_STATE(4210)] = 138470,
  [SMALL_STATE(4211)] = 138483,
  [SMALL_STATE(4212)] = 138496,
  [SMALL_STATE(4213)] = 138509,
  [SMALL_STATE(4214)] = 138518,
  [SMALL_STATE(4215)] = 138529,
  [SMALL_STATE(4216)] = 138540,
  [SMALL_STATE(4217)] = 138553,
  [SMALL_STATE(4218)] = 138566,
  [SMALL_STATE(4219)] = 138575,
  [SMALL_STATE(4220)] = 138588,
  [SMALL_STATE(4221)] = 138601,
  [SMALL_STATE(4222)] = 138610,
  [SMALL_STATE(4223)] = 138623,
  [SMALL_STATE(4224)] = 138632,
  [SMALL_STATE(4225)] = 138641,
  [SMALL_STATE(4226)] = 138652,
  [SMALL_STATE(4227)] = 138661,
  [SMALL_STATE(4228)] = 138674,
  [SMALL_STATE(4229)] = 138685,
  [SMALL_STATE(4230)] = 138698,
  [SMALL_STATE(4231)] = 138707,
  [SMALL_STATE(4232)] = 138718,
  [SMALL_STATE(4233)] = 138729,
  [SMALL_STATE(4234)] = 138742,
  [SMALL_STATE(4235)] = 138755,
  [SMALL_STATE(4236)] = 138768,
  [SMALL_STATE(4237)] = 138781,
  [SMALL_STATE(4238)] = 138794,
  [SMALL_STATE(4239)] = 138807,
  [SMALL_STATE(4240)] = 138820,
  [SMALL_STATE(4241)] = 138833,
  [SMALL_STATE(4242)] = 138846,
  [SMALL_STATE(4243)] = 138855,
  [SMALL_STATE(4244)] = 138868,
  [SMALL_STATE(4245)] = 138877,
  [SMALL_STATE(4246)] = 138890,
  [SMALL_STATE(4247)] = 138903,
  [SMALL_STATE(4248)] = 138912,
  [SMALL_STATE(4249)] = 138925,
  [SMALL_STATE(4250)] = 138934,
  [SMALL_STATE(4251)] = 138945,
  [SMALL_STATE(4252)] = 138956,
  [SMALL_STATE(4253)] = 138969,
  [SMALL_STATE(4254)] = 138982,
  [SMALL_STATE(4255)] = 138995,
  [SMALL_STATE(4256)] = 139008,
  [SMALL_STATE(4257)] = 139019,
  [SMALL_STATE(4258)] = 139032,
  [SMALL_STATE(4259)] = 139043,
  [SMALL_STATE(4260)] = 139056,
  [SMALL_STATE(4261)] = 139069,
  [SMALL_STATE(4262)] = 139082,
  [SMALL_STATE(4263)] = 139095,
  [SMALL_STATE(4264)] = 139108,
  [SMALL_STATE(4265)] = 139117,
  [SMALL_STATE(4266)] = 139130,
  [SMALL_STATE(4267)] = 139143,
  [SMALL_STATE(4268)] = 139156,
  [SMALL_STATE(4269)] = 139169,
  [SMALL_STATE(4270)] = 139182,
  [SMALL_STATE(4271)] = 139195,
  [SMALL_STATE(4272)] = 139208,
  [SMALL_STATE(4273)] = 139217,
  [SMALL_STATE(4274)] = 139230,
  [SMALL_STATE(4275)] = 139243,
  [SMALL_STATE(4276)] = 139251,
  [SMALL_STATE(4277)] = 139259,
  [SMALL_STATE(4278)] = 139269,
  [SMALL_STATE(4279)] = 139277,
  [SMALL_STATE(4280)] = 139287,
  [SMALL_STATE(4281)] = 139297,
  [SMALL_STATE(4282)] = 139307,
  [SMALL_STATE(4283)] = 139317,
  [SMALL_STATE(4284)] = 139327,
  [SMALL_STATE(4285)] = 139335,
  [SMALL_STATE(4286)] = 139345,
  [SMALL_STATE(4287)] = 139355,
  [SMALL_STATE(4288)] = 139363,
  [SMALL_STATE(4289)] = 139373,
  [SMALL_STATE(4290)] = 139383,
  [SMALL_STATE(4291)] = 139391,
  [SMALL_STATE(4292)] = 139399,
  [SMALL_STATE(4293)] = 139409,
  [SMALL_STATE(4294)] = 139419,
  [SMALL_STATE(4295)] = 139429,
  [SMALL_STATE(4296)] = 139439,
  [SMALL_STATE(4297)] = 139449,
  [SMALL_STATE(4298)] = 139459,
  [SMALL_STATE(4299)] = 139469,
  [SMALL_STATE(4300)] = 139479,
  [SMALL_STATE(4301)] = 139489,
  [SMALL_STATE(4302)] = 139499,
  [SMALL_STATE(4303)] = 139509,
  [SMALL_STATE(4304)] = 139519,
  [SMALL_STATE(4305)] = 139529,
  [SMALL_STATE(4306)] = 139539,
  [SMALL_STATE(4307)] = 139549,
  [SMALL_STATE(4308)] = 139559,
  [SMALL_STATE(4309)] = 139569,
  [SMALL_STATE(4310)] = 139579,
  [SMALL_STATE(4311)] = 139589,
  [SMALL_STATE(4312)] = 139599,
  [SMALL_STATE(4313)] = 139609,
  [SMALL_STATE(4314)] = 139617,
  [SMALL_STATE(4315)] = 139627,
  [SMALL_STATE(4316)] = 139637,
  [SMALL_STATE(4317)] = 139645,
  [SMALL_STATE(4318)] = 139655,
  [SMALL_STATE(4319)] = 139665,
  [SMALL_STATE(4320)] = 139673,
  [SMALL_STATE(4321)] = 139683,
  [SMALL_STATE(4322)] = 139691,
  [SMALL_STATE(4323)] = 139699,
  [SMALL_STATE(4324)] = 139709,
  [SMALL_STATE(4325)] = 139717,
  [SMALL_STATE(4326)] = 139727,
  [SMALL_STATE(4327)] = 139737,
  [SMALL_STATE(4328)] = 139747,
  [SMALL_STATE(4329)] = 139757,
  [SMALL_STATE(4330)] = 139767,
  [SMALL_STATE(4331)] = 139777,
  [SMALL_STATE(4332)] = 139787,
  [SMALL_STATE(4333)] = 139797,
  [SMALL_STATE(4334)] = 139807,
  [SMALL_STATE(4335)] = 139817,
  [SMALL_STATE(4336)] = 139827,
  [SMALL_STATE(4337)] = 139835,
  [SMALL_STATE(4338)] = 139845,
  [SMALL_STATE(4339)] = 139855,
  [SMALL_STATE(4340)] = 139865,
  [SMALL_STATE(4341)] = 139873,
  [SMALL_STATE(4342)] = 139883,
  [SMALL_STATE(4343)] = 139893,
  [SMALL_STATE(4344)] = 139901,
  [SMALL_STATE(4345)] = 139911,
  [SMALL_STATE(4346)] = 139921,
  [SMALL_STATE(4347)] = 139931,
  [SMALL_STATE(4348)] = 139939,
  [SMALL_STATE(4349)] = 139947,
  [SMALL_STATE(4350)] = 139955,
  [SMALL_STATE(4351)] = 139965,
  [SMALL_STATE(4352)] = 139975,
  [SMALL_STATE(4353)] = 139985,
  [SMALL_STATE(4354)] = 139995,
  [SMALL_STATE(4355)] = 140005,
  [SMALL_STATE(4356)] = 140015,
  [SMALL_STATE(4357)] = 140023,
  [SMALL_STATE(4358)] = 140033,
  [SMALL_STATE(4359)] = 140041,
  [SMALL_STATE(4360)] = 140051,
  [SMALL_STATE(4361)] = 140061,
  [SMALL_STATE(4362)] = 140069,
  [SMALL_STATE(4363)] = 140079,
  [SMALL_STATE(4364)] = 140089,
  [SMALL_STATE(4365)] = 140099,
  [SMALL_STATE(4366)] = 140109,
  [SMALL_STATE(4367)] = 140119,
  [SMALL_STATE(4368)] = 140129,
  [SMALL_STATE(4369)] = 140139,
  [SMALL_STATE(4370)] = 140149,
  [SMALL_STATE(4371)] = 140157,
  [SMALL_STATE(4372)] = 140167,
  [SMALL_STATE(4373)] = 140177,
  [SMALL_STATE(4374)] = 140187,
  [SMALL_STATE(4375)] = 140197,
  [SMALL_STATE(4376)] = 140207,
  [SMALL_STATE(4377)] = 140215,
  [SMALL_STATE(4378)] = 140225,
  [SMALL_STATE(4379)] = 140233,
  [SMALL_STATE(4380)] = 140243,
  [SMALL_STATE(4381)] = 140253,
  [SMALL_STATE(4382)] = 140263,
  [SMALL_STATE(4383)] = 140273,
  [SMALL_STATE(4384)] = 140281,
  [SMALL_STATE(4385)] = 140291,
  [SMALL_STATE(4386)] = 140299,
  [SMALL_STATE(4387)] = 140307,
  [SMALL_STATE(4388)] = 140317,
  [SMALL_STATE(4389)] = 140327,
  [SMALL_STATE(4390)] = 140337,
  [SMALL_STATE(4391)] = 140347,
  [SMALL_STATE(4392)] = 140355,
  [SMALL_STATE(4393)] = 140363,
  [SMALL_STATE(4394)] = 140373,
  [SMALL_STATE(4395)] = 140381,
  [SMALL_STATE(4396)] = 140389,
  [SMALL_STATE(4397)] = 140399,
  [SMALL_STATE(4398)] = 140409,
  [SMALL_STATE(4399)] = 140417,
  [SMALL_STATE(4400)] = 140425,
  [SMALL_STATE(4401)] = 140433,
  [SMALL_STATE(4402)] = 140443,
  [SMALL_STATE(4403)] = 140453,
  [SMALL_STATE(4404)] = 140463,
  [SMALL_STATE(4405)] = 140473,
  [SMALL_STATE(4406)] = 140483,
  [SMALL_STATE(4407)] = 140493,
  [SMALL_STATE(4408)] = 140503,
  [SMALL_STATE(4409)] = 140513,
  [SMALL_STATE(4410)] = 140523,
  [SMALL_STATE(4411)] = 140533,
  [SMALL_STATE(4412)] = 140543,
  [SMALL_STATE(4413)] = 140553,
  [SMALL_STATE(4414)] = 140563,
  [SMALL_STATE(4415)] = 140571,
  [SMALL_STATE(4416)] = 140581,
  [SMALL_STATE(4417)] = 140591,
  [SMALL_STATE(4418)] = 140601,
  [SMALL_STATE(4419)] = 140611,
  [SMALL_STATE(4420)] = 140619,
  [SMALL_STATE(4421)] = 140627,
  [SMALL_STATE(4422)] = 140635,
  [SMALL_STATE(4423)] = 140645,
  [SMALL_STATE(4424)] = 140655,
  [SMALL_STATE(4425)] = 140665,
  [SMALL_STATE(4426)] = 140675,
  [SMALL_STATE(4427)] = 140683,
  [SMALL_STATE(4428)] = 140693,
  [SMALL_STATE(4429)] = 140701,
  [SMALL_STATE(4430)] = 140711,
  [SMALL_STATE(4431)] = 140719,
  [SMALL_STATE(4432)] = 140727,
  [SMALL_STATE(4433)] = 140735,
  [SMALL_STATE(4434)] = 140745,
  [SMALL_STATE(4435)] = 140755,
  [SMALL_STATE(4436)] = 140765,
  [SMALL_STATE(4437)] = 140773,
  [SMALL_STATE(4438)] = 140783,
  [SMALL_STATE(4439)] = 140793,
  [SMALL_STATE(4440)] = 140801,
  [SMALL_STATE(4441)] = 140809,
  [SMALL_STATE(4442)] = 140817,
  [SMALL_STATE(4443)] = 140825,
  [SMALL_STATE(4444)] = 140835,
  [SMALL_STATE(4445)] = 140845,
  [SMALL_STATE(4446)] = 140855,
  [SMALL_STATE(4447)] = 140865,
  [SMALL_STATE(4448)] = 140875,
  [SMALL_STATE(4449)] = 140885,
  [SMALL_STATE(4450)] = 140893,
  [SMALL_STATE(4451)] = 140903,
  [SMALL_STATE(4452)] = 140913,
  [SMALL_STATE(4453)] = 140923,
  [SMALL_STATE(4454)] = 140933,
  [SMALL_STATE(4455)] = 140943,
  [SMALL_STATE(4456)] = 140953,
  [SMALL_STATE(4457)] = 140963,
  [SMALL_STATE(4458)] = 140971,
  [SMALL_STATE(4459)] = 140979,
  [SMALL_STATE(4460)] = 140987,
  [SMALL_STATE(4461)] = 140995,
  [SMALL_STATE(4462)] = 141005,
  [SMALL_STATE(4463)] = 141013,
  [SMALL_STATE(4464)] = 141023,
  [SMALL_STATE(4465)] = 141033,
  [SMALL_STATE(4466)] = 141043,
  [SMALL_STATE(4467)] = 141051,
  [SMALL_STATE(4468)] = 141061,
  [SMALL_STATE(4469)] = 141069,
  [SMALL_STATE(4470)] = 141079,
  [SMALL_STATE(4471)] = 141087,
  [SMALL_STATE(4472)] = 141095,
  [SMALL_STATE(4473)] = 141103,
  [SMALL_STATE(4474)] = 141113,
  [SMALL_STATE(4475)] = 141123,
  [SMALL_STATE(4476)] = 141131,
  [SMALL_STATE(4477)] = 141141,
  [SMALL_STATE(4478)] = 141149,
  [SMALL_STATE(4479)] = 141159,
  [SMALL_STATE(4480)] = 141167,
  [SMALL_STATE(4481)] = 141177,
  [SMALL_STATE(4482)] = 141187,
  [SMALL_STATE(4483)] = 141195,
  [SMALL_STATE(4484)] = 141203,
  [SMALL_STATE(4485)] = 141213,
  [SMALL_STATE(4486)] = 141221,
  [SMALL_STATE(4487)] = 141231,
  [SMALL_STATE(4488)] = 141239,
  [SMALL_STATE(4489)] = 141249,
  [SMALL_STATE(4490)] = 141259,
  [SMALL_STATE(4491)] = 141267,
  [SMALL_STATE(4492)] = 141277,
  [SMALL_STATE(4493)] = 141287,
  [SMALL_STATE(4494)] = 141297,
  [SMALL_STATE(4495)] = 141307,
  [SMALL_STATE(4496)] = 141317,
  [SMALL_STATE(4497)] = 141327,
  [SMALL_STATE(4498)] = 141337,
  [SMALL_STATE(4499)] = 141347,
  [SMALL_STATE(4500)] = 141357,
  [SMALL_STATE(4501)] = 141367,
  [SMALL_STATE(4502)] = 141377,
  [SMALL_STATE(4503)] = 141385,
  [SMALL_STATE(4504)] = 141395,
  [SMALL_STATE(4505)] = 141403,
  [SMALL_STATE(4506)] = 141413,
  [SMALL_STATE(4507)] = 141423,
  [SMALL_STATE(4508)] = 141433,
  [SMALL_STATE(4509)] = 141443,
  [SMALL_STATE(4510)] = 141453,
  [SMALL_STATE(4511)] = 141461,
  [SMALL_STATE(4512)] = 141471,
  [SMALL_STATE(4513)] = 141481,
  [SMALL_STATE(4514)] = 141491,
  [SMALL_STATE(4515)] = 141499,
  [SMALL_STATE(4516)] = 141507,
  [SMALL_STATE(4517)] = 141517,
  [SMALL_STATE(4518)] = 141525,
  [SMALL_STATE(4519)] = 141533,
  [SMALL_STATE(4520)] = 141543,
  [SMALL_STATE(4521)] = 141551,
  [SMALL_STATE(4522)] = 141561,
  [SMALL_STATE(4523)] = 141569,
  [SMALL_STATE(4524)] = 141579,
  [SMALL_STATE(4525)] = 141589,
  [SMALL_STATE(4526)] = 141599,
  [SMALL_STATE(4527)] = 141609,
  [SMALL_STATE(4528)] = 141619,
  [SMALL_STATE(4529)] = 141627,
  [SMALL_STATE(4530)] = 141637,
  [SMALL_STATE(4531)] = 141645,
  [SMALL_STATE(4532)] = 141653,
  [SMALL_STATE(4533)] = 141663,
  [SMALL_STATE(4534)] = 141673,
  [SMALL_STATE(4535)] = 141683,
  [SMALL_STATE(4536)] = 141693,
  [SMALL_STATE(4537)] = 141701,
  [SMALL_STATE(4538)] = 141711,
  [SMALL_STATE(4539)] = 141721,
  [SMALL_STATE(4540)] = 141729,
  [SMALL_STATE(4541)] = 141739,
  [SMALL_STATE(4542)] = 141749,
  [SMALL_STATE(4543)] = 141757,
  [SMALL_STATE(4544)] = 141767,
  [SMALL_STATE(4545)] = 141777,
  [SMALL_STATE(4546)] = 141787,
  [SMALL_STATE(4547)] = 141797,
  [SMALL_STATE(4548)] = 141805,
  [SMALL_STATE(4549)] = 141815,
  [SMALL_STATE(4550)] = 141823,
  [SMALL_STATE(4551)] = 141833,
  [SMALL_STATE(4552)] = 141841,
  [SMALL_STATE(4553)] = 141849,
  [SMALL_STATE(4554)] = 141859,
  [SMALL_STATE(4555)] = 141867,
  [SMALL_STATE(4556)] = 141877,
  [SMALL_STATE(4557)] = 141885,
  [SMALL_STATE(4558)] = 141893,
  [SMALL_STATE(4559)] = 141901,
  [SMALL_STATE(4560)] = 141911,
  [SMALL_STATE(4561)] = 141921,
  [SMALL_STATE(4562)] = 141931,
  [SMALL_STATE(4563)] = 141939,
  [SMALL_STATE(4564)] = 141949,
  [SMALL_STATE(4565)] = 141959,
  [SMALL_STATE(4566)] = 141967,
  [SMALL_STATE(4567)] = 141977,
  [SMALL_STATE(4568)] = 141987,
  [SMALL_STATE(4569)] = 141995,
  [SMALL_STATE(4570)] = 142003,
  [SMALL_STATE(4571)] = 142011,
  [SMALL_STATE(4572)] = 142021,
  [SMALL_STATE(4573)] = 142029,
  [SMALL_STATE(4574)] = 142039,
  [SMALL_STATE(4575)] = 142049,
  [SMALL_STATE(4576)] = 142059,
  [SMALL_STATE(4577)] = 142069,
  [SMALL_STATE(4578)] = 142079,
  [SMALL_STATE(4579)] = 142087,
  [SMALL_STATE(4580)] = 142097,
  [SMALL_STATE(4581)] = 142107,
  [SMALL_STATE(4582)] = 142117,
  [SMALL_STATE(4583)] = 142125,
  [SMALL_STATE(4584)] = 142133,
  [SMALL_STATE(4585)] = 142143,
  [SMALL_STATE(4586)] = 142153,
  [SMALL_STATE(4587)] = 142163,
  [SMALL_STATE(4588)] = 142173,
  [SMALL_STATE(4589)] = 142183,
  [SMALL_STATE(4590)] = 142193,
  [SMALL_STATE(4591)] = 142203,
  [SMALL_STATE(4592)] = 142213,
  [SMALL_STATE(4593)] = 142221,
  [SMALL_STATE(4594)] = 142231,
  [SMALL_STATE(4595)] = 142241,
  [SMALL_STATE(4596)] = 142249,
  [SMALL_STATE(4597)] = 142257,
  [SMALL_STATE(4598)] = 142267,
  [SMALL_STATE(4599)] = 142277,
  [SMALL_STATE(4600)] = 142287,
  [SMALL_STATE(4601)] = 142297,
  [SMALL_STATE(4602)] = 142305,
  [SMALL_STATE(4603)] = 142313,
  [SMALL_STATE(4604)] = 142323,
  [SMALL_STATE(4605)] = 142333,
  [SMALL_STATE(4606)] = 142341,
  [SMALL_STATE(4607)] = 142349,
  [SMALL_STATE(4608)] = 142359,
  [SMALL_STATE(4609)] = 142369,
  [SMALL_STATE(4610)] = 142379,
  [SMALL_STATE(4611)] = 142389,
  [SMALL_STATE(4612)] = 142399,
  [SMALL_STATE(4613)] = 142409,
  [SMALL_STATE(4614)] = 142419,
  [SMALL_STATE(4615)] = 142427,
  [SMALL_STATE(4616)] = 142435,
  [SMALL_STATE(4617)] = 142443,
  [SMALL_STATE(4618)] = 142453,
  [SMALL_STATE(4619)] = 142463,
  [SMALL_STATE(4620)] = 142473,
  [SMALL_STATE(4621)] = 142483,
  [SMALL_STATE(4622)] = 142493,
  [SMALL_STATE(4623)] = 142503,
  [SMALL_STATE(4624)] = 142513,
  [SMALL_STATE(4625)] = 142523,
  [SMALL_STATE(4626)] = 142533,
  [SMALL_STATE(4627)] = 142543,
  [SMALL_STATE(4628)] = 142553,
  [SMALL_STATE(4629)] = 142561,
  [SMALL_STATE(4630)] = 142571,
  [SMALL_STATE(4631)] = 142581,
  [SMALL_STATE(4632)] = 142589,
  [SMALL_STATE(4633)] = 142599,
  [SMALL_STATE(4634)] = 142609,
  [SMALL_STATE(4635)] = 142616,
  [SMALL_STATE(4636)] = 142623,
  [SMALL_STATE(4637)] = 142630,
  [SMALL_STATE(4638)] = 142637,
  [SMALL_STATE(4639)] = 142644,
  [SMALL_STATE(4640)] = 142651,
  [SMALL_STATE(4641)] = 142658,
  [SMALL_STATE(4642)] = 142665,
  [SMALL_STATE(4643)] = 142672,
  [SMALL_STATE(4644)] = 142679,
  [SMALL_STATE(4645)] = 142686,
  [SMALL_STATE(4646)] = 142693,
  [SMALL_STATE(4647)] = 142700,
  [SMALL_STATE(4648)] = 142707,
  [SMALL_STATE(4649)] = 142714,
  [SMALL_STATE(4650)] = 142721,
  [SMALL_STATE(4651)] = 142728,
  [SMALL_STATE(4652)] = 142735,
  [SMALL_STATE(4653)] = 142742,
  [SMALL_STATE(4654)] = 142749,
  [SMALL_STATE(4655)] = 142756,
  [SMALL_STATE(4656)] = 142763,
  [SMALL_STATE(4657)] = 142770,
  [SMALL_STATE(4658)] = 142777,
  [SMALL_STATE(4659)] = 142784,
  [SMALL_STATE(4660)] = 142791,
  [SMALL_STATE(4661)] = 142798,
  [SMALL_STATE(4662)] = 142805,
  [SMALL_STATE(4663)] = 142812,
  [SMALL_STATE(4664)] = 142819,
  [SMALL_STATE(4665)] = 142826,
  [SMALL_STATE(4666)] = 142833,
  [SMALL_STATE(4667)] = 142840,
  [SMALL_STATE(4668)] = 142847,
  [SMALL_STATE(4669)] = 142854,
  [SMALL_STATE(4670)] = 142861,
  [SMALL_STATE(4671)] = 142868,
  [SMALL_STATE(4672)] = 142875,
  [SMALL_STATE(4673)] = 142882,
  [SMALL_STATE(4674)] = 142889,
  [SMALL_STATE(4675)] = 142896,
  [SMALL_STATE(4676)] = 142903,
  [SMALL_STATE(4677)] = 142910,
  [SMALL_STATE(4678)] = 142917,
  [SMALL_STATE(4679)] = 142924,
  [SMALL_STATE(4680)] = 142931,
  [SMALL_STATE(4681)] = 142938,
  [SMALL_STATE(4682)] = 142945,
  [SMALL_STATE(4683)] = 142952,
  [SMALL_STATE(4684)] = 142959,
  [SMALL_STATE(4685)] = 142966,
  [SMALL_STATE(4686)] = 142973,
  [SMALL_STATE(4687)] = 142980,
  [SMALL_STATE(4688)] = 142987,
  [SMALL_STATE(4689)] = 142994,
  [SMALL_STATE(4690)] = 143001,
  [SMALL_STATE(4691)] = 143008,
  [SMALL_STATE(4692)] = 143015,
  [SMALL_STATE(4693)] = 143022,
  [SMALL_STATE(4694)] = 143029,
  [SMALL_STATE(4695)] = 143036,
  [SMALL_STATE(4696)] = 143043,
  [SMALL_STATE(4697)] = 143050,
  [SMALL_STATE(4698)] = 143057,
  [SMALL_STATE(4699)] = 143064,
  [SMALL_STATE(4700)] = 143071,
  [SMALL_STATE(4701)] = 143078,
  [SMALL_STATE(4702)] = 143085,
  [SMALL_STATE(4703)] = 143092,
  [SMALL_STATE(4704)] = 143099,
  [SMALL_STATE(4705)] = 143106,
  [SMALL_STATE(4706)] = 143113,
  [SMALL_STATE(4707)] = 143120,
  [SMALL_STATE(4708)] = 143127,
  [SMALL_STATE(4709)] = 143134,
  [SMALL_STATE(4710)] = 143141,
  [SMALL_STATE(4711)] = 143148,
  [SMALL_STATE(4712)] = 143155,
  [SMALL_STATE(4713)] = 143162,
  [SMALL_STATE(4714)] = 143169,
  [SMALL_STATE(4715)] = 143176,
  [SMALL_STATE(4716)] = 143183,
  [SMALL_STATE(4717)] = 143190,
  [SMALL_STATE(4718)] = 143197,
  [SMALL_STATE(4719)] = 143204,
  [SMALL_STATE(4720)] = 143211,
  [SMALL_STATE(4721)] = 143218,
  [SMALL_STATE(4722)] = 143225,
  [SMALL_STATE(4723)] = 143232,
  [SMALL_STATE(4724)] = 143239,
  [SMALL_STATE(4725)] = 143246,
  [SMALL_STATE(4726)] = 143253,
  [SMALL_STATE(4727)] = 143260,
  [SMALL_STATE(4728)] = 143267,
  [SMALL_STATE(4729)] = 143274,
  [SMALL_STATE(4730)] = 143281,
  [SMALL_STATE(4731)] = 143288,
  [SMALL_STATE(4732)] = 143295,
  [SMALL_STATE(4733)] = 143302,
  [SMALL_STATE(4734)] = 143309,
  [SMALL_STATE(4735)] = 143316,
  [SMALL_STATE(4736)] = 143323,
  [SMALL_STATE(4737)] = 143330,
  [SMALL_STATE(4738)] = 143337,
  [SMALL_STATE(4739)] = 143344,
  [SMALL_STATE(4740)] = 143351,
  [SMALL_STATE(4741)] = 143358,
  [SMALL_STATE(4742)] = 143365,
  [SMALL_STATE(4743)] = 143372,
  [SMALL_STATE(4744)] = 143379,
  [SMALL_STATE(4745)] = 143386,
  [SMALL_STATE(4746)] = 143393,
  [SMALL_STATE(4747)] = 143400,
  [SMALL_STATE(4748)] = 143407,
  [SMALL_STATE(4749)] = 143414,
  [SMALL_STATE(4750)] = 143421,
  [SMALL_STATE(4751)] = 143428,
  [SMALL_STATE(4752)] = 143435,
  [SMALL_STATE(4753)] = 143442,
  [SMALL_STATE(4754)] = 143449,
  [SMALL_STATE(4755)] = 143456,
  [SMALL_STATE(4756)] = 143463,
  [SMALL_STATE(4757)] = 143470,
  [SMALL_STATE(4758)] = 143477,
  [SMALL_STATE(4759)] = 143484,
  [SMALL_STATE(4760)] = 143491,
  [SMALL_STATE(4761)] = 143498,
  [SMALL_STATE(4762)] = 143505,
  [SMALL_STATE(4763)] = 143512,
  [SMALL_STATE(4764)] = 143519,
  [SMALL_STATE(4765)] = 143526,
  [SMALL_STATE(4766)] = 143533,
  [SMALL_STATE(4767)] = 143540,
  [SMALL_STATE(4768)] = 143547,
  [SMALL_STATE(4769)] = 143554,
  [SMALL_STATE(4770)] = 143561,
  [SMALL_STATE(4771)] = 143568,
  [SMALL_STATE(4772)] = 143575,
  [SMALL_STATE(4773)] = 143582,
  [SMALL_STATE(4774)] = 143589,
  [SMALL_STATE(4775)] = 143596,
  [SMALL_STATE(4776)] = 143603,
  [SMALL_STATE(4777)] = 143610,
  [SMALL_STATE(4778)] = 143617,
  [SMALL_STATE(4779)] = 143624,
  [SMALL_STATE(4780)] = 143631,
  [SMALL_STATE(4781)] = 143638,
  [SMALL_STATE(4782)] = 143645,
  [SMALL_STATE(4783)] = 143652,
  [SMALL_STATE(4784)] = 143659,
  [SMALL_STATE(4785)] = 143666,
  [SMALL_STATE(4786)] = 143673,
  [SMALL_STATE(4787)] = 143680,
  [SMALL_STATE(4788)] = 143687,
  [SMALL_STATE(4789)] = 143694,
  [SMALL_STATE(4790)] = 143701,
  [SMALL_STATE(4791)] = 143708,
  [SMALL_STATE(4792)] = 143715,
  [SMALL_STATE(4793)] = 143722,
  [SMALL_STATE(4794)] = 143729,
  [SMALL_STATE(4795)] = 143736,
  [SMALL_STATE(4796)] = 143743,
  [SMALL_STATE(4797)] = 143750,
  [SMALL_STATE(4798)] = 143757,
  [SMALL_STATE(4799)] = 143764,
  [SMALL_STATE(4800)] = 143771,
  [SMALL_STATE(4801)] = 143778,
  [SMALL_STATE(4802)] = 143785,
  [SMALL_STATE(4803)] = 143792,
  [SMALL_STATE(4804)] = 143799,
  [SMALL_STATE(4805)] = 143806,
  [SMALL_STATE(4806)] = 143813,
  [SMALL_STATE(4807)] = 143820,
  [SMALL_STATE(4808)] = 143827,
  [SMALL_STATE(4809)] = 143834,
  [SMALL_STATE(4810)] = 143841,
  [SMALL_STATE(4811)] = 143848,
  [SMALL_STATE(4812)] = 143855,
  [SMALL_STATE(4813)] = 143862,
  [SMALL_STATE(4814)] = 143869,
  [SMALL_STATE(4815)] = 143876,
  [SMALL_STATE(4816)] = 143883,
  [SMALL_STATE(4817)] = 143890,
  [SMALL_STATE(4818)] = 143897,
  [SMALL_STATE(4819)] = 143904,
  [SMALL_STATE(4820)] = 143911,
  [SMALL_STATE(4821)] = 143918,
  [SMALL_STATE(4822)] = 143925,
  [SMALL_STATE(4823)] = 143932,
  [SMALL_STATE(4824)] = 143939,
  [SMALL_STATE(4825)] = 143946,
  [SMALL_STATE(4826)] = 143953,
  [SMALL_STATE(4827)] = 143960,
  [SMALL_STATE(4828)] = 143967,
  [SMALL_STATE(4829)] = 143974,
  [SMALL_STATE(4830)] = 143981,
  [SMALL_STATE(4831)] = 143988,
  [SMALL_STATE(4832)] = 143995,
  [SMALL_STATE(4833)] = 144002,
  [SMALL_STATE(4834)] = 144009,
  [SMALL_STATE(4835)] = 144016,
  [SMALL_STATE(4836)] = 144023,
  [SMALL_STATE(4837)] = 144030,
  [SMALL_STATE(4838)] = 144037,
  [SMALL_STATE(4839)] = 144044,
  [SMALL_STATE(4840)] = 144051,
  [SMALL_STATE(4841)] = 144058,
  [SMALL_STATE(4842)] = 144065,
  [SMALL_STATE(4843)] = 144072,
  [SMALL_STATE(4844)] = 144079,
  [SMALL_STATE(4845)] = 144086,
  [SMALL_STATE(4846)] = 144093,
  [SMALL_STATE(4847)] = 144100,
  [SMALL_STATE(4848)] = 144107,
  [SMALL_STATE(4849)] = 144114,
  [SMALL_STATE(4850)] = 144121,
  [SMALL_STATE(4851)] = 144128,
  [SMALL_STATE(4852)] = 144135,
  [SMALL_STATE(4853)] = 144142,
  [SMALL_STATE(4854)] = 144149,
  [SMALL_STATE(4855)] = 144156,
  [SMALL_STATE(4856)] = 144163,
  [SMALL_STATE(4857)] = 144170,
  [SMALL_STATE(4858)] = 144177,
  [SMALL_STATE(4859)] = 144184,
  [SMALL_STATE(4860)] = 144191,
  [SMALL_STATE(4861)] = 144198,
  [SMALL_STATE(4862)] = 144205,
  [SMALL_STATE(4863)] = 144212,
  [SMALL_STATE(4864)] = 144219,
  [SMALL_STATE(4865)] = 144226,
  [SMALL_STATE(4866)] = 144233,
  [SMALL_STATE(4867)] = 144240,
  [SMALL_STATE(4868)] = 144247,
  [SMALL_STATE(4869)] = 144254,
  [SMALL_STATE(4870)] = 144261,
  [SMALL_STATE(4871)] = 144268,
  [SMALL_STATE(4872)] = 144275,
  [SMALL_STATE(4873)] = 144282,
  [SMALL_STATE(4874)] = 144289,
  [SMALL_STATE(4875)] = 144296,
  [SMALL_STATE(4876)] = 144303,
  [SMALL_STATE(4877)] = 144310,
  [SMALL_STATE(4878)] = 144317,
  [SMALL_STATE(4879)] = 144324,
  [SMALL_STATE(4880)] = 144331,
  [SMALL_STATE(4881)] = 144338,
  [SMALL_STATE(4882)] = 144345,
  [SMALL_STATE(4883)] = 144352,
  [SMALL_STATE(4884)] = 144359,
  [SMALL_STATE(4885)] = 144366,
  [SMALL_STATE(4886)] = 144373,
  [SMALL_STATE(4887)] = 144380,
  [SMALL_STATE(4888)] = 144387,
  [SMALL_STATE(4889)] = 144394,
  [SMALL_STATE(4890)] = 144401,
  [SMALL_STATE(4891)] = 144408,
  [SMALL_STATE(4892)] = 144415,
  [SMALL_STATE(4893)] = 144422,
  [SMALL_STATE(4894)] = 144429,
  [SMALL_STATE(4895)] = 144436,
  [SMALL_STATE(4896)] = 144443,
  [SMALL_STATE(4897)] = 144450,
  [SMALL_STATE(4898)] = 144457,
  [SMALL_STATE(4899)] = 144464,
  [SMALL_STATE(4900)] = 144471,
  [SMALL_STATE(4901)] = 144478,
  [SMALL_STATE(4902)] = 144485,
  [SMALL_STATE(4903)] = 144492,
  [SMALL_STATE(4904)] = 144499,
  [SMALL_STATE(4905)] = 144506,
  [SMALL_STATE(4906)] = 144513,
  [SMALL_STATE(4907)] = 144520,
  [SMALL_STATE(4908)] = 144527,
  [SMALL_STATE(4909)] = 144534,
  [SMALL_STATE(4910)] = 144541,
  [SMALL_STATE(4911)] = 144548,
  [SMALL_STATE(4912)] = 144555,
  [SMALL_STATE(4913)] = 144562,
  [SMALL_STATE(4914)] = 144569,
  [SMALL_STATE(4915)] = 144576,
  [SMALL_STATE(4916)] = 144583,
  [SMALL_STATE(4917)] = 144590,
  [SMALL_STATE(4918)] = 144597,
  [SMALL_STATE(4919)] = 144604,
  [SMALL_STATE(4920)] = 144611,
  [SMALL_STATE(4921)] = 144618,
  [SMALL_STATE(4922)] = 144625,
  [SMALL_STATE(4923)] = 144632,
  [SMALL_STATE(4924)] = 144639,
  [SMALL_STATE(4925)] = 144646,
  [SMALL_STATE(4926)] = 144653,
  [SMALL_STATE(4927)] = 144660,
  [SMALL_STATE(4928)] = 144667,
  [SMALL_STATE(4929)] = 144674,
  [SMALL_STATE(4930)] = 144681,
  [SMALL_STATE(4931)] = 144688,
  [SMALL_STATE(4932)] = 144695,
  [SMALL_STATE(4933)] = 144702,
  [SMALL_STATE(4934)] = 144709,
  [SMALL_STATE(4935)] = 144716,
  [SMALL_STATE(4936)] = 144723,
  [SMALL_STATE(4937)] = 144730,
  [SMALL_STATE(4938)] = 144737,
  [SMALL_STATE(4939)] = 144744,
  [SMALL_STATE(4940)] = 144751,
  [SMALL_STATE(4941)] = 144758,
  [SMALL_STATE(4942)] = 144765,
  [SMALL_STATE(4943)] = 144772,
  [SMALL_STATE(4944)] = 144779,
  [SMALL_STATE(4945)] = 144786,
  [SMALL_STATE(4946)] = 144793,
  [SMALL_STATE(4947)] = 144800,
  [SMALL_STATE(4948)] = 144807,
  [SMALL_STATE(4949)] = 144814,
  [SMALL_STATE(4950)] = 144821,
  [SMALL_STATE(4951)] = 144828,
  [SMALL_STATE(4952)] = 144835,
  [SMALL_STATE(4953)] = 144842,
  [SMALL_STATE(4954)] = 144849,
  [SMALL_STATE(4955)] = 144856,
  [SMALL_STATE(4956)] = 144863,
  [SMALL_STATE(4957)] = 144870,
  [SMALL_STATE(4958)] = 144877,
  [SMALL_STATE(4959)] = 144884,
  [SMALL_STATE(4960)] = 144891,
  [SMALL_STATE(4961)] = 144898,
  [SMALL_STATE(4962)] = 144905,
  [SMALL_STATE(4963)] = 144912,
  [SMALL_STATE(4964)] = 144919,
  [SMALL_STATE(4965)] = 144926,
  [SMALL_STATE(4966)] = 144933,
  [SMALL_STATE(4967)] = 144940,
  [SMALL_STATE(4968)] = 144947,
  [SMALL_STATE(4969)] = 144954,
  [SMALL_STATE(4970)] = 144961,
  [SMALL_STATE(4971)] = 144968,
  [SMALL_STATE(4972)] = 144975,
  [SMALL_STATE(4973)] = 144982,
  [SMALL_STATE(4974)] = 144989,
  [SMALL_STATE(4975)] = 144996,
  [SMALL_STATE(4976)] = 145003,
  [SMALL_STATE(4977)] = 145010,
  [SMALL_STATE(4978)] = 145017,
  [SMALL_STATE(4979)] = 145024,
  [SMALL_STATE(4980)] = 145031,
  [SMALL_STATE(4981)] = 145038,
  [SMALL_STATE(4982)] = 145045,
  [SMALL_STATE(4983)] = 145052,
  [SMALL_STATE(4984)] = 145059,
  [SMALL_STATE(4985)] = 145066,
  [SMALL_STATE(4986)] = 145073,
  [SMALL_STATE(4987)] = 145080,
  [SMALL_STATE(4988)] = 145087,
  [SMALL_STATE(4989)] = 145094,
  [SMALL_STATE(4990)] = 145101,
  [SMALL_STATE(4991)] = 145108,
  [SMALL_STATE(4992)] = 145115,
  [SMALL_STATE(4993)] = 145122,
  [SMALL_STATE(4994)] = 145129,
  [SMALL_STATE(4995)] = 145136,
  [SMALL_STATE(4996)] = 145143,
  [SMALL_STATE(4997)] = 145150,
  [SMALL_STATE(4998)] = 145157,
  [SMALL_STATE(4999)] = 145164,
  [SMALL_STATE(5000)] = 145171,
  [SMALL_STATE(5001)] = 145178,
  [SMALL_STATE(5002)] = 145185,
  [SMALL_STATE(5003)] = 145192,
  [SMALL_STATE(5004)] = 145199,
  [SMALL_STATE(5005)] = 145206,
  [SMALL_STATE(5006)] = 145213,
  [SMALL_STATE(5007)] = 145220,
  [SMALL_STATE(5008)] = 145227,
  [SMALL_STATE(5009)] = 145234,
  [SMALL_STATE(5010)] = 145241,
  [SMALL_STATE(5011)] = 145248,
  [SMALL_STATE(5012)] = 145255,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4261),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4204),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3548),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5003),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2864),
  [23] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 10), SHIFT(451),
  [26] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 10),
  [28] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [30] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [32] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 10),
  [34] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [36] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [38] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(456),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [53] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(4818),
  [56] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3113),
  [58] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [60] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3360),
  [62] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [64] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 10),
  [66] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [68] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1, .production_id = 10),
  [70] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [72] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [74] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [76] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [78] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [80] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [82] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [84] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(468),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4764),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4766),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2836),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 10), SHIFT(513),
  [124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 10), REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 10),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3358),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3320),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3231),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4335),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4435),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4039),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4598),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4353),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4355),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4038),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4035),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4595),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4752),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3114),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3321),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2236),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2237),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4676),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4677),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4679),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 264),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 264),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1274),
  [354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(618),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2),
  [359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1208),
  [362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1117),
  [365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4),
  [368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2),
  [370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(557),
  [373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1394),
  [376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1270),
  [379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3358),
  [382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3320),
  [385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3231),
  [388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(557),
  [391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4335),
  [394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4435),
  [397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4039),
  [400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(128),
  [403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(564),
  [406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4598),
  [409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(56),
  [412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4353),
  [415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4355),
  [418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4038),
  [421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4035),
  [424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4595),
  [427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(235),
  [430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(273),
  [433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(679),
  [436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(101),
  [439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(150),
  [442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4502),
  [445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(938),
  [448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4752),
  [451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3114),
  [454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(637),
  [457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3321),
  [460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(319),
  [463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(511),
  [466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3982),
  [469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3983),
  [472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(3482),
  [475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(2236),
  [478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(2236),
  [481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(2237),
  [484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4152),
  [487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(628),
  [490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(1114),
  [493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4676),
  [496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4677),
  [499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_statement_block_repeat1, 2), SHIFT_REPEAT(4679),
  [502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 50),
  [504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 50),
  [506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3, .production_id = 88),
  [508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3, .production_id = 88),
  [510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3262),
  [560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4434),
  [562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4495),
  [564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4095),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4548),
  [568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4506),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4437),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3121),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3276),
  [580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3242),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3238),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4486),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4130),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4529),
  [608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4499),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4087),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4082),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4466),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3112),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3256),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4834),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4801),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4800),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4818),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2373),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2221),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(127),
  [719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(157),
  [722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(938),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(3468),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 10),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2273),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3230),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4196),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1991),
  [786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4837),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4688),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2441),
  [854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2369),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2428),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2405),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2232),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3108),
  [908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3278),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2220),
  [1000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [1002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [1004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [1006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [1008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [1012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [1014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [1018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [1020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [1024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [1026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [1030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2344),
  [1036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [1038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [1040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [1042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [1052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [1054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4759),
  [1056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [1058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [1060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [1062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [1064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2044),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [1072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [1074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [1076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [1078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [1084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [1086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4790),
  [1090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [1092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [1094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [1096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [1098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [1104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [1106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [1108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [1110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [1112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [1114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [1116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [1124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [1130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [1136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2319),
  [1138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [1140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [1142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [1144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [1146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [1156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1710),
  [1158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [1160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [1162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [1164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [1166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [1168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [1170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [1172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [1174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2287),
  [1176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [1178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [1180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [1182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [1184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [1186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4666),
  [1196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [1198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [1200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [1208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [1210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [1212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [1216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [1218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [1232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [1246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [1248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [1250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [1254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [1256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [1258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [1260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [1262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2407),
  [1264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [1266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [1274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2461),
  [1276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [1278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [1280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [1282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2462),
  [1284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [1292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [1294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [1296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [1300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3310),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3309),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3229),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3105),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [1314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3246),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [1318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [1320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4954),
  [1322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4671),
  [1324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4672),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2397),
  [1330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [1332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [1334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [1336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [1338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [1340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [1342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [1344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [1346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [1348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2435),
  [1350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [1354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [1356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [1358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [1360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [1366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [1368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [1370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [1376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [1384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [1386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [1388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [1390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [1392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [1398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [1400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2831),
  [1402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [1404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [1406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3429),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [1412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4632),
  [1414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3937),
  [1416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4844),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3731),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [1426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2874),
  [1428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2869),
  [1430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [1434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [1436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [1444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [1452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_predefined_type, 1),
  [1462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_predefined_type, 1),
  [1464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 10), REDUCE(sym_rest_pattern, 2, .production_id = 49),
  [1467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2, .production_id = 49),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [1473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [1475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [1477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 2),
  [1479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [1481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [1487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 1, .production_id = 15),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 1, .production_id = 15),
  [1493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4898),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3266),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3261),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [1515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [1519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [1521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [1523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 145),
  [1525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 145),
  [1527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 145),
  [1529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 145),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [1533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [1535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [1537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 214),
  [1539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 214),
  [1541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 214),
  [1543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 214),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [1547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 252),
  [1549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 6, .production_id = 252),
  [1551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 252),
  [1553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 6, .production_id = 252),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [1557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 215),
  [1559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 215),
  [1561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 215),
  [1563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 215),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [1567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [1569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [1573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [1575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 87),
  [1577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 87),
  [1579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 87),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 87),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [1589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 146),
  [1591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 146),
  [1593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 146),
  [1595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 146),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [1599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 160),
  [1601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 160),
  [1603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 160),
  [1605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 160),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [1609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [1611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [1613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 157),
  [1615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 157),
  [1617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 157),
  [1619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 157),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [1623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [1625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [1627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_internal_module, 2, .production_id = 30),
  [1637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_internal_module, 2, .production_id = 30),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2901),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3053),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3376),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3870),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4720),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3068),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [1689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 207),
  [1691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 207),
  [1693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 207),
  [1695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 207),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [1699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 53),
  [1701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 53),
  [1703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 53),
  [1705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 53),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 108),
  [1711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 108),
  [1713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 108),
  [1715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 108),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [1719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__module, 2, .production_id = 66),
  [1721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 2, .production_id = 66),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 108),
  [1733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 108),
  [1735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 108),
  [1737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 108),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [1741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1748] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(2873),
  [1752] = {.entry = {.count = 3, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1), REDUCE(aux_sym_array_pattern_repeat1, 1), SHIFT(3042),
  [1756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [1772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [1780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 1),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessibility_modifier, 1),
  [1790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessibility_modifier, 1),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [1798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_modifier, 1),
  [1800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_modifier, 1),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3119),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [1814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [1824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [1832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3477),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3475),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2477),
  [1842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [1846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [1848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [1858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [1860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [1862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [1864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [1866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [1868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [1870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [1872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [1874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [1876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [1880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [1894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [1896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [1898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [1900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4645),
  [1902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [1904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [1906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [1908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [1910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [1912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [1914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [1916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [1918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4810),
  [1920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [1922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [1924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [1930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [1932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [1934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [1936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [1938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [1940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [1942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [1948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [1950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [1958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [1968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [1970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [1972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [1974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [1978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [1980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [1982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [1984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [1986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [1988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [1990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2370),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [1998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [2000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [2006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3903),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3895),
  [2010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(2546),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [2017] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 10), REDUCE(sym__property_name, 1, .production_id = 21), SHIFT(134),
  [2021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 21), SHIFT(46),
  [2024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(491),
  [2027] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 10), REDUCE(sym__property_name, 1, .production_id = 21), SHIFT(4632),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3327),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2389),
  [2037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1, .production_id = 21),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [2045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4117),
  [2047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4241),
  [2051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [2053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4930),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4918),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [2067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 10), REDUCE(sym__property_name, 1, .production_id = 21),
  [2070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 10), REDUCE(sym__property_name, 1, .production_id = 21),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4915),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4899),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4677),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [2089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3462),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [2095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2410),
  [2097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2499),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4761),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4491),
  [2105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6),
  [2107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6),
  [2109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3),
  [2111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3),
  [2113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2),
  [2115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2),
  [2117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4),
  [2119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4),
  [2121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5),
  [2123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5),
  [2125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4051),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4049),
  [2131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4843),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4995),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4757),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5005),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4834),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4801),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4800),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [2165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4996),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4407),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [2183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4586),
  [2191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4647),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4649),
  [2195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(134),
  [2198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(4632),
  [2201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3352),
  [2203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2, .production_id = 49),
  [2205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4703),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4704),
  [2209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4798),
  [2211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4822),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [2215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(4976),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3355),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [2222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3275),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3252),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5004),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5009),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4954),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4794),
  [2258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4793),
  [2260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(4793),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4936),
  [2265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4935),
  [2267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(272),
  [2270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [2272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 34),
  [2274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 34),
  [2276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4156),
  [2278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4503),
  [2280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4823),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4636),
  [2284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1, .production_id = 10), SHIFT(548),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [2289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4840),
  [2291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4839),
  [2293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3245),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4750),
  [2301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4749),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [2305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4928),
  [2307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 75),
  [2309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 75),
  [2311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 265),
  [2313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 265),
  [2315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [2317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [2319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 69),
  [2321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 69),
  [2323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [2327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 6, .production_id = 289),
  [2329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 6, .production_id = 289),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [2333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4944),
  [2335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4942),
  [2337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 10), SHIFT(4942),
  [2340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 34),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 34),
  [2344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [2346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [2348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [2350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 207),
  [2352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 207),
  [2354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 124),
  [2356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 124),
  [2358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 224),
  [2360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 5, .production_id = 224),
  [2362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 129),
  [2364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 129),
  [2366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 5, .production_id = 221),
  [2368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 5, .production_id = 221),
  [2370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 167),
  [2372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 167),
  [2374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 284),
  [2376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 284),
  [2378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [2380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [2382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 160),
  [2384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 160),
  [2386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [2388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [2390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2),
  [2392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [2394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 261),
  [2396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 261),
  [2398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 214),
  [2400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 214),
  [2402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 108),
  [2404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 108),
  [2406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 108),
  [2408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 108),
  [2410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 187),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 187),
  [2414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 127),
  [2416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 127),
  [2418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 259),
  [2420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 259),
  [2422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 215),
  [2424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 215),
  [2426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 225),
  [2428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 225),
  [2430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 137),
  [2432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 137),
  [2434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 262),
  [2436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 262),
  [2438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 87),
  [2440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 87),
  [2442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 263),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 6, .production_id = 263),
  [2446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 34),
  [2448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 34),
  [2450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [2452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [2454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 146),
  [2456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 146),
  [2458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 3),
  [2460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 3),
  [2462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 207),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 207),
  [2466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [2470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [2474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 130),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 130),
  [2478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5),
  [2480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5),
  [2482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 174),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 174),
  [2486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 175),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 175),
  [2490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4),
  [2494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 53),
  [2496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 53),
  [2498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 145),
  [2500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 145),
  [2502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 221),
  [2504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 221),
  [2506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [2508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [2510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 7, .production_id = 287),
  [2512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 7, .production_id = 287),
  [2514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [2518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, .production_id = 14),
  [2520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, .production_id = 14),
  [2522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 177),
  [2524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 177),
  [2526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 257),
  [2528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 257),
  [2530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 126),
  [2532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 126),
  [2534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 167),
  [2536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 167),
  [2538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, .production_id = 261),
  [2540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, .production_id = 261),
  [2542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 126),
  [2544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 126),
  [2546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 183),
  [2548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 4, .production_id = 183),
  [2550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 252),
  [2552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 252),
  [2554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 125),
  [2556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 125),
  [2558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 288),
  [2560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 7, .production_id = 288),
  [2562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 178),
  [2564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 178),
  [2566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4),
  [2568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4),
  [2570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 254),
  [2572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_declaration, 6, .production_id = 254),
  [2574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 2, .production_id = 30),
  [2576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 2, .production_id = 30),
  [2578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ambient_declaration, 2),
  [2580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ambient_declaration, 2),
  [2582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 174),
  [2584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 174),
  [2586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 232),
  [2588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 232),
  [2590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 145),
  [2592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 145),
  [2594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 157),
  [2600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 157),
  [2602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [2604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [2606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 231),
  [2608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 231),
  [2610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [2612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [2614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [2616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [2618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 4, .production_id = 182),
  [2620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 4, .production_id = 182),
  [2622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [2624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [2626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4, .production_id = 123),
  [2628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4, .production_id = 123),
  [2630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 180),
  [2632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 180),
  [2634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, .production_id = 14),
  [2636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, .production_id = 14),
  [2638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [2640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [2642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 146),
  [2644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 146),
  [2646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 77),
  [2648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 77),
  [2650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 76),
  [2652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 76),
  [2654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3, .production_id = 123),
  [2656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3, .production_id = 123),
  [2658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [2660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [2662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, .production_id = 11),
  [2664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, .production_id = 11),
  [2666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 87),
  [2668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 87),
  [2670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 70),
  [2672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 70),
  [2674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature, 5, .production_id = 226),
  [2676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature, 5, .production_id = 226),
  [2678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 181),
  [2680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 181),
  [2682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 228),
  [2684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 228),
  [2686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [2688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [2690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 227),
  [2692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_class_declaration, 5, .production_id = 227),
  [2694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 122),
  [2696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 122),
  [2698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 121),
  [2700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 121),
  [2702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 68),
  [2704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 68),
  [2706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 5),
  [2708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 5),
  [2710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 255),
  [2712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 255),
  [2714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 7, .production_id = 304),
  [2716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 7, .production_id = 304),
  [2718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 131),
  [2720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4, .production_id = 131),
  [2722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 283),
  [2724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 283),
  [2726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 256),
  [2728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 256),
  [2730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4880),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3009),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5002),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4771),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4826),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [2780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [2782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [2784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2981),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [2804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3902),
  [2806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [2810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [2812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [2814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [2816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [2818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [2820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4644),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [2824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [2826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [2830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [2832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [2834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [2836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [2838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [2840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [2842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3002),
  [2844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [2852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [2854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [2856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [2858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [2860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [2862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [2876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3030),
  [2878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [2882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [2884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [2886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [2888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [2890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [2892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [2894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3038),
  [2896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [2898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1380),
  [2902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [2904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [2906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [2908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [2916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [2918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [2920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [2934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [2936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [2950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3034),
  [2952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [2954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [2956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [2958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [2960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [2962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [2964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [2970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [2972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3110),
  [2974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [2976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1), REDUCE(aux_sym_object_pattern_repeat1, 1),
  [2979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [2981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [2983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [2985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [2987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [2989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [2991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [2997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2953),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [3001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [3003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3495),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [3009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3916),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4931),
  [3017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3123),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [3027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3106),
  [3029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3145),
  [3031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [3035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4988),
  [3037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2977),
  [3039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4933),
  [3041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [3045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [3051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2859),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [3055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2997),
  [3057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2967),
  [3059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2821),
  [3061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2877),
  [3063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2963),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [3067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2970),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [3071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [3075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [3077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3430),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [3083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3906),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [3091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1450),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [3097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [3099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [3105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4980),
  [3107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4780),
  [3109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [3117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3102),
  [3119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [3121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3933),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [3131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3328),
  [3133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [3137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4993),
  [3139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [3151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [3155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [3157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3423),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [3163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3862),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [3171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [3177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1858),
  [3179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [3181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [3185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4955),
  [3187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4709),
  [3189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [3211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3215),
  [3213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2979),
  [3215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3142),
  [3217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [3219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [3221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [3223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [3225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2051),
  [3227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [3229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [3231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [3235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3845),
  [3237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [3239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [3241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [3243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4809),
  [3245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 45),
  [3247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 45),
  [3249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 45), SHIFT_REPEAT(4196),
  [3252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [3256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 45), SHIFT(3118),
  [3259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [3261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [3263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4157),
  [3265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [3267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [3269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [3271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [3273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 19),
  [3275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 19),
  [3277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 41),
  [3279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 41),
  [3281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 96),
  [3283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 96),
  [3285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 97),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 97),
  [3289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_null_expression, 2),
  [3291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_null_expression, 2),
  [3293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [3295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [3297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [3299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 21),
  [3302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1, .production_id = 21),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__augmented_assignment_lhs, 1),
  [3309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 155),
  [3311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 155),
  [3313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 99),
  [3315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 99),
  [3317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 98),
  [3319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 98),
  [3321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3224),
  [3323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5, .production_id = 212),
  [3325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5, .production_id = 212),
  [3327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 96),
  [3329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 96),
  [3331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3044),
  [3333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [3339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [3341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [3343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [3345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [3347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1561),
  [3349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [3351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1522),
  [3353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [3355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [3357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(484),
  [3360] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 35),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [3366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 35),
  [3369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(1021),
  [3372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4648),
  [3375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [3377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 35),
  [3380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 35), SHIFT(4607),
  [3383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 35),
  [3385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [3387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [3391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [3395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4238),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4280),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4255),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [3413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [3415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(994),
  [3418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4825),
  [3421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [3423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [3425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [3427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [3438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(410),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1),
  [3443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), REDUCE(sym__primary_type, 1, .production_id = 35),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [3448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 10), REDUCE(sym_predefined_type, 1),
  [3451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 10), REDUCE(sym_predefined_type, 1),
  [3454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_pattern, 2),
  [3456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rest_pattern, 2),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [3468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(4960),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [3473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [3475] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 35), REDUCE(sym_rest_pattern, 2),
  [3479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [3481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [3483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [3485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [3491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4205),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [3495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [3497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [3499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [3509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [3511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [3513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [3517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [3519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [3521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [3531] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 10), REDUCE(sym_predefined_type, 1), REDUCE(sym_rest_pattern, 2, .production_id = 49),
  [3535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(261),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [3540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4234),
  [3542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(567),
  [3545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [3547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [3549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_rest_pattern, 2),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [3554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3164),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [3560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [3562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [3564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [3566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [3568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [3570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1886),
  [3572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3196),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [3576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [3578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [3580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [3582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [3584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [3586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [3588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [3592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [3594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [3596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [3598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1568),
  [3600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [3602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [3604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3188),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [3608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [3610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [3612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [3614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [3616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [3618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [3620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3206),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [3624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [3626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [3628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [3630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [3632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [3636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3198),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [3642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [3644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [3646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [3648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1836),
  [3650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [3652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3191),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [3656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [3658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [3660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [3662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1584),
  [3664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [3666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [3668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3611),
  [3670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3603),
  [3672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3966),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [3676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3518),
  [3678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4334),
  [3680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3175),
  [3682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3100),
  [3684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3512),
  [3686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2767),
  [3688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3509),
  [3690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4900),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [3694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3300),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [3698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [3700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [3702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [3704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [3706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [3708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2), SHIFT_REPEAT(3611),
  [3711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2), SHIFT_REPEAT(3603),
  [3714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2), SHIFT_REPEAT(3966),
  [3717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2),
  [3719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2), SHIFT_REPEAT(3262),
  [3722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2), SHIFT_REPEAT(3518),
  [3725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2), SHIFT_REPEAT(4334),
  [3728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2), SHIFT_REPEAT(4292),
  [3731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2), SHIFT_REPEAT(3175),
  [3734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2), SHIFT_REPEAT(3100),
  [3737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2), SHIFT_REPEAT(3512),
  [3740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2), SHIFT_REPEAT(2767),
  [3743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2), SHIFT_REPEAT(3509),
  [3746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 2), SHIFT_REPEAT(4900),
  [3749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [3757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [3759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [3761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4956),
  [3763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 21), SHIFT(1359),
  [3766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 21), SHIFT(1819),
  [3769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 21),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [3773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 21), SHIFT(2334),
  [3776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 21), SHIFT(1906),
  [3779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 21), SHIFT(2064),
  [3782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 21), SHIFT(1682),
  [3785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 21), SHIFT(2375),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [3790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [3794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [3798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [3800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [3806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4120),
  [3812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [3814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [3816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1550),
  [3818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [3820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2497),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [3824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3044),
  [3827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2562),
  [3830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [3832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(313),
  [3835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1486),
  [3838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(4643),
  [3841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3979),
  [3844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(3977),
  [3847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2923),
  [3850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(4120),
  [3853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1444),
  [3856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1442),
  [3859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1550),
  [3862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1424),
  [3865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1498),
  [3868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(1522),
  [3871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2497),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [3890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [3896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4207),
  [3898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4833),
  [3900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3117),
  [3902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [3906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [3908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [3912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4090),
  [3914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3116),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [3924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [3926] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 21), REDUCE(aux_sym_object_repeat1, 2, .production_id = 67), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 48),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [3934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [3938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [3940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [3942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2539),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [3950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [3954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [3956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [3958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3787),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [3970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [3976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [3978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3753),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [3984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [3988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [3990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1569),
  [3992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 39),
  [3994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 39),
  [3996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [4000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [4006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 35),
  [4008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4762),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [4014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [4018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [4020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1571),
  [4022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2509),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [4028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [4030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [4032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1565),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2536),
  [4036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [4040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2422),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4738),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [4050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [4054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [4058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [4062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2424),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [4068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2414),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [4074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [4076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [4080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [4082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1),
  [4084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [4088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [4092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [4096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2400),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [4100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2419),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [4104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [4106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [4108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [4112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [4116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [4118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3908),
  [4120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 1),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [4126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2406),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [4130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2409),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [4134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 79),
  [4136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 79),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4412),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [4142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2423),
  [4144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [4146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2427),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [4150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [4154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [4158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [4164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2411),
  [4166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 80),
  [4168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 80),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [4174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2434),
  [4176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_type, 1, .production_id = 37),
  [4178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 37),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [4182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [4184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [4186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [4190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 65),
  [4192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [4194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [4196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [4204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [4208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [4212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [4214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [4222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [4232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_query, 2, .production_id = 81),
  [4234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_query, 2, .production_id = 81),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [4238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [4240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 57),
  [4242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_type_identifier, 3, .production_id = 57),
  [4244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 57),
  [4247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, .production_id = 38),
  [4249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, .production_id = 38),
  [4251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [4253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [4257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 93),
  [4259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 94),
  [4261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 95),
  [4263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 95),
  [4265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 95), SHIFT(97),
  [4268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1),
  [4270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1),
  [4272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_existential_type, 1),
  [4274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_existential_type, 1),
  [4276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion, 2),
  [4278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion, 2),
  [4280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 103),
  [4282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 95),
  [4284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 150),
  [4286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 152),
  [4288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 153),
  [4290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 211),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [4294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 92),
  [4296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 92),
  [4298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3),
  [4300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3),
  [4302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [4304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [4306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [4310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 93),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [4316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [4318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [4320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [4322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [4324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [4326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [4328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [4330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [4332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2341),
  [4334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 67), REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 48),
  [4337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [4339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_type, 7, .production_id = 298),
  [4341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_type, 7, .production_id = 298),
  [4343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 6, .production_id = 277),
  [4345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 6, .production_id = 277),
  [4347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 276),
  [4349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 276),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [4353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [4355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [4357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 2),
  [4359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 2),
  [4361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 2),
  [4363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 2),
  [4365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 2, .production_id = 31),
  [4367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 2, .production_id = 31),
  [4369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 2),
  [4371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 2),
  [4373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 82),
  [4375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 82),
  [4377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_readonly_type, 2),
  [4379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_readonly_type, 2),
  [4381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_flow_maybe_type, 2),
  [4383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flow_maybe_type, 2),
  [4385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [4387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_infer_type, 2, .production_id = 85),
  [4389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_infer_type, 2, .production_id = 85),
  [4391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [4393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_type_query, 2),
  [4395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_type_query, 2),
  [4397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 86),
  [4399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 86),
  [4401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 275),
  [4403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 275),
  [4405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 41),
  [4407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 41),
  [4409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 274),
  [4411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 274),
  [4413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 140),
  [4415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 140),
  [4417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 273),
  [4419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 5, .production_id = 273),
  [4421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, .production_id = 247),
  [4423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, .production_id = 247),
  [4425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 5, .production_id = 246),
  [4427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 5, .production_id = 246),
  [4429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [4431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [4433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 245),
  [4435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 245),
  [4437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 244),
  [4439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 244),
  [4441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 243),
  [4443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 243),
  [4445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 31),
  [4447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 31),
  [4449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 31), SHIFT(97),
  [4452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [4454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [4456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(97),
  [4459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 141),
  [4461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_call_expression, 2, .production_id = 141),
  [4463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [4466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_type, 2),
  [4469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [4471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_pattern, 2),
  [4473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [4475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [4478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_tuple_type, 2),
  [4481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [4483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 31),
  [4485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 31),
  [4487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 31), SHIFT(97),
  [4490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 155),
  [4492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_subscript_expression, 4, .production_id = 155),
  [4494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [4496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [4498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [4500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [4502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_literal_type, 3),
  [4504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_literal_type, 3),
  [4506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 143),
  [4508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 143),
  [4510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3),
  [4512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3),
  [4514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [4516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [4518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [4520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [4522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 200),
  [4524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 200),
  [4526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 96),
  [4528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 96),
  [4530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 97),
  [4532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 97),
  [4534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 197),
  [4536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 197),
  [4538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_type, 4, .production_id = 203),
  [4540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_type, 4, .production_id = 203),
  [4542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 198),
  [4544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 198),
  [4546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 201),
  [4548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 201),
  [4550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookup_type, 4),
  [4552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookup_type, 4),
  [4554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 204),
  [4556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 204),
  [4558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 199),
  [4560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 199),
  [4562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, .production_id = 51),
  [4564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, .production_id = 51),
  [4566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_predicate, 3, .production_id = 213),
  [4568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate, 3, .production_id = 213),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [4572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 202),
  [4574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_query_member_expression, 3, .production_id = 202),
  [4576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [4580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [4584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [4588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [4594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [4596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [4598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [4600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(375),
  [4606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [4614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [4624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(501),
  [4626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 2, .production_id = 50),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [4630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [4632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [4638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [4642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [4648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [4656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [4664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [4666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [4674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [4678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [4682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [4684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [4692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [4700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [4702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [4704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [4706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [4708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 67),
  [4710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_pattern, 3, .production_id = 48),
  [4712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 67),
  [4714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3, .production_id = 48),
  [4716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 65),
  [4718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 95), SHIFT(90),
  [4721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 2, .production_id = 42),
  [4723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 2, .production_id = 42),
  [4725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_closing_tag, 1),
  [4727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_closing_tag, 1),
  [4729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 41),
  [4731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 41),
  [4733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 40),
  [4735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 40),
  [4737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [4743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2515),
  [4745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [4747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 95), SHIFT(94),
  [4750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 37),
  [4753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__primary_type, 1, .production_id = 37),
  [4756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [4758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [4760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [4763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_string, 2), REDUCE(sym_template_literal_type, 2),
  [4766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 34),
  [4768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 34),
  [4770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 88),
  [4772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 88),
  [4774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 31), SHIFT(90),
  [4777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 89),
  [4779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 89),
  [4781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 90),
  [4783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 90),
  [4785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [4787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [4789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 91),
  [4791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 91),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [4795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [4797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [4799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 2),
  [4801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 94),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [4805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(90),
  [4808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 100),
  [4810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 100),
  [4812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 101),
  [4814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 101),
  [4816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_template, 3, .production_id = 102),
  [4818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glimmer_template, 3, .production_id = 102),
  [4820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 103),
  [4822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 105),
  [4824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 105),
  [4826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 67),
  [4828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 67),
  [4830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [4833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1),
  [4836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [4838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [4842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [4844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [4846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [4848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 144),
  [4850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 144),
  [4852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 149),
  [4854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 149),
  [4856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 150),
  [4858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 151),
  [4860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 151),
  [4862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 152),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [4866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 31), SHIFT(90),
  [4869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1664),
  [4871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 153),
  [4873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 151),
  [4875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 151),
  [4877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, .production_id = 154),
  [4879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, .production_id = 154),
  [4881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 50),
  [4883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 50), SHIFT(447),
  [4886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, .production_id = 156),
  [4888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, .production_id = 156),
  [4890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 158),
  [4892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 158),
  [4894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 159),
  [4896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 159),
  [4898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [4900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 31), SHIFT(94),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [4905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(94),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [4910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 31), SHIFT(94),
  [4913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 106), REDUCE(sym_assignment_expression, 3, .production_id = 64),
  [4916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 106),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [4922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 2),
  [4924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 210),
  [4926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 210),
  [4928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 216),
  [4930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 216),
  [4932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 106), REDUCE(sym_assignment_expression, 3, .production_id = 93),
  [4935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 93), REDUCE(sym_assignment_expression, 3, .production_id = 93),
  [4938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_assignment_pattern, 3, .production_id = 93),
  [4940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 67),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [4946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [4951] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 31), SHIFT(99),
  [4954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(99),
  [4957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 31), SHIFT(99),
  [4960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 95), SHIFT(99),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [4973] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [4979] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [4987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 50),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [5013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 67), REDUCE(sym_object_pattern, 3, .production_id = 48),
  [5016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 93),
  [5018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [5020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [5025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [5027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [5029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [5031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [5035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [5045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [5053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [5057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [5059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [5067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 31), SHIFT(91),
  [5070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(91),
  [5073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 31), SHIFT(91),
  [5076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 95), SHIFT(91),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [5081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array_pattern, 2), REDUCE(sym_tuple_type, 2),
  [5084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [5086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [5088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [5090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [5092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [5094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [5098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 1, .production_id = 32),
  [5100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 32),
  [5102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__parameter_name, 1, .production_id = 32), REDUCE(sym__primary_type, 1, .production_id = 37),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [5107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [5111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 71),
  [5113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 71),
  [5115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 37), REDUCE(sym__parameter_name, 2, .production_id = 71),
  [5118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 71),
  [5120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 71),
  [5122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [5136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 32),
  [5139] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__parameter_name, 1, .production_id = 32), REDUCE(sym__primary_type, 1, .production_id = 37),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [5151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_object_pattern, 2), REDUCE(sym_object_type, 2),
  [5154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [5164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 107),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [5170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2361),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [5174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [5176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [5178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 95), SHIFT(95),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [5183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [5187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [5189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [5191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [5195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [5201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [5203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [5205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [5207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [5209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [5213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__initializer, 2, .production_id = 50), SHIFT(551),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [5220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 67), REDUCE(sym_object_pattern, 3, .production_id = 48),
  [5223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_object, 2), REDUCE(sym_object_pattern, 2),
  [5226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 190),
  [5228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 190),
  [5230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [5232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [5236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [5242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [5246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [5250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [5252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [5260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [5268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 2), REDUCE(sym_array_pattern, 2),
  [5271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [5274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [5276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [5279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_computed_property_name, 3),
  [5281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 136),
  [5283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 136),
  [5285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 4, .production_id = 188),
  [5287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 4, .production_id = 188),
  [5289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [5293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [5297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [5299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4663),
  [5301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 3, .production_id = 132),
  [5303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 3, .production_id = 132),
  [5305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 5, .production_id = 233),
  [5307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 5, .production_id = 233),
  [5309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [5311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [5313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [5315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [5321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [5325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [5329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [5331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [5333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [5339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [5355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 31), SHIFT(95),
  [5358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(95),
  [5361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 31), SHIFT(95),
  [5364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 31), SHIFT(93),
  [5367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(93),
  [5370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 31), SHIFT(93),
  [5373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [5376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [5378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__property_name, 1),
  [5381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__property_name, 1),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [5389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 31), SHIFT(96),
  [5392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(96),
  [5395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 31), SHIFT(96),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [5402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_name, 2, .production_id = 74),
  [5404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_name, 2, .production_id = 74),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [5408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 95), SHIFT(93),
  [5411] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_literal_type, 1), REDUCE(sym_rest_pattern, 2),
  [5415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 95), SHIFT(96),
  [5418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [5420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [5422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [5424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [5428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [5436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [5442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [5446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [5454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 317),
  [5456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 317),
  [5458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 286),
  [5460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 286),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [5466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2408),
  [5468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 9, .production_id = 318),
  [5470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 9, .production_id = 318),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [5474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 53),
  [5476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 53),
  [5478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 305),
  [5480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 305),
  [5482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 108),
  [5484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 108),
  [5486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 10, .production_id = 327),
  [5488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 10, .production_id = 327),
  [5490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 160),
  [5492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 160),
  [5494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 31), SHIFT(92),
  [5497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 128),
  [5499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 128),
  [5501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 258),
  [5503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 258),
  [5505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 223),
  [5507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 223),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [5511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2320),
  [5513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [5515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [5521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2431),
  [5523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 285),
  [5525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 285),
  [5527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 95), SHIFT(92),
  [5530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_await_expression, 2), SHIFT(92),
  [5533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4002),
  [5535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4546),
  [5537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 31), SHIFT(92),
  [5540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [5542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 186),
  [5544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 186),
  [5546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [5552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 8, .production_id = 306),
  [5554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 8, .production_id = 306),
  [5556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4806),
  [5558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 87), REDUCE(sym_class, 4, .production_id = 157),
  [5561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 87), REDUCE(sym_class, 4, .production_id = 157),
  [5564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 146), REDUCE(sym_class, 5, .production_id = 215),
  [5567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 146), REDUCE(sym_class, 5, .production_id = 215),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [5574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 207), REDUCE(sym_class, 6, .production_id = 252),
  [5577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 207), REDUCE(sym_class, 6, .production_id = 252),
  [5580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 34), REDUCE(sym_class, 3, .production_id = 105),
  [5583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 34), REDUCE(sym_class, 3, .production_id = 105),
  [5586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 149), REDUCE(sym_class, 5, .production_id = 216),
  [5589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 149), REDUCE(sym_class, 5, .production_id = 216),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [5594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4967),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [5598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4859),
  [5600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [5602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [5604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2492),
  [5606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 89), REDUCE(sym_class, 4, .production_id = 159),
  [5609] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 89), REDUCE(sym_class, 4, .production_id = 159),
  [5612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 88), REDUCE(sym_class, 4, .production_id = 158),
  [5615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 88), REDUCE(sym_class, 4, .production_id = 158),
  [5618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 145), REDUCE(sym_class, 5, .production_id = 214),
  [5621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 145), REDUCE(sym_class, 5, .production_id = 214),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [5628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [5630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4829),
  [5634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [5654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [5656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [5658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [5660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1697),
  [5662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [5678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [5680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_initializer, 3),
  [5682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_initializer, 3),
  [5684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_definition, 2, .production_id = 5),
  [5686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_definition, 2, .production_id = 5),
  [5688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_definition, 2, .production_id = 4),
  [5690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_definition, 2, .production_id = 4),
  [5692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [5694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [5700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [5702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [5704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2367),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [5710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [5712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [5714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_initializer, 2),
  [5716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_initializer, 2),
  [5718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [5720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [5722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_ui_annotated_object_repeat1, 2, .production_id = 7),
  [5724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ui_annotated_object_repeat1, 2, .production_id = 7), SHIFT_REPEAT(4292),
  [5727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_required, 3, .production_id = 25),
  [5729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_required, 3, .production_id = 25),
  [5731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, .production_id = 110),
  [5733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, .production_id = 110),
  [5735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [5737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [5739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3548),
  [5742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [5744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5003),
  [5747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 7, .production_id = 220),
  [5749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 7, .production_id = 220),
  [5751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 7, .production_id = 219),
  [5753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 7, .production_id = 219),
  [5755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 7, .production_id = 218),
  [5757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 7, .production_id = 218),
  [5759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 7, .production_id = 217),
  [5761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 7, .production_id = 217),
  [5763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_inline_component, 4, .production_id = 62),
  [5765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_inline_component, 4, .production_id = 62),
  [5767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_signal, 4, .production_id = 61),
  [5769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal, 4, .production_id = 61),
  [5771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 1, .production_id = 9),
  [5773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_object_initializer_repeat1, 1, .production_id = 9),
  [5775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, .production_id = 120),
  [5777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, .production_id = 120),
  [5779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [5781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qml_enum_declaration, 3, .production_id = 26),
  [5783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_declaration, 3, .production_id = 26),
  [5785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qml_enum_body, 3, .production_id = 116),
  [5787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_body, 3, .production_id = 116),
  [5789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_definition_binding, 4, .production_id = 46),
  [5791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_definition_binding, 4, .production_id = 46),
  [5793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qml_enum_body, 3, .production_id = 14),
  [5795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_body, 3, .production_id = 14),
  [5797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, .production_id = 113),
  [5799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, .production_id = 113),
  [5801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_required, 3, .production_id = 14),
  [5803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_required, 3, .production_id = 14),
  [5805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_signal, 3, .production_id = 14),
  [5807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal, 3, .production_id = 14),
  [5809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_binding, 3, .production_id = 24),
  [5811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_binding, 3, .production_id = 24),
  [5813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 4, .production_id = 60),
  [5815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 4, .production_id = 60),
  [5817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, .production_id = 161),
  [5819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, .production_id = 161),
  [5821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, .production_id = 162),
  [5823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, .production_id = 162),
  [5825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, .production_id = 163),
  [5827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, .production_id = 163),
  [5829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, .production_id = 164),
  [5831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, .production_id = 164),
  [5833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_annotated_object_member, 2, .production_id = 6),
  [5835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_annotated_object_member, 2, .production_id = 6),
  [5837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 4, .production_id = 59),
  [5839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 4, .production_id = 59),
  [5841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 4, .production_id = 58),
  [5843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 4, .production_id = 58),
  [5845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_definition_binding, 4, .production_id = 47),
  [5847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_definition_binding, 4, .production_id = 47),
  [5849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, .production_id = 109),
  [5851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, .production_id = 109),
  [5853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [5855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [5857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qml_enum_body, 4, .production_id = 167),
  [5859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_body, 4, .production_id = 167),
  [5861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qml_enum_body, 4, .production_id = 169),
  [5863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_body, 4, .production_id = 169),
  [5865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, .production_id = 170),
  [5867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, .production_id = 170),
  [5869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, .production_id = 171),
  [5871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, .production_id = 171),
  [5873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, .production_id = 172),
  [5875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, .production_id = 172),
  [5877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_array, 4),
  [5879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_array, 4),
  [5881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 6, .production_id = 173),
  [5883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 6, .production_id = 173),
  [5885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, .production_id = 119),
  [5887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, .production_id = 119),
  [5889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 4, .production_id = 56),
  [5891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 4, .production_id = 56),
  [5893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_definition_binding, 4, .production_id = 55),
  [5895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_definition_binding, 4, .production_id = 55),
  [5897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_definition_binding, 4, .production_id = 54),
  [5899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_definition_binding, 4, .production_id = 54),
  [5901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, .production_id = 118),
  [5903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, .production_id = 118),
  [5905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_binding, 3, .production_id = 18),
  [5907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_binding, 3, .production_id = 18),
  [5909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, .production_id = 117),
  [5911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, .production_id = 117),
  [5913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_annotated_object_member, 2, .production_id = 16),
  [5915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_annotated_object_member, 2, .production_id = 16),
  [5917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_object_array, 3),
  [5919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_object_array, 3),
  [5921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property, 5, .production_id = 112),
  [5923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property, 5, .production_id = 112),
  [5925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_annotation, 3, .production_id = 13),
  [5927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_annotation, 3, .production_id = 13),
  [5929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4398),
  [5931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4395),
  [5933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_property_modifier, 1),
  [5935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [5937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4976),
  [5939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_ui_property_modifier, 1), SHIFT(4395),
  [5942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2776),
  [5944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_ui_annotated_object_repeat1, 1, .production_id = 2),
  [5946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_annotated_object_repeat1, 1, .production_id = 2),
  [5948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_import, 3, .production_id = 11),
  [5950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_import, 3, .production_id = 11),
  [5952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_import, 6, .production_id = 63),
  [5954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_import, 6, .production_id = 63),
  [5956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_pragma, 5, .production_id = 29),
  [5958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_pragma, 5, .production_id = 29),
  [5960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_import, 5, .production_id = 27),
  [5962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_import, 5, .production_id = 27),
  [5964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_pragma, 3, .production_id = 14),
  [5966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_pragma, 3, .production_id = 14),
  [5968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_import, 4, .production_id = 17),
  [5970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_import, 4, .production_id = 17),
  [5972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4133),
  [5974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4135),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [5978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4433),
  [5980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4715),
  [5982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4256),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4258),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4648),
  [5988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4058),
  [5990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4059),
  [5992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4055),
  [5994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4056),
  [5996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4250),
  [5998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4251),
  [6000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_list_property_type, 4),
  [6002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4045),
  [6004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4053),
  [6006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ui_list_property_type, 4, .production_id = 111),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4406),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4236),
  [6024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [6030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [6036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4293),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4252),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4767),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4786),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [6072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 14),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [6088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 193),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4865),
  [6096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4846),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [6104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 15),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [6110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 240),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4953),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4959),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4891),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4886),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4883),
  [6132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4882),
  [6134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 272),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [6140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [6144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4698),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [6148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 272),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [6158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 14),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [6162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 240),
  [6164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [6166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 193),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [6170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [6172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4248),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4266),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [6190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4215),
  [6192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 1, .production_id = 15),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [6198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [6204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 35), REDUCE(sym_type_parameter, 1, .production_id = 36),
  [6207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [6209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 35), SHIFT(1019),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [6218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3437),
  [6220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 272),
  [6222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 15),
  [6224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 14),
  [6226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 14),
  [6228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 240),
  [6230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 193),
  [6232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 193),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [6236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_type, 1, .production_id = 35), SHIFT(4607),
  [6239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 240),
  [6241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 272),
  [6243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 15),
  [6245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [6247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [6249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [6251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [6255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [6257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 44),
  [6259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [6261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3214),
  [6263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [6265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [6267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [6269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2783),
  [6271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2781),
  [6273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4871),
  [6275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [6277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [6279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4919),
  [6281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [6283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [6285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 15),
  [6287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4560),
  [6289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [6291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3125),
  [6293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [6295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [6297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3124),
  [6299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [6301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3187),
  [6303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3156),
  [6305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [6307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3128),
  [6309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3126),
  [6311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4198),
  [6313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [6315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3200),
  [6317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3173),
  [6319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3137),
  [6321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3189),
  [6323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 20),
  [6325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [6327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [6331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 303),
  [6333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [6335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [6337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 4),
  [6339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [6341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4, .production_id = 48),
  [6343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [6345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [6349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [6351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [6353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [6355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [6357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_property_modifier, 1),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [6361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [6363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 4),
  [6365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_pattern, 3),
  [6367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_pattern, 3),
  [6369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_annotation, 2),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [6373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4887),
  [6375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [6377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [6379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [6381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [6383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [6385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [6387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [6389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3228),
  [6391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [6393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [6395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4682),
  [6397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [6399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4819),
  [6401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [6403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opting_type_annotation, 2),
  [6405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [6407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_omitting_type_annotation, 2),
  [6409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4754),
  [6411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 147),
  [6413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [6419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [6421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [6423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [6425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [6427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [6429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [6431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [6433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 234),
  [6435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 4, .production_id = 226),
  [6437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [6439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [6441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [6443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 36),
  [6445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [6447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 2, .production_id = 138),
  [6449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [6451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 267),
  [6453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 5, .production_id = 266),
  [6455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [6457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [6459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [6461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [6463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 242),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [6467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [6469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [6471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [6473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 308),
  [6475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 196),
  [6477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 3, .production_id = 182),
  [6479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 294),
  [6481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 184),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [6485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 184),
  [6487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(410),
  [6490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 6, .production_id = 295),
  [6492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 7, .production_id = 307),
  [6494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [6496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5008),
  [6498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 3, .production_id = 147),
  [6500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [6502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [6504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [6508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [6510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [6514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [6516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [6520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [6522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 1, .production_id = 33),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [6526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [6528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [6532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 2, .production_id = 139),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [6536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [6538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 321),
  [6540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [6542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asserts, 3),
  [6544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 8, .production_id = 322),
  [6546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 192),
  [6548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_signature, 9, .production_id = 328),
  [6550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [6552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [6554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 303),
  [6556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 195),
  [6558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_chain, 1),
  [6560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [6564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [6568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [6572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [6576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(484),
  [6579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [6583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [6587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [6589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [6591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [6595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [6597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [6601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [6603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [6605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [6607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [6611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [6613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2872),
  [6615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4854),
  [6617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [6619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [6623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [6627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [6629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [6633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [6637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [6639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [6643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(1312),
  [6646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2),
  [6648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [6650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [6652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [6654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [6656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [6658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [6660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [6666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [6670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [6672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [6674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [6678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [6680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_type_member, 1),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [6684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [6686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [6690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 184),
  [6692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 184),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [6696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [6700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2790),
  [6702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [6708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [6710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 45), SHIFT_REPEAT(4152),
  [6713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [6715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(4805),
  [6718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [6720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(333),
  [6723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 43),
  [6725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3562),
  [6727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [6731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [6733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [6737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [6739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4096),
  [6741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4769),
  [6743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4804),
  [6745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4929),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [6749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 2, .production_id = 33),
  [6751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [6755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 2, .production_id = 185),
  [6757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 2, .production_id = 185),
  [6759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [6761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [6763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [6765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [6767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [6769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [6771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 2),
  [6773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [6775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [6777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [6779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [6781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [6783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [6785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [6787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [6789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(3481),
  [6792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [6794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(348),
  [6797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4770),
  [6801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [6803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ui_property_repeat1, 2), SHIFT_REPEAT(3966),
  [6806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_property_repeat1, 2),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [6810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3797),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [6818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2962),
  [6820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [6822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [6824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [6826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [6830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [6842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [6844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4848),
  [6846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [6848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3939),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [6852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [6860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [6864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_signature, 3, .production_id = 104),
  [6866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_predicate_annotation, 2),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4888),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4213),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [6902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [6906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 319),
  [6908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [6920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 325),
  [6922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 20), SHIFT(1003),
  [6925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 44), SHIFT(946),
  [6928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [6934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [6936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [6938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 8, .production_id = 320),
  [6940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [6944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 2, .production_id = 23),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [6948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [6950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [6952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4692),
  [6954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4964),
  [6956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [6958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [6960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [6962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 269),
  [6964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 22),
  [6966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [6968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [6970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [6972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [6974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [6976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [6978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [6980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4960),
  [6982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [6984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 316),
  [6986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 185),
  [6988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 185),
  [6990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 311),
  [6992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [6994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 44), SHIFT(1022),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [6999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 290),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [7003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2),
  [7005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(1013),
  [7008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_literal_type_repeat1, 2), SHIFT_REPEAT(3636),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [7015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [7017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [7019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [7021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 292),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [7025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 7, .production_id = 311),
  [7027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 310),
  [7029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 7, .production_id = 309),
  [7031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 6, .production_id = 293),
  [7033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_type, 2),
  [7035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 194),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [7039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 3, .production_id = 235),
  [7041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 296),
  [7043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4270),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [7053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [7055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 4, .production_id = 236),
  [7057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 237),
  [7059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 238),
  [7061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 6, .production_id = 297),
  [7063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 4, .production_id = 239),
  [7065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [7067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4835),
  [7069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 4, .production_id = 241),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [7073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 269),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [7081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 51),
  [7083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 20), SHIFT(1080),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [7090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [7096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [7102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [7104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 20), SHIFT(953),
  [7107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 268),
  [7109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [7111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 44), SHIFT(1046),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [7118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3806),
  [7120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_signature, 1, .production_id = 78),
  [7122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 194),
  [7124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [7126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 296),
  [7128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 3, .production_id = 51),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [7132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 239),
  [7134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 297),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [7142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 238),
  [7144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_signature, 5, .production_id = 268),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [7148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [7152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 23),
  [7154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 5, .production_id = 271),
  [7156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_construct_signature, 3, .production_id = 191),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [7160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 2, .production_id = 44), SHIFT(951),
  [7163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_type, 2),
  [7165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_signature, 5, .production_id = 270),
  [7167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 23),
  [7169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__call_signature, 1, .production_id = 20), SHIFT(954),
  [7172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [7176] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [7186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(1076),
  [7189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [7193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [7195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [7197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [7199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3597),
  [7201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [7203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [7205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [7207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [7209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [7211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [7213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [7215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 3, .production_id = 148),
  [7217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3521),
  [7219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [7221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [7223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [7225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [7227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 134),
  [7229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3900),
  [7231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [7233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [7235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 84),
  [7237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [7241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3218),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [7245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [7249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3217),
  [7251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3883),
  [7253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3891),
  [7255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [7259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4246),
  [7261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [7263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [7265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [7267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [7279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2, .production_id = 48),
  [7281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [7283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [7285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [7287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [7289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [7291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [7293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(222),
  [7296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [7298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(3920),
  [7301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [7303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(3921),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [7314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [7316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [7318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [7322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1),
  [7324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 1), REDUCE(aux_sym_template_literal_type_repeat1, 1),
  [7327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [7329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [7331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [7333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [7335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [7341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [7343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_nested_identifier, 3),
  [7345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_clause, 4, .production_id = 208),
  [7347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_version_specifier, 1, .production_id = 12),
  [7349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4791),
  [7351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2824),
  [7353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 209),
  [7355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_clause_repeat1, 2, .production_id = 209), SHIFT_REPEAT(360),
  [7358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_nested_identifier, 3, .production_id = 10),
  [7360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mapped_type_clause, 5, .production_id = 291),
  [7362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [7366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 230),
  [7368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 230),
  [7370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extends_type_clause, 3, .production_id = 229),
  [7372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_type_clause, 3, .production_id = 229),
  [7374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [7378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [7380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 260),
  [7382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 260), SHIFT_REPEAT(3957),
  [7385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_extends_type_clause_repeat1, 2, .production_id = 260),
  [7387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 14),
  [7389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [7393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [7395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(3301),
  [7398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [7400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [7402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [7406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [7408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [7410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [7412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2795),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [7416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [7422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [7442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 73),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [7448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [7450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [7452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [7456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [7460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [7462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 3),
  [7464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4765),
  [7468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [7470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4231),
  [7472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4814),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [7476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 326),
  [7478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 324),
  [7480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [7482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(1567),
  [7485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [7487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 8, .production_id = 323),
  [7489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [7491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [7493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [7495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(923),
  [7498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [7500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 313),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [7504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 168), SHIFT_REPEAT(2500),
  [7507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, .production_id = 168),
  [7509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 315),
  [7511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [7513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [7515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 314),
  [7517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [7519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [7521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 7, .production_id = 312),
  [7523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [7525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [7527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [7529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [7531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [7533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [7535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [7537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [7539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [7541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [7543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [7547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [7549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4537),
  [7551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [7553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_version_specifier, 3, .production_id = 28),
  [7555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 205),
  [7557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [7559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [7561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [7563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [7565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [7567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [7569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(4561),
  [7572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [7582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [7590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [7594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, .production_id = 176),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [7598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 248),
  [7600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 226),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [7604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 251),
  [7606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 249),
  [7608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 4, .production_id = 234),
  [7610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [7614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [7616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [7618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [7622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [7624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 4, .production_id = 250),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [7632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 1),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [7636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(160),
  [7639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [7641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4557),
  [7643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [7645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 22),
  [7647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [7649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [7651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [7653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 6, .production_id = 294),
  [7655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 302),
  [7657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [7661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [7663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4925),
  [7665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 1, .production_id = 15),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4264),
  [7671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [7675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 9, .production_id = 329),
  [7677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .dynamic_precedence = -1), SHIFT(567),
  [7680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [7682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [7684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [7686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [7688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [7690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implements_clause, 3),
  [7692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [7694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal_parameter, 3, .production_id = 165),
  [7696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [7698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [7700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [7702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [7704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [7706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [7708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [7710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [7712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [7714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [7716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [7718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [7720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [7722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 3, .production_id = 182),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [7726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [7728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [7730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [7732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [7734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [7736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [7742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [7744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 206),
  [7746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 301),
  [7748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 300),
  [7750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [7752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [7754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [7756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [7758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [7766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [7768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [7770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ui_signal_parameters_repeat1, 2), SHIFT_REPEAT(3930),
  [7773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_signal_parameters_repeat1, 2),
  [7775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [7777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [7779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 278),
  [7781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [7783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [7785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [7789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair_pattern, 3, .production_id = 107),
  [7791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [7793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [7797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2), SHIFT_REPEAT(1469),
  [7800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_pattern_repeat1, 2),
  [7802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [7804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [7806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [7808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [7810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 279),
  [7812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [7814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [7816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [7818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4249),
  [7820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ui_object_array_repeat1, 2), SHIFT_REPEAT(2777),
  [7823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ui_object_array_repeat1, 2),
  [7825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__qml_enum_body_repeat1, 2, .production_id = 14),
  [7827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [7829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 52),
  [7831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [7833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__qml_enum_body_repeat1, 2, .production_id = 168), SHIFT_REPEAT(4527),
  [7836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__qml_enum_body_repeat1, 2, .production_id = 168),
  [7838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 6, .production_id = 299),
  [7840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [7842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [7844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [7846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4945),
  [7848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [7850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4966),
  [7854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [7856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_pattern_repeat1, 2), SHIFT_REPEAT(203),
  [7859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [7861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 51),
  [7863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [7865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [7867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [7869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [7871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [7873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [7879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [7883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [7885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, .production_id = 176),
  [7887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [7889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 2, .production_id = 14),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [7893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [7895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [7897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [7899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [7901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [7903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [7905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 281),
  [7907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 52),
  [7909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [7911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(3929),
  [7914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [7916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [7918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 266),
  [7920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [7922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [7924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4881),
  [7926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [7928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [7930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [7932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [7934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [7936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [7942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [7946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4815),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [7952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_method_signature, 5, .production_id = 267),
  [7954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(3911),
  [7957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [7959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4194),
  [7961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2), SHIFT_REPEAT(4246),
  [7964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_glimmer_template_repeat1, 2),
  [7966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 5, .production_id = 280),
  [7968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [7970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [7972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [7974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [7976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [7978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [7980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2888),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [7986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [7988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [7994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [7996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [7998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [8000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [8002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [8004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [8006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [8008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [8010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [8012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [8016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3, .production_id = 176),
  [8018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [8020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [8022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [8024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [8026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [8028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [8030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [8032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [8034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [8036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [8038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [8040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [8042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [8046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [8048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [8050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [8052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [8054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [8056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [8058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [8060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [8062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [8064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [8066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [8068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_require_clause, 6, .production_id = 282),
  [8070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [8072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [8074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [8076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [8078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 176),
  [8080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal_parameters, 2),
  [8082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4233),
  [8084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2890),
  [8086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [8088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [8090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [8092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [8094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [8096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4991),
  [8098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [8100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4990),
  [8102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [8104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [8106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [8108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4662),
  [8110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [8112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [8114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [8116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [8118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [8120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3825),
  [8122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [8124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [8126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 179),
  [8128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [8130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [8132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [8134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [8136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [8138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [8140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [8142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [8144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [8146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [8150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [8152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_negative_number, 2, .production_id = 31),
  [8154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_assignment, 2, .production_id = 22),
  [8156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [8158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [8160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [8162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [8164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [8166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [8168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [8170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [8172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [8174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [8176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [8178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [8180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [8182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 11),
  [8184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [8186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [8188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [8190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [8192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [8194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [8196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [8198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [8200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [8202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [8204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [8206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [8208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [8210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [8214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_tuple_parameter, 3, .production_id = 51),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [8218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [8220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [8224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [8226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [8232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [8234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [8236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [8238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [8240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [8242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__qml_enum_body_repeat1, 2, .production_id = 116),
  [8244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [8246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [8248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [8250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [8252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [8254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [8256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3, .production_id = 133),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [8260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 3, .production_id = 135),
  [8262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_assignment, 3, .production_id = 166),
  [8264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [8266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [8270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glimmer_opening_tag, 1),
  [8272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 4, .production_id = 189),
  [8274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [8276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qml_enum_assignment, 3, .production_id = 24),
  [8278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameter, 2, .production_id = 23),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [8282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal_parameters, 4),
  [8284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 83),
  [8286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 142),
  [8288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_required_parameter, 2, .production_id = 72),
  [8290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [8292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [8294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [8296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4057),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [8304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [8306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [8308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [8310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal_parameters, 3),
  [8312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [8314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [8316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal_parameter, 3, .production_id = 51),
  [8318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [8320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [8322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 3, .production_id = 222),
  [8324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2),
  [8326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [8330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3826),
  [8338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [8348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal_parameter, 2, .production_id = 114),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [8352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_signal_parameter, 2, .production_id = 115),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [8360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [8364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [8366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [8368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [8370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 4, .production_id = 253),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [8374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [8376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [8380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [8382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [8384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [8386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [8388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [8390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [8394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [8398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [8400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [8402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [8404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [8408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [8412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [8422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [8424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [8426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [8430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [8432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [8434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4706),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [8438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [8440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [8444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [8460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [8462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [8466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [8470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [8472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [8474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [8480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [8486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [8488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [8492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [8494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [8496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [8498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [8500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [8502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [8504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [8506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2348),
  [8508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [8512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [8514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [8518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [8520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [8528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [8530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [8532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [8536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [8538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [8544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [8546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [8548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [8552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [8554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [8556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [8558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [8560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [8562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [8566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [8568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [8570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, .production_id = 179),
  [8572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [8574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [8576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [8578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [8582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [8586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [8588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4777),
  [8590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2021),
  [8592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [8594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [8596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [8600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4788),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [8604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [8606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4343),
  [8612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [8614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4214),
  [8620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [8624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [8630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [8632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [8636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [8640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [8646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [8652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [8654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4939),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [8658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [8660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [8664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [8666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4533),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [8676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [8678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4927),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [8682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [8684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [8688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [8690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [8692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [8694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [8696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, .production_id = 179),
  [8698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [8700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4753),
  [8702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [8704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [8706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [8708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [8710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [8712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [8714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [8716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [8718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [8720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [8722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [8724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [8726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4745),
  [8728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [8730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import_export, 3),
  [8732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [8734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [8736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [8738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [8740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4725),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [8748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [8750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [8752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [8754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4535),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [8758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [8760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [8762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [8764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [8766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [8768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [8770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [8772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [8774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [8776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [8778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [8784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [8788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4776),
  [8792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [8794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [8796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4534),
  [8798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [8800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [8802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [8804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [8806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [8808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [8810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [8814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [8816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [8818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [8820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [8822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [8824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [8826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [8828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [8830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [8832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [8834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [8836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [8838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [8840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [8842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [8844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [8848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [8850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [8852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [8854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [8856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [8858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [8860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [8862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [8864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [8866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [8868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [8870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [8872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [8874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [8876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [8878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4806),
  [8880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [8884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [8886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [8890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4601),
  [8892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [8894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [8896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [8898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4763),
  [8900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [8902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [8904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [8906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [8908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [8910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [8912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [8914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [8916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2447),
  [8918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 3, .production_id = 8),
  [8920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [8922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ui_annotated_object, 2, .production_id = 6),
  [8924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [8926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, .production_id = 179),
  [8928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [8930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [8932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [8934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [8936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [8938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [8940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [8942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [8944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [8948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [8950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [8954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [8956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [8958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [8960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4814),
  [8964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4563),
  [8966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [8968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [8970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [8972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [8974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [8976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [8978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [8980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [8982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2, .production_id = 3),
  [8984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [8986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [8988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [8990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [8992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [8994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [8996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [8998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [9000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [9002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [9004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [9006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [9008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [9010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [9012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [9014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [9016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [9018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [9020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1, .production_id = 1),
  [9022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [9024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4866),
  [9026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [9028] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [9030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [9032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4967),
  [9034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [9036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [9038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [9040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [9042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [9044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [9046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [9048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_qmljs_external_scanner_create(void);
void tree_sitter_qmljs_external_scanner_destroy(void *);
bool tree_sitter_qmljs_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_qmljs_external_scanner_serialize(void *, char *);
void tree_sitter_qmljs_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_qmljs(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_qmljs_external_scanner_create,
      tree_sitter_qmljs_external_scanner_destroy,
      tree_sitter_qmljs_external_scanner_scan,
      tree_sitter_qmljs_external_scanner_serialize,
      tree_sitter_qmljs_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
